def aaa_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.aaa_config.aaa', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.aaa_config.aaa', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.aaa_config.aaa', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.aaa_config.aaa', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.authentication', u'login'), ('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.nos.v6_0_2f.aaa_config.aaa.authentication', u'login'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.nos.v7_2_0.aaa_config.aaa.authentication', u'login'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.authentication', u'login'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.authentication', u'login'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.authorization', u'command')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'first, second'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'first, second'}, {'leafval': 'server_type'}, {'leafval': 'first, second'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'first, second'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'first, second'}, {'leafval': 'firstauthor, secondauthor'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_accounting_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.aaa_config.aaa.accounting', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_accounting_commands_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.commands', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.commands', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.commands', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.commands', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.commands', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_accounting_commands_default_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.commands.defaultacc', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.commands.defaultacc', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.commands.defaultacc', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.commands.defaultacc', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.commands.defaultacc', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_accounting_commands_default_start_stop_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_accounting_commands_default_start_stop_server_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.commands.defaultacc.start_stop', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_accounting_exec_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.exec_', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.exec_', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.exec_', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.exec_', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.exec_', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_accounting_exec_default_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.exec_.defaultacc', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.exec_.defaultacc', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.exec_.defaultacc', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.exec_.defaultacc', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.exec_.defaultacc', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_accounting_exec_default_start_stop_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_accounting_exec_default_start_stop_server_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.exec_.defaultacc.start_stop', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_authentication_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.aaa_config.aaa.authentication', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.aaa_config.aaa.authentication', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.authentication', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.authentication', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.authentication', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.aaa_config.aaa.authentication', u'login'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.authentication', u'login'), ('pybind.nos.v6_0_2f.aaa_config.aaa.authentication', u'login'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.authentication', u'login'), ('pybind.nos.v7_2_0.aaa_config.aaa.authentication', u'login')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'first, second'}, {'leafval': 'first, second'}, {'leafval': 'first, second'}, {'leafval': 'first, second'}, {'leafval': 'first, second'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_authentication_login_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.aaa_config.aaa.authentication.login', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.aaa_config.aaa.authentication.login', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.authentication.login', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.authentication.login', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.authentication.login', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'first, second'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_authentication_login_first_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.aaa_config.aaa.authentication.login', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.aaa_config.aaa.authentication.login', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.authentication.login', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.authentication.login', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.authentication.login', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_authentication_login_second_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.aaa_config.aaa.authentication.login', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.aaa_config.aaa.authentication.login', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.authentication.login', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.authentication.login', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.authentication.login', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_authorization_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.aaa_config.aaa.authorization', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.aaa_config.aaa.authorization', u'command')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'firstauthor, secondauthor'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_authorization_command_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.aaa_config.aaa.authorization.command', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'firstauthor, secondauthor'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_authorization_command_firstauthor_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.aaa_config.aaa.authorization.command', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_authorization_command_secondauthor_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.aaa_config.aaa.authorization.command', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def aaa_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.aaa_config', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.aaa_config', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.aaa_config', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.aaa_config', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.aaa_config', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.authentication', u'login'), ('pybind.slxos.v17r_2_00.aaa_config.aaa.authorization', u'command'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.nos.v7_2_0.aaa_config.aaa.authentication', u'login'), ('pybind.nos.v7_2_0.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.slxos.v17s_1_02.aaa_config.aaa.authentication', u'login'), ('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.nos.v6_0_2f.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.nos.v6_0_2f.aaa_config.aaa.authentication', u'login'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.exec_.defaultacc', u'start_stop'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.accounting.commands.defaultacc', u'start_stop'), ('pybind.slxos.v17r_1_01a.aaa_config.aaa.authentication', u'login')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'first, second'}, {'leafval': 'firstauthor, secondauthor'}, {'leafval': 'server_type'}, {'leafval': 'first, second'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'first, second'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'first, second'}, {'leafval': 'server_type'}, {'leafval': 'server_type'}, {'leafval': 'first, second'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_mirror_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.acl_mirror', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.acl_mirror', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.acl_mirror', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.acl_mirror', u'source'), ('pybind.slxos.v17s_1_02.acl_mirror', u'source'), ('pybind.slxos.v17r_1_01a.acl_mirror', u'source')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'src_interface_type, src_interface_name, destination, dst_interface_type, dst_interface_name'}, {'leafval': 'src_interface_type, src_interface_name, destination, dst_interface_type, dst_interface_name'}, {'leafval': 'src_interface_type, src_interface_name, destination, dst_interface_type, dst_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_mirror_source_get(self, source=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type source: src_interface_type, src_interface_name, destination, dst_interface_type, dst_interface_name
    :param source: Keyword argument tuple.

    :type src_interface_type: unicode
    :param src_interface_type: **source** tuple argument.

        * enumeration restriction: ::

            ['ethernet']

    :type src_interface_name: unicode
    :param src_interface_name: **source** tuple argument.

        * pattern restriction: ::

            '((([0-9]|1[0-6])/([1-9]|[1-9][0-9])(:[1-4])?)|(['
            '1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5][0-9]{3}|6[0-'
            '1][0-4]{2}))'

    :type destination: unicode
    :param destination: **source** tuple argument.

        * enumeration restriction: ::

            ['destination']

    :type dst_interface_type: unicode
    :param dst_interface_type: **source** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type dst_interface_name: unicode
    :param dst_interface_name: **source** tuple argument.

        * pattern restriction: ::

            '((([0-9]|1[0-6])/([1-9]|[1-9][0-9])(:[1-4])?)|(['
            '1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5][0-9]{3}|6[0-'
            '1][0-4]{2}))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.acl_mirror.source', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.acl_mirror.source', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.acl_mirror.source', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'source', 'keyval': 'src_interface_type, src_interface_name, destination, dst_interface_type, dst_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, source=source)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, source=source)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_policy_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.acl_policy', 'pybind.slxos.v17r_1_01a.brocade_acl_policy', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.acl_policy', 'pybind.slxos.v17r_2_00.brocade_acl_policy', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.acl_policy', 'pybind.slxos.v17s_1_02.brocade_acl_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.acl_policy', u'global_acl_policy_conf_cmds'), ('pybind.slxos.v17r_1_01a.acl_policy', u'global_acl_policy_conf_cmds'), ('pybind.slxos.v17r_2_00.acl_policy', u'global_acl_policy_conf_cmds'), ('pybind.slxos.v17r_2_00.acl_policy.global_acl_policy_conf_cmds', u'enable_acl_log_raslog')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'allow_conflicting_rules, allow_duplicate_rules'}, {'leafval': 'allow_conflicting_rules, allow_duplicate_rules'}, {'leafval': 'allow_conflicting_rules, allow_duplicate_rules, enable_acl_cam_sharing'}, {'leafval': 'acl_log_raslog, log_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_policy_acl_log_raslog_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.acl_policy.global_acl_policy_conf_cmds.enable_acl_log_raslog', 'pybind.slxos.v17r_2_00.brocade_acl_policy', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_policy_allow_conflicting_rules_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.acl_policy.global_acl_policy_conf_cmds', 'pybind.slxos.v17r_1_01a.brocade_acl_policy', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.acl_policy.global_acl_policy_conf_cmds', 'pybind.slxos.v17r_2_00.brocade_acl_policy', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.acl_policy.global_acl_policy_conf_cmds', 'pybind.slxos.v17s_1_02.brocade_acl_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.acl_policy.global_acl_policy_conf_cmds', u'enable_acl_log_raslog')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'acl_log_raslog, log_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_policy_allow_duplicate_rules_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.acl_policy.global_acl_policy_conf_cmds', 'pybind.slxos.v17r_1_01a.brocade_acl_policy', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.acl_policy.global_acl_policy_conf_cmds', 'pybind.slxos.v17r_2_00.brocade_acl_policy', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.acl_policy.global_acl_policy_conf_cmds', 'pybind.slxos.v17s_1_02.brocade_acl_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.acl_policy.global_acl_policy_conf_cmds', u'enable_acl_log_raslog')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'acl_log_raslog, log_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_policy_enable_acl_cam_sharing_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.acl_policy.global_acl_policy_conf_cmds', 'pybind.slxos.v17r_2_00.brocade_acl_policy', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.acl_policy.global_acl_policy_conf_cmds', u'enable_acl_log_raslog')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'acl_log_raslog, log_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_policy_enable_acl_log_raslog_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.acl_policy.global_acl_policy_conf_cmds.enable_acl_log_raslog', 'pybind.slxos.v17r_2_00.brocade_acl_policy', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'acl_log_raslog, log_interval'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_policy_global_acl_policy_conf_cmds_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.acl_policy.global_acl_policy_conf_cmds', 'pybind.slxos.v17r_1_01a.brocade_acl_policy', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.acl_policy.global_acl_policy_conf_cmds', 'pybind.slxos.v17r_2_00.brocade_acl_policy', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.acl_policy.global_acl_policy_conf_cmds', 'pybind.slxos.v17s_1_02.brocade_acl_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.acl_policy.global_acl_policy_conf_cmds', u'enable_acl_log_raslog')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'acl_log_raslog, log_interval'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.acl_policy.global_acl_policy_conf_cmds": {"allow_duplicate_rules": "allow_duplicate_rules", "allow_conflicting_rules": "allow_conflicting_rules"}, "pybind.slxos.v17s_1_02.acl_policy.global_acl_policy_conf_cmds": {"allow_duplicate_rules": "allow_duplicate_rules", "allow_conflicting_rules": "allow_conflicting_rules"}, "pybind.slxos.v17r_2_00.acl_policy.global_acl_policy_conf_cmds": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_policy_log_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.acl_policy.global_acl_policy_conf_cmds.enable_acl_log_raslog', 'pybind.slxos.v17r_2_00.brocade_acl_policy', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.acl_state', u'vxlan_acl')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'overlay_acl_tr_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_get(self, vxlan_acl=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'extended_data')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vxlan_acl', 'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'acl_name, seq_num, permit_deny, dst_vtep_ip, src_vtep_ip, vni, vni_mask, native_tag, dst_ip, dst_ip_mask, src_ip, src_ip_mask, dst_port, src_port, count, byte_count, transit_name, sflow, redir_interface, mirror_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_byte_count_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_count_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_dst_ip_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_dst_ip_mask_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_dst_port_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_dst_vtep_ip_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_mirror_interface_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_native_tag_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_permit_deny_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_redir_interface_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_sflow_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_src_ip_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_src_ip_mask_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_src_port_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_src_vtep_ip_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_transit_name_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_vni_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def acl_state_vxlan_acl_extended_data_vni_mask_get(self, vxlan_acl=None, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vxlan_acl: overlay_acl_tr_name
    :param vxlan_acl: Keyword argument tuple.

    :type overlay_acl_tr_name: unicode
    :param overlay_acl_tr_name: **vxlan_acl** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl', u'vxlan_acl')]
    bindings_list = [('pybind.slxos.v17s_1_02.acl_state.vxlan_acl.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'overlay_acl_tr_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vxlan_acl=vxlan_acl, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vxlan_acl=vxlan_acl, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state', u'adj_neighbor'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state', u'adj_neighbor'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state', u'adj_neighbor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_state_change_time, adj_type, adj_state, neighbor_id, circuit_intf_name, snpa, adj_holding_time, adj_priority, adj_mtprot, adj_prot, remaining_time, adj_3way_state, host_name, adj_lan_name, adj_lan_id, adj_p2p_circ_id, adj_num_adds, adj_use, ip_circuit_id, adj_address, ip6_circuit_id, adj_ip6_address, bfd_holdover_interval, adj_bfd_holdover_time, bfd_state'}, {'leafval': 'adj_state_change_time, adj_type, adj_state, neighbor_id, circuit_intf_name, snpa, adj_holding_time, adj_priority, adj_mtprot, adj_prot, remaining_time, adj_3way_state, host_name, adj_lan_name, adj_lan_id, adj_p2p_circ_id, adj_num_adds, adj_use, ip_circuit_id, adj_address, ip6_circuit_id, adj_ip6_address, bfd_holdover_interval, adj_bfd_holdover_time, bfd_state'}, {'leafval': 'adj_state_change_time, adj_type, adj_state, neighbor_id, circuit_intf_name, snpa, adj_holding_time, adj_priority, adj_mtprot, adj_prot, remaining_time, adj_3way_state, host_name, adj_lan_name, adj_lan_id, adj_p2p_circ_id, adj_num_adds, adj_use, ip_circuit_id, adj_address, ip6_circuit_id, adj_ip6_address, bfd_holdover_interval, adj_bfd_holdover_time, bfd_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_3way_state_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_address_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_area_get(self, adj_neighbor=None, adj_area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type adj_area: adj_asi_area_name
    :param adj_area: Keyword argument tuple.

    :type adj_asi_area_name: unicode
    :param adj_asi_area_name: **adj_area** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_neighbor'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_neighbor'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor.adj_area', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor.adj_area', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor.adj_area', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'neighbor_id', 'extra_keyval': ''}, {'keyval': 'neighbor_id', 'extra_keyval': ''}, {'keyval': 'neighbor_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'adj_area', 'keyval': 'adj_asi_area_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor, adj_area=adj_area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor, adj_area=adj_area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_bfd_holdover_time_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_holding_time_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_ip6_address_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_lan_id_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_lan_name_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_mtprot_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_num_adds_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_p2p_circ_id_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_priority_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_prot_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_state_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_state_change_time_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_type_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_adj_use_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_bfd_holdover_interval_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_bfd_state_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_circuit_intf_name_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_host_name_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_ip6_circuit_id_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_ip_circuit_id_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_remaining_time_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def adj_neighbor_entries_state_adj_neighbor_snpa_get(self, adj_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type adj_neighbor: neighbor_id
    :param adj_neighbor: Keyword argument tuple.

    :type neighbor_id: unicode
    :param neighbor_id: **adj_neighbor** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17s_1_02.adj_neighbor_entries_state.adj_neighbor', u'adj_area'), ('pybind.slxos.v17r_1_01a.adj_neighbor_entries_state.adj_neighbor', u'adj_area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'adj_neighbor', 'keyval': 'neighbor_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}, {'leafval': 'adj_asi_area_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, adj_neighbor=adj_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, adj_neighbor=adj_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def alias_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.alias_config', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.alias_config', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.alias_config', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.alias_config', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.alias_config', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.alias_config', u'alias'), ('pybind.slxos.v17s_1_02.alias_config', u'user'), ('pybind.nos.v7_2_0.alias_config', u'user'), ('pybind.nos.v7_2_0.alias_config', u'alias'), ('pybind.slxos.v17r_1_01a.alias_config', u'user'), ('pybind.slxos.v17r_1_01a.alias_config', u'alias'), ('pybind.nos.v6_0_2f.alias_config', u'user'), ('pybind.nos.v6_0_2f.alias_config', u'alias'), ('pybind.slxos.v17r_2_00.alias_config', u'alias'), ('pybind.slxos.v17r_2_00.alias_config', u'user')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, expansion'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name, expansion'}, {'leafval': 'name'}, {'leafval': 'name, expansion'}, {'leafval': 'name'}, {'leafval': 'name, expansion'}, {'leafval': 'name, expansion'}, {'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def alias_config_alias_get(self, alias=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type alias: name
    :param alias: Keyword argument tuple.

    :type name: unicode
    :param name: **alias** tuple argument.

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.alias_config.alias', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.alias_config.alias', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.alias_config.alias', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.alias_config.alias', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.alias_config.alias', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alias', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alias=alias)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alias=alias)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def alias_config_alias_expansion_get(self, alias=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type alias: name
    :param alias: Keyword argument tuple.

    :type name: unicode
    :param name: **alias** tuple argument.

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.alias_config.alias', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.alias_config.alias', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.alias_config.alias', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.alias_config.alias', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.alias_config.alias', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alias', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alias=alias)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alias=alias)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def alias_config_user_get(self, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type user: name
    :param user: Keyword argument tuple.

    :type name: unicode
    :param name: **user** tuple argument.

        * length restriction: ::

            ['1..40']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.alias_config.user', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.alias_config.user', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.alias_config.user', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.alias_config.user', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.alias_config.user', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.alias_config.user', u'alias'), ('pybind.nos.v7_2_0.alias_config.user', u'alias'), ('pybind.slxos.v17r_2_00.alias_config.user', u'alias'), ('pybind.slxos.v17s_1_02.alias_config.user', u'alias'), ('pybind.nos.v6_0_2f.alias_config.user', u'alias')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, expansion'}, {'leafval': 'name, expansion'}, {'leafval': 'name, expansion'}, {'leafval': 'name, expansion'}, {'leafval': 'name, expansion'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def alias_config_user_alias_get(self, user=None, alias=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type user: name
    :param user: Keyword argument tuple.

    :type name: unicode
    :param name: **user** tuple argument.

        * length restriction: ::

            ['1..40']

    **Instance Keyword Argument Tuple**:

    :type alias: name
    :param alias: Keyword argument tuple.

    :type name: unicode
    :param name: **alias** tuple argument.

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.alias_config.user', u'user'), ('pybind.slxos.v17r_2_00.alias_config.user', u'user'), ('pybind.nos.v6_0_2f.alias_config.user', u'user'), ('pybind.nos.v7_2_0.alias_config.user', u'user'), ('pybind.slxos.v17r_1_01a.alias_config.user', u'user')]
    bindings_list = [('pybind.nos.v6_0_2f.alias_config.user.alias', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.alias_config.user.alias', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.alias_config.user.alias', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.alias_config.user.alias', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.alias_config.user.alias', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'alias', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user, alias=alias)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user, alias=alias)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def alias_config_user_alias_expansion_get(self, user=None, alias=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type user: name
    :param user: Keyword argument tuple.

    :type name: unicode
    :param name: **user** tuple argument.

        * length restriction: ::

            ['1..40']

    **Instance Keyword Argument Tuple**:

    :type alias: name
    :param alias: Keyword argument tuple.

    :type name: unicode
    :param name: **alias** tuple argument.

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.alias_config.user', u'user'), ('pybind.slxos.v17r_2_00.alias_config.user', u'user'), ('pybind.nos.v6_0_2f.alias_config.user', u'user'), ('pybind.nos.v7_2_0.alias_config.user', u'user'), ('pybind.slxos.v17r_1_01a.alias_config.user', u'user')]
    bindings_list = [('pybind.nos.v6_0_2f.alias_config.user.alias', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.alias_config.user.alias', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.alias_config.user.alias', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.alias_config.user.alias', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.alias_config.user.alias', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'alias', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user, alias=alias)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user, alias=alias)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def arp_get(self, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address, mac_address_value, interfacename, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac_address_value: unicode
    :param mac_address_value: **arp_entry** tuple argument.

    :type interfacename: unicode
    :param interfacename: **arp_entry** tuple argument.

        * enumeration restriction: ::

            ['interface']

    :type GigabitEthernet: unicode
    :param GigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type TenGigabitEthernet: unicode
    :param TenGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type FortyGigabitEthernet: unicode
    :param FortyGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type HundredGigabitEthernet: unicode
    :param HundredGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type Ve: long
    :param Ve: **arp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_arp_holder.arp_entry', 'pybind.nos.v6_0_2f.brocade_arp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_2_0.brocade_arp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.arp_entry', 'pybind.slxos.v17r_1_01a.brocade_arp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.arp_entry', 'pybind.slxos.v17r_2_00.brocade_arp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.arp_entry', 'pybind.slxos.v17s_1_02.brocade_arp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': 'arp_ip_address, mac_address_value, interfacename, Ethernet, Ve'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.arp_entry": {}, "pybind.nos.v6_0_2f.hide_arp_holder.arp_entry": {"mac_address_value": "mac_address_value", "interfacename": "interfacename", "FortyGigabitEthernet": "FortyGigabitEthernet", "GigabitEthernet": "GigabitEthernet", "TenGigabitEthernet": "TenGigabitEthernet", "arp_ip_address": "arp_ip_address", "HundredGigabitEthernet": "HundredGigabitEthernet", "Ve": "Ve"}, "pybind.slxos.v17r_2_00.arp_entry": {}, "pybind.slxos.v17r_1_01a.arp_entry": {}, "pybind.nos.v7_2_0.hide_arp_holder.arp_entry": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.hide_arp_holder.arp_entry': [u'Port_channel', u'Ve', u'FortyGigabitEthernet', u'GigabitEthernet', u'TenGigabitEthernet', u'HundredGigabitEthernet'], 'pybind.nos.v6_0_2f.hide_arp_holder.arp_entry': [u'FortyGigabitEthernet', u'GigabitEthernet', u'TenGigabitEthernet', u'HundredGigabitEthernet', u'Ve'], 'pybind.slxos.v17r_2_00.arp_entry': [u'Ethernet', u'Ve'], 'pybind.slxos.v17r_1_01a.arp_entry': [u'Ethernet', u'Ve'], 'pybind.slxos.v17s_1_02.arp_entry': [u'Ethernet', u'Ve']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def arp_access_list_get(self, access_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type access_list: acl_name
    :param access_list: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **access_list** tuple argument:  <WORD:1-62>;;Name of ARP access-list

        * length restriction: ::

            ['1..62']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,61})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.arp.access_list', 'pybind.nos.v6_0_2f.brocade_dai', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.arp.access_list', 'pybind.nos.v7_2_0.brocade_dai', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.dai_config.arp.access_list', 'pybind.slxos.v17r_1_01a.brocade_dai', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.dai_config.arp.access_list', 'pybind.slxos.v17r_2_00.brocade_dai', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.dai_config.arp.access_list', 'pybind.slxos.v17s_1_02.brocade_dai', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.dai_config.arp.access_list.permit', u'permit_list'), ('pybind.slxos.v17r_2_00.dai_config.arp.access_list.permit', u'permit_list'), ('pybind.nos.v6_0_2f.arp.access_list.permit', u'permit_list'), ('pybind.slxos.v17r_1_01a.dai_config.arp.access_list.permit', u'permit_list'), ('pybind.nos.v7_2_0.arp.access_list.permit', u'permit_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'access_list', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_type, host_ip, mac_type, host_mac, log'}, {'leafval': 'ip_type, host_ip, mac_type, host_mac'}, {'leafval': 'ip_type, host_ip, mac_type, host_mac, log'}, {'leafval': 'ip_type, host_ip, mac_type, host_mac'}, {'leafval': 'ip_type, host_ip, mac_type, host_mac, log'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_list=access_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_list=access_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def arp_access_list_permit_get(self, access_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type access_list: acl_name
    :param access_list: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **access_list** tuple argument:  <WORD:1-62>;;Name of ARP access-list

        * length restriction: ::

            ['1..62']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,61})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.dai_config.arp.access_list', u'access_list'), ('pybind.nos.v6_0_2f.arp.access_list', u'access_list'), ('pybind.slxos.v17s_1_02.dai_config.arp.access_list', u'access_list'), ('pybind.slxos.v17r_2_00.dai_config.arp.access_list', u'access_list'), ('pybind.nos.v7_2_0.arp.access_list', u'access_list')]
    bindings_list = [('pybind.nos.v6_0_2f.arp.access_list.permit', 'pybind.nos.v6_0_2f.brocade_dai', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.arp.access_list.permit', 'pybind.nos.v7_2_0.brocade_dai', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.dai_config.arp.access_list.permit', 'pybind.slxos.v17r_1_01a.brocade_dai', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.dai_config.arp.access_list.permit', 'pybind.slxos.v17r_2_00.brocade_dai', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.dai_config.arp.access_list.permit', 'pybind.slxos.v17s_1_02.brocade_dai', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_list=access_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_list=access_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def arp_access_list_permit_ip_get(self, access_list=None, permit_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type access_list: acl_name
    :param access_list: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **access_list** tuple argument:  <WORD:1-62>;;Name of ARP access-list

        * length restriction: ::

            ['1..62']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,61})'

    **Instance Keyword Argument Tuple**:

    :type permit_list: ip_type, host_ip, mac_type, host_mac, log
    :param permit_list: Keyword argument tuple.

    :type ip_type: unicode
    :param ip_type: **permit_list** tuple argument.

        * enumeration restriction: ::

            ['host']

    :type host_ip: unicode
    :param host_ip: **permit_list** tuple argument:  IPv4Address;;Source IPv4 Address A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac_type: unicode
    :param mac_type: **permit_list** tuple argument:  MAC address

        * enumeration restriction: ::

            ['host']

    :type host_mac: unicode
    :param host_mac: **permit_list** tuple argument:  MACADDRESS;;Mac address in HHHH.HHHH.HHHH format.

    :type log: YANGBool
    :param log: **permit_list** tuple argument:  Log packet

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.dai_config.arp.access_list', u'access_list'), ('pybind.slxos.v17r_1_01a.dai_config.arp.access_list', u'access_list'), ('pybind.slxos.v17r_2_00.dai_config.arp.access_list', u'access_list'), ('pybind.nos.v7_2_0.arp.access_list', u'access_list'), ('pybind.nos.v6_0_2f.arp.access_list', u'access_list')]
    bindings_list = [('pybind.nos.v6_0_2f.arp.access_list.permit.permit_list', 'pybind.nos.v6_0_2f.brocade_dai', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.arp.access_list.permit.permit_list', 'pybind.nos.v7_2_0.brocade_dai', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.dai_config.arp.access_list.permit.permit_list', 'pybind.slxos.v17r_1_01a.brocade_dai', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.dai_config.arp.access_list.permit.permit_list', 'pybind.slxos.v17r_2_00.brocade_dai', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.dai_config.arp.access_list.permit.permit_list', 'pybind.slxos.v17s_1_02.brocade_dai', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'permit_list', 'keyval': 'ip_type, host_ip, mac_type, host_mac', 'extra_keyval': 'ip_type, host_ip, mac_type, host_mac, log'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.arp.access_list.permit.permit_list": {"ip_type": "ip_type", "mac_type": "mac_type", "host_ip": "host_ip", "host_mac": "host_mac", "log": "log"}, "pybind.slxos.v17r_2_00.dai_config.arp.access_list.permit.permit_list": {}, "pybind.slxos.v17r_1_01a.dai_config.arp.access_list.permit.permit_list": {}, "pybind.nos.v6_0_2f.arp.access_list.permit.permit_list": {"ip_type": "ip_type", "mac_type": "mac_type", "host_ip": "host_ip", "host_mac": "host_mac", "log": "log"}, "pybind.slxos.v17s_1_02.dai_config.arp.access_list.permit.permit_list": {"ip_type": "ip_type", "mac_type": "mac_type", "host_ip": "host_ip", "host_mac": "host_mac", "log": "log"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_list=access_list, permit_list=permit_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_list=access_list, permit_list=permit_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def arp_access_list_permit_ip_log_get(self, access_list=None, permit_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type access_list: acl_name
    :param access_list: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **access_list** tuple argument:  <WORD:1-62>;;Name of ARP access-list

        * length restriction: ::

            ['1..62']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,61})'

    **Instance Keyword Argument Tuple**:

    :type permit_list: ip_type, host_ip, mac_type, host_mac
    :param permit_list: Keyword argument tuple.

    :type ip_type: unicode
    :param ip_type: **permit_list** tuple argument.

        * enumeration restriction: ::

            ['host']

    :type host_ip: unicode
    :param host_ip: **permit_list** tuple argument:  IPv4Address;;Source IPv4 Address A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac_type: unicode
    :param mac_type: **permit_list** tuple argument:  MAC address

        * enumeration restriction: ::

            ['host']

    :type host_mac: unicode
    :param host_mac: **permit_list** tuple argument:  MACADDRESS;;Mac address in HHHH.HHHH.HHHH format.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.arp.access_list', u'access_list'), ('pybind.slxos.v17s_1_02.dai_config.arp.access_list', u'access_list'), ('pybind.nos.v7_2_0.arp.access_list', u'access_list')]
    bindings_list = [('pybind.nos.v6_0_2f.arp.access_list.permit.permit_list', 'pybind.nos.v6_0_2f.brocade_dai', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.arp.access_list.permit.permit_list', 'pybind.nos.v7_2_0.brocade_dai', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.dai_config.arp.access_list.permit.permit_list', 'pybind.slxos.v17s_1_02.brocade_dai', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}, {'keyval': 'acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'permit_list', 'keyval': 'ip_type, host_ip, mac_type, host_mac', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_list=access_list, permit_list=permit_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_list=access_list, permit_list=permit_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def arp_ethernet_get(self, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.arp_entry', 'pybind.slxos.v17r_1_01a.brocade_arp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.arp_entry', 'pybind.slxos.v17r_2_00.brocade_arp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.arp_entry', 'pybind.slxos.v17s_1_02.brocade_arp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def arp_fortygigabitethernet_get(self, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_arp_holder.arp_entry', 'pybind.nos.v6_0_2f.brocade_arp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_2_0.brocade_arp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def arp_gigabitethernet_get(self, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_arp_holder.arp_entry', 'pybind.nos.v6_0_2f.brocade_arp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_2_0.brocade_arp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def arp_hundredgigabitethernet_get(self, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_arp_holder.arp_entry', 'pybind.nos.v6_0_2f.brocade_arp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_2_0.brocade_arp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def arp_interfacename_get(self, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_arp_holder.arp_entry', 'pybind.nos.v6_0_2f.brocade_arp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_2_0.brocade_arp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.arp_entry', 'pybind.slxos.v17r_1_01a.brocade_arp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.arp_entry', 'pybind.slxos.v17r_2_00.brocade_arp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.arp_entry', 'pybind.slxos.v17s_1_02.brocade_arp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def arp_mac_address_value_get(self, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_arp_holder.arp_entry', 'pybind.nos.v6_0_2f.brocade_arp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_2_0.brocade_arp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.arp_entry', 'pybind.slxos.v17r_1_01a.brocade_arp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.arp_entry', 'pybind.slxos.v17r_2_00.brocade_arp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.arp_entry', 'pybind.slxos.v17s_1_02.brocade_arp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def arp_port_channel_get(self, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_2_0.brocade_arp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def arp_tengigabitethernet_get(self, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_arp_holder.arp_entry', 'pybind.nos.v6_0_2f.brocade_arp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_2_0.brocade_arp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def arp_ve_get(self, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_arp_holder.arp_entry', 'pybind.nos.v6_0_2f.brocade_arp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_arp_holder.arp_entry', 'pybind.nos.v7_2_0.brocade_arp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.arp_entry', 'pybind.slxos.v17r_1_01a.brocade_arp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.arp_entry', 'pybind.slxos.v17r_2_00.brocade_arp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.arp_entry', 'pybind.slxos.v17s_1_02.brocade_arp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def banner_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.banner', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.banner', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.banner', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.banner', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.banner', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def banner_incoming_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.banner', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.banner', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.banner', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.banner', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.banner', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def banner_login_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.banner', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.banner', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.banner', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.banner', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.banner', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def banner_motd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.banner', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.banner', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.banner', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.banner', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.banner', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_mac_br_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_mac_br_state', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_mac_br_state', 'pybind.slxos.v17r_2_00.brocade_l2sys_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_mac_br_state', 'pybind.slxos.v17s_1_02.brocade_l2sys_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.bd_mac_br_state": {}, "pybind.slxos.v17r_2_00.bd_mac_br_state": {"dyn_mac_count": "dyn_mac_count", "total_mac_count": "total_mac_count", "static_mac_count": "static_mac_count"}, "pybind.slxos.v17r_1_01a.bd_mac_br_state": {"dyn_mac_count": "dyn_mac_count", "total_mac_count": "total_mac_count", "static_mac_count": "static_mac_count"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_mac_br_state_dyn_mac_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_mac_br_state', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_mac_br_state', 'pybind.slxos.v17r_2_00.brocade_l2sys_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_mac_br_state', 'pybind.slxos.v17s_1_02.brocade_l2sys_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_mac_br_state_evpn_mac_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.bd_mac_br_state', 'pybind.slxos.v17s_1_02.brocade_l2sys_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_mac_br_state_static_mac_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_mac_br_state', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_mac_br_state', 'pybind.slxos.v17r_2_00.brocade_l2sys_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_mac_br_state', 'pybind.slxos.v17s_1_02.brocade_l2sys_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_mac_br_state_total_mac_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_mac_br_state', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_mac_br_state', 'pybind.slxos.v17r_2_00.brocade_l2sys_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_mac_br_state', 'pybind.slxos.v17s_1_02.brocade_l2sys_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_get(self, bd_vc_peer_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', u'bd_vc_peer_counter'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state', u'bd_vc_peer_data'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', u'bd_vc_peer_counter'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', u'bd_vc_peer_data'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', u'bd_vc_peer_data'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', u'bd_vc_peer_counter')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bd_vc_peer_state', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_of_peer_configured, no_of_peer_operational'}, {'leafval': 'vc_peer_address, vc_peer_state, vc_peer_uptime, vc_peer_load_balance, vc_peer_cos_enabled, vc_peer_cos_value, vc_ldp_tnnl_in_use, vc_local_label, vc_remote_label, vc_local_mtu, vc_remote_mtu, vc_local_type, vc_remote_type, vc_local_pw_status, vc_remote_pw_status, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_local_control_word, vc_remote_control_word'}, {'leafval': 'no_of_peer_configured, no_of_peer_operational'}, {'leafval': 'vc_peer_address, vc_peer_state, vc_peer_uptime, vc_peer_load_balance, vc_peer_cos_enabled, vc_peer_cos_value, vc_ldp_tnnl_in_use, vc_local_label, vc_remote_label, vc_local_mtu, vc_remote_mtu, vc_local_type, vc_remote_type, vc_local_pw_status, vc_remote_pw_status'}, {'leafval': 'vc_peer_address, vc_peer_state, vc_peer_uptime, vc_peer_load_balance, vc_peer_cos_enabled, vc_peer_cos_value, vc_ldp_tnnl_in_use, vc_local_label, vc_remote_label, vc_local_mtu, vc_remote_mtu, vc_local_type, vc_remote_type'}, {'leafval': 'no_of_peer_configured, no_of_peer_operational'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_counter_get(self, bd_vc_peer_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_counter', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_counter', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_counter', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_counter_no_of_peer_configured_get(self, bd_vc_peer_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_counter', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_counter', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_counter', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_counter_no_of_peer_operational_get(self, bd_vc_peer_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_counter', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_counter', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_counter', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data": {}, "pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data": {"vc_peer_cos_value": "vc_peer_cos_value", "vc_local_type": "vc_local_type", "vc_peer_load_balance": "vc_peer_load_balance", "vc_remote_type": "vc_remote_type", "vc_peer_uptime": "vc_peer_uptime", "vc_peer_address": "vc_peer_address", "vc_peer_state": "vc_peer_state", "vc_local_mtu": "vc_local_mtu", "vc_local_pw_status": "vc_local_pw_status", "vc_local_label": "vc_local_label", "vc_peer_cos_enabled": "vc_peer_cos_enabled", "vc_remote_mtu": "vc_remote_mtu", "vc_ldp_tnnl_in_use": "vc_ldp_tnnl_in_use", "vc_remote_label": "vc_remote_label", "vc_remote_pw_status": "vc_remote_pw_status"}, "pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_assigned_lsp_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, vc_assigned_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type vc_assigned_lsp: vc_lsp_name
    :param vc_assigned_lsp: Keyword argument tuple.

    :type vc_lsp_name: unicode
    :param vc_lsp_name: **vc_assigned_lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data.vc_assigned_lsp', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data.vc_assigned_lsp', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data.vc_assigned_lsp', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_assigned_lsp', 'keyval': 'vc_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_assigned_lsp=vc_assigned_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_assigned_lsp=vc_assigned_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_ldp_tnnl_in_use_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_local_control_word_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_local_flow_label_rx_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_local_flow_label_tx_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_local_label_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_local_mtu_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_local_pw_status_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_local_type_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_peer_cos_enabled_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_peer_cos_value_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_peer_load_balance_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_peer_state_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_peer_uptime_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_proto_tnnl_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, vc_proto_tnnl=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_proto_tnnl_vc_ldp_name_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, vc_proto_tnnl=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_proto_tnnl_vc_ldp_tunnel_id_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, vc_proto_tnnl=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_proto_tnnl_vc_lsp_name_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, vc_proto_tnnl=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_proto_tnnl_vc_peer_lsp_cos_enabled_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, vc_proto_tnnl=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_proto_tnnl_vc_peer_lsp_cos_value_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, vc_proto_tnnl=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'bd_vc_peer_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_peer_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_remote_control_word_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_remote_flow_label_rx_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_remote_flow_label_tx_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_remote_label_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_remote_mtu_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_remote_pw_status_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bd_vc_peer_state_bd_vc_peer_data_vc_remote_type_get(self, bd_vc_peer_state=None, bd_vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bd_vc_peer_state: vc_id
    :param bd_vc_peer_state: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **bd_vc_peer_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_vc_peer_data: vc_peer_address
    :param bd_vc_peer_data: Keyword argument tuple.

    :type vc_peer_address: unicode
    :param vc_peer_address: **bd_vc_peer_data** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state', 'bd_vc_peer_state'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state', 'bd_vc_peer_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_2_00.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_1_01a.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17s_1_02.bd_vc_peer_state.bd_vc_peer_data', u'vc_assigned_lsp')]
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vc_peer_data', 'keyval': 'vc_peer_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_vc_peer_state=bd_vc_peer_state, bd_vc_peer_data=bd_vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def beacon_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.beacon', 'pybind.nos.v6_0_2f.brocade_beacon', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.beacon', 'pybind.nos.v7_2_0.brocade_beacon', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.beacon', 'pybind.slxos.v17r_1_01a.brocade_beacon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.beacon', 'pybind.slxos.v17r_2_00.brocade_beacon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.beacon', 'pybind.slxos.v17s_1_02.brocade_beacon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def beacon_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.beacon.disable', 'pybind.slxos.v17r_1_01a.brocade_beacon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.beacon.disable', 'pybind.slxos.v17r_2_00.brocade_beacon', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def beacon_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.beacon.enable', 'pybind.slxos.v17r_1_01a.brocade_beacon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.beacon.enable', 'pybind.slxos.v17r_2_00.brocade_beacon', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'mac'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'inclusive_multicast'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'nd'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'igmp_join_sync'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'igmp_leave_sync'), ('pybind.slxos.v17r_2_00.bgp_state.summary', u'evpn'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor', u'evpn'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'auto_discovery'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'arp'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'ipv4_prefix'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'ethernet_segment'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'ipv6_prefix')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}, {'leafval': 'router_id, local_as, confederation_id, cluster_id_ipv4, cluster_id, max_ecmp_paths, max_bgp_routes_in_rtm, num_neighbor_configured, num_neighbor_up, num_routes_installed, bytes_used_num_routes_installed, num_routes_adv_all_neighbors, num_routes_adv_all_neighbors_rib_out_entries, bytes_used_num_routes_adv_all_neighbors, num_attr_entries_installed, bytes_used_num_attr_entries_installed, update_msgs_dropped, oom_received_routes, oom_outgoing_routes, oom_attribute_entries'}, {'leafval': 'remote_as, router_id, vrf, local_as, no_prepend, description, bgp_state, bgp_state_time, keep_alive_time, hold_time, keep_alive_time_expire, hold_time_expire, min_advertisement_interval, peer_group, multihop_ebgp_ttl, multihop_btsh, md5_password, next_hop_self, remove_private_as, soft_inbound_reconfig, refresh_capability_received, gr_capability_received, gr_restart_time_received, gr_restart_bit_received, afi, safi, forwarding_bit, gr_capability_sent, gr_restart_time_sent, gr_restart_bit_sent, stale_state, stale_state_time_left_to_reconnect, restarting_state, restarting_time_left_to_converge, restarting_start_stale_timer, restarting_stale_timer_left_to_converge, purge_time, cooperative_filtering_capability_sent, cooperative_filtering_capability_received, route_reflector_client, send_community, peer_as_check, send_ext_community, default_originate, default_originate_sent, max_prefix_limit, unsuppress_route_map, last_conn_reset_reason, notification_sent_code, notification_received_code, remote_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_prefix, l3vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_prefix, l3vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor', u'evpn')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'remote_as, router_id, vrf, local_as, no_prepend, description, bgp_state, bgp_state_time, keep_alive_time, hold_time, keep_alive_time_expire, hold_time_expire, min_advertisement_interval, peer_group, multihop_ebgp_ttl, multihop_btsh, md5_password, next_hop_self, remove_private_as, soft_inbound_reconfig, refresh_capability_received, gr_capability_received, gr_restart_time_received, gr_restart_bit_received, afi, safi, forwarding_bit, gr_capability_sent, gr_restart_time_sent, gr_restart_bit_sent, stale_state, stale_state_time_left_to_reconnect, restarting_state, restarting_time_left_to_converge, restarting_start_stale_timer, restarting_stale_timer_left_to_converge, purge_time, cooperative_filtering_capability_sent, cooperative_filtering_capability_received, route_reflector_client, send_community, peer_as_check, send_ext_community, default_originate, default_originate_sent, max_prefix_limit, unsuppress_route_map, last_conn_reset_reason, notification_sent_code, notification_received_code, remote_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_afi_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_bgp_state_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_bgp_state_time_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_cooperative_filtering_capability_received_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_cooperative_filtering_capability_sent_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_default_originate_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_default_originate_sent_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_description_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_distribute_list_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.distribute_list', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_distribute_list_in_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.distribute_list', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_distribute_list_in_name_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.distribute_list', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_distribute_list_out_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.distribute_list', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_distribute_list_out_name_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.distribute_list', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_filter_list_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.filter_list', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_filter_list_in_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.filter_list', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_filter_list_in_name_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.filter_list', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_filter_list_out_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.filter_list', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_filter_list_out_name_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.filter_list', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_forwarding_bit_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_gr_capability_received_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_gr_capability_sent_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_gr_restart_bit_received_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_gr_restart_bit_sent_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_gr_restart_time_received_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_gr_restart_time_sent_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_hold_time_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_hold_time_expire_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_keep_alive_time_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_keep_alive_time_expire_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_last_conn_reset_reason_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_last_update_time_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.last_update_time', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_last_update_time_rx_nlri_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.last_update_time', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_last_update_time_rx_withdraw_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.last_update_time', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_last_update_time_tx_nlri_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.last_update_time', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_last_update_time_tx_withdraw_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.last_update_time', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_local_as_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_max_prefix_limit_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_md5_password_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_min_advertisement_interval_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_msg_received_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.msg_received', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_msg_received_keepalive_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.msg_received', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_msg_received_notification_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.msg_received', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_msg_received_open_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.msg_received', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_msg_received_refresh_req_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.msg_received', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_msg_received_update_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.msg_received', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_msg_sent_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.msg_sent', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_msg_sent_keepalive_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.msg_sent', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_msg_sent_notification_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.msg_sent', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_msg_sent_open_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.msg_sent', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_msg_sent_refresh_req_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.msg_sent', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_msg_sent_update_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.msg_sent', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_multihop_btsh_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_multihop_ebgp_ttl_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_configured_routes_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_configured_routes', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_configured_routes_as4_capability_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_configured_routes', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_configured_routes_ipv4_mcast_routes_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_configured_routes', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_configured_routes_ipv4_ucast_mcast_routes_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_configured_routes', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_configured_routes_ipv4_ucast_routes_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_configured_routes', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_configured_routes_ipv6_mcast_routes_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_configured_routes', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_configured_routes_ipv6_mpls_label_capability_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_configured_routes', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_configured_routes_ipv6_ucast_mcast_routes_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_configured_routes', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_configured_routes_ipv6_ucast_routes_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_configured_routes', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_configured_routes_l2vpn_evpn_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_configured_routes', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_configured_routes_l2vpn_vpls_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_configured_routes', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_configured_routes_vpnv4_ucast_routes_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_configured_routes', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_configured_routes_vpnv6_ucast_routes_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_configured_routes', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_nlri_negotiation_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_nlri_negotiation', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_nlri_negotiation_as4_capability_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_nlri_negotiation', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_nlri_negotiation_ipv4_mcast_capability_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_nlri_negotiation', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_nlri_negotiation_ipv4_ucast_capability_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_nlri_negotiation', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_nlri_negotiation_ipv4_ucast_mcast_capability_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_nlri_negotiation', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_nlri_negotiation_ipv6_mcast_capability_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_nlri_negotiation', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_nlri_negotiation_ipv6_mpls_label_capability_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_nlri_negotiation', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_nlri_negotiation_ipv6_ucast_capability_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_nlri_negotiation', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_nlri_negotiation_ipv6_ucast_mcast_capability_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_nlri_negotiation', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_nlri_negotiation_l2vpn_evpn_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_nlri_negotiation', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_nlri_negotiation_l2vpn_vpls_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_nlri_negotiation', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_nlri_negotiation_vpnv4_ucast_capability_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_nlri_negotiation', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_neighbor_nlri_negotiation_vpnv6_ucast_capability_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.neighbor_nlri_negotiation', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_next_hop_self_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_no_prepend_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_notification_received_code_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_notification_sent_code_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_peer_as_check_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_peer_group_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_prefix_list_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.prefix_list', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_prefix_list_in_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.prefix_list', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_prefix_list_in_name_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.prefix_list', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_prefix_list_out_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.prefix_list', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_prefix_list_out_name_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.prefix_list', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_purge_time_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_refresh_capability_received_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_remote_as_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_remove_private_as_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_restarting_stale_timer_left_to_converge_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_restarting_start_stale_timer_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_restarting_state_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_restarting_time_left_to_converge_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_route_map_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.route_map', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_route_map_in_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.route_map', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_route_map_in_name_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.route_map', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_route_map_out_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.route_map', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_route_map_out_name_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.route_map', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_route_reflector_client_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_router_id_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_safi_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_send_community_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_send_ext_community_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_soft_inbound_reconfig_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_stale_state_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_stale_state_time_left_to_reconnect_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_unsuppress_route_map_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_update_source_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.update_source', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_update_source_ethernet_port_id_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.update_source', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_update_source_interface_name_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.update_source', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_update_source_loopback_intf_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.update_source', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_update_source_pos_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.update_source', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_update_source_type_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.update_source', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_update_source_virtual_intf_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'evpn')]
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn.update_source', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'remote_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_neighbor_evpn_vrf_get(self, evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type evpn: remote_address
    :param evpn: Keyword argument tuple.

    :type remote_address: unicode
    :param remote_address: **evpn** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'distribute_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_configured_routes'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_received'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'route_map'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'prefix_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'last_update_time'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'update_source'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'filter_list'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'neighbor_nlri_negotiation'), ('pybind.slxos.v17r_2_00.bgp_state.neighbor.evpn', u'msg_sent')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn', 'keyval': 'remote_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_routes, ipv4_mcast_routes, ipv4_ucast_routes, vpnv4_ucast_routes, vpnv6_ucast_routes, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_routes, ipv6_mcast_routes, ipv6_ucast_routes, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'tx_nlri, tx_withdraw, rx_nlri, rx_withdraw'}, {'leafval': 'type, interface_name, loopback_intf, virtual_intf, ethernet_port_id, pos'}, {'leafval': 'in_, out, in_name, out_name'}, {'leafval': 'ipv4_ucast_mcast_capability, ipv4_mcast_capability, ipv4_ucast_capability, vpnv4_ucast_capability, vpnv6_ucast_capability, l2vpn_vpls, l2vpn_evpn, ipv6_ucast_mcast_capability, ipv6_mcast_capability, ipv6_ucast_capability, ipv6_mpls_label_capability, as4_capability'}, {'leafval': 'open, update, keepalive, notification, refresh_req'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn=evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn=evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'mac'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'inclusive_multicast'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'nd'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'igmp_join_sync'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'igmp_leave_sync'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'auto_discovery'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'arp'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'ipv4_prefix'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'ethernet_segment'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'ipv6_prefix')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_prefix, l3vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_prefix, l3vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'mac'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'inclusive_multicast'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'nd'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'igmp_join_sync'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'igmp_leave_sync'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'auto_discovery'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'arp'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'ipv4_prefix'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'ethernet_segment'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'ipv6_prefix')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_prefix, l3vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_prefix, l3vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_adj_rib_out_count_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_admin_distance_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_age_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_aggregator_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_as_path_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_atomic_aggregate_set_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_cluster_list_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_communities_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_esi_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_extended_community_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_l2_label_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_l3_label_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_local_preference_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_med_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_next_hop_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_next_hop_learned_from_peer_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_next_hop_metric_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_origin_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_originator_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_prefix_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_rd_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_rmac_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_source_rd_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_status_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_tag_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_vrf_label_direction_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_arp_weight_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_adj_rib_out_count_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_admin_distance_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_age_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_aggregator_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_as_path_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_atomic_aggregate_set_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_cluster_list_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_communities_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_esi_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_extended_community_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_l2_label_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_l3_label_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_local_preference_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_med_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_next_hop_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_next_hop_learned_from_peer_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_next_hop_metric_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_origin_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_originator_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_prefix_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_rd_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_rmac_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_source_rd_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_status_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_tag_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_vrf_label_direction_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_auto_discovery_weight_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_adj_rib_out_count_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_admin_distance_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_age_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_aggregator_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_as_path_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_atomic_aggregate_set_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_cluster_list_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_communities_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_esi_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_extended_community_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_l2_label_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_l3_label_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_local_preference_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_med_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_next_hop_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_next_hop_learned_from_peer_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_next_hop_metric_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_origin_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_originator_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_prefix_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_rd_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_rmac_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_source_rd_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_status_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_tag_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_vrf_label_direction_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ethernet_segment_weight_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_adj_rib_out_count_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_admin_distance_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_age_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_aggregator_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_as_path_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_atomic_aggregate_set_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_cluster_list_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_communities_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_esi_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_extended_community_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_l2_label_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_l3_label_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_local_preference_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_med_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_next_hop_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_next_hop_learned_from_peer_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_next_hop_metric_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_origin_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_originator_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_prefix_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_rd_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_rmac_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_source_rd_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_status_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_tag_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_vrf_label_direction_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_join_sync_weight_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_adj_rib_out_count_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_admin_distance_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_age_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_aggregator_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_as_path_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_atomic_aggregate_set_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_cluster_list_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_communities_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_esi_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_extended_community_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_l2_label_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_l3_label_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_local_preference_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_med_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_next_hop_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_next_hop_learned_from_peer_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_next_hop_metric_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_origin_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_originator_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_prefix_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_rd_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_rmac_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_source_rd_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_status_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_tag_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_vrf_label_direction_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_igmp_leave_sync_weight_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_adj_rib_out_count_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_admin_distance_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_age_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_aggregator_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_as_path_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_atomic_aggregate_set_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_cluster_list_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_communities_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_esi_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_extended_community_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_l2_label_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_l3_label_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_local_preference_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_med_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_next_hop_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_next_hop_learned_from_peer_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_next_hop_metric_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_origin_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_originator_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_prefix_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_rd_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_rmac_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_source_rd_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_status_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_tag_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_vrf_label_direction_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_inclusive_multicast_weight_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_adj_rib_out_count_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_admin_distance_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_age_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_aggregator_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_as_path_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_atomic_aggregate_set_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_cluster_list_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_communities_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_esi_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_extended_community_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_l2_label_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_l3_label_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_local_preference_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_med_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_next_hop_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_next_hop_learned_from_peer_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_next_hop_metric_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_origin_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_originator_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_prefix_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_rd_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_rmac_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_source_rd_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_status_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_tag_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_vrf_label_direction_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv4_prefix_weight_get(self, ipv4_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv4_prefix: ipv4_prefix, l3vni
    :param ipv4_prefix: Keyword argument tuple.

    :type ipv4_prefix: unicode
    :param ipv4_prefix: **ipv4_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type l3vni: long
    :param l3vni: **ipv4_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv4_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_prefix', 'keyval': 'ipv4_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_prefix=ipv4_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_prefix=ipv4_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_adj_rib_out_count_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_admin_distance_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_age_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_aggregator_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_as_path_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_atomic_aggregate_set_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_cluster_list_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_communities_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_esi_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_extended_community_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_l2_label_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_l3_label_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_local_preference_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_med_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_next_hop_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_next_hop_learned_from_peer_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_next_hop_metric_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_origin_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_originator_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_prefix_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_rd_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_rmac_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_source_rd_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_status_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_tag_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_vrf_label_direction_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_ipv6_prefix_weight_get(self, ipv6_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ipv6_prefix: ipv6_prefix, l3vni
    :param ipv6_prefix: Keyword argument tuple.

    :type ipv6_prefix: unicode
    :param ipv6_prefix: **ipv6_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type l3vni: long
    :param l3vni: **ipv6_prefix** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.ipv6_prefix', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_prefix', 'keyval': 'ipv6_prefix, l3vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_prefix=ipv6_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_prefix=ipv6_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'auto_discovery'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'arp'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'inclusive_multicast'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_join_sync'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'igmp_leave_sync'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'ethernet_segment')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv4_address, mac, ethernet_tag, l2vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ethernet_tag, ipv4_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, esi_value, ipv4_address, ipv6_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_adj_rib_out_count_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_admin_distance_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_age_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_aggregator_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_as_path_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_atomic_aggregate_set_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_cluster_list_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_communities_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_esi_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_extended_community_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_l2_label_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_l3_label_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_local_preference_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_med_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_next_hop_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_next_hop_learned_from_peer_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_next_hop_metric_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_origin_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_originator_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_prefix_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_rd_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_rmac_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_source_rd_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_status_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_tag_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_vrf_label_direction_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_arp_weight_get(self, arp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type arp: ipv4_address, mac, ethernet_tag, l2vni
    :param arp: Keyword argument tuple.

    :type ipv4_address: unicode
    :param ipv4_address: **arp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac: unicode
    :param mac: **arp** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **arp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.arp', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arp', 'keyval': 'ipv4_address, mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arp=arp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arp=arp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_adj_rib_out_count_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_admin_distance_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_age_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_aggregator_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_as_path_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_atomic_aggregate_set_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_cluster_list_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_communities_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_esi_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_extended_community_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_l2_label_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_l3_label_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_local_preference_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_med_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_next_hop_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_next_hop_learned_from_peer_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_next_hop_metric_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_origin_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_originator_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_prefix_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_rd_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_rmac_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_source_rd_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_status_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_tag_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_vrf_label_direction_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_auto_discovery_weight_get(self, auto_discovery=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type auto_discovery: esi_value, ethernet_tag
    :param auto_discovery: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **auto_discovery** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **auto_discovery** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.auto_discovery', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_discovery', 'keyval': 'esi_value, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_discovery=auto_discovery)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_discovery=auto_discovery)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_adj_rib_out_count_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_admin_distance_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_age_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_aggregator_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_as_path_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_atomic_aggregate_set_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_cluster_list_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_communities_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_esi_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_extended_community_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_l2_label_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_l3_label_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_local_preference_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_med_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_next_hop_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_next_hop_learned_from_peer_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_next_hop_metric_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_origin_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_originator_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_prefix_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_rd_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_rmac_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_source_rd_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_status_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_tag_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_vrf_label_direction_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_ethernet_segment_weight_get(self, ethernet_segment=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet_segment: esi_value, ipv4_address, ipv6_address
    :param ethernet_segment: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **ethernet_segment** tuple argument.

    :type ipv4_address: unicode
    :param ipv4_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_address: unicode
    :param ipv6_address: **ethernet_segment** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.ethernet_segment', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet_segment', 'keyval': 'esi_value, ipv4_address, ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet_segment=ethernet_segment)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet_segment=ethernet_segment)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_adj_rib_out_count_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_admin_distance_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_age_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_aggregator_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_as_path_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_atomic_aggregate_set_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_cluster_list_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_communities_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_esi_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_extended_community_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_l2_label_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_l3_label_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_local_preference_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_med_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_next_hop_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_next_hop_learned_from_peer_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_next_hop_metric_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_origin_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_originator_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_prefix_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_rd_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_rmac_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_source_rd_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_status_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_tag_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_vrf_label_direction_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_join_sync_weight_get(self, igmp_join_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_join_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address
    :param igmp_join_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_join_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_join_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_join_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_join_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_join_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_join_sync=igmp_join_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_join_sync=igmp_join_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_adj_rib_out_count_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_admin_distance_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_age_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_aggregator_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_as_path_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_atomic_aggregate_set_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_cluster_list_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_communities_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_esi_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_extended_community_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_l2_label_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_l3_label_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_local_preference_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_med_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_next_hop_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_next_hop_learned_from_peer_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_next_hop_metric_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_origin_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_originator_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_prefix_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_rd_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_rmac_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_source_rd_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_status_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_tag_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_vrf_label_direction_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_igmp_leave_sync_weight_get(self, igmp_leave_sync=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_leave_sync: esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync
    :param igmp_leave_sync: Keyword argument tuple.

    :type esi_value: unicode
    :param esi_value: **igmp_leave_sync** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_orig_rtrid: unicode
    :param ipv4_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_orig_rtrid: unicode
    :param ipv6_orig_rtrid: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_grp_address: unicode
    :param ipv4_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_grp_address: unicode
    :param ipv6_grp_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type ipv4_src_address: unicode
    :param ipv4_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv6_src_address: unicode
    :param ipv6_src_address: **igmp_leave_sync** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type leave_grp_sync: long
    :param leave_grp_sync: **igmp_leave_sync** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.igmp_leave_sync', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_leave_sync', 'keyval': 'esi_value, ethernet_tag, ipv4_orig_rtrid, ipv6_orig_rtrid, ipv4_grp_address, ipv6_grp_address, ipv4_src_address, ipv6_src_address, leave_grp_sync', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_leave_sync=igmp_leave_sync)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_leave_sync=igmp_leave_sync)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_adj_rib_out_count_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_admin_distance_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_age_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_aggregator_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_as_path_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_atomic_aggregate_set_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_cluster_list_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_communities_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_esi_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_extended_community_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_l2_label_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_l3_label_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_local_preference_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_med_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_next_hop_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_next_hop_learned_from_peer_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_next_hop_metric_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_origin_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_originator_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_prefix_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_rd_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_rmac_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_source_rd_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_status_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_tag_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_vrf_label_direction_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_inclusive_multicast_weight_get(self, inclusive_multicast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type inclusive_multicast: ethernet_tag, ipv4_address
    :param inclusive_multicast: Keyword argument tuple.

    :type ethernet_tag: long
    :param ethernet_tag: **inclusive_multicast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv4_address: unicode
    :param ipv4_address: **inclusive_multicast** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.inclusive_multicast', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inclusive_multicast', 'keyval': 'ethernet_tag, ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inclusive_multicast=inclusive_multicast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inclusive_multicast=inclusive_multicast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_adj_rib_out_count_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_admin_distance_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_age_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_aggregator_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_as_path_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_atomic_aggregate_set_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_cluster_list_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_communities_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_esi_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_extended_community_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_l2_label_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_l3_label_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_local_preference_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_med_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_next_hop_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_next_hop_learned_from_peer_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_next_hop_metric_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_origin_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_originator_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_prefix_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_rd_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_rmac_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_source_rd_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_status_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_tag_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_vrf_label_direction_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_mac_weight_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_adj_rib_out_count_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_admin_distance_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_age_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_aggregator_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_as_path_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_atomic_aggregate_set_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_cluster_list_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_communities_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_esi_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_extended_community_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_l2_label_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_l3_label_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_local_preference_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_med_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_next_hop_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_next_hop_learned_from_peer_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_next_hop_metric_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_origin_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_originator_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_prefix_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_rd_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_rmac_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_source_rd_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_status_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_tag_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_vrf_label_direction_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_l2_nd_weight_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_adj_rib_out_count_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_admin_distance_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_age_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_aggregator_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_as_path_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_atomic_aggregate_set_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_cluster_list_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_communities_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_esi_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_extended_community_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_l2_label_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_l3_label_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_local_preference_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_med_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_next_hop_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_next_hop_learned_from_peer_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_next_hop_metric_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_origin_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_originator_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_prefix_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_rd_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_rmac_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_source_rd_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_status_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_tag_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_vrf_label_direction_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_mac_weight_get(self, mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mac: mac, ethernet_tag, l2vni
    :param mac: Keyword argument tuple.

    :type mac: unicode
    :param mac: **mac** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type l2vni: long
    :param l2vni: **mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.mac', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mac', 'keyval': 'mac, ethernet_tag, l2vni', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac=mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac=mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_adj_rib_out_count_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_admin_distance_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_age_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_aggregator_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_as_path_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_atomic_aggregate_set_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_cluster_list_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_communities_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_esi_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_extended_community_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_l2_label_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_l3_label_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_local_preference_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_med_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_next_hop_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_next_hop_learned_from_peer_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_next_hop_metric_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_origin_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_originator_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_prefix_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_rd_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_rmac_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_source_rd_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_status_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_tag_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_vrf_label_direction_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_route_evpn_nd_weight_get(self, nd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type nd: ipv6_address, mac, ethernet_tag
    :param nd: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **nd** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type mac: unicode
    :param mac: **nd** tuple argument.

    :type ethernet_tag: long
    :param ethernet_tag: **nd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.nd', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nd', 'keyval': 'ipv6_address, mac, ethernet_tag', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, ipv6_address, mac, ethernet_tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nd=nd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nd=nd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bgp_state.summary', u'evpn')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, local_as, confederation_id, cluster_id_ipv4, cluster_id, max_ecmp_paths, max_bgp_routes_in_rtm, num_neighbor_configured, num_neighbor_up, num_routes_installed, bytes_used_num_routes_installed, num_routes_adv_all_neighbors, num_routes_adv_all_neighbors_rib_out_entries, bytes_used_num_routes_adv_all_neighbors, num_attr_entries_installed, bytes_used_num_attr_entries_installed, update_msgs_dropped, oom_received_routes, oom_outgoing_routes, oom_attribute_entries'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_bytes_used_num_attr_entries_installed_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_bytes_used_num_routes_adv_all_neighbors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_bytes_used_num_routes_installed_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_cluster_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_cluster_id_ipv4_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_confederation_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_local_as_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_max_bgp_routes_in_rtm_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_max_ecmp_paths_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_num_attr_entries_installed_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_num_neighbor_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_num_neighbor_up_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_num_routes_adv_all_neighbors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_num_routes_adv_all_neighbors_rib_out_entries_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_num_routes_installed_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_oom_attribute_entries_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_oom_outgoing_routes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_oom_received_routes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_router_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bgp_state_summary_evpn_update_msgs_dropped_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bgp_state.summary.evpn', 'pybind.slxos.v17r_2_00.brocade_bgp_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bp_rate_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bp_rate_limit', 'pybind.slxos.v17r_1_01a.brocade_bprate_limit', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bp_rate_limit', 'pybind.slxos.v17r_2_00.brocade_bprate_limit', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bp_rate_limit', 'pybind.slxos.v17s_1_02.brocade_bprate_limit', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bp_rate_limit.heavy', u'module'), ('pybind.slxos.v17r_1_01a.bp_rate_limit.heavy', u'module'), ('pybind.slxos.v17s_1_02.bp_rate_limit.heavy', u'module')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'add_, remove_'}, {'leafval': 'add_, remove_'}, {'leafval': 'add_, remove_'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bp_rate_limit_heavy_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bp_rate_limit.heavy', 'pybind.slxos.v17r_1_01a.brocade_bprate_limit', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bp_rate_limit.heavy', 'pybind.slxos.v17r_2_00.brocade_bprate_limit', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bp_rate_limit.heavy', 'pybind.slxos.v17s_1_02.brocade_bprate_limit', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bp_rate_limit.heavy', u'module'), ('pybind.slxos.v17r_1_01a.bp_rate_limit.heavy', u'module'), ('pybind.slxos.v17r_2_00.bp_rate_limit.heavy', u'module')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'add_, remove_'}, {'leafval': 'add_, remove_'}, {'leafval': 'add_, remove_'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bp_rate_limit_heavy_module_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bp_rate_limit.heavy.module', 'pybind.slxos.v17r_1_01a.brocade_bprate_limit', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bp_rate_limit.heavy.module', 'pybind.slxos.v17r_2_00.brocade_bprate_limit', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bp_rate_limit.heavy.module', 'pybind.slxos.v17s_1_02.brocade_bprate_limit', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bp_rate_limit_heavy_module_add_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bp_rate_limit.heavy.module', 'pybind.slxos.v17r_1_01a.brocade_bprate_limit', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bp_rate_limit.heavy.module', 'pybind.slxos.v17r_2_00.brocade_bprate_limit', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bp_rate_limit.heavy.module', 'pybind.slxos.v17s_1_02.brocade_bprate_limit', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bp_rate_limit_heavy_module_remove_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bp_rate_limit.heavy.module', 'pybind.slxos.v17r_1_01a.brocade_bprate_limit', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bp_rate_limit.heavy.module', 'pybind.slxos.v17r_2_00.brocade_bprate_limit', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bp_rate_limit.heavy.module', 'pybind.slxos.v17s_1_02.brocade_bprate_limit', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_bridge_domain', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.bridge_domain', u'router_interface'), ('pybind.slxos.v17s_1_02.bridge_domain', u'peer'), ('pybind.slxos.v17s_1_02.bridge_domain', u'suppress_arp'), ('pybind.slxos.v17s_1_02.bridge_domain', u'suppress_nd'), ('pybind.slxos.v17r_2_00.bridge_domain', u'suppress_nd'), ('pybind.slxos.v17r_2_00.bridge_domain', u'mac_address'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp', u'snooping'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_pim', u'snooping'), ('pybind.slxos.v17r_2_00.bridge_domain', u'suppress_arp'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', u'igmps_querier'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.bridge_domain', u'router_interface'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_2_00.bridge_domain', u'peer'), ('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.bridge_domain', u'peer'), ('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.bridge_domain', u'mac_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain', 'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_bind_id'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'router_ve'}, {'leafval': 'peer_ip, load_balance, cos'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'withdrawal'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'bd_pimv4_enable'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'lif_bind_id'}, {'leafval': 'igmps_qenable'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'router_ve, disallow_oar_ac'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'peer_ip, load_balance, cos, flow_label, control_word'}, {'leafval': 'lif_bind_id'}, {'leafval': 'peer_ip, load_balance, cos'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'withdrawal'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.bridge_domain": {"statistics": "statistics", "description": "description", "vc_id_num": "vc_id_num", "bridge_domain_id": "bridge_domain_id", "bpdu_drop_enable": "bpdu_drop_enable", "bridge_domain_type": "bridge_domain_type", "pw_profile_name": "pw_profile_name", "local_switching": "local_switching"}, "pybind.slxos.v17r_2_00.bridge_domain": {"statistics": "statistics", "description": "description", "vc_id_num": "vc_id_num", "bridge_domain_id": "bridge_domain_id", "bpdu_drop_enable": "bpdu_drop_enable", "bridge_domain_type": "bridge_domain_type", "pw_profile_name": "pw_profile_name", "local_switching": "local_switching"}, "pybind.slxos.v17s_1_02.bridge_domain": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_bpdu_drop_enable_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_bridge_domain', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.bridge_domain', u'router_interface'), ('pybind.slxos.v17s_1_02.bridge_domain', u'peer'), ('pybind.slxos.v17s_1_02.bridge_domain', u'suppress_arp'), ('pybind.slxos.v17s_1_02.bridge_domain', u'suppress_nd'), ('pybind.slxos.v17r_2_00.bridge_domain', u'suppress_nd'), ('pybind.slxos.v17r_2_00.bridge_domain', u'mac_address'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp', u'snooping'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_pim', u'snooping'), ('pybind.slxos.v17r_2_00.bridge_domain', u'suppress_arp'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', u'igmps_querier'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.bridge_domain', u'router_interface'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_2_00.bridge_domain', u'peer'), ('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.bridge_domain', u'peer'), ('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.bridge_domain', u'mac_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain', 'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_bind_id'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'router_ve'}, {'leafval': 'peer_ip, load_balance, cos'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'withdrawal'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'bd_pimv4_enable'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'lif_bind_id'}, {'leafval': 'igmps_qenable'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'router_ve, disallow_oar_ac'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'peer_ip, load_balance, cos, flow_label, control_word'}, {'leafval': 'lif_bind_id'}, {'leafval': 'peer_ip, load_balance, cos'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'withdrawal'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_description_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_bridge_domain', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.bridge_domain', u'router_interface'), ('pybind.slxos.v17s_1_02.bridge_domain', u'peer'), ('pybind.slxos.v17s_1_02.bridge_domain', u'suppress_arp'), ('pybind.slxos.v17s_1_02.bridge_domain', u'suppress_nd'), ('pybind.slxos.v17r_2_00.bridge_domain', u'suppress_nd'), ('pybind.slxos.v17r_2_00.bridge_domain', u'mac_address'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp', u'snooping'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_pim', u'snooping'), ('pybind.slxos.v17r_2_00.bridge_domain', u'suppress_arp'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', u'igmps_querier'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.bridge_domain', u'router_interface'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_2_00.bridge_domain', u'peer'), ('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.bridge_domain', u'peer'), ('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.bridge_domain', u'mac_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain', 'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_bind_id'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'router_ve'}, {'leafval': 'peer_ip, load_balance, cos'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'withdrawal'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'bd_pimv4_enable'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'lif_bind_id'}, {'leafval': 'igmps_qenable'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'router_ve, disallow_oar_ac'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'peer_ip, load_balance, cos, flow_label, control_word'}, {'leafval': 'lif_bind_id'}, {'leafval': 'peer_ip, load_balance, cos'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'withdrawal'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_igmp_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_igmp_snooping_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_igmp_snooping_enable_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_igmp_snooping_fast_leave_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_igmp_snooping_last_member_query_interval_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_igmp_snooping_mrouter_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping.igmps_mrouter', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_igmp_snooping_mrouter_logical_interface_get(self, bridge_domain=None, igmps_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    **Instance Keyword Argument Tuple**:

    :type igmps_interface: igmps_if_type, igmps_value
    :param igmps_interface: Keyword argument tuple.

    :type igmps_if_type: unicode
    :param igmps_if_type: **igmps_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type igmps_value: unicode
    :param igmps_value: **igmps_interface** tuple argument.

        * length restriction: ::

            ['1..10']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping.igmps_mrouter.igmps_interface', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmps_interface', 'keyval': 'igmps_if_type, igmps_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain, igmps_interface=igmps_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain, igmps_interface=igmps_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_igmp_snooping_querier_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping.igmps_querier', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_igmp_snooping_querier_enable_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping.igmps_querier', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_igmp_snooping_query_interval_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_igmp_snooping_query_max_response_time_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_igmp_snooping_static_group_get(self, bridge_domain=None, igmps_static_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    **Instance Keyword Argument Tuple**:

    :type igmps_static_group: igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value
    :param igmps_static_group: Keyword argument tuple.

    :type igmps_mcast_address: unicode
    :param igmps_mcast_address: **igmps_static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type igmps_interface: unicode
    :param igmps_interface: **igmps_static_group** tuple argument.

        * enumeration restriction: ::

            ['logical-interface']

    :type igmps_if_type: unicode
    :param igmps_if_type: **igmps_static_group** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type igmps_value: unicode
    :param igmps_value: **igmps_static_group** tuple argument.

        * length restriction: ::

            ['1..10']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping.igmps_static_group', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmps_static_group', 'keyval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain, igmps_static_group=igmps_static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain, igmps_static_group=igmps_static_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_igmp_snooping_version_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_pim_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_pim', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_pim_snooping_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_pim.snooping', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_ip_pim_snooping_enable_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_pim.snooping', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_local_switching_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_bridge_domain', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.bridge_domain', u'router_interface'), ('pybind.slxos.v17s_1_02.bridge_domain', u'peer'), ('pybind.slxos.v17s_1_02.bridge_domain', u'suppress_arp'), ('pybind.slxos.v17s_1_02.bridge_domain', u'suppress_nd'), ('pybind.slxos.v17r_2_00.bridge_domain', u'suppress_nd'), ('pybind.slxos.v17r_2_00.bridge_domain', u'mac_address'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp', u'snooping'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_pim', u'snooping'), ('pybind.slxos.v17r_2_00.bridge_domain', u'suppress_arp'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', u'igmps_querier'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.bridge_domain', u'router_interface'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_2_00.bridge_domain', u'peer'), ('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.bridge_domain', u'peer'), ('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.bridge_domain', u'mac_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain', 'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_bind_id'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'router_ve'}, {'leafval': 'peer_ip, load_balance, cos'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'withdrawal'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'bd_pimv4_enable'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'lif_bind_id'}, {'leafval': 'igmps_qenable'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'router_ve, disallow_oar_ac'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'peer_ip, load_balance, cos, flow_label, control_word'}, {'leafval': 'lif_bind_id'}, {'leafval': 'peer_ip, load_balance, cos'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'withdrawal'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_logical_interface_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17r_1_01a.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface', 'pybind.slxos.v17r_1_01a.brocade_bridge_domain', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_logical_interface_ethernet_get(self, bridge_domain=None, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    **Instance Keyword Argument Tuple**:

    :type ethernet: lif_bind_id
    :param ethernet: Keyword argument tuple.

    :type lif_bind_id: unicode
    :param lif_bind_id: **ethernet** tuple argument:  Instance ID of the LIF to bind

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)(\.([1-9]|[1-9][0-9]||[1-9][0-9]'
            '[0-9]|[1-9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]'
            '))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17r_1_01a.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17s_1_02.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface.ethernet', 'pybind.slxos.v17r_1_01a.brocade_bridge_domain', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain.logical_interface.ethernet', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'lif_bind_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_logical_interface_port_channel_get(self, bridge_domain=None, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    **Instance Keyword Argument Tuple**:

    :type port_channel: pc_lif_bind_id
    :param port_channel: Keyword argument tuple.

    :type pc_lif_bind_id: unicode
    :param pc_lif_bind_id: **port_channel** tuple argument:  Instance ID of the port-channel LIF to bind

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17r_1_01a.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17s_1_02.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface.port_channel', 'pybind.slxos.v17r_1_01a.brocade_bridge_domain', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain.logical_interface.port_channel', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'pc_lif_bind_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_mac_address_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain.mac_address', 'pybind.slxos.v17r_1_01a.brocade_bridge_domain', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain.mac_address', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_mac_address_withdrawal_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain.mac_address', 'pybind.slxos.v17r_1_01a.brocade_bridge_domain', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain.mac_address', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_mac_state_get(self, bridge_domain_mac_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_mac_state: bd_id
    :param bridge_domain_mac_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_mac_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_mac_state', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_mac_state', 'pybind.slxos.v17r_2_00.brocade_l2sys_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_mac_state', 'pybind.slxos.v17s_1_02.brocade_l2sys_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain_mac_state', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_mac_state=bridge_domain_mac_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_mac_state=bridge_domain_mac_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_mac_state_no_of_mac_get(self, bridge_domain_mac_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_mac_state: bd_id
    :param bridge_domain_mac_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_mac_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_mac_state', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_mac_state', 'pybind.slxos.v17r_2_00.brocade_l2sys_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_mac_state', 'pybind.slxos.v17s_1_02.brocade_l2sys_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain_mac_state', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_mac_state=bridge_domain_mac_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_mac_state=bridge_domain_mac_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_mac_state_no_of_static_mac_get(self, bridge_domain_mac_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_mac_state: bd_id
    :param bridge_domain_mac_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_mac_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_mac_state', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_mac_state', 'pybind.slxos.v17r_2_00.brocade_l2sys_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_mac_state', 'pybind.slxos.v17s_1_02.brocade_l2sys_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain_mac_state', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_mac_state=bridge_domain_mac_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_mac_state=bridge_domain_mac_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_peer_get(self, bridge_domain=None, peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    **Instance Keyword Argument Tuple**:

    :type peer: peer_ip, load_balance, cos
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  PW Peer Ip for remote peer

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type load_balance: YANGBool
    :param load_balance: **peer** tuple argument:  load balance

    :type cos: long
    :param cos: **peer** tuple argument:  cos value

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17r_1_01a.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain.peer', 'pybind.slxos.v17r_1_01a.brocade_bridge_domain', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain.peer', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain.peer', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer', 'keyval': 'peer_ip', 'extra_keyval': 'peer_ip, load_balance, cos, flow_label, control_word'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.bridge_domain.peer": {"load_balance": "load_balance", "cos": "cos", "peer_ip": "peer_ip"}, "pybind.slxos.v17s_1_02.bridge_domain.peer": {"load_balance": "load_balance", "cos": "cos", "peer_ip": "peer_ip"}, "pybind.slxos.v17r_2_00.bridge_domain.peer": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain, peer=peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_peer_control_word_get(self, bridge_domain=None, peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    **Instance Keyword Argument Tuple**:

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  PW Peer Ip for remote peer

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.peer', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer', 'keyval': 'peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain, peer=peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_peer_cos_get(self, bridge_domain=None, peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    **Instance Keyword Argument Tuple**:

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  PW Peer Ip for remote peer

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17s_1_02.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain.peer', 'pybind.slxos.v17r_1_01a.brocade_bridge_domain', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain.peer', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain.peer', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer', 'keyval': 'peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain, peer=peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_peer_flow_label_get(self, bridge_domain=None, peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    **Instance Keyword Argument Tuple**:

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  PW Peer Ip for remote peer

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.peer', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer', 'keyval': 'peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain, peer=peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_peer_load_balance_get(self, bridge_domain=None, peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    **Instance Keyword Argument Tuple**:

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  PW Peer Ip for remote peer

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17s_1_02.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain.peer', 'pybind.slxos.v17r_1_01a.brocade_bridge_domain', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain.peer', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain.peer', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer', 'keyval': 'peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain, peer=peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_pw_profile_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_bridge_domain', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.bridge_domain', u'router_interface'), ('pybind.slxos.v17s_1_02.bridge_domain', u'peer'), ('pybind.slxos.v17s_1_02.bridge_domain', u'suppress_arp'), ('pybind.slxos.v17s_1_02.bridge_domain', u'suppress_nd'), ('pybind.slxos.v17r_2_00.bridge_domain', u'suppress_nd'), ('pybind.slxos.v17r_2_00.bridge_domain', u'mac_address'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp', u'snooping'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_pim', u'snooping'), ('pybind.slxos.v17r_2_00.bridge_domain', u'suppress_arp'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', u'igmps_querier'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.bridge_domain', u'router_interface'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_2_00.bridge_domain', u'peer'), ('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.bridge_domain', u'peer'), ('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.bridge_domain', u'mac_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain', 'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_bind_id'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'router_ve'}, {'leafval': 'peer_ip, load_balance, cos'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'withdrawal'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'bd_pimv4_enable'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'lif_bind_id'}, {'leafval': 'igmps_qenable'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'router_ve, disallow_oar_ac'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'peer_ip, load_balance, cos, flow_label, control_word'}, {'leafval': 'lif_bind_id'}, {'leafval': 'peer_ip, load_balance, cos'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'withdrawal'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_router_interface_get(self, bridge_domain=None, router_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    **Instance Keyword Argument Tuple**:

    :type router_interface: router_ve
    :param router_interface: Keyword argument tuple.

    :type router_ve: long
    :param router_ve: **router_interface** tuple argument:  Ve number

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.router_interface', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'router_interface', 'keyval': 'router_ve', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain, router_interface=router_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain, router_interface=router_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_router_interface_disallow_oar_ac_get(self, bridge_domain=None, router_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    **Instance Keyword Argument Tuple**:

    :type router_interface: router_ve
    :param router_interface: Keyword argument tuple.

    :type router_ve: long
    :param router_ve: **router_interface** tuple argument:  Ve number

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.router_interface', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'router_interface', 'keyval': 'router_ve', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain, router_interface=router_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain, router_interface=router_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_router_interface_ve_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17s_1_02.bridge_domain.router_interface', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state', u'bridge_domain_counter'), ('pybind.slxos.v17s_1_02.bridge_domain_state', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state', u'bridge_domain_counter'), ('pybind.slxos.v17r_2_00.bridge_domain_state', u'bridge_domain_counter'), ('pybind.slxos.v17r_2_00.bridge_domain_state', u'bridge_domain_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bd_id, vc_id, active_ac_lif_count, config_ac_lif_count, active_vfi_lif_count, config_vfi_lif_count, local_switching, block_bpdu, bd_type, ve_ifindex, pw_profile, mac_limit, statistics, mac_addr_withdrawal, mct_enabled, description'}, {'leafval': 'no_of_bd, no_of_vpls_bd'}, {'leafval': 'bd_id, vc_id, active_ac_lif_count, config_ac_lif_count, active_vfi_lif_count, config_vfi_lif_count, local_switching, block_bpdu, bd_type, transparent, ve_ifindex, ve_id, pw_profile, mac_limit, statistics, description'}, {'leafval': 'no_of_bd, no_of_vpls_bd, no_of_dynamic_mac, no_of_static_mac'}, {'leafval': 'no_of_bd, no_of_vpls_bd'}, {'leafval': 'bd_id, vc_id, active_ac_lif_count, config_ac_lif_count, active_vfi_lif_count, config_vfi_lif_count, local_switching, block_bpdu, bd_type, ve_ifindex, ve_id, pw_profile, mac_limit, statistics, mac_addr_withdrawal, mct_enabled, description'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_counter_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_counter', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_counter', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_counter', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_counter": {}, "pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_counter": {"no_of_vpls_bd": "no_of_vpls_bd", "no_of_bd": "no_of_bd"}, "pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_counter": {"no_of_vpls_bd": "no_of_vpls_bd", "no_of_bd": "no_of_bd"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_counter_no_of_bd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_counter', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_counter', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_counter', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_counter_no_of_dynamic_mac_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_counter', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_counter_no_of_static_mac_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_counter', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_counter_no_of_vpls_bd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_counter', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_counter', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_counter', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {"pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list": {"description": "description", "pw_profile": "pw_profile", "mac_limit": "mac_limit", "bd_type": "bd_type", "bd_id": "bd_id", "config_ac_lif_count": "config_ac_lif_count", "block_bpdu": "block_bpdu", "active_ac_lif_count": "active_ac_lif_count", "statistics": "statistics", "vc_id": "vc_id", "config_vfi_lif_count": "config_vfi_lif_count", "ve_ifindex": "ve_ifindex", "active_vfi_lif_count": "active_vfi_lif_count", "local_switching": "local_switching"}, "pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list": {}, "pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list": {"description": "description", "pw_profile": "pw_profile", "mac_limit": "mac_limit", "bd_type": "bd_type", "mac_addr_withdrawal": "mac_addr_withdrawal", "bd_id": "bd_id", "config_ac_lif_count": "config_ac_lif_count", "block_bpdu": "block_bpdu", "active_ac_lif_count": "active_ac_lif_count", "mct_enabled": "mct_enabled", "statistics": "statistics", "vc_id": "vc_id", "config_vfi_lif_count": "config_vfi_lif_count", "ve_ifindex": "ve_ifindex", "active_vfi_lif_count": "active_vfi_lif_count", "local_switching": "local_switching"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_active_ac_lif_count_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_active_vfi_lif_count_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_bd_type_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_block_bpdu_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_config_ac_lif_count_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_config_vfi_lif_count_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_description_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_local_switching_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_mac_addr_withdrawal_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_mac_limit_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_mct_enabled_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_get(self, bridge_domain_list=None, outer_vlan_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'untagged_ports_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'tagged_ports_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'tagged_ports_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'untagged_ports_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'untagged_ports_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'tagged_ports_list')]
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'outer_vlan_list', 'keyval': 'outer_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}, {'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, inner_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}, {'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, inner_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}, {'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}, {'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}, {'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, inner_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_no_of_up_tagged_ports_get(self, bridge_domain_list=None, outer_vlan_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'untagged_ports_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'tagged_ports_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'tagged_ports_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'untagged_ports_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'untagged_ports_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'tagged_ports_list')]
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'outer_vlan_list', 'keyval': 'outer_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}, {'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, inner_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}, {'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, inner_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}, {'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}, {'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}, {'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, inner_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_no_of_up_untagged_ports_get(self, bridge_domain_list=None, outer_vlan_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'untagged_ports_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'tagged_ports_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'tagged_ports_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'untagged_ports_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'untagged_ports_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'tagged_ports_list')]
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'outer_vlan_list', 'keyval': 'outer_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}, {'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, inner_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}, {'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, inner_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}, {'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}, {'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}, {'leafval': 'lif_name, lif_ifindex, lif_main_intf_type, outer_vlan, inner_vlan, flags, ivid, encap_id, ingress_stats_id, egress_stats_id, op_state, service_instance'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_get(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_egress_stats_id_get(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_encap_id_get(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_flags_get(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_ingress_stats_id_get(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_inner_vlan_get(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_ivid_get(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_lif_ifindex_get(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_lif_main_intf_type_get(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_op_state_get(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_outer_vlan_get(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_tagged_ports_list_service_instance_get(self, bridge_domain_list=None, outer_vlan_list=None, tagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type tagged_ports_list: lif_name
    :param tagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **tagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.tagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, tagged_ports_list=tagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_get(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_egress_stats_id_get(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_encap_id_get(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_flags_get(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_ingress_stats_id_get(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_ivid_get(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_lif_ifindex_get(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_lif_main_intf_type_get(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_op_state_get(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_outer_vlan_get(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_outer_vlan_list_untagged_ports_list_service_instance_get(self, bridge_domain_list=None, outer_vlan_list=None, untagged_ports_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type outer_vlan_list: outer_vlan
    :param outer_vlan_list: Keyword argument tuple.

    :type outer_vlan: long
    :param outer_vlan: **outer_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type untagged_ports_list: lif_name
    :param untagged_ports_list: Keyword argument tuple.

    :type lif_name: unicode
    :param lif_name: **untagged_ports_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'bridge_domain_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list', u'outer_vlan_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list.outer_vlan_list.untagged_ports_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'outer_vlan', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'untagged_ports_list', 'keyval': 'lif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list, outer_vlan_list=outer_vlan_list, untagged_ports_list=untagged_ports_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_pw_profile_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_statistics_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_transparent_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_vc_id_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_ve_id_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_state_bridge_domain_list_ve_ifindex_get(self, bridge_domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_list: bd_id
    :param bridge_domain_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_2_00.bridge_domain_state.bridge_domain_list', u'outer_vlan_list'), ('pybind.slxos.v17r_1_01a.bridge_domain_state.bridge_domain_list', u'outer_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}, {'leafval': 'outer_vlan, no_of_up_tagged_ports, no_of_up_untagged_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_list=bridge_domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_list=bridge_domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_statistics_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_bridge_domain', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.bridge_domain', u'router_interface'), ('pybind.slxos.v17s_1_02.bridge_domain', u'peer'), ('pybind.slxos.v17s_1_02.bridge_domain', u'suppress_arp'), ('pybind.slxos.v17s_1_02.bridge_domain', u'suppress_nd'), ('pybind.slxos.v17r_2_00.bridge_domain', u'suppress_nd'), ('pybind.slxos.v17r_2_00.bridge_domain', u'mac_address'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp', u'snooping'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_pim', u'snooping'), ('pybind.slxos.v17r_2_00.bridge_domain', u'suppress_arp'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', u'igmps_querier'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.bridge_domain', u'router_interface'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_2_00.bridge_domain', u'peer'), ('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.bridge_domain', u'peer'), ('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.bridge_domain', u'mac_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain', 'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_bind_id'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'router_ve'}, {'leafval': 'peer_ip, load_balance, cos'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'withdrawal'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'bd_pimv4_enable'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'lif_bind_id'}, {'leafval': 'igmps_qenable'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'router_ve, disallow_oar_ac'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'peer_ip, load_balance, cos, flow_label, control_word'}, {'leafval': 'lif_bind_id'}, {'leafval': 'peer_ip, load_balance, cos'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'withdrawal'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_suppress_arp_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17s_1_02.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.suppress_arp', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain.suppress_arp', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_suppress_arp_enable_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17s_1_02.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.suppress_arp', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain.suppress_arp', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_suppress_nd_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17s_1_02.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.suppress_nd', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain.suppress_nd', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_suppress_nd_enable_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.bridge_domain', 'bridge_domain'), ('pybind.slxos.v17s_1_02.bridge_domain', 'bridge_domain')]
    bindings_list = [('pybind.slxos.v17r_2_00.bridge_domain.suppress_nd', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain.suppress_nd', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}, {'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_transparent_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.bridge_domain', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.bridge_domain', u'router_interface'), ('pybind.slxos.v17s_1_02.bridge_domain', u'peer'), ('pybind.slxos.v17s_1_02.bridge_domain', u'suppress_arp'), ('pybind.slxos.v17s_1_02.bridge_domain', u'suppress_nd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain', 'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_bind_id'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'router_ve'}, {'leafval': 'peer_ip, load_balance, cos'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'suppress_nd_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def bridge_domain_vc_id_get(self, bridge_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain: bridge_domain_id, bridge_domain_type
    :param bridge_domain: Keyword argument tuple.

    :type bridge_domain_id: long
    :param bridge_domain_id: **bridge_domain** tuple argument:  Bridge-domain ID.

        * range restriction: ::

            ['0..4294967295']

    :type bridge_domain_type: unicode
    :param bridge_domain_type: **bridge_domain** tuple argument:  Set the Bridge Domain Type

        * enumeration restriction: ::

            ['p2mp', 'p2p']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_bridge_domain', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.bridge_domain', 'pybind.slxos.v17r_2_00.brocade_bridge_domain', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.bridge_domain', 'pybind.slxos.v17s_1_02.brocade_bridge_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.bridge_domain', u'router_interface'), ('pybind.slxos.v17s_1_02.bridge_domain', u'peer'), ('pybind.slxos.v17s_1_02.bridge_domain', u'suppress_arp'), ('pybind.slxos.v17s_1_02.bridge_domain', u'suppress_nd'), ('pybind.slxos.v17r_2_00.bridge_domain', u'suppress_nd'), ('pybind.slxos.v17r_2_00.bridge_domain', u'mac_address'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp', u'snooping'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_pim', u'snooping'), ('pybind.slxos.v17r_2_00.bridge_domain', u'suppress_arp'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', u'igmps_querier'), ('pybind.slxos.v17r_2_00.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.bridge_domain', u'router_interface'), ('pybind.slxos.v17r_2_00.bridge_domain.ip.bd_ip_igmp.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_2_00.bridge_domain', u'peer'), ('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.bridge_domain', u'peer'), ('pybind.slxos.v17r_1_01a.bridge_domain.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.bridge_domain', u'mac_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'bridge_domain', 'keyval': 'bridge_domain_id, bridge_domain_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_bind_id'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'router_ve'}, {'leafval': 'peer_ip, load_balance, cos'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'withdrawal'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'bd_pimv4_enable'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'lif_bind_id'}, {'leafval': 'igmps_qenable'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'router_ve, disallow_oar_ac'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'peer_ip, load_balance, cos, flow_label, control_word'}, {'leafval': 'lif_bind_id'}, {'leafval': 'peer_ip, load_balance, cos'}, {'leafval': 'pc_lif_bind_id'}, {'leafval': 'withdrawal'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain=bridge_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain=bridge_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.capabilities', u'openflow'), ('pybind.slxos.v17r_1_01a.capabilities', u'l2'), ('pybind.slxos.v17r_1_01a.capabilities.qos', u'mqc'), ('pybind.slxos.v17r_1_01a.capabilities', u'l3'), ('pybind.slxos.v17r_1_01a.capabilities', u'ssm'), ('pybind.slxos.v17r_1_01a.capabilities', u'lag'), ('pybind.slxos.v17r_1_01a.capabilities', u'license'), ('pybind.slxos.v17r_1_01a.capabilities', u'ipv6'), ('pybind.slxos.v17r_1_01a.capabilities', u'temperature'), ('pybind.slxos.v17r_1_01a.capabilities', u'power'), ('pybind.slxos.v17s_1_02.capabilities.qos', u'cee'), ('pybind.slxos.v17s_1_02.capabilities', u'overlay'), ('pybind.slxos.v17s_1_02.capabilities', u'ip'), ('pybind.slxos.v17s_1_02.capabilities', u'l3'), ('pybind.slxos.v17s_1_02.capabilities', u'bgp'), ('pybind.slxos.v17s_1_02.capabilities', u'maps'), ('pybind.slxos.v17s_1_02.capabilities.qos', u'cpu'), ('pybind.slxos.v17s_1_02.capabilities', u'license'), ('pybind.slxos.v17s_1_02.capabilities', u'lag'), ('pybind.slxos.v17s_1_02.capabilities', u'l2'), ('pybind.slxos.v17s_1_02.capabilities', u'qos'), ('pybind.slxos.v17s_1_02.capabilities.ip', u'igmp_snooping'), ('pybind.slxos.v17s_1_02.capabilities', u'ssm'), ('pybind.slxos.v17s_1_02.capabilities', u'mqc'), ('pybind.slxos.v17s_1_02.capabilities.overlay', u'vxlan'), ('pybind.slxos.v17s_1_02.capabilities', u'ipv6'), ('pybind.slxos.v17r_2_00.capabilities', u'vlan'), ('pybind.slxos.v17r_2_00.capabilities', u'l2'), ('pybind.slxos.v17r_2_00.capabilities', u'temperature'), ('pybind.slxos.v17r_2_00.capabilities', u'license'), ('pybind.slxos.v17r_2_00.capabilities.overlay', u'vxlan'), ('pybind.slxos.v17r_2_00.capabilities.qos.mls', u'flowcontrol'), ('pybind.slxos.v17r_2_00.capabilities', u'lag'), ('pybind.slxos.v17r_2_00.capabilities.qos', u'mls'), ('pybind.slxos.v17r_2_00.capabilities', u'ipv6'), ('pybind.slxos.v17r_2_00.capabilities', u'overlay'), ('pybind.slxos.v17r_2_00.capabilities', u'power'), ('pybind.slxos.v17r_2_00.capabilities', u'openflow'), ('pybind.slxos.v17r_2_00.capabilities', u'l3'), ('pybind.slxos.v17r_2_00.capabilities', u'ssm'), ('pybind.slxos.v17r_2_00.capabilities.qos', u'mqc')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ingress'}, {'leafval': 'port_profile, overlap_vlan, rspan, mac_move, consistency_check, learning_mode, priority_tag, internal_nsm'}, {'leafval': 'span, vlan_based_actions, bd_based_actions'}, {'leafval': 'rpf'}, {'leafval': 'aclTrafficType'}, {'leafval': 'PortchannelRedundancy'}, {'leafval': 'eula_display, dpod_display, slot_display'}, {'leafval': 'ipv6Raguard'}, {'leafval': 'tmpr_detail'}, {'leafval': 'lc_sfm, psu_on_off'}, {'leafval': 'nas'}, {'leafval': 'gre, hardware_vtep'}, {'leafval': 'igmp'}, {'leafval': 'ip_mtu, vrrp_extended_group_phy'}, {'leafval': 'next_hop_mpls, redistribute_isis'}, {'leafval': 'qos_mpls'}, {'leafval': 'slot, queue'}, {'leafval': 'eula_display, dpod_display, slot_display'}, {'leafval': 'PortchannelRedundancy'}, {'leafval': 'port_profile, overlap_vlan, rspan, mac_move, consistency_check, learning_mode, priority_tag, internal_nsm, lif_untagged_vlan_id, lif_egress, lif_inner_vlan, bridgedomain_local_switching, bridgedomain_transparent, dot1x'}, {'leafval': 'system_rx_queue_limit, system_tx_queue_limit, show_rx_queue_interface, conf_rx_queue_interface'}, {'leafval': 'igmp_snooping_version'}, {'leafval': 'aclTrafficType'}, {'leafval': 'span'}, {'leafval': 'mac_learn_protocol_bgp'}, {'leafval': 'ipv6Raguard'}, {'leafval': 'vlan_ipv6'}, {'leafval': 'port_profile, overlap_vlan, rspan, mac_move, consistency_check, learning_mode, priority_tag, internal_nsm'}, {'leafval': 'tmpr_detail'}, {'leafval': 'eula_display, dpod_display, slot_display'}, {'leafval': 'hardware_vtep, vtep_ip_ve, vxlan_tunnel_bfd, vxlan_tunnel_mac_learn_protocol_bgp'}, {'leafval': 'clear_qos_flowcontrol_statistics'}, {'leafval': 'PortchannelRedundancy'}, {'leafval': 'qos_intf_default_cos, qos_intf_default_traffic_class'}, {'leafval': 'ipv6Raguard'}, {'leafval': 'gre'}, {'leafval': 'lc_sfm, psu_on_off'}, {'leafval': 'ingress'}, {'leafval': 'rpf'}, {'leafval': 'aclTrafficType'}, {'leafval': 'span, vlan_based_actions, bd_based_actions'}]
    leafval_map = {"pybind.slxos.v17r_2_00.capabilities": {"tm": "tm"}, "pybind.slxos.v17r_1_01a.capabilities": {"tm": "tm"}, "pybind.slxos.v17s_1_02.capabilities": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_bgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.bgp', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_bgp_next_hop_mpls_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.bgp', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_bgp_redistribute_isis_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.bgp', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_cfm_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.capabilities.qos', u'cee'), ('pybind.slxos.v17s_1_02.capabilities', u'overlay'), ('pybind.slxos.v17s_1_02.capabilities', u'ip'), ('pybind.slxos.v17s_1_02.capabilities', u'l3'), ('pybind.slxos.v17s_1_02.capabilities', u'bgp'), ('pybind.slxos.v17s_1_02.capabilities', u'maps'), ('pybind.slxos.v17s_1_02.capabilities.qos', u'cpu'), ('pybind.slxos.v17s_1_02.capabilities', u'license'), ('pybind.slxos.v17s_1_02.capabilities', u'lag'), ('pybind.slxos.v17s_1_02.capabilities', u'l2'), ('pybind.slxos.v17s_1_02.capabilities', u'qos'), ('pybind.slxos.v17s_1_02.capabilities.ip', u'igmp_snooping'), ('pybind.slxos.v17s_1_02.capabilities', u'ssm'), ('pybind.slxos.v17s_1_02.capabilities', u'mqc'), ('pybind.slxos.v17s_1_02.capabilities.overlay', u'vxlan'), ('pybind.slxos.v17s_1_02.capabilities', u'ipv6')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nas'}, {'leafval': 'gre, hardware_vtep'}, {'leafval': 'igmp'}, {'leafval': 'ip_mtu, vrrp_extended_group_phy'}, {'leafval': 'next_hop_mpls, redistribute_isis'}, {'leafval': 'qos_mpls'}, {'leafval': 'slot, queue'}, {'leafval': 'eula_display, dpod_display, slot_display'}, {'leafval': 'PortchannelRedundancy'}, {'leafval': 'port_profile, overlap_vlan, rspan, mac_move, consistency_check, learning_mode, priority_tag, internal_nsm, lif_untagged_vlan_id, lif_egress, lif_inner_vlan, bridgedomain_local_switching, bridgedomain_transparent, dot1x'}, {'leafval': 'system_rx_queue_limit, system_tx_queue_limit, show_rx_queue_interface, conf_rx_queue_interface'}, {'leafval': 'igmp_snooping_version'}, {'leafval': 'aclTrafficType'}, {'leafval': 'span'}, {'leafval': 'mac_learn_protocol_bgp'}, {'leafval': 'ipv6Raguard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.ip', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.capabilities.ip', u'igmp_snooping')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igmp_snooping_version'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_ip_igmp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.ip', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.capabilities.ip', u'igmp_snooping')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igmp_snooping_version'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_ip_igmp_snooping_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.ip.igmp_snooping', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_ip_igmp_snooping_igmp_snooping_version_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.ip.igmp_snooping', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_ipv6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.ipv6', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.ipv6', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.ipv6', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_ipv6_ipv6raguard_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.ipv6', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.ipv6', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.ipv6', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.l2', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.l2', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.l2', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.capabilities.l2": {}, "pybind.slxos.v17r_2_00.capabilities.l2": {"consistency_check": "consistency_check", "mac_move": "mac_move", "learning_mode": "learning_mode", "overlap_vlan": "overlap_vlan", "port_profile": "port_profile", "internal_nsm": "internal_nsm", "priority_tag": "priority_tag", "rspan": "rspan"}, "pybind.slxos.v17r_1_01a.capabilities.l2": {"consistency_check": "consistency_check", "mac_move": "mac_move", "learning_mode": "learning_mode", "overlap_vlan": "overlap_vlan", "port_profile": "port_profile", "internal_nsm": "internal_nsm", "priority_tag": "priority_tag", "rspan": "rspan"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l2_bridgedomain_local_switching_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.l2', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l2_bridgedomain_transparent_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.l2', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l2_consistency_check_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.l2', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.l2', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.l2', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l2_dot1x_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.l2', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l2_internal_nsm_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.l2', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.l2', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.l2', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l2_learning_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.l2', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.l2', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.l2', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l2_lif_egress_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.l2', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l2_lif_inner_vlan_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.l2', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l2_lif_untagged_vlan_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.l2', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l2_mac_move_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.l2', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.l2', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.l2', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l2_overlap_vlan_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.l2', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.l2', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.l2', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l2_port_profile_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.l2', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.l2', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.l2', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l2_priority_tag_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.l2', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.l2', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.l2', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l2_rspan_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.l2', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.l2', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.l2', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l3_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.l3', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.l3', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.l3', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.capabilities.l3": {}, "pybind.slxos.v17r_2_00.capabilities.l3": {"rpf": "rpf"}, "pybind.slxos.v17r_1_01a.capabilities.l3": {"rpf": "rpf"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l3_ip_mtu_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.l3', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l3_rpf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.l3', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.l3', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_l3_vrrp_extended_group_phy_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.l3', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_lag_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.lag', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.lag', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.lag', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_lag_portchannelredundancy_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.lag', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.lag', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.lag', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_license_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.license', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.license', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.license', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_license_dpod_display_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.license', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.license', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.license', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_license_eula_display_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.license', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.license', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.license', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_license_slot_display_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.license', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.license', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.license', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_maps_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.maps', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_maps_qos_mpls_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.maps', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_mqc_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.mqc', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_mqc_span_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.mqc', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_openflow_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.openflow', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.openflow', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_openflow_ingress_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.openflow', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.openflow', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_overlay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.capabilities.overlay', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.overlay', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.capabilities.overlay', u'vxlan'), ('pybind.slxos.v17r_2_00.capabilities.overlay', u'vxlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_learn_protocol_bgp'}, {'leafval': 'hardware_vtep, vtep_ip_ve, vxlan_tunnel_bfd, vxlan_tunnel_mac_learn_protocol_bgp'}]
    leafval_map = {"pybind.slxos.v17s_1_02.capabilities.overlay": {}, "pybind.slxos.v17r_2_00.capabilities.overlay": {"gre": "gre"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_overlay_gre_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.capabilities.overlay', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.overlay', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.capabilities.overlay', u'vxlan'), ('pybind.slxos.v17r_2_00.capabilities.overlay', u'vxlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_learn_protocol_bgp'}, {'leafval': 'hardware_vtep, vtep_ip_ve, vxlan_tunnel_bfd, vxlan_tunnel_mac_learn_protocol_bgp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_overlay_hardware_vtep_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.overlay', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.capabilities.overlay', u'vxlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_learn_protocol_bgp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_overlay_vxlan_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.capabilities.overlay.vxlan', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.overlay.vxlan', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.capabilities.overlay.vxlan": {}, "pybind.slxos.v17r_2_00.capabilities.overlay.vxlan": {"vxlan_tunnel_mac_learn_protocol_bgp": "vxlan_tunnel_mac_learn_protocol_bgp", "vxlan_tunnel_bfd": "vxlan_tunnel_bfd", "vtep_ip_ve": "vtep_ip_ve", "hardware_vtep": "hardware_vtep"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_overlay_vxlan_hardware_vtep_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.capabilities.overlay.vxlan', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_overlay_vxlan_mac_learn_protocol_bgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.overlay.vxlan', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_overlay_vxlan_vtep_ip_ve_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.capabilities.overlay.vxlan', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_overlay_vxlan_vxlan_tunnel_bfd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.capabilities.overlay.vxlan', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_overlay_vxlan_vxlan_tunnel_mac_learn_protocol_bgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.capabilities.overlay.vxlan', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_power_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.power', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.power', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_power_lc_sfm_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.power', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.power', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_power_psu_on_off_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.power', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.power', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_pw_profile_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.capabilities.qos', u'cee'), ('pybind.slxos.v17s_1_02.capabilities', u'overlay'), ('pybind.slxos.v17s_1_02.capabilities', u'ip'), ('pybind.slxos.v17s_1_02.capabilities', u'l3'), ('pybind.slxos.v17s_1_02.capabilities', u'bgp'), ('pybind.slxos.v17s_1_02.capabilities', u'maps'), ('pybind.slxos.v17s_1_02.capabilities.qos', u'cpu'), ('pybind.slxos.v17s_1_02.capabilities', u'license'), ('pybind.slxos.v17s_1_02.capabilities', u'lag'), ('pybind.slxos.v17s_1_02.capabilities', u'l2'), ('pybind.slxos.v17s_1_02.capabilities', u'qos'), ('pybind.slxos.v17s_1_02.capabilities.ip', u'igmp_snooping'), ('pybind.slxos.v17s_1_02.capabilities', u'ssm'), ('pybind.slxos.v17s_1_02.capabilities', u'mqc'), ('pybind.slxos.v17s_1_02.capabilities.overlay', u'vxlan'), ('pybind.slxos.v17s_1_02.capabilities', u'ipv6')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nas'}, {'leafval': 'gre, hardware_vtep'}, {'leafval': 'igmp'}, {'leafval': 'ip_mtu, vrrp_extended_group_phy'}, {'leafval': 'next_hop_mpls, redistribute_isis'}, {'leafval': 'qos_mpls'}, {'leafval': 'slot, queue'}, {'leafval': 'eula_display, dpod_display, slot_display'}, {'leafval': 'PortchannelRedundancy'}, {'leafval': 'port_profile, overlap_vlan, rspan, mac_move, consistency_check, learning_mode, priority_tag, internal_nsm, lif_untagged_vlan_id, lif_egress, lif_inner_vlan, bridgedomain_local_switching, bridgedomain_transparent, dot1x'}, {'leafval': 'system_rx_queue_limit, system_tx_queue_limit, show_rx_queue_interface, conf_rx_queue_interface'}, {'leafval': 'igmp_snooping_version'}, {'leafval': 'aclTrafficType'}, {'leafval': 'span'}, {'leafval': 'mac_learn_protocol_bgp'}, {'leafval': 'ipv6Raguard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.qos', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.qos', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.qos', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.capabilities.qos', u'mqc'), ('pybind.slxos.v17s_1_02.capabilities.qos', u'cee'), ('pybind.slxos.v17s_1_02.capabilities.qos', u'cpu'), ('pybind.slxos.v17r_2_00.capabilities.qos.mls', u'flowcontrol'), ('pybind.slxos.v17r_2_00.capabilities.qos', u'mls'), ('pybind.slxos.v17r_2_00.capabilities.qos', u'mqc')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'span, vlan_based_actions, bd_based_actions'}, {'leafval': 'nas'}, {'leafval': 'slot, queue'}, {'leafval': 'clear_qos_flowcontrol_statistics'}, {'leafval': 'qos_intf_default_cos, qos_intf_default_traffic_class'}, {'leafval': 'span, vlan_based_actions, bd_based_actions'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.capabilities.qos": {}, "pybind.slxos.v17r_2_00.capabilities.qos": {}, "pybind.slxos.v17s_1_02.capabilities.qos": {"conf_rx_queue_interface": "conf_rx_queue_interface", "system_rx_queue_limit": "system_rx_queue_limit", "system_tx_queue_limit": "system_tx_queue_limit", "show_rx_queue_interface": "show_rx_queue_interface"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_cee_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.qos.cee', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_cee_nas_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.qos.cee', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_conf_rx_queue_interface_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.qos', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.capabilities.qos', u'cee'), ('pybind.slxos.v17s_1_02.capabilities.qos', u'cpu')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nas'}, {'leafval': 'slot, queue'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_cpu_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.qos.cpu', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_cpu_queue_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.qos.cpu', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_cpu_slot_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.qos.cpu', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_mls_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.capabilities.qos.mls', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.capabilities.qos.mls', u'flowcontrol')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'clear_qos_flowcontrol_statistics'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_mls_flowcontrol_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.capabilities.qos.mls.flowcontrol', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_mls_flowcontrol_clear_qos_flowcontrol_statistics_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.capabilities.qos.mls.flowcontrol', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_mls_qos_intf_default_cos_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.capabilities.qos.mls', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.capabilities.qos.mls', u'flowcontrol')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'clear_qos_flowcontrol_statistics'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_mls_qos_intf_default_traffic_class_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.capabilities.qos.mls', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.capabilities.qos.mls', u'flowcontrol')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'clear_qos_flowcontrol_statistics'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_mqc_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.qos.mqc', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.qos.mqc', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_mqc_bd_based_actions_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.qos.mqc', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.qos.mqc', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_mqc_span_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.qos.mqc', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.qos.mqc', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_mqc_vlan_based_actions_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.qos.mqc', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.qos.mqc', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_show_rx_queue_interface_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.qos', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.capabilities.qos', u'cee'), ('pybind.slxos.v17s_1_02.capabilities.qos', u'cpu')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nas'}, {'leafval': 'slot, queue'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_system_rx_queue_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.qos', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.capabilities.qos', u'cee'), ('pybind.slxos.v17s_1_02.capabilities.qos', u'cpu')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nas'}, {'leafval': 'slot, queue'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_qos_system_tx_queue_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.capabilities.qos', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.capabilities.qos', u'cee'), ('pybind.slxos.v17s_1_02.capabilities.qos', u'cpu')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nas'}, {'leafval': 'slot, queue'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_ssm_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.ssm', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.ssm', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.ssm', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_ssm_acltraffictype_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.ssm', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.ssm', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities.ssm', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_temperature_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.temperature', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.temperature', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_temperature_tmpr_detail_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities.temperature', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities.temperature', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_tm_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.capabilities', 'pybind.slxos.v17r_1_01a.brocade_system_capabilities', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.capabilities', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.capabilities', 'pybind.slxos.v17s_1_02.brocade_system_capabilities', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.capabilities', u'openflow'), ('pybind.slxos.v17r_1_01a.capabilities', u'l2'), ('pybind.slxos.v17r_1_01a.capabilities.qos', u'mqc'), ('pybind.slxos.v17r_1_01a.capabilities', u'l3'), ('pybind.slxos.v17r_1_01a.capabilities', u'ssm'), ('pybind.slxos.v17r_1_01a.capabilities', u'lag'), ('pybind.slxos.v17r_1_01a.capabilities', u'license'), ('pybind.slxos.v17r_1_01a.capabilities', u'ipv6'), ('pybind.slxos.v17r_1_01a.capabilities', u'temperature'), ('pybind.slxos.v17r_1_01a.capabilities', u'power'), ('pybind.slxos.v17r_2_00.capabilities', u'vlan'), ('pybind.slxos.v17r_2_00.capabilities', u'l2'), ('pybind.slxos.v17r_2_00.capabilities', u'temperature'), ('pybind.slxos.v17r_2_00.capabilities', u'license'), ('pybind.slxos.v17r_2_00.capabilities.overlay', u'vxlan'), ('pybind.slxos.v17r_2_00.capabilities.qos.mls', u'flowcontrol'), ('pybind.slxos.v17r_2_00.capabilities', u'lag'), ('pybind.slxos.v17r_2_00.capabilities.qos', u'mls'), ('pybind.slxos.v17r_2_00.capabilities', u'ipv6'), ('pybind.slxos.v17r_2_00.capabilities', u'overlay'), ('pybind.slxos.v17r_2_00.capabilities', u'power'), ('pybind.slxos.v17r_2_00.capabilities', u'openflow'), ('pybind.slxos.v17r_2_00.capabilities', u'l3'), ('pybind.slxos.v17r_2_00.capabilities', u'ssm'), ('pybind.slxos.v17r_2_00.capabilities.qos', u'mqc'), ('pybind.slxos.v17s_1_02.capabilities.qos', u'cee'), ('pybind.slxos.v17s_1_02.capabilities', u'overlay'), ('pybind.slxos.v17s_1_02.capabilities', u'ip'), ('pybind.slxos.v17s_1_02.capabilities', u'l3'), ('pybind.slxos.v17s_1_02.capabilities', u'bgp'), ('pybind.slxos.v17s_1_02.capabilities', u'maps'), ('pybind.slxos.v17s_1_02.capabilities.qos', u'cpu'), ('pybind.slxos.v17s_1_02.capabilities', u'license'), ('pybind.slxos.v17s_1_02.capabilities', u'lag'), ('pybind.slxos.v17s_1_02.capabilities', u'l2'), ('pybind.slxos.v17s_1_02.capabilities', u'qos'), ('pybind.slxos.v17s_1_02.capabilities.ip', u'igmp_snooping'), ('pybind.slxos.v17s_1_02.capabilities', u'ssm'), ('pybind.slxos.v17s_1_02.capabilities', u'mqc'), ('pybind.slxos.v17s_1_02.capabilities.overlay', u'vxlan'), ('pybind.slxos.v17s_1_02.capabilities', u'ipv6')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ingress'}, {'leafval': 'port_profile, overlap_vlan, rspan, mac_move, consistency_check, learning_mode, priority_tag, internal_nsm'}, {'leafval': 'span, vlan_based_actions, bd_based_actions'}, {'leafval': 'rpf'}, {'leafval': 'aclTrafficType'}, {'leafval': 'PortchannelRedundancy'}, {'leafval': 'eula_display, dpod_display, slot_display'}, {'leafval': 'ipv6Raguard'}, {'leafval': 'tmpr_detail'}, {'leafval': 'lc_sfm, psu_on_off'}, {'leafval': 'vlan_ipv6'}, {'leafval': 'port_profile, overlap_vlan, rspan, mac_move, consistency_check, learning_mode, priority_tag, internal_nsm'}, {'leafval': 'tmpr_detail'}, {'leafval': 'eula_display, dpod_display, slot_display'}, {'leafval': 'hardware_vtep, vtep_ip_ve, vxlan_tunnel_bfd, vxlan_tunnel_mac_learn_protocol_bgp'}, {'leafval': 'clear_qos_flowcontrol_statistics'}, {'leafval': 'PortchannelRedundancy'}, {'leafval': 'qos_intf_default_cos, qos_intf_default_traffic_class'}, {'leafval': 'ipv6Raguard'}, {'leafval': 'gre'}, {'leafval': 'lc_sfm, psu_on_off'}, {'leafval': 'ingress'}, {'leafval': 'rpf'}, {'leafval': 'aclTrafficType'}, {'leafval': 'span, vlan_based_actions, bd_based_actions'}, {'leafval': 'nas'}, {'leafval': 'gre, hardware_vtep'}, {'leafval': 'igmp'}, {'leafval': 'ip_mtu, vrrp_extended_group_phy'}, {'leafval': 'next_hop_mpls, redistribute_isis'}, {'leafval': 'qos_mpls'}, {'leafval': 'slot, queue'}, {'leafval': 'eula_display, dpod_display, slot_display'}, {'leafval': 'PortchannelRedundancy'}, {'leafval': 'port_profile, overlap_vlan, rspan, mac_move, consistency_check, learning_mode, priority_tag, internal_nsm, lif_untagged_vlan_id, lif_egress, lif_inner_vlan, bridgedomain_local_switching, bridgedomain_transparent, dot1x'}, {'leafval': 'system_rx_queue_limit, system_tx_queue_limit, show_rx_queue_interface, conf_rx_queue_interface'}, {'leafval': 'igmp_snooping_version'}, {'leafval': 'aclTrafficType'}, {'leafval': 'span'}, {'leafval': 'mac_learn_protocol_bgp'}, {'leafval': 'ipv6Raguard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_vlan_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.capabilities.vlan', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def capabilities_vlan_vlan_ipv6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.capabilities.vlan', 'pybind.slxos.v17r_2_00.brocade_system_capabilities', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_get(self, cee_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.cee_map', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.cee_map.remap', u'fabric_priority'), ('pybind.nos.v6_0_2f.cee_map', u'priority_table'), ('pybind.nos.v6_0_2f.cee_map', u'priority_group_table'), ('pybind.nos.v6_0_2f.cee_map.remap', u'lossless_priority'), ('pybind.slxos.v17r_2_00.cee_map.remap', u'lossless_priority'), ('pybind.slxos.v17r_2_00.cee_map', u'priority_table'), ('pybind.slxos.v17r_2_00.cee_map.remap', u'fabric_priority'), ('pybind.slxos.v17r_2_00.cee_map', u'priority_group_table'), ('pybind.slxos.v17s_1_02.cee_map.remap', u'fabric_priority'), ('pybind.slxos.v17s_1_02.cee_map', u'priority_group_table'), ('pybind.slxos.v17s_1_02.cee_map', u'priority_table'), ('pybind.slxos.v17s_1_02.cee_map.remap', u'lossless_priority'), ('pybind.slxos.v17r_1_01a.cee_map.remap', u'lossless_priority'), ('pybind.slxos.v17r_1_01a.cee_map', u'priority_table'), ('pybind.slxos.v17r_1_01a.cee_map.remap', u'fabric_priority'), ('pybind.slxos.v17r_1_01a.cee_map', u'priority_group_table'), ('pybind.nos.v7_2_0.cee_map.remap', u'lossless_priority'), ('pybind.nos.v7_2_0.cee_map', u'priority_group_table'), ('pybind.nos.v7_2_0.cee_map.remap', u'fabric_priority'), ('pybind.nos.v7_2_0.cee_map', u'priority_table')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cee_map', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fabric_remapped_priority'}, {'leafval': 'map_cos0_pgid, map_cos1_pgid, map_cos2_pgid, map_cos3_pgid, map_cos4_pgid, map_cos5_pgid, map_cos6_pgid, map_cos7_pgid'}, {'leafval': 'PGID, weight, pfc'}, {'leafval': 'lossless_remapped_priority'}, {'leafval': 'lossless_remapped_priority'}, {'leafval': 'map_cos0_pgid, map_cos1_pgid, map_cos2_pgid, map_cos3_pgid, map_cos4_pgid, map_cos5_pgid, map_cos6_pgid, map_cos7_pgid'}, {'leafval': 'fabric_remapped_priority'}, {'leafval': 'PGID, weight, pfc'}, {'leafval': 'fabric_remapped_priority'}, {'leafval': 'PGID, weight, pfc'}, {'leafval': 'map_cos0_pgid, map_cos1_pgid, map_cos2_pgid, map_cos3_pgid, map_cos4_pgid, map_cos5_pgid, map_cos6_pgid, map_cos7_pgid'}, {'leafval': 'lossless_remapped_priority'}, {'leafval': 'lossless_remapped_priority'}, {'leafval': 'map_cos0_pgid, map_cos1_pgid, map_cos2_pgid, map_cos3_pgid, map_cos4_pgid, map_cos5_pgid, map_cos6_pgid, map_cos7_pgid'}, {'leafval': 'fabric_remapped_priority'}, {'leafval': 'PGID, weight, pfc'}, {'leafval': 'lossless_remapped_priority'}, {'leafval': 'PGID, weight, pfc'}, {'leafval': 'fabric_remapped_priority'}, {'leafval': 'map_cos0_pgid, map_cos1_pgid, map_cos2_pgid, map_cos3_pgid, map_cos4_pgid, map_cos5_pgid, map_cos6_pgid, map_cos7_pgid'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_precedence_get(self, cee_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.cee_map', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.cee_map.remap', u'fabric_priority'), ('pybind.nos.v6_0_2f.cee_map', u'priority_table'), ('pybind.nos.v6_0_2f.cee_map', u'priority_group_table'), ('pybind.nos.v6_0_2f.cee_map.remap', u'lossless_priority'), ('pybind.slxos.v17r_2_00.cee_map.remap', u'lossless_priority'), ('pybind.slxos.v17r_2_00.cee_map', u'priority_table'), ('pybind.slxos.v17r_2_00.cee_map.remap', u'fabric_priority'), ('pybind.slxos.v17r_2_00.cee_map', u'priority_group_table'), ('pybind.slxos.v17s_1_02.cee_map.remap', u'fabric_priority'), ('pybind.slxos.v17s_1_02.cee_map', u'priority_group_table'), ('pybind.slxos.v17s_1_02.cee_map', u'priority_table'), ('pybind.slxos.v17s_1_02.cee_map.remap', u'lossless_priority'), ('pybind.slxos.v17r_1_01a.cee_map.remap', u'lossless_priority'), ('pybind.slxos.v17r_1_01a.cee_map', u'priority_table'), ('pybind.slxos.v17r_1_01a.cee_map.remap', u'fabric_priority'), ('pybind.slxos.v17r_1_01a.cee_map', u'priority_group_table'), ('pybind.nos.v7_2_0.cee_map.remap', u'lossless_priority'), ('pybind.nos.v7_2_0.cee_map', u'priority_group_table'), ('pybind.nos.v7_2_0.cee_map.remap', u'fabric_priority'), ('pybind.nos.v7_2_0.cee_map', u'priority_table')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cee_map', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fabric_remapped_priority'}, {'leafval': 'map_cos0_pgid, map_cos1_pgid, map_cos2_pgid, map_cos3_pgid, map_cos4_pgid, map_cos5_pgid, map_cos6_pgid, map_cos7_pgid'}, {'leafval': 'PGID, weight, pfc'}, {'leafval': 'lossless_remapped_priority'}, {'leafval': 'lossless_remapped_priority'}, {'leafval': 'map_cos0_pgid, map_cos1_pgid, map_cos2_pgid, map_cos3_pgid, map_cos4_pgid, map_cos5_pgid, map_cos6_pgid, map_cos7_pgid'}, {'leafval': 'fabric_remapped_priority'}, {'leafval': 'PGID, weight, pfc'}, {'leafval': 'fabric_remapped_priority'}, {'leafval': 'PGID, weight, pfc'}, {'leafval': 'map_cos0_pgid, map_cos1_pgid, map_cos2_pgid, map_cos3_pgid, map_cos4_pgid, map_cos5_pgid, map_cos6_pgid, map_cos7_pgid'}, {'leafval': 'lossless_remapped_priority'}, {'leafval': 'lossless_remapped_priority'}, {'leafval': 'map_cos0_pgid, map_cos1_pgid, map_cos2_pgid, map_cos3_pgid, map_cos4_pgid, map_cos5_pgid, map_cos6_pgid, map_cos7_pgid'}, {'leafval': 'fabric_remapped_priority'}, {'leafval': 'PGID, weight, pfc'}, {'leafval': 'lossless_remapped_priority'}, {'leafval': 'PGID, weight, pfc'}, {'leafval': 'fabric_remapped_priority'}, {'leafval': 'map_cos0_pgid, map_cos1_pgid, map_cos2_pgid, map_cos3_pgid, map_cos4_pgid, map_cos5_pgid, map_cos6_pgid, map_cos7_pgid'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_priority_group_table_get(self, cee_map=None, priority_group_table=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Keyword Argument Tuple**:

    :type priority_group_table: PGID, weight, pfc
    :param priority_group_table: Keyword argument tuple.

    :type PGID: unicode
    :param PGID: **priority_group_table** tuple argument:  ;; Configure Priority Group (PGID 0-7,15.0-15.7)

        * pattern restriction: ::

            '[0-7]|15.[0-7]'

    :type weight: long
    :param weight: **priority_group_table** tuple argument:  Configure DWRR Priority Group (PGID 0-7) weight

        * range restriction: ::

            ['-2147483648..2147483647']

    :type pfc: unicode
    :param pfc: **priority_group_table** tuple argument:   Per-priority Flow Control

        * enumeration restriction: ::

            ['on', 'off']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.slxos.v17s_1_02.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_1_01a.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.priority_group_table', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.priority_group_table', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.priority_group_table', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.priority_group_table', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.priority_group_table', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'priority_group_table', 'keyval': 'PGID', 'extra_keyval': 'PGID, weight, pfc'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map, priority_group_table=priority_group_table)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map, priority_group_table=priority_group_table)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_priority_group_table_pfc_get(self, cee_map=None, priority_group_table=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Keyword Argument Tuple**:

    :type priority_group_table: PGID
    :param priority_group_table: Keyword argument tuple.

    :type PGID: unicode
    :param PGID: **priority_group_table** tuple argument:  ;; Configure Priority Group (PGID 0-7,15.0-15.7)

        * pattern restriction: ::

            '[0-7]|15.[0-7]'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.slxos.v17s_1_02.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_1_01a.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.priority_group_table', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.priority_group_table', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.priority_group_table', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.priority_group_table', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.priority_group_table', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'priority_group_table', 'keyval': 'PGID', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map, priority_group_table=priority_group_table)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map, priority_group_table=priority_group_table)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_priority_group_table_weight_get(self, cee_map=None, priority_group_table=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Keyword Argument Tuple**:

    :type priority_group_table: PGID
    :param priority_group_table: Keyword argument tuple.

    :type PGID: unicode
    :param PGID: **priority_group_table** tuple argument:  ;; Configure Priority Group (PGID 0-7,15.0-15.7)

        * pattern restriction: ::

            '[0-7]|15.[0-7]'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.slxos.v17s_1_02.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_1_01a.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.priority_group_table', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.priority_group_table', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.priority_group_table', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.priority_group_table', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.priority_group_table', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'priority_group_table', 'keyval': 'PGID', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map, priority_group_table=priority_group_table)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map, priority_group_table=priority_group_table)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_priority_table_get(self, cee_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map'), ('pybind.slxos.v17r_1_01a.cee_map', 'cee_map'), ('pybind.slxos.v17s_1_02.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.priority_table', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.priority_table', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.priority_table', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.priority_table', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.priority_table', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'map_cos0_pgid, map_cos1_pgid, map_cos2_pgid, map_cos3_pgid, map_cos4_pgid, map_cos5_pgid, map_cos6_pgid, map_cos7_pgid'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_priority_table_map_cos0_pgid_get(self, cee_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map'), ('pybind.slxos.v17r_1_01a.cee_map', 'cee_map'), ('pybind.slxos.v17s_1_02.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.priority_table', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.priority_table', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.priority_table', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.priority_table', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.priority_table', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_priority_table_map_cos1_pgid_get(self, cee_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map'), ('pybind.slxos.v17r_1_01a.cee_map', 'cee_map'), ('pybind.slxos.v17s_1_02.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.priority_table', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.priority_table', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.priority_table', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.priority_table', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.priority_table', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_priority_table_map_cos2_pgid_get(self, cee_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map'), ('pybind.slxos.v17r_1_01a.cee_map', 'cee_map'), ('pybind.slxos.v17s_1_02.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.priority_table', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.priority_table', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.priority_table', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.priority_table', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.priority_table', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_priority_table_map_cos3_pgid_get(self, cee_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map'), ('pybind.slxos.v17r_1_01a.cee_map', 'cee_map'), ('pybind.slxos.v17s_1_02.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.priority_table', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.priority_table', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.priority_table', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.priority_table', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.priority_table', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_priority_table_map_cos4_pgid_get(self, cee_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map'), ('pybind.slxos.v17r_1_01a.cee_map', 'cee_map'), ('pybind.slxos.v17s_1_02.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.priority_table', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.priority_table', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.priority_table', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.priority_table', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.priority_table', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_priority_table_map_cos5_pgid_get(self, cee_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map'), ('pybind.slxos.v17r_1_01a.cee_map', 'cee_map'), ('pybind.slxos.v17s_1_02.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.priority_table', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.priority_table', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.priority_table', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.priority_table', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.priority_table', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_priority_table_map_cos6_pgid_get(self, cee_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map'), ('pybind.slxos.v17r_1_01a.cee_map', 'cee_map'), ('pybind.slxos.v17s_1_02.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.priority_table', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.priority_table', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.priority_table', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.priority_table', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.priority_table', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_priority_table_map_cos7_pgid_get(self, cee_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map'), ('pybind.slxos.v17r_1_01a.cee_map', 'cee_map'), ('pybind.slxos.v17s_1_02.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.priority_table', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.priority_table', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.priority_table', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.priority_table', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.priority_table', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_remap_get(self, cee_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cee_map', 'cee_map'), ('pybind.slxos.v17r_1_01a.cee_map', 'cee_map'), ('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.remap', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.remap', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.remap', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.remap', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.remap', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_remap_fabric_priority_get(self, cee_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map'), ('pybind.slxos.v17s_1_02.cee_map', 'cee_map'), ('pybind.slxos.v17r_1_01a.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.remap.fabric_priority', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.remap.fabric_priority', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.remap.fabric_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.remap.fabric_priority', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.remap.fabric_priority', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_remap_fabric_priority_priority_get(self, cee_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map'), ('pybind.slxos.v17s_1_02.cee_map', 'cee_map'), ('pybind.slxos.v17r_1_01a.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.remap.fabric_priority', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.remap.fabric_priority', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.remap.fabric_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.remap.fabric_priority', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.remap.fabric_priority', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_remap_lossless_priority_get(self, cee_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map'), ('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.slxos.v17s_1_02.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.remap.lossless_priority', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.remap.lossless_priority', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.remap.lossless_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.remap.lossless_priority', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.remap.lossless_priority', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cee_map_remap_lossless_priority_priority_get(self, cee_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cee_map: name
    :param cee_map: Keyword argument tuple.

    :type name: unicode
    :param name: **cee_map** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cee_map', 'cee_map'), ('pybind.nos.v7_2_0.cee_map', 'cee_map'), ('pybind.slxos.v17r_2_00.cee_map', 'cee_map'), ('pybind.nos.v6_0_2f.cee_map', 'cee_map'), ('pybind.slxos.v17s_1_02.cee_map', 'cee_map')]
    bindings_list = [('pybind.nos.v6_0_2f.cee_map.remap.lossless_priority', 'pybind.nos.v6_0_2f.brocade_cee_map', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.cee_map.remap.lossless_priority', 'pybind.nos.v7_2_0.brocade_cee_map', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.cee_map.remap.lossless_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cee_map.remap.lossless_priority', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cee_map.remap.lossless_priority', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cee_map=cee_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cee_map=cee_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def certutil_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.certutil', 'pybind.nos.v6_0_2f.brocade_certutil', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.certutil', 'pybind.nos.v7_2_0.brocade_certutil', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.certutil', 'pybind.slxos.v17r_1_01a.brocade_certutil', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.certutil', 'pybind.slxos.v17r_2_00.brocade_certutil', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.certutil', 'pybind.slxos.v17s_1_02.brocade_certutil', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.cfm_config', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731', u'action_profile_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731', u'test_profile')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'domain_name, domain_id, domain_level'}, {'leafval': 'action_profile_name'}, {'leafval': 'test_profile, profile_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.dmm', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm', u'slm_session_detail'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731', u'test_profile'), ('pybind.slxos.v17r_2_00.cfm_state.slm', u'slm_session_brief'), ('pybind.slxos.v17r_2_00.cfm_state.slm', u'slm_stats_session_brief'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.dmm', u'dmm_stats_session_brief'), ('pybind.slxos.v17r_2_00.cfm_state.dmm', u'dmm_session_brief'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731', u'action_profile'), ('pybind.slxos.v17r_2_00.cfm_state.dmm', u'dmm_session_detail'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731', u'test_profile'), ('pybind.slxos.v17r_1_01a.cfm_state.slm', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm', u'dmm_session_detail'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm', u'dmm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.slm', u'slm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_1_01a.cfm_state.slm', u'slm_session_detail'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm', u'dmm_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.slm', u'slm_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731', u'action_profile'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail', u'domain')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'session_index'}, {'leafval': 'session_index'}, {'leafval': 'type, status, domain_name, ma_name, src_mep, tgt_mep, cos, start_time, stop_time, test_profile_name, start_type, stop_type, tx_interval, tx_frame_count, meas_interval, session_index, fwd_avg, fwd_max, bwd_avg, bwd_max'}, {'leafval': 'test_profile_name, type, cos, tx_interval, tx_frame_count, meas_interval, fwd_avg, fwd_max, bwd_avg, bwd_max, start, stop, timeout'}, {'leafval': 'type, status, domain_name, ma_name, src_mep, tgt_mep, cos, start_time, stop_time, session_index'}, {'leafval': 'session_index'}, {'leafval': 'md_name, md_idx, md_level'}, {'leafval': 'session_index, test_profile_name'}, {'leafval': 'type, status, domain_name, ma_name, src_mep, tgt_mep, cos, start_time, stop_time, session_index'}, {'leafval': 'action_profile_name'}, {'leafval': 'type, status, domain_name, ma_name, src_mep, tgt_mep, cos, start_time, stop_time, test_profile_name, start_type, stop_type, tx_interval, tx_frame_count, meas_interval, session_index, avg, max_'}, {'leafval': 'md_name, md_idx, md_level'}, {'leafval': 'test_profile_name, type, cos, tx_interval, tx_frame_count, meas_interval, fwd_avg, fwd_max, bwd_avg, bwd_max, start, stop, packets, timeout'}, {'leafval': 'session_index'}, {'leafval': 'type, status, domain_name, ma_name, src_mep, tgt_mep, cos, start_time, stop_time, test_profile_name, start_type, stop_type, tx_interval, tx_frame_count, meas_interval, session_index, avg, max_'}, {'leafval': 'session_index, test_profile_name'}, {'leafval': 'session_index'}, {'leafval': 'md_name, md_level'}, {'leafval': 'session_index'}, {'leafval': 'type, status, domain_name, ma_name, src_mep, tgt_mep, cos, start_time, stop_time, test_profile_name, start_type, stop_type, tx_interval, tx_frame_count, meas_interval, session_index, fwd_avg, fwd_max, bwd_avg, bwd_max'}, {'leafval': 'type, status, domain_name, ma_name, src_mep, tgt_mep, cos, start_time, stop_time, session_index'}, {'leafval': 'md_name, md_level'}, {'leafval': 'type, status, domain_name, ma_name, src_mep, tgt_mep, cos, start_time, stop_time, session_index'}, {'leafval': 'action_profile_name'}, {'leafval': 'md_name, md_level'}, {'leafval': 'md_name, md_level'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity', u'domain')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'md_name, md_level'}, {'leafval': 'md_name, md_idx, md_level'}, {'leafval': 'md_name, md_level'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_get(self, domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'ma')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain', 'keyval': 'md_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ma_name, ma_idx, ma_type, maid_format, ccm_interval, vlan_id, priority'}, {'leafval': 'ma_name, ma_idx, ma_type, ccm_interval, vlan_id, priority'}, {'leafval': 'ma_name, ma_idx, ma_type, maid_format, ccm_interval, vlan_id, priority'}]
    leafval_map = {"pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain": {"md_level": "md_level", "md_name": "md_name"}, "pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain": {"md_level": "md_level", "md_name": "md_name"}, "pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_get(self, domain=None, ma=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'mip'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'mip'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'mip')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, rmep_fail, rmep_ok'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}]
    leafval_map = {"pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma": {"ccm_interval": "ccm_interval", "maid_format": "maid_format", "ma_name": "ma_name", "priority": "priority", "ma_type": "ma_type", "ma_idx": "ma_idx", "vlan_id": "vlan_id"}, "pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma": {"ccm_interval": "ccm_interval", "maid_format": "maid_format", "ma_name": "ma_name", "priority": "priority", "ma_type": "ma_type", "ma_idx": "ma_idx", "vlan_id": "vlan_id"}, "pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_ccm_interval_get(self, domain=None, ma=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'mip'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'mip'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'mip')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, rmep_fail, rmep_ok'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_ma_idx_get(self, domain=None, ma=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'mip'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'mip'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'mip')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, rmep_fail, rmep_ok'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_ma_type_get(self, domain=None, ma=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'mip'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'mip'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'mip')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, rmep_fail, rmep_ok'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_maid_format_get(self, domain=None, ma=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'mip'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'mip')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, vlan_id, rmep_port, rmep_state'}]
    leafval_map = {"pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep": {"mep_vlan": "mep_vlan", "mep_port": "mep_port", "mep_mac": "mep_mac", "rmep_fail": "rmep_fail", "mep_inner_vlan": "mep_inner_vlan", "port_state": "port_state", "rmep_ok": "rmep_ok", "mep_id": "mep_id", "mep_direction": "mep_direction"}, "pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep": {"mep_vlan": "mep_vlan", "mep_port": "mep_port", "mep_mac": "mep_mac", "rmep_fail": "rmep_fail", "mep_inner_vlan": "mep_inner_vlan", "port_state": "port_state", "rmep_ok": "rmep_ok", "mep_id": "mep_id", "mep_direction": "mep_direction"}, "pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_mep_direction_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, vlan_id, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_mep_inner_vlan_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_mep_mac_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, vlan_id, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_mep_port_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, vlan_id, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_mep_vlan_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_port_state_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, vlan_id, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_rmep_get(self, domain=None, ma=None, mep=None, rmep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', u'mep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep.rmep": {"rmep_inner_vlan": "rmep_inner_vlan", "rmep_id": "rmep_id", "rmep_mac": "rmep_mac", "rmep_vlan": "rmep_vlan", "rmep_state": "rmep_state", "rmep_port": "rmep_port"}, "pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep.rmep": {}, "pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep.rmep": {"rmep_inner_vlan": "rmep_inner_vlan", "rmep_id": "rmep_id", "rmep_mac": "rmep_mac", "rmep_vlan": "rmep_vlan", "rmep_state": "rmep_state", "rmep_port": "rmep_port"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_rmep_fail_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, vlan_id, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_rmep_ok_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, vlan_id, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_rmep_rmep_inner_vlan_get(self, domain=None, ma=None, mep=None, rmep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_rmep_rmep_mac_get(self, domain=None, ma=None, mep=None, rmep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', u'mep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_rmep_rmep_port_get(self, domain=None, ma=None, mep=None, rmep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', u'mep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_rmep_rmep_state_get(self, domain=None, ma=None, mep=None, rmep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', u'mep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_rmep_rmep_vlan_get(self, domain=None, ma=None, mep=None, rmep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mep_rmep_vlan_id_get(self, domain=None, ma=None, mep=None, rmep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mep.rmep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mip_get(self, domain=None, ma=None, mip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mip: vlan_id
    :param mip: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **mip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mip', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mip', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mip', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mip', 'keyval': 'vlan_id, port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mip": {}, "pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mip": {"inner_vlan_id": "inner_vlan_id", "mac": "mac", "port": "port", "vlan_id": "vlan_id", "level": "level"}, "pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mip": {"inner_vlan_id": "inner_vlan_id", "mac": "mac", "port": "port", "vlan_id": "vlan_id", "level": "level"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mip=mip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mip=mip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mip_inner_vlan_id_get(self, domain=None, ma=None, mip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mip: vlan_id
    :param mip: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **mip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mip', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mip', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mip', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mip=mip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mip=mip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mip_level_get(self, domain=None, ma=None, mip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mip: vlan_id
    :param mip: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **mip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mip', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mip', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mip', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mip', 'keyval': 'vlan_id, port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mip": {}, "pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mip": {"vlan_id": "vlan_id", "level": "level"}, "pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mip": {"vlan_id": "vlan_id", "level": "level"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mip=mip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mip=mip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mip_mac_get(self, domain=None, ma=None, mip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mip: vlan_id
    :param mip: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **mip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mip', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mip', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mip', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mip', 'keyval': 'vlan_id, port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma.mip": {}, "pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mip": {"mac": "mac", "vlan_id": "vlan_id"}, "pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mip": {"mac": "mac", "vlan_id": "vlan_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mip=mip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mip=mip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_mip_port_get(self, domain=None, ma=None, mip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mip: vlan_id
    :param mip: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **mip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma.mip', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma.mip', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mip', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mip=mip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mip=mip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_priority_get(self, domain=None, ma=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'mip'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'mip'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'mip')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, rmep_fail, rmep_ok'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_ma_vlan_id_get(self, domain=None, ma=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain.ma', u'mip'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'mip'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain.ma', u'mip')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, rmep_fail, rmep_ok'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_md_idx_get(self, domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'ma')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain', 'keyval': 'md_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ma_name, ma_idx, ma_type, maid_format, ccm_interval, vlan_id, priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_connectivity_domain_md_level_get(self, domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_connectivity.domain', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_connectivity.domain', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_connectivity.domain', u'ma')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain', 'keyval': 'md_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ma_name, ma_idx, ma_type, ccm_interval, vlan_id, priority'}, {'leafval': 'ma_name, ma_idx, ma_type, maid_format, ccm_interval, vlan_id, priority'}, {'leafval': 'ma_name, ma_idx, ma_type, maid_format, ccm_interval, vlan_id, priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail', u'domain')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'md_name, md_idx, md_level'}, {'leafval': 'md_name, md_level'}, {'leafval': 'md_name, md_level'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_get(self, domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'ma')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain', 'keyval': 'md_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ma_name, ma_idx, ma_type, maid_format, ccm_interval, vlan_id, priority'}, {'leafval': 'ma_name, ma_idx, ma_type, ccm_interval, vlan_id, priority'}, {'leafval': 'ma_name, ma_idx, ma_type, maid_format, ccm_interval, vlan_id, priority'}]
    leafval_map = {"pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain": {}, "pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain": {"md_level": "md_level", "md_name": "md_name"}, "pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain": {"md_level": "md_level", "md_name": "md_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_get(self, domain=None, ma=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'mep'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'mep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'mep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'mip')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, port, level, mac'}]
    leafval_map = {"pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma": {}, "pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma": {"ccm_interval": "ccm_interval", "maid_format": "maid_format", "ma_name": "ma_name", "priority": "priority", "ma_type": "ma_type", "ma_idx": "ma_idx", "vlan_id": "vlan_id"}, "pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma": {"ccm_interval": "ccm_interval", "maid_format": "maid_format", "ma_name": "ma_name", "priority": "priority", "ma_type": "ma_type", "ma_idx": "ma_idx", "vlan_id": "vlan_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_ccm_interval_get(self, domain=None, ma=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'mep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'mep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, port, level, mac'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_ma_idx_get(self, domain=None, ma=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'mep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'mep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, port, level, mac'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_ma_type_get(self, domain=None, ma=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'mep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'mep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, port, level, mac'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_maid_format_get(self, domain=None, ma=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'mep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, vlan_id, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}]
    leafval_map = {"pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep": {"mep_vlan": "mep_vlan", "mep_port": "mep_port", "mep_mac": "mep_mac", "rmep_fail": "rmep_fail", "mep_inner_vlan": "mep_inner_vlan", "port_state": "port_state", "rmep_ok": "rmep_ok", "mep_id": "mep_id", "mep_direction": "mep_direction"}, "pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep": {}, "pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep": {"mep_vlan": "mep_vlan", "mep_port": "mep_port", "mep_mac": "mep_mac", "rmep_fail": "rmep_fail", "mep_inner_vlan": "mep_inner_vlan", "port_state": "port_state", "rmep_ok": "rmep_ok", "mep_id": "mep_id", "mep_direction": "mep_direction"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_mep_direction_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', u'rmep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, vlan_id, rmep_port, rmep_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_mep_inner_vlan_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_mep_mac_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', u'rmep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, vlan_id, rmep_port, rmep_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_mep_port_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', u'rmep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, vlan_id, rmep_port, rmep_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_mep_vlan_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_port_state_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', u'rmep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, vlan_id, rmep_port, rmep_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_rmep_get(self, domain=None, ma=None, mep=None, rmep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', u'mep'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep.rmep": {}, "pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep.rmep": {"rmep_inner_vlan": "rmep_inner_vlan", "rmep_id": "rmep_id", "rmep_mac": "rmep_mac", "rmep_vlan": "rmep_vlan", "rmep_state": "rmep_state", "rmep_port": "rmep_port"}, "pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep.rmep": {"rmep_inner_vlan": "rmep_inner_vlan", "rmep_id": "rmep_id", "rmep_mac": "rmep_mac", "rmep_vlan": "rmep_vlan", "rmep_state": "rmep_state", "rmep_port": "rmep_port"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_rmep_fail_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', u'rmep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, vlan_id, rmep_port, rmep_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_rmep_ok_get(self, domain=None, ma=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', u'rmep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', u'rmep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', u'rmep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, rmep_vlan, rmep_inner_vlan, rmep_port, rmep_state'}, {'leafval': 'rmep_id, rmep_mac, vlan_id, rmep_port, rmep_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_rmep_rmep_inner_vlan_get(self, domain=None, ma=None, mep=None, rmep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_rmep_rmep_mac_get(self, domain=None, ma=None, mep=None, rmep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', u'mep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_rmep_rmep_port_get(self, domain=None, ma=None, mep=None, rmep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', u'mep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_rmep_rmep_state_get(self, domain=None, ma=None, mep=None, rmep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', u'mep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_rmep_rmep_vlan_get(self, domain=None, ma=None, mep=None, rmep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mep_rmep_vlan_id_get(self, domain=None, ma=None, mep=None, rmep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: int
    :param mep_id: **mep** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type rmep: rmep_id
    :param rmep: Keyword argument tuple.

    :type rmep_id: int
    :param rmep_id: **rmep** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mep.rmep', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep', 'keyval': 'rmep_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mep=mep, rmep=rmep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mep=mep, rmep=rmep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mip_get(self, domain=None, ma=None, mip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mip: vlan_id
    :param mip: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **mip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mip', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mip', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mip', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mip', 'keyval': 'vlan_id, port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mip": {}, "pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mip": {"inner_vlan_id": "inner_vlan_id", "mac": "mac", "port": "port", "vlan_id": "vlan_id", "level": "level"}, "pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mip": {"inner_vlan_id": "inner_vlan_id", "mac": "mac", "port": "port", "vlan_id": "vlan_id", "level": "level"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mip=mip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mip=mip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mip_inner_vlan_id_get(self, domain=None, ma=None, mip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mip: vlan_id
    :param mip: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **mip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mip', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mip', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mip', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mip=mip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mip=mip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mip_level_get(self, domain=None, ma=None, mip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mip: vlan_id
    :param mip: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **mip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mip', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mip', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mip', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mip', 'keyval': 'vlan_id, port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mip": {}, "pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mip": {"vlan_id": "vlan_id", "level": "level"}, "pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mip": {"vlan_id": "vlan_id", "level": "level"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mip=mip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mip=mip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mip_mac_get(self, domain=None, ma=None, mip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mip: vlan_id
    :param mip: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **mip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mip', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mip', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mip', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mip', 'keyval': 'vlan_id, port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma.mip": {}, "pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mip": {"mac": "mac", "vlan_id": "vlan_id"}, "pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mip": {"mac": "mac", "vlan_id": "vlan_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mip=mip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mip=mip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_mip_port_get(self, domain=None, ma=None, mip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mip: vlan_id
    :param mip: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **mip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'ma')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma.mip', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma.mip', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mip', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma, mip=mip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma, mip=mip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_priority_get(self, domain=None, ma=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'mep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'mep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, port, level, mac'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_ma_vlan_id_get(self, domain=None, ma=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ma: ma_name
    :param ma: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'domain'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'domain')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'mep'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain.ma', u'mep'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'mip'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain.ma', u'mep')]
    compositions_keyval_list = [{'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}, {'keyval': 'md_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, port, level, mac'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}, {'leafval': 'vlan_id, inner_vlan_id, port, level, mac'}, {'leafval': 'mep_id, mep_direction, mep_mac, mep_port, port_state, mep_vlan, mep_inner_vlan, rmep_fail, rmep_ok'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain, ma=ma)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain, ma=ma)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_md_idx_get(self, domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'ma')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain', 'keyval': 'md_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ma_name, ma_idx, ma_type, maid_format, ccm_interval, vlan_id, priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_detail_domain_md_level_get(self, domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type domain: md_name
    :param domain: Keyword argument tuple.

    :type md_name: unicode
    :param md_name: **domain** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', 'pybind.slxos.v17s_1_02.brocade_dot1ag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_detail.domain', u'ma'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_detail.domain', u'ma'), ('pybind.slxos.v17s_1_02.cfm_state.cfm_detail.domain', u'ma')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain', 'keyval': 'md_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ma_name, ma_idx, ma_type, maid_format, ccm_interval, vlan_id, priority'}, {'leafval': 'ma_name, ma_idx, ma_type, maid_format, ccm_interval, vlan_id, priority'}, {'leafval': 'ma_name, ma_idx, ma_type, ccm_interval, vlan_id, priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain=domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain=domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731', u'test_profile'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731', u'action_profile'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731', u'test_profile'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731', u'action_profile')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'test_profile_name, type, cos, tx_interval, tx_frame_count, meas_interval, fwd_avg, fwd_max, bwd_avg, bwd_max, start, stop, timeout'}, {'leafval': 'action_profile_name'}, {'leafval': 'test_profile_name, type, cos, tx_interval, tx_frame_count, meas_interval, fwd_avg, fwd_max, bwd_avg, bwd_max, start, stop, packets, timeout'}, {'leafval': 'action_profile_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_action_profile_get(self, action_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type action_profile: action_profile_name
    :param action_profile: Keyword argument tuple.

    :type action_profile_name: unicode
    :param action_profile_name: **action_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.action_profile', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.action_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.action_profile', u'action_profile_event_actions'), ('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.action_profile', u'action_profile_event_actions')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'action_profile', 'keyval': 'action_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'event, actions'}, {'leafval': 'event, actions'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, action_profile=action_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, action_profile=action_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_action_profile_action_profile_event_actions_get(self, action_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type action_profile: action_profile_name
    :param action_profile: Keyword argument tuple.

    :type action_profile_name: unicode
    :param action_profile_name: **action_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.action_profile', u'action_profile'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.action_profile', u'action_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.action_profile.action_profile_event_actions', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.action_profile.action_profile_event_actions', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'action_profile_name', 'extra_keyval': ''}, {'keyval': 'action_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, action_profile=action_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, action_profile=action_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_action_profile_action_profile_event_actions_actions_get(self, action_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type action_profile: action_profile_name
    :param action_profile: Keyword argument tuple.

    :type action_profile_name: unicode
    :param action_profile_name: **action_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.action_profile', u'action_profile'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.action_profile', u'action_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.action_profile.action_profile_event_actions', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.action_profile.action_profile_event_actions', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'action_profile_name', 'extra_keyval': ''}, {'keyval': 'action_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, action_profile=action_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, action_profile=action_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_action_profile_action_profile_event_actions_event_get(self, action_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type action_profile: action_profile_name
    :param action_profile: Keyword argument tuple.

    :type action_profile_name: unicode
    :param action_profile_name: **action_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.action_profile', u'action_profile'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.action_profile', u'action_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.action_profile.action_profile_event_actions', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.action_profile.action_profile_event_actions', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'action_profile_name', 'extra_keyval': ''}, {'keyval': 'action_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, action_profile=action_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, action_profile=action_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_test_profile_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type test_profile: test_profile_name
    :param test_profile: Keyword argument tuple.

    :type test_profile_name: unicode
    :param test_profile_name: **test_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'test_profile', 'keyval': 'test_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.test_profile": {"cos": "cos", "tx_interval": "tx_interval", "stop": "stop", "bwd_max": "bwd_max", "tx_frame_count": "tx_frame_count", "packets": "packets", "start": "start", "meas_interval": "meas_interval", "bwd_avg": "bwd_avg", "fwd_max": "fwd_max", "fwd_avg": "fwd_avg", "timeout": "timeout", "type": "type", "test_profile_name": "test_profile_name"}, "pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.test_profile": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_test_profile_bwd_avg_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type test_profile: test_profile_name
    :param test_profile: Keyword argument tuple.

    :type test_profile_name: unicode
    :param test_profile_name: **test_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'test_profile', 'keyval': 'test_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_test_profile_bwd_max_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type test_profile: test_profile_name
    :param test_profile: Keyword argument tuple.

    :type test_profile_name: unicode
    :param test_profile_name: **test_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'test_profile', 'keyval': 'test_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_test_profile_cos_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type test_profile: test_profile_name
    :param test_profile: Keyword argument tuple.

    :type test_profile_name: unicode
    :param test_profile_name: **test_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'test_profile', 'keyval': 'test_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_test_profile_fwd_avg_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type test_profile: test_profile_name
    :param test_profile: Keyword argument tuple.

    :type test_profile_name: unicode
    :param test_profile_name: **test_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'test_profile', 'keyval': 'test_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_test_profile_fwd_max_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type test_profile: test_profile_name
    :param test_profile: Keyword argument tuple.

    :type test_profile_name: unicode
    :param test_profile_name: **test_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'test_profile', 'keyval': 'test_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_test_profile_meas_interval_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type test_profile: test_profile_name
    :param test_profile: Keyword argument tuple.

    :type test_profile_name: unicode
    :param test_profile_name: **test_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'test_profile', 'keyval': 'test_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_test_profile_packets_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Instance Keyword Argument Tuple**:

    :type test_profile: test_profile_name
    :param test_profile: Keyword argument tuple.

    :type test_profile_name: unicode
    :param test_profile_name: **test_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'test_profile', 'keyval': 'test_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_test_profile_start_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type test_profile: test_profile_name
    :param test_profile: Keyword argument tuple.

    :type test_profile_name: unicode
    :param test_profile_name: **test_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'test_profile', 'keyval': 'test_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_test_profile_stop_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type test_profile: test_profile_name
    :param test_profile: Keyword argument tuple.

    :type test_profile_name: unicode
    :param test_profile_name: **test_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'test_profile', 'keyval': 'test_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_test_profile_timeout_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type test_profile: test_profile_name
    :param test_profile: Keyword argument tuple.

    :type test_profile_name: unicode
    :param test_profile_name: **test_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'test_profile', 'keyval': 'test_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_test_profile_tx_frame_count_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type test_profile: test_profile_name
    :param test_profile: Keyword argument tuple.

    :type test_profile_name: unicode
    :param test_profile_name: **test_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'test_profile', 'keyval': 'test_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_test_profile_tx_interval_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type test_profile: test_profile_name
    :param test_profile: Keyword argument tuple.

    :type test_profile_name: unicode
    :param test_profile_name: **test_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'test_profile', 'keyval': 'test_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_cfm_y1731_test_profile_type_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type test_profile: test_profile_name
    :param test_profile: Keyword argument tuple.

    :type test_profile_name: unicode
    :param test_profile_name: **test_profile** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.cfm_y1731.test_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'test_profile', 'keyval': 'test_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.dmm', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm', u'dmm_stats_session_brief'), ('pybind.slxos.v17r_2_00.cfm_state.dmm', u'dmm_session_brief'), ('pybind.slxos.v17r_2_00.cfm_state.dmm', u'dmm_session_detail'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm', u'dmm_session_detail'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm', u'dmm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm', u'dmm_session_brief')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'session_index'}, {'leafval': 'session_index, test_profile_name'}, {'leafval': 'type, status, domain_name, ma_name, src_mep, tgt_mep, cos, start_time, stop_time, session_index'}, {'leafval': 'type, status, domain_name, ma_name, src_mep, tgt_mep, cos, start_time, stop_time, test_profile_name, start_type, stop_type, tx_interval, tx_frame_count, meas_interval, session_index, avg, max_'}, {'leafval': 'type, status, domain_name, ma_name, src_mep, tgt_mep, cos, start_time, stop_time, test_profile_name, start_type, stop_type, tx_interval, tx_frame_count, meas_interval, session_index, avg, max_'}, {'leafval': 'session_index, test_profile_name'}, {'leafval': 'session_index'}, {'leafval': 'type, status, domain_name, ma_name, src_mep, tgt_mep, cos, start_time, stop_time, session_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_brief_get(self, dmm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_brief: session_index
    :param dmm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_brief=dmm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_brief=dmm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_brief_cos_get(self, dmm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_brief: session_index
    :param dmm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_brief=dmm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_brief=dmm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_brief_domain_name_get(self, dmm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_brief: session_index
    :param dmm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_brief=dmm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_brief=dmm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_brief_ma_name_get(self, dmm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_brief: session_index
    :param dmm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_brief=dmm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_brief=dmm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_brief_src_mep_get(self, dmm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_brief: session_index
    :param dmm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_brief=dmm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_brief=dmm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_brief_start_time_get(self, dmm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_brief: session_index
    :param dmm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_brief=dmm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_brief=dmm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_brief_status_get(self, dmm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_brief: session_index
    :param dmm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_brief=dmm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_brief=dmm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_brief_stop_time_get(self, dmm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_brief: session_index
    :param dmm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_brief=dmm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_brief=dmm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_brief_tgt_mep_get(self, dmm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_brief: session_index
    :param dmm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_brief=dmm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_brief=dmm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_brief_type_get(self, dmm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_brief: session_index
    :param dmm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_brief=dmm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_brief=dmm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_avg_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_cos_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_domain_name_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_ma_name_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_max_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_meas_interval_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_src_mep_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_start_time_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_start_type_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_status_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_stop_time_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_stop_type_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_test_profile_name_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_tgt_mep_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_tx_frame_count_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_tx_interval_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_session_detail_type_get(self, dmm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_session_detail: session_index
    :param dmm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_session_detail=dmm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_session_detail=dmm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_brief_get(self, dmm_stats_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_brief: session_index
    :param dmm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_history_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_history_brief')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'start_time, elapsed_time, avg_delay, max_delay, min_delay, fdv_avg, fdv_max, fdv_min, history_index'}, {'leafval': 'start_time, elapsed_time, avg_delay, max_delay, min_delay, fdv_avg, fdv_max, fdv_min, history_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_brief=dmm_stats_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_brief=dmm_stats_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_brief_dmm_stats_session_history_brief_get(self, dmm_stats_session_brief=None, dmm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_brief: session_index
    :param dmm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_brief: history_index
    :param dmm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_brief_dmm_stats_session_history_brief_avg_delay_get(self, dmm_stats_session_brief=None, dmm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_brief: session_index
    :param dmm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_brief: history_index
    :param dmm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_brief_dmm_stats_session_history_brief_elapsed_time_get(self, dmm_stats_session_brief=None, dmm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_brief: session_index
    :param dmm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_brief: history_index
    :param dmm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_brief_dmm_stats_session_history_brief_fdv_avg_get(self, dmm_stats_session_brief=None, dmm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_brief: session_index
    :param dmm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_brief: history_index
    :param dmm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_brief_dmm_stats_session_history_brief_fdv_max_get(self, dmm_stats_session_brief=None, dmm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_brief: session_index
    :param dmm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_brief: history_index
    :param dmm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_brief_dmm_stats_session_history_brief_fdv_min_get(self, dmm_stats_session_brief=None, dmm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_brief: session_index
    :param dmm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_brief: history_index
    :param dmm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_brief_dmm_stats_session_history_brief_max_delay_get(self, dmm_stats_session_brief=None, dmm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_brief: session_index
    :param dmm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_brief: history_index
    :param dmm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_brief_dmm_stats_session_history_brief_min_delay_get(self, dmm_stats_session_brief=None, dmm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_brief: session_index
    :param dmm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_brief: history_index
    :param dmm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_brief_dmm_stats_session_history_brief_start_time_get(self, dmm_stats_session_brief=None, dmm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_brief: session_index
    :param dmm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_brief: history_index
    :param dmm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief.dmm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_brief=dmm_stats_session_brief, dmm_stats_session_history_brief=dmm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_brief_test_profile_name_get(self, dmm_stats_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_brief: session_index
    :param dmm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_history_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_brief', u'dmm_stats_session_history_brief')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'start_time, elapsed_time, avg_delay, max_delay, min_delay, fdv_avg, fdv_max, fdv_min, history_index'}, {'leafval': 'start_time, elapsed_time, avg_delay, max_delay, min_delay, fdv_avg, fdv_max, fdv_min, history_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_brief=dmm_stats_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_brief=dmm_stats_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_detailed_get(self, dmm_stats_session_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_detailed: session_index
    :param dmm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_history_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_history_detailed')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_detailed', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'start_time, elapsed_time, tx_count, rx_count, avg_delay, max_delay, min_delay, fdv_avg, fdv_max, fdv_min, test_profile_name, intiated_meas, completed_meas, history_index, session_index'}, {'leafval': 'start_time, elapsed_time, tx_count, rx_count, avg_delay, max_delay, min_delay, fdv_avg, fdv_max, fdv_min, test_profile_name, intiated_meas, completed_meas, history_index, session_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_detailed=dmm_stats_session_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_detailed=dmm_stats_session_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_detailed_dmm_stats_session_history_detailed_get(self, dmm_stats_session_detailed=None, dmm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_detailed: session_index
    :param dmm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_detailed: history_index
    :param dmm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_detailed_dmm_stats_session_history_detailed_avg_delay_get(self, dmm_stats_session_detailed=None, dmm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_detailed: session_index
    :param dmm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_detailed: history_index
    :param dmm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_detailed_dmm_stats_session_history_detailed_completed_meas_get(self, dmm_stats_session_detailed=None, dmm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_detailed: session_index
    :param dmm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_detailed: history_index
    :param dmm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_detailed_dmm_stats_session_history_detailed_elapsed_time_get(self, dmm_stats_session_detailed=None, dmm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_detailed: session_index
    :param dmm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_detailed: history_index
    :param dmm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_detailed_dmm_stats_session_history_detailed_fdv_avg_get(self, dmm_stats_session_detailed=None, dmm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_detailed: session_index
    :param dmm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_detailed: history_index
    :param dmm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_detailed_dmm_stats_session_history_detailed_fdv_max_get(self, dmm_stats_session_detailed=None, dmm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_detailed: session_index
    :param dmm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_detailed: history_index
    :param dmm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_detailed_dmm_stats_session_history_detailed_fdv_min_get(self, dmm_stats_session_detailed=None, dmm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_detailed: session_index
    :param dmm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_detailed: history_index
    :param dmm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_detailed_dmm_stats_session_history_detailed_intiated_meas_get(self, dmm_stats_session_detailed=None, dmm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_detailed: session_index
    :param dmm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_detailed: history_index
    :param dmm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_detailed_dmm_stats_session_history_detailed_max_delay_get(self, dmm_stats_session_detailed=None, dmm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_detailed: session_index
    :param dmm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_detailed: history_index
    :param dmm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_detailed_dmm_stats_session_history_detailed_min_delay_get(self, dmm_stats_session_detailed=None, dmm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_detailed: session_index
    :param dmm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_detailed: history_index
    :param dmm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_detailed_dmm_stats_session_history_detailed_rx_count_get(self, dmm_stats_session_detailed=None, dmm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_detailed: session_index
    :param dmm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_detailed: history_index
    :param dmm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_detailed_dmm_stats_session_history_detailed_session_index_get(self, dmm_stats_session_detailed=None, dmm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_detailed: session_index
    :param dmm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_detailed: history_index
    :param dmm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_detailed_dmm_stats_session_history_detailed_start_time_get(self, dmm_stats_session_detailed=None, dmm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_detailed: session_index
    :param dmm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_detailed: history_index
    :param dmm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_detailed_dmm_stats_session_history_detailed_test_profile_name_get(self, dmm_stats_session_detailed=None, dmm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_detailed: session_index
    :param dmm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_detailed: history_index
    :param dmm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_dmm_dmm_stats_session_detailed_dmm_stats_session_history_detailed_tx_count_get(self, dmm_stats_session_detailed=None, dmm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dmm_stats_session_detailed: session_index
    :param dmm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **dmm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type dmm_stats_session_history_detailed: history_index
    :param dmm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **dmm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed', u'dmm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.dmm.dmm_stats_session_detailed.dmm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dmm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dmm_stats_session_detailed=dmm_stats_session_detailed, dmm_stats_session_history_detailed=dmm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.slm', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm', u'slm_session_detail'), ('pybind.slxos.v17r_2_00.cfm_state.slm', u'slm_session_brief'), ('pybind.slxos.v17r_2_00.cfm_state.slm', u'slm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.slm', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_1_01a.cfm_state.slm', u'slm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.slm', u'slm_session_detail'), ('pybind.slxos.v17r_1_01a.cfm_state.slm', u'slm_session_brief')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'session_index'}, {'leafval': 'type, status, domain_name, ma_name, src_mep, tgt_mep, cos, start_time, stop_time, test_profile_name, start_type, stop_type, tx_interval, tx_frame_count, meas_interval, session_index, fwd_avg, fwd_max, bwd_avg, bwd_max'}, {'leafval': 'type, status, domain_name, ma_name, src_mep, tgt_mep, cos, start_time, stop_time, session_index'}, {'leafval': 'session_index'}, {'leafval': 'session_index'}, {'leafval': 'session_index'}, {'leafval': 'type, status, domain_name, ma_name, src_mep, tgt_mep, cos, start_time, stop_time, test_profile_name, start_type, stop_type, tx_interval, tx_frame_count, meas_interval, session_index, fwd_avg, fwd_max, bwd_avg, bwd_max'}, {'leafval': 'type, status, domain_name, ma_name, src_mep, tgt_mep, cos, start_time, stop_time, session_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_brief_get(self, slm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_brief: session_index
    :param slm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_brief=slm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_brief=slm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_brief_cos_get(self, slm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_brief: session_index
    :param slm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_brief=slm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_brief=slm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_brief_domain_name_get(self, slm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_brief: session_index
    :param slm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_brief=slm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_brief=slm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_brief_ma_name_get(self, slm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_brief: session_index
    :param slm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_brief=slm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_brief=slm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_brief_src_mep_get(self, slm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_brief: session_index
    :param slm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_brief=slm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_brief=slm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_brief_start_time_get(self, slm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_brief: session_index
    :param slm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_brief=slm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_brief=slm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_brief_status_get(self, slm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_brief: session_index
    :param slm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_brief=slm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_brief=slm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_brief_stop_time_get(self, slm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_brief: session_index
    :param slm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_brief=slm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_brief=slm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_brief_tgt_mep_get(self, slm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_brief: session_index
    :param slm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_brief=slm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_brief=slm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_brief_type_get(self, slm_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_brief: session_index
    :param slm_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_brief=slm_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_brief=slm_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_bwd_avg_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_bwd_max_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_cos_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_domain_name_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_fwd_avg_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_fwd_max_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_ma_name_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_meas_interval_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_src_mep_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_start_time_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_start_type_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_status_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_stop_time_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_stop_type_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_test_profile_name_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_tgt_mep_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_tx_frame_count_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_tx_interval_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_session_detail_type_get(self, slm_session_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_session_detail: session_index
    :param slm_session_detail: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_session_detail** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_session_detail', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_session_detail', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_session_detail=slm_session_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_session_detail=slm_session_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_brief_get(self, slm_stats_session_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_brief: session_index
    :param slm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_history_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_history_brief')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_brief', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'suspect_status, start_time, elapsed_time, tx_fwd, rx_fwd, tx_bwd, rx_bwd, flr_ratio, blr_ratio, history_index'}, {'leafval': 'suspect_status, start_time, elapsed_time, tx_fwd, rx_fwd, tx_bwd, rx_bwd, flr_ratio, blr_ratio, history_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_brief=slm_stats_session_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_brief=slm_stats_session_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_brief_slm_stats_session_history_brief_get(self, slm_stats_session_brief=None, slm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_brief: session_index
    :param slm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_brief: history_index
    :param slm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_brief_slm_stats_session_history_brief_blr_ratio_get(self, slm_stats_session_brief=None, slm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_brief: session_index
    :param slm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_brief: history_index
    :param slm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_brief_slm_stats_session_history_brief_elapsed_time_get(self, slm_stats_session_brief=None, slm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_brief: session_index
    :param slm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_brief: history_index
    :param slm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_brief_slm_stats_session_history_brief_flr_ratio_get(self, slm_stats_session_brief=None, slm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_brief: session_index
    :param slm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_brief: history_index
    :param slm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_brief_slm_stats_session_history_brief_rx_bwd_get(self, slm_stats_session_brief=None, slm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_brief: session_index
    :param slm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_brief: history_index
    :param slm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_brief_slm_stats_session_history_brief_rx_fwd_get(self, slm_stats_session_brief=None, slm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_brief: session_index
    :param slm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_brief: history_index
    :param slm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_brief_slm_stats_session_history_brief_start_time_get(self, slm_stats_session_brief=None, slm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_brief: session_index
    :param slm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_brief: history_index
    :param slm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_brief_slm_stats_session_history_brief_suspect_status_get(self, slm_stats_session_brief=None, slm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_brief: session_index
    :param slm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_brief: history_index
    :param slm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_brief_slm_stats_session_history_brief_tx_bwd_get(self, slm_stats_session_brief=None, slm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_brief: session_index
    :param slm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_brief: history_index
    :param slm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_brief_slm_stats_session_history_brief_tx_fwd_get(self, slm_stats_session_brief=None, slm_stats_session_history_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_brief: session_index
    :param slm_stats_session_brief: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_brief: history_index
    :param slm_stats_session_history_brief: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_brief** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief'), ('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief', u'slm_stats_session_brief')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_brief.slm_stats_session_history_brief', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_brief', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_brief=slm_stats_session_brief, slm_stats_session_history_brief=slm_stats_session_history_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_get(self, slm_stats_session_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_history_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_history_detailed')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_detailed', 'keyval': 'session_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'suspect_status, start_time, elapsed_time, tx_fwd, rx_fwd, tx_bwd, rx_bwd, test_profile_name, intiated_meas, completed_meas, flr_min_ratio, flr_max_ratio, flr_avg_ratio, blr_min_ratio, blr_max_ratio, blr_avg_ratio, history_index, session_index'}, {'leafval': 'suspect_status, start_time, elapsed_time, tx_fwd, rx_fwd, tx_bwd, rx_bwd, test_profile_name, intiated_meas, completed_meas, flr_min_ratio, flr_max_ratio, flr_avg_ratio, blr_min_ratio, blr_max_ratio, blr_avg_ratio, history_index, session_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_blr_avg_ratio_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_blr_max_ratio_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_blr_min_ratio_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_completed_meas_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_elapsed_time_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_flr_avg_ratio_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_flr_max_ratio_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_flr_min_ratio_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_intiated_meas_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_rx_bwd_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_rx_fwd_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_session_index_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_start_time_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_suspect_status_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_test_profile_name_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_tx_bwd_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cfm_state_slm_slm_stats_session_detailed_slm_stats_session_history_detailed_tx_fwd_get(self, slm_stats_session_detailed=None, slm_stats_session_history_detailed=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slm_stats_session_detailed: session_index
    :param slm_stats_session_detailed: Keyword argument tuple.

    :type session_index: long
    :param session_index: **slm_stats_session_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slm_stats_session_history_detailed: history_index
    :param slm_stats_session_history_detailed: Keyword argument tuple.

    :type history_index: long
    :param history_index: **slm_stats_session_history_detailed** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed', u'slm_stats_session_detailed')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_state.slm.slm_stats_session_detailed.slm_stats_session_history_detailed', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_index', 'extra_keyval': ''}, {'keyval': 'session_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slm_stats_session_history_detailed', 'keyval': 'history_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slm_stats_session_detailed=slm_stats_session_detailed, slm_stats_session_history_detailed=slm_stats_session_history_detailed)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def chassis_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.chassis', 'pybind.nos.v6_0_2f.brocade_chassis', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.chassis', 'pybind.nos.v7_2_0.brocade_chassis', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.chassis', 'pybind.slxos.v17r_1_01a.brocade_chassis', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.chassis', 'pybind.slxos.v17r_2_00.brocade_chassis', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.chassis', 'pybind.slxos.v17s_1_02.brocade_chassis', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.slxos.v17s_1_02.hide_virtual_ip_holder', u'chassis'), ('pybind.nos.v7_2_0.hide_virtual_ip_holder', u'chassis'), ('pybind.nos.v7_2_0.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.slxos.v17r_1_01a.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.slxos.v17r_1_01a.hide_virtual_ip_holder', u'chassis'), ('pybind.nos.v6_0_2f.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.nos.v6_0_2f.hide_virtual_ip_holder', u'chassis'), ('pybind.slxos.v17r_2_00.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.slxos.v17r_2_00.hide_virtual_ip_holder', u'chassis')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_ip, virtual_ipv6'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def chassis_fan_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.chassis.fan', 'pybind.nos.v6_0_2f.brocade_chassis', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.chassis.fan', 'pybind.nos.v7_2_0.brocade_chassis', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.chassis.fan', 'pybind.slxos.v17r_1_01a.brocade_chassis', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.chassis.fan', 'pybind.slxos.v17r_2_00.brocade_chassis', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.chassis.fan', 'pybind.slxos.v17s_1_02.brocade_chassis', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def chassis_hide_virtual_ip_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_virtual_ip_holder.chassis', 'pybind.nos.v6_0_2f.brocade_chassis', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_virtual_ip_holder.chassis', 'pybind.nos.v7_2_0.brocade_chassis', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hide_virtual_ip_holder.chassis', 'pybind.slxos.v17r_1_01a.brocade_chassis', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hide_virtual_ip_holder.chassis', 'pybind.slxos.v17r_2_00.brocade_chassis', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hide_virtual_ip_holder.chassis', 'pybind.slxos.v17s_1_02.brocade_chassis', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.slxos.v17r_1_01a.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.nos.v7_2_0.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.nos.v6_0_2f.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.slxos.v17s_1_02.hide_virtual_ip_holder.chassis', u'oper_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_oper_Vip_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def chassis_oper_address_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_virtual_ip_holder.chassis.oper_address', 'pybind.nos.v6_0_2f.brocade_chassis', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_virtual_ip_holder.chassis.oper_address', 'pybind.nos.v7_2_0.brocade_chassis', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def chassis_virtual_ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_virtual_ip_holder.chassis', 'pybind.nos.v6_0_2f.brocade_chassis', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_virtual_ip_holder.chassis', 'pybind.nos.v7_2_0.brocade_chassis', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hide_virtual_ip_holder.chassis', 'pybind.slxos.v17r_1_01a.brocade_chassis', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hide_virtual_ip_holder.chassis', 'pybind.slxos.v17r_2_00.brocade_chassis', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hide_virtual_ip_holder.chassis', 'pybind.slxos.v17s_1_02.brocade_chassis', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.slxos.v17r_1_01a.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.nos.v7_2_0.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.nos.v6_0_2f.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.slxos.v17s_1_02.hide_virtual_ip_holder.chassis', u'oper_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_oper_Vip_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def chassis_virtual_ip_oper_address_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_virtual_ip_holder.chassis.oper_address', 'pybind.nos.v6_0_2f.brocade_chassis', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_virtual_ip_holder.chassis.oper_address', 'pybind.nos.v7_2_0.brocade_chassis', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def chassis_virtual_ip_v4_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hide_virtual_ip_holder.chassis.oper_address', 'pybind.slxos.v17r_1_01a.brocade_chassis', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hide_virtual_ip_holder.chassis.oper_address', 'pybind.slxos.v17r_2_00.brocade_chassis', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hide_virtual_ip_holder.chassis.oper_address', 'pybind.slxos.v17s_1_02.brocade_chassis', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def chassis_virtual_ipv6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_virtual_ip_holder.chassis', 'pybind.nos.v6_0_2f.brocade_chassis', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_virtual_ip_holder.chassis', 'pybind.nos.v7_2_0.brocade_chassis', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hide_virtual_ip_holder.chassis', 'pybind.slxos.v17r_1_01a.brocade_chassis', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hide_virtual_ip_holder.chassis', 'pybind.slxos.v17r_2_00.brocade_chassis', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hide_virtual_ip_holder.chassis', 'pybind.slxos.v17s_1_02.brocade_chassis', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.slxos.v17r_1_01a.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.nos.v7_2_0.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.nos.v6_0_2f.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.slxos.v17s_1_02.hide_virtual_ip_holder.chassis', u'oper_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_oper_Vip_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def class_map_get(self, class_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type class_map: name
    :param class_map: Keyword argument tuple.

    :type name: unicode
    :param name: **class_map** tuple argument:  Class Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.class_map', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.class_map', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.class_map', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.class_map', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.class_map', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.class_map.match', u'vlan'), ('pybind.slxos.v17r_2_00.class_map.match', u'access_group'), ('pybind.slxos.v17r_2_00.class_map.match', u'bridge_domain'), ('pybind.nos.v6_0_2f.class_map.match', u'access_group'), ('pybind.nos.v7_2_0.class_map.match', u'access_group'), ('pybind.slxos.v17r_1_01a.class_map.match', u'access_group'), ('pybind.slxos.v17r_1_01a.class_map.match', u'vlan'), ('pybind.slxos.v17r_1_01a.class_map.match', u'bridge_domain'), ('pybind.slxos.v17s_1_02.class_map.match', u'access_group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'class_map', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_range'}, {'leafval': 'access_group_name'}, {'leafval': 'bridge_domain_range'}, {'leafval': 'access_group_name'}, {'leafval': 'access_group_name'}, {'leafval': 'access_group_name'}, {'leafval': 'vlan_range'}, {'leafval': 'bridge_domain_range'}, {'leafval': 'access_group_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, class_map=class_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, class_map=class_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def class_map_match_get(self, class_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type class_map: name
    :param class_map: Keyword argument tuple.

    :type name: unicode
    :param name: **class_map** tuple argument:  Class Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.class_map', 'class_map'), ('pybind.nos.v7_2_0.class_map', 'class_map'), ('pybind.slxos.v17r_2_00.class_map', 'class_map'), ('pybind.slxos.v17r_1_01a.class_map', 'class_map'), ('pybind.slxos.v17s_1_02.class_map', 'class_map')]
    bindings_list = [('pybind.nos.v6_0_2f.class_map.match', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.class_map.match', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.class_map.match', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.class_map.match', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.class_map.match', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, class_map=class_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, class_map=class_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def class_map_match_access_group_get(self, class_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type class_map: name
    :param class_map: Keyword argument tuple.

    :type name: unicode
    :param name: **class_map** tuple argument:  Class Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.class_map', 'class_map'), ('pybind.nos.v7_2_0.class_map', 'class_map'), ('pybind.slxos.v17s_1_02.class_map', 'class_map'), ('pybind.slxos.v17r_1_01a.class_map', 'class_map'), ('pybind.nos.v6_0_2f.class_map', 'class_map')]
    bindings_list = [('pybind.nos.v6_0_2f.class_map.match.access_group', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.class_map.match.access_group', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.class_map.match.access_group', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.class_map.match.access_group', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.class_map.match.access_group', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'access_group_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, class_map=class_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, class_map=class_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def class_map_match_access_group_access_group_name_get(self, class_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type class_map: name
    :param class_map: Keyword argument tuple.

    :type name: unicode
    :param name: **class_map** tuple argument:  Class Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.class_map', 'class_map'), ('pybind.nos.v7_2_0.class_map', 'class_map'), ('pybind.slxos.v17s_1_02.class_map', 'class_map'), ('pybind.slxos.v17r_1_01a.class_map', 'class_map'), ('pybind.nos.v6_0_2f.class_map', 'class_map')]
    bindings_list = [('pybind.nos.v6_0_2f.class_map.match.access_group', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.class_map.match.access_group', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.class_map.match.access_group', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.class_map.match.access_group', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.class_map.match.access_group', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, class_map=class_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, class_map=class_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def class_map_match_bridge_domain_get(self, class_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type class_map: name
    :param class_map: Keyword argument tuple.

    :type name: unicode
    :param name: **class_map** tuple argument:  Class Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.class_map', 'class_map'), ('pybind.slxos.v17r_1_01a.class_map', 'class_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.class_map.match.bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.class_map.match.bridge_domain', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'bridge_domain_range'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, class_map=class_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, class_map=class_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def class_map_match_bridge_domain_bridge_domain_range_get(self, class_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type class_map: name
    :param class_map: Keyword argument tuple.

    :type name: unicode
    :param name: **class_map** tuple argument:  Class Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.class_map', 'class_map'), ('pybind.slxos.v17r_1_01a.class_map', 'class_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.class_map.match.bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.class_map.match.bridge_domain', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, class_map=class_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, class_map=class_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def class_map_match_vlan_get(self, class_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type class_map: name
    :param class_map: Keyword argument tuple.

    :type name: unicode
    :param name: **class_map** tuple argument:  Class Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.class_map', 'class_map'), ('pybind.slxos.v17r_2_00.class_map', 'class_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.class_map.match.vlan', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.class_map.match.vlan', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'vlan_range'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, class_map=class_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, class_map=class_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def class_map_match_vlan_vlan_range_get(self, class_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type class_map: name
    :param class_map: Keyword argument tuple.

    :type name: unicode
    :param name: **class_map** tuple argument:  Class Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.class_map', 'class_map'), ('pybind.slxos.v17r_2_00.class_map', 'class_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.class_map.match.vlan', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.class_map.match.vlan', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, class_map=class_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, class_map=class_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.clear', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.clear', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.clear', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.clear', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.clear', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def clock_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.clock_sa.clock', 'pybind.nos.v6_0_2f.brocade_clock', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.clock_sa.clock', 'pybind.nos.v7_2_0.brocade_clock', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.clock_sa.clock', 'pybind.slxos.v17r_1_01a.brocade_clock', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.clock_sa.clock', 'pybind.slxos.v17r_2_00.brocade_clock', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.clock_sa.clock', 'pybind.slxos.v17s_1_02.brocade_clock', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def clock_sa_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.clock_sa', 'pybind.nos.v6_0_2f.brocade_clock', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.clock_sa', 'pybind.nos.v7_2_0.brocade_clock', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.clock_sa', 'pybind.slxos.v17r_1_01a.brocade_clock', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.clock_sa', 'pybind.slxos.v17r_2_00.brocade_clock', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.clock_sa', 'pybind.slxos.v17s_1_02.brocade_clock', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.clock_sa', u'clock'), ('pybind.nos.v7_2_0.clock_sa', u'clock'), ('pybind.slxos.v17s_1_02.clock_sa', u'clock'), ('pybind.slxos.v17r_2_00.clock_sa', u'clock'), ('pybind.nos.v6_0_2f.clock_sa', u'clock')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'timezone'}, {'leafval': 'timezone'}, {'leafval': 'timezone'}, {'leafval': 'timezone'}, {'leafval': 'timezone'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def clock_timezone_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.clock_sa.clock', 'pybind.nos.v6_0_2f.brocade_clock', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.clock_sa.clock', 'pybind.nos.v7_2_0.brocade_clock', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.clock_sa.clock', 'pybind.slxos.v17r_1_01a.brocade_clock', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.clock_sa.clock', 'pybind.slxos.v17r_2_00.brocade_clock', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.clock_sa.clock', 'pybind.slxos.v17s_1_02.brocade_clock', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cluster', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cluster.member', u'bridge_domain'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17s_1_02.cluster', u'peer_interface'), ('pybind.slxos.v17s_1_02.cluster.member', u'vlan'), ('pybind.slxos.v17s_1_02.cluster', u'client'), ('pybind.slxos.v17s_1_02.cluster', u'peer'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ip', u'address'), ('pybind.slxos.v17r_2_00.cluster', u'client_pw'), ('pybind.slxos.v17r_2_00.cluster', u'peer_interface'), ('pybind.slxos.v17r_2_00.cluster', u'client_isolation'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17r_2_00.cluster', u'peer'), ('pybind.slxos.v17r_2_00.cluster', u'client'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ip', u'address'), ('pybind.slxos.v17r_1_01a.cluster.member', u'vlan'), ('pybind.slxos.v17r_1_01a.cluster', u'client_pw'), ('pybind.slxos.v17r_1_01a.cluster', u'client_isolation'), ('pybind.slxos.v17r_1_01a.cluster', u'peer_interface'), ('pybind.slxos.v17r_1_01a.cluster', u'client'), ('pybind.slxos.v17r_1_01a.cluster.member', u'bridge_domain'), ('pybind.slxos.v17r_1_01a.cluster', u'peer')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cluster', 'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'add_bd, remove_bd'}, {'leafval': 'ipv6address'}, {'leafval': 'peer_if_type, peer_if_name'}, {'leafval': 'add_, remove_'}, {'leafval': 'client_name, client_id, client_deploy'}, {'leafval': 'peer_ip'}, {'leafval': 'address'}, {'leafval': 'client_pw_esi, client_pw_deploy'}, {'leafval': 'peer_if_type, peer_if_name'}, {'leafval': 'strict, loose'}, {'leafval': 'ipv6address'}, {'leafval': 'peer_ip'}, {'leafval': 'client_name, client_id, client_deploy'}, {'leafval': 'address'}, {'leafval': 'add_, remove_'}, {'leafval': 'client_pw_esi, client_pw_deploy'}, {'leafval': 'strict, loose'}, {'leafval': 'peer_if_type, peer_if_name'}, {'leafval': 'client_name, client_id, esi, client_deploy'}, {'leafval': 'add_bd, remove_bd'}, {'leafval': 'peer_ip'}]
    leafval_map = {"pybind.slxos.v17s_1_02.cluster": {}, "pybind.slxos.v17r_2_00.cluster": {"cluster_name": "cluster_name", "client_interfaces_shutdown": "client_interfaces_shutdown", "cluster_id": "cluster_id", "deploy": "deploy", "designated_forwarder_hold_time": "designated_forwarder_hold_time"}, "pybind.slxos.v17r_1_01a.cluster": {"cluster_name": "cluster_name", "client_interfaces_shutdown": "client_interfaces_shutdown", "cluster_id": "cluster_id", "deploy": "deploy", "designated_forwarder_hold_time": "designated_forwarder_hold_time"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_client_get(self, cluster=None, client=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client: client_name, client_id
    :param client: Keyword argument tuple.

    :type client_name: unicode
    :param client_name: **client** tuple argument:  Name for the Cluster Client (MAX: 64 Characters)

        * length restriction: ::

            ['1..64']

    :type client_id: long
    :param client_id: **client** tuple argument:  Id for the Cluster Client (Range: 1 - 512)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cluster', 'cluster'), ('pybind.slxos.v17s_1_02.cluster', 'cluster'), ('pybind.slxos.v17r_1_01a.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.client', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster.client', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cluster.client', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cluster.client', u'client_interface'), ('pybind.slxos.v17r_2_00.cluster.client', u'esi'), ('pybind.slxos.v17s_1_02.cluster.client', u'client_interface'), ('pybind.slxos.v17s_1_02.cluster.client', u'esi'), ('pybind.slxos.v17r_1_01a.cluster.client', u'client_interface')]
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client', 'keyval': 'client_name, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'if_type, if_value'}, {'leafval': 'esi_value, esi_auto'}, {'leafval': 'if_type, if_value'}, {'leafval': 'esi_value, esi_auto'}, {'leafval': 'if_type, if_value'}]
    leafval_map = {"pybind.slxos.v17s_1_02.cluster.client": {}, "pybind.slxos.v17r_1_01a.cluster.client": {"client_name": "client_name", "client_deploy": "client_deploy", "esi": "esi", "client_id": "client_id"}, "pybind.slxos.v17r_2_00.cluster.client": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, client=client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, client=client)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_client_client_interface_get(self, cluster=None, client=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type client: client_name, client_id
    :param client: Keyword argument tuple.

    :type client_name: unicode
    :param client_name: **client** tuple argument:  Name for the Cluster Client (MAX: 64 Characters)

        * length restriction: ::

            ['1..64']

    :type client_id: long
    :param client_id: **client** tuple argument:  Id for the Cluster Client (Range: 1 - 512)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster.client', u'client'), ('pybind.slxos.v17s_1_02.cluster', 'cluster'), ('pybind.slxos.v17s_1_02.cluster.client', u'client'), ('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17r_1_01a.cluster.client', u'client')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.client.client_interface', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster.client.client_interface', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cluster.client.client_interface', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'client_name, client_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'client_name, client_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'client_name, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, client=client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, client=client)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_client_client_interface_if_type_get(self, cluster=None, client=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type client: client_name, client_id
    :param client: Keyword argument tuple.

    :type client_name: unicode
    :param client_name: **client** tuple argument:  Name for the Cluster Client (MAX: 64 Characters)

        * length restriction: ::

            ['1..64']

    :type client_id: long
    :param client_id: **client** tuple argument:  Id for the Cluster Client (Range: 1 - 512)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster.client', u'client'), ('pybind.slxos.v17s_1_02.cluster', 'cluster'), ('pybind.slxos.v17s_1_02.cluster.client', u'client'), ('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17r_1_01a.cluster.client', u'client')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.client.client_interface', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster.client.client_interface', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cluster.client.client_interface', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'client_name, client_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'client_name, client_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'client_name, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, client=client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, client=client)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_client_client_interface_if_value_get(self, cluster=None, client=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type client: client_name, client_id
    :param client: Keyword argument tuple.

    :type client_name: unicode
    :param client_name: **client** tuple argument:  Name for the Cluster Client (MAX: 64 Characters)

        * length restriction: ::

            ['1..64']

    :type client_id: long
    :param client_id: **client** tuple argument:  Id for the Cluster Client (Range: 1 - 512)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster.client', u'client'), ('pybind.slxos.v17s_1_02.cluster', 'cluster'), ('pybind.slxos.v17s_1_02.cluster.client', u'client'), ('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17r_1_01a.cluster.client', u'client')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.client.client_interface', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster.client.client_interface', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cluster.client.client_interface', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'client_name, client_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'client_name, client_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'client_name, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, client=client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, client=client)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_client_deploy_get(self, cluster=None, client=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client: client_name, client_id
    :param client: Keyword argument tuple.

    :type client_name: unicode
    :param client_name: **client** tuple argument:  Name for the Cluster Client (MAX: 64 Characters)

        * length restriction: ::

            ['1..64']

    :type client_id: long
    :param client_id: **client** tuple argument:  Id for the Cluster Client (Range: 1 - 512)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cluster', 'cluster'), ('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17s_1_02.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.client', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster.client', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cluster.client', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cluster.client', u'client_interface'), ('pybind.slxos.v17r_2_00.cluster.client', u'esi'), ('pybind.slxos.v17r_1_01a.cluster.client', u'client_interface'), ('pybind.slxos.v17s_1_02.cluster.client', u'client_interface'), ('pybind.slxos.v17s_1_02.cluster.client', u'esi')]
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client', 'keyval': 'client_name, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'if_type, if_value'}, {'leafval': 'esi_value, esi_auto'}, {'leafval': 'if_type, if_value'}, {'leafval': 'if_type, if_value'}, {'leafval': 'esi_value, esi_auto'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, client=client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, client=client)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_client_esi_get(self, cluster=None, client=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client: client_name, client_id
    :param client: Keyword argument tuple.

    :type client_name: unicode
    :param client_name: **client** tuple argument:  Name for the Cluster Client (MAX: 64 Characters)

        * length restriction: ::

            ['1..64']

    :type client_id: long
    :param client_id: **client** tuple argument:  Id for the Cluster Client (Range: 1 - 512)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.client', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cluster.client', u'client_interface')]
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client', 'keyval': 'client_name, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'if_type, if_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, client=client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, client=client)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_client_esi_auto_get(self, cluster=None, client=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type client: client_name, client_id
    :param client: Keyword argument tuple.

    :type client_name: unicode
    :param client_name: **client** tuple argument:  Name for the Cluster Client (MAX: 64 Characters)

        * length restriction: ::

            ['1..64']

    :type client_id: long
    :param client_id: **client** tuple argument:  Id for the Cluster Client (Range: 1 - 512)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cluster', 'cluster'), ('pybind.slxos.v17s_1_02.cluster.client', u'client'), ('pybind.slxos.v17r_2_00.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster.client', u'client')]
    bindings_list = [('pybind.slxos.v17r_2_00.cluster.client.esi', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cluster.client.esi', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'client_name, client_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'client_name, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, client=client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, client=client)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_client_esi_esi_value_get(self, cluster=None, client=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type client: client_name, client_id
    :param client: Keyword argument tuple.

    :type client_name: unicode
    :param client_name: **client** tuple argument:  Name for the Cluster Client (MAX: 64 Characters)

        * length restriction: ::

            ['1..64']

    :type client_id: long
    :param client_id: **client** tuple argument:  Id for the Cluster Client (Range: 1 - 512)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cluster', 'cluster'), ('pybind.slxos.v17s_1_02.cluster.client', u'client'), ('pybind.slxos.v17r_2_00.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster.client', u'client')]
    bindings_list = [('pybind.slxos.v17r_2_00.cluster.client.esi', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cluster.client.esi', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'client_name, client_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'client_name, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, client=client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, client=client)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_client_interfaces_shutdown_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cluster', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cluster.member', u'bridge_domain'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17s_1_02.cluster', u'peer_interface'), ('pybind.slxos.v17s_1_02.cluster.member', u'vlan'), ('pybind.slxos.v17s_1_02.cluster', u'client'), ('pybind.slxos.v17s_1_02.cluster', u'peer'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ip', u'address'), ('pybind.slxos.v17r_1_01a.cluster.member', u'vlan'), ('pybind.slxos.v17r_1_01a.cluster', u'client_pw'), ('pybind.slxos.v17r_1_01a.cluster', u'client_isolation'), ('pybind.slxos.v17r_1_01a.cluster', u'peer_interface'), ('pybind.slxos.v17r_1_01a.cluster', u'client'), ('pybind.slxos.v17r_1_01a.cluster.member', u'bridge_domain'), ('pybind.slxos.v17r_1_01a.cluster', u'peer'), ('pybind.slxos.v17r_2_00.cluster', u'client_pw'), ('pybind.slxos.v17r_2_00.cluster', u'peer_interface'), ('pybind.slxos.v17r_2_00.cluster', u'client_isolation'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17r_2_00.cluster', u'peer'), ('pybind.slxos.v17r_2_00.cluster', u'client'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ip', u'address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cluster', 'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'add_bd, remove_bd'}, {'leafval': 'ipv6address'}, {'leafval': 'peer_if_type, peer_if_name'}, {'leafval': 'add_, remove_'}, {'leafval': 'client_name, client_id, client_deploy'}, {'leafval': 'peer_ip'}, {'leafval': 'address'}, {'leafval': 'add_, remove_'}, {'leafval': 'client_pw_esi, client_pw_deploy'}, {'leafval': 'strict, loose'}, {'leafval': 'peer_if_type, peer_if_name'}, {'leafval': 'client_name, client_id, esi, client_deploy'}, {'leafval': 'add_bd, remove_bd'}, {'leafval': 'peer_ip'}, {'leafval': 'client_pw_esi, client_pw_deploy'}, {'leafval': 'peer_if_type, peer_if_name'}, {'leafval': 'strict, loose'}, {'leafval': 'ipv6address'}, {'leafval': 'peer_ip'}, {'leafval': 'client_name, client_id, client_deploy'}, {'leafval': 'address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_client_isolation_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.client_isolation', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster.client_isolation', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_client_isolation_loose_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.client_isolation', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster.client_isolation', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_client_isolation_strict_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cluster', 'cluster'), ('pybind.slxos.v17r_1_01a.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.client_isolation', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster.client_isolation', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cluster', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cluster.member', u'bridge_domain'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17s_1_02.cluster', u'peer_interface'), ('pybind.slxos.v17s_1_02.cluster.member', u'vlan'), ('pybind.slxos.v17s_1_02.cluster', u'client'), ('pybind.slxos.v17s_1_02.cluster', u'peer'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ip', u'address')]
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'add_bd, remove_bd'}, {'leafval': 'ipv6address'}, {'leafval': 'peer_if_type, peer_if_name'}, {'leafval': 'add_, remove_'}, {'leafval': 'client_name, client_id, client_deploy'}, {'leafval': 'peer_ip'}, {'leafval': 'address'}]
    leafval_map = {"pybind.slxos.v17s_1_02.cluster": {}, "pybind.slxos.v17r_1_01a.cluster.client_isolation": {"strict": "strict"}, "pybind.slxos.v17r_2_00.cluster.client_isolation": {"strict": "strict"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_client_pw_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.client_pw', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster.client_pw', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_client_pw_deploy_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.client_pw', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster.client_pw', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_client_pw_esi_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.client_pw', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster.client_pw', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_cluster_control_vlan_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  1-65535;;Id for the Cluster

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.cluster', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cluster.member', u'bridge_domain'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17s_1_02.cluster', u'peer_interface'), ('pybind.slxos.v17s_1_02.cluster.member', u'vlan'), ('pybind.slxos.v17s_1_02.cluster', u'client'), ('pybind.slxos.v17s_1_02.cluster', u'peer'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ip', u'address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cluster', 'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'add_bd, remove_bd'}, {'leafval': 'ipv6address'}, {'leafval': 'peer_if_type, peer_if_name'}, {'leafval': 'add_, remove_'}, {'leafval': 'client_name, client_id, client_deploy'}, {'leafval': 'peer_ip'}, {'leafval': 'address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_deploy_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cluster', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cluster.member', u'bridge_domain'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17s_1_02.cluster', u'peer_interface'), ('pybind.slxos.v17s_1_02.cluster.member', u'vlan'), ('pybind.slxos.v17s_1_02.cluster', u'client'), ('pybind.slxos.v17s_1_02.cluster', u'peer'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ip', u'address'), ('pybind.slxos.v17r_1_01a.cluster.member', u'vlan'), ('pybind.slxos.v17r_1_01a.cluster', u'client_pw'), ('pybind.slxos.v17r_1_01a.cluster', u'client_isolation'), ('pybind.slxos.v17r_1_01a.cluster', u'peer_interface'), ('pybind.slxos.v17r_1_01a.cluster', u'client'), ('pybind.slxos.v17r_1_01a.cluster.member', u'bridge_domain'), ('pybind.slxos.v17r_1_01a.cluster', u'peer'), ('pybind.slxos.v17r_2_00.cluster', u'client_pw'), ('pybind.slxos.v17r_2_00.cluster', u'peer_interface'), ('pybind.slxos.v17r_2_00.cluster', u'client_isolation'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17r_2_00.cluster', u'peer'), ('pybind.slxos.v17r_2_00.cluster', u'client'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ip', u'address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cluster', 'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'add_bd, remove_bd'}, {'leafval': 'ipv6address'}, {'leafval': 'peer_if_type, peer_if_name'}, {'leafval': 'add_, remove_'}, {'leafval': 'client_name, client_id, client_deploy'}, {'leafval': 'peer_ip'}, {'leafval': 'address'}, {'leafval': 'add_, remove_'}, {'leafval': 'client_pw_esi, client_pw_deploy'}, {'leafval': 'strict, loose'}, {'leafval': 'peer_if_type, peer_if_name'}, {'leafval': 'client_name, client_id, esi, client_deploy'}, {'leafval': 'add_bd, remove_bd'}, {'leafval': 'peer_ip'}, {'leafval': 'client_pw_esi, client_pw_deploy'}, {'leafval': 'peer_if_type, peer_if_name'}, {'leafval': 'strict, loose'}, {'leafval': 'ipv6address'}, {'leafval': 'peer_ip'}, {'leafval': 'client_name, client_id, client_deploy'}, {'leafval': 'address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_designated_forwarder_hold_time_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cluster', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cluster.member', u'bridge_domain'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17s_1_02.cluster', u'peer_interface'), ('pybind.slxos.v17s_1_02.cluster.member', u'vlan'), ('pybind.slxos.v17s_1_02.cluster', u'client'), ('pybind.slxos.v17s_1_02.cluster', u'peer'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ip', u'address'), ('pybind.slxos.v17r_1_01a.cluster.member', u'vlan'), ('pybind.slxos.v17r_1_01a.cluster', u'client_pw'), ('pybind.slxos.v17r_1_01a.cluster', u'client_isolation'), ('pybind.slxos.v17r_1_01a.cluster', u'peer_interface'), ('pybind.slxos.v17r_1_01a.cluster', u'client'), ('pybind.slxos.v17r_1_01a.cluster.member', u'bridge_domain'), ('pybind.slxos.v17r_1_01a.cluster', u'peer'), ('pybind.slxos.v17r_2_00.cluster', u'client_pw'), ('pybind.slxos.v17r_2_00.cluster', u'peer_interface'), ('pybind.slxos.v17r_2_00.cluster', u'client_isolation'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17r_2_00.cluster', u'peer'), ('pybind.slxos.v17r_2_00.cluster', u'client'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ip', u'address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cluster', 'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'add_bd, remove_bd'}, {'leafval': 'ipv6address'}, {'leafval': 'peer_if_type, peer_if_name'}, {'leafval': 'add_, remove_'}, {'leafval': 'client_name, client_id, client_deploy'}, {'leafval': 'peer_ip'}, {'leafval': 'address'}, {'leafval': 'add_, remove_'}, {'leafval': 'client_pw_esi, client_pw_deploy'}, {'leafval': 'strict, loose'}, {'leafval': 'peer_if_type, peer_if_name'}, {'leafval': 'client_name, client_id, esi, client_deploy'}, {'leafval': 'add_bd, remove_bd'}, {'leafval': 'peer_ip'}, {'leafval': 'client_pw_esi, client_pw_deploy'}, {'leafval': 'peer_if_type, peer_if_name'}, {'leafval': 'strict, loose'}, {'leafval': 'ipv6address'}, {'leafval': 'peer_ip'}, {'leafval': 'client_name, client_id, client_deploy'}, {'leafval': 'address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_df_load_balance_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  1-65535;;Id for the Cluster

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.cluster', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cluster.member', u'bridge_domain'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17s_1_02.cluster', u'peer_interface'), ('pybind.slxos.v17s_1_02.cluster.member', u'vlan'), ('pybind.slxos.v17s_1_02.cluster', u'client'), ('pybind.slxos.v17s_1_02.cluster', u'peer'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ip', u'address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cluster', 'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'add_bd, remove_bd'}, {'leafval': 'ipv6address'}, {'leafval': 'peer_if_type, peer_if_name'}, {'leafval': 'add_, remove_'}, {'leafval': 'client_name, client_id, client_deploy'}, {'leafval': 'peer_ip'}, {'leafval': 'address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_management_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management', 'pybind.slxos.v17r_2_00.brocade_cluster', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management', 'pybind.slxos.v17s_1_02.brocade_cluster', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ip', u'address'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ip', u'address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6address'}, {'leafval': 'address'}, {'leafval': 'ipv6address'}, {'leafval': 'address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_management_virtual_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual', 'pybind.slxos.v17r_2_00.brocade_cluster', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual', 'pybind.slxos.v17s_1_02.brocade_cluster', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ip', u'address'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ip', u'address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6address'}, {'leafval': 'address'}, {'leafval': 'ipv6address'}, {'leafval': 'address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_management_virtual_ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ip', 'pybind.slxos.v17r_2_00.brocade_cluster', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ip', 'pybind.slxos.v17s_1_02.brocade_cluster', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ip', u'address'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ip', u'address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'address'}, {'leafval': 'address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_management_virtual_ip_address_get(self, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  Virtual IP address (IPv4 Address/Prefix)

        * pattern restriction: ::

            '((0|(1[0-9]{0,2})|(2(([0-4][0-9]?)|(5[0-5]?)|([6'
            '-9]?)))|([3-9][0-9]?))\.){3}(0|(1[0-9]{0,2})|(2('
            '([0-4][0-9]?)|(5[0-5]?)|([6-9]?)))|([3-9][0-9]?)'
            ')/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ip.address', 'pybind.slxos.v17r_2_00.brocade_cluster', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ip.address', 'pybind.slxos.v17s_1_02.brocade_cluster', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_management_virtual_ipv6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ipv6', 'pybind.slxos.v17r_2_00.brocade_cluster', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ipv6', 'pybind.slxos.v17s_1_02.brocade_cluster', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ipv6', u'address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6address'}, {'leafval': 'ipv6address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_management_virtual_ipv6_address_get(self, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type address: ipv6address
    :param address: Keyword argument tuple.

    :type ipv6address: unicode
    :param ipv6address: **address** tuple argument:  Virtual IPV6 address (IPv6 Address/Prefix)

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ipv6.address', 'pybind.slxos.v17r_2_00.brocade_cluster', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ipv6.address', 'pybind.slxos.v17s_1_02.brocade_cluster', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'ipv6address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_member_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cluster', 'cluster'), ('pybind.slxos.v17r_1_01a.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.member', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.cluster.member', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_member_bridge_domain_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17s_1_02.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.member.bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.cluster.member.bridge_domain', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_member_bridge_domain_add_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17s_1_02.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.member.bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.cluster.member.bridge_domain', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_member_bridge_domain_remove_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17s_1_02.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.member.bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.cluster.member.bridge_domain', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_member_vlan_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17s_1_02.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.member.vlan', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.cluster.member.vlan', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_member_vlan_add_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17s_1_02.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.member.vlan', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.cluster.member.vlan', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_member_vlan_remove_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17s_1_02.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.member.vlan', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.cluster.member.vlan', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_peer_get(self, cluster=None, peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  MCT Peer node IP Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cluster', 'cluster'), ('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17s_1_02.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.peer', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster.peer', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cluster.peer', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cluster.peer', u'source'), ('pybind.slxos.v17r_2_00.cluster.peer.source', u'interface')]
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer', 'keyval': 'peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'source_ip'}, {'leafval': 'loopback'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, peer=peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_peer_interface_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cluster', 'cluster'), ('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.peer_interface', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster.peer_interface', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cluster.peer_interface', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_peer_interface_peer_if_name_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cluster', 'cluster'), ('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.peer_interface', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster.peer_interface', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cluster.peer_interface', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_peer_interface_peer_if_type_get(self, cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cluster', 'cluster'), ('pybind.slxos.v17r_1_01a.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster', 'cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cluster.peer_interface', 'pybind.slxos.v17r_1_01a.brocade_mct', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cluster.peer_interface', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cluster.peer_interface', 'pybind.slxos.v17s_1_02.brocade_mct', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_peer_source_get(self, cluster=None, peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  MCT Peer node IP Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster.peer', u'peer')]
    bindings_list = [('pybind.slxos.v17r_2_00.cluster.peer.source', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'peer_ip', 'extra_keyval': 'peer_ip'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, peer=peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_peer_source_interface_get(self, cluster=None, peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  MCT Peer node IP Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster.peer', u'peer')]
    bindings_list = [('pybind.slxos.v17r_2_00.cluster.peer.source.interface', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'peer_ip', 'extra_keyval': 'peer_ip'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, peer=peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_peer_source_interface_loopback_get(self, cluster=None, peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  MCT Peer node IP Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster.peer', u'peer')]
    bindings_list = [('pybind.slxos.v17r_2_00.cluster.peer.source.interface', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'peer_ip', 'extra_keyval': 'peer_ip'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, peer=peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cluster_peer_source_ip_get(self, cluster=None, peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cluster: cluster_name, cluster_id
    :param cluster: Keyword argument tuple.

    :type cluster_name: unicode
    :param cluster_name: **cluster** tuple argument:  Name for the Cluster (MAX: 64 Characters)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type cluster_id: long
    :param cluster_id: **cluster** tuple argument:  Id for the Cluster (Range: 1 - 65535

        * range restriction: ::

            ['0..4294967295']

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  MCT Peer node IP Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cluster', 'cluster'), ('pybind.slxos.v17r_2_00.cluster.peer', u'peer')]
    bindings_list = [('pybind.slxos.v17r_2_00.cluster.peer.source', 'pybind.slxos.v17r_2_00.brocade_mct', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_name, cluster_id', 'extra_keyval': ''}, {'keyval': 'peer_ip', 'extra_keyval': 'peer_ip'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cluster=cluster, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cluster=cluster, peer=peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def control_plane_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.control_plane', 'pybind.slxos.v17r_1_01a.brocade_control_plane', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.control_plane', 'pybind.slxos.v17r_2_00.brocade_control_plane', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.control_plane', 'pybind.slxos.v17s_1_02.brocade_control_plane', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.control_plane.ipv6', u'subnet_rate_limit'), ('pybind.slxos.v17r_1_01a.control_plane.ipv6', u'subnet_rate_limit'), ('pybind.slxos.v17s_1_02.control_plane.ipv6', u'subnet_rate_limit')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cir, cbr'}, {'leafval': 'cir, cbr'}, {'leafval': 'cir, cbr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def control_plane_ipv6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.control_plane.ipv6', 'pybind.slxos.v17r_1_01a.brocade_control_plane', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.control_plane.ipv6', 'pybind.slxos.v17r_2_00.brocade_control_plane', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.control_plane.ipv6', 'pybind.slxos.v17s_1_02.brocade_control_plane', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.control_plane.ipv6', u'subnet_rate_limit'), ('pybind.slxos.v17s_1_02.control_plane.ipv6', u'subnet_rate_limit'), ('pybind.slxos.v17r_2_00.control_plane.ipv6', u'subnet_rate_limit')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cir, cbr'}, {'leafval': 'cir, cbr'}, {'leafval': 'cir, cbr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def control_plane_ipv6_subnet_rate_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.control_plane.ipv6.subnet_rate_limit', 'pybind.slxos.v17r_1_01a.brocade_control_plane', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.control_plane.ipv6.subnet_rate_limit', 'pybind.slxos.v17r_2_00.brocade_control_plane', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.control_plane.ipv6.subnet_rate_limit', 'pybind.slxos.v17s_1_02.brocade_control_plane', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def control_plane_ipv6_subnet_rate_limit_cbr_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.control_plane.ipv6.subnet_rate_limit', 'pybind.slxos.v17r_1_01a.brocade_control_plane', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.control_plane.ipv6.subnet_rate_limit', 'pybind.slxos.v17r_2_00.brocade_control_plane', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.control_plane.ipv6.subnet_rate_limit', 'pybind.slxos.v17s_1_02.brocade_control_plane', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def control_plane_ipv6_subnet_rate_limit_cir_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.control_plane.ipv6.subnet_rate_limit', 'pybind.slxos.v17r_1_01a.brocade_control_plane', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.control_plane.ipv6.subnet_rate_limit', 'pybind.slxos.v17r_2_00.brocade_control_plane', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.control_plane.ipv6.subnet_rate_limit', 'pybind.slxos.v17s_1_02.brocade_control_plane', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def copy_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.copy', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.copy', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.copy', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.copy', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.copy', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17s_1_02.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17r_2_00.counts_state', u'bad_lsp_log')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_areamis_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17s_1_02.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17r_2_00.counts_state', u'bad_lsp_log')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_bad_lsp_log_get(self, bad_lsp_log=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bad_lsp_log: type_index
    :param bad_lsp_log: Keyword argument tuple.

    :type type_index: int
    :param type_index: **bad_lsp_log** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state.bad_lsp_log', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state.bad_lsp_log', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state.bad_lsp_log', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bad_lsp_log', 'keyval': 'type_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bad_lsp_log=bad_lsp_log)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bad_lsp_log=bad_lsp_log)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_bad_lsp_log_l1_count_get(self, bad_lsp_log=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bad_lsp_log: type_index
    :param bad_lsp_log: Keyword argument tuple.

    :type type_index: int
    :param type_index: **bad_lsp_log** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state.bad_lsp_log', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state.bad_lsp_log', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state.bad_lsp_log', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bad_lsp_log', 'keyval': 'type_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bad_lsp_log=bad_lsp_log)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bad_lsp_log=bad_lsp_log)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_bad_lsp_log_l2_count_get(self, bad_lsp_log=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bad_lsp_log: type_index
    :param bad_lsp_log: Keyword argument tuple.

    :type type_index: int
    :param type_index: **bad_lsp_log** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state.bad_lsp_log', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state.bad_lsp_log', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state.bad_lsp_log', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bad_lsp_log', 'keyval': 'type_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bad_lsp_log=bad_lsp_log)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bad_lsp_log=bad_lsp_log)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_bad_lsp_log_time_stamp_get(self, bad_lsp_log=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bad_lsp_log: type_index
    :param bad_lsp_log: Keyword argument tuple.

    :type type_index: int
    :param type_index: **bad_lsp_log** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state.bad_lsp_log', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state.bad_lsp_log', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state.bad_lsp_log', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bad_lsp_log', 'keyval': 'type_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bad_lsp_log=bad_lsp_log)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bad_lsp_log=bad_lsp_log)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_badidlen_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17s_1_02.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17r_2_00.counts_state', u'bad_lsp_log')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_circ_l1authfail_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17s_1_02.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17r_2_00.counts_state', u'bad_lsp_log')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_circ_l2authfail_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17s_1_02.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17r_2_00.counts_state', u'bad_lsp_log')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_csnp_l1authfail_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17s_1_02.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17r_2_00.counts_state', u'bad_lsp_log')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_csnp_l2authfail_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17s_1_02.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17r_2_00.counts_state', u'bad_lsp_log')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_l1dbol_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17s_1_02.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17r_2_00.counts_state', u'bad_lsp_log')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_l2dbol_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17s_1_02.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17r_2_00.counts_state', u'bad_lsp_log')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_maxareamis_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17s_1_02.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17r_2_00.counts_state', u'bad_lsp_log')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_ownpurge_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17s_1_02.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17r_2_00.counts_state', u'bad_lsp_log')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_psnp_l1authfail_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17s_1_02.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17r_2_00.counts_state', u'bad_lsp_log')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_psnp_l2authfail_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17s_1_02.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17r_2_00.counts_state', u'bad_lsp_log')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_seqerr_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17s_1_02.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17r_2_00.counts_state', u'bad_lsp_log')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def counts_state_seqskip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.counts_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.counts_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.counts_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17s_1_02.counts_state', u'bad_lsp_log'), ('pybind.slxos.v17r_2_00.counts_state', u'bad_lsp_log')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}, {'leafval': 'type_index, time_stamp, l1_count, l2_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_get(self, cpu_cfg_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_state: slot_id
    :param cpu_cfg_state: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_state** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_cfg_state', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state', u'cpu_cfg_group'), ('pybind.slxos.v17r_2_00.cpu_cfg_state', u'cpu_cfg_group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cpu_cfg_state', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'shaper_rate, burst_size, wfq_value, group_id'}, {'leafval': 'shaper_rate, burst_size, wfq_value, group_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_state=cpu_cfg_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_state=cpu_cfg_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_burst_size_get(self, cpu_cfg_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_state: slot_id
    :param cpu_cfg_state: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_state** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_cfg_state', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state', u'cpu_cfg_group'), ('pybind.slxos.v17r_2_00.cpu_cfg_state', u'cpu_cfg_group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cpu_cfg_state', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'shaper_rate, burst_size, wfq_value, group_id'}, {'leafval': 'shaper_rate, burst_size, wfq_value, group_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_state=cpu_cfg_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_state=cpu_cfg_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_group_get(self, cpu_cfg_state=None, cpu_cfg_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_state: slot_id
    :param cpu_cfg_state: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_state** tuple argument.

        * range restriction: ::

            ['-128..127']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state', 'cpu_cfg_state'), ('pybind.slxos.v17r_2_00.cpu_cfg_state', 'cpu_cfg_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state.cpu_cfg_group', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_cfg_state.cpu_cfg_group', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state.cpu_cfg_group', u'cpu_cfg_prio'), ('pybind.slxos.v17r_2_00.cpu_cfg_state.cpu_cfg_group', u'cpu_cfg_prio')]
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_group', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'shaper_rate, burst_size, wfq_value, prio_id'}, {'leafval': 'shaper_rate, burst_size, wfq_value, prio_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_state=cpu_cfg_state, cpu_cfg_group=cpu_cfg_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_state=cpu_cfg_state, cpu_cfg_group=cpu_cfg_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_group_burst_size_get(self, cpu_cfg_state=None, cpu_cfg_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_state: slot_id
    :param cpu_cfg_state: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_state** tuple argument.

        * range restriction: ::

            ['-128..127']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state', 'cpu_cfg_state'), ('pybind.slxos.v17r_2_00.cpu_cfg_state', 'cpu_cfg_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state.cpu_cfg_group', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_cfg_state.cpu_cfg_group', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state.cpu_cfg_group', u'cpu_cfg_prio'), ('pybind.slxos.v17r_2_00.cpu_cfg_state.cpu_cfg_group', u'cpu_cfg_prio')]
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_group', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'shaper_rate, burst_size, wfq_value, prio_id'}, {'leafval': 'shaper_rate, burst_size, wfq_value, prio_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_state=cpu_cfg_state, cpu_cfg_group=cpu_cfg_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_state=cpu_cfg_state, cpu_cfg_group=cpu_cfg_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_group_cpu_cfg_prio_get(self, cpu_cfg_state=None, cpu_cfg_group=None, cpu_cfg_prio=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_state: slot_id
    :param cpu_cfg_state: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_state** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['-128..127']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_prio: prio_id
    :param cpu_cfg_prio: Keyword argument tuple.

    :type prio_id: int
    :param prio_id: **cpu_cfg_prio** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state', 'cpu_cfg_state'), ('pybind.slxos.v17r_1_01a.cpu_cfg_state.cpu_cfg_group', u'cpu_cfg_group'), ('pybind.slxos.v17r_2_00.cpu_cfg_state', 'cpu_cfg_state'), ('pybind.slxos.v17r_2_00.cpu_cfg_state.cpu_cfg_group', u'cpu_cfg_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state.cpu_cfg_group.cpu_cfg_prio', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_cfg_state.cpu_cfg_group.cpu_cfg_prio', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_prio', 'keyval': 'prio_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_state=cpu_cfg_state, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_state=cpu_cfg_state, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_group_cpu_cfg_prio_burst_size_get(self, cpu_cfg_state=None, cpu_cfg_group=None, cpu_cfg_prio=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_state: slot_id
    :param cpu_cfg_state: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_state** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['-128..127']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_prio: prio_id
    :param cpu_cfg_prio: Keyword argument tuple.

    :type prio_id: int
    :param prio_id: **cpu_cfg_prio** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state', 'cpu_cfg_state'), ('pybind.slxos.v17r_1_01a.cpu_cfg_state.cpu_cfg_group', u'cpu_cfg_group'), ('pybind.slxos.v17r_2_00.cpu_cfg_state', 'cpu_cfg_state'), ('pybind.slxos.v17r_2_00.cpu_cfg_state.cpu_cfg_group', u'cpu_cfg_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state.cpu_cfg_group.cpu_cfg_prio', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_cfg_state.cpu_cfg_group.cpu_cfg_prio', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_prio', 'keyval': 'prio_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_state=cpu_cfg_state, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_state=cpu_cfg_state, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_group_cpu_cfg_prio_shaper_rate_get(self, cpu_cfg_state=None, cpu_cfg_group=None, cpu_cfg_prio=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_state: slot_id
    :param cpu_cfg_state: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_state** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['-128..127']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_prio: prio_id
    :param cpu_cfg_prio: Keyword argument tuple.

    :type prio_id: int
    :param prio_id: **cpu_cfg_prio** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state', 'cpu_cfg_state'), ('pybind.slxos.v17r_1_01a.cpu_cfg_state.cpu_cfg_group', u'cpu_cfg_group'), ('pybind.slxos.v17r_2_00.cpu_cfg_state', 'cpu_cfg_state'), ('pybind.slxos.v17r_2_00.cpu_cfg_state.cpu_cfg_group', u'cpu_cfg_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state.cpu_cfg_group.cpu_cfg_prio', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_cfg_state.cpu_cfg_group.cpu_cfg_prio', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_prio', 'keyval': 'prio_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_state=cpu_cfg_state, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_state=cpu_cfg_state, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_group_cpu_cfg_prio_wfq_value_get(self, cpu_cfg_state=None, cpu_cfg_group=None, cpu_cfg_prio=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_state: slot_id
    :param cpu_cfg_state: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_state** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['-128..127']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_prio: prio_id
    :param cpu_cfg_prio: Keyword argument tuple.

    :type prio_id: int
    :param prio_id: **cpu_cfg_prio** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state', 'cpu_cfg_state'), ('pybind.slxos.v17r_1_01a.cpu_cfg_state.cpu_cfg_group', u'cpu_cfg_group'), ('pybind.slxos.v17r_2_00.cpu_cfg_state', 'cpu_cfg_state'), ('pybind.slxos.v17r_2_00.cpu_cfg_state.cpu_cfg_group', u'cpu_cfg_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state.cpu_cfg_group.cpu_cfg_prio', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_cfg_state.cpu_cfg_group.cpu_cfg_prio', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_prio', 'keyval': 'prio_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_state=cpu_cfg_state, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_state=cpu_cfg_state, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_group_shaper_rate_get(self, cpu_cfg_state=None, cpu_cfg_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_state: slot_id
    :param cpu_cfg_state: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_state** tuple argument.

        * range restriction: ::

            ['-128..127']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state', 'cpu_cfg_state'), ('pybind.slxos.v17r_2_00.cpu_cfg_state', 'cpu_cfg_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state.cpu_cfg_group', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_cfg_state.cpu_cfg_group', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state.cpu_cfg_group', u'cpu_cfg_prio'), ('pybind.slxos.v17r_2_00.cpu_cfg_state.cpu_cfg_group', u'cpu_cfg_prio')]
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_group', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'shaper_rate, burst_size, wfq_value, prio_id'}, {'leafval': 'shaper_rate, burst_size, wfq_value, prio_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_state=cpu_cfg_state, cpu_cfg_group=cpu_cfg_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_state=cpu_cfg_state, cpu_cfg_group=cpu_cfg_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_group_wfq_value_get(self, cpu_cfg_state=None, cpu_cfg_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_state: slot_id
    :param cpu_cfg_state: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_state** tuple argument.

        * range restriction: ::

            ['-128..127']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state', 'cpu_cfg_state'), ('pybind.slxos.v17r_2_00.cpu_cfg_state', 'cpu_cfg_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state.cpu_cfg_group', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_cfg_state.cpu_cfg_group', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state.cpu_cfg_group', u'cpu_cfg_prio'), ('pybind.slxos.v17r_2_00.cpu_cfg_state.cpu_cfg_group', u'cpu_cfg_prio')]
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_group', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'shaper_rate, burst_size, wfq_value, prio_id'}, {'leafval': 'shaper_rate, burst_size, wfq_value, prio_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_state=cpu_cfg_state, cpu_cfg_group=cpu_cfg_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_state=cpu_cfg_state, cpu_cfg_group=cpu_cfg_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_get(self, cpu_cfg_slot=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_data'), ('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_slot', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'shaper_rate, burst_size, wfq_value'}, {'leafval': 'group_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_data_get(self, cpu_cfg_slot=None, cpu_cfg_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_data', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_data=cpu_cfg_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_data_burst_size_get(self, cpu_cfg_slot=None, cpu_cfg_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_data', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_data=cpu_cfg_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_data_wfq_value_get(self, cpu_cfg_slot=None, cpu_cfg_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_data', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_data=cpu_cfg_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_group_get(self, cpu_cfg_slot=None, cpu_cfg_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', u'cpu_cfg_prio'), ('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', u'cpu_cfg_data')]
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_group', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prio_id'}, {'leafval': 'shaper_rate, burst_size, wfq_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_group_cpu_cfg_data_get(self, cpu_cfg_slot=None, cpu_cfg_group=None, cpu_cfg_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot'), ('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', u'cpu_cfg_group')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_data', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_data=cpu_cfg_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_group_cpu_cfg_data_burst_size_get(self, cpu_cfg_slot=None, cpu_cfg_group=None, cpu_cfg_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot'), ('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', u'cpu_cfg_group')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_data', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_data=cpu_cfg_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_group_cpu_cfg_data_wfq_value_get(self, cpu_cfg_slot=None, cpu_cfg_group=None, cpu_cfg_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot'), ('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', u'cpu_cfg_group')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_data', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_data=cpu_cfg_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_group_cpu_cfg_prio_get(self, cpu_cfg_slot=None, cpu_cfg_group=None, cpu_cfg_prio=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_prio: prio_id
    :param cpu_cfg_prio: Keyword argument tuple.

    :type prio_id: int
    :param prio_id: **cpu_cfg_prio** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot'), ('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', u'cpu_cfg_group')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_prio', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_prio', u'cpu_cfg_data')]
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_prio', 'keyval': 'prio_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'shaper_rate, burst_size, wfq_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_group_cpu_cfg_prio_cpu_cfg_data_get(self, cpu_cfg_slot=None, cpu_cfg_group=None, cpu_cfg_prio=None, cpu_cfg_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_prio: prio_id
    :param cpu_cfg_prio: Keyword argument tuple.

    :type prio_id: int
    :param prio_id: **cpu_cfg_prio** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot'), ('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', u'cpu_cfg_group'), ('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_prio', u'cpu_cfg_prio')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_prio.cpu_cfg_data', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'prio_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio, cpu_cfg_data=cpu_cfg_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_group_cpu_cfg_prio_cpu_cfg_data_burst_size_get(self, cpu_cfg_slot=None, cpu_cfg_group=None, cpu_cfg_prio=None, cpu_cfg_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_prio: prio_id
    :param cpu_cfg_prio: Keyword argument tuple.

    :type prio_id: int
    :param prio_id: **cpu_cfg_prio** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot'), ('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', u'cpu_cfg_group'), ('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_prio', u'cpu_cfg_prio')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_prio.cpu_cfg_data', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'prio_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio, cpu_cfg_data=cpu_cfg_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_cpu_cfg_slot_cpu_cfg_group_cpu_cfg_prio_cpu_cfg_data_wfq_value_get(self, cpu_cfg_slot=None, cpu_cfg_group=None, cpu_cfg_prio=None, cpu_cfg_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_cfg_slot: slot_id
    :param cpu_cfg_slot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_slot** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_group: group_id
    :param cpu_cfg_group: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_cfg_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type cpu_cfg_prio: prio_id
    :param cpu_cfg_prio: Keyword argument tuple.

    :type prio_id: int
    :param prio_id: **cpu_cfg_prio** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_data: shaper_rate
    :param cpu_cfg_data: Keyword argument tuple.

    :type shaper_rate: long
    :param shaper_rate: **cpu_cfg_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot', u'cpu_cfg_slot'), ('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group', u'cpu_cfg_group'), ('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_prio', u'cpu_cfg_prio')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_cfg_state.cpu_cfg_slot.cpu_cfg_group.cpu_cfg_prio.cpu_cfg_data', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'prio_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_cfg_data', 'keyval': 'shaper_rate', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio, cpu_cfg_data=cpu_cfg_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_slot=cpu_cfg_slot, cpu_cfg_group=cpu_cfg_group, cpu_cfg_prio=cpu_cfg_prio, cpu_cfg_data=cpu_cfg_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_shaper_rate_get(self, cpu_cfg_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_state: slot_id
    :param cpu_cfg_state: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_state** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_cfg_state', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state', u'cpu_cfg_group'), ('pybind.slxos.v17r_2_00.cpu_cfg_state', u'cpu_cfg_group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cpu_cfg_state', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'shaper_rate, burst_size, wfq_value, group_id'}, {'leafval': 'shaper_rate, burst_size, wfq_value, group_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_state=cpu_cfg_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_state=cpu_cfg_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_cfg_state_wfq_value_get(self, cpu_cfg_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_cfg_state: slot_id
    :param cpu_cfg_state: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **cpu_cfg_state** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_cfg_state', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_cfg_state', u'cpu_cfg_group'), ('pybind.slxos.v17r_2_00.cpu_cfg_state', u'cpu_cfg_group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cpu_cfg_state', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'shaper_rate, burst_size, wfq_value, group_id'}, {'leafval': 'shaper_rate, burst_size, wfq_value, group_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_cfg_state=cpu_cfg_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_cfg_state=cpu_cfg_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_info_state_get(self, cpu_info_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_info_state: group_id
    :param cpu_info_state: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_info_state** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_info_state', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_info_state', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cpu_info_state', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_info_state=cpu_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_info_state=cpu_info_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_info_state_cpu_info_egid_get(self, cpu_info_egid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cpu_info_egid: group_id
    :param cpu_info_egid: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_info_egid** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_info_state.cpu_info_egid', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_info_egid', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_info_egid=cpu_info_egid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_info_egid=cpu_info_egid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_info_state_cpu_info_egid_description_get(self, cpu_info_egid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cpu_info_egid: group_id
    :param cpu_info_egid: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_info_egid** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_info_state.cpu_info_egid', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_info_egid', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_info_egid=cpu_info_egid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_info_egid=cpu_info_egid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_info_state_cpu_info_egid_egid_get(self, cpu_info_egid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cpu_info_egid: group_id
    :param cpu_info_egid: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_info_egid** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_info_state.cpu_info_egid', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_info_egid', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_info_egid=cpu_info_egid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_info_egid=cpu_info_egid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_info_state_cpu_info_egid_name_get(self, cpu_info_egid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cpu_info_egid: group_id
    :param cpu_info_egid: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_info_egid** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_info_state.cpu_info_egid', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_info_egid', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_info_egid=cpu_info_egid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_info_egid=cpu_info_egid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_info_state_description_get(self, cpu_info_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_info_state: group_id
    :param cpu_info_state: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_info_state** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_info_state', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_info_state', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cpu_info_state', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_info_state=cpu_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_info_state=cpu_info_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_info_state_egid_get(self, cpu_info_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_info_state: group_id
    :param cpu_info_state: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_info_state** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_info_state', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_info_state', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cpu_info_state', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_info_state=cpu_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_info_state=cpu_info_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_info_state_name_get(self, cpu_info_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_info_state: group_id
    :param cpu_info_state: Keyword argument tuple.

    :type group_id: int
    :param group_id: **cpu_info_state** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_info_state', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_info_state', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cpu_info_state', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_info_state=cpu_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_info_state=cpu_info_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.cpu_interface_state', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state', u'stats'), ('pybind.slxos.v17s_1_02.cpu_interface_state', u'gos_stats'), ('pybind.slxos.v17s_1_02.cpu_interface_state', u'host_stats'), ('pybind.slxos.v17r_2_00.cpu_interface_state', u'stats')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cpu_interface_state', 'keyval': 'ifname', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gos_link_status, gos_tx_pkts_cnt, gos_tx_bytes_cnt, gos_tx_errors_cnt, gos_tx_drop_cnt, gos_tx_overrun_error_cnt, gos_tx_carrier_error_cnt, gos_rx_pkts_cnt, gos_rx_bytes_cnt, gos_rx_errors_cnt, gos_rx_drop_cnt, gos_rx_overrun_error_cnt, gos_rx_frame_error_cnt, host_link_status, host_tx_pkts_cnt, host_tx_bytes_cnt, host_tx_errors_cnt, host_tx_drop_cnt, host_tx_overrun_error_cnt, host_tx_carrier_error_cnt, host_rx_pkts_cnt, host_rx_bytes_cnt, host_rx_errors_cnt, host_rx_drop_cnt, host_rx_overrun_error_cnt, host_rx_frame_error_cnt, host_tx_aborted_error_cnt, host_tx_fifo_error_cnt, host_tx_timeout_cnt, host_tx_flow_control_xon_cnt, host_tx_flow_control_xoff_cnt, host_tx_pkts_64bytes_cnt, host_tx_pkts_64_127bytes_cnt, host_tx_pkts_128_255bytes_cnt, host_tx_pkts_256_511bytes_cnt, host_tx_pkts_512_1023bytes_cnt, host_tx_pkts_1024bytes_max_cnt, host_tx_bcast_pkts_cnt, host_tx_mcast_pkts_cnt, host_rx_crc_error_cnt, host_rx_fifo_error_cnt, host_rx_missed_errors_cnt, host_rx_no_dma_resource_cnt, host_rx_flow_control_xon_cnt, host_rx_flow_control_xoff_cnt, host_rx_pkts_64bytes_cnt, host_rx_pkts_64_127bytes_cnt, host_rx_pkts_128_255bytes_cnt, host_rx_pkts_256_511bytes_cnt, host_rx_pkts_512_1023bytes_cnt, host_rx_pkts_1024bytes_max_cnt, host_rx_good_pkts_cnt, host_rx_bcast_pkts_cnt, host_rx_mcast_pkts_cnt'}, {'leafval': 'link_status, tx_pkts_cnt, tx_bytes_cnt, tx_errors_cnt, tx_drop_cnt, tx_overrun_error_cnt, tx_carrier_error_cnt, rx_pkts_cnt, rx_bytes_cnt, rx_errors_cnt, rx_drop_cnt, rx_overrun_error_cnt, rx_frame_error_cnt, tx_aborted_error_cnt, tx_fifo_error_cnt, tx_timeout_cnt, tx_flow_control_xon_cnt, tx_flow_control_xoff_cnt, tx_pkts_64bytes_cnt, tx_pkts_64_127bytes_cnt, tx_pkts_128_255bytes_cnt, tx_pkts_256_511bytes_cnt, tx_pkts_512_1023bytes_cnt, tx_pkts_1024bytes_max_cnt, tx_bcast_pkts_cnt, tx_mcast_pkts_cnt, rx_crc_error_cnt, rx_fifo_error_cnt, rx_missed_errors_cnt, rx_no_dma_resource_cnt, rx_flow_control_xon_cnt, rx_flow_control_xoff_cnt, rx_pkts_64bytes_cnt, rx_pkts_64_127bytes_cnt, rx_pkts_128_255bytes_cnt, rx_pkts_256_511bytes_cnt, rx_pkts_512_1023bytes_cnt, rx_pkts_1024bytes_max_cnt, rx_good_pkts_cnt, rx_bcast_pkts_cnt, rx_mcast_pkts_cnt'}, {'leafval': 'link_status, tx_pkts_cnt, tx_bytes_cnt, tx_errors_cnt, tx_drop_cnt, tx_overrun_error_cnt, tx_carrier_error_cnt, rx_pkts_cnt, rx_bytes_cnt, rx_errors_cnt, rx_drop_cnt, rx_overrun_error_cnt, rx_frame_error_cnt, tx_aborted_error_cnt, tx_fifo_error_cnt, tx_timeout_cnt, tx_flow_control_xon_cnt, tx_flow_control_xoff_cnt, tx_pkts_64bytes_cnt, tx_pkts_64_127bytes_cnt, tx_pkts_128_255bytes_cnt, tx_pkts_256_511bytes_cnt, tx_pkts_512_1023bytes_cnt, tx_pkts_1024bytes_max_cnt, tx_bcast_pkts_cnt, tx_mcast_pkts_cnt, rx_crc_error_cnt, rx_fifo_error_cnt, rx_missed_errors_cnt, rx_no_dma_resource_cnt, rx_flow_control_xon_cnt, rx_flow_control_xoff_cnt, rx_pkts_64bytes_cnt, rx_pkts_64_127bytes_cnt, rx_pkts_128_255bytes_cnt, rx_pkts_256_511bytes_cnt, rx_pkts_512_1023bytes_cnt, rx_pkts_1024bytes_max_cnt, rx_good_pkts_cnt, rx_bcast_pkts_cnt, rx_mcast_pkts_cnt'}, {'leafval': 'gos_link_status, gos_tx_pkts_cnt, gos_tx_bytes_cnt, gos_tx_errors_cnt, gos_tx_drop_cnt, gos_tx_overrun_error_cnt, gos_tx_carrier_error_cnt, gos_rx_pkts_cnt, gos_rx_bytes_cnt, gos_rx_errors_cnt, gos_rx_drop_cnt, gos_rx_overrun_error_cnt, gos_rx_frame_error_cnt, host_link_status, host_tx_pkts_cnt, host_tx_bytes_cnt, host_tx_errors_cnt, host_tx_drop_cnt, host_tx_overrun_error_cnt, host_tx_carrier_error_cnt, host_rx_pkts_cnt, host_rx_bytes_cnt, host_rx_errors_cnt, host_rx_drop_cnt, host_rx_overrun_error_cnt, host_rx_frame_error_cnt, host_tx_aborted_error_cnt, host_tx_fifo_error_cnt, host_tx_timeout_cnt, host_tx_flow_control_xon_cnt, host_tx_flow_control_xoff_cnt, host_tx_pkts_64bytes_cnt, host_tx_pkts_64_127bytes_cnt, host_tx_pkts_128_255bytes_cnt, host_tx_pkts_256_511bytes_cnt, host_tx_pkts_512_1023bytes_cnt, host_tx_pkts_1024bytes_max_cnt, host_tx_bcast_pkts_cnt, host_tx_mcast_pkts_cnt, host_rx_crc_error_cnt, host_rx_fifo_error_cnt, host_rx_missed_errors_cnt, host_rx_no_dma_resource_cnt, host_rx_flow_control_xon_cnt, host_rx_flow_control_xoff_cnt, host_rx_pkts_64bytes_cnt, host_rx_pkts_64_127bytes_cnt, host_rx_pkts_128_255bytes_cnt, host_rx_pkts_256_511bytes_cnt, host_rx_pkts_512_1023bytes_cnt, host_rx_pkts_1024bytes_max_cnt, host_rx_good_pkts_cnt, host_rx_bcast_pkts_cnt, host_rx_mcast_pkts_cnt'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_link_status_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_bcast_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_crc_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_drop_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_errors_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_fifo_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_flow_control_xoff_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_flow_control_xon_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_frame_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_good_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_mcast_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_missed_errors_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_no_dma_resource_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_overrun_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_pkts_1024bytes_max_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_pkts_128_255bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_pkts_256_511bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_pkts_512_1023bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_pkts_64_127bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_pkts_64bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_rx_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_aborted_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_bcast_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_carrier_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_drop_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_errors_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_fifo_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_flow_control_xoff_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_flow_control_xon_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_mcast_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_overrun_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_pkts_1024bytes_max_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_pkts_128_255bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_pkts_256_511bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_pkts_512_1023bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_pkts_64_127bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_pkts_64bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_gos_stats_tx_timeout_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.gos_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_link_status_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_bcast_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_crc_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_drop_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_errors_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_fifo_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_flow_control_xoff_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_flow_control_xon_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_frame_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_good_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_mcast_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_missed_errors_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_no_dma_resource_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_overrun_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_pkts_1024bytes_max_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_pkts_128_255bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_pkts_256_511bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_pkts_512_1023bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_pkts_64_127bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_pkts_64bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_rx_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_aborted_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_bcast_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_carrier_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_drop_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_errors_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_fifo_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_flow_control_xoff_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_flow_control_xon_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_mcast_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_overrun_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_pkts_1024bytes_max_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_pkts_128_255bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_pkts_256_511bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_pkts_512_1023bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_pkts_64_127bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_pkts_64bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_host_stats_tx_timeout_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_interface_state.host_stats', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_gos_link_status_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_gos_rx_bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_gos_rx_drop_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_gos_rx_errors_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_gos_rx_frame_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_gos_rx_overrun_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_gos_rx_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_gos_tx_bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_gos_tx_carrier_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_gos_tx_drop_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_gos_tx_errors_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_gos_tx_overrun_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_gos_tx_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_link_status_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_bcast_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_crc_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_drop_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_errors_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_fifo_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_flow_control_xoff_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_flow_control_xon_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_frame_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_good_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_mcast_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_missed_errors_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_no_dma_resource_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_overrun_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_pkts_1024bytes_max_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_pkts_128_255bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_pkts_256_511bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_pkts_512_1023bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_pkts_64_127bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_pkts_64bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_rx_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_aborted_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_bcast_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_carrier_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_drop_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_errors_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_fifo_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_flow_control_xoff_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_flow_control_xon_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_mcast_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_overrun_error_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_pkts_1024bytes_max_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_pkts_128_255bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_pkts_256_511bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_pkts_512_1023bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_pkts_64_127bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_pkts_64bytes_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_pkts_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_interface_state_stats_host_tx_timeout_cnt_get(self, cpu_interface_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_interface_state: ifname
    :param cpu_interface_state: Keyword argument tuple.

    :type ifname: unicode
    :param ifname: **cpu_interface_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cpu_interface_state', 'cpu_interface_state'), ('pybind.slxos.v17r_1_01a.cpu_interface_state', 'cpu_interface_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_interface_state.stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_interface_state.stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ifname', 'extra_keyval': ''}, {'keyval': 'ifname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_interface_state=cpu_interface_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_interface_state=cpu_interface_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_queue_id_info_state_get(self, cpu_queue_id_info_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cpu_queue_id_info_state: queue_range
    :param cpu_queue_id_info_state: Keyword argument tuple.

    :type queue_range: unicode
    :param queue_range: **cpu_queue_id_info_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_queue_id_info_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cpu_queue_id_info_state', u'cpu_queue_id_details')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cpu_queue_id_info_state', 'keyval': 'queue_range', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'queue_id, default_fps, current_fps'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_queue_id_info_state=cpu_queue_id_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_queue_id_info_state=cpu_queue_id_info_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_queue_id_info_state_cpu_queue_id_details_get(self, cpu_queue_id_info_state=None, cpu_queue_id_details=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_queue_id_info_state: queue_range
    :param cpu_queue_id_info_state: Keyword argument tuple.

    :type queue_range: unicode
    :param queue_range: **cpu_queue_id_info_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type cpu_queue_id_details: queue_id
    :param cpu_queue_id_details: Keyword argument tuple.

    :type queue_id: int
    :param queue_id: **cpu_queue_id_details** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_queue_id_info_state', 'cpu_queue_id_info_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_queue_id_info_state.cpu_queue_id_details', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'queue_range', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_queue_id_details', 'keyval': 'queue_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_queue_id_info_state=cpu_queue_id_info_state, cpu_queue_id_details=cpu_queue_id_details)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_queue_id_info_state=cpu_queue_id_info_state, cpu_queue_id_details=cpu_queue_id_details)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_queue_id_info_state_cpu_queue_id_details_current_fps_get(self, cpu_queue_id_info_state=None, cpu_queue_id_details=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_queue_id_info_state: queue_range
    :param cpu_queue_id_info_state: Keyword argument tuple.

    :type queue_range: unicode
    :param queue_range: **cpu_queue_id_info_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type cpu_queue_id_details: queue_id
    :param cpu_queue_id_details: Keyword argument tuple.

    :type queue_id: int
    :param queue_id: **cpu_queue_id_details** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_queue_id_info_state', 'cpu_queue_id_info_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_queue_id_info_state.cpu_queue_id_details', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'queue_range', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_queue_id_details', 'keyval': 'queue_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_queue_id_info_state=cpu_queue_id_info_state, cpu_queue_id_details=cpu_queue_id_details)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_queue_id_info_state=cpu_queue_id_info_state, cpu_queue_id_details=cpu_queue_id_details)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_queue_id_info_state_cpu_queue_id_details_default_fps_get(self, cpu_queue_id_info_state=None, cpu_queue_id_details=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cpu_queue_id_info_state: queue_range
    :param cpu_queue_id_info_state: Keyword argument tuple.

    :type queue_range: unicode
    :param queue_range: **cpu_queue_id_info_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type cpu_queue_id_details: queue_id
    :param cpu_queue_id_details: Keyword argument tuple.

    :type queue_id: int
    :param queue_id: **cpu_queue_id_details** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.cpu_queue_id_info_state', 'cpu_queue_id_info_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_queue_id_info_state.cpu_queue_id_details', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'queue_range', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cpu_queue_id_details', 'keyval': 'queue_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_queue_id_info_state=cpu_queue_id_info_state, cpu_queue_id_details=cpu_queue_id_details)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_queue_id_info_state=cpu_queue_id_info_state, cpu_queue_id_details=cpu_queue_id_details)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_queue_id_info_state_credits_get(self, cpu_queue_id_info_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cpu_queue_id_info_state: queue_range
    :param cpu_queue_id_info_state: Keyword argument tuple.

    :type queue_range: unicode
    :param queue_range: **cpu_queue_id_info_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_queue_id_info_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cpu_queue_id_info_state', u'cpu_queue_id_details')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'cpu_queue_id_info_state', 'keyval': 'queue_range', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'queue_id, default_fps, current_fps'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_queue_id_info_state=cpu_queue_id_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_queue_id_info_state=cpu_queue_id_info_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_queue_info_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_queue_info_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cpu_queue_info_state', u'cpu_queue_info_details')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'queue_id, fps, priority, usage'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_queue_info_state_cpu_queue_info_details_get(self, cpu_queue_info_details=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cpu_queue_info_details: queue_id
    :param cpu_queue_info_details: Keyword argument tuple.

    :type queue_id: int
    :param queue_id: **cpu_queue_info_details** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_queue_info_state.cpu_queue_info_details', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_queue_info_details', 'keyval': 'queue_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_queue_info_details=cpu_queue_info_details)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_queue_info_details=cpu_queue_info_details)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_queue_info_state_cpu_queue_info_details_fps_get(self, cpu_queue_info_details=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cpu_queue_info_details: queue_id
    :param cpu_queue_info_details: Keyword argument tuple.

    :type queue_id: int
    :param queue_id: **cpu_queue_info_details** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_queue_info_state.cpu_queue_info_details', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_queue_info_details', 'keyval': 'queue_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_queue_info_details=cpu_queue_info_details)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_queue_info_details=cpu_queue_info_details)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_queue_info_state_cpu_queue_info_details_priority_get(self, cpu_queue_info_details=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cpu_queue_info_details: queue_id
    :param cpu_queue_info_details: Keyword argument tuple.

    :type queue_id: int
    :param queue_id: **cpu_queue_info_details** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_queue_info_state.cpu_queue_info_details', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_queue_info_details', 'keyval': 'queue_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_queue_info_details=cpu_queue_info_details)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_queue_info_details=cpu_queue_info_details)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_queue_info_state_cpu_queue_info_details_usage_get(self, cpu_queue_info_details=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cpu_queue_info_details: queue_id
    :param cpu_queue_info_details: Keyword argument tuple.

    :type queue_id: int
    :param queue_id: **cpu_queue_info_details** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_queue_info_state.cpu_queue_info_details', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_queue_info_details', 'keyval': 'queue_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_queue_info_details=cpu_queue_info_details)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_queue_info_details=cpu_queue_info_details)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_queue_info_state_credits_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.cpu_queue_info_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.cpu_queue_info_state', u'cpu_queue_info_details')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'queue_id, fps, priority, usage'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cpu_state', u'process_list'), ('pybind.slxos.v17r_2_00.cpu_state.process_list', u'cpu_process_list'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.all_partition', u'cpu_allpart_util'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.all_partition', u'cpu_allpart_load'), ('pybind.slxos.v17r_2_00.cpu_state', u'history'), ('pybind.slxos.v17r_2_00.cpu_state', u'summary'), ('pybind.slxos.v17r_2_00.cpu_state', u'top'), ('pybind.slxos.v17r_1_01a.cpu_state', u'top'), ('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_1_01a.cpu_state', u'summary'), ('pybind.slxos.v17r_1_01a.cpu_state.all_partition', u'cpu_allpart_util'), ('pybind.slxos.v17r_1_01a.cpu_state.process_list', u'cpu_process_list'), ('pybind.slxos.v17r_1_01a.cpu_state', u'history'), ('pybind.slxos.v17r_1_01a.cpu_state', u'process_list'), ('pybind.slxos.v17r_1_01a.cpu_state.all_partition', u'cpu_allpart_load')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'list_cpu_load_average_one_min, list_cpu_load_average_five_min, list_cpu_load_average_fifteen_min, list_cpu_util_current, list_cpu_util_current_user, list_cpu_util_current_kernel, list_cpu_util_current_iowait'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_blade_name, cpu_util_current, cpu_util_user, cpu_util_kernel, cpu_util_iowait'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_blade_name, cpu_load_average_1min, cpu_load_average_5min, cpu_load_average_15min'}, {'leafval': 'cpu_load_average_one_min, cpu_load_average_five_min, cpu_load_average_fifteen_min, cpu_util_current, cpu_util_current_user, cpu_util_current_kernel, cpu_util_current_iowait, cpu_util_1min, cpu_util_1min_user, cpu_util_1min_kernel, cpu_util_1min_iowait, cpu_util_5min, cpu_util_5min_user, cpu_util_5min_kernel, cpu_util_5min_iowait, cpu_util_15min, cpu_util_15min_user, cpu_util_15min_kernel, cpu_util_15min_iowait, cpu_util_1hour, cpu_util_1hour_user, cpu_util_1hour_kernel, cpu_util_1hour_iowait, cpu_util_5hour, cpu_util_5hour_user, cpu_util_5hour_kernel, cpu_util_5hour_iowait, cpu_util_24hour, cpu_util_24hour_user, cpu_util_24hour_kernel, cpu_util_24hour_iowait, cpu_util_72hour, cpu_util_72hour_user, cpu_util_72hour_kernel, cpu_util_72hour_iowait'}, {'leafval': 'summary_cpu_load_average_one_min, summary_cpu_load_average_five_min, summary_cpu_load_average_fifteen_min, summary_cpu_util_current, summary_cpu_util_current_user, summary_cpu_util_current_kernel, summary_cpu_util_current_iowait'}, {'leafval': 'cpu_curr_time, cpu_system_uptime, cpu_no_of_users, cpu_load_average_one_min, cpu_load_average_five_min, cpu_load_average_fifteen_min, cpu_total_task, cpu_running_task, cpu_sleeping_task, cpu_stopped_task, cpu_zombie_task, cpu_util_user, cpu_util_kernel, cpu_util_nice, cpu_util_idle, cpu_util_iowait, cpu_util_hi, cpu_util_si, cpu_util_st, cpu_total_mem, cpu_used_mem, cpu_free_mem, cpu_buffer_mem, cpu_total_mem_swap, cpu_used_mem_swap, cpu_free_mem_swap, cpu_cache_mem_swap'}, {'leafval': 'cpu_curr_time, cpu_system_uptime, cpu_no_of_users, cpu_load_average_one_min, cpu_load_average_five_min, cpu_load_average_fifteen_min, cpu_total_task, cpu_running_task, cpu_sleeping_task, cpu_stopped_task, cpu_zombie_task, cpu_util_user, cpu_util_kernel, cpu_util_nice, cpu_util_idle, cpu_util_iowait, cpu_util_hi, cpu_util_si, cpu_util_st, cpu_total_mem, cpu_used_mem, cpu_free_mem, cpu_buffer_mem, cpu_total_mem_swap, cpu_used_mem_swap, cpu_free_mem_swap, cpu_cache_mem_swap'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'summary_cpu_load_average_one_min, summary_cpu_load_average_five_min, summary_cpu_load_average_fifteen_min, summary_cpu_util_current, summary_cpu_util_current_user, summary_cpu_util_current_kernel, summary_cpu_util_current_iowait'}, {'leafval': 'cpu_blade_name, cpu_util_current, cpu_util_user, cpu_util_kernel, cpu_util_iowait'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}, {'leafval': 'cpu_load_average_one_min, cpu_load_average_five_min, cpu_load_average_fifteen_min, cpu_util_current, cpu_util_current_user, cpu_util_current_kernel, cpu_util_current_iowait, cpu_util_1min, cpu_util_1min_user, cpu_util_1min_kernel, cpu_util_1min_iowait, cpu_util_5min, cpu_util_5min_user, cpu_util_5min_kernel, cpu_util_5min_iowait, cpu_util_15min, cpu_util_15min_user, cpu_util_15min_kernel, cpu_util_15min_iowait, cpu_util_1hour, cpu_util_1hour_user, cpu_util_1hour_kernel, cpu_util_1hour_iowait, cpu_util_5hour, cpu_util_5hour_user, cpu_util_5hour_kernel, cpu_util_5hour_iowait, cpu_util_24hour, cpu_util_24hour_user, cpu_util_24hour_kernel, cpu_util_24hour_iowait, cpu_util_72hour, cpu_util_72hour_user, cpu_util_72hour_kernel, cpu_util_72hour_iowait'}, {'leafval': 'list_cpu_load_average_one_min, list_cpu_load_average_five_min, list_cpu_load_average_fifteen_min, list_cpu_util_current, list_cpu_util_current_user, list_cpu_util_current_kernel, list_cpu_util_current_iowait'}, {'leafval': 'cpu_blade_name, cpu_load_average_1min, cpu_load_average_5min, cpu_load_average_15min'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_all_partition_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.all_partition', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.all_partition', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.all_partition', u'cpu_allpart_util'), ('pybind.slxos.v17r_1_01a.cpu_state.all_partition', u'cpu_allpart_load'), ('pybind.slxos.v17r_2_00.cpu_state.all_partition', u'cpu_allpart_util'), ('pybind.slxos.v17r_2_00.cpu_state.all_partition', u'cpu_allpart_load')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_blade_name, cpu_util_current, cpu_util_user, cpu_util_kernel, cpu_util_iowait'}, {'leafval': 'cpu_blade_name, cpu_load_average_1min, cpu_load_average_5min, cpu_load_average_15min'}, {'leafval': 'cpu_blade_name, cpu_util_current, cpu_util_user, cpu_util_kernel, cpu_util_iowait'}, {'leafval': 'cpu_blade_name, cpu_load_average_1min, cpu_load_average_5min, cpu_load_average_15min'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_all_partition_cpu_allpart_load_get(self, cpu_allpart_load=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_allpart_load: cpu_blade_name
    :param cpu_allpart_load: Keyword argument tuple.

    :type cpu_blade_name: unicode
    :param cpu_blade_name: **cpu_allpart_load** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.all_partition.cpu_allpart_load', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.all_partition.cpu_allpart_load', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_allpart_load', 'keyval': 'cpu_blade_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_allpart_load=cpu_allpart_load)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_allpart_load=cpu_allpart_load)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_all_partition_cpu_allpart_load_cpu_load_average_15min_get(self, cpu_allpart_load=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_allpart_load: cpu_blade_name
    :param cpu_allpart_load: Keyword argument tuple.

    :type cpu_blade_name: unicode
    :param cpu_blade_name: **cpu_allpart_load** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.all_partition.cpu_allpart_load', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.all_partition.cpu_allpart_load', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_allpart_load', 'keyval': 'cpu_blade_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_allpart_load=cpu_allpart_load)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_allpart_load=cpu_allpart_load)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_all_partition_cpu_allpart_load_cpu_load_average_1min_get(self, cpu_allpart_load=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_allpart_load: cpu_blade_name
    :param cpu_allpart_load: Keyword argument tuple.

    :type cpu_blade_name: unicode
    :param cpu_blade_name: **cpu_allpart_load** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.all_partition.cpu_allpart_load', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.all_partition.cpu_allpart_load', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_allpart_load', 'keyval': 'cpu_blade_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_allpart_load=cpu_allpart_load)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_allpart_load=cpu_allpart_load)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_all_partition_cpu_allpart_load_cpu_load_average_5min_get(self, cpu_allpart_load=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_allpart_load: cpu_blade_name
    :param cpu_allpart_load: Keyword argument tuple.

    :type cpu_blade_name: unicode
    :param cpu_blade_name: **cpu_allpart_load** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.all_partition.cpu_allpart_load', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.all_partition.cpu_allpart_load', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_allpart_load', 'keyval': 'cpu_blade_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_allpart_load=cpu_allpart_load)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_allpart_load=cpu_allpart_load)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_all_partition_cpu_allpart_util_get(self, cpu_allpart_util=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_allpart_util: cpu_blade_name
    :param cpu_allpart_util: Keyword argument tuple.

    :type cpu_blade_name: unicode
    :param cpu_blade_name: **cpu_allpart_util** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.all_partition.cpu_allpart_util', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.all_partition.cpu_allpart_util', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_allpart_util', 'keyval': 'cpu_blade_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_allpart_util=cpu_allpart_util)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_allpart_util=cpu_allpart_util)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_all_partition_cpu_allpart_util_cpu_util_current_get(self, cpu_allpart_util=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_allpart_util: cpu_blade_name
    :param cpu_allpart_util: Keyword argument tuple.

    :type cpu_blade_name: unicode
    :param cpu_blade_name: **cpu_allpart_util** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.all_partition.cpu_allpart_util', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.all_partition.cpu_allpart_util', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_allpart_util', 'keyval': 'cpu_blade_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_allpart_util=cpu_allpart_util)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_allpart_util=cpu_allpart_util)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_all_partition_cpu_allpart_util_cpu_util_iowait_get(self, cpu_allpart_util=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_allpart_util: cpu_blade_name
    :param cpu_allpart_util: Keyword argument tuple.

    :type cpu_blade_name: unicode
    :param cpu_blade_name: **cpu_allpart_util** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.all_partition.cpu_allpart_util', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.all_partition.cpu_allpart_util', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_allpart_util', 'keyval': 'cpu_blade_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_allpart_util=cpu_allpart_util)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_allpart_util=cpu_allpart_util)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_all_partition_cpu_allpart_util_cpu_util_kernel_get(self, cpu_allpart_util=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_allpart_util: cpu_blade_name
    :param cpu_allpart_util: Keyword argument tuple.

    :type cpu_blade_name: unicode
    :param cpu_blade_name: **cpu_allpart_util** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.all_partition.cpu_allpart_util', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.all_partition.cpu_allpart_util', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_allpart_util', 'keyval': 'cpu_blade_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_allpart_util=cpu_allpart_util)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_allpart_util=cpu_allpart_util)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_all_partition_cpu_allpart_util_cpu_util_user_get(self, cpu_allpart_util=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_allpart_util: cpu_blade_name
    :param cpu_allpart_util: Keyword argument tuple.

    :type cpu_blade_name: unicode
    :param cpu_blade_name: **cpu_allpart_util** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.all_partition.cpu_allpart_util', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.all_partition.cpu_allpart_util', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_allpart_util', 'keyval': 'cpu_blade_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_allpart_util=cpu_allpart_util)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_allpart_util=cpu_allpart_util)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_load_average_fifteen_min_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_load_average_five_min_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_load_average_one_min_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_15min_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_15min_iowait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_15min_kernel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_15min_user_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_1hour_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_1hour_iowait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_1hour_kernel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_1hour_user_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_1min_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_1min_iowait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_1min_kernel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_1min_user_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_24hour_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_24hour_iowait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_24hour_kernel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_24hour_user_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_5hour_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_5hour_iowait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_5hour_kernel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_5hour_user_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_5min_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_5min_iowait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_5min_kernel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_5min_user_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_72hour_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_72hour_iowait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_72hour_kernel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_72hour_user_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_current_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_current_iowait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_current_kernel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_current_user_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.history', u'cpu_util_process_history'), ('pybind.slxos.v17r_2_00.cpu_state.history', u'cpu_util_process_history')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_util_current, cpu_util_1m, cpu_util_5m, cpu_util_15m, cpu_util_1h, cpu_util_5h, cpu_util_24h, cpu_util_72h'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_process_history_get(self, cpu_util_process_history=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_util_process_history: cpu_process_id
    :param cpu_util_process_history: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_util_process_history** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_util_process_history', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_util_process_history=cpu_util_process_history)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_util_process_history=cpu_util_process_history)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_process_history_cpu_process_name_get(self, cpu_util_process_history=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_util_process_history: cpu_process_id
    :param cpu_util_process_history: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_util_process_history** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_util_process_history', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_util_process_history=cpu_util_process_history)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_util_process_history=cpu_util_process_history)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_process_history_cpu_util_15m_get(self, cpu_util_process_history=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_util_process_history: cpu_process_id
    :param cpu_util_process_history: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_util_process_history** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_util_process_history', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_util_process_history=cpu_util_process_history)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_util_process_history=cpu_util_process_history)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_process_history_cpu_util_1h_get(self, cpu_util_process_history=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_util_process_history: cpu_process_id
    :param cpu_util_process_history: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_util_process_history** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_util_process_history', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_util_process_history=cpu_util_process_history)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_util_process_history=cpu_util_process_history)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_process_history_cpu_util_1m_get(self, cpu_util_process_history=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_util_process_history: cpu_process_id
    :param cpu_util_process_history: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_util_process_history** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_util_process_history', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_util_process_history=cpu_util_process_history)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_util_process_history=cpu_util_process_history)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_process_history_cpu_util_24h_get(self, cpu_util_process_history=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_util_process_history: cpu_process_id
    :param cpu_util_process_history: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_util_process_history** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_util_process_history', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_util_process_history=cpu_util_process_history)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_util_process_history=cpu_util_process_history)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_process_history_cpu_util_5h_get(self, cpu_util_process_history=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_util_process_history: cpu_process_id
    :param cpu_util_process_history: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_util_process_history** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_util_process_history', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_util_process_history=cpu_util_process_history)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_util_process_history=cpu_util_process_history)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_process_history_cpu_util_5m_get(self, cpu_util_process_history=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_util_process_history: cpu_process_id
    :param cpu_util_process_history: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_util_process_history** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_util_process_history', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_util_process_history=cpu_util_process_history)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_util_process_history=cpu_util_process_history)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_process_history_cpu_util_72h_get(self, cpu_util_process_history=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_util_process_history: cpu_process_id
    :param cpu_util_process_history: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_util_process_history** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_util_process_history', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_util_process_history=cpu_util_process_history)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_util_process_history=cpu_util_process_history)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_history_cpu_util_process_history_cpu_util_current_get(self, cpu_util_process_history=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_util_process_history: cpu_process_id
    :param cpu_util_process_history: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_util_process_history** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.history.cpu_util_process_history', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_util_process_history', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_util_process_history=cpu_util_process_history)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_util_process_history=cpu_util_process_history)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_process_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.process_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.process_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cpu_state.process_list', u'cpu_process_list'), ('pybind.slxos.v17r_1_01a.cpu_state.process_list', u'cpu_process_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_process_list_cpu_process_list_get(self, cpu_process_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_process_list: cpu_process_id
    :param cpu_process_list: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_process_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.process_list.cpu_process_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.process_list.cpu_process_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_process_list', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_process_list=cpu_process_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_process_list=cpu_process_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_process_list_cpu_process_list_cpu_process_name_get(self, cpu_process_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_process_list: cpu_process_id
    :param cpu_process_list: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_process_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.process_list.cpu_process_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.process_list.cpu_process_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_process_list', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_process_list=cpu_process_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_process_list=cpu_process_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_process_list_cpu_process_list_cpu_process_start_time_get(self, cpu_process_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_process_list: cpu_process_id
    :param cpu_process_list: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_process_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.process_list.cpu_process_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.process_list.cpu_process_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_process_list', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_process_list=cpu_process_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_process_list=cpu_process_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_process_list_cpu_process_list_cpu_process_state_get(self, cpu_process_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_process_list: cpu_process_id
    :param cpu_process_list: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_process_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.process_list.cpu_process_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.process_list.cpu_process_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_process_list', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_process_list=cpu_process_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_process_list=cpu_process_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_process_list_cpu_process_list_cpu_process_util_get(self, cpu_process_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_process_list: cpu_process_id
    :param cpu_process_list: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_process_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.process_list.cpu_process_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.process_list.cpu_process_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_process_list', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_process_list=cpu_process_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_process_list=cpu_process_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_process_list_list_cpu_load_average_fifteen_min_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.process_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.process_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cpu_state.process_list', u'cpu_process_list'), ('pybind.slxos.v17r_1_01a.cpu_state.process_list', u'cpu_process_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_process_list_list_cpu_load_average_five_min_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.process_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.process_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cpu_state.process_list', u'cpu_process_list'), ('pybind.slxos.v17r_1_01a.cpu_state.process_list', u'cpu_process_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_process_list_list_cpu_load_average_one_min_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.process_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.process_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cpu_state.process_list', u'cpu_process_list'), ('pybind.slxos.v17r_1_01a.cpu_state.process_list', u'cpu_process_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_process_list_list_cpu_util_current_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.process_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.process_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cpu_state.process_list', u'cpu_process_list'), ('pybind.slxos.v17r_1_01a.cpu_state.process_list', u'cpu_process_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_process_list_list_cpu_util_current_iowait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.process_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.process_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cpu_state.process_list', u'cpu_process_list'), ('pybind.slxos.v17r_1_01a.cpu_state.process_list', u'cpu_process_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_process_list_list_cpu_util_current_kernel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.process_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.process_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cpu_state.process_list', u'cpu_process_list'), ('pybind.slxos.v17r_1_01a.cpu_state.process_list', u'cpu_process_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_process_list_list_cpu_util_current_user_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.process_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.process_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cpu_state.process_list', u'cpu_process_list'), ('pybind.slxos.v17r_1_01a.cpu_state.process_list', u'cpu_process_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}, {'leafval': 'cpu_process_id, cpu_process_name, cpu_process_util, cpu_process_state, cpu_process_start_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_summary_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.summary', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.summary', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_summary_summary_cpu_load_average_fifteen_min_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.summary', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.summary', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_summary_summary_cpu_load_average_five_min_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.summary', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.summary', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_summary_summary_cpu_load_average_one_min_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.summary', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.summary', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_summary_summary_cpu_util_current_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.summary', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.summary', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_summary_summary_cpu_util_current_iowait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.summary', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.summary', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_summary_summary_cpu_util_current_kernel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.summary', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.summary', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_summary_summary_cpu_util_current_user_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.summary', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.summary', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_buffer_mem_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_cache_mem_swap_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_curr_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_free_mem_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_free_mem_swap_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_load_average_fifteen_min_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_load_average_five_min_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_load_average_one_min_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_no_of_users_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_running_task_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_sleeping_task_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_stopped_task_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_system_uptime_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_top_process_information_get(self, cpu_top_process_information=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_top_process_information: cpu_process_id
    :param cpu_top_process_information: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_top_process_information** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_top_process_information', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_top_process_information=cpu_top_process_information)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_top_process_information=cpu_top_process_information)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_top_process_information_cpu_process_cmd_get(self, cpu_top_process_information=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_top_process_information: cpu_process_id
    :param cpu_top_process_information: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_top_process_information** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_top_process_information', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_top_process_information=cpu_top_process_information)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_top_process_information=cpu_top_process_information)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_top_process_information_cpu_process_cpuutil_get(self, cpu_top_process_information=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_top_process_information: cpu_process_id
    :param cpu_top_process_information: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_top_process_information** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_top_process_information', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_top_process_information=cpu_top_process_information)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_top_process_information=cpu_top_process_information)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_top_process_information_cpu_process_memutil_get(self, cpu_top_process_information=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_top_process_information: cpu_process_id
    :param cpu_top_process_information: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_top_process_information** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_top_process_information', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_top_process_information=cpu_top_process_information)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_top_process_information=cpu_top_process_information)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_top_process_information_cpu_process_ni_get(self, cpu_top_process_information=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_top_process_information: cpu_process_id
    :param cpu_top_process_information: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_top_process_information** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_top_process_information', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_top_process_information=cpu_top_process_information)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_top_process_information=cpu_top_process_information)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_top_process_information_cpu_process_priority_get(self, cpu_top_process_information=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_top_process_information: cpu_process_id
    :param cpu_top_process_information: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_top_process_information** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_top_process_information', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_top_process_information=cpu_top_process_information)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_top_process_information=cpu_top_process_information)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_top_process_information_cpu_process_resident_mem_get(self, cpu_top_process_information=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_top_process_information: cpu_process_id
    :param cpu_top_process_information: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_top_process_information** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_top_process_information', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_top_process_information=cpu_top_process_information)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_top_process_information=cpu_top_process_information)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_top_process_information_cpu_process_running_time_get(self, cpu_top_process_information=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_top_process_information: cpu_process_id
    :param cpu_top_process_information: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_top_process_information** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_top_process_information', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_top_process_information=cpu_top_process_information)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_top_process_information=cpu_top_process_information)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_top_process_information_cpu_process_shared_mem_get(self, cpu_top_process_information=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_top_process_information: cpu_process_id
    :param cpu_top_process_information: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_top_process_information** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_top_process_information', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_top_process_information=cpu_top_process_information)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_top_process_information=cpu_top_process_information)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_top_process_information_cpu_process_state_get(self, cpu_top_process_information=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_top_process_information: cpu_process_id
    :param cpu_top_process_information: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_top_process_information** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_top_process_information', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_top_process_information=cpu_top_process_information)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_top_process_information=cpu_top_process_information)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_top_process_information_cpu_process_user_get(self, cpu_top_process_information=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_top_process_information: cpu_process_id
    :param cpu_top_process_information: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_top_process_information** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_top_process_information', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_top_process_information=cpu_top_process_information)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_top_process_information=cpu_top_process_information)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_top_process_information_cpu_process_virtual_mem_get(self, cpu_top_process_information=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type cpu_top_process_information: cpu_process_id
    :param cpu_top_process_information: Keyword argument tuple.

    :type cpu_process_id: long
    :param cpu_process_id: **cpu_top_process_information** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top.cpu_top_process_information', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cpu_top_process_information', 'keyval': 'cpu_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cpu_top_process_information=cpu_top_process_information)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cpu_top_process_information=cpu_top_process_information)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_total_mem_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_total_mem_swap_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_total_task_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_used_mem_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_used_mem_swap_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_util_hi_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_util_idle_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_util_iowait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_util_kernel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_util_nice_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_util_si_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_util_st_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_util_user_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def cpu_state_top_cpu_zombie_task_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cpu_state.top', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.cpu_state.top', u'cpu_top_process_information'), ('pybind.slxos.v17r_2_00.cpu_state.top', u'cpu_top_process_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}, {'leafval': 'cpu_process_id, cpu_process_user, cpu_process_priority, cpu_process_ni, cpu_process_virtual_mem, cpu_process_resident_mem, cpu_process_shared_mem, cpu_process_state, cpu_process_cpuutil, cpu_process_memutil, cpu_process_running_time, cpu_process_cmd'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def crypto_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.crypto', 'pybind.nos.v6_0_2f.brocade_crypto_ext', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.crypto', 'pybind.nos.v7_2_0.brocade_crypto_ext', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.crypto', 'pybind.slxos.v17r_1_01a.brocade_crypto_ext', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.crypto', 'pybind.slxos.v17r_2_00.brocade_crypto_ext', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.crypto', 'pybind.slxos.v17s_1_02.brocade_crypto_ext', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.crypto_sa.crypto', u'ca'), ('pybind.slxos.v17r_1_01a.crypto_sa.crypto', u'key'), ('pybind.slxos.v17r_2_00.crypto_sa.crypto', u'key'), ('pybind.slxos.v17r_2_00.crypto_sa.crypto', u'ca'), ('pybind.slxos.v17s_1_02.crypto_sa.crypto', u'ca'), ('pybind.slxos.v17s_1_02.crypto_sa.crypto', u'key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trustpoint, keypair'}, {'leafval': 'label, type, modulus'}, {'leafval': 'label, type, modulus'}, {'leafval': 'trustpoint, keypair'}, {'leafval': 'trustpoint, keypair'}, {'leafval': 'label, type, modulus'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def crypto_ca_get(self, ca=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ca: trustpoint
    :param ca: Keyword argument tuple.

    :type trustpoint: unicode
    :param trustpoint: **ca** tuple argument:  Trustpoint name

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.crypto_sa.crypto.ca', 'pybind.slxos.v17r_1_01a.brocade_crypto', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.crypto_sa.crypto.ca', 'pybind.slxos.v17r_2_00.brocade_crypto', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.crypto_sa.crypto.ca', 'pybind.slxos.v17s_1_02.brocade_crypto', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ca', 'keyval': 'trustpoint', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ca=ca)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ca=ca)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def crypto_ca_keypair_get(self, ca=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ca: trustpoint
    :param ca: Keyword argument tuple.

    :type trustpoint: unicode
    :param trustpoint: **ca** tuple argument:  Trustpoint name

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.crypto_sa.crypto.ca', 'pybind.slxos.v17r_1_01a.brocade_crypto', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.crypto_sa.crypto.ca', 'pybind.slxos.v17r_2_00.brocade_crypto', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.crypto_sa.crypto.ca', 'pybind.slxos.v17s_1_02.brocade_crypto', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ca', 'keyval': 'trustpoint', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ca=ca)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ca=ca)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def crypto_crypto_sa_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.crypto_sa.crypto', 'pybind.slxos.v17r_1_01a.brocade_crypto', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.crypto_sa.crypto', 'pybind.slxos.v17r_2_00.brocade_crypto', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.crypto_sa.crypto', 'pybind.slxos.v17s_1_02.brocade_crypto', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.crypto_sa.crypto', u'key'), ('pybind.slxos.v17r_2_00.crypto_sa.crypto', u'ca'), ('pybind.slxos.v17s_1_02.crypto_sa.crypto', u'ca'), ('pybind.slxos.v17s_1_02.crypto_sa.crypto', u'key'), ('pybind.slxos.v17r_1_01a.crypto_sa.crypto', u'ca'), ('pybind.slxos.v17r_1_01a.crypto_sa.crypto', u'key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'label, type, modulus'}, {'leafval': 'trustpoint, keypair'}, {'leafval': 'trustpoint, keypair'}, {'leafval': 'label, type, modulus'}, {'leafval': 'trustpoint, keypair'}, {'leafval': 'label, type, modulus'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def crypto_key_get(self, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type key: label, type, modulus
    :param key: Keyword argument tuple.

    :type label: unicode
    :param label: **key** tuple argument:  Key Label

        * length restriction: ::

            ['1..64']

    :type type: unicode
    :param type: **key** tuple argument:  Key Type

        * enumeration restriction: ::

            ['dsa', 'rsa', 'ecdsa']

    :type modulus: long
    :param modulus: **key** tuple argument:  Key Size

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.crypto_sa.crypto.key', 'pybind.slxos.v17r_1_01a.brocade_crypto', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.crypto_sa.crypto.key', 'pybind.slxos.v17r_2_00.brocade_crypto', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.crypto_sa.crypto.key', 'pybind.slxos.v17s_1_02.brocade_crypto', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'key', 'keyval': 'label', 'extra_keyval': 'label, type, modulus'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def crypto_key_modulus_get(self, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type key: label
    :param key: Keyword argument tuple.

    :type label: unicode
    :param label: **key** tuple argument:  Key Label

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.crypto_sa.crypto.key', 'pybind.slxos.v17r_1_01a.brocade_crypto', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.crypto_sa.crypto.key', 'pybind.slxos.v17r_2_00.brocade_crypto', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.crypto_sa.crypto.key', 'pybind.slxos.v17s_1_02.brocade_crypto', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'key', 'keyval': 'label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def crypto_key_type_get(self, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type key: label
    :param key: Keyword argument tuple.

    :type label: unicode
    :param label: **key** tuple argument:  Key Label

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.crypto_sa.crypto.key', 'pybind.slxos.v17r_1_01a.brocade_crypto', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.crypto_sa.crypto.key', 'pybind.slxos.v17r_2_00.brocade_crypto', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.crypto_sa.crypto.key', 'pybind.slxos.v17s_1_02.brocade_crypto', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'key', 'keyval': 'label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def crypto_sa_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.crypto_sa', 'pybind.slxos.v17r_1_01a.brocade_crypto', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.crypto_sa', 'pybind.slxos.v17r_2_00.brocade_crypto', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.crypto_sa', 'pybind.slxos.v17s_1_02.brocade_crypto', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.crypto_sa.crypto', u'ca'), ('pybind.slxos.v17s_1_02.crypto_sa.crypto', u'key'), ('pybind.slxos.v17r_1_01a.crypto_sa.crypto', u'ca'), ('pybind.slxos.v17r_1_01a.crypto_sa.crypto', u'key'), ('pybind.slxos.v17r_2_00.crypto_sa.crypto', u'key'), ('pybind.slxos.v17r_2_00.crypto_sa.crypto', u'ca')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trustpoint, keypair'}, {'leafval': 'label, type, modulus'}, {'leafval': 'trustpoint, keypair'}, {'leafval': 'label, type, modulus'}, {'leafval': 'label, type, modulus'}, {'leafval': 'trustpoint, keypair'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def dai_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.dai_config', 'pybind.slxos.v17r_1_01a.brocade_dai', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.dai_config', 'pybind.slxos.v17r_2_00.brocade_dai', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.dai_config', 'pybind.slxos.v17s_1_02.brocade_dai', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.dai_config.arp', u'access_list'), ('pybind.slxos.v17r_2_00.dai_config.arp', u'access_list'), ('pybind.slxos.v17r_1_01a.dai_config.arp', u'access_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'acl_name'}, {'leafval': 'acl_name'}, {'leafval': 'acl_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def destination_console_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.destination_console', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.destination_console', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.destination_console', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.destination_console', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.destination_console', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def dhcp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.dhcp', 'pybind.nos.v6_0_2f.brocade_firmware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.dhcp', 'pybind.nos.v7_2_0.brocade_firmware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.dhcp', 'pybind.slxos.v17r_1_01a.brocade_firmware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.dhcp', 'pybind.slxos.v17r_2_00.brocade_firmware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.dhcp', 'pybind.slxos.v17s_1_02.brocade_firmware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.ip.dhcp.relay', u'information'), ('pybind.slxos.v17r_1_01a.routing_system.ip.dhcp.relay', u'information'), ('pybind.slxos.v17s_1_02.routing_system.ip.dhcp.relay', u'information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'option'}, {'leafval': 'option'}, {'leafval': 'option'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def diag_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.diag', 'pybind.nos.v6_0_2f.brocade_diagnostics', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.diag', 'pybind.nos.v7_2_0.brocade_diagnostics', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.diag', 'pybind.slxos.v17r_1_01a.brocade_diagnostics', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.diag', 'pybind.slxos.v17r_2_00.brocade_diagnostics', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.nos.v6_0_2f.diag', u'post'), ('pybind.nos.v6_0_2f.diag.post', u'rbridge_id'), ('pybind.nos.v7_2_0.diag', u'post'), ('pybind.nos.v7_2_0.diag.post', u'rbridge_id'), ('pybind.slxos.v17r_2_00.diag', u'post'), ('pybind.slxos.v17r_2_00.diag.post', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.diag.post', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.diag', u'post')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable'}, {'leafval': 'enable, rbridge_id'}, {'leafval': 'enable'}, {'leafval': 'enable, rbridge_id'}, {'leafval': 'enable'}, {'leafval': 'enable, rbridge_id'}, {'leafval': 'enable, rbridge_id'}, {'leafval': 'enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def diag_post_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.diag.post', 'pybind.nos.v6_0_2f.brocade_diagnostics', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.diag.post', 'pybind.nos.v7_2_0.brocade_diagnostics', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.diag.post', 'pybind.slxos.v17r_1_01a.brocade_diagnostics', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.diag.post', 'pybind.slxos.v17r_2_00.brocade_diagnostics', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.diag.post', u'rbridge_id'), ('pybind.nos.v6_0_2f.diag.post', u'rbridge_id'), ('pybind.nos.v7_2_0.diag.post', u'rbridge_id'), ('pybind.slxos.v17r_2_00.diag.post', u'rbridge_id')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, rbridge_id'}, {'leafval': 'enable, rbridge_id'}, {'leafval': 'enable, rbridge_id'}, {'leafval': 'enable, rbridge_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def diag_post_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.diag.post', 'pybind.nos.v6_0_2f.brocade_diagnostics', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.diag.post', 'pybind.nos.v7_2_0.brocade_diagnostics', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.diag.post', 'pybind.slxos.v17r_1_01a.brocade_diagnostics', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.diag.post', 'pybind.slxos.v17r_2_00.brocade_diagnostics', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.diag.post', u'rbridge_id'), ('pybind.nos.v6_0_2f.diag.post', u'rbridge_id'), ('pybind.nos.v7_2_0.diag.post', u'rbridge_id'), ('pybind.slxos.v17r_2_00.diag.post', u'rbridge_id')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, rbridge_id'}, {'leafval': 'enable, rbridge_id'}, {'leafval': 'enable, rbridge_id'}, {'leafval': 'enable, rbridge_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def diag_post_rbridge_id_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument:  Syntax: rbridgeId [rbridgeId]

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.diag.post.rbridge_id', 'pybind.nos.v6_0_2f.brocade_diagnostics', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.diag.post.rbridge_id', 'pybind.nos.v7_2_0.brocade_diagnostics', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.diag.post.rbridge_id', 'pybind.slxos.v17r_1_01a.brocade_diagnostics', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.diag.post.rbridge_id', 'pybind.slxos.v17r_2_00.brocade_diagnostics', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rbridge_id', 'keyval': 'rbridge_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def diag_post_rbridge_id_enable_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument:  Syntax: rbridgeId [rbridgeId]

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.diag.post.rbridge_id', 'pybind.nos.v6_0_2f.brocade_diagnostics', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.diag.post.rbridge_id', 'pybind.nos.v7_2_0.brocade_diagnostics', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.diag.post.rbridge_id', 'pybind.slxos.v17r_1_01a.brocade_diagnostics', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.diag.post.rbridge_id', 'pybind.slxos.v17r_2_00.brocade_diagnostics', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rbridge_id', 'keyval': 'rbridge_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def dot1x_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.dot1x', 'pybind.nos.v6_0_2f.brocade_dot1x', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.dot1x', 'pybind.nos.v7_2_0.brocade_dot1x', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.dot1x', 'pybind.slxos.v17r_1_01a.brocade_dot1x', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.dot1x', 'pybind.slxos.v17r_2_00.brocade_dot1x', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.dot1x', 'pybind.slxos.v17s_1_02.brocade_dot1x', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.dot1x', u'test'), ('pybind.slxos.v17s_1_02.dot1x', u'test'), ('pybind.slxos.v17r_2_00.dot1x', u'test'), ('pybind.slxos.v17r_1_01a.dot1x', u'test'), ('pybind.nos.v6_0_2f.dot1x', u'test')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'timeout'}, {'leafval': 'timeout'}, {'leafval': 'timeout'}, {'leafval': 'timeout'}, {'leafval': 'timeout'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def dot1x_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.dot1x', 'pybind.nos.v6_0_2f.brocade_dot1x', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.dot1x', 'pybind.nos.v7_2_0.brocade_dot1x', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.dot1x', 'pybind.slxos.v17r_1_01a.brocade_dot1x', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.dot1x', 'pybind.slxos.v17r_2_00.brocade_dot1x', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.dot1x', 'pybind.slxos.v17s_1_02.brocade_dot1x', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.dot1x', u'test'), ('pybind.slxos.v17s_1_02.dot1x', u'test'), ('pybind.slxos.v17r_2_00.dot1x', u'test'), ('pybind.slxos.v17r_1_01a.dot1x', u'test'), ('pybind.nos.v6_0_2f.dot1x', u'test')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'timeout'}, {'leafval': 'timeout'}, {'leafval': 'timeout'}, {'leafval': 'timeout'}, {'leafval': 'timeout'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def dot1x_test_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.dot1x.test', 'pybind.nos.v6_0_2f.brocade_dot1x', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.dot1x.test', 'pybind.nos.v7_2_0.brocade_dot1x', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.dot1x.test', 'pybind.slxos.v17r_1_01a.brocade_dot1x', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.dot1x.test', 'pybind.slxos.v17r_2_00.brocade_dot1x', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.dot1x.test', 'pybind.slxos.v17s_1_02.brocade_dot1x', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def dot1x_test_timeout_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.dot1x.test', 'pybind.nos.v6_0_2f.brocade_dot1x', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.dot1x.test', 'pybind.nos.v7_2_0.brocade_dot1x', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.dot1x.test', 'pybind.slxos.v17r_1_01a.brocade_dot1x', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.dot1x.test', 'pybind.slxos.v17r_2_00.brocade_dot1x', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.dot1x.test', 'pybind.slxos.v17s_1_02.brocade_dot1x', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def dpod_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.dpod', 'pybind.nos.v6_0_2f.brocade_license', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.dpod', 'pybind.nos.v7_2_0.brocade_license', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.dpod', 'pybind.slxos.v17r_1_01a.brocade_license', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.dpod', 'pybind.slxos.v17r_2_00.brocade_license', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.dpod', 'pybind.slxos.v17s_1_02.brocade_license', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.dpod', u'port_id'), ('pybind.nos.v6_0_2f.dpod', u'port_id'), ('pybind.slxos.v17s_1_02.dpod', u'port_id'), ('pybind.slxos.v17r_2_00.dpod', u'port_id'), ('pybind.nos.v7_2_0.dpod', u'port_id')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'port_id, operation'}, {'leafval': 'port_id, operation'}, {'leafval': 'port_id, operation'}, {'leafval': 'port_id, operation'}, {'leafval': 'port_id, operation'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def dpod_port_id_get(self, port_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_id: port_id
    :param port_id: Keyword argument tuple.

    :type port_id: unicode
    :param port_id: **port_id** tuple argument:  Syntax: [rbridge-id/slot/port]

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.dpod.port_id', 'pybind.nos.v6_0_2f.brocade_license', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.dpod.port_id', 'pybind.nos.v7_2_0.brocade_license', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.dpod.port_id', 'pybind.slxos.v17r_1_01a.brocade_license', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.dpod.port_id', 'pybind.slxos.v17r_2_00.brocade_license', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.dpod.port_id', 'pybind.slxos.v17s_1_02.brocade_license', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_id', 'keyval': 'port_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_id=port_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_id=port_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def dpod_port_id_operation_get(self, port_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_id: port_id
    :param port_id: Keyword argument tuple.

    :type port_id: unicode
    :param port_id: **port_id** tuple argument:  Syntax: [rbridge-id/slot/port]

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.dpod.port_id', 'pybind.nos.v6_0_2f.brocade_license', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.dpod.port_id', 'pybind.nos.v7_2_0.brocade_license', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.dpod.port_id', 'pybind.slxos.v17r_1_01a.brocade_license', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.dpod.port_id', 'pybind.slxos.v17r_2_00.brocade_license', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.dpod.port_id', 'pybind.slxos.v17s_1_02.brocade_license', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_id', 'keyval': 'port_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_id=port_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_id=port_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def dscp_exp_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.dscp_exp_state', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.dscp_exp_state', u'qos_mpls')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'map_type, map_name, enabled_slots'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def dscp_exp_state_qos_mpls_get(self, qos_mpls=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.dscp_exp_state.qos_mpls', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def dscp_exp_state_qos_mpls_enabled_slots_get(self, qos_mpls=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.dscp_exp_state.qos_mpls', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def dscp_exp_state_qos_mpls_map_type_get(self, qos_mpls=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.dscp_exp_state.qos_mpls', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.event_handler', 'pybind.nos.v6_0_2f.brocade_event_handler', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.event_handler', 'pybind.nos.v7_2_0.brocade_event_handler', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.event_handler', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.event_handler', u'event_handler_list'), ('pybind.nos.v7_2_0.event_handler', u'event_handler_list'), ('pybind.slxos.v17s_1_02.event_handler.activate', u'name'), ('pybind.slxos.v17s_1_02.event_handler', u'event_handler_list'), ('pybind.slxos.v17r_2_00.event_handler.activate', u'name'), ('pybind.slxos.v17r_2_00.event_handler', u'event_handler_list'), ('pybind.slxos.v17r_1_01a.event_handler.activate', u'name'), ('pybind.slxos.v17r_1_01a.event_handler', u'event_handler_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}, {'leafval': 'name, description'}, {'leafval': 'name, delay, iterations, interval, run_mode, trigger_mode, action_timeout'}, {'leafval': 'name, description'}, {'leafval': 'name, delay, iterations, interval, run_mode, trigger_mode, action_timeout'}, {'leafval': 'name, description'}, {'leafval': 'name, delay, iterations, interval, run_mode, trigger_mode, action_timeout'}, {'leafval': 'name, description'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_activate_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.event_handler.activate', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.activate', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.activate', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.event_handler.activate', u'name'), ('pybind.slxos.v17r_1_01a.event_handler.activate', u'name'), ('pybind.slxos.v17s_1_02.event_handler.activate', u'name')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, delay, iterations, interval, run_mode, trigger_mode, action_timeout'}, {'leafval': 'name, delay, iterations, interval, run_mode, trigger_mode, action_timeout'}, {'leafval': 'name, delay, iterations, interval, run_mode, trigger_mode, action_timeout'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_activate_name_get(self, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.event_handler.activate.name', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.activate.name', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.activate.name', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.event_handler.activate.name', u'trigger_function'), ('pybind.slxos.v17r_1_01a.event_handler.activate.name', u'trigger_function'), ('pybind.slxos.v17s_1_02.event_handler.activate.name', u'trigger_function')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_activate_name_action_timeout_get(self, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.event_handler.activate.name', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.activate.name', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.activate.name', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.event_handler.activate.name', u'trigger_function'), ('pybind.slxos.v17r_1_01a.event_handler.activate.name', u'trigger_function'), ('pybind.slxos.v17s_1_02.event_handler.activate.name', u'trigger_function')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_activate_name_delay_get(self, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.event_handler.activate.name', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.activate.name', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.activate.name', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.event_handler.activate.name', u'trigger_function'), ('pybind.slxos.v17r_1_01a.event_handler.activate.name', u'trigger_function'), ('pybind.slxos.v17s_1_02.event_handler.activate.name', u'trigger_function')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_activate_name_interval_get(self, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.event_handler.activate.name', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.activate.name', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.activate.name', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.event_handler.activate.name', u'trigger_function'), ('pybind.slxos.v17r_1_01a.event_handler.activate.name', u'trigger_function'), ('pybind.slxos.v17s_1_02.event_handler.activate.name', u'trigger_function')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_activate_name_iterations_get(self, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.event_handler.activate.name', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.activate.name', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.activate.name', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.event_handler.activate.name', u'trigger_function'), ('pybind.slxos.v17r_1_01a.event_handler.activate.name', u'trigger_function'), ('pybind.slxos.v17s_1_02.event_handler.activate.name', u'trigger_function')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_activate_name_run_mode_get(self, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.event_handler.activate.name', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.activate.name', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.activate.name', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.event_handler.activate.name', u'trigger_function'), ('pybind.slxos.v17r_1_01a.event_handler.activate.name', u'trigger_function'), ('pybind.slxos.v17s_1_02.event_handler.activate.name', u'trigger_function')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_activate_name_trigger_function_get(self, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.event_handler.activate.name', u'name'), ('pybind.slxos.v17r_1_01a.event_handler.activate.name', u'name'), ('pybind.slxos.v17r_2_00.event_handler.activate.name', u'name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.event_handler.activate.name.trigger_function', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.activate.name.trigger_function', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.activate.name.trigger_function', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'trigger_function, time_window'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_activate_name_trigger_function_time_window_get(self, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.event_handler.activate.name', u'name'), ('pybind.slxos.v17r_1_01a.event_handler.activate.name', u'name'), ('pybind.slxos.v17r_2_00.event_handler.activate.name', u'name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.event_handler.activate.name.trigger_function', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.activate.name.trigger_function', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.activate.name.trigger_function', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_activate_name_trigger_function_trigger_function_get(self, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.event_handler.activate.name', u'name'), ('pybind.slxos.v17r_1_01a.event_handler.activate.name', u'name'), ('pybind.slxos.v17r_2_00.event_handler.activate.name', u'name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.event_handler.activate.name.trigger_function', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.activate.name.trigger_function', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.activate.name.trigger_function', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_activate_name_trigger_mode_get(self, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.event_handler.activate.name', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.activate.name', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.activate.name', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.event_handler.activate.name', u'trigger_function'), ('pybind.slxos.v17r_1_01a.event_handler.activate.name', u'trigger_function'), ('pybind.slxos.v17s_1_02.event_handler.activate.name', u'trigger_function')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_event_handler_list_get(self, event_handler_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.event_handler.event_handler_list', 'pybind.nos.v6_0_2f.brocade_event_handler', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.event_handler.event_handler_list', 'pybind.nos.v7_2_0.brocade_event_handler', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.event_handler.event_handler_list', u'action'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list', u'trigger'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list', u'trigger'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list', u'action'), ('pybind.nos.v7_2_0.event_handler.event_handler_list', u'trigger'), ('pybind.nos.v7_2_0.event_handler.event_handler_list', u'action'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list', u'action'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list', u'trigger'), ('pybind.nos.v6_0_2f.event_handler.event_handler_list', u'action'), ('pybind.nos.v6_0_2f.event_handler.event_handler_list', u'trigger')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'event_handler_list', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'python_script'}, {'leafval': 'trigger_id, vcs'}, {'leafval': 'trigger_id, vcs'}, {'leafval': 'python_script'}, {'leafval': 'trigger_id, vcs'}, {'leafval': 'python_script'}, {'leafval': 'python_script'}, {'leafval': 'trigger_id, vcs'}, {'leafval': 'python_script'}, {'leafval': 'trigger_id, vcs, raslog'}]
    leafval_map = {"pybind.nos.v6_0_2f.event_handler.event_handler_list": {"name": "name"}, "pybind.slxos.v17r_2_00.event_handler.event_handler_list": {}, "pybind.nos.v7_2_0.event_handler.event_handler_list": {}, "pybind.slxos.v17s_1_02.event_handler.event_handler_list": {}, "pybind.slxos.v17r_1_01a.event_handler.event_handler_list": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_event_handler_list_action_get(self, event_handler_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v6_0_2f.event_handler.event_handler_list', u'event_handler_list')]
    bindings_list = [('pybind.nos.v6_0_2f.event_handler.event_handler_list.action', 'pybind.nos.v6_0_2f.brocade_event_handler', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.event_handler.event_handler_list.action', 'pybind.nos.v7_2_0.brocade_event_handler', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list.action', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list.action', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list.action', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.event_handler.event_handler_list.action': [u'python_script'], 'pybind.nos.v7_2_0.event_handler.event_handler_list.action': [u'python_script'], 'pybind.slxos.v17r_2_00.event_handler.event_handler_list.action': [u'python_script'], 'pybind.slxos.v17r_1_01a.event_handler.event_handler_list.action': [u'python_script'], 'pybind.nos.v6_0_2f.event_handler.event_handler_list.action': [u'python_script']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_event_handler_list_action_python_script_get(self, event_handler_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v6_0_2f.event_handler.event_handler_list', u'event_handler_list')]
    bindings_list = [('pybind.nos.v6_0_2f.event_handler.event_handler_list.action', 'pybind.nos.v6_0_2f.brocade_event_handler', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.event_handler.event_handler_list.action', 'pybind.nos.v7_2_0.brocade_event_handler', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list.action', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list.action', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list.action', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_event_handler_list_description_get(self, event_handler_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.event_handler.event_handler_list', 'pybind.nos.v7_2_0.brocade_event_handler', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.event_handler.event_handler_list', u'action'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list', u'trigger'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list', u'trigger'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list', u'action'), ('pybind.nos.v7_2_0.event_handler.event_handler_list', u'trigger'), ('pybind.nos.v7_2_0.event_handler.event_handler_list', u'action'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list', u'action'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list', u'trigger')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'event_handler_list', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'python_script'}, {'leafval': 'trigger_id, vcs'}, {'leafval': 'trigger_id, vcs'}, {'leafval': 'python_script'}, {'leafval': 'trigger_id, vcs'}, {'leafval': 'python_script'}, {'leafval': 'python_script'}, {'leafval': 'trigger_id, vcs'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_event_handler_list_trigger_get(self, event_handler_list=None, trigger=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Keyword Argument Tuple**:

    :type trigger: trigger_id, vcs, raslog
    :param trigger: Keyword argument tuple.

    :type trigger_id: long
    :param trigger_id: **trigger** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vcs: unicode
    :param vcs: **trigger** tuple argument:  VCS event type.

        * enumeration restriction: ::

            ['switch-bootup',
            'switch-ready-for-configuration']

    :type raslog: unicode
    :param raslog: **trigger** tuple argument:  RASlog Id.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v6_0_2f.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v7_2_0.event_handler.event_handler_list', u'event_handler_list')]
    bindings_list = [('pybind.nos.v6_0_2f.event_handler.event_handler_list.trigger', 'pybind.nos.v6_0_2f.brocade_event_handler', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.event_handler.event_handler_list.trigger', 'pybind.nos.v7_2_0.brocade_event_handler', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list.trigger', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list.trigger', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list.trigger', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.event_handler.event_handler_list.trigger', u'raslog'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list.trigger', u'raslog'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list.trigger', u'raslog'), ('pybind.nos.v7_2_0.event_handler.event_handler_list.trigger', u'raslog')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'trigger', 'keyval': 'trigger_id', 'extra_keyval': 'trigger_id, vcs'}
    composed_child_leafval_list = [{'leafval': 'raslog, pattern'}, {'leafval': 'raslog, pattern'}, {'leafval': 'raslog, pattern'}, {'leafval': 'raslog, pattern'}]
    leafval_map = {"pybind.nos.v6_0_2f.event_handler.event_handler_list.trigger": {"vcs": "vcs", "raslog": "raslog", "trigger_id": "trigger_id"}, "pybind.slxos.v17r_2_00.event_handler.event_handler_list.trigger": {}, "pybind.nos.v7_2_0.event_handler.event_handler_list.trigger": {}, "pybind.slxos.v17s_1_02.event_handler.event_handler_list.trigger": {}, "pybind.slxos.v17r_1_01a.event_handler.event_handler_list.trigger": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.event_handler.event_handler_list.trigger': [u'vcs', u'raslog'], 'pybind.slxos.v17s_1_02.event_handler.event_handler_list.trigger': [u'vcs', u'raslog'], 'pybind.nos.v7_2_0.event_handler.event_handler_list.trigger': [u'vcs', u'raslog'], 'pybind.slxos.v17r_1_01a.event_handler.event_handler_list.trigger': [u'vcs', u'raslog'], 'pybind.slxos.v17r_2_00.event_handler.event_handler_list.trigger': [u'vcs', u'raslog']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list, trigger=trigger)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list, trigger=trigger)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_event_handler_list_trigger_raslog_get(self, event_handler_list=None, trigger=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Keyword Argument Tuple**:

    :type trigger: trigger_id
    :param trigger: Keyword argument tuple.

    :type trigger_id: long
    :param trigger_id: **trigger** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.event_handler.event_handler_list', u'event_handler_list')]
    bindings_list = [('pybind.nos.v6_0_2f.event_handler.event_handler_list.trigger', 'pybind.nos.v6_0_2f.brocade_event_handler', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'trigger', 'keyval': 'trigger_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list, trigger=trigger)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list, trigger=trigger)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_event_handler_list_trigger_raslog_pattern_get(self, event_handler_list=None, trigger=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type trigger: trigger_id, vcs
    :param trigger: Keyword argument tuple.

    :type trigger_id: long
    :param trigger_id: **trigger** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vcs: unicode
    :param vcs: **trigger** tuple argument:  VCS event type.

        * enumeration restriction: ::

            ['switch-bootup',
            'switch-ready-for-configuration']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list.trigger', u'trigger'), ('pybind.nos.v7_2_0.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v7_2_0.event_handler.event_handler_list.trigger', u'trigger'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list.trigger', u'trigger'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list.trigger', u'trigger')]
    bindings_list = [('pybind.nos.v7_2_0.event_handler.event_handler_list.trigger.raslog', 'pybind.nos.v7_2_0.brocade_event_handler', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list.trigger.raslog', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list.trigger.raslog', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list.trigger.raslog', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'trigger_id', 'extra_keyval': 'trigger_id, vcs'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'trigger_id', 'extra_keyval': 'trigger_id, vcs'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'trigger_id', 'extra_keyval': 'trigger_id, vcs'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'trigger_id', 'extra_keyval': 'trigger_id, vcs'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list, trigger=trigger)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list, trigger=trigger)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_event_handler_list_trigger_raslog_raslog_get(self, event_handler_list=None, trigger=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type trigger: trigger_id, vcs
    :param trigger: Keyword argument tuple.

    :type trigger_id: long
    :param trigger_id: **trigger** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vcs: unicode
    :param vcs: **trigger** tuple argument:  VCS event type.

        * enumeration restriction: ::

            ['switch-bootup',
            'switch-ready-for-configuration']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list.trigger', u'trigger'), ('pybind.nos.v7_2_0.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v7_2_0.event_handler.event_handler_list.trigger', u'trigger'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list.trigger', u'trigger'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list.trigger', u'trigger')]
    bindings_list = [('pybind.nos.v7_2_0.event_handler.event_handler_list.trigger.raslog', 'pybind.nos.v7_2_0.brocade_event_handler', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list.trigger.raslog', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list.trigger.raslog', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list.trigger.raslog', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'trigger_id', 'extra_keyval': 'trigger_id, vcs'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'trigger_id', 'extra_keyval': 'trigger_id, vcs'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'trigger_id', 'extra_keyval': 'trigger_id, vcs'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'trigger_id', 'extra_keyval': 'trigger_id, vcs'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list, trigger=trigger)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list, trigger=trigger)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def event_handler_event_handler_list_trigger_vcs_get(self, event_handler_list=None, trigger=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type event_handler_list: name
    :param event_handler_list: Keyword argument tuple.

    :type name: unicode
    :param name: **event_handler_list** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Keyword Argument Tuple**:

    :type trigger: trigger_id
    :param trigger: Keyword argument tuple.

    :type trigger_id: long
    :param trigger_id: **trigger** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v6_0_2f.event_handler.event_handler_list', u'event_handler_list'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list', u'event_handler_list'), ('pybind.nos.v7_2_0.event_handler.event_handler_list', u'event_handler_list')]
    bindings_list = [('pybind.nos.v6_0_2f.event_handler.event_handler_list.trigger', 'pybind.nos.v6_0_2f.brocade_event_handler', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.event_handler.event_handler_list.trigger', 'pybind.nos.v7_2_0.brocade_event_handler', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.event_handler.event_handler_list.trigger', 'pybind.slxos.v17r_1_01a.brocade_event_handler', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list.trigger', 'pybind.slxos.v17r_2_00.brocade_event_handler', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list.trigger', 'pybind.slxos.v17s_1_02.brocade_event_handler', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.event_handler.event_handler_list.trigger', u'raslog'), ('pybind.slxos.v17s_1_02.event_handler.event_handler_list.trigger', u'raslog'), ('pybind.slxos.v17r_2_00.event_handler.event_handler_list.trigger', u'raslog'), ('pybind.nos.v7_2_0.event_handler.event_handler_list.trigger', u'raslog')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'trigger', 'keyval': 'trigger_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'raslog, pattern'}, {'leafval': 'raslog, pattern'}, {'leafval': 'raslog, pattern'}, {'leafval': 'raslog, pattern'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_handler_list=event_handler_list, trigger=trigger)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_handler_list=event_handler_list, trigger=trigger)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn', u'evpn_instance')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'instance_name, df_delay_timer'}, {'leafval': 'instance_name, df_delay_timer'}, {'leafval': 'instance_name, df_delay_timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn', u'evpn_instance')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'instance_name, df_delay_timer'}, {'leafval': 'instance_name, df_delay_timer'}, {'leafval': 'instance_name, df_delay_timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_get(self, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.route_target', u'export'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'duplicate_mac_timer'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain', u'bd_add'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'route_distinguisher'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.route_target', u'both'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan', u'evpn_vlan'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan', u'vlan_add'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.route_target', u'import_'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain', u'evpn_bd'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain', u'bd_add'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan', u'evpn_vlan'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain', u'evpn_bd'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.route_target', u'both'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan', u'vlan_add'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.route_target', u'import_'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'route_distinguisher'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.route_target', u'export'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'duplicate_mac_timer'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.route_target', u'both'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.route_target', u'import_'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan', u'vlan_add'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain', u'evpn_bd'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'duplicate_mac_timer'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.route_target', u'export'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan', u'evpn_vlan'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'route_distinguisher'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain', u'bd_add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_instance', 'keyval': 'instance_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'target_community'}, {'leafval': 'duplicate_mac_timer_value, max_count'}, {'leafval': 'bd_range_add, bd_range_remove'}, {'leafval': 'auto'}, {'leafval': 'target_community, ignore_as'}, {'leafval': 'vlan_number, rd'}, {'leafval': 'add_, remove_'}, {'leafval': 'target_community, ignore_as'}, {'leafval': 'bd_number, rd'}, {'leafval': 'bd_range_add, bd_range_remove'}, {'leafval': 'vlan_number, rd'}, {'leafval': 'bd_number, rd'}, {'leafval': 'target_community, ignore_as'}, {'leafval': 'add_, remove_'}, {'leafval': 'target_community, ignore_as'}, {'leafval': 'auto'}, {'leafval': 'target_community'}, {'leafval': 'duplicate_mac_timer_value, max_count'}, {'leafval': 'target_community, ignore_as'}, {'leafval': 'target_community, ignore_as'}, {'leafval': 'add_, remove_'}, {'leafval': 'bd_number, rd'}, {'leafval': 'duplicate_mac_timer_value, max_count'}, {'leafval': 'target_community'}, {'leafval': 'vlan_number, rd'}, {'leafval': 'auto'}, {'leafval': 'bd_range_add, bd_range_remove'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_bridge_domain_get(self, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_bridge_domain_add_get(self, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.bd_add', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.bd_add', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.bd_add', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_bridge_domain_bd_add_get(self, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.bd_add', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.bd_add', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.bd_add', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_bridge_domain_evpn_bd_get(self, evpn_instance=None, evpn_bd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type evpn_bd: bd_number
    :param evpn_bd: Keyword argument tuple.

    :type bd_number: long
    :param bd_number: **evpn_bd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'import_'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'export'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'both'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'import_'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'both'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'export'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'export'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'both'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'import_')]
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_bd', 'keyval': 'bd_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, evpn_bd=evpn_bd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, evpn_bd=evpn_bd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_bridge_domain_evpn_bd_rd_get(self, evpn_instance=None, evpn_bd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type evpn_bd: bd_number
    :param evpn_bd: Keyword argument tuple.

    :type bd_number: long
    :param bd_number: **evpn_bd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'import_'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'export'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'both'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'import_'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'both'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'export'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'export'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'both'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', u'import_')]
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_bd', 'keyval': 'bd_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, evpn_bd=evpn_bd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, evpn_bd=evpn_bd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_bridge_domain_evpn_bd_route_target_get(self, evpn_instance=None, evpn_bd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type evpn_bd: bd_number
    :param evpn_bd: Keyword argument tuple.

    :type bd_number: long
    :param bd_number: **evpn_bd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', u'evpn_bd'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', u'evpn_bd'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', u'evpn_bd')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'bd_number', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'bd_number', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'bd_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, evpn_bd=evpn_bd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, evpn_bd=evpn_bd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_bridge_domain_evpn_bd_route_target_both_get(self, evpn_instance=None, evpn_bd=None, both=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type evpn_bd: bd_number
    :param evpn_bd: Keyword argument tuple.

    :type bd_number: long
    :param bd_number: **evpn_bd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type both: target_community
    :param both: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **both** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '(((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4][0-9'
            ']{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(6553[0-'
            '5])):(([0-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1]['
            '0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4'
            '294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|(429496[0'
            '-6][0-9]{3})|(4294967[0-1][0-9]{2})|(42949672[0-'
            '8][0-9])|(429496729[0-5])))|((([1-9][0-9]{0,8})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])):(([1-9][0-9]{0,3})|([1-5][0-9]'
            '{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2'
            '][0-9])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9'
            ']{2}|2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9]['
            '0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9'
            ']{0,3})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4'
            '][0-9]{2})|(655[0-2][0-9])|(6553[0-5]))))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', u'evpn_bd'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', u'evpn_bd'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', u'evpn_bd')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target.both', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target.both', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target.both', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'bd_number', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'bd_number', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'bd_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'both', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, evpn_bd=evpn_bd, both=both)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, evpn_bd=evpn_bd, both=both)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_bridge_domain_evpn_bd_route_target_export_get(self, evpn_instance=None, evpn_bd=None, export=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type evpn_bd: bd_number
    :param evpn_bd: Keyword argument tuple.

    :type bd_number: long
    :param bd_number: **evpn_bd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type export: target_community
    :param export: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **export** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '(((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4][0-9'
            ']{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(6553[0-'
            '5])):(([0-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1]['
            '0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4'
            '294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|(429496[0'
            '-6][0-9]{3})|(4294967[0-1][0-9]{2})|(42949672[0-'
            '8][0-9])|(429496729[0-5])))|((([1-9][0-9]{0,8})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])):(([1-9][0-9]{0,3})|([1-5][0-9]'
            '{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2'
            '][0-9])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9'
            ']{2}|2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9]['
            '0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9'
            ']{0,3})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4'
            '][0-9]{2})|(655[0-2][0-9])|(6553[0-5]))))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', u'evpn_bd'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', u'evpn_bd'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', u'evpn_bd')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target.export', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target.export', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target.export', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'bd_number', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'bd_number', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'bd_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'export', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, evpn_bd=evpn_bd, export=export)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, evpn_bd=evpn_bd, export=export)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_bridge_domain_evpn_bd_route_target_import_get(self, evpn_instance=None, evpn_bd=None, import_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type evpn_bd: bd_number
    :param evpn_bd: Keyword argument tuple.

    :type bd_number: long
    :param bd_number: **evpn_bd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type import_: target_community
    :param import_: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **import_** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '(((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4][0-9'
            ']{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(6553[0-'
            '5])):(([0-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1]['
            '0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4'
            '294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|(429496[0'
            '-6][0-9]{3})|(4294967[0-1][0-9]{2})|(42949672[0-'
            '8][0-9])|(429496729[0-5])))|((([1-9][0-9]{0,8})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])):(([1-9][0-9]{0,3})|([1-5][0-9]'
            '{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2'
            '][0-9])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9'
            ']{2}|2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9]['
            '0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9'
            ']{0,3})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4'
            '][0-9]{2})|(655[0-2][0-9])|(6553[0-5]))))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', u'evpn_bd'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', u'evpn_bd'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd', u'evpn_bd')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target.import_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target.import_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.evpn_bd.route_target.import_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'bd_number', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'bd_number', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'bd_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'import_', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, evpn_bd=evpn_bd, import_=import_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, evpn_bd=evpn_bd, import_=import_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_bridge_domain_remove_get(self, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.bd_add', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.bd_add', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain.bd_add', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_df_delay_timer_get(self, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.route_target', u'export'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'duplicate_mac_timer'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain', u'bd_add'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'route_distinguisher'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.route_target', u'both'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan', u'evpn_vlan'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan', u'vlan_add'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.route_target', u'import_'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.bridge_domain', u'evpn_bd'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain', u'bd_add'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan', u'evpn_vlan'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.bridge_domain', u'evpn_bd'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.route_target', u'both'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan', u'vlan_add'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.route_target', u'import_'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'route_distinguisher'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.route_target', u'export'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'duplicate_mac_timer'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.route_target', u'both'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.route_target', u'import_'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan', u'vlan_add'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain', u'evpn_bd'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'duplicate_mac_timer'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.route_target', u'export'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan', u'evpn_vlan'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'route_distinguisher'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.bridge_domain', u'bd_add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_instance', 'keyval': 'instance_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'target_community'}, {'leafval': 'duplicate_mac_timer_value, max_count'}, {'leafval': 'bd_range_add, bd_range_remove'}, {'leafval': 'auto'}, {'leafval': 'target_community, ignore_as'}, {'leafval': 'vlan_number, rd'}, {'leafval': 'add_, remove_'}, {'leafval': 'target_community, ignore_as'}, {'leafval': 'bd_number, rd'}, {'leafval': 'bd_range_add, bd_range_remove'}, {'leafval': 'vlan_number, rd'}, {'leafval': 'bd_number, rd'}, {'leafval': 'target_community, ignore_as'}, {'leafval': 'add_, remove_'}, {'leafval': 'target_community, ignore_as'}, {'leafval': 'auto'}, {'leafval': 'target_community'}, {'leafval': 'duplicate_mac_timer_value, max_count'}, {'leafval': 'target_community, ignore_as'}, {'leafval': 'target_community, ignore_as'}, {'leafval': 'add_, remove_'}, {'leafval': 'bd_number, rd'}, {'leafval': 'duplicate_mac_timer_value, max_count'}, {'leafval': 'target_community'}, {'leafval': 'vlan_number, rd'}, {'leafval': 'auto'}, {'leafval': 'bd_range_add, bd_range_remove'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_duplicate_mac_timer_get(self, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.duplicate_mac_timer', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.duplicate_mac_timer', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.duplicate_mac_timer', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'duplicate_mac_timer_value, max_count'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_duplicate_mac_timer_duplicate_mac_timer_value_get(self, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.duplicate_mac_timer', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.duplicate_mac_timer', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.duplicate_mac_timer', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_duplicate_mac_timer_max_count_get(self, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.duplicate_mac_timer', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.duplicate_mac_timer', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.duplicate_mac_timer', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_rd_get(self, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.route_distinguisher', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.route_distinguisher', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.route_distinguisher', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'auto'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.route_distinguisher': [u'auto'], 'pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.route_distinguisher': [u'auto'], 'pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.route_distinguisher': [u'auto']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_rd_auto_get(self, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.route_distinguisher', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.route_distinguisher', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.route_distinguisher', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_route_target_get(self, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.route_target', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.route_target', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.route_target', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_route_target_both_get(self, evpn_instance=None, both=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type both: target_community
    :param both: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **both** tuple argument:  auto;; Target VPN Extended Community

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.route_target.both', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.route_target.both', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.route_target.both', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'both', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, both=both)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, both=both)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_route_target_both_ignore_as_get(self, evpn_instance=None, both=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type both: target_community
    :param both: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **both** tuple argument:  auto;; Target VPN Extended Community

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.route_target.both', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.route_target.both', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.route_target.both', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'both', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, both=both)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, both=both)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_route_target_export_get(self, evpn_instance=None, export=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type export: target_community
    :param export: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **export** tuple argument:  auto;; Target VPN Extended Community

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.route_target.export', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.route_target.export', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.route_target.export', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'export', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, export=export)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, export=export)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_route_target_import_get(self, evpn_instance=None, import_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type import_: target_community
    :param import_: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **import_** tuple argument:  auto ;; Target VPN Extended Community

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.route_target.import_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.route_target.import_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.route_target.import_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'import_', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, import_=import_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, import_=import_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_route_target_import_ignore_as_get(self, evpn_instance=None, import_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type import_: target_community
    :param import_: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **import_** tuple argument:  auto ;; Target VPN Extended Community

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.route_target.import_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.route_target.import_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.route_target.import_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'import_', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, import_=import_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, import_=import_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_vlan_get(self, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_vlan_add_get(self, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.vlan_add', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.vlan_add', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.vlan_add', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_vlan_evpn_vlan_get(self, evpn_instance=None, evpn_vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type evpn_vlan: vlan_number
    :param evpn_vlan: Keyword argument tuple.

    :type vlan_number: long
    :param vlan_number: **evpn_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'import_'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'export'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'both'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'export'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'both'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'import_'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'export'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'both'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'import_')]
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_vlan', 'keyval': 'vlan_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, evpn_vlan=evpn_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, evpn_vlan=evpn_vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_vlan_evpn_vlan_rd_get(self, evpn_instance=None, evpn_vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type evpn_vlan: vlan_number
    :param evpn_vlan: Keyword argument tuple.

    :type vlan_number: long
    :param vlan_number: **evpn_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'import_'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'export'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'both'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'export'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'both'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'import_'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'export'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'both'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', u'import_')]
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_vlan', 'keyval': 'vlan_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, evpn_vlan=evpn_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, evpn_vlan=evpn_vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_vlan_evpn_vlan_route_target_get(self, evpn_instance=None, evpn_vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type evpn_vlan: vlan_number
    :param evpn_vlan: Keyword argument tuple.

    :type vlan_number: long
    :param vlan_number: **evpn_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', u'evpn_vlan'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', u'evpn_vlan'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', u'evpn_vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vlan_number', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vlan_number', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vlan_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, evpn_vlan=evpn_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, evpn_vlan=evpn_vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_vlan_evpn_vlan_route_target_both_get(self, evpn_instance=None, evpn_vlan=None, both=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type evpn_vlan: vlan_number
    :param evpn_vlan: Keyword argument tuple.

    :type vlan_number: long
    :param vlan_number: **evpn_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type both: target_community
    :param both: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **both** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '(((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4][0-9'
            ']{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(6553[0-'
            '5])):(([0-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1]['
            '0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4'
            '294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|(429496[0'
            '-6][0-9]{3})|(4294967[0-1][0-9]{2})|(42949672[0-'
            '8][0-9])|(429496729[0-5])))|((([1-9][0-9]{0,8})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])):(([1-9][0-9]{0,3})|([1-5][0-9]'
            '{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2'
            '][0-9])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9'
            ']{2}|2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9]['
            '0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9'
            ']{0,3})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4'
            '][0-9]{2})|(655[0-2][0-9])|(6553[0-5]))))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', u'evpn_vlan'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', u'evpn_vlan'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', u'evpn_vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target.both', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target.both', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target.both', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vlan_number', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vlan_number', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vlan_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'both', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, evpn_vlan=evpn_vlan, both=both)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, evpn_vlan=evpn_vlan, both=both)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_vlan_evpn_vlan_route_target_export_get(self, evpn_instance=None, evpn_vlan=None, export=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type evpn_vlan: vlan_number
    :param evpn_vlan: Keyword argument tuple.

    :type vlan_number: long
    :param vlan_number: **evpn_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type export: target_community
    :param export: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **export** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '(((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4][0-9'
            ']{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(6553[0-'
            '5])):(([0-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1]['
            '0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4'
            '294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|(429496[0'
            '-6][0-9]{3})|(4294967[0-1][0-9]{2})|(42949672[0-'
            '8][0-9])|(429496729[0-5])))|((([1-9][0-9]{0,8})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])):(([1-9][0-9]{0,3})|([1-5][0-9]'
            '{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2'
            '][0-9])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9'
            ']{2}|2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9]['
            '0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9'
            ']{0,3})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4'
            '][0-9]{2})|(655[0-2][0-9])|(6553[0-5]))))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', u'evpn_vlan'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', u'evpn_vlan'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', u'evpn_vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target.export', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target.export', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target.export', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vlan_number', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vlan_number', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vlan_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'export', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, evpn_vlan=evpn_vlan, export=export)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, evpn_vlan=evpn_vlan, export=export)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_vlan_evpn_vlan_route_target_import_get(self, evpn_instance=None, evpn_vlan=None, import_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type evpn_vlan: vlan_number
    :param evpn_vlan: Keyword argument tuple.

    :type vlan_number: long
    :param vlan_number: **evpn_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type import_: target_community
    :param import_: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **import_** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '(((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4][0-9'
            ']{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(6553[0-'
            '5])):(([0-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1]['
            '0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4'
            '294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|(429496[0'
            '-6][0-9]{3})|(4294967[0-1][0-9]{2})|(42949672[0-'
            '8][0-9])|(429496729[0-5])))|((([1-9][0-9]{0,8})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])):(([1-9][0-9]{0,3})|([1-5][0-9]'
            '{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2'
            '][0-9])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9'
            ']{2}|2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9]['
            '0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9'
            ']{0,3})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4'
            '][0-9]{2})|(655[0-2][0-9])|(6553[0-5]))))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', u'evpn_vlan'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', u'evpn_vlan'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan', u'evpn_vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target.import_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target.import_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.evpn_vlan.route_target.import_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vlan_number', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vlan_number', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vlan_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'import_', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance, evpn_vlan=evpn_vlan, import_=import_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance, evpn_vlan=evpn_vlan, import_=import_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_vlan_remove_get(self, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.vlan_add', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.vlan_add', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.vlan_add', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def evpn_evpn_instance_vlan_vlan_add_get(self, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn.evpn_instance.vlan.vlan_add', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn.evpn_instance.vlan.vlan_add', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn.evpn_instance.vlan.vlan_add', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def exp_dscp_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.exp_dscp_state', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.exp_dscp_state', u'qos_mpls')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'map_type, map_name, enabled_slots'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def exp_dscp_state_qos_mpls_get(self, qos_mpls=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.exp_dscp_state.qos_mpls', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def exp_dscp_state_qos_mpls_enabled_slots_get(self, qos_mpls=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.exp_dscp_state.qos_mpls', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def exp_dscp_state_qos_mpls_map_type_get(self, qos_mpls=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.exp_dscp_state.qos_mpls', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def exp_traffic_class_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.exp_traffic_class_state', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.exp_traffic_class_state', u'qos_mpls')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'map_type, map_name, enabled_slots'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def exp_traffic_class_state_qos_mpls_get(self, qos_mpls=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.exp_traffic_class_state.qos_mpls', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def exp_traffic_class_state_qos_mpls_enabled_slots_get(self, qos_mpls=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.exp_traffic_class_state.qos_mpls', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def exp_traffic_class_state_qos_mpls_map_type_get(self, qos_mpls=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.exp_traffic_class_state.qos_mpls', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fabric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fabric', 'pybind.nos.v6_0_2f.brocade_fabric_service', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fabric', 'pybind.nos.v7_2_0.brocade_fabric_service', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fabric', 'pybind.slxos.v17r_1_01a.brocade_fabric_service', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fabric', 'pybind.slxos.v17r_2_00.brocade_fabric_service', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fabric', 'pybind.slxos.v17s_1_02.brocade_fabric_service', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17s_1_02.fabric.route.mcast', u'rbridge_id'), ('pybind.nos.v7_2_0.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17r_2_00.fabric.route.mcast', u'rbridge_id'), ('pybind.nos.v6_0_2f.fabric.route.mcast', u'rbridge_id')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fabric_route_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fabric.route', 'pybind.nos.v6_0_2f.brocade_fabric_service', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fabric.route', 'pybind.nos.v7_2_0.brocade_fabric_service', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fabric.route', 'pybind.slxos.v17r_1_01a.brocade_fabric_service', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fabric.route', 'pybind.slxos.v17r_2_00.brocade_fabric_service', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fabric.route', 'pybind.slxos.v17s_1_02.brocade_fabric_service', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.fabric.route.mcast', u'rbridge_id'), ('pybind.nos.v6_0_2f.fabric.route.mcast', u'rbridge_id'), ('pybind.nos.v7_2_0.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17r_2_00.fabric.route.mcast', u'rbridge_id')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fabric_route_mcast_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fabric.route.mcast', 'pybind.nos.v6_0_2f.brocade_fabric_service', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fabric.route.mcast', 'pybind.nos.v7_2_0.brocade_fabric_service', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fabric.route.mcast', 'pybind.slxos.v17r_1_01a.brocade_fabric_service', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fabric.route.mcast', 'pybind.slxos.v17r_2_00.brocade_fabric_service', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fabric.route.mcast', 'pybind.slxos.v17s_1_02.brocade_fabric_service', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.fabric.route.mcast', u'rbridge_id'), ('pybind.nos.v6_0_2f.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17s_1_02.fabric.route.mcast', u'rbridge_id'), ('pybind.nos.v7_2_0.fabric.route.mcast', u'rbridge_id')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fabric_route_mcast_rbridge_id_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument:  Syntax: rbridgeId [rbridgeId]

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fabric.route.mcast.rbridge_id', 'pybind.nos.v6_0_2f.brocade_fabric_service', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fabric.route.mcast.rbridge_id', 'pybind.nos.v7_2_0.brocade_fabric_service', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fabric.route.mcast.rbridge_id', 'pybind.slxos.v17r_1_01a.brocade_fabric_service', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fabric.route.mcast.rbridge_id', 'pybind.slxos.v17r_2_00.brocade_fabric_service', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fabric.route.mcast.rbridge_id', 'pybind.slxos.v17s_1_02.brocade_fabric_service', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rbridge_id', 'keyval': 'rbridge_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fabric_route_mcast_rbridge_id_priority_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument:  Syntax: rbridgeId [rbridgeId]

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fabric.route.mcast.rbridge_id', 'pybind.nos.v6_0_2f.brocade_fabric_service', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fabric.route.mcast.rbridge_id', 'pybind.nos.v7_2_0.brocade_fabric_service', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fabric.route.mcast.rbridge_id', 'pybind.slxos.v17r_1_01a.brocade_fabric_service', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fabric.route.mcast.rbridge_id', 'pybind.slxos.v17r_2_00.brocade_fabric_service', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fabric.route.mcast.rbridge_id', 'pybind.slxos.v17s_1_02.brocade_fabric_service', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rbridge_id', 'keyval': 'rbridge_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcoe', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.fcoe', u'fcoe_fabric_map'), ('pybind.slxos.v17s_1_02.fcoe', u'fcoe_map'), ('pybind.nos.v6_0_2f.interface', u'fcoe'), ('pybind.nos.v6_0_2f.fcoe', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2f.fcoe', u'fcoe_map'), ('pybind.slxos.v17r_2_00.fcoe', u'fcoe_map'), ('pybind.slxos.v17r_2_00.fcoe', u'fcoe_fabric_map'), ('pybind.slxos.v17r_1_01a.fcoe', u'fcoe_map'), ('pybind.slxos.v17r_1_01a.fcoe', u'fcoe_fabric_map'), ('pybind.nos.v7_2_0.fcoe', u'fcoe_fabric_map'), ('pybind.nos.v7_2_0.interface', u'fcoe'), ('pybind.nos.v7_2_0.fcoe', u'fcoe_map')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fcoe_fabric_map_name, fcoe_fabric_map_vlan, fcoe_fabric_mode, fcoe_fabric_map_priority, fcoe_fabric_map_virtual_fabric, fcoe_fabric_map_fcmap'}, {'leafval': 'fcoe_map_name'}, {'leafval': 'fcoe_interface_name, fcoe_interface_shutdown'}, {'leafval': 'fcoe_fabric_map_name, fcoe_fabric_map_vlan, fcoe_fabric_mode, fcoe_fabric_map_priority, fcoe_fabric_map_virtual_fabric, fcoe_fabric_map_fcmap'}, {'leafval': 'fcoe_map_name'}, {'leafval': 'fcoe_map_name'}, {'leafval': 'fcoe_fabric_map_name, fcoe_fabric_map_vlan, fcoe_fabric_mode, fcoe_fabric_map_priority, fcoe_fabric_map_virtual_fabric, fcoe_fabric_map_fcmap'}, {'leafval': 'fcoe_map_name'}, {'leafval': 'fcoe_fabric_map_name, fcoe_fabric_map_vlan, fcoe_fabric_mode, fcoe_fabric_map_priority, fcoe_fabric_map_virtual_fabric, fcoe_fabric_map_fcmap'}, {'leafval': 'fcoe_fabric_map_name, fcoe_fabric_map_vlan, fcoe_fabric_mode, fcoe_fabric_map_priority, fcoe_fabric_map_virtual_fabric, fcoe_fabric_map_fcmap'}, {'leafval': 'fcoe_interface_name, fcoe_interface_shutdown'}, {'leafval': 'fcoe_map_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_get(self, fcoe_fabric_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe_fabric_map', 'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_advertisement_get(self, fcoe_fabric_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fip_advertisement', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fip_advertisement', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fip_advertisement', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fip_advertisement', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fip_advertisement', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_advertisement_interval_get(self, fcoe_fabric_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fip_advertisement', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fip_advertisement', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fip_advertisement', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fip_advertisement', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fip_advertisement', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_fcf_group_get(self, fcoe_fabric_map=None, fcoe_fcf_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    **Instance Keyword Argument Tuple**:

    :type fcoe_fcf_map: fcf_map_name
    :param fcoe_fcf_map: Keyword argument tuple.

    :type fcf_map_name: unicode
    :param fcf_map_name: **fcoe_fcf_map** tuple argument.

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcf_map_fif_rbid'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcf_map_fif_rbid'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcf_map_fif_rbid'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcf_map_fif_rbid'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcf_map_fif_rbid')]
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fcoe_fcf_map', 'keyval': 'fcf_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fcf_map_fif_rbid_add, fcf_map_fif_rbid_remove'}, {'leafval': 'fcf_map_fif_rbid_add, fcf_map_fif_rbid_remove'}, {'leafval': 'fcf_map_fif_rbid_add, fcf_map_fif_rbid_remove'}, {'leafval': 'fcf_map_fif_rbid_add, fcf_map_fif_rbid_remove'}, {'leafval': 'fcf_map_fif_rbid_add, fcf_map_fif_rbid_remove'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_fcf_group_fcf_rbid_get(self, fcoe_fabric_map=None, fcoe_fcf_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    **Instance Keyword Argument Tuple**:

    :type fcoe_fcf_map: fcf_map_name
    :param fcoe_fcf_map: Keyword argument tuple.

    :type fcf_map_name: unicode
    :param fcf_map_name: **fcoe_fcf_map** tuple argument.

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcf_map', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcf_map_fif_rbid'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcf_map_fif_rbid'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcf_map_fif_rbid'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcf_map_fif_rbid'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcf_map_fif_rbid')]
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fcoe_fcf_map', 'keyval': 'fcf_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fcf_map_fif_rbid_add, fcf_map_fif_rbid_remove'}, {'leafval': 'fcf_map_fif_rbid_add, fcf_map_fif_rbid_remove'}, {'leafval': 'fcf_map_fif_rbid_add, fcf_map_fif_rbid_remove'}, {'leafval': 'fcf_map_fif_rbid_add, fcf_map_fif_rbid_remove'}, {'leafval': 'fcf_map_fif_rbid_add, fcf_map_fif_rbid_remove'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_fcf_group_fif_rbid_get(self, fcoe_fabric_map=None, fcoe_fcf_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type fcoe_fcf_map: fcf_map_name
    :param fcoe_fcf_map: Keyword argument tuple.

    :type fcf_map_name: unicode
    :param fcf_map_name: **fcoe_fcf_map** tuple argument.

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map')]
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_fcf_group_fif_rbid_add_get(self, fcoe_fabric_map=None, fcoe_fcf_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type fcoe_fcf_map: fcf_map_name
    :param fcoe_fcf_map: Keyword argument tuple.

    :type fcf_map_name: unicode
    :param fcf_map_name: **fcoe_fcf_map** tuple argument.

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map')]
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_fcf_group_fif_rbid_remove_get(self, fcoe_fabric_map=None, fcoe_fcf_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type fcoe_fcf_map: fcf_map_name
    :param fcoe_fcf_map: Keyword argument tuple.

    :type fcf_map_name: unicode
    :param fcf_map_name: **fcoe_fcf_map** tuple argument.

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcf_map', u'fcoe_fcf_map')]
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcf_map.fcf_map_fif_rbid', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcf_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map, fcoe_fcf_map=fcoe_fcf_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_fcmap_get(self, fcoe_fabric_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe_fabric_map', 'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_fcport_group_get(self, fcoe_fabric_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_fcport_group_fcport_group_rbid_get(self, fcoe_fabric_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_fcport_group_fcport_group_rbid_add_get(self, fcoe_fabric_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_fcport_group_fcport_group_rbid_remove_get(self, fcoe_fabric_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcport_group_config.fcport_group_rbid', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_keep_alive_get(self, fcoe_fabric_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fip_keep_alive', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fip_keep_alive', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fip_keep_alive', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fip_keep_alive', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fip_keep_alive', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_keep_alive_timeout_get(self, fcoe_fabric_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fabric_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fabric_map')]
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fip_keep_alive', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fip_keep_alive', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fip_keep_alive', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fip_keep_alive', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fip_keep_alive', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_priority_get(self, fcoe_fabric_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe_fabric_map', 'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_san_mode_get(self, fcoe_fabric_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe_fabric_map', 'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_virtual_fabric_get(self, fcoe_fabric_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe_fabric_map', 'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fabric_map_vlan_get(self, fcoe_fabric_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type fcoe_fabric_map: fcoe_fabric_map_name
    :param fcoe_fabric_map: Keyword argument tuple.

    :type fcoe_fabric_map_name: unicode
    :param fcoe_fabric_map_name: **fcoe_fabric_map** tuple argument:  FCoE Fabric-map name (Max Size - 31)

        * length restriction: ::

            ['1..31']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v6_0_2f.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.nos.v7_2_0.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fip_advertisement'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fcf_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map', u'fcoe_fip_keep_alive'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_fabric_map.fcoe_fcport_group_config', u'fcport_group_rbid')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe_fabric_map', 'keyval': 'fcoe_fabric_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcoe_fip_advertisement_interval'}, {'leafval': 'fcf_map_name, fcf_map_fcf_rbid'}, {'leafval': 'fcoe_fip_keep_alive_timeout'}, {'leafval': 'fcport_group_rbid_add, fcport_group_rbid_remove'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_fabric_map=fcoe_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_fabric_map=fcoe_fabric_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fcoe_map_get(self, fcoe_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type fcoe_map: fcoe_map_name
    :param fcoe_map: Keyword argument tuple.

    :type fcoe_map_name: unicode
    :param fcoe_map_name: **fcoe_map** tuple argument:  FCoE Map name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_map', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_map', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_map', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_map', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_map', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.fcoe.fcoe_map', u'fcoe_map_cee_map'), ('pybind.nos.v6_0_2f.fcoe.fcoe_map', u'fcoe_map_cee_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_map', u'fcoe_map_cee_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_map', u'fcoe_map_cee_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_map', u'fcoe_map_cee_map')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe_map', 'keyval': 'fcoe_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fcoe_map_cee_map_leaf'}, {'leafval': 'fcoe_map_cee_map_leaf'}, {'leafval': 'fcoe_map_cee_map_leaf'}, {'leafval': 'fcoe_map_cee_map_leaf'}, {'leafval': 'fcoe_map_cee_map_leaf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_map=fcoe_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_map=fcoe_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fcoe_map_cee_map_get(self, fcoe_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_map: fcoe_map_name
    :param fcoe_map: Keyword argument tuple.

    :type fcoe_map_name: unicode
    :param fcoe_map_name: **fcoe_map** tuple argument:  FCoE Map name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.fcoe.fcoe_map', u'fcoe_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_map', u'fcoe_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_map', u'fcoe_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_map', u'fcoe_map'), ('pybind.nos.v6_0_2f.fcoe.fcoe_map', u'fcoe_map')]
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_map=fcoe_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_map=fcoe_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fcoe_map_cee_map_fcoe_map_cee_map_leaf_get(self, fcoe_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_map: fcoe_map_name
    :param fcoe_map: Keyword argument tuple.

    :type fcoe_map_name: unicode
    :param fcoe_map_name: **fcoe_map** tuple argument:  FCoE Map name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.fcoe.fcoe_map', u'fcoe_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_map', u'fcoe_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_map', u'fcoe_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_map', u'fcoe_map'), ('pybind.nos.v6_0_2f.fcoe.fcoe_map', u'fcoe_map')]
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_map.fcoe_map_cee_map', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_map=fcoe_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_map=fcoe_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcoe_fcoe_map_fabric_map_get(self, fcoe_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe_map: fcoe_map_name
    :param fcoe_map: Keyword argument tuple.

    :type fcoe_map_name: unicode
    :param fcoe_map_name: **fcoe_map** tuple argument:  FCoE Map name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_map', u'fcoe_map'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_map', u'fcoe_map'), ('pybind.nos.v7_2_0.fcoe.fcoe_map', u'fcoe_map'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_map', u'fcoe_map'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_map', u'fcoe_map')]
    bindings_list = [('pybind.nos.v6_0_2f.fcoe.fcoe_map.fcoe_map_fabric_map', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe.fcoe_map.fcoe_map_fabric_map', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe.fcoe_map.fcoe_map_fabric_map', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe.fcoe_map.fcoe_map_fabric_map', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe.fcoe_map.fcoe_map_fabric_map', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}, {'keyval': 'fcoe_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe_map=fcoe_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe_map=fcoe_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcsp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcsp', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcsp', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcsp', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcsp', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.fcsp_sa.fcsp.auth', u'policy'), ('pybind.slxos.v17r_2_00.fcsp_sa.fcsp.auth', u'proto'), ('pybind.nos.v7_2_0.fcsp_sa.fcsp.auth', u'proto'), ('pybind.nos.v7_2_0.fcsp_sa.fcsp.auth', u'policy'), ('pybind.nos.v6_0_2f.fcsp_sa.fcsp.auth', u'policy'), ('pybind.nos.v6_0_2f.fcsp_sa.fcsp.auth', u'proto'), ('pybind.slxos.v17r_1_01a.fcsp_sa.fcsp.auth', u'proto'), ('pybind.slxos.v17r_1_01a.fcsp_sa.fcsp.auth', u'policy')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'switch'}, {'leafval': 'auth_type, group, hash'}, {'leafval': 'auth_type, group, hash'}, {'leafval': 'switch'}, {'leafval': 'switch'}, {'leafval': 'auth_type, group, hash'}, {'leafval': 'auth_type, group, hash'}, {'leafval': 'switch'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcsp_auth_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcsp_sa.fcsp.auth', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcsp_sa.fcsp.auth', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcsp_sa.fcsp.auth', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcsp_sa.fcsp.auth', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.fcsp_sa.fcsp.auth', u'proto'), ('pybind.slxos.v17r_1_01a.fcsp_sa.fcsp.auth', u'policy'), ('pybind.nos.v6_0_2f.fcsp_sa.fcsp.auth', u'policy'), ('pybind.nos.v6_0_2f.fcsp_sa.fcsp.auth', u'proto'), ('pybind.slxos.v17r_2_00.fcsp_sa.fcsp.auth', u'policy'), ('pybind.slxos.v17r_2_00.fcsp_sa.fcsp.auth', u'proto'), ('pybind.nos.v7_2_0.fcsp_sa.fcsp.auth', u'proto'), ('pybind.nos.v7_2_0.fcsp_sa.fcsp.auth', u'policy')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'auth_type, group, hash'}, {'leafval': 'switch'}, {'leafval': 'switch'}, {'leafval': 'auth_type, group, hash'}, {'leafval': 'switch'}, {'leafval': 'auth_type, group, hash'}, {'leafval': 'auth_type, group, hash'}, {'leafval': 'switch'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcsp_auth_auth_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcsp_sa.fcsp.auth.proto', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcsp_sa.fcsp.auth.proto', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcsp_auth_group_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcsp_sa.fcsp.auth.proto', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcsp_sa.fcsp.auth.proto', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcsp_auth_hash_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcsp_sa.fcsp.auth.proto', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcsp_sa.fcsp.auth.proto', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcsp_auth_policy_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcsp_sa.fcsp.auth.policy', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcsp_sa.fcsp.auth.policy', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcsp_sa.fcsp.auth.policy', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcsp_sa.fcsp.auth.policy', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcsp_auth_policy_switch_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcsp_sa.fcsp.auth.policy', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcsp_sa.fcsp.auth.policy', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcsp_sa.fcsp.auth.policy', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcsp_sa.fcsp.auth.policy', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcsp_auth_proto_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcsp_sa.fcsp.auth.proto', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcsp_sa.fcsp.auth.proto', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcsp_sa.fcsp.auth.proto', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcsp_fcsp_sa_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcsp_sa.fcsp', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcsp_sa.fcsp', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcsp_sa.fcsp', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcsp_sa.fcsp', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.nos.v7_2_0.fcsp_sa.fcsp.auth', u'proto'), ('pybind.nos.v7_2_0.fcsp_sa.fcsp.auth', u'policy'), ('pybind.nos.v6_0_2f.fcsp_sa.fcsp.auth', u'policy'), ('pybind.nos.v6_0_2f.fcsp_sa.fcsp.auth', u'proto'), ('pybind.slxos.v17r_1_01a.fcsp_sa.fcsp.auth', u'proto'), ('pybind.slxos.v17r_1_01a.fcsp_sa.fcsp.auth', u'policy'), ('pybind.slxos.v17r_2_00.fcsp_sa.fcsp.auth', u'policy'), ('pybind.slxos.v17r_2_00.fcsp_sa.fcsp.auth', u'proto')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'auth_type, group, hash'}, {'leafval': 'switch'}, {'leafval': 'switch'}, {'leafval': 'auth_type, group, hash'}, {'leafval': 'auth_type, group, hash'}, {'leafval': 'switch'}, {'leafval': 'switch'}, {'leafval': 'auth_type, group, hash'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fcsp_sa_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcsp_sa', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcsp_sa', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcsp_sa', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcsp_sa', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.fcsp_sa.fcsp.auth', u'proto'), ('pybind.slxos.v17r_1_01a.fcsp_sa.fcsp.auth', u'policy'), ('pybind.slxos.v17r_2_00.fcsp_sa.fcsp.auth', u'policy'), ('pybind.slxos.v17r_2_00.fcsp_sa.fcsp.auth', u'proto'), ('pybind.nos.v6_0_2f.fcsp_sa.fcsp.auth', u'policy'), ('pybind.nos.v6_0_2f.fcsp_sa.fcsp.auth', u'proto'), ('pybind.nos.v7_2_0.fcsp_sa.fcsp.auth', u'proto'), ('pybind.nos.v7_2_0.fcsp_sa.fcsp.auth', u'policy')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'auth_type, group, hash'}, {'leafval': 'switch'}, {'leafval': 'switch'}, {'leafval': 'auth_type, group, hash'}, {'leafval': 'switch'}, {'leafval': 'auth_type, group, hash'}, {'leafval': 'auth_type, group, hash'}, {'leafval': 'switch'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def filter_change_update_delay_get(self, filter_change_update_delay=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type filter_change_update_delay: filter_delay_value
    :param filter_change_update_delay: Keyword argument tuple.

    :type filter_delay_value: long
    :param filter_delay_value: **filter_change_update_delay** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_filter_change_update_delay_holder.filter_change_update_delay', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_filter_change_update_delay_holder.filter_change_update_delay', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hide_filter_change_update_delay_holder.filter_change_update_delay', 'pybind.slxos.v17r_1_01a.brocade_ip_policy', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hide_filter_change_update_delay_holder.filter_change_update_delay', 'pybind.slxos.v17r_2_00.brocade_ip_policy', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hide_filter_change_update_delay_holder.filter_change_update_delay', 'pybind.slxos.v17s_1_02.brocade_ip_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'filter_change_update_delay', 'keyval': 'filter_delay_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, filter_change_update_delay=filter_change_update_delay)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, filter_change_update_delay=filter_change_update_delay)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def filter_info_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.filter_info_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.filter_info_state', u'interface_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def filter_info_state_interface_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.filter_info_state.interface_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def filter_info_state_interface_list_interface_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.filter_info_state.interface_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def filter_info_state_interface_list_interface_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.filter_info_state.interface_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def firmware_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.firmware', 'pybind.nos.v6_0_2f.brocade_firmware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.firmware', 'pybind.nos.v7_2_0.brocade_firmware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.firmware', 'pybind.slxos.v17r_1_01a.brocade_firmware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.firmware', 'pybind.slxos.v17r_2_00.brocade_firmware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.firmware', 'pybind.slxos.v17s_1_02.brocade_firmware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.firmware', u'autoupgrade_params'), ('pybind.nos.v6_0_2f.firmware', u'autoupgrade')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path, protocol, ipaddress, username, pass_'}, {'leafval': 'enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def firmware_auto_upgrade_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.firmware.autoupgrade', 'pybind.nos.v6_0_2f.brocade_firmware', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def firmware_auto_upgrade_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.firmware.autoupgrade', 'pybind.nos.v6_0_2f.brocade_firmware', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def firmware_auto_upgrade_params_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.firmware.autoupgrade_params', 'pybind.nos.v6_0_2f.brocade_firmware', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def firmware_auto_upgrade_params_host_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.firmware.autoupgrade_params', 'pybind.nos.v6_0_2f.brocade_firmware', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def firmware_auto_upgrade_params_password_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.firmware.autoupgrade_params', 'pybind.nos.v6_0_2f.brocade_firmware', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def firmware_auto_upgrade_params_path_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.firmware.autoupgrade_params', 'pybind.nos.v6_0_2f.brocade_firmware', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def firmware_auto_upgrade_params_protocol_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.firmware.autoupgrade_params', 'pybind.nos.v6_0_2f.brocade_firmware', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def firmware_auto_upgrade_params_username_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.firmware.autoupgrade_params', 'pybind.nos.v6_0_2f.brocade_firmware', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def firmware_download_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.firmware.download', 'pybind.nos.v6_0_2f.brocade_firmware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.firmware.download', 'pybind.nos.v7_2_0.brocade_firmware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.firmware.download', 'pybind.slxos.v17r_1_01a.brocade_firmware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.firmware.download', 'pybind.slxos.v17r_2_00.brocade_firmware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.firmware.download', 'pybind.slxos.v17s_1_02.brocade_firmware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.brocade_firmware_rpc.firmware_download.input": {"coldboot": "coldboot", "rbridge_id": "rbridge_id", "auto_activate": "auto_activate"}, "pybind.slxos.v17r_2_00.firmware.download": {}, "pybind.slxos.v17s_1_02.brocade_firmware_rpc.firmware_download.input": {}, "pybind.nos.v7_2_0.brocade_firmware_rpc.firmware_download.input": {"coldboot": "coldboot", "rbridge_id": "rbridge_id", "auto_activate": "auto_activate"}, "pybind.nos.v6_0_2f.firmware.download": {}, "pybind.nos.v7_2_0.firmware.download": {}, "pybind.slxos.v17s_1_02.firmware.download": {}, "pybind.slxos.v17r_1_01a.firmware.download": {}, "pybind.slxos.v17r_2_00.brocade_firmware_rpc.firmware_download.input": {}, "pybind.slxos.v17r_1_01a.brocade_firmware_rpc.firmware_download.input": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def firmware_download_logical_chassis_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.firmware.download.logical_chassis', 'pybind.nos.v6_0_2f.brocade_firmware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.firmware.download.logical_chassis', 'pybind.nos.v7_2_0.brocade_firmware', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def firmware_peripheral_update_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.firmware.peripheral_update', 'pybind.nos.v7_2_0.brocade_firmware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.firmware.peripheral_update_option', 'pybind.slxos.v17r_1_01a.brocade_firmware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.firmware.peripheral_update_option', 'pybind.slxos.v17r_2_00.brocade_firmware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def firmware_peripheral_update_microcode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.firmware.peripheral_update.microcode', 'pybind.nos.v7_2_0.brocade_firmware', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fsb_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcoe_fsb', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe_fsb', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe_fsb', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe_fsb', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe_fsb', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def fsb_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.fcoe_fsb', 'pybind.nos.v6_0_2f.brocade_fcoe', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.fcoe_fsb', 'pybind.nos.v7_2_0.brocade_fcoe', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.fcoe_fsb', 'pybind.slxos.v17r_1_01a.brocade_fcoe', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.fcoe_fsb', 'pybind.slxos.v17r_2_00.brocade_fcoe', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.fcoe_fsb', 'pybind.slxos.v17s_1_02.brocade_fcoe', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def global_lc_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.global_lc_holder', 'pybind.slxos.v17r_1_01a.brocade_linecard_management', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.global_lc_holder', 'pybind.slxos.v17r_2_00.brocade_linecard_management', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.global_lc_holder', 'pybind.slxos.v17s_1_02.brocade_linecard_management', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.global_lc_holder.linecard', u'linecards'), ('pybind.slxos.v17r_1_01a.global_lc_holder.linecard', u'linecards'), ('pybind.slxos.v17s_1_02.global_lc_holder.linecard', u'linecards')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'linecardName, linecardType'}, {'leafval': 'linecardName, linecardType'}, {'leafval': 'linecardName, linecardType'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def global_mtu_conf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.global_mtu_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_2_00.global_mtu_conf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.global_mtu_conf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.global_mtu_conf', u'ip'), ('pybind.slxos.v17r_2_00.global_mtu_conf', u'ipv6'), ('pybind.slxos.v17s_1_02.global_mtu_conf', u'ipv6'), ('pybind.slxos.v17s_1_02.global_mtu_conf', u'ip'), ('pybind.nos.v7_2_0.global_mtu_conf', u'ipv6'), ('pybind.nos.v7_2_0.global_mtu_conf', u'ip')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'global_ip_mtu'}, {'leafval': 'global_ipv6_mtu'}, {'leafval': 'global_ipv6_mtu'}, {'leafval': 'global_ip_mtu'}, {'leafval': 'global_ipv6_mtu'}, {'leafval': 'global_ip_mtu'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ha_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ha', 'pybind.nos.v6_0_2f.brocade_ha', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ha', 'pybind.nos.v7_2_0.brocade_ha', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ha', 'pybind.slxos.v17r_1_01a.brocade_ha', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ha', 'pybind.slxos.v17r_2_00.brocade_ha', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ha', 'pybind.slxos.v17s_1_02.brocade_ha', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ha.process_restart', u'disable_res'), ('pybind.slxos.v17r_1_01a.ha', u'process_restart'), ('pybind.slxos.v17r_2_00.ha', u'process_restart')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mpls'}, {'leafval': 'mpls, bgp, isis, ospfv2, ospfv3'}, {'leafval': 'mpls, bgp, isis, ospfv2, ospfv3'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ha_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ha_action', 'pybind.slxos.v17r_1_01a.brocade_ha', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ha_action', 'pybind.slxos.v17r_2_00.brocade_ha', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ha_action', 'pybind.slxos.v17s_1_02.brocade_ha', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ha_ha_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ha_action.ha', 'pybind.slxos.v17r_1_01a.brocade_ha', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ha_action.ha', 'pybind.slxos.v17r_2_00.brocade_ha', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ha_action.ha', 'pybind.slxos.v17s_1_02.brocade_ha', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ha_process_restart_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ha.process_restart', 'pybind.slxos.v17r_1_01a.brocade_ha', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ha.process_restart', 'pybind.slxos.v17r_2_00.brocade_ha', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ha.process_restart', 'pybind.slxos.v17s_1_02.brocade_ha', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ha.process_restart', u'disable_res')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mpls'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.ha.process_restart": {"bgp": "bgp", "isis": "isis", "mpls": "mpls", "ospfv2": "ospfv2", "ospfv3": "ospfv3"}, "pybind.slxos.v17r_2_00.ha.process_restart": {"bgp": "bgp", "isis": "isis", "mpls": "mpls", "ospfv2": "ospfv2", "ospfv3": "ospfv3"}, "pybind.slxos.v17s_1_02.ha.process_restart": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ha_process_restart_bgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ha.process_restart', 'pybind.slxos.v17r_1_01a.brocade_ha', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ha.process_restart', 'pybind.slxos.v17r_2_00.brocade_ha', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ha_process_restart_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ha.process_restart.disable_res', 'pybind.slxos.v17s_1_02.brocade_ha', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'mpls'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ha_process_restart_disable_mpls_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ha.process_restart.disable_res', 'pybind.slxos.v17s_1_02.brocade_ha', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ha_process_restart_isis_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ha.process_restart', 'pybind.slxos.v17r_1_01a.brocade_ha', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ha.process_restart', 'pybind.slxos.v17r_2_00.brocade_ha', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ha_process_restart_mpls_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ha.process_restart', 'pybind.slxos.v17r_1_01a.brocade_ha', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ha.process_restart', 'pybind.slxos.v17r_2_00.brocade_ha', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ha_process_restart_ospfv2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ha.process_restart', 'pybind.slxos.v17r_1_01a.brocade_ha', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ha.process_restart', 'pybind.slxos.v17r_2_00.brocade_ha', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ha_process_restart_ospfv3_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ha.process_restart', 'pybind.slxos.v17r_1_01a.brocade_ha', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ha.process_restart', 'pybind.slxos.v17r_2_00.brocade_ha', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hardware', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.hardware', u'connector'), ('pybind.nos.v6_0_2f.hardware', u'flexport'), ('pybind.nos.v6_0_2f.hardware.custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware', u'port_group'), ('pybind.nos.v6_0_2f.hardware', u'connector_group'), ('pybind.slxos.v17s_1_02.hardware.profile.route_table', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.kap', u'predefined'), ('pybind.slxos.v17s_1_02.hardware', u'connector'), ('pybind.slxos.v17s_1_02.hardware.profile.route_table.predefined', u'routing_parameter'), ('pybind.slxos.v17s_1_02.hardware.profile.vlan_classification', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.kap', u'customized'), ('pybind.slxos.v17s_1_02.hardware.profile.tcam', u'predefined'), ('pybind.slxos.v17s_1_02.hardware', u'port_group'), ('pybind.slxos.v17s_1_02.hardware.profile.lag', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.counters', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.overlay_visibility', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware', u'flexport'), ('pybind.nos.v7_2_0.hardware', u'connector'), ('pybind.nos.v7_2_0.hardware', u'port_group'), ('pybind.nos.v7_2_0.hardware.custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware', u'connector_group'), ('pybind.slxos.v17r_1_01a.hardware.profile.kap', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware.profile.route_table', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware.profile.route_table.predefined', u'routing_parameter'), ('pybind.slxos.v17r_1_01a.hardware.profile.vlan_classification', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.profile.lag', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware.profile.tcam', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware', u'connector'), ('pybind.slxos.v17r_1_01a.hardware.profile.kap', u'customized'), ('pybind.slxos.v17r_1_01a.hardware', u'port_group'), ('pybind.slxos.v17r_1_01a.hardware.profile.counters', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.tcam', u'cam_share'), ('pybind.slxos.v17r_2_00.hardware.profile.route.predefined', u'route_parameter'), ('pybind.slxos.v17r_2_00.hardware.profile.route', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.route_table', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.profile.route_table.predefined', u'routing_parameter'), ('pybind.slxos.v17r_2_00.hardware.profile.kap', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.vlan_classification', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.kap', u'customized'), ('pybind.slxos.v17r_2_00.hardware.profile.tcam', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.counters', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.lag', u'predefined'), ('pybind.slxos.v17r_2_00.hardware', u'connector'), ('pybind.slxos.v17r_2_00.hardware', u'port_group'), ('pybind.slxos.v17r_2_00.hardware.profile.tcam', u'limit')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}, {'leafval': 'id'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'id, speed'}, {'leafval': 'routing_profiletype'}, {'leafval': 'kap_profiletype'}, {'leafval': 'name'}, {'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'vlan_profiletype'}, {'leafval': 'kap_profilename'}, {'leafval': 'tcam_profiletype'}, {'leafval': 'name, portgroup_speed'}, {'leafval': 'lag_profiletype'}, {'leafval': 'counters_profiletype'}, {'leafval': 'overlay_visibility_profiletype'}, {'leafval': 'name'}, {'leafval': 'id'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'id, speed'}, {'leafval': 'kap_profiletype'}, {'leafval': 'routing_profiletype'}, {'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'vlan_profiletype'}, {'leafval': 'name'}, {'leafval': 'lag_profiletype'}, {'leafval': 'tcam_profiletype'}, {'leafval': 'name'}, {'leafval': 'kap_profilename'}, {'leafval': 'name, portgroup_speed'}, {'leafval': 'counters_profiletype'}, {'leafval': 'l2_ingress_acl, l3_v4_ingress_acl, l3_v6_ingress_acl, l3_v4_pbr, l3_v6_pbr, openflow_v4, openflow_v6'}, {'leafval': 'hwopt_enable, v4fibcomp_enable, v6fibcomp_enable'}, {'leafval': 'route_profiletype'}, {'leafval': 'routing_profiletype'}, {'leafval': 'name'}, {'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'kap_profiletype'}, {'leafval': 'vlan_profiletype'}, {'leafval': 'kap_profilename'}, {'leafval': 'tcam_profiletype'}, {'leafval': 'counters_profiletype'}, {'leafval': 'lag_profiletype'}, {'leafval': 'name'}, {'leafval': 'name, portgroup_speed'}, {'leafval': 'l2l3v4_app, v6_app, flex_acl'}]
    leafval_map = {"pybind.slxos.v17r_2_00.hardware": {}, "pybind.nos.v6_0_2f.hardware": {}, "pybind.slxos.v17s_1_02.hardware": {"system_mode": "system_mode"}, "pybind.nos.v7_2_0.hardware": {}, "pybind.slxos.v17r_1_01a.hardware": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_connector_get(self, connector=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type connector: name
    :param connector: Keyword argument tuple.

    :type name: unicode
    :param name: **connector** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hardware.connector', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.connector', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.connector', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.connector', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.connector', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.hardware.connector', u'breakout'), ('pybind.slxos.v17r_1_01a.hardware.connector', u'insight'), ('pybind.nos.v6_0_2f.hardware.connector', u'sfp'), ('pybind.slxos.v17s_1_02.hardware.connector', u'breakout'), ('pybind.nos.v7_2_0.hardware.connector', u'sfp'), ('pybind.slxos.v17r_2_00.hardware.connector', u'insight'), ('pybind.slxos.v17r_2_00.hardware.connector', u'breakout')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'connector', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cage_mode'}, {'leafval': 'insmode'}, {'leafval': 'breakout'}, {'leafval': 'cage_mode'}, {'leafval': 'breakout'}, {'leafval': 'insmode'}, {'leafval': 'cage_mode'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connector=connector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connector=connector)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_connector_breakout_get(self, connector=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type connector: name
    :param connector: Keyword argument tuple.

    :type name: unicode
    :param name: **connector** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.hardware.connector', u'connector'), ('pybind.slxos.v17r_2_00.hardware.connector', u'connector'), ('pybind.slxos.v17r_1_01a.hardware.connector', u'connector')]
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.connector.breakout', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.connector.breakout', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.connector.breakout', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connector=connector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connector=connector)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_connector_breakout_mode_get(self, connector=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type connector: name
    :param connector: Keyword argument tuple.

    :type name: unicode
    :param name: **connector** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.hardware.connector', u'connector'), ('pybind.slxos.v17r_2_00.hardware.connector', u'connector'), ('pybind.slxos.v17r_1_01a.hardware.connector', u'connector')]
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.connector.breakout', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.connector.breakout', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.connector.breakout', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connector=connector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connector=connector)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_connector_group_get(self, connector_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type connector_group: id
    :param connector_group: Keyword argument tuple.

    :type id: unicode
    :param id: **connector_group** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hardware.connector_group', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.connector_group', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'connector_group', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connector_group=connector_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connector_group=connector_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_connector_group_speed_get(self, connector_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type connector_group: id
    :param connector_group: Keyword argument tuple.

    :type id: unicode
    :param id: **connector_group** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hardware.connector_group', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.connector_group', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'connector_group', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connector_group=connector_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connector_group=connector_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_connector_insight_get(self, connector=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type connector: name
    :param connector: Keyword argument tuple.

    :type name: unicode
    :param name: **connector** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.hardware.connector', u'connector'), ('pybind.slxos.v17r_2_00.hardware.connector', u'connector')]
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.connector.insight', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.connector.insight', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connector=connector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connector=connector)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_connector_insight_mode_get(self, connector=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type connector: name
    :param connector: Keyword argument tuple.

    :type name: unicode
    :param name: **connector** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.hardware.connector', u'connector'), ('pybind.slxos.v17r_2_00.hardware.connector', u'connector')]
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.connector.insight', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.connector.insight', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connector=connector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connector=connector)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_connector_sfp_get(self, connector=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type connector: name
    :param connector: Keyword argument tuple.

    :type name: unicode
    :param name: **connector** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hardware.connector', u'connector'), ('pybind.nos.v6_0_2f.hardware.connector', u'connector')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.connector.sfp', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.connector.sfp', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connector=connector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connector=connector)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_connector_sfp_breakout_get(self, connector=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type connector: name
    :param connector: Keyword argument tuple.

    :type name: unicode
    :param name: **connector** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hardware.connector', u'connector'), ('pybind.nos.v6_0_2f.hardware.connector', u'connector')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.connector.sfp', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.connector.sfp', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connector=connector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connector=connector)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.hardware.custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware.custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17s_1_02.hardware.custom_profile', u'kap_custom_profile')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'bfd_vxlan'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'lacp'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'rpvst'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'xstp'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'bfd_l3'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'fcoe'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'udld'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'udld'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'bfd_vxlan'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'rpvst'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'lacp'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'fcoe'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'xstp'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'bfd_l3'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'rpvst'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'xstp'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'fcoe'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'bfd_vxlan'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'lacp'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'bfd_l3'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'udld'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'lacp'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'bfd_vxlan'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'fcoe'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'xstp'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'udld'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'rpvst'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'bfd_l3'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'bfd_vxlan'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'xstp'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'fcoe'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'lacp'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'rpvst'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'udld'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'bfd_l3')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'kap_custom_profile', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_vxlan_hello_interval, bfd_vxlan_num_entry'}, {'leafval': 'lacp_hello_interval, lacp_num_entry'}, {'leafval': 'rpvst_hello_interval, rpvst_num_entry'}, {'leafval': 'xstp_hello_interval, xstp_num_entry'}, {'leafval': 'bfd_l3_hello_interval, bfd_l3_num_entry'}, {'leafval': 'fcoe_hello_interval, fcoe_num_entry'}, {'leafval': 'udld_hello_interval, udld_num_entry'}, {'leafval': 'udld_hello_interval, udld_num_entry'}, {'leafval': 'bfd_vxlan_hello_interval, bfd_vxlan_num_entry'}, {'leafval': 'rpvst_hello_interval, rpvst_num_entry'}, {'leafval': 'lacp_hello_interval, lacp_num_entry'}, {'leafval': 'fcoe_hello_interval, fcoe_num_entry'}, {'leafval': 'xstp_hello_interval, xstp_num_entry'}, {'leafval': 'bfd_l3_hello_interval, bfd_l3_num_entry'}, {'leafval': 'rpvst_hello_interval, rpvst_num_entry'}, {'leafval': 'xstp_hello_interval, xstp_num_entry'}, {'leafval': 'fcoe_hello_interval, fcoe_num_entry'}, {'leafval': 'bfd_vxlan_hello_interval, bfd_vxlan_num_entry'}, {'leafval': 'lacp_hello_interval, lacp_num_entry'}, {'leafval': 'bfd_l3_hello_interval, bfd_l3_num_entry'}, {'leafval': 'udld_hello_interval, udld_num_entry'}, {'leafval': 'lacp_hello_interval, lacp_num_entry'}, {'leafval': 'bfd_vxlan_hello_interval, bfd_vxlan_num_entry'}, {'leafval': 'fcoe_hello_interval, fcoe_num_entry'}, {'leafval': 'xstp_hello_interval, xstp_num_entry'}, {'leafval': 'udld_hello_interval, udld_num_entry'}, {'leafval': 'rpvst_hello_interval, rpvst_num_entry'}, {'leafval': 'bfd_l3_hello_interval, bfd_l3_num_entry'}, {'leafval': 'bfd_vxlan_hello_interval, bfd_vxlan_num_entry'}, {'leafval': 'xstp_hello_interval, xstp_num_entry'}, {'leafval': 'fcoe_hello_interval, fcoe_num_entry'}, {'leafval': 'lacp_hello_interval, lacp_num_entry'}, {'leafval': 'rpvst_hello_interval, rpvst_num_entry'}, {'leafval': 'udld_hello_interval, udld_num_entry'}, {'leafval': 'bfd_l3_hello_interval, bfd_l3_num_entry'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_bfd_l3_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'bfd_l3_hello_interval, bfd_l3_num_entry'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_bfd_l3_hello_interval_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_bfd_l3_num_entry_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.bfd_l3', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_bfd_vxlan_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'bfd_vxlan_hello_interval, bfd_vxlan_num_entry'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_bfd_vxlan_hello_interval_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_bfd_vxlan_num_entry_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.bfd_vxlan', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_fcoe_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'fcoe_hello_interval, fcoe_num_entry'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_fcoe_hello_interval_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_fcoe_num_entry_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.fcoe', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_lacp_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'lacp_hello_interval, lacp_num_entry'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_lacp_hello_interval_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_lacp_num_entry_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.lacp', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_rpvst_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'rpvst_hello_interval, rpvst_num_entry'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_rpvst_hello_interval_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_rpvst_num_entry_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.rpvst', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_udld_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.udld', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.udld', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.udld', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.udld', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.udld', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'udld_hello_interval, udld_num_entry'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_udld_hello_interval_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.udld', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.udld', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.udld', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.udld', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.udld', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_udld_num_entry_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.udld', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.udld', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.udld', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.udld', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.udld', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_xstp_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'xstp_hello_interval, xstp_num_entry'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_xstp_hello_interval_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_custom_profile_kap_xstp_num_entry_get(self, kap_custom_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type kap_custom_profile: name
    :param kap_custom_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **kap_custom_profile** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile', u'kap_custom_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.custom_profile.kap_custom_profile.xstp', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, kap_custom_profile=kap_custom_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, kap_custom_profile=kap_custom_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_flexport_get(self, flexport=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type flexport: id
    :param flexport: Keyword argument tuple.

    :type id: unicode
    :param id: **flexport** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hardware.flexport', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.flexport', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.hardware.flexport', u'flexport_type'), ('pybind.nos.v7_2_0.hardware.flexport', u'flexport_type')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flexport', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type, instance, skip_deconfig'}, {'leafval': 'type, instance, skip_deconfig'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flexport=flexport)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flexport=flexport)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_flexport_instance_get(self, flexport=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flexport: id
    :param flexport: Keyword argument tuple.

    :type id: unicode
    :param id: **flexport** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hardware.flexport', u'flexport'), ('pybind.nos.v7_2_0.hardware.flexport', u'flexport')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.flexport.flexport_type', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.flexport.flexport_type', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flexport=flexport)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flexport=flexport)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_flexport_skip_deconfig_get(self, flexport=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flexport: id
    :param flexport: Keyword argument tuple.

    :type id: unicode
    :param id: **flexport** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hardware.flexport', u'flexport'), ('pybind.nos.v7_2_0.hardware.flexport', u'flexport')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.flexport.flexport_type', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.flexport.flexport_type', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flexport=flexport)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flexport=flexport)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_flexport_type_get(self, flexport=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flexport: id
    :param flexport: Keyword argument tuple.

    :type id: unicode
    :param id: **flexport** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hardware.flexport', u'flexport'), ('pybind.nos.v7_2_0.hardware.flexport', u'flexport')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.flexport.flexport_type', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.flexport.flexport_type', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flexport=flexport)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flexport=flexport)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_port_group_get(self, port_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_group: name
    :param port_group: Keyword argument tuple.

    :type name: unicode
    :param name: **port_group** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hardware.port_group', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.port_group', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hardware.port_group', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.port_group', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.port_group', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.hardware.port_group', u'mode'), ('pybind.nos.v6_0_2f.hardware.port_group', u'mode')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_group', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'performance, portgroup_speed, support_performance, support_multispeed'}, {'leafval': 'performance'}]
    leafval_map = {"pybind.slxos.v17r_2_00.hardware.port_group": {}, "pybind.slxos.v17r_1_01a.hardware.port_group": {}, "pybind.nos.v6_0_2f.hardware.port_group": {"name": "name"}, "pybind.slxos.v17s_1_02.hardware.port_group": {}, "pybind.nos.v7_2_0.hardware.port_group": {"name": "name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_group=port_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_group=port_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_port_group_mode_get(self, port_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_group: name
    :param port_group: Keyword argument tuple.

    :type name: unicode
    :param name: **port_group** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.port_group', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.port_group', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.port_group', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_group', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_group=port_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_group=port_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_port_group_mode_performance_get(self, port_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_group: name
    :param port_group: Keyword argument tuple.

    :type name: unicode
    :param name: **port_group** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hardware.port_group', u'port_group'), ('pybind.nos.v6_0_2f.hardware.port_group', u'port_group')]
    bindings_list = [('pybind.nos.v6_0_2f.hardware.port_group.mode', 'pybind.nos.v6_0_2f.brocade_hardware', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hardware.port_group.mode', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_group=port_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_group=port_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_port_group_mode_portgroup_speed_get(self, port_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_group: name
    :param port_group: Keyword argument tuple.

    :type name: unicode
    :param name: **port_group** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hardware.port_group', u'port_group')]
    bindings_list = [('pybind.nos.v7_2_0.hardware.port_group.mode', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_group=port_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_group=port_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_port_group_mode_support_multispeed_get(self, port_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_group: name
    :param port_group: Keyword argument tuple.

    :type name: unicode
    :param name: **port_group** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hardware.port_group', u'port_group')]
    bindings_list = [('pybind.nos.v7_2_0.hardware.port_group.mode', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_group=port_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_group=port_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_port_group_mode_support_performance_get(self, port_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_group: name
    :param port_group: Keyword argument tuple.

    :type name: unicode
    :param name: **port_group** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hardware.port_group', u'port_group')]
    bindings_list = [('pybind.nos.v7_2_0.hardware.port_group.mode', 'pybind.nos.v7_2_0.brocade_hardware', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_group=port_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_group=port_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.hardware.profile.route_table', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.kap', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.route_table.predefined', u'routing_parameter'), ('pybind.slxos.v17s_1_02.hardware.profile.vlan_classification', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.kap', u'customized'), ('pybind.slxos.v17s_1_02.hardware.profile.tcam', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.lag', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.counters', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.overlay_visibility', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware.profile.kap', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware.profile.route_table', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware.profile.route_table.predefined', u'routing_parameter'), ('pybind.slxos.v17r_1_01a.hardware.profile.vlan_classification', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware.profile.lag', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware.profile.tcam', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware.profile.kap', u'customized'), ('pybind.slxos.v17r_1_01a.hardware.profile.counters', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.tcam', u'cam_share'), ('pybind.slxos.v17r_2_00.hardware.profile.route.predefined', u'route_parameter'), ('pybind.slxos.v17r_2_00.hardware.profile.route', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.route_table', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.route_table.predefined', u'routing_parameter'), ('pybind.slxos.v17r_2_00.hardware.profile.kap', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.vlan_classification', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.kap', u'customized'), ('pybind.slxos.v17r_2_00.hardware.profile.tcam', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.counters', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.lag', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.tcam', u'limit')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'routing_profiletype'}, {'leafval': 'kap_profiletype'}, {'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'vlan_profiletype'}, {'leafval': 'kap_profilename'}, {'leafval': 'tcam_profiletype'}, {'leafval': 'lag_profiletype'}, {'leafval': 'counters_profiletype'}, {'leafval': 'overlay_visibility_profiletype'}, {'leafval': 'kap_profiletype'}, {'leafval': 'routing_profiletype'}, {'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'vlan_profiletype'}, {'leafval': 'lag_profiletype'}, {'leafval': 'tcam_profiletype'}, {'leafval': 'kap_profilename'}, {'leafval': 'counters_profiletype'}, {'leafval': 'l2_ingress_acl, l3_v4_ingress_acl, l3_v6_ingress_acl, l3_v4_pbr, l3_v6_pbr, openflow_v4, openflow_v6'}, {'leafval': 'hwopt_enable, v4fibcomp_enable, v6fibcomp_enable'}, {'leafval': 'route_profiletype'}, {'leafval': 'routing_profiletype'}, {'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'kap_profiletype'}, {'leafval': 'vlan_profiletype'}, {'leafval': 'kap_profilename'}, {'leafval': 'tcam_profiletype'}, {'leafval': 'counters_profiletype'}, {'leafval': 'lag_profiletype'}, {'leafval': 'l2l3v4_app, v6_app, flex_acl'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_counters_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.counters', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.counters', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.counters', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.hardware.profile.counters', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware.profile.counters', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.counters', u'predefined')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'counters_profiletype'}, {'leafval': 'counters_profiletype'}, {'leafval': 'counters_profiletype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_counters_counters_profiletype_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.counters.predefined', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.counters.predefined', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.counters.predefined', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_counters_predefined_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.counters.predefined', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.counters.predefined', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.counters.predefined', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_kap_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.kap', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.kap', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.kap', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.hardware.profile.kap', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.kap', u'customized'), ('pybind.slxos.v17r_2_00.hardware.profile.kap', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.kap', u'customized'), ('pybind.slxos.v17r_1_01a.hardware.profile.kap', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware.profile.kap', u'customized')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'kap_profiletype'}, {'leafval': 'kap_profilename'}, {'leafval': 'kap_profiletype'}, {'leafval': 'kap_profilename'}, {'leafval': 'kap_profiletype'}, {'leafval': 'kap_profilename'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_kap_custom_profile_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.kap.customized', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.kap.customized', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.kap.customized', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_kap_custom_profile_kap_profilename_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.kap.customized', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.kap.customized', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.kap.customized', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_kap_kap_profiletype_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.kap.predefined', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.kap.predefined', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.kap.predefined', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_kap_predefined_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.kap.predefined', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.kap.predefined', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.kap.predefined', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_lag_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.lag', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.lag', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.lag', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.hardware.profile.lag', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.lag', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware.profile.lag', u'predefined')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lag_profiletype'}, {'leafval': 'lag_profiletype'}, {'leafval': 'lag_profiletype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_lag_lag_profiletype_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.lag.predefined', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.lag.predefined', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.lag.predefined', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_lag_predefined_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.lag.predefined', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.lag.predefined', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.lag.predefined', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_overlay_visibility_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.hardware.profile.overlay_visibility', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.hardware.profile.overlay_visibility', u'predefined')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'overlay_visibility_profiletype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_overlay_visibility_overlay_visibility_profiletype_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.hardware.profile.overlay_visibility.predefined', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_overlay_visibility_predefined_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.hardware.profile.overlay_visibility.predefined', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_route_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.route', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.hardware.profile.route.predefined', u'route_parameter'), ('pybind.slxos.v17r_2_00.hardware.profile.route', u'predefined')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hwopt_enable, v4fibcomp_enable, v6fibcomp_enable'}, {'leafval': 'route_profiletype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_route_hw_opt_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.route.predefined.route_parameter', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_route_predefined_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.route.predefined', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.hardware.profile.route.predefined', u'route_parameter')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'route_profiletype'}
    composed_child_leafval_list = [{'leafval': 'hwopt_enable, v4fibcomp_enable, v6fibcomp_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_route_route_parameter_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.route.predefined.route_parameter', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hwopt_enable, v4fibcomp_enable, v6fibcomp_enable'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_route_route_profiletype_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.route.predefined', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.hardware.profile.route.predefined', u'route_parameter')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hwopt_enable, v4fibcomp_enable, v6fibcomp_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_route_table_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.route_table', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.route_table', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.route_table', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.hardware.profile.route_table', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.route_table.predefined', u'routing_parameter'), ('pybind.slxos.v17r_1_01a.hardware.profile.route_table', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware.profile.route_table.predefined', u'routing_parameter'), ('pybind.slxos.v17r_2_00.hardware.profile.route_table', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.route_table.predefined', u'routing_parameter')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'routing_profiletype'}, {'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'routing_profiletype'}, {'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'routing_profiletype'}, {'leafval': 'maximum_paths, openflow_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_route_table_maximum_paths_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.route_table.predefined.routing_parameter', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.route_table.predefined.routing_parameter', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.route_table.predefined.routing_parameter', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_route_table_openflow_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.route_table.predefined.routing_parameter', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.route_table.predefined.routing_parameter', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.route_table.predefined.routing_parameter', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_route_table_predefined_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.route_table.predefined', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.route_table.predefined', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.route_table.predefined', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.hardware.profile.route_table.predefined', u'routing_parameter'), ('pybind.slxos.v17r_1_01a.hardware.profile.route_table.predefined', u'routing_parameter'), ('pybind.slxos.v17s_1_02.hardware.profile.route_table.predefined', u'routing_parameter')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'routing_profiletype'}
    composed_child_leafval_list = [{'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'maximum_paths, openflow_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_route_table_routing_parameter_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.route_table.predefined.routing_parameter', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.route_table.predefined.routing_parameter', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.route_table.predefined.routing_parameter', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'maximum_paths, openflow_enable'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_route_table_routing_profiletype_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.route_table.predefined', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.route_table.predefined', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.route_table.predefined', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.hardware.profile.route_table.predefined', u'routing_parameter'), ('pybind.slxos.v17r_1_01a.hardware.profile.route_table.predefined', u'routing_parameter'), ('pybind.slxos.v17s_1_02.hardware.profile.route_table.predefined', u'routing_parameter')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'maximum_paths, openflow_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_route_v4_fib_comp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.route.predefined.route_parameter', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_route_v6_fib_comp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.route.predefined.route_parameter', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_tcam_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.tcam', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.tcam', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.tcam', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.hardware.profile.tcam', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware.profile.tcam', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.tcam', u'cam_share'), ('pybind.slxos.v17r_2_00.hardware.profile.tcam', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.tcam', u'limit')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'tcam_profiletype'}, {'leafval': 'tcam_profiletype'}, {'leafval': 'l2_ingress_acl, l3_v4_ingress_acl, l3_v6_ingress_acl, l3_v4_pbr, l3_v6_pbr, openflow_v4, openflow_v6'}, {'leafval': 'tcam_profiletype'}, {'leafval': 'l2l3v4_app, v6_app, flex_acl'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_tcam_cam_share_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.tcam.cam_share', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_tcam_cam_share_l2_ingress_acl_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.tcam.cam_share', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_tcam_cam_share_l3_v4_ingress_acl_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.tcam.cam_share', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_tcam_cam_share_l3_v4_pbr_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.tcam.cam_share', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_tcam_cam_share_l3_v6_ingress_acl_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.tcam.cam_share', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_tcam_cam_share_l3_v6_pbr_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.tcam.cam_share', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_tcam_cam_share_openflow_v4_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.tcam.cam_share', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_tcam_cam_share_openflow_v6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.tcam.cam_share', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_tcam_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.tcam.limit', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_tcam_limit_flex_acl_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.tcam.limit', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_tcam_limit_l2l3v4_app_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.tcam.limit', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_tcam_limit_v6_app_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hardware.profile.tcam.limit', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_tcam_predefined_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.tcam.predefined', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.tcam.predefined', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.tcam.predefined', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_tcam_tcam_profiletype_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.tcam.predefined', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.tcam.predefined', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.tcam.predefined', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_vlan_classification_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.vlan_classification', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.vlan_classification', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.hardware.profile.vlan_classification', u'predefined'), ('pybind.slxos.v17r_1_01a.hardware.profile.vlan_classification', u'predefined'), ('pybind.slxos.v17r_2_00.hardware.profile.vlan_classification', u'predefined')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_profiletype'}, {'leafval': 'vlan_profiletype'}, {'leafval': 'vlan_profiletype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_vlan_classification_predefined_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.vlan_classification.predefined', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.vlan_classification.predefined', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.vlan_classification.predefined', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_profile_vlan_classification_vlan_profiletype_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.hardware.profile.vlan_classification.predefined', 'pybind.slxos.v17r_1_01a.brocade_hardware', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hardware.profile.vlan_classification.predefined', 'pybind.slxos.v17r_2_00.brocade_hardware', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hardware.profile.vlan_classification.predefined', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hardware_system_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.hardware', 'pybind.slxos.v17s_1_02.brocade_hardware', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.hardware.profile.route_table', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.kap', u'predefined'), ('pybind.slxos.v17s_1_02.hardware', u'connector'), ('pybind.slxos.v17s_1_02.hardware.profile.route_table.predefined', u'routing_parameter'), ('pybind.slxos.v17s_1_02.hardware.profile.vlan_classification', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.kap', u'customized'), ('pybind.slxos.v17s_1_02.hardware.profile.tcam', u'predefined'), ('pybind.slxos.v17s_1_02.hardware', u'port_group'), ('pybind.slxos.v17s_1_02.hardware.profile.lag', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.counters', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.profile.overlay_visibility', u'predefined'), ('pybind.slxos.v17s_1_02.hardware.custom_profile', u'kap_custom_profile')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'routing_profiletype'}, {'leafval': 'kap_profiletype'}, {'leafval': 'name'}, {'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'vlan_profiletype'}, {'leafval': 'kap_profilename'}, {'leafval': 'tcam_profiletype'}, {'leafval': 'name, portgroup_speed'}, {'leafval': 'lag_profiletype'}, {'leafval': 'counters_profiletype'}, {'leafval': 'overlay_visibility_profiletype'}, {'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hide_arp_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_arp_holder', 'pybind.nos.v6_0_2f.brocade_arp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_arp_holder', 'pybind.nos.v7_2_0.brocade_arp', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.hide_arp_holder', u'system_max'), ('pybind.nos.v6_0_2f.hide_arp_holder', u'arp_entry'), ('pybind.nos.v7_2_0.hide_arp_holder', u'arp_entry'), ('pybind.nos.v7_2_0.hide_arp_holder', u'system_max')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'arp'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, Port_channel, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve'}, {'leafval': 'arp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hide_filter_change_update_delay_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_filter_change_update_delay_holder', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_filter_change_update_delay_holder', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hide_filter_change_update_delay_holder', 'pybind.slxos.v17r_1_01a.brocade_ip_policy', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hide_filter_change_update_delay_holder', 'pybind.slxos.v17r_2_00.brocade_ip_policy', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hide_filter_change_update_delay_holder', 'pybind.slxos.v17s_1_02.brocade_ip_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.hide_filter_change_update_delay_holder', u'filter_change_update_delay'), ('pybind.slxos.v17r_2_00.hide_filter_change_update_delay_holder', u'filter_change_update_delay'), ('pybind.slxos.v17r_1_01a.hide_filter_change_update_delay_holder', u'filter_change_update_delay'), ('pybind.slxos.v17s_1_02.hide_filter_change_update_delay_holder', u'filter_change_update_delay'), ('pybind.nos.v7_2_0.hide_filter_change_update_delay_holder', u'filter_change_update_delay')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_delay_value'}, {'leafval': 'filter_delay_value'}, {'leafval': 'filter_delay_value'}, {'leafval': 'filter_delay_value'}, {'leafval': 'filter_delay_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hide_intf_loopback_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface', u'loopback'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface', u'loopback')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'id'}, {'leafval': 'id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hide_routemap_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.hide_routemap_holder', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder', u'route_map')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, action_rm, instance'}, {'leafval': 'name, action_rm, instance'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hide_virtual_ip_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_virtual_ip_holder', 'pybind.nos.v6_0_2f.brocade_chassis', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_virtual_ip_holder', 'pybind.nos.v7_2_0.brocade_chassis', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.hide_virtual_ip_holder', 'pybind.slxos.v17r_1_01a.brocade_chassis', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.hide_virtual_ip_holder', 'pybind.slxos.v17r_2_00.brocade_chassis', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.hide_virtual_ip_holder', 'pybind.slxos.v17s_1_02.brocade_chassis', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.slxos.v17r_2_00.hide_virtual_ip_holder', u'chassis'), ('pybind.slxos.v17r_1_01a.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.slxos.v17r_1_01a.hide_virtual_ip_holder', u'chassis'), ('pybind.nos.v6_0_2f.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.nos.v6_0_2f.hide_virtual_ip_holder', u'chassis'), ('pybind.slxos.v17s_1_02.hide_virtual_ip_holder.chassis', u'oper_address'), ('pybind.slxos.v17s_1_02.hide_virtual_ip_holder', u'chassis'), ('pybind.nos.v7_2_0.hide_virtual_ip_holder', u'chassis'), ('pybind.nos.v7_2_0.hide_virtual_ip_holder.chassis', u'oper_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'virtual_oper_Vip_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def host_table_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.host_table', 'pybind.slxos.v17s_1_02.brocade_arp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.host_table', u'isis_router_entry'), ('pybind.slxos.v17s_1_02.host_table', u'aging_time'), ('pybind.slxos.v17s_1_02.host_table', u'aging_mode'), ('pybind.slxos.v17s_1_02.isis_state', u'host_table')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'system_id, host_name, is_local'}, {'leafval': 'conversational_timeout'}, {'leafval': 'conversational'}, {'leafval': 'hostname_enabled'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def host_table_aging_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.host_table.aging_mode', 'pybind.slxos.v17s_1_02.brocade_arp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def host_table_aging_mode_conversational_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.host_table.aging_mode', 'pybind.slxos.v17s_1_02.brocade_arp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def host_table_aging_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.host_table.aging_time', 'pybind.slxos.v17s_1_02.brocade_arp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def host_table_aging_time_conversational_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.host_table.aging_time', 'pybind.slxos.v17s_1_02.brocade_arp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def http_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.http_sa.http', 'pybind.nos.v6_0_2f.brocade_http_config', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.http_sa.http', 'pybind.nos.v7_2_0.brocade_http_config', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.http_sa.http', 'pybind.slxos.v17r_1_01a.brocade_http_config', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.http_sa.http', 'pybind.slxos.v17r_2_00.brocade_http_config', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.http_sa.http', 'pybind.slxos.v17s_1_02.brocade_http_config', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.http_sa.http', u'server'), ('pybind.slxos.v17r_2_00.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.nos.v6_0_2f.http_sa.http', u'server'), ('pybind.slxos.v17r_1_01a.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.http_sa.http', u'server'), ('pybind.slxos.v17s_1_02.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.slxos.v17s_1_02.http_sa.http', u'server'), ('pybind.nos.v7_2_0.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.http_sa.http', u'server')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'shutdown'}, {'leafval': 'use_vrf_name, http_vrf_shutdown'}, {'leafval': 'shutdown'}, {'leafval': 'use_vrf_name, http_vrf_shutdown'}, {'leafval': 'shutdown'}, {'leafval': 'use_vrf_name, http_vrf_shutdown'}, {'leafval': 'shutdown'}, {'leafval': 'use_vrf_name, secure_and_plain, http_vrf_shutdown'}, {'leafval': 'shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def http_sa_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.http_sa', 'pybind.nos.v6_0_2f.brocade_http_config', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.http_sa', 'pybind.nos.v7_2_0.brocade_http_config', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.http_sa', 'pybind.slxos.v17r_1_01a.brocade_http_config', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.http_sa', 'pybind.slxos.v17r_2_00.brocade_http_config', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.http_sa', 'pybind.slxos.v17s_1_02.brocade_http_config', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.http_sa.http', u'server'), ('pybind.slxos.v17s_1_02.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.slxos.v17s_1_02.http_sa.http', u'server'), ('pybind.slxos.v17r_1_01a.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.http_sa.http', u'server'), ('pybind.slxos.v17r_2_00.http_sa.http', u'server'), ('pybind.slxos.v17r_2_00.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.nos.v6_0_2f.http_sa.http', u'server')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_vrf_name, secure_and_plain, http_vrf_shutdown'}, {'leafval': 'shutdown'}, {'leafval': 'use_vrf_name, http_vrf_shutdown'}, {'leafval': 'shutdown'}, {'leafval': 'use_vrf_name, http_vrf_shutdown'}, {'leafval': 'shutdown'}, {'leafval': 'shutdown'}, {'leafval': 'use_vrf_name, http_vrf_shutdown'}, {'leafval': 'shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def http_server_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.http_sa.http.server', 'pybind.nos.v6_0_2f.brocade_http_config', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.http_sa.http.server', 'pybind.nos.v7_2_0.brocade_http_config', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.http_sa.http.server', 'pybind.slxos.v17r_1_01a.brocade_http_config', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.http_sa.http.server', 'pybind.slxos.v17r_2_00.brocade_http_config', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.http_sa.http.server', 'pybind.slxos.v17s_1_02.brocade_http_config', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.slxos.v17s_1_02.http_sa.http.server.http_vrf_cont', u'use_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_vrf_name, http_vrf_shutdown'}, {'leafval': 'use_vrf_name, http_vrf_shutdown'}, {'leafval': 'use_vrf_name, secure_and_plain, http_vrf_shutdown'}, {'leafval': 'use_vrf_name, http_vrf_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def http_server_http_vrf_cont_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.http_sa.http.server.http_vrf_cont', 'pybind.nos.v7_2_0.brocade_http_config', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.http_sa.http.server.http_vrf_cont', 'pybind.slxos.v17r_1_01a.brocade_http_config', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.http_sa.http.server.http_vrf_cont', 'pybind.slxos.v17r_2_00.brocade_http_config', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.http_sa.http.server.http_vrf_cont', 'pybind.slxos.v17s_1_02.brocade_http_config', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.slxos.v17s_1_02.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.http_sa.http.server.http_vrf_cont', u'use_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_vrf_name, http_vrf_shutdown'}, {'leafval': 'use_vrf_name, http_vrf_shutdown'}, {'leafval': 'use_vrf_name, http_vrf_shutdown'}, {'leafval': 'use_vrf_name, secure_and_plain, http_vrf_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def http_server_shutdown_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.http_sa.http.server', 'pybind.nos.v6_0_2f.brocade_http_config', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.http_sa.http.server', 'pybind.nos.v7_2_0.brocade_http_config', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.http_sa.http.server', 'pybind.slxos.v17r_1_01a.brocade_http_config', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.http_sa.http.server', 'pybind.slxos.v17r_2_00.brocade_http_config', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.http_sa.http.server', 'pybind.slxos.v17s_1_02.brocade_http_config', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.http_sa.http.server.http_vrf_cont', u'use_vrf'), ('pybind.slxos.v17s_1_02.http_sa.http.server.http_vrf_cont', u'use_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_vrf_name, http_vrf_shutdown'}, {'leafval': 'use_vrf_name, http_vrf_shutdown'}, {'leafval': 'use_vrf_name, secure_and_plain, http_vrf_shutdown'}, {'leafval': 'use_vrf_name, http_vrf_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def http_server_use_vrf_get(self, use_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name, secure_and_plain, http_vrf_shutdown
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0..max']

    :type secure_and_plain: YANGBool
    :param secure_and_plain: **use_vrf** tuple argument:  Enable/Disable HTTP server when HTTPS certificate is installed.

    :type http_vrf_shutdown: YANGBool
    :param http_vrf_shutdown: **use_vrf** tuple argument:  Shutdown HTTP/HTTPS server on the given vrf

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.http_sa.http.server.http_vrf_cont.use_vrf', 'pybind.nos.v7_2_0.brocade_http_config', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.http_sa.http.server.http_vrf_cont.use_vrf', 'pybind.slxos.v17r_1_01a.brocade_http_config', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.http_sa.http.server.http_vrf_cont.use_vrf', 'pybind.slxos.v17r_2_00.brocade_http_config', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.http_sa.http.server.http_vrf_cont.use_vrf', 'pybind.slxos.v17s_1_02.brocade_http_config', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': 'use_vrf_name, http_vrf_shutdown'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.http_sa.http.server.http_vrf_cont.use_vrf": {"secure_and_plain": "secure_and_plain", "http_vrf_shutdown": "http_vrf_shutdown", "use_vrf_name": "use_vrf_name"}, "pybind.slxos.v17r_1_01a.http_sa.http.server.http_vrf_cont.use_vrf": {}, "pybind.slxos.v17r_2_00.http_sa.http.server.http_vrf_cont.use_vrf": {}, "pybind.slxos.v17s_1_02.http_sa.http.server.http_vrf_cont.use_vrf": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, use_vrf=use_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def http_server_use_vrf_secure_and_plain_get(self, use_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0..max']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.http_sa.http.server.http_vrf_cont.use_vrf', 'pybind.nos.v7_2_0.brocade_http_config', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, use_vrf=use_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def http_server_use_vrf_shutdown_get(self, use_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0..max']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.http_sa.http.server.http_vrf_cont.use_vrf', 'pybind.nos.v7_2_0.brocade_http_config', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.http_sa.http.server.http_vrf_cont.use_vrf', 'pybind.slxos.v17r_1_01a.brocade_http_config', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.http_sa.http.server.http_vrf_cont.use_vrf', 'pybind.slxos.v17r_2_00.brocade_http_config', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.http_sa.http.server.http_vrf_cont.use_vrf', 'pybind.slxos.v17s_1_02.brocade_http_config', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, use_vrf=use_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hw_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hw_state', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.hw_state', u'hw_route_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'slot, tower, lpm_percent, lem_percent'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hw_state_hw_route_info_get(self, hw_route_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type hw_route_info: slot, tower
    :param hw_route_info: Keyword argument tuple.

    :type slot: int
    :param slot: **hw_route_info** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **hw_route_info** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hw_state.hw_route_info', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hw_route_info', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hw_route_info=hw_route_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hw_route_info=hw_route_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hw_state_hw_route_info_lem_percent_get(self, hw_route_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type hw_route_info: slot, tower
    :param hw_route_info: Keyword argument tuple.

    :type slot: int
    :param slot: **hw_route_info** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **hw_route_info** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hw_state.hw_route_info', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hw_route_info', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hw_route_info=hw_route_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hw_route_info=hw_route_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def hw_state_hw_route_info_lpm_percent_get(self, hw_route_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type hw_route_info: slot, tower
    :param hw_route_info: Keyword argument tuple.

    :type slot: int
    :param slot: **hw_route_info** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **hw_route_info** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.hw_state.hw_route_info', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hw_route_info', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hw_route_info=hw_route_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hw_route_info=hw_route_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_multicast_snooping_bridge_domains_state_get(self, igmp_multicast_snooping_bridge_domains_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_multicast_snooping_bridge_domains_state: bd_id
    :param igmp_multicast_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_multicast_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_multicast_snooping_bridge_domains_state', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_multicast_snooping_bridge_domains_state', u'igmp_multicast_snooping_bridge_domains')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'igmp_multicast_snooping_bridge_domains_state', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bd_id, pim_sn_status, igmp_sn_status, igmp_version'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_multicast_snooping_bridge_domains_state=igmp_multicast_snooping_bridge_domains_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_multicast_snooping_bridge_domains_state=igmp_multicast_snooping_bridge_domains_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_multicast_snooping_bridge_domains_state_igmp_multicast_snooping_bridge_domains_get(self, igmp_multicast_snooping_bridge_domains_state=None, igmp_multicast_snooping_bridge_domains=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_multicast_snooping_bridge_domains_state: bd_id
    :param igmp_multicast_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_multicast_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_multicast_snooping_bridge_domains: bd_id
    :param igmp_multicast_snooping_bridge_domains: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_multicast_snooping_bridge_domains** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_multicast_snooping_bridge_domains_state', 'igmp_multicast_snooping_bridge_domains_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_multicast_snooping_bridge_domains_state.igmp_multicast_snooping_bridge_domains', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_multicast_snooping_bridge_domains', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_multicast_snooping_bridge_domains_state=igmp_multicast_snooping_bridge_domains_state, igmp_multicast_snooping_bridge_domains=igmp_multicast_snooping_bridge_domains)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_multicast_snooping_bridge_domains_state=igmp_multicast_snooping_bridge_domains_state, igmp_multicast_snooping_bridge_domains=igmp_multicast_snooping_bridge_domains)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_multicast_snooping_bridge_domains_state_igmp_multicast_snooping_bridge_domains_igmp_sn_status_get(self, igmp_multicast_snooping_bridge_domains_state=None, igmp_multicast_snooping_bridge_domains=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_multicast_snooping_bridge_domains_state: bd_id
    :param igmp_multicast_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_multicast_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_multicast_snooping_bridge_domains: bd_id
    :param igmp_multicast_snooping_bridge_domains: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_multicast_snooping_bridge_domains** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_multicast_snooping_bridge_domains_state', 'igmp_multicast_snooping_bridge_domains_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_multicast_snooping_bridge_domains_state.igmp_multicast_snooping_bridge_domains', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_multicast_snooping_bridge_domains', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_multicast_snooping_bridge_domains_state=igmp_multicast_snooping_bridge_domains_state, igmp_multicast_snooping_bridge_domains=igmp_multicast_snooping_bridge_domains)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_multicast_snooping_bridge_domains_state=igmp_multicast_snooping_bridge_domains_state, igmp_multicast_snooping_bridge_domains=igmp_multicast_snooping_bridge_domains)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_multicast_snooping_bridge_domains_state_igmp_multicast_snooping_bridge_domains_igmp_version_get(self, igmp_multicast_snooping_bridge_domains_state=None, igmp_multicast_snooping_bridge_domains=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_multicast_snooping_bridge_domains_state: bd_id
    :param igmp_multicast_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_multicast_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_multicast_snooping_bridge_domains: bd_id
    :param igmp_multicast_snooping_bridge_domains: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_multicast_snooping_bridge_domains** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_multicast_snooping_bridge_domains_state', 'igmp_multicast_snooping_bridge_domains_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_multicast_snooping_bridge_domains_state.igmp_multicast_snooping_bridge_domains', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_multicast_snooping_bridge_domains', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_multicast_snooping_bridge_domains_state=igmp_multicast_snooping_bridge_domains_state, igmp_multicast_snooping_bridge_domains=igmp_multicast_snooping_bridge_domains)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_multicast_snooping_bridge_domains_state=igmp_multicast_snooping_bridge_domains_state, igmp_multicast_snooping_bridge_domains=igmp_multicast_snooping_bridge_domains)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_multicast_snooping_bridge_domains_state_igmp_multicast_snooping_bridge_domains_pim_sn_status_get(self, igmp_multicast_snooping_bridge_domains_state=None, igmp_multicast_snooping_bridge_domains=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_multicast_snooping_bridge_domains_state: bd_id
    :param igmp_multicast_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_multicast_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_multicast_snooping_bridge_domains: bd_id
    :param igmp_multicast_snooping_bridge_domains: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_multicast_snooping_bridge_domains** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_multicast_snooping_bridge_domains_state', 'igmp_multicast_snooping_bridge_domains_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_multicast_snooping_bridge_domains_state.igmp_multicast_snooping_bridge_domains', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_multicast_snooping_bridge_domains', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_multicast_snooping_bridge_domains_state=igmp_multicast_snooping_bridge_domains_state, igmp_multicast_snooping_bridge_domains=igmp_multicast_snooping_bridge_domains)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_multicast_snooping_bridge_domains_state=igmp_multicast_snooping_bridge_domains_state, igmp_multicast_snooping_bridge_domains=igmp_multicast_snooping_bridge_domains)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.igmp_snooping', 'pybind.nos.v6_0_2f.brocade_igmp_snooping', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.igmp_snooping', 'pybind.nos.v7_2_0.brocade_igmp_snooping', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.igmp_snooping', 'pybind.slxos.v17r_1_01a.brocade_igmp_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping', 'pybind.slxos.v17r_2_00.brocade_igmp_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping', 'pybind.slxos.v17s_1_02.brocade_igmp_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.igmp_snooping.ip.pim', u'snooping'), ('pybind.nos.v7_2_0.igmp_snooping.ip.igmp', u'snooping'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip', u'igmp'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.pim', u'snooping'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp', u'igmp_snooping'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.pim', u'snooping'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp', u'igmp_snooping'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip', u'igmp'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip', u'igmp'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17s_1_02.capabilities.ip', u'igmp_snooping'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.pim', u'snooping'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp', u'igmp_snooping'), ('pybind.nos.v6_0_2f.igmp_snooping.ip.igmp', u'snooping')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'pimv4_enable'}, {'leafval': 'enable'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'router_alert_check_disable'}, {'leafval': 'pimv4_enable'}, {'leafval': 'igmps_enable'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'pimv4_enable'}, {'leafval': 'igmps_enable'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'router_alert_check_disable'}, {'leafval': 'router_alert_check_disable'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'igmp_snooping_version'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'pimv4_enable'}, {'leafval': 'igmps_enable'}, {'leafval': 'enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domain_mrouters_state_get(self, igmp_snooping_bridge_domain_mrouters_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_bridge_domain_mrouters_state: bd_id
    :param igmp_snooping_bridge_domain_mrouters_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domain_mrouters_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domain_mrouters_state', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domain_mrouters_state', u'igmp_snooping_bridge_domain_mrouters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'igmp_snooping_bridge_domain_mrouters_state', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bd_id, interface_name, expiry_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domain_mrouters_state=igmp_snooping_bridge_domain_mrouters_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domain_mrouters_state=igmp_snooping_bridge_domain_mrouters_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domain_mrouters_state_igmp_snooping_bridge_domain_mrouters_get(self, igmp_snooping_bridge_domain_mrouters_state=None, igmp_snooping_bridge_domain_mrouters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_bridge_domain_mrouters_state: bd_id
    :param igmp_snooping_bridge_domain_mrouters_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domain_mrouters_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_bridge_domain_mrouters: bd_id
    :param igmp_snooping_bridge_domain_mrouters: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domain_mrouters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domain_mrouters_state', 'igmp_snooping_bridge_domain_mrouters_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domain_mrouters_state.igmp_snooping_bridge_domain_mrouters', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_bridge_domain_mrouters', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domain_mrouters_state=igmp_snooping_bridge_domain_mrouters_state, igmp_snooping_bridge_domain_mrouters=igmp_snooping_bridge_domain_mrouters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domain_mrouters_state=igmp_snooping_bridge_domain_mrouters_state, igmp_snooping_bridge_domain_mrouters=igmp_snooping_bridge_domain_mrouters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domain_mrouters_state_igmp_snooping_bridge_domain_mrouters_expiry_time_get(self, igmp_snooping_bridge_domain_mrouters_state=None, igmp_snooping_bridge_domain_mrouters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_bridge_domain_mrouters_state: bd_id
    :param igmp_snooping_bridge_domain_mrouters_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domain_mrouters_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_bridge_domain_mrouters: bd_id
    :param igmp_snooping_bridge_domain_mrouters: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domain_mrouters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domain_mrouters_state', 'igmp_snooping_bridge_domain_mrouters_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domain_mrouters_state.igmp_snooping_bridge_domain_mrouters', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_bridge_domain_mrouters', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domain_mrouters_state=igmp_snooping_bridge_domain_mrouters_state, igmp_snooping_bridge_domain_mrouters=igmp_snooping_bridge_domain_mrouters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domain_mrouters_state=igmp_snooping_bridge_domain_mrouters_state, igmp_snooping_bridge_domain_mrouters=igmp_snooping_bridge_domain_mrouters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domain_mrouters_state_igmp_snooping_bridge_domain_mrouters_interface_name_get(self, igmp_snooping_bridge_domain_mrouters_state=None, igmp_snooping_bridge_domain_mrouters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_bridge_domain_mrouters_state: bd_id
    :param igmp_snooping_bridge_domain_mrouters_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domain_mrouters_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_bridge_domain_mrouters: bd_id
    :param igmp_snooping_bridge_domain_mrouters: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domain_mrouters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domain_mrouters_state', 'igmp_snooping_bridge_domain_mrouters_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domain_mrouters_state.igmp_snooping_bridge_domain_mrouters', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_bridge_domain_mrouters', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domain_mrouters_state=igmp_snooping_bridge_domain_mrouters_state, igmp_snooping_bridge_domain_mrouters=igmp_snooping_bridge_domain_mrouters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domain_mrouters_state=igmp_snooping_bridge_domain_mrouters_state, igmp_snooping_bridge_domain_mrouters=igmp_snooping_bridge_domain_mrouters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domains_state_get(self, igmp_snooping_bridge_domains_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_bridge_domains_state: bd_id
    :param igmp_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state', u'igmp_snooping_bridge_domains')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'igmp_snooping_bridge_domains_state', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bd_id, multicast_router_ports, is_querier, igmp_operation_mode, fast_leave, qmrt, lmqi, qi, version, num_of_mcast_grps'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domains_state_igmp_snooping_bridge_domains_get(self, igmp_snooping_bridge_domains_state=None, igmp_snooping_bridge_domains=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_bridge_domains_state: bd_id
    :param igmp_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_bridge_domains: bd_id
    :param igmp_snooping_bridge_domains: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state', 'igmp_snooping_bridge_domains_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', u'vlan_groups')]
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_bridge_domains', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'grp_ip_addr, member_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domains_state_igmp_snooping_bridge_domains_fast_leave_get(self, igmp_snooping_bridge_domains_state=None, igmp_snooping_bridge_domains=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_bridge_domains_state: bd_id
    :param igmp_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_bridge_domains: bd_id
    :param igmp_snooping_bridge_domains: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state', 'igmp_snooping_bridge_domains_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', u'vlan_groups')]
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_bridge_domains', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'grp_ip_addr, member_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domains_state_igmp_snooping_bridge_domains_igmp_operation_mode_get(self, igmp_snooping_bridge_domains_state=None, igmp_snooping_bridge_domains=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_bridge_domains_state: bd_id
    :param igmp_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_bridge_domains: bd_id
    :param igmp_snooping_bridge_domains: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state', 'igmp_snooping_bridge_domains_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', u'vlan_groups')]
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_bridge_domains', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'grp_ip_addr, member_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domains_state_igmp_snooping_bridge_domains_is_querier_get(self, igmp_snooping_bridge_domains_state=None, igmp_snooping_bridge_domains=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_bridge_domains_state: bd_id
    :param igmp_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_bridge_domains: bd_id
    :param igmp_snooping_bridge_domains: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state', 'igmp_snooping_bridge_domains_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', u'vlan_groups')]
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_bridge_domains', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'grp_ip_addr, member_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domains_state_igmp_snooping_bridge_domains_lmqi_get(self, igmp_snooping_bridge_domains_state=None, igmp_snooping_bridge_domains=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_bridge_domains_state: bd_id
    :param igmp_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_bridge_domains: bd_id
    :param igmp_snooping_bridge_domains: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state', 'igmp_snooping_bridge_domains_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', u'vlan_groups')]
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_bridge_domains', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'grp_ip_addr, member_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domains_state_igmp_snooping_bridge_domains_multicast_router_ports_get(self, igmp_snooping_bridge_domains_state=None, igmp_snooping_bridge_domains=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_bridge_domains_state: bd_id
    :param igmp_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_bridge_domains: bd_id
    :param igmp_snooping_bridge_domains: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state', 'igmp_snooping_bridge_domains_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', u'vlan_groups')]
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_bridge_domains', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'grp_ip_addr, member_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domains_state_igmp_snooping_bridge_domains_num_of_mcast_grps_get(self, igmp_snooping_bridge_domains_state=None, igmp_snooping_bridge_domains=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_bridge_domains_state: bd_id
    :param igmp_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_bridge_domains: bd_id
    :param igmp_snooping_bridge_domains: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state', 'igmp_snooping_bridge_domains_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', u'vlan_groups')]
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_bridge_domains', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'grp_ip_addr, member_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domains_state_igmp_snooping_bridge_domains_qi_get(self, igmp_snooping_bridge_domains_state=None, igmp_snooping_bridge_domains=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_bridge_domains_state: bd_id
    :param igmp_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_bridge_domains: bd_id
    :param igmp_snooping_bridge_domains: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state', 'igmp_snooping_bridge_domains_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', u'vlan_groups')]
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_bridge_domains', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'grp_ip_addr, member_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domains_state_igmp_snooping_bridge_domains_qmrt_get(self, igmp_snooping_bridge_domains_state=None, igmp_snooping_bridge_domains=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_bridge_domains_state: bd_id
    :param igmp_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_bridge_domains: bd_id
    :param igmp_snooping_bridge_domains: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state', 'igmp_snooping_bridge_domains_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', u'vlan_groups')]
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_bridge_domains', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'grp_ip_addr, member_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domains_state_igmp_snooping_bridge_domains_version_get(self, igmp_snooping_bridge_domains_state=None, igmp_snooping_bridge_domains=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_bridge_domains_state: bd_id
    :param igmp_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_bridge_domains: bd_id
    :param igmp_snooping_bridge_domains: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state', 'igmp_snooping_bridge_domains_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', u'vlan_groups')]
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_bridge_domains', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'grp_ip_addr, member_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domains_state_igmp_snooping_bridge_domains_vlan_groups_get(self, igmp_snooping_bridge_domains_state=None, igmp_snooping_bridge_domains=None, vlan_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_bridge_domains_state: bd_id
    :param igmp_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type igmp_snooping_bridge_domains: bd_id
    :param igmp_snooping_bridge_domains: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan_groups: grp_ip_addr
    :param vlan_groups: Keyword argument tuple.

    :type grp_ip_addr: unicode
    :param grp_ip_addr: **vlan_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state', 'igmp_snooping_bridge_domains_state'), ('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', u'igmp_snooping_bridge_domains')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains.vlan_groups', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_groups', 'keyval': 'grp_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains, vlan_groups=vlan_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains, vlan_groups=vlan_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_bridge_domains_state_igmp_snooping_bridge_domains_vlan_groups_member_ports_get(self, igmp_snooping_bridge_domains_state=None, igmp_snooping_bridge_domains=None, vlan_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_bridge_domains_state: bd_id
    :param igmp_snooping_bridge_domains_state: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type igmp_snooping_bridge_domains: bd_id
    :param igmp_snooping_bridge_domains: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **igmp_snooping_bridge_domains** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan_groups: grp_ip_addr
    :param vlan_groups: Keyword argument tuple.

    :type grp_ip_addr: unicode
    :param grp_ip_addr: **vlan_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state', 'igmp_snooping_bridge_domains_state'), ('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains', u'igmp_snooping_bridge_domains')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_bridge_domains_state.igmp_snooping_bridge_domains.vlan_groups', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_groups', 'keyval': 'grp_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains, vlan_groups=vlan_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_bridge_domains_state=igmp_snooping_bridge_domains_state, igmp_snooping_bridge_domains=igmp_snooping_bridge_domains, vlan_groups=vlan_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state', u'debug_igmp'), ('pybind.slxos.v17r_2_00.igmp_snooping_state', u'igmp_snooping_mrouters'), ('pybind.slxos.v17r_2_00.igmp_snooping_state', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics', u'igmp_statistics'), ('pybind.slxos.v17r_2_00.igmp_snooping_state', u'igmp_multicast_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state', u'igmp_mct_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state', u'igmp_l3_interfaces'), ('pybind.slxos.v17r_2_00.igmp_snooping_state', u'igmp_interface_statistics'), ('pybind.slxos.v17r_2_00.igmp_snooping_state', u'igmp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state', u'pim_snp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.multicast_ssm_mapping', u'ssm_maps'), ('pybind.slxos.v17s_1_02.igmp_snooping_state', u'igmp_snooping_vlans'), ('pybind.slxos.v17s_1_02.igmp_snooping_state', u'debug_igmp'), ('pybind.slxos.v17s_1_02.igmp_snooping_state', u'igmp_multicast_snooping_vlans'), ('pybind.slxos.v17s_1_02.igmp_snooping_state', u'igmp_snooping_mrouters'), ('pybind.slxos.v17s_1_02.igmp_snooping_state', u'igmp_l3_interfaces'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics', u'igmp_statistics'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.multicast_ssm_mapping', u'ssm_maps'), ('pybind.slxos.v17s_1_02.igmp_snooping_state', u'igmp_interface_statistics'), ('pybind.slxos.v17s_1_02.igmp_snooping_state', u'igmp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state', u'pim_snp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state', u'pim_snp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state', u'igmp_interface_statistics'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics', u'igmp_statistics'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state', u'igmp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state', u'igmp_multicast_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state', u'igmp_l3_interfaces'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state', u'igmp_snooping_mrouters'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state', u'debug_igmp'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.multicast_ssm_mapping', u'ssm_maps')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable_any, error, events, group, packets, grp_addr, protocol, query, v1_report, direction, phy_port_name, io_port_name'}, {'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}, {'leafval': 'interface_name, query_edge_recvd, query_edge_sent, query_edge_rx_errors, v1_report_edge_recvd, v1_report_edge_sent, v1_report_edge_rx_errors, v2_report_edge_recvd, v2_report_edge_sent, v2_report_edge_rx_errors, v3_report_edge_recvd, v3_report_edge_sent, v3_report_edge_rx_errors, grp_leave_edge_recvd, grp_leave_edge_sent, grp_leave_edge_rx_errors, pim_hello_edge_recvd, pim_hello_edge_sent, pim_hello_edge_rx_errors, error_unknown_types, error_bad_length, error_bad_checksum'}, {'leafval': 'vlan_id'}, {'leafval': 'cluster_id, client_id'}, {'leafval': 'interface_name'}, {'leafval': 'interface_name, query_edge_recvd, query_edge_sent, query_edge_rx_errors, v1_report_edge_recvd, v1_report_edge_sent, v1_report_edge_rx_errors, v2_report_edge_recvd, v2_report_edge_sent, v2_report_edge_rx_errors, v3_report_edge_recvd, v3_report_edge_sent, v3_report_edge_rx_errors, grp_leave_edge_recvd, grp_leave_edge_sent, grp_leave_edge_rx_errors, pim_hello_edge_recvd, pim_hello_edge_sent, pim_hello_edge_rx_errors, error_unknown_types, error_bad_length, error_bad_checksum'}, {'leafval': 'group_addr, interface_name'}, {'leafval': 'vlan_id'}, {'leafval': 'prefix_list_name, src_ip_addr'}, {'leafval': 'vlan_id'}, {'leafval': 'enable_any, error, events, group, packets, grp_addr, protocol, query, v1_report, direction, phy_port_name, io_port_name'}, {'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}, {'leafval': 'interface_name'}, {'leafval': 'interface_name, query_edge_recvd, query_edge_sent, query_edge_rx_errors, v1_report_edge_recvd, v1_report_edge_sent, v1_report_edge_rx_errors, v2_report_edge_recvd, v2_report_edge_sent, v2_report_edge_rx_errors, v3_report_edge_recvd, v3_report_edge_sent, v3_report_edge_rx_errors, grp_leave_edge_recvd, grp_leave_edge_sent, grp_leave_edge_rx_errors, pim_hello_edge_recvd, pim_hello_edge_sent, pim_hello_edge_rx_errors, error_unknown_types, error_bad_length, error_bad_checksum'}, {'leafval': 'prefix_list_name, src_ip_addr'}, {'leafval': 'interface_name, query_edge_recvd, query_edge_sent, query_edge_rx_errors, v1_report_edge_recvd, v1_report_edge_sent, v1_report_edge_rx_errors, v2_report_edge_recvd, v2_report_edge_sent, v2_report_edge_rx_errors, v3_report_edge_recvd, v3_report_edge_sent, v3_report_edge_rx_errors, grp_leave_edge_recvd, grp_leave_edge_sent, grp_leave_edge_rx_errors, pim_hello_edge_recvd, pim_hello_edge_sent, pim_hello_edge_rx_errors, error_unknown_types, error_bad_length, error_bad_checksum'}, {'leafval': 'group_addr, interface_name'}, {'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}, {'leafval': 'interface_name, query_edge_recvd, query_edge_sent, query_edge_rx_errors, v1_report_edge_recvd, v1_report_edge_sent, v1_report_edge_rx_errors, v2_report_edge_recvd, v2_report_edge_sent, v2_report_edge_rx_errors, v3_report_edge_recvd, v3_report_edge_sent, v3_report_edge_rx_errors, grp_leave_edge_recvd, grp_leave_edge_sent, grp_leave_edge_rx_errors, pim_hello_edge_recvd, pim_hello_edge_sent, pim_hello_edge_rx_errors, error_unknown_types, error_bad_length, error_bad_checksum'}, {'leafval': 'interface_name, query_edge_recvd, query_edge_sent, query_edge_rx_errors, v1_report_edge_recvd, v1_report_edge_sent, v1_report_edge_rx_errors, v2_report_edge_recvd, v2_report_edge_sent, v2_report_edge_rx_errors, v3_report_edge_recvd, v3_report_edge_sent, v3_report_edge_rx_errors, grp_leave_edge_recvd, grp_leave_edge_sent, grp_leave_edge_rx_errors, pim_hello_edge_recvd, pim_hello_edge_sent, pim_hello_edge_rx_errors, error_unknown_types, error_bad_length, error_bad_checksum'}, {'leafval': 'group_addr, interface_name'}, {'leafval': 'vlan_id'}, {'leafval': 'interface_name'}, {'leafval': 'vlan_id'}, {'leafval': 'enable_any, error, events, group, packets, grp_addr, protocol, query, v1_report, direction, phy_port_name, io_port_name'}, {'leafval': 'prefix_list_name, src_ip_addr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_direction_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_enable_any_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_error_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_events_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_group_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_grp_addr_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_io_port_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_packets_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_phy_port_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_protocol_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_query_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_debug_igmp_v1_report_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.debug_igmp', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_get(self, igmp_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups.igmp_groups_', u'igmpv3_sources'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups.igmp_groups_', u'igmpv3_sources'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups.igmp_groups_', u'igmpv3_sources')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_groups', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_name'}, {'leafval': 'group_addr, interface_name, uptime, expiry_time, last_reporter, filter_mode, member_ship'}, {'leafval': 'interface_name'}, {'leafval': 'group_addr, interface_name, uptime, expiry_time, last_reporter, filter_mode, member_ship'}, {'leafval': 'group_addr, interface_name, uptime, expiry_time, last_reporter, filter_mode, member_ship'}, {'leafval': 'interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_get(self, igmp_groups=None, igmp_groups_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type igmp_groups_: group_addr, interface_name
    :param igmp_groups_: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups_** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups_** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups', u'igmp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups.igmp_groups', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups.igmp_groups', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups.igmp_groups', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_groups_', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups, igmp_groups_=igmp_groups_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups, igmp_groups_=igmp_groups_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_expiry_time_get(self, igmp_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups', u'igmp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_filter_mode_get(self, igmp_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups', u'igmp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_igmpv3_sources_get(self, igmp_groups=None, igmpv3_sources=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type igmpv3_sources: interface_name
    :param igmpv3_sources: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmpv3_sources** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups', u'igmp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', u'incl_src_ip'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', u'excl_src_ip'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', u'excl_src_ip'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', u'incl_src_ip'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', u'incl_src_ip'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', u'excl_src_ip')]
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmpv3_sources', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv4_addr'}, {'leafval': 'ipv4_addr'}, {'leafval': 'ipv4_addr'}, {'leafval': 'ipv4_addr'}, {'leafval': 'ipv4_addr'}, {'leafval': 'ipv4_addr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups, igmpv3_sources=igmpv3_sources)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups, igmpv3_sources=igmpv3_sources)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_igmpv3_sources_excl_src_ip_get(self, igmp_groups=None, igmpv3_sources=None, excl_src_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    :type igmpv3_sources: interface_name
    :param igmpv3_sources: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmpv3_sources** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type excl_src_ip: ipv4_addr
    :param excl_src_ip: Keyword argument tuple.

    :type ipv4_addr: unicode
    :param ipv4_addr: **excl_src_ip** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', u'igmpv3_sources'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', u'igmpv3_sources'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', u'igmpv3_sources')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources.excl_src_ip', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources.excl_src_ip', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources.excl_src_ip', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'excl_src_ip', 'keyval': 'ipv4_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups, igmpv3_sources=igmpv3_sources, excl_src_ip=excl_src_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups, igmpv3_sources=igmpv3_sources, excl_src_ip=excl_src_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_igmpv3_sources_incl_src_ip_get(self, igmp_groups=None, igmpv3_sources=None, incl_src_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    :type igmpv3_sources: interface_name
    :param igmpv3_sources: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmpv3_sources** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type incl_src_ip: ipv4_addr
    :param incl_src_ip: Keyword argument tuple.

    :type ipv4_addr: unicode
    :param ipv4_addr: **incl_src_ip** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', u'igmpv3_sources'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', u'igmpv3_sources'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources', u'igmpv3_sources')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources.incl_src_ip', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources.incl_src_ip', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups.igmp_groups_.igmpv3_sources.incl_src_ip', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'incl_src_ip', 'keyval': 'ipv4_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups, igmpv3_sources=igmpv3_sources, incl_src_ip=incl_src_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups, igmpv3_sources=igmpv3_sources, incl_src_ip=incl_src_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_last_reporter_get(self, igmp_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups', u'igmp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_member_ship_get(self, igmp_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups', u'igmp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_groups_igmp_groups_uptime_get(self, igmp_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_groups: group_addr, interface_name
    :param igmp_groups: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_groups** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups', u'igmp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups', u'igmp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_groups.igmp_groups_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_groups=igmp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_groups=igmp_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_error_bad_checksum_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_error_bad_length_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_error_unknown_types_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_grp_leave_edge_recvd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_grp_leave_edge_rx_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_grp_leave_edge_sent_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_interface_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_pim_hello_edge_recvd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_pim_hello_edge_rx_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_pim_hello_edge_sent_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_query_edge_recvd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_query_edge_rx_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_query_edge_sent_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v1_report_edge_recvd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v1_report_edge_rx_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v1_report_edge_sent_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v2_report_edge_recvd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v2_report_edge_rx_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v2_report_edge_sent_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v3_report_edge_recvd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v3_report_edge_rx_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_interface_statistics_v3_report_edge_sent_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_interface_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_get(self, igmp_l3_interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_l3_interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_name, is_igmp_enabled, query_interval, other_querier_interval, query_reponse_time, last_member_query_interval, immediate_leave, igmp_querier, is_igmp_querier_local'}, {'leafval': 'interface_name, is_igmp_enabled, query_interval, other_querier_interval, query_reponse_time, last_member_query_interval, immediate_leave, igmp_querier, is_igmp_querier_local'}, {'leafval': 'interface_name, is_igmp_enabled, query_interval, other_querier_interval, query_reponse_time, last_member_query_interval, immediate_leave, igmp_querier, is_igmp_querier_local, igmp_version'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_get(self, igmp_l3_interfaces=None, igmp_l3_interfaces_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type igmp_l3_interfaces_: interface_name
    :param igmp_l3_interfaces_: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces_** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_l3_interfaces_', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces": {}, "pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces": {"is_igmp_enabled": "is_igmp_enabled", "last_member_query_interval": "last_member_query_interval", "igmp_querier": "igmp_querier", "other_querier_interval": "other_querier_interval", "immediate_leave": "immediate_leave", "is_igmp_querier_local": "is_igmp_querier_local", "query_interval": "query_interval", "interface_name": "interface_name", "query_reponse_time": "query_reponse_time"}, "pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces": {"is_igmp_enabled": "is_igmp_enabled", "last_member_query_interval": "last_member_query_interval", "igmp_querier": "igmp_querier", "other_querier_interval": "other_querier_interval", "immediate_leave": "immediate_leave", "is_igmp_querier_local": "is_igmp_querier_local", "query_interval": "query_interval", "interface_name": "interface_name", "query_reponse_time": "query_reponse_time"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces, igmp_l3_interfaces_=igmp_l3_interfaces_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces, igmp_l3_interfaces_=igmp_l3_interfaces_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_igmp_querier_get(self, igmp_l3_interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_igmp_version_get(self, igmp_l3_interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name, igmp_querier', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_immediate_leave_get(self, igmp_l3_interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_is_igmp_enabled_get(self, igmp_l3_interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_is_igmp_querier_local_get(self, igmp_l3_interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_last_member_query_interval_get(self, igmp_l3_interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_other_querier_interval_get(self, igmp_l3_interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_query_interval_get(self, igmp_l3_interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_l3_interfaces_igmp_l3_interfaces_query_reponse_time_get(self, igmp_l3_interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_l3_interfaces: interface_name
    :param igmp_l3_interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_l3_interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces', u'igmp_l3_interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_l3_interfaces.igmp_l3_interfaces_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_querier', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_l3_interfaces=igmp_l3_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_l3_interfaces=igmp_l3_interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_mct_groups_get(self, igmp_mct_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type igmp_mct_groups: cluster_id, client_id
    :param igmp_mct_groups: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **igmp_mct_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **igmp_mct_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_mct_groups', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_mct_groups', u'igmp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_mct_groups', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'grp_addr, src_addr, interface_name, member_intf, member_type, filter_mode, mcast_df, peer_addr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_mct_groups=igmp_mct_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_mct_groups=igmp_mct_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_mct_groups_igmp_entry_get(self, igmp_mct_groups=None, igmp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_mct_groups: cluster_id, client_id
    :param igmp_mct_groups: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **igmp_mct_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **igmp_mct_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_entry: grp_addr, src_addr, interface_name, member_intf
    :param igmp_entry: Keyword argument tuple.

    :type grp_addr: unicode
    :param grp_addr: **igmp_entry** tuple argument.

    :type src_addr: unicode
    :param src_addr: **igmp_entry** tuple argument.

    :type interface_name: unicode
    :param interface_name: **igmp_entry** tuple argument.

    :type member_intf: unicode
    :param member_intf: **igmp_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_mct_groups', u'igmp_mct_groups')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_mct_groups.igmp_entry', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_entry', 'keyval': 'grp_addr, src_addr, interface_name, member_intf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_mct_groups=igmp_mct_groups, igmp_entry=igmp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_mct_groups=igmp_mct_groups, igmp_entry=igmp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_mct_groups_igmp_entry_filter_mode_get(self, igmp_mct_groups=None, igmp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_mct_groups: cluster_id, client_id
    :param igmp_mct_groups: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **igmp_mct_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **igmp_mct_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_entry: grp_addr, src_addr, interface_name, member_intf
    :param igmp_entry: Keyword argument tuple.

    :type grp_addr: unicode
    :param grp_addr: **igmp_entry** tuple argument.

    :type src_addr: unicode
    :param src_addr: **igmp_entry** tuple argument.

    :type interface_name: unicode
    :param interface_name: **igmp_entry** tuple argument.

    :type member_intf: unicode
    :param member_intf: **igmp_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_mct_groups', u'igmp_mct_groups')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_mct_groups.igmp_entry', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_entry', 'keyval': 'grp_addr, src_addr, interface_name, member_intf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_mct_groups=igmp_mct_groups, igmp_entry=igmp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_mct_groups=igmp_mct_groups, igmp_entry=igmp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_mct_groups_igmp_entry_mcast_df_get(self, igmp_mct_groups=None, igmp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_mct_groups: cluster_id, client_id
    :param igmp_mct_groups: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **igmp_mct_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **igmp_mct_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_entry: grp_addr, src_addr, interface_name, member_intf
    :param igmp_entry: Keyword argument tuple.

    :type grp_addr: unicode
    :param grp_addr: **igmp_entry** tuple argument.

    :type src_addr: unicode
    :param src_addr: **igmp_entry** tuple argument.

    :type interface_name: unicode
    :param interface_name: **igmp_entry** tuple argument.

    :type member_intf: unicode
    :param member_intf: **igmp_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_mct_groups', u'igmp_mct_groups')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_mct_groups.igmp_entry', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_entry', 'keyval': 'grp_addr, src_addr, interface_name, member_intf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_mct_groups=igmp_mct_groups, igmp_entry=igmp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_mct_groups=igmp_mct_groups, igmp_entry=igmp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_mct_groups_igmp_entry_member_type_get(self, igmp_mct_groups=None, igmp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_mct_groups: cluster_id, client_id
    :param igmp_mct_groups: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **igmp_mct_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **igmp_mct_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_entry: grp_addr, src_addr, interface_name, member_intf
    :param igmp_entry: Keyword argument tuple.

    :type grp_addr: unicode
    :param grp_addr: **igmp_entry** tuple argument.

    :type src_addr: unicode
    :param src_addr: **igmp_entry** tuple argument.

    :type interface_name: unicode
    :param interface_name: **igmp_entry** tuple argument.

    :type member_intf: unicode
    :param member_intf: **igmp_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_mct_groups', u'igmp_mct_groups')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_mct_groups.igmp_entry', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_entry', 'keyval': 'grp_addr, src_addr, interface_name, member_intf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_mct_groups=igmp_mct_groups, igmp_entry=igmp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_mct_groups=igmp_mct_groups, igmp_entry=igmp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_mct_groups_igmp_entry_peer_addr_get(self, igmp_mct_groups=None, igmp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_mct_groups: cluster_id, client_id
    :param igmp_mct_groups: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **igmp_mct_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **igmp_mct_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_entry: grp_addr, src_addr, interface_name, member_intf
    :param igmp_entry: Keyword argument tuple.

    :type grp_addr: unicode
    :param grp_addr: **igmp_entry** tuple argument.

    :type src_addr: unicode
    :param src_addr: **igmp_entry** tuple argument.

    :type interface_name: unicode
    :param interface_name: **igmp_entry** tuple argument.

    :type member_intf: unicode
    :param member_intf: **igmp_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_mct_groups', u'igmp_mct_groups')]
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_mct_groups.igmp_entry', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_entry', 'keyval': 'grp_addr, src_addr, interface_name, member_intf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_mct_groups=igmp_mct_groups, igmp_entry=igmp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_mct_groups=igmp_mct_groups, igmp_entry=igmp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_multicast_snooping_vlans_get(self, igmp_multicast_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type igmp_multicast_snooping_vlans: vlan_id
    :param igmp_multicast_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_multicast_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_multicast_snooping_vlans', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_multicast_snooping_vlans', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_multicast_snooping_vlans', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_multicast_snooping_vlans', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id, pim_sn_status, igmp_sn_status, igmp_version'}, {'leafval': 'vlan_id, pim_sn_status, igmp_sn_status, igmp_version'}, {'leafval': 'vlan_id, pim_sn_status, igmp_sn_status, igmp_version'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_multicast_snooping_vlans_igmp_multicast_snooping_vlans_get(self, igmp_multicast_snooping_vlans=None, igmp_multicast_snooping_vlans_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_multicast_snooping_vlans: vlan_id
    :param igmp_multicast_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_multicast_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_multicast_snooping_vlans_: vlan_id
    :param igmp_multicast_snooping_vlans_: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_multicast_snooping_vlans_** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_multicast_snooping_vlans.igmp_multicast_snooping_vlans', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_multicast_snooping_vlans.igmp_multicast_snooping_vlans', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_multicast_snooping_vlans.igmp_multicast_snooping_vlans', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_multicast_snooping_vlans_', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans, igmp_multicast_snooping_vlans_=igmp_multicast_snooping_vlans_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans, igmp_multicast_snooping_vlans_=igmp_multicast_snooping_vlans_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_multicast_snooping_vlans_igmp_multicast_snooping_vlans_igmp_sn_status_get(self, igmp_multicast_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_multicast_snooping_vlans: vlan_id
    :param igmp_multicast_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_multicast_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_multicast_snooping_vlans.igmp_multicast_snooping_vlans_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_multicast_snooping_vlans.igmp_multicast_snooping_vlans_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_multicast_snooping_vlans.igmp_multicast_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_sn_status', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_multicast_snooping_vlans_igmp_multicast_snooping_vlans_igmp_version_get(self, igmp_multicast_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_multicast_snooping_vlans: vlan_id
    :param igmp_multicast_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_multicast_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_multicast_snooping_vlans.igmp_multicast_snooping_vlans_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_multicast_snooping_vlans.igmp_multicast_snooping_vlans_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_multicast_snooping_vlans.igmp_multicast_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_sn_status', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_multicast_snooping_vlans_igmp_multicast_snooping_vlans_pim_sn_status_get(self, igmp_multicast_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_multicast_snooping_vlans: vlan_id
    :param igmp_multicast_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_multicast_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_multicast_snooping_vlans', u'igmp_multicast_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_multicast_snooping_vlans.igmp_multicast_snooping_vlans_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_multicast_snooping_vlans.igmp_multicast_snooping_vlans_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_multicast_snooping_vlans.igmp_multicast_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_sn_status', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_multicast_snooping_vlans=igmp_multicast_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_mrouters_get(self, igmp_snooping_mrouters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_mrouters: vlan_id
    :param igmp_snooping_mrouters: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_mrouters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_mrouters', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_mrouters', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_mrouters', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_mrouters', u'igmp_snooping_mrouters'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_mrouters', u'igmp_snooping_mrouters'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_mrouters', u'igmp_snooping_mrouters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_mrouters', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id, interface_name, expiry_time'}, {'leafval': 'vlan_id, interface_name, expiry_time'}, {'leafval': 'vlan_id, interface_name, expiry_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_mrouters=igmp_snooping_mrouters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_mrouters=igmp_snooping_mrouters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_mrouters_igmp_snooping_mrouters_get(self, igmp_snooping_mrouters=None, igmp_snooping_mrouters_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_mrouters: vlan_id
    :param igmp_snooping_mrouters: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_mrouters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_mrouters_: vlan_id
    :param igmp_snooping_mrouters_: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_mrouters_** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_mrouters', u'igmp_snooping_mrouters'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_mrouters', u'igmp_snooping_mrouters'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_mrouters', u'igmp_snooping_mrouters')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_mrouters.igmp_snooping_mrouters', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_mrouters.igmp_snooping_mrouters', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_mrouters.igmp_snooping_mrouters', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_mrouters_', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_mrouters=igmp_snooping_mrouters, igmp_snooping_mrouters_=igmp_snooping_mrouters_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_mrouters=igmp_snooping_mrouters, igmp_snooping_mrouters_=igmp_snooping_mrouters_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_mrouters_igmp_snooping_mrouters_expiry_time_get(self, igmp_snooping_mrouters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_mrouters: vlan_id
    :param igmp_snooping_mrouters: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_mrouters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_mrouters', u'igmp_snooping_mrouters'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_mrouters', u'igmp_snooping_mrouters'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_mrouters', u'igmp_snooping_mrouters')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_mrouters.igmp_snooping_mrouters_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_mrouters.igmp_snooping_mrouters_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_mrouters.igmp_snooping_mrouters_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_mrouters=igmp_snooping_mrouters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_mrouters=igmp_snooping_mrouters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_mrouters_igmp_snooping_mrouters_interface_name_get(self, igmp_snooping_mrouters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_mrouters: vlan_id
    :param igmp_snooping_mrouters: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_mrouters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_mrouters', u'igmp_snooping_mrouters'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_mrouters', u'igmp_snooping_mrouters'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_mrouters', u'igmp_snooping_mrouters')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_mrouters.igmp_snooping_mrouters_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_mrouters.igmp_snooping_mrouters_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_mrouters.igmp_snooping_mrouters_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_mrouters=igmp_snooping_mrouters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_mrouters=igmp_snooping_mrouters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_get(self, igmp_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', u'vlan_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', u'vlan_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', u'vlan_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_vlans', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id, multicast_router_ports, is_querier, igmp_operation_mode, fast_leave, qmrt, lmqi, qi, version, num_of_mcast_grps'}, {'leafval': 'grp_ip_addr, member_ports'}, {'leafval': 'grp_ip_addr, member_ports'}, {'leafval': 'vlan_id, multicast_router_ports, is_querier, igmp_operation_mode, fast_leave, qmrt, lmqi, qi, version, num_of_mcast_grps'}, {'leafval': 'grp_ip_addr, member_ports'}, {'leafval': 'vlan_id, multicast_router_ports, is_querier, igmp_operation_mode, fast_leave, qmrt, lmqi, qi, version, lmqc, sqi, sqc, rv, rum, num_of_mcast_grps'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_get(self, igmp_snooping_vlans=None, igmp_snooping_vlans_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmp_snooping_vlans_: vlan_id
    :param igmp_snooping_vlans_: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans_** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_snooping_vlans_', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans": {"multicast_router_ports": "multicast_router_ports", "igmp_operation_mode": "igmp_operation_mode", "version": "version", "qmrt": "qmrt", "is_querier": "is_querier", "qi": "qi", "lmqi": "lmqi", "fast_leave": "fast_leave", "num_of_mcast_grps": "num_of_mcast_grps", "vlan_id": "vlan_id"}, "pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans": {"multicast_router_ports": "multicast_router_ports", "igmp_operation_mode": "igmp_operation_mode", "version": "version", "qmrt": "qmrt", "is_querier": "is_querier", "qi": "qi", "lmqi": "lmqi", "fast_leave": "fast_leave", "num_of_mcast_grps": "num_of_mcast_grps", "vlan_id": "vlan_id"}, "pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans, igmp_snooping_vlans_=igmp_snooping_vlans_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans, igmp_snooping_vlans_=igmp_snooping_vlans_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_fast_leave_get(self, igmp_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_igmp_operation_mode_get(self, igmp_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_is_querier_get(self, igmp_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_lmqc_get(self, igmp_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_lmqi_get(self, igmp_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_multicast_router_ports_get(self, igmp_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_num_of_mcast_grps_get(self, igmp_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_qi_get(self, igmp_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_qmrt_get(self, igmp_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_rum_get(self, igmp_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_rv_get(self, igmp_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_sqc_get(self, igmp_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_sqi_get(self, igmp_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_version_get(self, igmp_snooping_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fast_leave', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_vlan_groups_get(self, igmp_snooping_vlans=None, vlan_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan_groups: grp_ip_addr
    :param vlan_groups: Keyword argument tuple.

    :type grp_ip_addr: unicode
    :param grp_ip_addr: **vlan_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_.vlan_groups', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_.vlan_groups', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_.vlan_groups', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_groups', 'keyval': 'grp_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans, vlan_groups=vlan_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans, vlan_groups=vlan_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_snooping_vlans_igmp_snooping_vlans_vlan_groups_member_ports_get(self, igmp_snooping_vlans=None, vlan_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_snooping_vlans: vlan_id
    :param igmp_snooping_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **igmp_snooping_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan_groups: grp_ip_addr
    :param vlan_groups: Keyword argument tuple.

    :type grp_ip_addr: unicode
    :param grp_ip_addr: **vlan_groups** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans', u'igmp_snooping_vlans')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_.vlan_groups', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_.vlan_groups', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_snooping_vlans.igmp_snooping_vlans_.vlan_groups', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_groups', 'keyval': 'grp_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_snooping_vlans=igmp_snooping_vlans, vlan_groups=vlan_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_snooping_vlans=igmp_snooping_vlans, vlan_groups=vlan_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics', u'igmp_statistics'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics', u'igmp_statistics'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics', u'igmp_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_name, query_edge_recvd, query_edge_sent, query_edge_rx_errors, v1_report_edge_recvd, v1_report_edge_sent, v1_report_edge_rx_errors, v2_report_edge_recvd, v2_report_edge_sent, v2_report_edge_rx_errors, v3_report_edge_recvd, v3_report_edge_sent, v3_report_edge_rx_errors, grp_leave_edge_recvd, grp_leave_edge_sent, grp_leave_edge_rx_errors, pim_hello_edge_recvd, pim_hello_edge_sent, pim_hello_edge_rx_errors, error_unknown_types, error_bad_length, error_bad_checksum'}, {'leafval': 'interface_name, query_edge_recvd, query_edge_sent, query_edge_rx_errors, v1_report_edge_recvd, v1_report_edge_sent, v1_report_edge_rx_errors, v2_report_edge_recvd, v2_report_edge_sent, v2_report_edge_rx_errors, v3_report_edge_recvd, v3_report_edge_sent, v3_report_edge_rx_errors, grp_leave_edge_recvd, grp_leave_edge_sent, grp_leave_edge_rx_errors, pim_hello_edge_recvd, pim_hello_edge_sent, pim_hello_edge_rx_errors, error_unknown_types, error_bad_length, error_bad_checksum'}, {'leafval': 'interface_name, query_edge_recvd, query_edge_sent, query_edge_rx_errors, v1_report_edge_recvd, v1_report_edge_sent, v1_report_edge_rx_errors, v2_report_edge_recvd, v2_report_edge_sent, v2_report_edge_rx_errors, v3_report_edge_recvd, v3_report_edge_sent, v3_report_edge_rx_errors, grp_leave_edge_recvd, grp_leave_edge_sent, grp_leave_edge_rx_errors, pim_hello_edge_recvd, pim_hello_edge_sent, pim_hello_edge_rx_errors, error_unknown_types, error_bad_length, error_bad_checksum'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_get(self, igmp_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type igmp_statistics: interface_name
    :param igmp_statistics: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmp_statistics** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmp_statistics', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_statistics=igmp_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_statistics=igmp_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_error_bad_checksum_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_error_bad_length_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_error_unknown_types_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_grp_leave_edge_recvd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_grp_leave_edge_rx_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_grp_leave_edge_sent_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_pim_hello_edge_recvd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_pim_hello_edge_rx_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_pim_hello_edge_sent_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_query_edge_recvd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_query_edge_rx_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_query_edge_sent_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v1_report_edge_recvd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v1_report_edge_rx_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v1_report_edge_sent_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v2_report_edge_recvd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v2_report_edge_rx_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v2_report_edge_sent_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v3_report_edge_recvd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v3_report_edge_rx_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_igmp_statistics_igmp_statistics_v3_report_edge_sent_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.igmp_statistics.igmp_statistics_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'error_bad_checksum', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_multicast_ssm_mapping_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.multicast_ssm_mapping', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.multicast_ssm_mapping', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.multicast_ssm_mapping', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.multicast_ssm_mapping', u'ssm_maps'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.multicast_ssm_mapping', u'ssm_maps'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.multicast_ssm_mapping', u'ssm_maps')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_name, src_ip_addr'}, {'leafval': 'prefix_list_name, src_ip_addr'}, {'leafval': 'prefix_list_name, src_ip_addr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_multicast_ssm_mapping_ssm_maps_get(self, ssm_maps=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ssm_maps: prefix_list_name
    :param ssm_maps: Keyword argument tuple.

    :type prefix_list_name: unicode
    :param prefix_list_name: **ssm_maps** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.multicast_ssm_mapping.ssm_maps', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.multicast_ssm_mapping.ssm_maps', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.multicast_ssm_mapping.ssm_maps', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ssm_maps', 'keyval': 'prefix_list_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ssm_maps=ssm_maps)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ssm_maps=ssm_maps)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_multicast_ssm_mapping_ssm_maps_src_ip_addr_get(self, ssm_maps=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ssm_maps: prefix_list_name
    :param ssm_maps: Keyword argument tuple.

    :type prefix_list_name: unicode
    :param prefix_list_name: **ssm_maps** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.multicast_ssm_mapping.ssm_maps', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.multicast_ssm_mapping.ssm_maps', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.multicast_ssm_mapping.ssm_maps', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ssm_maps', 'keyval': 'prefix_list_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ssm_maps=ssm_maps)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ssm_maps=ssm_maps)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_get(self, pim_snp_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', u'pim_snp_sources'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', u'pim_snp_wg_member_ports'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', u'pim_snp_sources'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', u'pim_snp_wg_member_ports'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', u'pim_snp_wg_member_ports'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', u'pim_snp_sources'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'pim_snp_groups', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'src_addr, src_flags, src_uptime'}, {'leafval': 'interface_name, mbr_flags, flag_string, mbr_uptime'}, {'leafval': 'group_addr, vlan_id, uptime, expiry_time, last_reporter'}, {'leafval': 'src_addr, src_flags, src_uptime'}, {'leafval': 'interface_name, mbr_flags, flag_string, mbr_uptime'}, {'leafval': 'group_addr, vlan_id, uptime, expiry_time, last_reporter'}, {'leafval': 'interface_name, mbr_flags, flag_string, mbr_uptime'}, {'leafval': 'src_addr, src_flags, src_uptime'}, {'leafval': 'group_addr, vlan_id, uptime, expiry_time, last_reporter'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_get(self, pim_snp_groups=None, pim_snp_groups_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_groups_: group_addr, vlan_id
    :param pim_snp_groups_: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **pim_snp_groups_** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups_** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_groups_', 'keyval': 'group_addr, vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_groups_=pim_snp_groups_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_groups_=pim_snp_groups_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_expiry_time_get(self, pim_snp_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'group_addr, vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_last_reporter_get(self, pim_snp_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'group_addr, vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_sources_get(self, pim_snp_groups=None, pim_snp_sources=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_sources: src_addr
    :param pim_snp_sources: Keyword argument tuple.

    :type src_addr: unicode
    :param src_addr: **pim_snp_sources** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sg_member_ports'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sg_member_ports'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sg_member_ports')]
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_sources', 'keyval': 'src_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_name, mbr_flags, flag_string, mbr_uptime'}, {'leafval': 'interface_name, mbr_flags, flag_string, mbr_uptime'}, {'leafval': 'interface_name, mbr_flags, flag_string, mbr_uptime'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_sources_pim_snp_sg_member_ports_get(self, pim_snp_groups=None, pim_snp_sources=None, pim_snp_sg_member_ports=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type pim_snp_sources: src_addr
    :param pim_snp_sources: Keyword argument tuple.

    :type src_addr: unicode
    :param src_addr: **pim_snp_sources** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type pim_snp_sg_member_ports: interface_name
    :param pim_snp_sg_member_ports: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_snp_sg_member_ports** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sources'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sources'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sources')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources.pim_snp_sg_member_ports', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources.pim_snp_sg_member_ports', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources.pim_snp_sg_member_ports', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'src_addr', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'src_addr', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'src_addr', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_sg_member_ports', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources, pim_snp_sg_member_ports=pim_snp_sg_member_ports)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources, pim_snp_sg_member_ports=pim_snp_sg_member_ports)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_sources_pim_snp_sg_member_ports_flag_string_get(self, pim_snp_groups=None, pim_snp_sources=None, pim_snp_sg_member_ports=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type pim_snp_sources: src_addr
    :param pim_snp_sources: Keyword argument tuple.

    :type src_addr: unicode
    :param src_addr: **pim_snp_sources** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type pim_snp_sg_member_ports: interface_name
    :param pim_snp_sg_member_ports: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_snp_sg_member_ports** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sources'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sources'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sources')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources.pim_snp_sg_member_ports', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources.pim_snp_sg_member_ports', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources.pim_snp_sg_member_ports', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'src_addr', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'src_addr', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'src_addr', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_sg_member_ports', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources, pim_snp_sg_member_ports=pim_snp_sg_member_ports)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources, pim_snp_sg_member_ports=pim_snp_sg_member_ports)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_sources_pim_snp_sg_member_ports_mbr_flags_get(self, pim_snp_groups=None, pim_snp_sources=None, pim_snp_sg_member_ports=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type pim_snp_sources: src_addr
    :param pim_snp_sources: Keyword argument tuple.

    :type src_addr: unicode
    :param src_addr: **pim_snp_sources** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type pim_snp_sg_member_ports: interface_name
    :param pim_snp_sg_member_ports: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_snp_sg_member_ports** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sources'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sources'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sources')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources.pim_snp_sg_member_ports', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources.pim_snp_sg_member_ports', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources.pim_snp_sg_member_ports', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'src_addr', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'src_addr', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'src_addr', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_sg_member_ports', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources, pim_snp_sg_member_ports=pim_snp_sg_member_ports)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources, pim_snp_sg_member_ports=pim_snp_sg_member_ports)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_sources_pim_snp_sg_member_ports_mbr_uptime_get(self, pim_snp_groups=None, pim_snp_sources=None, pim_snp_sg_member_ports=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type pim_snp_sources: src_addr
    :param pim_snp_sources: Keyword argument tuple.

    :type src_addr: unicode
    :param src_addr: **pim_snp_sources** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type pim_snp_sg_member_ports: interface_name
    :param pim_snp_sg_member_ports: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_snp_sg_member_ports** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sources'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sources'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sources')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources.pim_snp_sg_member_ports', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources.pim_snp_sg_member_ports', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources.pim_snp_sg_member_ports', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'src_addr', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'src_addr', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'src_addr', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_sg_member_ports', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources, pim_snp_sg_member_ports=pim_snp_sg_member_ports)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources, pim_snp_sg_member_ports=pim_snp_sg_member_ports)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_sources_src_flags_get(self, pim_snp_groups=None, pim_snp_sources=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_sources: src_addr
    :param pim_snp_sources: Keyword argument tuple.

    :type src_addr: unicode
    :param src_addr: **pim_snp_sources** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sg_member_ports'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sg_member_ports'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sg_member_ports')]
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_sources', 'keyval': 'src_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_name, mbr_flags, flag_string, mbr_uptime'}, {'leafval': 'interface_name, mbr_flags, flag_string, mbr_uptime'}, {'leafval': 'interface_name, mbr_flags, flag_string, mbr_uptime'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_sources_src_uptime_get(self, pim_snp_groups=None, pim_snp_sources=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_sources: src_addr
    :param pim_snp_sources: Keyword argument tuple.

    :type src_addr: unicode
    :param src_addr: **pim_snp_sources** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sg_member_ports'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sg_member_ports'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_sources', u'pim_snp_sg_member_ports')]
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_sources', 'keyval': 'src_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_name, mbr_flags, flag_string, mbr_uptime'}, {'leafval': 'interface_name, mbr_flags, flag_string, mbr_uptime'}, {'leafval': 'interface_name, mbr_flags, flag_string, mbr_uptime'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_sources=pim_snp_sources)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_wg_member_ports_get(self, pim_snp_groups=None, pim_snp_wg_member_ports=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_wg_member_ports: interface_name
    :param pim_snp_wg_member_ports: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_snp_wg_member_ports** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_wg_member_ports', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_wg_member_ports', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_wg_member_ports', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_wg_member_ports', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_wg_member_ports=pim_snp_wg_member_ports)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_wg_member_ports=pim_snp_wg_member_ports)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_wg_member_ports_flag_string_get(self, pim_snp_groups=None, pim_snp_wg_member_ports=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_wg_member_ports: interface_name
    :param pim_snp_wg_member_ports: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_snp_wg_member_ports** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_wg_member_ports', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_wg_member_ports', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_wg_member_ports', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_wg_member_ports', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_wg_member_ports=pim_snp_wg_member_ports)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_wg_member_ports=pim_snp_wg_member_ports)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_wg_member_ports_mbr_flags_get(self, pim_snp_groups=None, pim_snp_wg_member_ports=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_wg_member_ports: interface_name
    :param pim_snp_wg_member_ports: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_snp_wg_member_ports** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_wg_member_ports', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_wg_member_ports', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_wg_member_ports', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_wg_member_ports', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_wg_member_ports=pim_snp_wg_member_ports)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_wg_member_ports=pim_snp_wg_member_ports)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_pim_snp_wg_member_ports_mbr_uptime_get(self, pim_snp_groups=None, pim_snp_wg_member_ports=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pim_snp_wg_member_ports: interface_name
    :param pim_snp_wg_member_ports: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **pim_snp_wg_member_ports** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_wg_member_ports', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_wg_member_ports', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_.pim_snp_wg_member_ports', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_snp_wg_member_ports', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups, pim_snp_wg_member_ports=pim_snp_wg_member_ports)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups, pim_snp_wg_member_ports=pim_snp_wg_member_ports)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_snooping_state_pim_snp_groups_pim_snp_groups_uptime_get(self, pim_snp_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_snp_groups: vlan_id
    :param pim_snp_groups: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **pim_snp_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups', u'pim_snp_groups')]
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', 'pybind.slxos.v17r_1_01a.brocade_mc_hms_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', 'pybind.slxos.v17r_2_00.brocade_mc_hms_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping_state.pim_snp_groups.pim_snp_groups_', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'expiry_time', 'keyval': 'group_addr, vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_snp_groups=pim_snp_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_snp_groups=pim_snp_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_static_groups_state_get(self, igmp_static_groups_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type igmp_static_groups_state: group_addr, interface_name
    :param igmp_static_groups_state: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_static_groups_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state', u'igmp_static_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'igmp_static_groups_state', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'group_addr, interface_name, uptime, expiry_time, last_reporter, filter_mode, member_ship'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_static_groups_state=igmp_static_groups_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_static_groups_state=igmp_static_groups_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_static_groups_state_igmp_static_groups_get(self, igmp_static_groups_state=None, igmp_static_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_static_groups_state: group_addr, interface_name
    :param igmp_static_groups_state: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_static_groups_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type igmp_static_groups: group_addr, interface_name
    :param igmp_static_groups: Keyword argument tuple.

    :type group_addr: long
    :param group_addr: **igmp_static_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state', 'igmp_static_groups_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups', u'igmpv3_sources')]
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_static_groups', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_static_groups_state_igmp_static_groups_expiry_time_get(self, igmp_static_groups_state=None, igmp_static_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_static_groups_state: group_addr, interface_name
    :param igmp_static_groups_state: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_static_groups_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type igmp_static_groups: group_addr, interface_name
    :param igmp_static_groups: Keyword argument tuple.

    :type group_addr: long
    :param group_addr: **igmp_static_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state', 'igmp_static_groups_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups', u'igmpv3_sources')]
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_static_groups', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_static_groups_state_igmp_static_groups_filter_mode_get(self, igmp_static_groups_state=None, igmp_static_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_static_groups_state: group_addr, interface_name
    :param igmp_static_groups_state: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_static_groups_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type igmp_static_groups: group_addr, interface_name
    :param igmp_static_groups: Keyword argument tuple.

    :type group_addr: long
    :param group_addr: **igmp_static_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state', 'igmp_static_groups_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups', u'igmpv3_sources')]
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_static_groups', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_static_groups_state_igmp_static_groups_igmpv3_sources_get(self, igmp_static_groups_state=None, igmp_static_groups=None, igmpv3_sources=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_static_groups_state: group_addr, interface_name
    :param igmp_static_groups_state: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_static_groups_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups_state** tuple argument.

    :type igmp_static_groups: group_addr, interface_name
    :param igmp_static_groups: Keyword argument tuple.

    :type group_addr: long
    :param group_addr: **igmp_static_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type igmpv3_sources: interface_name
    :param igmpv3_sources: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmpv3_sources** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state', 'igmp_static_groups_state'), ('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups', u'igmp_static_groups')]
    bindings_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups.igmpv3_sources', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups.igmpv3_sources', u'excl_src_ip'), ('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups.igmpv3_sources', u'incl_src_ip')]
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmpv3_sources', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv4_addr'}, {'leafval': 'ipv4_addr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups, igmpv3_sources=igmpv3_sources)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups, igmpv3_sources=igmpv3_sources)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_static_groups_state_igmp_static_groups_igmpv3_sources_excl_src_ip_get(self, igmp_static_groups_state=None, igmp_static_groups=None, igmpv3_sources=None, excl_src_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_static_groups_state: group_addr, interface_name
    :param igmp_static_groups_state: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_static_groups_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups_state** tuple argument.

    :type igmp_static_groups: group_addr, interface_name
    :param igmp_static_groups: Keyword argument tuple.

    :type group_addr: long
    :param group_addr: **igmp_static_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups** tuple argument.

    :type igmpv3_sources: interface_name
    :param igmpv3_sources: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmpv3_sources** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type excl_src_ip: ipv4_addr
    :param excl_src_ip: Keyword argument tuple.

    :type ipv4_addr: long
    :param ipv4_addr: **excl_src_ip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state', 'igmp_static_groups_state'), ('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups', u'igmp_static_groups'), ('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups.igmpv3_sources', u'igmpv3_sources')]
    bindings_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups.igmpv3_sources.excl_src_ip', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'excl_src_ip', 'keyval': 'ipv4_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups, igmpv3_sources=igmpv3_sources, excl_src_ip=excl_src_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups, igmpv3_sources=igmpv3_sources, excl_src_ip=excl_src_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_static_groups_state_igmp_static_groups_igmpv3_sources_incl_src_ip_get(self, igmp_static_groups_state=None, igmp_static_groups=None, igmpv3_sources=None, incl_src_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_static_groups_state: group_addr, interface_name
    :param igmp_static_groups_state: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_static_groups_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups_state** tuple argument.

    :type igmp_static_groups: group_addr, interface_name
    :param igmp_static_groups: Keyword argument tuple.

    :type group_addr: long
    :param group_addr: **igmp_static_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups** tuple argument.

    :type igmpv3_sources: interface_name
    :param igmpv3_sources: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **igmpv3_sources** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type incl_src_ip: ipv4_addr
    :param incl_src_ip: Keyword argument tuple.

    :type ipv4_addr: long
    :param ipv4_addr: **incl_src_ip** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state', 'igmp_static_groups_state'), ('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups', u'igmp_static_groups'), ('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups.igmpv3_sources', u'igmpv3_sources')]
    bindings_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups.igmpv3_sources.incl_src_ip', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'group_addr, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'incl_src_ip', 'keyval': 'ipv4_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups, igmpv3_sources=igmpv3_sources, incl_src_ip=incl_src_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups, igmpv3_sources=igmpv3_sources, incl_src_ip=incl_src_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_static_groups_state_igmp_static_groups_last_reporter_get(self, igmp_static_groups_state=None, igmp_static_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_static_groups_state: group_addr, interface_name
    :param igmp_static_groups_state: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_static_groups_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type igmp_static_groups: group_addr, interface_name
    :param igmp_static_groups: Keyword argument tuple.

    :type group_addr: long
    :param group_addr: **igmp_static_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state', 'igmp_static_groups_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups', u'igmpv3_sources')]
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_static_groups', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_static_groups_state_igmp_static_groups_member_ship_get(self, igmp_static_groups_state=None, igmp_static_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_static_groups_state: group_addr, interface_name
    :param igmp_static_groups_state: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_static_groups_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type igmp_static_groups: group_addr, interface_name
    :param igmp_static_groups: Keyword argument tuple.

    :type group_addr: long
    :param group_addr: **igmp_static_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state', 'igmp_static_groups_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups', u'igmpv3_sources')]
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_static_groups', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def igmp_static_groups_state_igmp_static_groups_uptime_get(self, igmp_static_groups_state=None, igmp_static_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type igmp_static_groups_state: group_addr, interface_name
    :param igmp_static_groups_state: Keyword argument tuple.

    :type group_addr: unicode
    :param group_addr: **igmp_static_groups_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type igmp_static_groups: group_addr, interface_name
    :param igmp_static_groups: Keyword argument tuple.

    :type group_addr: long
    :param group_addr: **igmp_static_groups** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_name: unicode
    :param interface_name: **igmp_static_groups** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state', 'igmp_static_groups_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups', 'pybind.slxos.v17s_1_02.brocade_mc_hms_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.igmp_static_groups_state.igmp_static_groups', u'igmpv3_sources')]
    compositions_keyval_list = [{'keyval': 'group_addr, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmp_static_groups', 'keyval': 'group_addr, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmp_static_groups_state=igmp_static_groups_state, igmp_static_groups=igmp_static_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface', u'loopback'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.interface', u'tunnel'), ('pybind.slxos.v17r_1_01a.system_config', u'interface'), ('pybind.slxos.v17r_1_01a.openflow_state', u'interface'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17r_1_01a.interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface', u'management'), ('pybind.slxos.v17r_1_01a.telemetry.profile', u'interface'), ('pybind.slxos.v17r_1_01a.logging.raslog', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface', u've'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.interface', u'email_list'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor', u'interface'), ('pybind.slxos.v17r_1_01a.interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.system_monitor_mail', u'interface'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17s_1_02.logging.raslog', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface', u've'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor', u'interface'), ('pybind.slxos.v17s_1_02.interface', u'ethernet'), ('pybind.slxos.v17s_1_02.system_monitor_mail.interface', u'email_list'), ('pybind.slxos.v17s_1_02.interface', u'port_channel'), ('pybind.slxos.v17s_1_02.interface', u'management'), ('pybind.slxos.v17s_1_02.interface', u'tunnel'), ('pybind.slxos.v17s_1_02.system_monitor_mail', u'interface'), ('pybind.slxos.v17s_1_02.openflow_state', u'interface'), ('pybind.slxos.v17s_1_02.mpls_state', u'interface'), ('pybind.slxos.v17s_1_02.interface', u'homerun'), ('pybind.slxos.v17s_1_02.routing_system.interface', u'loopback'), ('pybind.slxos.v17s_1_02.telemetry.profile', u'interface'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.interface', u'management'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17r_2_00.interface', u'port_channel'), ('pybind.slxos.v17r_2_00.system_monitor_mail', u'interface'), ('pybind.slxos.v17r_2_00.system_config', u'interface'), ('pybind.slxos.v17r_2_00.logging.raslog', u'interface'), ('pybind.slxos.v17r_2_00.system_monitor_mail.interface', u'email_list'), ('pybind.slxos.v17r_2_00.routing_system.interface', u'loopback'), ('pybind.slxos.v17r_2_00.interface', u'ethernet'), ('pybind.slxos.v17r_2_00.openflow_state', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface', u've'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor', u'interface'), ('pybind.slxos.v17r_2_00.interface', u'tunnel'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface', u'loopback')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'id'}, {'leafval': 'id, shutdown'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'identifier, tunnel_destination, tunnel_shutdown, gre_ttl, gre_dscp, tunnel_name, dscp_ttl_mode, statistics'}, {'leafval': 'utilization_watermark'}, {'leafval': 'port, link, port_state, speed, mac, port_id, mode'}, {'leafval': 'policy_name'}, {'leafval': 'name, po_speed, ifindex, description, shutdown, minimum_links, mtu, route_only, priority_tag_enable, load_balance, load_balance_type, port_profile_port'}, {'leafval': 'name, speed, shutdown_management, shutdown_management_oper'}, {'leafval': 'name, interval'}, {'leafval': 'description'}, {'leafval': 'name, shutdown'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'email'}, {'leafval': 'apply, pause'}, {'leafval': 'name, long_distance_isl, speed, ifindex, description, shutdown, mtu, route_only, priority_tag_enable, port_profile_port'}, {'leafval': 'enable'}, {'leafval': 'policy_name'}, {'leafval': 'description'}, {'leafval': 'name, shutdown'}, {'leafval': 'apply, pause'}, {'leafval': 'name, long_distance_isl, cee, speed, ifindex, description, shutdown, mtu, priority_tag_enable, port_profile_port'}, {'leafval': 'email'}, {'leafval': 'name, cee, po_speed, ifindex, description, shutdown, minimum_links, mtu, priority_tag_enable, load_balance, load_balance_type, port_profile_port'}, {'leafval': 'name, speed, shutdown_management, shutdown_management_oper'}, {'leafval': 'identifier, tunnel_destination, tunnel_shutdown, gre_ttl, gre_dscp, tunnel_name, dscp_ttl_mode, statistics'}, {'leafval': 'enable'}, {'leafval': 'port, link, port_state, speed, mac, port_id, mode'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'name, ifindex, description, shutdown, mtu'}, {'leafval': 'id, shutdown'}, {'leafval': 'name, interval'}, {'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'name, speed, shutdown_management, shutdown_management_oper'}, {'leafval': 'name, interval'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'policy_name'}, {'leafval': 'name, po_speed, ifindex, description, shutdown, minimum_links, mtu, route_only, tag_type, priority_tag_enable, load_balance, load_balance_type, port_profile_port, offsets'}, {'leafval': 'enable'}, {'leafval': 'utilization_watermark'}, {'leafval': 'description'}, {'leafval': 'email'}, {'leafval': 'id, shutdown'}, {'leafval': 'name, long_distance_isl, loopback, speed, ifindex, description, shutdown, mtu, route_only, tag_type, priority_tag_enable, strip_header, port_profile_port'}, {'leafval': 'port, interface_type, interface_name, link, port_state, speed, mac, port_id, mode'}, {'leafval': 'name, shutdown'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'apply, pause'}, {'leafval': 'identifier, tunnel_destination, tunnel_shutdown, gre_ttl, gre_dscp, tunnel_name, dscp_ttl_mode, statistics'}, {'leafval': 'id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface', u'management'), ('pybind.nos.v6_0_2f.interface', u'port_channel'), ('pybind.nos.v6_0_2f.interface', u'fcoe'), ('pybind.nos.v6_0_2f.interface_vlan.interface', u'vlan'), ('pybind.nos.v6_0_2f.interface', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface', u'gigabitethernet'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor', u'interface'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.nos.v6_0_2f.interface', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.system_monitor_mail.interface', u'email_list'), ('pybind.nos.v6_0_2f.interface_vlan.interface', u've'), ('pybind.nos.v6_0_2f.system_monitor_mail', u'interface'), ('pybind.nos.v6_0_2f.interface', u'fc_port'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface', u'loopback'), ('pybind.nos.v7_2_0.interface', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface_vlan.interface', u've'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor', u'interface'), ('pybind.nos.v7_2_0.system_monitor_mail', u'interface'), ('pybind.nos.v7_2_0.interface', u'management'), ('pybind.nos.v7_2_0.interface', u'fcoe'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface', u'loopback'), ('pybind.nos.v7_2_0.interface_vlan.interface', u'vlan'), ('pybind.nos.v7_2_0.system_monitor_mail.interface', u'email_list'), ('pybind.nos.v7_2_0.interface', u'port_channel'), ('pybind.nos.v7_2_0.interface', u'fc_port'), ('pybind.nos.v7_2_0.interface', u'gigabitethernet'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface', u'policy')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, speed, shutdown_management, shutdown_management_oper'}, {'leafval': 'name, cee, po_speed, ifindex, description, shutdown, minimum_links, mtu, load_balance, port_profile_port, priority_tag_enable'}, {'leafval': 'fcoe_interface_name, fcoe_interface_shutdown'}, {'leafval': 'name, transport_service, ifindex, description, vlan_name, remote_span'}, {'leafval': 'name, cee, ifindex, description, shutdown, mtu, port_profile_port, priority_tag_enable'}, {'leafval': 'name, ifindex, description, shutdown, mtu, port_profile_port, priority_tag_enable'}, {'leafval': 'apply, pause'}, {'leafval': 'policy_name'}, {'leafval': 'name, cee, ifindex, description, shutdown, mtu, port_profile_port, priority_tag_enable'}, {'leafval': 'name, long_distance_isl, cee, speed, ifindex, description, shutdown, mtu, port_profile_port, priority_tag_enable'}, {'leafval': 'email'}, {'leafval': 'gve_name, global_ve_shutdown'}, {'leafval': 'enable'}, {'leafval': 'name, fc_speed_cfg, fill_word, long_distance, vc_link_init, desire_distance, isl_r_rdy_mode, trunk_enable, shutdown, config_mode, fec_enable, description'}, {'leafval': 'id'}, {'leafval': 'name, long_distance_isl, cee, speed, ifindex, description, shutdown, mtu, port_profile_port, priority_tag_enable'}, {'leafval': 'name, cee, ifindex, description, shutdown, mtu, port_profile_port, priority_tag_enable'}, {'leafval': 'name, cee, ifindex, description, shutdown, mtu, port_profile_port, priority_tag_enable'}, {'leafval': 'gve_name, global_ve_shutdown'}, {'leafval': 'apply, pause'}, {'leafval': 'enable'}, {'leafval': 'name, speed, shutdown_management, shutdown_management_oper'}, {'leafval': 'fcoe_interface_name, fcoe_interface_shutdown'}, {'leafval': 'id'}, {'leafval': 'name, transport_service, ifindex, description, vlan_name, remote_span'}, {'leafval': 'email'}, {'leafval': 'name, cee, po_speed, ifindex, description, shutdown, minimum_links, mtu, load_balance, port_profile_port, priority_tag_enable'}, {'leafval': 'name, fc_speed_cfg, fill_word, long_distance, vc_link_init, desire_distance, isl_r_rdy_mode, trunk_enable, shutdown, config_mode, fec_enable, description'}, {'leafval': 'name, ifindex, description, shutdown, mtu, port_profile_port, priority_tag_enable'}, {'leafval': 'policy_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_1_01a.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'track'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'udld'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'qos'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'udld'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrpe'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'qos'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fec'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.ethernet.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'channel_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf_mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17s_1_02.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'connectivity'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lacp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'track'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'deny'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'sflow'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vepa'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17s_1_02.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ipv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lldp'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'dot1x'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'udld'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fec'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'qos'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'offsets_container'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'track'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_2_00.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'rpf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'accessvlan'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'sticky_flag'}, {'leafval': 'basic'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'disable'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'link_fault_action'}, {'leafval': 'log, mode'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'mtu'}, {'leafval': 'in_, out'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'bfd_enable'}, {'leafval': 'root'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'raguard'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'use_link_local_only'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'instance_id'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vepa_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trust'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'profile_domain_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'address_suppress_all'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'acl_name'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'gateway'}, {'leafval': 'max_interval, min_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'vlan_mode'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'udld_enable'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'route_map_name'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'channel'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'rx, tx'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'fcoeport_map'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'attempts, time'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'critical_event_action'}, {'leafval': 'native_vlan'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'expire'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'forwarding'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'gateway'}, {'leafval': 'trust'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'udld_enable'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'rx, tx'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'fec_mode'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'disable'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'profile_domain_name'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'id, cost, priority'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'in_, out'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mode'}, {'leafval': 'accessvlan'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'mtu'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'route_map_name'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'root'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'add_, remove_'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ingress, egress'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'address_suppress_all'}, {'leafval': 'max_interval, min_'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'instance_id'}, {'leafval': 'bfd_enable'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'basic'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'vepa_enable'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'fcoeport_map'}, {'leafval': 'raguard'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'native_vlan'}, {'leafval': 'log'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'expire'}, {'leafval': 'vlan_mode'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'interface_bfd_disable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'disable'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rx, tx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'accessvlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vepa_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'root'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'sticky_flag'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'fec_mode'}, {'leafval': 'learn_any'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'critical_event_action'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'expire'}, {'leafval': 'attempts, time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'in_, out'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'key_chain'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'forwarding'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'profile_domain_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trust'}, {'leafval': 'instance_id, shutdown, name'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'acl_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address_suppress_all'}, {'leafval': 'route_map_name'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'raguard'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'id, cost, priority'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'offsets'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'fcoeport_map'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'key_chain'}, {'leafval': 'link_fault_action'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'gateway'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'mtu'}, {'leafval': 'basic'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'channel'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'use_link_local_only'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'enable'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'log, mode'}]
    leafval_map = {"pybind.slxos.v17r_2_00.interface.ethernet": {}, "pybind.slxos.v17r_1_01a.interface.ethernet": {"priority_tag_enable": "priority_tag_enable", "long_distance_isl": "long_distance_isl", "name": "name", "mtu": "mtu", "shutdown": "shutdown", "ifindex": "ifindex", "route_only": "route_only", "speed": "speed", "port_profile_port": "port_profile_port", "description": "description"}, "pybind.slxos.v17s_1_02.interface.ethernet": {"priority_tag_enable": "priority_tag_enable", "long_distance_isl": "long_distance_isl", "name": "name", "mtu": "mtu", "shutdown": "shutdown", "ifindex": "ifindex", "speed": "speed", "port_profile_port": "port_profile_port", "description": "description"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_bfd_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.bfd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.bfd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_bfd_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_bfd_interval_min_rx_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_bfd_interval_min_tx_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_bfd_interval_multiplier_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_bfd_shutdown_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.bfd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.bfd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_cee_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'udld'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrpe'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'qos'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fec'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.ethernet.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'channel_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf_mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17s_1_02.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'connectivity'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lacp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'track'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'deny'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'sflow'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vepa'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17s_1_02.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ipv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lldp'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'dot1x'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'gateway'}, {'leafval': 'trust'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'udld_enable'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'rx, tx'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'fec_mode'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'disable'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'profile_domain_name'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'id, cost, priority'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'in_, out'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mode'}, {'leafval': 'accessvlan'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'mtu'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'route_map_name'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'root'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'add_, remove_'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ingress, egress'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'address_suppress_all'}, {'leafval': 'max_interval, min_'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'instance_id'}, {'leafval': 'bfd_enable'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'basic'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'vepa_enable'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'fcoeport_map'}, {'leafval': 'raguard'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'native_vlan'}, {'leafval': 'log'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'expire'}, {'leafval': 'vlan_mode'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'interface_bfd_disable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_channel_group_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.channel_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.channel_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.channel_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'port_int, mode, type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_channel_group_mode_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.channel_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.channel_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.channel_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_channel_group_port_int_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.channel_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.channel_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.channel_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_channel_group_type_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.channel_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.channel_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.channel_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_delay_link_event_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.delay_link_event', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.delay_link_event', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_delay_link_event_delay_link_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.delay_link_event.delay_link', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event.delay_link', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.delay_link_event.delay_link', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_delay_link_event_delay_link_event_entry_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.delay_link_event.delay_link', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event.delay_link', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.delay_link_event.delay_link', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_delay_link_event_delay_link_event_type_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.delay_link_event.delay_link', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event.delay_link', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.delay_link_event.delay_link', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_deny_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.deny', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_deny_inner_gtp_https_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.deny', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_description_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'udld'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrpe'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'qos'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fec'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.ethernet.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'channel_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf_mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17s_1_02.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'connectivity'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lacp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'track'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'deny'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'sflow'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vepa'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17s_1_02.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ipv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lldp'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'dot1x'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'udld'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fec'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'qos'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'offsets_container'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'track'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_2_00.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_1_01a.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'track'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'udld'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'qos'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'gateway'}, {'leafval': 'trust'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'udld_enable'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'rx, tx'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'fec_mode'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'disable'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'profile_domain_name'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'id, cost, priority'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'in_, out'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mode'}, {'leafval': 'accessvlan'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'mtu'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'route_map_name'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'root'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'add_, remove_'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ingress, egress'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'address_suppress_all'}, {'leafval': 'max_interval, min_'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'instance_id'}, {'leafval': 'bfd_enable'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'basic'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'vepa_enable'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'fcoeport_map'}, {'leafval': 'raguard'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'native_vlan'}, {'leafval': 'log'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'expire'}, {'leafval': 'vlan_mode'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'interface_bfd_disable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'disable'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rx, tx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'accessvlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vepa_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'root'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'sticky_flag'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'fec_mode'}, {'leafval': 'learn_any'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'critical_event_action'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'expire'}, {'leafval': 'attempts, time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'in_, out'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'key_chain'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'forwarding'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'profile_domain_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trust'}, {'leafval': 'instance_id, shutdown, name'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'acl_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address_suppress_all'}, {'leafval': 'route_map_name'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'raguard'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'id, cost, priority'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'offsets'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'fcoeport_map'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'key_chain'}, {'leafval': 'link_fault_action'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'gateway'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'mtu'}, {'leafval': 'basic'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'channel'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'use_link_local_only'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'enable'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'log, mode'}, {'leafval': 'accessvlan'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'sticky_flag'}, {'leafval': 'basic'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'disable'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'link_fault_action'}, {'leafval': 'log, mode'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'mtu'}, {'leafval': 'in_, out'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'bfd_enable'}, {'leafval': 'root'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'raguard'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'use_link_local_only'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'instance_id'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vepa_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trust'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'profile_domain_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'address_suppress_all'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'acl_name'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'gateway'}, {'leafval': 'max_interval, min_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'vlan_mode'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'udld_enable'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'route_map_name'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'channel'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'rx, tx'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'fcoeport_map'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'attempts, time'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'critical_event_action'}, {'leafval': 'native_vlan'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'expire'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'forwarding'}, {'leafval': 'encrypttype, auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_deviceconnectivity_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.connectivity', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.connectivity', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.connectivity', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_dot1x_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_dot1x_authentication_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_dot1x_filter_strict_security_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_dot1x_max_req_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_dot1x_port_control_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_dot1x_protocol_version_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_dot1x_quiet_period_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_dot1x_reauthentication_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_dot1x_reauthmax_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_dot1x_timeout_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x.timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x.timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x.timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_dot1x_timeout_re_authperiod_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x.timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x.timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x.timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_dot1x_timeout_server_timeout_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x.timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x.timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x.timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_dot1x_timeout_supp_timeout_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x.timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x.timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x.timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_dot1x_timeout_tx_period_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x.timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x.timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x.timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_edge_loop_detection_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.edge_loop_detection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_edge_loop_detection_native_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.edge_loop_detection_native', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.edge_loop_detection_native', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_edge_loop_detection_port_priority_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.edge_loop_detection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_edge_loop_detection_vlan_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.edge_loop_detection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_fabric_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_fabric_dport_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.fabric.fabric_dport', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric.fabric_dport', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric.fabric_dport', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_fabric_dport_enable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.fabric.fabric_dport', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric.fabric_dport', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric.fabric_dport', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_fabric_isl_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.fabric.fabric_isl', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric.fabric_isl', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric.fabric_isl', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_fabric_isl_enable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.fabric.fabric_isl', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric.fabric_isl', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric.fabric_isl', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_fabric_neighbor_discovery_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.fabric.neighbor_discovery', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric.neighbor_discovery', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric.neighbor_discovery', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_fabric_neighbor_discovery_disable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.fabric.neighbor_discovery', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric.neighbor_discovery', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric.neighbor_discovery', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_fabric_trunk_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.fabric.fabric_trunk', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric.fabric_trunk', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric.fabric_trunk', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_fabric_trunk_enable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.fabric.fabric_trunk', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric.fabric_trunk', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric.fabric_trunk', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_fcoeport_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.fcoeport', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.fcoeport', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.fcoeport', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_fcoeport_map_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.fcoeport', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.fcoeport', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.fcoeport', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_fec_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.fec', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.fec', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_fec_mode_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.fec', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.fec', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ifindex_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'udld'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrpe'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'qos'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fec'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.ethernet.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'channel_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf_mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17s_1_02.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'connectivity'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lacp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'track'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'deny'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'sflow'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vepa'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17s_1_02.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ipv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lldp'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'dot1x'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'udld'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fec'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'qos'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'offsets_container'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'track'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_2_00.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_1_01a.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'track'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'udld'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'qos'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'gateway'}, {'leafval': 'trust'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'udld_enable'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'rx, tx'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'fec_mode'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'disable'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'profile_domain_name'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'id, cost, priority'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'in_, out'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mode'}, {'leafval': 'accessvlan'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'mtu'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'route_map_name'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'root'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'add_, remove_'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ingress, egress'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'address_suppress_all'}, {'leafval': 'max_interval, min_'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'instance_id'}, {'leafval': 'bfd_enable'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'basic'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'vepa_enable'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'fcoeport_map'}, {'leafval': 'raguard'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'native_vlan'}, {'leafval': 'log'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'expire'}, {'leafval': 'vlan_mode'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'interface_bfd_disable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'disable'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rx, tx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'accessvlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vepa_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'root'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'sticky_flag'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'fec_mode'}, {'leafval': 'learn_any'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'critical_event_action'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'expire'}, {'leafval': 'attempts, time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'in_, out'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'key_chain'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'forwarding'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'profile_domain_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trust'}, {'leafval': 'instance_id, shutdown, name'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'acl_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address_suppress_all'}, {'leafval': 'route_map_name'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'raguard'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'id, cost, priority'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'offsets'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'fcoeport_map'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'key_chain'}, {'leafval': 'link_fault_action'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'gateway'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'mtu'}, {'leafval': 'basic'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'channel'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'use_link_local_only'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'enable'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'log, mode'}, {'leafval': 'accessvlan'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'sticky_flag'}, {'leafval': 'basic'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'disable'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'link_fault_action'}, {'leafval': 'log, mode'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'mtu'}, {'leafval': 'in_, out'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'bfd_enable'}, {'leafval': 'root'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'raguard'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'use_link_local_only'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'instance_id'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vepa_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trust'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'profile_domain_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'address_suppress_all'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'acl_name'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'gateway'}, {'leafval': 'max_interval, min_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'vlan_mode'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'udld_enable'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'route_map_name'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'channel'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'rx, tx'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'fcoeport_map'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'attempts, time'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'critical_event_action'}, {'leafval': 'native_vlan'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'expire'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'forwarding'}, {'leafval': 'encrypttype, auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_interface_eth_isis_conf_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_intf_isis_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_access_group_get(self, ethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip_acl_interface.ip.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface.ip.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_acl_interface.ip.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': 'ip_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_access_group_traffic_type_get(self, ethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip_acl_interface.ip.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface.ip.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_acl_interface.ip.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_acl_interface_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip_acl_interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_acl_interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_address_get(self, ethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary, ospf_passive, ospf_ignore
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: **address** tuple argument:  ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: **address** tuple argument:  ospf active address on the specific interface

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config.address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config.address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_address_ospf_ignore_get(self, ethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config.address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config.address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_address_ospf_passive_get(self, ethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config.address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config.address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_address_secondary_get(self, ethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config.address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config.address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_arp_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.arp_node_config.arp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_arp_aging_timeout_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_arp_inspection_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp.inspection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.arp_node_config.arp.inspection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_arp_inspection_filter_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp.inspection.filter', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection.filter', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_arp_inspection_filter_acl_name_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp.inspection.filter', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection.filter', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_arp_inspection_trust_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp.inspection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.arp_node_config.arp.inspection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_arp_ip_config_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config.arp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config.arp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_arp_learn_any_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config.arp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config.arp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_arp_node_config_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.arp_node_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_dhcp_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_dhcp_relay_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_dhcp_relay_gateway_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_dhcp_relay_servers_get(self, ethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  A.B.C.D;; IP address of the DHCP server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCP server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr, server_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_directed_broadcast_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_icmp_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.icmp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.icmp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.icmp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_icmp_rate_limiting_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.icmp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.icmp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.icmp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_icmp_redirect_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.icmp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.icmp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.icmp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_igmp_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp": {}, "pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp": {"igmpl3_query_max_response_time": "igmpl3_query_max_response_time", "igmpl3_immediate_leave": "igmpl3_immediate_leave", "igmpl3_query_interval": "igmpl3_query_interval", "igmpl3_last_member_query_interval": "igmpl3_last_member_query_interval", "igmpl3_version": "igmpl3_version"}, "pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp": {"igmpl3_query_max_response_time": "igmpl3_query_max_response_time", "igmpl3_immediate_leave": "igmpl3_immediate_leave", "igmpl3_query_interval": "igmpl3_query_interval", "igmpl3_last_member_query_interval": "igmpl3_last_member_query_interval", "igmpl3_version": "igmpl3_version"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_igmp_igmp_phy_intf_cfg_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_igmp_immediate_leave_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_igmp_last_member_query_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_igmp_phy_intf_cfg_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_igmp_query_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_igmp_query_max_response_time_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_igmp_static_group_get(self, ethernet=None, igmpl3_static_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type igmpl3_static_group: igmpl3_sg_addr
    :param igmpl3_static_group: Keyword argument tuple.

    :type igmpl3_sg_addr: unicode
    :param igmpl3_sg_addr: **igmpl3_static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp.igmpl3_static_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp.igmpl3_static_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp.igmpl3_static_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmpl3_static_group', 'keyval': 'igmpl3_sg_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, igmpl3_static_group=igmpl3_static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, igmpl3_static_group=igmpl3_static_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_igmp_version_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_interface_eth_dhcp_conf_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_interface_eth_ospf_conf_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_intf_router_isis_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.intf_router_isis', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.intf_router_isis', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.intf_router_isis', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ip_acl_interface_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip_acl_interface.ip', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface.ip', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_acl_interface.ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ip_config_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ip_pbr_interface_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip_pbr_interface.ip', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_pbr_interface.ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_mtu_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_multicast_boundary_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_active_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_area_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_auth_change_wait_time_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_authentication_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_authentication_key_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_authentication_key_auth_key_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_authentication_key_auth_key_table_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_authentication_key_chain_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_authentication_key_encrypttype_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_authentication_key_no_encrypt_auth_key_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_authentication_key_no_encrypt_auth_key_table_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_bfd_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.bfd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.bfd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.bfd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_bfd_intf_bfd_enable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.bfd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.bfd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.bfd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_cost_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_database_filter_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_database_filter_all_external_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_database_filter_all_out_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_database_filter_all_summary_external_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_dead_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_hello_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_ldp_sync_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_md5_authentication_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_md5_authentication_key_activation_wait_time_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_md5_authentication_key_id_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'key_id, key, md5_authentication_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_md5_authentication_key_id_key_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_md5_authentication_key_id_key_id_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_md5_authentication_no_encrypt_key_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_md5_authentication_no_encrypt_key_id_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_md5_authentication_no_encrypt_key_table_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_encrypt_key_id, no_encrypt_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_mtu_ignore_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_network_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_passive_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_priority_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_retransmit_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_ospf_transmit_delay_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_pbr_interface_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip_pbr_interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_pbr_interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_pim_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_pim_dr_priority_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_pim_int_cmd_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_pim_intf_phy_cont_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_pim_neighbor_filter_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_pim_sparse_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_pim_ttl_threshold_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_policy_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip_pbr_interface.ip.policy', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip.policy', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_pbr_interface.ip.policy', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_policy_route_map_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_policy_route_map_route_map_name_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_proxy_arp_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_router_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_router_isis_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_unnumbered_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config.unnumbered', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config.unnumbered', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ip_donor_interface_type, ip_donor_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_unnumbered_ip_donor_interface_name_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config.unnumbered', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config.unnumbered', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ip_unnumbered_ip_donor_interface_type_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config.unnumbered', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config.unnumbered', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_access_group_get(self, ethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': 'ipv6_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_access_group_traffic_type_get(self, ethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_address_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_address_ipv6_address_get(self, ethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_address_ipv6_address_anycast_get(self, ethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_address_ipv6_address_eui_64_get(self, ethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_address_ipv6_address_secondary_get(self, ethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_address_ipv6_address_secondary_eui_config_get(self, ethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_address_link_local_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_address_link_local_address_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_address_link_local_config_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_address_use_link_local_only_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_dhcp_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_dhcp_relay_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_dhcp_relay_servers_get(self, ethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_dhcp_relay_servers_interface_get(self, ethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_dhcp_relay_servers_interface_interface_get(self, ethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_dhcp_relay_servers_interface_interface_name_get(self, ethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_dhcp_relay_servers_use_vrf_get(self, ethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_hop_by_hop_trap_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_icmpv6_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.icmpv6', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.icmpv6', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.icmpv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_icmpv6_rate_limiting_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.icmpv6', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.icmpv6', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.icmpv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_icmpv6_redirect_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.icmpv6', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.icmpv6', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.icmpv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_interface_phy_dhcp_conf_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_intf_ipv6_router_isis_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.intf_ipv6_router_isis', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.intf_ipv6_router_isis', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.intf_ipv6_router_isis', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ipv6_config_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ipv6_intf_cmds_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ipv6_nd_ra_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ipv6_phy_intf_cmds_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_mtu_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_address_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_address_suppress_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_address_suppressing_address_get(self, ethernet=None, suppressing_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type suppressing_address: suppress_ipv6_address
    :param suppressing_address: Keyword argument tuple.

    :type suppress_ipv6_address: unicode
    :param suppress_ipv6_address: **suppressing_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address.suppressing_address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address.suppressing_address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address.suppressing_address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'suppressing_address', 'keyval': 'suppress_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, suppressing_address=suppressing_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, suppressing_address=suppressing_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_address_suppressing_address_suppress_get(self, ethernet=None, suppressing_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type suppressing_address: suppress_ipv6_address
    :param suppressing_address: Keyword argument tuple.

    :type suppress_ipv6_address: unicode
    :param suppress_ipv6_address: **suppressing_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address.suppressing_address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address.suppressing_address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address.suppressing_address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'suppressing_address', 'keyval': 'suppress_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, suppressing_address=suppressing_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, suppressing_address=suppressing_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_broadcast_mac_trap_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_cache_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'expire'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_cache_expire_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_dad_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_dad_attempts_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_dad_time_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_hoplimit_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_managed_config_flag_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_mtu_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ns_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_nud_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_nud_retry_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'base, interval, max_attempts'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_nud_retry_base_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_nud_retry_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_nud_retry_max_attempts_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_other_config_flag_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_get(self, ethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'preferred_lifetime, preferred_infinite'}, {'leafval': 'no_advertise, valid_lifetime, valid_infinite'}, {'leafval': 'no_autoconfig, no_onlink, off_link'}, {'leafval': 'preferred_lifetime, preferred_infinite'}, {'leafval': 'no_advertise, valid_lifetime, valid_infinite'}, {'leafval': 'no_autoconfig, no_onlink, off_link'}, {'leafval': 'preferred_lifetime, preferred_infinite'}, {'leafval': 'no_advertise, valid_lifetime, valid_infinite'}, {'leafval': 'no_autoconfig, no_onlink, off_link'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_infinite_get(self, ethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_infinite_preferred_get(self, ethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_no_advertise_get(self, ethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_no_autoconfig_get(self, ethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_no_onlink_get(self, ethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_off_link_get(self, ethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_preferred_get(self, ethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'preferred_lifetime, preferred_infinite'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_preferred_lifetime_get(self, ethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_prefix_flags_get(self, ethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_autoconfig, no_onlink, off_link'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_prefix_valid_lifetime_get(self, ethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_proxy_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ra_dns_server_get(self, ethernet=None, ra_dns_server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ra_dns_server: dns_server_prefix
    :param ra_dns_server: Keyword argument tuple.

    :type dns_server_prefix: unicode
    :param dns_server_prefix: **ra_dns_server** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_dns_server', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_dns_server', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_dns_server', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ra_dns_server', 'keyval': 'dns_server_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ra_dns_server=ra_dns_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ra_dns_server=ra_dns_server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ra_dns_server_lifetime_multiplier_get(self, ethernet=None, ra_dns_server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ra_dns_server: dns_server_prefix
    :param ra_dns_server: Keyword argument tuple.

    :type dns_server_prefix: unicode
    :param dns_server_prefix: **ra_dns_server** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_dns_server', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_dns_server', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_dns_server', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ra_dns_server', 'keyval': 'dns_server_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ra_dns_server=ra_dns_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ra_dns_server=ra_dns_server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ra_domain_name_get(self, ethernet=None, ra_domain_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ra_domain_name: domain_name_string
    :param ra_domain_name: Keyword argument tuple.

    :type domain_name_string: unicode
    :param domain_name_string: **ra_domain_name** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_domain_name', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_domain_name', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_domain_name', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ra_domain_name', 'keyval': 'domain_name_string', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ra_domain_name=ra_domain_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ra_domain_name=ra_domain_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ra_domain_name_lifetime_multiplier_get(self, ethernet=None, ra_domain_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ra_domain_name: domain_name_string
    :param ra_domain_name: Keyword argument tuple.

    :type domain_name_string: unicode
    :param domain_name_string: **ra_domain_name** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_domain_name', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_domain_name', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_domain_name', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ra_domain_name', 'keyval': 'domain_name_string', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ra_domain_name=ra_domain_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ra_domain_name=ra_domain_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ra_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_interval, min_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ra_interval_max_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ra_interval_min_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_ra_lifetime_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_reachable_time_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_retrans_timer_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_router_preference_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'router_pref_high, router_pref_low, router_pref_medium'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_router_preference_high_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_router_preference_low_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_router_preference_medium_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_send_ra_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_suppress_ra_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_suppress_ra_all_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_suppress_ra_mtu_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_nd_suppress_ra_suppress_ra_flag_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_neighbor_get(self, ethernet=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_neighbor_hardware_address_get(self, ethernet=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_active_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_area_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication": {"key_chain": "key_chain"}, "pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication": {}, "pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_ah_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_esp_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_esp_auth_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_esp_key_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_esp_no_encrypt_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_ipsec_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_ipsec_auth_key_config_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_ipsec_disable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_ipsec_key_add_remove_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_key_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_key_chain_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_no_encrypt_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_authentication_spi_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_bfd_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_bfd_bfd_enable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_cost_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_dead_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_hello_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_hello_jitter_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_instance_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_link_interval_properties_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_mtu_ignore_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_network_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_passive_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_priority_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_retransmit_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_suppress_linklsa_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_ospf_transmit_delay_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_policy_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.policy', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.policy', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.policy', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_policy_route_map_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.policy.route_map', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.policy.route_map', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.policy.route_map', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_policy_route_map_ipv6_route_map_name_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.policy.route_map', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.policy.route_map', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.policy.route_map', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_raguard_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_router_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_router_isis_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_mac'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_advertise_backup_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_mac'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_advertisement_interval_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_mac'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_advertisement_interval_scale_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_mac'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_backup_advertisement_interval_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_mac'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_description_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_mac'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_enable_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_mac'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_hold_time_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_mac'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_nd_advertisement_timer_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_mac'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_preempt_mode_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_mac'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_priority_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_mac'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_short_path_forwarding_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_short_path_forwarding_basic_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_short_path_forwarding_revert_priority_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_track_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.track', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.track', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.track', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_track_interface_get(self, ethernet=None, vrrpv3e_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_track_interface_priority_get(self, ethernet=None, vrrpv3e_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_virtual_ip_get(self, ethernet=None, vrrpv3e_group=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_virtual_mac_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.virtual_mac', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_extended_group_virtual_mac_02e0_5200_00xx_get(self, ethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3e_group.virtual_mac', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_get(self, ethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'owner'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_advertisement_interval_get(self, ethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'owner'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_description_get(self, ethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'owner'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_enable_get(self, ethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'owner'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_hold_time_get(self, ethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'owner'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_owner_get(self, ethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group.owner', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_owner_priority_get(self, ethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group.owner', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_owner_track_priority_get(self, ethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group.owner', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_preempt_mode_get(self, ethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'owner'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_priority_get(self, ethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'owner'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_track_get(self, ethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group.track', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group.track', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group.track', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_track_interface_get(self, ethernet=None, vrrpv3_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group.track.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group.track.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_track_interface_priority_get(self, ethernet=None, vrrpv3_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group.track.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group.track.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_use_v2_checksum_get(self, ethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'owner'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_group_virtual_ip_get(self, ethernet=None, vrrpv3_group=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_ipv6_vrrp_suppress_interface_ra_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_auth_check_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_auth_check_level_1_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_auth_check_level_1_disable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_auth_check_level_2_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_auth_check_level_2_disable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_auth_key_get(self, ethernet=None, interface_auth_key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_auth_key: interface_auth_key_level, interface_auth_key_str
    :param interface_auth_key: Keyword argument tuple.

    :type interface_auth_key_level: unicode
    :param interface_auth_key_level: **interface_auth_key** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_auth_key_str: unicode
    :param interface_auth_key_str: **interface_auth_key** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_auth_key', 'keyval': 'interface_auth_key_level', 'extra_keyval': 'interface_auth_key_level, interface_auth_key_str'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_auth_key=interface_auth_key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_auth_key=interface_auth_key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_auth_key_interface_auth_key_str_get(self, ethernet=None, interface_auth_key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_auth_key: interface_auth_key_level
    :param interface_auth_key: Keyword argument tuple.

    :type interface_auth_key_level: unicode
    :param interface_auth_key_level: **interface_auth_key** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_auth_key', 'keyval': 'interface_auth_key_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_auth_key=interface_auth_key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_auth_key=interface_auth_key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_auth_mode_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_auth_mode_md5_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_auth_mode_md5_level_1_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_auth_mode_md5_level_2_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_bfd_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_bfd": {}, "pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_bfd": {"interface_bfd_enable": "interface_bfd_enable"}, "pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_bfd": {"interface_bfd_enable": "interface_bfd_enable"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_bfd_disable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_bfd_interface_bfd_enable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_circuit_type_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_hello_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_hello_interval_get(self, ethernet=None, interface_hello_interval=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_hello_interval: interface_hello_interval_level, interface_hello_interval_val
    :param interface_hello_interval: Keyword argument tuple.

    :type interface_hello_interval_level: unicode
    :param interface_hello_interval_level: **interface_hello_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_hello_interval_val: long
    :param interface_hello_interval_val: **interface_hello_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_interval', 'keyval': 'interface_hello_interval_level', 'extra_keyval': 'interface_hello_interval_level, interface_hello_interval_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_hello_interval=interface_hello_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_hello_interval=interface_hello_interval)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_hello_interval_interface_hello_interval_val_get(self, ethernet=None, interface_hello_interval=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_hello_interval: interface_hello_interval_level
    :param interface_hello_interval: Keyword argument tuple.

    :type interface_hello_interval_level: unicode
    :param interface_hello_interval_level: **interface_hello_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_interval', 'keyval': 'interface_hello_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_hello_interval=interface_hello_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_hello_interval=interface_hello_interval)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_hello_multiplier_get(self, ethernet=None, interface_hello_multiplier=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_hello_multiplier: interface_hello_multiplier_level, interface_hello_multiplier_val
    :param interface_hello_multiplier: Keyword argument tuple.

    :type interface_hello_multiplier_level: unicode
    :param interface_hello_multiplier_level: **interface_hello_multiplier** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_hello_multiplier_val: long
    :param interface_hello_multiplier_val: **interface_hello_multiplier** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_multiplier', 'keyval': 'interface_hello_multiplier_level', 'extra_keyval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_hello_multiplier=interface_hello_multiplier)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_hello_multiplier=interface_hello_multiplier)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_hello_multiplier_interface_hello_multiplier_val_get(self, ethernet=None, interface_hello_multiplier=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_hello_multiplier: interface_hello_multiplier_level
    :param interface_hello_multiplier: Keyword argument tuple.

    :type interface_hello_multiplier_level: unicode
    :param interface_hello_multiplier_level: **interface_hello_multiplier** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_multiplier', 'keyval': 'interface_hello_multiplier_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_hello_multiplier=interface_hello_multiplier)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_hello_multiplier=interface_hello_multiplier)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_hello_padding_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_hello_padding_disable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_ipv6_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_ipv6_metric_get(self, ethernet=None, interface_ipv6_metric=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_ipv6_metric: interface_ipv6_metric_level, interface_ipv6_metric_val
    :param interface_ipv6_metric: Keyword argument tuple.

    :type interface_ipv6_metric_level: unicode
    :param interface_ipv6_metric_level: **interface_ipv6_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_ipv6_metric_val: long
    :param interface_ipv6_metric_val: **interface_ipv6_metric** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_ipv6_metric', 'keyval': 'interface_ipv6_metric_level', 'extra_keyval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_ipv6_metric=interface_ipv6_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_ipv6_metric=interface_ipv6_metric)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_ipv6_metric_interface_ipv6_metric_val_get(self, ethernet=None, interface_ipv6_metric=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_ipv6_metric: interface_ipv6_metric_level
    :param interface_ipv6_metric: Keyword argument tuple.

    :type interface_ipv6_metric_level: unicode
    :param interface_ipv6_metric_level: **interface_ipv6_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_ipv6_metric', 'keyval': 'interface_ipv6_metric_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_ipv6_metric=interface_ipv6_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_ipv6_metric=interface_ipv6_metric)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_ldp_sync_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_metric_get(self, ethernet=None, interface_metric=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_metric: interface_metric_level, interface_metric_val
    :param interface_metric: Keyword argument tuple.

    :type interface_metric_level: unicode
    :param interface_metric_level: **interface_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_metric_val: long
    :param interface_metric_val: **interface_metric** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_metric', 'keyval': 'interface_metric_level', 'extra_keyval': 'interface_metric_level, interface_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_metric=interface_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_metric=interface_metric)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_metric_interface_metric_val_get(self, ethernet=None, interface_metric=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface_metric: interface_metric_level
    :param interface_metric: Keyword argument tuple.

    :type interface_metric_level: unicode
    :param interface_metric_level: **interface_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_metric', 'keyval': 'interface_metric_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface_metric=interface_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface_metric=interface_metric)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_passive_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_point_to_point_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_priority_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_priority_level_1_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_priority_level_2_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_reverse_metric_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_reverse_metric_rev_metric_common_attributes_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_reverse_metric_rev_metric_val_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_reverse_metric_te_def_metric_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_isis_reverse_metric_whole_lan_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_lacp_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.lacp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.lacp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.lacp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_lacp_default_up_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.lacp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.lacp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.lacp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_lacp_pdu_forward_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.lacp_pdu_forward', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.lacp_pdu_forward', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_lacp_pdu_forward_enable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.lacp_pdu_forward', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.lacp_pdu_forward', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_lacp_port_priority_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.lacp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.lacp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.lacp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_lacp_timeout_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.lacp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.lacp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.lacp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_error_disable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_error_disable', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_error_disable', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.link_error_disable', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_error_disable_link_error_disable_entry_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_error_disable', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_error_disable', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.link_error_disable', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_error_disable_sampling_time_in_sec_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_error_disable', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_error_disable', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.link_error_disable', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_error_disable_wait_time_in_sec_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_error_disable', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_error_disable', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.link_error_disable', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_fault_signaling_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_fault_signaling', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_fault_signaling', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.link_fault_signaling', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'rx, tx'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_fault_signaling_rx_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_fault_signaling', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_fault_signaling', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.link_fault_signaling', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_fault_signaling_tx_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_fault_signaling', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_fault_signaling', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.link_fault_signaling', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_oam_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_oam_allow_loopback_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_oam_enable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_oam_remote_failure_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_oam_remote_failure_critical_event_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure.critical_event', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure.critical_event', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_oam_remote_failure_critical_event_action_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure.critical_event', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure.critical_event', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_oam_remote_failure_dying_gasp_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure.dying_gasp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure.dying_gasp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_oam_remote_failure_dying_gasp_action_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure.dying_gasp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure.dying_gasp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_oam_remote_failure_link_fault_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure.link_fault', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure.link_fault', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_link_oam_remote_failure_link_fault_action_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure.link_fault', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure.link_fault', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_lldp_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.lldp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_lldp_cee_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.lldp.cee', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp.cee', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp.cee', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_lldp_cee_lldp_cee_on_off_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.lldp.cee', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp.cee', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp.cee', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_lldp_dcbx_version_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.lldp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_lldp_disable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.lldp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_lldp_iscsi_priority_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.lldp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_lldp_profile_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.lldp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_log_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.rpf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.rpf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)(\.([1-9]|[1-9][0-9]||[1-9][0-9]'
            '[0-9]|[1-9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]'
            '))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged', u'untagged_vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_common_commands_dummy', u'name'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container', u'tagged_outer_vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_common_commands_dummy', u'shutdown'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy', u'untagged_vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_common_commands_dummy', u'shutdown'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container', u'get_untagged_vlan_dummy'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_common_commands_dummy', u'name'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container', u'tagged_outer_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet', u'tagged_outer_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet.untagged', u'untagged_vlan')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ethernet_', 'keyval': 'instance_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'untagged_vlan_id'}, {'leafval': 'logical_interface_name'}, {'leafval': 'outer_tagged_vlan_id, inner_vlan, inner_tagged_vlan_id'}, {'leafval': 'shutdown_status'}, {'leafval': 'untagged_flag, untagged_vlan_id'}, {'leafval': 'shutdown_status'}, {'leafval': 'egress'}, {'leafval': 'logical_interface_name'}, {'leafval': 'outer_tagged_vlan_id, inner_vlan, inner_tagged_vlan_id'}, {'leafval': 'outer_tagged_vlan_id, inner_tagged_vlan_id'}, {'leafval': 'untagged_vlan_id'}]
    leafval_map = {"pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet": {"instance_id": "instance_id"}, "pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet": {"instance_id": "instance_id"}, "pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_egress_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-9][0-9]['
            '0-9][0-9]|1[0-1][0-9][0-9][0-9]|12[0-1][0-9][0-9'
            ']|122[0-7][0-9]|1228[0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_get_untagged_vlan_dummy_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)(\.([1-9]|[1-9][0-9]||[1-9][0-9]'
            '[0-9]|[1-9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]'
            '))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet', u'ethernet_'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy": {"egress": "egress"}, "pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_name_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)(\.([1-9]|[1-9][0-9]||[1-9][0-9]'
            '[0-9]|[1-9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]'
            '))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet', u'tagged_outer_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet.untagged', u'untagged_vlan')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ethernet_', 'keyval': 'instance_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_tagged_vlan_id, inner_tagged_vlan_id'}, {'leafval': 'untagged_vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_name_logical_interface_name_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)(\.([1-9]|[1-9][0-9]||[1-9][0-9]'
            '[0-9]|[1-9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]'
            '))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet', u'ethernet_'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_common_commands_dummy.name', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_common_commands_dummy.name', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_service_instance_common_commands_dummy_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)(\.([1-9]|[1-9][0-9]||[1-9][0-9]'
            '[0-9]|[1-9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]'
            '))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet', u'ethernet_'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_common_commands_dummy', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_common_commands_dummy', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_service_instance_vlan_cmds_dummy_container_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)(\.([1-9]|[1-9][0-9]||[1-9][0-9]'
            '[0-9]|[1-9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]'
            '))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet', u'ethernet_'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_shutdown_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)(\.([1-9]|[1-9][0-9]||[1-9][0-9]'
            '[0-9]|[1-9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]'
            '))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet', u'tagged_outer_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet.untagged', u'untagged_vlan')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ethernet_', 'keyval': 'instance_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_tagged_vlan_id, inner_tagged_vlan_id'}, {'leafval': 'untagged_vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_shutdown_shutdown_status_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)(\.([1-9]|[1-9][0-9]||[1-9][0-9]'
            '[0-9]|[1-9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]'
            '))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet', u'ethernet_'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_common_commands_dummy.shutdown', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_common_commands_dummy.shutdown', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_untagged_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)(\.([1-9]|[1-9][0-9]||[1-9][0-9]'
            '[0-9]|[1-9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]'
            '))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet', u'ethernet_'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet', u'ethernet_'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet.untagged', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged": {}, "pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged_vlan": {"untagged_vlan_id": "untagged_vlan_id", "untagged_flag": "untagged_flag"}, "pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet.untagged": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_untagged_untagged_flag_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-9][0-9]['
            '0-9][0-9]|1[0-1][0-9][0-9][0-9]|12[0-1][0-9][0-9'
            ']|122[0-7][0-9]|1228[0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_untagged_vlan_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9])(:[1-4])?)'
            '(\.([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-9][0-9]['
            '0-9][0-9]|1[0-1][0-9][0-9][0-9]|12[0-1][0-9][0-9'
            ']|122[0-7][0-9]|1228[0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_untagged_vlan_untagged_vlan_id_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)(\.([1-9]|[1-9][0-9]||[1-9][0-9]'
            '[0-9]|[1-9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]'
            '))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet', u'ethernet_'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged.untagged_vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet.untagged.untagged_vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_vlan_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)(\.([1-9]|[1-9][0-9]||[1-9][0-9]'
            '[0-9]|[1-9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]'
            '))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet', u'ethernet_'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet', u'ethernet_'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet.tagged_outer_vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'outer_tagged_vlan_id, inner_tagged_vlan_id'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet.tagged_outer_vlan": {}, "pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan": {"outer_tagged_vlan_id": "outer_tagged_vlan_id", "inner_vlan": "inner_vlan", "inner_tagged_vlan_id": "inner_tagged_vlan_id"}, "pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan": {"outer_tagged_vlan_id": "outer_tagged_vlan_id", "inner_vlan": "inner_vlan", "inner_tagged_vlan_id": "inner_tagged_vlan_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_vlan_inner_tagged_vlan_id_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)(\.([1-9]|[1-9][0-9]||[1-9][0-9]'
            '[0-9]|[1-9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]'
            '))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet', u'ethernet_'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_vlan_inner_vlan_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)(\.([1-9]|[1-9][0-9]||[1-9][0-9]'
            '[0-9]|[1-9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]'
            '))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet', u'ethernet_'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet', u'ethernet_'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet.tagged_outer_vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet.tagged_outer_vlan": {}, "pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan": {"inner_vlan": "inner_vlan"}, "pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan": {"inner_vlan": "inner_vlan"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_logical_interface_ethernet_vlan_outer_tagged_vlan_id_get(self, ethernet=None, ethernet_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ethernet_: instance_id
    :param ethernet_: Keyword argument tuple.

    :type instance_id: unicode
    :param instance_id: **ethernet_** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)(\.([1-9]|[1-9][0-9]||[1-9][0-9]'
            '[0-9]|[1-9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]'
            '))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet', u'ethernet_'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet', u'ethernet_'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet', u'ethernet_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface.ethernet.tagged_outer_vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface.ethernet.cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ethernet_=ethernet_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ethernet_=ethernet_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_long_distance_isl_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'udld'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrpe'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'qos'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fec'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.ethernet.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'channel_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf_mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17s_1_02.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'connectivity'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lacp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'track'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'deny'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'sflow'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vepa'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17s_1_02.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ipv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lldp'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'dot1x'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'udld'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fec'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'qos'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'offsets_container'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'track'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_2_00.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_1_01a.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'track'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'udld'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'qos'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'gateway'}, {'leafval': 'trust'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'udld_enable'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'rx, tx'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'fec_mode'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'disable'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'profile_domain_name'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'id, cost, priority'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'in_, out'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mode'}, {'leafval': 'accessvlan'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'mtu'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'route_map_name'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'root'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'add_, remove_'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ingress, egress'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'address_suppress_all'}, {'leafval': 'max_interval, min_'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'instance_id'}, {'leafval': 'bfd_enable'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'basic'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'vepa_enable'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'fcoeport_map'}, {'leafval': 'raguard'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'native_vlan'}, {'leafval': 'log'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'expire'}, {'leafval': 'vlan_mode'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'interface_bfd_disable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'disable'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rx, tx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'accessvlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vepa_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'root'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'sticky_flag'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'fec_mode'}, {'leafval': 'learn_any'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'critical_event_action'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'expire'}, {'leafval': 'attempts, time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'in_, out'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'key_chain'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'forwarding'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'profile_domain_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trust'}, {'leafval': 'instance_id, shutdown, name'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'acl_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address_suppress_all'}, {'leafval': 'route_map_name'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'raguard'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'id, cost, priority'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'offsets'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'fcoeport_map'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'key_chain'}, {'leafval': 'link_fault_action'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'gateway'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'mtu'}, {'leafval': 'basic'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'channel'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'use_link_local_only'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'enable'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'log, mode'}, {'leafval': 'accessvlan'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'sticky_flag'}, {'leafval': 'basic'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'disable'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'link_fault_action'}, {'leafval': 'log, mode'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'mtu'}, {'leafval': 'in_, out'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'bfd_enable'}, {'leafval': 'root'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'raguard'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'use_link_local_only'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'instance_id'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vepa_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trust'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'profile_domain_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'address_suppress_all'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'acl_name'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'gateway'}, {'leafval': 'max_interval, min_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'vlan_mode'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'udld_enable'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'route_map_name'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'channel'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'rx, tx'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'fcoeport_map'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'attempts, time'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'critical_event_action'}, {'leafval': 'native_vlan'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'expire'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'forwarding'}, {'leafval': 'encrypttype, auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_loop_detection_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.edge_loop_detection_native', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.edge_loop_detection_native', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_loop_detection_port_priority_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.edge_loop_detection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.edge_loop_detection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_loop_detection_shutdown_disable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.edge_loop_detection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.edge_loop_detection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_loop_detection_vlan_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.edge_loop_detection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.edge_loop_detection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_loopback_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'udld'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fec'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'qos'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'offsets_container'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'track'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_2_00.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'rpf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'disable'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rx, tx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'accessvlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vepa_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'root'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'sticky_flag'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'fec_mode'}, {'leafval': 'learn_any'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'critical_event_action'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'expire'}, {'leafval': 'attempts, time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'in_, out'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'key_chain'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'forwarding'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'profile_domain_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trust'}, {'leafval': 'instance_id, shutdown, name'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'acl_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address_suppress_all'}, {'leafval': 'route_map_name'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'raguard'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'id, cost, priority'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'offsets'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'fcoeport_map'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'key_chain'}, {'leafval': 'link_fault_action'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'gateway'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'mtu'}, {'leafval': 'basic'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'channel'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'use_link_local_only'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'enable'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'log, mode'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_mac_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.mac', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.mac', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.mac', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_mac_access_group_get(self, ethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.mac.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.mac.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.mac.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': 'mac_access_list, mac_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_mac_access_group_traffic_type_get(self, ethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.mac.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.mac.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.mac.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_mtu_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'udld'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrpe'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'qos'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fec'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.ethernet.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'channel_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf_mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17s_1_02.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'connectivity'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lacp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'track'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'deny'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'sflow'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vepa'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17s_1_02.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ipv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lldp'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'dot1x'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'udld'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fec'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'qos'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'offsets_container'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'track'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_2_00.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_1_01a.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'track'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'udld'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'qos'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'gateway'}, {'leafval': 'trust'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'udld_enable'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'rx, tx'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'fec_mode'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'disable'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'profile_domain_name'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'id, cost, priority'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'in_, out'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mode'}, {'leafval': 'accessvlan'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'mtu'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'route_map_name'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'root'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'add_, remove_'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ingress, egress'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'address_suppress_all'}, {'leafval': 'max_interval, min_'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'instance_id'}, {'leafval': 'bfd_enable'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'basic'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'vepa_enable'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'fcoeport_map'}, {'leafval': 'raguard'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'native_vlan'}, {'leafval': 'log'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'expire'}, {'leafval': 'vlan_mode'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'interface_bfd_disable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'disable'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rx, tx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'accessvlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vepa_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'root'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'sticky_flag'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'fec_mode'}, {'leafval': 'learn_any'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'critical_event_action'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'expire'}, {'leafval': 'attempts, time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'in_, out'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'key_chain'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'forwarding'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'profile_domain_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trust'}, {'leafval': 'instance_id, shutdown, name'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'acl_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address_suppress_all'}, {'leafval': 'route_map_name'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'raguard'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'id, cost, priority'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'offsets'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'fcoeport_map'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'key_chain'}, {'leafval': 'link_fault_action'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'gateway'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'mtu'}, {'leafval': 'basic'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'channel'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'use_link_local_only'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'enable'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'log, mode'}, {'leafval': 'accessvlan'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'sticky_flag'}, {'leafval': 'basic'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'disable'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'link_fault_action'}, {'leafval': 'log, mode'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'mtu'}, {'leafval': 'in_, out'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'bfd_enable'}, {'leafval': 'root'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'raguard'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'use_link_local_only'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'instance_id'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vepa_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trust'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'profile_domain_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'address_suppress_all'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'acl_name'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'gateway'}, {'leafval': 'max_interval, min_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'vlan_mode'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'udld_enable'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'route_map_name'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'channel'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'rx, tx'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'fcoeport_map'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'attempts, time'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'critical_event_action'}, {'leafval': 'native_vlan'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'expire'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'forwarding'}, {'leafval': 'encrypttype, auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_npb_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.npb', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_npb_policy_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.npb.policy', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_npb_policy_route_map_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.npb.policy.route_map', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_npb_policy_route_map_npb_route_map_name_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.npb.policy.route_map', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_offsets_container_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.offsets_container', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_openflow_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_openflow_enable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.openflow.enableInterfaceLevel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow.enableInterfaceLevel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow.enableInterfaceLevel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'modeType, hybrid_mode'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_openflow_enable_hybrid_mode_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.openflow.enableInterfaceLevel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow.enableInterfaceLevel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow.enableInterfaceLevel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_openflow_enable_modetype_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.openflow.enableInterfaceLevel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow.enableInterfaceLevel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow.enableInterfaceLevel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_openflow_protected_vlans_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.openflow.protected_vlans', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow.protected_vlans', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow.protected_vlans', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_openflow_protected_vlans_add_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.openflow.protected_vlans', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow.protected_vlans', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow.protected_vlans', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_openflow_protected_vlans_remove_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.openflow.protected_vlans', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow.protected_vlans', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow.protected_vlans', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_port_profile_port_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'udld'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrpe'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'qos'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fec'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.ethernet.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'channel_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf_mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17s_1_02.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'connectivity'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lacp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'track'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'deny'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'sflow'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vepa'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17s_1_02.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ipv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lldp'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'dot1x'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'udld'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fec'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'qos'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'offsets_container'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'track'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_2_00.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_1_01a.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'track'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'udld'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'qos'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'gateway'}, {'leafval': 'trust'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'udld_enable'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'rx, tx'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'fec_mode'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'disable'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'profile_domain_name'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'id, cost, priority'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'in_, out'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mode'}, {'leafval': 'accessvlan'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'mtu'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'route_map_name'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'root'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'add_, remove_'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ingress, egress'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'address_suppress_all'}, {'leafval': 'max_interval, min_'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'instance_id'}, {'leafval': 'bfd_enable'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'basic'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'vepa_enable'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'fcoeport_map'}, {'leafval': 'raguard'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'native_vlan'}, {'leafval': 'log'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'expire'}, {'leafval': 'vlan_mode'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'interface_bfd_disable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'disable'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rx, tx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'accessvlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vepa_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'root'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'sticky_flag'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'fec_mode'}, {'leafval': 'learn_any'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'critical_event_action'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'expire'}, {'leafval': 'attempts, time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'in_, out'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'key_chain'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'forwarding'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'profile_domain_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trust'}, {'leafval': 'instance_id, shutdown, name'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'acl_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address_suppress_all'}, {'leafval': 'route_map_name'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'raguard'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'id, cost, priority'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'offsets'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'fcoeport_map'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'key_chain'}, {'leafval': 'link_fault_action'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'gateway'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'mtu'}, {'leafval': 'basic'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'channel'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'use_link_local_only'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'enable'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'log, mode'}, {'leafval': 'accessvlan'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'sticky_flag'}, {'leafval': 'basic'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'disable'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'link_fault_action'}, {'leafval': 'log, mode'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'mtu'}, {'leafval': 'in_, out'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'bfd_enable'}, {'leafval': 'root'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'raguard'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'use_link_local_only'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'instance_id'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vepa_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trust'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'profile_domain_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'address_suppress_all'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'acl_name'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'gateway'}, {'leafval': 'max_interval, min_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'vlan_mode'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'udld_enable'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'route_map_name'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'channel'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'rx, tx'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'fcoeport_map'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'attempts, time'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'critical_event_action'}, {'leafval': 'native_vlan'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'expire'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'forwarding'}, {'leafval': 'encrypttype, auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_port_profile_port_domain_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_port_profile_port_domain_profile_domain_name_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_port_profile_port_profile_get(self, ethernet=None, port_to_port_profile_associations=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_to_port_profile_associations: port_to_port_profile_association
    :param port_to_port_profile_associations: Keyword argument tuple.

    :type port_to_port_profile_association: unicode
    :param port_to_port_profile_association: **port_to_port_profile_associations** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_to_port_profile_associations', 'keyval': 'port_to_port_profile_association', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, port_to_port_profile_associations=port_to_port_profile_associations)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, port_to_port_profile_associations=port_to_port_profile_associations)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_port_profile_to_interface_associations_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_priority_tag_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'udld'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrpe'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'qos'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fec'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.ethernet.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'channel_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf_mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17s_1_02.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'connectivity'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lacp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'track'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'deny'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'sflow'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vepa'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17s_1_02.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ipv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lldp'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'dot1x'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'udld'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fec'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'qos'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'offsets_container'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'track'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_2_00.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_1_01a.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'track'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'udld'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'qos'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'gateway'}, {'leafval': 'trust'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'udld_enable'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'rx, tx'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'fec_mode'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'disable'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'profile_domain_name'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'id, cost, priority'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'in_, out'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mode'}, {'leafval': 'accessvlan'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'mtu'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'route_map_name'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'root'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'add_, remove_'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ingress, egress'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'address_suppress_all'}, {'leafval': 'max_interval, min_'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'instance_id'}, {'leafval': 'bfd_enable'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'basic'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'vepa_enable'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'fcoeport_map'}, {'leafval': 'raguard'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'native_vlan'}, {'leafval': 'log'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'expire'}, {'leafval': 'vlan_mode'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'interface_bfd_disable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'disable'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rx, tx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'accessvlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vepa_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'root'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'sticky_flag'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'fec_mode'}, {'leafval': 'learn_any'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'critical_event_action'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'expire'}, {'leafval': 'attempts, time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'in_, out'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'key_chain'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'forwarding'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'profile_domain_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trust'}, {'leafval': 'instance_id, shutdown, name'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'acl_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address_suppress_all'}, {'leafval': 'route_map_name'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'raguard'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'id, cost, priority'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'offsets'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'fcoeport_map'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'key_chain'}, {'leafval': 'link_fault_action'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'gateway'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'mtu'}, {'leafval': 'basic'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'channel'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'use_link_local_only'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'enable'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'log, mode'}, {'leafval': 'accessvlan'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'sticky_flag'}, {'leafval': 'basic'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'disable'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'link_fault_action'}, {'leafval': 'log, mode'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'mtu'}, {'leafval': 'in_, out'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'bfd_enable'}, {'leafval': 'root'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'raguard'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'use_link_local_only'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'instance_id'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vepa_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trust'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'profile_domain_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'address_suppress_all'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'acl_name'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'gateway'}, {'leafval': 'max_interval, min_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'vlan_mode'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'udld_enable'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'route_map_name'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'channel'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'rx, tx'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'fcoeport_map'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'attempts, time'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'critical_event_action'}, {'leafval': 'native_vlan'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'expire'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'forwarding'}, {'leafval': 'encrypttype, auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_protocol_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.protocol', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_protocol_ptp_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_protocol_ptp_announce_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_protocol_ptp_announce_timeout_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_protocol_ptp_delay_request_min_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_protocol_ptp_enable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_protocol_ptp_ptp_vlan_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_protocol_ptp_sync_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_cos_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_cos_mutation_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_cos_traffic_class_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_drop_monitor_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.drop_monitor', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.drop_monitor', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.drop_monitor', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_drop_monitor_enable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.drop_monitor', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.drop_monitor', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.drop_monitor', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_dscp_cos_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_dscp_mutation_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_dscp_traffic_class_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_link_level_flowcontrol_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_pfc_get(self, ethernet=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: int
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol.pfc', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol.pfc', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_pfc_rx_get(self, ethernet=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: int
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol.pfc', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol.pfc', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_pfc_threshold_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_pfc_tx_get(self, ethernet=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: int
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol.pfc', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol.pfc', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_rx_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_threshold_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_threshold_2_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold_tx_on, threshold_tx_off'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_threshold_off_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_threshold_on_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_threshold_pfc_get(self, ethernet=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_threshold_cos
    :param pfc: Keyword argument tuple.

    :type pfc_threshold_cos: int
    :param pfc_threshold_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold.pfc', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_threshold_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_threshold_pfc_off_get(self, ethernet=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_threshold_cos
    :param pfc: Keyword argument tuple.

    :type pfc_threshold_cos: int
    :param pfc_threshold_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold.pfc', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_threshold_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_threshold_pfc_on_get(self, ethernet=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_threshold_cos
    :param pfc: Keyword argument tuple.

    :type pfc_threshold_cos: int
    :param pfc_threshold_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold.pfc', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_threshold_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_flowcontrol_tx_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_random_detect_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.random_detect', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.random_detect', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_random_detect_traffic_class_get(self, ethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value, red_dp_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: int
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..255']

    :type red_dp_value: int
    :param red_dp_value: **traffic_class** tuple argument:  drop-precedence of the traffic-class

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.random_detect.traffic_class', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect.traffic_class', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.random_detect.traffic_class', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.interface.ethernet.qos.random_detect.traffic_class": {}, "pybind.slxos.v17r_1_01a.interface.ethernet.qos.random_detect.traffic_class": {"red_tc_value": "red_tc_value", "red_dp_value": "red_dp_value", "red_profile_id": "red_profile_id"}, "pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect.traffic_class": {"red_tc_value": "red_tc_value", "red_dp_value": "red_dp_value", "red_profile_id": "red_profile_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_random_detect_traffic_class_red_profile_id_get(self, ethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value, red_dp_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: int
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..255']

    :type red_dp_value: int
    :param red_dp_value: **traffic_class** tuple argument:  drop-precedence of the traffic-class

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.random_detect.traffic_class', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect.traffic_class', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.random_detect.traffic_class', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.interface.ethernet.qos.random_detect.traffic_class": {}, "pybind.slxos.v17r_1_01a.interface.ethernet.qos.random_detect.traffic_class": {"red_tc_value": "red_tc_value", "red_dp_value": "red_dp_value", "red_profile_id": "red_profile_id"}, "pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect.traffic_class": {"red_tc_value": "red_tc_value", "red_dp_value": "red_dp_value", "red_profile_id": "red_profile_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_cos0_threshold_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_cos1_threshold_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_cos2_threshold_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_cos3_threshold_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_cos4_threshold_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_cos5_threshold_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_cos6_threshold_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_cos_threshold_cos7_threshold_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.cos_threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_multicast_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.multicast', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.multicast', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_multicast_best_effort_rate_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.multicast', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.multicast', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_multicast_guarantee_rate_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.multicast', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.multicast', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_multicast_queue_size_get(self, ethernet=None, queue_size=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type queue_size: traffic_class, min_queue_size, max_queue_size
    :param queue_size: Keyword argument tuple.

    :type traffic_class: int
    :param traffic_class: **queue_size** tuple argument:  Traffic class to configure multicast queue size

        * range restriction: ::

            ['0..255']

    :type min_queue_size: long
    :param min_queue_size: **queue_size** tuple argument:  Configure minimum queue size

        * range restriction: ::

            ['0..4294967295']

    :type max_queue_size: long
    :param max_queue_size: **queue_size** tuple argument:  Configure maximum queue size

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.multicast.queue_size', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast.queue_size', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.multicast.queue_size', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_size', 'keyval': 'traffic_class', 'extra_keyval': 'traffic_class, min_queue_size, max_queue_size'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, queue_size=queue_size)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, queue_size=queue_size)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_multicast_queue_size_max_queue_size_get(self, ethernet=None, queue_size=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type queue_size: traffic_class
    :param queue_size: Keyword argument tuple.

    :type traffic_class: int
    :param traffic_class: **queue_size** tuple argument:  Traffic class to configure multicast queue size

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.multicast.queue_size', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast.queue_size', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.multicast.queue_size', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_size', 'keyval': 'traffic_class', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, queue_size=queue_size)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, queue_size=queue_size)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_multicast_queue_size_min_queue_size_get(self, ethernet=None, queue_size=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type queue_size: traffic_class
    :param queue_size: Keyword argument tuple.

    :type traffic_class: int
    :param traffic_class: **queue_size** tuple argument:  Traffic class to configure multicast queue size

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.multicast.queue_size', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast.queue_size', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.multicast.queue_size', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_size', 'keyval': 'traffic_class', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, queue_size=queue_size)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, queue_size=queue_size)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_unicast_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.unicast', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.unicast', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_unicast_queue_size_get(self, ethernet=None, queue_size=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type queue_size: traffic_class, min_queue_size, max_queue_size
    :param queue_size: Keyword argument tuple.

    :type traffic_class: int
    :param traffic_class: **queue_size** tuple argument:  Traffic class to configure unicast queue size

        * range restriction: ::

            ['0..255']

    :type min_queue_size: long
    :param min_queue_size: **queue_size** tuple argument:  Configure minimum queue size

        * range restriction: ::

            ['0..4294967295']

    :type max_queue_size: long
    :param max_queue_size: **queue_size** tuple argument:  Configure maximum queue size

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.unicast.queue_size', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast.queue_size', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.unicast.queue_size', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_size', 'keyval': 'traffic_class', 'extra_keyval': 'traffic_class, min_queue_size, max_queue_size'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, queue_size=queue_size)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, queue_size=queue_size)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_unicast_queue_size_max_queue_size_get(self, ethernet=None, queue_size=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type queue_size: traffic_class
    :param queue_size: Keyword argument tuple.

    :type traffic_class: int
    :param traffic_class: **queue_size** tuple argument:  Traffic class to configure unicast queue size

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.unicast.queue_size', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast.queue_size', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.unicast.queue_size', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_size', 'keyval': 'traffic_class', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, queue_size=queue_size)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, queue_size=queue_size)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_rx_queue_unicast_queue_size_min_queue_size_get(self, ethernet=None, queue_size=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type queue_size: traffic_class
    :param queue_size: Keyword argument tuple.

    :type traffic_class: int
    :param traffic_class: **queue_size** tuple argument:  Traffic class to configure unicast queue size

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.unicast.queue_size', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast.queue_size', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.unicast.queue_size', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_size', 'keyval': 'traffic_class', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, queue_size=queue_size)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, queue_size=queue_size)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_traffic_class_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_traffic_class_cos_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_trust_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.trust', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.trust', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.trust', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_trust_cos_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.trust', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.trust', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.trust', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_qos_trust_dscp_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.qos.trust', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.trust', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.trust', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_rmon_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.rmon', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_rmon_collection_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_rmon_collection_history_get(self, ethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_buckets_requested: long
    :param history_control_buckets_requested: **history_control_entry** tuple argument:  Buckets (default 50)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_interval: long
    :param history_control_interval: **history_control_entry** tuple argument:  Polling Interval (default 1800)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_owner: unicode
    :param history_control_owner: **history_control_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection.history_control_entry', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection.history_control_entry', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection.history_control_entry', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_rmon_collection_history_buckets_get(self, ethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection.history_control_entry', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection.history_control_entry', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection.history_control_entry', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_rmon_collection_history_interval_get(self, ethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection.history_control_entry', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection.history_control_entry', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection.history_control_entry', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_rmon_collection_history_owner_get(self, ethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection.history_control_entry', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection.history_control_entry', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection.history_control_entry', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_rmon_collection_stats_get(self, ethernet=None, ether_stats_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index, ether_stats_owner
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type ether_stats_owner: unicode
    :param ether_stats_owner: **ether_stats_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection.ether_stats_entry', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection.ether_stats_entry', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection.ether_stats_entry', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': 'ether_stats_index, ether_stats_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ether_stats_entry=ether_stats_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ether_stats_entry=ether_stats_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_rmon_collection_stats_owner_get(self, ethernet=None, ether_stats_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection.ether_stats_entry', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection.ether_stats_entry', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection.ether_stats_entry', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ether_stats_entry=ether_stats_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ether_stats_entry=ether_stats_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_route_only_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'udld'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fec'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'qos'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'offsets_container'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'track'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_2_00.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_1_01a.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'track'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'udld'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'qos'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'disable'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rx, tx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'accessvlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vepa_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'root'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'sticky_flag'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'fec_mode'}, {'leafval': 'learn_any'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'critical_event_action'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'expire'}, {'leafval': 'attempts, time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'in_, out'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'key_chain'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'forwarding'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'profile_domain_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trust'}, {'leafval': 'instance_id, shutdown, name'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'acl_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address_suppress_all'}, {'leafval': 'route_map_name'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'raguard'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'id, cost, priority'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'offsets'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'fcoeport_map'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'key_chain'}, {'leafval': 'link_fault_action'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'gateway'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'mtu'}, {'leafval': 'basic'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'channel'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'use_link_local_only'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'enable'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'log, mode'}, {'leafval': 'accessvlan'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'sticky_flag'}, {'leafval': 'basic'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'disable'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'link_fault_action'}, {'leafval': 'log, mode'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'mtu'}, {'leafval': 'in_, out'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'bfd_enable'}, {'leafval': 'root'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'raguard'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'use_link_local_only'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'instance_id'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vepa_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trust'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'profile_domain_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'address_suppress_all'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'acl_name'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'gateway'}, {'leafval': 'max_interval, min_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'vlan_mode'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'udld_enable'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'route_map_name'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'channel'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'rx, tx'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'fcoeport_map'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'attempts, time'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'critical_event_action'}, {'leafval': 'native_vlan'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'expire'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'forwarding'}, {'leafval': 'encrypttype, auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_rpf_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.rpf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.rpf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.rpf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.interface.ethernet.rpf": {}, "pybind.slxos.v17r_2_00.interface.ethernet.rpf": {"log": "log", "mode": "mode"}, "pybind.slxos.v17r_1_01a.interface.ethernet.rpf": {"log": "log", "mode": "mode"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_rpf_log_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.rpf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_rpf_mode_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.rpf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.rpf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_rpf_mode_mode_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.rpf_mode', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_service_policy_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.service_policy', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.service_policy', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.service_policy', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_service_policy_in_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.service_policy', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.service_policy', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.service_policy', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_service_policy_out_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.service_policy', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.service_policy', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.service_policy', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_sflow_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.sflow', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.sflow', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.sflow', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_sflow_enable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.sflow', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.sflow', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.sflow', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_sflow_polling_interval_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.sflow', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.sflow', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.sflow', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_sflow_sample_rate_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.sflow', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.sflow', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.sflow', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_shutdown_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'udld'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrpe'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'qos'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fec'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.ethernet.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'channel_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf_mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17s_1_02.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'connectivity'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lacp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'track'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'deny'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'sflow'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vepa'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17s_1_02.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ipv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lldp'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'dot1x'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'udld'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fec'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'qos'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'offsets_container'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'track'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_2_00.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_1_01a.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'track'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'udld'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'qos'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'gateway'}, {'leafval': 'trust'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'udld_enable'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'rx, tx'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'fec_mode'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'disable'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'profile_domain_name'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'id, cost, priority'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'in_, out'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mode'}, {'leafval': 'accessvlan'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'mtu'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'route_map_name'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'root'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'add_, remove_'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ingress, egress'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'address_suppress_all'}, {'leafval': 'max_interval, min_'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'instance_id'}, {'leafval': 'bfd_enable'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'basic'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'vepa_enable'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'fcoeport_map'}, {'leafval': 'raguard'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'native_vlan'}, {'leafval': 'log'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'expire'}, {'leafval': 'vlan_mode'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'interface_bfd_disable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'disable'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rx, tx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'accessvlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vepa_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'root'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'sticky_flag'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'fec_mode'}, {'leafval': 'learn_any'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'critical_event_action'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'expire'}, {'leafval': 'attempts, time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'in_, out'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'key_chain'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'forwarding'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'profile_domain_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trust'}, {'leafval': 'instance_id, shutdown, name'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'acl_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address_suppress_all'}, {'leafval': 'route_map_name'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'raguard'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'id, cost, priority'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'offsets'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'fcoeport_map'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'key_chain'}, {'leafval': 'link_fault_action'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'gateway'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'mtu'}, {'leafval': 'basic'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'channel'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'use_link_local_only'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'enable'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'log, mode'}, {'leafval': 'accessvlan'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'sticky_flag'}, {'leafval': 'basic'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'disable'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'link_fault_action'}, {'leafval': 'log, mode'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'mtu'}, {'leafval': 'in_, out'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'bfd_enable'}, {'leafval': 'root'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'raguard'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'use_link_local_only'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'instance_id'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vepa_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trust'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'profile_domain_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'address_suppress_all'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'acl_name'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'gateway'}, {'leafval': 'max_interval, min_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'vlan_mode'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'udld_enable'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'route_map_name'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'channel'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'rx, tx'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'fcoeport_map'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'attempts, time'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'critical_event_action'}, {'leafval': 'native_vlan'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'expire'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'forwarding'}, {'leafval': 'encrypttype, auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_autoedge_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_bpdu_mac_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_cost_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_edgeport_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.edgeport', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.edgeport', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.edgeport', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.edgeport": {"edgeportbasic": "edgeportbasic", "bpdu_filter": "bpdu_filter", "bpdu_guard": "bpdu_guard"}, "pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.edgeport": {}, "pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.edgeport": {"edgeportbasic": "edgeportbasic", "bpdu_filter": "bpdu_filter", "bpdu_guard": "bpdu_guard"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_edgeport_bpdu_filter_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.edgeport', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.edgeport', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_edgeport_bpdu_guard_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.edgeport', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.edgeport', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.edgeport', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_edgeport_edgeportbasic_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.edgeport', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.edgeport', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.edgeport', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_guard_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.guard', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.guard', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.guard', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_guard_root_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.guard', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.guard', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.guard', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_instance_get(self, ethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_instance_cost_get(self, ethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_instance_priority_get(self, ethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_instance_restricted_role_get(self, ethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_instance_restricted_tcn_get(self, ethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.instance', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_link_type_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_portfast_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.portfast', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.portfast', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.portfast', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.portfast": {"portfastbasic": "portfastbasic", "bpdu_filter": "bpdu_filter", "bpdu_guard": "bpdu_guard"}, "pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.portfast": {"portfastbasic": "portfastbasic", "bpdu_filter": "bpdu_filter", "bpdu_guard": "bpdu_guard"}, "pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.portfast": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_portfast_bpdu_filter_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.portfast', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.portfast', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_portfast_bpdu_guard_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.portfast', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.portfast', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.portfast', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_portfast_portfastbasic_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.portfast', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.portfast', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.portfast', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_priority_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_restricted_role_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_restricted_tcn_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_shutdown_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_vlan_get(self, ethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.vlan', u'guard'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.vlan', u'guard'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_vlan_cost_get(self, ethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.vlan', u'guard'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.vlan', u'guard'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_vlan_guard_get(self, ethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.vlan.guard', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.vlan.guard', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.vlan.guard', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_vlan_guard_root_get(self, ethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.vlan.guard', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.vlan.guard', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.vlan.guard', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_spanning_tree_vlan_priority_get(self, ethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree.vlan', u'guard'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree.vlan', u'guard'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_speed_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'udld'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrpe'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'qos'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fec'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.ethernet.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'channel_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf_mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17s_1_02.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17s_1_02.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'connectivity'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lacp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17s_1_02.interface.ethernet.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'track'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'deny'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17s_1_02.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'sflow'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'vepa'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.igmp.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17s_1_02.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.ethernet.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ipv6'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'rpf'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'lldp'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'dot1x'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17s_1_02.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'udld'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fec'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'qos'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'offsets_container'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'track'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_2_00.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_1_01a.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'rpf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_1_01a.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'track'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'udld'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'qos'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_1_01a.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_1_01a.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'gateway'}, {'leafval': 'trust'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'udld_enable'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'rx, tx'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'fec_mode'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'disable'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'profile_domain_name'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'id, cost, priority'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'in_, out'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mode'}, {'leafval': 'accessvlan'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'mtu'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'route_map_name'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'root'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'add_, remove_'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ingress, egress'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'address_suppress_all'}, {'leafval': 'max_interval, min_'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'instance_id'}, {'leafval': 'bfd_enable'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'basic'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'vepa_enable'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'fcoeport_map'}, {'leafval': 'raguard'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'native_vlan'}, {'leafval': 'log'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'expire'}, {'leafval': 'vlan_mode'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'interface_bfd_disable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'disable'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rx, tx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'accessvlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vepa_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'root'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'sticky_flag'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'fec_mode'}, {'leafval': 'learn_any'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'critical_event_action'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'expire'}, {'leafval': 'attempts, time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'in_, out'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'key_chain'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'forwarding'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'profile_domain_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trust'}, {'leafval': 'instance_id, shutdown, name'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'acl_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address_suppress_all'}, {'leafval': 'route_map_name'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'raguard'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'id, cost, priority'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'offsets'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'fcoeport_map'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'key_chain'}, {'leafval': 'link_fault_action'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'gateway'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'mtu'}, {'leafval': 'basic'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'channel'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'use_link_local_only'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'enable'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'log, mode'}, {'leafval': 'accessvlan'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'sticky_flag'}, {'leafval': 'basic'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'disable'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'link_fault_action'}, {'leafval': 'log, mode'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'mtu'}, {'leafval': 'in_, out'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'bfd_enable'}, {'leafval': 'root'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'raguard'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'use_link_local_only'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'instance_id'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vepa_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trust'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'profile_domain_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'address_suppress_all'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'acl_name'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'gateway'}, {'leafval': 'max_interval, min_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'vlan_mode'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'udld_enable'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'route_map_name'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'channel'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'rx, tx'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'fcoeport_map'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'attempts, time'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'critical_event_action'}, {'leafval': 'native_vlan'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'expire'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'forwarding'}, {'leafval': 'encrypttype, auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_storm_control_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.storm_control', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.storm_control', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_storm_control_ingress_get(self, ethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type, rate_format, rate_bps, rate_percent, bum_action
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type rate_format: unicode
    :param rate_format: **ingress** tuple argument.

        * enumeration restriction: ::

            ['limit-bps', 'limit-percent']

    :type rate_bps: long
    :param rate_bps: **ingress** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type rate_percent: long
    :param rate_percent: **ingress** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bum_action: unicode
    :param bum_action: **ingress** tuple argument.

        * enumeration restriction: ::

            ['monitor', 'shutdown']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.storm_control.ingress', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control.ingress', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.storm_control.ingress', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_storm_control_ingress_bum_action_get(self, ethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.storm_control.ingress', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control.ingress', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.storm_control.ingress', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_storm_control_ingress_rate_bps_get(self, ethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.storm_control.ingress', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control.ingress', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.storm_control.ingress', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_storm_control_ingress_rate_format_get(self, ethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.storm_control.ingress', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control.ingress', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.storm_control.ingress', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_storm_control_ingress_rate_percent_get(self, ethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.storm_control.ingress', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control.ingress', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.storm_control.ingress', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_strip_header_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'udld'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fec'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'qos'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'offsets_container'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'track'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_2_00.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'rpf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'disable'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rx, tx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'accessvlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vepa_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'root'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'sticky_flag'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'fec_mode'}, {'leafval': 'learn_any'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'critical_event_action'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'expire'}, {'leafval': 'attempts, time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'in_, out'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'key_chain'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'forwarding'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'profile_domain_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trust'}, {'leafval': 'instance_id, shutdown, name'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'acl_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address_suppress_all'}, {'leafval': 'route_map_name'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'raguard'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'id, cost, priority'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'offsets'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'fcoeport_map'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'key_chain'}, {'leafval': 'link_fault_action'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'gateway'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'mtu'}, {'leafval': 'basic'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'channel'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'use_link_local_only'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'enable'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'log, mode'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport_basic', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport_basic', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport_basic', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_access_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_group_rspan_vlan_classification_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_group_rspan_vlan_classification_access_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_group_rspan_vlan_classification_access_rspan_vlan_get(self, ethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_group_vlan_classification_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_group_vlan_classification_access_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_vlan_classification.access', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_vlan_classification.access', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_vlan_classification.access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_group_vlan_classification_access_vlan_get(self, ethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_rspan_vlan_classification_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_rspan_vlan_classification_access_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_rspan_vlan_classification_access_rspan_vlan_get(self, ethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_vlan_classification_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_vlan_classification_access_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_vlan_classification.access', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_vlan_classification.access', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_vlan_classification.access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_access_mac_vlan_classification_access_vlan_get(self, ethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_access_rspan_access_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access.rspan_access', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access.rspan_access', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access.rspan_access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_access_rspan_vlan_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access.rspan_access', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access.rspan_access', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access.rspan_access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_access_vlan_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.access', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_basic_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport_basic', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport_basic', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport_basic', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_mode_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.mode', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.mode', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.mode', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_mode_vlan_mode_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.mode', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.mode', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.mode', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_port_security_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_port_security_max_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_port_security_port_security_mac_address_get(self, ethernet=None, port_security_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_security_mac_address: mac_address, port_sec_vlan
    :param port_security_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_security_mac_address** tuple argument:  Mac Address

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_security_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security.port_security_mac_address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.port_security_mac_address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_security_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, port_security_mac_address=port_security_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, port_security_mac_address=port_security_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_port_security_port_secutiry_mac_address_get(self, ethernet=None, port_secutiry_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_port_security_shutdown_time_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_port_security_sticky_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security.sticky', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security.sticky', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky": {"sticky_flag": "sticky_flag"}, "pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security.sticky": {"sticky_flag": "sticky_flag"}, "pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security.sticky": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_port_security_sticky_port_security_mac_address_get(self, ethernet=None, port_security_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_security_mac_address: mac_address, port_sec_vlan
    :param port_security_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_security_mac_address** tuple argument:  Mac Address

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_security_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security.sticky.port_security_mac_address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky.port_security_mac_address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_security_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, port_security_mac_address=port_security_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, port_security_mac_address=port_security_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_port_security_sticky_port_secutiry_mac_address_get(self, ethernet=None, port_secutiry_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_port_security_sticky_sticky_flag_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security.sticky', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_port_security_violation_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.port_security', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.port_security', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_rspan_vlan_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_rspan_vlan_add_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_rspan_vlan_remove_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_trunk_rspan_vlan_classification_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_trunk_rspan_vlan_classification_rspan_vlan_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_trunk_rspan_vlan_classification_rspan_vlan_add_get(self, ethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_trunk_rspan_vlan_classification_rspan_vlan_remove_get(self, ethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlan_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlan_add_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlan_all_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlan_except_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlan_none_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlan_remove_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlanoper_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlanoper', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlanoper', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlanoper_vlan_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlanoper_vlan_add_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_allowed_vlanoper_vlan_remove_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_ctag_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_ctag_native_vlan_xtagged_config_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_default_vlan_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.default_vlan_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.default_vlan_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.default_vlan_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_default_vlan_config_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.default_vlan_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.default_vlan_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.default_vlan_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_transparent_vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_egress_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_native_vlan_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_native_vlan_classification_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id, native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_native_vlan_untagged_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_native_vlan_untagged_config_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_untagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_native_vlan_xtagged_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_native_vlan_xtagged_config_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_tag_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.tag', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.tag', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.tag', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_tag_native_vlan_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.tag', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.tag', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.tag', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_trunk_vlan_classification_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_trunk_vlan_classification_allowed_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_trunk_vlan_classification_allowed_vlan_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_trunk_vlan_classification_allowed_vlan_add_get(self, ethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_trunk_vlan_classification_allowed_vlan_add_ctag_get(self, ethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_trunk_vlan_classification_allowed_vlan_remove_get(self, ethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_switchport_trunk_trunk_vlan_classification_allowed_vlan_remove_ctag_get(self, ethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_system_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.system', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_system_packet_timestamp_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.system.packet_timestamp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_system_packet_timestamp_egress_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.system.packet_timestamp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_system_packet_timestamp_ingress_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.system.packet_timestamp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_tag_type_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'history_control_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_dport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.rmon.collection', u'ether_stats_entry'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'connectivity'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'neighbor_discovery'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access', u'rspan_access'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'dying_gasp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_fault_signaling'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vepa'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.ethernet.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.multicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_trunk'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'udld'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fec'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'dot1x'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'critical_event'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_error_disable'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.bfd', u'interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'enableinterfacelevel'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'vrf'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.ethernet.logical_interface', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.arp_node_config.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'qos'), ('pybind.slxos.v17r_2_00.interface.ethernet.dot1x', u'timeout'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'sflow'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lldp'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'link_oam_interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.storm_control', u'ingress'), ('pybind.slxos.v17r_2_00.interface.ethernet.lldp', u'cee'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'multicast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'offsets_container'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'track'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.igmp_phy_intf_cfg.igmp', u'igmpl3_static_group'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'vrrpv3e_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.interface.ethernet.link_oam_interface.remote_failure', u'link_fault'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue.unicast', u'queue_size'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.delay_link_event', u'delay_link'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.ethernet.fabric', u'fabric_isl'), ('pybind.slxos.v17r_2_00.interface.ethernet.openflow', u'protected_vlans'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'channel_group'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_2_00.interface.ethernet.tunable_optics', u'sfpp'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.interface.ethernet.spanning_tree', u'portfast'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.interface.ethernet.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.ethernet.ip.interface_eth_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.interface.ethernet.qos.rx_queue', u'cos_threshold'), ('pybind.slxos.v17r_2_00.interface.ethernet.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.ethernet.interface_eth_isis_conf.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'rpf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'disable'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'dying_gasp_action'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rx, tx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'accessvlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vepa_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'root'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'sticky_flag'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'fec_mode'}, {'leafval': 'learn_any'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, max_req, reauthentication, filter_strict_security'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'critical_event_action'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'loop_detection_native'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'expire'}, {'leafval': 'attempts, time'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'in_, out'}, {'leafval': 'link_error_disable_entry, sampling_time_in_sec, wait_time_in_sec'}, {'leafval': 'key_chain'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'modeType, hybrid_mode'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'forwarding'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'profile_domain_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trust'}, {'leafval': 'instance_id, shutdown, name'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'acl_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address_suppress_all'}, {'leafval': 'route_map_name'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'raguard'}, {'leafval': 'enable, allow_loopback'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'id, cost, priority'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'guarantee_rate, best_effort_rate'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'offsets'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'fcoeport_map'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'key_chain'}, {'leafval': 'link_fault_action'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'traffic_class, min_queue_size, max_queue_size'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'delay_link_event_entry, delay_link_event_type'}, {'leafval': 'gateway'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'mtu'}, {'leafval': 'basic'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'protected_vlan_add, protected_vlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'channel'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'use_link_local_only'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'enable'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'log, mode'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_track_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.track', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_track_enable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.track', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_track_interface_get(self, ethernet=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface: track_interface_type, track_interface_name
    :param interface: Keyword argument tuple.

    :type track_interface_type: unicode
    :param track_interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type track_interface_name: unicode
    :param track_interface_name: **interface** tuple argument:  Interface name

        * pattern restriction: ::

            '(((([1-9]|[1-9][0-9]|1[0-9]{2}|2[0-3][0-9])/)?(('
            '[0-9]|1[0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]'
            ')(:[1-4])?)|([1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5'
            '][0-9]{3}|6[0-1][0-4]{2}))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.track.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.track.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'track_interface_type, track_interface_name', 'extra_keyval': 'track_interface_type, track_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_track_min_link_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.track', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.track', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.track', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_track_remove_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.track.remove_', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.track.remove_', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.track.remove_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_track_remove_all_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.track.remove_', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.track.remove_', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.track.remove_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_tunable_optics_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.tunable_optics', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.tunable_optics', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_tunable_optics_sfpp_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.tunable_optics.sfpp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.tunable_optics.sfpp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_tunable_optics_sfpp_channel_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.tunable_optics.sfpp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.tunable_optics.sfpp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_tvf_domain_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.tvf_domain', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_tvf_domain_add_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.tvf_domain', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_tvf_domain_all_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.tvf_domain', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_tvf_domain_except_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.tvf_domain', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_tvf_domain_none_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.tvf_domain', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_tvf_domain_remove_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.tvf_domain', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_uda_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.uda', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_uda_access_group_get(self, ethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: uda_access_list, uda_direction
    :param access_group: Keyword argument tuple.

    :type uda_access_list: unicode
    :param uda_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type uda_direction: unicode
    :param uda_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.uda.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'uda_access_list, uda_direction', 'extra_keyval': 'uda_access_list, uda_direction'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_uda_profile_apply_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.ethernet.offsets_container', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_udld_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.udld', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.udld', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.udld', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_udld_enable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.udld', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.udld', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.udld', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vepa_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vepa', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vepa', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vepa', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vepa_enable_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vepa', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vepa', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vepa', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrf_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrf_forwarding_get(self, ethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_advertise_backup_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_advertisement_interval_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_advertisement_interval_scale_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_arp_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.arp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_arp_unicast_request_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.arp.unicast_request', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_arp_unicast_request_receive_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.arp.unicast_request', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_backup_advertisement_interval_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_description_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_enable_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_hold_time_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_preempt_mode_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_priority_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_short_path_forwarding_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.short_path_forwarding', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_short_path_forwarding_basic_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.short_path_forwarding', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_short_path_forwarding_revert_priority_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.short_path_forwarding', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_track_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_track_interface_get(self, ethernet=None, vrrpe=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_track_interface_priority_get(self, ethernet=None, vrrpe=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_track_network_get(self, ethernet=None, vrrpe=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  IPv4 global address

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-2])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track.network', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_track_network_priority_get(self, ethernet=None, vrrpe=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  IPv4 global address

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-2])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track.network', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_virtual_ip_get(self, ethernet=None, vrrpe=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.virtual_ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_virtual_mac_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_extended_group_vrrpe_garp_timer_get(self, ethernet=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrpe', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_get(self, ethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'owner'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_advertisement_interval_get(self, ethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'owner'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_arp_get(self, ethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.arp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.arp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.arp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_arp_unicast_request_get(self, ethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.arp.unicast_request', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.arp.unicast_request', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.arp.unicast_request', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_arp_unicast_request_receive_get(self, ethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.arp.unicast_request', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.arp.unicast_request', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.arp.unicast_request', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_description_get(self, ethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'owner'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_enable_get(self, ethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'owner'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_hold_time_get(self, ethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'owner'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_owner_get(self, ethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.owner', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_owner_priority_get(self, ethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.owner', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_owner_track_priority_get(self, ethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.owner', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_preempt_mode_get(self, ethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'owner'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_priority_get(self, ethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'owner'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_track_get(self, ethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.track', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.track', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.track', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_track_interface_get(self, ethernet=None, vrrp=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.track.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.track.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_track_interface_priority_get(self, ethernet=None, vrrp=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.track.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.track.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_use_v2_checksum_get(self, ethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'owner'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ethernet_vrrp_group_virtual_ip_get(self, ethernet=None, vrrp=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ethernet: name
    :param ethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **ethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address in dotted decimal

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.ethernet', u'ethernet'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.ethernet', u'ethernet'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.ethernet.vrrp.virtual_ip', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.ethernet.vrrp.virtual_ip', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.ethernet.vrrp.virtual_ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ethernet=ethernet, vrrp=vrrp, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ethernet=ethernet, vrrp=vrrp, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fcoe_get(self, fcoe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fcoe', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fcoe', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.fcoe', u'fcoe_interface_bind'), ('pybind.nos.v7_2_0.interface.fcoe', u'fcoe_interface_bind')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe', 'keyval': 'fcoe_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fcoe_interface_bind_te, fcoe_interface_bind_fo, fcoe_interface_bind_po, fcoe_interface_bind_mac, fcoe_interface_bind_hu, fcoe_interface_bind_name'}, {'leafval': 'fcoe_interface_bind_te, fcoe_interface_bind_fo, fcoe_interface_bind_po, fcoe_interface_bind_mac, fcoe_interface_bind_hu, fcoe_interface_bind_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fcoe_bind_get(self, fcoe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fcoe', u'fcoe'), ('pybind.nos.v7_2_0.interface.fcoe', u'fcoe')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'fcoe_interface_bind_te, fcoe_interface_bind_fo, fcoe_interface_bind_po, fcoe_interface_bind_mac, fcoe_interface_bind_hu, fcoe_interface_bind_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.interface.fcoe.fcoe_interface_bind': [u'fcoe_interface_bind_mac', u'fcoe_interface_bind_te', u'fcoe_interface_bind_po', u'fcoe_interface_bind_fo', u'fcoe_interface_bind_hu'], 'pybind.nos.v6_0_2f.interface.fcoe.fcoe_interface_bind': [u'fcoe_interface_bind_mac', u'fcoe_interface_bind_te', u'fcoe_interface_bind_po', u'fcoe_interface_bind_fo', u'fcoe_interface_bind_hu']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fcoe_bind_fcoe_interface_bind_name_get(self, fcoe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fcoe', u'fcoe'), ('pybind.nos.v7_2_0.interface.fcoe', u'fcoe')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fcoe_bind_fortygigabitethernet_get(self, fcoe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fcoe', u'fcoe'), ('pybind.nos.v7_2_0.interface.fcoe', u'fcoe')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fcoe_bind_hundredgigabitethernet_get(self, fcoe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fcoe', u'fcoe'), ('pybind.nos.v7_2_0.interface.fcoe', u'fcoe')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fcoe_bind_mac_address_get(self, fcoe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fcoe', u'fcoe'), ('pybind.nos.v7_2_0.interface.fcoe', u'fcoe')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fcoe_bind_port_channel_get(self, fcoe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fcoe', u'fcoe'), ('pybind.nos.v7_2_0.interface.fcoe', u'fcoe')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fcoe_bind_tengigabitethernet_get(self, fcoe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fcoe', u'fcoe'), ('pybind.nos.v7_2_0.interface.fcoe', u'fcoe')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fcoe.fcoe_interface_bind', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'fcoe_interface_name', 'extra_keyval': ''}, {'keyval': 'fcoe_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fcoe_shutdown_get(self, fcoe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fcoe: fcoe_interface_name
    :param fcoe: Keyword argument tuple.

    :type fcoe_interface_name: unicode
    :param fcoe_interface_name: **fcoe** tuple argument.

        * length restriction: ::

            ['3..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fcoe', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fcoe', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.fcoe', u'fcoe_interface_bind'), ('pybind.nos.v7_2_0.interface.fcoe', u'fcoe_interface_bind')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fcoe', 'keyval': 'fcoe_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fcoe_interface_bind_te, fcoe_interface_bind_fo, fcoe_interface_bind_po, fcoe_interface_bind_mac, fcoe_interface_bind_hu, fcoe_interface_bind_name'}, {'leafval': 'fcoe_interface_bind_te, fcoe_interface_bind_fo, fcoe_interface_bind_po, fcoe_interface_bind_mac, fcoe_interface_bind_hu, fcoe_interface_bind_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fcoe=fcoe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fcoe=fcoe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fibrechannel_get(self, fc_port=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fc_port: name
    :param fc_port: Keyword argument tuple.

    :type name: unicode
    :param name: **fc_port** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fc_port', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fc_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fc_port', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fc_port=fc_port)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fc_port=fc_port)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fibrechannel_config_mode_get(self, fc_port=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fc_port: name
    :param fc_port: Keyword argument tuple.

    :type name: unicode
    :param name: **fc_port** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fc_port', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fc_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fc_port', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fc_port=fc_port)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fc_port=fc_port)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fibrechannel_description_get(self, fc_port=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fc_port: name
    :param fc_port: Keyword argument tuple.

    :type name: unicode
    :param name: **fc_port** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fc_port', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fc_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fc_port', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fc_port=fc_port)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fc_port=fc_port)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fibrechannel_desire_distance_get(self, fc_port=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fc_port: name
    :param fc_port: Keyword argument tuple.

    :type name: unicode
    :param name: **fc_port** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fc_port', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fc_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fc_port', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fc_port=fc_port)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fc_port=fc_port)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fibrechannel_fec_enable_get(self, fc_port=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fc_port: name
    :param fc_port: Keyword argument tuple.

    :type name: unicode
    :param name: **fc_port** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fc_port', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fc_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fc_port', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fc_port=fc_port)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fc_port=fc_port)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fibrechannel_fill_word_get(self, fc_port=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fc_port: name
    :param fc_port: Keyword argument tuple.

    :type name: unicode
    :param name: **fc_port** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fc_port', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fc_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fc_port', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fc_port=fc_port)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fc_port=fc_port)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fibrechannel_isl_r_rdy_get(self, fc_port=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fc_port: name
    :param fc_port: Keyword argument tuple.

    :type name: unicode
    :param name: **fc_port** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fc_port', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fc_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fc_port', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fc_port=fc_port)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fc_port=fc_port)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fibrechannel_long_distance_get(self, fc_port=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fc_port: name
    :param fc_port: Keyword argument tuple.

    :type name: unicode
    :param name: **fc_port** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fc_port', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fc_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fc_port', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fc_port=fc_port)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fc_port=fc_port)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fibrechannel_shutdown_get(self, fc_port=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fc_port: name
    :param fc_port: Keyword argument tuple.

    :type name: unicode
    :param name: **fc_port** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fc_port', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fc_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fc_port', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fc_port=fc_port)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fc_port=fc_port)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fibrechannel_speed_get(self, fc_port=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fc_port: name
    :param fc_port: Keyword argument tuple.

    :type name: unicode
    :param name: **fc_port** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fc_port', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fc_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fc_port', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fc_port=fc_port)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fc_port=fc_port)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fibrechannel_trunk_enable_get(self, fc_port=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fc_port: name
    :param fc_port: Keyword argument tuple.

    :type name: unicode
    :param name: **fc_port** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fc_port', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fc_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fc_port', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fc_port=fc_port)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fc_port=fc_port)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fibrechannel_vc_link_init_get(self, fc_port=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fc_port: name
    :param fc_port: Keyword argument tuple.

    :type name: unicode
    :param name: **fc_port** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fc_port', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fc_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fc_port', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fc_port=fc_port)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fc_port=fc_port)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fortygigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'trust'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'oui'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'raguard'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'forwarding'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'accessvlan'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'enable, direction'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'udld_enable'}, {'leafval': 'sticky_flag'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'use_link_local_only'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'mtu'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'gateway'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'logical_instance_id'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'attempts, time'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'native_vlan'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'root'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'in_, out'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'id, cost, priority'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'expire'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'basic'}, {'leafval': 'enable, match_profile'}, {'leafval': 'disable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'sg_addr'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'route_map_name'}, {'leafval': 'add_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'promiscuous, host'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vlan_mode'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'groupid, vlan'}, {'leafval': 'mtu'}, {'leafval': 'groupid, vlan'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'route_map_name'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'max_interval, min_'}, {'leafval': 'sticky_flag'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'raguard'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'protected_port_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'native_vlan'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'promiscuous, host'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'gateway'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'add_, remove_'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'log, mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'sg_addr'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'disable'}, {'leafval': 'oui'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'in_, out'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'channel'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'forwarding'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'trust'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'root'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'profile_domain_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'multinet_enable'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'bfd_enable'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'udld_enable'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'enable, direction'}, {'leafval': 'vlan_mode'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'enable, match_profile'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'logical_instance_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_bfd_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_bfd_interval_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_bfd_interval_min_rx_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_bfd_interval_min_tx_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_bfd_interval_multiplier_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_bfd_shutdown_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_bpdu_drop_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bpdu_drop', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable, direction'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_bpdu_drop_direction_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bpdu_drop', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_bpdu_drop_enable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bpdu_drop', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_cee_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fortygigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'trust'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'oui'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'raguard'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'forwarding'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'accessvlan'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'enable, direction'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'udld_enable'}, {'leafval': 'sticky_flag'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'use_link_local_only'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'mtu'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'gateway'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'logical_instance_id'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'attempts, time'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'native_vlan'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'root'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'in_, out'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'id, cost, priority'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'expire'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'basic'}, {'leafval': 'enable, match_profile'}, {'leafval': 'disable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'sg_addr'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'route_map_name'}, {'leafval': 'add_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'promiscuous, host'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vlan_mode'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'groupid, vlan'}, {'leafval': 'mtu'}, {'leafval': 'groupid, vlan'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'route_map_name'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'max_interval, min_'}, {'leafval': 'sticky_flag'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'raguard'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'protected_port_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'native_vlan'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'promiscuous, host'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'gateway'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'add_, remove_'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'log, mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'sg_addr'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'disable'}, {'leafval': 'oui'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'in_, out'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'channel'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'forwarding'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'trust'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'root'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'profile_domain_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'multinet_enable'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'bfd_enable'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'udld_enable'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'enable, direction'}, {'leafval': 'vlan_mode'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'enable, match_profile'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'logical_instance_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_channel_group_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.channel_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.channel_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'port_int, mode, type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_channel_group_mode_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.channel_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.channel_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_channel_group_port_int_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.channel_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.channel_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_channel_group_type_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.channel_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.channel_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_description_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fortygigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'trust'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'oui'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'raguard'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'forwarding'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'accessvlan'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'enable, direction'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'udld_enable'}, {'leafval': 'sticky_flag'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'use_link_local_only'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'mtu'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'gateway'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'logical_instance_id'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'attempts, time'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'native_vlan'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'root'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'in_, out'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'id, cost, priority'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'expire'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'basic'}, {'leafval': 'enable, match_profile'}, {'leafval': 'disable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'sg_addr'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'route_map_name'}, {'leafval': 'add_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'promiscuous, host'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vlan_mode'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'groupid, vlan'}, {'leafval': 'mtu'}, {'leafval': 'groupid, vlan'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'route_map_name'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'max_interval, min_'}, {'leafval': 'sticky_flag'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'raguard'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'protected_port_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'native_vlan'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'promiscuous, host'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'gateway'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'add_, remove_'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'log, mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'sg_addr'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'disable'}, {'leafval': 'oui'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'in_, out'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'channel'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'forwarding'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'trust'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'root'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'profile_domain_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'multinet_enable'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'bfd_enable'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'udld_enable'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'enable, direction'}, {'leafval': 'vlan_mode'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'enable, match_profile'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'logical_instance_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_deviceconnectivity_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.connectivity', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.connectivity', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x": {"reauthMax": "reauthMax", "port_control": "port_control", "quiet_period": "quiet_period", "authentication": "authentication", "reauthentication": "reauthentication", "protocol_version": "protocol_version"}, "pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_authentication_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_mac_auth_bypass_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_mac_auth_enable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_port_control_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_protocol_version_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_quiet_period_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_reauthentication_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_reauthmax_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_timeout_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_timeout_re_authperiod_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_timeout_server_timeout_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_timeout_supp_timeout_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_dot1x_timeout_tx_period_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_edge_loop_detection_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_edge_loop_detection_port_priority_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_edge_loop_detection_vlan_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_fabric_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_fabric_dport_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric.fabric_dport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric.fabric_dport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric.fabric_dport": {}, "pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric.fabric_dport": {"fabric_dport_enable": "fabric_dport_enable"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_fabric_dport_enable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric.fabric_dport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_fabric_dport_mode_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric.fabric_dport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_fabric_isl_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric.fabric_isl', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric.fabric_isl', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_fabric_isl_enable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric.fabric_isl', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric.fabric_isl', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_fabric_neighbor_discovery_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_fabric_neighbor_discovery_disable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_fabric_trunk_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric.fabric_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric.fabric_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_fabric_trunk_enable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric.fabric_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric.fabric_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_fcoeport_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fcoeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fcoeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'fcoeport_map, ns_ip_registration'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_fcoeport_map_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fcoeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fcoeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_fcoeport_ns_ip_registration_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fcoeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fcoeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ifindex_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fortygigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'trust'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'oui'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'raguard'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'forwarding'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'accessvlan'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'enable, direction'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'udld_enable'}, {'leafval': 'sticky_flag'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'use_link_local_only'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'mtu'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'gateway'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'logical_instance_id'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'attempts, time'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'native_vlan'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'root'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'in_, out'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'id, cost, priority'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'expire'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'basic'}, {'leafval': 'enable, match_profile'}, {'leafval': 'disable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'sg_addr'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'route_map_name'}, {'leafval': 'add_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'promiscuous, host'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vlan_mode'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'groupid, vlan'}, {'leafval': 'mtu'}, {'leafval': 'groupid, vlan'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'route_map_name'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'max_interval, min_'}, {'leafval': 'sticky_flag'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'raguard'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'protected_port_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'native_vlan'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'promiscuous, host'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'gateway'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'add_, remove_'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'log, mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'sg_addr'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'disable'}, {'leafval': 'oui'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'in_, out'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'channel'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'forwarding'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'trust'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'root'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'profile_domain_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'multinet_enable'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'bfd_enable'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'udld_enable'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'enable, direction'}, {'leafval': 'vlan_mode'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'enable, match_profile'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'logical_instance_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_access_group_get(self, fortygigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': 'ip_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_access_group_traffic_type_get(self, fortygigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_acl_interface_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_acl_interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_acl_interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_address_get(self, fortygigabitethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary, ospf_passive, ospf_ignore
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: **address** tuple argument:  ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: **address** tuple argument:  ospf active address on the specific interface

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_address_ospf_ignore_get(self, fortygigabitethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_address_ospf_passive_get(self, fortygigabitethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_address_secondary_get(self, fortygigabitethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_arp_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.arp_node_config.arp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.arp_node_config.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_arp_aging_timeout_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_arp_inspection_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_arp_inspection_trust_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_arp_ip_config_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_arp_learn_any_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_arp_node_config_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.arp_node_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.arp_node_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_dhcp_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_dhcp_relay_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_dhcp_relay_gateway_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_dhcp_relay_servers_get(self, fortygigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  A.B.C.D;; IP address of the DHCP server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCP server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr, server_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_directed_broadcast_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_icmp_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_icmp_address_mask_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_icmp_echo_reply_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_icmp_rate_limiting_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_icmp_redirect_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_icmp_unreachable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp": {}, "pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp": {"immediate_leave": "immediate_leave", "last_member_query_interval": "last_member_query_interval", "query_interval": "query_interval", "query_max_response_time": "query_max_response_time"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_immediate_leave_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_last_member_query_count_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_last_member_query_interval_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_phy_intf_cfg_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_query_interval_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_query_max_response_time_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_robustness_variable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_startup_query_count_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_startup_query_interval_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_igmp_static_group_get(self, fortygigabitethernet=None, static_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type static_group: sg_addr
    :param static_group: Keyword argument tuple.

    :type sg_addr: unicode
    :param sg_addr: **static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'sg_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, static_group=static_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_interface_fo_dhcp_conf_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_interface_fo_ospf_conf_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ip_acl_interface_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_acl_interface.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_acl_interface.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ip_config_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ip_pbr_interface_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_pbr_interface.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_pbr_interface.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_mtu_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_multicast_boundary_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_active_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_area_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_auth_change_wait_time_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_authentication_key_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_authentication_key_auth_key_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_authentication_key_auth_key_table_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_authentication_key_encrypttype_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_authentication_key_no_encrypt_auth_key_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_authentication_key_no_encrypt_auth_key_table_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_bfd_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_bfd_intf_bfd_enable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_cost_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_database_filter_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_database_filter_all_external_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_database_filter_all_out_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_database_filter_all_summary_external_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_dead_interval_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_hello_interval_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_md5_authentication_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_md5_authentication_key_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_md5_authentication_key_activation_wait_time_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_md5_authentication_key_id_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_md5_authentication_key_id_key_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_md5_authentication_key_id_key_id_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_md5_authentication_key_id_md5_authentication_key_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_md5_authentication_no_encrypt_key_table_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_encrypt_key_id, no_encrypt_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_mtu_ignore_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_network_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_passive_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_priority_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_retransmit_interval_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_ospf_transmit_delay_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_pbr_interface_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_pbr_interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_pbr_interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_pim_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_pim_dr_priority_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_pim_int_cmd_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_pim_intf_phy_cont_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_pim_multinet_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_pim_multinet_enable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_pim_neighbor_filter_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_pim_sparse_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_policy_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_policy_route_map_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_policy_route_map_route_map_name_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_proxy_arp_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_unnumbered_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ip_donor_interface_type, ip_donor_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_unnumbered_ip_donor_interface_name_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ip_unnumbered_ip_donor_interface_type_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_access_group_get(self, fortygigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': 'ipv6_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_access_group_traffic_type_get(self, fortygigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_ipv6_address_get(self, fortygigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_ipv6_address_anycast_get(self, fortygigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_ipv6_address_eui_64_get(self, fortygigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_ipv6_address_secondary_get(self, fortygigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_ipv6_address_secondary_eui_config_get(self, fortygigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_link_local_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_link_local_address_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_link_local_config_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_address_use_link_local_only_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_dhcp_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_dhcp_relay_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_dhcp_relay_servers_get(self, fortygigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_dhcp_relay_servers_interface_get(self, fortygigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_dhcp_relay_servers_interface_interface_get(self, fortygigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_dhcp_relay_servers_interface_interface_name_get(self, fortygigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_dhcp_relay_servers_use_vrf_get(self, fortygigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_hop_by_hop_trap_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_icmpv6_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_icmpv6_echo_reply_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_icmpv6_rate_limiting_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_icmpv6_redirect_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_icmpv6_unreachable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_interface_phy_dhcp_conf_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ipv6_config_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ipv6_intf_cmds_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ipv6_nd_ra_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ipv6_phy_intf_cmds_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_mtu_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd": {"managed_config_flag": "managed_config_flag", "broadcast_mac_trap": "broadcast_mac_trap", "ra_lifetime": "ra_lifetime", "hoplimit": "hoplimit", "mtu": "mtu", "retrans_timer": "retrans_timer", "other_config_flag": "other_config_flag", "ns_interval": "ns_interval", "reachable_time": "reachable_time", "proxy": "proxy"}, "pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_broadcast_mac_trap_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_cache_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'expire'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_cache_expire_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_dad_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_dad_attempts_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_dad_time_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_hoplimit_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_managed_config_flag_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_mtu_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_ns_interval_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_nud_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_nud_retry_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'base, interval, max_attempts'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_nud_retry_base_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_nud_retry_interval_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_nud_retry_max_attempts_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_other_config_flag_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_get(self, fortygigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_autoconfig, no_onlink, off_link'}, {'leafval': 'no_advertise, valid_lifetime, valid_infinite'}, {'leafval': 'preferred_lifetime, preferred_infinite'}, {'leafval': 'preferred_lifetime, preferred_infinite'}, {'leafval': 'no_autoconfig, no_onlink, off_link'}, {'leafval': 'no_advertise, valid_lifetime, valid_infinite'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_infinite_get(self, fortygigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_infinite_preferred_get(self, fortygigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_no_advertise_get(self, fortygigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_no_autoconfig_get(self, fortygigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_no_onlink_get(self, fortygigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_off_link_get(self, fortygigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_preferred_get(self, fortygigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'preferred_lifetime, preferred_infinite'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_preferred_lifetime_get(self, fortygigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_prefix_flags_get(self, fortygigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_autoconfig, no_onlink, off_link'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_prefix_valid_lifetime_get(self, fortygigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_proxy_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_ra_interval_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_interval, min_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_ra_interval_max_interval_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_ra_interval_min_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_ra_lifetime_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_reachable_time_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_retrans_timer_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_set_cache_expire_time_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_set_hoplimit_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_suppress_ra_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_suppress_ra_all_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_suppress_ra_mtu_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_nd_suppress_ra_suppress_ra_flag_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_neighbor_get(self, fortygigabitethernet=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_neighbor_hardware_address_get(self, fortygigabitethernet=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_active_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_area_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_ah_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_esp_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_esp_auth_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_esp_key_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_esp_no_encrypt_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_ipsec_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_ipsec_auth_key_config_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_ipsec_disable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_ipsec_key_add_remove_interval_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_key_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_no_encrypt_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_authentication_spi_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_bfd_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_bfd_bfd_enable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_cost_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_dead_interval_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_hello_interval_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_hello_jitter_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_instance_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_link_interval_properties_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_mtu_ignore_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_network_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_passive_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_priority_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_retransmit_interval_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_suppress_linklsa_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_ospf_transmit_delay_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_policy_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_policy_route_map_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.policy.route_map', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_policy_route_map_ipv6_route_map_name_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.policy.route_map', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_raguard_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_get(self, fortygigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_advertise_backup_get(self, fortygigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_advertisement_interval_get(self, fortygigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_advertisement_interval_scale_get(self, fortygigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_backup_advertisement_interval_get(self, fortygigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_description_get(self, fortygigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_enable_get(self, fortygigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_hold_time_get(self, fortygigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_nd_advertisement_timer_get(self, fortygigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_preempt_mode_get(self, fortygigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_priority_get(self, fortygigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_get(self, fortygigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_basic_get(self, fortygigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_revert_priority_get(self, fortygigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_track_get(self, fortygigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_track_interface_get(self, fortygigabitethernet=None, vrrpv3e_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_track_interface_priority_get(self, fortygigabitethernet=None, vrrpv3e_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_extended_group_virtual_ip_get(self, fortygigabitethernet=None, vrrpv3e_group=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_get(self, fortygigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_advertisement_interval_get(self, fortygigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_description_get(self, fortygigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_enable_get(self, fortygigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_hold_time_get(self, fortygigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_preempt_mode_get(self, fortygigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_priority_get(self, fortygigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_track_get(self, fortygigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_track_interface_get(self, fortygigabitethernet=None, vrrpv3_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_track_interface_priority_get(self, fortygigabitethernet=None, vrrpv3_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_use_v2_checksum_get(self, fortygigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_group_virtual_ip_get(self, fortygigabitethernet=None, vrrpv3_group=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_ipv6_vrrp_suppress_interface_ra_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_lacp_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lacp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lacp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_lacp_default_up_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lacp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lacp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_lacp_port_priority_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lacp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lacp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_lacp_timeout_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lacp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lacp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_lldp_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_lldp_cee_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lldp.cee', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lldp.cee', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_lldp_cee_lldp_cee_on_off_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lldp.cee', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lldp.cee', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_lldp_dcbx_version_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_lldp_disable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_lldp_iscsi_priority_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_lldp_profile_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_log_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.rpf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_mac_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_mac_access_group_get(self, fortygigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': 'mac_access_list, mac_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_mac_access_group_traffic_type_get(self, fortygigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_mac_learning_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac_learning', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac_learning', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_mac_learning_disable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_mac_learning_disable_vlan_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_mac_learning_disable_vlan_add_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_mac_learning_disable_vlan_remove_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_mtu_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fortygigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'trust'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'oui'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'raguard'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'forwarding'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'accessvlan'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'enable, direction'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'udld_enable'}, {'leafval': 'sticky_flag'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'use_link_local_only'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'mtu'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'gateway'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'logical_instance_id'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'attempts, time'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'native_vlan'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'root'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'in_, out'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'id, cost, priority'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'expire'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'basic'}, {'leafval': 'enable, match_profile'}, {'leafval': 'disable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'sg_addr'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'route_map_name'}, {'leafval': 'add_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'promiscuous, host'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vlan_mode'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'groupid, vlan'}, {'leafval': 'mtu'}, {'leafval': 'groupid, vlan'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'route_map_name'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'max_interval, min_'}, {'leafval': 'sticky_flag'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'raguard'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'protected_port_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'native_vlan'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'promiscuous, host'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'gateway'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'add_, remove_'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'log, mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'sg_addr'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'disable'}, {'leafval': 'oui'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'in_, out'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'channel'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'forwarding'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'trust'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'root'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'profile_domain_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'multinet_enable'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'bfd_enable'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'udld_enable'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'enable, direction'}, {'leafval': 'vlan_mode'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'enable, match_profile'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'logical_instance_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_openflow_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.openflow_interface_cfg', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.openflow_interface_cfg', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_openflow_enable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_openflow_logical_instance_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.openflow_interface_cfg', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.openflow_interface_cfg', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_openflow_match_profile_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_openflow_openflow_enable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable, match_profile'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_port_profile_port_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fortygigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'trust'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'oui'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'raguard'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'forwarding'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'accessvlan'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'enable, direction'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'udld_enable'}, {'leafval': 'sticky_flag'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'use_link_local_only'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'mtu'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'gateway'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'logical_instance_id'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'attempts, time'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'native_vlan'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'root'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'in_, out'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'id, cost, priority'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'expire'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'basic'}, {'leafval': 'enable, match_profile'}, {'leafval': 'disable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'sg_addr'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'route_map_name'}, {'leafval': 'add_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'promiscuous, host'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vlan_mode'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'groupid, vlan'}, {'leafval': 'mtu'}, {'leafval': 'groupid, vlan'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'route_map_name'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'max_interval, min_'}, {'leafval': 'sticky_flag'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'raguard'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'protected_port_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'native_vlan'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'promiscuous, host'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'gateway'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'add_, remove_'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'log, mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'sg_addr'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'disable'}, {'leafval': 'oui'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'in_, out'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'channel'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'forwarding'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'trust'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'root'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'profile_domain_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'multinet_enable'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'bfd_enable'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'udld_enable'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'enable, direction'}, {'leafval': 'vlan_mode'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'enable, match_profile'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'logical_instance_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_port_profile_port_domain_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_port_profile_port_domain_profile_domain_name_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_port_profile_port_profile_get(self, fortygigabitethernet=None, port_to_port_profile_associations=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_to_port_profile_associations: port_to_port_profile_association
    :param port_to_port_profile_associations: Keyword argument tuple.

    :type port_to_port_profile_association: unicode
    :param port_to_port_profile_association: **port_to_port_profile_associations** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_to_port_profile_associations', 'keyval': 'port_to_port_profile_association', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, port_to_port_profile_associations=port_to_port_profile_associations)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, port_to_port_profile_associations=port_to_port_profile_associations)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_port_profile_to_interface_associations_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_priority_tag_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fortygigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'trust'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'oui'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'raguard'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'forwarding'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'accessvlan'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'enable, direction'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'udld_enable'}, {'leafval': 'sticky_flag'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'use_link_local_only'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'mtu'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'gateway'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'logical_instance_id'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'attempts, time'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'native_vlan'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'root'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'in_, out'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'id, cost, priority'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'expire'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'basic'}, {'leafval': 'enable, match_profile'}, {'leafval': 'disable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'sg_addr'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'route_map_name'}, {'leafval': 'add_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'promiscuous, host'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vlan_mode'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'groupid, vlan'}, {'leafval': 'mtu'}, {'leafval': 'groupid, vlan'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'route_map_name'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'max_interval, min_'}, {'leafval': 'sticky_flag'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'raguard'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'protected_port_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'native_vlan'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'promiscuous, host'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'gateway'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'add_, remove_'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'log, mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'sg_addr'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'disable'}, {'leafval': 'oui'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'in_, out'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'channel'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'forwarding'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'trust'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'root'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'profile_domain_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'multinet_enable'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'bfd_enable'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'udld_enable'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'enable, direction'}, {'leafval': 'vlan_mode'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'enable, match_profile'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'logical_instance_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_protected_port_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.protected_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_protected_port_enable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.protected_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_cos_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_cos_mutation_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_cos_traffic_class_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_drop_monitor_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.drop_monitor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.drop_monitor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_drop_monitor_enable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.drop_monitor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.drop_monitor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_dscp_cos_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_dscp_mutation_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_dscp_traffic_class_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_ecn_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.ecn', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_flowcontrol_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_flowcontrol_link_level_flowcontrol_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_flowcontrol_pfc_get(self, fortygigabitethernet=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_flowcontrol_pfc_rx_get(self, fortygigabitethernet=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_flowcontrol_pfc_tx_get(self, fortygigabitethernet=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_flowcontrol_rx_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_flowcontrol_tx_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_random_detect_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.random_detect', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.ecn.random_detect', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_random_detect_2_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.random_detect', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_random_detect_ecn_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.ecn.random_detect.random_detect_ecn', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_random_detect_ecn_traffic_class_get(self, fortygigabitethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: int
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.ecn.random_detect.random_detect_ecn.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_random_detect_traffic_class_get(self, fortygigabitethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_random_detect_traffic_class_apply_get(self, fortygigabitethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_random_detect_traffic_class_red_profile_id_get(self, fortygigabitethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_trust_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.trust', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.trust', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_trust_cos_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.trust', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.trust', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_qos_trust_dscp_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.trust', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.trust', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_rmon_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_rmon_collection_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_rmon_collection_history_get(self, fortygigabitethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_buckets_requested: long
    :param history_control_buckets_requested: **history_control_entry** tuple argument:  Buckets (default 50)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_interval: long
    :param history_control_interval: **history_control_entry** tuple argument:  Polling Interval (default 1800)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_owner: unicode
    :param history_control_owner: **history_control_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_rmon_collection_history_buckets_get(self, fortygigabitethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_rmon_collection_history_interval_get(self, fortygigabitethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_rmon_collection_history_owner_get(self, fortygigabitethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_rmon_collection_stats_get(self, fortygigabitethernet=None, ether_stats_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index, ether_stats_owner
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type ether_stats_owner: unicode
    :param ether_stats_owner: **ether_stats_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': 'ether_stats_index, ether_stats_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ether_stats_entry=ether_stats_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ether_stats_entry=ether_stats_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_rmon_collection_stats_owner_get(self, fortygigabitethernet=None, ether_stats_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ether_stats_entry=ether_stats_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ether_stats_entry=ether_stats_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_rpf_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.rpf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_rpf_mode_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.rpf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_service_policy_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.service_policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.service_policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_service_policy_in_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.service_policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.service_policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_service_policy_out_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.service_policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.service_policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_sflow_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.sflow', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.sflow', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_sflow_enable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.sflow', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.sflow', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_sflow_polling_interval_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.sflow', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.sflow', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_sflow_sample_rate_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.sflow', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.sflow', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_shutdown_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'fortygigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'trust'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'oui'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'raguard'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'forwarding'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'accessvlan'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'enable, direction'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'udld_enable'}, {'leafval': 'sticky_flag'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'use_link_local_only'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'mtu'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'gateway'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'logical_instance_id'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'attempts, time'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'native_vlan'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'root'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'in_, out'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'id, cost, priority'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'expire'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'basic'}, {'leafval': 'enable, match_profile'}, {'leafval': 'disable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'sg_addr'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'route_map_name'}, {'leafval': 'add_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'promiscuous, host'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vlan_mode'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'groupid, vlan'}, {'leafval': 'mtu'}, {'leafval': 'groupid, vlan'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'route_map_name'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'max_interval, min_'}, {'leafval': 'sticky_flag'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'raguard'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'protected_port_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'native_vlan'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'promiscuous, host'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'gateway'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'add_, remove_'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'log, mode'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'sg_addr'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'disable'}, {'leafval': 'oui'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'in_, out'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'channel'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'forwarding'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'trust'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'root'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'profile_domain_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'multinet_enable'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'learn_any'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'bfd_enable'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'udld_enable'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'enable, direction'}, {'leafval': 'vlan_mode'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'enable, match_profile'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'logical_instance_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_snmp_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.snmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.snmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_snmp_trap_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.snmp.trap', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.snmp.trap', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_snmp_trap_link_status_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.snmp.trap', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.snmp.trap', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_autoedge_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_bpdu_mac_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_cost_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_edgeport_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_edgeport_bpdu_filter_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_edgeport_bpdu_guard_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_edgeport_edgeportbasic_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_guard_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_guard_root_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_hello_time_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_instance_get(self, fortygigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_instance_cost_get(self, fortygigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_instance_priority_get(self, fortygigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_instance_restricted_role_get(self, fortygigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_instance_restricted_tcn_get(self, fortygigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_link_type_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_portfast_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_portfast_bpdu_filter_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_portfast_bpdu_guard_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_portfast_portfastbasic_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_priority_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_restricted_role_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_restricted_tcn_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_shutdown_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_vlan_get(self, fortygigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.vlan', u'guard'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_vlan_cost_get(self, fortygigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.vlan', u'guard'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_vlan_guard_get(self, fortygigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_vlan_guard_root_get(self, fortygigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_spanning_tree_vlan_priority_get(self, fortygigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.spanning_tree.vlan', u'guard'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_storm_control_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.storm_control', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.storm_control', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_storm_control_ingress_get(self, fortygigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type, rate_format, rate_bps, rate_percent, bum_action
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type rate_format: unicode
    :param rate_format: **ingress** tuple argument.

        * enumeration restriction: ::

            ['limit-bps', 'limit-percent']

    :type rate_bps: long
    :param rate_bps: **ingress** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type rate_percent: long
    :param rate_percent: **ingress** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bum_action: unicode
    :param bum_action: **ingress** tuple argument.

        * enumeration restriction: ::

            ['monitor', 'shutdown']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_storm_control_ingress_bum_action_get(self, fortygigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_storm_control_ingress_rate_bps_get(self, fortygigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_storm_control_ingress_rate_format_get(self, fortygigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_storm_control_ingress_rate_percent_get(self, fortygigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport_basic', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport_basic', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_access_mac_group_rspan_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_access_mac_group_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_access_mac_rspan_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_access_mac_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_mac_group_rspan_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_mac_group_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_mac_rspan_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_mac_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_rspan_access_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access.rspan_access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access.rspan_access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_rspan_vlan_get(self, fortygigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_rspan_vlan_access_mac_rspan_vlan_classification_get(self, fortygigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_vlan_get(self, fortygigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_access_vlan_access_mac_vlan_classification_get(self, fortygigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_basic_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport_basic', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport_basic', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_private_vlan_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_private_vlan_host_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_private_vlan_promiscuous_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_private_vlan_trunk_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_private_vlan_trunk_host_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_private_vlan_trunk_promiscuous_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_private_vlan_trunk_trunk_basic_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_mode_vlan_mode_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.mode', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.mode', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_allowed_ouis_get(self, fortygigabitethernet=None, allowed_ouis=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type allowed_ouis: oui
    :param allowed_ouis: Keyword argument tuple.

    :type oui: unicode
    :param oui: **allowed_ouis** tuple argument:  <OUI> OUI in HHHH.HH00.0000 format

        * pattern restriction: ::

            '[0-9a-fA-F]{4}\.[0-9a-fA-F]{2}00\.0000'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'allowed_ouis', 'keyval': 'oui', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, allowed_ouis=allowed_ouis)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, allowed_ouis=allowed_ouis)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_max_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_port_secutiry_mac_address_get(self, fortygigabitethernet=None, port_secutiry_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_shutdown_time_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_sticky_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security.sticky', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_sticky_port_secutiry_mac_address_get(self, fortygigabitethernet=None, port_secutiry_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_sticky_sticky_flag_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security.sticky', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_port_security_violation_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_association_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_association_trunk_get(self, fortygigabitethernet=None, trunk=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type trunk: trunk_pri_pvlan, trunk_sec_pvlan
    :param trunk: Keyword argument tuple.

    :type trunk_pri_pvlan: long
    :param trunk_pri_pvlan: **trunk** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type trunk_sec_pvlan: long
    :param trunk_sec_pvlan: **trunk** tuple argument:  Secondary vlan id 

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'trunk', 'keyval': 'trunk_pri_pvlan, trunk_sec_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, trunk=trunk)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, trunk=trunk)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_host_association_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'host_pri_pvlan, host_sec_pvlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_host_association_host_pri_pvlan_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_host_association_host_sec_pvlan_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_mapping_get(self, fortygigabitethernet=None, mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan, oper, promis_sec_pvlan_range
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type oper: unicode
    :param oper: **mapping** tuple argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type promis_sec_pvlan_range: unicode
    :param promis_sec_pvlan_range: **mapping** tuple argument:  Secondary vlan range

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-7][0-9]{3})|(80[0-9]{2})|'
            '(81[0-8][0-9])|(819[01]))(-(([2-9])|([1-9][0-9]{'
            '1,2})|([1-7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9]'
            ')|(819[01])))?((,(([2-9])|([1-9][0-9]{1,2})|([1-'
            '7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9])|(819[01]'
            '))(-(([3-9])|([1-9][0-9]{1,2})|([1-7][0-9]{3})|('
            '80[0-9]{2})|(81[0-8][0-9])|(819[01])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, mapping=mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_mapping_oper_get(self, fortygigabitethernet=None, mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, mapping=mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_mapping_promis_sec_pvlan_range_get(self, fortygigabitethernet=None, mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, mapping=mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_trunk_private_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_vlan_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_vlan_add_get(self, fortygigabitethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_vlan_all_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_vlan_except_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_vlan_none_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_vlan_remove_get(self, fortygigabitethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_allowed_vlan_trunk_private_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_native_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_native_ctag_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_native_vlan_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_private_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_tag_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_tag_native_vlan_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_private_vlan_trunk_trunk_private_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_rspan_vlan_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_rspan_vlan_add_get(self, fortygigabitethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_rspan_vlan_remove_get(self, fortygigabitethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_rspan_vlan_trunk_rspan_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_trunk_rspan_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_trunk_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_add_get(self, fortygigabitethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_add_ctag_get(self, fortygigabitethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_all_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_except_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_none_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_remove_get(self, fortygigabitethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_remove_ctag_get(self, fortygigabitethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlan_trunk_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlanoper_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlanoper_vlan_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlanoper_vlan_add_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_allowed_vlanoper_vlan_remove_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_ctag_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_ctag_native_vlan_xtagged_config_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_default_vlan_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_default_vlan_config_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_transparent_vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_egress_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_native_vlan_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_native_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id, native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_native_vlan_untagged_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_native_vlan_untagged_config_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_untagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_native_vlan_xtagged_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_native_vlan_xtagged_config_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_private_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_tag_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_tag_native_vlan_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_switchport_trunk_trunk_vlan_classification_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_track_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_track_enable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_track_interface_get(self, fortygigabitethernet=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface: track_interface_type, track_interface_name
    :param interface: Keyword argument tuple.

    :type track_interface_type: unicode
    :param track_interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type track_interface_name: unicode
    :param track_interface_name: **interface** tuple argument:  Interface name

        * pattern restriction: ::

            '(((([1-9]|[1-9][0-9]|1[0-9]{2}|2[0-3][0-9])/)?(('
            '[0-9]|1[0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]'
            ')(:[1-4])?)|([1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5'
            '][0-9]{3}|6[0-1][0-4]{2}))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'track_interface_type, track_interface_name', 'extra_keyval': 'track_interface_type, track_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_track_min_link_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_track_remove_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_track_remove_all_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.track.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.track.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_tunable_optics_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.tunable_optics', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_tunable_optics_sfpp_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.tunable_optics.sfpp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_tunable_optics_sfpp_channel_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.tunable_optics.sfpp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_tunnel_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.tunnel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.tunnel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_tunnel_tagged_ieee_bpdu_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.tunnel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.tunnel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_udld_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.udld', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.udld', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_udld_enable_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.udld', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.udld', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vlan_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vlan_classifier_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vlan.classifier', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vlan.classifier', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vlan_classifier_activate_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vlan.classifier.activate', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vlan.classifier.activate', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vlan_classifier_activate_group_get(self, fortygigabitethernet=None, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type group: groupid, vlan
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vlan: long
    :param vlan: **group** tuple argument:  1-8191;;Vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': 'groupid, vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vlan_classifier_activate_group_vlan_get(self, fortygigabitethernet=None, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type group: groupid
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrf_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrf_forwarding_get(self, fortygigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_get(self, fortygigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_advertisement_interval_get(self, fortygigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_arp_get(self, fortygigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.arp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_arp_unicast_request_get(self, fortygigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_arp_unicast_request_receive_get(self, fortygigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_description_get(self, fortygigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_enable_get(self, fortygigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_hold_time_get(self, fortygigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_preempt_mode_get(self, fortygigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_priority_get(self, fortygigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_track_get(self, fortygigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_track_interface_get(self, fortygigabitethernet=None, vrrp=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_track_interface_priority_get(self, fortygigabitethernet=None, vrrp=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_use_v2_checksum_get(self, fortygigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_fortygigabitethernet_vrrp_group_virtual_ip_get(self, fortygigabitethernet=None, vrrp=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type fortygigabitethernet: name
    :param fortygigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **fortygigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address in dotted decimal

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet', u'fortygigabitethernet'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.fortygigabitethernet.vrrp.virtual_ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.fortygigabitethernet.vrrp.virtual_ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, fortygigabitethernet=fortygigabitethernet, vrrp=vrrp, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.gigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.gigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.gigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.gigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', u'drop_monitor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'gigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'add_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'enable, match_profile'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'trust'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'groupid, vlan'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'bfd_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'basic'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'accessvlan'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'route_map_name'}, {'leafval': 'disable'}, {'leafval': 'mtu'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'sticky_flag'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'oui'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'attempts, time'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'root'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'use_link_local_only'}, {'leafval': 'logical_instance_id'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'id, cost, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'forwarding'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'in_, out'}, {'leafval': 'raguard'}, {'leafval': 'sg_addr'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'native_vlan'}, {'leafval': 'profile_domain_name'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'max_interval, min_'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'bfd_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'groupid, vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'raguard'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'disable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'oui'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'vlan_mode'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'use_link_local_only'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'promiscuous, host'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'accessvlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'protected_port_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'in_, out'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'trust'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mtu'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'basic'}, {'leafval': 'attempts, time'}, {'leafval': 'enable, direction'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'sg_addr'}, {'leafval': 'expire'}, {'leafval': 'enable, match_profile'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'multinet_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'route_map_name'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'log, mode'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'channel'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'logical_instance_id'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'learn_any'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'root'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'gateway'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'red_tc_value'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'id, cost, priority'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'sticky_flag'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'drop_monitor_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_bfd_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_bfd_interval_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.bfd.interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_bfd_interval_min_rx_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.bfd.interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_bfd_interval_min_tx_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.bfd.interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_bfd_interval_multiplier_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.bfd.interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_bfd_shutdown_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_bpdu_drop_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.bpdu_drop', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable, direction'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_bpdu_drop_direction_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.bpdu_drop', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_bpdu_drop_enable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.bpdu_drop', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_channel_group_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.channel_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.channel_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'port_int, mode, type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_channel_group_mode_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.channel_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.channel_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_channel_group_port_int_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.channel_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.channel_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_channel_group_type_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.channel_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.channel_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_description_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.gigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.gigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.gigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.gigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', u'drop_monitor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'gigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'add_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'enable, match_profile'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'trust'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'groupid, vlan'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'bfd_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'basic'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'accessvlan'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'route_map_name'}, {'leafval': 'disable'}, {'leafval': 'mtu'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'sticky_flag'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'oui'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'attempts, time'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'root'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'use_link_local_only'}, {'leafval': 'logical_instance_id'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'id, cost, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'forwarding'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'in_, out'}, {'leafval': 'raguard'}, {'leafval': 'sg_addr'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'native_vlan'}, {'leafval': 'profile_domain_name'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'max_interval, min_'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'bfd_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'groupid, vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'raguard'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'disable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'oui'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'vlan_mode'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'use_link_local_only'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'promiscuous, host'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'accessvlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'protected_port_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'in_, out'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'trust'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mtu'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'basic'}, {'leafval': 'attempts, time'}, {'leafval': 'enable, direction'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'sg_addr'}, {'leafval': 'expire'}, {'leafval': 'enable, match_profile'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'multinet_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'route_map_name'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'log, mode'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'channel'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'logical_instance_id'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'learn_any'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'root'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'gateway'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'red_tc_value'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'id, cost, priority'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'sticky_flag'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'drop_monitor_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_deviceconnectivity_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.connectivity', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.connectivity', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_dot1x_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x": {"reauthMax": "reauthMax", "port_control": "port_control", "quiet_period": "quiet_period", "authentication": "authentication", "reauthentication": "reauthentication", "protocol_version": "protocol_version"}, "pybind.nos.v7_2_0.interface.gigabitethernet.dot1x": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_dot1x_authentication_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_dot1x_mac_auth_bypass_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_dot1x_mac_auth_enable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_dot1x_port_control_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_dot1x_protocol_version_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_dot1x_quiet_period_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_dot1x_reauthentication_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_dot1x_reauthmax_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_dot1x_timeout_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_dot1x_timeout_re_authperiod_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_dot1x_timeout_server_timeout_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_dot1x_timeout_supp_timeout_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_dot1x_timeout_tx_period_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_edge_loop_detection_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_edge_loop_detection_port_priority_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_edge_loop_detection_vlan_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_fabric_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.fabric', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.fabric', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_fabric_neighbor_discovery_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_fabric_neighbor_discovery_disable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ifindex_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.gigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.gigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.gigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.gigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', u'drop_monitor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'gigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'add_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'enable, match_profile'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'trust'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'groupid, vlan'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'bfd_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'basic'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'accessvlan'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'route_map_name'}, {'leafval': 'disable'}, {'leafval': 'mtu'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'sticky_flag'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'oui'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'attempts, time'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'root'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'use_link_local_only'}, {'leafval': 'logical_instance_id'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'id, cost, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'forwarding'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'in_, out'}, {'leafval': 'raguard'}, {'leafval': 'sg_addr'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'native_vlan'}, {'leafval': 'profile_domain_name'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'max_interval, min_'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'bfd_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'groupid, vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'raguard'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'disable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'oui'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'vlan_mode'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'use_link_local_only'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'promiscuous, host'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'accessvlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'protected_port_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'in_, out'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'trust'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mtu'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'basic'}, {'leafval': 'attempts, time'}, {'leafval': 'enable, direction'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'sg_addr'}, {'leafval': 'expire'}, {'leafval': 'enable, match_profile'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'multinet_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'route_map_name'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'log, mode'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'channel'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'logical_instance_id'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'learn_any'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'root'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'gateway'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'red_tc_value'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'id, cost, priority'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'sticky_flag'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'drop_monitor_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_access_group_get(self, gigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': 'ip_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_access_group_traffic_type_get(self, gigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_acl_interface_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_acl_interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_acl_interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_address_get(self, gigabitethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary, ospf_passive, ospf_ignore
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: **address** tuple argument:  ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: **address** tuple argument:  ospf active address on the specific interface

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_address_ospf_ignore_get(self, gigabitethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_address_ospf_passive_get(self, gigabitethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_address_secondary_get(self, gigabitethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_arp_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.arp_node_config.arp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.arp_node_config.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_arp_aging_timeout_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_arp_inspection_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_arp_inspection_trust_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_arp_ip_config_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_arp_learn_any_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_arp_node_config_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.arp_node_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.arp_node_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_dhcp_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_dhcp_relay_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_dhcp_relay_gateway_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_dhcp_relay_servers_get(self, gigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  A.B.C.D;; IP address of the DHCP server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCP server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr, server_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_directed_broadcast_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_icmp_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_icmp_address_mask_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_icmp_echo_reply_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_icmp_rate_limiting_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_icmp_redirect_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_icmp_unreachable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp": {"immediate_leave": "immediate_leave", "last_member_query_interval": "last_member_query_interval", "query_interval": "query_interval", "query_max_response_time": "query_max_response_time"}, "pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_immediate_leave_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_last_member_query_count_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_last_member_query_interval_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_phy_intf_cfg_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_query_interval_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_query_max_response_time_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_robustness_variable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_startup_query_count_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_startup_query_interval_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_igmp_static_group_get(self, gigabitethernet=None, static_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type static_group: sg_addr
    :param static_group: Keyword argument tuple.

    :type sg_addr: unicode
    :param sg_addr: **static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'sg_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, static_group=static_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_interface_gi_dhcp_conf_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_interface_gi_ospf_conf_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ip_acl_interface_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_acl_interface.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_acl_interface.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ip_config_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ip_pbr_interface_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_pbr_interface.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_pbr_interface.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_mtu_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_multicast_boundary_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_active_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_area_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_auth_change_wait_time_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_authentication_key_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_authentication_key_auth_key_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_authentication_key_auth_key_table_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_authentication_key_encrypttype_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_authentication_key_no_encrypt_auth_key_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_authentication_key_no_encrypt_auth_key_table_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_bfd_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_bfd_intf_bfd_enable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_cost_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_database_filter_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_database_filter_all_external_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_database_filter_all_out_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_database_filter_all_summary_external_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_dead_interval_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_hello_interval_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_md5_authentication_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_md5_authentication_key_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_md5_authentication_key_activation_wait_time_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_md5_authentication_key_id_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_md5_authentication_key_id_key_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_md5_authentication_key_id_key_id_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_md5_authentication_key_id_md5_authentication_key_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_md5_authentication_no_encrypt_key_table_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_encrypt_key_id, no_encrypt_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_mtu_ignore_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_network_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_passive_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_priority_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_retransmit_interval_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_ospf_transmit_delay_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_pbr_interface_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_pbr_interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_pbr_interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_pim_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_pim_dr_priority_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_pim_int_cmd_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_pim_intf_phy_cont_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_pim_multinet_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_pim_multinet_enable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_pim_neighbor_filter_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_pim_sparse_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_policy_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_policy_route_map_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_policy_route_map_route_map_name_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_proxy_arp_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_unnumbered_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ip_donor_interface_type, ip_donor_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_unnumbered_ip_donor_interface_name_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ip_unnumbered_ip_donor_interface_type_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_access_group_get(self, gigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': 'ipv6_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_access_group_traffic_type_get(self, gigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_ipv6_address_get(self, gigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_ipv6_address_anycast_get(self, gigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_ipv6_address_eui_64_get(self, gigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_ipv6_address_secondary_get(self, gigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_ipv6_address_secondary_eui_config_get(self, gigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_link_local_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_link_local_address_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_link_local_config_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_address_use_link_local_only_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_dhcp_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_dhcp_relay_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_dhcp_relay_servers_get(self, gigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_dhcp_relay_servers_interface_get(self, gigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_dhcp_relay_servers_interface_interface_get(self, gigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_dhcp_relay_servers_interface_interface_name_get(self, gigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_dhcp_relay_servers_use_vrf_get(self, gigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_hop_by_hop_trap_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_icmpv6_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_icmpv6_echo_reply_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_icmpv6_rate_limiting_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_icmpv6_redirect_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_icmpv6_unreachable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_interface_phy_dhcp_conf_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ipv6_config_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ipv6_intf_cmds_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ipv6_nd_ra_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ipv6_phy_intf_cmds_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_mtu_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd": {"managed_config_flag": "managed_config_flag", "broadcast_mac_trap": "broadcast_mac_trap", "ra_lifetime": "ra_lifetime", "hoplimit": "hoplimit", "mtu": "mtu", "retrans_timer": "retrans_timer", "other_config_flag": "other_config_flag", "ns_interval": "ns_interval", "reachable_time": "reachable_time", "proxy": "proxy"}, "pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_broadcast_mac_trap_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_cache_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'expire'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_cache_expire_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_dad_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_dad_attempts_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_dad_time_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_hoplimit_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_managed_config_flag_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_mtu_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_ns_interval_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_nud_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_nud_retry_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'base, interval, max_attempts'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_nud_retry_base_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_nud_retry_interval_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_nud_retry_max_attempts_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_other_config_flag_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_get(self, gigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_advertise, valid_lifetime, valid_infinite'}, {'leafval': 'no_autoconfig, no_onlink, off_link'}, {'leafval': 'preferred_lifetime, preferred_infinite'}, {'leafval': 'no_advertise, valid_lifetime, valid_infinite'}, {'leafval': 'no_autoconfig, no_onlink, off_link'}, {'leafval': 'preferred_lifetime, preferred_infinite'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_infinite_get(self, gigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_infinite_preferred_get(self, gigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_no_advertise_get(self, gigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_no_autoconfig_get(self, gigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_no_onlink_get(self, gigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_off_link_get(self, gigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_preferred_get(self, gigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'preferred_lifetime, preferred_infinite'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_preferred_lifetime_get(self, gigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_prefix_flags_get(self, gigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_autoconfig, no_onlink, off_link'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_prefix_valid_lifetime_get(self, gigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_proxy_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_ra_interval_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_interval, min_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_ra_interval_max_interval_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_ra_interval_min_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_ra_lifetime_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_reachable_time_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_retrans_timer_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_set_cache_expire_time_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_set_hoplimit_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_suppress_ra_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_suppress_ra_all_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_suppress_ra_mtu_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_nd_suppress_ra_suppress_ra_flag_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_neighbor_get(self, gigabitethernet=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_neighbor_hardware_address_get(self, gigabitethernet=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_active_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_area_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_ah_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_esp_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_esp_auth_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_esp_key_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_esp_no_encrypt_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_ipsec_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_ipsec_auth_key_config_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_ipsec_disable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_ipsec_key_add_remove_interval_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_key_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_no_encrypt_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_authentication_spi_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_bfd_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_bfd_bfd_enable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_cost_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_dead_interval_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_hello_interval_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_hello_jitter_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_instance_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_link_interval_properties_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_mtu_ignore_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_network_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_passive_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_priority_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_retransmit_interval_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_suppress_linklsa_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_ospf_transmit_delay_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_policy_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_policy_route_map_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.policy.route_map', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_policy_route_map_ipv6_route_map_name_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.policy.route_map', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_raguard_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_get(self, gigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_advertise_backup_get(self, gigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_advertisement_interval_get(self, gigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_advertisement_interval_scale_get(self, gigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_backup_advertisement_interval_get(self, gigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_description_get(self, gigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_enable_get(self, gigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_hold_time_get(self, gigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_nd_advertisement_timer_get(self, gigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_preempt_mode_get(self, gigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_priority_get(self, gigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_get(self, gigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_basic_get(self, gigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_revert_priority_get(self, gigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_track_get(self, gigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_track_interface_get(self, gigabitethernet=None, vrrpv3e_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_track_interface_priority_get(self, gigabitethernet=None, vrrpv3e_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_extended_group_virtual_ip_get(self, gigabitethernet=None, vrrpv3e_group=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_get(self, gigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_advertisement_interval_get(self, gigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_description_get(self, gigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_enable_get(self, gigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_hold_time_get(self, gigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_preempt_mode_get(self, gigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_priority_get(self, gigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_track_get(self, gigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_track_interface_get(self, gigabitethernet=None, vrrpv3_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_track_interface_priority_get(self, gigabitethernet=None, vrrpv3_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_use_v2_checksum_get(self, gigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_group_virtual_ip_get(self, gigabitethernet=None, vrrpv3_group=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_ipv6_vrrp_suppress_interface_ra_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_lacp_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.lacp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lacp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_lacp_default_up_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.lacp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lacp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_lacp_port_priority_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.lacp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lacp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_lacp_timeout_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.lacp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lacp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_lldp_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_lldp_cee_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.lldp.cee', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lldp.cee', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_lldp_cee_lldp_cee_on_off_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.lldp.cee', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lldp.cee', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_lldp_dcbx_version_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_lldp_disable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_lldp_iscsi_priority_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_lldp_profile_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_log_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.rpf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_mac_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.mac', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_mac_access_group_get(self, gigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.mac.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': 'mac_access_list, mac_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_mac_access_group_traffic_type_get(self, gigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.mac.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_mac_learning_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.mac_learning', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac_learning', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_mac_learning_disable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_mac_learning_disable_vlan_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_mac_learning_disable_vlan_add_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_mac_learning_disable_vlan_remove_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_mtu_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.gigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.gigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.gigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.gigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', u'drop_monitor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'gigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'add_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'enable, match_profile'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'trust'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'groupid, vlan'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'bfd_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'basic'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'accessvlan'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'route_map_name'}, {'leafval': 'disable'}, {'leafval': 'mtu'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'sticky_flag'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'oui'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'attempts, time'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'root'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'use_link_local_only'}, {'leafval': 'logical_instance_id'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'id, cost, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'forwarding'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'in_, out'}, {'leafval': 'raguard'}, {'leafval': 'sg_addr'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'native_vlan'}, {'leafval': 'profile_domain_name'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'max_interval, min_'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'bfd_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'groupid, vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'raguard'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'disable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'oui'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'vlan_mode'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'use_link_local_only'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'promiscuous, host'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'accessvlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'protected_port_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'in_, out'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'trust'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mtu'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'basic'}, {'leafval': 'attempts, time'}, {'leafval': 'enable, direction'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'sg_addr'}, {'leafval': 'expire'}, {'leafval': 'enable, match_profile'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'multinet_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'route_map_name'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'log, mode'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'channel'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'logical_instance_id'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'learn_any'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'root'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'gateway'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'red_tc_value'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'id, cost, priority'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'sticky_flag'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'drop_monitor_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_openflow_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.openflow_interface_cfg', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.openflow_interface_cfg', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_openflow_enable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_openflow_logical_instance_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.openflow_interface_cfg', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.openflow_interface_cfg', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_openflow_match_profile_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_openflow_openflow_enable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable, match_profile'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_port_profile_port_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.gigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.gigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.gigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.gigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', u'drop_monitor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'gigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'add_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'enable, match_profile'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'trust'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'groupid, vlan'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'bfd_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'basic'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'accessvlan'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'route_map_name'}, {'leafval': 'disable'}, {'leafval': 'mtu'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'sticky_flag'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'oui'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'attempts, time'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'root'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'use_link_local_only'}, {'leafval': 'logical_instance_id'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'id, cost, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'forwarding'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'in_, out'}, {'leafval': 'raguard'}, {'leafval': 'sg_addr'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'native_vlan'}, {'leafval': 'profile_domain_name'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'max_interval, min_'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'bfd_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'groupid, vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'raguard'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'disable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'oui'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'vlan_mode'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'use_link_local_only'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'promiscuous, host'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'accessvlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'protected_port_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'in_, out'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'trust'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mtu'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'basic'}, {'leafval': 'attempts, time'}, {'leafval': 'enable, direction'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'sg_addr'}, {'leafval': 'expire'}, {'leafval': 'enable, match_profile'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'multinet_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'route_map_name'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'log, mode'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'channel'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'logical_instance_id'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'learn_any'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'root'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'gateway'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'red_tc_value'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'id, cost, priority'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'sticky_flag'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'drop_monitor_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_port_profile_port_domain_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_port_profile_port_domain_profile_domain_name_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_port_profile_port_profile_get(self, gigabitethernet=None, port_to_port_profile_associations=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_to_port_profile_associations: port_to_port_profile_association
    :param port_to_port_profile_associations: Keyword argument tuple.

    :type port_to_port_profile_association: unicode
    :param port_to_port_profile_association: **port_to_port_profile_associations** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_to_port_profile_associations', 'keyval': 'port_to_port_profile_association', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, port_to_port_profile_associations=port_to_port_profile_associations)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, port_to_port_profile_associations=port_to_port_profile_associations)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_port_profile_to_interface_associations_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_priority_tag_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.gigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.gigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.gigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.gigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', u'drop_monitor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'gigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'add_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'enable, match_profile'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'trust'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'groupid, vlan'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'bfd_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'basic'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'accessvlan'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'route_map_name'}, {'leafval': 'disable'}, {'leafval': 'mtu'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'sticky_flag'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'oui'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'attempts, time'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'root'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'use_link_local_only'}, {'leafval': 'logical_instance_id'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'id, cost, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'forwarding'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'in_, out'}, {'leafval': 'raguard'}, {'leafval': 'sg_addr'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'native_vlan'}, {'leafval': 'profile_domain_name'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'max_interval, min_'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'bfd_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'groupid, vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'raguard'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'disable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'oui'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'vlan_mode'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'use_link_local_only'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'promiscuous, host'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'accessvlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'protected_port_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'in_, out'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'trust'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mtu'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'basic'}, {'leafval': 'attempts, time'}, {'leafval': 'enable, direction'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'sg_addr'}, {'leafval': 'expire'}, {'leafval': 'enable, match_profile'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'multinet_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'route_map_name'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'log, mode'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'channel'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'logical_instance_id'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'learn_any'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'root'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'gateway'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'red_tc_value'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'id, cost, priority'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'sticky_flag'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'drop_monitor_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_protected_port_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.protected_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_protected_port_enable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.protected_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_cos_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_cos_mutation_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_cos_traffic_class_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_drop_monitor_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.drop_monitor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.drop_monitor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_drop_monitor_enable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.drop_monitor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.drop_monitor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_dscp_cos_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_dscp_mutation_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_dscp_traffic_class_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_ecn_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.qos.ecn', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_flowcontrol_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_flowcontrol_link_level_flowcontrol_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_flowcontrol_rx_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_flowcontrol_tx_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_random_detect_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.random_detect', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.ecn.random_detect', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_random_detect_2_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.qos.random_detect', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_random_detect_ecn_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.qos.ecn.random_detect.random_detect_ecn', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_random_detect_ecn_traffic_class_get(self, gigabitethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: int
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.qos.ecn.random_detect.random_detect_ecn.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_random_detect_traffic_class_get(self, gigabitethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_random_detect_traffic_class_apply_get(self, gigabitethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_random_detect_traffic_class_red_profile_id_get(self, gigabitethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_cos0_threshold_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_cos1_threshold_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_cos2_threshold_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_cos3_threshold_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_cos4_threshold_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_cos5_threshold_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_cos6_threshold_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_rcv_queue_cos_threshold_cos7_threshold_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_trust_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.trust', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.trust', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_trust_cos_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.trust', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.trust', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_qos_trust_dscp_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.trust', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.trust', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_rmon_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_rmon_collection_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_rmon_collection_history_get(self, gigabitethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_buckets_requested: long
    :param history_control_buckets_requested: **history_control_entry** tuple argument:  Buckets (default 50)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_interval: long
    :param history_control_interval: **history_control_entry** tuple argument:  Polling Interval (default 1800)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_owner: unicode
    :param history_control_owner: **history_control_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_rmon_collection_history_buckets_get(self, gigabitethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_rmon_collection_history_interval_get(self, gigabitethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_rmon_collection_history_owner_get(self, gigabitethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_rmon_collection_stats_get(self, gigabitethernet=None, ether_stats_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index, ether_stats_owner
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type ether_stats_owner: unicode
    :param ether_stats_owner: **ether_stats_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': 'ether_stats_index, ether_stats_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ether_stats_entry=ether_stats_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ether_stats_entry=ether_stats_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_rmon_collection_stats_owner_get(self, gigabitethernet=None, ether_stats_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ether_stats_entry=ether_stats_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ether_stats_entry=ether_stats_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_rpf_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.rpf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_rpf_mode_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.rpf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_service_policy_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.service_policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.service_policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_service_policy_in_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.service_policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.service_policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_service_policy_out_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.service_policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.service_policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_sflow_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.sflow', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.sflow', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_sflow_enable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.sflow', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.sflow', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_sflow_polling_interval_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.sflow', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.sflow', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_sflow_sample_rate_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.sflow', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.sflow', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_shutdown_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.gigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.gigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.gigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.gigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.gigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.gigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ip.interface_gi_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.gigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.gigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.gigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.gigabitethernet.qos', u'drop_monitor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'gigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'add_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'enable, match_profile'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'trust'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'groupid, vlan'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'bfd_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'basic'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'accessvlan'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'route_map_name'}, {'leafval': 'disable'}, {'leafval': 'mtu'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'sticky_flag'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'oui'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'attempts, time'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'root'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'use_link_local_only'}, {'leafval': 'logical_instance_id'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'id, cost, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'forwarding'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'in_, out'}, {'leafval': 'raguard'}, {'leafval': 'sg_addr'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'native_vlan'}, {'leafval': 'profile_domain_name'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'max_interval, min_'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'bfd_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'groupid, vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'raguard'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'disable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'oui'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'vlan_mode'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'use_link_local_only'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'promiscuous, host'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'accessvlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'protected_port_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'in_, out'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'trust'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mtu'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'basic'}, {'leafval': 'attempts, time'}, {'leafval': 'enable, direction'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'sg_addr'}, {'leafval': 'expire'}, {'leafval': 'enable, match_profile'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'forwarding'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'multinet_enable'}, {'leafval': 'udld_enable'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'route_map_name'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'log, mode'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'channel'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'logical_instance_id'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'learn_any'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'root'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'gateway'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'red_tc_value'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'id, cost, priority'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'sticky_flag'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'drop_monitor_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_snmp_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.snmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.snmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_snmp_trap_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.snmp.trap', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.snmp.trap', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_snmp_trap_link_status_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.snmp.trap', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.snmp.trap', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_autoedge_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_bpdu_mac_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_cost_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_edgeport_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_edgeport_bpdu_filter_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_edgeport_bpdu_guard_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_edgeport_edgeportbasic_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_guard_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_guard_root_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_hello_time_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_instance_get(self, gigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_instance_cost_get(self, gigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_instance_priority_get(self, gigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_instance_restricted_role_get(self, gigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_instance_restricted_tcn_get(self, gigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_link_type_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_portfast_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_portfast_bpdu_filter_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_portfast_bpdu_guard_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_portfast_portfastbasic_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_priority_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_restricted_role_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_restricted_tcn_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_shutdown_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_vlan_get(self, gigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.vlan', u'guard'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_vlan_cost_get(self, gigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.vlan', u'guard'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_vlan_guard_get(self, gigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_vlan_guard_root_get(self, gigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_spanning_tree_vlan_priority_get(self, gigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.spanning_tree.vlan', u'guard'), ('pybind.nos.v7_2_0.interface.gigabitethernet.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_storm_control_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.storm_control', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.storm_control', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_storm_control_ingress_get(self, gigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type, rate_format, rate_bps, rate_percent, bum_action
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type rate_format: unicode
    :param rate_format: **ingress** tuple argument.

        * enumeration restriction: ::

            ['limit-bps', 'limit-percent']

    :type rate_bps: long
    :param rate_bps: **ingress** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type rate_percent: long
    :param rate_percent: **ingress** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bum_action: unicode
    :param bum_action: **ingress** tuple argument.

        * enumeration restriction: ::

            ['monitor', 'shutdown']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_storm_control_ingress_bum_action_get(self, gigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_storm_control_ingress_rate_bps_get(self, gigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_storm_control_ingress_rate_format_get(self, gigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_storm_control_ingress_rate_percent_get(self, gigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport_basic', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport_basic', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_access_mac_group_rspan_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_access_mac_group_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_access_mac_rspan_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_access_mac_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_mac_group_rspan_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_mac_group_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_mac_rspan_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_mac_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_rspan_access_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access.rspan_access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access.rspan_access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_rspan_vlan_get(self, gigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_rspan_vlan_access_mac_rspan_vlan_classification_get(self, gigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_vlan_get(self, gigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_access_vlan_access_mac_vlan_classification_get(self, gigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_basic_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport_basic', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport_basic', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_private_vlan_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_private_vlan_host_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_private_vlan_promiscuous_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_private_vlan_trunk_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_private_vlan_trunk_host_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_private_vlan_trunk_promiscuous_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_private_vlan_trunk_trunk_basic_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_mode_vlan_mode_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.mode', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.mode', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_allowed_ouis_get(self, gigabitethernet=None, allowed_ouis=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type allowed_ouis: oui
    :param allowed_ouis: Keyword argument tuple.

    :type oui: unicode
    :param oui: **allowed_ouis** tuple argument:  <OUI> OUI in HHHH.HH00.0000 format

        * pattern restriction: ::

            '[0-9a-fA-F]{4}\.[0-9a-fA-F]{2}00\.0000'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'allowed_ouis', 'keyval': 'oui', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, allowed_ouis=allowed_ouis)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, allowed_ouis=allowed_ouis)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_max_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_port_secutiry_mac_address_get(self, gigabitethernet=None, port_secutiry_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_shutdown_time_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_sticky_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security.sticky', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_sticky_port_secutiry_mac_address_get(self, gigabitethernet=None, port_secutiry_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_sticky_sticky_flag_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security.sticky', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_port_security_violation_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_association_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_association_trunk_get(self, gigabitethernet=None, trunk=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type trunk: trunk_pri_pvlan, trunk_sec_pvlan
    :param trunk: Keyword argument tuple.

    :type trunk_pri_pvlan: long
    :param trunk_pri_pvlan: **trunk** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type trunk_sec_pvlan: long
    :param trunk_sec_pvlan: **trunk** tuple argument:  Secondary vlan id 

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'trunk', 'keyval': 'trunk_pri_pvlan, trunk_sec_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, trunk=trunk)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, trunk=trunk)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_host_association_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'host_pri_pvlan, host_sec_pvlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_host_association_host_pri_pvlan_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_host_association_host_sec_pvlan_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_mapping_get(self, gigabitethernet=None, mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan, oper, promis_sec_pvlan_range
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type oper: unicode
    :param oper: **mapping** tuple argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type promis_sec_pvlan_range: unicode
    :param promis_sec_pvlan_range: **mapping** tuple argument:  Secondary vlan range

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-7][0-9]{3})|(80[0-9]{2})|'
            '(81[0-8][0-9])|(819[01]))(-(([2-9])|([1-9][0-9]{'
            '1,2})|([1-7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9]'
            ')|(819[01])))?((,(([2-9])|([1-9][0-9]{1,2})|([1-'
            '7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9])|(819[01]'
            '))(-(([3-9])|([1-9][0-9]{1,2})|([1-7][0-9]{3})|('
            '80[0-9]{2})|(81[0-8][0-9])|(819[01])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, mapping=mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_mapping_oper_get(self, gigabitethernet=None, mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, mapping=mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_mapping_promis_sec_pvlan_range_get(self, gigabitethernet=None, mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, mapping=mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_trunk_private_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_vlan_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_vlan_add_get(self, gigabitethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_vlan_all_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_vlan_except_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_vlan_none_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_vlan_remove_get(self, gigabitethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_allowed_vlan_trunk_private_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_native_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_native_ctag_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_native_vlan_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_private_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_tag_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_tag_native_vlan_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_private_vlan_trunk_trunk_private_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_rspan_vlan_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_rspan_vlan_add_get(self, gigabitethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_rspan_vlan_remove_get(self, gigabitethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_rspan_vlan_trunk_rspan_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_trunk_rspan_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_trunk_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_add_get(self, gigabitethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_add_ctag_get(self, gigabitethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_all_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_except_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_none_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_remove_get(self, gigabitethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_remove_ctag_get(self, gigabitethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlan_trunk_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlanoper_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlanoper_vlan_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlanoper_vlan_add_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_allowed_vlanoper_vlan_remove_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_ctag_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_ctag_native_vlan_xtagged_config_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_default_vlan_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_default_vlan_config_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_transparent_vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_egress_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_native_vlan_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_native_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id, native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_native_vlan_untagged_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_native_vlan_untagged_config_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_untagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_native_vlan_xtagged_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_native_vlan_xtagged_config_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_private_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_tag_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_tag_native_vlan_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_switchport_trunk_trunk_vlan_classification_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_track_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_track_enable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_track_interface_get(self, gigabitethernet=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface: track_interface_type, track_interface_name
    :param interface: Keyword argument tuple.

    :type track_interface_type: unicode
    :param track_interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type track_interface_name: unicode
    :param track_interface_name: **interface** tuple argument:  Interface name

        * pattern restriction: ::

            '(((([1-9]|[1-9][0-9]|1[0-9]{2}|2[0-3][0-9])/)?(('
            '[0-9]|1[0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]'
            ')(:[1-4])?)|([1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5'
            '][0-9]{3}|6[0-1][0-4]{2}))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'track_interface_type, track_interface_name', 'extra_keyval': 'track_interface_type, track_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_track_min_link_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_track_remove_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.track.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_track_remove_all_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.track.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.track.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_tunable_optics_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.tunable_optics', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_tunable_optics_sfpp_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.tunable_optics.sfpp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_tunable_optics_sfpp_channel_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.tunable_optics.sfpp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_tunnel_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.tunnel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.tunnel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_tunnel_tagged_ieee_bpdu_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.tunnel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.tunnel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_udld_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.udld', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.udld', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_udld_enable_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.udld', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.udld', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vlan_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vlan_classifier_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vlan.classifier', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vlan.classifier', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vlan_classifier_activate_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vlan.classifier.activate', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vlan.classifier.activate', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vlan_classifier_activate_group_get(self, gigabitethernet=None, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type group: groupid, vlan
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vlan: long
    :param vlan: **group** tuple argument:  1-8191;;Vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': 'groupid, vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vlan_classifier_activate_group_vlan_get(self, gigabitethernet=None, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type group: groupid
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrf_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrf_forwarding_get(self, gigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_get(self, gigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.arp', u'unicast_request')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_advertisement_interval_get(self, gigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.arp', u'unicast_request')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_arp_get(self, gigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.arp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_arp_unicast_request_get(self, gigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_arp_unicast_request_receive_get(self, gigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_description_get(self, gigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.arp', u'unicast_request')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_enable_get(self, gigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.arp', u'unicast_request')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_hold_time_get(self, gigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.arp', u'unicast_request')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_preempt_mode_get(self, gigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.arp', u'unicast_request')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_priority_get(self, gigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.arp', u'unicast_request')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_track_get(self, gigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_track_interface_get(self, gigabitethernet=None, vrrp=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_track_interface_priority_get(self, gigabitethernet=None, vrrp=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_use_v2_checksum_get(self, gigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.arp', u'unicast_request')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_gigabitethernet_vrrp_group_virtual_ip_get(self, gigabitethernet=None, vrrp=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type gigabitethernet: name
    :param gigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **gigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address in dotted decimal

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.gigabitethernet', u'gigabitethernet'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.gigabitethernet.vrrp.virtual_ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.gigabitethernet.vrrp.virtual_ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, gigabitethernet=gigabitethernet, vrrp=vrrp, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, gigabitethernet=gigabitethernet, vrrp=vrrp, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'vrf'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.homerun', u'udld'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.homerun', u'channel_group'), ('pybind.slxos.v17s_1_02.interface.homerun', u'sflow'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.homerun', u'lldp'), ('pybind.slxos.v17s_1_02.interface.homerun', u'ipv6'), ('pybind.slxos.v17s_1_02.interface.homerun', u'bfd'), ('pybind.slxos.v17s_1_02.interface.homerun.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access', u'rspan_access'), ('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.interface.homerun.lldp', u'cee'), ('pybind.slxos.v17s_1_02.interface.homerun.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.bfd', u'interval'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun', u'lacp'), ('pybind.slxos.v17s_1_02.interface.homerun', u'track'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17s_1_02.interface.homerun.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed', u'rspan_vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'homerun', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'forwarding'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'udld_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'raguard'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'learn_any'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'basic'}, {'leafval': 'use_link_local_only'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mtu'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan'}, {'leafval': 'accessvlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vlan_mode'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_bfd_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.bfd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_bfd_interval_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_bfd_interval_min_rx_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_bfd_interval_min_tx_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_bfd_interval_multiplier_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_bfd_shutdown_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.bfd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_channel_group_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.channel_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'port_int, mode, type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_channel_group_mode_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.channel_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_channel_group_port_int_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.channel_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_channel_group_type_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.channel_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_description_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'vrf'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.homerun', u'udld'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.homerun', u'channel_group'), ('pybind.slxos.v17s_1_02.interface.homerun', u'sflow'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.homerun', u'lldp'), ('pybind.slxos.v17s_1_02.interface.homerun', u'ipv6'), ('pybind.slxos.v17s_1_02.interface.homerun', u'bfd'), ('pybind.slxos.v17s_1_02.interface.homerun.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access', u'rspan_access'), ('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.interface.homerun.lldp', u'cee'), ('pybind.slxos.v17s_1_02.interface.homerun.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.bfd', u'interval'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun', u'lacp'), ('pybind.slxos.v17s_1_02.interface.homerun', u'track'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17s_1_02.interface.homerun.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed', u'rspan_vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'homerun', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'forwarding'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'udld_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'raguard'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'learn_any'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'basic'}, {'leafval': 'use_link_local_only'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mtu'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan'}, {'leafval': 'accessvlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vlan_mode'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ifindex_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'vrf'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.homerun', u'udld'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.homerun', u'channel_group'), ('pybind.slxos.v17s_1_02.interface.homerun', u'sflow'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.homerun', u'lldp'), ('pybind.slxos.v17s_1_02.interface.homerun', u'ipv6'), ('pybind.slxos.v17s_1_02.interface.homerun', u'bfd'), ('pybind.slxos.v17s_1_02.interface.homerun.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access', u'rspan_access'), ('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.interface.homerun.lldp', u'cee'), ('pybind.slxos.v17s_1_02.interface.homerun.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.bfd', u'interval'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun', u'lacp'), ('pybind.slxos.v17s_1_02.interface.homerun', u'track'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17s_1_02.interface.homerun.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed', u'rspan_vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'homerun', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'forwarding'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'udld_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'raguard'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'learn_any'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'basic'}, {'leafval': 'use_link_local_only'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mtu'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan'}, {'leafval': 'accessvlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vlan_mode'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ip_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ip_address_get(self, homerun=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary, ospf_passive, ospf_ignore
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: **address** tuple argument:  ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: **address** tuple argument:  ospf active address on the specific interface

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ip_address_ospf_ignore_get(self, homerun=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ip_address_ospf_passive_get(self, homerun=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ip_address_secondary_get(self, homerun=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ip_arp_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config.arp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ip_arp_aging_timeout_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ip_arp_learn_any_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config.arp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ip_directed_broadcast_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ip_ip_config_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ip_mtu_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ip_proxy_arp_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ip_unnumbered_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config.unnumbered', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ip_donor_interface_type, ip_donor_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ip_unnumbered_ip_donor_interface_name_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config.unnumbered', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ip_unnumbered_ip_donor_interface_type_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config.unnumbered', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ipv6_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ipv6_address_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ipv6_address_ipv6_address_get(self, homerun=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ipv6_address_ipv6_address_anycast_get(self, homerun=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ipv6_address_ipv6_address_eui_64_get(self, homerun=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ipv6_address_ipv6_address_secondary_get(self, homerun=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ipv6_address_ipv6_address_secondary_eui_config_get(self, homerun=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ipv6_address_link_local_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ipv6_address_link_local_address_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ipv6_address_link_local_config_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ipv6_address_use_link_local_only_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ipv6_ipv6_config_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ipv6_mtu_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_ipv6_raguard_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.ipv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_lacp_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.lacp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_lacp_default_up_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.lacp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_lacp_port_priority_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.lacp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_lacp_timeout_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.lacp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_lldp_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_lldp_cee_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.lldp.cee', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_lldp_cee_lldp_cee_on_off_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.lldp.cee', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_lldp_dcbx_version_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_lldp_disable_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_lldp_iscsi_priority_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_lldp_profile_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_mtu_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'vrf'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.homerun', u'udld'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.homerun', u'channel_group'), ('pybind.slxos.v17s_1_02.interface.homerun', u'sflow'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.homerun', u'lldp'), ('pybind.slxos.v17s_1_02.interface.homerun', u'ipv6'), ('pybind.slxos.v17s_1_02.interface.homerun', u'bfd'), ('pybind.slxos.v17s_1_02.interface.homerun.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access', u'rspan_access'), ('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.interface.homerun.lldp', u'cee'), ('pybind.slxos.v17s_1_02.interface.homerun.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.bfd', u'interval'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun', u'lacp'), ('pybind.slxos.v17s_1_02.interface.homerun', u'track'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17s_1_02.interface.homerun.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed', u'rspan_vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'homerun', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'forwarding'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'udld_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'raguard'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'learn_any'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'basic'}, {'leafval': 'use_link_local_only'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mtu'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan'}, {'leafval': 'accessvlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vlan_mode'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_sflow_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.sflow', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_sflow_enable_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.sflow', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_sflow_polling_interval_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.sflow', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_sflow_sample_rate_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.sflow', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_shutdown_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'vrf'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.homerun', u'udld'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.homerun', u'channel_group'), ('pybind.slxos.v17s_1_02.interface.homerun', u'sflow'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.homerun', u'lldp'), ('pybind.slxos.v17s_1_02.interface.homerun', u'ipv6'), ('pybind.slxos.v17s_1_02.interface.homerun', u'bfd'), ('pybind.slxos.v17s_1_02.interface.homerun.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access', u'rspan_access'), ('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.interface.homerun.lldp', u'cee'), ('pybind.slxos.v17s_1_02.interface.homerun.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.bfd', u'interval'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun', u'lacp'), ('pybind.slxos.v17s_1_02.interface.homerun', u'track'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.homerun.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.interface.homerun.ip.ip_config', u'unnumbered'), ('pybind.slxos.v17s_1_02.interface.homerun.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed', u'rspan_vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'homerun', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'forwarding'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'udld_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'raguard'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'learn_any'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'basic'}, {'leafval': 'use_link_local_only'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'add_, remove_'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mtu'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan'}, {'leafval': 'accessvlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vlan_mode'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport_basic', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_access_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_access_mac_group_rspan_vlan_classification_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_group_rspan_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_access_mac_group_rspan_vlan_classification_access_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_group_rspan_vlan_classification.access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_access_mac_group_rspan_vlan_classification_access_rspan_vlan_get(self, homerun=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_access_mac_group_vlan_classification_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_group_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_access_mac_group_vlan_classification_access_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_group_vlan_classification.access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_access_mac_group_vlan_classification_access_vlan_get(self, homerun=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_access_mac_rspan_vlan_classification_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_rspan_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_access_mac_rspan_vlan_classification_access_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_rspan_vlan_classification.access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_access_mac_rspan_vlan_classification_access_rspan_vlan_get(self, homerun=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_access_mac_vlan_classification_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_access_mac_vlan_classification_access_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_vlan_classification.access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_access_mac_vlan_classification_access_vlan_get(self, homerun=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.access_mac_vlan_classification.access.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_access_rspan_access_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.access.rspan_access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_access_rspan_vlan_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.access.rspan_access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_access_vlan_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_mode_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.mode', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_mode_vlan_mode_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.mode', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_port_security_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_port_security_max_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_port_security_port_secutiry_mac_address_get(self, homerun=None, port_secutiry_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security.port_secutiry_mac_address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_port_security_shutdown_time_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_port_security_sticky_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security.sticky', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_port_security_sticky_port_secutiry_mac_address_get(self, homerun=None, port_secutiry_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_port_security_violation_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.port_security', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_rspan_vlan_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.rspan_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_rspan_vlan_add_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.rspan_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_rspan_vlan_remove_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.rspan_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_trunk_rspan_vlan_classification_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_trunk_rspan_vlan_classification_rspan_vlan_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_trunk_rspan_vlan_classification_rspan_vlan_add_get(self, homerun=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_trunk_rspan_vlan_classification_rspan_vlan_remove_get(self, homerun=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_vlan_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_vlan_add_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_vlan_all_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_vlan_except_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_vlan_none_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_vlan_remove_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_vlanoper_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.vlanoper', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_vlanoper_vlan_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_vlanoper_vlan_add_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_allowed_vlanoper_vlan_remove_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_ctag_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_ctag_native_vlan_xtagged_config_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_default_vlan_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.default_vlan_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_default_vlan_config_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.default_vlan_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_transparent_vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_egress_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_native_vlan_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_native_vlan_classification_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id, native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_native_vlan_untagged_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_native_vlan_untagged_config_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_untagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_native_vlan_xtagged_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_native_vlan_xtagged_config_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_tag_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.tag', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_tag_native_vlan_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.tag', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_trunk_vlan_classification_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_trunk_vlan_classification_allowed_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_trunk_vlan_classification_allowed_vlan_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_trunk_vlan_classification_allowed_vlan_add_get(self, homerun=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_trunk_vlan_classification_allowed_vlan_add_ctag_get(self, homerun=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_trunk_vlan_classification_allowed_vlan_remove_get(self, homerun=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_switchport_trunk_trunk_vlan_classification_allowed_vlan_remove_ctag_get(self, homerun=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_track_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.track', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_track_enable_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.track', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_track_interface_get(self, homerun=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface: track_interface_type, track_interface_name
    :param interface: Keyword argument tuple.

    :type track_interface_type: unicode
    :param track_interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type track_interface_name: unicode
    :param track_interface_name: **interface** tuple argument:  Interface name

        * pattern restriction: ::

            '(((([1-9]|[1-9][0-9]|1[0-9]{2}|2[0-3][0-9])/)?(('
            '[0-9]|1[0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]'
            ')(:[1-4])?)|([1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5'
            '][0-9]{3}|6[0-1][0-4]{2}))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'track_interface_type, track_interface_name', 'extra_keyval': 'track_interface_type, track_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_track_min_link_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.track', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_track_remove_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.track.remove_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_track_remove_all_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.track.remove_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_udld_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.udld', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_udld_enable_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.udld', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_vrf_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.vrf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_homerun_vrf_forwarding_get(self, homerun=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type homerun: name
    :param homerun: Keyword argument tuple.

    :type name: unicode
    :param name: **homerun** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.homerun', u'homerun')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.homerun.vrf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, homerun=homerun)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, homerun=homerun)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'fec'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'dot1x')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hundredgigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gateway'}, {'leafval': 'disable'}, {'leafval': 'enable, match_profile'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'raguard'}, {'leafval': 'basic'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, direction'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'root'}, {'leafval': 'forwarding'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sticky_flag'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'trust'}, {'leafval': 'expire'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'promiscuous, host'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'use_link_local_only'}, {'leafval': 'logical_instance_id'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'id, cost, priority'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'route_map_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'groupid, vlan'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'oui'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'in_, out'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'native_vlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'sg_addr'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'udld_enable'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'max_interval, min_'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_, remove_'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'profile_domain_name'}, {'leafval': 'mtu'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'route_map_name'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'profile_domain_name'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'channel'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'logical_instance_id'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'disable'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'raguard'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'forwarding'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'log, mode'}, {'leafval': 'native_vlan'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'protected_port_enable'}, {'leafval': 'bfd_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'oui'}, {'leafval': 'enable, direction'}, {'leafval': 'sticky_flag'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'expire'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'max_interval, min_'}, {'leafval': 'enable, match_profile'}, {'leafval': 'trust'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'use_link_local_only'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_, remove_'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'gateway'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'root'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'basic'}, {'leafval': 'attempts, time'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'promiscuous, host'}, {'leafval': 'id, cost, priority'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'accessvlan'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sg_addr'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'mtu'}, {'leafval': 'udld_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'red_tc_value'}, {'leafval': 'groupid, vlan'}, {'leafval': 'multinet_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'learn_any'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fec_enable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_bfd_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_bfd_interval_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_bfd_interval_min_rx_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_bfd_interval_min_tx_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_bfd_interval_multiplier_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_bfd_shutdown_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_bpdu_drop_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bpdu_drop', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable, direction'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_bpdu_drop_direction_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bpdu_drop', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_bpdu_drop_enable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bpdu_drop', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_cee_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'fec'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'dot1x')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hundredgigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gateway'}, {'leafval': 'disable'}, {'leafval': 'enable, match_profile'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'raguard'}, {'leafval': 'basic'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, direction'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'root'}, {'leafval': 'forwarding'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sticky_flag'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'trust'}, {'leafval': 'expire'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'promiscuous, host'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'use_link_local_only'}, {'leafval': 'logical_instance_id'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'id, cost, priority'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'route_map_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'groupid, vlan'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'oui'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'in_, out'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'native_vlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'sg_addr'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'udld_enable'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'max_interval, min_'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_, remove_'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'profile_domain_name'}, {'leafval': 'mtu'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'route_map_name'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'profile_domain_name'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'channel'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'logical_instance_id'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'disable'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'raguard'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'forwarding'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'log, mode'}, {'leafval': 'native_vlan'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'protected_port_enable'}, {'leafval': 'bfd_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'oui'}, {'leafval': 'enable, direction'}, {'leafval': 'sticky_flag'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'expire'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'max_interval, min_'}, {'leafval': 'enable, match_profile'}, {'leafval': 'trust'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'use_link_local_only'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_, remove_'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'gateway'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'root'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'basic'}, {'leafval': 'attempts, time'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'promiscuous, host'}, {'leafval': 'id, cost, priority'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'accessvlan'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sg_addr'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'mtu'}, {'leafval': 'udld_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'red_tc_value'}, {'leafval': 'groupid, vlan'}, {'leafval': 'multinet_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'learn_any'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fec_enable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_channel_group_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'port_int, mode, type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_channel_group_mode_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_channel_group_port_int_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_channel_group_type_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.channel_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_description_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'fec'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'dot1x')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hundredgigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gateway'}, {'leafval': 'disable'}, {'leafval': 'enable, match_profile'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'raguard'}, {'leafval': 'basic'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, direction'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'root'}, {'leafval': 'forwarding'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sticky_flag'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'trust'}, {'leafval': 'expire'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'promiscuous, host'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'use_link_local_only'}, {'leafval': 'logical_instance_id'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'id, cost, priority'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'route_map_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'groupid, vlan'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'oui'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'in_, out'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'native_vlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'sg_addr'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'udld_enable'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'max_interval, min_'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_, remove_'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'profile_domain_name'}, {'leafval': 'mtu'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'route_map_name'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'profile_domain_name'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'channel'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'logical_instance_id'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'disable'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'raguard'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'forwarding'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'log, mode'}, {'leafval': 'native_vlan'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'protected_port_enable'}, {'leafval': 'bfd_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'oui'}, {'leafval': 'enable, direction'}, {'leafval': 'sticky_flag'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'expire'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'max_interval, min_'}, {'leafval': 'enable, match_profile'}, {'leafval': 'trust'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'use_link_local_only'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_, remove_'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'gateway'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'root'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'basic'}, {'leafval': 'attempts, time'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'promiscuous, host'}, {'leafval': 'id, cost, priority'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'accessvlan'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sg_addr'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'mtu'}, {'leafval': 'udld_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'red_tc_value'}, {'leafval': 'groupid, vlan'}, {'leafval': 'multinet_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'learn_any'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fec_enable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_deviceconnectivity_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.connectivity', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.connectivity', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x": {"reauthMax": "reauthMax", "port_control": "port_control", "quiet_period": "quiet_period", "authentication": "authentication", "reauthentication": "reauthentication", "protocol_version": "protocol_version"}, "pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_authentication_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_mac_auth_bypass_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_mac_auth_enable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_port_control_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_protocol_version_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_quiet_period_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_reauthentication_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_reauthmax_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_timeout_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_timeout_re_authperiod_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_timeout_server_timeout_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_timeout_supp_timeout_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_dot1x_timeout_tx_period_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_edge_loop_detection_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_edge_loop_detection_port_priority_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_edge_loop_detection_vlan_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_fabric_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_fabric_dport_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric.fabric_dport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric.fabric_dport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric.fabric_dport": {"fabric_dport_enable": "fabric_dport_enable"}, "pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric.fabric_dport": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_fabric_dport_enable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric.fabric_dport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_fabric_dport_mode_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric.fabric_dport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_fabric_isl_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric.fabric_isl', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric.fabric_isl', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_fabric_isl_enable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric.fabric_isl', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric.fabric_isl', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_fabric_neighbor_discovery_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_fabric_neighbor_discovery_disable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_fabric_trunk_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric.fabric_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric.fabric_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_fabric_trunk_enable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric.fabric_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric.fabric_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_fcoeport_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fcoeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fcoeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'fcoeport_map, ns_ip_registration'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_fcoeport_map_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fcoeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fcoeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_fcoeport_ns_ip_registration_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fcoeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fcoeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_fec_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_fec_enable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ifindex_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'fec'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'dot1x')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hundredgigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gateway'}, {'leafval': 'disable'}, {'leafval': 'enable, match_profile'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'raguard'}, {'leafval': 'basic'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, direction'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'root'}, {'leafval': 'forwarding'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sticky_flag'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'trust'}, {'leafval': 'expire'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'promiscuous, host'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'use_link_local_only'}, {'leafval': 'logical_instance_id'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'id, cost, priority'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'route_map_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'groupid, vlan'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'oui'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'in_, out'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'native_vlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'sg_addr'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'udld_enable'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'max_interval, min_'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_, remove_'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'profile_domain_name'}, {'leafval': 'mtu'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'route_map_name'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'profile_domain_name'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'channel'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'logical_instance_id'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'disable'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'raguard'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'forwarding'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'log, mode'}, {'leafval': 'native_vlan'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'protected_port_enable'}, {'leafval': 'bfd_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'oui'}, {'leafval': 'enable, direction'}, {'leafval': 'sticky_flag'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'expire'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'max_interval, min_'}, {'leafval': 'enable, match_profile'}, {'leafval': 'trust'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'use_link_local_only'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_, remove_'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'gateway'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'root'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'basic'}, {'leafval': 'attempts, time'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'promiscuous, host'}, {'leafval': 'id, cost, priority'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'accessvlan'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sg_addr'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'mtu'}, {'leafval': 'udld_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'red_tc_value'}, {'leafval': 'groupid, vlan'}, {'leafval': 'multinet_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'learn_any'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fec_enable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_access_group_get(self, hundredgigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': 'ip_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_access_group_traffic_type_get(self, hundredgigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_acl_interface_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_acl_interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_acl_interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_address_get(self, hundredgigabitethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary, ospf_passive, ospf_ignore
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: **address** tuple argument:  ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: **address** tuple argument:  ospf active address on the specific interface

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_address_ospf_ignore_get(self, hundredgigabitethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_address_ospf_passive_get(self, hundredgigabitethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_address_secondary_get(self, hundredgigabitethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_arp_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.arp_node_config.arp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.arp_node_config.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_arp_aging_timeout_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_arp_inspection_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_arp_inspection_trust_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_arp_ip_config_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_arp_learn_any_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_arp_node_config_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.arp_node_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.arp_node_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_dhcp_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_dhcp_relay_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_dhcp_relay_gateway_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_dhcp_relay_servers_get(self, hundredgigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  A.B.C.D;; IP address of the DHCP server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCP server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr, server_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_directed_broadcast_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_icmp_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_icmp_address_mask_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_icmp_echo_reply_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_icmp_rate_limiting_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_icmp_redirect_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_icmp_unreachable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp": {}, "pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp": {"immediate_leave": "immediate_leave", "last_member_query_interval": "last_member_query_interval", "query_interval": "query_interval", "query_max_response_time": "query_max_response_time"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_immediate_leave_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_last_member_query_count_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_last_member_query_interval_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_phy_intf_cfg_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_query_interval_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_query_max_response_time_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_robustness_variable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_startup_query_count_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_startup_query_interval_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_igmp_static_group_get(self, hundredgigabitethernet=None, static_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type static_group: sg_addr
    :param static_group: Keyword argument tuple.

    :type sg_addr: unicode
    :param sg_addr: **static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'sg_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, static_group=static_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_interface_fo_ospf_conf_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_interface_hu_dhcp_conf_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ip_acl_interface_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_acl_interface.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_acl_interface.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ip_config_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ip_pbr_interface_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_pbr_interface.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_pbr_interface.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_mtu_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_multicast_boundary_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_active_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_area_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_auth_change_wait_time_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_authentication_key_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_authentication_key_auth_key_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_authentication_key_auth_key_table_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_authentication_key_encrypttype_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_authentication_key_no_encrypt_auth_key_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_authentication_key_no_encrypt_auth_key_table_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_bfd_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_bfd_intf_bfd_enable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_cost_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_database_filter_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_database_filter_all_external_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_database_filter_all_out_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_database_filter_all_summary_external_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_dead_interval_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_hello_interval_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_md5_authentication_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_md5_authentication_key_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_md5_authentication_key_activation_wait_time_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_md5_authentication_key_id_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_md5_authentication_key_id_key_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_md5_authentication_key_id_key_id_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_md5_authentication_key_id_md5_authentication_key_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_md5_authentication_no_encrypt_key_table_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_encrypt_key_id, no_encrypt_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_mtu_ignore_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_network_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_passive_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_priority_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_retransmit_interval_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_ospf_transmit_delay_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_pbr_interface_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_pbr_interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_pbr_interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_pim_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_pim_dr_priority_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_pim_int_cmd_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_pim_intf_phy_cont_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_pim_multinet_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_pim_multinet_enable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_pim_neighbor_filter_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_pim_sparse_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_policy_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_policy_route_map_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_policy_route_map_route_map_name_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_proxy_arp_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_unnumbered_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ip_donor_interface_type, ip_donor_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_unnumbered_ip_donor_interface_name_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ip_unnumbered_ip_donor_interface_type_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_access_group_get(self, hundredgigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': 'ipv6_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_access_group_traffic_type_get(self, hundredgigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_ipv6_address_get(self, hundredgigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_ipv6_address_anycast_get(self, hundredgigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_ipv6_address_eui_64_get(self, hundredgigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_ipv6_address_secondary_get(self, hundredgigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_ipv6_address_secondary_eui_config_get(self, hundredgigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_link_local_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_link_local_address_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_link_local_config_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_address_use_link_local_only_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_dhcp_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_dhcp_relay_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_dhcp_relay_servers_get(self, hundredgigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_dhcp_relay_servers_interface_get(self, hundredgigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_dhcp_relay_servers_interface_interface_get(self, hundredgigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_dhcp_relay_servers_interface_interface_name_get(self, hundredgigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_dhcp_relay_servers_use_vrf_get(self, hundredgigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_hop_by_hop_trap_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_icmpv6_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_icmpv6_echo_reply_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_icmpv6_rate_limiting_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_icmpv6_redirect_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_icmpv6_unreachable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_interface_phy_dhcp_conf_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ipv6_config_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ipv6_intf_cmds_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ipv6_nd_ra_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ipv6_phy_intf_cmds_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_mtu_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd": {"managed_config_flag": "managed_config_flag", "broadcast_mac_trap": "broadcast_mac_trap", "ra_lifetime": "ra_lifetime", "hoplimit": "hoplimit", "mtu": "mtu", "retrans_timer": "retrans_timer", "other_config_flag": "other_config_flag", "ns_interval": "ns_interval", "reachable_time": "reachable_time", "proxy": "proxy"}, "pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_broadcast_mac_trap_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_cache_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'expire'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_cache_expire_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_dad_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_dad_attempts_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_dad_time_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_hoplimit_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_managed_config_flag_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_mtu_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_ns_interval_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_nud_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_nud_retry_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'base, interval, max_attempts'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_nud_retry_base_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_nud_retry_interval_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_nud_retry_max_attempts_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_other_config_flag_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_get(self, hundredgigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_advertise, valid_lifetime, valid_infinite'}, {'leafval': 'no_autoconfig, no_onlink, off_link'}, {'leafval': 'preferred_lifetime, preferred_infinite'}, {'leafval': 'preferred_lifetime, preferred_infinite'}, {'leafval': 'no_autoconfig, no_onlink, off_link'}, {'leafval': 'no_advertise, valid_lifetime, valid_infinite'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_infinite_get(self, hundredgigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_infinite_preferred_get(self, hundredgigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_no_advertise_get(self, hundredgigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_no_autoconfig_get(self, hundredgigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_no_onlink_get(self, hundredgigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_off_link_get(self, hundredgigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_preferred_get(self, hundredgigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'preferred_lifetime, preferred_infinite'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_preferred_lifetime_get(self, hundredgigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_prefix_flags_get(self, hundredgigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_autoconfig, no_onlink, off_link'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_prefix_valid_lifetime_get(self, hundredgigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_proxy_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_ra_interval_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_interval, min_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_ra_interval_max_interval_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_ra_interval_min_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_ra_lifetime_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_reachable_time_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_retrans_timer_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_set_cache_expire_time_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_set_hoplimit_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_suppress_ra_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_suppress_ra_all_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_suppress_ra_mtu_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_nd_suppress_ra_suppress_ra_flag_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_neighbor_get(self, hundredgigabitethernet=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_neighbor_hardware_address_get(self, hundredgigabitethernet=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_active_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_area_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_ah_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_esp_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_esp_auth_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_esp_key_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_esp_no_encrypt_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_ipsec_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_ipsec_auth_key_config_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_ipsec_disable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_ipsec_key_add_remove_interval_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_key_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_no_encrypt_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_authentication_spi_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_bfd_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_bfd_bfd_enable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_cost_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_dead_interval_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_hello_interval_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_hello_jitter_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_instance_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_link_interval_properties_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_mtu_ignore_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_network_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_passive_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_priority_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_retransmit_interval_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_suppress_linklsa_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_ospf_transmit_delay_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_policy_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_policy_route_map_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.policy.route_map', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_policy_route_map_ipv6_route_map_name_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.policy.route_map', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_raguard_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_advertise_backup_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_advertisement_interval_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_advertisement_interval_scale_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_backup_advertisement_interval_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_description_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_enable_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_hold_time_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_nd_advertisement_timer_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_preempt_mode_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_priority_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_basic_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_revert_priority_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_track_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_track_interface_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_track_interface_priority_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_extended_group_virtual_ip_get(self, hundredgigabitethernet=None, vrrpv3e_group=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_get(self, hundredgigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_advertisement_interval_get(self, hundredgigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_description_get(self, hundredgigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_enable_get(self, hundredgigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_hold_time_get(self, hundredgigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_preempt_mode_get(self, hundredgigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_priority_get(self, hundredgigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_track_get(self, hundredgigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_track_interface_get(self, hundredgigabitethernet=None, vrrpv3_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_track_interface_priority_get(self, hundredgigabitethernet=None, vrrpv3_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_use_v2_checksum_get(self, hundredgigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_group_virtual_ip_get(self, hundredgigabitethernet=None, vrrpv3_group=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_ipv6_vrrp_suppress_interface_ra_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_lacp_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lacp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lacp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_lacp_default_up_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lacp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lacp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_lacp_port_priority_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lacp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lacp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_lacp_timeout_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lacp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lacp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_lldp_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_lldp_cee_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lldp.cee', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lldp.cee', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_lldp_cee_lldp_cee_on_off_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lldp.cee', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lldp.cee', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_lldp_dcbx_version_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_lldp_disable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_lldp_iscsi_priority_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_lldp_profile_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_log_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rpf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_mac_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_mac_access_group_get(self, hundredgigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': 'mac_access_list, mac_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_mac_access_group_traffic_type_get(self, hundredgigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_mac_learning_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac_learning', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac_learning', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_mac_learning_disable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_mac_learning_disable_vlan_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_mac_learning_disable_vlan_add_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_mac_learning_disable_vlan_remove_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_mtu_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'fec'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'dot1x')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hundredgigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gateway'}, {'leafval': 'disable'}, {'leafval': 'enable, match_profile'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'raguard'}, {'leafval': 'basic'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, direction'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'root'}, {'leafval': 'forwarding'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sticky_flag'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'trust'}, {'leafval': 'expire'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'promiscuous, host'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'use_link_local_only'}, {'leafval': 'logical_instance_id'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'id, cost, priority'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'route_map_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'groupid, vlan'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'oui'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'in_, out'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'native_vlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'sg_addr'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'udld_enable'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'max_interval, min_'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_, remove_'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'profile_domain_name'}, {'leafval': 'mtu'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'route_map_name'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'profile_domain_name'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'channel'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'logical_instance_id'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'disable'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'raguard'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'forwarding'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'log, mode'}, {'leafval': 'native_vlan'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'protected_port_enable'}, {'leafval': 'bfd_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'oui'}, {'leafval': 'enable, direction'}, {'leafval': 'sticky_flag'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'expire'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'max_interval, min_'}, {'leafval': 'enable, match_profile'}, {'leafval': 'trust'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'use_link_local_only'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_, remove_'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'gateway'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'root'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'basic'}, {'leafval': 'attempts, time'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'promiscuous, host'}, {'leafval': 'id, cost, priority'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'accessvlan'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sg_addr'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'mtu'}, {'leafval': 'udld_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'red_tc_value'}, {'leafval': 'groupid, vlan'}, {'leafval': 'multinet_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'learn_any'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fec_enable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_openflow_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.openflow_interface_cfg', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.openflow_interface_cfg', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_openflow_enable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_openflow_logical_instance_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.openflow_interface_cfg', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.openflow_interface_cfg', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_openflow_match_profile_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_openflow_openflow_enable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable, match_profile'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_port_profile_port_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'fec'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'dot1x')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hundredgigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gateway'}, {'leafval': 'disable'}, {'leafval': 'enable, match_profile'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'raguard'}, {'leafval': 'basic'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, direction'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'root'}, {'leafval': 'forwarding'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sticky_flag'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'trust'}, {'leafval': 'expire'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'promiscuous, host'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'use_link_local_only'}, {'leafval': 'logical_instance_id'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'id, cost, priority'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'route_map_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'groupid, vlan'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'oui'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'in_, out'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'native_vlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'sg_addr'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'udld_enable'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'max_interval, min_'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_, remove_'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'profile_domain_name'}, {'leafval': 'mtu'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'route_map_name'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'profile_domain_name'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'channel'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'logical_instance_id'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'disable'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'raguard'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'forwarding'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'log, mode'}, {'leafval': 'native_vlan'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'protected_port_enable'}, {'leafval': 'bfd_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'oui'}, {'leafval': 'enable, direction'}, {'leafval': 'sticky_flag'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'expire'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'max_interval, min_'}, {'leafval': 'enable, match_profile'}, {'leafval': 'trust'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'use_link_local_only'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_, remove_'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'gateway'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'root'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'basic'}, {'leafval': 'attempts, time'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'promiscuous, host'}, {'leafval': 'id, cost, priority'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'accessvlan'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sg_addr'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'mtu'}, {'leafval': 'udld_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'red_tc_value'}, {'leafval': 'groupid, vlan'}, {'leafval': 'multinet_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'learn_any'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fec_enable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_port_profile_port_domain_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_port_profile_port_domain_profile_domain_name_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_port_profile_port_profile_get(self, hundredgigabitethernet=None, port_to_port_profile_associations=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_to_port_profile_associations: port_to_port_profile_association
    :param port_to_port_profile_associations: Keyword argument tuple.

    :type port_to_port_profile_association: unicode
    :param port_to_port_profile_association: **port_to_port_profile_associations** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_to_port_profile_associations', 'keyval': 'port_to_port_profile_association', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, port_to_port_profile_associations=port_to_port_profile_associations)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, port_to_port_profile_associations=port_to_port_profile_associations)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_port_profile_to_interface_associations_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_priority_tag_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'fec'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'dot1x')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hundredgigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gateway'}, {'leafval': 'disable'}, {'leafval': 'enable, match_profile'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'raguard'}, {'leafval': 'basic'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, direction'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'root'}, {'leafval': 'forwarding'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sticky_flag'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'trust'}, {'leafval': 'expire'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'promiscuous, host'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'use_link_local_only'}, {'leafval': 'logical_instance_id'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'id, cost, priority'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'route_map_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'groupid, vlan'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'oui'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'in_, out'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'native_vlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'sg_addr'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'udld_enable'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'max_interval, min_'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_, remove_'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'profile_domain_name'}, {'leafval': 'mtu'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'route_map_name'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'profile_domain_name'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'channel'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'logical_instance_id'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'disable'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'raguard'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'forwarding'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'log, mode'}, {'leafval': 'native_vlan'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'protected_port_enable'}, {'leafval': 'bfd_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'oui'}, {'leafval': 'enable, direction'}, {'leafval': 'sticky_flag'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'expire'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'max_interval, min_'}, {'leafval': 'enable, match_profile'}, {'leafval': 'trust'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'use_link_local_only'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_, remove_'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'gateway'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'root'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'basic'}, {'leafval': 'attempts, time'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'promiscuous, host'}, {'leafval': 'id, cost, priority'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'accessvlan'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sg_addr'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'mtu'}, {'leafval': 'udld_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'red_tc_value'}, {'leafval': 'groupid, vlan'}, {'leafval': 'multinet_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'learn_any'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fec_enable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_protected_port_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.protected_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_protected_port_enable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.protected_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_cos_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_cos_mutation_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_cos_traffic_class_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_drop_monitor_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.drop_monitor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.drop_monitor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_drop_monitor_enable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.drop_monitor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.drop_monitor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_dscp_cos_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_dscp_mutation_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_dscp_traffic_class_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_ecn_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.ecn', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_flowcontrol_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_flowcontrol_link_level_flowcontrol_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_flowcontrol_pfc_get(self, hundredgigabitethernet=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_flowcontrol_pfc_rx_get(self, hundredgigabitethernet=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_flowcontrol_pfc_tx_get(self, hundredgigabitethernet=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_flowcontrol_rx_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_flowcontrol_tx_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_random_detect_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.random_detect', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.ecn.random_detect', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_random_detect_2_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.random_detect', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_random_detect_ecn_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.ecn.random_detect.random_detect_ecn', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_random_detect_ecn_traffic_class_get(self, hundredgigabitethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: int
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.ecn.random_detect.random_detect_ecn.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_random_detect_traffic_class_get(self, hundredgigabitethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_random_detect_traffic_class_apply_get(self, hundredgigabitethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_random_detect_traffic_class_red_profile_id_get(self, hundredgigabitethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_trust_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.trust', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.trust', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_trust_cos_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.trust', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.trust', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_qos_trust_dscp_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.trust', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.trust', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_rmon_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_rmon_collection_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_rmon_collection_history_get(self, hundredgigabitethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_buckets_requested: long
    :param history_control_buckets_requested: **history_control_entry** tuple argument:  Buckets (default 50)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_interval: long
    :param history_control_interval: **history_control_entry** tuple argument:  Polling Interval (default 1800)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_owner: unicode
    :param history_control_owner: **history_control_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_rmon_collection_history_buckets_get(self, hundredgigabitethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_rmon_collection_history_interval_get(self, hundredgigabitethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_rmon_collection_history_owner_get(self, hundredgigabitethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_rmon_collection_stats_get(self, hundredgigabitethernet=None, ether_stats_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index, ether_stats_owner
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type ether_stats_owner: unicode
    :param ether_stats_owner: **ether_stats_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': 'ether_stats_index, ether_stats_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ether_stats_entry=ether_stats_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ether_stats_entry=ether_stats_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_rmon_collection_stats_owner_get(self, hundredgigabitethernet=None, ether_stats_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ether_stats_entry=ether_stats_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ether_stats_entry=ether_stats_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_rpf_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rpf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_rpf_mode_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rpf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_service_policy_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.service_policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.service_policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_service_policy_in_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.service_policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.service_policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_service_policy_out_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.service_policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.service_policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_sflow_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.sflow', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.sflow', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_sflow_enable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.sflow', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.sflow', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_sflow_polling_interval_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.sflow', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.sflow', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_sflow_sample_rate_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.sflow', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.sflow', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_shutdown_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_fo_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.interface_hu_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'udld'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'fec'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'dot1x')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hundredgigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gateway'}, {'leafval': 'disable'}, {'leafval': 'enable, match_profile'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'raguard'}, {'leafval': 'basic'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, direction'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'root'}, {'leafval': 'forwarding'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sticky_flag'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'trust'}, {'leafval': 'expire'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'promiscuous, host'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'use_link_local_only'}, {'leafval': 'logical_instance_id'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'id, cost, priority'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'route_map_name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'groupid, vlan'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'oui'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'in_, out'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'native_vlan'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'sg_addr'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'udld_enable'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'max_interval, min_'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_, remove_'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'profile_domain_name'}, {'leafval': 'mtu'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'route_map_name'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'profile_domain_name'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'channel'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'logical_instance_id'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'disable'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'raguard'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'forwarding'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'log, mode'}, {'leafval': 'native_vlan'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'protected_port_enable'}, {'leafval': 'bfd_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'oui'}, {'leafval': 'enable, direction'}, {'leafval': 'sticky_flag'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'expire'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'max_interval, min_'}, {'leafval': 'enable, match_profile'}, {'leafval': 'trust'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'use_link_local_only'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'add_, remove_'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'gateway'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'root'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'basic'}, {'leafval': 'attempts, time'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'promiscuous, host'}, {'leafval': 'id, cost, priority'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'accessvlan'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sg_addr'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'mtu'}, {'leafval': 'udld_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'red_tc_value'}, {'leafval': 'groupid, vlan'}, {'leafval': 'multinet_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'learn_any'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fec_enable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_snmp_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.snmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.snmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_snmp_trap_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.snmp.trap', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.snmp.trap', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_snmp_trap_link_status_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.snmp.trap', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.snmp.trap', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_autoedge_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_bpdu_mac_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_cost_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_edgeport_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_edgeport_bpdu_filter_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_edgeport_bpdu_guard_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_edgeport_edgeportbasic_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_guard_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_guard_root_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_hello_time_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_instance_get(self, hundredgigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_instance_cost_get(self, hundredgigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_instance_priority_get(self, hundredgigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_instance_restricted_role_get(self, hundredgigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_instance_restricted_tcn_get(self, hundredgigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_link_type_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_portfast_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_portfast_bpdu_filter_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_portfast_bpdu_guard_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_portfast_portfastbasic_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_priority_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_restricted_role_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_restricted_tcn_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_shutdown_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_vlan_get(self, hundredgigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.vlan', u'guard'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_vlan_cost_get(self, hundredgigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.vlan', u'guard'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_vlan_guard_get(self, hundredgigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_vlan_guard_root_get(self, hundredgigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_spanning_tree_vlan_priority_get(self, hundredgigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.spanning_tree.vlan', u'guard'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_storm_control_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.storm_control', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.storm_control', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_storm_control_ingress_get(self, hundredgigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type, rate_format, rate_bps, rate_percent, bum_action
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type rate_format: unicode
    :param rate_format: **ingress** tuple argument.

        * enumeration restriction: ::

            ['limit-bps', 'limit-percent']

    :type rate_bps: long
    :param rate_bps: **ingress** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type rate_percent: long
    :param rate_percent: **ingress** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bum_action: unicode
    :param bum_action: **ingress** tuple argument.

        * enumeration restriction: ::

            ['monitor', 'shutdown']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_storm_control_ingress_bum_action_get(self, hundredgigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_storm_control_ingress_rate_bps_get(self, hundredgigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_storm_control_ingress_rate_format_get(self, hundredgigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_storm_control_ingress_rate_percent_get(self, hundredgigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport_basic', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport_basic', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_access_mac_group_rspan_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_access_mac_group_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_access_mac_rspan_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_access_mac_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_mac_group_rspan_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_mac_group_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_mac_rspan_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_mac_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_rspan_access_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access.rspan_access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access.rspan_access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_rspan_vlan_get(self, hundredgigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_rspan_vlan_access_mac_rspan_vlan_classification_get(self, hundredgigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_vlan_get(self, hundredgigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_access_vlan_access_mac_vlan_classification_get(self, hundredgigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_basic_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport_basic', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport_basic', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_private_vlan_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_private_vlan_host_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_private_vlan_promiscuous_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_private_vlan_trunk_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_private_vlan_trunk_host_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_private_vlan_trunk_promiscuous_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_private_vlan_trunk_trunk_basic_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_mode_vlan_mode_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.mode', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.mode', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_allowed_ouis_get(self, hundredgigabitethernet=None, allowed_ouis=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type allowed_ouis: oui
    :param allowed_ouis: Keyword argument tuple.

    :type oui: unicode
    :param oui: **allowed_ouis** tuple argument:  <OUI> OUI in HHHH.HH00.0000 format

        * pattern restriction: ::

            '[0-9a-fA-F]{4}\.[0-9a-fA-F]{2}00\.0000'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'allowed_ouis', 'keyval': 'oui', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, allowed_ouis=allowed_ouis)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, allowed_ouis=allowed_ouis)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_max_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_port_secutiry_mac_address_get(self, hundredgigabitethernet=None, port_secutiry_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_shutdown_time_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_sticky_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security.sticky', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_sticky_port_secutiry_mac_address_get(self, hundredgigabitethernet=None, port_secutiry_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_sticky_sticky_flag_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security.sticky', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_port_security_violation_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_association_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_association_trunk_get(self, hundredgigabitethernet=None, trunk=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type trunk: trunk_pri_pvlan, trunk_sec_pvlan
    :param trunk: Keyword argument tuple.

    :type trunk_pri_pvlan: long
    :param trunk_pri_pvlan: **trunk** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type trunk_sec_pvlan: long
    :param trunk_sec_pvlan: **trunk** tuple argument:  Secondary vlan id 

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'trunk', 'keyval': 'trunk_pri_pvlan, trunk_sec_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, trunk=trunk)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, trunk=trunk)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_host_association_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'host_pri_pvlan, host_sec_pvlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_host_association_host_pri_pvlan_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_host_association_host_sec_pvlan_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_mapping_get(self, hundredgigabitethernet=None, mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan, oper, promis_sec_pvlan_range
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type oper: unicode
    :param oper: **mapping** tuple argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type promis_sec_pvlan_range: unicode
    :param promis_sec_pvlan_range: **mapping** tuple argument:  Secondary vlan range

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-7][0-9]{3})|(80[0-9]{2})|'
            '(81[0-8][0-9])|(819[01]))(-(([2-9])|([1-9][0-9]{'
            '1,2})|([1-7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9]'
            ')|(819[01])))?((,(([2-9])|([1-9][0-9]{1,2})|([1-'
            '7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9])|(819[01]'
            '))(-(([3-9])|([1-9][0-9]{1,2})|([1-7][0-9]{3})|('
            '80[0-9]{2})|(81[0-8][0-9])|(819[01])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, mapping=mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_mapping_oper_get(self, hundredgigabitethernet=None, mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, mapping=mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_mapping_promis_sec_pvlan_range_get(self, hundredgigabitethernet=None, mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, mapping=mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_trunk_private_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_vlan_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_vlan_add_get(self, hundredgigabitethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_vlan_all_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_vlan_except_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_vlan_none_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_vlan_remove_get(self, hundredgigabitethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_allowed_vlan_trunk_private_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_native_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_native_ctag_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_native_vlan_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_private_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_tag_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_tag_native_vlan_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_private_vlan_trunk_trunk_private_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_rspan_vlan_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_rspan_vlan_add_get(self, hundredgigabitethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_rspan_vlan_remove_get(self, hundredgigabitethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_rspan_vlan_trunk_rspan_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_trunk_rspan_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_trunk_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_add_get(self, hundredgigabitethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_add_ctag_get(self, hundredgigabitethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_all_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_except_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_none_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_remove_get(self, hundredgigabitethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_remove_ctag_get(self, hundredgigabitethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlan_trunk_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlanoper_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlanoper_vlan_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlanoper_vlan_add_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_allowed_vlanoper_vlan_remove_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_ctag_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_ctag_native_vlan_xtagged_config_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_default_vlan_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_default_vlan_config_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_transparent_vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_egress_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_native_vlan_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_native_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id, native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_native_vlan_untagged_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_native_vlan_untagged_config_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_untagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_native_vlan_xtagged_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_native_vlan_xtagged_config_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_private_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_tag_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_tag_native_vlan_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_switchport_trunk_trunk_vlan_classification_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_track_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_track_enable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_track_interface_get(self, hundredgigabitethernet=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface: track_interface_type, track_interface_name
    :param interface: Keyword argument tuple.

    :type track_interface_type: unicode
    :param track_interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type track_interface_name: unicode
    :param track_interface_name: **interface** tuple argument:  Interface name

        * pattern restriction: ::

            '(((([1-9]|[1-9][0-9]|1[0-9]{2}|2[0-3][0-9])/)?(('
            '[0-9]|1[0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]'
            ')(:[1-4])?)|([1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5'
            '][0-9]{3}|6[0-1][0-4]{2}))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'track_interface_type, track_interface_name', 'extra_keyval': 'track_interface_type, track_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_track_min_link_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_track_remove_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_track_remove_all_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.track.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.track.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_tunable_optics_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.tunable_optics', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_tunable_optics_sfpp_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.tunable_optics.sfpp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_tunable_optics_sfpp_channel_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.tunable_optics.sfpp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_udld_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.udld', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.udld', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_udld_enable_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.udld', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.udld', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vlan_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vlan_classifier_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vlan.classifier', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vlan.classifier', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vlan_classifier_activate_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vlan.classifier.activate', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vlan.classifier.activate', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vlan_classifier_activate_group_get(self, hundredgigabitethernet=None, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type group: groupid, vlan
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vlan: long
    :param vlan: **group** tuple argument:  1-8191;;Vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': 'groupid, vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vlan_classifier_activate_group_vlan_get(self, hundredgigabitethernet=None, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type group: groupid
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrf_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrf_forwarding_get(self, hundredgigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_get(self, hundredgigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_advertisement_interval_get(self, hundredgigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_arp_get(self, hundredgigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.arp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_arp_unicast_request_get(self, hundredgigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_arp_unicast_request_receive_get(self, hundredgigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_description_get(self, hundredgigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_enable_get(self, hundredgigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_hold_time_get(self, hundredgigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_preempt_mode_get(self, hundredgigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_priority_get(self, hundredgigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_track_get(self, hundredgigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_track_interface_get(self, hundredgigabitethernet=None, vrrp=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_track_interface_priority_get(self, hundredgigabitethernet=None, vrrp=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_use_v2_checksum_get(self, hundredgigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_hundredgigabitethernet_vrrp_group_virtual_ip_get(self, hundredgigabitethernet=None, vrrp=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type hundredgigabitethernet: name
    :param hundredgigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **hundredgigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address in dotted decimal

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet', u'hundredgigabitethernet'), ('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.hundredgigabitethernet.vrrp.virtual_ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.hundredgigabitethernet.vrrp.virtual_ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hundredgigabitethernet=hundredgigabitethernet, vrrp=vrrp, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_interface_vlan_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface_vlan.interface', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface', u'vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, transport_service, ifindex, description, vlan_name, remote_span'}, {'leafval': 'gve_name, global_ve_shutdown'}, {'leafval': 'gve_name, global_ve_shutdown'}, {'leafval': 'name, transport_service, ifindex, description, vlan_name, remote_span'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'vrf'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'intf_loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.pim_intf_loopback_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'vrf'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'intf_loopback'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'vrf'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis', u'interface_isis'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.pim_intf_loopback_cont', u'pim_int_cmd'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf', u'ospf1'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'vrf'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.pim_intf_loopback_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'vrf'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_auth_key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'loopback', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'link_local_address, link_local'}, {'leafval': 'address, eui64, anycast'}, {'leafval': 'forwarding'}, {'leafval': 'address'}, {'leafval': 'use_link_local_only'}, {'leafval': 'shutdown'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'address, eui64, anycast'}, {'leafval': 'use_link_local_only'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'address'}, {'leafval': 'bfd_enable'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'key_chain'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'key_chain'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'forwarding'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'address'}, {'leafval': 'shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'address, eui64, anycast'}, {'leafval': 'forwarding'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'use_link_local_only'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'interface_bfd_disable'}, {'leafval': 'address'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'forwarding'}, {'leafval': 'bfd_enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'address, eui64, anycast'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'address, eui64, anycast'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'address'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'bfd_enable'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'use_link_local_only'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'forwarding'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.routing_system.interface.loopback": {}, "pybind.slxos.v17r_2_00.routing_system.interface.loopback": {}, "pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback": {"id": "id"}, "pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback": {"id": "id"}, "pybind.slxos.v17s_1_02.routing_system.interface.loopback": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ip', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ip', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_address_get(self, loopback=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/32'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.ip_config.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.ip_config.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.ip_config.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_interface_loopback_ospf_conf_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_intf_router_isis_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.intf_router_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.intf_router_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.intf_router_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ip_config_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ip.ip_config', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.ip_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.ip_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.ip_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_multicast_boundary_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_active_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_area_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_auth_change_wait_time_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_authentication_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_authentication_key_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_authentication_key_auth_key_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_authentication_key_auth_key_table_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_authentication_key_chain_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_authentication_key_encrypttype_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_authentication_key_no_encrypt_auth_key_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_authentication_key_no_encrypt_auth_key_table_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_bfd_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_bfd_intf_bfd_enable_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_cost_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_database_filter_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_database_filter_all_external_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_database_filter_all_out_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_database_filter_all_summary_external_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_dead_interval_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_hello_interval_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_ldp_sync_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_md5_authentication_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_md5_authentication_key_activation_wait_time_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_md5_authentication_key_id_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'key_id, key, md5_authentication_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_md5_authentication_key_id_key_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_md5_authentication_key_id_key_id_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_md5_authentication_no_encrypt_key_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_md5_authentication_no_encrypt_key_id_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_md5_authentication_no_encrypt_key_table_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_encrypt_key_id, no_encrypt_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_mtu_ignore_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_network_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_passive_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_priority_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_retransmit_interval_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_ospf_transmit_delay_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_pim_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd.pim', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_pim_dr_priority_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd.pim', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_pim_int_cmd_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_pim_intf_loopback_cont_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.pim_intf_loopback_cont', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.pim_intf_loopback_cont', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.pim_intf_loopback_cont', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_pim_neighbor_filter_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd.pim', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_pim_sparse_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_pim_ttl_threshold_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd.pim', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_router_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ip_router_isis_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ipv6', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ipv6', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_address_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.ipv6_config.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.ipv6_config.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.ipv6_config.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_address_ipv6_address_get(self, loopback=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, eui64, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type eui64: YANGBool
    :param eui64: **ipv6_address** tuple argument:  Configure ipv6 address with an automatically computed EUI-64 interface Id

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, eui64, anycast'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_address_ipv6_address_anycast_get(self, loopback=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_address_ipv6_address_eui_64_get(self, loopback=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_address_link_local_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_address_link_local_address_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_address_link_local_config_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_address_use_link_local_only_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.ipv6_config.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.ipv6_config.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.ipv6_config.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_intf_ipv6_router_isis_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ipv6_config_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.ipv6.ipv6_config', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.ipv6_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.ipv6_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.ipv6_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_active_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_area_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication": {"key_chain": "key_chain"}, "pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication": {}, "pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_ah_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_esp_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_esp_auth_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_esp_key_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_esp_no_encrypt_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_ipsec_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_ipsec_auth_key_config_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_ipsec_disable_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_ipsec_key_add_remove_interval_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_key_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_key_chain_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_no_encrypt_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_authentication_spi_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_bfd_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_bfd_bfd_enable_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_cost_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_dead_interval_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_hello_interval_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_hello_jitter_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_instance_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_link_interval_properties_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_mtu_ignore_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_network_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_passive_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_priority_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_retransmit_interval_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_suppress_linklsa_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_ospf_transmit_delay_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_router_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_ipv6_router_isis_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_auth_check_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.auth_check', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.auth_check', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.auth_check', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_auth_check_level_1_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_auth_check_level_1_disable_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_auth_check_level_2_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_auth_check_level_2_disable_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_auth_key_get(self, loopback=None, interface_auth_key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_auth_key: interface_auth_key_level, interface_auth_key_str
    :param interface_auth_key: Keyword argument tuple.

    :type interface_auth_key_level: unicode
    :param interface_auth_key_level: **interface_auth_key** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_auth_key_str: unicode
    :param interface_auth_key_str: **interface_auth_key** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_auth_key', 'keyval': 'interface_auth_key_level', 'extra_keyval': 'interface_auth_key_level, interface_auth_key_str'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_auth_key=interface_auth_key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_auth_key=interface_auth_key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_auth_key_interface_auth_key_str_get(self, loopback=None, interface_auth_key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_auth_key: interface_auth_key_level
    :param interface_auth_key: Keyword argument tuple.

    :type interface_auth_key_level: unicode
    :param interface_auth_key_level: **interface_auth_key** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_auth_key', 'keyval': 'interface_auth_key_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_auth_key=interface_auth_key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_auth_key=interface_auth_key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_auth_mode_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_auth_mode_md5_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_auth_mode_md5_level_1_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_auth_mode_md5_level_2_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_bfd_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_bfd": {"interface_bfd_enable": "interface_bfd_enable"}, "pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_bfd": {"interface_bfd_enable": "interface_bfd_enable"}, "pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_bfd": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_bfd_disable_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_bfd_interface_bfd_enable_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_circuit_type_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_hello_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_hello_interval_get(self, loopback=None, interface_hello_interval=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_hello_interval: interface_hello_interval_level, interface_hello_interval_val
    :param interface_hello_interval: Keyword argument tuple.

    :type interface_hello_interval_level: unicode
    :param interface_hello_interval_level: **interface_hello_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_hello_interval_val: long
    :param interface_hello_interval_val: **interface_hello_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_interval', 'keyval': 'interface_hello_interval_level', 'extra_keyval': 'interface_hello_interval_level, interface_hello_interval_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_hello_interval=interface_hello_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_hello_interval=interface_hello_interval)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_hello_interval_interface_hello_interval_val_get(self, loopback=None, interface_hello_interval=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_hello_interval: interface_hello_interval_level
    :param interface_hello_interval: Keyword argument tuple.

    :type interface_hello_interval_level: unicode
    :param interface_hello_interval_level: **interface_hello_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_interval', 'keyval': 'interface_hello_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_hello_interval=interface_hello_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_hello_interval=interface_hello_interval)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_hello_multiplier_get(self, loopback=None, interface_hello_multiplier=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_hello_multiplier: interface_hello_multiplier_level, interface_hello_multiplier_val
    :param interface_hello_multiplier: Keyword argument tuple.

    :type interface_hello_multiplier_level: unicode
    :param interface_hello_multiplier_level: **interface_hello_multiplier** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_hello_multiplier_val: long
    :param interface_hello_multiplier_val: **interface_hello_multiplier** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_multiplier', 'keyval': 'interface_hello_multiplier_level', 'extra_keyval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_hello_multiplier=interface_hello_multiplier)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_hello_multiplier=interface_hello_multiplier)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_hello_multiplier_interface_hello_multiplier_val_get(self, loopback=None, interface_hello_multiplier=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_hello_multiplier: interface_hello_multiplier_level
    :param interface_hello_multiplier: Keyword argument tuple.

    :type interface_hello_multiplier_level: unicode
    :param interface_hello_multiplier_level: **interface_hello_multiplier** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_multiplier', 'keyval': 'interface_hello_multiplier_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_hello_multiplier=interface_hello_multiplier)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_hello_multiplier=interface_hello_multiplier)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_hello_padding_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_hello_padding_disable_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_ipv6_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_ipv6_metric_get(self, loopback=None, interface_ipv6_metric=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_ipv6_metric: interface_ipv6_metric_level, interface_ipv6_metric_val
    :param interface_ipv6_metric: Keyword argument tuple.

    :type interface_ipv6_metric_level: unicode
    :param interface_ipv6_metric_level: **interface_ipv6_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_ipv6_metric_val: long
    :param interface_ipv6_metric_val: **interface_ipv6_metric** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_ipv6_metric', 'keyval': 'interface_ipv6_metric_level', 'extra_keyval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_ipv6_metric=interface_ipv6_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_ipv6_metric=interface_ipv6_metric)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_ipv6_metric_interface_ipv6_metric_val_get(self, loopback=None, interface_ipv6_metric=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_ipv6_metric: interface_ipv6_metric_level
    :param interface_ipv6_metric: Keyword argument tuple.

    :type interface_ipv6_metric_level: unicode
    :param interface_ipv6_metric_level: **interface_ipv6_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_ipv6_metric', 'keyval': 'interface_ipv6_metric_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_ipv6_metric=interface_ipv6_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_ipv6_metric=interface_ipv6_metric)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_ldp_sync_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_metric_get(self, loopback=None, interface_metric=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_metric: interface_metric_level, interface_metric_val
    :param interface_metric: Keyword argument tuple.

    :type interface_metric_level: unicode
    :param interface_metric_level: **interface_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_metric_val: long
    :param interface_metric_val: **interface_metric** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_metric', 'keyval': 'interface_metric_level', 'extra_keyval': 'interface_metric_level, interface_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_metric=interface_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_metric=interface_metric)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_metric_interface_metric_val_get(self, loopback=None, interface_metric=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_metric: interface_metric_level
    :param interface_metric: Keyword argument tuple.

    :type interface_metric_level: unicode
    :param interface_metric_level: **interface_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_metric', 'keyval': 'interface_metric_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback, interface_metric=interface_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback, interface_metric=interface_metric)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_passive_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_point_to_point_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_priority_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_priority_level_1_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_priority_level_2_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_reverse_metric_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_reverse_metric_rev_metric_common_attributes_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_reverse_metric_rev_metric_val_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_reverse_metric_te_def_metric_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_isis_reverse_metric_whole_lan_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_shutdown_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.intf_loopback', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.intf_loopback', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ip.pim_intf_loopback_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'vrf'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.pim_intf_loopback_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'vrf'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis', u'interface_isis'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.pim_intf_loopback_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.pim_intf_loopback_cont', u'pim_int_cmd'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf', u'ospf1'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'vrf'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.ip.interface_loopback_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes')]
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'address, eui64, anycast'}, {'leafval': 'use_link_local_only'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'address'}, {'leafval': 'bfd_enable'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'key_chain'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'key_chain'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'forwarding'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'address, eui64, anycast'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'address'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'bfd_enable'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'use_link_local_only'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'forwarding'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'use_link_local_only'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'interface_bfd_disable'}, {'leafval': 'address'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'forwarding'}, {'leafval': 'bfd_enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'address, eui64, anycast'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}]
    leafval_map = {"pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.intf_loopback": {"shutdown": "shutdown"}, "pybind.slxos.v17r_2_00.routing_system.interface.loopback": {}, "pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.intf_loopback": {"shutdown": "shutdown"}, "pybind.slxos.v17s_1_02.routing_system.interface.loopback": {}, "pybind.slxos.v17r_1_01a.routing_system.interface.loopback": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_vrf_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.vrf', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.vrf', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_loopback_vrf_forwarding_get(self, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_intf_loopback_holder.interface.loopback.vrf', 'pybind.nos.v6_0_2f.brocade_intf_loopback', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_intf_loopback_holder.interface.loopback.vrf', 'pybind.nos.v7_2_0.brocade_intf_loopback', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.loopback.vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.loopback.vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.loopback.vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.management', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.management.ip', u'gateway'), ('pybind.nos.v6_0_2f.interface.management.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.management.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.management', u'vrf'), ('pybind.nos.v6_0_2f.interface.management.ip', u'oper_address'), ('pybind.nos.v6_0_2f.interface.management.ip', u'oper_gateway_con'), ('pybind.nos.v6_0_2f.interface.management.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.nos.v6_0_2f.interface.management', u'tcp'), ('pybind.nos.v6_0_2f.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont'), ('pybind.nos.v6_0_2f.interface.management.ip', u'address'), ('pybind.nos.v6_0_2f.interface.management', u'line_speed'), ('pybind.nos.v6_0_2f.interface.management.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'oper_gateway_con'), ('pybind.slxos.v17r_1_01a.interface.management', u'tcp'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'icmp'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.management', u'line_speed'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'gateway'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'oper_address'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6', u'icmpv6'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'address'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.management', u'vrf'), ('pybind.slxos.v17s_1_02.interface.management', u'line_speed'), ('pybind.slxos.v17s_1_02.interface.management.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'address'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'oper_gateway_con'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'gateway'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'icmp'), ('pybind.slxos.v17s_1_02.interface.management', u'vrf'), ('pybind.slxos.v17s_1_02.interface.management.ipv6', u'icmpv6'), ('pybind.slxos.v17s_1_02.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'oper_address'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont'), ('pybind.slxos.v17s_1_02.interface.management', u'tcp'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'oper_gateway_con'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'address'), ('pybind.slxos.v17r_2_00.interface.management', u'vrf'), ('pybind.slxos.v17r_2_00.interface.management', u'tcp'), ('pybind.slxos.v17r_2_00.interface.management.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'oper_address'), ('pybind.slxos.v17r_2_00.interface.management', u'line_speed'), ('pybind.slxos.v17r_2_00.interface.management.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'gateway'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.nos.v7_2_0.interface.management.ip', u'oper_gateway_con'), ('pybind.nos.v7_2_0.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.nos.v7_2_0.interface.management.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.management.ip', u'gateway'), ('pybind.nos.v7_2_0.interface.management.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.management.ip', u'address'), ('pybind.nos.v7_2_0.interface.management.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.management.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.management', u'vrf'), ('pybind.nos.v7_2_0.interface.management.ip', u'oper_address'), ('pybind.nos.v7_2_0.interface.management', u'tcp'), ('pybind.nos.v7_2_0.interface.management', u'line_speed'), ('pybind.nos.v7_2_0.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'management', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gateway_address'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'oper_ip_address'}, {'leafval': 'oper_gateway'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'actual, configured'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'oper_gateway'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'actual, configured'}, {'leafval': 'gateway_address'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'oper_ip_address'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'actual, configured'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'oper_gateway'}, {'leafval': 'gateway_address'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'oper_ip_address'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'oper_gateway'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'oper_ip_address'}, {'leafval': 'actual, configured'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'gateway_address'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'oper_gateway'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'gateway_address'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'oper_ip_address'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'actual, configured'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_access_group_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'mgmt_ip_access_list, mgmt_ip_direction'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_access_group_mgmt_ip_access_list_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_access_group_mgmt_ip_direction_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_address_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip.address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip.address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_address_dhcp_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip.address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip.address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_address_ip_address_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip.address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip.address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip.address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_address_ip_address_oper_address_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip.oper_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip.oper_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip.oper_address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip.oper_address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip.oper_address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_address_oper_address_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip.oper_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip.oper_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip.oper_address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip.oper_address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip.oper_address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_gateway_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip.gateway', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip.gateway', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip.gateway', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip.gateway', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip.gateway', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_gateway_address_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip.gateway', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip.gateway', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip.gateway', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip.gateway', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip.gateway', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_gateway_address_oper_gateway_con_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip.oper_gateway_con', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip.oper_gateway_con', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip.oper_gateway_con', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip.oper_gateway_con', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip.oper_gateway_con', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_icmp_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip.icmp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip.icmp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip.icmp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_icmp_echo_reply_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip.icmp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip.icmp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip.icmp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_icmp_rate_limiting_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip.icmp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip.icmp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip.icmp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_icmp_unreachable_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip.icmp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip.icmp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip.icmp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ip_oper_gateway_con_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ip.oper_gateway_con', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ip.oper_gateway_con', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ip.oper_gateway_con', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ip.oper_gateway_con', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ip.oper_gateway_con', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ipv6_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ipv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ipv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ipv6', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ipv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ipv6_access_group_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ipv6_access_group_mgmt_ip_direction_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ipv6_access_group_mgmt_ipv6_access_list_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ipv6_address_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ipv6.ipv6_address_cont', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ipv6.ipv6_address_cont', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.ipv6_address_cont', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.ipv6_address_cont', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.ipv6_address_cont', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ipv6_address_autoconfig_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ipv6.ipv6_address_cont', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ipv6.ipv6_address_cont', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.ipv6_address_cont', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.ipv6_address_cont', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.ipv6_address_cont', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ipv6_address_dhcp_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ipv6.ipv6_address_cont', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ipv6.ipv6_address_cont', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.ipv6_address_cont', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.ipv6_address_cont', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.ipv6_address_cont', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ipv6_address_eui_64_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ipv6_address_ipv6_global_address_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ipv6_address_ipv6_global_cont_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.ipv6_address_cont.ipv6_global_cont', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ipv6_global_address, ipv6_global_address_eui64'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ipv6_icmpv6_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.icmpv6', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.icmpv6', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.icmpv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ipv6_icmpv6_echo_reply_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.icmpv6', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.icmpv6', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.icmpv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ipv6_icmpv6_rate_limiting_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.icmpv6', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.icmpv6', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.icmpv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_ipv6_icmpv6_unreachable_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.icmpv6', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.icmpv6', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.icmpv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_line_speed_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.line_speed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.line_speed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.line_speed', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.line_speed', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.line_speed', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_line_speed_actual_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.line_speed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.line_speed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.line_speed', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.line_speed', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.line_speed', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_line_speed_configured_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.nos.v6_0_2f.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.line_speed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.line_speed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.line_speed', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.line_speed', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.line_speed', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_oper_status_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.management', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.management.ip', u'gateway'), ('pybind.nos.v6_0_2f.interface.management.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.management.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.management', u'vrf'), ('pybind.nos.v6_0_2f.interface.management.ip', u'oper_address'), ('pybind.nos.v6_0_2f.interface.management.ip', u'oper_gateway_con'), ('pybind.nos.v6_0_2f.interface.management.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.nos.v6_0_2f.interface.management', u'tcp'), ('pybind.nos.v6_0_2f.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont'), ('pybind.nos.v6_0_2f.interface.management.ip', u'address'), ('pybind.nos.v6_0_2f.interface.management', u'line_speed'), ('pybind.nos.v6_0_2f.interface.management.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'oper_gateway_con'), ('pybind.slxos.v17r_1_01a.interface.management', u'tcp'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'icmp'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.management', u'line_speed'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'gateway'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'oper_address'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6', u'icmpv6'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'address'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.management', u'vrf'), ('pybind.slxos.v17s_1_02.interface.management', u'line_speed'), ('pybind.slxos.v17s_1_02.interface.management.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'address'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'oper_gateway_con'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'gateway'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'icmp'), ('pybind.slxos.v17s_1_02.interface.management', u'vrf'), ('pybind.slxos.v17s_1_02.interface.management.ipv6', u'icmpv6'), ('pybind.slxos.v17s_1_02.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'oper_address'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont'), ('pybind.slxos.v17s_1_02.interface.management', u'tcp'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'oper_gateway_con'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'address'), ('pybind.slxos.v17r_2_00.interface.management', u'vrf'), ('pybind.slxos.v17r_2_00.interface.management', u'tcp'), ('pybind.slxos.v17r_2_00.interface.management.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'oper_address'), ('pybind.slxos.v17r_2_00.interface.management', u'line_speed'), ('pybind.slxos.v17r_2_00.interface.management.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'gateway'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.nos.v7_2_0.interface.management.ip', u'oper_gateway_con'), ('pybind.nos.v7_2_0.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.nos.v7_2_0.interface.management.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.management.ip', u'gateway'), ('pybind.nos.v7_2_0.interface.management.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.management.ip', u'address'), ('pybind.nos.v7_2_0.interface.management.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.management.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.management', u'vrf'), ('pybind.nos.v7_2_0.interface.management.ip', u'oper_address'), ('pybind.nos.v7_2_0.interface.management', u'tcp'), ('pybind.nos.v7_2_0.interface.management', u'line_speed'), ('pybind.nos.v7_2_0.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'management', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gateway_address'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'oper_ip_address'}, {'leafval': 'oper_gateway'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'actual, configured'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'oper_gateway'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'actual, configured'}, {'leafval': 'gateway_address'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'oper_ip_address'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'actual, configured'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'oper_gateway'}, {'leafval': 'gateway_address'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'oper_ip_address'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'oper_gateway'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'oper_ip_address'}, {'leafval': 'actual, configured'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'gateway_address'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'oper_gateway'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'gateway_address'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'oper_ip_address'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'actual, configured'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_shutdown_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.management', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.management.ip', u'gateway'), ('pybind.nos.v6_0_2f.interface.management.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.management.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.management', u'vrf'), ('pybind.nos.v6_0_2f.interface.management.ip', u'oper_address'), ('pybind.nos.v6_0_2f.interface.management.ip', u'oper_gateway_con'), ('pybind.nos.v6_0_2f.interface.management.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.nos.v6_0_2f.interface.management', u'tcp'), ('pybind.nos.v6_0_2f.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont'), ('pybind.nos.v6_0_2f.interface.management.ip', u'address'), ('pybind.nos.v6_0_2f.interface.management', u'line_speed'), ('pybind.nos.v6_0_2f.interface.management.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'oper_gateway_con'), ('pybind.slxos.v17r_1_01a.interface.management', u'tcp'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'icmp'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.management', u'line_speed'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'gateway'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'oper_address'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6', u'icmpv6'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'address'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.management', u'vrf'), ('pybind.slxos.v17s_1_02.interface.management', u'line_speed'), ('pybind.slxos.v17s_1_02.interface.management.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'address'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'oper_gateway_con'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'gateway'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'icmp'), ('pybind.slxos.v17s_1_02.interface.management', u'vrf'), ('pybind.slxos.v17s_1_02.interface.management.ipv6', u'icmpv6'), ('pybind.slxos.v17s_1_02.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'oper_address'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont'), ('pybind.slxos.v17s_1_02.interface.management', u'tcp'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'oper_gateway_con'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'address'), ('pybind.slxos.v17r_2_00.interface.management', u'vrf'), ('pybind.slxos.v17r_2_00.interface.management', u'tcp'), ('pybind.slxos.v17r_2_00.interface.management.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'oper_address'), ('pybind.slxos.v17r_2_00.interface.management', u'line_speed'), ('pybind.slxos.v17r_2_00.interface.management.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'gateway'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.nos.v7_2_0.interface.management.ip', u'oper_gateway_con'), ('pybind.nos.v7_2_0.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.nos.v7_2_0.interface.management.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.management.ip', u'gateway'), ('pybind.nos.v7_2_0.interface.management.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.management.ip', u'address'), ('pybind.nos.v7_2_0.interface.management.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.management.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.management', u'vrf'), ('pybind.nos.v7_2_0.interface.management.ip', u'oper_address'), ('pybind.nos.v7_2_0.interface.management', u'tcp'), ('pybind.nos.v7_2_0.interface.management', u'line_speed'), ('pybind.nos.v7_2_0.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'management', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gateway_address'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'oper_ip_address'}, {'leafval': 'oper_gateway'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'actual, configured'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'oper_gateway'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'actual, configured'}, {'leafval': 'gateway_address'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'oper_ip_address'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'actual, configured'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'oper_gateway'}, {'leafval': 'gateway_address'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'oper_ip_address'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'oper_gateway'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'oper_ip_address'}, {'leafval': 'actual, configured'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'gateway_address'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'oper_gateway'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'gateway_address'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'oper_ip_address'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'actual, configured'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_speed_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.management', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.management.ip', u'gateway'), ('pybind.nos.v6_0_2f.interface.management.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.management.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.management', u'vrf'), ('pybind.nos.v6_0_2f.interface.management.ip', u'oper_address'), ('pybind.nos.v6_0_2f.interface.management.ip', u'oper_gateway_con'), ('pybind.nos.v6_0_2f.interface.management.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.nos.v6_0_2f.interface.management', u'tcp'), ('pybind.nos.v6_0_2f.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont'), ('pybind.nos.v6_0_2f.interface.management.ip', u'address'), ('pybind.nos.v6_0_2f.interface.management', u'line_speed'), ('pybind.nos.v6_0_2f.interface.management.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'oper_gateway_con'), ('pybind.slxos.v17r_1_01a.interface.management', u'tcp'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'icmp'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.management', u'line_speed'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'gateway'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'oper_address'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6', u'icmpv6'), ('pybind.slxos.v17r_1_01a.interface.management.ip', u'address'), ('pybind.slxos.v17r_1_01a.interface.management.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.management', u'vrf'), ('pybind.slxos.v17s_1_02.interface.management', u'line_speed'), ('pybind.slxos.v17s_1_02.interface.management.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'address'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'oper_gateway_con'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'gateway'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'icmp'), ('pybind.slxos.v17s_1_02.interface.management', u'vrf'), ('pybind.slxos.v17s_1_02.interface.management.ipv6', u'icmpv6'), ('pybind.slxos.v17s_1_02.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.slxos.v17s_1_02.interface.management.ip', u'oper_address'), ('pybind.slxos.v17s_1_02.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont'), ('pybind.slxos.v17s_1_02.interface.management', u'tcp'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'icmp'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'oper_gateway_con'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'address'), ('pybind.slxos.v17r_2_00.interface.management', u'vrf'), ('pybind.slxos.v17r_2_00.interface.management', u'tcp'), ('pybind.slxos.v17r_2_00.interface.management.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'oper_address'), ('pybind.slxos.v17r_2_00.interface.management', u'line_speed'), ('pybind.slxos.v17r_2_00.interface.management.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'gateway'), ('pybind.slxos.v17r_2_00.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont'), ('pybind.slxos.v17r_2_00.interface.management.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.nos.v7_2_0.interface.management.ip', u'oper_gateway_con'), ('pybind.nos.v7_2_0.interface.management.ipv6', u'ipv6_address_cont'), ('pybind.nos.v7_2_0.interface.management.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.management.ip', u'gateway'), ('pybind.nos.v7_2_0.interface.management.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.management.ip', u'address'), ('pybind.nos.v7_2_0.interface.management.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.management.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.management', u'vrf'), ('pybind.nos.v7_2_0.interface.management.ip', u'oper_address'), ('pybind.nos.v7_2_0.interface.management', u'tcp'), ('pybind.nos.v7_2_0.interface.management', u'line_speed'), ('pybind.nos.v7_2_0.interface.management.ipv6.ipv6_address_cont', u'ipv6_global_cont')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'management', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gateway_address'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'oper_ip_address'}, {'leafval': 'oper_gateway'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'actual, configured'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'oper_gateway'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'actual, configured'}, {'leafval': 'gateway_address'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'oper_ip_address'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'actual, configured'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'oper_gateway'}, {'leafval': 'gateway_address'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'oper_ip_address'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'oper_gateway'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'oper_ip_address'}, {'leafval': 'actual, configured'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'gateway_address'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'oper_gateway'}, {'leafval': 'autoconfig, dhcpv6'}, {'leafval': 'mgmt_ipv6_access_list, mgmt_ip_direction'}, {'leafval': 'gateway_address'}, {'leafval': 'v6_unreachable, v6_echo_reply, v6_rate_limiting'}, {'leafval': 'dhcp, ip_address'}, {'leafval': 'mgmt_ip_access_list, mgmt_ip_direction'}, {'leafval': 'unreachable, echo_reply, rate_limiting'}, {'leafval': 'vrf_forwarding'}, {'leafval': 'oper_ip_address'}, {'leafval': 'tcp_burstrate, tcp_lockdown'}, {'leafval': 'actual, configured'}, {'leafval': 'ipv6_global_address, ipv6_global_address_eui64'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_tcp_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.tcp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.tcp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.tcp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.tcp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.tcp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_tcp_burstrate_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.tcp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.tcp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.tcp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.tcp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.tcp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_tcp_lockup_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.tcp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.tcp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.tcp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.tcp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.tcp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_vrf_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.vrf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.vrf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.vrf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.vrf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.vrf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_management_vrf_forwarding_get(self, management=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type management: name
    :param management: Keyword argument tuple.

    :type name: unicode
    :param name: **management** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/([0-9'
            ']|[1-9][0-9])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.management', u'management'), ('pybind.slxos.v17r_1_01a.interface.management', u'management'), ('pybind.slxos.v17r_2_00.interface.management', u'management'), ('pybind.nos.v7_2_0.interface.management', u'management'), ('pybind.slxos.v17s_1_02.interface.management', u'management')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.management.vrf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.management.vrf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.management.vrf', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.management.vrf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.management.vrf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, management=management)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, management=management)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17s_1_02.interface.port_channel.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'deny'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.port_channel.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'track'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'insight'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'esi'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'vlag'), ('pybind.slxos.v17s_1_02.interface.port_channel.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'qos'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'qos'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'insight'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'track'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.port_channel.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'track'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'qos'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'insight'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.port_channel', u'tunnel'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v6_0_2f.interface.port_channel.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.port_channel', u'qos'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.port_channel', u'track'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel', u'vlag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.port_channel', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel', u'ipv6'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.port_channel', u'service_policy'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'access'), ('pybind.nos.v7_2_0.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrf'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.port_channel', u'rpf'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'trust'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.port_channel', u'ipv6'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.port_channel', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.port_channel', u'qos'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'service_policy'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'tunnel'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'track'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.port_channel', u'vlag'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.port_channel.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.port_channel', u'fcoeport'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'esi'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel', u'protected_port'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'profile_domain_name'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'basic'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ingress, egress'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trust'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'insight_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'value, auto'}, {'leafval': 'native_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'ignore_split'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pc_instance_id'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'in_, out'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'raguard'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'basic'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'loop_detection_native'}, {'leafval': 'vlan_mode'}, {'leafval': 'pc_instance_id, shutdown, name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'id, cost, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'native_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trust'}, {'leafval': 'learn_any'}, {'leafval': 'address, secondary'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'in_, out'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'modeTypePo'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'add_, remove_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'root'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'raguard'}, {'leafval': 'sticky_flag'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'loop_detection_native'}, {'leafval': 'root'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'raguard'}, {'leafval': 'enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'ignore_split'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'address, secondary'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'in_, out'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sticky_flag'}, {'leafval': 'acl_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'basic'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pc_instance_id'}, {'leafval': 'accessvlan'}, {'leafval': 'fcoeport_map'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan'}, {'leafval': 'vlan_mode'}, {'leafval': 'modeTypePo'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trust'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'accessvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'enable, direction'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'basic'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trust'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vlan_mode'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'id, cost, priority'}, {'leafval': 'native_vlan'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'address, secondary'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'add_, remove_'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'raguard'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'oui'}, {'leafval': 'in_, out'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'promiscuous, host'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'red_tc_value'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'oui'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'forwarding'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'log, mode'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'expire'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'raguard'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'groupid, vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'root'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mtu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust'}, {'leafval': 'gateway'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'vlan_mode'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'learn_any'}, {'leafval': 'enable, direction'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'multinet_enable'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'ignore_split'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'id, cost, priority'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'add_, remove_'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'value, auto'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'protected_port_enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}]
    leafval_map = {"pybind.slxos.v17r_2_00.interface.port_channel": {}, "pybind.nos.v7_2_0.interface.port_channel": {"cee": "cee", "minimum_links": "minimum_links", "name": "name", "priority_tag_enable": "priority_tag_enable", "mtu": "mtu", "shutdown": "shutdown", "ifindex": "ifindex", "load_balance": "load_balance", "po_speed": "po_speed", "port_profile_port": "port_profile_port", "description": "description"}, "pybind.slxos.v17r_1_01a.interface.port_channel": {}, "pybind.slxos.v17s_1_02.interface.port_channel": {}, "pybind.nos.v6_0_2f.interface.port_channel": {"cee": "cee", "minimum_links": "minimum_links", "name": "name", "priority_tag_enable": "priority_tag_enable", "mtu": "mtu", "shutdown": "shutdown", "ifindex": "ifindex", "load_balance": "load_balance", "po_speed": "po_speed", "port_profile_port": "port_profile_port", "description": "description"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_bfd_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_bfd_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_bfd_interval_min_rx_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_bfd_interval_min_tx_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_bfd_interval_multiplier_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_bfd_shutdown_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_bpdu_drop_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.bpdu_drop', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.bpdu_drop', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable, direction'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_bpdu_drop_direction_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.bpdu_drop', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.bpdu_drop', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_bpdu_drop_enable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.bpdu_drop', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.bpdu_drop', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_cee_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.interface.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.port_channel', u'tunnel'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v6_0_2f.interface.port_channel.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.port_channel', u'qos'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.port_channel', u'track'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel', u'vlag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.port_channel', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel', u'ipv6'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.port_channel', u'service_policy'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'access'), ('pybind.nos.v7_2_0.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrf'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.port_channel', u'rpf'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'trust'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.port_channel', u'ipv6'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.port_channel', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.port_channel', u'qos'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'service_policy'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'tunnel'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'track'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.port_channel', u'vlag'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.port_channel.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.port_channel', u'fcoeport'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'esi'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel', u'protected_port'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17s_1_02.interface.port_channel.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'deny'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.port_channel.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'track'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'insight'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'esi'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'vlag'), ('pybind.slxos.v17s_1_02.interface.port_channel.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'qos'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'ipv6')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'accessvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'enable, direction'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'basic'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trust'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vlan_mode'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'id, cost, priority'}, {'leafval': 'native_vlan'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'address, secondary'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'add_, remove_'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'raguard'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'oui'}, {'leafval': 'in_, out'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'promiscuous, host'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'red_tc_value'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'oui'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'forwarding'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'log, mode'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'expire'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'raguard'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'groupid, vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'root'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mtu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust'}, {'leafval': 'gateway'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'vlan_mode'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'learn_any'}, {'leafval': 'enable, direction'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'multinet_enable'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'ignore_split'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'id, cost, priority'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'add_, remove_'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'value, auto'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'protected_port_enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'profile_domain_name'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'basic'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ingress, egress'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trust'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'insight_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'value, auto'}, {'leafval': 'native_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'ignore_split'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pc_instance_id'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'in_, out'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'raguard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_deny_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.deny', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_deny_inner_gtp_https_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.deny', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_description_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17s_1_02.interface.port_channel.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'deny'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.port_channel.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'track'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'insight'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'esi'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'vlag'), ('pybind.slxos.v17s_1_02.interface.port_channel.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'qos'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'qos'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'insight'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'track'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.port_channel.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'track'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'qos'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'insight'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.port_channel', u'tunnel'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v6_0_2f.interface.port_channel.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.port_channel', u'qos'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.port_channel', u'track'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel', u'vlag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.port_channel', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel', u'ipv6'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.port_channel', u'service_policy'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'access'), ('pybind.nos.v7_2_0.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrf'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.port_channel', u'rpf'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'trust'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.port_channel', u'ipv6'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.port_channel', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.port_channel', u'qos'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'service_policy'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'tunnel'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'track'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.port_channel', u'vlag'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.port_channel.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.port_channel', u'fcoeport'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'esi'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel', u'protected_port'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'profile_domain_name'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'basic'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ingress, egress'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trust'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'insight_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'value, auto'}, {'leafval': 'native_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'ignore_split'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pc_instance_id'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'in_, out'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'raguard'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'basic'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'loop_detection_native'}, {'leafval': 'vlan_mode'}, {'leafval': 'pc_instance_id, shutdown, name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'id, cost, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'native_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trust'}, {'leafval': 'learn_any'}, {'leafval': 'address, secondary'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'in_, out'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'modeTypePo'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'add_, remove_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'root'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'raguard'}, {'leafval': 'sticky_flag'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'loop_detection_native'}, {'leafval': 'root'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'raguard'}, {'leafval': 'enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'ignore_split'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'address, secondary'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'in_, out'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sticky_flag'}, {'leafval': 'acl_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'basic'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pc_instance_id'}, {'leafval': 'accessvlan'}, {'leafval': 'fcoeport_map'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan'}, {'leafval': 'vlan_mode'}, {'leafval': 'modeTypePo'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trust'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'accessvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'enable, direction'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'basic'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trust'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vlan_mode'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'id, cost, priority'}, {'leafval': 'native_vlan'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'address, secondary'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'add_, remove_'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'raguard'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'oui'}, {'leafval': 'in_, out'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'promiscuous, host'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'red_tc_value'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'oui'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'forwarding'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'log, mode'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'expire'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'raguard'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'groupid, vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'root'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mtu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust'}, {'leafval': 'gateway'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'vlan_mode'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'learn_any'}, {'leafval': 'enable, direction'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'multinet_enable'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'ignore_split'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'id, cost, priority'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'add_, remove_'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'value, auto'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'protected_port_enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_edge_loop_detection_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.interface.port_channel.edge_loop_detection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_edge_loop_detection_port_priority_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.interface.port_channel.edge_loop_detection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_edge_loop_detection_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.interface.port_channel.edge_loop_detection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_esi_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.esi', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.interface.port_channel.esi', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_esi_auto_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.esi', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.interface.port_channel.esi', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_esi_value_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.esi', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.interface.port_channel.esi', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_fcoeport_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.fcoeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.fcoeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.fcoeport', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.fcoeport', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.fcoeport', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.interface.port_channel.fcoeport": {}, "pybind.nos.v6_0_2f.interface.port_channel.fcoeport": {"fcoeport_map": "fcoeport_map", "ns_ip_registration": "ns_ip_registration"}, "pybind.slxos.v17r_1_01a.interface.port_channel.fcoeport": {}, "pybind.nos.v7_2_0.interface.port_channel.fcoeport": {"fcoeport_map": "fcoeport_map", "ns_ip_registration": "ns_ip_registration"}, "pybind.slxos.v17r_2_00.interface.port_channel.fcoeport": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_fcoeport_map_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.fcoeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.fcoeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.fcoeport', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.fcoeport', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.fcoeport', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_fcoeport_ns_ip_registration_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.fcoeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.fcoeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_hide_vrrp_holer_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ifindex_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17s_1_02.interface.port_channel.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'deny'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.port_channel.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'track'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'insight'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'esi'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'vlag'), ('pybind.slxos.v17s_1_02.interface.port_channel.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'qos'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'qos'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'insight'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'track'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.port_channel.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'track'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'qos'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'insight'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.port_channel', u'tunnel'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v6_0_2f.interface.port_channel.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.port_channel', u'qos'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.port_channel', u'track'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel', u'vlag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.port_channel', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel', u'ipv6'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.port_channel', u'service_policy'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'access'), ('pybind.nos.v7_2_0.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrf'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.port_channel', u'rpf'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'trust'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.port_channel', u'ipv6'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.port_channel', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.port_channel', u'qos'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'service_policy'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'tunnel'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'track'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.port_channel', u'vlag'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.port_channel.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.port_channel', u'fcoeport'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'esi'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel', u'protected_port'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'profile_domain_name'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'basic'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ingress, egress'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trust'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'insight_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'value, auto'}, {'leafval': 'native_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'ignore_split'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pc_instance_id'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'in_, out'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'raguard'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'basic'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'loop_detection_native'}, {'leafval': 'vlan_mode'}, {'leafval': 'pc_instance_id, shutdown, name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'id, cost, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'native_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trust'}, {'leafval': 'learn_any'}, {'leafval': 'address, secondary'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'in_, out'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'modeTypePo'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'add_, remove_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'root'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'raguard'}, {'leafval': 'sticky_flag'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'loop_detection_native'}, {'leafval': 'root'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'raguard'}, {'leafval': 'enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'ignore_split'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'address, secondary'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'in_, out'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sticky_flag'}, {'leafval': 'acl_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'basic'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pc_instance_id'}, {'leafval': 'accessvlan'}, {'leafval': 'fcoeport_map'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan'}, {'leafval': 'vlan_mode'}, {'leafval': 'modeTypePo'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trust'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'accessvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'enable, direction'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'basic'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trust'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vlan_mode'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'id, cost, priority'}, {'leafval': 'native_vlan'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'address, secondary'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'add_, remove_'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'raguard'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'oui'}, {'leafval': 'in_, out'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'promiscuous, host'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'red_tc_value'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'oui'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'forwarding'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'log, mode'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'expire'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'raguard'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'groupid, vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'root'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mtu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust'}, {'leafval': 'gateway'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'vlan_mode'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'learn_any'}, {'leafval': 'enable, direction'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'multinet_enable'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'ignore_split'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'id, cost, priority'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'add_, remove_'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'value, auto'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'protected_port_enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_insight_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.insight', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.insight', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.insight', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.interface.port_channel.insight": {"insight_enable": "insight_enable", "insight_mmId": "insight_mmId"}, "pybind.slxos.v17r_1_01a.interface.port_channel.insight": {"insight_enable": "insight_enable", "insight_mmId": "insight_mmId"}, "pybind.slxos.v17s_1_02.interface.port_channel.insight": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_insight_enable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.insight', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.insight', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.insight', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_insight_mmid_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.insight', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.insight', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_access_group_get(self, port_channel=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ip_acl_interface.ip.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip_acl_interface.ip.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip_acl_interface.ip.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': 'ip_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_access_group_traffic_type_get(self, port_channel=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ip_acl_interface.ip.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip_acl_interface.ip.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip_acl_interface.ip.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_acl_interface_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ip_acl_interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip_acl_interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip_acl_interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_address_get(self, port_channel=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config.address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config.address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config.address": {"secondary": "secondary", "address": "address"}, "pybind.nos.v7_2_0.interface.port_channel.ip.ip_config.address": {}, "pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config.address": {"secondary": "secondary", "address": "address"}, "pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config.address": {"secondary": "secondary", "address": "address"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_address_ospf_ignore_get(self, port_channel=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_address_ospf_passive_get(self, port_channel=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_address_secondary_get(self, port_channel=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config.address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config.address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_arp_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ip.arp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ip.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip.arp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_arp_aging_timeout_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_arp_hide_ip_holder_ip_config_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config.arp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_arp_inspection_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ip.arp.inspection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ip.arp.inspection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp.inspection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip.arp.inspection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_arp_inspection_filter_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp.inspection.filter', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection.filter', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_arp_inspection_filter_acl_name_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp.inspection.filter', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection.filter', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_arp_inspection_trust_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ip.arp.inspection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ip.arp.inspection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp.inspection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip.arp.inspection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_arp_ip_config_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_arp_learn_any_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config.arp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_dhcp_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_dhcp_relay_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_dhcp_relay_gateway_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_dhcp_relay_servers_get(self, port_channel=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  A.B.C.D;; IP address of the DHCP server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCP server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr, server_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_directed_broadcast_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_hide_ip_holder_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_icmp_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_icmp_address_mask_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_icmp_echo_reply_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_icmp_rate_limiting_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_icmp_redirect_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_icmp_unreachable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_igmp_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_igmp_immediate_leave_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_igmp_last_member_query_count_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_igmp_last_member_query_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_igmp_po_intf_cfg_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_igmp_query_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_igmp_query_max_response_time_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_igmp_robustness_variable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_igmp_startup_query_count_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_igmp_startup_query_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_igmp_static_group_get(self, port_channel=None, static_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_group: sg_addr
    :param static_group: Keyword argument tuple.

    :type sg_addr: unicode
    :param sg_addr: **static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp.static_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'sg_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, static_group=static_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_interface_PO_ospf_conf_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_interface_po_dhcp_conf_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ip_acl_interface_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ip_acl_interface.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ip_acl_interface.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip_acl_interface.ip', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip_acl_interface.ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ip_config_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ip_pbr_interface_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip_pbr_interface.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_mtu_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_multicast_boundary_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_active_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_area_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_auth_change_wait_time_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_authentication_key_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_authentication_key_auth_key_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_authentication_key_auth_key_table_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_authentication_key_encrypttype_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_authentication_key_no_encrypt_auth_key_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_authentication_key_no_encrypt_auth_key_table_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_bfd_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_bfd_intf_bfd_enable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_cost_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_database_filter_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_database_filter_all_external_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_database_filter_all_out_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_database_filter_all_summary_external_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_dead_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_hello_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_md5_authentication_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_md5_authentication_key_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_md5_authentication_key_activation_wait_time_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_md5_authentication_key_id_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_md5_authentication_key_id_key_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_md5_authentication_key_id_key_id_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_md5_authentication_key_id_md5_authentication_key_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_md5_authentication_no_encrypt_key_table_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_encrypt_key_id, no_encrypt_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_mtu_ignore_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_network_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_passive_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_priority_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_retransmit_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_ospf_transmit_delay_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_pbr_interface_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip_pbr_interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_pim_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_pim_dr_priority_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_pim_int_cmd_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_pim_intf_po_cont_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_pim_multinet_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_pim_multinet_enable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_pim_neighbor_filter_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_pim_sparse_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_policy_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip_pbr_interface.ip.policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_policy_route_map_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_policy_route_map_route_map_name_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_proxy_arp_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_unnumbered_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config.unnumbered', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ip_donor_interface_type, ip_donor_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_unnumbered_ip_donor_interface_name_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config.unnumbered', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ip_unnumbered_ip_donor_interface_type_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config.unnumbered', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_access_group_get(self, port_channel=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': 'ipv6_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_access_group_traffic_type_get(self, port_channel=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_address_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_address_ipv6_address_get(self, port_channel=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_address_ipv6_address_anycast_get(self, port_channel=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_address_ipv6_address_eui_64_get(self, port_channel=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_address_ipv6_address_secondary_get(self, port_channel=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_address_ipv6_address_secondary_eui_config_get(self, port_channel=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_address_link_local_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_address_link_local_address_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_address_link_local_config_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_address_use_link_local_only_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_dhcp_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_dhcp_relay_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_dhcp_relay_servers_get(self, port_channel=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_dhcp_relay_servers_interface_get(self, port_channel=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_dhcp_relay_servers_interface_interface_get(self, port_channel=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_dhcp_relay_servers_interface_interface_name_get(self, port_channel=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_dhcp_relay_servers_use_vrf_get(self, port_channel=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay.servers', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_hide_vrrpv3_holder_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_icmpv6_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_icmpv6_echo_reply_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_icmpv6_rate_limiting_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_icmpv6_redirect_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_icmpv6_unreachable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_interface_po_dhcp_conf_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ipv6_config_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ipv6_intf_cmds_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ipv6_nd_ra_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_mtu_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_broadcast_mac_trap_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_cache_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'expire'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_cache_expire_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_dad_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_dad_attempts_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_dad_time_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_hoplimit_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_managed_config_flag_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_mtu_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_ns_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_nud_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_nud_retry_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'base, interval, max_attempts'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_nud_retry_base_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_nud_retry_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_nud_retry_max_attempts_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_other_config_flag_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_get(self, port_channel=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_advertise, valid_lifetime, valid_infinite'}, {'leafval': 'no_autoconfig, no_onlink, off_link'}, {'leafval': 'preferred_lifetime, preferred_infinite'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_infinite_get(self, port_channel=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_infinite_preferred_get(self, port_channel=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_no_advertise_get(self, port_channel=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_no_autoconfig_get(self, port_channel=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_no_onlink_get(self, port_channel=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_off_link_get(self, port_channel=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_preferred_get(self, port_channel=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'preferred_lifetime, preferred_infinite'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_preferred_lifetime_get(self, port_channel=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_prefix_flags_get(self, port_channel=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_autoconfig, no_onlink, off_link'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_prefix_valid_lifetime_get(self, port_channel=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_proxy_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_ra_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_interval, min_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_ra_interval_max_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_ra_interval_min_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_ra_lifetime_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_reachable_time_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_retrans_timer_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_set_cache_expire_time_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_set_hoplimit_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_suppress_ra_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_suppress_ra_all_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_suppress_ra_mtu_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_nd_suppress_ra_suppress_ra_flag_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_neighbor_get(self, port_channel=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_neighbor_hardware_address_get(self, port_channel=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_active_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_area_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_ah_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_esp_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_esp_auth_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_esp_key_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_esp_no_encrypt_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_ipsec_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_ipsec_auth_key_config_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_ipsec_disable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_ipsec_key_add_remove_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_key_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_no_encrypt_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_authentication_spi_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_bfd_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_bfd_bfd_enable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_cost_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_dead_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_hello_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_hello_jitter_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_instance_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_link_interval_properties_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_mtu_ignore_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_network_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_passive_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_priority_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_retransmit_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_suppress_linklsa_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_ospf_transmit_delay_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_policy_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_policy_route_map_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_policy_route_map_ipv6_route_map_name_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_raguard_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_get(self, port_channel=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_advertise_backup_get(self, port_channel=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_advertisement_interval_get(self, port_channel=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_advertisement_interval_scale_get(self, port_channel=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_backup_advertisement_interval_get(self, port_channel=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_description_get(self, port_channel=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_enable_get(self, port_channel=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_hold_time_get(self, port_channel=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_nd_advertisement_timer_get(self, port_channel=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_preempt_mode_get(self, port_channel=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_priority_get(self, port_channel=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_short_path_forwarding_get(self, port_channel=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_short_path_forwarding_basic_get(self, port_channel=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_short_path_forwarding_revert_priority_get(self, port_channel=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_track_get(self, port_channel=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_track_interface_get(self, port_channel=None, vrrpv3e=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_track_interface_priority_get(self, port_channel=None, vrrpv3e=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_extended_group_virtual_ip_get(self, port_channel=None, vrrpv3e=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.virtual_ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.virtual_ip', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.virtual_ip', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3e.virtual_ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3e=vrrpv3e, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3e=vrrpv3e, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_get(self, port_channel=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'owner'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {"pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3": {"enable": "enable", "description": "description", "vrid": "vrid", "priority": "priority", "advertisement_interval": "advertisement_interval", "hold_time": "hold_time", "preempt_mode": "preempt_mode"}, "pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3": {"enable": "enable", "description": "description", "vrid": "vrid", "priority": "priority", "advertisement_interval": "advertisement_interval", "hold_time": "hold_time", "preempt_mode": "preempt_mode"}, "pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3": {"enable": "enable", "description": "description", "vrid": "vrid", "priority": "priority", "advertisement_interval": "advertisement_interval", "hold_time": "hold_time", "preempt_mode": "preempt_mode"}, "pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3": {"enable": "enable", "description": "description", "vrid": "vrid", "priority": "priority", "advertisement_interval": "advertisement_interval", "hold_time": "hold_time", "preempt_mode": "preempt_mode"}, "pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_advertisement_interval_get(self, port_channel=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'owner'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_description_get(self, port_channel=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'owner'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_enable_get(self, port_channel=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'owner'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_hold_time_get(self, port_channel=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'owner'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_owner_get(self, port_channel=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.owner', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_owner_priority_get(self, port_channel=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.owner', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_owner_track_priority_get(self, port_channel=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.owner', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_preempt_mode_get(self, port_channel=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'owner'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_priority_get(self, port_channel=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'owner'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_track_get(self, port_channel=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_track_interface_get(self, port_channel=None, vrrpv3=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_track_interface_priority_get(self, port_channel=None, vrrpv3=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_use_v2_checksum_get(self, port_channel=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_group_virtual_ip_get(self, port_channel=None, vrrpv3=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.virtual_ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.virtual_ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.virtual_ip', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.virtual_ip', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder.vrrpv3.virtual_ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrpv3=vrrpv3, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrpv3=vrrpv3, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_ipv6_vrrp_suppress_interface_ra_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_lacp_pdu_forward_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.lacp_pdu_forward', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.lacp_pdu_forward', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_lacp_pdu_forward_enable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.lacp_pdu_forward', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.lacp_pdu_forward', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_load_balance_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17s_1_02.interface.port_channel.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'deny'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.port_channel.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'track'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'insight'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'esi'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'vlag'), ('pybind.slxos.v17s_1_02.interface.port_channel.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'qos'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'qos'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'insight'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'track'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.port_channel.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'track'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'qos'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'insight'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.port_channel', u'tunnel'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v6_0_2f.interface.port_channel.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.port_channel', u'qos'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.port_channel', u'track'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel', u'vlag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.port_channel', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel', u'ipv6'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.port_channel', u'service_policy'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'access'), ('pybind.nos.v7_2_0.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrf'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.port_channel', u'rpf'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'trust'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.port_channel', u'ipv6'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.port_channel', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.port_channel', u'qos'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'service_policy'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'tunnel'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'track'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.port_channel', u'vlag'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.port_channel.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.port_channel', u'fcoeport'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'esi'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel', u'protected_port'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'profile_domain_name'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'basic'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ingress, egress'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trust'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'insight_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'value, auto'}, {'leafval': 'native_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'ignore_split'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pc_instance_id'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'in_, out'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'raguard'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'basic'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'loop_detection_native'}, {'leafval': 'vlan_mode'}, {'leafval': 'pc_instance_id, shutdown, name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'id, cost, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'native_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trust'}, {'leafval': 'learn_any'}, {'leafval': 'address, secondary'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'in_, out'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'modeTypePo'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'add_, remove_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'root'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'raguard'}, {'leafval': 'sticky_flag'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'loop_detection_native'}, {'leafval': 'root'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'raguard'}, {'leafval': 'enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'ignore_split'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'address, secondary'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'in_, out'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sticky_flag'}, {'leafval': 'acl_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'basic'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pc_instance_id'}, {'leafval': 'accessvlan'}, {'leafval': 'fcoeport_map'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan'}, {'leafval': 'vlan_mode'}, {'leafval': 'modeTypePo'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trust'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'accessvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'enable, direction'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'basic'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trust'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vlan_mode'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'id, cost, priority'}, {'leafval': 'native_vlan'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'address, secondary'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'add_, remove_'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'raguard'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'oui'}, {'leafval': 'in_, out'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'promiscuous, host'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'red_tc_value'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'oui'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'forwarding'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'log, mode'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'expire'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'raguard'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'groupid, vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'root'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mtu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust'}, {'leafval': 'gateway'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'vlan_mode'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'learn_any'}, {'leafval': 'enable, direction'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'multinet_enable'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'ignore_split'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'id, cost, priority'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'add_, remove_'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'value, auto'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'protected_port_enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_load_balance_type_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17s_1_02.interface.port_channel.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'deny'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.port_channel.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'track'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'insight'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'esi'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'vlag'), ('pybind.slxos.v17s_1_02.interface.port_channel.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'qos'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'qos'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'insight'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'track'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.port_channel.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'track'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'qos'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'insight'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'pfc')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'profile_domain_name'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'basic'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ingress, egress'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trust'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'insight_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'value, auto'}, {'leafval': 'native_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'ignore_split'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pc_instance_id'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'in_, out'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'raguard'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'basic'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'loop_detection_native'}, {'leafval': 'vlan_mode'}, {'leafval': 'pc_instance_id, shutdown, name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'id, cost, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'native_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trust'}, {'leafval': 'learn_any'}, {'leafval': 'address, secondary'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'in_, out'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'modeTypePo'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'add_, remove_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'root'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'raguard'}, {'leafval': 'sticky_flag'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'loop_detection_native'}, {'leafval': 'root'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'raguard'}, {'leafval': 'enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'ignore_split'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'address, secondary'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'in_, out'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sticky_flag'}, {'leafval': 'acl_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'basic'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pc_instance_id'}, {'leafval': 'accessvlan'}, {'leafval': 'fcoeport_map'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan'}, {'leafval': 'vlan_mode'}, {'leafval': 'modeTypePo'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trust'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_log_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.rpf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_common_commands_dummy', u'name'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container', u'tagged_outer_vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged', u'untagged_vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_common_commands_dummy', u'shutdown'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_common_commands_dummy', u'name'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_common_commands_dummy', u'shutdown'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy', u'untagged_vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container', u'get_untagged_vlan_dummy'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container', u'tagged_outer_vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel', u'tagged_outer_vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel.untagged', u'untagged_vlan')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_channel_', 'keyval': 'pc_instance_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'logical_interface_name'}, {'leafval': 'outer_tagged_vlan_id, inner_vlan, inner_tagged_vlan_id'}, {'leafval': 'untagged_vlan_id'}, {'leafval': 'shutdown_status'}, {'leafval': 'logical_interface_name'}, {'leafval': 'shutdown_status'}, {'leafval': 'untagged_flag, untagged_vlan_id'}, {'leafval': 'egress'}, {'leafval': 'outer_tagged_vlan_id, inner_vlan, inner_tagged_vlan_id'}, {'leafval': 'outer_tagged_vlan_id, inner_tagged_vlan_id'}, {'leafval': 'untagged_vlan_id'}]
    leafval_map = {"pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel": {"pc_instance_id": "pc_instance_id"}, "pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel": {"pc_instance_id": "pc_instance_id"}, "pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_egress_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-9'
            '][0-9][0-9][0-9]|1[0-1][0-9][0-9][0-9]|12[0-1][0'
            '-9][0-9]|122[0-7][0-9]|1228[0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_get_untagged_vlan_dummy_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel', u'port_channel_'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy": {"egress": "egress"}, "pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_name_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel', u'tagged_outer_vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel.untagged', u'untagged_vlan')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_channel_', 'keyval': 'pc_instance_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_tagged_vlan_id, inner_tagged_vlan_id'}, {'leafval': 'untagged_vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_name_logical_interface_name_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel', u'port_channel_'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_common_commands_dummy.name', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_common_commands_dummy.name', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_service_instance_common_commands_dummy_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel', u'port_channel_'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_common_commands_dummy', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_common_commands_dummy', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_service_instance_vlan_cmds_dummy_container_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel', u'port_channel_'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_shutdown_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel', u'tagged_outer_vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel.untagged', u'untagged_vlan')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_channel_', 'keyval': 'pc_instance_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outer_tagged_vlan_id, inner_tagged_vlan_id'}, {'leafval': 'untagged_vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_shutdown_shutdown_status_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel', u'port_channel_'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_common_commands_dummy.shutdown', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_common_commands_dummy.shutdown', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_untagged_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel', u'port_channel_'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel', u'port_channel_'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel.untagged', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel.untagged": {}, "pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged_vlan": {"untagged_vlan_id": "untagged_vlan_id", "untagged_flag": "untagged_flag"}, "pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_untagged_untagged_flag_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-9'
            '][0-9][0-9][0-9]|1[0-1][0-9][0-9][0-9]|12[0-1][0'
            '-9][0-9]|122[0-7][0-9]|1228[0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_untagged_vlan_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-9'
            '][0-9][0-9][0-9]|1[0-1][0-9][0-9][0-9]|12[0-1][0'
            '-9][0-9]|122[0-7][0-9]|1228[0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_untagged_vlan_untagged_vlan_id_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel', u'port_channel_'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.get_untagged_vlan_dummy.untagged.untagged_vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel.untagged.untagged_vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_vlan_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel', u'port_channel_'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel', u'port_channel_'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel.tagged_outer_vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'outer_tagged_vlan_id, inner_tagged_vlan_id'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan": {"outer_tagged_vlan_id": "outer_tagged_vlan_id", "inner_vlan": "inner_vlan", "inner_tagged_vlan_id": "inner_tagged_vlan_id"}, "pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan": {"outer_tagged_vlan_id": "outer_tagged_vlan_id", "inner_vlan": "inner_vlan", "inner_tagged_vlan_id": "inner_tagged_vlan_id"}, "pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel.tagged_outer_vlan": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_vlan_inner_tagged_vlan_id_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel', u'port_channel_'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_vlan_inner_vlan_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel', u'port_channel_'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel', u'port_channel_'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel.tagged_outer_vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan": {"inner_vlan": "inner_vlan"}, "pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan": {"inner_vlan": "inner_vlan"}, "pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel.tagged_outer_vlan": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_logical_interface_port_channel_vlan_outer_tagged_vlan_id_get(self, port_channel=None, port_channel_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_: pc_instance_id
    :param port_channel_: Keyword argument tuple.

    :type pc_instance_id: unicode
    :param pc_instance_id: **port_channel_** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|[1-9][0-9][0-9]|[1-6][0-9][0-'
            '9][0-9])\.([1-9]|[1-9][0-9]||[1-9][0-9][0-9]|[1-'
            '9][0-9][0-9][0-9]|1[0-2][0-2][0-8][0-8]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel', u'port_channel_'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel', u'port_channel_'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel', u'port_channel_')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface.port_channel.tagged_outer_vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface.port_channel.pc_cmd_container_dummy.service_instance_vlan_cmds_dummy_container.tagged_outer_vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'pc_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_channel_=port_channel_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_channel_=port_channel_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_loop_detection_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.edge_loop_detection_native', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.edge_loop_detection_native', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_loop_detection_port_priority_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.edge_loop_detection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.edge_loop_detection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_loop_detection_shutdown_disable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.edge_loop_detection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.edge_loop_detection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_loop_detection_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.edge_loop_detection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.edge_loop_detection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_mac_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.mac', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.mac', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.mac', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.mac', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_mac_access_group_get(self, port_channel=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.mac.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.mac.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.mac.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.mac.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': 'mac_access_list, mac_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_mac_access_group_traffic_type_get(self, port_channel=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.mac.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.mac.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.mac.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.mac.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_mac_learning_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.mac_learning', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.mac_learning', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_mac_learning_disable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.mac_learning.mac_learn_disable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.mac_learning.mac_learn_disable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_mac_learning_disable_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_mac_learning_disable_vlan_add_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_mac_learning_disable_vlan_remove_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_minimum_links_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17s_1_02.interface.port_channel.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'deny'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.port_channel.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'track'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'insight'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'esi'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'vlag'), ('pybind.slxos.v17s_1_02.interface.port_channel.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'qos'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'qos'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'insight'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'track'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.port_channel.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'track'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'qos'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'insight'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.port_channel', u'tunnel'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v6_0_2f.interface.port_channel.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.port_channel', u'qos'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.port_channel', u'track'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel', u'vlag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.port_channel', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel', u'ipv6'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.port_channel', u'service_policy'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'access'), ('pybind.nos.v7_2_0.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrf'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.port_channel', u'rpf'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'trust'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.port_channel', u'ipv6'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.port_channel', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.port_channel', u'qos'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'service_policy'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'tunnel'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'track'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.port_channel', u'vlag'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.port_channel.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.port_channel', u'fcoeport'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'esi'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel', u'protected_port'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'profile_domain_name'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'basic'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ingress, egress'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trust'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'insight_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'value, auto'}, {'leafval': 'native_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'ignore_split'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pc_instance_id'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'in_, out'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'raguard'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'basic'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'loop_detection_native'}, {'leafval': 'vlan_mode'}, {'leafval': 'pc_instance_id, shutdown, name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'id, cost, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'native_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trust'}, {'leafval': 'learn_any'}, {'leafval': 'address, secondary'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'in_, out'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'modeTypePo'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'add_, remove_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'root'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'raguard'}, {'leafval': 'sticky_flag'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'loop_detection_native'}, {'leafval': 'root'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'raguard'}, {'leafval': 'enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'ignore_split'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'address, secondary'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'in_, out'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sticky_flag'}, {'leafval': 'acl_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'basic'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pc_instance_id'}, {'leafval': 'accessvlan'}, {'leafval': 'fcoeport_map'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan'}, {'leafval': 'vlan_mode'}, {'leafval': 'modeTypePo'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trust'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'accessvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'enable, direction'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'basic'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trust'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vlan_mode'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'id, cost, priority'}, {'leafval': 'native_vlan'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'address, secondary'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'add_, remove_'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'raguard'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'oui'}, {'leafval': 'in_, out'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'promiscuous, host'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'red_tc_value'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'oui'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'forwarding'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'log, mode'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'expire'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'raguard'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'groupid, vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'root'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mtu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust'}, {'leafval': 'gateway'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'vlan_mode'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'learn_any'}, {'leafval': 'enable, direction'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'multinet_enable'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'ignore_split'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'id, cost, priority'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'add_, remove_'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'value, auto'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'protected_port_enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_mtu_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17s_1_02.interface.port_channel.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'deny'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.port_channel.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'track'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'insight'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'esi'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'vlag'), ('pybind.slxos.v17s_1_02.interface.port_channel.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'qos'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'qos'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'insight'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'track'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.port_channel.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'track'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'qos'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'insight'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.port_channel', u'tunnel'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v6_0_2f.interface.port_channel.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.port_channel', u'qos'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.port_channel', u'track'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel', u'vlag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.port_channel', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel', u'ipv6'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.port_channel', u'service_policy'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'access'), ('pybind.nos.v7_2_0.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrf'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.port_channel', u'rpf'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'trust'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.port_channel', u'ipv6'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.port_channel', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.port_channel', u'qos'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'service_policy'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'tunnel'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'track'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.port_channel', u'vlag'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.port_channel.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.port_channel', u'fcoeport'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'esi'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel', u'protected_port'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'profile_domain_name'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'basic'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ingress, egress'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trust'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'insight_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'value, auto'}, {'leafval': 'native_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'ignore_split'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pc_instance_id'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'in_, out'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'raguard'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'basic'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'loop_detection_native'}, {'leafval': 'vlan_mode'}, {'leafval': 'pc_instance_id, shutdown, name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'id, cost, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'native_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trust'}, {'leafval': 'learn_any'}, {'leafval': 'address, secondary'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'in_, out'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'modeTypePo'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'add_, remove_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'root'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'raguard'}, {'leafval': 'sticky_flag'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'loop_detection_native'}, {'leafval': 'root'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'raguard'}, {'leafval': 'enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'ignore_split'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'address, secondary'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'in_, out'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sticky_flag'}, {'leafval': 'acl_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'basic'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pc_instance_id'}, {'leafval': 'accessvlan'}, {'leafval': 'fcoeport_map'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan'}, {'leafval': 'vlan_mode'}, {'leafval': 'modeTypePo'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trust'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'accessvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'enable, direction'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'basic'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trust'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vlan_mode'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'id, cost, priority'}, {'leafval': 'native_vlan'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'address, secondary'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'add_, remove_'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'raguard'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'oui'}, {'leafval': 'in_, out'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'promiscuous, host'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'red_tc_value'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'oui'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'forwarding'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'log, mode'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'expire'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'raguard'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'groupid, vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'root'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mtu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust'}, {'leafval': 'gateway'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'vlan_mode'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'learn_any'}, {'leafval': 'enable, direction'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'multinet_enable'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'ignore_split'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'id, cost, priority'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'add_, remove_'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'value, auto'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'protected_port_enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_npb_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.npb', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_npb_policy_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.npb.policy', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_npb_policy_route_map_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.npb.policy.route_map', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_npb_policy_route_map_npb_route_map_name_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.npb.policy.route_map', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_openflow_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.openflowPo', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_openflow_enable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.openflowPo.enablePoMode', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo.enablePoMode', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_openflow_enable_modetypepo_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.openflowPo.enablePoMode', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo.enablePoMode', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_port_profile_port_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17s_1_02.interface.port_channel.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'deny'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.port_channel.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'track'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'insight'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'esi'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'vlag'), ('pybind.slxos.v17s_1_02.interface.port_channel.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'qos'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'qos'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'insight'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'track'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.port_channel.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'track'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'qos'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'insight'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.port_channel', u'tunnel'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v6_0_2f.interface.port_channel.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.port_channel', u'qos'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.port_channel', u'track'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel', u'vlag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.port_channel', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel', u'ipv6'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.port_channel', u'service_policy'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'access'), ('pybind.nos.v7_2_0.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrf'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.port_channel', u'rpf'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'trust'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.port_channel', u'ipv6'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.port_channel', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.port_channel', u'qos'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'service_policy'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'tunnel'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'track'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.port_channel', u'vlag'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.port_channel.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.port_channel', u'fcoeport'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'esi'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel', u'protected_port'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'profile_domain_name'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'basic'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ingress, egress'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trust'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'insight_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'value, auto'}, {'leafval': 'native_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'ignore_split'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pc_instance_id'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'in_, out'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'raguard'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'basic'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'loop_detection_native'}, {'leafval': 'vlan_mode'}, {'leafval': 'pc_instance_id, shutdown, name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'id, cost, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'native_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trust'}, {'leafval': 'learn_any'}, {'leafval': 'address, secondary'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'in_, out'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'modeTypePo'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'add_, remove_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'root'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'raguard'}, {'leafval': 'sticky_flag'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'loop_detection_native'}, {'leafval': 'root'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'raguard'}, {'leafval': 'enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'ignore_split'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'address, secondary'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'in_, out'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sticky_flag'}, {'leafval': 'acl_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'basic'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pc_instance_id'}, {'leafval': 'accessvlan'}, {'leafval': 'fcoeport_map'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan'}, {'leafval': 'vlan_mode'}, {'leafval': 'modeTypePo'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trust'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'accessvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'enable, direction'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'basic'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trust'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vlan_mode'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'id, cost, priority'}, {'leafval': 'native_vlan'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'address, secondary'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'add_, remove_'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'raguard'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'oui'}, {'leafval': 'in_, out'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'promiscuous, host'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'red_tc_value'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'oui'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'forwarding'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'log, mode'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'expire'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'raguard'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'groupid, vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'root'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mtu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust'}, {'leafval': 'gateway'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'vlan_mode'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'learn_any'}, {'leafval': 'enable, direction'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'multinet_enable'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'ignore_split'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'id, cost, priority'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'add_, remove_'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'value, auto'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'protected_port_enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_port_profile_port_domain_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_port_profile_port_domain_profile_domain_name_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_port_profile_port_profile_get(self, port_channel=None, port_to_port_profile_associations=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_to_port_profile_associations: port_to_port_profile_association
    :param port_to_port_profile_associations: Keyword argument tuple.

    :type port_to_port_profile_association: unicode
    :param port_to_port_profile_association: **port_to_port_profile_associations** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_to_port_profile_associations', 'keyval': 'port_to_port_profile_association', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_to_port_profile_associations=port_to_port_profile_associations)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_to_port_profile_associations=port_to_port_profile_associations)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_port_profile_to_interface_associations_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_priority_tag_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17s_1_02.interface.port_channel.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'deny'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.port_channel.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'track'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'insight'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'esi'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'vlag'), ('pybind.slxos.v17s_1_02.interface.port_channel.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'qos'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'qos'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'insight'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'track'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.port_channel.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'track'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'qos'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'insight'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.port_channel', u'tunnel'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v6_0_2f.interface.port_channel.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.port_channel', u'qos'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.port_channel', u'track'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel', u'vlag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.port_channel', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel', u'ipv6'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.port_channel', u'service_policy'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'access'), ('pybind.nos.v7_2_0.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrf'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.port_channel', u'rpf'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'trust'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.port_channel', u'ipv6'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.port_channel', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.port_channel', u'qos'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'service_policy'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'tunnel'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'track'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.port_channel', u'vlag'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.port_channel.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.port_channel', u'fcoeport'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'esi'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel', u'protected_port'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'profile_domain_name'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'basic'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ingress, egress'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trust'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'insight_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'value, auto'}, {'leafval': 'native_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'ignore_split'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pc_instance_id'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'in_, out'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'raguard'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'basic'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'loop_detection_native'}, {'leafval': 'vlan_mode'}, {'leafval': 'pc_instance_id, shutdown, name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'id, cost, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'native_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trust'}, {'leafval': 'learn_any'}, {'leafval': 'address, secondary'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'in_, out'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'modeTypePo'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'add_, remove_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'root'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'raguard'}, {'leafval': 'sticky_flag'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'loop_detection_native'}, {'leafval': 'root'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'raguard'}, {'leafval': 'enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'ignore_split'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'address, secondary'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'in_, out'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sticky_flag'}, {'leafval': 'acl_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'basic'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pc_instance_id'}, {'leafval': 'accessvlan'}, {'leafval': 'fcoeport_map'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan'}, {'leafval': 'vlan_mode'}, {'leafval': 'modeTypePo'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trust'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'accessvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'enable, direction'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'basic'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trust'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vlan_mode'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'id, cost, priority'}, {'leafval': 'native_vlan'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'address, secondary'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'add_, remove_'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'raguard'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'oui'}, {'leafval': 'in_, out'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'promiscuous, host'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'red_tc_value'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'oui'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'forwarding'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'log, mode'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'expire'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'raguard'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'groupid, vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'root'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mtu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust'}, {'leafval': 'gateway'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'vlan_mode'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'learn_any'}, {'leafval': 'enable, direction'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'multinet_enable'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'ignore_split'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'id, cost, priority'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'add_, remove_'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'value, auto'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'protected_port_enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_protected_port_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.protected_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_protected_port_enable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.protected_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_protocol_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.protocol', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_protocol_ptp_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_protocol_ptp_announce_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_protocol_ptp_announce_timeout_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_protocol_ptp_delay_request_min_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_protocol_ptp_enable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_protocol_ptp_ptp_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_protocol_ptp_sync_interval_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.interface.port_channel.qos": {"cos_mutation": "cos_mutation", "default_cos": "default_cos", "dscp_mutation": "dscp_mutation", "dscp_traffic_class": "dscp_traffic_class", "cos_traffic_class": "cos_traffic_class", "dscp_cos": "dscp_cos"}, "pybind.slxos.v17s_1_02.interface.port_channel.qos": {}, "pybind.slxos.v17r_1_01a.interface.port_channel.qos": {}, "pybind.nos.v6_0_2f.interface.port_channel.qos": {"cos_mutation": "cos_mutation", "default_cos": "default_cos", "dscp_mutation": "dscp_mutation", "dscp_traffic_class": "dscp_traffic_class", "cos_traffic_class": "cos_traffic_class", "dscp_cos": "dscp_cos"}, "pybind.slxos.v17r_2_00.interface.port_channel.qos": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_cos_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_cos_mutation_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_cos_traffic_class_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_drop_monitor_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos.drop_monitor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos.drop_monitor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.drop_monitor', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.drop_monitor', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.drop_monitor', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_drop_monitor_enable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos.drop_monitor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos.drop_monitor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.drop_monitor', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.drop_monitor', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.drop_monitor', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_dscp_cos_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_dscp_mutation_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_dscp_traffic_class_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_ecn_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.qos.ecn', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_link_level_flowcontrol_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_pfc_get(self, port_channel=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol.pfc', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol.pfc', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol.pfc', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_pfc_rx_get(self, port_channel=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol.pfc', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol.pfc', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol.pfc', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_pfc_threshold_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_pfc_tx_get(self, port_channel=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol.pfc', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol.pfc', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol.pfc', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_rx_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_threshold_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_threshold_2_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold_tx_on, threshold_tx_off'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_threshold_off_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_threshold_on_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.threshold', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_threshold_pfc_get(self, port_channel=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_threshold_cos
    :param pfc: Keyword argument tuple.

    :type pfc_threshold_cos: int
    :param pfc_threshold_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold.pfc', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_threshold_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_threshold_pfc_off_get(self, port_channel=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_threshold_cos
    :param pfc: Keyword argument tuple.

    :type pfc_threshold_cos: int
    :param pfc_threshold_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold.pfc', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_threshold_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_threshold_pfc_on_get(self, port_channel=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_threshold_cos
    :param pfc: Keyword argument tuple.

    :type pfc_threshold_cos: int
    :param pfc_threshold_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold.pfc', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_threshold_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_flowcontrol_tx_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol.link_level_flowcontrol', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_random_detect_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos.ecn.random_detect', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_random_detect_2_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.qos.random_detect', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_random_detect_ecn_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.qos.ecn.random_detect.random_detect_ecn', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_random_detect_ecn_traffic_class_get(self, port_channel=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: int
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.qos.ecn.random_detect.random_detect_ecn.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_random_detect_traffic_class_get(self, port_channel=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos.random_detect.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect.traffic_class', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect.traffic_class', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect.traffic_class', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value, red_dp_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect.traffic_class": {}, "pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect.traffic_class": {"red_tc_value": "red_tc_value", "red_profile_id": "red_profile_id", "red_enable": "red_enable"}, "pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect.traffic_class": {"red_tc_value": "red_tc_value", "red_profile_id": "red_profile_id"}, "pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect.traffic_class": {"red_tc_value": "red_tc_value", "red_profile_id": "red_profile_id"}, "pybind.nos.v7_2_0.interface.port_channel.qos.random_detect.traffic_class": {"red_tc_value": "red_tc_value", "red_profile_id": "red_profile_id", "red_enable": "red_enable"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_random_detect_traffic_class_apply_get(self, port_channel=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos.random_detect.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_random_detect_traffic_class_red_profile_id_get(self, port_channel=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos.random_detect.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect.traffic_class', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect.traffic_class', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect.traffic_class', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value, red_dp_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect.traffic_class": {"red_tc_value": "red_tc_value", "red_profile_id": "red_profile_id"}, "pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect.traffic_class": {"red_tc_value": "red_tc_value", "red_profile_id": "red_profile_id"}, "pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect.traffic_class": {}, "pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect.traffic_class": {}, "pybind.nos.v7_2_0.interface.port_channel.qos.random_detect.traffic_class": {"red_tc_value": "red_tc_value", "red_profile_id": "red_profile_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_traffic_class_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_traffic_class_cos_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.qos', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_trust_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos.trust', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos.trust', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.trust', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.trust', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.trust', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_trust_cos_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos.trust', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos.trust', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.trust', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.trust', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.trust', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_qos_trust_dscp_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.qos.trust', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.qos.trust', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.trust', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.trust', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.trust', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_route_only_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'qos'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'insight'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'track'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.port_channel.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'track'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'qos'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'insight'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'pfc')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'basic'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'loop_detection_native'}, {'leafval': 'vlan_mode'}, {'leafval': 'pc_instance_id, shutdown, name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'id, cost, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'native_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trust'}, {'leafval': 'learn_any'}, {'leafval': 'address, secondary'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'in_, out'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'modeTypePo'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'add_, remove_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'root'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'raguard'}, {'leafval': 'sticky_flag'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'loop_detection_native'}, {'leafval': 'root'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'raguard'}, {'leafval': 'enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'ignore_split'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'address, secondary'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'in_, out'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sticky_flag'}, {'leafval': 'acl_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'basic'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pc_instance_id'}, {'leafval': 'accessvlan'}, {'leafval': 'fcoeport_map'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan'}, {'leafval': 'vlan_mode'}, {'leafval': 'modeTypePo'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trust'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_rpf_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.rpf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_rpf_mode_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.rpf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_service_policy_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.service_policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.service_policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.service_policy', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.service_policy', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.service_policy', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_service_policy_in_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.service_policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.service_policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.service_policy', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.service_policy', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.service_policy', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_service_policy_out_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.service_policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.service_policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.service_policy', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.service_policy', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.service_policy', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_shutdown_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17s_1_02.interface.port_channel.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'deny'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.port_channel.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'track'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'insight'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'esi'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'vlag'), ('pybind.slxos.v17s_1_02.interface.port_channel.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'qos'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'qos'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'insight'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'track'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.port_channel.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'track'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'qos'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'insight'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.port_channel', u'tunnel'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v6_0_2f.interface.port_channel.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.port_channel', u'qos'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.port_channel', u'track'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel', u'vlag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.port_channel', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel', u'ipv6'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.port_channel', u'service_policy'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'access'), ('pybind.nos.v7_2_0.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrf'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.port_channel', u'rpf'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'trust'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.port_channel', u'ipv6'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.port_channel', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.port_channel', u'qos'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'service_policy'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'tunnel'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'track'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.port_channel', u'vlag'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.port_channel.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.port_channel', u'fcoeport'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'esi'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel', u'protected_port'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'profile_domain_name'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'basic'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ingress, egress'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trust'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'insight_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'value, auto'}, {'leafval': 'native_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'ignore_split'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pc_instance_id'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'in_, out'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'raguard'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'basic'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'loop_detection_native'}, {'leafval': 'vlan_mode'}, {'leafval': 'pc_instance_id, shutdown, name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'id, cost, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'native_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trust'}, {'leafval': 'learn_any'}, {'leafval': 'address, secondary'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'in_, out'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'modeTypePo'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'add_, remove_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'root'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'raguard'}, {'leafval': 'sticky_flag'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'loop_detection_native'}, {'leafval': 'root'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'raguard'}, {'leafval': 'enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'ignore_split'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'address, secondary'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'in_, out'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sticky_flag'}, {'leafval': 'acl_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'basic'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pc_instance_id'}, {'leafval': 'accessvlan'}, {'leafval': 'fcoeport_map'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan'}, {'leafval': 'vlan_mode'}, {'leafval': 'modeTypePo'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trust'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'accessvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'enable, direction'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'basic'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trust'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vlan_mode'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'id, cost, priority'}, {'leafval': 'native_vlan'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'address, secondary'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'add_, remove_'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'raguard'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'oui'}, {'leafval': 'in_, out'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'promiscuous, host'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'red_tc_value'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'oui'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'forwarding'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'log, mode'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'expire'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'raguard'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'groupid, vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'root'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mtu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust'}, {'leafval': 'gateway'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'vlan_mode'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'learn_any'}, {'leafval': 'enable, direction'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'multinet_enable'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'ignore_split'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'id, cost, priority'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'add_, remove_'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'value, auto'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'protected_port_enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_snmp_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.snmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.snmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_snmp_trap_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.snmp.trap', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.snmp.trap', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_snmp_trap_link_status_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.snmp.trap', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.snmp.trap', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree": {}, "pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree": {}, "pybind.nos.v7_2_0.interface.port_channel.spanning_tree": {"bpdu_mac": "bpdu_mac", "hello_time": "hello_time", "restricted_tcn": "restricted_tcn", "autoedge": "autoedge", "priority": "priority", "cost": "cost", "peer_switch": "peer_switch", "shutdown": "shutdown", "restricted_role": "restricted_role", "link_type": "link_type"}, "pybind.nos.v6_0_2f.interface.port_channel.spanning_tree": {"bpdu_mac": "bpdu_mac", "hello_time": "hello_time", "restricted_tcn": "restricted_tcn", "autoedge": "autoedge", "priority": "priority", "cost": "cost", "peer_switch": "peer_switch", "shutdown": "shutdown", "restricted_role": "restricted_role", "link_type": "link_type"}, "pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_autoedge_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_bpdu_mac_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_cost_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_edgeport_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.edgeport', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.edgeport', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.edgeport', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.edgeport": {"edgeportbasic": "edgeportbasic", "bpdu_filter": "bpdu_filter", "bpdu_guard": "bpdu_guard"}, "pybind.nos.v7_2_0.interface.port_channel.spanning_tree.edgeport": {"edgeportbasic": "edgeportbasic", "bpdu_filter": "bpdu_filter", "bpdu_guard": "bpdu_guard"}, "pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.edgeport": {}, "pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.edgeport": {"edgeportbasic": "edgeportbasic", "bpdu_filter": "bpdu_filter", "bpdu_guard": "bpdu_guard"}, "pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.edgeport": {"edgeportbasic": "edgeportbasic", "bpdu_filter": "bpdu_filter", "bpdu_guard": "bpdu_guard"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_edgeport_bpdu_filter_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.edgeport', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.edgeport', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_edgeport_bpdu_guard_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.edgeport', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.edgeport', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.edgeport', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_edgeport_edgeportbasic_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.edgeport', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.edgeport', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.edgeport', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_guard_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.guard', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.guard', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.guard', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_guard_root_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.guard', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.guard', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.guard', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_hello_time_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_instance_get(self, port_channel=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_instance_cost_get(self, port_channel=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_instance_priority_get(self, port_channel=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_instance_restricted_role_get(self, port_channel=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_instance_restricted_tcn_get(self, port_channel=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.instance', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_link_type_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_peer_switch_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_portfast_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.portfast', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.portfast', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.portfast', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.portfast": {"portfastbasic": "portfastbasic", "bpdu_filter": "bpdu_filter", "bpdu_guard": "bpdu_guard"}, "pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.portfast": {"portfastbasic": "portfastbasic", "bpdu_filter": "bpdu_filter", "bpdu_guard": "bpdu_guard"}, "pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.portfast": {"portfastbasic": "portfastbasic", "bpdu_filter": "bpdu_filter", "bpdu_guard": "bpdu_guard"}, "pybind.nos.v7_2_0.interface.port_channel.spanning_tree.portfast": {"portfastbasic": "portfastbasic", "bpdu_filter": "bpdu_filter", "bpdu_guard": "bpdu_guard"}, "pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.portfast": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_portfast_bpdu_filter_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.portfast', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.portfast', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_portfast_bpdu_guard_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.portfast', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.portfast', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.portfast', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_portfast_portfastbasic_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.portfast', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.portfast', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.portfast', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_priority_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_restricted_role_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_restricted_tcn_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_shutdown_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_vlan_get(self, port_channel=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.vlan', u'guard'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.vlan', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.vlan', u'guard'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.vlan', u'guard'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}, {'leafval': 'root'}, {'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_vlan_cost_get(self, port_channel=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.vlan', u'guard'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.vlan', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.vlan', u'guard'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.vlan', u'guard'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}, {'leafval': 'root'}, {'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_vlan_guard_get(self, port_channel=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.vlan.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.vlan.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.vlan.guard', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.vlan.guard', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.vlan.guard', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_vlan_guard_root_get(self, port_channel=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.vlan.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.vlan.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.vlan.guard', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.vlan.guard', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.vlan.guard', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_spanning_tree_vlan_priority_get(self, port_channel=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree.vlan', u'guard'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree.vlan', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree.vlan', u'guard'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree.vlan', u'guard'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}, {'leafval': 'root'}, {'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_speed_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17s_1_02.interface.port_channel.npb.policy', u'route_map'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'tvf_domain'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'deny'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17s_1_02.interface.port_channel.system', u'packet_timestamp'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'track'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'insight'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'esi'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17s_1_02.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'vlag'), ('pybind.slxos.v17s_1_02.interface.port_channel.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17s_1_02.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17s_1_02.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'qos'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'service_policy'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'qos'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'insight'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'track'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.port_channel.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'track'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'qos'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_1_01a.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'insight'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_1_01a.interface.port_channel.spanning_tree', u'portfast'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.port_channel', u'tunnel'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.port_channel', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v6_0_2f.interface.port_channel.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.port_channel', u'qos'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.port_channel.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.port_channel', u'track'), ('pybind.nos.v6_0_2f.interface.port_channel.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.port_channel', u'vlag'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.port_channel', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel', u'ipv6'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.port_channel', u'service_policy'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'access'), ('pybind.nos.v7_2_0.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrf'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.port_channel', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.port_channel', u'rpf'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.port_channel', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'trust'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.port_channel', u'ipv6'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.port_channel.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.port_channel.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.port_channel.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.port_channel', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_po_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.port_channel', u'qos'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.port_channel', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'service_policy'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.port_channel.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'tunnel'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'track'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.port_channel.ip.igmp_po_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.port_channel.ip.pim_intf_po_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.port_channel', u'vlag'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.port_channel.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.port_channel', u'fcoeport'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.port_channel.ip.interface_PO_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.port_channel.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.port_channel', u'esi'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel', u'protected_port'), ('pybind.nos.v7_2_0.interface.port_channel.track', u'remove'), ('pybind.nos.v7_2_0.interface.port_channel.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.port_channel', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.port_channel.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.port_channel.ipv6.interface_ospfv3_conf.authentication', u'ipsec')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'profile_domain_name'}, {'leafval': 'red_tc_value, red_profile_id'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'basic'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'npb_route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard'}, {'leafval': 'tvfdomain_all, tvfdomain_none, tvfdomain_add, tvfdomain_remove, tvfdomain_except'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'inner_gtp_https'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'ingress, egress'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trust'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'insight_enable'}, {'leafval': 'vlan_mode'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'value, auto'}, {'leafval': 'native_vlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'ignore_split'}, {'leafval': 'enable, announce_interval, announce_timeout, sync_interval, delay_request_min_interval, ptp_vlan'}, {'leafval': 'portfastbasic, bpdu_guard'}, {'leafval': 'id, cost, priority'}, {'leafval': 'pc_instance_id'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'in_, out'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'raguard'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'basic'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'loop_detection_native'}, {'leafval': 'vlan_mode'}, {'leafval': 'pc_instance_id, shutdown, name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'id, cost, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'native_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trust'}, {'leafval': 'learn_any'}, {'leafval': 'address, secondary'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'in_, out'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'modeTypePo'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'add_, remove_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'root'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'raguard'}, {'leafval': 'sticky_flag'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'loop_detection_native'}, {'leafval': 'root'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'raguard'}, {'leafval': 'enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'profile_domain_name'}, {'leafval': 'ignore_split'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'address, secondary'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'in_, out'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'sticky_flag'}, {'leafval': 'acl_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'basic'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'pc_instance_id'}, {'leafval': 'accessvlan'}, {'leafval': 'fcoeport_map'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'native_vlan'}, {'leafval': 'vlan_mode'}, {'leafval': 'modeTypePo'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'add_, remove_'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trust'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'accessvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'enable, direction'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'basic'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'trust'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'root'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'vlan_mode'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'id, cost, priority'}, {'leafval': 'native_vlan'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'address, secondary'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'add_, remove_'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'raguard'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'oui'}, {'leafval': 'in_, out'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'promiscuous, host'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'route_map_name'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'red_tc_value'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'basic'}, {'leafval': 'accessvlan'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'oui'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'forwarding'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'profile_domain_name'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'sg_addr'}, {'leafval': 'attempts, time'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'log, mode'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'expire'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'raguard'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'groupid, vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'root'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'mtu'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'trust'}, {'leafval': 'gateway'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'vlan_mode'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'learn_any'}, {'leafval': 'enable, direction'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'in_, out'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'native_vlan'}, {'leafval': 'bfd_enable'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'promiscuous, host'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'multinet_enable'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'ignore_split'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'id, cost, priority'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'add_, remove_'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'value, auto'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'protected_port_enable'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'max_interval, min_'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport_basic', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport_basic', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport_basic', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport_basic', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport_basic', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_access_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_access_access_mac_group_vlan_classification_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_group_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_group_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_access_access_mac_vlan_classification_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_access_mac_group_vlan_classification_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_group_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_group_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_group_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_access_mac_group_vlan_classification_access_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_group_vlan_classification.access', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification.access', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_group_vlan_classification.access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_access_mac_group_vlan_classification_access_vlan_get(self, port_channel=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_access_mac_vlan_classification_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_access_mac_vlan_classification_access_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_vlan_classification.access', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification.access', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_vlan_classification.access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_access_mac_vlan_classification_access_vlan_get(self, port_channel=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access_mac_vlan_classification.access.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification.access.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access_mac_vlan_classification.access.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_access_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.access', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.access', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_access_vlan_access_mac_vlan_classification_get(self, port_channel=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_basic_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport_basic', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport_basic', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport_basic', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport_basic', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport_basic', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_mode_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.mode', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.mode', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.mode', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_mode_private_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_mode_private_vlan_host_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_mode_private_vlan_promiscuous_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_mode_private_vlan_trunk_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_mode_private_vlan_trunk_host_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_mode_private_vlan_trunk_promiscuous_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_mode_private_vlan_trunk_trunk_basic_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_mode_vlan_mode_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.mode', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.mode', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.mode', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.mode', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.mode', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_port_security_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_port_security_allowed_ouis_get(self, port_channel=None, allowed_ouis=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type allowed_ouis: oui
    :param allowed_ouis: Keyword argument tuple.

    :type oui: unicode
    :param oui: **allowed_ouis** tuple argument:  <OUI> OUI in HHHH.HH00.0000 format

        * pattern restriction: ::

            '[0-9a-fA-F]{4}\.[0-9a-fA-F]{2}00\.0000'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.allowed_ouis', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.allowed_ouis', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'allowed_ouis', 'keyval': 'oui', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, allowed_ouis=allowed_ouis)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, allowed_ouis=allowed_ouis)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_port_security_max_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_port_security_port_security_mac_address_get(self, port_channel=None, port_security_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_security_mac_address: mac_address, port_sec_vlan
    :param port_security_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_security_mac_address** tuple argument:  Mac Address

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_security_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.port_security_mac_address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.port_security_mac_address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_security_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_security_mac_address=port_security_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_security_mac_address=port_security_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_port_security_port_secutiry_mac_address_get(self, port_channel=None, port_secutiry_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security.port_secutiry_mac_address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_port_security_shutdown_time_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_port_security_sticky_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.sticky', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.sticky', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.sticky', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security.sticky', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky": {"sticky_flag": "sticky_flag"}, "pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.sticky": {"sticky_flag": "sticky_flag"}, "pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.sticky": {"sticky_flag": "sticky_flag"}, "pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security.sticky": {}, "pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.sticky": {"sticky_flag": "sticky_flag"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_port_security_sticky_port_security_mac_address_get(self, port_channel=None, port_security_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_security_mac_address: mac_address, port_sec_vlan
    :param port_security_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_security_mac_address** tuple argument:  Mac Address

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_security_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.sticky.port_security_mac_address', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky.port_security_mac_address', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_security_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_security_mac_address=port_security_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_security_mac_address=port_security_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_port_security_sticky_port_secutiry_mac_address_get(self, port_channel=None, port_secutiry_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_port_security_sticky_sticky_flag_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security.sticky', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security.sticky', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security.sticky', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_port_security_violation_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.port_security', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.port_security', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_association_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_association_trunk_get(self, port_channel=None, trunk=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type trunk: trunk_pri_pvlan, trunk_sec_pvlan
    :param trunk: Keyword argument tuple.

    :type trunk_pri_pvlan: long
    :param trunk_pri_pvlan: **trunk** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type trunk_sec_pvlan: long
    :param trunk_sec_pvlan: **trunk** tuple argument:  Secondary vlan id 

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.association.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.association.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'trunk', 'keyval': 'trunk_pri_pvlan, trunk_sec_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, trunk=trunk)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, trunk=trunk)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_host_association_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.host_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'host_pri_pvlan, host_sec_pvlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_host_association_host_pri_pvlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.host_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_host_association_host_sec_pvlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.host_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_mapping_get(self, port_channel=None, mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan, oper, promis_sec_pvlan_range
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type oper: unicode
    :param oper: **mapping** tuple argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type promis_sec_pvlan_range: unicode
    :param promis_sec_pvlan_range: **mapping** tuple argument:  Secondary vlan range

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-7][0-9]{3})|(80[0-9]{2})|'
            '(81[0-8][0-9])|(819[01]))(-(([2-9])|([1-9][0-9]{'
            '1,2})|([1-7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9]'
            ')|(819[01])))?((,(([2-9])|([1-9][0-9]{1,2})|([1-'
            '7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9])|(819[01]'
            '))(-(([3-9])|([1-9][0-9]{1,2})|([1-7][0-9]{3})|('
            '80[0-9]{2})|(81[0-8][0-9])|(819[01])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.mapping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, mapping=mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_mapping_oper_get(self, port_channel=None, mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.mapping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, mapping=mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_mapping_promis_sec_pvlan_range_get(self, port_channel=None, mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.mapping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, mapping=mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_trunk_private_vlan_classification_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_vlan_add_get(self, port_channel=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_vlan_all_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_vlan_except_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_vlan_none_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_vlan_remove_get(self, port_channel=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_allowed_vlan_trunk_private_vlan_classification_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_native_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.native', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_native_ctag_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.native', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_native_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.native', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_private_vlan_classification_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_tag_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_tag_native_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_private_vlan_trunk_trunk_private_vlan_classification_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_trunk_vlan_classification_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_add_get(self, port_channel=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_add_ctag_get(self, port_channel=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_all_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_except_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_none_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_remove_get(self, port_channel=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_remove_ctag_get(self, port_channel=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlan_trunk_vlan_classification_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlanoper_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlanoper', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlanoper', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlanoper', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlanoper', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlanoper_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlanoper_vlan_add_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_allowed_vlanoper_vlan_remove_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.allowed.vlanoper.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_ctag_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_ctag_native_vlan_xtagged_config_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_default_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_default_vlan_config_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.default_vlan_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_transparent_vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_egress_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_native_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_native_vlan_classification_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id, native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_native_vlan_untagged_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_native_vlan_untagged_config_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.native_vlan_untagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_untagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_native_vlan_xtagged_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_native_vlan_xtagged_config_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.native_vlan_xtagged_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_private_vlan_classification_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk_private_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk_private_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_tag_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.tag', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.tag', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.tag', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_tag_native_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.tag', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.tag', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.tag', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_trunk_vlan_classification_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_trunk_vlan_classification_allowed_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_trunk_vlan_classification_allowed_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_trunk_vlan_classification_allowed_vlan_add_get(self, port_channel=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_trunk_vlan_classification_allowed_vlan_add_ctag_get(self, port_channel=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_trunk_vlan_classification_allowed_vlan_remove_get(self, port_channel=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_switchport_trunk_trunk_vlan_classification_allowed_vlan_remove_ctag_get(self, port_channel=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_system_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.system', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_system_packet_timestamp_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.system.packet_timestamp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_system_packet_timestamp_egress_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.system.packet_timestamp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_system_packet_timestamp_ingress_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.system.packet_timestamp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_tag_type_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'qos'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'insight'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'track'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.port_channel.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'portfast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'basic'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'loop_detection_native'}, {'leafval': 'vlan_mode'}, {'leafval': 'pc_instance_id, shutdown, name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'id, cost, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'native_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trust'}, {'leafval': 'learn_any'}, {'leafval': 'address, secondary'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'in_, out'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'modeTypePo'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'add_, remove_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'root'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'raguard'}, {'leafval': 'sticky_flag'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_track_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_track_enable_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_track_interface_get(self, port_channel=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface: track_interface_type, track_interface_name
    :param interface: Keyword argument tuple.

    :type track_interface_type: unicode
    :param track_interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type track_interface_name: unicode
    :param track_interface_name: **interface** tuple argument:  Interface name

        * pattern restriction: ::

            '(((([1-9]|[1-9][0-9]|1[0-9]{2}|2[0-3][0-9])/)?(('
            '[0-9]|1[0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]'
            ')(:[1-4])?)|([1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5'
            '][0-9]{3}|6[0-1][0-4]{2}))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.track.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'track_interface_type, track_interface_name', 'extra_keyval': 'track_interface_type, track_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_track_min_link_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.track', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_track_remove_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.track.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.track.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track.remove_', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.track.remove_', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.track.remove_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_track_remove_all_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.track.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.track.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.track.remove_', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.track.remove_', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.track.remove_', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_tunnel_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.tunnel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.tunnel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_tunnel_tagged_ieee_bpdu_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.tunnel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.tunnel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_tvf_domain_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.tvf_domain', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_tvf_domain_add_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.tvf_domain', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_tvf_domain_all_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.tvf_domain', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_tvf_domain_except_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.tvf_domain', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_tvf_domain_none_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.tvf_domain', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_tvf_domain_remove_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.tvf_domain', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_uda_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.port_channel.uda', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_uda_access_group_get(self, port_channel=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: uda_access_list, uda_direction
    :param access_group: Keyword argument tuple.

    :type uda_access_list: unicode
    :param uda_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type uda_direction: unicode
    :param uda_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface.port_channel.uda.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'uda_access_list, uda_direction', 'extra_keyval': 'uda_access_list, uda_direction'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_uda_profile_apply_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.interface.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.random_detect', u'traffic_class'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'switchport_basic'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'threshold'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection_native'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'mode'), ('pybind.slxos.v17r_2_00.interface.port_channel.logical_interface', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security.sticky', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'fcoeport'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol.pfc_threshold.threshold', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'edgeport'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'qos'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'interface'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'insight'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'tag'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'track'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'access'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'lacp_pdu_forward'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3'), ('pybind.slxos.v17r_2_00.interface.port_channel.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'instance'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'vlag'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'trust'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder.ip_config', u'address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.interface.port_channel.track', u'remove'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'service_policy'), ('pybind.slxos.v17r_2_00.interface.port_channel.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.openflowPo', u'enablepomode'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.hide_ip_holder', u'ip_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.slxos.v17r_2_00.interface.port_channel.qos', u'drop_monitor'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'port_security_mac_address'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport', u'port_security'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'guard'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface.port_channel.ipv6.hide_vrrpv3_holder', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.trunk', u'default_vlan_config'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'ipv6'), ('pybind.slxos.v17r_2_00.interface.port_channel.switchport.port_security', u'sticky'), ('pybind.slxos.v17r_2_00.interface.port_channel.uda', u'access_group'), ('pybind.slxos.v17r_2_00.interface.port_channel.spanning_tree', u'portfast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrid, version, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'red_tc_value, red_dp_value, red_profile_id'}, {'leafval': 'basic'}, {'leafval': 'threshold_tx_on, threshold_tx_off'}, {'leafval': 'loop_detection_native'}, {'leafval': 'vlan_mode'}, {'leafval': 'pc_instance_id, shutdown, name'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'fcoeport_map'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'pfc_threshold_cos, pfc_threshold_tx_on, pfc_threshold_tx_off'}, {'leafval': 'id, cost, priority'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, default_tc, cos_mutation, traffic_class_cos, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'insight_enable, insight_mmId'}, {'leafval': 'native_vlan'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'accessvlan'}, {'leafval': 'enable'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'vrid, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ignore_split'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trust'}, {'leafval': 'learn_any'}, {'leafval': 'address, secondary'}, {'leafval': 'eldprio, eldshutdown_disable, eldvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'in_, out'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'modeTypePo'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'add_, remove_'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'autoedge, cost, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown, peer_switch'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'root'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'raguard'}, {'leafval': 'sticky_flag'}, {'leafval': 'uda_access_list, uda_direction'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vlag_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.vlag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vlag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.vlag', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.vlag', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.vlag', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vlag_ignore_split_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.vlag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vlag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.vlag', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.vlag', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.vlag', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vlan_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vlan_classifier_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.vlan.classifier', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vlan.classifier', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vlan_classifier_activate_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.vlan.classifier.activate', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vlan.classifier.activate', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vlan_classifier_activate_group_get(self, port_channel=None, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group: groupid, vlan
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vlan: long
    :param vlan: **group** tuple argument:  1-8191;;Vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.vlan.classifier.activate.group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vlan.classifier.activate.group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': 'groupid, vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vlan_classifier_activate_group_vlan_get(self, port_channel=None, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group: groupid
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.vlan.classifier.activate.group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vlan.classifier.activate.group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrf_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.vrf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrf_forwarding_get(self, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.vrf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_get(self, port_channel=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'owner'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.arp', u'unicast_request')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}]
    leafval_map = {"pybind.nos.v7_2_0.interface.port_channel.vrrp": {}, "pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp": {"enable": "enable", "version": "version", "vrid": "vrid", "priority": "priority", "advertisement_interval": "advertisement_interval", "hold_time": "hold_time", "preempt_mode": "preempt_mode", "description": "description"}, "pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp": {"enable": "enable", "version": "version", "vrid": "vrid", "priority": "priority", "advertisement_interval": "advertisement_interval", "hold_time": "hold_time", "preempt_mode": "preempt_mode", "description": "description"}, "pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp": {"enable": "enable", "version": "version", "vrid": "vrid", "priority": "priority", "advertisement_interval": "advertisement_interval", "hold_time": "hold_time", "preempt_mode": "preempt_mode", "description": "description"}, "pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp": {"enable": "enable", "version": "version", "vrid": "vrid", "priority": "priority", "advertisement_interval": "advertisement_interval", "hold_time": "hold_time", "preempt_mode": "preempt_mode", "description": "description"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_advertisement_interval_get(self, port_channel=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'owner'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.arp', u'unicast_request')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_arp_get(self, port_channel=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.arp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.arp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.arp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.arp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_arp_unicast_request_get(self, port_channel=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.arp.unicast_request', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.arp.unicast_request', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.arp.unicast_request', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.arp.unicast_request', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_arp_unicast_request_receive_get(self, port_channel=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.arp.unicast_request', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.arp.unicast_request', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.arp.unicast_request', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.arp.unicast_request', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_description_get(self, port_channel=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'owner'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.arp', u'unicast_request')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_enable_get(self, port_channel=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'owner'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.arp', u'unicast_request')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_hold_time_get(self, port_channel=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'owner'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.arp', u'unicast_request')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_owner_get(self, port_channel=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.owner', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_owner_priority_get(self, port_channel=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.owner', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_owner_track_priority_get(self, port_channel=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.owner', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_preempt_mode_get(self, port_channel=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'owner'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.arp', u'unicast_request')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_priority_get(self, port_channel=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'owner'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.arp', u'unicast_request')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_track_get(self, port_channel=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.track', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.track', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.track', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_track_interface_get(self, port_channel=None, vrrp=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.track.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.track.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_track_interface_priority_get(self, port_channel=None, vrrp=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.track.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.track.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.track.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_use_v2_checksum_get(self, port_channel=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.port_channel', u'port_channel')]
    bindings_list = [('pybind.nos.v7_2_0.interface.port_channel.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.port_channel.vrrp.track', u'interface'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.arp', u'unicast_request')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_port_channel_vrrp_group_virtual_ip_get(self, port_channel=None, vrrp=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.interface.port_channel', u'port_channel'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.port_channel', u'port_channel'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.port_channel', u'port_channel'), ('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp'), ('pybind.slxos.v17s_1_02.interface.port_channel', u'port_channel'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.port_channel.hide_vrrp_holer.vrrp.virtual_ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.port_channel.vrrp.virtual_ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface.port_channel.hide_vrrp_holer.vrrp.virtual_ip', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.port_channel.hide_vrrp_holer.vrrp.virtual_ip', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.port_channel.hide_vrrp_holer.vrrp.virtual_ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel=port_channel, vrrp=vrrp, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel=port_channel, vrrp=vrrp, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_routing_system_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.interface', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.interface', u've')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'id, shutdown'}, {'leafval': 'name, shutdown'}, {'leafval': 'name, shutdown'}, {'leafval': 'id, shutdown'}, {'leafval': 'id, shutdown'}, {'leafval': 'name, shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state', u'interface_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'if_name, if_index, in_pkts, in_unicast_pkts, in_broadcast_pkts, in_multicast_pkts, in_pkts_per_second, in_bandwidth, in_octets, in_errors, in_crc_errors, in_discards, out_pkts, out_unicast_pkts, out_broadcast_pkts, out_multicast_pkts, out_pkts_per_second, out_bandwidth, out_octets, out_errors, out_crc_errors, out_discards'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_if_index_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_if_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_in_bandwidth_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_in_broadcast_pkts_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_in_crc_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_in_discards_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_in_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_in_multicast_pkts_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_in_octets_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_in_pkts_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_in_pkts_per_second_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_in_unicast_pkts_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_out_bandwidth_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_out_broadcast_pkts_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_out_crc_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_out_discards_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_out_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_out_multicast_pkts_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_out_octets_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_out_pkts_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_out_pkts_per_second_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_interface_counters_out_unicast_pkts_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state.interface_counters', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_statistics_state_profile_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state', 'pybind.slxos.v17r_1_01a.brocade_interface_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface_statistics_state', u'interface_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'if_name, if_index, in_pkts, in_unicast_pkts, in_broadcast_pkts, in_multicast_pkts, in_pkts_per_second, in_bandwidth, in_octets, in_errors, in_crc_errors, in_discards, out_pkts, out_unicast_pkts, out_broadcast_pkts, out_multicast_pkts, out_pkts_per_second, out_bandwidth, out_octets, out_errors, out_crc_errors, out_discards'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'udld')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hop_by_hop_trap'}, {'leafval': 'basic'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'groupid, vlan'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'in_, out'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'add_, remove_'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'vepa_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'route_map_name'}, {'leafval': 'trust'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'raguard'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'root'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'sg_addr'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'id, cost, priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'logical_instance_id'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'promiscuous, host'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'oui'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'gateway'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'mtu'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'disable'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'forwarding'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'basic'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'promiscuous, host'}, {'leafval': 'multinet_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'red_tc_value'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'route_map_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'oui'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'logical_instance_id'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'learn_any'}, {'leafval': 'expire'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'mtu'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'channel'}, {'leafval': 'max_interval, min_'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'in_, out'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'disable'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'forwarding'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vepa_enable'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'raguard'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'attempts, time'}, {'leafval': 'root'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sg_addr'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'log, mode'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'sticky_flag'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'protected_port_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'accessvlan'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'bfd_enable'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'enable, direction'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_bfd_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_bfd_interval_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_bfd_interval_min_rx_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_bfd_interval_min_tx_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_bfd_interval_multiplier_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bfd.interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_bfd_shutdown_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_bpdu_drop_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bpdu_drop', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable, direction'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_bpdu_drop_direction_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bpdu_drop', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_bpdu_drop_enable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.bpdu_drop', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bpdu_drop', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_cee_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'udld')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hop_by_hop_trap'}, {'leafval': 'basic'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'groupid, vlan'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'in_, out'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'add_, remove_'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'vepa_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'route_map_name'}, {'leafval': 'trust'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'raguard'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'root'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'sg_addr'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'id, cost, priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'logical_instance_id'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'promiscuous, host'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'oui'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'gateway'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'mtu'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'disable'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'forwarding'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'basic'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'promiscuous, host'}, {'leafval': 'multinet_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'red_tc_value'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'route_map_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'oui'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'logical_instance_id'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'learn_any'}, {'leafval': 'expire'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'mtu'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'channel'}, {'leafval': 'max_interval, min_'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'in_, out'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'disable'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'forwarding'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vepa_enable'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'raguard'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'attempts, time'}, {'leafval': 'root'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sg_addr'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'log, mode'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'sticky_flag'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'protected_port_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'accessvlan'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'bfd_enable'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'enable, direction'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_channel_group_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.channel_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.channel_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'port_int, mode, type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_channel_group_mode_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.channel_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.channel_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_channel_group_port_int_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.channel_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.channel_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_channel_group_type_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.channel_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.channel_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_description_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'udld')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hop_by_hop_trap'}, {'leafval': 'basic'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'groupid, vlan'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'in_, out'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'add_, remove_'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'vepa_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'route_map_name'}, {'leafval': 'trust'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'raguard'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'root'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'sg_addr'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'id, cost, priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'logical_instance_id'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'promiscuous, host'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'oui'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'gateway'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'mtu'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'disable'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'forwarding'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'basic'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'promiscuous, host'}, {'leafval': 'multinet_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'red_tc_value'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'route_map_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'oui'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'logical_instance_id'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'learn_any'}, {'leafval': 'expire'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'mtu'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'channel'}, {'leafval': 'max_interval, min_'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'in_, out'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'disable'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'forwarding'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vepa_enable'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'raguard'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'attempts, time'}, {'leafval': 'root'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sg_addr'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'log, mode'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'sticky_flag'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'protected_port_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'accessvlan'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'bfd_enable'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'enable, direction'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_deviceconnectivity_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.connectivity', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.connectivity', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x": {"reauthMax": "reauthMax", "port_control": "port_control", "quiet_period": "quiet_period", "authentication": "authentication", "reauthentication": "reauthentication", "protocol_version": "protocol_version"}, "pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_authentication_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_mac_auth_bypass_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_mac_auth_enable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_port_control_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_protocol_version_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_quiet_period_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_reauthentication_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_reauthmax_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_timeout_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_timeout_re_authperiod_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_timeout_server_timeout_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_timeout_supp_timeout_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_dot1x_timeout_tx_period_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x.timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_edge_loop_detection_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_edge_loop_detection_port_priority_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_edge_loop_detection_vlan_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_fabric_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_fabric_dport_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric.fabric_dport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric.fabric_dport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric.fabric_dport": {"fabric_dport_enable": "fabric_dport_enable"}, "pybind.nos.v7_2_0.interface.tengigabitethernet.fabric.fabric_dport": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_fabric_dport_enable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric.fabric_dport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_fabric_dport_mode_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric.fabric_dport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_fabric_isl_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric.fabric_isl', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric.fabric_isl', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_fabric_isl_enable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric.fabric_isl', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric.fabric_isl', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_fabric_neighbor_discovery_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_fabric_neighbor_discovery_disable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric.neighbor_discovery', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_fabric_trunk_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric.fabric_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric.fabric_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_fabric_trunk_enable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric.fabric_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric.fabric_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_fcoeport_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.fcoeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fcoeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'fcoeport_map, ns_ip_registration'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_fcoeport_map_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.fcoeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fcoeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_fcoeport_ns_ip_registration_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.fcoeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fcoeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ifindex_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'udld')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hop_by_hop_trap'}, {'leafval': 'basic'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'groupid, vlan'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'in_, out'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'add_, remove_'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'vepa_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'route_map_name'}, {'leafval': 'trust'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'raguard'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'root'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'sg_addr'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'id, cost, priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'logical_instance_id'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'promiscuous, host'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'oui'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'gateway'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'mtu'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'disable'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'forwarding'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'basic'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'promiscuous, host'}, {'leafval': 'multinet_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'red_tc_value'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'route_map_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'oui'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'logical_instance_id'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'learn_any'}, {'leafval': 'expire'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'mtu'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'channel'}, {'leafval': 'max_interval, min_'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'in_, out'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'disable'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'forwarding'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vepa_enable'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'raguard'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'attempts, time'}, {'leafval': 'root'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sg_addr'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'log, mode'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'sticky_flag'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'protected_port_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'accessvlan'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'bfd_enable'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'enable, direction'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_access_group_get(self, tengigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': 'ip_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_access_group_traffic_type_get(self, tengigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_acl_interface.ip.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_acl_interface_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_acl_interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_acl_interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_address_get(self, tengigabitethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary, ospf_passive, ospf_ignore
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: **address** tuple argument:  ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: **address** tuple argument:  ospf active address on the specific interface

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_address_ospf_ignore_get(self, tengigabitethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_address_ospf_passive_get(self, tengigabitethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_address_secondary_get(self, tengigabitethernet=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_arp_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.arp_node_config.arp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.arp_node_config.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_arp_aging_timeout_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_arp_inspection_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_arp_inspection_trust_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.arp_node_config.arp.inspection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_arp_ip_config_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_arp_learn_any_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_arp_node_config_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.arp_node_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.arp_node_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_dhcp_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_dhcp_relay_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_dhcp_relay_gateway_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_dhcp_relay_servers_get(self, tengigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  A.B.C.D;; IP address of the DHCP server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCP server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr, server_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_directed_broadcast_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_icmp_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_icmp_address_mask_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_icmp_echo_reply_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_icmp_rate_limiting_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_icmp_redirect_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_icmp_unreachable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.icmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp": {}, "pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp": {"immediate_leave": "immediate_leave", "last_member_query_interval": "last_member_query_interval", "query_interval": "query_interval", "query_max_response_time": "query_max_response_time"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_immediate_leave_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_last_member_query_count_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_last_member_query_interval_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_phy_intf_cfg_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_query_interval_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_query_max_response_time_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_robustness_variable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_startup_query_count_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_startup_query_interval_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_igmp_static_group_get(self, tengigabitethernet=None, static_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type static_group: sg_addr
    :param static_group: Keyword argument tuple.

    :type sg_addr: unicode
    :param sg_addr: **static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp.static_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'sg_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, static_group=static_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_interface_te_dhcp_conf_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_interface_te_ospf_conf_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ip_acl_interface_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_acl_interface.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_acl_interface.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ip_config_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ip_pbr_interface_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_pbr_interface.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_pbr_interface.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_mtu_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_multicast_boundary_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_active_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_area_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_auth_change_wait_time_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_authentication_key_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_authentication_key_auth_key_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_authentication_key_auth_key_table_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_authentication_key_encrypttype_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_authentication_key_no_encrypt_auth_key_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_authentication_key_no_encrypt_auth_key_table_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_bfd_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_bfd_intf_bfd_enable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_cost_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_database_filter_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_database_filter_all_external_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_database_filter_all_out_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_database_filter_all_summary_external_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_dead_interval_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_hello_interval_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_md5_authentication_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_md5_authentication_key_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_md5_authentication_key_activation_wait_time_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_md5_authentication_key_id_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_md5_authentication_key_id_key_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_md5_authentication_key_id_key_id_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_md5_authentication_key_id_md5_authentication_key_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_md5_authentication_no_encrypt_key_table_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_encrypt_key_id, no_encrypt_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_mtu_ignore_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_network_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_passive_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_priority_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_retransmit_interval_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_ospf_transmit_delay_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_pbr_interface_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_pbr_interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_pbr_interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_pim_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_pim_dr_priority_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_pim_int_cmd_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_pim_intf_phy_cont_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_pim_multinet_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_pim_multinet_enable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_pim_neighbor_filter_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_pim_sparse_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_policy_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_pbr_interface.ip.policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_policy_route_map_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_policy_route_map_route_map_name_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_proxy_arp_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_unnumbered_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ip_donor_interface_type, ip_donor_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_unnumbered_ip_donor_interface_name_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ip_unnumbered_ip_donor_interface_type_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config.unnumbered', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_access_group_get(self, tengigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': 'ipv6_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_access_group_traffic_type_get(self, tengigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_ipv6_address_get(self, tengigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_ipv6_address_anycast_get(self, tengigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_ipv6_address_eui_64_get(self, tengigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_ipv6_address_secondary_get(self, tengigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_ipv6_address_secondary_eui_config_get(self, tengigabitethernet=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_link_local_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_link_local_address_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_link_local_config_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_address_use_link_local_only_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_dhcp_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_dhcp_relay_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_dhcp_relay_servers_get(self, tengigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_dhcp_relay_servers_interface_get(self, tengigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_dhcp_relay_servers_interface_interface_get(self, tengigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_dhcp_relay_servers_interface_interface_name_get(self, tengigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_dhcp_relay_servers_use_vrf_get(self, tengigabitethernet=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay.servers', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_hop_by_hop_trap_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_icmpv6_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_icmpv6_echo_reply_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_icmpv6_rate_limiting_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_icmpv6_redirect_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_icmpv6_unreachable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_interface_phy_dhcp_conf_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ipv6_config_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ipv6_intf_cmds_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ipv6_nd_ra_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ipv6_phy_intf_cmds_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_phy_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_mtu_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd": {}, "pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd": {"managed_config_flag": "managed_config_flag", "broadcast_mac_trap": "broadcast_mac_trap", "ra_lifetime": "ra_lifetime", "hoplimit": "hoplimit", "mtu": "mtu", "retrans_timer": "retrans_timer", "other_config_flag": "other_config_flag", "ns_interval": "ns_interval", "reachable_time": "reachable_time", "proxy": "proxy"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_broadcast_mac_trap_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_cache_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'expire'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_cache_expire_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_dad_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_dad_attempts_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_dad_time_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_hoplimit_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_managed_config_flag_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_mtu_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_ns_interval_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_nud_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_nud_retry_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'base, interval, max_attempts'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_nud_retry_base_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_nud_retry_interval_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_nud_retry_max_attempts_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_other_config_flag_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_get(self, tengigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_advertise, valid_lifetime, valid_infinite'}, {'leafval': 'no_autoconfig, no_onlink, off_link'}, {'leafval': 'preferred_lifetime, preferred_infinite'}, {'leafval': 'no_advertise, valid_lifetime, valid_infinite'}, {'leafval': 'no_autoconfig, no_onlink, off_link'}, {'leafval': 'preferred_lifetime, preferred_infinite'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_infinite_get(self, tengigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_infinite_preferred_get(self, tengigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_no_advertise_get(self, tengigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_no_autoconfig_get(self, tengigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_no_onlink_get(self, tengigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_off_link_get(self, tengigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_preferred_get(self, tengigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'preferred_lifetime, preferred_infinite'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_preferred_lifetime_get(self, tengigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_prefix_flags_get(self, tengigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_autoconfig, no_onlink, off_link'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_prefix_valid_lifetime_get(self, tengigabitethernet=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_proxy_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_ra_interval_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_interval, min_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_ra_interval_max_interval_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_ra_interval_min_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_ra_lifetime_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_reachable_time_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_retrans_timer_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_set_cache_expire_time_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_set_hoplimit_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_suppress_ra_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_suppress_ra_all_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_suppress_ra_mtu_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_nd_suppress_ra_suppress_ra_flag_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_neighbor_get(self, tengigabitethernet=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_neighbor_hardware_address_get(self, tengigabitethernet=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_active_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_area_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_ah_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_esp_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_esp_auth_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_esp_key_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_esp_no_encrypt_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_ipsec_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_ipsec_auth_key_config_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_ipsec_disable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_ipsec_key_add_remove_interval_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_key_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_no_encrypt_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_authentication_spi_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_bfd_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_bfd_bfd_enable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_cost_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_dead_interval_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_hello_interval_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_hello_jitter_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_instance_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_link_interval_properties_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_mtu_ignore_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_network_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_passive_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_priority_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_retransmit_interval_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_suppress_linklsa_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_ospf_transmit_delay_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_policy_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_policy_route_map_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.policy.route_map', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_policy_route_map_ipv6_route_map_name_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.policy.route_map', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.policy.route_map', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_raguard_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_get(self, tengigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_advertise_backup_get(self, tengigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_advertisement_interval_get(self, tengigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_advertisement_interval_scale_get(self, tengigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_backup_advertisement_interval_get(self, tengigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_description_get(self, tengigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_enable_get(self, tengigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_hold_time_get(self, tengigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_nd_advertisement_timer_get(self, tengigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_preempt_mode_get(self, tengigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_priority_get(self, tengigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'virtual_ip'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_get(self, tengigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_basic_get(self, tengigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_short_path_forwarding_revert_priority_get(self, tengigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_track_get(self, tengigabitethernet=None, vrrpv3e_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_track_interface_get(self, tengigabitethernet=None, vrrpv3e_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_track_interface_priority_get(self, tengigabitethernet=None, vrrpv3e_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_extended_group_virtual_ip_get(self, tengigabitethernet=None, vrrpv3e_group=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3e_group: vrid
    :param vrrpv3e_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group', u'vrrpv3e_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3e_group.virtual_ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3e_group=vrrpv3e_group, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_get(self, tengigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_advertisement_interval_get(self, tengigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_description_get(self, tengigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_enable_get(self, tengigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_hold_time_get(self, tengigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_preempt_mode_get(self, tengigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_priority_get(self, tengigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_track_get(self, tengigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_track_interface_get(self, tengigabitethernet=None, vrrpv3_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_track_interface_priority_get(self, tengigabitethernet=None, vrrpv3_group=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_use_v2_checksum_get(self, tengigabitethernet=None, vrrpv3_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3_group', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_group_virtual_ip_get(self, tengigabitethernet=None, vrrpv3_group=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrpv3_group: vrid
    :param vrrpv3_group: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3_group** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group', u'vrrpv3_group')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.vrrpv3_group.virtual_ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrpv3_group=vrrpv3_group, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_ipv6_vrrp_suppress_interface_ra_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_lacp_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.lacp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lacp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_lacp_default_up_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.lacp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lacp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_lacp_port_priority_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.lacp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lacp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_lacp_timeout_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.lacp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lacp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_lldp_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_lldp_cee_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp.cee', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp.cee', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_lldp_cee_lldp_cee_on_off_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp.cee', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp.cee', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_lldp_dcbx_version_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_lldp_disable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_lldp_iscsi_priority_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_lldp_profile_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_log_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.rpf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_long_distance_isl_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'udld')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hop_by_hop_trap'}, {'leafval': 'basic'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'groupid, vlan'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'in_, out'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'add_, remove_'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'vepa_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'route_map_name'}, {'leafval': 'trust'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'raguard'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'root'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'sg_addr'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'id, cost, priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'logical_instance_id'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'promiscuous, host'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'oui'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'gateway'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'mtu'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'disable'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'forwarding'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'basic'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'promiscuous, host'}, {'leafval': 'multinet_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'red_tc_value'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'route_map_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'oui'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'logical_instance_id'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'learn_any'}, {'leafval': 'expire'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'mtu'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'channel'}, {'leafval': 'max_interval, min_'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'in_, out'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'disable'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'forwarding'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vepa_enable'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'raguard'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'attempts, time'}, {'leafval': 'root'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sg_addr'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'log, mode'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'sticky_flag'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'protected_port_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'accessvlan'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'bfd_enable'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'enable, direction'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_mac_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_mac_access_group_get(self, tengigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': 'mac_access_list, mac_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_mac_access_group_traffic_type_get(self, tengigabitethernet=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_mac_learning_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac_learning', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac_learning', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_mac_learning_disable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac_learning.mac_learn_disable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_mac_learning_disable_vlan_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_mac_learning_disable_vlan_add_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_mac_learning_disable_vlan_remove_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac_learning.mac_learn_disable.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_mtu_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'udld')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hop_by_hop_trap'}, {'leafval': 'basic'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'groupid, vlan'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'in_, out'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'add_, remove_'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'vepa_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'route_map_name'}, {'leafval': 'trust'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'raguard'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'root'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'sg_addr'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'id, cost, priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'logical_instance_id'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'promiscuous, host'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'oui'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'gateway'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'mtu'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'disable'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'forwarding'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'basic'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'promiscuous, host'}, {'leafval': 'multinet_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'red_tc_value'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'route_map_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'oui'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'logical_instance_id'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'learn_any'}, {'leafval': 'expire'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'mtu'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'channel'}, {'leafval': 'max_interval, min_'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'in_, out'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'disable'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'forwarding'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vepa_enable'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'raguard'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'attempts, time'}, {'leafval': 'root'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sg_addr'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'log, mode'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'sticky_flag'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'protected_port_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'accessvlan'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'bfd_enable'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'enable, direction'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_openflow_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.openflow_interface_cfg', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.openflow_interface_cfg', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_openflow_enable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_openflow_logical_instance_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.openflow_interface_cfg', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.openflow_interface_cfg', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_openflow_match_profile_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_openflow_openflow_enable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.openflow_interface_cfg.openflow_enable', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable, match_profile'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_port_profile_port_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'udld')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hop_by_hop_trap'}, {'leafval': 'basic'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'groupid, vlan'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'in_, out'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'add_, remove_'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'vepa_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'route_map_name'}, {'leafval': 'trust'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'raguard'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'root'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'sg_addr'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'id, cost, priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'logical_instance_id'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'promiscuous, host'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'oui'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'gateway'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'mtu'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'disable'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'forwarding'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'basic'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'promiscuous, host'}, {'leafval': 'multinet_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'red_tc_value'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'route_map_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'oui'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'logical_instance_id'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'learn_any'}, {'leafval': 'expire'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'mtu'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'channel'}, {'leafval': 'max_interval, min_'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'in_, out'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'disable'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'forwarding'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vepa_enable'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'raguard'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'attempts, time'}, {'leafval': 'root'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sg_addr'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'log, mode'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'sticky_flag'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'protected_port_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'accessvlan'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'bfd_enable'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'enable, direction'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_port_profile_port_domain_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_port_profile_port_domain_profile_domain_name_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_domain_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_port_profile_port_profile_get(self, tengigabitethernet=None, port_to_port_profile_associations=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_to_port_profile_associations: port_to_port_profile_association
    :param port_to_port_profile_associations: Keyword argument tuple.

    :type port_to_port_profile_association: unicode
    :param port_to_port_profile_association: **port_to_port_profile_associations** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port.port_to_port_profile_associations', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_to_port_profile_associations', 'keyval': 'port_to_port_profile_association', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, port_to_port_profile_associations=port_to_port_profile_associations)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, port_to_port_profile_associations=port_to_port_profile_associations)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_port_profile_to_interface_associations_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_priority_tag_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'udld')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hop_by_hop_trap'}, {'leafval': 'basic'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'groupid, vlan'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'in_, out'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'add_, remove_'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'vepa_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'route_map_name'}, {'leafval': 'trust'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'raguard'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'root'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'sg_addr'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'id, cost, priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'logical_instance_id'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'promiscuous, host'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'oui'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'gateway'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'mtu'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'disable'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'forwarding'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'basic'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'promiscuous, host'}, {'leafval': 'multinet_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'red_tc_value'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'route_map_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'oui'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'logical_instance_id'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'learn_any'}, {'leafval': 'expire'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'mtu'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'channel'}, {'leafval': 'max_interval, min_'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'in_, out'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'disable'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'forwarding'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vepa_enable'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'raguard'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'attempts, time'}, {'leafval': 'root'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sg_addr'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'log, mode'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'sticky_flag'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'protected_port_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'accessvlan'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'bfd_enable'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'enable, direction'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_protected_port_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.protected_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_protected_port_enable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.protected_port', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_cos_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_cos_mutation_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_cos_traffic_class_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_drop_monitor_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.drop_monitor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.drop_monitor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_drop_monitor_enable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.drop_monitor', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.drop_monitor', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_dscp_cos_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_dscp_mutation_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_dscp_traffic_class_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_ecn_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.ecn', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_flowcontrol_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_flowcontrol_link_level_flowcontrol_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_flowcontrol_pfc_get(self, tengigabitethernet=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_flowcontrol_pfc_rx_get(self, tengigabitethernet=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_flowcontrol_pfc_tx_get(self, tengigabitethernet=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  0-7;;CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol.pfc', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_flowcontrol_rx_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_flowcontrol_tx_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol.link_level_flowcontrol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_random_detect_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.random_detect', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.ecn.random_detect', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_random_detect_2_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.random_detect', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_random_detect_ecn_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.ecn.random_detect.random_detect_ecn', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_random_detect_ecn_traffic_class_get(self, tengigabitethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: int
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.ecn.random_detect.random_detect_ecn.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_random_detect_traffic_class_get(self, tengigabitethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_random_detect_traffic_class_apply_get(self, tengigabitethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_random_detect_traffic_class_red_profile_id_get(self, tengigabitethernet=None, traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type traffic_class: red_tc_value
    :param traffic_class: Keyword argument tuple.

    :type red_tc_value: long
    :param red_tc_value: **traffic_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.random_detect.traffic_class', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class', 'keyval': 'red_tc_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, traffic_class=traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, traffic_class=traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_cos0_threshold_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_cos1_threshold_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_cos2_threshold_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_cos3_threshold_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_cos4_threshold_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_cos5_threshold_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_cos6_threshold_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_rcv_queue_cos_threshold_cos7_threshold_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue.cos_threshold', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_trust_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.trust', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.trust', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_trust_cos_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.trust', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.trust', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_qos_trust_dscp_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.trust', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.trust', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_rmon_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_rmon_collection_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_rmon_collection_history_get(self, tengigabitethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_buckets_requested: long
    :param history_control_buckets_requested: **history_control_entry** tuple argument:  Buckets (default 50)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_interval: long
    :param history_control_interval: **history_control_entry** tuple argument:  Polling Interval (default 1800)

        * range restriction: ::

            ['-2147483648..2147483647']

    :type history_control_owner: unicode
    :param history_control_owner: **history_control_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_rmon_collection_history_buckets_get(self, tengigabitethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_rmon_collection_history_interval_get(self, tengigabitethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_rmon_collection_history_owner_get(self, tengigabitethernet=None, history_control_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type history_control_entry: history_control_index
    :param history_control_entry: Keyword argument tuple.

    :type history_control_index: long
    :param history_control_index: **history_control_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection.history_control_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'history_control_entry', 'keyval': 'history_control_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, history_control_entry=history_control_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, history_control_entry=history_control_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_rmon_collection_stats_get(self, tengigabitethernet=None, ether_stats_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index, ether_stats_owner
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type ether_stats_owner: unicode
    :param ether_stats_owner: **ether_stats_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': 'ether_stats_index, ether_stats_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ether_stats_entry=ether_stats_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ether_stats_entry=ether_stats_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_rmon_collection_stats_owner_get(self, tengigabitethernet=None, ether_stats_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ether_stats_entry: ether_stats_index
    :param ether_stats_entry: Keyword argument tuple.

    :type ether_stats_index: long
    :param ether_stats_index: **ether_stats_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection.ether_stats_entry', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ether_stats_entry', 'keyval': 'ether_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ether_stats_entry=ether_stats_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ether_stats_entry=ether_stats_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_rpf_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.rpf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_rpf_mode_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.rpf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_service_policy_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.service_policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.service_policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_service_policy_in_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.service_policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.service_policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_service_policy_out_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.service_policy', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.service_policy', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_sflow_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.sflow', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.sflow', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_sflow_enable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.sflow', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.sflow', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_sflow_polling_interval_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.sflow', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.sflow', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_sflow_sample_rate_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.sflow', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.sflow', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_shutdown_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'udld')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hop_by_hop_trap'}, {'leafval': 'basic'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'groupid, vlan'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'in_, out'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'add_, remove_'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'vepa_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'route_map_name'}, {'leafval': 'trust'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'raguard'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'root'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'sg_addr'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'id, cost, priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'logical_instance_id'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'promiscuous, host'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'oui'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'gateway'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'mtu'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'disable'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'forwarding'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'basic'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'promiscuous, host'}, {'leafval': 'multinet_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'red_tc_value'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'route_map_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'oui'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'logical_instance_id'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'learn_any'}, {'leafval': 'expire'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'mtu'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'channel'}, {'leafval': 'max_interval, min_'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'in_, out'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'disable'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'forwarding'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vepa_enable'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'raguard'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'attempts, time'}, {'leafval': 'root'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sg_addr'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'log, mode'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'sticky_flag'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'protected_port_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'accessvlan'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'bfd_enable'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'enable, direction'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_snmp_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.snmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.snmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_snmp_trap_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.snmp.trap', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.snmp.trap', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_snmp_trap_link_status_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.snmp.trap', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.snmp.trap', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_autoedge_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_bpdu_mac_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_cost_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_edgeport_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_edgeport_bpdu_filter_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_edgeport_bpdu_guard_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_edgeport_edgeportbasic_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.edgeport', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_guard_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_guard_root_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_hello_time_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_instance_get(self, tengigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_instance_cost_get(self, tengigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_instance_priority_get(self, tengigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_instance_restricted_role_get(self, tengigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_instance_restricted_tcn_get(self, tengigabitethernet=None, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_link_type_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_portfast_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_portfast_bpdu_filter_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_portfast_bpdu_guard_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_portfast_portfastbasic_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.portfast', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_priority_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_restricted_role_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_restricted_tcn_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_shutdown_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_vlan_get(self, tengigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.vlan', u'guard'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_vlan_cost_get(self, tengigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.vlan', u'guard'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_vlan_guard_get(self, tengigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_vlan_guard_root_get(self, tengigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.vlan.guard', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_spanning_tree_vlan_priority_get(self, tengigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree.vlan', u'guard'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree.vlan', u'guard')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'root'}, {'leafval': 'root'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_speed_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'qos'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'track'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'udld'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.lldp', u'cee'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'switchport_basic'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_associations'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'trust'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'spanning_tree'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode', u'private_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.storm_control', u'ingress'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.bfd', u'interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.ecn.random_detect.random_detect_ecn', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.random_detect', u'traffic_class'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'edge_loop_detection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.association', u'trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'allowed_ouis'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'portfast'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'openflow_interface_cfg'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'instance'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'ether_stats_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'edgeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'dot1x'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access', u'rspan_access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tunnel'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.tunable_optics', u'sfpp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'channel_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'service_policy'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'neighbor_discovery'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'mapping'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_isl'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vlan.classifier.activate', u'group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'interface'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vepa'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos', u'drop_monitor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_dport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'sflow'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_phy_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'ipv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_xtagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.spanning_tree', u'guard'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'rpf'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'ip_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', u'sticky'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac_learning.mac_learn_disable', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.snmp', u'trap'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'mode'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'connectivity'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'protected_port'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security.sticky', u'port_secutiry_mac_address'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'access'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.dot1x', u'timeout'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'qos'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip', u'icmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.rcv_queue', u'cos_threshold'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.pim_intf_phy_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'native'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'fcoeport'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'vrrp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bpdu_drop'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport', u'port_security'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.port_profile_to_interface_associations.port_profile_port', u'port_to_port_profile_domain_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', u'remove'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'bfd'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'track'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.ip_config', u'unnumbered'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.mac', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.rmon.collection', u'history_control_entry'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lacp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.openflow_interface_cfg', u'openflow_enable'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'vrrpv3e_group'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.arp_node_config.arp', u'inspection'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', u'pvlan_tag'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan', u'private_vlan_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'lldp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.qos.flowcontrol', u'link_level_flowcontrol'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', u'host_association'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'native_vlan_untagged_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', u'rspan_vlan'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.igmp_phy_intf_cfg', u'igmp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ip.interface_te_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.ipv6', u'ipv6_phy_intf_cmds'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', u'default_vlan_config'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.fabric', u'fabric_trunk'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'udld')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tengigabitethernet', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hop_by_hop_trap'}, {'leafval': 'basic'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'groupid, vlan'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'in_, out'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'add_, remove_'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vlan_mode'}, {'leafval': 'vepa_enable'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'route_map_name'}, {'leafval': 'trust'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'raguard'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'profile_domain_name'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'root'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'sg_addr'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'accessvlan'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'enable, direction'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'id, cost, priority'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'logical_instance_id'}, {'leafval': 'use_link_local_only'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'promiscuous, host'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'fabric_dport_enable'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'bfd_enable'}, {'leafval': 'attempts, time'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'oui'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'gateway'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'mtu'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'sticky_flag'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'disable'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'forwarding'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'expire'}, {'leafval': 'udld_enable'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'lldp_cee_on_off'}, {'leafval': 'basic'}, {'leafval': 'port_to_port_profile_association'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'id, cost, priority'}, {'leafval': 'trust_cos, trust_dscp'}, {'leafval': 'autoedge, cost, hello_time, bpdu_mac, link_type, priority, restricted_role, restricted_tcn, shutdown'}, {'leafval': 'promiscuous, host'}, {'leafval': 'multinet_enable'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pvlan_all, pvlan_none, pvlan_add, pvlan_except, pvlan_remove'}, {'leafval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'red_tc_value'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'red_tc_value, red_enable, red_profile_id'}, {'leafval': 'route_map_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'eldprio, eldvlan'}, {'leafval': 'trunk_pri_pvlan, trunk_sec_pvlan'}, {'leafval': 'oui'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'portfastbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'logical_instance_id'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'learn_any'}, {'leafval': 'expire'}, {'leafval': 'id, cost, priority, restricted_role, restricted_tcn'}, {'leafval': 'ether_stats_index, ether_stats_owner'}, {'leafval': 'mtu'}, {'leafval': 'edgeportbasic, bpdu_guard, bpdu_filter'}, {'leafval': 'authentication, port_control, protocol_version, quiet_period, reauthMax, reauthentication, mac_auth_bypass, mac_auth_enable'}, {'leafval': 'rspan_access_vlan'}, {'leafval': 'tagged_ieee_bpdu'}, {'leafval': 'channel'}, {'leafval': 'max_interval, min_'}, {'leafval': 'port_int, mode, type'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'in_, out'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'disable'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}, {'leafval': 'fabric_isl_enable'}, {'leafval': 'forwarding'}, {'leafval': 'groupid, vlan'}, {'leafval': 'track_interface_type, track_interface_name'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vepa_enable'}, {'leafval': 'drop_monitor_enable'}, {'leafval': 'add_, remove_'}, {'leafval': 'fabric_dport_mode'}, {'leafval': 'pfc_cos, pfc_flowcontrol_tx, pfc_flowcontrol_rx'}, {'leafval': 'enable, polling_interval, sample_rate'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'use_link_local_only'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'raguard'}, {'leafval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'attempts, time'}, {'leafval': 'root'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sg_addr'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'log, mode'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'sticky_flag'}, {'leafval': 'mac_learning_vlan_add, mac_learning_vlan_remove'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'vlan_mode'}, {'leafval': 'deviceconnectivity'}, {'leafval': 'protected_port_enable'}, {'leafval': 'mac_address, port_sec_vlan'}, {'leafval': 'accessvlan'}, {'leafval': 're_authperiod, server_timeout, supp_timeout, tx_period'}, {'leafval': 'default_cos, cos_mutation, cos_traffic_class, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'cos0_threshold, cos1_threshold, cos2_threshold, cos3_threshold, cos4_threshold, cos5_threshold, cos6_threshold, cos7_threshold'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}, {'leafval': 'fcoeport_map, ns_ip_registration'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'bfd_enable'}, {'leafval': 'gateway'}, {'leafval': 'remove_all_track_interfaces'}, {'leafval': 'enable, direction'}, {'leafval': 'port_sec_max, port_sec_violation, shutdown_time'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'profile_domain_name'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'track_enable, min_link'}, {'leafval': 'ip_donor_interface_type, ip_donor_interface_name'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'trunk_vlan_id, trunk_ctag_range'}, {'leafval': 'history_control_index, history_control_buckets_requested, history_control_interval, history_control_owner'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'timeout, std_port_priority, default_up'}, {'leafval': 'enable, match_profile'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'trust'}, {'leafval': 'pvlan_tag_native_vlan'}, {'leafval': 'trunk_basic, trunk_promiscuous, trunk_host'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'dcbx_version, disable, iscsi_priority, profile'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'flowcontrol_tx, flowcontrol_rx'}, {'leafval': 'host_pri_pvlan, host_sec_pvlan'}, {'leafval': 'native_vlan_id_untagged'}, {'leafval': 'add_rspan_trunk_vlan, remove_rspan_trunk_vlan'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable, immediate_leave'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'default_transparent_vlan'}, {'leafval': 'fabric_trunk_enable'}, {'leafval': 'udld_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_storm_control_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.storm_control', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.storm_control', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_storm_control_ingress_get(self, tengigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type, rate_format, rate_bps, rate_percent, bum_action
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type rate_format: unicode
    :param rate_format: **ingress** tuple argument.

        * enumeration restriction: ::

            ['limit-bps', 'limit-percent']

    :type rate_bps: long
    :param rate_bps: **ingress** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type rate_percent: long
    :param rate_percent: **ingress** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bum_action: unicode
    :param bum_action: **ingress** tuple argument.

        * enumeration restriction: ::

            ['monitor', 'shutdown']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': 'protocol_type, rate_format, rate_bps, rate_percent, bum_action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_storm_control_ingress_bum_action_get(self, tengigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_storm_control_ingress_rate_bps_get(self, tengigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_storm_control_ingress_rate_format_get(self, tengigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_storm_control_ingress_rate_percent_get(self, tengigabitethernet=None, ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type ingress: protocol_type
    :param ingress: Keyword argument tuple.

    :type protocol_type: unicode
    :param protocol_type: **ingress** tuple argument.

        * enumeration restriction: ::

            ['broadcast', 'unknown-unicast', 'multicast']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.storm_control.ingress', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ingress', 'keyval': 'protocol_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, ingress=ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, ingress=ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport_basic', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport_basic', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_access_mac_group_rspan_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_access_mac_group_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_access_mac_rspan_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_access_mac_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_mac_group_rspan_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_mac_group_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_mac_rspan_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_mac_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_rspan_access_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access.rspan_access', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access.rspan_access', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_rspan_vlan_get(self, tengigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_rspan_vlan_access_mac_rspan_vlan_classification_get(self, tengigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_rspan_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_vlan_get(self, tengigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_access_vlan_access_mac_vlan_classification_get(self, tengigabitethernet=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_basic_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport_basic', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport_basic', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_private_vlan_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_private_vlan_host_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_private_vlan_promiscuous_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_private_vlan_trunk_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_private_vlan_trunk_host_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_private_vlan_trunk_promiscuous_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_private_vlan_trunk_trunk_basic_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode.private_vlan.private_vlan_trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_mode_vlan_mode_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.mode', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.mode', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_allowed_ouis_get(self, tengigabitethernet=None, allowed_ouis=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type allowed_ouis: oui
    :param allowed_ouis: Keyword argument tuple.

    :type oui: unicode
    :param oui: **allowed_ouis** tuple argument:  <OUI> OUI in HHHH.HH00.0000 format

        * pattern restriction: ::

            '[0-9a-fA-F]{4}\.[0-9a-fA-F]{2}00\.0000'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security.allowed_ouis', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'allowed_ouis', 'keyval': 'oui', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, allowed_ouis=allowed_ouis)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, allowed_ouis=allowed_ouis)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_max_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_port_secutiry_mac_address_get(self, tengigabitethernet=None, port_secutiry_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security.port_secutiry_mac_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_shutdown_time_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_sticky_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security.sticky', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_sticky_port_secutiry_mac_address_get(self, tengigabitethernet=None, port_secutiry_mac_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type port_secutiry_mac_address: mac_address, port_sec_vlan
    :param port_secutiry_mac_address: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **port_secutiry_mac_address** tuple argument:  Mac Address

    :type port_sec_vlan: long
    :param port_sec_vlan: **port_secutiry_mac_address** tuple argument:  Forwarding vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security.sticky.port_secutiry_mac_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_secutiry_mac_address', 'keyval': 'mac_address, port_sec_vlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, port_secutiry_mac_address=port_secutiry_mac_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_sticky_sticky_flag_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security.sticky', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security.sticky', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_port_security_violation_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.port_security', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_association_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_association_trunk_get(self, tengigabitethernet=None, trunk=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type trunk: trunk_pri_pvlan, trunk_sec_pvlan
    :param trunk: Keyword argument tuple.

    :type trunk_pri_pvlan: long
    :param trunk_pri_pvlan: **trunk** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type trunk_sec_pvlan: long
    :param trunk_sec_pvlan: **trunk** tuple argument:  Secondary vlan id 

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.association.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'trunk', 'keyval': 'trunk_pri_pvlan, trunk_sec_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, trunk=trunk)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, trunk=trunk)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_host_association_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'host_pri_pvlan, host_sec_pvlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_host_association_host_pri_pvlan_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_host_association_host_sec_pvlan_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.host_association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_mapping_get(self, tengigabitethernet=None, mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan, oper, promis_sec_pvlan_range
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type oper: unicode
    :param oper: **mapping** tuple argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type promis_sec_pvlan_range: unicode
    :param promis_sec_pvlan_range: **mapping** tuple argument:  Secondary vlan range

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(([1-9][0-9]{0,2})|([1-7][0-9]{3})|(80[0-9]{2})|'
            '(81[0-8][0-9])|(819[01]))(-(([2-9])|([1-9][0-9]{'
            '1,2})|([1-7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9]'
            ')|(819[01])))?((,(([2-9])|([1-9][0-9]{1,2})|([1-'
            '7][0-9]{3})|(80[0-9]{2})|(81[0-8][0-9])|(819[01]'
            '))(-(([3-9])|([1-9][0-9]{1,2})|([1-7][0-9]{3})|('
            '80[0-9]{2})|(81[0-8][0-9])|(819[01])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': 'promis_pri_pvlan, oper, promis_sec_pvlan_range'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, mapping=mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_mapping_oper_get(self, tengigabitethernet=None, mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, mapping=mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_mapping_promis_sec_pvlan_range_get(self, tengigabitethernet=None, mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type mapping: promis_pri_pvlan
    :param mapping: Keyword argument tuple.

    :type promis_pri_pvlan: long
    :param promis_pri_pvlan: **mapping** tuple argument:  Primary vlan id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.mapping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mapping', 'keyval': 'promis_pri_pvlan', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, mapping=mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, mapping=mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_trunk_private_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_vlan_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_vlan_add_get(self, tengigabitethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_vlan_all_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_vlan_except_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_vlan_none_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_vlan_remove_get(self, tengigabitethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_allowed_vlan_trunk_private_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_native_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'pvlanNativevlan, pvlan_native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_native_ctag_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_native_vlan_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.native', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_private_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_tag_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_tag_native_vlan_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.private_vlan.trunk.pvlan_tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_private_vlan_trunk_trunk_private_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification.private_vlan.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_rspan_vlan_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.rspan_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_rspan_vlan_add_get(self, tengigabitethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_rspan_vlan_remove_get(self, tengigabitethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_rspan_vlan_trunk_rspan_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification.rspan_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_trunk_rspan_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.trunk_rspan_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_trunk_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_add_get(self, tengigabitethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_add_ctag_get(self, tengigabitethernet=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_all_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_except_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_none_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_remove_get(self, tengigabitethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_remove_ctag_get(self, tengigabitethernet=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlan_trunk_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlanoper_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlanoper_vlan_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlanoper_vlan_add_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_allowed_vlanoper_vlan_remove_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.allowed.vlanoper.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_ctag_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_ctag_native_vlan_xtagged_config_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_default_vlan_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_default_vlan_config_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.default_vlan_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_transparent_vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_egress_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_native_vlan_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_native_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id, native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_native_vlan_untagged_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_native_vlan_untagged_config_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.native_vlan_untagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_untagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_native_vlan_xtagged_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_native_vlan_xtagged_config_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.native_vlan_xtagged_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id_xtagged, native_vlan_ctag_id_xtagged, native_vlan_egress_type_xtagged'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_private_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk_private_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_tag_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_tag_native_vlan_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.tag', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.tag', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_switchport_trunk_trunk_vlan_classification_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_track_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_track_enable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_track_interface_get(self, tengigabitethernet=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type interface: track_interface_type, track_interface_name
    :param interface: Keyword argument tuple.

    :type track_interface_type: unicode
    :param track_interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type track_interface_name: unicode
    :param track_interface_name: **interface** tuple argument:  Interface name

        * pattern restriction: ::

            '(((([1-9]|[1-9][0-9]|1[0-9]{2}|2[0-3][0-9])/)?(('
            '[0-9]|1[0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]'
            ')(:[1-4])?)|([1-9]|[1-9][0-9]|[1-9][0-9]{2}|[1-5'
            '][0-9]{3}|6[0-1][0-4]{2}))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'track_interface_type, track_interface_name', 'extra_keyval': 'track_interface_type, track_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_track_min_link_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_track_remove_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.track.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_track_remove_all_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.track.remove_', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.track.remove_', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_tunable_optics_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.tunable_optics', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_tunable_optics_sfpp_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.tunable_optics.sfpp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_tunable_optics_sfpp_channel_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.tunable_optics.sfpp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_tunnel_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.tunnel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.tunnel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_tunnel_tagged_ieee_bpdu_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.tunnel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.tunnel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_udld_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.udld', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.udld', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_udld_enable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.udld', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.udld', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vepa_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vepa', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vepa', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vepa_enable_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vepa', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vepa', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vlan_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vlan_classifier_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vlan.classifier', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vlan.classifier', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vlan_classifier_activate_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vlan.classifier.activate', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vlan.classifier.activate', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vlan_classifier_activate_group_get(self, tengigabitethernet=None, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type group: groupid, vlan
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vlan: long
    :param vlan: **group** tuple argument:  1-8191;;Vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': 'groupid, vlan'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vlan_classifier_activate_group_vlan_get(self, tengigabitethernet=None, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type group: groupid
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vlan.classifier.activate.group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrf_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrf_forwarding_get(self, tengigabitethernet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrf', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_get(self, tengigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_advertisement_interval_get(self, tengigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_arp_get(self, tengigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.arp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_arp_unicast_request_get(self, tengigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_arp_unicast_request_receive_get(self, tengigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.arp.unicast_request', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_description_get(self, tengigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_enable_get(self, tengigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_hold_time_get(self, tengigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_preempt_mode_get(self, tengigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_priority_get(self, tengigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_track_get(self, tengigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.track', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.track', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_track_interface_get(self, tengigabitethernet=None, vrrp=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_track_interface_priority_get(self, tengigabitethernet=None, vrrp=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.track.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.track.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_use_v2_checksum_get(self, tengigabitethernet=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tengigabitethernet_vrrp_group_virtual_ip_get(self, tengigabitethernet=None, vrrp=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tengigabitethernet: name
    :param tengigabitethernet: Keyword argument tuple.

    :type name: unicode
    :param name: **tengigabitethernet** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address in dotted decimal

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.interface.tengigabitethernet', u'tengigabitethernet'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.interface.tengigabitethernet.vrrp.virtual_ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface.tengigabitethernet.vrrp.virtual_ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tengigabitethernet=tengigabitethernet, vrrp=vrrp, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'mode'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'gre_source'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'keepalive'), ('pybind.slxos.v17s_1_02.interface.tunnel.mode', u'gre'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'gre_source'), ('pybind.slxos.v17r_1_01a.interface.tunnel.mode', u'gre'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'mode'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'keepalive'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'mode'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'gre_source'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'keepalive'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_2_00.interface.tunnel.mode', u'gre')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel', 'keyval': 'identifier', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'vxlan'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'ip'}, {'leafval': 'router_ve'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'ip'}, {'leafval': 'vxlan'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'router_ve'}, {'leafval': 'vxlan'}, {'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'router_ve'}, {'leafval': 'ip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_destination_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'mode'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'gre_source'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'keepalive'), ('pybind.slxos.v17s_1_02.interface.tunnel.mode', u'gre'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'gre_source'), ('pybind.slxos.v17r_1_01a.interface.tunnel.mode', u'gre'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'mode'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'keepalive'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'mode'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'gre_source'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'keepalive'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_2_00.interface.tunnel.mode', u'gre')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel', 'keyval': 'identifier', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'vxlan'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'ip'}, {'leafval': 'router_ve'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'ip'}, {'leafval': 'vxlan'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'router_ve'}, {'leafval': 'vxlan'}, {'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'router_ve'}, {'leafval': 'ip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_dscp_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'mode'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'gre_source'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'keepalive'), ('pybind.slxos.v17s_1_02.interface.tunnel.mode', u'gre'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'gre_source'), ('pybind.slxos.v17r_1_01a.interface.tunnel.mode', u'gre'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'mode'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'keepalive'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'mode'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'gre_source'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'keepalive'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_2_00.interface.tunnel.mode', u'gre')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel', 'keyval': 'identifier', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'vxlan'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'ip'}, {'leafval': 'router_ve'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'ip'}, {'leafval': 'vxlan'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'router_ve'}, {'leafval': 'vxlan'}, {'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'router_ve'}, {'leafval': 'ip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_dscp_ttl_mode_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'mode'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'gre_source'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'keepalive'), ('pybind.slxos.v17s_1_02.interface.tunnel.mode', u'gre'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'gre_source'), ('pybind.slxos.v17r_1_01a.interface.tunnel.mode', u'gre'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'mode'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'keepalive'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'mode'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'gre_source'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'keepalive'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_2_00.interface.tunnel.mode', u'gre')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel', 'keyval': 'identifier', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'vxlan'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'ip'}, {'leafval': 'router_ve'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'ip'}, {'leafval': 'vxlan'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'router_ve'}, {'leafval': 'vxlan'}, {'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'router_ve'}, {'leafval': 'ip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_keepalive_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.keepalive', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.keepalive', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.keepalive', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_keepalive_retry_count_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.keepalive', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.keepalive', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.keepalive', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_keepalive_time_interval_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.keepalive', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.keepalive', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.keepalive', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_map_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.tunnel_map', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.tunnel_map', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.tunnel_map', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.interface.tunnel.tunnel_map': [u'map_bd', u'map_vlan'], 'pybind.slxos.v17r_2_00.interface.tunnel.tunnel_map': [u'map_bd', u'map_vlan'], 'pybind.slxos.v17r_1_01a.interface.tunnel.tunnel_map': [u'map_bd', u'map_vlan']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_map_bd_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.tunnel_map', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.tunnel_map', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.tunnel_map', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_map_vlan_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.tunnel_map', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.tunnel_map', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.tunnel_map', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_map_vni_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.tunnel_map', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.tunnel_map', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.tunnel_map', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_mode_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.mode', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.mode', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.mode', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_mode_gre_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.mode.gre', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.mode.gre', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.mode.gre', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_mode_gre_ip_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.mode.gre', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.mode.gre', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.mode.gre', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_mode_vxlan_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.mode', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.mode', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.mode', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_name_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'mode'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'gre_source'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'keepalive'), ('pybind.slxos.v17s_1_02.interface.tunnel.mode', u'gre'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'gre_source'), ('pybind.slxos.v17r_1_01a.interface.tunnel.mode', u'gre'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'mode'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'keepalive'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'mode'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'gre_source'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'keepalive'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_2_00.interface.tunnel.mode', u'gre')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel', 'keyval': 'identifier', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'vxlan'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'ip'}, {'leafval': 'router_ve'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'ip'}, {'leafval': 'vxlan'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'router_ve'}, {'leafval': 'vxlan'}, {'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'router_ve'}, {'leafval': 'ip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_router_interface_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.tunnel_router_interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.tunnel_router_interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.tunnel_router_interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_router_interface_ve_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.tunnel_router_interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.tunnel_router_interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.tunnel_router_interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_shutdown_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'mode'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'gre_source'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'keepalive'), ('pybind.slxos.v17s_1_02.interface.tunnel.mode', u'gre'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'gre_source'), ('pybind.slxos.v17r_1_01a.interface.tunnel.mode', u'gre'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'mode'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'keepalive'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'mode'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'gre_source'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'keepalive'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_2_00.interface.tunnel.mode', u'gre')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel', 'keyval': 'identifier', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'vxlan'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'ip'}, {'leafval': 'router_ve'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'ip'}, {'leafval': 'vxlan'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'router_ve'}, {'leafval': 'vxlan'}, {'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'router_ve'}, {'leafval': 'ip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_source_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.gre_source', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.gre_source', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.gre_source', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.interface.tunnel.gre_source': [u'source_address', u'interface_ethernet', u'interface_loopback', u'interface_ve'], 'pybind.slxos.v17s_1_02.interface.tunnel.gre_source': [u'source_address', u'interface_ethernet', u'interface_loopback', u'interface_ve'], 'pybind.slxos.v17r_1_01a.interface.tunnel.gre_source': [u'source_address', u'interface_ethernet', u'interface_loopback', u'interface_ve']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_source_ethernet_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.gre_source', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.gre_source', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.gre_source', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_source_loopback_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.gre_source', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.gre_source', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.gre_source', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_source_source_address_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.gre_source', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.gre_source', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.gre_source', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_source_ve_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel.gre_source', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel.gre_source', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel.gre_source', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}, {'keyval': 'identifier', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_statistics_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'mode'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'gre_source'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'keepalive'), ('pybind.slxos.v17s_1_02.interface.tunnel.mode', u'gre'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'gre_source'), ('pybind.slxos.v17r_1_01a.interface.tunnel.mode', u'gre'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'mode'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'keepalive'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'mode'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'gre_source'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'keepalive'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_2_00.interface.tunnel.mode', u'gre')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel', 'keyval': 'identifier', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'vxlan'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'ip'}, {'leafval': 'router_ve'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'ip'}, {'leafval': 'vxlan'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'router_ve'}, {'leafval': 'vxlan'}, {'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'router_ve'}, {'leafval': 'ip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_tunnel_ttl_get(self, tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tunnel: identifier
    :param tunnel: Keyword argument tuple.

    :type identifier: long
    :param identifier: **tunnel** tuple argument:  Identifier value range 1 to 1024

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface.tunnel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface.tunnel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface.tunnel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'mode'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'gre_source'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'keepalive'), ('pybind.slxos.v17s_1_02.interface.tunnel.mode', u'gre'), ('pybind.slxos.v17s_1_02.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'gre_source'), ('pybind.slxos.v17r_1_01a.interface.tunnel.mode', u'gre'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'mode'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'keepalive'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17r_1_01a.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'mode'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel_map'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'gre_source'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'keepalive'), ('pybind.slxos.v17r_2_00.interface.tunnel', u'tunnel_router_interface'), ('pybind.slxos.v17r_2_00.interface.tunnel.mode', u'gre')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel', 'keyval': 'identifier', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'vxlan'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'ip'}, {'leafval': 'router_ve'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'ip'}, {'leafval': 'vxlan'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'router_ve'}, {'leafval': 'vxlan'}, {'leafval': 'map_vlan, map_bd, map_vni'}, {'leafval': 'source_address, interface_loopback, interface_ethernet, interface_ve'}, {'leafval': 'time_interval, retry_count'}, {'leafval': 'router_ve'}, {'leafval': 'ip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel=tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel=tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip', u'ip_anycast_gateway'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve.attach', u'rbridge_id'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6', u'ipv6_anycast_gateway'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip', u'icmp'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf', u'ospf1'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'ipv6_ve_intf_cmds'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip', u'icmp_plus'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'ipv6_anycast_address'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.policy', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u'rpf_mode'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type', u'md5_auth'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u'vrf'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip', u'ip_local_anycast_gateway'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'icmpv6'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u'vrrp'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u'vrrpe'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip', u'igmp'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.pim_intf_vlan_cont', u'pim_int_cmd'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'vrrpv3'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip', u'ip_anycast_address'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type', u'md5_auth'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis', u'interface_isis'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.igmp', u've_igmpl3_static_group'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u'qos'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', u'interface_metric'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip', u'ip_anycast_gateway'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6', u'ipv6_anycast_gateway'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.attach', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', u'icmpv6'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', u'ipv6_ve_intf_cmds'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip', u'igmp'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type', u'md5_auth'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u'vrrpe'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type', u'md5_auth'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u'vrf'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip', u'icmp_plus'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u'vrrp'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip', u'icmp'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip', u'ip_config'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u'qos'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.igmp', u've_igmpl3_static_group'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u'rpf'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.pim_intf_vlan_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip', u'igmp'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.igmp', u've_igmpl3_static_group'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u'vrrpe'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip', u'icmp'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u'vrf'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip', u'icmp_plus'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type', u'md5_auth'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'vrrpv3'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'ipv6_ve_intf_cmds'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u'rpf'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.pim_intf_vlan_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u'qos'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'ipv6_anycast_address'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip', u'ip_config'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type', u'md5_auth'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip', u'ip_anycast_address'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u'vrrp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u've', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_gw_id, ipv4_gateway_address, hold_time, load_balancing_disable, enable, description'}, {'leafval': 'rb_add, rb_remove'}, {'leafval': 'ipv6_gw_id, hold_time, load_balancing_disable, enable, description'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'mtu'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'echo_reply, unreachable, address_mask'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'route_map_name'}, {'leafval': 'ipv6_address'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'expire'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'local_ipv6_gw_id, enable_local, disable_local'}, {'leafval': 'mode'}, {'leafval': 'auth_data'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'forwarding'}, {'leafval': 'local_ip_gw_id, enable_local, disable_local'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'learn_any'}, {'leafval': 'bfd_enable'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'use_link_local_only'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'attempts, time'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'ip_address'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'gateway'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'address_suppress_all'}, {'leafval': 'auth_data'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'dscp_cos, dscp_mutation, dscp_traffic_class'}, {'leafval': 'interface_bfd_disable'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'ip_gw_id, ipv4_gateway_address, hold_time, load_balancing_disable, enable, description'}, {'leafval': 'ipv6_gw_id, hold_time, load_balancing_disable, enable, description'}, {'leafval': 'rb_add, rb_remove'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'local_ipv6_gw_id, enable_local, disable_local'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'use_link_local_only'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'rate_limiting'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'gateway'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'address_suppress_all'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'auth_data'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'route_map_name'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'auth_data'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'forwarding'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'echo_reply, unreachable, address_mask'}, {'leafval': 'mtu'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'bfd_enable'}, {'leafval': 'local_ip_gw_id, enable_local, disable_local'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'attempts, time'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'max_interval, min_'}, {'leafval': 'rate_limiting'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'dscp_cos, dscp_mutation, dscp_traffic_class'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'expire'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'log, mode'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vrid, virtual_mac, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'use_link_local_only'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'gateway'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'address_suppress_all'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'bfd_enable'}, {'leafval': 'key_chain'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'rate_limiting'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'route_map_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'forwarding'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'echo_reply, unreachable, address_mask'}, {'leafval': 'attempts, time'}, {'leafval': 'rate_limiting'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'expire'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'auth_data'}, {'leafval': 'vrid, virtual_mac, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'learn_any'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'key_chain'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'local_ipv6_gw_id, enable_local, disable_local'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_ip_gw_id, enable_local, disable_local'}, {'leafval': 'log, mode'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'dscp_cos, dscp_mutation, dscp_traffic_class'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'ipv6_address'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'auth_data'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'ip_address'}, {'leafval': 'mtu'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}]
    leafval_map = {"pybind.nos.v7_2_0.interface_vlan.interface.ve": {"global_ve_shutdown": "global_ve_shutdown", "gve_name": "gve_name"}, "pybind.slxos.v17s_1_02.routing_system.interface.ve": {"global_ve_shutdown": "shutdown", "gve_name": "name"}, "pybind.slxos.v17r_1_01a.routing_system.interface.ve": {"global_ve_shutdown": "shutdown", "gve_name": "name"}, "pybind.nos.v6_0_2f.interface_vlan.interface.ve": {"global_ve_shutdown": "global_ve_shutdown", "gve_name": "gve_name"}, "pybind.slxos.v17r_2_00.routing_system.interface.ve": {"global_ve_shutdown": "shutdown", "gve_name": "name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_attach_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.attach', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.attach', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_attach_rbridge_id_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.attach.rbridge_id', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.attach.rbridge_id', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_attach_rbridge_id_add_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.attach.rbridge_id', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.attach.rbridge_id', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_attach_rbridge_id_remove_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.attach.rbridge_id', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.attach.rbridge_id', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_bfd_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_bfd_interval_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_bfd_interval_min_rx_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_bfd_interval_min_tx_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_bfd_interval_multiplier_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_bfd_shutdown_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_access_group_get(self, ve=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip_acl_interface.ip.access_group', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip_acl_interface.ip.access_group', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip_acl_interface.ip.access_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': 'ip_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_access_group_traffic_type_get(self, ve=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip_acl_interface.ip.access_group', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip_acl_interface.ip.access_group', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip_acl_interface.ip.access_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_acl_interface_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip_acl_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip_acl_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip_acl_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_address_get(self, ve=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary, ospf_passive, ospf_ignore
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: **address** tuple argument:  ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: **address** tuple argument:  ospf active address on the specific interface

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_config.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_config.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_config.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_address_ospf_ignore_get(self, ve=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_config.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_config.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_config.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_address_ospf_passive_get(self, ve=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_config.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_config.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_config.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_address_secondary_get(self, ve=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_config.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_config.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_config.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_anycast_address_get(self, ve=None, ip_anycast_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_anycast_address: ip_address
    :param ip_anycast_address: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **ip_anycast_address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_anycast_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_anycast_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_anycast_address', 'keyval': 'ip_address', 'extra_keyval': 'ip_address'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_address=ip_anycast_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_address=ip_anycast_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_arp_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_config.arp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_config.arp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_arp_aging_timeout_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_arp_learn_any_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_config.arp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_config.arp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_dhcp_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_dhcp_relay_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_dhcp_relay_gateway_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_dhcp_relay_servers_get(self, ve=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  A.B.C.D;; IP address of the DHCP server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCP server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr, server_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_directed_broadcast_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_get(self, ve=None, ip_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_anycast_gateway: ip_gw_id
    :param ip_anycast_gateway: Keyword argument tuple.

    :type ip_gw_id: long
    :param ip_gw_id: **ip_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'next_hop'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'load_balancing'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'network'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'gratuitous_arp'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'load_balancing'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'next_hop'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'next_hop'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'load_balancing')]
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_local_anycast_gateway', 'keyval': 'local_ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gve_timer'}, {'leafval': 'next_hop_address, next_hop_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'interface_type, interface_name, interface_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'gve_timer'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, interface_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'next_hop_address, next_hop_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'next_hop_address, next_hop_priority'}, {'leafval': 'interface_type, interface_name, interface_priority'}, {'leafval': 'basic, threshold_priority'}]
    leafval_map = {"pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway": {"enable": "enable", "description": "description", "ipv4_gateway_address": "ipv4_gateway_address", "ip_gw_id": "ip_gw_id", "load_balancing_disable": "load_balancing_disable", "hold_time": "hold_time"}, "pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway": {"enable": "enable", "description": "description", "ipv4_gateway_address": "ipv4_gateway_address", "ip_gw_id": "ip_gw_id", "load_balancing_disable": "load_balancing_disable", "hold_time": "hold_time"}, "pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway": {}, "pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway": {}, "pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_description_get(self, ve=None, ip_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_anycast_gateway: ip_gw_id
    :param ip_anycast_gateway: Keyword argument tuple.

    :type ip_gw_id: long
    :param ip_gw_id: **ip_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'gratuitous_arp'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'gratuitous_arp')]
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_anycast_gateway', 'keyval': 'ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gve_timer'}, {'leafval': 'gve_timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_disable_get(self, ve=None, ip_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'next_hop'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'load_balancing'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'load_balancing'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'next_hop'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'next_hop'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'load_balancing')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_local_anycast_gateway', 'keyval': 'local_ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'next_hop_address, next_hop_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'interface_type, interface_name, interface_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, interface_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'next_hop_address, next_hop_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'next_hop_address, next_hop_priority'}, {'leafval': 'interface_type, interface_name, interface_priority'}, {'leafval': 'basic, threshold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_enable_get(self, ve=None, ip_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_anycast_gateway: ip_gw_id
    :param ip_anycast_gateway: Keyword argument tuple.

    :type ip_gw_id: long
    :param ip_gw_id: **ip_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'next_hop'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'load_balancing'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'network'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'gratuitous_arp'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'load_balancing'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'next_hop'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'next_hop'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'load_balancing')]
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_local_anycast_gateway', 'keyval': 'local_ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gve_timer'}, {'leafval': 'next_hop_address, next_hop_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'interface_type, interface_name, interface_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'gve_timer'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, interface_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'next_hop_address, next_hop_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'next_hop_address, next_hop_priority'}, {'leafval': 'interface_type, interface_name, interface_priority'}, {'leafval': 'basic, threshold_priority'}]
    leafval_map = {"pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway": {"ip_gw_id": "ip_gw_id", "enable": "enable"}, "pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway": {"ip_gw_id": "ip_gw_id", "enable": "enable"}, "pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway": {"ip_gw_id": "local_ip_gw_id", "enable": "enable_local"}, "pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway": {"ip_gw_id": "local_ip_gw_id", "enable": "enable_local"}, "pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway": {"ip_gw_id": "local_ip_gw_id", "enable": "enable_local"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_gateway_address_get(self, ve=None, ip_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_anycast_gateway: ip_gw_id
    :param ip_anycast_gateway: Keyword argument tuple.

    :type ip_gw_id: long
    :param ip_gw_id: **ip_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'gratuitous_arp'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'gratuitous_arp')]
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_anycast_gateway', 'keyval': 'ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gve_timer'}, {'leafval': 'gve_timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_gratuitous_arp_get(self, ve=None, ip_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_anycast_gateway: ip_gw_id
    :param ip_anycast_gateway: Keyword argument tuple.

    :type ip_gw_id: long
    :param ip_gw_id: **ip_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'ip_anycast_gateway'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'ip_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway.gratuitous_arp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway.gratuitous_arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ip_gw_id', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_gratuitous_arp_timer_get(self, ve=None, ip_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_anycast_gateway: ip_gw_id
    :param ip_anycast_gateway: Keyword argument tuple.

    :type ip_gw_id: long
    :param ip_gw_id: **ip_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'ip_anycast_gateway'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'ip_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway.gratuitous_arp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway.gratuitous_arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ip_gw_id', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_hold_time_get(self, ve=None, ip_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_anycast_gateway: ip_gw_id
    :param ip_anycast_gateway: Keyword argument tuple.

    :type ip_gw_id: long
    :param ip_gw_id: **ip_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'gratuitous_arp'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'gratuitous_arp')]
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_anycast_gateway', 'keyval': 'ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gve_timer'}, {'leafval': 'gve_timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_load_balancing_get(self, ve=None, ip_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_load_balancing_basic_get(self, ve=None, ip_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_load_balancing_disable_get(self, ve=None, ip_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_anycast_gateway: ip_gw_id
    :param ip_anycast_gateway: Keyword argument tuple.

    :type ip_gw_id: long
    :param ip_gw_id: **ip_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'gratuitous_arp'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip.ip_anycast_gateway', u'gratuitous_arp')]
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_anycast_gateway', 'keyval': 'ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gve_timer'}, {'leafval': 'gve_timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_anycast_gateway=ip_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_load_balancing_threshold_priority_get(self, ve=None, ip_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_track_get(self, ve=None, ip_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.track', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_track_interface_get(self, ve=None, ip_local_anycast_gateway=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_track_interface_priority_get(self, ve=None, ip_local_anycast_gateway=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_track_network_get(self, ve=None, ip_local_anycast_gateway=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_track_network_priority_get(self, ve=None, ip_local_anycast_gateway=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_track_next_hop_get(self, ve=None, ip_local_anycast_gateway=None, next_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type next_hop: next_hop_address
    :param next_hop: Keyword argument tuple.

    :type next_hop_address: unicode
    :param next_hop_address: **next_hop** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop', 'keyval': 'next_hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, next_hop=next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, next_hop=next_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_fabric_virtual_gateway_track_next_hop_priority_get(self, ve=None, ip_local_anycast_gateway=None, next_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type next_hop: next_hop_address
    :param next_hop: Keyword argument tuple.

    :type next_hop_address: unicode
    :param next_hop_address: **next_hop** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop', 'keyval': 'next_hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, next_hop=next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, next_hop=next_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_icmp_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.icmp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.icmp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.icmp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.icmp": {"rate_limiting": "rate_limiting"}, "pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.icmp": {}, "pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.icmp": {"rate_limiting": "rate_limiting"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_icmp_plus_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.icmp_plus', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.icmp_plus', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.icmp_plus', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_icmp_plus_address_mask_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.icmp_plus', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.icmp_plus', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.icmp_plus', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_icmp_plus_echo_reply_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.icmp_plus', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.icmp_plus', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.icmp_plus', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_icmp_plus_unreachable_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.icmp_plus', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.icmp_plus', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.icmp_plus', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_icmp_rate_limiting_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.icmp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.icmp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.icmp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_icmp_redirect_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.icmp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_igmp_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_igmp_immediate_leave_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_igmp_last_member_query_interval_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_igmp_query_interval_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_igmp_query_max_response_time_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_igmp_static_group_get(self, ve=None, ve_igmpl3_static_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ve_igmpl3_static_group: igmpl3_sg_addr
    :param ve_igmpl3_static_group: Keyword argument tuple.

    :type igmpl3_sg_addr: unicode
    :param igmpl3_sg_addr: **ve_igmpl3_static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.igmp.ve_igmpl3_static_group', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.igmp.ve_igmpl3_static_group', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.igmp.ve_igmpl3_static_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u've_igmpl3_static_group', 'keyval': 'igmpl3_sg_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ve_igmpl3_static_group=ve_igmpl3_static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ve_igmpl3_static_group=ve_igmpl3_static_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_igmp_version_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.igmp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_interface_ve_dhcp_conf_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_ve_dhcp_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_ve_dhcp_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_ve_dhcp_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_interface_vlan_ospf_conf_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_intf_router_isis_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.intf_router_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.intf_router_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.intf_router_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ip_acl_interface_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip_acl_interface.ip', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip_acl_interface.ip', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip_acl_interface.ip', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ip_config_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ip_pbr_interface_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip_pbr_interface.ip', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip_pbr_interface.ip', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip_pbr_interface.ip', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_mtu_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_multicast_boundary_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_active_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_area_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_auth_change_wait_time_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_authentication_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_authentication_key_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_authentication_key_auth_key_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_authentication_key_auth_key_table_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_authentication_key_chain_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_authentication_key_encrypttype_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.auth_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_authentication_key_no_encrypt_auth_key_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_authentication_key_no_encrypt_auth_key_table_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_bfd_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_bfd_intf_bfd_enable_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_cost_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_database_filter_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_database_filter_all_external_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_database_filter_all_out_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_database_filter_all_summary_external_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.database_filter', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_dead_interval_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_hello_interval_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_ldp_sync_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_md5_authentication_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_md5_authentication_key_activation_wait_time_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_md5_authentication_key_id_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'key_id, key, md5_authentication_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_md5_authentication_key_id_key_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_md5_authentication_key_id_key_id_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_md5_authentication_no_encrypt_key_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_md5_authentication_no_encrypt_key_id_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_md5_authentication_no_encrypt_key_table_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_encrypt_key_id, no_encrypt_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_mtu_ignore_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_network_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_passive_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_priority_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_retransmit_interval_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_ospf_transmit_delay_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_pbr_interface_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip_pbr_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip_pbr_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip_pbr_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_pim_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_pim_dr_priority_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_pim_int_cmd_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_pim_intf_vlan_cont_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.pim_intf_vlan_cont', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.pim_intf_vlan_cont', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.pim_intf_vlan_cont', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_pim_neighbor_filter_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_pim_sparse_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_pim_ttl_threshold_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_policy_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip_pbr_interface.ip.policy', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip_pbr_interface.ip.policy', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip_pbr_interface.ip.policy', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_policy_route_map_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_policy_route_map_route_map_name_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_proxy_arp_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_router_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_router_isis_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.intf_router_isis.int_router_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_vrrp_extended_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_vrrp_extended', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_vrrp_extended', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_vrrp_extended', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_vrrp_extended_auth_type_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_vrrp_extended_auth_type_md5_auth_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type.md5_auth', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type.md5_auth', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type.md5_auth', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ip_vrrp_extended_auth_type_md5_auth_auth_data_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type.md5_auth', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type.md5_auth', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type.md5_auth', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_access_group_get(self, ve=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.access_group', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.access_group', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.access_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': 'ipv6_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_access_group_traffic_type_get(self, ve=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.access_group', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.access_group', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.access_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_address_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_address_ipv6_address_get(self, ve=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_address_ipv6_address_anycast_get(self, ve=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_address_ipv6_address_eui_64_get(self, ve=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_address_ipv6_address_secondary_get(self, ve=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_address_ipv6_address_secondary_eui_config_get(self, ve=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_address_link_local_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_address_link_local_address_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_address_link_local_config_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_address_use_link_local_only_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_anycast_address_get(self, ve=None, ipv6_anycast_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_anycast_address: ipv6_address
    :param ipv6_anycast_address: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **ipv6_anycast_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_anycast_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_anycast_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_anycast_address', 'keyval': 'ipv6_address', 'extra_keyval': 'ipv6_address'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_address=ipv6_anycast_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_address=ipv6_anycast_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_dhcp_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_dhcp_relay_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_dhcp_relay_servers_get(self, ve=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_dhcp_relay_servers_interface_get(self, ve=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_dhcp_relay_servers_interface_interface_get(self, ve=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_dhcp_relay_servers_interface_interface_name_get(self, ve=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_dhcp_relay_servers_use_vrf_get(self, ve=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_get(self, ve=None, ipv6_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_anycast_gateway: ipv6_gw_id
    :param ipv6_anycast_gateway: Keyword argument tuple.

    :type ipv6_gw_id: long
    :param ipv6_gw_id: **ipv6_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_next_hop'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'load_balancing'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'load_balancing'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_next_hop'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_network'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_gateway_address'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_next_hop'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'load_balancing'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_interface'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_gateway_address'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'gratuitous_arp')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_anycast_gateway', 'keyval': 'ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_next_hop_address, ipv6_next_hop_priority'}, {'leafval': 'ipv6_interface_type, ipv6_interface_name, ipv6_interface_priority'}, {'leafval': 'ipv6_network_address, ipv6_network_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'ipv6_next_hop_address, ipv6_next_hop_priority'}, {'leafval': 'ipv6_interface_type, ipv6_interface_name, ipv6_interface_priority'}, {'leafval': 'ipv6_network_address, ipv6_network_priority'}, {'leafval': 'gve_timer'}, {'leafval': 'ipv6_gw_addr'}, {'leafval': 'ipv6_next_hop_address, ipv6_next_hop_priority'}, {'leafval': 'ipv6_network_address, ipv6_network_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'ipv6_interface_type, ipv6_interface_name, ipv6_interface_priority'}, {'leafval': 'ipv6_gw_addr'}, {'leafval': 'gve_timer'}]
    leafval_map = {"pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway": {"ipv6_gw_id": "ipv6_gw_id", "enable": "enable", "hold_time": "hold_time", "description": "description", "load_balancing_disable": "load_balancing_disable"}, "pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway": {"ipv6_gw_id": "ipv6_gw_id", "enable": "enable", "hold_time": "hold_time", "description": "description", "load_balancing_disable": "load_balancing_disable"}, "pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway": {}, "pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway": {}, "pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_description_get(self, ve=None, ipv6_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_anycast_gateway: ipv6_gw_id
    :param ipv6_anycast_gateway: Keyword argument tuple.

    :type ipv6_gw_id: long
    :param ipv6_gw_id: **ipv6_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_gateway_address'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_gateway_address'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'gratuitous_arp')]
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_anycast_gateway', 'keyval': 'ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gve_timer'}, {'leafval': 'ipv6_gw_addr'}, {'leafval': 'ipv6_gw_addr'}, {'leafval': 'gve_timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_disable_get(self, ve=None, ipv6_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_next_hop'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'load_balancing'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_next_hop'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'load_balancing'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'load_balancing'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_next_hop'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_network')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_local_anycast_gateway', 'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_next_hop_address, ipv6_next_hop_priority'}, {'leafval': 'ipv6_interface_type, ipv6_interface_name, ipv6_interface_priority'}, {'leafval': 'ipv6_network_address, ipv6_network_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'ipv6_next_hop_address, ipv6_next_hop_priority'}, {'leafval': 'ipv6_network_address, ipv6_network_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'ipv6_interface_type, ipv6_interface_name, ipv6_interface_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'ipv6_next_hop_address, ipv6_next_hop_priority'}, {'leafval': 'ipv6_interface_type, ipv6_interface_name, ipv6_interface_priority'}, {'leafval': 'ipv6_network_address, ipv6_network_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_enable_get(self, ve=None, ipv6_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_anycast_gateway: ipv6_gw_id
    :param ipv6_anycast_gateway: Keyword argument tuple.

    :type ipv6_gw_id: long
    :param ipv6_gw_id: **ipv6_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_next_hop'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'load_balancing'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'load_balancing'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_next_hop'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_network'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_gateway_address'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_next_hop'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'load_balancing'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_interface'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_gateway_address'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'gratuitous_arp')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_anycast_gateway', 'keyval': 'ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_next_hop_address, ipv6_next_hop_priority'}, {'leafval': 'ipv6_interface_type, ipv6_interface_name, ipv6_interface_priority'}, {'leafval': 'ipv6_network_address, ipv6_network_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'ipv6_next_hop_address, ipv6_next_hop_priority'}, {'leafval': 'ipv6_interface_type, ipv6_interface_name, ipv6_interface_priority'}, {'leafval': 'ipv6_network_address, ipv6_network_priority'}, {'leafval': 'gve_timer'}, {'leafval': 'ipv6_gw_addr'}, {'leafval': 'ipv6_next_hop_address, ipv6_next_hop_priority'}, {'leafval': 'ipv6_network_address, ipv6_network_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'ipv6_interface_type, ipv6_interface_name, ipv6_interface_priority'}, {'leafval': 'ipv6_gw_addr'}, {'leafval': 'gve_timer'}]
    leafval_map = {"pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway": {"ipv6_gw_id": "ipv6_gw_id", "enable": "enable"}, "pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway": {"ipv6_gw_id": "ipv6_gw_id", "enable": "enable"}, "pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway": {"ipv6_gw_id": "local_ipv6_gw_id", "enable": "enable_local"}, "pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway": {"ipv6_gw_id": "local_ipv6_gw_id", "enable": "enable_local"}, "pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway": {"ipv6_gw_id": "local_ipv6_gw_id", "enable": "enable_local"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_gateway_address_get(self, ve=None, ipv6_anycast_gateway=None, ipv6_gateway_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_anycast_gateway: ipv6_gw_id
    :param ipv6_anycast_gateway: Keyword argument tuple.

    :type ipv6_gw_id: long
    :param ipv6_gw_id: **ipv6_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_gateway_address: ipv6_gw_addr
    :param ipv6_gateway_address: Keyword argument tuple.

    :type ipv6_gw_addr: unicode
    :param ipv6_gw_addr: **ipv6_gateway_address** tuple argument:  IPv6 Address/Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_anycast_gateway'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway.ipv6_gateway_address', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway.ipv6_gateway_address', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_gateway_address', 'keyval': 'ipv6_gw_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway, ipv6_gateway_address=ipv6_gateway_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway, ipv6_gateway_address=ipv6_gateway_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_gratuitous_arp_get(self, ve=None, ipv6_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_anycast_gateway: ipv6_gw_id
    :param ipv6_anycast_gateway: Keyword argument tuple.

    :type ipv6_gw_id: long
    :param ipv6_gw_id: **ipv6_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_anycast_gateway'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway.gratuitous_arp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway.gratuitous_arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_gratuitous_arp_timer_get(self, ve=None, ipv6_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_anycast_gateway: ipv6_gw_id
    :param ipv6_anycast_gateway: Keyword argument tuple.

    :type ipv6_gw_id: long
    :param ipv6_gw_id: **ipv6_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_anycast_gateway'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway.gratuitous_arp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway.gratuitous_arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_hold_time_get(self, ve=None, ipv6_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_anycast_gateway: ipv6_gw_id
    :param ipv6_anycast_gateway: Keyword argument tuple.

    :type ipv6_gw_id: long
    :param ipv6_gw_id: **ipv6_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_gateway_address'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_gateway_address'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'gratuitous_arp')]
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_anycast_gateway', 'keyval': 'ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gve_timer'}, {'leafval': 'ipv6_gw_addr'}, {'leafval': 'ipv6_gw_addr'}, {'leafval': 'gve_timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_load_balancing_get(self, ve=None, ipv6_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_load_balancing_basic_get(self, ve=None, ipv6_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_load_balancing_disable_get(self, ve=None, ipv6_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_anycast_gateway: ipv6_gw_id
    :param ipv6_anycast_gateway: Keyword argument tuple.

    :type ipv6_gw_id: long
    :param ipv6_gw_id: **ipv6_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', u've'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_gateway_address'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'ipv6_gateway_address'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6.ipv6_anycast_gateway', u'gratuitous_arp')]
    compositions_keyval_list = [{'keyval': 'gve_name', 'extra_keyval': ''}, {'keyval': 'gve_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_anycast_gateway', 'keyval': 'ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'gve_timer'}, {'leafval': 'ipv6_gw_addr'}, {'leafval': 'ipv6_gw_addr'}, {'leafval': 'gve_timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_anycast_gateway=ipv6_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_load_balancing_threshold_priority_get(self, ve=None, ipv6_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_track_get(self, ve=None, ipv6_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_track_interface_get(self, ve=None, ipv6_local_anycast_gateway=None, ipv6_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_interface: ipv6_interface_type, ipv6_interface_name
    :param ipv6_interface: Keyword argument tuple.

    :type ipv6_interface_type: unicode
    :param ipv6_interface_type: **ipv6_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type ipv6_interface_name: unicode
    :param ipv6_interface_name: **ipv6_interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_interface', 'keyval': 'ipv6_interface_type, ipv6_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_interface=ipv6_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_interface=ipv6_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_track_interface_priority_get(self, ve=None, ipv6_local_anycast_gateway=None, ipv6_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_interface: ipv6_interface_type, ipv6_interface_name
    :param ipv6_interface: Keyword argument tuple.

    :type ipv6_interface_type: unicode
    :param ipv6_interface_type: **ipv6_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type ipv6_interface_name: unicode
    :param ipv6_interface_name: **ipv6_interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_interface', 'keyval': 'ipv6_interface_type, ipv6_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_interface=ipv6_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_interface=ipv6_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_track_network_get(self, ve=None, ipv6_local_anycast_gateway=None, ipv6_network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_network: ipv6_network_address
    :param ipv6_network: Keyword argument tuple.

    :type ipv6_network_address: unicode
    :param ipv6_network_address: **ipv6_network** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_network', 'keyval': 'ipv6_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_network=ipv6_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_network=ipv6_network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_track_network_priority_get(self, ve=None, ipv6_local_anycast_gateway=None, ipv6_network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_network: ipv6_network_address
    :param ipv6_network: Keyword argument tuple.

    :type ipv6_network_address: unicode
    :param ipv6_network_address: **ipv6_network** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_network', 'keyval': 'ipv6_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_network=ipv6_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_network=ipv6_network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_track_next_hop_get(self, ve=None, ipv6_local_anycast_gateway=None, ipv6_next_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_next_hop: ipv6_next_hop_address
    :param ipv6_next_hop: Keyword argument tuple.

    :type ipv6_next_hop_address: unicode
    :param ipv6_next_hop_address: **ipv6_next_hop** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_next_hop', 'keyval': 'ipv6_next_hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_next_hop=ipv6_next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_next_hop=ipv6_next_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_fabric_virtual_gateway_track_next_hop_priority_get(self, ve=None, ipv6_local_anycast_gateway=None, ipv6_next_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_next_hop: ipv6_next_hop_address
    :param ipv6_next_hop: Keyword argument tuple.

    :type ipv6_next_hop_address: unicode
    :param ipv6_next_hop_address: **ipv6_next_hop** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_next_hop', 'keyval': 'ipv6_next_hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_next_hop=ipv6_next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_next_hop=ipv6_next_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_hop_by_hop_trap_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_icmpv6_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.icmpv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.icmpv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.icmpv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.icmpv6": {"rate_limiting": "rate_limiting"}, "pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.icmpv6": {}, "pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.icmpv6": {"rate_limiting": "rate_limiting"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_icmpv6_rate_limiting_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.icmpv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.icmpv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.icmpv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_icmpv6_redirect_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.icmpv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_interface_ve_dhcp_conf_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_intf_ipv6_router_isis_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.intf_ipv6_router_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.intf_ipv6_router_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.intf_ipv6_router_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ipv6_config_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ipv6_intf_cmds_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ipv6_nd_ra_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ipv6_ve_intf_cmds_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_mtu_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_address_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_address_suppress_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_address_suppressing_address_get(self, ve=None, suppressing_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type suppressing_address: suppress_ipv6_address
    :param suppressing_address: Keyword argument tuple.

    :type suppress_ipv6_address: unicode
    :param suppress_ipv6_address: **suppressing_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address.suppressing_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address.suppressing_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address.suppressing_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'suppressing_address', 'keyval': 'suppress_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, suppressing_address=suppressing_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, suppressing_address=suppressing_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_address_suppressing_address_suppress_get(self, ve=None, suppressing_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type suppressing_address: suppress_ipv6_address
    :param suppressing_address: Keyword argument tuple.

    :type suppress_ipv6_address: unicode
    :param suppress_ipv6_address: **suppressing_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address.suppressing_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address.suppressing_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address.suppressing_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'suppressing_address', 'keyval': 'suppress_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, suppressing_address=suppressing_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, suppressing_address=suppressing_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_broadcast_mac_trap_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_cache_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'expire'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_cache_expire_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_dad_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_dad_attempts_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_dad_time_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_hoplimit_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_managed_config_flag_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_mtu_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_ns_interval_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_nud_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_nud_retry_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'base, interval, max_attempts'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_nud_retry_base_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_nud_retry_interval_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_nud_retry_max_attempts_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_other_config_flag_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_get(self, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_advertise, valid_lifetime, valid_infinite'}, {'leafval': 'preferred_lifetime, preferred_infinite'}, {'leafval': 'no_autoconfig, no_onlink, off_link'}, {'leafval': 'no_autoconfig, no_onlink, off_link'}, {'leafval': 'preferred_lifetime, preferred_infinite'}, {'leafval': 'no_advertise, valid_lifetime, valid_infinite'}, {'leafval': 'no_advertise, valid_lifetime, valid_infinite'}, {'leafval': 'no_autoconfig, no_onlink, off_link'}, {'leafval': 'preferred_lifetime, preferred_infinite'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_infinite_get(self, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_infinite_preferred_get(self, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_no_advertise_get(self, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_no_autoconfig_get(self, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_no_onlink_get(self, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_off_link_get(self, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_preferred_get(self, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'preferred_lifetime, preferred_infinite'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_preferred_lifetime_get(self, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_prefix_flags_get(self, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_autoconfig, no_onlink, off_link'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_prefix_valid_lifetime_get(self, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_proxy_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_ra_dns_server_get(self, ve=None, ra_dns_server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ra_dns_server: dns_server_prefix
    :param ra_dns_server: Keyword argument tuple.

    :type dns_server_prefix: unicode
    :param dns_server_prefix: **ra_dns_server** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_dns_server', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_dns_server', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_dns_server', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ra_dns_server', 'keyval': 'dns_server_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ra_dns_server=ra_dns_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ra_dns_server=ra_dns_server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_ra_dns_server_lifetime_multiplier_get(self, ve=None, ra_dns_server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ra_dns_server: dns_server_prefix
    :param ra_dns_server: Keyword argument tuple.

    :type dns_server_prefix: unicode
    :param dns_server_prefix: **ra_dns_server** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_dns_server', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_dns_server', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_dns_server', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ra_dns_server', 'keyval': 'dns_server_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ra_dns_server=ra_dns_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ra_dns_server=ra_dns_server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_ra_domain_name_get(self, ve=None, ra_domain_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ra_domain_name: domain_name_string
    :param ra_domain_name: Keyword argument tuple.

    :type domain_name_string: unicode
    :param domain_name_string: **ra_domain_name** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_domain_name', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_domain_name', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_domain_name', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ra_domain_name', 'keyval': 'domain_name_string', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ra_domain_name=ra_domain_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ra_domain_name=ra_domain_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_ra_domain_name_lifetime_multiplier_get(self, ve=None, ra_domain_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ra_domain_name: domain_name_string
    :param ra_domain_name: Keyword argument tuple.

    :type domain_name_string: unicode
    :param domain_name_string: **ra_domain_name** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_domain_name', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_domain_name', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_domain_name', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ra_domain_name', 'keyval': 'domain_name_string', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, ra_domain_name=ra_domain_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, ra_domain_name=ra_domain_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_ra_interval_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_interval, min_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_ra_interval_max_interval_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_ra_interval_min_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_ra_lifetime_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_reachable_time_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_retrans_timer_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_router_preference_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'router_pref_high, router_pref_low, router_pref_medium'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_router_preference_high_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_router_preference_low_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_router_preference_medium_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.router_preference', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_send_ra_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_suppress_ra_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_suppress_ra_all_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_suppress_ra_mtu_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_nd_suppress_ra_suppress_ra_flag_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_neighbor_get(self, ve=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_neighbor_hardware_address_get(self, ve=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_active_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_area_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication": {}, "pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication": {}, "pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication": {"key_chain": "key_chain"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_ah_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_esp_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_esp_auth_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_esp_key_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_esp_no_encrypt_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_ipsec_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_ipsec_auth_key_config_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_ipsec_disable_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_ipsec_key_add_remove_interval_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_key_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_key_chain_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_no_encrypt_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_authentication_spi_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_bfd_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_bfd_bfd_enable_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_cost_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_dead_interval_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_hello_interval_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_hello_jitter_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_instance_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_link_interval_properties_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_mtu_ignore_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_network_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_passive_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_priority_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_retransmit_interval_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_suppress_linklsa_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_ospf_transmit_delay_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_policy_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.policy', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.policy', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.policy', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_policy_route_map_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.policy.route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.policy.route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.policy.route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_policy_route_map_ipv6_route_map_name_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.policy.route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.policy.route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.policy.route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_router_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_router_isis_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.intf_ipv6_router_isis.int_ipv6_router_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_vrrp_extended', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_vrrp_extended', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_vrrp_extended', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_auth_type_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_auth_type_md5_auth_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type.md5_auth', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type.md5_auth', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type.md5_auth', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_auth_type_md5_auth_auth_data_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type.md5_auth', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type.md5_auth', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type.md5_auth', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'vmac'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e": {"enable": "enable", "description": "description", "nd_advertisement_timer": "nd_advertisement_timer", "advertisement_interval_scale": "advertisement_interval_scale", "vrid": "vrid", "advertise_backup": "advertise_backup", "virtual_mac": "virtual_mac", "priority": "priority", "vrrpe_advertisement_interval": "vrrpe_advertisement_interval", "hold_time": "hold_time", "preempt_mode": "preempt_mode", "backup_advertisement_interval": "backup_advertisement_interval"}, "pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e": {}, "pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e": {"enable": "enable", "description": "description", "nd_advertisement_timer": "nd_advertisement_timer", "advertisement_interval_scale": "advertisement_interval_scale", "vrid": "vrid", "advertise_backup": "advertise_backup", "virtual_mac": "virtual_mac", "priority": "priority", "vrrpe_advertisement_interval": "vrrpe_advertisement_interval", "hold_time": "hold_time", "preempt_mode": "preempt_mode", "backup_advertisement_interval": "backup_advertisement_interval"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_advertise_backup_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'vmac'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_advertisement_interval_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'vmac'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_advertisement_interval_scale_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'vmac'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_backup_advertisement_interval_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'vmac'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_description_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'vmac'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_enable_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'vmac'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_hold_time_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'vmac'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_nd_advertisement_timer_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'vmac'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_preempt_mode_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'vmac'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_priority_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'vmac'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_short_path_forwarding_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_short_path_forwarding_basic_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_short_path_forwarding_revert_priority_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_track_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_track_interface_get(self, ve=None, vrrpv3e=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_track_interface_priority_get(self, ve=None, vrrpv3e=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_track_network_get(self, ve=None, vrrpv3e=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  XXXX::YYYY/L;;IPv6 global address prefix in ipv6-address/Prefix length format

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_track_network_priority_get(self, ve=None, vrrpv3e=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  XXXX::YYYY/L;;IPv6 global address prefix in ipv6-address/Prefix length format

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_virtual_ip_get(self, ve=None, vrrpv3e=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.virtual_ip', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.virtual_ip', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.virtual_ip', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_virtual_mac_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_extended_group_virtual_mac_02e0_5200_00xx_get(self, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3e.virtual_mac', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_get(self, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'owner'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_advertisement_interval_get(self, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'owner'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_description_get(self, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'owner'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_enable_get(self, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'owner'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_hold_time_get(self, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'owner'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_owner_get(self, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3.owner', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_owner_priority_get(self, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3.owner', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_owner_track_priority_get(self, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3.owner', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_preempt_mode_get(self, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'owner'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_priority_get(self, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'owner'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_track_get(self, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3.track', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3.track', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3.track', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_track_interface_get(self, ve=None, vrrpv3=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_track_interface_priority_get(self, ve=None, vrrpv3=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_use_v2_checksum_get(self, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'owner'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_group_virtual_ip_get(self, ve=None, vrrpv3=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.vrrpv3.virtual_ip', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.vrrpv3.virtual_ip', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.vrrpv3.virtual_ip', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpv3=vrrpv3, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpv3=vrrpv3, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_ipv6_vrrp_suppress_interface_ra_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_auth_check_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.auth_check', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.auth_check', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.auth_check', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_auth_check_level_1_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_auth_check_level_1_disable_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.auth_check.auth_check_level1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_auth_check_level_2_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_auth_check_level_2_disable_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.auth_check.auth_check_level2', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_auth_key_get(self, ve=None, interface_auth_key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_auth_key: interface_auth_key_level, interface_auth_key_str
    :param interface_auth_key: Keyword argument tuple.

    :type interface_auth_key_level: unicode
    :param interface_auth_key_level: **interface_auth_key** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_auth_key_str: unicode
    :param interface_auth_key_str: **interface_auth_key** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_auth_key', 'keyval': 'interface_auth_key_level', 'extra_keyval': 'interface_auth_key_level, interface_auth_key_str'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_auth_key=interface_auth_key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_auth_key=interface_auth_key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_auth_key_interface_auth_key_str_get(self, ve=None, interface_auth_key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_auth_key: interface_auth_key_level
    :param interface_auth_key: Keyword argument tuple.

    :type interface_auth_key_level: unicode
    :param interface_auth_key_level: **interface_auth_key** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_key', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_auth_key', 'keyval': 'interface_auth_key_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_auth_key=interface_auth_key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_auth_key=interface_auth_key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_auth_mode_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_auth_mode_md5_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_auth_mode_md5_level_1_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_auth_mode_md5_level_2_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode.interface_md5', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_bfd_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_bfd": {}, "pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_bfd": {"interface_bfd_enable": "interface_bfd_enable"}, "pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_bfd": {"interface_bfd_enable": "interface_bfd_enable"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_bfd_disable_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_bfd_interface_bfd_enable_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_circuit_type_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_hello_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_hello', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_hello', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_hello', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_hello_interval_get(self, ve=None, interface_hello_interval=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_hello_interval: interface_hello_interval_level, interface_hello_interval_val
    :param interface_hello_interval: Keyword argument tuple.

    :type interface_hello_interval_level: unicode
    :param interface_hello_interval_level: **interface_hello_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_hello_interval_val: long
    :param interface_hello_interval_val: **interface_hello_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_interval', 'keyval': 'interface_hello_interval_level', 'extra_keyval': 'interface_hello_interval_level, interface_hello_interval_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_hello_interval=interface_hello_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_hello_interval=interface_hello_interval)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_hello_interval_interface_hello_interval_val_get(self, ve=None, interface_hello_interval=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_hello_interval: interface_hello_interval_level
    :param interface_hello_interval: Keyword argument tuple.

    :type interface_hello_interval_level: unicode
    :param interface_hello_interval_level: **interface_hello_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_hello_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_interval', 'keyval': 'interface_hello_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_hello_interval=interface_hello_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_hello_interval=interface_hello_interval)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_hello_multiplier_get(self, ve=None, interface_hello_multiplier=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_hello_multiplier: interface_hello_multiplier_level, interface_hello_multiplier_val
    :param interface_hello_multiplier: Keyword argument tuple.

    :type interface_hello_multiplier_level: unicode
    :param interface_hello_multiplier_level: **interface_hello_multiplier** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_hello_multiplier_val: long
    :param interface_hello_multiplier_val: **interface_hello_multiplier** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_multiplier', 'keyval': 'interface_hello_multiplier_level', 'extra_keyval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_hello_multiplier=interface_hello_multiplier)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_hello_multiplier=interface_hello_multiplier)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_hello_multiplier_interface_hello_multiplier_val_get(self, ve=None, interface_hello_multiplier=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_hello_multiplier: interface_hello_multiplier_level
    :param interface_hello_multiplier: Keyword argument tuple.

    :type interface_hello_multiplier_level: unicode
    :param interface_hello_multiplier_level: **interface_hello_multiplier** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_hello_multiplier', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_hello_multiplier', 'keyval': 'interface_hello_multiplier_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_hello_multiplier=interface_hello_multiplier)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_hello_multiplier=interface_hello_multiplier)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_hello_padding_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_hello_padding_disable_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_hello.interface_hello_padding', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_ipv6_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_ipv6_metric_get(self, ve=None, interface_ipv6_metric=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_ipv6_metric: interface_ipv6_metric_level, interface_ipv6_metric_val
    :param interface_ipv6_metric: Keyword argument tuple.

    :type interface_ipv6_metric_level: unicode
    :param interface_ipv6_metric_level: **interface_ipv6_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_ipv6_metric_val: long
    :param interface_ipv6_metric_val: **interface_ipv6_metric** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_ipv6_metric', 'keyval': 'interface_ipv6_metric_level', 'extra_keyval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_ipv6_metric=interface_ipv6_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_ipv6_metric=interface_ipv6_metric)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_ipv6_metric_interface_ipv6_metric_val_get(self, ve=None, interface_ipv6_metric=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_ipv6_metric: interface_ipv6_metric_level
    :param interface_ipv6_metric: Keyword argument tuple.

    :type interface_ipv6_metric_level: unicode
    :param interface_ipv6_metric_level: **interface_ipv6_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6.interface_ipv6_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_ipv6_metric', 'keyval': 'interface_ipv6_metric_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_ipv6_metric=interface_ipv6_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_ipv6_metric=interface_ipv6_metric)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_ldp_sync_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_metric_get(self, ve=None, interface_metric=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_metric: interface_metric_level, interface_metric_val
    :param interface_metric: Keyword argument tuple.

    :type interface_metric_level: unicode
    :param interface_metric_level: **interface_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type interface_metric_val: long
    :param interface_metric_val: **interface_metric** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_metric', 'keyval': 'interface_metric_level', 'extra_keyval': 'interface_metric_level, interface_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_metric=interface_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_metric=interface_metric)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_metric_interface_metric_val_get(self, ve=None, interface_metric=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface_metric: interface_metric_level
    :param interface_metric: Keyword argument tuple.

    :type interface_metric_level: unicode
    :param interface_metric_level: **interface_metric** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_metric', 'keyval': 'interface_metric_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, interface_metric=interface_metric)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, interface_metric=interface_metric)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_passive_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_point_to_point_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_priority_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_priority_level_1_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_priority_level_2_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_priority', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_reverse_metric_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_reverse_metric_rev_metric_common_attributes_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_reverse_metric_rev_metric_val_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_reverse_metric_te_def_metric_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_isis_reverse_metric_whole_lan_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_log_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.rpf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.rpf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_qos_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.qos', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.qos', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.qos', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_qos_dscp_cos_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.qos', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.qos', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.qos', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_qos_dscp_mutation_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.qos', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.qos', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.qos', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_qos_dscp_traffic_class_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.qos', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.qos', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.qos', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_rpf_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.rpf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.rpf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_rpf_mode_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.rpf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.rpf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_rpf_mode_mode_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.rpf_mode', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_shutdown_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ve: gve_name
    :param ve: Keyword argument tuple.

    :type gve_name: long
    :param gve_name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ip', u'ip_anycast_gateway'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve.attach', u'rbridge_id'), ('pybind.nos.v6_0_2f.interface_vlan.interface.ve.ipv6', u'ipv6_anycast_gateway'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'ipv6_config'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip', u'icmp'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf', u'ospf1'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip', u'ip_config'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'vrrpv3e'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'ipv6_ve_intf_cmds'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip', u'icmp_plus'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_config', u'address'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'ipv6_anycast_address'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.policy', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u'rpf_mode'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type', u'md5_auth'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u'vrf'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip', u'ip_local_anycast_gateway'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.ip_config', u'arp'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'icmpv6'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u'vrrp'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u'vrrpe'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip', u'igmp'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.pim_intf_vlan_cont', u'pim_int_cmd'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6', u'vrrpv3'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip', u'ip_anycast_address'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type', u'md5_auth'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis', u'interface_isis'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ip.igmp', u've_igmpl3_static_group'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u'qos'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.intf_isis.interface_isis', u'interface_metric'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ip', u'ip_anycast_gateway'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.ipv6', u'ipv6_anycast_gateway'), ('pybind.nos.v7_2_0.interface_vlan.interface.ve.attach', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', u'icmpv6'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', u'ipv6_ve_intf_cmds'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', u'vrrpv3'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip', u'igmp'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type', u'md5_auth'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u'vrrpe'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type', u'md5_auth'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u'vrf'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip', u'icmp_plus'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.ip_config', u'address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u'vrrp'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_vlan_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip', u'icmp'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip', u'ip_config'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u'qos'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.igmp', u've_igmpl3_static_group'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u'rpf'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ip.pim_intf_vlan_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.ipv6', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config', u'address'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', u'interface_metric'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp', u'relay'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'router_preference'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf', u'ospf1'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'address'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.intf_router_isis', u'int_router_isis'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf', u'authentication'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip', u'igmp'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.igmp', u've_igmpl3_static_group'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_ipv6', u'interface_ipv6_metric'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u'vrrpe'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'interface_ospfv3_conf'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip', u'icmp'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', u'interface_auth_key'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', u'pim'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.policy', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u'vrf'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', u'interface_hello_multiplier'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip', u'icmp_plus'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'icmpv6'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'database_filter'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'md5_authentication'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_vrrp_extended.auth_type', u'md5_auth'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'vrrpv3e'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_config', u'arp'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis', u'interface_isis'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'vrrpv3'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_config', u'address'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'ipv6_ve_intf_cmds'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'authentication'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', u'interface_priority'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'ipv6_local_anycast_gateway'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_dns_server'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_hello', u'interface_hello_padding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip', u'ip_local_anycast_gateway'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u'rpf'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.pim_intf_vlan_cont', u'pim_int_cmd'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_auth_mode', u'interface_md5'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u'qos'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', u'interface_bfd'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'ipv6_anycast_address'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.interface_reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.address', u'suppressing_address'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip', u'ip_config'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.ip_vrrp_extended.auth_type', u'md5_auth'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip', u'ip_anycast_address'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6', u'ipv6_config'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_domain_name'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip_acl_interface.ip', u'access_group'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.intf_isis.interface_isis', u'interface_hello_interval'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ip.interface_vlan_ospf_conf.ospf1.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.ipv6.intf_ipv6_router_isis', u'int_ipv6_router_isis'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u'vrrp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u've', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_gw_id, ipv4_gateway_address, hold_time, load_balancing_disable, enable, description'}, {'leafval': 'rb_add, rb_remove'}, {'leafval': 'ipv6_gw_id, hold_time, load_balancing_disable, enable, description'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'mtu'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'echo_reply, unreachable, address_mask'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'route_map_name'}, {'leafval': 'ipv6_address'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'expire'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'local_ipv6_gw_id, enable_local, disable_local'}, {'leafval': 'mode'}, {'leafval': 'auth_data'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'forwarding'}, {'leafval': 'local_ip_gw_id, enable_local, disable_local'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'learn_any'}, {'leafval': 'bfd_enable'}, {'leafval': 'rate_limiting, redirect'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'use_link_local_only'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'attempts, time'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'ip_address'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'gateway'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'address_suppress_all'}, {'leafval': 'auth_data'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'dscp_cos, dscp_mutation, dscp_traffic_class'}, {'leafval': 'interface_bfd_disable'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'ip_gw_id, ipv4_gateway_address, hold_time, load_balancing_disable, enable, description'}, {'leafval': 'ipv6_gw_id, hold_time, load_balancing_disable, enable, description'}, {'leafval': 'rb_add, rb_remove'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'local_ipv6_gw_id, enable_local, disable_local'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'use_link_local_only'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'rate_limiting'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'gateway'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'address_suppress_all'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'auth_data'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'route_map_name'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'auth_data'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'forwarding'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'echo_reply, unreachable, address_mask'}, {'leafval': 'mtu'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'bfd_enable'}, {'leafval': 'local_ip_gw_id, enable_local, disable_local'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'attempts, time'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'max_interval, min_'}, {'leafval': 'rate_limiting'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'dscp_cos, dscp_mutation, dscp_traffic_class'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'expire'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'log, mode'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'vrid, virtual_mac, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'use_link_local_only'}, {'leafval': 'interface_metric_level, interface_metric_val'}, {'leafval': 'gateway'}, {'leafval': 'router_pref_high, router_pref_low, router_pref_medium'}, {'leafval': 'interface_auth_check_level2_disable'}, {'leafval': 'area, auth_change_wait_time, hello_interval, dead_interval, retransmit_interval, transmit_delay, cost, network, intf_ldp_sync, mtu_ignore, active, passive, priority'}, {'leafval': 'address_suppress_all'}, {'leafval': 'interface_ip_router_isis'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'bfd_enable'}, {'leafval': 'key_chain'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'igmpl3_last_member_query_interval, igmpl3_query_interval, igmpl3_query_max_response_time, igmpl3_immediate_leave, igmpl3_version'}, {'leafval': 'igmpl3_sg_addr'}, {'leafval': 'interface_ipv6_metric_level, interface_ipv6_metric_val'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'rate_limiting'}, {'leafval': 'interface_auth_key_level, interface_auth_key_str'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'neighbor_filter, dr_priority, ttl_threshold'}, {'leafval': 'route_map_name'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'forwarding'}, {'leafval': 'interface_hello_multiplier_level, interface_hello_multiplier_val'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'echo_reply, unreachable, address_mask'}, {'leafval': 'attempts, time'}, {'leafval': 'rate_limiting'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'expire'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'auth_data'}, {'leafval': 'vrid, virtual_mac, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'learn_any'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'circuit_type, interface_point_to_point, interface_passive, interface_ldp_sync'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'key_chain'}, {'leafval': 'interface_priority_level1, interface_priority_level2'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'local_ipv6_gw_id, enable_local, disable_local'}, {'leafval': 'dns_server_prefix, dns_server_lifetime_multiplier'}, {'leafval': 'interface_hello_padding_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_ip_gw_id, enable_local, disable_local'}, {'leafval': 'log, mode'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'interface_auth_mode_md5_level1, interface_auth_mode_md5_level2'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'dscp_cos, dscp_mutation, dscp_traffic_class'}, {'leafval': 'interface_bfd_enable'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'max_interval, min_'}, {'leafval': 'ipv6_address'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'suppress_ipv6_address, suppress_per_address'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'auth_data'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'ip_address'}, {'leafval': 'mtu'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'interface_auth_check_level1_disable'}, {'leafval': 'domain_name_string, domain_name_lifetime_multiplier'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy, send_ra'}, {'leafval': 'interface_hello_interval_level, interface_hello_interval_val'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'interface_ipv6_router_isis'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}]
    leafval_map = {"pybind.nos.v7_2_0.interface_vlan.interface.ve": {"global_ve_shutdown": "global_ve_shutdown", "gve_name": "gve_name"}, "pybind.slxos.v17s_1_02.routing_system.interface.ve": {"global_ve_shutdown": "shutdown", "gve_name": "name"}, "pybind.slxos.v17r_1_01a.routing_system.interface.ve": {"global_ve_shutdown": "shutdown", "gve_name": "name"}, "pybind.nos.v6_0_2f.interface_vlan.interface.ve": {"global_ve_shutdown": "global_ve_shutdown", "gve_name": "gve_name"}, "pybind.slxos.v17r_2_00.routing_system.interface.ve": {"global_ve_shutdown": "shutdown", "gve_name": "name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrf_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrf_forwarding_get(self, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_advertise_backup_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_advertisement_interval_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_advertisement_interval_scale_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_arp_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.arp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.arp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.arp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_arp_unicast_request_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.arp.unicast_request', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.arp.unicast_request', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.arp.unicast_request', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_arp_unicast_request_receive_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.arp.unicast_request', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.arp.unicast_request', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.arp.unicast_request', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_backup_advertisement_interval_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_description_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_enable_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_hold_time_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_preempt_mode_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_priority_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_short_path_forwarding_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.short_path_forwarding', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.short_path_forwarding', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.short_path_forwarding', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_short_path_forwarding_basic_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.short_path_forwarding', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.short_path_forwarding', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.short_path_forwarding', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_short_path_forwarding_revert_priority_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.short_path_forwarding', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.short_path_forwarding', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.short_path_forwarding', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_track_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_track_interface_get(self, ve=None, vrrpe=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_track_interface_priority_get(self, ve=None, vrrpe=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_track_network_get(self, ve=None, vrrpe=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  IPv4 global address

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-2])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_track_network_priority_get(self, ve=None, vrrpe=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  IPv4 global address

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-2])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_virtual_ip_get(self, ve=None, vrrpe=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'vrrpe'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.virtual_ip', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.virtual_ip', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.virtual_ip', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_virtual_mac_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_extended_group_vrrpe_garp_timer_get(self, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'network'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'receive'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_get(self, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'owner'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_advertisement_interval_get(self, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'owner'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_arp_get(self, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', u'vrrp'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.arp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.arp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.arp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_arp_unicast_request_get(self, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', u'vrrp'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.arp.unicast_request', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.arp.unicast_request', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.arp.unicast_request', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_arp_unicast_request_receive_get(self, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', u'vrrp'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.arp.unicast_request', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.arp.unicast_request', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.arp.unicast_request', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_description_get(self, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'owner'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_enable_get(self, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'owner'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_hold_time_get(self, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'owner'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_owner_get(self, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.owner', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_owner_priority_get(self, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.owner', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_owner_track_priority_get(self, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.owner', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_preempt_mode_get(self, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'owner'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_priority_get(self, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'owner'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_track_get(self, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'vrrp'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.track', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.track', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.track', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_track_interface_get(self, ve=None, vrrp=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', u'vrrp'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.track.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.track.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.track.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_track_interface_priority_get(self, ve=None, vrrp=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', u'vrrp'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.track.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.track.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.track.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_use_v2_checksum_get(self, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.track', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.track', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'virtual_ip'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'owner'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'owner_priority, owner_track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_ve_vrrp_group_virtual_ip_get(self, ve=None, vrrp=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.interface.ve', u've'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp', u'vrrp'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp', u'vrrp'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve', u've'), ('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.interface.ve.vrrp.virtual_ip', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.interface.ve.vrrp.virtual_ip', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.interface.ve.vrrp.virtual_ip', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ve=ve, vrrp=vrrp, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ve=ve, vrrp=vrrp, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_description_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'spanning_tree'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping', u'querier'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.mac', u'access_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip', u'igmp'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'suppress_nd'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldPIM', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', u'static_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmpPIM', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.private_vlan', u'association'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter', u'interface'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'suppress_arp'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6', u'mldvlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'private_vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection', u'filter'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection', u'logging'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', u'snooping'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter', u'interface'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'private_vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip', u'igmp'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', u'static_group'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.private_vlan', u'association'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp', u'snooping'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6', u'mldvlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection', u'logging'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection', u'filter'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp', u'static_group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mcast_address, interface, if_type, value, source'}, {'leafval': 'stp_shutdown'}, {'leafval': 'qenable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'last_member_query_interval, query_interval, igmp_version, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'enable, fast_leave, mrouter_timeout, restrict_unknown_multicast'}, {'leafval': 'if_type, value'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'enable, fast_leave, restrict_unknown_multicast_vlan, robustness_variable'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'sec_assoc_add, sec_assoc_remove'}, {'leafval': 'if_type, value'}, {'leafval': 'trust'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval'}, {'leafval': 'pvlan_type_leaf'}, {'leafval': 'acl_name'}, {'leafval': 'acl_match'}, {'leafval': 'qenable'}, {'leafval': 'qenable'}, {'leafval': 'enable, fast_leave, restrict_unknown_multicast_vlan, robustness_variable'}, {'leafval': 'if_type, value'}, {'leafval': 'qenable'}, {'leafval': 'pvlan_type_leaf'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'if_type, value'}, {'leafval': 'trust'}, {'leafval': 'sec_assoc_add, sec_assoc_remove'}, {'leafval': 'enable, fast_leave, mrouter_timeout, restrict_unknown_multicast'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval'}, {'leafval': 'stp_shutdown'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'acl_match'}, {'leafval': 'acl_name'}, {'leafval': 'mcast_address, interface, if_type, value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ifindex_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'spanning_tree'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping', u'querier'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.mac', u'access_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip', u'igmp'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'suppress_nd'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldPIM', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', u'static_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmpPIM', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.private_vlan', u'association'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter', u'interface'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'suppress_arp'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6', u'mldvlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'private_vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection', u'filter'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection', u'logging'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', u'snooping'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter', u'interface'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'private_vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip', u'igmp'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', u'static_group'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.private_vlan', u'association'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp', u'snooping'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6', u'mldvlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection', u'logging'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection', u'filter'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp', u'static_group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mcast_address, interface, if_type, value, source'}, {'leafval': 'stp_shutdown'}, {'leafval': 'qenable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'last_member_query_interval, query_interval, igmp_version, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'enable, fast_leave, mrouter_timeout, restrict_unknown_multicast'}, {'leafval': 'if_type, value'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'enable, fast_leave, restrict_unknown_multicast_vlan, robustness_variable'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'sec_assoc_add, sec_assoc_remove'}, {'leafval': 'if_type, value'}, {'leafval': 'trust'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval'}, {'leafval': 'pvlan_type_leaf'}, {'leafval': 'acl_name'}, {'leafval': 'acl_match'}, {'leafval': 'qenable'}, {'leafval': 'qenable'}, {'leafval': 'enable, fast_leave, restrict_unknown_multicast_vlan, robustness_variable'}, {'leafval': 'if_type, value'}, {'leafval': 'qenable'}, {'leafval': 'pvlan_type_leaf'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'if_type, value'}, {'leafval': 'trust'}, {'leafval': 'sec_assoc_add, sec_assoc_remove'}, {'leafval': 'enable, fast_leave, mrouter_timeout, restrict_unknown_multicast'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval'}, {'leafval': 'stp_shutdown'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'acl_match'}, {'leafval': 'acl_name'}, {'leafval': 'mcast_address, interface, if_type, value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_arp_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_arp_inspection_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_arp_inspection_filter_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection.filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection.filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_arp_inspection_filter_acl_name_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection.filter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection.filter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_arp_inspection_logging_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection.logging', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection.logging', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_arp_inspection_logging_acl_match_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection.logging', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection.logging', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_arp_inspection_trust_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp": {"last_member_query_interval": "last_member_query_interval", "query_interval": "query_interval", "query_max_response_time": "query_max_response_time"}, "pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_last_member_query_count_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_last_member_query_interval_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_query_interval_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_query_max_response_time_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_robustness_variable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_snooping_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_snooping_enable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_snooping_fast_leave_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_snooping_mrouter_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_snooping_mrouter_interface_get(self, vlan=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface: if_type, value
    :param interface: Keyword argument tuple.

    :type if_type: unicode
    :param if_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['FortyGigabitEthernet',
            'GigabitEthernet',
            'Port-channel',
            'TenGigabitEthernet',
            'HundredGigabitEthernet']

    :type value: unicode
    :param value: **interface** tuple argument.

        * length restriction: ::

            ['1..10']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'if_type, value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_snooping_mrouter_timeout_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_snooping_querier_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping.querier', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping.querier', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_snooping_querier_enable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping.querier', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping.querier', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_snooping_restrict_unknown_multicast_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_startup_query_count_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_startup_query_interval_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_static_group_get(self, vlan=None, static_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_group: mcast_address, interface, if_type, value
    :param static_group: Keyword argument tuple.

    :type mcast_address: unicode
    :param mcast_address: **static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface: unicode
    :param interface: **static_group** tuple argument.

        * enumeration restriction: ::

            ['interface']

    :type if_type: unicode
    :param if_type: **static_group** tuple argument.

        * enumeration restriction: ::

            ['FortyGigabitEthernet',
            'GigabitEthernet',
            'Port-channel',
            'TenGigabitEthernet',
            'HundredGigabitEthernet']

    :type value: unicode
    :param value: **static_group** tuple argument.

        * length restriction: ::

            ['1..10']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.static_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.static_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'mcast_address, interface, if_type, value, source', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.static_group": {}, "pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.static_group": {"interface": "interface", "mcast_address": "mcast_address", "value": "value", "if_type": "if_type"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, static_group=static_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_igmp_version_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_pim_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmpPIM', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_pim_snooping_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmpPIM.snooping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ip_pim_snooping_enable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmpPIM.snooping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_last_member_query_count_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_last_member_query_interval_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_query_interval_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_query_max_response_time_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_snooping_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_snooping_enable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_snooping_fast_leave_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_snooping_mrouter_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_snooping_mrouter_interface_get(self, vlan=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface: if_type, value
    :param interface: Keyword argument tuple.

    :type if_type: unicode
    :param if_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['FortyGigabitEthernet',
            'GigabitEthernet',
            'Port-channel',
            'TenGigabitEthernet',
            'HundredGigabitEthernet']

    :type value: unicode
    :param value: **interface** tuple argument.

        * length restriction: ::

            ['1..10']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter.interface', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter.interface', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'if_type, value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_snooping_querier_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.querier', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.querier', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_snooping_querier_enable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.querier', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.querier', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_snooping_restrict_unknown_multicast_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_snooping_robustness_variable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_startup_query_count_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_startup_query_interval_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_mld_static_group_get(self, vlan=None, static_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_group: mcast_address, interface, if_type, value
    :param static_group: Keyword argument tuple.

    :type mcast_address: unicode
    :param mcast_address: **static_group** tuple argument:  Multicast Address to be Joined in format xxxx:xxxx/ml, xxxx:xxxx::/ml

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type interface: unicode
    :param interface: **static_group** tuple argument.

        * enumeration restriction: ::

            ['interface']

    :type if_type: unicode
    :param if_type: **static_group** tuple argument.

        * enumeration restriction: ::

            ['FortyGigabitEthernet',
            'GigabitEthernet',
            'Port-channel',
            'TenGigabitEthernet',
            'HundredGigabitEthernet']

    :type value: unicode
    :param value: **static_group** tuple argument.

        * length restriction: ::

            ['1..10']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.static_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.static_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'mcast_address, interface, if_type, value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, static_group=static_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_pim_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldPIM', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_pim_snooping_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldPIM.snooping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_ipv6_pim_snooping_enable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldPIM.snooping', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_mac_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.mac', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.mac', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_mac_access_group_get(self, vlan=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.mac.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.mac.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': 'mac_access_list, mac_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_mac_access_group_traffic_type_get(self, vlan=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.mac.access_group', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.mac.access_group', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_name_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'spanning_tree'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping', u'querier'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.mac', u'access_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip', u'igmp'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'suppress_nd'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldPIM', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', u'static_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmpPIM', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.private_vlan', u'association'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter', u'interface'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'suppress_arp'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6', u'mldvlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'private_vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection', u'filter'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection', u'logging'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', u'snooping'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter', u'interface'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'private_vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip', u'igmp'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', u'static_group'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.private_vlan', u'association'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp', u'snooping'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6', u'mldvlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection', u'logging'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection', u'filter'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp', u'static_group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mcast_address, interface, if_type, value, source'}, {'leafval': 'stp_shutdown'}, {'leafval': 'qenable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'last_member_query_interval, query_interval, igmp_version, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'enable, fast_leave, mrouter_timeout, restrict_unknown_multicast'}, {'leafval': 'if_type, value'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'enable, fast_leave, restrict_unknown_multicast_vlan, robustness_variable'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'sec_assoc_add, sec_assoc_remove'}, {'leafval': 'if_type, value'}, {'leafval': 'trust'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval'}, {'leafval': 'pvlan_type_leaf'}, {'leafval': 'acl_name'}, {'leafval': 'acl_match'}, {'leafval': 'qenable'}, {'leafval': 'qenable'}, {'leafval': 'enable, fast_leave, restrict_unknown_multicast_vlan, robustness_variable'}, {'leafval': 'if_type, value'}, {'leafval': 'qenable'}, {'leafval': 'pvlan_type_leaf'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'if_type, value'}, {'leafval': 'trust'}, {'leafval': 'sec_assoc_add, sec_assoc_remove'}, {'leafval': 'enable, fast_leave, mrouter_timeout, restrict_unknown_multicast'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval'}, {'leafval': 'stp_shutdown'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'acl_match'}, {'leafval': 'acl_name'}, {'leafval': 'mcast_address, interface, if_type, value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_private_vlan_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_private_vlan_association_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.private_vlan.association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.private_vlan.association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_private_vlan_association_add_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.private_vlan.association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.private_vlan.association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_private_vlan_association_remove_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.private_vlan.association', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.private_vlan.association', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_private_vlan_pvlan_type_leaf_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.private_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.private_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_rspan_vlan_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'spanning_tree'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping', u'querier'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.mac', u'access_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip', u'igmp'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'suppress_nd'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldPIM', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', u'static_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmpPIM', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.private_vlan', u'association'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter', u'interface'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'suppress_arp'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6', u'mldvlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'private_vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection', u'filter'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection', u'logging'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', u'snooping'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter', u'interface'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'private_vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip', u'igmp'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', u'static_group'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.private_vlan', u'association'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp', u'snooping'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6', u'mldvlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection', u'logging'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection', u'filter'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp', u'static_group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mcast_address, interface, if_type, value, source'}, {'leafval': 'stp_shutdown'}, {'leafval': 'qenable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'last_member_query_interval, query_interval, igmp_version, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'enable, fast_leave, mrouter_timeout, restrict_unknown_multicast'}, {'leafval': 'if_type, value'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'enable, fast_leave, restrict_unknown_multicast_vlan, robustness_variable'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'sec_assoc_add, sec_assoc_remove'}, {'leafval': 'if_type, value'}, {'leafval': 'trust'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval'}, {'leafval': 'pvlan_type_leaf'}, {'leafval': 'acl_name'}, {'leafval': 'acl_match'}, {'leafval': 'qenable'}, {'leafval': 'qenable'}, {'leafval': 'enable, fast_leave, restrict_unknown_multicast_vlan, robustness_variable'}, {'leafval': 'if_type, value'}, {'leafval': 'qenable'}, {'leafval': 'pvlan_type_leaf'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'if_type, value'}, {'leafval': 'trust'}, {'leafval': 'sec_assoc_add, sec_assoc_remove'}, {'leafval': 'enable, fast_leave, mrouter_timeout, restrict_unknown_multicast'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval'}, {'leafval': 'stp_shutdown'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'acl_match'}, {'leafval': 'acl_name'}, {'leafval': 'mcast_address, interface, if_type, value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_spanning_tree_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_spanning_tree_shutdown_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_suppress_arp_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.suppress_arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_suppress_arp_enable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.suppress_arp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_suppress_nd_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.suppress_nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_suppress_nd_enable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.suppress_nd', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def interface_vlan_transport_service_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'spanning_tree'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping', u'querier'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.mac', u'access_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip', u'igmp'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'suppress_nd'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldPIM', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', u'static_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmpPIM', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.private_vlan', u'association'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter', u'interface'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'suppress_arp'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6', u'mldvlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'private_vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection', u'filter'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection', u'logging'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', u'snooping'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter', u'interface'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'private_vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip', u'igmp'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', u'static_group'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.private_vlan', u'association'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp', u'snooping'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6', u'mldvlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection', u'logging'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection', u'filter'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp', u'static_group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mcast_address, interface, if_type, value, source'}, {'leafval': 'stp_shutdown'}, {'leafval': 'qenable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'last_member_query_interval, query_interval, igmp_version, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'enable, fast_leave, mrouter_timeout, restrict_unknown_multicast'}, {'leafval': 'if_type, value'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'enable, fast_leave, restrict_unknown_multicast_vlan, robustness_variable'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'sec_assoc_add, sec_assoc_remove'}, {'leafval': 'if_type, value'}, {'leafval': 'trust'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval'}, {'leafval': 'pvlan_type_leaf'}, {'leafval': 'acl_name'}, {'leafval': 'acl_match'}, {'leafval': 'qenable'}, {'leafval': 'qenable'}, {'leafval': 'enable, fast_leave, restrict_unknown_multicast_vlan, robustness_variable'}, {'leafval': 'if_type, value'}, {'leafval': 'qenable'}, {'leafval': 'pvlan_type_leaf'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'if_type, value'}, {'leafval': 'trust'}, {'leafval': 'sec_assoc_add, sec_assoc_remove'}, {'leafval': 'enable, fast_leave, mrouter_timeout, restrict_unknown_multicast'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval'}, {'leafval': 'stp_shutdown'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'acl_match'}, {'leafval': 'acl_name'}, {'leafval': 'mcast_address, interface, if_type, value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.igmp_snooping.ip', 'pybind.nos.v6_0_2f.brocade_igmp_snooping', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.global_mtu_conf.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip', 'pybind.slxos.v17r_1_01a.brocade_igmp_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.global_mtu_conf.ip', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.global_mtu_conf.ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.igmp_snooping.ip.pim', u'snooping'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp', u'igmp_snooping'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip', u'igmp'), ('pybind.nos.v6_0_2f.igmp_snooping.ip.igmp', u'snooping')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'pimv4_enable'}, {'leafval': 'igmps_enable'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'router_alert_check_disable'}, {'leafval': 'enable'}]
    leafval_map = {"pybind.slxos.v17r_2_00.global_mtu_conf.ip": {"global_ip_mtu": "global_ip_mtu"}, "pybind.slxos.v17r_1_01a.igmp_snooping.ip": {}, "pybind.slxos.v17s_1_02.global_mtu_conf.ip": {"global_ip_mtu": "global_ip_mtu"}, "pybind.nos.v6_0_2f.igmp_snooping.ip": {}, "pybind.nos.v7_2_0.global_mtu_conf.ip": {"global_ip_mtu": "global_ip_mtu"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.ip.hide_community_list_holder.community_list', u'standard'), ('pybind.nos.v7_2_0.igmp_snooping.ip.pim', u'snooping'), ('pybind.nos.v7_2_0.ip.hide_ext_community_list_holder', u'extcommunity_list'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.ip.dns', u'dom_name'), ('pybind.nos.v7_2_0.ip.hide_as_path_holder.as_path', u'access_list'), ('pybind.nos.v7_2_0.ip.hide_prefix_holder', u'prefix_list'), ('pybind.nos.v7_2_0.ip', u'rtm_config'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_oif'), ('pybind.nos.v7_2_0.ip.dns', u'name_server'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_nh'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list', u'extended'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.nos.v7_2_0.ip.hide_community_list_holder.community_list', u'extended'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list', u'standard'), ('pybind.nos.v7_2_0.igmp_snooping.ip.igmp', u'snooping'), ('pybind.nos.v7_2_0.vcs.virtual.ip', u'address'), ('pybind.nos.v7_2_0.global_mtu_conf', u'ip'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.nos.v6_0_2f.ip.hide_community_list_holder.community_list', u'extended'), ('pybind.nos.v6_0_2f.ip.hide_community_list_holder.community_list', u'standard'), ('pybind.nos.v6_0_2f.ip', u'rtm_config'), ('pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.nos.v6_0_2f.ip.dns', u'name_server'), ('pybind.nos.v6_0_2f.ip.hide_as_path_holder.as_path', u'access_list'), ('pybind.nos.v6_0_2f.igmp_snooping.ip.igmp', u'snooping'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list', u'standard'), ('pybind.nos.v6_0_2f.vcs.virtual.ip', u'address'), ('pybind.nos.v6_0_2f.ip.dns', u'dom_name'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list', u'extended'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_oif'), ('pybind.nos.v6_0_2f.ip.hide_prefix_holder', u'prefix_list'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_nh'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.nos.v6_0_2f.ip.hide_ext_community_list_holder', u'extcommunity_list'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17s_1_02.capabilities', u'ip'), ('pybind.slxos.v17s_1_02.ip.hide_community_list_holder.community_list', u'extended'), ('pybind.slxos.v17s_1_02.ip.icmp', u'echo'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip', u'igmp'), ('pybind.slxos.v17s_1_02.ip.hide_as_path_holder.as_path', u'access_list'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17s_1_02.routing_system.ip.receive', u'access_group'), ('pybind.slxos.v17s_1_02.ip', u'rtm_config'), ('pybind.slxos.v17s_1_02.ip.rtm_config.import_', u'routes'), ('pybind.slxos.v17s_1_02.ip.dns', u'dom_name'), ('pybind.slxos.v17s_1_02.routing_system.ip.dhcp.relay', u'information'), ('pybind.slxos.v17s_1_02.global_mtu_conf', u'ip'), ('pybind.slxos.v17s_1_02.ip.dns', u'name_server'), ('pybind.slxos.v17s_1_02.ip.hide_ext_community_list_holder.extcommunity_list', u'standard'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list', u'extended'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_nh'), ('pybind.slxos.v17s_1_02.capabilities.ip', u'igmp_snooping'), ('pybind.slxos.v17s_1_02.ip.hide_community_list_holder.community_list', u'standard'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list', u'standard'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17s_1_02.load_balance.hash', u'ip'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_oif'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.pim', u'snooping'), ('pybind.slxos.v17s_1_02.vcs.virtual.ip', u'address'), ('pybind.slxos.v17s_1_02.ip.hide_prefix_holder', u'prefix_list'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp', u'igmp_snooping'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ip', u'address'), ('pybind.slxos.v17s_1_02.routing_system.ip.static_ag_ip_config', u'anycast_gateway_mac'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list', u'standard'), ('pybind.slxos.v17r_2_00.routing_system.ip.receive', u'access_group'), ('pybind.slxos.v17r_2_00.ip.rtm_config.import_', u'routes'), ('pybind.slxos.v17r_2_00.ip.hide_prefix_holder', u'prefix_list'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17r_2_00.routing_system.ip.static_ag_ip_config', u'anycast_gateway_mac'), ('pybind.slxos.v17r_2_00.ip.dns', u'dom_name'), ('pybind.slxos.v17r_2_00.ip', u'rtm_config'), ('pybind.slxos.v17r_2_00.global_mtu_conf', u'ip'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip', u'igmp'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_nh'), ('pybind.slxos.v17r_2_00.vcs.virtual.ip', u'address'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list', u'extended'), ('pybind.slxos.v17r_2_00.ip.hide_community_list_holder.community_list', u'standard'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.pim', u'snooping'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp', u'igmp_snooping'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list', u'extended'), ('pybind.slxos.v17r_2_00.routing_system.ip.dhcp.relay', u'information'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash', u'ip'), ('pybind.slxos.v17r_2_00.ip.icmp', u'echo'), ('pybind.slxos.v17r_2_00.ip.hide_as_path_holder.as_path', u'access_list'), ('pybind.slxos.v17r_2_00.ip.dns', u'name_server'), ('pybind.slxos.v17r_2_00.ip.hide_community_list_holder.community_list', u'extended'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_oif'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ip', u'address'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list', u'standard'), ('pybind.slxos.v17r_1_01a.ip.hide_as_path_holder.as_path', u'access_list'), ('pybind.slxos.v17r_1_01a.ip.dns', u'name_server'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.pim', u'snooping'), ('pybind.slxos.v17r_1_01a.ip', u'rtm_config'), ('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list', u'standard'), ('pybind.slxos.v17r_1_01a.ip.hide_prefix_holder', u'prefix_list'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp', u'igmp_snooping'), ('pybind.slxos.v17r_1_01a.ip.dns', u'dom_name'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.routing_system.ip.dhcp.relay', u'information'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list', u'standard'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.import_', u'routes'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash', u'ip'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list', u'extended'), ('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list', u'extended'), ('pybind.slxos.v17r_1_01a.ip.hide_community_list_holder.community_list', u'extended'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ip', u'address'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.routing_system.ip.receive', u'access_group'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static', u'bfd'), ('pybind.slxos.v17r_1_01a.ip.icmp', u'echo'), ('pybind.slxos.v17r_1_01a.ip.hide_community_list_holder.community_list', u'standard'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip', u'igmp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'pimv4_enable'}, {'leafval': 'extcommunity_list_num, ext_community_action, ext_community_regex, ext_community_expr'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'domain_name'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'router_id, load_sharing'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'name_server_ip'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'name'}, {'leafval': 'enable'}, {'leafval': 'address'}, {'leafval': 'global_ip_mtu'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'router_id, load_sharing'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'name_server_ip'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'enable'}, {'leafval': 'name'}, {'leafval': 'address'}, {'leafval': 'domain_name'}, {'leafval': 'name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'extcommunity_list_num, ext_community_action, ext_community_expr'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'igmp'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'broadcast_request'}, {'leafval': 'router_alert_check_disable'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'ip_access_list, ip_direction'}, {'leafval': 'router_id, load_sharing'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'domain_name'}, {'leafval': 'option'}, {'leafval': 'global_ip_mtu'}, {'leafval': 'name_server_ip'}, {'leafval': 'extcommunity_list_name, ext_community_action, ext_community_expr'}, {'leafval': 'name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'igmp_snooping_version'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'src_l4_port, dst_l4_port, src_ip, dst_ip, protocol'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'pimv4_enable'}, {'leafval': 'address'}, {'leafval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'igmps_enable'}, {'leafval': 'address'}, {'leafval': 'ip_anycast_gateway_mac, ip_anycast_default_mac'}, {'leafval': 'holdover_interval'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'extcommunity_list_name'}, {'leafval': 'acl_name'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'ip_anycast_gateway_mac, ip_anycast_default_mac'}, {'leafval': 'domain_name'}, {'leafval': 'router_id, load_sharing'}, {'leafval': 'global_ip_mtu'}, {'leafval': 'router_alert_check_disable'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'address'}, {'leafval': 'holdover_interval'}, {'leafval': 'extended_extcommunity_list_name'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'pimv4_enable'}, {'leafval': 'igmps_enable'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'name'}, {'leafval': 'option'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'src_l4_port, dst_l4_port, src_ip, dst_ip, protocol'}, {'leafval': 'broadcast_request'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'name_server_ip'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'address'}, {'leafval': 'name'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'name_server_ip'}, {'leafval': 'pimv4_enable'}, {'leafval': 'router_id, load_sharing'}, {'leafval': 'extcommunity_list_name'}, {'leafval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'igmps_enable'}, {'leafval': 'domain_name'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'option'}, {'leafval': 'name'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'src_l4_port, dst_l4_port, src_ip, dst_ip, protocol'}, {'leafval': 'name'}, {'leafval': 'extended_extcommunity_list_name'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'address'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'acl_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'holdover_interval'}, {'leafval': 'broadcast_request'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'router_alert_check_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ip_acl.ip.access_list', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list', u'standard'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list', u'standard'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list', u'standard'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list', u'standard'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list', u'extended'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list', u'extended'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list', u'standard')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_get(self, extended=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext', u'seq'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext', u'seq'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext', u'seq'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext', u'seq'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext', u'seq')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, dscp_force, drop_precedence_force, urg, ack, push, fin, rst, sync, vlan, count, log, mirror, copy_sflow'}, {'leafval': 'seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, dscp_force, drop_precedence_force, urg, ack, push, fin, rst, sync, vlan, count, log, mirror, copy_sflow'}, {'leafval': 'seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, urg, ack, push, fin, rst, sync, vlan, count, log'}, {'leafval': 'seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, dscp_force, drop_precedence_force, urg, ack, push, fin, rst, sync, vlan, count, log, mirror, copy_sflow'}, {'leafval': 'seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, urg, ack, push, fin, rst, sync, vlan, count, log'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, urg, ack, push, fin, rst, sync, vlan, count, log
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type action: unicode
    :param action: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type protocol_type: unicode
    :param protocol_type: **seq** tuple argument.

        * enumeration restriction: ::

            ['ip', 'udp', 'icmp', 'tcp']

    :type src_host_any_sip: unicode
    :param src_host_any_sip: **seq** tuple argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type src_host_ip: unicode
    :param src_host_ip: **seq** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_mask: unicode
    :param src_mask: **seq** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type sport: unicode
    :param sport: **seq** tuple argument.

        * enumeration restriction: ::

            ['lt', 'gt', 'eq', 'range', 'neq']

    :type sport_number_eq_neq_tcp: unicode
    :param sport_number_eq_neq_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_lt_tcp: unicode
    :param sport_number_lt_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_gt_tcp: unicode
    :param sport_number_gt_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_eq_neq_udp: unicode
    :param sport_number_eq_neq_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_lt_udp: unicode
    :param sport_number_lt_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_gt_udp: unicode
    :param sport_number_gt_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_range_lower_tcp: unicode
    :param sport_number_range_lower_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_range_lower_udp: unicode
    :param sport_number_range_lower_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_range_higher_tcp: unicode
    :param sport_number_range_higher_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_range_higher_udp: unicode
    :param sport_number_range_higher_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dst_host_any_dip: unicode
    :param dst_host_any_dip: **seq** tuple argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type dst_host_ip: unicode
    :param dst_host_ip: **seq** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type dst_mask: unicode
    :param dst_mask: **seq** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type dport: unicode
    :param dport: **seq** tuple argument.

        * enumeration restriction: ::

            ['lt', 'gt', 'eq', 'range', 'neq']

    :type dport_number_eq_neq_tcp: unicode
    :param dport_number_eq_neq_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_lt_tcp: unicode
    :param dport_number_lt_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_gt_tcp: unicode
    :param dport_number_gt_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_eq_neq_udp: unicode
    :param dport_number_eq_neq_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_lt_udp: unicode
    :param dport_number_lt_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_gt_udp: unicode
    :param dport_number_gt_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_range_lower_tcp: unicode
    :param dport_number_range_lower_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_range_lower_udp: unicode
    :param dport_number_range_lower_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_range_higher_tcp: unicode
    :param dport_number_range_higher_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_range_higher_udp: unicode
    :param dport_number_range_higher_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dscp: unicode
    :param dscp: **seq** tuple argument:  Differentiated Service Code Point

        * enumeration restriction: ::

            ['af23',
            'af22',
            'af21',
            'af33',
            'af41',
            'af43',
            'af31',
            'default',
            'af42',
            'af12',
            'af32',
            'af13',
            'cs6',
            'cs2',
            'cs5',
            'cs4',
            'cs7',
            'af11',
            'cs1',
            'cs3',
            'ef']

    :type urg: YANGBool
    :param urg: **seq** tuple argument:  Urgent

    :type ack: YANGBool
    :param ack: **seq** tuple argument:  Acknowledgement

    :type push: YANGBool
    :param push: **seq** tuple argument:  Push

    :type fin: YANGBool
    :param fin: **seq** tuple argument:  No more data

    :type rst: YANGBool
    :param rst: **seq** tuple argument:  Reset connection

    :type sync: YANGBool
    :param sync: **seq** tuple argument:  Synchronize

    :type vlan: long
    :param vlan: **seq** tuple argument:  Vlan

        * range restriction: ::

            ['0..4294967295']

    :type count: YANGBool
    :param count: **seq** tuple argument:  Packet Count

    :type log: YANGBool
    :param log: **seq** tuple argument:  Log Packet

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': 'seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, urg, ack, push, fin, rst, sync, vlan, count, log'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq": {}, "pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq": {"dport_number_range_higher_udp": "dport_number_range_higher_udp", "sport_number_range_lower_tcp": "sport_number_range_lower_tcp", "push": "push", "sport_number_eq_neq_udp": "sport_number_eq_neq_udp", "sport_number_range_higher_tcp": "sport_number_range_higher_tcp", "sync": "sync", "sport": "sport", "src_mask": "src_mask", "dport_number_lt_udp": "dport_number_lt_udp", "sport_number_range_lower_udp": "sport_number_range_lower_udp", "log": "log", "seq_id": "seq_id", "dport_number_range_lower_tcp": "dport_number_range_lower_tcp", "dport_number_eq_neq_udp": "dport_number_eq_neq_udp", "src_host_ip": "src_host_ip", "sport_number_lt_tcp": "sport_number_lt_tcp", "sport_number_gt_tcp": "sport_number_gt_tcp", "dport_number_gt_udp": "dport_number_gt_udp", "fin": "fin", "dport_number_gt_tcp": "dport_number_gt_tcp", "vlan": "vlan", "dport_number_range_higher_tcp": "dport_number_range_higher_tcp", "sport_number_eq_neq_tcp": "sport_number_eq_neq_tcp", "dscp": "dscp", "sport_number_range_higher_udp": "sport_number_range_higher_udp", "action": "action", "dst_host_ip": "dst_host_ip", "rst": "rst", "dst_mask": "dst_mask", "protocol_type": "protocol_type", "count": "count", "urg": "urg", "dport_number_lt_tcp": "dport_number_lt_tcp", "ack": "ack", "dport_number_eq_neq_tcp": "dport_number_eq_neq_tcp", "dport_number_range_lower_udp": "dport_number_range_lower_udp", "dport": "dport", "src_host_any_sip": "src_host_any_sip", "dst_host_any_dip": "dst_host_any_dip", "sport_number_lt_udp": "sport_number_lt_udp", "sport_number_gt_udp": "sport_number_gt_udp"}, "pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq": {}, "pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq": {"dport_number_range_higher_udp": "dport_number_range_higher_udp", "sport_number_range_lower_tcp": "sport_number_range_lower_tcp", "push": "push", "sport_number_eq_neq_udp": "sport_number_eq_neq_udp", "sport_number_range_higher_tcp": "sport_number_range_higher_tcp", "sync": "sync", "sport": "sport", "src_mask": "src_mask", "dport_number_lt_udp": "dport_number_lt_udp", "sport_number_range_lower_udp": "sport_number_range_lower_udp", "log": "log", "seq_id": "seq_id", "dport_number_range_lower_tcp": "dport_number_range_lower_tcp", "dport_number_eq_neq_udp": "dport_number_eq_neq_udp", "src_host_ip": "src_host_ip", "sport_number_lt_tcp": "sport_number_lt_tcp", "sport_number_gt_tcp": "sport_number_gt_tcp", "dport_number_gt_udp": "dport_number_gt_udp", "fin": "fin", "dport_number_gt_tcp": "dport_number_gt_tcp", "vlan": "vlan", "dport_number_range_higher_tcp": "dport_number_range_higher_tcp", "sport_number_eq_neq_tcp": "sport_number_eq_neq_tcp", "dscp": "dscp", "sport_number_range_higher_udp": "sport_number_range_higher_udp", "action": "action", "dst_host_ip": "dst_host_ip", "rst": "rst", "dst_mask": "dst_mask", "protocol_type": "protocol_type", "count": "count", "urg": "urg", "dport_number_lt_tcp": "dport_number_lt_tcp", "ack": "ack", "dport_number_eq_neq_tcp": "dport_number_eq_neq_tcp", "dport_number_range_lower_udp": "dport_number_range_lower_udp", "dport": "dport", "src_host_any_sip": "src_host_any_sip", "dst_host_any_dip": "dst_host_any_dip", "sport_number_lt_udp": "sport_number_lt_udp", "sport_number_gt_udp": "sport_number_gt_udp"}, "pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_ack_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_action_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_copy_sflow_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_count_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_dport_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_eq_neq_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_eq_neq_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_gt_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_gt_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_lt_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_lt_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_range_higher_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_range_higher_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_range_lower_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_dport_number_range_lower_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_drop_precedence_force_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_dscp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_dscp_force_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_dst_host_any_dip_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_dst_host_ip_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_dst_mask_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_fin_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_log_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_mirror_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_protocol_type_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_push_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_rst_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_sport_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_eq_neq_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_eq_neq_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_gt_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_gt_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_lt_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_lt_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_range_higher_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_range_higher_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_range_lower_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_sport_number_range_lower_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_src_host_any_sip_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_src_host_ip_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_src_mask_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_sync_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_urg_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_extended_seq_vlan_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.extended.hide_ip_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_standard_get(self, standard=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.standard', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard.hide_ip_acl_std', u'seq'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard.hide_ip_acl_std', u'seq'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard.hide_ip_acl_std', u'seq'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.standard.hide_ip_acl_std', u'seq'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard.hide_ip_acl_std', u'seq')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log, copy_sflow'}, {'leafval': 'seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log'}, {'leafval': 'seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log, copy_sflow'}, {'leafval': 'seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log'}, {'leafval': 'seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log, copy_sflow'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_standard_seq_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type action: unicode
    :param action: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type src_host_any_sip: unicode
    :param src_host_any_sip: **seq** tuple argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type src_host_ip: unicode
    :param src_host_ip: **seq** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_mask: unicode
    :param src_mask: **seq** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type count: YANGBool
    :param count: **seq** tuple argument:  Packet count

    :type log: YANGBool
    :param log: **seq** tuple argument:  Log Packet

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': 'seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log, copy_sflow'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq": {"count": "count", "log": "log", "seq_id": "seq_id", "src_host_ip": "src_host_ip", "action": "action", "src_host_any_sip": "src_host_any_sip", "src_mask": "src_mask"}, "pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq": {}, "pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq": {}, "pybind.nos.v7_2_0.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq": {"count": "count", "log": "log", "seq_id": "seq_id", "src_host_ip": "src_host_ip", "action": "action", "src_host_any_sip": "src_host_any_sip", "src_mask": "src_mask"}, "pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_standard_seq_action_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_standard_seq_copy_sflow_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_standard_seq_count_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_standard_seq_log_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_standard_seq_src_host_any_sip_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_standard_seq_src_host_ip_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_access_list_standard_seq_src_mask_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list.standard.hide_ip_acl_std.seq', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_acl_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.ip_acl.ip.access_list', u'extended'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list', u'standard'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list', u'standard'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list', u'standard'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list', u'standard'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list', u'standard')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_anycast_gateway_mac_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.ip.static_ag_ip_config.anycast_gateway_mac', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ip.static_ag_ip_config.anycast_gateway_mac', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_anycast_gateway_mac_default_mac_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.ip.static_ag_ip_config.anycast_gateway_mac', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ip.static_ag_ip_config.anycast_gateway_mac', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_anycast_gateway_mac_ip_anycast_gateway_mac_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.ip.static_ag_ip_config.anycast_gateway_mac', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ip.static_ag_ip_config.anycast_gateway_mac', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_as_path_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_as_path_holder.as_path', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_as_path_holder.as_path', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_as_path_holder.as_path', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_as_path_holder.as_path', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_as_path_holder.as_path', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.ip.hide_as_path_holder.as_path', u'access_list'), ('pybind.slxos.v17s_1_02.ip.hide_as_path_holder.as_path', u'access_list'), ('pybind.nos.v7_2_0.ip.hide_as_path_holder.as_path', u'access_list'), ('pybind.slxos.v17r_2_00.ip.hide_as_path_holder.as_path', u'access_list'), ('pybind.slxos.v17r_1_01a.ip.hide_as_path_holder.as_path', u'access_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_as_path_access_list_get(self, access_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type access_list: name, seq_keyword, instance, ip_action, ip_reg_expr
    :param access_list: Keyword argument tuple.

    :type name: unicode
    :param name: **access_list** tuple argument.

        * length restriction: ::

            ['1..32']

    :type seq_keyword: unicode
    :param seq_keyword: **access_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **access_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ip_action: unicode
    :param ip_action: **access_list** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ip_reg_expr: unicode
    :param ip_reg_expr: **access_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_as_path_holder.as_path.access_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_as_path_holder.as_path.access_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_as_path_holder.as_path.access_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_as_path_holder.as_path.access_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_as_path_holder.as_path.access_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'access_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_list=access_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_list=access_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_as_path_access_list_ip_action_get(self, access_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type access_list: name, seq_keyword, instance
    :param access_list: Keyword argument tuple.

    :type name: unicode
    :param name: **access_list** tuple argument.

        * length restriction: ::

            ['1..32']

    :type seq_keyword: unicode
    :param seq_keyword: **access_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **access_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_as_path_holder.as_path.access_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_as_path_holder.as_path.access_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_as_path_holder.as_path.access_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_as_path_holder.as_path.access_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_as_path_holder.as_path.access_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'access_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_list=access_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_list=access_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_as_path_access_list_ip_reg_expr_get(self, access_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type access_list: name, seq_keyword, instance
    :param access_list: Keyword argument tuple.

    :type name: unicode
    :param name: **access_list** tuple argument.

        * length restriction: ::

            ['1..32']

    :type seq_keyword: unicode
    :param seq_keyword: **access_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **access_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_as_path_holder.as_path.access_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_as_path_holder.as_path.access_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_as_path_holder.as_path.access_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_as_path_holder.as_path.access_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_as_path_holder.as_path.access_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'access_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_list=access_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_list=access_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_community_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_community_list_holder.community_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_community_list_holder.community_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_community_list_holder.community_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_community_list_holder.community_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_community_list_holder.community_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.ip.hide_community_list_holder.community_list', u'standard'), ('pybind.nos.v7_2_0.ip.hide_community_list_holder.community_list', u'extended'), ('pybind.slxos.v17r_1_01a.ip.hide_community_list_holder.community_list', u'extended'), ('pybind.slxos.v17r_1_01a.ip.hide_community_list_holder.community_list', u'standard'), ('pybind.slxos.v17s_1_02.ip.hide_community_list_holder.community_list', u'extended'), ('pybind.slxos.v17s_1_02.ip.hide_community_list_holder.community_list', u'standard'), ('pybind.nos.v6_0_2f.ip.hide_community_list_holder.community_list', u'extended'), ('pybind.nos.v6_0_2f.ip.hide_community_list_holder.community_list', u'standard'), ('pybind.slxos.v17r_2_00.ip.hide_community_list_holder.community_list', u'standard'), ('pybind.slxos.v17r_2_00.ip.hide_community_list_holder.community_list', u'extended')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_community_list_extended_get(self, extended=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended: name, seq_keyword, instance, ip_action, ip_community_reg_expr
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **extended** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **extended** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ip_action: unicode
    :param ip_action: **extended** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ip_community_reg_expr: unicode
    :param ip_community_reg_expr: **extended** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_community_list_holder.community_list.extended', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_community_list_holder.community_list.extended', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_community_list_holder.community_list.extended', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_community_list_holder.community_list.extended', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_community_list_holder.community_list.extended', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_community_list_extended_ip_action_get(self, extended=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended: name, seq_keyword, instance
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **extended** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **extended** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_community_list_holder.community_list.extended', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_community_list_holder.community_list.extended', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_community_list_holder.community_list.extended', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_community_list_holder.community_list.extended', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_community_list_holder.community_list.extended', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_community_list_extended_ip_community_reg_expr_get(self, extended=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended: name, seq_keyword, instance
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **extended** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **extended** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_community_list_holder.community_list.extended', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_community_list_holder.community_list.extended', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_community_list_holder.community_list.extended', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_community_list_holder.community_list.extended', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_community_list_holder.community_list.extended', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_community_list_standard_get(self, standard=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type standard: name, seq_keyword, instance, ip_action, std_community_expr
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **standard** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **standard** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ip_action: unicode
    :param ip_action: **standard** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type std_community_expr: unicode
    :param std_community_expr: **standard** tuple argument.

        * pattern restriction: ::

            '(\s*)|(\s*((local\-as)|(internet)|(no\-export)|('
            'no\-advertise)|((([1-9][0-9]{0,3})|([1-5][0-9]{4'
            '})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2]['
            '0-9])|(6553[0-5])):(([0-9][0-9]{0,3})|([1-5][0-9'
            ']{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-'
            '2][0-9])|(6553[0-5])))|([1-9][0-9]{0,8})|([1-3]['
            '0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429'
            '[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5][0'
            '-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9]'
            '{2})|(42949672[0-8][0-9])|(429496729[0-5])))((\s'
            '+((local\-as)|(internet)|(no\-export)|(no\-adver'
            'tise)|((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4'
            '][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(65'
            '53[0-5])):(([0-9][0-9]{0,3})|([1-5][0-9]{4})|(6['
            '0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|'
            '(6553[0-5])))|([1-9][0-9]{0,8})|([1-3][0-9]{9})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])|(429496729[0-5])))*)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_community_list_holder.community_list.standard', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_community_list_holder.community_list.standard', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_community_list_holder.community_list.standard', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_community_list_holder.community_list.standard', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_community_list_holder.community_list.standard', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, ip_action, std_community_expr'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_community_list_standard_ip_action_get(self, standard=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type standard: name, seq_keyword, instance
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **standard** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **standard** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_community_list_holder.community_list.standard', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_community_list_holder.community_list.standard', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_community_list_holder.community_list.standard', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_community_list_holder.community_list.standard', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_community_list_holder.community_list.standard', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_community_list_standard_std_community_expr_get(self, standard=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type standard: name, seq_keyword, instance
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **standard** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **standard** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_community_list_holder.community_list.standard', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_community_list_holder.community_list.standard', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_community_list_holder.community_list.standard', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_community_list_holder.community_list.standard', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_community_list_holder.community_list.standard', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_dhcp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ip.dhcp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ip.dhcp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ip.dhcp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.ip.dhcp.relay', u'information'), ('pybind.slxos.v17s_1_02.routing_system.ip.dhcp.relay', u'information'), ('pybind.slxos.v17r_1_01a.routing_system.ip.dhcp.relay', u'information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'option'}, {'leafval': 'option'}, {'leafval': 'option'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_dhcp_relay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ip.dhcp.relay', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ip.dhcp.relay', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ip.dhcp.relay', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.ip.dhcp.relay', u'information'), ('pybind.slxos.v17r_1_01a.routing_system.ip.dhcp.relay', u'information'), ('pybind.slxos.v17r_2_00.routing_system.ip.dhcp.relay', u'information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'option'}, {'leafval': 'option'}, {'leafval': 'option'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_dhcp_relay_information_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ip.dhcp.relay.information', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ip.dhcp.relay.information', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ip.dhcp.relay.information', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_dhcp_relay_information_option_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ip.dhcp.relay.information', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ip.dhcp.relay.information', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ip.dhcp.relay.information', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_dns_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.dns', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.dns', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.dns', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.dns', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.dns', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.ip.dns', u'name_server'), ('pybind.nos.v6_0_2f.ip.dns', u'dom_name'), ('pybind.slxos.v17r_1_01a.ip.dns', u'name_server'), ('pybind.slxos.v17r_1_01a.ip.dns', u'dom_name'), ('pybind.nos.v7_2_0.ip.dns', u'dom_name'), ('pybind.nos.v7_2_0.ip.dns', u'name_server'), ('pybind.slxos.v17r_2_00.ip.dns', u'dom_name'), ('pybind.slxos.v17r_2_00.ip.dns', u'name_server'), ('pybind.slxos.v17s_1_02.ip.dns', u'dom_name'), ('pybind.slxos.v17s_1_02.ip.dns', u'name_server')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name_server_ip'}, {'leafval': 'domain_name'}, {'leafval': 'name_server_ip'}, {'leafval': 'domain_name'}, {'leafval': 'domain_name'}, {'leafval': 'name_server_ip'}, {'leafval': 'domain_name'}, {'leafval': 'name_server_ip'}, {'leafval': 'domain_name'}, {'leafval': 'name_server_ip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_dns_dom_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.dns.dom_name', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.dns.dom_name', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.dns.dom_name', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.dns.dom_name', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.dns.dom_name', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_dns_domain_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.dns.dom_name', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.dns.dom_name', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.dns.dom_name', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.dns.dom_name', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.dns.dom_name', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_dns_name_server_get(self, name_server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type name_server: name_server_ip
    :param name_server: Keyword argument tuple.

    :type name_server_ip: unicode
    :param name_server_ip: **name_server** tuple argument:  IPv4ADDRESS/IPv6ADDRESS;;The IPv4 or Ipv6 Address for Name Server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.dns.name_server', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.dns.name_server', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.dns.name_server', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.dns.name_server', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.dns.name_server', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name_server', 'keyval': 'name_server_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name_server=name_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name_server=name_server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_extcommunity_list_get(self, extcommunity_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type extcommunity_list: extcommunity_list_num, ext_community_action, ext_community_expr
    :param extcommunity_list: Keyword argument tuple.

    :type extcommunity_list_num: int
    :param extcommunity_list_num: **extcommunity_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ext_community_action: unicode
    :param ext_community_action: **extcommunity_list** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ext_community_expr: unicode
    :param ext_community_expr: **extcommunity_list** tuple argument:  Ext-community-list

        * pattern restriction: ::

            '(\s*)|(\s*((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|((([0-9]|[1-9][0-9]|1[0-9]{2'
            '}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1['
            '0-9]{2}|2[0-4][0-9]|25[0-5]):(([1-9][0-9]{0,8})|'
            '([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7'
            '})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949'
            '[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-'
            '1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-5]'
            ')))))((\s+((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|(((([0-9]|[1-9][0-9]|1[0-9]{'
            '2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,8}'
            ')|([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]'
            '{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(429'
            '49[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967['
            '0-1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-'
            '5])))))*)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extcommunity_list', 'keyval': 'extcommunity_list_num', 'extra_keyval': 'extcommunity_list_num, ext_community_action, ext_community_expr'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.ip.hide_ext_community_list_holder.extcommunity_list": {"ext_community_action": "ext_community_action", "ext_community_expr": "ext_community_expr", "extcommunity_list_num": "extcommunity_list_num"}, "pybind.nos.v7_2_0.ip.hide_ext_community_list_holder.extcommunity_list": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extcommunity_list=extcommunity_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extcommunity_list=extcommunity_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_extcommunity_list_ext_community_action_get(self, extcommunity_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type extcommunity_list: extcommunity_list_num
    :param extcommunity_list: Keyword argument tuple.

    :type extcommunity_list_num: int
    :param extcommunity_list_num: **extcommunity_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extcommunity_list', 'keyval': 'extcommunity_list_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extcommunity_list=extcommunity_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extcommunity_list=extcommunity_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_extcommunity_list_ext_community_expr_get(self, extcommunity_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type extcommunity_list: extcommunity_list_num
    :param extcommunity_list: Keyword argument tuple.

    :type extcommunity_list_num: int
    :param extcommunity_list_num: **extcommunity_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extcommunity_list', 'keyval': 'extcommunity_list_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extcommunity_list=extcommunity_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extcommunity_list=extcommunity_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_extcommunity_list_ext_community_regex_get(self, extcommunity_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type extcommunity_list: extcommunity_list_num
    :param extcommunity_list: Keyword argument tuple.

    :type extcommunity_list_num: int
    :param extcommunity_list_num: **extcommunity_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.ip.hide_ext_community_list_holder.extcommunity_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extcommunity_list', 'keyval': 'extcommunity_list_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extcommunity_list=extcommunity_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extcommunity_list=extcommunity_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_extcommunity_list_extended_get(self, extended=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended: extended_extcommunity_list_name
    :param extended: Keyword argument tuple.

    :type extended_extcommunity_list_name: unicode
    :param extended_extcommunity_list_name: **extended** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.extended', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.extended', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.extended', u'seq'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.extended', u'seq')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'extended_extcommunity_list_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'extended_seq_id, exp_ext_community_action, ext_community_regex'}, {'leafval': 'extended_seq_id, exp_ext_community_action, ext_community_regex'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_extcommunity_list_extended_seq_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: extended_extcommunity_list_name
    :param extended: Keyword argument tuple.

    :type extended_extcommunity_list_name: unicode
    :param extended_extcommunity_list_name: **extended** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type seq: extended_seq_id, exp_ext_community_action, ext_community_regex
    :param seq: Keyword argument tuple.

    :type extended_seq_id: long
    :param extended_seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type exp_ext_community_action: unicode
    :param exp_ext_community_action: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ext_community_regex: unicode
    :param ext_community_regex: **seq** tuple argument:  Filter regular expression.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'extended_extcommunity_list_name', 'extra_keyval': ''}, {'keyval': 'extended_extcommunity_list_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'extended_seq_id', 'extra_keyval': 'extended_seq_id, exp_ext_community_action, ext_community_regex'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_extcommunity_list_extended_seq_exp_ext_community_action_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: extended_extcommunity_list_name
    :param extended: Keyword argument tuple.

    :type extended_extcommunity_list_name: unicode
    :param extended_extcommunity_list_name: **extended** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type seq: extended_seq_id
    :param seq: Keyword argument tuple.

    :type extended_seq_id: long
    :param extended_seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'extended_extcommunity_list_name', 'extra_keyval': ''}, {'keyval': 'extended_extcommunity_list_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'extended_seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_extcommunity_list_extended_seq_ext_community_regex_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: extended_extcommunity_list_name
    :param extended: Keyword argument tuple.

    :type extended_extcommunity_list_name: unicode
    :param extended_extcommunity_list_name: **extended** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type seq: extended_seq_id
    :param seq: Keyword argument tuple.

    :type extended_seq_id: long
    :param extended_seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'extended_extcommunity_list_name', 'extra_keyval': ''}, {'keyval': 'extended_extcommunity_list_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'extended_seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_extcommunity_list_standard_get(self, standard=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type standard: extcommunity_list_name
    :param standard: Keyword argument tuple.

    :type extcommunity_list_name: unicode
    :param extcommunity_list_name: **standard** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.standard', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.standard', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_ext_community_list_holder.extcommunity_list.standard', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.standard', u'seq'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.standard', u'seq')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'extcommunity_list_name', 'extra_keyval': 'extcommunity_list_name, ext_community_action, ext_community_expr'}
    composed_child_leafval_list = [{'leafval': 'seq_id, ext_community_action, ext_community_expr'}, {'leafval': 'seq_id, ext_community_action, ext_community_expr'}]
    leafval_map = {"pybind.slxos.v17s_1_02.ip.hide_ext_community_list_holder.extcommunity_list.standard": {}, "pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.standard": {"extcommunity_list_name": "extcommunity_list_name"}, "pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.standard": {"extcommunity_list_name": "extcommunity_list_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_extcommunity_list_standard_ext_community_action_get(self, standard=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type standard: extcommunity_list_name
    :param standard: Keyword argument tuple.

    :type extcommunity_list_name: unicode
    :param extcommunity_list_name: **standard** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ip.hide_ext_community_list_holder.extcommunity_list.standard', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'extcommunity_list_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_extcommunity_list_standard_ext_community_expr_get(self, standard=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type standard: extcommunity_list_name
    :param standard: Keyword argument tuple.

    :type extcommunity_list_name: unicode
    :param extcommunity_list_name: **standard** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ip.hide_ext_community_list_holder.extcommunity_list.standard', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'extcommunity_list_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_extcommunity_list_standard_seq_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: extcommunity_list_name
    :param standard: Keyword argument tuple.

    :type extcommunity_list_name: unicode
    :param extcommunity_list_name: **standard** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id, ext_community_action, ext_community_expr
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ext_community_action: unicode
    :param ext_community_action: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ext_community_expr: unicode
    :param ext_community_expr: **seq** tuple argument:  Ext-community-list

        * pattern restriction: ::

            '(\s*)|(\s*((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|((([0-9]|[1-9][0-9]|1[0-9]{2'
            '}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1['
            '0-9]{2}|2[0-4][0-9]|25[0-5]):(([1-9][0-9]{0,8})|'
            '([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7'
            '})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949'
            '[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-'
            '1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-5]'
            ')))))((\s+((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|(((([0-9]|[1-9][0-9]|1[0-9]{'
            '2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,8}'
            ')|([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]'
            '{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(429'
            '49[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967['
            '0-1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-'
            '5])))))*)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.standard.seq', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'extcommunity_list_name', 'extra_keyval': ''}, {'keyval': 'extcommunity_list_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': 'seq_id, ext_community_action, ext_community_expr'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_extcommunity_list_standard_seq_ext_community_action_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: extcommunity_list_name
    :param standard: Keyword argument tuple.

    :type extcommunity_list_name: unicode
    :param extcommunity_list_name: **standard** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.standard.seq', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'extcommunity_list_name', 'extra_keyval': ''}, {'keyval': 'extcommunity_list_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_extcommunity_list_standard_seq_ext_community_expr_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: extcommunity_list_name
    :param standard: Keyword argument tuple.

    :type extcommunity_list_name: unicode
    :param extcommunity_list_name: **standard** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list.standard.seq', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'extcommunity_list_name', 'extra_keyval': ''}, {'keyval': 'extcommunity_list_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_hide_as_path_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_as_path_holder', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_as_path_holder', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_as_path_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_as_path_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_as_path_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.ip.hide_as_path_holder.as_path', u'access_list'), ('pybind.slxos.v17s_1_02.ip.hide_as_path_holder.as_path', u'access_list'), ('pybind.nos.v6_0_2f.ip.hide_as_path_holder.as_path', u'access_list'), ('pybind.nos.v7_2_0.ip.hide_as_path_holder.as_path', u'access_list'), ('pybind.slxos.v17r_2_00.ip.hide_as_path_holder.as_path', u'access_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_hide_community_list_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_community_list_holder', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_community_list_holder', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_community_list_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_community_list_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_community_list_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ip.hide_community_list_holder.community_list', u'standard'), ('pybind.slxos.v17r_2_00.ip.hide_community_list_holder.community_list', u'extended'), ('pybind.nos.v6_0_2f.ip.hide_community_list_holder.community_list', u'extended'), ('pybind.nos.v6_0_2f.ip.hide_community_list_holder.community_list', u'standard'), ('pybind.nos.v7_2_0.ip.hide_community_list_holder.community_list', u'standard'), ('pybind.nos.v7_2_0.ip.hide_community_list_holder.community_list', u'extended'), ('pybind.slxos.v17s_1_02.ip.hide_community_list_holder.community_list', u'extended'), ('pybind.slxos.v17s_1_02.ip.hide_community_list_holder.community_list', u'standard'), ('pybind.slxos.v17r_1_01a.ip.hide_community_list_holder.community_list', u'extended'), ('pybind.slxos.v17r_1_01a.ip.hide_community_list_holder.community_list', u'standard')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_hide_ext_community_list_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_ext_community_list_holder', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_ext_community_list_holder', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_ext_community_list_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list', u'standard'), ('pybind.slxos.v17r_2_00.ip.hide_ext_community_list_holder.extcommunity_list', u'extended'), ('pybind.nos.v6_0_2f.ip.hide_ext_community_list_holder', u'extcommunity_list'), ('pybind.nos.v7_2_0.ip.hide_ext_community_list_holder', u'extcommunity_list'), ('pybind.slxos.v17s_1_02.ip.hide_ext_community_list_holder.extcommunity_list', u'standard'), ('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list', u'standard'), ('pybind.slxos.v17r_1_01a.ip.hide_ext_community_list_holder.extcommunity_list', u'extended')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'extcommunity_list_name'}, {'leafval': 'extended_extcommunity_list_name'}, {'leafval': 'extcommunity_list_num, ext_community_action, ext_community_expr'}, {'leafval': 'extcommunity_list_num, ext_community_action, ext_community_regex, ext_community_expr'}, {'leafval': 'extcommunity_list_name, ext_community_action, ext_community_expr'}, {'leafval': 'extcommunity_list_name'}, {'leafval': 'extended_extcommunity_list_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_hide_prefix_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_prefix_holder', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_prefix_holder', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_prefix_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_prefix_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_prefix_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.ip.hide_prefix_holder', u'prefix_list'), ('pybind.slxos.v17r_2_00.ip.hide_prefix_holder', u'prefix_list'), ('pybind.nos.v6_0_2f.ip.hide_prefix_holder', u'prefix_list'), ('pybind.nos.v7_2_0.ip.hide_prefix_holder', u'prefix_list'), ('pybind.slxos.v17s_1_02.ip.hide_prefix_holder', u'prefix_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_icmp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ip.icmp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.icmp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.icmp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ip.icmp', u'echo'), ('pybind.slxos.v17r_1_01a.ip.icmp', u'echo'), ('pybind.slxos.v17r_2_00.ip.icmp', u'echo')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'broadcast_request'}, {'leafval': 'broadcast_request'}, {'leafval': 'broadcast_request'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_icmp_echo_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ip.icmp.echo', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.icmp.echo', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.icmp.echo', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_icmp_echo_broadcast_request_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ip.icmp.echo', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.icmp.echo', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.icmp.echo', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_igmp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.igmp_snooping.ip.igmp', 'pybind.nos.v6_0_2f.brocade_igmp_snooping', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.igmp_snooping.ip.igmp', 'pybind.nos.v7_2_0.brocade_igmp_snooping', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp', 'pybind.slxos.v17r_1_01a.brocade_igmp_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp', 'pybind.slxos.v17r_2_00.brocade_igmp_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp', 'pybind.slxos.v17s_1_02.brocade_igmp_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.igmp_snooping.ip.igmp', u'snooping'), ('pybind.nos.v6_0_2f.igmp_snooping.ip.igmp', u'snooping'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp', u'igmp_snooping'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp', u'igmp_snooping'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp', u'igmp_snooping'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'igmps_enable'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'igmps_enable'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'igmps_enable'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}]
    leafval_map = {"pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp": {"router_alert_check_disable": "router_alert_check_disable"}, "pybind.nos.v7_2_0.igmp_snooping.ip.igmp": {}, "pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp": {"router_alert_check_disable": "router_alert_check_disable"}, "pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp": {"router_alert_check_disable": "router_alert_check_disable"}, "pybind.nos.v6_0_2f.igmp_snooping.ip.igmp": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_igmp_router_alert_check_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp', 'pybind.slxos.v17r_1_01a.brocade_igmp_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp', 'pybind.slxos.v17r_2_00.brocade_igmp_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp', 'pybind.slxos.v17s_1_02.brocade_igmp_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp', u'igmp_snooping'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp', u'igmp_snooping'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp', u'igmp_snooping'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'igmps_enable'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'igmps_enable'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'igmps_enable'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_igmp_snooping_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.igmp_snooping.ip.igmp.snooping', 'pybind.nos.v6_0_2f.brocade_igmp_snooping', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.igmp_snooping.ip', 'pybind.nos.v7_2_0.brocade_igmp_snooping', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp.igmp_snooping', 'pybind.slxos.v17r_1_01a.brocade_igmp_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip', 'pybind.slxos.v17r_2_00.brocade_igmp_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip', 'pybind.slxos.v17s_1_02.brocade_igmp_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip', u'igmp'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.pim', u'snooping'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp', u'igmp_snooping'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip', u'igmp'), ('pybind.nos.v7_2_0.igmp_snooping.ip.pim', u'snooping'), ('pybind.nos.v7_2_0.igmp_snooping.ip.igmp', u'snooping'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip', u'igmp'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17s_1_02.capabilities.ip', u'igmp_snooping'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.pim', u'snooping'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp', u'igmp_snooping')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igmps_ssmmap'}, {'leafval': 'router_alert_check_disable'}, {'leafval': 'pimv4_enable'}, {'leafval': 'igmps_enable'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'router_alert_check_disable'}, {'leafval': 'pimv4_enable'}, {'leafval': 'enable'}, {'leafval': 'router_alert_check_disable'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'igmp_snooping_version'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'pimv4_enable'}, {'leafval': 'igmps_enable'}]
    leafval_map = {"pybind.slxos.v17r_2_00.igmp_snooping.ip": {}, "pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp.igmp_snooping": {"enable": "igmps_enable"}, "pybind.nos.v6_0_2f.igmp_snooping.ip.igmp.snooping": {"enable": "enable"}, "pybind.slxos.v17s_1_02.igmp_snooping.ip": {}, "pybind.nos.v7_2_0.igmp_snooping.ip": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_igmp_snooping_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.igmp_snooping.ip.igmp.snooping', 'pybind.nos.v7_2_0.brocade_igmp_snooping', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_igmp_snooping_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.igmp_snooping.ip.igmp.snooping', 'pybind.nos.v6_0_2f.brocade_igmp_snooping', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.igmp_snooping.ip.igmp.snooping', 'pybind.nos.v7_2_0.brocade_igmp_snooping', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp.igmp_snooping', 'pybind.slxos.v17r_1_01a.brocade_igmp_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp.igmp_snooping', 'pybind.slxos.v17r_2_00.brocade_igmp_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp.igmp_snooping', 'pybind.slxos.v17s_1_02.brocade_igmp_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip', u'igmp'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip', u'igmp'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip', u'igmp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igmps_ssmmap'}, {'leafval': 'router_alert_check_disable'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'router_alert_check_disable'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'igmps_ssmmap'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'router_alert_check_disable'}]
    leafval_map = {"pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp.igmp_snooping": {"enable": "igmps_enable"}, "pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp.igmp_snooping": {"enable": "igmps_enable"}, "pybind.nos.v6_0_2f.igmp_snooping.ip.igmp.snooping": {"enable": "enable"}, "pybind.nos.v7_2_0.igmp_snooping.ip.igmp.snooping": {"enable": "enable"}, "pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp.igmp_snooping": {"enable": "igmps_enable"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_igmp_snooping_igmp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp.igmp_snooping', 'pybind.slxos.v17r_2_00.brocade_igmp_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp.igmp_snooping', 'pybind.slxos.v17s_1_02.brocade_igmp_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp', u'ssm_map'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip', u'igmp'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip', u'igmp'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp', u'ssm_map')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igmps_ssmmap'}, {'leafval': 'router_alert_check_disable'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'router_alert_check_disable'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'igmps_ssmmap'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_igmp_ssm_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp.ssm_map', 'pybind.slxos.v17r_1_01a.brocade_igmp_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp.ssm_map', 'pybind.slxos.v17r_2_00.brocade_igmp_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp.ssm_map', 'pybind.slxos.v17s_1_02.brocade_igmp_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_igmp_ssm_map_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp.ssm_map', 'pybind.slxos.v17r_1_01a.brocade_igmp_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp.ssm_map', 'pybind.slxos.v17r_2_00.brocade_igmp_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp.ssm_map', 'pybind.slxos.v17s_1_02.brocade_igmp_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp.ssm_map', u'igmps_prefix_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}, {'leafval': 'igmps_prefix_list_name, igmps_prefix_src_addr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_igmp_ssm_map_igmps_prefix_list_get(self, igmps_prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type igmps_prefix_list: igmps_prefix_list_name, igmps_prefix_src_addr
    :param igmps_prefix_list: Keyword argument tuple.

    :type igmps_prefix_list_name: unicode
    :param igmps_prefix_list_name: **igmps_prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type igmps_prefix_src_addr: unicode
    :param igmps_prefix_src_addr: **igmps_prefix_list** tuple argument:  A.B.C.D     Source address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.igmp_snooping.ip.igmp.ssm_map.igmps_prefix_list', 'pybind.slxos.v17r_1_01a.brocade_igmp_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.igmp.ssm_map.igmps_prefix_list', 'pybind.slxos.v17r_2_00.brocade_igmp_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.igmp.ssm_map.igmps_prefix_list', 'pybind.slxos.v17s_1_02.brocade_igmp_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'igmps_prefix_list', 'keyval': 'igmps_prefix_list_name, igmps_prefix_src_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, igmps_prefix_list=igmps_prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, igmps_prefix_list=igmps_prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_import_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ip.rtm_config.import_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.import_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.import_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ip.rtm_config.import_', u'routes'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.import_', u'routes'), ('pybind.slxos.v17r_2_00.ip.rtm_config.import_', u'routes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'src_vrf, route_map'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'src_vrf, route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_import_routes_get(self, routes=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type routes: src_vrf, route_map
    :param routes: Keyword argument tuple.

    :type src_vrf: unicode
    :param src_vrf: **routes** tuple argument:  ASCII string;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type route_map: unicode
    :param route_map: **routes** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ip.rtm_config.import_.routes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.import_.routes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.import_.routes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'routes', 'keyval': 'src_vrf, route_map', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, routes=routes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, routes=routes)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_ip_acl_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip_acl.ip', 'pybind.nos.v6_0_2f.brocade_ip_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip_acl.ip', 'pybind.nos.v7_2_0.brocade_ip_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip_acl.ip', 'pybind.slxos.v17r_1_01a.brocade_ip_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip_acl.ip', 'pybind.slxos.v17r_2_00.brocade_ip_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip_acl.ip', 'pybind.slxos.v17s_1_02.brocade_ip_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list', u'standard'), ('pybind.slxos.v17r_1_01a.ip_acl.ip.access_list', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list', u'extended'), ('pybind.slxos.v17r_2_00.ip_acl.ip.access_list', u'standard'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list', u'standard'), ('pybind.nos.v6_0_2f.ip_acl.ip.access_list', u'extended'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list', u'extended'), ('pybind.nos.v7_2_0.ip_acl.ip.access_list', u'standard'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list', u'extended'), ('pybind.slxos.v17s_1_02.ip_acl.ip.access_list', u'standard')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_load_sharing_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_oif'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_nh'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_oif'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_nh'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.import_', u'routes'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.slxos.v17r_2_00.ip.rtm_config.import_', u'routes'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_nh'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_oif'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17s_1_02.ip.rtm_config.import_', u'routes'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_nh'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_oif'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static', u'bfd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'holdover_interval'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'holdover_interval'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'holdover_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_mtu_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.global_mtu_conf.ip', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_2_00.global_mtu_conf.ip', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.global_mtu_conf.ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_pim_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.igmp_snooping.ip.pim', 'pybind.nos.v7_2_0.brocade_igmp_snooping', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.pim', 'pybind.slxos.v17r_1_01a.brocade_igmp_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.pim', 'pybind.slxos.v17r_2_00.brocade_igmp_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.pim', 'pybind.slxos.v17s_1_02.brocade_igmp_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.igmp_snooping.ip.pim', u'snooping'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.pim', u'snooping'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.pim', u'snooping'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.pim', u'snooping')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'pimv4_enable'}, {'leafval': 'pimv4_enable'}, {'leafval': 'pimv4_enable'}, {'leafval': 'pimv4_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_pim_snooping_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.igmp_snooping.ip.pim.snooping', 'pybind.nos.v7_2_0.brocade_igmp_snooping', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.pim.snooping', 'pybind.slxos.v17r_1_01a.brocade_igmp_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.pim.snooping', 'pybind.slxos.v17r_2_00.brocade_igmp_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.pim.snooping', 'pybind.slxos.v17s_1_02.brocade_igmp_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_pim_snooping_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.igmp_snooping.ip.pim.snooping', 'pybind.nos.v7_2_0.brocade_igmp_snooping', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.igmp_snooping.ip.pim.snooping', 'pybind.slxos.v17r_1_01a.brocade_igmp_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.igmp_snooping.ip.pim.snooping', 'pybind.slxos.v17r_2_00.brocade_igmp_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.igmp_snooping.ip.pim.snooping', 'pybind.slxos.v17s_1_02.brocade_igmp_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_prefix_list_get(self, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type action_ipp: unicode
    :param action_ipp: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type prefix_ipp: unicode
    :param prefix_ipp: **prefix_list** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type ge_ipp: long
    :param ge_ipp: **prefix_list** tuple argument:  Minimum IP prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type le_ipp: long
    :param le_ipp: **prefix_list** tuple argument:  Maximum IP prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_prefix_list_action_ipp_get(self, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_prefix_list_ge_get(self, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_prefix_list_le_get(self, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_prefix_list_prefix_ipp_get(self, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.hide_prefix_holder.prefix_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.hide_prefix_holder.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_receive_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ip.receive', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ip.receive', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ip.receive', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.ip.receive', u'access_group'), ('pybind.slxos.v17r_1_01a.routing_system.ip.receive', u'access_group'), ('pybind.slxos.v17s_1_02.routing_system.ip.receive', u'access_group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'acl_name'}, {'leafval': 'acl_name'}, {'leafval': 'ip_access_list, ip_direction'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_receive_access_group_get(self, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type access_group: acl_name
    :param access_group: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ip.receive.access_group', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ip.receive.access_group', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_receive_access_group_ip_access_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.ip.receive.access_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_receive_access_group_ip_direction_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.ip.receive.access_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_oif'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_nh'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_nh'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_oif'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static', u'bfd'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_oif'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_nh'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_nh'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_oif'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd', u'bfd_static_route')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'holdover_interval'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'holdover_interval'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'holdover_interval'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static', u'bfd'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static', u'bfd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'holdover_interval'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'holdover_interval'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'holdover_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_bfd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd', u'bfd_static_route')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd": {"holdover_interval": "holdover_interval"}, "pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd": {"holdover_interval": "holdover_interval"}, "pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd": {}, "pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd": {"holdover_interval": "holdover_interval"}, "pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_bfd_bfd_static_route_get(self, bfd_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd.bfd_static_route', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd.bfd_static_route', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd.bfd_static_route', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd.bfd_static_route', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd.bfd_static_route', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_interval_attributes'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_interval_attributes'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_interval_attributes'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_interval_attributes'), ('pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_interval_attributes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bfd_static_route', 'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bfd_static_route=bfd_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_bfd_bfd_static_route_interval_get(self, bfd_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bfd_static_route=bfd_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_bfd_bfd_static_route_min_rx_get(self, bfd_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bfd_static_route=bfd_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_bfd_bfd_static_route_multiplier_get(self, bfd_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bfd_static_route=bfd_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_bfd_holdover_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd', u'bfd_static_route')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_route_nh_get(self, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_nh', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_nh', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_nh', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_nh', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_nh', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_nh', u'route_attributes'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_nh', u'route_attributes'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_nh', u'route_attributes'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_nh', u'route_attributes'), ('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_nh', u'route_attributes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_route_nh', 'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_route_nh_distance_get(self, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_route_nh_metric_get(self, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_route_nh_tag_get(self, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_route_nh_vrf_get(self, static_route_nh_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop
    :param static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_nh_vrf** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh_vrf** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_nh_vrf', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_nh_vrf', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_nh_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_nh_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_nh_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh_vrf=static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh_vrf=static_route_nh_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_route_oif_get(self, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_oif', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_oif', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_oif', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_oif', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_oif', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_oif', u'route_attributes'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_oif', u'route_attributes'), ('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_oif', u'route_attributes'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_oif', u'route_attributes'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_oif', u'route_attributes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_route_oif', 'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_route_oif_distance_get(self, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_route_oif_metric_get(self, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_route_oif_tag_get(self, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_route_static_route_oif_vrf_get(self, static_route_oif_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type static_route_oif_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name
    :param static_route_oif_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_oif_vrf** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_oif_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static_route_oif_vrf', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static_route_oif_vrf', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static_route_oif_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static_route_oif_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static_route_oif_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_route_oif_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif_vrf=static_route_oif_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif_vrf=static_route_oif_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_router_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_oif'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_nh'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_oif'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_nh'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.import_', u'routes'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.slxos.v17r_2_00.ip.rtm_config.import_', u'routes'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_nh'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_oif'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17s_1_02.ip.rtm_config.import_', u'routes'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_nh'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_oif'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static', u'bfd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'holdover_interval'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'holdover_interval'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'holdover_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_routing_system_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ip', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ip', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ip', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.ip.dhcp.relay', u'information'), ('pybind.slxos.v17r_1_01a.routing_system.ip.receive', u'access_group'), ('pybind.slxos.v17r_2_00.routing_system.ip.receive', u'access_group'), ('pybind.slxos.v17r_2_00.routing_system.ip.static_ag_ip_config', u'anycast_gateway_mac'), ('pybind.slxos.v17r_2_00.routing_system.ip.dhcp.relay', u'information'), ('pybind.slxos.v17s_1_02.routing_system.ip.receive', u'access_group'), ('pybind.slxos.v17s_1_02.routing_system.ip.dhcp.relay', u'information'), ('pybind.slxos.v17s_1_02.routing_system.ip.static_ag_ip_config', u'anycast_gateway_mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'option'}, {'leafval': 'acl_name'}, {'leafval': 'acl_name'}, {'leafval': 'ip_anycast_gateway_mac, ip_anycast_default_mac'}, {'leafval': 'option'}, {'leafval': 'ip_access_list, ip_direction'}, {'leafval': 'option'}, {'leafval': 'ip_anycast_gateway_mac, ip_anycast_default_mac'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_rtm_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ip.rtm_config', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ip.rtm_config', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ip.rtm_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ip.rtm_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ip.rtm_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_oif'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_nh'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.nos.v6_0_2f.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_oif'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_nh'), ('pybind.nos.v7_2_0.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.nos.v7_2_0.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.import_', u'routes'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_1_01a.ip.rtm_config.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.slxos.v17r_2_00.ip.rtm_config.import_', u'routes'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_nh'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route', u'static_route_oif'), ('pybind.slxos.v17r_2_00.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17s_1_02.ip.rtm_config.import_', u'routes'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_nh'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route', u'static_route_oif'), ('pybind.slxos.v17s_1_02.ip.rtm_config.route.static', u'bfd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'holdover_interval'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'holdover_interval'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'holdover_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ip_static_ag_ip_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.ip.static_ag_ip_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ip.static_ag_ip_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.ip.static_ag_ip_config', u'anycast_gateway_mac'), ('pybind.slxos.v17r_2_00.routing_system.ip.static_ag_ip_config', u'anycast_gateway_mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_anycast_gateway_mac, ip_anycast_default_mac'}, {'leafval': 'ip_anycast_gateway_mac, ip_anycast_default_mac'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ipv6', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.global_mtu_conf.ipv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.global_mtu_conf.ipv6', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.global_mtu_conf.ipv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.ipv6.hide_prefix_holder', u'prefix_list'), ('pybind.nos.v6_0_2f.vcs.virtual.ipv6', u'address'), ('pybind.nos.v6_0_2f.ipv6.ipv6route', u'route'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.nos.v6_0_2f.mld_snooping.ipv6.mld', u'snooping'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global', u'domain_name_global'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.ipv6.import_', u'routes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.ipv6.route.static', u'bfd'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds', u'nd_global'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ipv6', u'address'), ('pybind.slxos.v17r_1_01a.ipv6', u'proto_vrrpv3'), ('pybind.slxos.v17r_1_01a.ipv6', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.mld_snooping.ipv6.pim', u'snooping'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global', u'dns_server_global'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global', u'dad'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.control_plane.ipv6', u'subnet_rate_limit'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash', u'ipv6'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.slxos.v17r_1_01a.ipv6.route', u'link_local_static_route_nh'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.receive', u'access_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.mld_snooping.ipv6.mld', u'snooping'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6route', u'route'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.ipv6.route', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.capabilities', u'ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_1_01a.ipv6.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.slxos.v17r_1_01a.ipv6.route', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'ipv6address'}, {'leafval': 'dest, next_hop'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'enable'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'timer'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'domain_name_string_global, domain_name_lifetime_global'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'global_suppress_ra'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'ipv6address'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'pimv6_enable'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'dns_server_prefix_global, dns_server_lifetime_global'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'timer'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'global_dad_time'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'cir, cbr'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'ipv6_src_l4_port, ipv6_dst_l4_port, ipv6_src_ip, ipv6_dst_ip, ipv6_next_hdr'}, {'leafval': 'name'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'acl_name'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'enable'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'dest, next_hop'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'ipv6Raguard'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.ipv6": {}, "pybind.slxos.v17r_2_00.global_mtu_conf.ipv6": {"global_ipv6_mtu": "global_ipv6_mtu"}, "pybind.slxos.v17s_1_02.global_mtu_conf.ipv6": {"global_ipv6_mtu": "global_ipv6_mtu"}, "pybind.nos.v6_0_2f.ipv6": {}, "pybind.nos.v7_2_0.global_mtu_conf.ipv6": {"global_ipv6_mtu": "global_ipv6_mtu"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.ipv6', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_2_00.ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.slxos.v17s_1_02.control_plane.ipv6', u'subnet_rate_limit'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global', u'dad'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17s_1_02.ipv6.route', u'static_route_nh'), ('pybind.slxos.v17s_1_02.ipv6.route', u'link_local_static_route_nh'), ('pybind.slxos.v17s_1_02.ipv6.ipv6route', u'route'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.global_mtu_conf', u'ipv6'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global', u'domain_name_global'), ('pybind.slxos.v17s_1_02.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.slxos.v17s_1_02.ipv6', u'proto_vrrpv3'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.receive', u'access_group'), ('pybind.slxos.v17s_1_02.ipv6.route.static', u'bfd'), ('pybind.slxos.v17s_1_02.ipv6.import_', u'routes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds', u'nd_global'), ('pybind.slxos.v17s_1_02.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.static_ag_ipv6_config', u'anycast_gateway_mac'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.mld_snooping.ipv6.pim', u'snooping'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6', u'prefix_list'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17s_1_02.ipv6.route', u'static_route_oif'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17s_1_02.vcs.virtual.ipv6', u'address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17s_1_02.mld_snooping.ipv6.mld', u'snooping'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.ipv6.route', u'static_route_nh_vrf'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global', u'dns_server_global'), ('pybind.slxos.v17s_1_02.load_balance.hash', u'ipv6'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.capabilities', u'ipv6'), ('pybind.slxos.v17r_2_00.ipv6.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.control_plane.ipv6', u'subnet_rate_limit'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.receive', u'access_group'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global', u'domain_name_global'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global', u'dns_server_global'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.ipv6.route', u'static_route_nh'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.ipv6', u'proto_vrrpv3'), ('pybind.slxos.v17r_2_00.ipv6.route', u'link_local_static_route_nh'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.ipv6.route', u'static_route_oif'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.mld_snooping.ipv6.pim', u'snooping'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.slxos.v17r_2_00.ipv6.ipv6route', u'route'), ('pybind.slxos.v17r_2_00.capabilities', u'ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.static_ag_ipv6_config', u'anycast_gateway_mac'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.slxos.v17r_2_00.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds', u'nd_global'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global', u'dad'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.ipv6', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash', u'ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.global_mtu_conf', u'ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.mld_snooping.ipv6.mld', u'snooping'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.slxos.v17r_2_00.vcs.virtual.ipv6', u'address'), ('pybind.slxos.v17r_2_00.ipv6.import_', u'routes'), ('pybind.slxos.v17r_2_00.ipv6.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.ipv6.hide_prefix_holder', u'prefix_list'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.nos.v7_2_0.global_mtu_conf', u'ipv6'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.nos.v7_2_0.mld_snooping.ipv6.pim', u'snooping'), ('pybind.nos.v7_2_0.ipv6.ipv6route', u'route'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.nos.v7_2_0.vcs.virtual.ipv6', u'address'), ('pybind.nos.v7_2_0.mld_snooping.ipv6.mld', u'snooping'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list', u'standard')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'ipv6address'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'cir, cbr'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'global_dad_time'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'dest, next_hop'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'global_ipv6_mtu'}, {'leafval': 'timer'}, {'leafval': 'domain_name_string_global, domain_name_lifetime_global'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ipv6_access_list, ip_direction'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'name'}, {'leafval': 'global_suppress_ra'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'ipv6_anycast_gateway_mac, ipv6_anycast_default_mac'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'pimv6_enable'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'ipv6address'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'enable'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'name'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'dns_server_prefix_global, dns_server_lifetime_global'}, {'leafval': 'ipv6_src_l4_port, ipv6_dst_l4_port, ipv6_src_ip, ipv6_dst_ip, ipv6_next_hdr'}, {'leafval': 'table_map_route_map'}, {'leafval': 'ipv6Raguard'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'cir, cbr'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'acl_name'}, {'leafval': 'domain_name_string_global, domain_name_lifetime_global'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'dns_server_prefix_global, dns_server_lifetime_global'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability, auth_transition'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'timer'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'pimv6_enable'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'name'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'dest, next_hop'}, {'leafval': 'ipv6Raguard'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ipv6_anycast_gateway_mac, ipv6_anycast_default_mac'}, {'leafval': 'name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'global_suppress_ra'}, {'leafval': 'ipv6address'}, {'leafval': 'global_dad_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'ipv6_src_l4_port, ipv6_dst_l4_port, ipv6_src_ip, ipv6_dst_ip, ipv6_next_hdr'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'global_ipv6_mtu'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'enable'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'ipv6address'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'name'}, {'leafval': 'global_ipv6_mtu'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'pimv6_enable'}, {'leafval': 'dest, next_hop'}, {'leafval': 'timer'}, {'leafval': 'ipv6address'}, {'leafval': 'enable'}, {'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list', u'extended')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_get(self, extended=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'seq'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'seq'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'seq'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'seq'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'seq')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, dscp_force, drop_precedence_force, urg, ack, push, fin, rst, sync, vlan, count, log, mirror, copy_sflow'}, {'leafval': 'seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, urg, ack, push, fin, rst, sync, vlan, count, log'}, {'leafval': 'seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, dscp_force, drop_precedence_force, urg, ack, push, fin, rst, sync, vlan, count, log, mirror, copy_sflow'}, {'leafval': 'seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, dscp_force, drop_precedence_force, urg, ack, push, fin, rst, sync, vlan, count, log, mirror, copy_sflow'}, {'leafval': 'seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, urg, ack, push, fin, rst, sync, vlan, count, log'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, urg, ack, push, fin, rst, sync, vlan, count, log
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type action: unicode
    :param action: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type protocol_type: unicode
    :param protocol_type: **seq** tuple argument.

        * enumeration restriction: ::

            ['udp', 'ipv6-icmp', 'tcp', 'ipv6']

    :type src_host_any_sip: unicode
    :param src_host_any_sip: **seq** tuple argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type src_host_ip: unicode
    :param src_host_ip: **seq** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type src_mask: unicode
    :param src_mask: **seq** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type sport: unicode
    :param sport: **seq** tuple argument.

        * enumeration restriction: ::

            ['lt', 'gt', 'eq', 'range', 'neq']

    :type sport_number_eq_neq_tcp: unicode
    :param sport_number_eq_neq_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_lt_tcp: unicode
    :param sport_number_lt_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_gt_tcp: unicode
    :param sport_number_gt_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_eq_neq_udp: unicode
    :param sport_number_eq_neq_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_lt_udp: unicode
    :param sport_number_lt_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_gt_udp: unicode
    :param sport_number_gt_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_range_lower_tcp: unicode
    :param sport_number_range_lower_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_range_lower_udp: unicode
    :param sport_number_range_lower_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type sport_number_range_higher_tcp: unicode
    :param sport_number_range_higher_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type sport_number_range_higher_udp: unicode
    :param sport_number_range_higher_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dst_host_any_dip: unicode
    :param dst_host_any_dip: **seq** tuple argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type dst_host_ip: unicode
    :param dst_host_ip: **seq** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type dst_mask: unicode
    :param dst_mask: **seq** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type dport: unicode
    :param dport: **seq** tuple argument.

        * enumeration restriction: ::

            ['lt', 'gt', 'eq', 'range', 'neq']

    :type dport_number_eq_neq_tcp: unicode
    :param dport_number_eq_neq_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_lt_tcp: unicode
    :param dport_number_lt_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_gt_tcp: unicode
    :param dport_number_gt_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_eq_neq_udp: unicode
    :param dport_number_eq_neq_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_lt_udp: unicode
    :param dport_number_lt_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_gt_udp: unicode
    :param dport_number_gt_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_range_lower_tcp: unicode
    :param dport_number_range_lower_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_range_lower_udp: unicode
    :param dport_number_range_lower_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dport_number_range_higher_tcp: unicode
    :param dport_number_range_higher_tcp: **seq** tuple argument.

        * enumeration restriction: ::

            ['ftp',
            'domain',
            'tacacs',
            'hostname',
            'smtp',
            'www',
            'telnet',
            'echo',
            'bgp',
            'syslog',
            'ftp-data',
            'daytime',
            'time',
            'pim-auto-rp',
            'login',
            'talk']

    :type dport_number_range_higher_udp: unicode
    :param dport_number_range_higher_udp: **seq** tuple argument.

        * enumeration restriction: ::

            ['domain',
            'ntp',
            'rip',
            'echo',
            'syslog',
            'pim-auto-rp',
            'tacacs',
            'snmp',
            'bootps',
            'tftp',
            'bootpc']

    :type dscp: unicode
    :param dscp: **seq** tuple argument:  Differentiated Service Code Point

        * enumeration restriction: ::

            ['af23',
            'af22',
            'af21',
            'af33',
            'af41',
            'af43',
            'af31',
            'default',
            'af42',
            'af12',
            'af32',
            'af13',
            'cs6',
            'cs2',
            'cs5',
            'cs4',
            'cs7',
            'af11',
            'cs1',
            'cs3',
            'ef']

    :type urg: YANGBool
    :param urg: **seq** tuple argument:  Urgent

    :type ack: YANGBool
    :param ack: **seq** tuple argument:  Acknowledgement

    :type push: YANGBool
    :param push: **seq** tuple argument:  Push

    :type fin: YANGBool
    :param fin: **seq** tuple argument:  No more data

    :type rst: YANGBool
    :param rst: **seq** tuple argument:  Reset connection

    :type sync: YANGBool
    :param sync: **seq** tuple argument:  Synchronize

    :type vlan: long
    :param vlan: **seq** tuple argument:  Vlan

        * range restriction: ::

            ['0..4294967295']

    :type count: YANGBool
    :param count: **seq** tuple argument:  Packet Count

    :type log: YANGBool
    :param log: **seq** tuple argument:  Log Packet

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': 'seq_id, action, protocol_type, src_host_any_sip, src_host_ip, src_mask, sport, sport_number_eq_neq_tcp, sport_number_lt_tcp, sport_number_gt_tcp, sport_number_eq_neq_udp, sport_number_lt_udp, sport_number_gt_udp, sport_number_range_lower_tcp, sport_number_range_lower_udp, sport_number_range_higher_tcp, sport_number_range_higher_udp, dst_host_any_dip, dst_host_ip, dst_mask, dport, dport_number_eq_neq_tcp, dport_number_lt_tcp, dport_number_gt_tcp, dport_number_eq_neq_udp, dport_number_lt_udp, dport_number_gt_udp, dport_number_range_lower_tcp, dport_number_range_lower_udp, dport_number_range_higher_tcp, dport_number_range_higher_udp, dscp, urg, ack, push, fin, rst, sync, vlan, count, log'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq": {}, "pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq": {"dport_number_range_higher_udp": "dport_number_range_higher_udp", "sport_number_range_lower_tcp": "sport_number_range_lower_tcp", "push": "push", "sport_number_eq_neq_udp": "sport_number_eq_neq_udp", "sport_number_range_higher_tcp": "sport_number_range_higher_tcp", "sync": "sync", "sport": "sport", "src_mask": "src_mask", "dport_number_lt_udp": "dport_number_lt_udp", "sport_number_range_lower_udp": "sport_number_range_lower_udp", "log": "log", "seq_id": "seq_id", "dport_number_range_lower_tcp": "dport_number_range_lower_tcp", "dport_number_eq_neq_udp": "dport_number_eq_neq_udp", "src_host_ip": "src_host_ip", "sport_number_lt_tcp": "sport_number_lt_tcp", "sport_number_gt_tcp": "sport_number_gt_tcp", "dport_number_gt_udp": "dport_number_gt_udp", "fin": "fin", "dport_number_gt_tcp": "dport_number_gt_tcp", "vlan": "vlan", "dport_number_range_higher_tcp": "dport_number_range_higher_tcp", "sport_number_eq_neq_tcp": "sport_number_eq_neq_tcp", "dscp": "dscp", "sport_number_range_higher_udp": "sport_number_range_higher_udp", "action": "action", "dst_host_ip": "dst_host_ip", "rst": "rst", "dst_mask": "dst_mask", "protocol_type": "protocol_type", "count": "count", "urg": "urg", "dport_number_lt_tcp": "dport_number_lt_tcp", "ack": "ack", "dport_number_eq_neq_tcp": "dport_number_eq_neq_tcp", "dport_number_range_lower_udp": "dport_number_range_lower_udp", "dport": "dport", "src_host_any_sip": "src_host_any_sip", "dst_host_any_dip": "dst_host_any_dip", "sport_number_lt_udp": "sport_number_lt_udp", "sport_number_gt_udp": "sport_number_gt_udp"}, "pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq": {}, "pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq": {}, "pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq": {"dport_number_range_higher_udp": "dport_number_range_higher_udp", "sport_number_range_lower_tcp": "sport_number_range_lower_tcp", "push": "push", "sport_number_eq_neq_udp": "sport_number_eq_neq_udp", "sport_number_range_higher_tcp": "sport_number_range_higher_tcp", "sync": "sync", "sport": "sport", "src_mask": "src_mask", "dport_number_lt_udp": "dport_number_lt_udp", "sport_number_range_lower_udp": "sport_number_range_lower_udp", "log": "log", "seq_id": "seq_id", "dport_number_range_lower_tcp": "dport_number_range_lower_tcp", "dport_number_eq_neq_udp": "dport_number_eq_neq_udp", "src_host_ip": "src_host_ip", "sport_number_lt_tcp": "sport_number_lt_tcp", "sport_number_gt_tcp": "sport_number_gt_tcp", "dport_number_gt_udp": "dport_number_gt_udp", "fin": "fin", "dport_number_gt_tcp": "dport_number_gt_tcp", "vlan": "vlan", "dport_number_range_higher_tcp": "dport_number_range_higher_tcp", "sport_number_eq_neq_tcp": "sport_number_eq_neq_tcp", "dscp": "dscp", "sport_number_range_higher_udp": "sport_number_range_higher_udp", "action": "action", "dst_host_ip": "dst_host_ip", "rst": "rst", "dst_mask": "dst_mask", "protocol_type": "protocol_type", "count": "count", "urg": "urg", "dport_number_lt_tcp": "dport_number_lt_tcp", "ack": "ack", "dport_number_eq_neq_tcp": "dport_number_eq_neq_tcp", "dport_number_range_lower_udp": "dport_number_range_lower_udp", "dport": "dport", "src_host_any_sip": "src_host_any_sip", "dst_host_any_dip": "dst_host_any_dip", "sport_number_lt_udp": "sport_number_lt_udp", "sport_number_gt_udp": "sport_number_gt_udp"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_ack_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_action_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_copy_sflow_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_count_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_eq_neq_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_eq_neq_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_gt_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_gt_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_lt_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_lt_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_range_higher_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_range_higher_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_range_lower_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_dport_number_range_lower_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_drop_precedence_force_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_dscp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_dscp_force_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_dst_host_any_dip_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_dst_host_ip_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_dst_mask_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_fin_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_log_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_mirror_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_protocol_type_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_push_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_rst_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_eq_neq_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_eq_neq_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_gt_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_gt_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_lt_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_lt_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_range_higher_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_range_higher_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_range_lower_tcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_sport_number_range_lower_udp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_src_host_any_sip_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_src_host_ip_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_src_mask_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_sync_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_urg_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_extended_seq_vlan_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.extended.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_standard_get(self, standard=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard', u'seq'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard', u'seq'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard', u'seq'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard', u'seq'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard', u'seq')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log'}, {'leafval': 'seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log'}, {'leafval': 'seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log, copy_sflow'}, {'leafval': 'seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log, copy_sflow'}, {'leafval': 'seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log, copy_sflow'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_standard_seq_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type action: unicode
    :param action: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type src_host_any_sip: unicode
    :param src_host_any_sip: **seq** tuple argument.

        * enumeration restriction: ::

            ['host', 'any']

    :type src_host_ip: unicode
    :param src_host_ip: **seq** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type src_mask: unicode
    :param src_mask: **seq** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type count: YANGBool
    :param count: **seq** tuple argument:  Packet count

    :type log: YANGBool
    :param log: **seq** tuple argument:  Log Packet

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': 'seq_id, action, src_host_any_sip, src_host_ip, src_mask, count, log'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard.seq": {}, "pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard.seq": {"count": "count", "log": "log", "seq_id": "seq_id", "src_host_ip": "src_host_ip", "action": "action", "src_host_any_sip": "src_host_any_sip", "src_mask": "src_mask"}, "pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard.seq": {}, "pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard.seq": {"count": "count", "log": "log", "seq_id": "seq_id", "src_host_ip": "src_host_ip", "action": "action", "src_host_any_sip": "src_host_any_sip", "src_mask": "src_mask"}, "pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard.seq": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_standard_seq_action_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_standard_seq_copy_sflow_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_standard_seq_count_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_standard_seq_log_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_standard_seq_src_host_any_sip_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_standard_seq_src_host_ip_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_access_list_standard_seq_src_mask_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list.standard.seq', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_acl_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list', u'extended')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_anycast_gateway_mac_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.static_ag_ipv6_config.anycast_gateway_mac', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.static_ag_ipv6_config.anycast_gateway_mac', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_anycast_gateway_mac_default_mac_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.static_ag_ipv6_config.anycast_gateway_mac', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.static_ag_ipv6_config.anycast_gateway_mac', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_anycast_gateway_mac_ipv6_anycast_gateway_mac_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.static_ag_ipv6_config.anycast_gateway_mac', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.static_ag_ipv6_config.anycast_gateway_mac', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_hide_prefix_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ipv6.hide_prefix_holder', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6.hide_prefix_holder', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.ipv6.hide_prefix_holder', u'prefix_list'), ('pybind.nos.v7_2_0.ipv6.hide_prefix_holder', u'prefix_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_import_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.import_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.import_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.import_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ipv6.import_', u'routes'), ('pybind.slxos.v17r_1_01a.ipv6.import_', u'routes'), ('pybind.slxos.v17r_2_00.ipv6.import_', u'routes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'src_vrf, route_map'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'src_vrf, route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_import_routes_get(self, routes=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type routes: src_vrf, route_map
    :param routes: Keyword argument tuple.

    :type src_vrf: unicode
    :param src_vrf: **routes** tuple argument:  ASCII string;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type route_map: unicode
    :param route_map: **routes** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.import_.routes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.import_.routes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.import_.routes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'routes', 'keyval': 'src_vrf, route_map', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, routes=routes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, routes=routes)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_ipv6_acl_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ipv6_acl.ipv6', 'pybind.nos.v6_0_2f.brocade_ipv6_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6', 'pybind.nos.v7_2_0.brocade_ipv6_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6', 'pybind.slxos.v17r_1_01a.brocade_ipv6_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6', 'pybind.slxos.v17r_2_00.brocade_ipv6_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6', 'pybind.slxos.v17s_1_02.brocade_ipv6_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.slxos.v17r_2_00.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.slxos.v17s_1_02.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.nos.v6_0_2f.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list', u'extended'), ('pybind.nos.v7_2_0.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list', u'standard'), ('pybind.slxos.v17r_1_01a.ipv6_acl.ipv6.access_list', u'extended')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_ipv6_global_cmds_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global', u'dad'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global', u'domain_name_global'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds', u'nd_global'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global', u'dns_server_global'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global', u'domain_name_global'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global', u'dns_server_global'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds', u'nd_global'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global', u'dad'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global', u'domain_name_global'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds', u'nd_global'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global', u'dns_server_global'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global', u'dad')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'global_dad_time'}, {'leafval': 'domain_name_string_global, domain_name_lifetime_global'}, {'leafval': 'global_suppress_ra'}, {'leafval': 'dns_server_prefix_global, dns_server_lifetime_global'}, {'leafval': 'domain_name_string_global, domain_name_lifetime_global'}, {'leafval': 'dns_server_prefix_global, dns_server_lifetime_global'}, {'leafval': 'global_suppress_ra'}, {'leafval': 'global_dad_time'}, {'leafval': 'domain_name_string_global, domain_name_lifetime_global'}, {'leafval': 'global_suppress_ra'}, {'leafval': 'dns_server_prefix_global, dns_server_lifetime_global'}, {'leafval': 'global_dad_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_ipv6route_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ipv6.ipv6route', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6.ipv6route', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6route', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.ipv6route', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.ipv6route', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ipv6.ipv6route', u'route'), ('pybind.nos.v6_0_2f.ipv6.ipv6route', u'route'), ('pybind.slxos.v17s_1_02.ipv6.ipv6route', u'route'), ('pybind.nos.v7_2_0.ipv6.ipv6route', u'route'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6route', u'route')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dest, next_hop'}, {'leafval': 'dest, next_hop'}, {'leafval': 'dest, next_hop'}, {'leafval': 'dest, next_hop'}, {'leafval': 'dest, next_hop'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_mld_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mld_snooping.ipv6.mld', 'pybind.nos.v6_0_2f.brocade_mld_snooping', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mld_snooping.ipv6.mld', 'pybind.nos.v7_2_0.brocade_mld_snooping', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mld_snooping.ipv6.mld', 'pybind.slxos.v17r_1_01a.brocade_mld_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mld_snooping.ipv6.mld', 'pybind.slxos.v17r_2_00.brocade_mld_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mld_snooping.ipv6.mld', 'pybind.slxos.v17s_1_02.brocade_mld_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.mld_snooping.ipv6.mld', u'snooping'), ('pybind.slxos.v17r_2_00.mld_snooping.ipv6.mld', u'snooping'), ('pybind.nos.v7_2_0.mld_snooping.ipv6.mld', u'snooping'), ('pybind.slxos.v17s_1_02.mld_snooping.ipv6.mld', u'snooping'), ('pybind.slxos.v17r_1_01a.mld_snooping.ipv6.mld', u'snooping')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_mld_snooping_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mld_snooping.ipv6', 'pybind.nos.v6_0_2f.brocade_mld_snooping', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mld_snooping.ipv6', 'pybind.nos.v7_2_0.brocade_mld_snooping', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mld_snooping.ipv6', 'pybind.slxos.v17r_1_01a.brocade_mld_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mld_snooping.ipv6', 'pybind.slxos.v17r_2_00.brocade_mld_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mld_snooping.ipv6', 'pybind.slxos.v17s_1_02.brocade_mld_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mld_snooping.ipv6.pim', u'snooping'), ('pybind.slxos.v17s_1_02.mld_snooping.ipv6.mld', u'snooping'), ('pybind.slxos.v17r_2_00.mld_snooping.ipv6.pim', u'snooping'), ('pybind.slxos.v17r_2_00.mld_snooping.ipv6.mld', u'snooping'), ('pybind.slxos.v17r_1_01a.mld_snooping.ipv6.pim', u'snooping'), ('pybind.slxos.v17r_1_01a.mld_snooping.ipv6.mld', u'snooping'), ('pybind.nos.v7_2_0.mld_snooping.ipv6.pim', u'snooping'), ('pybind.nos.v7_2_0.mld_snooping.ipv6.mld', u'snooping'), ('pybind.nos.v6_0_2f.mld_snooping.ipv6.mld', u'snooping')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'pimv6_enable'}, {'leafval': 'enable'}, {'leafval': 'pimv6_enable'}, {'leafval': 'enable'}, {'leafval': 'pimv6_enable'}, {'leafval': 'enable'}, {'leafval': 'pimv6_enable'}, {'leafval': 'enable'}, {'leafval': 'enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_mld_snooping_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mld_snooping.ipv6.mld.snooping', 'pybind.nos.v6_0_2f.brocade_mld_snooping', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mld_snooping.ipv6.mld.snooping', 'pybind.nos.v7_2_0.brocade_mld_snooping', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mld_snooping.ipv6.mld.snooping', 'pybind.slxos.v17r_1_01a.brocade_mld_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mld_snooping.ipv6.mld.snooping', 'pybind.slxos.v17r_2_00.brocade_mld_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mld_snooping.ipv6.mld.snooping', 'pybind.slxos.v17s_1_02.brocade_mld_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_mld_snooping_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mld_snooping.ipv6.mld.snooping', 'pybind.nos.v6_0_2f.brocade_mld_snooping', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mld_snooping.ipv6.mld.snooping', 'pybind.nos.v7_2_0.brocade_mld_snooping', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mld_snooping.ipv6.mld.snooping', 'pybind.slxos.v17r_1_01a.brocade_mld_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mld_snooping.ipv6.mld.snooping', 'pybind.slxos.v17r_2_00.brocade_mld_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mld_snooping.ipv6.mld.snooping', 'pybind.slxos.v17s_1_02.brocade_mld_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_mtu_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.global_mtu_conf.ipv6', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_2_00.global_mtu_conf.ipv6', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.global_mtu_conf.ipv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_nd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global', u'domain_name_global'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global', u'dns_server_global'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global', u'dad'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global', u'dad'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global', u'domain_name_global'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global', u'dns_server_global'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global', u'domain_name_global'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global', u'dns_server_global'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global', u'dad')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'domain_name_string_global, domain_name_lifetime_global'}, {'leafval': 'dns_server_prefix_global, dns_server_lifetime_global'}, {'leafval': 'global_dad_time'}, {'leafval': 'global_dad_time'}, {'leafval': 'domain_name_string_global, domain_name_lifetime_global'}, {'leafval': 'dns_server_prefix_global, dns_server_lifetime_global'}, {'leafval': 'domain_name_string_global, domain_name_lifetime_global'}, {'leafval': 'dns_server_prefix_global, dns_server_lifetime_global'}, {'leafval': 'global_dad_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_nd_dad_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_nd_dad_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_nd_global_suppress_ra_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global', u'domain_name_global'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global', u'dns_server_global'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global', u'dad'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global', u'dad'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global', u'domain_name_global'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global', u'dns_server_global'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global', u'domain_name_global'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global', u'dns_server_global'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global', u'dad')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'domain_name_string_global, domain_name_lifetime_global'}, {'leafval': 'dns_server_prefix_global, dns_server_lifetime_global'}, {'leafval': 'global_dad_time'}, {'leafval': 'global_dad_time'}, {'leafval': 'domain_name_string_global, domain_name_lifetime_global'}, {'leafval': 'dns_server_prefix_global, dns_server_lifetime_global'}, {'leafval': 'domain_name_string_global, domain_name_lifetime_global'}, {'leafval': 'dns_server_prefix_global, dns_server_lifetime_global'}, {'leafval': 'global_dad_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_nd_ra_dns_server_get(self, dns_server_global=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dns_server_global: dns_server_prefix_global
    :param dns_server_global: Keyword argument tuple.

    :type dns_server_prefix_global: unicode
    :param dns_server_prefix_global: **dns_server_global** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global.dns_server_global', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global.dns_server_global', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global.dns_server_global', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dns_server_global', 'keyval': 'dns_server_prefix_global', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dns_server_global=dns_server_global)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dns_server_global=dns_server_global)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_nd_ra_dns_server_lifetime_multiplier_get(self, dns_server_global=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dns_server_global: dns_server_prefix_global
    :param dns_server_global: Keyword argument tuple.

    :type dns_server_prefix_global: unicode
    :param dns_server_prefix_global: **dns_server_global** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global.dns_server_global', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global.dns_server_global', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global.dns_server_global', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dns_server_global', 'keyval': 'dns_server_prefix_global', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dns_server_global=dns_server_global)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dns_server_global=dns_server_global)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_nd_ra_domain_name_get(self, domain_name_global=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type domain_name_global: domain_name_string_global
    :param domain_name_global: Keyword argument tuple.

    :type domain_name_string_global: unicode
    :param domain_name_string_global: **domain_name_global** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global.domain_name_global', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global.domain_name_global', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global.domain_name_global', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain_name_global', 'keyval': 'domain_name_string_global', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name_global=domain_name_global)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name_global=domain_name_global)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_nd_ra_domain_name_lifetime_multiplier_get(self, domain_name_global=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type domain_name_global: domain_name_string_global
    :param domain_name_global: Keyword argument tuple.

    :type domain_name_string_global: unicode
    :param domain_name_string_global: **domain_name_global** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.ipv6_global_cmds.nd_global.domain_name_global', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.ipv6_global_cmds.nd_global.domain_name_global', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.ipv6_global_cmds.nd_global.domain_name_global', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain_name_global', 'keyval': 'domain_name_string_global', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name_global=domain_name_global)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name_global=domain_name_global)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_pim_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.mld_snooping.ipv6.pim', 'pybind.nos.v7_2_0.brocade_mld_snooping', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mld_snooping.ipv6.pim', 'pybind.slxos.v17r_1_01a.brocade_mld_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mld_snooping.ipv6.pim', 'pybind.slxos.v17r_2_00.brocade_mld_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mld_snooping.ipv6.pim', 'pybind.slxos.v17s_1_02.brocade_mld_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mld_snooping.ipv6.pim', u'snooping'), ('pybind.slxos.v17r_1_01a.mld_snooping.ipv6.pim', u'snooping'), ('pybind.nos.v7_2_0.mld_snooping.ipv6.pim', u'snooping'), ('pybind.slxos.v17r_2_00.mld_snooping.ipv6.pim', u'snooping')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'pimv6_enable'}, {'leafval': 'pimv6_enable'}, {'leafval': 'pimv6_enable'}, {'leafval': 'pimv6_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_pim_snooping_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.mld_snooping.ipv6.pim.snooping', 'pybind.nos.v7_2_0.brocade_mld_snooping', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mld_snooping.ipv6.pim.snooping', 'pybind.slxos.v17r_1_01a.brocade_mld_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mld_snooping.ipv6.pim.snooping', 'pybind.slxos.v17r_2_00.brocade_mld_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mld_snooping.ipv6.pim.snooping', 'pybind.slxos.v17s_1_02.brocade_mld_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_pim_snooping_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.mld_snooping.ipv6.pim.snooping', 'pybind.nos.v7_2_0.brocade_mld_snooping', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mld_snooping.ipv6.pim.snooping', 'pybind.slxos.v17r_1_01a.brocade_mld_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mld_snooping.ipv6.pim.snooping', 'pybind.slxos.v17r_2_00.brocade_mld_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mld_snooping.ipv6.pim.snooping', 'pybind.slxos.v17s_1_02.brocade_mld_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_prefix_list_get(self, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type action_ipp: unicode
    :param action_ipp: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ipv6_prefix_ipp: unicode
    :param ipv6_prefix_ipp: **prefix_list** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type ge_ipp: long
    :param ge_ipp: **prefix_list** tuple argument:  Minimum IPv6 prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type le_ipp: long
    :param le_ipp: **prefix_list** tuple argument:  Maximum IPv6 prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_prefix_list_action_ipp_get(self, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_prefix_list_ge_get(self, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_prefix_list_ipv6_prefix_ipp_get(self, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_prefix_list_le_get(self, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6.hide_prefix_holder.prefix_list', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_protocol_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.proto_vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.proto_vrrpv3', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.proto_vrrpv3', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_protocol_vrrp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.proto_vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.proto_vrrpv3', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.proto_vrrpv3', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_protocol_vrrp_extended_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.proto_vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.proto_vrrpv3', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.proto_vrrpv3', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_receive_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.receive', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.receive', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.receive', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.receive', u'access_group'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.receive', u'access_group'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.receive', u'access_group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'acl_name'}, {'leafval': 'acl_name'}, {'leafval': 'ipv6_access_list, ip_direction'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_receive_access_group_get(self, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type access_group: acl_name
    :param access_group: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.receive.access_group', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.receive.access_group', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_receive_access_group_ip_direction_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.receive.access_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_receive_access_group_ipv6_access_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.receive.access_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: dest
    :param route: Keyword argument tuple.

    :type dest: unicode
    :param dest: **route** tuple argument:  IPv6Address/prefix.;; Destination IPv6 address-prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ipv6.ipv6route.route', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6.ipv6route.route', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6route.route', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.ipv6route.route', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.ipv6route.route', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'dest', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.ipv6.ipv6route.route': [u'next_hop'], 'pybind.nos.v7_2_0.ipv6.ipv6route.route': [u'next_hop'], 'pybind.slxos.v17r_1_01a.ipv6.ipv6route.route': [u'next_hop'], 'pybind.slxos.v17r_2_00.ipv6.ipv6route.route': [u'next_hop'], 'pybind.nos.v6_0_2f.ipv6.ipv6route.route': [u'next_hop']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_ipv6_static_route_oif_vrf_get(self, ipv6_static_route_oif_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv6_static_route_oif_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name
    :param ipv6_static_route_oif_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **ipv6_static_route_oif_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **ipv6_static_route_oif_vrf** tuple argument:  Next Hop Vrf Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **ipv6_static_route_oif_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **ipv6_static_route_oif_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_static_route_oif_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_static_route_oif_vrf=ipv6_static_route_oif_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_static_route_oif_vrf=ipv6_static_route_oif_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_link_local_static_route_nh_get(self, link_local_static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.link_local_static_route_nh', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.link_local_static_route_nh', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.link_local_static_route_nh', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ipv6.route.link_local_static_route_nh', u'route_attributes'), ('pybind.slxos.v17r_1_01a.ipv6.route.link_local_static_route_nh', u'route_attributes'), ('pybind.slxos.v17r_2_00.ipv6.route.link_local_static_route_nh', u'route_attributes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'link_local_static_route_nh', 'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_link_local_static_route_nh_distance_get(self, link_local_static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.slxos.v17r_1_01a.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.slxos.v17r_2_00.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_link_local_static_route_nh_metric_get(self, link_local_static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.slxos.v17r_1_01a.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.slxos.v17r_2_00.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_link_local_static_route_nh_tag_get(self, link_local_static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.slxos.v17r_1_01a.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.slxos.v17r_2_00.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_link_local_static_route_nh_vrf_get(self, link_local_static_route_nh_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type link_local_static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **link_local_static_route_nh_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **link_local_static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type link_local_next_hop: unicode
    :param link_local_next_hop: **link_local_static_route_nh_vrf** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.link_local_static_route_nh_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.link_local_static_route_nh_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.link_local_static_route_nh_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'link_local_static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link_local_static_route_nh_vrf=link_local_static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link_local_static_route_nh_vrf=link_local_static_route_nh_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_next_hop_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: dest
    :param route: Keyword argument tuple.

    :type dest: unicode
    :param dest: **route** tuple argument:  IPv6Address/prefix.;; Destination IPv6 address-prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ipv6.ipv6route.route', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ipv6.ipv6route.route', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ipv6.ipv6route.route', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.ipv6route.route', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.ipv6route.route', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'dest', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ipv6.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17r_1_01a.ipv6.route.static', u'bfd'), ('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17s_1_02.ipv6.route.static', u'bfd'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_holdover_interval'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_bfd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_get(self, bfd_ipv6_link_local_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_interval_attributes'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_interval_attributes'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_interval_attributes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bfd_ipv6_link_local_static_route', 'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_interval_get(self, bfd_ipv6_link_local_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_min_rx_get(self, bfd_ipv6_link_local_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_multiplier_get(self, bfd_ipv6_link_local_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_bfd_bfd_ipv6_static_route_get(self, bfd_ipv6_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_interval_attributes'), ('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_interval_attributes'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_interval_attributes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bfd_ipv6_static_route', 'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_bfd_bfd_ipv6_static_route_interval_get(self, bfd_ipv6_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_bfd_bfd_ipv6_static_route_min_rx_get(self, bfd_ipv6_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_bfd_bfd_ipv6_static_route_multiplier_get(self, bfd_ipv6_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_bfd_holdover_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17s_1_02.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_1_01a.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_2_00.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_route_nh_get(self, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static_route_nh', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static_route_nh', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static_route_nh', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ipv6.route.static_route_nh', u'route_attributes'), ('pybind.slxos.v17r_2_00.ipv6.route.static_route_nh', u'route_attributes'), ('pybind.slxos.v17r_1_01a.ipv6.route.static_route_nh', u'route_attributes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_route_nh', 'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_route_nh_distance_get(self, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_2_00.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_route_nh_metric_get(self, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_2_00.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_route_nh_tag_get(self, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_2_00.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_route_nh_vrf_get(self, static_route_nh_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop
    :param static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_nh_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh_vrf** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static_route_nh_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static_route_nh_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static_route_nh_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_nh_vrf=static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_nh_vrf=static_route_nh_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_route_oif_get(self, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static_route_oif', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static_route_oif', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static_route_oif', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ipv6.route.static_route_oif', u'route_attributes'), ('pybind.slxos.v17s_1_02.ipv6.route.static_route_oif', u'route_attributes'), ('pybind.slxos.v17r_1_01a.ipv6.route.static_route_oif', u'route_attributes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_route_oif', 'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_route_oif_distance_get(self, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17r_2_00.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17s_1_02.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_route_oif_metric_get(self, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17r_2_00.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17s_1_02.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_route_static_route_oif_tag_get(self, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17r_2_00.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17s_1_02.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v17r_1_01a.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability, auth_transition'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'table_map_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric', u'router_lsa')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'reference_bandwidth'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'area_id, normal'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'external_lsa_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'external_lsa_value'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'area_id, normal'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'external_lsa_value'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'all_lsas, include_stub'}]
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf": {}, "pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf": {}, "pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf": {"vrf_lite_capability": "vrf_lite_capability", "default_metric": "default_metric", "global_metric_type": "global_metric_type", "maximum_paths": "maximum_paths", "database_overflow_interval": "database_overflow_interval", "key_add_remove_interval": "key_add_remove_interval", "default_passive_interface": "default_passive_interface", "vrf": "vrf", "external_lsdb_limit": "external_lsdb_limit", "key_rollover_interval": "key_rollover_interval", "nonstop_routing": "nonstop_routing", "log_status_change": "log_status_change"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area_range'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.nssa', u'metric'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'nssa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'stub'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.nssa', u'area_default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'nssa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.nssa', u'metric'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area_range'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'stub'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.nssa', u'area_default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area_range'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'stub'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.nssa', u'area_default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.nssa', u'metric'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'nssa')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'range_address, range_effect, range_cost'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'nssa_area_metric'}, {'leafval': 'virtual_link_neighbor'}, {'leafval': 'no_redistribution, nssa_area_no_summary, translator_always, translator_interval'}, {'leafval': 'stub_area_no_summary, stub_area_metric'}, {'leafval': 'area_default_information_originate_metric, area_default_information_originate_metric_type'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'no_redistribution, nssa_area_no_summary, translator_always, translator_interval'}, {'leafval': 'nssa_area_metric'}, {'leafval': 'range_address, range_effect, range_cost'}, {'leafval': 'stub_area_no_summary, stub_area_metric'}, {'leafval': 'virtual_link_neighbor'}, {'leafval': 'area_default_information_originate_metric, area_default_information_originate_metric_type'}, {'leafval': 'virtual_link_neighbor'}, {'leafval': 'range_address, range_effect, range_cost'}, {'leafval': 'stub_area_no_summary, stub_area_metric'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'area_default_information_originate_metric, area_default_information_originate_metric_type'}, {'leafval': 'nssa_area_metric'}, {'leafval': 'no_redistribution, nssa_area_no_summary, translator_always, translator_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.authentication', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.authentication', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_ah_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_esp_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_esp_auth_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_esp_key_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_esp_no_encrypt_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_ipsec_auth_key_config_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config': [u'ah', u'esp']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_key_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_no_encrypt_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_authentication_spi_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_normal_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area_range'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.nssa', u'metric'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'nssa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'stub'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.nssa', u'area_default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'nssa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.nssa', u'metric'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area_range'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'stub'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.nssa', u'area_default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area_range'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'stub'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.nssa', u'area_default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.nssa', u'metric'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'nssa')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'range_address, range_effect, range_cost'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'nssa_area_metric'}, {'leafval': 'virtual_link_neighbor'}, {'leafval': 'no_redistribution, nssa_area_no_summary, translator_always, translator_interval'}, {'leafval': 'stub_area_no_summary, stub_area_metric'}, {'leafval': 'area_default_information_originate_metric, area_default_information_originate_metric_type'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'no_redistribution, nssa_area_no_summary, translator_always, translator_interval'}, {'leafval': 'nssa_area_metric'}, {'leafval': 'range_address, range_effect, range_cost'}, {'leafval': 'stub_area_no_summary, stub_area_metric'}, {'leafval': 'virtual_link_neighbor'}, {'leafval': 'area_default_information_originate_metric, area_default_information_originate_metric_type'}, {'leafval': 'virtual_link_neighbor'}, {'leafval': 'range_address, range_effect, range_cost'}, {'leafval': 'stub_area_no_summary, stub_area_metric'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'area_default_information_originate_metric, area_default_information_originate_metric_type'}, {'leafval': 'nssa_area_metric'}, {'leafval': 'no_redistribution, nssa_area_no_summary, translator_always, translator_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_redistribution, nssa_area_no_summary, translator_always, translator_interval'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_default_information_originate_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'area_default_information_originate_metric, area_default_information_originate_metric_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_default_information_originate_metric_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_default_information_originate_metric_type_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_metric_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.nssa.metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.nssa.metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.nssa.metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_no_redistribution_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_no_summary_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_nssa_area_metric_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.nssa.metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.nssa.metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.nssa.metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_translator_always_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_nssa_translator_interval_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.nssa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_range_get(self, ospf=None, area=None, area_range=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type area_range: range_address, range_effect, range_cost
    :param area_range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **area_range** tuple argument:  A:B::C:D/LEN;; IPv6 address to match

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type range_effect: unicode
    :param range_effect: **area_range** tuple argument:  Advertise/Do not advertise this type-3 summarization

        * enumeration restriction: ::

            ['advertise', 'not-advertise']

    :type range_cost: long
    :param range_cost: **area_range** tuple argument:  Configure area range cost

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.area_range', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.area_range', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.area_range', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area_range', 'keyval': 'range_address', 'extra_keyval': 'range_address, range_effect, range_cost'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, area_range=area_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, area_range=area_range)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_range_cost_get(self, ospf=None, area=None, area_range=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type area_range: range_address
    :param area_range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **area_range** tuple argument:  A:B::C:D/LEN;; IPv6 address to match

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.area_range', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.area_range', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.area_range', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area_range', 'keyval': 'range_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, area_range=area_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, area_range=area_range)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_range_range_effect_get(self, ospf=None, area=None, area_range=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type area_range: range_address
    :param area_range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **area_range** tuple argument:  A:B::C:D/LEN;; IPv6 address to match

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.area_range', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.area_range', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.area_range', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area_range', 'keyval': 'range_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, area_range=area_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, area_range=area_range)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_stub_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.stub', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.stub', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.stub', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'stub_area_no_summary, stub_area_metric'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_stub_no_summary_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.stub', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.stub', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.stub', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_stub_stub_area_metric_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.stub', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.stub', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.stub', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties', u'link_interval_properties'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication', u'ipsec_auth_key_config'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties', u'authentication'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties', u'link_interval_properties'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties', u'link_interval_properties'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication', u'ipsec_auth_key_config')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'key_chain'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication": {}, "pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication": {"key_chain": "key_chain"}, "pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_ah_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_esp_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_esp_auth_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_esp_key_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_esp_no_encrypt_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_ipsec_auth_key_config_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config': [u'ah', u'esp']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_key_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_key_chain_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_no_encrypt_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_authentication_spi_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_dead_interval_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_hello_interval_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_hello_jitter_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_link_interval_properties_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_retransmit_interval_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_area_virtual_link_transmit_delay_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_auth_transition_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'summary_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'reference_bandwidth'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'area_id, normal'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'external_lsa_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'summary_address_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_auto_cost_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.auto_cost', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.auto_cost', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.auto_cost', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_auto_cost_reference_bandwidth_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.auto_cost', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.auto_cost', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.auto_cost', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_bfd_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_bfd_bfd_enable_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_bfd_holdover_interval_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_database_overflow_interval_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'summary_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'external_lsa_value'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'area_id, normal'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'external_lsa_value'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'area_id, normal'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'external_lsa_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'summary_address_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_default_information_originate_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.global_default_information_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.global_default_information_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.global_default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_default_information_originate_always_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.global_default_information_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.global_default_information_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.global_default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_default_information_originate_metric_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.global_default_information_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.global_default_information_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.global_default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_default_information_originate_metric_type_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.global_default_information_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.global_default_information_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.global_default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_default_metric_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'summary_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'external_lsa_value'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'area_id, normal'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'external_lsa_value'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'area_id, normal'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'external_lsa_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'summary_address_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_default_passive_interface_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'summary_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'external_lsa_value'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'area_id, normal'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'external_lsa_value'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'area_id, normal'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'external_lsa_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'summary_address_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_distance_get(self, ospf=None, distance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propagation

        * enumeration restriction: ::

            ['intra-area', 'external', 'inter-area']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distance', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distance', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distance', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, distance=distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, distance=distance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_distance_distance_value_get(self, ospf=None, distance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propagation

        * enumeration restriction: ::

            ['intra-area', 'external', 'inter-area']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distance', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distance', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distance', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, distance=distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, distance=distance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_distribute_list_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_distribute_list_prefix_list_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_distribute_list_prefix_list_distribute_list_prefix_list_name_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_distribute_list_prefix_list_in_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_distribute_list_route_map_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list.route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list.route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list.route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'distribute_list_route_map_name, distribute_list_route_map_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_distribute_list_route_map_distribute_list_route_map_name_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list.route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list.route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list.route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_distribute_list_route_map_in_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list.route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list.route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list.route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_external_lsdb_limit_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'summary_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'external_lsa_value'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'area_id, normal'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'external_lsa_value'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'area_id, normal'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'external_lsa_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'summary_address_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_graceful_restart_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_graceful_restart_helper_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.graceful_restart.helper', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart.helper', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.graceful_restart.helper', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_graceful_restart_helper_disable_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.graceful_restart.helper', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart.helper', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.graceful_restart.helper', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_graceful_restart_helper_strict_lsa_checking_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.graceful_restart.helper', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart.helper', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.graceful_restart.helper', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_key_add_remove_interval_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'summary_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'external_lsa_value'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'area_id, normal'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'external_lsa_value'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'area_id, normal'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'external_lsa_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'summary_address_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_key_rollover_interval_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'summary_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'external_lsa_value'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'area_id, normal'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'external_lsa_value'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'area_id, normal'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'external_lsa_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'summary_address_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_log_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_log_adjacency_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log.log_adjacency', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log.log_adjacency', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log.log_adjacency', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_log_adjacency_dr_only_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log.log_adjacency', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log.log_adjacency', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log.log_adjacency', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_log_all_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_log_bad_packet_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log.log_bad_packet', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log.log_bad_packet', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log.log_bad_packet', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_log_bad_packet_checksum_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log.log_bad_packet', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log.log_bad_packet', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log.log_bad_packet', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_log_database_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_log_retransmit_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_log_status_change_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'summary_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'external_lsa_value'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'area_id, normal'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'external_lsa_value'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'area_id, normal'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'external_lsa_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'summary_address_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_max_metric_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_all_lsas_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_external_lsa_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_external_lsa_external_lsa_value_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_include_stub_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_on_startup_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_on_startup_on_startup_time_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_on_startup_wait_for_bgp_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_summary_lsa_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_max_metric_router_lsa_summary_lsa_summary_lsa_value_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_maximum_paths_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'summary_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'external_lsa_value'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'area_id, normal'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'external_lsa_value'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'area_id, normal'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'external_lsa_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'summary_address_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_metric_type_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'summary_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'external_lsa_value'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'area_id, normal'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'external_lsa_value'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'area_id, normal'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'external_lsa_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'summary_address_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_nonstop_routing_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'summary_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'external_lsa_value'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'area_id, normal'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'external_lsa_value'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'area_id, normal'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'external_lsa_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'summary_address_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_bgp_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_bgp_metric_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_bgp_metric_type_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_bgp_route_map_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_connected_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_connected_metric_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_connected_metric_type_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_connected_route_map_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_isis_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_isis': [u'level_2', u'level_1', u'level_1_2'], 'pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_isis': [u'level_2', u'level_1', u'level_1_2'], 'pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_isis': [u'level_2', u'level_1', u'level_1_2']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_isis_level_1_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_isis_level_1_2_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_isis_level_2_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_isis_metric_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_isis_metric_type_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_isis_route_map_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_ospf_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_ospf_metric_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_ospf_metric_type_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_ospf_route_map_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_static_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_static_metric_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_static_metric_type_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_redistribute_static_route_map_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_summary_address_get(self, ospf=None, summary_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type summary_address: summary_address_value
    :param summary_address: Keyword argument tuple.

    :type summary_address_value: unicode
    :param summary_address_value: **summary_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.summary_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.summary_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.summary_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'summary_address', 'keyval': 'summary_address_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, summary_address=summary_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, summary_address=summary_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_timers_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_timers_lsa_group_pacing_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_timers_spf_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers.spf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers.spf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.timers.spf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spf_delay, spf_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_timers_spf_spf_delay_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers.spf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers.spf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.timers.spf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_timers_spf_spf_hold_time_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers.spf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers.spf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router.ospf.timers.spf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_router_ospf_vrf_lite_capability_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'auto_cost'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.timers', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router.ospf', u'summary_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'external_lsa_value'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'area_id, normal'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric, redistribute_isis_metric_type'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'area_id, normal'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'external_lsa_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'summary_address_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_routing_system_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.receive', u'access_group'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.static_ag_ipv6_config', u'anycast_gateway_mac'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6', u'prefix_list'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.receive', u'access_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.receive', u'access_group'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.static_ag_ipv6_config', u'anycast_gateway_mac'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ipv6_access_list, ip_direction'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'ipv6_anycast_gateway_mac, ipv6_anycast_default_mac'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'table_map_route_map'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'acl_name'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'acl_name'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability, auth_transition'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ipv6_anycast_gateway_mac, ipv6_anycast_default_mac'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ipv6_static_ag_ipv6_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.ipv6.static_ag_ipv6_config', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.static_ag_ipv6_config', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.ipv6.static_ag_ipv6_config', u'anycast_gateway_mac'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.static_ag_ipv6_config', u'anycast_gateway_mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_anycast_gateway_mac, ipv6_anycast_default_mac'}, {'leafval': 'ipv6_anycast_gateway_mac, ipv6_anycast_default_mac'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.host_table', u'isis_router_entry'), ('pybind.slxos.v17s_1_02.isis_state', u'database'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state', u'ipv4_routes'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes', u'ipv6_route_entry'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes', u'ipv4_route_entry'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.interface_brief', u'isis_intf_brief'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state', u'router_isis_config'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail', u'isis_intf'), ('pybind.slxos.v17s_1_02.isis_state', u'global_isis_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state', u'host_table'), ('pybind.slxos.v17s_1_02.isis_state', u'ipv6_routes'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state', u'database'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes', u'ipv6_route_entry'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state', u'global_isis_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes', u'ipv4_route_entry'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state', u'router_isis_config'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state', u'ipv6_routes'), ('pybind.slxos.v17r_1_01a.isis_state.interface_brief', u'isis_intf_brief'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state', u'ipv4_routes'), ('pybind.slxos.v17r_1_01a.isis_state', u'host_table'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.host_table', u'isis_router_entry'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state', u'database'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state', u'host_table'), ('pybind.slxos.v17r_2_00.isis_state', u'ipv4_routes'), ('pybind.slxos.v17r_2_00.isis_state.interface_brief', u'isis_intf_brief'), ('pybind.slxos.v17r_2_00.isis_state', u'ipv6_routes'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state', u'router_isis_config'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state', u'global_isis_info'), ('pybind.slxos.v17r_2_00.isis_state.host_table', u'isis_router_entry'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.ipv4_routes', u'ipv4_route_entry'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes', u'ipv6_route_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'system_id, host_name, is_local'}, {'leafval': 'isis_operation, level, detail, summary, lsp_level1_count, lsp_level2_count, lsp_level1_loading, lsp_level2_loading, lsp_level1_fragments, lsp_level2_fragments, lsp_level1_pseudo, lsp_level2_pseudo, lsp_level1_pseudo_fragments, lsp_level2_pseudo_fragments, lsp_level1_my_count, lsp_level2_my_count, lsp_level1_my_lsp_fragments, lsp_level2_my_lsp_fragments, lsp_level1_my_pseudo, lsp_level2_my_pseudo, lsp_level1_my_pseudo_fragments, lsp_level2_my_pseudo_fragments, lsp_level1_checksum, lsp_level2_checksum'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'total_routes_count'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'intf_name, circuit_type, is_circuit_passive, circuit_mode, circ_state, mtu_size, circ_adj_up, circ_changes, adj_changes, is_l1_dis, is_l2_dis'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'nsr_state, lsp_flood_count, lsp_fast_flood_count, fast_flood_wait_count, hello_padding, hello_padding_ptp, csnp_interval, lsp_gen_interval, lsp_interval, lsp_refresh_interval, lsp_lifetime, retransmit_interval, pspf_enabled, ispf_enabled, istct_spf_enabled, overload_state, overload_startup_time, overload_wait_on_bgp, overload_bgp_wait_time, enable_code_assertions, graceful_restart_helper, isis_hostname_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'intf_name, intf_type, intf_index, v4circuit_enabled, v6circuit_enabled, circuit_id, circuit_ifid, circuit_state, circuit_ip_state, circuit_ipv6_state, circuit_mode, circuit_type, circuit_encap, is_circuit_passive, mtu_size, padding_enabled, bfd_enabled'}, {'leafval': 'isis_protocol, isis_state, is_type, system_id, area_addresses, database_state_level_1, database_state_level_2, database_state_level_1_2, overload_reason, check_alarm, overload_state_since, overload_state_rem_time, admin_distance, v6_admin_distance, max_paths, v6_max_paths, default_redis_metric, v6_default_redis_metric, default_link_metric_l1_conf, default_link_metric_l1_adv, default_link_metric_l2_conf, default_link_metric_l2_adv, v6_default_link_metric_l1_conf, v6_default_link_metric_l1_adv, v6_default_link_metric_l2_conf, v6_default_link_metric_l2_adv, redis_protocol, no_routes_redis, v6_redis_protocol, v6_no_routes_redis, auth_mode_l1, auth_mode_l2, auth_key_l1, auth_key_l2, metric_style_l1, metric_style_l2, graceful_restart_helper, pspf_optimization, spf_max_wait_l1, spf_max_wait_l2, spf_init_wait_l1, spf_init_wait_l2, spf_second_wait_l1, spf_second_wait_l2, spf_scheduled_l1, spf_scheduled_l2, pspf_max_wait, pspf_init_wait, pspf_second_wait, pspf_scheduled, spf6_max_wait_l1, spf6_max_wait_l2, spf6_init_wait_l1, spf6_init_wait_l2, spf6_second_wait_l1, spf6_second_wait_l2, spf6_scheduled_l1, spf6_scheduled_l2, pspf6_max_wait, pspf6_init_wait, pspf6_second_wait, pspf6_scheduled, lsp_max_lifetime, lsp_refresh_interval, lsp_gen_interval, lsp_retrans_interval, lsp_interval, snp_csnp_interval, snp_psnp_interval, hello_padding, hello_padding_ptp, ptp_handshake, bgp_ipv4_converged, bgp_ipv6_converged, isis_te, isis_shortcuts, isis_reverse_metric, isis_reverse_metric_wbit, isis_reverse_metric_sbit, bfd_enabled, bfd_hold_interval, nsr_enabled, nsr_state, nsr_standby_state, nsr_sync_state, isis_is_mp, ldp_sync, ldp_sync_holddown_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'hostname_enabled'}, {'leafval': 'level1_route_count, level2_route_count, ecmp_route_count'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'isis_operation, level, lsp_level1_count, lsp_level2_count, lsp_level1_loading, lsp_level2_loading, lsp_level1_fragments, lsp_level2_fragments, lsp_level1_pseudo, lsp_level2_pseudo, lsp_level1_pseudo_fragments, lsp_level2_pseudo_fragments, lsp_level1_my_count, lsp_level2_my_count, lsp_level1_my_lsp_fragments, lsp_level2_my_lsp_fragments, lsp_level1_my_pseudo, lsp_level2_my_pseudo, lsp_level1_my_pseudo_fragments, lsp_level2_my_pseudo_fragments, lsp_level1_checksum, lsp_level2_checksum'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'isis_protocol, isis_state, is_type, system_id, area_addresses, database_state_level_1, database_state_level_2, database_state_level_1_2, overload_reason, check_alarm, overload_state_since, overload_state_rem_time, admin_distance, v6_admin_distance, max_paths, v6_max_paths, default_redis_metric, v6_default_redis_metric, default_link_metric_l1_conf, default_link_metric_l1_adv, default_link_metric_l2_conf, default_link_metric_l2_adv, v6_default_link_metric_l1_conf, v6_default_link_metric_l1_adv, v6_default_link_metric_l2_conf, v6_default_link_metric_l2_adv, redis_protocol, no_routes_redis, v6_redis_protocol, v6_no_routes_redis, auth_mode_l1, auth_mode_l2, auth_key_l1, auth_key_l2, l1_auth_no_check, l2_auth_no_check, metric_style_l1, metric_style_l2, graceful_restart_helper, pspf_optimization, spf_max_wait_l1, spf_max_wait_l2, spf_init_wait_l1, spf_init_wait_l2, spf_second_wait_l1, spf_second_wait_l2, spf_scheduled_l1, spf_scheduled_l2, pspf_max_wait, pspf_init_wait, pspf_second_wait, pspf_scheduled, spf6_max_wait_l1, spf6_max_wait_l2, spf6_init_wait_l1, spf6_init_wait_l2, spf6_second_wait_l1, spf6_second_wait_l2, spf6_scheduled_l1, spf6_scheduled_l2, pspf6_max_wait, pspf6_init_wait, pspf6_second_wait, pspf6_scheduled, lsp_max_lifetime, lsp_refresh_interval, lsp_gen_interval, lsp_retrans_interval, lsp_interval, snp_csnp_interval, snp_psnp_interval, hello_padding, hello_padding_ptp, ptp_handshake, bgp_ipv4_converged, bgp_ipv6_converged, isis_te, isis_shortcuts, isis_reverse_metric, isis_reverse_metric_wbit, isis_reverse_metric_sbit, bfd_enabled, bfd_hold_interval, nsr_enabled, nsr_state, nsr_sync_state, isis_is_mp, ldp_sync, ldp_sync_holddown_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'nsr_state, lsp_flood_count, lsp_fast_flood_count, fast_flood_wait_count, hello_padding, hello_padding_ptp, csnp_interval, lsp_gen_interval, lsp_interval, lsp_refresh_interval, lsp_lifetime, retransmit_interval, pspf_enabled, ispf_enabled, istct_spf_enabled, overload_state, overload_startup_time, overload_wait_on_bgp, overload_bgp_wait_time, enable_code_assertions, graceful_restart_helper, isis_hostname_enabled, bfd, bfd_holdover_interval'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'level1_route_count, level2_route_count, ecmp_route_count, total_routes_count'}, {'leafval': 'intf_type, intf_number, circuit_type, is_circuit_passive, circuit_mode, circ_state, mtu_size, circ_adj_up, circ_changes, adj_changes, is_l1_dis, is_l2_dis'}, {'leafval': 'address, level'}, {'leafval': 'total_routes_count'}, {'leafval': 'hostname_enabled'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'system_id, host_name, is_local'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'intf_type, intf_number, v4circuit_enabled, v6circuit_enabled, circuit_id, circuit_ifid, circuit_state, circuit_ip_state, circuit_ipv6_state, circuit_mode, circuit_type, circuit_encap, is_circuit_passive, mtu_size, padding_enabled, bfd_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'isis_operation, level, lsp_level1_count, lsp_level2_count, lsp_level1_loading, lsp_level2_loading, lsp_level1_fragments, lsp_level2_fragments, lsp_level1_pseudo, lsp_level2_pseudo, lsp_level1_pseudo_fragments, lsp_level2_pseudo_fragments, lsp_level1_my_count, lsp_level2_my_count, lsp_level1_my_lsp_fragments, lsp_level2_my_lsp_fragments, lsp_level1_my_pseudo, lsp_level2_my_pseudo, lsp_level1_my_pseudo_fragments, lsp_level2_my_pseudo_fragments, lsp_level1_checksum, lsp_level2_checksum'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'hostname_enabled'}, {'leafval': 'total_routes_count'}, {'leafval': 'intf_type, intf_number, circuit_type, is_circuit_passive, circuit_mode, circ_state, mtu_size, circ_adj_up, circ_changes, adj_changes, is_l1_dis, is_l2_dis'}, {'leafval': 'level1_route_count, level2_route_count, ecmp_route_count, total_routes_count'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'nsr_state, lsp_flood_count, lsp_fast_flood_count, fast_flood_wait_count, hello_padding, hello_padding_ptp, csnp_interval, lsp_gen_interval, lsp_interval, lsp_refresh_interval, lsp_lifetime, retransmit_interval, pspf_enabled, ispf_enabled, istct_spf_enabled, overload_state, overload_startup_time, overload_wait_on_bgp, overload_bgp_wait_time, enable_code_assertions, graceful_restart_helper, isis_hostname_enabled, bfd, bfd_holdover_interval'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'isis_protocol, isis_state, is_type, system_id, area_addresses, database_state_level_1, database_state_level_2, database_state_level_1_2, overload_reason, check_alarm, overload_state_since, overload_state_rem_time, admin_distance, v6_admin_distance, max_paths, v6_max_paths, default_redis_metric, v6_default_redis_metric, default_link_metric_l1_conf, default_link_metric_l1_adv, default_link_metric_l2_conf, default_link_metric_l2_adv, v6_default_link_metric_l1_conf, v6_default_link_metric_l1_adv, v6_default_link_metric_l2_conf, v6_default_link_metric_l2_adv, redis_protocol, no_routes_redis, v6_redis_protocol, v6_no_routes_redis, auth_mode_l1, auth_mode_l2, auth_key_l1, auth_key_l2, l1_auth_no_check, l2_auth_no_check, metric_style_l1, metric_style_l2, graceful_restart_helper, pspf_optimization, spf_max_wait_l1, spf_max_wait_l2, spf_init_wait_l1, spf_init_wait_l2, spf_second_wait_l1, spf_second_wait_l2, spf_scheduled_l1, spf_scheduled_l2, pspf_max_wait, pspf_init_wait, pspf_second_wait, pspf_scheduled, spf6_max_wait_l1, spf6_max_wait_l2, spf6_init_wait_l1, spf6_init_wait_l2, spf6_second_wait_l1, spf6_second_wait_l2, spf6_scheduled_l1, spf6_scheduled_l2, pspf6_max_wait, pspf6_init_wait, pspf6_second_wait, pspf6_scheduled, lsp_max_lifetime, lsp_refresh_interval, lsp_gen_interval, lsp_retrans_interval, lsp_interval, snp_csnp_interval, snp_psnp_interval, hello_padding, hello_padding_ptp, ptp_handshake, bgp_ipv4_converged, bgp_ipv6_converged, isis_te, isis_shortcuts, isis_reverse_metric, isis_reverse_metric_wbit, isis_reverse_metric_sbit, bfd_enabled, bfd_hold_interval, nsr_enabled, nsr_state, nsr_sync_state, isis_is_mp, ldp_sync, ldp_sync_holddown_time'}, {'leafval': 'system_id, host_name, is_local'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len'}, {'leafval': 'intf_type, intf_number, v4circuit_enabled, v6circuit_enabled, circuit_id, circuit_ifid, circuit_state, circuit_ip_state, circuit_ipv6_state, circuit_mode, circuit_type, circuit_encap, is_circuit_passive, mtu_size, padding_enabled, bfd_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {"pybind.slxos.v17r_2_00.isis_state.database": {"isis_operation": "isis_operation", "lsp_level2_fragments": "lsp_level2_fragments", "lsp_level2_pseudo_fragments": "lsp_level2_pseudo_fragments", "lsp_level1_my_pseudo": "lsp_level1_my_pseudo", "lsp_level2_my_pseudo_fragments": "lsp_level2_my_pseudo_fragments", "lsp_level1_loading": "lsp_level1_loading", "lsp_level2_checksum": "lsp_level2_checksum", "lsp_level1_my_pseudo_fragments": "lsp_level1_my_pseudo_fragments", "lsp_level1_pseudo": "lsp_level1_pseudo", "lsp_level2_count": "lsp_level2_count", "lsp_level2_my_count": "lsp_level2_my_count", "lsp_level1_fragments": "lsp_level1_fragments", "lsp_level2_my_pseudo": "lsp_level2_my_pseudo", "lsp_level1_count": "lsp_level1_count", "level": "level", "lsp_level2_pseudo": "lsp_level2_pseudo", "lsp_level1_my_count": "lsp_level1_my_count", "lsp_level2_my_lsp_fragments": "lsp_level2_my_lsp_fragments", "lsp_level1_checksum": "lsp_level1_checksum", "lsp_level1_pseudo_fragments": "lsp_level1_pseudo_fragments", "lsp_level2_loading": "lsp_level2_loading", "lsp_level1_my_lsp_fragments": "lsp_level1_my_lsp_fragments"}, "pybind.slxos.v17r_1_01a.isis_state.database": {"isis_operation": "isis_operation", "lsp_level2_fragments": "lsp_level2_fragments", "lsp_level2_pseudo_fragments": "lsp_level2_pseudo_fragments", "lsp_level1_my_pseudo": "lsp_level1_my_pseudo", "lsp_level2_my_pseudo_fragments": "lsp_level2_my_pseudo_fragments", "lsp_level1_loading": "lsp_level1_loading", "lsp_level2_checksum": "lsp_level2_checksum", "lsp_level1_my_pseudo_fragments": "lsp_level1_my_pseudo_fragments", "lsp_level1_pseudo": "lsp_level1_pseudo", "lsp_level2_count": "lsp_level2_count", "lsp_level2_my_count": "lsp_level2_my_count", "lsp_level1_fragments": "lsp_level1_fragments", "lsp_level2_my_pseudo": "lsp_level2_my_pseudo", "lsp_level1_count": "lsp_level1_count", "level": "level", "lsp_level2_pseudo": "lsp_level2_pseudo", "lsp_level1_my_count": "lsp_level1_my_count", "lsp_level2_my_lsp_fragments": "lsp_level2_my_lsp_fragments", "lsp_level1_checksum": "lsp_level1_checksum", "lsp_level1_pseudo_fragments": "lsp_level1_pseudo_fragments", "lsp_level2_loading": "lsp_level2_loading", "lsp_level1_my_lsp_fragments": "lsp_level1_my_lsp_fragments"}, "pybind.slxos.v17s_1_02.isis_state.database": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_detail_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_isis_operation_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_entry_get(self, database=None, lsp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'database'), ('pybind.slxos.v17s_1_02.isis_state.database', u'database'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry', u'lsp_tlv_entry'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', u'lsp_tlv_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry', u'lsp_tlv_entry')]
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type, length'}, {'leafval': 'type, length'}, {'leafval': 'type, length'}]
    leafval_map = {"pybind.slxos.v17r_2_00.isis_state.database.lsp_entry": {"lsp_ol": "lsp_ol", "lsp_level": "lsp_level", "lsp_checksum": "lsp_checksum", "lsp_p": "lsp_p", "lsp_att": "lsp_att", "lsp_holdtime": "lsp_holdtime", "lsp_id": "lsp_id", "lsp_seq_no": "lsp_seq_no"}, "pybind.slxos.v17s_1_02.isis_state.database.lsp_entry": {}, "pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry": {"lsp_ol": "lsp_ol", "lsp_level": "lsp_level", "lsp_checksum": "lsp_checksum", "lsp_p": "lsp_p", "lsp_att": "lsp_att", "lsp_holdtime": "lsp_holdtime", "lsp_id": "lsp_id", "lsp_seq_no": "lsp_seq_no"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_area_address_get(self, database=None, lsp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', u'lsp_tlv_entry')]
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type, length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_att_get(self, database=None, lsp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'database'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'database'), ('pybind.slxos.v17s_1_02.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry', u'lsp_tlv_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry', u'lsp_tlv_entry'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', u'lsp_tlv_entry')]
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type, length'}, {'leafval': 'type, length'}, {'leafval': 'type, length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_checksum_get(self, database=None, lsp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'database'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'database'), ('pybind.slxos.v17s_1_02.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry', u'lsp_tlv_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry', u'lsp_tlv_entry'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', u'lsp_tlv_entry')]
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type, length'}, {'leafval': 'type, length'}, {'leafval': 'type, length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_holdtime_get(self, database=None, lsp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'database'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'database'), ('pybind.slxos.v17s_1_02.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry', u'lsp_tlv_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry', u'lsp_tlv_entry'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', u'lsp_tlv_entry')]
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type, length'}, {'leafval': 'type, length'}, {'leafval': 'type, length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_hostname_get(self, database=None, lsp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', u'lsp_tlv_entry')]
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type, length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_nlpid_get(self, database=None, lsp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', u'lsp_tlv_entry')]
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type, length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_ol_get(self, database=None, lsp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'database'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'database'), ('pybind.slxos.v17s_1_02.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry', u'lsp_tlv_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry', u'lsp_tlv_entry'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', u'lsp_tlv_entry')]
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type, length'}, {'leafval': 'type, length'}, {'leafval': 'type, length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_p_get(self, database=None, lsp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'database'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'database'), ('pybind.slxos.v17s_1_02.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry', u'lsp_tlv_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry', u'lsp_tlv_entry'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', u'lsp_tlv_entry')]
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type, length'}, {'leafval': 'type, length'}, {'leafval': 'type, length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_seq_no_get(self, database=None, lsp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'database'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'database'), ('pybind.slxos.v17s_1_02.isis_state.database', u'database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry', u'lsp_tlv_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry', u'lsp_tlv_entry'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', u'lsp_tlv_entry')]
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_entry', 'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type, length'}, {'leafval': 'type, length'}, {'leafval': 'type, length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_tlv_entry_get(self, database=None, lsp_entry=None, lsp_tlv_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type lsp_tlv_entry: type
    :param lsp_tlv_entry: Keyword argument tuple.

    :type type: long
    :param type: **lsp_tlv_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.database', u'database'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', u'lsp_entry'), ('pybind.slxos.v17r_2_00.isis_state.database', u'database'), ('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'database'), ('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry', u'lsp_entry')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry.lsp_tlv_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry.lsp_tlv_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry.lsp_tlv_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry.lsp_tlv_entry', u'sub_tlv_entry')]
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_tlv_entry', 'keyval': 'type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type, length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry, lsp_tlv_entry=lsp_tlv_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry, lsp_tlv_entry=lsp_tlv_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_tlv_entry_length_get(self, database=None, lsp_entry=None, lsp_tlv_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type lsp_tlv_entry: type
    :param lsp_tlv_entry: Keyword argument tuple.

    :type type: long
    :param type: **lsp_tlv_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.database', u'database'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', u'lsp_entry'), ('pybind.slxos.v17r_2_00.isis_state.database', u'database'), ('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'database'), ('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry', u'lsp_entry')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database.lsp_entry.lsp_tlv_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database.lsp_entry.lsp_tlv_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry.lsp_tlv_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry.lsp_tlv_entry', u'sub_tlv_entry')]
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_tlv_entry', 'keyval': 'type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type, length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry, lsp_tlv_entry=lsp_tlv_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry, lsp_tlv_entry=lsp_tlv_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_tlv_entry_sub_tlv_entry_get(self, database=None, lsp_entry=None, lsp_tlv_entry=None, sub_tlv_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type lsp_tlv_entry: type
    :param lsp_tlv_entry: Keyword argument tuple.

    :type type: long
    :param type: **lsp_tlv_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_tlv_entry: type
    :param sub_tlv_entry: Keyword argument tuple.

    :type type: long
    :param type: **sub_tlv_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.database', u'database'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry.lsp_tlv_entry', u'lsp_tlv_entry')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry.lsp_tlv_entry.sub_tlv_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}, {'keyval': 'type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_tlv_entry', 'keyval': 'type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry, lsp_tlv_entry=lsp_tlv_entry, sub_tlv_entry=sub_tlv_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry, lsp_tlv_entry=lsp_tlv_entry, sub_tlv_entry=sub_tlv_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_entry_lsp_tlv_entry_sub_tlv_entry_length_get(self, database=None, lsp_entry=None, lsp_tlv_entry=None, sub_tlv_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_entry: lsp_level, lsp_id
    :param lsp_entry: Keyword argument tuple.

    :type lsp_level: long
    :param lsp_level: **lsp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: unicode
    :param lsp_id: **lsp_entry** tuple argument.

    :type lsp_tlv_entry: type
    :param lsp_tlv_entry: Keyword argument tuple.

    :type type: long
    :param type: **lsp_tlv_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_tlv_entry: type
    :param sub_tlv_entry: Keyword argument tuple.

    :type type: long
    :param type: **sub_tlv_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.database', u'database'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry.lsp_tlv_entry', u'lsp_tlv_entry')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.database.lsp_entry.lsp_tlv_entry.sub_tlv_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'lsp_level, lsp_id', 'extra_keyval': ''}, {'keyval': 'type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_tlv_entry', 'keyval': 'type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database, lsp_entry=lsp_entry, lsp_tlv_entry=lsp_tlv_entry, sub_tlv_entry=sub_tlv_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database, lsp_entry=lsp_entry, lsp_tlv_entry=lsp_tlv_entry, sub_tlv_entry=sub_tlv_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level1_checksum_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level1_count_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level1_fragments_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level1_loading_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level1_my_count_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level1_my_lsp_fragments_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level1_my_pseudo_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level1_my_pseudo_fragments_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level1_pseudo_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level1_pseudo_fragments_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level2_checksum_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level2_count_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level2_fragments_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level2_loading_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level2_my_count_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level2_my_lsp_fragments_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level2_my_pseudo_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level2_my_pseudo_fragments_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level2_pseudo_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_lsp_level2_pseudo_fragments_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.database', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.database', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry'), ('pybind.slxos.v17r_1_01a.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}, {'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_database_summary_get(self, database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type database: level
    :param database: Keyword argument tuple.

    :type level: long
    :param level: **database** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.database', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.database', u'lsp_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'database', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_level, lsp_id, lsp_seq_no, lsp_checksum, lsp_holdtime, lsp_att, lsp_p, lsp_ol, lsp_area_address, lsp_nlpid, lsp_hostname'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, database=database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, database=database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.isis_state.global_isis_info": {"auth_mode_l2": "auth_mode_l2", "auth_mode_l1": "auth_mode_l1", "max_paths": "max_paths", "isis_reverse_metric_wbit": "isis_reverse_metric_wbit", "pspf6_scheduled": "pspf6_scheduled", "spf6_second_wait_l1": "spf6_second_wait_l1", "spf6_second_wait_l2": "spf6_second_wait_l2", "bfd_hold_interval": "bfd_hold_interval", "v6_redis_protocol": "v6_redis_protocol", "isis_is_mp": "isis_is_mp", "no_routes_redis": "no_routes_redis", "graceful_restart_helper": "graceful_restart_helper", "nsr_sync_state": "nsr_sync_state", "spf_second_wait_l2": "spf_second_wait_l2", "spf6_max_wait_l1": "spf6_max_wait_l1", "spf6_max_wait_l2": "spf6_max_wait_l2", "spf6_init_wait_l1": "spf6_init_wait_l1", "spf6_init_wait_l2": "spf6_init_wait_l2", "hello_padding_ptp": "hello_padding_ptp", "default_link_metric_l2_conf": "default_link_metric_l2_conf", "isis_te": "isis_te", "snp_psnp_interval": "snp_psnp_interval", "lsp_retrans_interval": "lsp_retrans_interval", "v6_no_routes_redis": "v6_no_routes_redis", "default_redis_metric": "default_redis_metric", "isis_reverse_metric_sbit": "isis_reverse_metric_sbit", "pspf6_init_wait": "pspf6_init_wait", "metric_style_l2": "metric_style_l2", "metric_style_l1": "metric_style_l1", "isis_state": "isis_state", "database_state_level_2": "database_state_level_2", "pspf_init_wait": "pspf_init_wait", "l1_auth_no_check": "l1_auth_no_check", "nsr_state": "nsr_state", "v6_default_link_metric_l1_adv": "v6_default_link_metric_l1_adv", "lsp_refresh_interval": "lsp_refresh_interval", "nsr_enabled": "nsr_enabled", "pspf_optimization": "pspf_optimization", "hello_padding": "hello_padding", "snp_csnp_interval": "snp_csnp_interval", "check_alarm": "check_alarm", "is_type": "is_type", "isis_shortcuts": "isis_shortcuts", "v6_default_link_metric_l2_adv": "v6_default_link_metric_l2_adv", "overload_reason": "overload_reason", "v6_max_paths": "v6_max_paths", "redis_protocol": "redis_protocol", "lsp_max_lifetime": "lsp_max_lifetime", "default_link_metric_l1_conf": "default_link_metric_l1_conf", "spf_second_wait_l1": "spf_second_wait_l1", "admin_distance": "admin_distance", "ptp_handshake": "ptp_handshake", "database_state_level_1_2": "database_state_level_1_2", "isis_reverse_metric": "isis_reverse_metric", "v6_default_link_metric_l2_conf": "v6_default_link_metric_l2_conf", "lsp_gen_interval": "lsp_gen_interval", "spf_init_wait_l1": "spf_init_wait_l1", "spf_init_wait_l2": "spf_init_wait_l2", "pspf_max_wait": "pspf_max_wait", "bgp_ipv4_converged": "bgp_ipv4_converged", "overload_state_since": "overload_state_since", "default_link_metric_l2_adv": "default_link_metric_l2_adv", "area_addresses": "area_addresses", "ldp_sync": "ldp_sync", "spf_max_wait_l2": "spf_max_wait_l2", "spf_max_wait_l1": "spf_max_wait_l1", "isis_protocol": "isis_protocol", "pspf6_max_wait": "pspf6_max_wait", "pspf6_second_wait": "pspf6_second_wait", "lsp_interval": "lsp_interval", "bgp_ipv6_converged": "bgp_ipv6_converged", "spf6_scheduled_l1": "spf6_scheduled_l1", "spf6_scheduled_l2": "spf6_scheduled_l2", "spf_scheduled_l1": "spf_scheduled_l1", "spf_scheduled_l2": "spf_scheduled_l2", "system_id": "system_id", "v6_admin_distance": "v6_admin_distance", "default_link_metric_l1_adv": "default_link_metric_l1_adv", "pspf_scheduled": "pspf_scheduled", "auth_key_l2": "auth_key_l2", "database_state_level_1": "database_state_level_1", "auth_key_l1": "auth_key_l1", "v6_default_link_metric_l1_conf": "v6_default_link_metric_l1_conf", "ldp_sync_holddown_time": "ldp_sync_holddown_time", "l2_auth_no_check": "l2_auth_no_check", "overload_state_rem_time": "overload_state_rem_time", "bfd_enabled": "bfd_enabled", "pspf_second_wait": "pspf_second_wait", "v6_default_redis_metric": "v6_default_redis_metric"}, "pybind.slxos.v17r_1_01a.isis_state.global_isis_info": {"auth_mode_l2": "auth_mode_l2", "auth_mode_l1": "auth_mode_l1", "max_paths": "max_paths", "isis_reverse_metric_wbit": "isis_reverse_metric_wbit", "pspf6_scheduled": "pspf6_scheduled", "spf6_second_wait_l1": "spf6_second_wait_l1", "spf6_second_wait_l2": "spf6_second_wait_l2", "bfd_hold_interval": "bfd_hold_interval", "v6_redis_protocol": "v6_redis_protocol", "isis_is_mp": "isis_is_mp", "no_routes_redis": "no_routes_redis", "graceful_restart_helper": "graceful_restart_helper", "nsr_sync_state": "nsr_sync_state", "spf_second_wait_l2": "spf_second_wait_l2", "spf6_max_wait_l1": "spf6_max_wait_l1", "spf6_max_wait_l2": "spf6_max_wait_l2", "spf6_init_wait_l1": "spf6_init_wait_l1", "spf6_init_wait_l2": "spf6_init_wait_l2", "hello_padding_ptp": "hello_padding_ptp", "default_link_metric_l2_conf": "default_link_metric_l2_conf", "isis_te": "isis_te", "snp_psnp_interval": "snp_psnp_interval", "lsp_retrans_interval": "lsp_retrans_interval", "v6_no_routes_redis": "v6_no_routes_redis", "default_redis_metric": "default_redis_metric", "isis_reverse_metric_sbit": "isis_reverse_metric_sbit", "pspf6_init_wait": "pspf6_init_wait", "metric_style_l2": "metric_style_l2", "metric_style_l1": "metric_style_l1", "isis_state": "isis_state", "database_state_level_2": "database_state_level_2", "pspf_init_wait": "pspf_init_wait", "l1_auth_no_check": "l1_auth_no_check", "nsr_state": "nsr_state", "v6_default_link_metric_l1_adv": "v6_default_link_metric_l1_adv", "lsp_refresh_interval": "lsp_refresh_interval", "nsr_enabled": "nsr_enabled", "pspf_optimization": "pspf_optimization", "hello_padding": "hello_padding", "snp_csnp_interval": "snp_csnp_interval", "check_alarm": "check_alarm", "is_type": "is_type", "isis_shortcuts": "isis_shortcuts", "v6_default_link_metric_l2_adv": "v6_default_link_metric_l2_adv", "overload_reason": "overload_reason", "v6_max_paths": "v6_max_paths", "redis_protocol": "redis_protocol", "lsp_max_lifetime": "lsp_max_lifetime", "default_link_metric_l1_conf": "default_link_metric_l1_conf", "spf_second_wait_l1": "spf_second_wait_l1", "admin_distance": "admin_distance", "ptp_handshake": "ptp_handshake", "database_state_level_1_2": "database_state_level_1_2", "isis_reverse_metric": "isis_reverse_metric", "v6_default_link_metric_l2_conf": "v6_default_link_metric_l2_conf", "lsp_gen_interval": "lsp_gen_interval", "spf_init_wait_l1": "spf_init_wait_l1", "spf_init_wait_l2": "spf_init_wait_l2", "pspf_max_wait": "pspf_max_wait", "bgp_ipv4_converged": "bgp_ipv4_converged", "overload_state_since": "overload_state_since", "default_link_metric_l2_adv": "default_link_metric_l2_adv", "area_addresses": "area_addresses", "ldp_sync": "ldp_sync", "spf_max_wait_l2": "spf_max_wait_l2", "spf_max_wait_l1": "spf_max_wait_l1", "isis_protocol": "isis_protocol", "pspf6_max_wait": "pspf6_max_wait", "pspf6_second_wait": "pspf6_second_wait", "lsp_interval": "lsp_interval", "bgp_ipv6_converged": "bgp_ipv6_converged", "spf6_scheduled_l1": "spf6_scheduled_l1", "spf6_scheduled_l2": "spf6_scheduled_l2", "spf_scheduled_l1": "spf_scheduled_l1", "spf_scheduled_l2": "spf_scheduled_l2", "system_id": "system_id", "v6_admin_distance": "v6_admin_distance", "default_link_metric_l1_adv": "default_link_metric_l1_adv", "pspf_scheduled": "pspf_scheduled", "auth_key_l2": "auth_key_l2", "database_state_level_1": "database_state_level_1", "auth_key_l1": "auth_key_l1", "v6_default_link_metric_l1_conf": "v6_default_link_metric_l1_conf", "ldp_sync_holddown_time": "ldp_sync_holddown_time", "l2_auth_no_check": "l2_auth_no_check", "overload_state_rem_time": "overload_state_rem_time", "bfd_enabled": "bfd_enabled", "pspf_second_wait": "pspf_second_wait", "v6_default_redis_metric": "v6_default_redis_metric"}, "pybind.slxos.v17s_1_02.isis_state.global_isis_info": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_admin_distance_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_area_addresses_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_auth_key_l1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_auth_key_l2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_auth_mode_l1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_auth_mode_l2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_bfd_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_bfd_hold_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_bgp_ipv4_converged_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_bgp_ipv6_converged_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_check_alarm_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_database_state_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_database_state_level_1_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_database_state_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_default_link_metric_l1_adv_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_default_link_metric_l1_conf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_default_link_metric_l2_adv_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_default_link_metric_l2_conf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_default_redis_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_graceful_restart_helper_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_hello_padding_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_hello_padding_ptp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_is_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_isis_is_mp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_isis_protocol_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_isis_reverse_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_isis_reverse_metric_sbit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_isis_reverse_metric_wbit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_isis_shortcuts_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_isis_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_isis_te_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_l1_auth_no_check_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_l2_auth_no_check_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_ldp_sync_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_ldp_sync_holddown_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_lsp_gen_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_lsp_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_lsp_max_lifetime_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_lsp_refresh_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_lsp_retrans_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_max_paths_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_metric_style_l1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_metric_style_l2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_no_routes_redis_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_nsr_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_nsr_standby_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_nsr_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_nsr_sync_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_overload_reason_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_overload_state_rem_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_overload_state_since_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_pspf6_init_wait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_pspf6_max_wait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_pspf6_scheduled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_pspf6_second_wait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_pspf_init_wait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_pspf_max_wait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_pspf_optimization_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_pspf_scheduled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_pspf_second_wait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_ptp_handshake_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_redis_protocol_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_snp_csnp_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_snp_psnp_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_spf6_init_wait_l1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_spf6_init_wait_l2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_spf6_max_wait_l1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_spf6_max_wait_l2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_spf6_scheduled_l1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_spf6_scheduled_l2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_spf6_second_wait_l1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_spf6_second_wait_l2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_spf_init_wait_l1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_spf_init_wait_l2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_spf_max_wait_l1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_spf_max_wait_l2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_spf_scheduled_l1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_spf_scheduled_l2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_spf_second_wait_l1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_spf_second_wait_l2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_system_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_v6_admin_distance_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_v6_default_link_metric_l1_adv_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_v6_default_link_metric_l1_conf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_v6_default_link_metric_l2_adv_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_v6_default_link_metric_l2_conf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_v6_default_redis_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_v6_max_paths_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_v6_no_routes_redis_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_global_isis_info_v6_redis_protocol_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.global_isis_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.global_isis_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.global_isis_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_host_table_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.host_table', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.host_table', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.host_table', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.host_table', u'isis_router_entry'), ('pybind.slxos.v17r_1_01a.isis_state.host_table', u'isis_router_entry'), ('pybind.slxos.v17s_1_02.isis_state.host_table', u'isis_router_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'system_id, host_name, is_local'}, {'leafval': 'system_id, host_name, is_local'}, {'leafval': 'system_id, host_name, is_local'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_host_table_hostname_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.host_table', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.host_table', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.host_table', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.host_table', u'isis_router_entry'), ('pybind.slxos.v17r_1_01a.isis_state.host_table', u'isis_router_entry'), ('pybind.slxos.v17s_1_02.isis_state.host_table', u'isis_router_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'system_id, host_name, is_local'}, {'leafval': 'system_id, host_name, is_local'}, {'leafval': 'system_id, host_name, is_local'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_host_table_isis_router_entry_get(self, isis_router_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_router_entry: system_id
    :param isis_router_entry: Keyword argument tuple.

    :type system_id: unicode
    :param system_id: **isis_router_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.host_table.isis_router_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.host_table.isis_router_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.host_table.isis_router_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_router_entry', 'keyval': 'system_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_router_entry=isis_router_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_router_entry=isis_router_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_host_table_isis_router_entry_host_name_get(self, isis_router_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_router_entry: system_id
    :param isis_router_entry: Keyword argument tuple.

    :type system_id: unicode
    :param system_id: **isis_router_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.host_table.isis_router_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.host_table.isis_router_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.host_table.isis_router_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_router_entry', 'keyval': 'system_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_router_entry=isis_router_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_router_entry=isis_router_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_host_table_isis_router_entry_is_local_get(self, isis_router_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_router_entry: system_id
    :param isis_router_entry: Keyword argument tuple.

    :type system_id: unicode
    :param system_id: **isis_router_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.host_table.isis_router_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.host_table.isis_router_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.host_table.isis_router_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_router_entry', 'keyval': 'system_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_router_entry=isis_router_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_router_entry=isis_router_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_brief_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_brief', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_brief', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_brief', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.interface_brief', u'isis_intf_brief'), ('pybind.slxos.v17r_1_01a.isis_state.interface_brief', u'isis_intf_brief'), ('pybind.slxos.v17s_1_02.isis_state.interface_brief', u'isis_intf_brief')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'intf_type, intf_number, circuit_type, is_circuit_passive, circuit_mode, circ_state, mtu_size, circ_adj_up, circ_changes, adj_changes, is_l1_dis, is_l2_dis'}, {'leafval': 'intf_type, intf_number, circuit_type, is_circuit_passive, circuit_mode, circ_state, mtu_size, circ_adj_up, circ_changes, adj_changes, is_l1_dis, is_l2_dis'}, {'leafval': 'intf_name, circuit_type, is_circuit_passive, circuit_mode, circ_state, mtu_size, circ_adj_up, circ_changes, adj_changes, is_l1_dis, is_l2_dis'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_get(self, isis_intf_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_type, intf_number
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf_brief** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf_brief** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief": {}, "pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief": {"circuit_mode": "circuit_mode", "intf_number": "intf_number", "intf_type": "intf_type", "circuit_type": "circuit_type", "circ_adj_up": "circ_adj_up", "mtu_size": "mtu_size", "is_circuit_passive": "is_circuit_passive", "circ_changes": "circ_changes", "is_l2_dis": "is_l2_dis", "adj_changes": "adj_changes", "circ_state": "circ_state", "is_l1_dis": "is_l1_dis"}, "pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief": {"circuit_mode": "circuit_mode", "intf_number": "intf_number", "intf_type": "intf_type", "circuit_type": "circuit_type", "circ_adj_up": "circ_adj_up", "mtu_size": "mtu_size", "is_circuit_passive": "is_circuit_passive", "circ_changes": "circ_changes", "is_l2_dis": "is_l2_dis", "adj_changes": "adj_changes", "circ_state": "circ_state", "is_l1_dis": "is_l1_dis"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_adj_changes_get(self, isis_intf_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_type, intf_number
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf_brief** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf_brief** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief": {}, "pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief": {"adj_changes": "adj_changes", "intf_type": "intf_type", "intf_number": "intf_number"}, "pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief": {"adj_changes": "adj_changes", "intf_type": "intf_type", "intf_number": "intf_number"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_circ_adj_up_get(self, isis_intf_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_type, intf_number
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf_brief** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf_brief** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief": {}, "pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief": {"circ_adj_up": "circ_adj_up", "intf_type": "intf_type", "intf_number": "intf_number"}, "pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief": {"circ_adj_up": "circ_adj_up", "intf_type": "intf_type", "intf_number": "intf_number"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_circ_changes_get(self, isis_intf_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_type, intf_number
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf_brief** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf_brief** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief": {}, "pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief": {"intf_number": "intf_number", "intf_type": "intf_type", "circ_changes": "circ_changes"}, "pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief": {"intf_number": "intf_number", "intf_type": "intf_type", "circ_changes": "circ_changes"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_circ_state_get(self, isis_intf_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_type, intf_number
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf_brief** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf_brief** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief": {}, "pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief": {"intf_number": "intf_number", "intf_type": "intf_type", "circ_state": "circ_state"}, "pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief": {"intf_number": "intf_number", "intf_type": "intf_type", "circ_state": "circ_state"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_circuit_mode_get(self, isis_intf_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_type, intf_number
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf_brief** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf_brief** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief": {}, "pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief": {"circuit_mode": "circuit_mode", "intf_number": "intf_number", "intf_type": "intf_type"}, "pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief": {"circuit_mode": "circuit_mode", "intf_number": "intf_number", "intf_type": "intf_type"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_circuit_type_get(self, isis_intf_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_type, intf_number
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf_brief** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf_brief** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief": {}, "pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief": {"circuit_type": "circuit_type", "intf_number": "intf_number", "intf_type": "intf_type"}, "pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief": {"circuit_type": "circuit_type", "intf_number": "intf_number", "intf_type": "intf_type"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_is_circuit_passive_get(self, isis_intf_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_type, intf_number
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf_brief** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf_brief** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief": {}, "pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief": {"intf_number": "intf_number", "intf_type": "intf_type", "is_circuit_passive": "is_circuit_passive"}, "pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief": {"intf_number": "intf_number", "intf_type": "intf_type", "is_circuit_passive": "is_circuit_passive"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_is_l1_dis_get(self, isis_intf_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_type, intf_number
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf_brief** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf_brief** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief": {}, "pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief": {"intf_number": "intf_number", "intf_type": "intf_type", "is_l1_dis": "is_l1_dis"}, "pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief": {"intf_number": "intf_number", "intf_type": "intf_type", "is_l1_dis": "is_l1_dis"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_is_l2_dis_get(self, isis_intf_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_type, intf_number
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf_brief** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf_brief** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief": {}, "pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief": {"is_l2_dis": "is_l2_dis", "intf_number": "intf_number", "intf_type": "intf_type"}, "pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief": {"is_l2_dis": "is_l2_dis", "intf_number": "intf_number", "intf_type": "intf_type"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_brief_isis_intf_brief_mtu_size_get(self, isis_intf_brief=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf_brief: intf_type, intf_number
    :param isis_intf_brief: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf_brief** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf_brief** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf_brief', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_brief.isis_intf_brief": {}, "pybind.slxos.v17r_2_00.isis_state.interface_brief.isis_intf_brief": {"mtu_size": "mtu_size", "intf_number": "intf_number", "intf_type": "intf_type"}, "pybind.slxos.v17r_1_01a.isis_state.interface_brief.isis_intf_brief": {"mtu_size": "mtu_size", "intf_number": "intf_number", "intf_type": "intf_type"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf_brief=isis_intf_brief)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf_brief=isis_intf_brief)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail', u'isis_intf'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail', u'isis_intf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'intf_type, intf_number, v4circuit_enabled, v6circuit_enabled, circuit_id, circuit_ifid, circuit_state, circuit_ip_state, circuit_ipv6_state, circuit_mode, circuit_type, circuit_encap, is_circuit_passive, mtu_size, padding_enabled, bfd_enabled'}, {'leafval': 'intf_type, intf_number, v4circuit_enabled, v6circuit_enabled, circuit_id, circuit_ifid, circuit_state, circuit_ip_state, circuit_ipv6_state, circuit_mode, circuit_type, circuit_encap, is_circuit_passive, mtu_size, padding_enabled, bfd_enabled'}, {'leafval': 'intf_name, intf_type, intf_index, v4circuit_enabled, v6circuit_enabled, circuit_id, circuit_ifid, circuit_state, circuit_ip_state, circuit_ipv6_state, circuit_mode, circuit_type, circuit_encap, is_circuit_passive, mtu_size, padding_enabled, bfd_enabled'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'ip_add, ip_prefix'}]
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf": {}, "pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf": {"circuit_mode": "circuit_mode", "intf_number": "intf_number", "intf_type": "intf_type", "padding_enabled": "padding_enabled", "circuit_type": "circuit_type", "circuit_id": "circuit_id", "mtu_size": "mtu_size", "circuit_state": "circuit_state", "v4circuit_enabled": "v4circuit_enabled", "circuit_ip_state": "circuit_ip_state", "v6circuit_enabled": "v6circuit_enabled", "is_circuit_passive": "is_circuit_passive", "circuit_ifid": "circuit_ifid", "circuit_encap": "circuit_encap", "circuit_ipv6_state": "circuit_ipv6_state", "bfd_enabled": "bfd_enabled"}, "pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf": {"circuit_mode": "circuit_mode", "intf_number": "intf_number", "intf_type": "intf_type", "padding_enabled": "padding_enabled", "circuit_type": "circuit_type", "circuit_id": "circuit_id", "mtu_size": "mtu_size", "circuit_state": "circuit_state", "v4circuit_enabled": "v4circuit_enabled", "circuit_ip_state": "circuit_ip_state", "v6circuit_enabled": "v6circuit_enabled", "is_circuit_passive": "is_circuit_passive", "circuit_ifid": "circuit_ifid", "circuit_encap": "circuit_encap", "circuit_ipv6_state": "circuit_ipv6_state", "bfd_enabled": "bfd_enabled"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_bfd_enabled_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'ip_add, ip_prefix'}]
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf": {}, "pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf": {"intf_number": "intf_number", "intf_type": "intf_type", "bfd_enabled": "bfd_enabled"}, "pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf": {"intf_number": "intf_number", "intf_type": "intf_type", "bfd_enabled": "bfd_enabled"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_adj_changes_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_adj_rej_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_bad_lsps_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_circ_changes_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_ctrl_in_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_ctrl_out_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_l1authfail_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_chstats_l2authfail_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.circ_chstats', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_metrics_get(self, isis_intf=None, circ_metrics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type circ_metrics: level
    :param circ_metrics: Keyword argument tuple.

    :type level: unicode
    :param level: **circ_metrics** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'circ_metrics', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, circ_metrics=circ_metrics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, circ_metrics=circ_metrics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_metrics_active_adj_get(self, isis_intf=None, circ_metrics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type circ_metrics: level
    :param circ_metrics: Keyword argument tuple.

    :type level: unicode
    :param level: **circ_metrics** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'circ_metrics', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, circ_metrics=circ_metrics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, circ_metrics=circ_metrics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_metrics_auth_check_get(self, isis_intf=None, circ_metrics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type circ_metrics: level
    :param circ_metrics: Keyword argument tuple.

    :type level: unicode
    :param level: **circ_metrics** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'circ_metrics', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, circ_metrics=circ_metrics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, circ_metrics=circ_metrics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_metrics_auth_key_get(self, isis_intf=None, circ_metrics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type circ_metrics: level
    :param circ_metrics: Keyword argument tuple.

    :type level: unicode
    :param level: **circ_metrics** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'circ_metrics', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, circ_metrics=circ_metrics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, circ_metrics=circ_metrics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_metrics_auth_mode_get(self, isis_intf=None, circ_metrics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type circ_metrics: level
    :param circ_metrics: Keyword argument tuple.

    :type level: unicode
    :param level: **circ_metrics** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'circ_metrics', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, circ_metrics=circ_metrics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, circ_metrics=circ_metrics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_metrics_circ_metric_get(self, isis_intf=None, circ_metrics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type circ_metrics: level
    :param circ_metrics: Keyword argument tuple.

    :type level: unicode
    :param level: **circ_metrics** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'circ_metrics', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, circ_metrics=circ_metrics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, circ_metrics=circ_metrics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_metrics_circ_priority_get(self, isis_intf=None, circ_metrics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type circ_metrics: level
    :param circ_metrics: Keyword argument tuple.

    :type level: unicode
    :param level: **circ_metrics** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'circ_metrics', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, circ_metrics=circ_metrics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, circ_metrics=circ_metrics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_metrics_dis_get(self, isis_intf=None, circ_metrics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type circ_metrics: level
    :param circ_metrics: Keyword argument tuple.

    :type level: unicode
    :param level: **circ_metrics** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'circ_metrics', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, circ_metrics=circ_metrics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, circ_metrics=circ_metrics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_metrics_dis_ch_get(self, isis_intf=None, circ_metrics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type circ_metrics: level
    :param circ_metrics: Keyword argument tuple.

    :type level: unicode
    :param level: **circ_metrics** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'circ_metrics', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, circ_metrics=circ_metrics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, circ_metrics=circ_metrics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_metrics_hello_int_get(self, isis_intf=None, circ_metrics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type circ_metrics: level
    :param circ_metrics: Keyword argument tuple.

    :type level: unicode
    :param level: **circ_metrics** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'circ_metrics', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, circ_metrics=circ_metrics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, circ_metrics=circ_metrics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_metrics_hello_mult_get(self, isis_intf=None, circ_metrics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type circ_metrics: level
    :param circ_metrics: Keyword argument tuple.

    :type level: unicode
    :param level: **circ_metrics** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'circ_metrics', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, circ_metrics=circ_metrics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, circ_metrics=circ_metrics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_metrics_ip6_circ_metric_get(self, isis_intf=None, circ_metrics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type circ_metrics: level
    :param circ_metrics: Keyword argument tuple.

    :type level: unicode
    :param level: **circ_metrics** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'circ_metrics', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, circ_metrics=circ_metrics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, circ_metrics=circ_metrics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circ_metrics_next_hello_get(self, isis_intf=None, circ_metrics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type circ_metrics: level
    :param circ_metrics: Keyword argument tuple.

    :type level: unicode
    :param level: **circ_metrics** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.circ_metrics', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'circ_metrics', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, circ_metrics=circ_metrics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, circ_metrics=circ_metrics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circuit_encap_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'ip_add, ip_prefix'}]
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf": {}, "pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf": {"circuit_encap": "circuit_encap", "intf_type": "intf_type", "intf_number": "intf_number"}, "pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf": {"circuit_encap": "circuit_encap", "intf_type": "intf_type", "intf_number": "intf_number"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circuit_id_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'ip_add, ip_prefix'}]
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf": {}, "pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf": {"circuit_id": "circuit_id", "intf_number": "intf_number", "intf_type": "intf_type"}, "pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf": {"circuit_id": "circuit_id", "intf_number": "intf_number", "intf_type": "intf_type"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circuit_ifid_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'ip_add, ip_prefix'}]
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf": {}, "pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf": {"intf_number": "intf_number", "intf_type": "intf_type", "circuit_ifid": "circuit_ifid"}, "pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf": {"intf_number": "intf_number", "intf_type": "intf_type", "circuit_ifid": "circuit_ifid"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circuit_ip_state_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'ip_add, ip_prefix'}]
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf": {}, "pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf": {"circuit_ip_state": "circuit_ip_state", "intf_number": "intf_number", "intf_type": "intf_type"}, "pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf": {"circuit_ip_state": "circuit_ip_state", "intf_number": "intf_number", "intf_type": "intf_type"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circuit_ipv6_state_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'ip_add, ip_prefix'}]
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf": {}, "pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf": {"intf_type": "intf_type", "intf_number": "intf_number", "circuit_ipv6_state": "circuit_ipv6_state"}, "pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf": {"intf_type": "intf_type", "intf_number": "intf_number", "circuit_ipv6_state": "circuit_ipv6_state"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circuit_mode_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'ip_add, ip_prefix'}]
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf": {}, "pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf": {"circuit_mode": "circuit_mode", "intf_number": "intf_number", "intf_type": "intf_type"}, "pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf": {"circuit_mode": "circuit_mode", "intf_number": "intf_number", "intf_type": "intf_type"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circuit_state_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'ip_add, ip_prefix'}]
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf": {}, "pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf": {"intf_number": "intf_number", "intf_type": "intf_type", "circuit_state": "circuit_state"}, "pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf": {"intf_number": "intf_number", "intf_type": "intf_type", "circuit_state": "circuit_state"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_circuit_type_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'ip_add, ip_prefix'}]
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf": {}, "pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf": {"circuit_type": "circuit_type", "intf_number": "intf_number", "intf_type": "intf_type"}, "pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf": {"circuit_type": "circuit_type", "intf_number": "intf_number", "intf_type": "intf_type"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_intf_index_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_intf_type_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ip6_info_get(self, isis_intf=None, ip6_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ip6_info: ip6_add
    :param ip6_info: Keyword argument tuple.

    :type ip6_add: unicode
    :param ip6_add: **ip6_info** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.ip6_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.ip6_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.ip6_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip6_info', 'keyval': 'ip6_add', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, ip6_info=ip6_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, ip6_info=ip6_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ip6_info_ip6_prefix_get(self, isis_intf=None, ip6_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ip6_info: ip6_add
    :param ip6_info: Keyword argument tuple.

    :type ip6_add: unicode
    :param ip6_add: **ip6_info** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.ip6_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.ip6_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.ip6_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip6_info', 'keyval': 'ip6_add', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, ip6_info=ip6_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, ip6_info=ip6_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ip6_info_is_link_local_get(self, isis_intf=None, ip6_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ip6_info: ip6_add
    :param ip6_info: Keyword argument tuple.

    :type ip6_add: unicode
    :param ip6_add: **ip6_info** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.ip6_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.ip6_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.ip6_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip6_info', 'keyval': 'ip6_add', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, ip6_info=ip6_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, ip6_info=ip6_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ip_info_get(self, isis_intf=None, ip_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ip_info: ip_add
    :param ip_info: Keyword argument tuple.

    :type ip_add: unicode
    :param ip_add: **ip_info** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.ip_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.ip_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.ip_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_info', 'keyval': 'ip_add', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, ip_info=ip_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, ip_info=ip_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ip_info_ip_prefix_get(self, isis_intf=None, ip_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type ip_info: ip_add
    :param ip_info: Keyword argument tuple.

    :type ip_add: unicode
    :param ip_add: **ip_info** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.ip_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.ip_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.ip_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_info', 'keyval': 'ip_add', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf, ip_info=ip_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf, ip_info=ip_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_is_circuit_passive_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'ip_add, ip_prefix'}]
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf": {}, "pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf": {"intf_number": "intf_number", "intf_type": "intf_type", "is_circuit_passive": "is_circuit_passive"}, "pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf": {"intf_number": "intf_number", "intf_type": "intf_type", "is_circuit_passive": "is_circuit_passive"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_active_adj_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_auth_check_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_auth_key_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_auth_mode_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_circ_metric_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_circ_priority_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_dis_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_dis_ch_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_hello_int_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_hello_mult_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_ip6_circ_metric_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l1_circ_metrics_next_hello_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l1_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_active_adj_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_auth_check_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_auth_key_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_auth_mode_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_circ_metric_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_circ_priority_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_dis_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_dis_ch_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_hello_int_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_hello_mult_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_ip6_circ_metric_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_l2_circ_metrics_next_hello_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_name
    :param isis_intf: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.l2_circ_metrics', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ldp_sync_info_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ldp_sync_info_ldp_in_sync_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ldp_sync_info_ldp_sync_enabled_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ldp_sync_info_ldp_sync_hd_expired_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ldp_sync_info_ldp_sync_hold_down_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_ldp_sync_info_remain_hd_time_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.ldp_sync_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_mpls_info_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_mpls_info_admin_group_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_mpls_info_max_link_bw_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_mpls_info_max_reserv_bw_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_mpls_info_te_enabled_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_mpls_info_te_metric_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.mpls_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_mtu_size_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'ip_add, ip_prefix'}]
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf": {}, "pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf": {"mtu_size": "mtu_size", "intf_number": "intf_number", "intf_type": "intf_type"}, "pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf": {"mtu_size": "mtu_size", "intf_number": "intf_number", "intf_type": "intf_type"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_padding_enabled_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'ip_add, ip_prefix'}]
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf": {}, "pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf": {"intf_number": "intf_number", "intf_type": "intf_type", "padding_enabled": "padding_enabled"}, "pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf": {"intf_number": "intf_number", "intf_type": "intf_type", "padding_enabled": "padding_enabled"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_reverse_metric_info_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_reverse_metric_info_is_global_config_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_reverse_metric_info_rev_metric_te_def_metric_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_reverse_metric_info_rev_metric_whole_lan_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_reverse_metric_info_reverse_metric_value_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'isis_intf'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'isis_intf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf.reverse_metric_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_type, intf_number', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_v4circuit_enabled_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'ip_add, ip_prefix'}]
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf": {}, "pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf": {"v4circuit_enabled": "v4circuit_enabled", "intf_number": "intf_number", "intf_type": "intf_type"}, "pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf": {"v4circuit_enabled": "v4circuit_enabled", "intf_number": "intf_number", "intf_type": "intf_type"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_interface_detail_isis_intf_v6circuit_enabled_get(self, isis_intf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type isis_intf: intf_type, intf_number
    :param isis_intf: Keyword argument tuple.

    :type intf_type: unicode
    :param intf_type: **isis_intf** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type intf_number: unicode
    :param intf_number: **isis_intf** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l1_circ_metrics'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'ip_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf', u'l2_circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'reverse_metric_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ldp_sync_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip6_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_chstats'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'circ_metrics'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'mpls_info'), ('pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf', u'ip_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isis_intf', 'keyval': 'intf_type, intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'ip_add, ip_prefix'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'is_global_config, reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ldp_sync_enabled, ldp_sync_hold_down, ldp_in_sync, remain_hd_time, ldp_sync_hd_expired'}, {'leafval': 'ip6_add, ip6_prefix, is_link_local'}, {'leafval': 'circ_changes, adj_changes, adj_rej, l1authfail, l2authfail, bad_lsps, ctrl_out, ctrl_in'}, {'leafval': 'level, auth_check, auth_mode, auth_key, circ_metric, ip6_circ_metric, circ_priority, hello_int, hello_mult, dis, dis_ch, next_hello, active_adj'}, {'leafval': 'te_enabled, admin_group, te_metric, max_link_bw, max_reserv_bw'}, {'leafval': 'ip_add, ip_prefix'}]
    leafval_map = {"pybind.slxos.v17s_1_02.isis_state.interface_detail.isis_intf": {}, "pybind.slxos.v17r_2_00.isis_state.interface_detail.isis_intf": {"v6circuit_enabled": "v6circuit_enabled", "intf_type": "intf_type", "intf_number": "intf_number"}, "pybind.slxos.v17r_1_01a.isis_state.interface_detail.isis_intf": {"v6circuit_enabled": "v6circuit_enabled", "intf_type": "intf_type", "intf_number": "intf_number"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isis_intf=isis_intf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isis_intf=isis_intf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv4_routes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv4_routes', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv4_routes', u'ipv4_route_entry'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes', u'ipv4_route_entry'), ('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes', u'ipv4_route_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_get(self, ipv4_route_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info'), ('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_route_entry', 'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv4_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv4_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv4_nh_addr, outgoing_intf_name, is_mpls_tunnel_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_cost_get(self, ipv4_route_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info'), ('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_route_entry', 'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv4_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv4_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv4_nh_addr, outgoing_intf_name, is_mpls_tunnel_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_flags_get(self, ipv4_route_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info'), ('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_route_entry', 'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv4_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv4_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv4_nh_addr, outgoing_intf_name, is_mpls_tunnel_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_is_l1_summarized_get(self, ipv4_route_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info'), ('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_route_entry', 'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv4_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv4_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv4_nh_addr, outgoing_intf_name, is_mpls_tunnel_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_is_l2_summarized_get(self, ipv4_route_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info'), ('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_route_entry', 'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv4_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv4_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv4_nh_addr, outgoing_intf_name, is_mpls_tunnel_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_is_summary_get(self, ipv4_route_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info'), ('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_route_entry', 'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv4_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv4_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv4_nh_addr, outgoing_intf_name, is_mpls_tunnel_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_level_get(self, ipv4_route_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info'), ('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_route_entry', 'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv4_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv4_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv4_nh_addr, outgoing_intf_name, is_mpls_tunnel_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_nh_info_get(self, ipv4_route_entry=None, nh_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    **Instance Keyword Argument Tuple**:

    :type nh_info: outgoing_intf_type, outgoing_intf_number
    :param nh_info: Keyword argument tuple.

    :type outgoing_intf_type: unicode
    :param outgoing_intf_type: **nh_info** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type outgoing_intf_number: unicode
    :param outgoing_intf_number: **nh_info** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', u'ipv4_route_entry'), ('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', u'ipv4_route_entry'), ('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', u'ipv4_route_entry')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry.nh_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry.nh_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry.nh_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry.nh_info', u'lsp_info')]
    compositions_keyval_list = [{'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}, {'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}, {'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nh_info', 'keyval': 'outgoing_intf_type, outgoing_intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_name'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry.nh_info": {"outgoing_intf_number": "outgoing_intf_number", "outgoing_intf_type": "outgoing_intf_type", "ipv4_nh_addr": "ipv4_nh_addr"}, "pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry.nh_info": {"outgoing_intf_number": "outgoing_intf_number", "outgoing_intf_type": "outgoing_intf_type", "ipv4_nh_addr": "ipv4_nh_addr"}, "pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry.nh_info": {"ipv4_nh_addr": "ipv4_nh_addr"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry, nh_info=nh_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry, nh_info=nh_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_nh_info_ipv4_nh_addr_get(self, ipv4_route_entry=None, nh_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    **Instance Keyword Argument Tuple**:

    :type nh_info: outgoing_intf_type, outgoing_intf_number
    :param nh_info: Keyword argument tuple.

    :type outgoing_intf_type: unicode
    :param outgoing_intf_type: **nh_info** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type outgoing_intf_number: unicode
    :param outgoing_intf_number: **nh_info** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', u'ipv4_route_entry'), ('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', u'ipv4_route_entry'), ('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', u'ipv4_route_entry')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry.nh_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry.nh_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry.nh_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry.nh_info', u'lsp_info')]
    compositions_keyval_list = [{'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}, {'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}, {'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nh_info', 'keyval': 'outgoing_intf_type, outgoing_intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_name'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry.nh_info": {"outgoing_intf_number": "outgoing_intf_number", "outgoing_intf_type": "outgoing_intf_type", "ipv4_nh_addr": "ipv4_nh_addr"}, "pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry.nh_info": {"outgoing_intf_number": "outgoing_intf_number", "outgoing_intf_type": "outgoing_intf_type", "ipv4_nh_addr": "ipv4_nh_addr"}, "pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry.nh_info": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry, nh_info=nh_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry, nh_info=nh_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_nh_info_is_mpls_tunnel_port_get(self, ipv4_route_entry=None, nh_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    **Instance Keyword Argument Tuple**:

    :type nh_info: outgoing_intf_name
    :param nh_info: Keyword argument tuple.

    :type outgoing_intf_name: unicode
    :param outgoing_intf_name: **nh_info** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', u'ipv4_route_entry')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry.nh_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry.nh_info', u'lsp_info')]
    compositions_keyval_list = [{'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nh_info', 'keyval': 'outgoing_intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry, nh_info=nh_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry, nh_info=nh_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_nh_info_lsp_info_get(self, ipv4_route_entry=None, nh_info=None, lsp_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type nh_info: outgoing_intf_name
    :param nh_info: Keyword argument tuple.

    :type outgoing_intf_name: unicode
    :param outgoing_intf_name: **nh_info** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type lsp_info: lsp_name
    :param lsp_info: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp_info** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', u'ipv4_route_entry'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry.nh_info', u'nh_info')]
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry.nh_info.lsp_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}, {'keyval': 'outgoing_intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_info', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry, nh_info=nh_info, lsp_info=lsp_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry, nh_info=nh_info, lsp_info=lsp_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv4_routes_ipv4_route_entry_tag_get(self, ipv4_route_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv4_route_entry: ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len
    :param ipv4_route_entry: Keyword argument tuple.

    :type ipv4_dest_addr: unicode
    :param ipv4_dest_addr: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_subnet_mask: unicode
    :param ipv4_subnet_mask: **ipv4_route_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ipv4_prefix_len: int
    :param ipv4_prefix_len: **ipv4_route_entry** tuple argument.

        * range restriction: ::

            ['-128..127']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info'), ('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes.ipv4_route_entry', u'nh_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv4_route_entry', 'keyval': 'ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv4_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv4_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv4_nh_addr, outgoing_intf_name, is_mpls_tunnel_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv4_route_entry=ipv4_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv4_route_entry=ipv4_route_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv4_routes_total_routes_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv4_routes', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv4_routes', u'ipv4_route_entry'), ('pybind.slxos.v17s_1_02.isis_state.ipv4_routes', u'ipv4_route_entry'), ('pybind.slxos.v17r_1_01a.isis_state.ipv4_routes', u'ipv4_route_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv4_dest_addr, ipv4_subnet_mask, ipv4_prefix_len'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv6_routes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv6_routes', u'ipv6_route_entry'), ('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes', u'ipv6_route_entry'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes', u'ipv6_route_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.isis_state.ipv6_routes": {"level2_route_count": "level2_route_count", "ecmp_route_count": "ecmp_route_count", "total_routes_count": "total_routes_count", "level1_route_count": "level1_route_count"}, "pybind.slxos.v17s_1_02.isis_state.ipv6_routes": {}, "pybind.slxos.v17r_2_00.isis_state.ipv6_routes": {"level2_route_count": "level2_route_count", "ecmp_route_count": "ecmp_route_count", "total_routes_count": "total_routes_count", "level1_route_count": "level1_route_count"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv6_routes_ecmp_route_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.ipv6_routes', u'ipv6_route_entry'), ('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes', u'ipv6_route_entry'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes', u'ipv6_route_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_get(self, ipv6_route_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info'), ('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_route_entry', 'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv6_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv6_nh_addr, outgoing_intf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_cost_get(self, ipv6_route_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info'), ('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_route_entry', 'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv6_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv6_nh_addr, outgoing_intf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_flags_get(self, ipv6_route_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info'), ('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_route_entry', 'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv6_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv6_nh_addr, outgoing_intf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_is_l1_summarized_get(self, ipv6_route_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info'), ('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_route_entry', 'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv6_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv6_nh_addr, outgoing_intf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_is_l2_summarized_get(self, ipv6_route_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info'), ('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_route_entry', 'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv6_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv6_nh_addr, outgoing_intf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_is_summary_get(self, ipv6_route_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info'), ('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_route_entry', 'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv6_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv6_nh_addr, outgoing_intf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_level_get(self, ipv6_route_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info'), ('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_route_entry', 'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv6_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv6_nh_addr, outgoing_intf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_nh_info_get(self, ipv6_route_entry=None, nh_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type nh_info: outgoing_intf_type, outgoing_intf_number
    :param nh_info: Keyword argument tuple.

    :type outgoing_intf_type: unicode
    :param outgoing_intf_type: **nh_info** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type outgoing_intf_number: unicode
    :param outgoing_intf_number: **nh_info** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', u'ipv6_route_entry'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', u'ipv6_route_entry'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', u'ipv6_route_entry')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry.nh_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry.nh_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry.nh_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}, {'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}, {'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nh_info', 'keyval': 'outgoing_intf_type, outgoing_intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry.nh_info": {"outgoing_intf_number": "outgoing_intf_number", "outgoing_intf_type": "outgoing_intf_type", "ipv6_nh_addr": "ipv6_nh_addr"}, "pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry.nh_info": {"outgoing_intf_number": "outgoing_intf_number", "outgoing_intf_type": "outgoing_intf_type", "ipv6_nh_addr": "ipv6_nh_addr"}, "pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry.nh_info": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry, nh_info=nh_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry, nh_info=nh_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_nh_info_ipv6_nh_addr_get(self, ipv6_route_entry=None, nh_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type nh_info: outgoing_intf_type, outgoing_intf_number
    :param nh_info: Keyword argument tuple.

    :type outgoing_intf_type: unicode
    :param outgoing_intf_type: **nh_info** tuple argument.

        * enumeration restriction: ::

            ['eth', 've', 'invalid', 'loopback']

    :type outgoing_intf_number: unicode
    :param outgoing_intf_number: **nh_info** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', u'ipv6_route_entry'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', u'ipv6_route_entry'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', u'ipv6_route_entry')]
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry.nh_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry.nh_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry.nh_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}, {'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}, {'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nh_info', 'keyval': 'outgoing_intf_type, outgoing_intf_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry.nh_info": {"outgoing_intf_number": "outgoing_intf_number", "outgoing_intf_type": "outgoing_intf_type", "ipv6_nh_addr": "ipv6_nh_addr"}, "pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry.nh_info": {"outgoing_intf_number": "outgoing_intf_number", "outgoing_intf_type": "outgoing_intf_type", "ipv6_nh_addr": "ipv6_nh_addr"}, "pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry.nh_info": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry, nh_info=nh_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry, nh_info=nh_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv6_routes_ipv6_route_entry_tag_get(self, ipv6_route_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ipv6_route_entry: ipv6_dest_addr, ipv6_prefix_len
    :param ipv6_route_entry: Keyword argument tuple.

    :type ipv6_dest_addr: unicode
    :param ipv6_dest_addr: **ipv6_route_entry** tuple argument.

    :type ipv6_prefix_len: int
    :param ipv6_prefix_len: **ipv6_route_entry** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info'), ('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes.ipv6_route_entry', u'nh_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ipv6_route_entry', 'keyval': 'ipv6_dest_addr, ipv6_prefix_len', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv6_nh_addr, outgoing_intf_type, outgoing_intf_number'}, {'leafval': 'ipv6_nh_addr, outgoing_intf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ipv6_route_entry=ipv6_route_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ipv6_route_entry=ipv6_route_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv6_routes_level1_route_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.ipv6_routes', u'ipv6_route_entry'), ('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes', u'ipv6_route_entry'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes', u'ipv6_route_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv6_routes_level2_route_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.ipv6_routes', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.ipv6_routes', u'ipv6_route_entry'), ('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes', u'ipv6_route_entry'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes', u'ipv6_route_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_ipv6_routes_total_routes_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.ipv6_routes', u'ipv6_route_entry'), ('pybind.slxos.v17r_2_00.isis_state.ipv6_routes', u'ipv6_route_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}, {'leafval': 'level, cost, tag, flags, is_l1_summarized, is_l2_summarized, is_summary, ipv6_dest_addr, ipv6_prefix_len'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.isis_state.router_isis_config": {"ispf_enabled": "ispf_enabled", "overload_bgp_wait_time": "overload_bgp_wait_time", "fast_flood_wait_count": "fast_flood_wait_count", "lsp_interval": "lsp_interval", "overload_state": "overload_state", "retransmit_interval": "retransmit_interval", "lsp_fast_flood_count": "lsp_fast_flood_count", "overload_startup_time": "overload_startup_time", "csnp_interval": "csnp_interval", "istct_spf_enabled": "istct_spf_enabled", "lsp_flood_count": "lsp_flood_count", "nsr_state": "nsr_state", "overload_wait_on_bgp": "overload_wait_on_bgp", "lsp_gen_interval": "lsp_gen_interval", "lsp_refresh_interval": "lsp_refresh_interval", "lsp_lifetime": "lsp_lifetime", "isis_hostname_enabled": "isis_hostname_enabled", "hello_padding": "hello_padding", "graceful_restart_helper": "graceful_restart_helper", "bfd_holdover_interval": "bfd_holdover_interval", "enable_code_assertions": "enable_code_assertions", "bfd": "bfd", "hello_padding_ptp": "hello_padding_ptp", "pspf_enabled": "pspf_enabled"}, "pybind.slxos.v17r_2_00.isis_state.router_isis_config": {"ispf_enabled": "ispf_enabled", "overload_bgp_wait_time": "overload_bgp_wait_time", "fast_flood_wait_count": "fast_flood_wait_count", "lsp_interval": "lsp_interval", "overload_state": "overload_state", "retransmit_interval": "retransmit_interval", "lsp_fast_flood_count": "lsp_fast_flood_count", "overload_startup_time": "overload_startup_time", "csnp_interval": "csnp_interval", "istct_spf_enabled": "istct_spf_enabled", "lsp_flood_count": "lsp_flood_count", "nsr_state": "nsr_state", "overload_wait_on_bgp": "overload_wait_on_bgp", "lsp_gen_interval": "lsp_gen_interval", "lsp_refresh_interval": "lsp_refresh_interval", "lsp_lifetime": "lsp_lifetime", "isis_hostname_enabled": "isis_hostname_enabled", "hello_padding": "hello_padding", "graceful_restart_helper": "graceful_restart_helper", "bfd_holdover_interval": "bfd_holdover_interval", "enable_code_assertions": "enable_code_assertions", "bfd": "bfd", "hello_padding_ptp": "hello_padding_ptp", "pspf_enabled": "pspf_enabled"}, "pybind.slxos.v17s_1_02.isis_state.router_isis_config": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_bfd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_bfd_holdover_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_csnp_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_debug_handler_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.debug_handler', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.debug_handler', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.debug_handler', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_debug_handler_debug_nsr_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.debug_handler', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.debug_handler', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.debug_handler', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_enable_code_assertions_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_fast_flood_wait_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_graceful_restart_helper_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_hello_padding_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_hello_padding_ptp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_administrative_distance_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_afi_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_default_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_l1_default_link_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_l1_wide_metric_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_l2_default_link_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_l2_wide_metric_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_ldp_sync_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_ldp_sync_hold_down_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_maximum_equal_cost_paths_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_originate_default_route_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_originate_default_routemap_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_bgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_bgp_redist_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_bgp_redist_level_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_bgp_redist_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_bgp_redist_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_bgp_redist_routemap_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_bgp', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_connected_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_connected_redist_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_connected_redist_level_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_connected_redist_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_connected_redist_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_connected_redist_routemap_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_connected', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_isis_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_isis_redist_is_l1_to_l2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_isis_redist_is_l1_to_l2_prefix_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_isis_redist_is_l2_to_l1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_isis_redist_is_l2_to_l1_prefix_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_isis', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_ospf_external1_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_ospf_external2_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_ospf_internal_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_redist_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_redist_level_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_redist_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_redist_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_ospf_redist_routemap_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_rip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_rip', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_rip_redist_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_rip', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_rip_redist_level_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_rip', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_rip_redist_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_rip', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_rip_redist_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_rip', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_rip_redist_routemap_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_rip', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_static_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_static_redist_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_static_redist_level_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_static_redist_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_static_redist_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_redist_static_redist_routemap_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.redist_static', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_safi_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_summary_address_v4_get(self, summary_address_v4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type summary_address_v4: address
    :param summary_address_v4: Keyword argument tuple.

    :type address: unicode
    :param address: **summary_address_v4** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.summary_address_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.summary_address_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.summary_address_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_address_v4', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_address_v4=summary_address_v4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_address_v4=summary_address_v4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_summary_address_v4_ipv4_mask_get(self, summary_address_v4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type summary_address_v4: address
    :param summary_address_v4: Keyword argument tuple.

    :type address: unicode
    :param address: **summary_address_v4** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.summary_address_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.summary_address_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.summary_address_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_address_v4', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_address_v4=summary_address_v4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_address_v4=summary_address_v4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v4_summary_address_v4_level_get(self, summary_address_v4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type summary_address_v4: address
    :param summary_address_v4: Keyword argument tuple.

    :type address: unicode
    :param address: **summary_address_v4** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4.summary_address_v4', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4.summary_address_v4', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4.summary_address_v4', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_address_v4', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_address_v4=summary_address_v4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_address_v4=summary_address_v4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_adjacency_check_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_administrative_distance_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_afi_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_default_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_l1_default_link_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_l2_default_link_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_maximum_equal_cost_paths_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_mt_transition_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_multi_topology_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_originate_default_route_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_originate_default_routemap_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_bgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_bgp_redist_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_bgp_redist_level_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_bgp_redist_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_bgp_redist_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_bgp_redist_routemap_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_bgp', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_connected_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_connected_redist_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_connected_redist_level_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_connected_redist_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_connected_redist_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_connected_redist_routemap_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_connected', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_isis_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_isis_redist_is_l1_to_l2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_isis_redist_is_l1_to_l2_prefix_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_isis_redist_is_l2_to_l1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_isis_redist_is_l2_to_l1_prefix_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_isis', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_ospf_external1_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_ospf_external2_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_ospf_internal_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_redist_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_redist_level_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_redist_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_redist_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_ospf_redist_routemap_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_ospf', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_rip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_rip', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_rip_redist_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_rip', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_rip_redist_level_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_rip', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_rip_redist_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_rip', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_rip_redist_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_rip', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_rip_redist_routemap_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_rip', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_static_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_static_redist_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_static_redist_level_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_static_redist_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_static_redist_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_redist_static_redist_routemap_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.redist_static', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_safi_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'address, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_summary_prefix_v6_get(self, summary_prefix_v6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type summary_prefix_v6: address
    :param summary_prefix_v6: Keyword argument tuple.

    :type address: unicode
    :param address: **summary_prefix_v6** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.summary_prefix_v6', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.summary_prefix_v6', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.summary_prefix_v6', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_prefix_v6', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_prefix_v6=summary_prefix_v6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_prefix_v6=summary_prefix_v6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_is_address_family_v6_summary_prefix_v6_level_get(self, summary_prefix_v6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type summary_prefix_v6: address
    :param summary_prefix_v6: Keyword argument tuple.

    :type address: unicode
    :param address: **summary_prefix_v6** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6.summary_prefix_v6', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6.summary_prefix_v6', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6.summary_prefix_v6', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_prefix_v6', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_prefix_v6=summary_prefix_v6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_prefix_v6=summary_prefix_v6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_isis_hostname_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_isis_system_info_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'length, net_addr'}, {'leafval': 'length, net_addr'}, {'leafval': 'length, net_addr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_isis_system_info_nsap_get(self, nsap=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type nsap: net_addr
    :param nsap: Keyword argument tuple.

    :type net_addr: unicode
    :param net_addr: **nsap** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info.nsap', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info.nsap', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info.nsap', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nsap', 'keyval': 'net_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsap=nsap)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsap=nsap)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_isis_system_info_nsap_length_get(self, nsap=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type nsap: net_addr
    :param nsap: Keyword argument tuple.

    :type net_addr: unicode
    :param net_addr: **nsap** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info.nsap', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info.nsap', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info.nsap', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'nsap', 'keyval': 'net_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsap=nsap)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsap=nsap)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_isis_system_info_operation_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'length, net_addr'}, {'leafval': 'length, net_addr'}, {'leafval': 'length, net_addr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_isis_system_info_protocol_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'length, net_addr'}, {'leafval': 'length, net_addr'}, {'leafval': 'length, net_addr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_isis_system_info_system_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'length, net_addr'}, {'leafval': 'length, net_addr'}, {'leafval': 'length, net_addr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_ispf_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_istct_spf_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l1_auth_profile_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l1_auth_profile', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l1_auth_profile', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l1_auth_profile', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l1_auth_profile_auth_check_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l1_auth_profile', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l1_auth_profile', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l1_auth_profile', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l1_auth_profile_auth_key_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l1_auth_profile', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l1_auth_profile', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l1_auth_profile', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l1_auth_profile_auth_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l1_auth_profile', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l1_auth_profile', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l1_auth_profile', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l1_spf6_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l1_spf6_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l1_spf6_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l1_spf6_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l1_spf6_timer_hold_down_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l1_spf6_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l1_spf6_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l1_spf6_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l1_spf6_timer_init_delay_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l1_spf6_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l1_spf6_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l1_spf6_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l1_spf6_timer_max_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l1_spf6_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l1_spf6_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l1_spf6_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l1_spf_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l1_spf_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l1_spf_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l1_spf_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l1_spf_timer_hold_down_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l1_spf_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l1_spf_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l1_spf_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l1_spf_timer_init_delay_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l1_spf_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l1_spf_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l1_spf_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l1_spf_timer_max_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l1_spf_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l1_spf_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l1_spf_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l2_auth_profile_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l2_auth_profile', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l2_auth_profile', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l2_auth_profile', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l2_auth_profile_auth_check_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l2_auth_profile', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l2_auth_profile', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l2_auth_profile', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l2_auth_profile_auth_key_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l2_auth_profile', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l2_auth_profile', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l2_auth_profile', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l2_auth_profile_auth_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l2_auth_profile', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l2_auth_profile', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l2_auth_profile', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l2_spf6_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l2_spf6_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l2_spf6_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l2_spf6_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l2_spf6_timer_hold_down_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l2_spf6_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l2_spf6_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l2_spf6_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l2_spf6_timer_init_delay_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l2_spf6_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l2_spf6_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l2_spf6_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l2_spf6_timer_max_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l2_spf6_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l2_spf6_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l2_spf6_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l2_spf_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l2_spf_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l2_spf_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l2_spf_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l2_spf_timer_hold_down_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l2_spf_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l2_spf_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l2_spf_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l2_spf_timer_init_delay_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l2_spf_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l2_spf_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l2_spf_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_l2_spf_timer_max_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.l2_spf_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.l2_spf_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.l2_spf_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_log_handler_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.log_handler', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.log_handler', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.log_handler', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_log_handler_log_adj_state_change_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.log_handler', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.log_handler', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.log_handler', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_log_handler_log_bad_lsp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.log_handler', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.log_handler', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.log_handler', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_lsp_fast_flood_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_lsp_flood_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_lsp_gen_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_lsp_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_lsp_lifetime_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_lsp_refresh_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_nsr_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_overload_bgp_wait_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_overload_startup_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_overload_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_overload_wait_on_bgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_pspf6_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.pspf6_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.pspf6_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.pspf6_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_pspf6_timer_hold_down_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.pspf6_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.pspf6_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.pspf6_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_pspf6_timer_init_delay_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.pspf6_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.pspf6_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.pspf6_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_pspf6_timer_max_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.pspf6_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.pspf6_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.pspf6_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_pspf_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_pspf_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.pspf_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.pspf_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.pspf_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_pspf_timer_hold_down_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.pspf_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.pspf_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.pspf_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_pspf_timer_init_delay_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.pspf_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.pspf_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.pspf_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_pspf_timer_max_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.pspf_timer', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.pspf_timer', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.pspf_timer', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_retransmit_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'log_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17r_1_01a.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_spf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_static'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'summary_prefix_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'isis_system_info'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.isis_system_info', u'nsap'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf6_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_ospf'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'pspf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_rip'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'debug_handler'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_bgp'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l1_spf_timer'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'reverse_metric'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_connected'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v6', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'l2_auth_profile'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'is_address_family_v6'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'redist_isis'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.is_address_family_v4', u'summary_address_v4'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config', u'log_handler')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, level'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'length, net_addr'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'debug_nsr'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'address, level'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, l1_wide_metric_enabled, l2_wide_metric_enabled, ldp_sync_enabled, ldp_sync_hold_down'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'protocol_enabled, operation_mode, system_id'}, {'leafval': 'length, net_addr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name, ospf_internal_enabled, ospf_external1_enabled, ospf_external2_enabled'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'debug_nsr'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'init_delay_time, hold_down_time, max_time'}, {'leafval': 'reverse_metric_value, rev_metric_whole_lan, rev_metric_te_def_metric, rev_metric_tlv_type'}, {'leafval': 'redist_enabled, redist_level, redist_metric, redist_metric_type, redist_routemap_name'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'auth_check, auth_mode, auth_key'}, {'leafval': 'afi, safi, originate_default_route, originate_default_routemap_name, default_metric, l1_default_link_metric, l2_default_link_metric, administrative_distance, maximum_equal_cost_paths, adjacency_check, multi_topology, mt_transition_state'}, {'leafval': 'redist_is_l2_to_l1, redist_is_l2_to_l1_prefix, redist_is_l1_to_l2, redist_is_l1_to_l2_prefix'}, {'leafval': 'address, ipv4_mask, level'}, {'leafval': 'log_adj_state_change, log_bad_lsp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_reverse_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_reverse_metric_rev_metric_te_def_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_reverse_metric_rev_metric_tlv_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_reverse_metric_rev_metric_whole_lan_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isis_state_router_isis_config_reverse_metric_reverse_metric_value_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.isis_state.router_isis_config.reverse_metric', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isns_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.isns', 'pybind.nos.v7_2_0.brocade_isns', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.isns', u'isns_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isns_vrf_instance, isns_ipaddress, esi_timeout'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isns_vrf_forwarding_get(self, isns_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type isns_vrf: isns_vrf_instance
    :param isns_vrf: Keyword argument tuple.

    :type isns_vrf_instance: long
    :param isns_vrf_instance: **isns_vrf** tuple argument:  iSNS VRF forwarding value 1

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.isns.isns_vrf', 'pybind.nos.v7_2_0.brocade_isns', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.isns.isns_vrf', u'isns_discovery_domain_set'), ('pybind.nos.v7_2_0.isns.isns_vrf', u'isns_discovery_domain')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isns_vrf', 'keyval': 'isns_vrf_instance', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isns_discovery_domain_set_name, isns_discovery_domain_set_enable'}, {'leafval': 'isns_discovery_domain_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isns_vrf=isns_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isns_vrf=isns_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isns_vrf_forwarding_discovery_domain_get(self, isns_vrf=None, isns_discovery_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isns_vrf: isns_vrf_instance
    :param isns_vrf: Keyword argument tuple.

    :type isns_vrf_instance: long
    :param isns_vrf_instance: **isns_vrf** tuple argument:  iSNS VRF forwarding value 1

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type isns_discovery_domain: isns_discovery_domain_name
    :param isns_discovery_domain: Keyword argument tuple.

    :type isns_discovery_domain_name: unicode
    :param isns_discovery_domain_name: **isns_discovery_domain** tuple argument:  iSNS Discovery Domain Name (Max Size - 256)

        * length restriction: ::

            ['1..255']

        * pattern restriction: ::

            '[-_0-9a-zA-Z]{1,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.isns.isns_vrf', u'isns_vrf')]
    bindings_list = [('pybind.nos.v7_2_0.isns.isns_vrf.isns_discovery_domain', 'pybind.nos.v7_2_0.brocade_isns', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'isns_vrf_instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'isns_discovery_domain', 'keyval': 'isns_discovery_domain_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isns_vrf=isns_vrf, isns_discovery_domain=isns_discovery_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isns_vrf=isns_vrf, isns_discovery_domain=isns_discovery_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isns_vrf_forwarding_discovery_domain_set_get(self, isns_vrf=None, isns_discovery_domain_set=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isns_vrf: isns_vrf_instance
    :param isns_vrf: Keyword argument tuple.

    :type isns_vrf_instance: long
    :param isns_vrf_instance: **isns_vrf** tuple argument:  iSNS VRF forwarding value 1

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type isns_discovery_domain_set: isns_discovery_domain_set_name
    :param isns_discovery_domain_set: Keyword argument tuple.

    :type isns_discovery_domain_set_name: unicode
    :param isns_discovery_domain_set_name: **isns_discovery_domain_set** tuple argument:  iSNS Discovery Domain Set Name (Max Size - 256)

        * length restriction: ::

            ['1..255']

        * pattern restriction: ::

            '[-_0-9a-zA-Z]{1,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.isns.isns_vrf', u'isns_vrf')]
    bindings_list = [('pybind.nos.v7_2_0.isns.isns_vrf.isns_discovery_domain_set', 'pybind.nos.v7_2_0.brocade_isns', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'isns_vrf_instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'isns_discovery_domain_set', 'keyval': 'isns_discovery_domain_set_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isns_vrf=isns_vrf, isns_discovery_domain_set=isns_discovery_domain_set)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isns_vrf=isns_vrf, isns_discovery_domain_set=isns_discovery_domain_set)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isns_vrf_forwarding_discovery_domain_set_enable_get(self, isns_vrf=None, isns_discovery_domain_set=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type isns_vrf: isns_vrf_instance
    :param isns_vrf: Keyword argument tuple.

    :type isns_vrf_instance: long
    :param isns_vrf_instance: **isns_vrf** tuple argument:  iSNS VRF forwarding value 1

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type isns_discovery_domain_set: isns_discovery_domain_set_name
    :param isns_discovery_domain_set: Keyword argument tuple.

    :type isns_discovery_domain_set_name: unicode
    :param isns_discovery_domain_set_name: **isns_discovery_domain_set** tuple argument:  iSNS Discovery Domain Set Name (Max Size - 256)

        * length restriction: ::

            ['1..255']

        * pattern restriction: ::

            '[-_0-9a-zA-Z]{1,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.isns.isns_vrf', u'isns_vrf')]
    bindings_list = [('pybind.nos.v7_2_0.isns.isns_vrf.isns_discovery_domain_set', 'pybind.nos.v7_2_0.brocade_isns', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'isns_vrf_instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'isns_discovery_domain_set', 'keyval': 'isns_discovery_domain_set_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isns_vrf=isns_vrf, isns_discovery_domain_set=isns_discovery_domain_set)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isns_vrf=isns_vrf, isns_discovery_domain_set=isns_discovery_domain_set)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isns_vrf_forwarding_esi_timeout_get(self, isns_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type isns_vrf: isns_vrf_instance
    :param isns_vrf: Keyword argument tuple.

    :type isns_vrf_instance: long
    :param isns_vrf_instance: **isns_vrf** tuple argument:  iSNS VRF forwarding value 1

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.isns.isns_vrf', 'pybind.nos.v7_2_0.brocade_isns', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.isns.isns_vrf', u'isns_discovery_domain_set'), ('pybind.nos.v7_2_0.isns.isns_vrf', u'isns_discovery_domain')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isns_vrf', 'keyval': 'isns_vrf_instance', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isns_discovery_domain_set_name, isns_discovery_domain_set_enable'}, {'leafval': 'isns_discovery_domain_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isns_vrf=isns_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isns_vrf=isns_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def isns_vrf_forwarding_isns_ipaddress_get(self, isns_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type isns_vrf: isns_vrf_instance
    :param isns_vrf: Keyword argument tuple.

    :type isns_vrf_instance: long
    :param isns_vrf_instance: **isns_vrf** tuple argument:  iSNS VRF forwarding value 1

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.isns.isns_vrf', 'pybind.nos.v7_2_0.brocade_isns', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.isns.isns_vrf', u'isns_discovery_domain_set'), ('pybind.nos.v7_2_0.isns.isns_vrf', u'isns_discovery_domain')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'isns_vrf', 'keyval': 'isns_vrf_instance', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isns_discovery_domain_set_name, isns_discovery_domain_set_enable'}, {'leafval': 'isns_discovery_domain_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, isns_vrf=isns_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, isns_vrf=isns_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def keychain_get(self, keychain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type keychain: name_of_keychain
    :param keychain: Keyword argument tuple.

    :type name_of_keychain: unicode
    :param name_of_keychain: **keychain** tuple argument:  name of the keychain

        * length restriction: ::

            ['4..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.keychain', 'pybind.slxos.v17r_2_00.brocade_keychain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.keychain', u'key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'keychain', 'keyval': 'name_of_keychain', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'key_id, key_algorithm'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, keychain=keychain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, keychain=keychain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def keychain_accept_tolerance_get(self, keychain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type keychain: name_of_keychain
    :param keychain: Keyword argument tuple.

    :type name_of_keychain: unicode
    :param name_of_keychain: **keychain** tuple argument:  name of the keychain

        * length restriction: ::

            ['4..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.keychain', 'pybind.slxos.v17r_2_00.brocade_keychain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.keychain', u'key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'keychain', 'keyval': 'name_of_keychain', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'key_id, key_algorithm'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, keychain=keychain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, keychain=keychain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def keychain_key_get(self, keychain=None, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type keychain: name_of_keychain
    :param keychain: Keyword argument tuple.

    :type name_of_keychain: unicode
    :param name_of_keychain: **keychain** tuple argument:  name of the keychain

        * length restriction: ::

            ['4..32']

    **Instance Keyword Argument Tuple**:

    :type key: key_id
    :param key: Keyword argument tuple.

    :type key_id: long
    :param key_id: **key** tuple argument:  unique key-id(Range: 1 - 65535)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.keychain', 'keychain')]
    bindings_list = [('pybind.slxos.v17r_2_00.keychain.key', 'pybind.slxos.v17r_2_00.brocade_keychain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.keychain.key', u'accept_lifetime'), ('pybind.slxos.v17r_2_00.keychain.key.accept_lifetime', u'duration'), ('pybind.slxos.v17r_2_00.keychain.key', u'key_string')]
    compositions_keyval_list = [{'keyval': 'name_of_keychain', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'key', 'keyval': 'key_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_, start_time'}, {'leafval': 'duration_value, infinite, end_time'}, {'leafval': 'key_string_text, encryption_level'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, keychain=keychain, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, keychain=keychain, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def keychain_key_accept_lifetime_get(self, keychain=None, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type keychain: name_of_keychain
    :param keychain: Keyword argument tuple.

    :type name_of_keychain: unicode
    :param name_of_keychain: **keychain** tuple argument:  name of the keychain

        * length restriction: ::

            ['4..32']

    :type key: key_id
    :param key: Keyword argument tuple.

    :type key_id: long
    :param key_id: **key** tuple argument:  unique key-id(Range: 1 - 65535)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.keychain', 'keychain'), ('pybind.slxos.v17r_2_00.keychain.key', u'key')]
    bindings_list = [('pybind.slxos.v17r_2_00.keychain.key.accept_lifetime', 'pybind.slxos.v17r_2_00.brocade_keychain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name_of_keychain', 'extra_keyval': ''}, {'keyval': 'key_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, keychain=keychain, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, keychain=keychain, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def keychain_key_accept_lifetime_duration_get(self, keychain=None, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type keychain: name_of_keychain
    :param keychain: Keyword argument tuple.

    :type name_of_keychain: unicode
    :param name_of_keychain: **keychain** tuple argument:  name of the keychain

        * length restriction: ::

            ['4..32']

    :type key: key_id
    :param key: Keyword argument tuple.

    :type key_id: long
    :param key_id: **key** tuple argument:  unique key-id(Range: 1 - 65535)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.keychain', 'keychain'), ('pybind.slxos.v17r_2_00.keychain.key', u'key')]
    bindings_list = [('pybind.slxos.v17r_2_00.keychain.key.accept_lifetime.duration', 'pybind.slxos.v17r_2_00.brocade_keychain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name_of_keychain', 'extra_keyval': ''}, {'keyval': 'key_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, keychain=keychain, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, keychain=keychain, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def keychain_key_accept_lifetime_duration_duration_value_get(self, keychain=None, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type keychain: name_of_keychain
    :param keychain: Keyword argument tuple.

    :type name_of_keychain: unicode
    :param name_of_keychain: **keychain** tuple argument:  name of the keychain

        * length restriction: ::

            ['4..32']

    :type key: key_id
    :param key: Keyword argument tuple.

    :type key_id: long
    :param key_id: **key** tuple argument:  unique key-id(Range: 1 - 65535)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.keychain', 'keychain'), ('pybind.slxos.v17r_2_00.keychain.key', u'key')]
    bindings_list = [('pybind.slxos.v17r_2_00.keychain.key.accept_lifetime.duration', 'pybind.slxos.v17r_2_00.brocade_keychain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name_of_keychain', 'extra_keyval': ''}, {'keyval': 'key_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, keychain=keychain, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, keychain=keychain, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def keychain_key_accept_lifetime_duration_end_time_get(self, keychain=None, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type keychain: name_of_keychain
    :param keychain: Keyword argument tuple.

    :type name_of_keychain: unicode
    :param name_of_keychain: **keychain** tuple argument:  name of the keychain

        * length restriction: ::

            ['4..32']

    :type key: key_id
    :param key: Keyword argument tuple.

    :type key_id: long
    :param key_id: **key** tuple argument:  unique key-id(Range: 1 - 65535)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.keychain', 'keychain'), ('pybind.slxos.v17r_2_00.keychain.key', u'key')]
    bindings_list = [('pybind.slxos.v17r_2_00.keychain.key.accept_lifetime.duration', 'pybind.slxos.v17r_2_00.brocade_keychain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name_of_keychain', 'extra_keyval': ''}, {'keyval': 'key_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, keychain=keychain, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, keychain=keychain, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def keychain_key_accept_lifetime_duration_infinite_get(self, keychain=None, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type keychain: name_of_keychain
    :param keychain: Keyword argument tuple.

    :type name_of_keychain: unicode
    :param name_of_keychain: **keychain** tuple argument:  name of the keychain

        * length restriction: ::

            ['4..32']

    :type key: key_id
    :param key: Keyword argument tuple.

    :type key_id: long
    :param key_id: **key** tuple argument:  unique key-id(Range: 1 - 65535)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.keychain', 'keychain'), ('pybind.slxos.v17r_2_00.keychain.key', u'key')]
    bindings_list = [('pybind.slxos.v17r_2_00.keychain.key.accept_lifetime.duration', 'pybind.slxos.v17r_2_00.brocade_keychain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name_of_keychain', 'extra_keyval': ''}, {'keyval': 'key_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, keychain=keychain, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, keychain=keychain, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def keychain_key_accept_lifetime_local_get(self, keychain=None, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type keychain: name_of_keychain
    :param keychain: Keyword argument tuple.

    :type name_of_keychain: unicode
    :param name_of_keychain: **keychain** tuple argument:  name of the keychain

        * length restriction: ::

            ['4..32']

    :type key: key_id
    :param key: Keyword argument tuple.

    :type key_id: long
    :param key_id: **key** tuple argument:  unique key-id(Range: 1 - 65535)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.keychain', 'keychain'), ('pybind.slxos.v17r_2_00.keychain.key', u'key')]
    bindings_list = [('pybind.slxos.v17r_2_00.keychain.key.accept_lifetime', 'pybind.slxos.v17r_2_00.brocade_keychain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name_of_keychain', 'extra_keyval': ''}, {'keyval': 'key_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, keychain=keychain, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, keychain=keychain, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def keychain_key_accept_lifetime_start_time_get(self, keychain=None, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type keychain: name_of_keychain
    :param keychain: Keyword argument tuple.

    :type name_of_keychain: unicode
    :param name_of_keychain: **keychain** tuple argument:  name of the keychain

        * length restriction: ::

            ['4..32']

    :type key: key_id
    :param key: Keyword argument tuple.

    :type key_id: long
    :param key_id: **key** tuple argument:  unique key-id(Range: 1 - 65535)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.keychain', 'keychain'), ('pybind.slxos.v17r_2_00.keychain.key', u'key')]
    bindings_list = [('pybind.slxos.v17r_2_00.keychain.key.accept_lifetime', 'pybind.slxos.v17r_2_00.brocade_keychain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name_of_keychain', 'extra_keyval': ''}, {'keyval': 'key_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, keychain=keychain, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, keychain=keychain, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def keychain_key_key_algorithm_get(self, keychain=None, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type keychain: name_of_keychain
    :param keychain: Keyword argument tuple.

    :type name_of_keychain: unicode
    :param name_of_keychain: **keychain** tuple argument:  name of the keychain

        * length restriction: ::

            ['4..32']

    **Instance Keyword Argument Tuple**:

    :type key: key_id
    :param key: Keyword argument tuple.

    :type key_id: long
    :param key_id: **key** tuple argument:  unique key-id(Range: 1 - 65535)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.keychain', 'keychain')]
    bindings_list = [('pybind.slxos.v17r_2_00.keychain.key', 'pybind.slxos.v17r_2_00.brocade_keychain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.keychain.key', u'accept_lifetime'), ('pybind.slxos.v17r_2_00.keychain.key.accept_lifetime', u'duration'), ('pybind.slxos.v17r_2_00.keychain.key', u'key_string')]
    compositions_keyval_list = [{'keyval': 'name_of_keychain', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'key', 'keyval': 'key_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_, start_time'}, {'leafval': 'duration_value, infinite, end_time'}, {'leafval': 'key_string_text, encryption_level'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, keychain=keychain, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, keychain=keychain, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def keychain_key_key_string_get(self, keychain=None, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type keychain: name_of_keychain
    :param keychain: Keyword argument tuple.

    :type name_of_keychain: unicode
    :param name_of_keychain: **keychain** tuple argument:  name of the keychain

        * length restriction: ::

            ['4..32']

    :type key: key_id
    :param key: Keyword argument tuple.

    :type key_id: long
    :param key_id: **key** tuple argument:  unique key-id(Range: 1 - 65535)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.keychain', 'keychain'), ('pybind.slxos.v17r_2_00.keychain.key', u'key')]
    bindings_list = [('pybind.slxos.v17r_2_00.keychain.key.key_string', 'pybind.slxos.v17r_2_00.brocade_keychain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name_of_keychain', 'extra_keyval': ''}, {'keyval': 'key_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, keychain=keychain, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, keychain=keychain, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def keychain_key_key_string_encryption_level_get(self, keychain=None, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type keychain: name_of_keychain
    :param keychain: Keyword argument tuple.

    :type name_of_keychain: unicode
    :param name_of_keychain: **keychain** tuple argument:  name of the keychain

        * length restriction: ::

            ['4..32']

    :type key: key_id
    :param key: Keyword argument tuple.

    :type key_id: long
    :param key_id: **key** tuple argument:  unique key-id(Range: 1 - 65535)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.keychain', 'keychain'), ('pybind.slxos.v17r_2_00.keychain.key', u'key')]
    bindings_list = [('pybind.slxos.v17r_2_00.keychain.key.key_string', 'pybind.slxos.v17r_2_00.brocade_keychain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name_of_keychain', 'extra_keyval': ''}, {'keyval': 'key_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, keychain=keychain, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, keychain=keychain, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def keychain_key_key_string_key_string_text_get(self, keychain=None, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type keychain: name_of_keychain
    :param keychain: Keyword argument tuple.

    :type name_of_keychain: unicode
    :param name_of_keychain: **keychain** tuple argument:  name of the keychain

        * length restriction: ::

            ['4..32']

    :type key: key_id
    :param key: Keyword argument tuple.

    :type key_id: long
    :param key_id: **key** tuple argument:  unique key-id(Range: 1 - 65535)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.keychain', 'keychain'), ('pybind.slxos.v17r_2_00.keychain.key', u'key')]
    bindings_list = [('pybind.slxos.v17r_2_00.keychain.key.key_string', 'pybind.slxos.v17r_2_00.brocade_keychain', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name_of_keychain', 'extra_keyval': ''}, {'keyval': 'key_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, keychain=keychain, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, keychain=keychain, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def lacp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.lacp', 'pybind.nos.v6_0_2f.brocade_lacp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.lacp', 'pybind.nos.v7_2_0.brocade_lacp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.lacp', 'pybind.slxos.v17r_1_01a.brocade_lacp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.lacp', 'pybind.slxos.v17r_2_00.brocade_lacp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.lacp', 'pybind.slxos.v17s_1_02.brocade_lacp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def lacp_system_priority_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.lacp', 'pybind.nos.v6_0_2f.brocade_lacp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.lacp', 'pybind.nos.v7_2_0.brocade_lacp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.lacp', 'pybind.slxos.v17r_1_01a.brocade_lacp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.lacp', 'pybind.slxos.v17r_2_00.brocade_lacp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.lacp', 'pybind.slxos.v17s_1_02.brocade_lacp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def lag_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.lag', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.lag.hash', u'bos'), ('pybind.slxos.v17s_1_02.lag', u'hash'), ('pybind.slxos.v17s_1_02.capabilities', u'lag'), ('pybind.slxos.v17s_1_02.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17s_1_02.lag.hash', u'hdr_start'), ('pybind.slxos.v17s_1_02.hardware.profile.lag', u'predefined'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'hdr_start'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag', u'hash'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'bos'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'bos'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'hdr_start'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag', u'hash')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'start_skip'}, {'leafval': 'hdr_count, rotate, normalize, srcport, pwctrlword'}, {'leafval': 'PortchannelRedundancy'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'fwd_term'}, {'leafval': 'lag_profiletype'}, {'leafval': 'fwd_term'}, {'leafval': 'hdr_count, rotate, normalize, srcport, pwctrlword'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'start_skip'}, {'leafval': 'start_skip'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'fwd_term'}, {'leafval': 'hdr_count, rotate, normalize, srcport, pwctrlword'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def lag_hash_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.lag.hash', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'bos'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'hdr_start'), ('pybind.slxos.v17s_1_02.lag.hash', u'bos'), ('pybind.slxos.v17s_1_02.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17s_1_02.lag.hash', u'hdr_start'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'hdr_start'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'bos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'start_skip'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'fwd_term'}, {'leafval': 'start_skip'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'fwd_term'}, {'leafval': 'fwd_term'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'start_skip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def lag_hash_bos_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash.bos', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash.bos', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.lag.hash.bos', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'start_skip'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def lag_hash_bos_start_skip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash.bos', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash.bos', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.lag.hash.bos', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def lag_hash_hdr_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.lag.hash', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'bos'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'hdr_start'), ('pybind.slxos.v17s_1_02.lag.hash', u'bos'), ('pybind.slxos.v17s_1_02.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17s_1_02.lag.hash', u'hdr_start'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'hdr_start'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'bos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'start_skip'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'fwd_term'}, {'leafval': 'start_skip'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'fwd_term'}, {'leafval': 'fwd_term'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'start_skip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def lag_hash_hdr_start_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash.hdr_start', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash.hdr_start', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.lag.hash.hdr_start', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'fwd_term'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def lag_hash_hdr_start_fwd_term_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash.hdr_start', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash.hdr_start', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.lag.hash.hdr_start', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def lag_hash_normalize_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.lag.hash', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'bos'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'hdr_start'), ('pybind.slxos.v17s_1_02.lag.hash', u'bos'), ('pybind.slxos.v17s_1_02.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17s_1_02.lag.hash', u'hdr_start'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'hdr_start'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'bos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'start_skip'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'fwd_term'}, {'leafval': 'start_skip'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'fwd_term'}, {'leafval': 'fwd_term'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'start_skip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def lag_hash_pwctrlword_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.lag.hash', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'bos'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'hdr_start'), ('pybind.slxos.v17s_1_02.lag.hash', u'bos'), ('pybind.slxos.v17s_1_02.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17s_1_02.lag.hash', u'hdr_start'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'hdr_start'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'bos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'start_skip'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'fwd_term'}, {'leafval': 'start_skip'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'fwd_term'}, {'leafval': 'fwd_term'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'start_skip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def lag_hash_rotate_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.lag.hash', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'bos'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'hdr_start'), ('pybind.slxos.v17s_1_02.lag.hash', u'bos'), ('pybind.slxos.v17s_1_02.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17s_1_02.lag.hash', u'hdr_start'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'hdr_start'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'bos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'start_skip'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'fwd_term'}, {'leafval': 'start_skip'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'fwd_term'}, {'leafval': 'fwd_term'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'start_skip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def lag_hash_speculate_mpls_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash.speculate_mpls', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash.speculate_mpls', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.lag.hash.speculate_mpls', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def lag_hash_speculate_mpls_enable_eth_ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash.speculate_mpls', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash.speculate_mpls', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.lag.hash.speculate_mpls', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def lag_hash_srcport_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.lag.hash', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'bos'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'hdr_start'), ('pybind.slxos.v17s_1_02.lag.hash', u'bos'), ('pybind.slxos.v17s_1_02.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17s_1_02.lag.hash', u'hdr_start'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'hdr_start'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'bos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'start_skip'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'fwd_term'}, {'leafval': 'start_skip'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'fwd_term'}, {'leafval': 'fwd_term'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'start_skip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def latch_detection_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.latch_detection_config', 'pybind.slxos.v17r_1_01a.brocade_linecard_management', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.latch_detection_config', 'pybind.slxos.v17r_2_00.brocade_linecard_management', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ldap_server_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ldap_server', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ldap_server', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ldap_server', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ldap_server', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ldap_server', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ldap_server', u'host'), ('pybind.slxos.v17s_1_02.ldap_server.maprole', u'group'), ('pybind.nos.v7_2_0.ldap_server', u'host'), ('pybind.nos.v7_2_0.ldap_server.maprole', u'group'), ('pybind.slxos.v17r_2_00.ldap_server', u'host'), ('pybind.slxos.v17r_2_00.ldap_server.maprole', u'group'), ('pybind.nos.v6_0_2f.ldap_server', u'host'), ('pybind.nos.v6_0_2f.ldap_server.maprole', u'group'), ('pybind.slxos.v17r_1_01a.ldap_server.maprole', u'group'), ('pybind.slxos.v17r_1_01a.ldap_server', u'host')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hostname, use_vrf'}, {'leafval': 'ad_group, switch_role'}, {'leafval': 'hostname, use_vrf, port, retries, timeout, basedn'}, {'leafval': 'ad_group, switch_role'}, {'leafval': 'hostname, use_vrf'}, {'leafval': 'ad_group, switch_role'}, {'leafval': 'hostname, port, retries, timeout, basedn'}, {'leafval': 'ad_group, switch_role'}, {'leafval': 'ad_group, switch_role'}, {'leafval': 'hostname, use_vrf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ldap_server_host_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this LDAP server

        * length restriction: ::

            ['1..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ldap_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ldap_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ldap_server.host', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ldap_server.host', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ldap_server.host', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ldap_server.host', u'ldap_server_options'), ('pybind.slxos.v17r_1_01a.ldap_server.host', u'ldap_server_options'), ('pybind.slxos.v17r_2_00.ldap_server.host', u'ldap_server_options')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'port, retries, timeout, basedn'}, {'leafval': 'port, retries, timeout, basedn'}, {'leafval': 'port, retries, timeout, basedn'}]
    leafval_map = {"pybind.nos.v7_2_0.ldap_server.host": {}, "pybind.slxos.v17s_1_02.ldap_server.host": {}, "pybind.slxos.v17r_1_01a.ldap_server.host": {}, "pybind.nos.v6_0_2f.ldap_server.host": {"retries": "retries", "hostname": "hostname", "basedn": "basedn", "port": "port", "timeout": "timeout"}, "pybind.slxos.v17r_2_00.ldap_server.host": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ldap_server_host_basedn_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this LDAP server

        * length restriction: ::

            ['1..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ldap_server.host', u'host'), ('pybind.slxos.v17r_2_00.ldap_server.host', u'host'), ('pybind.slxos.v17r_1_01a.ldap_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.ldap_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ldap_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ldap_server.host.ldap_server_options', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ldap_server.host.ldap_server_options', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ldap_server.host.ldap_server_options', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.ldap_server.host": {}, "pybind.slxos.v17r_1_01a.ldap_server.host.ldap_server_options": {}, "pybind.slxos.v17r_2_00.ldap_server.host.ldap_server_options": {}, "pybind.nos.v6_0_2f.ldap_server.host": {"basedn": "basedn", "hostname": "hostname"}, "pybind.slxos.v17s_1_02.ldap_server.host.ldap_server_options": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ldap_server_host_port_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this LDAP server

        * length restriction: ::

            ['1..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ldap_server.host', u'host'), ('pybind.slxos.v17r_2_00.ldap_server.host', u'host'), ('pybind.slxos.v17r_1_01a.ldap_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.ldap_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ldap_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ldap_server.host.ldap_server_options', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ldap_server.host.ldap_server_options', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ldap_server.host.ldap_server_options', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.ldap_server.host": {}, "pybind.slxos.v17r_1_01a.ldap_server.host.ldap_server_options": {}, "pybind.slxos.v17r_2_00.ldap_server.host.ldap_server_options": {}, "pybind.nos.v6_0_2f.ldap_server.host": {"hostname": "hostname", "port": "port"}, "pybind.slxos.v17s_1_02.ldap_server.host.ldap_server_options": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ldap_server_host_retries_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this LDAP server

        * length restriction: ::

            ['1..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ldap_server.host', u'host'), ('pybind.slxos.v17r_2_00.ldap_server.host', u'host'), ('pybind.slxos.v17r_1_01a.ldap_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.ldap_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ldap_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ldap_server.host.ldap_server_options', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ldap_server.host.ldap_server_options', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ldap_server.host.ldap_server_options', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.ldap_server.host": {}, "pybind.slxos.v17r_1_01a.ldap_server.host.ldap_server_options": {}, "pybind.slxos.v17r_2_00.ldap_server.host.ldap_server_options": {}, "pybind.nos.v6_0_2f.ldap_server.host": {"retries": "retries", "hostname": "hostname"}, "pybind.slxos.v17s_1_02.ldap_server.host.ldap_server_options": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ldap_server_host_timeout_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this LDAP server

        * length restriction: ::

            ['1..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ldap_server.host', u'host'), ('pybind.slxos.v17r_2_00.ldap_server.host', u'host'), ('pybind.slxos.v17r_1_01a.ldap_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.ldap_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ldap_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ldap_server.host.ldap_server_options', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ldap_server.host.ldap_server_options', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ldap_server.host.ldap_server_options', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.ldap_server.host": {}, "pybind.slxos.v17r_1_01a.ldap_server.host.ldap_server_options": {}, "pybind.slxos.v17r_2_00.ldap_server.host.ldap_server_options": {}, "pybind.nos.v6_0_2f.ldap_server.host": {"hostname": "hostname", "timeout": "timeout"}, "pybind.slxos.v17s_1_02.ldap_server.host.ldap_server_options": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ldap_server_maprole_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ldap_server.maprole', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ldap_server.maprole', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ldap_server.maprole', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ldap_server.maprole', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ldap_server.maprole', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.ldap_server.maprole', u'group'), ('pybind.nos.v7_2_0.ldap_server.maprole', u'group'), ('pybind.slxos.v17s_1_02.ldap_server.maprole', u'group'), ('pybind.nos.v6_0_2f.ldap_server.maprole', u'group'), ('pybind.slxos.v17r_2_00.ldap_server.maprole', u'group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ad_group, switch_role'}, {'leafval': 'ad_group, switch_role'}, {'leafval': 'ad_group, switch_role'}, {'leafval': 'ad_group, switch_role'}, {'leafval': 'ad_group, switch_role'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ldap_server_maprole_group_get(self, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group: ad_group, switch_role
    :param group: Keyword argument tuple.

    :type ad_group: unicode
    :param ad_group: **group** tuple argument:  AD group belongs to user on the AD Server

        * length restriction: ::

            ['1..max']

    :type switch_role: unicode
    :param switch_role: **group** tuple argument:  AD group belongs to user on the AD Server

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ldap_server.maprole.group', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ldap_server.maprole.group', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ldap_server.maprole.group', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ldap_server.maprole.group', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ldap_server.maprole.group', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'ad_group', 'extra_keyval': 'ad_group, switch_role'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ldap_server_maprole_group_role_get(self, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group: ad_group
    :param group: Keyword argument tuple.

    :type ad_group: unicode
    :param ad_group: **group** tuple argument:  AD group belongs to user on the AD Server

        * length restriction: ::

            ['1..max']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ldap_server.maprole.group', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ldap_server.maprole.group', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ldap_server.maprole.group', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ldap_server.maprole.group', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ldap_server.maprole.group', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'ad_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def line_get(self, line=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type line: sessionid
    :param line: Keyword argument tuple.

    :type sessionid: unicode
    :param sessionid: **line** tuple argument:  Terminal type

        * enumeration restriction: ::

            ['vty']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.terminal_cfg.line', 'pybind.nos.v6_0_2f.brocade_terminal', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.terminal_cfg.line', 'pybind.nos.v7_2_0.brocade_terminal', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.terminal_cfg.line', 'pybind.slxos.v17r_1_01a.brocade_terminal', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.terminal_cfg.line', 'pybind.slxos.v17r_2_00.brocade_terminal', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.terminal_cfg.line', 'pybind.slxos.v17s_1_02.brocade_terminal', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'line', 'keyval': 'sessionid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, line=line)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, line=line)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def line_exec_timeout_get(self, line=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type line: sessionid
    :param line: Keyword argument tuple.

    :type sessionid: unicode
    :param sessionid: **line** tuple argument:  Terminal type

        * enumeration restriction: ::

            ['vty']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.terminal_cfg.line', 'pybind.nos.v6_0_2f.brocade_terminal', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.terminal_cfg.line', 'pybind.nos.v7_2_0.brocade_terminal', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.terminal_cfg.line', 'pybind.slxos.v17r_1_01a.brocade_terminal', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.terminal_cfg.line', 'pybind.slxos.v17r_2_00.brocade_terminal', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.terminal_cfg.line', 'pybind.slxos.v17s_1_02.brocade_terminal', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'line', 'keyval': 'sessionid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, line=line)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, line=line)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def linecard_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.global_lc_holder.linecard', 'pybind.slxos.v17r_1_01a.brocade_linecard_management', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.global_lc_holder.linecard', 'pybind.slxos.v17r_2_00.brocade_linecard_management', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.global_lc_holder.linecard', 'pybind.slxos.v17s_1_02.brocade_linecard_management', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.global_lc_holder.linecard', u'linecards'), ('pybind.slxos.v17r_2_00.global_lc_holder.linecard', u'linecards'), ('pybind.slxos.v17s_1_02.global_lc_holder.linecard', u'linecards')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'linecardName, linecardType'}, {'leafval': 'linecardName, linecardType'}, {'leafval': 'linecardName, linecardType'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def linecard_linecards_get(self, linecards=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type linecards: linecardName, linecardType
    :param linecards: Keyword argument tuple.

    :type linecardName: unicode
    :param linecardName: **linecards** tuple argument.

        * pattern restriction: ::

            '([1-9]|[1][0-6])'

    :type linecardType: unicode
    :param linecardType: **linecards** tuple argument.

        * enumeration restriction: ::

            ['LC36X100G', 'LC72X10G']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.global_lc_holder.linecard.linecards', 'pybind.slxos.v17r_1_01a.brocade_linecard_management', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.global_lc_holder.linecard.linecards', 'pybind.slxos.v17r_2_00.brocade_linecard_management', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.global_lc_holder.linecard.linecards', 'pybind.slxos.v17s_1_02.brocade_linecard_management', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'linecards', 'keyval': 'linecardName', 'extra_keyval': 'linecardName, linecardType'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, linecards=linecards)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, linecards=linecards)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def linecard_linecards_linecardtype_get(self, linecards=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type linecards: linecardName
    :param linecards: Keyword argument tuple.

    :type linecardName: unicode
    :param linecardName: **linecards** tuple argument.

        * pattern restriction: ::

            '([1-9]|[1][0-6])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.global_lc_holder.linecard.linecards', 'pybind.slxos.v17r_1_01a.brocade_linecard_management', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.global_lc_holder.linecard.linecards', 'pybind.slxos.v17r_2_00.brocade_linecard_management', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.global_lc_holder.linecard.linecards', 'pybind.slxos.v17s_1_02.brocade_linecard_management', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'linecards', 'keyval': 'linecardName', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, linecards=linecards)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, linecards=linecards)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def link_fault_signaling_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.link_fault_signaling', 'pybind.slxos.v17r_1_01a.brocade_lfs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.link_fault_signaling', 'pybind.slxos.v17r_2_00.brocade_lfs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.link_fault_signaling', 'pybind.slxos.v17s_1_02.brocade_lfs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'rx, tx'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def link_fault_signaling_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.link_fault_signaling', 'pybind.slxos.v17r_1_01a.brocade_lfs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.link_fault_signaling', 'pybind.slxos.v17r_2_00.brocade_lfs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.link_fault_signaling', 'pybind.slxos.v17s_1_02.brocade_lfs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def link_fault_signaling_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.link_fault_signaling', 'pybind.slxos.v17r_1_01a.brocade_lfs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.link_fault_signaling', 'pybind.slxos.v17r_2_00.brocade_lfs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.link_fault_signaling', 'pybind.slxos.v17s_1_02.brocade_lfs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def link_fault_signalling_counters_state_get(self, link_fault_signalling_counters_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type link_fault_signalling_counters_state: name
    :param link_fault_signalling_counters_state: Keyword argument tuple.

    :type name: unicode
    :param name: **link_fault_signalling_counters_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.link_fault_signalling_counters_state', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'link_fault_signalling_counters_state', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link_fault_signalling_counters_state=link_fault_signalling_counters_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link_fault_signalling_counters_state=link_fault_signalling_counters_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def link_fault_signalling_counters_state_local_fault_counter_get(self, link_fault_signalling_counters_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type link_fault_signalling_counters_state: name
    :param link_fault_signalling_counters_state: Keyword argument tuple.

    :type name: unicode
    :param name: **link_fault_signalling_counters_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.link_fault_signalling_counters_state', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'link_fault_signalling_counters_state', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link_fault_signalling_counters_state=link_fault_signalling_counters_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link_fault_signalling_counters_state=link_fault_signalling_counters_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def link_fault_signalling_counters_state_local_fault_time_get(self, link_fault_signalling_counters_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type link_fault_signalling_counters_state: name
    :param link_fault_signalling_counters_state: Keyword argument tuple.

    :type name: unicode
    :param name: **link_fault_signalling_counters_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.link_fault_signalling_counters_state', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'link_fault_signalling_counters_state', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link_fault_signalling_counters_state=link_fault_signalling_counters_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link_fault_signalling_counters_state=link_fault_signalling_counters_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def link_fault_signalling_counters_state_remote_fault_counter_get(self, link_fault_signalling_counters_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type link_fault_signalling_counters_state: name
    :param link_fault_signalling_counters_state: Keyword argument tuple.

    :type name: unicode
    :param name: **link_fault_signalling_counters_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.link_fault_signalling_counters_state', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'link_fault_signalling_counters_state', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link_fault_signalling_counters_state=link_fault_signalling_counters_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link_fault_signalling_counters_state=link_fault_signalling_counters_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def link_fault_signalling_counters_state_remote_fault_time_get(self, link_fault_signalling_counters_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type link_fault_signalling_counters_state: name
    :param link_fault_signalling_counters_state: Keyword argument tuple.

    :type name: unicode
    :param name: **link_fault_signalling_counters_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.link_fault_signalling_counters_state', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'link_fault_signalling_counters_state', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link_fault_signalling_counters_state=link_fault_signalling_counters_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link_fault_signalling_counters_state=link_fault_signalling_counters_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash', u'mpls'), ('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash', u'ip'), ('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash', u'ipv6'), ('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash', u'ethernet'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash', u'ethernet'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash', u'ip'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash', u'ipv6'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash', u'mpls'), ('pybind.slxos.v17s_1_02.load_balance', u'po_load_balance'), ('pybind.slxos.v17s_1_02.load_balance.hash', u'ethernet'), ('pybind.slxos.v17s_1_02.load_balance.hash', u'ip'), ('pybind.slxos.v17s_1_02.load_balance.hash', u'mpls'), ('pybind.slxos.v17s_1_02.load_balance.hash', u'ipv6')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'label1, label2, label3'}, {'leafval': 'src_l4_port, dst_l4_port, src_ip, dst_ip, protocol'}, {'leafval': 'ipv6_src_l4_port, ipv6_dst_l4_port, ipv6_src_ip, ipv6_dst_ip, ipv6_next_hdr'}, {'leafval': 'sa_mac, da_mac, vlan, etype'}, {'leafval': 'sa_mac, da_mac, vlan, etype'}, {'leafval': 'src_l4_port, dst_l4_port, src_ip, dst_ip, protocol'}, {'leafval': 'ipv6_src_l4_port, ipv6_dst_l4_port, ipv6_src_ip, ipv6_dst_ip, ipv6_next_hdr'}, {'leafval': 'label1, label2, label3'}, {'leafval': 'load_balance_type'}, {'leafval': 'sa_mac, da_mac, vlan, etype'}, {'leafval': 'src_l4_port, dst_l4_port, src_ip, dst_ip, protocol'}, {'leafval': 'label1, label2, label3'}, {'leafval': 'ipv6_src_l4_port, ipv6_dst_l4_port, ipv6_src_ip, ipv6_dst_ip, ipv6_next_hdr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash', u'mpls'), ('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash', u'ip'), ('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash', u'ipv6'), ('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash', u'ethernet'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash', u'ethernet'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash', u'ip'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash', u'ipv6'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash', u'mpls'), ('pybind.slxos.v17s_1_02.load_balance.hash', u'ethernet'), ('pybind.slxos.v17s_1_02.load_balance.hash', u'ip'), ('pybind.slxos.v17s_1_02.load_balance.hash', u'mpls'), ('pybind.slxos.v17s_1_02.load_balance.hash', u'ipv6')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'label1, label2, label3'}, {'leafval': 'src_l4_port, dst_l4_port, src_ip, dst_ip, protocol'}, {'leafval': 'ipv6_src_l4_port, ipv6_dst_l4_port, ipv6_src_ip, ipv6_dst_ip, ipv6_next_hdr'}, {'leafval': 'sa_mac, da_mac, vlan, etype'}, {'leafval': 'sa_mac, da_mac, vlan, etype'}, {'leafval': 'src_l4_port, dst_l4_port, src_ip, dst_ip, protocol'}, {'leafval': 'ipv6_src_l4_port, ipv6_dst_l4_port, ipv6_src_ip, ipv6_dst_ip, ipv6_next_hdr'}, {'leafval': 'label1, label2, label3'}, {'leafval': 'sa_mac, da_mac, vlan, etype'}, {'leafval': 'src_l4_port, dst_l4_port, src_ip, dst_ip, protocol'}, {'leafval': 'label1, label2, label3'}, {'leafval': 'ipv6_src_l4_port, ipv6_dst_l4_port, ipv6_src_ip, ipv6_dst_ip, ipv6_next_hdr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ethernet_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ethernet', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ethernet', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ethernet', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ethernet_da_mac_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ethernet', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ethernet', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ethernet', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ethernet_etype_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ethernet', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ethernet', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ethernet', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ethernet_sa_mac_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ethernet', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ethernet', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ethernet', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ethernet_vlan_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ethernet', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ethernet', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ethernet', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ip', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ip_dst_ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ip', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ip_dst_l4_port_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ip', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ip_protocol_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ip', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ip_src_ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ip', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ip_src_l4_port_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ip', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ip', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ipv6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ipv6', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ipv6_ipv6_dst_ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ipv6', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ipv6_ipv6_dst_l4_port_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ipv6', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ipv6_ipv6_next_hdr_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ipv6', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ipv6_ipv6_src_ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ipv6', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_ipv6_ipv6_src_l4_port_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.ipv6', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.ipv6', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_mpls_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.mpls', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.mpls', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.mpls', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_mpls_label1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.mpls', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.mpls', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.mpls', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_mpls_label2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.mpls', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.mpls', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.mpls', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_hash_mpls_label3_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash.mpls', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash.mpls', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.load_balance.hash.mpls', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_lag_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.load_balance_lag', 'pybind.slxos.v17r_1_01a.brocade_rbridge_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.load_balance_lag', 'pybind.slxos.v17r_2_00.brocade_rbridge_lag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash', u'mpls'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'bos'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag.hash', u'hdr_start'), ('pybind.slxos.v17r_1_01a.load_balance_lag.lag', u'hash'), ('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash', u'ip'), ('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash', u'ipv6'), ('pybind.slxos.v17r_1_01a.load_balance_lag.load_balance.hash', u'ethernet'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'hdr_start'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag', u'hash'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'speculate_mpls'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash', u'ethernet'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash', u'ip'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash', u'ipv6'), ('pybind.slxos.v17r_2_00.load_balance_lag.lag.hash', u'bos'), ('pybind.slxos.v17r_2_00.load_balance_lag.load_balance.hash', u'mpls')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'label1, label2, label3'}, {'leafval': 'start_skip'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'fwd_term'}, {'leafval': 'hdr_count, rotate, normalize, srcport, pwctrlword'}, {'leafval': 'src_l4_port, dst_l4_port, src_ip, dst_ip, protocol'}, {'leafval': 'ipv6_src_l4_port, ipv6_dst_l4_port, ipv6_src_ip, ipv6_dst_ip, ipv6_next_hdr'}, {'leafval': 'sa_mac, da_mac, vlan, etype'}, {'leafval': 'fwd_term'}, {'leafval': 'hdr_count, rotate, normalize, srcport, pwctrlword'}, {'leafval': 'enable_eth_ip'}, {'leafval': 'sa_mac, da_mac, vlan, etype'}, {'leafval': 'src_l4_port, dst_l4_port, src_ip, dst_ip, protocol'}, {'leafval': 'ipv6_src_l4_port, ipv6_dst_l4_port, ipv6_src_ip, ipv6_dst_ip, ipv6_next_hdr'}, {'leafval': 'start_skip'}, {'leafval': 'label1, label2, label3'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_load_balance_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.load_balance.po_load_balance', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def load_balance_po_load_balance_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.load_balance.po_load_balance', 'pybind.slxos.v17s_1_02.brocade_rbridge_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def loam_show_debug_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.loam_show_debug_state', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.loam_show_debug_state', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.loam_show_debug_state', u'loam_show_debug_information'), ('pybind.slxos.v17r_1_01a.loam_show_debug_state', u'loam_show_debug_information')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'if_name, direction'}, {'leafval': 'if_name, direction'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def loam_show_debug_state_loam_show_debug_information_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.loam_show_debug_state.loam_show_debug_information', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.loam_show_debug_state.loam_show_debug_information', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def loam_show_debug_state_loam_show_debug_information_direction_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.loam_show_debug_state.loam_show_debug_information', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.loam_show_debug_state.loam_show_debug_information', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def loam_show_debug_state_loam_show_debug_information_if_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.loam_show_debug_state.loam_show_debug_information', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.loam_show_debug_state.loam_show_debug_information', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def loam_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.loam_state', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.loam_state', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.loam_state', u'loam_info'), ('pybind.slxos.v17r_1_01a.loam_state', u'loam_statistics'), ('pybind.slxos.v17r_2_00.loam_state', u'loam_info'), ('pybind.slxos.v17r_2_00.loam_state', u'loam_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'port, link_status, loam_status, mode, local_stable, remote_stable'}, {'leafval': 'port, tx_pdus, rx_pdus'}, {'leafval': 'port, link_status, loam_status, mode, local_stable, remote_stable'}, {'leafval': 'port, tx_pdus, rx_pdus'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def loam_state_loam_info_get(self, loam_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type loam_info: port
    :param loam_info: Keyword argument tuple.

    :type port: unicode
    :param port: **loam_info** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.loam_state.loam_info', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.loam_state.loam_info', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'loam_info', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loam_info=loam_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loam_info=loam_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def loam_state_loam_info_link_status_get(self, loam_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type loam_info: port
    :param loam_info: Keyword argument tuple.

    :type port: unicode
    :param port: **loam_info** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.loam_state.loam_info', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.loam_state.loam_info', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'loam_info', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loam_info=loam_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loam_info=loam_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def loam_state_loam_info_loam_status_get(self, loam_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type loam_info: port
    :param loam_info: Keyword argument tuple.

    :type port: unicode
    :param port: **loam_info** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.loam_state.loam_info', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.loam_state.loam_info', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'loam_info', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loam_info=loam_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loam_info=loam_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def loam_state_loam_info_local_stable_get(self, loam_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type loam_info: port
    :param loam_info: Keyword argument tuple.

    :type port: unicode
    :param port: **loam_info** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.loam_state.loam_info', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.loam_state.loam_info', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'loam_info', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loam_info=loam_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loam_info=loam_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def loam_state_loam_info_mode_get(self, loam_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type loam_info: port
    :param loam_info: Keyword argument tuple.

    :type port: unicode
    :param port: **loam_info** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.loam_state.loam_info', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.loam_state.loam_info', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'loam_info', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loam_info=loam_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loam_info=loam_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def loam_state_loam_info_remote_stable_get(self, loam_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type loam_info: port
    :param loam_info: Keyword argument tuple.

    :type port: unicode
    :param port: **loam_info** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.loam_state.loam_info', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.loam_state.loam_info', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'loam_info', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loam_info=loam_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loam_info=loam_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def loam_state_loam_statistics_get(self, loam_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type loam_statistics: port
    :param loam_statistics: Keyword argument tuple.

    :type port: unicode
    :param port: **loam_statistics** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.loam_state.loam_statistics', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.loam_state.loam_statistics', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'loam_statistics', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loam_statistics=loam_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loam_statistics=loam_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def loam_state_loam_statistics_rx_pdus_get(self, loam_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type loam_statistics: port
    :param loam_statistics: Keyword argument tuple.

    :type port: unicode
    :param port: **loam_statistics** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.loam_state.loam_statistics', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.loam_state.loam_statistics', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'loam_statistics', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loam_statistics=loam_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loam_statistics=loam_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def loam_state_loam_statistics_tx_pdus_get(self, loam_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type loam_statistics: port
    :param loam_statistics: Keyword argument tuple.

    :type port: unicode
    :param port: **loam_statistics** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.loam_state.loam_statistics', 'pybind.slxos.v17r_1_01a.brocade_dot1ag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.loam_state.loam_statistics', 'pybind.slxos.v17r_2_00.brocade_dot1ag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'loam_statistics', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, loam_statistics=loam_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, loam_statistics=loam_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def local_node_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.local_node', 'pybind.nos.v6_0_2f.brocade_vcs', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.local_node', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.local_node', 'pybind.slxos.v17r_1_01a.brocade_vcs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.local_node', 'pybind.slxos.v17r_2_00.brocade_vcs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.local_node', 'pybind.slxos.v17s_1_02.brocade_vcs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def local_node_swbd_number_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.local_node', 'pybind.nos.v6_0_2f.brocade_vcs', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.local_node', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.local_node', 'pybind.slxos.v17r_1_01a.brocade_vcs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.local_node', 'pybind.slxos.v17r_2_00.brocade_vcs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.local_node', 'pybind.slxos.v17s_1_02.brocade_vcs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.destination_console.logging', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.destination_console.logging', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.destination_console.logging', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.destination_console.logging', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.destination_console.logging', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.logging', u'syslog_client'), ('pybind.slxos.v17r_2_00.logging.raslog', u'interface'), ('pybind.slxos.v17r_2_00.logging.raslog.module', u'modid'), ('pybind.slxos.v17r_2_00.logging.raslog.message', u'msgid'), ('pybind.slxos.v17r_2_00.logging', u'raslog'), ('pybind.slxos.v17r_2_00.logging.auditlog', u'class_'), ('pybind.slxos.v17r_2_00.logging', u'syslog_server'), ('pybind.slxos.v17r_2_00.logging', u'syslog_facility'), ('pybind.nos.v6_0_2f.logging.raslog.module', u'modid'), ('pybind.nos.v6_0_2f.logging.auditlog', u'class_'), ('pybind.nos.v6_0_2f.logging.raslog.message', u'msgid'), ('pybind.nos.v6_0_2f.logging', u'raslog'), ('pybind.nos.v6_0_2f.logging', u'syslog_server'), ('pybind.nos.v6_0_2f.logging', u'syslog_client'), ('pybind.nos.v6_0_2f.logging', u'syslog_facility'), ('pybind.slxos.v17s_1_02.logging.auditlog', u'class_'), ('pybind.slxos.v17s_1_02.logging.raslog', u'interface'), ('pybind.slxos.v17s_1_02.logging.raslog.module', u'modid'), ('pybind.slxos.v17s_1_02.logging', u'raslog'), ('pybind.slxos.v17s_1_02.logging', u'syslog_facility'), ('pybind.slxos.v17s_1_02.logging', u'syslog_server'), ('pybind.slxos.v17s_1_02.logging.raslog.message', u'msgid'), ('pybind.slxos.v17s_1_02.logging', u'syslog_client'), ('pybind.slxos.v17r_1_01a.logging.raslog.module', u'modid'), ('pybind.slxos.v17r_1_01a.logging', u'syslog_client'), ('pybind.slxos.v17r_1_01a.logging', u'syslog_facility'), ('pybind.slxos.v17r_1_01a.logging.raslog.message', u'msgid'), ('pybind.slxos.v17r_1_01a.logging.auditlog', u'class_'), ('pybind.slxos.v17r_1_01a.logging.raslog', u'interface'), ('pybind.slxos.v17r_1_01a.logging', u'raslog'), ('pybind.slxos.v17r_1_01a.logging', u'syslog_server'), ('pybind.nos.v7_2_0.logging', u'raslog'), ('pybind.nos.v7_2_0.logging.raslog.module', u'modid'), ('pybind.nos.v7_2_0.logging.raslog.message', u'msgid'), ('pybind.nos.v7_2_0.logging', u'syslog_server'), ('pybind.nos.v7_2_0.logging.auditlog', u'class_'), ('pybind.nos.v7_2_0.logging', u'syslog_client'), ('pybind.nos.v7_2_0.logging', u'syslog_facility')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'localip'}, {'leafval': 'description'}, {'leafval': 'modId'}, {'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'console'}, {'leafval': 'class_'}, {'leafval': 'syslogip, use_vrf, format'}, {'leafval': 'local_'}, {'leafval': 'modId'}, {'leafval': 'class_'}, {'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'console'}, {'leafval': 'syslogip, use_vrf, secure, port'}, {'leafval': 'localip'}, {'leafval': 'local_'}, {'leafval': 'class_'}, {'leafval': 'description'}, {'leafval': 'modId'}, {'leafval': 'console'}, {'leafval': 'local_'}, {'leafval': 'syslogip, use_vrf'}, {'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'localip'}, {'leafval': 'modId'}, {'leafval': 'localip'}, {'leafval': 'local_'}, {'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'class_'}, {'leafval': 'description'}, {'leafval': 'console'}, {'leafval': 'syslogip, use_vrf'}, {'leafval': 'console'}, {'leafval': 'modId'}, {'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'syslogip, use_vrf, secure, port'}, {'leafval': 'class_'}, {'leafval': 'localip'}, {'leafval': 'local_'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_auditlog_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging.auditlog', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.auditlog', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.auditlog', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.auditlog', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.auditlog', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.logging.auditlog', u'class_'), ('pybind.nos.v6_0_2f.logging.auditlog', u'class_'), ('pybind.slxos.v17r_1_01a.logging.auditlog', u'class_'), ('pybind.nos.v7_2_0.logging.auditlog', u'class_'), ('pybind.slxos.v17r_2_00.logging.auditlog', u'class_')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'class_'}, {'leafval': 'class_'}, {'leafval': 'class_'}, {'leafval': 'class_'}, {'leafval': 'class_'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_auditlog_class_get(self, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type class_: class_
    :param class_: Keyword argument tuple.

    :type class_: unicode
    :param class_: **class_** tuple argument.

        * enumeration restriction: ::

            ['CONFIGURATION', 'SECURITY', 'FIRMWARE']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging.auditlog.class_', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.auditlog.class_', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.auditlog.class_', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.auditlog.class_', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.auditlog.class_', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'class_', 'keyval': 'class_', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_raslog_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging.raslog', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.raslog', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.raslog', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.raslog', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.raslog', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.logging.raslog', u'interface'), ('pybind.slxos.v17r_2_00.logging.raslog.module', u'modid'), ('pybind.slxos.v17r_2_00.logging.raslog.message', u'msgid'), ('pybind.nos.v7_2_0.logging.raslog.module', u'modid'), ('pybind.nos.v7_2_0.logging.raslog.message', u'msgid'), ('pybind.slxos.v17r_1_01a.logging.raslog.module', u'modid'), ('pybind.slxos.v17r_1_01a.logging.raslog.message', u'msgid'), ('pybind.slxos.v17r_1_01a.logging.raslog', u'interface'), ('pybind.nos.v6_0_2f.logging.raslog.module', u'modid'), ('pybind.nos.v6_0_2f.logging.raslog.message', u'msgid'), ('pybind.slxos.v17s_1_02.logging.raslog', u'interface'), ('pybind.slxos.v17s_1_02.logging.raslog.module', u'modid'), ('pybind.slxos.v17s_1_02.logging.raslog.message', u'msgid')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'description'}, {'leafval': 'modId'}, {'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'modId'}, {'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'modId'}, {'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'description'}, {'leafval': 'modId'}, {'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'description'}, {'leafval': 'modId'}, {'leafval': 'msgId, severity, suppress, syslog'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_raslog_console_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging.raslog', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.raslog', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.raslog', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.raslog', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.raslog', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.logging.raslog', u'interface'), ('pybind.slxos.v17r_2_00.logging.raslog.module', u'modid'), ('pybind.slxos.v17r_2_00.logging.raslog.message', u'msgid'), ('pybind.nos.v7_2_0.logging.raslog.module', u'modid'), ('pybind.nos.v7_2_0.logging.raslog.message', u'msgid'), ('pybind.slxos.v17r_1_01a.logging.raslog.module', u'modid'), ('pybind.slxos.v17r_1_01a.logging.raslog.message', u'msgid'), ('pybind.slxos.v17r_1_01a.logging.raslog', u'interface'), ('pybind.nos.v6_0_2f.logging.raslog.module', u'modid'), ('pybind.nos.v6_0_2f.logging.raslog.message', u'msgid'), ('pybind.slxos.v17s_1_02.logging.raslog', u'interface'), ('pybind.slxos.v17s_1_02.logging.raslog.module', u'modid'), ('pybind.slxos.v17s_1_02.logging.raslog.message', u'msgid')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'description'}, {'leafval': 'modId'}, {'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'modId'}, {'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'modId'}, {'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'description'}, {'leafval': 'modId'}, {'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'description'}, {'leafval': 'modId'}, {'leafval': 'msgId, severity, suppress, syslog'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_raslog_interface_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.logging.raslog.interface', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.raslog.interface', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.raslog.interface', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_raslog_interface_description_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.logging.raslog.interface', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.raslog.interface', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.raslog.interface', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_raslog_message_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging.raslog.message', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.raslog.message', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.raslog.message', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.raslog.message', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.raslog.message', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.logging.raslog.message', u'msgid'), ('pybind.slxos.v17s_1_02.logging.raslog.message', u'msgid'), ('pybind.slxos.v17r_2_00.logging.raslog.message', u'msgid'), ('pybind.nos.v6_0_2f.logging.raslog.message', u'msgid'), ('pybind.slxos.v17r_1_01a.logging.raslog.message', u'msgid')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'msgId, severity, suppress, syslog'}, {'leafval': 'msgId, severity, suppress, syslog'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_raslog_message_msgid_get(self, msgid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type msgid: msgId
    :param msgid: Keyword argument tuple.

    :type msgId: unicode
    :param msgId: **msgid** tuple argument:  Specify the Msg ID

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging.raslog.message.msgId', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.raslog.message.msgId', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.raslog.message.msgId', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.raslog.message.msgId', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.raslog.message.msgId', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'msgid', 'keyval': 'msgId', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, msgid=msgid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, msgid=msgid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_raslog_message_msgid_severity_get(self, msgid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type msgid: msgId
    :param msgid: Keyword argument tuple.

    :type msgId: unicode
    :param msgId: **msgid** tuple argument:  Specify the Msg ID

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging.raslog.message.msgId', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.raslog.message.msgId', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.raslog.message.msgId', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.raslog.message.msgId', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.raslog.message.msgId', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'msgid', 'keyval': 'msgId', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, msgid=msgid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, msgid=msgid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_raslog_message_msgid_suppress_get(self, msgid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type msgid: msgId
    :param msgid: Keyword argument tuple.

    :type msgId: unicode
    :param msgId: **msgid** tuple argument:  Specify the Msg ID

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging.raslog.message.msgId', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.raslog.message.msgId', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.raslog.message.msgId', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.raslog.message.msgId', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.raslog.message.msgId', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'msgid', 'keyval': 'msgId', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, msgid=msgid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, msgid=msgid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_raslog_message_msgid_syslog_get(self, msgid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type msgid: msgId
    :param msgid: Keyword argument tuple.

    :type msgId: unicode
    :param msgId: **msgid** tuple argument:  Specify the Msg ID

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging.raslog.message.msgId', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.raslog.message.msgId', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.raslog.message.msgId', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.raslog.message.msgId', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.raslog.message.msgId', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'msgid', 'keyval': 'msgId', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, msgid=msgid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, msgid=msgid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_raslog_module_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging.raslog.module', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.raslog.module', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.raslog.module', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.raslog.module', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.raslog.module', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.logging.raslog.module', u'modid'), ('pybind.slxos.v17s_1_02.logging.raslog.module', u'modid'), ('pybind.nos.v7_2_0.logging.raslog.module', u'modid'), ('pybind.nos.v6_0_2f.logging.raslog.module', u'modid'), ('pybind.slxos.v17r_1_01a.logging.raslog.module', u'modid')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'modId'}, {'leafval': 'modId'}, {'leafval': 'modId'}, {'leafval': 'modId'}, {'leafval': 'modId'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_raslog_module_modid_get(self, modid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type modid: modId
    :param modid: Keyword argument tuple.

    :type modId: unicode
    :param modId: **modid** tuple argument:  Specify the Module ID

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging.raslog.module.modId', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.raslog.module.modId', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.raslog.module.modId', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.raslog.module.modId', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.raslog.module.modId', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'modid', 'keyval': 'modId', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, modid=modid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, modid=modid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_syslog_client_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging.syslog_client', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.syslog_client', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.syslog_client', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.syslog_client', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.syslog_client', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_syslog_client_localip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging.syslog_client', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.syslog_client', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.syslog_client', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.syslog_client', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.syslog_client', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_syslog_facility_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging.syslog_facility', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.syslog_facility', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.syslog_facility', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.syslog_facility', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.syslog_facility', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_syslog_facility_local_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging.syslog_facility', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.syslog_facility', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.syslog_facility', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.syslog_facility', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.syslog_facility', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_syslog_server_get(self, syslog_server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type syslog_server: syslogip, use_vrf, secure, port
    :param syslog_server: Keyword argument tuple.

    :type syslogip: unicode
    :param syslogip: **syslog_server** tuple argument:  IPADDRESS		The IPv4 or IPv6 Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type use_vrf: unicode
    :param use_vrf: **syslog_server** tuple argument:  vrf to use for sending notification to the receiver. (Default=management).

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type secure: YANGBool
    :param secure: **syslog_server** tuple argument:  Indicates if transport is secure

    :type port: int
    :param port: **syslog_server** tuple argument:  Port number on which the syslog server is listening

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logging.syslog_server', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.syslog_server', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.syslog_server', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.syslog_server', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.syslog_server', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.logging.syslog_server', u'syslog_secure'), ('pybind.slxos.v17r_2_00.logging.syslog_server', u'syslog_secure'), ('pybind.slxos.v17s_1_02.logging.syslog_server', u'syslog_secure')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'syslog_server', 'keyval': 'syslogip, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'secure, port'}, {'leafval': 'secure, port'}, {'leafval': 'secure, port'}]
    leafval_map = {"pybind.nos.v6_0_2f.logging.syslog_server": {"port": "port", "syslogip": "syslogip", "use_vrf": "use_vrf", "secure": "secure"}, "pybind.nos.v7_2_0.logging.syslog_server": {"port": "port", "syslogip": "syslogip", "use_vrf": "use_vrf", "secure": "secure"}, "pybind.slxos.v17r_2_00.logging.syslog_server": {}, "pybind.slxos.v17s_1_02.logging.syslog_server": {}, "pybind.slxos.v17r_1_01a.logging.syslog_server": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, syslog_server=syslog_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, syslog_server=syslog_server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_syslog_server_format_get(self, syslog_server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type syslog_server: syslogip, use_vrf
    :param syslog_server: Keyword argument tuple.

    :type syslogip: unicode
    :param syslogip: **syslog_server** tuple argument:  IPADDRESS		The IPv4 or IPv6 Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type use_vrf: unicode
    :param use_vrf: **syslog_server** tuple argument:  vrf to use for sending notification to the receiver. (Default=management).

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.logging.syslog_server', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.logging.syslog_server', u'syslog_secure')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'syslog_server', 'keyval': 'syslogip, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'secure, port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, syslog_server=syslog_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, syslog_server=syslog_server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_syslog_server_port_get(self, syslog_server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type syslog_server: syslogip, use_vrf
    :param syslog_server: Keyword argument tuple.

    :type syslogip: unicode
    :param syslogip: **syslog_server** tuple argument:  IPADDRESS		The IPv4 or IPv6 Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type use_vrf: unicode
    :param use_vrf: **syslog_server** tuple argument:  vrf to use for sending notification to the receiver. (Default=management).

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logging.syslog_server', u'syslog_server'), ('pybind.slxos.v17r_1_01a.logging.syslog_server', u'syslog_server'), ('pybind.slxos.v17s_1_02.logging.syslog_server', u'syslog_server')]
    bindings_list = [('pybind.nos.v6_0_2f.logging.syslog_server', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.syslog_server', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.syslog_server.syslog_secure', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.syslog_server.syslog_secure', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.syslog_server.syslog_secure', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'syslogip, use_vrf', 'extra_keyval': ''}, {'keyval': 'syslogip, use_vrf', 'extra_keyval': ''}, {'keyval': 'syslogip, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.logging.syslog_server": {"syslogip": "syslogip", "port": "port", "use_vrf": "use_vrf"}, "pybind.nos.v7_2_0.logging.syslog_server": {"syslogip": "syslogip", "port": "port", "use_vrf": "use_vrf"}, "pybind.slxos.v17r_2_00.logging.syslog_server.syslog_secure": {}, "pybind.slxos.v17r_1_01a.logging.syslog_server.syslog_secure": {}, "pybind.slxos.v17s_1_02.logging.syslog_server.syslog_secure": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, syslog_server=syslog_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, syslog_server=syslog_server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logging_syslog_server_secure_get(self, syslog_server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type syslog_server: syslogip, use_vrf
    :param syslog_server: Keyword argument tuple.

    :type syslogip: unicode
    :param syslogip: **syslog_server** tuple argument:  IPADDRESS		The IPv4 or IPv6 Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type use_vrf: unicode
    :param use_vrf: **syslog_server** tuple argument:  vrf to use for sending notification to the receiver. (Default=management).

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logging.syslog_server', u'syslog_server'), ('pybind.slxos.v17r_1_01a.logging.syslog_server', u'syslog_server'), ('pybind.slxos.v17s_1_02.logging.syslog_server', u'syslog_server')]
    bindings_list = [('pybind.nos.v6_0_2f.logging.syslog_server', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logging.syslog_server', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logging.syslog_server.syslog_secure', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logging.syslog_server.syslog_secure', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logging.syslog_server.syslog_secure', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'syslogip, use_vrf', 'extra_keyval': ''}, {'keyval': 'syslogip, use_vrf', 'extra_keyval': ''}, {'keyval': 'syslogip, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.logging.syslog_server": {"syslogip": "syslogip", "secure": "secure", "use_vrf": "use_vrf"}, "pybind.nos.v7_2_0.logging.syslog_server": {"syslogip": "syslogip", "secure": "secure", "use_vrf": "use_vrf"}, "pybind.slxos.v17r_2_00.logging.syslog_server.syslog_secure": {}, "pybind.slxos.v17r_1_01a.logging.syslog_server.syslog_secure": {}, "pybind.slxos.v17s_1_02.logging.syslog_server.syslog_secure": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, syslog_server=syslog_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, syslog_server=syslog_server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.logical_interface_state', u'main_interface_tunnel'), ('pybind.slxos.v17r_1_01a.logical_interface_state', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state', u'main_interface_pseudo_wire'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel', u'logical_interface_tunnel'), ('pybind.slxos.v17s_1_02.logical_interface_state', u'main_interface_pseudo_wire'), ('pybind.slxos.v17s_1_02.logical_interface_state', u'main_interface_tunnel'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state', u'main_interface_physical'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire', u'logical_interface_pseudo_wire'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire', u'counters'), ('pybind.slxos.v17r_2_00.logical_interface_state', u'main_interface_tunnel'), ('pybind.slxos.v17r_2_00.logical_interface_state', u'main_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state', u'main_interface_pseudo_wire')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'protocol_status, admin_status, interface_index'}, {'leafval': 'protocol_status, admin_status, interface_index, intf_type, intf_name, is_tagged, port_mode'}, {'leafval': 'protocol_status, admin_status, interface_index'}, {'leafval': 'logical_interface_name, source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, vni_tni'}, {'leafval': 'protocol_status, admin_status, interface_index'}, {'leafval': 'protocol_status, admin_status, interface_index'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'protocol_status, admin_status, interface_index, intf_type, intf_name, is_tagged, port_mode'}, {'leafval': 'logical_interface_name, source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, ip_address'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'protocol_status, admin_status, interface_index'}, {'leafval': 'protocol_status, admin_status, interface_index, intf_type, intf_name, is_tagged, port_mode'}, {'leafval': 'protocol_status, admin_status, interface_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_get(self, main_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'logical_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'logical_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'logical_interface_physical')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_physical', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'logical_interface_name, source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_admin_status_get(self, main_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'logical_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'logical_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'logical_interface_physical')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_physical', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'logical_interface_name, source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}]
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical": {"admin_status": "admin_status", "intf_name": "intf_name", "interface_index": "interface_index"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical": {"admin_status": "admin_status", "intf_name": "intf_name", "interface_index": "interface_index"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_counters_get(self, main_interface_physical=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'counters', 'keyval': 'implicit_lifs, explicit_lifs', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_counters_binded_lifs_get(self, main_interface_physical=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'counters', 'keyval': 'implicit_lifs, explicit_lifs', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.counters": {}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.counters": {"explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs", "binded_lifs": "binded_lifs"}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.counters": {"explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs", "binded_lifs": "binded_lifs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_counters_explicit_lifs_get(self, main_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_counters_implicit_lifs_get(self, main_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_counters_lif_type_get(self, main_interface_physical=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'counters', 'keyval': 'implicit_lifs, explicit_lifs', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.counters": {}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.counters": {"explicit_lifs": "explicit_lifs", "lif_type": "lif_type", "implicit_lifs": "implicit_lifs"}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.counters": {"explicit_lifs": "explicit_lifs", "lif_type": "lif_type", "implicit_lifs": "implicit_lifs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_counters_protocol_status_up_lifs_get(self, main_interface_physical=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'counters', 'keyval': 'implicit_lifs, explicit_lifs', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.counters": {}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.counters": {"protocol_status_up_lifs": "protocol_status_up_lifs", "explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs"}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.counters": {"protocol_status_up_lifs": "protocol_status_up_lifs", "explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_counters_total_lifs_get(self, main_interface_physical=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'counters', 'keyval': 'implicit_lifs, explicit_lifs', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.counters": {}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.counters": {"explicit_lifs": "explicit_lifs", "total_lifs": "total_lifs", "implicit_lifs": "implicit_lifs"}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.counters": {"explicit_lifs": "explicit_lifs", "total_lifs": "total_lifs", "implicit_lifs": "implicit_lifs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_counters_unbinded_lifs_get(self, main_interface_physical=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'counters', 'keyval': 'implicit_lifs, explicit_lifs', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.counters": {}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.counters": {"explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs", "unbinded_lifs": "unbinded_lifs"}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.counters": {"explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs", "unbinded_lifs": "unbinded_lifs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_interface_index_get(self, main_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'logical_interface_physical')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_physical', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'logical_interface_name, source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_intf_type_get(self, main_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'logical_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'logical_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'logical_interface_physical')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_physical', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'logical_interface_name, source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}]
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical": {"intf_type": "intf_type", "intf_name": "intf_name", "interface_index": "interface_index"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical": {"intf_type": "intf_type", "intf_name": "intf_name", "interface_index": "interface_index"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_is_tagged_get(self, main_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'logical_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'logical_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'logical_interface_physical')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_physical', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'logical_interface_name, source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}]
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical": {"intf_name": "intf_name", "is_tagged": "is_tagged", "interface_index": "interface_index"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical": {"intf_name": "intf_name", "is_tagged": "is_tagged", "interface_index": "interface_index"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_get(self, main_interface_physical=None, logical_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type logical_interface_physical: logical_interface_name
    :param logical_interface_physical: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_interface_physical', 'keyval': 'logical_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_admin_status_get(self, main_interface_physical=None, logical_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type logical_interface_physical: logical_interface_name
    :param logical_interface_physical: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical": {"admin_status": "admin_status", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical": {"admin_status": "admin_status", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_bridge_domain_index_get(self, main_interface_physical=None, logical_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type logical_interface_physical: logical_interface_name
    :param logical_interface_physical: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical": {"bridge_domain_index": "bridge_domain_index", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical": {"bridge_domain_index": "bridge_domain_index", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_inner_vlan_id_get(self, main_interface_physical=None, logical_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type logical_interface_physical: logical_interface_name
    :param logical_interface_physical: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical": {"inner_vlan_id": "inner_vlan_id", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical": {"inner_vlan_id": "inner_vlan_id", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_interface_name_get(self, main_interface_physical=None, logical_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type logical_interface_physical: logical_interface_name
    :param logical_interface_physical: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical": {"interface_name": "interface_name", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical": {"interface_name": "interface_name", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_intf_type_get(self, main_interface_physical=None, logical_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type logical_interface_physical: logical_interface_name
    :param logical_interface_physical: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical": {"intf_type": "intf_type", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical": {"intf_type": "intf_type", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_is_binded_get(self, main_interface_physical=None, logical_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type logical_interface_physical: logical_interface_name
    :param logical_interface_physical: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical": {"is_binded": "is_binded", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical": {"is_binded": "is_binded", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_is_tagged_get(self, main_interface_physical=None, logical_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type logical_interface_physical: logical_interface_name
    :param logical_interface_physical: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical": {"is_tagged": "is_tagged", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical": {"is_tagged": "is_tagged", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_lif_index_get(self, main_interface_physical=None, logical_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type logical_interface_physical: logical_interface_name
    :param logical_interface_physical: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical": {"lif_index": "lif_index", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical": {"lif_index": "lif_index", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_logical_interface_name_get(self, main_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_outer_vlan_id_get(self, main_interface_physical=None, logical_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type logical_interface_physical: logical_interface_name
    :param logical_interface_physical: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical": {"outer_vlan_id": "outer_vlan_id", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical": {"outer_vlan_id": "outer_vlan_id", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_protocol_status_get(self, main_interface_physical=None, logical_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type logical_interface_physical: logical_interface_name
    :param logical_interface_physical: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical": {"protocol_status": "protocol_status", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical": {"protocol_status": "protocol_status", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_logical_interface_physical_source_type_get(self, main_interface_physical=None, logical_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type logical_interface_physical: logical_interface_name
    :param logical_interface_physical: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'main_interface_physical'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'main_interface_physical')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'interface_index, intf_name', 'extra_keyval': ''}, {'keyval': 'intf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical.logical_interface_physical": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical.logical_interface_physical": {"source_type": "source_type", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical.logical_interface_physical": {"source_type": "source_type", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical, logical_interface_physical=logical_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_port_mode_get(self, main_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'logical_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'logical_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'logical_interface_physical')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_physical', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'logical_interface_name, source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}]
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical": {"port_mode": "port_mode", "intf_name": "intf_name", "interface_index": "interface_index"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical": {"port_mode": "port_mode", "intf_name": "intf_name", "interface_index": "interface_index"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_physical_protocol_status_get(self, main_interface_physical=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type main_interface_physical: interface_index, intf_name
    :param main_interface_physical: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_physical** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type intf_name: unicode
    :param intf_name: **main_interface_physical** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical', u'logical_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'logical_interface_physical'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical', u'logical_interface_physical')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_physical', 'keyval': 'intf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'logical_interface_name, source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, outer_vlan_id, inner_vlan_id, intf_type, is_tagged'}]
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_physical": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_physical": {"intf_name": "intf_name", "protocol_status": "protocol_status", "interface_index": "interface_index"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_physical": {"intf_name": "intf_name", "protocol_status": "protocol_status", "interface_index": "interface_index"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_physical=main_interface_physical)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_physical=main_interface_physical)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_get(self, main_interface_pseudo_wire=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'logical_interface_pseudo_wire'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'counters'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'logical_interface_pseudo_wire'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_pseudo_wire', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, ip_address'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, ip_address'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_admin_status_get(self, main_interface_pseudo_wire=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'logical_interface_pseudo_wire'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'counters'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'logical_interface_pseudo_wire'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire', u'logical_interface_pseudo_wire'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire', u'counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, ip_address'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, ip_address'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'logical_interface_name, source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, ip_address'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}]
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire": {"admin_status": "admin_status", "interface_index": "interface_index"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire": {"admin_status": "admin_status", "interface_index": "interface_index"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_counters_get(self, main_interface_pseudo_wire=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'counters', 'keyval': 'implicit_lifs, explicit_lifs', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_counters_binded_lifs_get(self, main_interface_pseudo_wire=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'counters', 'keyval': 'implicit_lifs, explicit_lifs', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.counters": {"explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs", "binded_lifs": "binded_lifs"}, "pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.counters": {}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.counters": {"explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs", "binded_lifs": "binded_lifs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_counters_explicit_lifs_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_counters_implicit_lifs_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_counters_lif_type_get(self, main_interface_pseudo_wire=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'counters', 'keyval': 'implicit_lifs, explicit_lifs', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.counters": {"explicit_lifs": "explicit_lifs", "lif_type": "lif_type", "implicit_lifs": "implicit_lifs"}, "pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.counters": {}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.counters": {"explicit_lifs": "explicit_lifs", "lif_type": "lif_type", "implicit_lifs": "implicit_lifs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_counters_protocol_status_up_lifs_get(self, main_interface_pseudo_wire=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'counters', 'keyval': 'implicit_lifs, explicit_lifs', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.counters": {"protocol_status_up_lifs": "protocol_status_up_lifs", "explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs"}, "pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.counters": {}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.counters": {"protocol_status_up_lifs": "protocol_status_up_lifs", "explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_counters_total_lifs_get(self, main_interface_pseudo_wire=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'counters', 'keyval': 'implicit_lifs, explicit_lifs', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.counters": {"explicit_lifs": "explicit_lifs", "total_lifs": "total_lifs", "implicit_lifs": "implicit_lifs"}, "pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.counters": {}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.counters": {"explicit_lifs": "explicit_lifs", "total_lifs": "total_lifs", "implicit_lifs": "implicit_lifs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_counters_unbinded_lifs_get(self, main_interface_pseudo_wire=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'counters', 'keyval': 'implicit_lifs, explicit_lifs', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.counters": {"explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs", "unbinded_lifs": "unbinded_lifs"}, "pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.counters": {}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.counters": {"explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs", "unbinded_lifs": "unbinded_lifs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_interface_index_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire', u'logical_interface_pseudo_wire'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire', u'counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'logical_interface_name, source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, ip_address'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_get(self, main_interface_pseudo_wire=None, logical_interface_pseudo_wire=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_pseudo_wire: logical_interface_name
    :param logical_interface_pseudo_wire: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_pseudo_wire** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_interface_pseudo_wire', 'keyval': 'logical_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_admin_status_get(self, main_interface_pseudo_wire=None, logical_interface_pseudo_wire=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_pseudo_wire: logical_interface_name
    :param logical_interface_pseudo_wire: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_pseudo_wire** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {"admin_status": "admin_status", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {"admin_status": "admin_status", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_bridge_domain_index_get(self, main_interface_pseudo_wire=None, logical_interface_pseudo_wire=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_pseudo_wire: logical_interface_name
    :param logical_interface_pseudo_wire: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_pseudo_wire** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {"bridge_domain_index": "bridge_domain_index", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {"bridge_domain_index": "bridge_domain_index", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_interface_name_get(self, main_interface_pseudo_wire=None, logical_interface_pseudo_wire=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_pseudo_wire: logical_interface_name
    :param logical_interface_pseudo_wire: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_pseudo_wire** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {"interface_name": "interface_name", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {"interface_name": "interface_name", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_ip_address_get(self, main_interface_pseudo_wire=None, logical_interface_pseudo_wire=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_pseudo_wire: logical_interface_name
    :param logical_interface_pseudo_wire: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_pseudo_wire** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {"ip_address": "ip_address", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {"ip_address": "ip_address", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_is_binded_get(self, main_interface_pseudo_wire=None, logical_interface_pseudo_wire=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_pseudo_wire: logical_interface_name
    :param logical_interface_pseudo_wire: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_pseudo_wire** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {"is_binded": "is_binded", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {"is_binded": "is_binded", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_lif_index_get(self, main_interface_pseudo_wire=None, logical_interface_pseudo_wire=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_pseudo_wire: logical_interface_name
    :param logical_interface_pseudo_wire: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_pseudo_wire** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {"lif_index": "lif_index", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {"lif_index": "lif_index", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_logical_interface_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_protocol_status_get(self, main_interface_pseudo_wire=None, logical_interface_pseudo_wire=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_pseudo_wire: logical_interface_name
    :param logical_interface_pseudo_wire: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_pseudo_wire** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {"protocol_status": "protocol_status", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {"protocol_status": "protocol_status", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_logical_interface_pseudo_wire_source_type_get(self, main_interface_pseudo_wire=None, logical_interface_pseudo_wire=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_pseudo_wire: logical_interface_name
    :param logical_interface_pseudo_wire: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_pseudo_wire** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'main_interface_pseudo_wire')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {"source_type": "source_type", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire.logical_interface_pseudo_wire": {"source_type": "source_type", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire, logical_interface_pseudo_wire=logical_interface_pseudo_wire)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_pseudo_wire_protocol_status_get(self, main_interface_pseudo_wire=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type main_interface_pseudo_wire: interface_index
    :param main_interface_pseudo_wire: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_pseudo_wire** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'logical_interface_pseudo_wire'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire', u'counters'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'logical_interface_pseudo_wire'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire', u'logical_interface_pseudo_wire'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire', u'counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, ip_address'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, ip_address'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'logical_interface_name, source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, ip_address'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}]
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_pseudo_wire": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_pseudo_wire": {"protocol_status": "protocol_status", "interface_index": "interface_index"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_pseudo_wire": {"protocol_status": "protocol_status", "interface_index": "interface_index"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_pseudo_wire=main_interface_pseudo_wire)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_pseudo_wire=main_interface_pseudo_wire)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_get(self, main_interface_tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'logical_interface_tunnel'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'counters'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'logical_interface_tunnel'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_tunnel', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, vni_tni'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, vni_tni'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_admin_status_get(self, main_interface_tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'logical_interface_tunnel'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel', u'logical_interface_tunnel'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel', u'counters'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'logical_interface_tunnel'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_tunnel', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, vni_tni'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'logical_interface_name, source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, vni_tni'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, vni_tni'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}]
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel": {"admin_status": "admin_status", "interface_index": "interface_index"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel": {"admin_status": "admin_status", "interface_index": "interface_index"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_counters_get(self, main_interface_tunnel=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'counters', 'keyval': 'implicit_lifs, explicit_lifs', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_counters_binded_lifs_get(self, main_interface_tunnel=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.counters": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.counters": {"explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs", "binded_lifs": "binded_lifs"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.counters": {"explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs", "binded_lifs": "binded_lifs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_counters_explicit_lifs_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_counters_implicit_lifs_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_counters_lif_type_get(self, main_interface_tunnel=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.counters": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.counters": {"explicit_lifs": "explicit_lifs", "lif_type": "lif_type", "implicit_lifs": "implicit_lifs"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.counters": {"explicit_lifs": "explicit_lifs", "lif_type": "lif_type", "implicit_lifs": "implicit_lifs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_counters_protocol_status_up_lifs_get(self, main_interface_tunnel=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.counters": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.counters": {"protocol_status_up_lifs": "protocol_status_up_lifs", "explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.counters": {"protocol_status_up_lifs": "protocol_status_up_lifs", "explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_counters_total_lifs_get(self, main_interface_tunnel=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.counters": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.counters": {"explicit_lifs": "explicit_lifs", "total_lifs": "total_lifs", "implicit_lifs": "implicit_lifs"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.counters": {"explicit_lifs": "explicit_lifs", "total_lifs": "total_lifs", "implicit_lifs": "implicit_lifs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_counters_unbinded_lifs_get(self, main_interface_tunnel=None, counters=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type counters: implicit_lifs, explicit_lifs
    :param counters: Keyword argument tuple.

    :type implicit_lifs: long
    :param implicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type explicit_lifs: long
    :param explicit_lifs: **counters** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.counters', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.counters": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.counters": {"explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs", "unbinded_lifs": "unbinded_lifs"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.counters": {"explicit_lifs": "explicit_lifs", "implicit_lifs": "implicit_lifs", "unbinded_lifs": "unbinded_lifs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel, counters=counters)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel, counters=counters)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_interface_index_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel', u'logical_interface_tunnel'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel', u'counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'logical_interface_name, source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, vni_tni'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_get(self, main_interface_tunnel=None, logical_interface_tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_tunnel: logical_interface_name
    :param logical_interface_tunnel: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_tunnel** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_interface_tunnel', 'keyval': 'logical_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_admin_status_get(self, main_interface_tunnel=None, logical_interface_tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_tunnel: logical_interface_name
    :param logical_interface_tunnel: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_tunnel** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_interface_tunnel', 'keyval': 'logical_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {"admin_status": "admin_status", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {"admin_status": "admin_status", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_bridge_domain_index_get(self, main_interface_tunnel=None, logical_interface_tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_tunnel: logical_interface_name
    :param logical_interface_tunnel: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_tunnel** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_interface_tunnel', 'keyval': 'logical_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {"bridge_domain_index": "bridge_domain_index", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {"bridge_domain_index": "bridge_domain_index", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_interface_name_get(self, main_interface_tunnel=None, logical_interface_tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_tunnel: logical_interface_name
    :param logical_interface_tunnel: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_tunnel** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_interface_tunnel', 'keyval': 'logical_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {"interface_name": "interface_name", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {"interface_name": "interface_name", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_is_binded_get(self, main_interface_tunnel=None, logical_interface_tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_tunnel: logical_interface_name
    :param logical_interface_tunnel: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_tunnel** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_interface_tunnel', 'keyval': 'logical_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {"is_binded": "is_binded", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {"is_binded": "is_binded", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_lif_index_get(self, main_interface_tunnel=None, logical_interface_tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_tunnel: logical_interface_name
    :param logical_interface_tunnel: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_tunnel** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_interface_tunnel', 'keyval': 'logical_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {"lif_index": "lif_index", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {"lif_index": "lif_index", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_logical_interface_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_protocol_status_get(self, main_interface_tunnel=None, logical_interface_tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_tunnel: logical_interface_name
    :param logical_interface_tunnel: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_tunnel** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_interface_tunnel', 'keyval': 'logical_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {"protocol_status": "protocol_status", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {"protocol_status": "protocol_status", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_source_type_get(self, main_interface_tunnel=None, logical_interface_tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_tunnel: logical_interface_name
    :param logical_interface_tunnel: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_tunnel** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_interface_tunnel', 'keyval': 'logical_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {"source_type": "source_type", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {"source_type": "source_type", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_logical_interface_tunnel_vni_tni_get(self, main_interface_tunnel=None, logical_interface_tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_interface_tunnel: logical_interface_name
    :param logical_interface_tunnel: Keyword argument tuple.

    :type logical_interface_name: unicode
    :param logical_interface_name: **logical_interface_tunnel** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'main_interface_tunnel')]
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_index', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_interface_tunnel', 'keyval': 'logical_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {"vni_tni": "vni_tni", "logical_interface_name": "logical_interface_name"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel.logical_interface_tunnel": {"vni_tni": "vni_tni", "logical_interface_name": "logical_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel, logical_interface_tunnel=logical_interface_tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logical_interface_state_main_interface_tunnel_protocol_status_get(self, main_interface_tunnel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type main_interface_tunnel: interface_index
    :param main_interface_tunnel: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **main_interface_tunnel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'logical_interface_tunnel'), ('pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel', u'counters'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel', u'logical_interface_tunnel'), ('pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel', u'counters'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'logical_interface_tunnel'), ('pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel', u'counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'main_interface_tunnel', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, vni_tni'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'logical_interface_name, source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, vni_tni'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}, {'leafval': 'source_type, protocol_status, admin_status, lif_index, bridge_domain_index, interface_name, is_binded, logical_interface_name, vni_tni'}, {'leafval': 'lif_type, total_lifs, protocol_status_up_lifs, binded_lifs, unbinded_lifs, implicit_lifs, explicit_lifs'}]
    leafval_map = {"pybind.slxos.v17s_1_02.logical_interface_state.main_interface_tunnel": {}, "pybind.slxos.v17r_1_01a.logical_interface_state.main_interface_tunnel": {"protocol_status": "protocol_status", "interface_index": "interface_index"}, "pybind.slxos.v17r_2_00.logical_interface_state.main_interface_tunnel": {"protocol_status": "protocol_status", "interface_index": "interface_index"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, main_interface_tunnel=main_interface_tunnel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, main_interface_tunnel=main_interface_tunnel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def logtest_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.logtest', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.logtest', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.logtest', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.logtest', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.logtest', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.mac.access_list', u'standard'), ('pybind.nos.v6_0_2f.mac.access_list', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list', u'standard'), ('pybind.slxos.v17s_1_02.mac.access_list', u'extended'), ('pybind.slxos.v17s_1_02.routing_system.mac.receive', u'access_group'), ('pybind.slxos.v17r_2_00.mac.access_list', u'extended'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn.l2', u'mac'), ('pybind.slxos.v17r_2_00.bgp_state.route.evpn', u'mac'), ('pybind.slxos.v17r_2_00.mac.access_list', u'standard'), ('pybind.nos.v7_2_0.mac.access_list', u'standard'), ('pybind.nos.v7_2_0.mac.access_list', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list', u'standard')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'mac_access_list, mac_direction'}, {'leafval': 'name'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}, {'leafval': 'prefix, status, age, next_hop, next_hop_learned_from_peer, next_hop_metric, rd, vrf_label_direction, local_preference, med, origin, weight, as_path, communities, extended_community, atomic_aggregate_set, aggregator, originator, cluster_list, adj_rib_out_count, admin_distance, tag, l3_label, l2_label, esi, rmac, source_rd, mac, ethernet_tag, l2vni'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.mac.access_list', u'standard'), ('pybind.nos.v7_2_0.mac.access_list', u'extended'), ('pybind.slxos.v17r_2_00.mac.access_list', u'extended'), ('pybind.slxos.v17r_2_00.mac.access_list', u'standard'), ('pybind.nos.v6_0_2f.mac.access_list', u'standard'), ('pybind.nos.v6_0_2f.mac.access_list', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list', u'standard'), ('pybind.slxos.v17s_1_02.mac.access_list', u'standard'), ('pybind.slxos.v17s_1_02.mac.access_list', u'extended')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_get(self, extended=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.extended', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.extended', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext', u'seq'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext', u'seq'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext', u'seq'), ('pybind.nos.v7_2_0.mac.access_list.extended.hide_mac_acl_ext', u'seq'), ('pybind.nos.v6_0_2f.mac.access_list.extended.hide_mac_acl_ext', u'seq')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, action, source, srchost, src_mac_addr_mask, dst, dsthost, dst_mac_addr_mask, ethertype, vlan, pcp, pcp_force, drop_precedence_force, count, log, mirror, copy_sflow'}, {'leafval': 'seq_id, action, source, srchost, src_mac_addr_mask, dst, dsthost, dst_mac_addr_mask, vlan_tag_format, vlan, vlan_id_mask, outer_vlan, outer_vlan_id_mask, inner_vlan, inner_vlan_id_mask, ethertype, arp_guard, pcp, pcp_force, drop_precedence_force, count, log, mirror, copy_sflow'}, {'leafval': 'seq_id, action, source, srchost, src_mac_addr_mask, dst, dsthost, dst_mac_addr_mask, vlan_tag_format, vlan, vlan_id_mask, outer_vlan, outer_vlan_id_mask, inner_vlan, inner_vlan_id_mask, ethertype, arp_guard, pcp, pcp_force, drop_precedence_force, count, log, mirror, copy_sflow'}, {'leafval': 'seq_id, action, source, srchost, src_mac_addr_mask, dst, dsthost, dst_mac_addr_mask, ethertype, vlan, count, log'}, {'leafval': 'seq_id, action, source, srchost, src_mac_addr_mask, dst, dsthost, dst_mac_addr_mask, ethertype, vlan, count, log'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id, action, source, srchost, src_mac_addr_mask, dst, dsthost, dst_mac_addr_mask, ethertype, vlan, count, log
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type action: unicode
    :param action: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type source: unicode
    :param source: **seq** tuple argument.

    :type srchost: unicode
    :param srchost: **seq** tuple argument:  source mac address HHHH.HHHH.HHHH

    :type src_mac_addr_mask: unicode
    :param src_mac_addr_mask: **seq** tuple argument.

    :type dst: unicode
    :param dst: **seq** tuple argument.

    :type dsthost: unicode
    :param dsthost: **seq** tuple argument:  Destination mac address HHHH.HHHH.HHHH

    :type dst_mac_addr_mask: unicode
    :param dst_mac_addr_mask: **seq** tuple argument.

    :type ethertype: unicode
    :param ethertype: **seq** tuple argument.

        * enumeration restriction: ::

            ['arp', 'fcoe', 'ipv4']

    :type vlan: long
    :param vlan: **seq** tuple argument:  Vlan

        * range restriction: ::

            ['0..4294967295']

    :type count: YANGBool
    :param count: **seq** tuple argument:  Packet count

    :type log: YANGBool
    :param log: **seq** tuple argument:  Log Packet

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': 'seq_id, action, source, srchost, src_mac_addr_mask, dst, dsthost, dst_mac_addr_mask, vlan_tag_format, vlan, vlan_id_mask, outer_vlan, outer_vlan_id_mask, inner_vlan, inner_vlan_id_mask, ethertype, arp_guard, pcp, pcp_force, drop_precedence_force, count, log, mirror, copy_sflow'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq": {}, "pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq": {}, "pybind.nos.v6_0_2f.mac.access_list.extended.hide_mac_acl_ext.seq": {"dsthost": "dsthost", "count": "count", "log": "log", "srchost": "srchost", "seq_id": "seq_id", "dst": "dst", "vlan": "vlan", "dst_mac_addr_mask": "dst_mac_addr_mask", "source": "source", "src_mac_addr_mask": "src_mac_addr_mask", "ethertype": "ethertype", "action": "action"}, "pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq": {}, "pybind.nos.v7_2_0.mac.access_list.extended.hide_mac_acl_ext.seq": {"dsthost": "dsthost", "count": "count", "log": "log", "srchost": "srchost", "seq_id": "seq_id", "dst": "dst", "vlan": "vlan", "dst_mac_addr_mask": "dst_mac_addr_mask", "source": "source", "src_mac_addr_mask": "src_mac_addr_mask", "ethertype": "ethertype", "action": "action"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_action_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_arp_guard_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_copy_sflow_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_count_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_drop_precedence_force_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_dst_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_dst_mac_addr_mask_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_dsthost_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_ethertype_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_inner_vlan_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_inner_vlan_id_mask_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_log_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_mirror_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_outer_vlan_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_outer_vlan_id_mask_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_pcp_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_pcp_force_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_source_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_src_mac_addr_mask_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_srchost_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_vlan_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.mac.access_list.extended', u'extended'), ('pybind.nos.v6_0_2f.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended'), ('pybind.slxos.v17s_1_02.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_vlan_id_mask_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_extended_seq_vlan_tag_format_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.extended', u'extended'), ('pybind.slxos.v17r_1_01a.mac.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.extended.hide_mac_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_standard_get(self, standard=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.standard', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.standard', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.standard', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.standard', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mac.access_list.standard.hide_mac_acl_std', u'seq'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard.hide_mac_acl_std', u'seq'), ('pybind.nos.v6_0_2f.mac.access_list.standard.hide_mac_acl_std', u'seq'), ('pybind.nos.v7_2_0.mac.access_list.standard.hide_mac_acl_std', u'seq'), ('pybind.slxos.v17s_1_02.mac.access_list.standard.hide_mac_acl_std', u'seq')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, action, source, srchost, src_mac_addr_mask, count, log, copy_sflow'}, {'leafval': 'seq_id, action, source, srchost, src_mac_addr_mask, count, log, copy_sflow'}, {'leafval': 'seq_id, action, source, srchost, src_mac_addr_mask, count, log'}, {'leafval': 'seq_id, action, source, srchost, src_mac_addr_mask, count, log'}, {'leafval': 'seq_id, action, source, srchost, src_mac_addr_mask, count, log, copy_sflow'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_standard_seq_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id, action, source, srchost, src_mac_addr_mask, count, log
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type action: unicode
    :param action: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'hard-drop', 'permit']

    :type source: unicode
    :param source: **seq** tuple argument.

    :type srchost: unicode
    :param srchost: **seq** tuple argument.

    :type src_mac_addr_mask: unicode
    :param src_mac_addr_mask: **seq** tuple argument.

    :type count: YANGBool
    :param count: **seq** tuple argument:  Packet count

    :type log: YANGBool
    :param log: **seq** tuple argument:  Log Packet

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.standard', u'standard'), ('pybind.slxos.v17s_1_02.mac.access_list.standard', u'standard'), ('pybind.nos.v6_0_2f.mac.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.mac.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': 'seq_id, action, source, srchost, src_mac_addr_mask, count, log, copy_sflow'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.mac.access_list.standard.hide_mac_acl_std.seq": {}, "pybind.nos.v6_0_2f.mac.access_list.standard.hide_mac_acl_std.seq": {"count": "count", "log": "log", "srchost": "srchost", "seq_id": "seq_id", "source": "source", "src_mac_addr_mask": "src_mac_addr_mask", "action": "action"}, "pybind.slxos.v17r_2_00.mac.access_list.standard.hide_mac_acl_std.seq": {}, "pybind.slxos.v17s_1_02.mac.access_list.standard.hide_mac_acl_std.seq": {}, "pybind.nos.v7_2_0.mac.access_list.standard.hide_mac_acl_std.seq": {"count": "count", "log": "log", "srchost": "srchost", "seq_id": "seq_id", "source": "source", "src_mac_addr_mask": "src_mac_addr_mask", "action": "action"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_standard_seq_action_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.standard', u'standard'), ('pybind.slxos.v17s_1_02.mac.access_list.standard', u'standard'), ('pybind.nos.v6_0_2f.mac.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.mac.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_standard_seq_copy_sflow_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mac.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard', u'standard'), ('pybind.slxos.v17r_2_00.mac.access_list.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_standard_seq_count_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.standard', u'standard'), ('pybind.slxos.v17s_1_02.mac.access_list.standard', u'standard'), ('pybind.nos.v6_0_2f.mac.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.mac.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_standard_seq_log_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.standard', u'standard'), ('pybind.slxos.v17s_1_02.mac.access_list.standard', u'standard'), ('pybind.nos.v6_0_2f.mac.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.mac.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_standard_seq_source_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.standard', u'standard'), ('pybind.slxos.v17s_1_02.mac.access_list.standard', u'standard'), ('pybind.nos.v6_0_2f.mac.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.mac.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_standard_seq_src_mac_addr_mask_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.standard', u'standard'), ('pybind.slxos.v17s_1_02.mac.access_list.standard', u'standard'), ('pybind.nos.v6_0_2f.mac.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.mac.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_access_list_standard_seq_srchost_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: name
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mac.access_list.standard', u'standard'), ('pybind.slxos.v17s_1_02.mac.access_list.standard', u'standard'), ('pybind.nos.v6_0_2f.mac.access_list.standard', u'standard'), ('pybind.nos.v7_2_0.mac.access_list.standard', u'standard'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard', u'standard')]
    bindings_list = [('pybind.nos.v6_0_2f.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v6_0_2f.brocade_mac_access_list', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.nos.v7_2_0.brocade_mac_access_list', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17r_1_01a.brocade_mac_access_list', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17r_2_00.brocade_mac_access_list', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac.access_list.standard.hide_mac_acl_std.seq', 'pybind.slxos.v17s_1_02.brocade_mac_access_list', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac_address_table', 'pybind.nos.v6_0_2f.brocade_mac_address_table', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac_address_table', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac_address_table', 'pybind.slxos.v17r_1_01a.brocade_mac_address_table', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac_address_table', 'pybind.slxos.v17r_2_00.brocade_mac_address_table', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac_address_table', 'pybind.slxos.v17s_1_02.brocade_mac_address_table', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.mac_address_table', u'mac_move'), ('pybind.nos.v7_2_0.mac_address_table.mac_move', u'auto_recovery'), ('pybind.nos.v7_2_0.mac_address_table', u'consistency_check'), ('pybind.nos.v7_2_0.mac_address_table', u'static'), ('pybind.nos.v7_2_0.mac_address_table', u'aging_time'), ('pybind.nos.v6_0_2f.mac_address_table', u'static'), ('pybind.nos.v6_0_2f.mac_address_table', u'mac_move'), ('pybind.nos.v6_0_2f.mac_address_table', u'aging_time'), ('pybind.nos.v6_0_2f.mac_address_table', u'consistency_check'), ('pybind.slxos.v17r_1_01a.mac_address_table.static', u'static_mac'), ('pybind.slxos.v17r_1_01a.mac_address_table', u'aging_time'), ('pybind.slxos.v17r_1_01a.mac_address_table', u'consistency_check'), ('pybind.slxos.v17r_1_01a.mac_address_table.static', u'static_ac_lif'), ('pybind.slxos.v17r_1_01a.mac_address_table', u'mac_move'), ('pybind.slxos.v17s_1_02.mac_address_table.static', u'static_mac'), ('pybind.slxos.v17s_1_02.mac_address_table', u'mac_move'), ('pybind.slxos.v17s_1_02.mac_address_table.static', u'static_ac_lif'), ('pybind.slxos.v17s_1_02.mac_address_table', u'consistency_check'), ('pybind.slxos.v17s_1_02.mac_address_table', u'aging_time'), ('pybind.slxos.v17r_2_00.mac_address_table', u'aging_time'), ('pybind.slxos.v17r_2_00.mac_address_table.static', u'static_mac'), ('pybind.slxos.v17r_2_00.mac_address_table', u'consistency_check'), ('pybind.slxos.v17r_2_00.mac_address_table.static', u'static_ac_lif'), ('pybind.slxos.v17r_2_00.mac_address_table', u'mac_move')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_move_detect_enable, mac_move_limit, mac_move_action'}, {'leafval': 'auto_recovery_enable, auto_recovery_time'}, {'leafval': 'mac_consistency_check_suppress, mac_consistency_check_interval'}, {'leafval': 'mac_address, forward, interface_type, interface_name, vlan, vlanid'}, {'leafval': 'conversational_time_out, legacy_time_out'}, {'leafval': 'mac_address, forward, interface_type, interface_name, vlan, vlanid'}, {'leafval': 'mac_move_detect_enable, mac_move_limit'}, {'leafval': 'conversational_time_out, legacy_time_out'}, {'leafval': 'mac_consistency_check_suppress, mac_consistency_check_interval'}, {'leafval': 'mac_address, forward, interface_type, interface_name, vlan, vlanid'}, {'leafval': 'conversational_time_out, legacy_time_out'}, {'leafval': 'mac_consistency_check_suppress, mac_consistency_check_interval'}, {'leafval': 'mac_address_lif, forward_lif, logical_interface, interface_type_lif, logical_interface_name'}, {'leafval': 'mac_move_detect_enable, mac_move_limit'}, {'leafval': 'mac_address, forward, interface_type, interface_name, vlan, vlanid'}, {'leafval': 'mac_move_detect_enable, mac_move_limit'}, {'leafval': 'mac_address_lif, forward_lif, logical_interface, interface_type_lif, logical_interface_name'}, {'leafval': 'mac_consistency_check_suppress, mac_consistency_check_interval'}, {'leafval': 'conversational_time_out, legacy_time_out'}, {'leafval': 'conversational_time_out, legacy_time_out'}, {'leafval': 'mac_address, forward, interface_type, interface_name, vlan, vlanid'}, {'leafval': 'mac_consistency_check_suppress, mac_consistency_check_interval'}, {'leafval': 'mac_address_lif, forward_lif, logical_interface, interface_type_lif, logical_interface_name'}, {'leafval': 'mac_move_detect_enable, mac_move_limit'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_aging_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac_address_table.aging_time', 'pybind.nos.v6_0_2f.brocade_mac_address_table', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac_address_table.aging_time', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac_address_table.aging_time', 'pybind.slxos.v17r_1_01a.brocade_mac_address_table', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac_address_table.aging_time', 'pybind.slxos.v17r_2_00.brocade_mac_address_table', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac_address_table.aging_time', 'pybind.slxos.v17s_1_02.brocade_mac_address_table', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_aging_time_conversational_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac_address_table.aging_time', 'pybind.nos.v6_0_2f.brocade_mac_address_table', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac_address_table.aging_time', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac_address_table.aging_time', 'pybind.slxos.v17r_1_01a.brocade_mac_address_table', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac_address_table.aging_time', 'pybind.slxos.v17r_2_00.brocade_mac_address_table', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac_address_table.aging_time', 'pybind.slxos.v17s_1_02.brocade_mac_address_table', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_aging_time_legacy_time_out_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac_address_table.aging_time', 'pybind.nos.v6_0_2f.brocade_mac_address_table', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac_address_table.aging_time', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac_address_table.aging_time', 'pybind.slxos.v17r_1_01a.brocade_mac_address_table', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac_address_table.aging_time', 'pybind.slxos.v17r_2_00.brocade_mac_address_table', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac_address_table.aging_time', 'pybind.slxos.v17s_1_02.brocade_mac_address_table', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_consistency_check_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac_address_table.consistency_check', 'pybind.nos.v6_0_2f.brocade_mac_address_table', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac_address_table.consistency_check', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac_address_table.consistency_check', 'pybind.slxos.v17r_1_01a.brocade_mac_address_table', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac_address_table.consistency_check', 'pybind.slxos.v17r_2_00.brocade_mac_address_table', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac_address_table.consistency_check', 'pybind.slxos.v17s_1_02.brocade_mac_address_table', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_consistency_check_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac_address_table.consistency_check', 'pybind.nos.v6_0_2f.brocade_mac_address_table', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac_address_table.consistency_check', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac_address_table.consistency_check', 'pybind.slxos.v17r_1_01a.brocade_mac_address_table', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac_address_table.consistency_check', 'pybind.slxos.v17r_2_00.brocade_mac_address_table', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac_address_table.consistency_check', 'pybind.slxos.v17s_1_02.brocade_mac_address_table', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_consistency_check_suppress_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac_address_table.consistency_check', 'pybind.nos.v6_0_2f.brocade_mac_address_table', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac_address_table.consistency_check', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac_address_table.consistency_check', 'pybind.slxos.v17r_1_01a.brocade_mac_address_table', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac_address_table.consistency_check', 'pybind.slxos.v17r_2_00.brocade_mac_address_table', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac_address_table.consistency_check', 'pybind.slxos.v17s_1_02.brocade_mac_address_table', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_learning_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac_address_table', 'pybind.nos.v6_0_2f.brocade_mac_address_table', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac_address_table', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac_address_table', 'pybind.slxos.v17r_1_01a.brocade_mac_address_table', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac_address_table', 'pybind.slxos.v17r_2_00.brocade_mac_address_table', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac_address_table', 'pybind.slxos.v17s_1_02.brocade_mac_address_table', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.mac_address_table', u'mac_move'), ('pybind.nos.v7_2_0.mac_address_table.mac_move', u'auto_recovery'), ('pybind.nos.v7_2_0.mac_address_table', u'consistency_check'), ('pybind.nos.v7_2_0.mac_address_table', u'static'), ('pybind.nos.v7_2_0.mac_address_table', u'aging_time'), ('pybind.nos.v6_0_2f.mac_address_table', u'static'), ('pybind.nos.v6_0_2f.mac_address_table', u'mac_move'), ('pybind.nos.v6_0_2f.mac_address_table', u'aging_time'), ('pybind.nos.v6_0_2f.mac_address_table', u'consistency_check'), ('pybind.slxos.v17r_1_01a.mac_address_table.static', u'static_mac'), ('pybind.slxos.v17r_1_01a.mac_address_table', u'aging_time'), ('pybind.slxos.v17r_1_01a.mac_address_table', u'consistency_check'), ('pybind.slxos.v17r_1_01a.mac_address_table.static', u'static_ac_lif'), ('pybind.slxos.v17r_1_01a.mac_address_table', u'mac_move'), ('pybind.slxos.v17s_1_02.mac_address_table.static', u'static_mac'), ('pybind.slxos.v17s_1_02.mac_address_table', u'mac_move'), ('pybind.slxos.v17s_1_02.mac_address_table.static', u'static_ac_lif'), ('pybind.slxos.v17s_1_02.mac_address_table', u'consistency_check'), ('pybind.slxos.v17s_1_02.mac_address_table', u'aging_time'), ('pybind.slxos.v17r_2_00.mac_address_table', u'aging_time'), ('pybind.slxos.v17r_2_00.mac_address_table.static', u'static_mac'), ('pybind.slxos.v17r_2_00.mac_address_table', u'consistency_check'), ('pybind.slxos.v17r_2_00.mac_address_table.static', u'static_ac_lif'), ('pybind.slxos.v17r_2_00.mac_address_table', u'mac_move')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_move_detect_enable, mac_move_limit, mac_move_action'}, {'leafval': 'auto_recovery_enable, auto_recovery_time'}, {'leafval': 'mac_consistency_check_suppress, mac_consistency_check_interval'}, {'leafval': 'mac_address, forward, interface_type, interface_name, vlan, vlanid'}, {'leafval': 'conversational_time_out, legacy_time_out'}, {'leafval': 'mac_address, forward, interface_type, interface_name, vlan, vlanid'}, {'leafval': 'mac_move_detect_enable, mac_move_limit'}, {'leafval': 'conversational_time_out, legacy_time_out'}, {'leafval': 'mac_consistency_check_suppress, mac_consistency_check_interval'}, {'leafval': 'mac_address, forward, interface_type, interface_name, vlan, vlanid'}, {'leafval': 'conversational_time_out, legacy_time_out'}, {'leafval': 'mac_consistency_check_suppress, mac_consistency_check_interval'}, {'leafval': 'mac_address_lif, forward_lif, logical_interface, interface_type_lif, logical_interface_name'}, {'leafval': 'mac_move_detect_enable, mac_move_limit'}, {'leafval': 'mac_address, forward, interface_type, interface_name, vlan, vlanid'}, {'leafval': 'mac_move_detect_enable, mac_move_limit'}, {'leafval': 'mac_address_lif, forward_lif, logical_interface, interface_type_lif, logical_interface_name'}, {'leafval': 'mac_consistency_check_suppress, mac_consistency_check_interval'}, {'leafval': 'conversational_time_out, legacy_time_out'}, {'leafval': 'conversational_time_out, legacy_time_out'}, {'leafval': 'mac_address, forward, interface_type, interface_name, vlan, vlanid'}, {'leafval': 'mac_consistency_check_suppress, mac_consistency_check_interval'}, {'leafval': 'mac_address_lif, forward_lif, logical_interface, interface_type_lif, logical_interface_name'}, {'leafval': 'mac_move_detect_enable, mac_move_limit'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_mac_move_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac_address_table.mac_move', 'pybind.nos.v6_0_2f.brocade_mac_address_table', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac_address_table.mac_move', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac_address_table.mac_move', 'pybind.slxos.v17r_1_01a.brocade_mac_address_table', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac_address_table.mac_move', 'pybind.slxos.v17r_2_00.brocade_mac_address_table', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac_address_table.mac_move', 'pybind.slxos.v17s_1_02.brocade_mac_address_table', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.mac_address_table.mac_move', u'auto_recovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'auto_recovery_enable, auto_recovery_time'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mac_address_table.mac_move": {"mac_move_detect_enable": "mac_move_detect_enable", "mac_move_limit": "mac_move_limit"}, "pybind.nos.v7_2_0.mac_address_table.mac_move": {}, "pybind.slxos.v17r_2_00.mac_address_table.mac_move": {"mac_move_detect_enable": "mac_move_detect_enable", "mac_move_limit": "mac_move_limit"}, "pybind.nos.v6_0_2f.mac_address_table.mac_move": {"mac_move_detect_enable": "mac_move_detect_enable", "mac_move_limit": "mac_move_limit"}, "pybind.slxos.v17r_1_01a.mac_address_table.mac_move": {"mac_move_detect_enable": "mac_move_detect_enable", "mac_move_limit": "mac_move_limit"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_mac_move_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.mac_address_table.mac_move', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.mac_address_table.mac_move', u'auto_recovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'auto_recovery_enable, auto_recovery_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_mac_move_auto_recovery_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.mac_address_table.mac_move.auto_recovery', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_mac_move_auto_recovery_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.mac_address_table.mac_move.auto_recovery', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_mac_move_auto_recovery_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.mac_address_table.mac_move.auto_recovery', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_mac_move_detect_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac_address_table.mac_move', 'pybind.nos.v6_0_2f.brocade_mac_address_table', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac_address_table.mac_move', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac_address_table.mac_move', 'pybind.slxos.v17r_1_01a.brocade_mac_address_table', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac_address_table.mac_move', 'pybind.slxos.v17r_2_00.brocade_mac_address_table', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac_address_table.mac_move', 'pybind.slxos.v17s_1_02.brocade_mac_address_table', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.mac_address_table.mac_move', u'auto_recovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'auto_recovery_enable, auto_recovery_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_mac_move_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac_address_table.mac_move', 'pybind.nos.v6_0_2f.brocade_mac_address_table', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac_address_table.mac_move', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac_address_table.mac_move', 'pybind.slxos.v17r_1_01a.brocade_mac_address_table', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac_address_table.mac_move', 'pybind.slxos.v17r_2_00.brocade_mac_address_table', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac_address_table.mac_move', 'pybind.slxos.v17s_1_02.brocade_mac_address_table', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.mac_address_table.mac_move', u'auto_recovery')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'auto_recovery_enable, auto_recovery_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_static_get(self, static=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type static: mac_address, forward, interface_type, interface_name, vlan, vlanid
    :param static: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **static** tuple argument.

    :type forward: unicode
    :param forward: **static** tuple argument:  Forward

        * enumeration restriction: ::

            ['forward']

    :type interface_type: unicode
    :param interface_type: **static** tuple argument:  Interface

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **static** tuple argument:  Interface identifier

    :type vlan: unicode
    :param vlan: **static** tuple argument:  vlan

        * enumeration restriction: ::

            ['vlan']

    :type vlanid: long
    :param vlanid: **static** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac_address_table.static', 'pybind.nos.v6_0_2f.brocade_mac_address_table', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac_address_table.static', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static', 'keyval': 'mac_address, forward, interface_type, interface_name, vlan, vlanid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static=static)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static=static)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_static_static_ac_lif_get(self, static_ac_lif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type static_ac_lif: mac_address_lif, forward_lif, logical_interface, interface_type_lif, logical_interface_name
    :param static_ac_lif: Keyword argument tuple.

    :type mac_address_lif: unicode
    :param mac_address_lif: **static_ac_lif** tuple argument.

    :type forward_lif: unicode
    :param forward_lif: **static_ac_lif** tuple argument:  Forward

        * enumeration restriction: ::

            ['forward']

    :type logical_interface: unicode
    :param logical_interface: **static_ac_lif** tuple argument:  Logical Interface

        * enumeration restriction: ::

            ['logical-interface']

    :type interface_type_lif: unicode
    :param interface_type_lif: **static_ac_lif** tuple argument:  Logical Ethernet Interface

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type logical_interface_name: unicode
    :param logical_interface_name: **static_ac_lif** tuple argument:  Logical interface name

        * pattern restriction: ::

            '(((([0-9]|1[0-6])/([1-9]|[1-9][0-9])(:[1-4])?)|('
            '[1-9]|[1-9][0-9]|[1-4][0-9][0-9]|50[0-9]|51[0-2]'
            '))\.([1-9]|[1-9][0-9]+))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mac_address_table.static.static_ac_lif', 'pybind.slxos.v17r_1_01a.brocade_mac_address_table', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac_address_table.static.static_ac_lif', 'pybind.slxos.v17r_2_00.brocade_mac_address_table', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac_address_table.static.static_ac_lif', 'pybind.slxos.v17s_1_02.brocade_mac_address_table', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_ac_lif', 'keyval': 'mac_address_lif, forward_lif, logical_interface, interface_type_lif, logical_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_ac_lif=static_ac_lif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_ac_lif=static_ac_lif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_address_table_static_static_mac_get(self, static_mac=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type static_mac: mac_address, forward, interface_type, interface_name, vlan, vlanid
    :param static_mac: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **static_mac** tuple argument.

    :type forward: unicode
    :param forward: **static_mac** tuple argument:  Forward

        * enumeration restriction: ::

            ['forward']

    :type interface_type: unicode
    :param interface_type: **static_mac** tuple argument:  Interface

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type interface_name: unicode
    :param interface_name: **static_mac** tuple argument:  Interface identifier

    :type vlan: unicode
    :param vlan: **static_mac** tuple argument:  vlan

        * enumeration restriction: ::

            ['vlan']

    :type vlanid: long
    :param vlanid: **static_mac** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mac_address_table.static.static_mac', 'pybind.slxos.v17r_1_01a.brocade_mac_address_table', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac_address_table.static.static_mac', 'pybind.slxos.v17r_2_00.brocade_mac_address_table', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac_address_table.static.static_mac', 'pybind.slxos.v17s_1_02.brocade_mac_address_table', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_mac', 'keyval': 'mac_address, forward, interface_type, interface_name, vlan, vlanid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_mac=static_mac)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_mac=static_mac)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_group_get(self, mac_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type mac_group: mac_group_id
    :param mac_group: Keyword argument tuple.

    :type mac_group_id: long
    :param mac_group_id: **mac_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mac_group', 'pybind.nos.v6_0_2f.brocade_mac_address_table', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac_group', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac_group', 'pybind.slxos.v17r_1_01a.brocade_mac_address_table', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac_group', 'pybind.slxos.v17r_2_00.brocade_mac_address_table', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac_group', 'pybind.slxos.v17s_1_02.brocade_mac_address_table', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mac_group', u'mac_group_entry'), ('pybind.nos.v7_2_0.mac_group', u'mac_group_entry'), ('pybind.slxos.v17s_1_02.mac_group', u'mac_group_entry'), ('pybind.nos.v6_0_2f.mac_group', u'mac_group_entry'), ('pybind.slxos.v17r_2_00.mac_group', u'mac_group_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'mac_group', 'keyval': 'mac_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'entry_address'}, {'leafval': 'entry_address'}, {'leafval': 'entry_address'}, {'leafval': 'entry_address'}, {'leafval': 'entry_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac_group=mac_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac_group=mac_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_group_mac_get(self, mac_group=None, mac_group_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mac_group: mac_group_id
    :param mac_group: Keyword argument tuple.

    :type mac_group_id: long
    :param mac_group_id: **mac_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type mac_group_entry: entry_address
    :param mac_group_entry: Keyword argument tuple.

    :type entry_address: unicode
    :param entry_address: **mac_group_entry** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mac_group', 'mac_group'), ('pybind.slxos.v17r_1_01a.mac_group', 'mac_group'), ('pybind.nos.v6_0_2f.mac_group', 'mac_group'), ('pybind.slxos.v17r_2_00.mac_group', 'mac_group'), ('pybind.nos.v7_2_0.mac_group', 'mac_group')]
    bindings_list = [('pybind.nos.v6_0_2f.mac_group.mac_group_entry', 'pybind.nos.v6_0_2f.brocade_mac_address_table', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mac_group.mac_group_entry', 'pybind.nos.v7_2_0.brocade_mac_address_table', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mac_group.mac_group_entry', 'pybind.slxos.v17r_1_01a.brocade_mac_address_table', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mac_group.mac_group_entry', 'pybind.slxos.v17r_2_00.brocade_mac_address_table', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mac_group.mac_group_entry', 'pybind.slxos.v17s_1_02.brocade_mac_address_table', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'mac_group_id', 'extra_keyval': ''}, {'keyval': 'mac_group_id', 'extra_keyval': ''}, {'keyval': 'mac_group_id', 'extra_keyval': ''}, {'keyval': 'mac_group_id', 'extra_keyval': ''}, {'keyval': 'mac_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mac_group_entry', 'keyval': 'entry_address', 'extra_keyval': 'entry_address'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mac_group=mac_group, mac_group_entry=mac_group_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mac_group=mac_group, mac_group_entry=mac_group_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_receive_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.mac.receive', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.mac.receive', u'access_group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_access_list, mac_direction'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_receive_access_group_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.mac.receive.access_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'mac_access_list, mac_direction'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_receive_access_group_mac_access_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.mac.receive.access_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_receive_access_group_mac_direction_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.mac.receive.access_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mac_routing_system_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.mac', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.mac.receive', u'access_group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_access_list, mac_direction'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def maps_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.maps', 'pybind.slxos.v17r_1_01a.brocade_maps', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.maps', 'pybind.slxos.v17r_2_00.brocade_maps', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.maps', 'pybind.slxos.v17s_1_02.brocade_maps', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.maps.email', u'email_list'), ('pybind.slxos.v17s_1_02.capabilities', u'maps'), ('pybind.slxos.v17s_1_02.maps', u'enable'), ('pybind.slxos.v17s_1_02.maps', u'relay'), ('pybind.slxos.v17r_1_01a.maps', u'enable'), ('pybind.slxos.v17r_1_01a.maps.email', u'email_list'), ('pybind.slxos.v17r_1_01a.maps', u'relay'), ('pybind.slxos.v17r_2_00.maps', u'relay'), ('pybind.slxos.v17r_2_00.maps.email', u'email_list'), ('pybind.slxos.v17r_2_00.maps', u'enable')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'email'}, {'leafval': 'qos_mpls'}, {'leafval': 'policy, actions'}, {'leafval': 'hostip, domainname'}, {'leafval': 'policy, actions'}, {'leafval': 'email'}, {'leafval': 'hostip, domainname'}, {'leafval': 'hostip, domainname'}, {'leafval': 'email'}, {'leafval': 'policy, actions'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def maps_email_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.maps.email', 'pybind.slxos.v17r_1_01a.brocade_maps', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.maps.email', 'pybind.slxos.v17r_2_00.brocade_maps', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.maps.email', 'pybind.slxos.v17s_1_02.brocade_maps', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.maps.email', u'email_list'), ('pybind.slxos.v17r_1_01a.maps.email', u'email_list'), ('pybind.slxos.v17r_2_00.maps.email', u'email_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def maps_email_email_list_get(self, email_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type email_list: email
    :param email_list: Keyword argument tuple.

    :type email: unicode
    :param email: **email_list** tuple argument:  <email:string>  e-mail address for MAPS alerts

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.maps.email.email_list', 'pybind.slxos.v17r_1_01a.brocade_maps', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.maps.email.email_list', 'pybind.slxos.v17r_2_00.brocade_maps', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.maps.email.email_list', 'pybind.slxos.v17s_1_02.brocade_maps', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'email_list', 'keyval': 'email', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, email_list=email_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, email_list=email_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def maps_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.maps.enable', 'pybind.slxos.v17r_1_01a.brocade_maps', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.maps.enable', 'pybind.slxos.v17r_2_00.brocade_maps', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.maps.enable', 'pybind.slxos.v17s_1_02.brocade_maps', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def maps_enable_actions_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.maps.enable', 'pybind.slxos.v17r_1_01a.brocade_maps', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.maps.enable', 'pybind.slxos.v17r_2_00.brocade_maps', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.maps.enable', 'pybind.slxos.v17s_1_02.brocade_maps', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def maps_enable_policy_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.maps.enable', 'pybind.slxos.v17r_1_01a.brocade_maps', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.maps.enable', 'pybind.slxos.v17r_2_00.brocade_maps', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.maps.enable', 'pybind.slxos.v17s_1_02.brocade_maps', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def maps_relay_get(self, relay=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type relay: hostip
    :param relay: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **relay** tuple argument:  <IP:Address> IP address of Relay Host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.maps.relay', 'pybind.slxos.v17r_1_01a.brocade_maps', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.maps.relay', 'pybind.slxos.v17r_2_00.brocade_maps', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.maps.relay', 'pybind.slxos.v17s_1_02.brocade_maps', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'relay', 'keyval': 'hostip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, relay=relay)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, relay=relay)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def maps_relay_domainname_get(self, relay=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type relay: hostip
    :param relay: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **relay** tuple argument:  <IP:Address> IP address of Relay Host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.maps.relay', 'pybind.slxos.v17r_1_01a.brocade_maps', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.maps.relay', 'pybind.slxos.v17r_2_00.brocade_maps', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.maps.relay', 'pybind.slxos.v17s_1_02.brocade_maps', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'relay', 'keyval': 'hostip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, relay=relay)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, relay=relay)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_l2ys_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_vlan', u'vlan_label_info'), ('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_bd', u'bd_label_info'), ('pybind.slxos.v17r_1_01a.mct_l2ys_state', u'show_cluster_mem_bd'), ('pybind.slxos.v17r_1_01a.mct_l2ys_state', u'show_cluster_mem_vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id, unicast_label_local, unicast_label_remote, fw_state'}, {'leafval': 'bd_id, unicast_label_local, unicast_label_remote, fw_state'}, {'leafval': 'num_bds'}, {'leafval': 'num_vlans'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_bd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_bd', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_bd', u'bd_label_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bd_id, unicast_label_local, unicast_label_remote, fw_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_bd_bd_label_info_get(self, bd_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Instance Keyword Argument Tuple**:

    :type bd_label_info: bd_id
    :param bd_label_info: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bd_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_bd.bd_label_info', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bd_label_info', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_label_info=bd_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_label_info=bd_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_bd_bd_label_info_fw_state_get(self, bd_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Instance Keyword Argument Tuple**:

    :type bd_label_info: bd_id
    :param bd_label_info: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bd_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_bd.bd_label_info', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bd_label_info', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_label_info=bd_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_label_info=bd_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_bd_bd_label_info_unicast_label_local_get(self, bd_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Instance Keyword Argument Tuple**:

    :type bd_label_info: bd_id
    :param bd_label_info: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bd_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_bd.bd_label_info', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bd_label_info', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_label_info=bd_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_label_info=bd_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_bd_bd_label_info_unicast_label_remote_get(self, bd_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Instance Keyword Argument Tuple**:

    :type bd_label_info: bd_id
    :param bd_label_info: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bd_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_bd.bd_label_info', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bd_label_info', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bd_label_info=bd_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bd_label_info=bd_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_bd_num_bds_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_bd', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_bd', u'bd_label_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bd_id, unicast_label_local, unicast_label_remote, fw_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_vlan_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_vlan', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_vlan', u'vlan_label_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id, unicast_label_local, unicast_label_remote, fw_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_vlan_num_vlans_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_vlan', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_vlan', u'vlan_label_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id, unicast_label_local, unicast_label_remote, fw_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_vlan_vlan_label_info_get(self, vlan_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Instance Keyword Argument Tuple**:

    :type vlan_label_info: vlan_id
    :param vlan_label_info: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_vlan.vlan_label_info', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan_label_info', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_label_info=vlan_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_label_info=vlan_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_vlan_vlan_label_info_fw_state_get(self, vlan_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Instance Keyword Argument Tuple**:

    :type vlan_label_info: vlan_id
    :param vlan_label_info: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_vlan.vlan_label_info', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan_label_info', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_label_info=vlan_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_label_info=vlan_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_vlan_vlan_label_info_unicast_label_local_get(self, vlan_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Instance Keyword Argument Tuple**:

    :type vlan_label_info: vlan_id
    :param vlan_label_info: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_vlan.vlan_label_info', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan_label_info', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_label_info=vlan_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_label_info=vlan_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_l2ys_state_show_cluster_mem_vlan_vlan_label_info_unicast_label_remote_get(self, vlan_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Instance Keyword Argument Tuple**:

    :type vlan_label_info: vlan_id
    :param vlan_label_info: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_l2ys_state.show_cluster_mem_vlan.vlan_label_info', 'pybind.slxos.v17r_1_01a.brocade_l2sys_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan_label_info', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_label_info=vlan_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_label_info=vlan_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_mem_bd_state_get(self, mct_mem_bd_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mct_mem_bd_state: cluster_id
    :param mct_mem_bd_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **mct_mem_bd_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mct_mem_bd_state', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mct_mem_bd_state', u'bd_label_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'mct_mem_bd_state', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bd_id, unicast_label_remote, mcast_label_remote, fw_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mct_mem_bd_state=mct_mem_bd_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mct_mem_bd_state=mct_mem_bd_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_mem_bd_state_bd_label_info_get(self, mct_mem_bd_state=None, bd_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mct_mem_bd_state: cluster_id
    :param mct_mem_bd_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **mct_mem_bd_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_label_info: bd_id
    :param bd_label_info: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bd_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mct_mem_bd_state', 'mct_mem_bd_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.mct_mem_bd_state.bd_label_info', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_label_info', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mct_mem_bd_state=mct_mem_bd_state, bd_label_info=bd_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mct_mem_bd_state=mct_mem_bd_state, bd_label_info=bd_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_mem_bd_state_bd_label_info_fw_state_get(self, mct_mem_bd_state=None, bd_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mct_mem_bd_state: cluster_id
    :param mct_mem_bd_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **mct_mem_bd_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_label_info: bd_id
    :param bd_label_info: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bd_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mct_mem_bd_state', 'mct_mem_bd_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.mct_mem_bd_state.bd_label_info', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_label_info', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mct_mem_bd_state=mct_mem_bd_state, bd_label_info=bd_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mct_mem_bd_state=mct_mem_bd_state, bd_label_info=bd_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_mem_bd_state_bd_label_info_mcast_label_remote_get(self, mct_mem_bd_state=None, bd_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mct_mem_bd_state: cluster_id
    :param mct_mem_bd_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **mct_mem_bd_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_label_info: bd_id
    :param bd_label_info: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bd_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mct_mem_bd_state', 'mct_mem_bd_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.mct_mem_bd_state.bd_label_info', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_label_info', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mct_mem_bd_state=mct_mem_bd_state, bd_label_info=bd_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mct_mem_bd_state=mct_mem_bd_state, bd_label_info=bd_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_mem_bd_state_bd_label_info_unicast_label_remote_get(self, mct_mem_bd_state=None, bd_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mct_mem_bd_state: cluster_id
    :param mct_mem_bd_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **mct_mem_bd_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_label_info: bd_id
    :param bd_label_info: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bd_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mct_mem_bd_state', 'mct_mem_bd_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.mct_mem_bd_state.bd_label_info', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_label_info', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mct_mem_bd_state=mct_mem_bd_state, bd_label_info=bd_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mct_mem_bd_state=mct_mem_bd_state, bd_label_info=bd_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_mem_bd_state_num_bds_get(self, mct_mem_bd_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mct_mem_bd_state: cluster_id
    :param mct_mem_bd_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **mct_mem_bd_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mct_mem_bd_state', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mct_mem_bd_state', u'bd_label_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'mct_mem_bd_state', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bd_id, unicast_label_remote, mcast_label_remote, fw_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mct_mem_bd_state=mct_mem_bd_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mct_mem_bd_state=mct_mem_bd_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_mem_vlan_state_get(self, mct_mem_vlan_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mct_mem_vlan_state: cluster_id
    :param mct_mem_vlan_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **mct_mem_vlan_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mct_mem_vlan_state', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mct_mem_vlan_state', u'vlan_label_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'mct_mem_vlan_state', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id, unicast_label_remote, mcast_label_remote, fw_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mct_mem_vlan_state=mct_mem_vlan_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mct_mem_vlan_state=mct_mem_vlan_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_mem_vlan_state_num_vlans_get(self, mct_mem_vlan_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mct_mem_vlan_state: cluster_id
    :param mct_mem_vlan_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **mct_mem_vlan_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mct_mem_vlan_state', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mct_mem_vlan_state', u'vlan_label_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'mct_mem_vlan_state', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id, unicast_label_remote, mcast_label_remote, fw_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mct_mem_vlan_state=mct_mem_vlan_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mct_mem_vlan_state=mct_mem_vlan_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_mem_vlan_state_vlan_label_info_get(self, mct_mem_vlan_state=None, vlan_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mct_mem_vlan_state: cluster_id
    :param mct_mem_vlan_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **mct_mem_vlan_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan_label_info: vlan_id
    :param vlan_label_info: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mct_mem_vlan_state', 'mct_mem_vlan_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.mct_mem_vlan_state.vlan_label_info', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_label_info', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mct_mem_vlan_state=mct_mem_vlan_state, vlan_label_info=vlan_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mct_mem_vlan_state=mct_mem_vlan_state, vlan_label_info=vlan_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_mem_vlan_state_vlan_label_info_fw_state_get(self, mct_mem_vlan_state=None, vlan_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mct_mem_vlan_state: cluster_id
    :param mct_mem_vlan_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **mct_mem_vlan_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan_label_info: vlan_id
    :param vlan_label_info: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mct_mem_vlan_state', 'mct_mem_vlan_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.mct_mem_vlan_state.vlan_label_info', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_label_info', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mct_mem_vlan_state=mct_mem_vlan_state, vlan_label_info=vlan_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mct_mem_vlan_state=mct_mem_vlan_state, vlan_label_info=vlan_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_mem_vlan_state_vlan_label_info_mcast_label_remote_get(self, mct_mem_vlan_state=None, vlan_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mct_mem_vlan_state: cluster_id
    :param mct_mem_vlan_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **mct_mem_vlan_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan_label_info: vlan_id
    :param vlan_label_info: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mct_mem_vlan_state', 'mct_mem_vlan_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.mct_mem_vlan_state.vlan_label_info', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_label_info', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mct_mem_vlan_state=mct_mem_vlan_state, vlan_label_info=vlan_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mct_mem_vlan_state=mct_mem_vlan_state, vlan_label_info=vlan_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_mem_vlan_state_vlan_label_info_unicast_label_remote_get(self, mct_mem_vlan_state=None, vlan_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mct_mem_vlan_state: cluster_id
    :param mct_mem_vlan_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **mct_mem_vlan_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan_label_info: vlan_id
    :param vlan_label_info: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mct_mem_vlan_state', 'mct_mem_vlan_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.mct_mem_vlan_state.vlan_label_info', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_label_info', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mct_mem_vlan_state=mct_mem_vlan_state, vlan_label_info=vlan_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mct_mem_vlan_state=mct_mem_vlan_state, vlan_label_info=vlan_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mct_state', u'show_cluster'), ('pybind.slxos.v17s_1_02.mct_state', u'show_cluster'), ('pybind.slxos.v17r_2_00.mct_state', u'show_cluster')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cluster_id, is_cluster_client_command, cluster_name, cluster_status, client_isolation_status, num_peers, num_clients, num_config_vlans, num_active_vlans, num_bds, num_active_bds, client_interfaces_shutdown'}, {'leafval': 'cluster_id, is_cluster_client_command, is_cluster_all_command, cluster_name, cluster_status, client_isolation_status, num_peers, num_clients, num_config_vlans, num_active_vlans, num_bds, num_active_bds, client_interfaces_shutdown, control_vlan, df_hold_time'}, {'leafval': 'cluster_id, is_cluster_client_command, cluster_name, cluster_status, client_isolation_status, num_peers, num_clients, num_config_vlans, num_active_vlans, num_bds, num_active_bds, client_interfaces_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_get(self, show_cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mct_state.show_cluster": {}, "pybind.slxos.v17r_1_01a.mct_state.show_cluster": {"num_active_bds": "num_active_bds", "num_active_vlans": "num_active_vlans", "client_isolation_status": "client_isolation_status", "client_interfaces_shutdown": "client_interfaces_shutdown", "is_cluster_client_command": "is_cluster_client_command", "num_config_vlans": "num_config_vlans", "num_bds": "num_bds", "cluster_name": "cluster_name", "cluster_id": "cluster_id", "cluster_status": "cluster_status", "num_peers": "num_peers", "num_clients": "num_clients"}, "pybind.slxos.v17r_2_00.mct_state.show_cluster": {"num_active_bds": "num_active_bds", "num_active_vlans": "num_active_vlans", "client_isolation_status": "client_isolation_status", "client_interfaces_shutdown": "client_interfaces_shutdown", "is_cluster_client_command": "is_cluster_client_command", "num_config_vlans": "num_config_vlans", "num_bds": "num_bds", "cluster_name": "cluster_name", "cluster_id": "cluster_id", "cluster_status": "cluster_status", "num_peers": "num_peers", "num_clients": "num_clients"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_active_bd_list_get(self, show_cluster=None, active_bd_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type active_bd_list: bd_id
    :param active_bd_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **active_bd_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster.active_bd_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.active_bd_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.active_bd_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'active_bd_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, active_bd_list=active_bd_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, active_bd_list=active_bd_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_active_vlan_list_get(self, show_cluster=None, active_vlan_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type active_vlan_list: vlan_id
    :param active_vlan_list: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **active_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster.active_vlan_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.active_vlan_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.active_vlan_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'active_vlan_list', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, active_vlan_list=active_vlan_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, active_vlan_list=active_vlan_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_bd_list_get(self, show_cluster=None, bd_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_list: bd_id
    :param bd_list: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bd_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster.bd_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.bd_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.bd_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_list', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, bd_list=bd_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, bd_list=bd_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_get(self, show_cluster=None, client_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', u'config_vlans'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', u'config_vlans'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', u'config_vlans')]
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_info_list', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_client_esi_get(self, show_cluster=None, client_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', u'config_vlans'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', u'config_vlans'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', u'config_vlans')]
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_info_list', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_client_interface_get(self, show_cluster=None, client_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', u'config_vlans'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', u'config_vlans'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', u'config_vlans')]
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_info_list', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_client_name_get(self, show_cluster=None, client_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', u'config_vlans'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', u'config_vlans'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', u'config_vlans')]
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_info_list', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_client_state_get(self, show_cluster=None, client_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', u'config_vlans'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', u'config_vlans'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', u'config_vlans')]
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_info_list', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_config_bds_get(self, show_cluster=None, client_info_list=None, config_bds=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_bds: bd_id
    :param config_bds: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **config_bds** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', u'client_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', u'client_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list.config_bds', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list.config_bds', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list.config_bds', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id, client_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id, client_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_bds', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list, config_bds=config_bds)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list, config_bds=config_bds)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_config_vlans_get(self, show_cluster=None, client_info_list=None, config_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_vlans: vlan_id
    :param config_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **config_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', u'client_info_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', u'client_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list.config_vlans', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list.config_vlans', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list.config_vlans', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id, client_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id, client_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_vlans', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list, config_vlans=config_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list, config_vlans=config_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_num_config_bds_get(self, show_cluster=None, client_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', u'config_vlans'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', u'config_vlans'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', u'config_vlans')]
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_info_list', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_client_info_list_num_config_vlans_get(self, show_cluster=None, client_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_info_list: cluster_id, client_id
    :param client_info_list: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **client_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', u'config_vlans'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster.client_info_list', u'config_vlans'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', u'config_bds'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.client_info_list', u'config_vlans')]
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_info_list', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, client_info_list=client_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, client_info_list=client_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_client_interfaces_shutdown_get(self, show_cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_client_isolation_status_get(self, show_cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_cluster_name_get(self, show_cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_cluster_status_get(self, show_cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_config_vlan_list_get(self, show_cluster=None, config_vlan_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_vlan_list: vlan_id
    :param config_vlan_list: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **config_vlan_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster.config_vlan_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.config_vlan_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.config_vlan_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_vlan_list', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, config_vlan_list=config_vlan_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, config_vlan_list=config_vlan_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_control_vlan_get(self, show_cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'peer_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_df_hold_time_get(self, show_cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'peer_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_is_cluster_all_command_get(self, show_cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'peer_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_is_cluster_client_command_get(self, show_cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_num_active_bds_get(self, show_cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_num_active_vlans_get(self, show_cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_num_bds_get(self, show_cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_num_clients_get(self, show_cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_num_config_vlans_get(self, show_cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_num_peers_get(self, show_cluster=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'active_vlan_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'peer_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'client_info_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'config_vlan_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'bd_list'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'active_vlan_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'peer_ip_addr, peer_state, peer_interface'}, {'leafval': 'client_name, cluster_id, client_id, client_esi, client_interface, client_state, num_config_vlans, num_config_bds'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_peer_info_list_get(self, show_cluster=None, peer_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type peer_info_list: peer_ip_addr
    :param peer_info_list: Keyword argument tuple.

    :type peer_ip_addr: long
    :param peer_ip_addr: **peer_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster.peer_info_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.peer_info_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.peer_info_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer_info_list', 'keyval': 'peer_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, peer_info_list=peer_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, peer_info_list=peer_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_peer_info_list_peer_interface_get(self, show_cluster=None, peer_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type peer_info_list: peer_ip_addr
    :param peer_info_list: Keyword argument tuple.

    :type peer_ip_addr: long
    :param peer_ip_addr: **peer_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster.peer_info_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.peer_info_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.peer_info_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer_info_list', 'keyval': 'peer_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, peer_info_list=peer_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, peer_info_list=peer_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mct_state_show_cluster_peer_info_list_peer_state_get(self, show_cluster=None, peer_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster: cluster_id
    :param show_cluster: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type peer_info_list: peer_ip_addr
    :param peer_info_list: Keyword argument tuple.

    :type peer_ip_addr: long
    :param peer_ip_addr: **peer_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster', u'show_cluster'), ('pybind.slxos.v17r_1_01a.mct_state.show_cluster', u'show_cluster')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mct_state.show_cluster.peer_info_list', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mct_state.show_cluster.peer_info_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mct_state.show_cluster.peer_info_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer_info_list', 'keyval': 'peer_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster=show_cluster, peer_info_list=peer_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster=show_cluster, peer_info_list=peer_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mctd_client_state_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mctd_client_state_state', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state', u'show_cluster_mctd_client'), ('pybind.slxos.v17r_1_01a.mctd_client_state_state', u'show_cluster_mem_vlan'), ('pybind.slxos.v17s_1_02.mctd_client_state_state', u'show_cluster_mctd_client')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cluster_id, num_clients'}, {'leafval': 'cluster_id, num_vlans'}, {'leafval': 'cluster_id, num_clients, tunnel_type, tunnel_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_get(self, show_cluster_mctd_client=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client', u'client_state_info'), ('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client', u'client_state_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster_mctd_client', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'client_name, client_id, local_state, remote_state, local_esi_label, remote_esi_label'}, {'leafval': 'client_name, client_id, local_state, remote_state, local_esi_label, remote_esi_label'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client": {}, "pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client": {"cluster_id": "cluster_id", "num_clients": "num_clients"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_client_state_info_get(self, show_cluster_mctd_client=None, client_state_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_state_info: client_id
    :param client_state_info: Keyword argument tuple.

    :type client_id: long
    :param client_id: **client_state_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client'), ('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_state_info', 'keyval': 'client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client, client_state_info=client_state_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client, client_state_info=client_state_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_client_state_info_client_name_get(self, show_cluster_mctd_client=None, client_state_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_state_info: client_id
    :param client_state_info: Keyword argument tuple.

    :type client_id: long
    :param client_id: **client_state_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client'), ('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_state_info', 'keyval': 'client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client, client_state_info=client_state_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client, client_state_info=client_state_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_client_state_info_local_esi_label_get(self, show_cluster_mctd_client=None, client_state_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_state_info: client_id
    :param client_state_info: Keyword argument tuple.

    :type client_id: long
    :param client_id: **client_state_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client'), ('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_state_info', 'keyval': 'client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client, client_state_info=client_state_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client, client_state_info=client_state_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_client_state_info_local_state_get(self, show_cluster_mctd_client=None, client_state_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_state_info: client_id
    :param client_state_info: Keyword argument tuple.

    :type client_id: long
    :param client_id: **client_state_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client'), ('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_state_info', 'keyval': 'client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client, client_state_info=client_state_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client, client_state_info=client_state_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_client_state_info_remote_esi_label_get(self, show_cluster_mctd_client=None, client_state_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_state_info: client_id
    :param client_state_info: Keyword argument tuple.

    :type client_id: long
    :param client_id: **client_state_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client'), ('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_state_info', 'keyval': 'client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client, client_state_info=client_state_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client, client_state_info=client_state_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_client_state_info_remote_state_get(self, show_cluster_mctd_client=None, client_state_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_state_info: client_id
    :param client_state_info: Keyword argument tuple.

    :type client_id: long
    :param client_id: **client_state_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client'), ('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client', u'show_cluster_mctd_client')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client.client_state_info', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}, {'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_state_info', 'keyval': 'client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client, client_state_info=client_state_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client, client_state_info=client_state_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_num_clients_get(self, show_cluster_mctd_client=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client', u'client_state_info'), ('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mctd_client', u'client_state_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster_mctd_client', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'client_name, client_id, local_state, remote_state, local_esi_label, remote_esi_label'}, {'leafval': 'client_name, client_id, local_state, remote_state, local_esi_label, remote_esi_label'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_tunnel_status_get(self, show_cluster_mctd_client=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client', u'client_state_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster_mctd_client', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'client_name, client_id, local_state, remote_state, local_esi_label, remote_esi_label'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mctd_client_tunnel_type_get(self, show_cluster_mctd_client=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_mctd_client: cluster_id
    :param show_cluster_mctd_client: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mctd_client** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mctd_client_state_state.show_cluster_mctd_client', u'client_state_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster_mctd_client', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'client_name, client_id, local_state, remote_state, local_esi_label, remote_esi_label'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mctd_client=show_cluster_mctd_client)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mctd_client=show_cluster_mctd_client)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mem_vlan_get(self, show_cluster_mem_vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mem_vlan', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mem_vlan', u'vlan_label_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster_mem_vlan', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id, mcast_label_local, mcast_label_remote'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mem_vlan_num_vlans_get(self, show_cluster_mem_vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mem_vlan', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mem_vlan', u'vlan_label_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'show_cluster_mem_vlan', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id, mcast_label_local, mcast_label_remote'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mem_vlan_vlan_label_info_get(self, show_cluster_mem_vlan=None, vlan_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan_label_info: vlan_id
    :param vlan_label_info: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mem_vlan', u'show_cluster_mem_vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mem_vlan.vlan_label_info', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_label_info', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan, vlan_label_info=vlan_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan, vlan_label_info=vlan_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mem_vlan_vlan_label_info_mcast_label_local_get(self, show_cluster_mem_vlan=None, vlan_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan_label_info: vlan_id
    :param vlan_label_info: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mem_vlan', u'show_cluster_mem_vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mem_vlan.vlan_label_info', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_label_info', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan, vlan_label_info=vlan_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan, vlan_label_info=vlan_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mctd_client_state_state_show_cluster_mem_vlan_vlan_label_info_mcast_label_remote_get(self, show_cluster_mem_vlan=None, vlan_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_vlan: cluster_id
    :param show_cluster_mem_vlan: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan_label_info: vlan_id
    :param vlan_label_info: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mem_vlan', u'show_cluster_mem_vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mctd_client_state_state.show_cluster_mem_vlan.vlan_label_info', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_label_info', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan=show_cluster_mem_vlan, vlan_label_info=vlan_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan=show_cluster_mem_vlan, vlan_label_info=vlan_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mem_state', u'summary'), ('pybind.slxos.v17r_2_00.mem_state', u'mem_list'), ('pybind.slxos.v17r_2_00.mem_state.mem_list', u'memory_per_process'), ('pybind.slxos.v17r_1_01a.mem_state', u'summary'), ('pybind.slxos.v17r_1_01a.mem_state', u'mem_list'), ('pybind.slxos.v17r_1_01a.mem_state.mem_list', u'memory_per_process')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'memory_used_percentage, memory_total, memory_total_used, memory_total_free, memory_low_free, memory_high_free, memory_cached'}, {'leafval': 'memory_used_percentage, memory_total, memory_total_used, memory_total_free, memory_low_free, memory_high_free, memory_cached'}, {'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}, {'leafval': 'memory_used_percentage, memory_total, memory_total_used, memory_total_free, memory_low_free, memory_high_free, memory_cached'}, {'leafval': 'memory_used_percentage, memory_total, memory_total_used, memory_total_free, memory_low_free, memory_high_free, memory_cached'}, {'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_mem_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.mem_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.mem_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mem_state.mem_list', u'memory_per_process'), ('pybind.slxos.v17r_1_01a.mem_state.mem_list', u'memory_per_process')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}, {'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_mem_list_memory_cached_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.mem_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.mem_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mem_state.mem_list', u'memory_per_process'), ('pybind.slxos.v17r_1_01a.mem_state.mem_list', u'memory_per_process')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}, {'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_mem_list_memory_high_free_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.mem_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.mem_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mem_state.mem_list', u'memory_per_process'), ('pybind.slxos.v17r_1_01a.mem_state.mem_list', u'memory_per_process')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}, {'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_mem_list_memory_low_free_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.mem_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.mem_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mem_state.mem_list', u'memory_per_process'), ('pybind.slxos.v17r_1_01a.mem_state.mem_list', u'memory_per_process')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}, {'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_mem_list_memory_per_process_get(self, memory_per_process=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type memory_per_process: memory_process_id
    :param memory_per_process: Keyword argument tuple.

    :type memory_process_id: long
    :param memory_process_id: **memory_per_process** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.mem_list.memory_per_process', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.mem_list.memory_per_process', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'memory_per_process', 'keyval': 'memory_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, memory_per_process=memory_per_process)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, memory_per_process=memory_per_process)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_mem_list_memory_per_process_memory_process_name_get(self, memory_per_process=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type memory_per_process: memory_process_id
    :param memory_per_process: Keyword argument tuple.

    :type memory_process_id: long
    :param memory_process_id: **memory_per_process** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.mem_list.memory_per_process', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.mem_list.memory_per_process', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'memory_per_process', 'keyval': 'memory_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, memory_per_process=memory_per_process)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, memory_per_process=memory_per_process)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_mem_list_memory_per_process_memory_utilized_get(self, memory_per_process=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type memory_per_process: memory_process_id
    :param memory_per_process: Keyword argument tuple.

    :type memory_process_id: long
    :param memory_process_id: **memory_per_process** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.mem_list.memory_per_process', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.mem_list.memory_per_process', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'memory_per_process', 'keyval': 'memory_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, memory_per_process=memory_per_process)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, memory_per_process=memory_per_process)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_mem_list_memory_per_process_memory_utilized_pss_get(self, memory_per_process=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type memory_per_process: memory_process_id
    :param memory_per_process: Keyword argument tuple.

    :type memory_process_id: long
    :param memory_process_id: **memory_per_process** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.mem_list.memory_per_process', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.mem_list.memory_per_process', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'memory_per_process', 'keyval': 'memory_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, memory_per_process=memory_per_process)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, memory_per_process=memory_per_process)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_mem_list_memory_per_process_memory_utilized_rss_get(self, memory_per_process=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type memory_per_process: memory_process_id
    :param memory_per_process: Keyword argument tuple.

    :type memory_process_id: long
    :param memory_process_id: **memory_per_process** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.mem_list.memory_per_process', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.mem_list.memory_per_process', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'memory_per_process', 'keyval': 'memory_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, memory_per_process=memory_per_process)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, memory_per_process=memory_per_process)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_mem_list_memory_per_process_memory_utilized_vsize_get(self, memory_per_process=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type memory_per_process: memory_process_id
    :param memory_per_process: Keyword argument tuple.

    :type memory_process_id: long
    :param memory_process_id: **memory_per_process** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.mem_list.memory_per_process', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.mem_list.memory_per_process', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'memory_per_process', 'keyval': 'memory_process_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, memory_per_process=memory_per_process)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, memory_per_process=memory_per_process)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_mem_list_memory_total_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.mem_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.mem_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mem_state.mem_list', u'memory_per_process'), ('pybind.slxos.v17r_1_01a.mem_state.mem_list', u'memory_per_process')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}, {'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_mem_list_memory_total_free_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.mem_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.mem_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mem_state.mem_list', u'memory_per_process'), ('pybind.slxos.v17r_1_01a.mem_state.mem_list', u'memory_per_process')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}, {'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_mem_list_memory_total_used_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.mem_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.mem_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mem_state.mem_list', u'memory_per_process'), ('pybind.slxos.v17r_1_01a.mem_state.mem_list', u'memory_per_process')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}, {'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_mem_list_memory_used_percentage_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.mem_list', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.mem_list', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mem_state.mem_list', u'memory_per_process'), ('pybind.slxos.v17r_1_01a.mem_state.mem_list', u'memory_per_process')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}, {'leafval': 'memory_process_id, memory_process_name, memory_utilized, memory_utilized_vsize, memory_utilized_rss, memory_utilized_pss'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_summary_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.summary', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.summary', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_summary_memory_cached_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.summary', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.summary', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_summary_memory_high_free_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.summary', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.summary', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_summary_memory_low_free_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.summary', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.summary', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_summary_memory_total_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.summary', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.summary', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_summary_memory_total_free_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.summary', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.summary', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_summary_memory_total_used_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.summary', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.summary', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mem_state_summary_memory_used_percentage_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mem_state.summary', 'pybind.slxos.v17r_1_01a.brocade_RAS_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mem_state.summary', 'pybind.slxos.v17r_2_00.brocade_RAS_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mgmt_cluster_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mgmt_cluster', 'pybind.slxos.v17r_2_00.brocade_cluster', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mgmt_cluster', 'pybind.slxos.v17s_1_02.brocade_cluster', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17s_1_02.mgmt_cluster.cluster.management.virtual.ip', u'address'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ipv6', u'address'), ('pybind.slxos.v17r_2_00.mgmt_cluster.cluster.management.virtual.ip', u'address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6address'}, {'leafval': 'address'}, {'leafval': 'ipv6address'}, {'leafval': 'address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mld_snooping_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.mld_snooping', 'pybind.nos.v6_0_2f.brocade_mld_snooping', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.mld_snooping', 'pybind.nos.v7_2_0.brocade_mld_snooping', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mld_snooping', 'pybind.slxos.v17r_1_01a.brocade_mld_snooping', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mld_snooping', 'pybind.slxos.v17r_2_00.brocade_mld_snooping', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mld_snooping', 'pybind.slxos.v17s_1_02.brocade_mld_snooping', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.mld_snooping.ipv6.pim', u'snooping'), ('pybind.nos.v7_2_0.mld_snooping.ipv6.mld', u'snooping'), ('pybind.slxos.v17s_1_02.mld_snooping.ipv6.pim', u'snooping'), ('pybind.slxos.v17s_1_02.mld_snooping.ipv6.mld', u'snooping'), ('pybind.nos.v6_0_2f.mld_snooping.ipv6.mld', u'snooping'), ('pybind.slxos.v17r_1_01a.mld_snooping.ipv6.pim', u'snooping'), ('pybind.slxos.v17r_1_01a.mld_snooping.ipv6.mld', u'snooping'), ('pybind.slxos.v17r_2_00.mld_snooping.ipv6.pim', u'snooping'), ('pybind.slxos.v17r_2_00.mld_snooping.ipv6.mld', u'snooping')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'pimv6_enable'}, {'leafval': 'enable'}, {'leafval': 'pimv6_enable'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'pimv6_enable'}, {'leafval': 'enable'}, {'leafval': 'pimv6_enable'}, {'leafval': 'enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def monitor_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.monitor', 'pybind.nos.v6_0_2f.brocade_span', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.monitor', 'pybind.nos.v7_2_0.brocade_span', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.monitor', 'pybind.slxos.v17r_1_01a.brocade_span', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.monitor', 'pybind.slxos.v17r_2_00.brocade_span', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.monitor', 'pybind.slxos.v17s_1_02.brocade_span', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.monitor', u'session'), ('pybind.slxos.v17s_1_02.monitor', u'session'), ('pybind.nos.v6_0_2f.monitor', u'session'), ('pybind.slxos.v17r_2_00.monitor', u'session'), ('pybind.nos.v7_2_0.monitor', u'session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'session_number, description'}, {'leafval': 'session_number, description'}, {'leafval': 'session_number, description'}, {'leafval': 'session_number, description'}, {'leafval': 'session_number, description'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def monitor_session_get(self, session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.monitor.session', 'pybind.nos.v6_0_2f.brocade_span', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.monitor.session', 'pybind.nos.v7_2_0.brocade_span', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.monitor.session', 'pybind.slxos.v17r_1_01a.brocade_span', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.monitor.session', 'pybind.slxos.v17r_2_00.brocade_span', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.monitor.session', 'pybind.slxos.v17s_1_02.brocade_span', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.monitor.session', u'span_command'), ('pybind.slxos.v17r_2_00.monitor.session', u'span_command'), ('pybind.nos.v6_0_2f.monitor.session', u'span_command'), ('pybind.slxos.v17s_1_02.monitor.session', u'span_command'), ('pybind.nos.v7_2_0.monitor.session', u'span_command')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'session', 'keyval': 'session_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'source, src_ethernet, src_ethernet_val, destination, dest_ethernet, dest_ethernet_val, dest_vlan_val, dest_port_channel_val, direction'}, {'leafval': 'source, src_ethernet, src_ethernet_val, destination, dest_ethernet, dest_ethernet_val, dest_vlan_val, dest_port_channel_val, direction'}, {'leafval': 'source, src_tengigabitethernet, src_tengigabitethernet_val, destination, dest_tengigabitethernet, dest_tengigabitethernet_val, dest_vlan_val, direction'}, {'leafval': 'source, src_ethernet, src_ethernet_val, destination, dest_ethernet, dest_ethernet_val, dest_vlan_val, dest_port_channel_val, direction'}, {'leafval': 'source, src_tengigabitethernet, src_tengigabitethernet_val, destination, dest_tengigabitethernet, dest_tengigabitethernet_val, dest_vlan_val, direction'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def monitor_session_description_get(self, session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.monitor.session', 'pybind.nos.v6_0_2f.brocade_span', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.monitor.session', 'pybind.nos.v7_2_0.brocade_span', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.monitor.session', 'pybind.slxos.v17r_1_01a.brocade_span', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.monitor.session', 'pybind.slxos.v17r_2_00.brocade_span', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.monitor.session', 'pybind.slxos.v17s_1_02.brocade_span', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.monitor.session', u'span_command'), ('pybind.slxos.v17r_2_00.monitor.session', u'span_command'), ('pybind.nos.v6_0_2f.monitor.session', u'span_command'), ('pybind.slxos.v17s_1_02.monitor.session', u'span_command'), ('pybind.nos.v7_2_0.monitor.session', u'span_command')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'session', 'keyval': 'session_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'source, src_ethernet, src_ethernet_val, destination, dest_ethernet, dest_ethernet_val, dest_vlan_val, dest_port_channel_val, direction'}, {'leafval': 'source, src_ethernet, src_ethernet_val, destination, dest_ethernet, dest_ethernet_val, dest_vlan_val, dest_port_channel_val, direction'}, {'leafval': 'source, src_tengigabitethernet, src_tengigabitethernet_val, destination, dest_tengigabitethernet, dest_tengigabitethernet_val, dest_vlan_val, direction'}, {'leafval': 'source, src_ethernet, src_ethernet_val, destination, dest_ethernet, dest_ethernet_val, dest_vlan_val, dest_port_channel_val, direction'}, {'leafval': 'source, src_tengigabitethernet, src_tengigabitethernet_val, destination, dest_tengigabitethernet, dest_tengigabitethernet_val, dest_vlan_val, direction'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def monitor_session_dest_ethernet_get(self, session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument:  NUMBER:1-512;;Session_Id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.monitor.session', u'session'), ('pybind.slxos.v17r_1_01a.monitor.session', u'session'), ('pybind.slxos.v17s_1_02.monitor.session', u'session')]
    bindings_list = [('pybind.slxos.v17r_1_01a.monitor.session.span_command', 'pybind.slxos.v17r_1_01a.brocade_span', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.monitor.session.span_command', 'pybind.slxos.v17r_2_00.brocade_span', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.monitor.session.span_command', 'pybind.slxos.v17s_1_02.brocade_span', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def monitor_session_dest_ethernet_val_get(self, session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument:  NUMBER:1-512;;Session_Id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.monitor.session', u'session'), ('pybind.slxos.v17r_1_01a.monitor.session', u'session'), ('pybind.slxos.v17s_1_02.monitor.session', u'session')]
    bindings_list = [('pybind.slxos.v17r_1_01a.monitor.session.span_command', 'pybind.slxos.v17r_1_01a.brocade_span', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.monitor.session.span_command', 'pybind.slxos.v17r_2_00.brocade_span', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.monitor.session.span_command', 'pybind.slxos.v17s_1_02.brocade_span', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def monitor_session_dest_port_channel_val_get(self, session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument:  NUMBER:1-512;;Session_Id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.monitor.session', u'session'), ('pybind.slxos.v17r_1_01a.monitor.session', u'session'), ('pybind.slxos.v17s_1_02.monitor.session', u'session')]
    bindings_list = [('pybind.slxos.v17r_1_01a.monitor.session.span_command', 'pybind.slxos.v17r_1_01a.brocade_span', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.monitor.session.span_command', 'pybind.slxos.v17r_2_00.brocade_span', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.monitor.session.span_command', 'pybind.slxos.v17s_1_02.brocade_span', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def monitor_session_dest_tengigabitethernet_get(self, session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.monitor.session', u'session'), ('pybind.nos.v7_2_0.monitor.session', u'session')]
    bindings_list = [('pybind.nos.v6_0_2f.monitor.session.span_command', 'pybind.nos.v6_0_2f.brocade_span', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.monitor.session.span_command', 'pybind.nos.v7_2_0.brocade_span', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def monitor_session_dest_tengigabitethernet_val_get(self, session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.monitor.session', u'session'), ('pybind.nos.v7_2_0.monitor.session', u'session')]
    bindings_list = [('pybind.nos.v6_0_2f.monitor.session.span_command', 'pybind.nos.v6_0_2f.brocade_span', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.monitor.session.span_command', 'pybind.nos.v7_2_0.brocade_span', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def monitor_session_dest_vlan_val_get(self, session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.monitor.session', u'session'), ('pybind.nos.v6_0_2f.monitor.session', u'session'), ('pybind.slxos.v17r_1_01a.monitor.session', u'session'), ('pybind.slxos.v17s_1_02.monitor.session', u'session'), ('pybind.nos.v7_2_0.monitor.session', u'session')]
    bindings_list = [('pybind.nos.v6_0_2f.monitor.session.span_command', 'pybind.nos.v6_0_2f.brocade_span', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.monitor.session.span_command', 'pybind.nos.v7_2_0.brocade_span', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.monitor.session.span_command', 'pybind.slxos.v17r_1_01a.brocade_span', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.monitor.session.span_command', 'pybind.slxos.v17r_2_00.brocade_span', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.monitor.session.span_command', 'pybind.slxos.v17s_1_02.brocade_span', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def monitor_session_destination_get(self, session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.monitor.session', u'session'), ('pybind.nos.v6_0_2f.monitor.session', u'session'), ('pybind.slxos.v17r_1_01a.monitor.session', u'session'), ('pybind.slxos.v17s_1_02.monitor.session', u'session'), ('pybind.nos.v7_2_0.monitor.session', u'session')]
    bindings_list = [('pybind.nos.v6_0_2f.monitor.session.span_command', 'pybind.nos.v6_0_2f.brocade_span', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.monitor.session.span_command', 'pybind.nos.v7_2_0.brocade_span', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.monitor.session.span_command', 'pybind.slxos.v17r_1_01a.brocade_span', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.monitor.session.span_command', 'pybind.slxos.v17r_2_00.brocade_span', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.monitor.session.span_command', 'pybind.slxos.v17s_1_02.brocade_span', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def monitor_session_direction_get(self, session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.monitor.session', u'session'), ('pybind.nos.v6_0_2f.monitor.session', u'session'), ('pybind.slxos.v17r_1_01a.monitor.session', u'session'), ('pybind.slxos.v17s_1_02.monitor.session', u'session'), ('pybind.nos.v7_2_0.monitor.session', u'session')]
    bindings_list = [('pybind.nos.v6_0_2f.monitor.session.span_command', 'pybind.nos.v6_0_2f.brocade_span', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.monitor.session.span_command', 'pybind.nos.v7_2_0.brocade_span', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.monitor.session.span_command', 'pybind.slxos.v17r_1_01a.brocade_span', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.monitor.session.span_command', 'pybind.slxos.v17r_2_00.brocade_span', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.monitor.session.span_command', 'pybind.slxos.v17s_1_02.brocade_span', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def monitor_session_source_get(self, session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.monitor.session', u'session'), ('pybind.nos.v6_0_2f.monitor.session', u'session'), ('pybind.slxos.v17r_1_01a.monitor.session', u'session'), ('pybind.slxos.v17s_1_02.monitor.session', u'session'), ('pybind.nos.v7_2_0.monitor.session', u'session')]
    bindings_list = [('pybind.nos.v6_0_2f.monitor.session.span_command', 'pybind.nos.v6_0_2f.brocade_span', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.monitor.session.span_command', 'pybind.nos.v7_2_0.brocade_span', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.monitor.session.span_command', 'pybind.slxos.v17r_1_01a.brocade_span', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.monitor.session.span_command', 'pybind.slxos.v17r_2_00.brocade_span', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.monitor.session.span_command', 'pybind.slxos.v17s_1_02.brocade_span', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def monitor_session_src_ethernet_get(self, session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument:  NUMBER:1-512;;Session_Id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.monitor.session', u'session'), ('pybind.slxos.v17r_1_01a.monitor.session', u'session'), ('pybind.slxos.v17s_1_02.monitor.session', u'session')]
    bindings_list = [('pybind.slxos.v17r_1_01a.monitor.session.span_command', 'pybind.slxos.v17r_1_01a.brocade_span', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.monitor.session.span_command', 'pybind.slxos.v17r_2_00.brocade_span', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.monitor.session.span_command', 'pybind.slxos.v17s_1_02.brocade_span', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def monitor_session_src_ethernet_val_get(self, session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument:  NUMBER:1-512;;Session_Id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.monitor.session', u'session'), ('pybind.slxos.v17r_1_01a.monitor.session', u'session'), ('pybind.slxos.v17s_1_02.monitor.session', u'session')]
    bindings_list = [('pybind.slxos.v17r_1_01a.monitor.session.span_command', 'pybind.slxos.v17r_1_01a.brocade_span', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.monitor.session.span_command', 'pybind.slxos.v17r_2_00.brocade_span', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.monitor.session.span_command', 'pybind.slxos.v17s_1_02.brocade_span', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def monitor_session_src_tengigabitethernet_get(self, session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.monitor.session', u'session'), ('pybind.nos.v7_2_0.monitor.session', u'session')]
    bindings_list = [('pybind.nos.v6_0_2f.monitor.session.span_command', 'pybind.nos.v6_0_2f.brocade_span', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.monitor.session.span_command', 'pybind.nos.v7_2_0.brocade_span', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def monitor_session_src_tengigabitethernet_val_get(self, session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type session: session_number
    :param session: Keyword argument tuple.

    :type session_number: long
    :param session_number: **session** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.monitor.session', u'session'), ('pybind.nos.v7_2_0.monitor.session', u'session')]
    bindings_list = [('pybind.nos.v6_0_2f.monitor.session.span_command', 'pybind.nos.v6_0_2f.brocade_span', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.monitor.session.span_command', 'pybind.nos.v7_2_0.brocade_span', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'session_number', 'extra_keyval': ''}, {'keyval': 'session_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, session=session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, session=session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'bypass_lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'lsp_xc_traps'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'autobw_template'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'cspf_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'bypass_lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'policy'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'lsp_xc_traps'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'rsvp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'autobw_template'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'cspf_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'bypass_lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'lsp_xc_traps'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'policy'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'cspf_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'autobw_template'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'lsp_name, lsp_dest_address, lsp_cspf, lsp_ipmtu, lsp_metric, lsp_revert_timer, lsp_tie_breaking, lsp_src_address, lsp_primary_path, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, lsp_soft_preemption, lsp_enable'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'interface_type, interface_name, mpls_interface_ldp_enable'}, {'leafval': 'bypass_lsp_name, bypass_lsp_dest_address, bypass_lsp_src_address, bypass_lsp_tie_breaking, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, bypass_lsp_primary_path, bypass_lsp_enable'}, {'leafval': 'refresh_interval, refresh_multiple, global_rsvp_hello_acknowledgements, global_rsvp_hello_unprioritize, g_rsvp_backup_bw_guarantee, delay_resv_send'}, {'leafval': 'lsp_xc_traps_enable'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'autobw_template_name, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'cspf_group_name'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'path_name'}, {'leafval': 'backup_retry_time, cspf_interface_constraint, handle_isis_neighbor_down, handle_ospf_neighbor_down, load_interval, retry_time, retry_limit, rapid_retry, rsvp_periodic_flooding_time, qos_ttl_mode, ingress_tunnel_accounting, transit_session_accounting'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'add_penalty'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'path_name'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'isis_set_level'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'add_penalty'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'lsp_name, lsp_dest_address, lsp_cspf, lsp_ipmtu, lsp_metric, lsp_revert_timer, lsp_tie_breaking, lsp_src_address, lsp_primary_path, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, lsp_soft_preemption, lsp_enable'}, {'leafval': 'bypass_lsp_name, bypass_lsp_dest_address, bypass_lsp_src_address, bypass_lsp_tie_breaking, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, bypass_lsp_primary_path, bypass_lsp_enable'}, {'leafval': 'backup_retry_time, cspf_interface_constraint, handle_isis_neighbor_down, handle_ospf_neighbor_down, load_interval, retry_time, retry_limit, rapid_retry, rsvp_periodic_flooding_time, qos_ttl_mode, ingress_tunnel_accounting, transit_session_accounting'}, {'leafval': 'lsp_xc_traps_enable'}, {'leafval': 'refresh_interval, refresh_multiple, global_rsvp_hello_acknowledgements, global_rsvp_hello_unprioritize, g_rsvp_backup_bw_guarantee'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'interface_type, interface_name, mpls_interface_ldp_enable'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'autobw_template_name, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'cspf_group_name'}, {'leafval': 'bypass_lsp_name, bypass_lsp_dest_address, bypass_lsp_src_address, bypass_lsp_tie_breaking, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, bypass_lsp_primary_path, bypass_lsp_enable'}, {'leafval': 'lsp_xc_traps_enable'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'interface_type, interface_name, mpls_interface_ldp_enable'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'add_penalty'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'backup_retry_time, cspf_interface_constraint, handle_isis_neighbor_down, handle_ospf_neighbor_down, load_interval, retry_time, retry_limit, rapid_retry, rsvp_periodic_flooding_time, qos_ttl_mode, ingress_tunnel_accounting, transit_session_accounting, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'cspf_group_name'}, {'leafval': 'lsp_name, lsp_dest_address, lsp_cspf, lsp_ipmtu, lsp_metric, lsp_revert_timer, lsp_tie_breaking, lsp_src_address, lsp_primary_path, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, lsp_soft_preemption, lsp_enable'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_template_name, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'refresh_interval, refresh_multiple, global_rsvp_hello_acknowledgements, global_rsvp_hello_unprioritize, g_rsvp_backup_bw_guarantee, delay_resv_send'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'path_name'}, {'leafval': 'bundle_send_delay'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17s_1_02.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17s_1_02.mpls_state', u'route'), ('pybind.slxos.v17s_1_02.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17s_1_02.mpls_state.te', u'database'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17s_1_02.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17s_1_02.mpls_state', u'summary'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_neighbors', u'neighbor'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'prefix'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state', u'te'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17s_1_02.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_vcs'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17s_1_02.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_prefix_prefix'), ('pybind.slxos.v17s_1_02.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.te.database', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'ldp_out'), ('pybind.slxos.v17s_1_02.mpls_state', u'policy'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_vcid'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_summary'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs', u'vc'), ('pybind.slxos.v17s_1_02.mpls_state.memory', u'pools'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state', u'path'), ('pybind.slxos.v17s_1_02.mpls_state', u'rsvp'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_errors_instance_since_clear', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state', u'bfd'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17s_1_02.mpls_state', u'interface'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'key'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.memory', u'stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs', u'key'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_prefixes'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17s_1_02.mpls_state', u'memory'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_stats_instance_since_clear', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'path'), ('pybind.slxos.v17s_1_02.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'router_id'}, {'leafval': 'num_link_neighbors, num_targeted_neighbors'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'paths_configured, lsps_configured, lsps_enabled, lsps_operational, detour_lsps_up, backup_lsps_up, bypass_lsps, bypass_lsps_up, bypass_lsps_enabled, ldp_lsps_operational, transit_lsps_configured, transit_lsps_enabled, transit_lsps_operational, cspf_groups_configured, tunnels_supported, tunnels_allocated, cross_connects_supported, cross_connects_allocated, auto_bw_templates_supported, auto_bw_templates_configured, times_enabled'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'tot_no_of_vc_fec, tot_no_of_vc_fec_installed'}, {'leafval': 'ldp_database_peer_ip, ldp_database_own_ip'}, {'leafval': 'in_label, protocol, statistics_valid'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'prefix, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_state, prefix_ingress, prefix_egress, prefix_um_dist_done, prefix_lwd, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'error_type, count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, propagate_ttl, label_propagate_ttl, vrf_propagate_ttl, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'vc_id, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_state, prefix_ingress, prefix_egress, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'tot_no_of_prefix_fec, tot_no_of_prefix_fec_installed, tot_no_of_prefix_fec_filtered, tot_no_of_vc_fec_128, tot_no_of_vc_fec_129, tot_no_of_vc_fec_installed, tot_no_of_route_upd_proc_errors, tot_no_of_vc_fec_proc_errors'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'threshold_type'}, {'leafval': 'peer_id, peer_lblspc, state, vc_id, peer_vc_type, peer_fec_type, ingress, egress'}, {'leafval': 'pool_index'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'error_type, count'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'name, group_number'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}, {'leafval': 'prefix'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}, {'leafval': 'tot_no_of_prefix_fec, tot_no_of_prefix_fec_installed, tot_no_of_prefix_fec_filtered, tot_no_of_prefix_fec_lwd, filtered, prefix_filtered'}, {'leafval': 'if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'destination_route'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state": {}, "pybind.slxos.v17r_1_01a.mpls_state": {"cspf_groups_configured": "cspf_groups_configured", "lsps_enabled": "lsps_enabled", "paths_configured": "paths_configured", "lsps_configured": "lsps_configured", "bypass_lsps_enabled": "bypass_lsps_enabled", "tunnels_supported": "tunnels_supported", "cross_connects_allocated": "cross_connects_allocated", "bypass_lsps_up": "bypass_lsps_up", "detour_lsps_up": "detour_lsps_up", "cross_connects_supported": "cross_connects_supported", "times_enabled": "times_enabled", "transit_lsps_enabled": "transit_lsps_enabled", "transit_lsps_configured": "transit_lsps_configured", "lsps_operational": "lsps_operational", "auto_bw_templates_supported": "auto_bw_templates_supported", "bypass_lsps": "bypass_lsps", "backup_lsps_up": "backup_lsps_up", "ldp_lsps_operational": "ldp_lsps_operational", "auto_bw_templates_configured": "auto_bw_templates_configured", "tunnels_allocated": "tunnels_allocated", "transit_lsps_operational": "transit_lsps_operational"}, "pybind.slxos.v17r_2_00.mpls_state": {"cspf_groups_configured": "cspf_groups_configured", "lsps_enabled": "lsps_enabled", "paths_configured": "paths_configured", "lsps_configured": "lsps_configured", "bypass_lsps_enabled": "bypass_lsps_enabled", "tunnels_supported": "tunnels_supported", "cross_connects_allocated": "cross_connects_allocated", "bypass_lsps_up": "bypass_lsps_up", "detour_lsps_up": "detour_lsps_up", "cross_connects_supported": "cross_connects_supported", "times_enabled": "times_enabled", "transit_lsps_enabled": "transit_lsps_enabled", "transit_lsps_configured": "transit_lsps_configured", "lsps_operational": "lsps_operational", "auto_bw_templates_supported": "auto_bw_templates_supported", "bypass_lsps": "bypass_lsps", "backup_lsps_up": "backup_lsps_up", "ldp_lsps_operational": "ldp_lsps_operational", "auto_bw_templates_configured": "auto_bw_templates_configured", "tunnels_allocated": "tunnels_allocated", "transit_lsps_operational": "transit_lsps_operational"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_get(self, auto_bandwidth_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', u'associated_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_adjustment_interval_get(self, auto_bandwidth_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', u'associated_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_adjustment_threshold_get(self, auto_bandwidth_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', u'associated_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_associated_paths_get(self, auto_bandwidth_template=None, associated_paths=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type associated_paths: lsp_name
    :param associated_paths: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **associated_paths** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', u'auto_bandwidth_template'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', u'auto_bandwidth_template')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template.associated_paths', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template.associated_paths', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template.associated_paths', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'associated_paths', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template, associated_paths=associated_paths)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template, associated_paths=associated_paths)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_associated_paths_count_get(self, auto_bandwidth_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', u'associated_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_associated_paths_is_active_get(self, auto_bandwidth_template=None, associated_paths=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type associated_paths: lsp_name
    :param associated_paths: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **associated_paths** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', u'auto_bandwidth_template'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', u'auto_bandwidth_template')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template.associated_paths', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template.associated_paths', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template.associated_paths', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'associated_paths', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template, associated_paths=associated_paths)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template, associated_paths=associated_paths)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_associated_paths_path_name_get(self, auto_bandwidth_template=None, associated_paths=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type associated_paths: lsp_name
    :param associated_paths: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **associated_paths** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', u'auto_bandwidth_template'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', u'auto_bandwidth_template')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template.associated_paths', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template.associated_paths', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template.associated_paths', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'associated_paths', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template, associated_paths=associated_paths)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template, associated_paths=associated_paths)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_maximum_bandwidth_get(self, auto_bandwidth_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', u'associated_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_minimum_bandwidth_get(self, auto_bandwidth_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', u'associated_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_mode_get(self, auto_bandwidth_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', u'associated_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_overflow_limit_get(self, auto_bandwidth_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', u'associated_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_sample_recording_get(self, auto_bandwidth_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', u'associated_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_auto_bandwidth_template_underflow_limit_get(self, auto_bandwidth_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type auto_bandwidth_template: name
    :param auto_bandwidth_template: Keyword argument tuple.

    :type name: unicode
    :param name: **auto_bandwidth_template** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17r_2_00.mpls_state.auto_bandwidth_template', u'associated_paths'), ('pybind.slxos.v17s_1_02.mpls_state.auto_bandwidth_template', u'associated_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'auto_bandwidth_template', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}, {'leafval': 'lsp_name, path_name, is_active'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, auto_bandwidth_template=auto_bandwidth_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, auto_bandwidth_template=auto_bandwidth_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_auto_bw_templates_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_auto_bw_templates_supported_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_autobw_threshold_table_entry_get(self, autobw_threshold_table_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type autobw_threshold_table_entry: bandwidth
    :param autobw_threshold_table_entry: Keyword argument tuple.

    :type bandwidth: long
    :param bandwidth: **autobw_threshold_table_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.autobw_threshold_table_entry', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.autobw_threshold_table_entry', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.autobw_threshold_table_entry', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_threshold_table_entry', 'keyval': 'bandwidth', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_threshold_table_entry=autobw_threshold_table_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_threshold_table_entry=autobw_threshold_table_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_autobw_threshold_table_entry_is_percentage_threshold_get(self, autobw_threshold_table_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type autobw_threshold_table_entry: bandwidth
    :param autobw_threshold_table_entry: Keyword argument tuple.

    :type bandwidth: long
    :param bandwidth: **autobw_threshold_table_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.autobw_threshold_table_entry', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.autobw_threshold_table_entry', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.autobw_threshold_table_entry', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_threshold_table_entry', 'keyval': 'bandwidth', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_threshold_table_entry=autobw_threshold_table_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_threshold_table_entry=autobw_threshold_table_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_autobw_threshold_table_entry_threshold_get(self, autobw_threshold_table_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type autobw_threshold_table_entry: bandwidth
    :param autobw_threshold_table_entry: Keyword argument tuple.

    :type bandwidth: long
    :param bandwidth: **autobw_threshold_table_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.autobw_threshold_table_entry', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.autobw_threshold_table_entry', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.autobw_threshold_table_entry', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_threshold_table_entry', 'keyval': 'bandwidth', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_threshold_table_entry=autobw_threshold_table_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_threshold_table_entry=autobw_threshold_table_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_autobw_threshold_table_summary_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.autobw_threshold_table_summary', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.autobw_threshold_table_summary', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.autobw_threshold_table_summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_autobw_threshold_table_summary_total_number_of_autobw_threshold_table_entries_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.autobw_threshold_table_summary', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.autobw_threshold_table_summary', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.autobw_threshold_table_summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_backup_lsps_up_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_bfd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.bfd', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.bfd', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.bfd', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_bfd_admin_status_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.bfd', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.bfd', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.bfd', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_bfd_detection_time_multiplier_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.bfd', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.bfd', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.bfd', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_bfd_min_rx_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.bfd', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.bfd', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.bfd', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_bfd_min_tx_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.bfd', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.bfd', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.bfd', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_bypass_lsps_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_bypass_lsps_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_bypass_lsps_up_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_cross_connects_allocated_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_cross_connects_supported_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_cspf_groups_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_detour_lsps_up_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_global_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_global_bypass_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_global_config_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_global_config_enable_all_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_global_max_bypasses_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_global_max_bypasses_per_mp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_global_reoptimize_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_global', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"record_route": "record_route", "include_all": "include_all", "traffic_eng_max_burst": "traffic_eng_max_burst", "tie_breaking": "tie_breaking", "status_flags": "status_flags", "include_any": "include_any", "if_index": "if_index", "from_addr": "from_addr", "mp_count": "mp_count", "active_status": "active_status", "primary_path": "primary_path", "traffic_eng_mean_rate": "traffic_eng_mean_rate", "hold_priority": "hold_priority", "reoptimize_timer": "reoptimize_timer", "bypass_count": "bypass_count", "max_bypasses_per_mp": "max_bypasses_per_mp", "adaptive": "adaptive", "name_prefix": "name_prefix", "cspf_comp_mode": "cspf_comp_mode", "if_name": "if_name", "admin_status": "admin_status", "exclude_any": "exclude_any", "setup_priority": "setup_priority", "cos": "cos", "admin_type": "admin_type", "traffic_eng_max_rate": "traffic_eng_max_rate", "if_type": "if_type", "hop_limit": "hop_limit"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"record_route": "record_route", "include_all": "include_all", "traffic_eng_max_burst": "traffic_eng_max_burst", "tie_breaking": "tie_breaking", "status_flags": "status_flags", "include_any": "include_any", "if_index": "if_index", "from_addr": "from_addr", "mp_count": "mp_count", "active_status": "active_status", "primary_path": "primary_path", "traffic_eng_mean_rate": "traffic_eng_mean_rate", "hold_priority": "hold_priority", "reoptimize_timer": "reoptimize_timer", "bypass_count": "bypass_count", "max_bypasses_per_mp": "max_bypasses_per_mp", "adaptive": "adaptive", "name_prefix": "name_prefix", "cspf_comp_mode": "cspf_comp_mode", "if_name": "if_name", "admin_status": "admin_status", "exclude_any": "exclude_any", "setup_priority": "setup_priority", "cos": "cos", "admin_type": "admin_type", "traffic_eng_max_rate": "traffic_eng_max_rate", "if_type": "if_type", "hop_limit": "hop_limit"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_active_status_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"if_name": "if_name", "active_status": "active_status"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"if_name": "if_name", "active_status": "active_status"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_adaptive_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"adaptive": "adaptive", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"adaptive": "adaptive", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_admin_status_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"admin_status": "admin_status", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"admin_status": "admin_status", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_admin_type_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"admin_type": "admin_type", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"admin_type": "admin_type", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_bypass_count_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"bypass_count": "bypass_count", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"bypass_count": "bypass_count", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_cos_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"cos": "cos", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"cos": "cos", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_cspf_comp_mode_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"cspf_comp_mode": "cspf_comp_mode", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"cspf_comp_mode": "cspf_comp_mode", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_exclude_any_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"if_name": "if_name", "exclude_any": "exclude_any"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"if_name": "if_name", "exclude_any": "exclude_any"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_from_addr_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"if_name": "if_name", "from_addr": "from_addr"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"if_name": "if_name", "from_addr": "from_addr"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_hold_priority_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"hold_priority": "hold_priority", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"hold_priority": "hold_priority", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_hop_limit_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"hop_limit": "hop_limit", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"hop_limit": "hop_limit", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_if_index_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_if_type_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_include_all_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"include_all": "include_all", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"include_all": "include_all", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_include_any_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"include_any": "include_any", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"include_any": "include_any", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_max_bypasses_per_mp_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"max_bypasses_per_mp": "max_bypasses_per_mp", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"max_bypasses_per_mp": "max_bypasses_per_mp", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_mp_count_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"if_name": "if_name", "mp_count": "mp_count"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"if_name": "if_name", "mp_count": "mp_count"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_mp_infos_get(self, dynamic_bypass_interface=None, mp_infos=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mp_infos: router_id
    :param mp_infos: Keyword argument tuple.

    :type router_id: unicode
    :param router_id: **mp_infos** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'dynamic_bypass_interface'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'dynamic_bypass_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface.mp_infos', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface.mp_infos', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface.mp_infos', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'if_name', 'extra_keyval': ''}, {'keyval': 'if_name', 'extra_keyval': ''}, {'keyval': 'if_name, if_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mp_infos', 'keyval': 'router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface, mp_infos=mp_infos)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface, mp_infos=mp_infos)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_mp_infos_bypass_count_get(self, dynamic_bypass_interface=None, mp_infos=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type mp_infos: router_id
    :param mp_infos: Keyword argument tuple.

    :type router_id: unicode
    :param router_id: **mp_infos** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'dynamic_bypass_interface'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'dynamic_bypass_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface.mp_infos', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface.mp_infos', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface.mp_infos', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'if_name', 'extra_keyval': ''}, {'keyval': 'if_name', 'extra_keyval': ''}, {'keyval': 'if_name, if_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mp_infos', 'keyval': 'router_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface, mp_infos=mp_infos)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface, mp_infos=mp_infos)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_name_prefix_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"name_prefix": "name_prefix", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"name_prefix": "name_prefix", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_primary_path_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"primary_path": "primary_path", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"primary_path": "primary_path", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_record_route_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"record_route": "record_route", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"record_route": "record_route", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_reoptimize_timer_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"reoptimize_timer": "reoptimize_timer", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"reoptimize_timer": "reoptimize_timer", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_setup_priority_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"setup_priority": "setup_priority", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"setup_priority": "setup_priority", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_status_flags_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"if_name": "if_name", "status_flags": "status_flags"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"if_name": "if_name", "status_flags": "status_flags"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_tie_breaking_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"tie_breaking": "tie_breaking", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"tie_breaking": "tie_breaking", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_traffic_eng_max_burst_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"if_name": "if_name", "traffic_eng_max_burst": "traffic_eng_max_burst"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"if_name": "if_name", "traffic_eng_max_burst": "traffic_eng_max_burst"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_traffic_eng_max_rate_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"traffic_eng_max_rate": "traffic_eng_max_rate", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"traffic_eng_max_rate": "traffic_eng_max_rate", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_dynamic_bypass_dynamic_bypass_interface_traffic_eng_mean_rate_get(self, dynamic_bypass_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dynamic_bypass_interface: if_name
    :param dynamic_bypass_interface: Keyword argument tuple.

    :type if_name: unicode
    :param if_name: **dynamic_bypass_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos'), ('pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface', u'mp_infos')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dynamic_bypass_interface', 'keyval': 'if_name, if_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}, {'leafval': 'router_id, bypass_count'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.dynamic_bypass.dynamic_bypass_interface": {}, "pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"traffic_eng_mean_rate": "traffic_eng_mean_rate", "if_name": "if_name"}, "pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass.dynamic_bypass_interface": {"traffic_eng_mean_rate": "traffic_eng_mean_rate", "if_name": "if_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dynamic_bypass_interface=dynamic_bypass_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dynamic_bypass_interface=dynamic_bypass_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_forwarding_entry_get(self, forwarding_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type forwarding_entry: entry_index, sync_index
    :param forwarding_entry: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type sync_index: long
    :param sync_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.forwarding_entry', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.forwarding_entry', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.forwarding_entry', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'forwarding_entry', 'keyval': 'entry_index, sync_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, forwarding_entry=forwarding_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, forwarding_entry=forwarding_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_forwarding_entry_dest_ip_prefix_get(self, forwarding_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type forwarding_entry: entry_index, sync_index
    :param forwarding_entry: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type sync_index: long
    :param sync_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.forwarding_entry', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.forwarding_entry', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.forwarding_entry', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'forwarding_entry', 'keyval': 'entry_index, sync_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, forwarding_entry=forwarding_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, forwarding_entry=forwarding_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_forwarding_entry_in_label_get(self, forwarding_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type forwarding_entry: entry_index, sync_index
    :param forwarding_entry: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type sync_index: long
    :param sync_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.forwarding_entry', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.forwarding_entry', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.forwarding_entry', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'forwarding_entry', 'keyval': 'entry_index, sync_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, forwarding_entry=forwarding_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, forwarding_entry=forwarding_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_forwarding_entry_nexthop_ip_addr_get(self, forwarding_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type forwarding_entry: entry_index, sync_index
    :param forwarding_entry: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type sync_index: long
    :param sync_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.forwarding_entry', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.forwarding_entry', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.forwarding_entry', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'forwarding_entry', 'keyval': 'entry_index, sync_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, forwarding_entry=forwarding_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, forwarding_entry=forwarding_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_forwarding_entry_out_interface_name_get(self, forwarding_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type forwarding_entry: entry_index, sync_index
    :param forwarding_entry: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type sync_index: long
    :param sync_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.forwarding_entry', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.forwarding_entry', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.forwarding_entry', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'forwarding_entry', 'keyval': 'entry_index, sync_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, forwarding_entry=forwarding_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, forwarding_entry=forwarding_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_forwarding_entry_out_label_get(self, forwarding_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type forwarding_entry: entry_index, sync_index
    :param forwarding_entry: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type sync_index: long
    :param sync_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.forwarding_entry', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.forwarding_entry', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.forwarding_entry', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'forwarding_entry', 'keyval': 'entry_index, sync_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, forwarding_entry=forwarding_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, forwarding_entry=forwarding_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_forwarding_entry_protocol_get(self, forwarding_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type forwarding_entry: entry_index, sync_index
    :param forwarding_entry: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type sync_index: long
    :param sync_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.forwarding_entry', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.forwarding_entry', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.forwarding_entry', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'forwarding_entry', 'keyval': 'entry_index, sync_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, forwarding_entry=forwarding_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, forwarding_entry=forwarding_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_forwarding_entry_type_get(self, forwarding_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type forwarding_entry: entry_index, sync_index
    :param forwarding_entry: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type sync_index: long
    :param sync_index: **forwarding_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.forwarding_entry', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.forwarding_entry', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.forwarding_entry', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'forwarding_entry', 'keyval': 'entry_index, sync_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, forwarding_entry=forwarding_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, forwarding_entry=forwarding_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_admin_group_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.interface": {"admin_group": "admin_group"}, "pybind.slxos.v17r_2_00.mpls_state.interface": {"admin_group": "admin_group", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.interface": {"admin_group": "admin_group", "interface_name": "interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_admin_group_max_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.interface": {"admin_group_max": "admin_group_max"}, "pybind.slxos.v17r_2_00.mpls_state.interface": {"admin_group_max": "admin_group_max", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.interface": {"admin_group_max": "admin_group_max", "interface_name": "interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_admin_group_min_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.interface": {"admin_group_min": "admin_group_min"}, "pybind.slxos.v17r_2_00.mpls_state.interface": {"interface_name": "interface_name", "admin_group_min": "admin_group_min"}, "pybind.slxos.v17r_1_01a.mpls_state.interface": {"interface_name": "interface_name", "admin_group_min": "admin_group_min"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_admin_status_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.interface": {"admin_status": "admin_status"}, "pybind.slxos.v17r_2_00.mpls_state.interface": {"admin_status": "admin_status", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.interface": {"admin_status": "admin_status", "interface_name": "interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_bypass_lsp_count_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.interface": {"bypass_lsp_count": "bypass_lsp_count"}, "pybind.slxos.v17r_2_00.mpls_state.interface": {"interface_name": "interface_name", "bypass_lsp_count": "bypass_lsp_count"}, "pybind.slxos.v17r_1_01a.mpls_state.interface": {"interface_name": "interface_name", "bypass_lsp_count": "bypass_lsp_count"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_interface_index_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_interface_name_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_index
    :param interface: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_is_gre_port_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.interface": {"is_gre_port": "is_gre_port"}, "pybind.slxos.v17r_2_00.mpls_state.interface": {"interface_name": "interface_name", "is_gre_port": "is_gre_port"}, "pybind.slxos.v17r_1_01a.mpls_state.interface": {"interface_name": "interface_name", "is_gre_port": "is_gre_port"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_is_ldp_enabled_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.interface": {"is_ldp_enabled": "is_ldp_enabled"}, "pybind.slxos.v17r_2_00.mpls_state.interface": {"interface_name": "interface_name", "is_ldp_enabled": "is_ldp_enabled"}, "pybind.slxos.v17r_1_01a.mpls_state.interface": {"interface_name": "interface_name", "is_ldp_enabled": "is_ldp_enabled"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_ldp_transit_tunnel_count_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.interface": {"ldp_transit_tunnel_count": "ldp_transit_tunnel_count"}, "pybind.slxos.v17r_2_00.mpls_state.interface": {"ldp_transit_tunnel_count": "ldp_transit_tunnel_count", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.interface": {"ldp_transit_tunnel_count": "ldp_transit_tunnel_count", "interface_name": "interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_ldp_tunnel_count_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.interface": {"ldp_tunnel_count": "ldp_tunnel_count"}, "pybind.slxos.v17r_2_00.mpls_state.interface": {"interface_name": "interface_name", "ldp_tunnel_count": "ldp_tunnel_count"}, "pybind.slxos.v17r_1_01a.mpls_state.interface": {"interface_name": "interface_name", "ldp_tunnel_count": "ldp_tunnel_count"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_max_bandwidth_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.interface": {"max_bandwidth": "max_bandwidth"}, "pybind.slxos.v17r_2_00.mpls_state.interface": {"interface_name": "interface_name", "max_bandwidth": "max_bandwidth"}, "pybind.slxos.v17r_1_01a.mpls_state.interface": {"interface_name": "interface_name", "max_bandwidth": "max_bandwidth"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_max_lsp_priority_level_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.interface": {"max_lsp_priority_level": "max_lsp_priority_level"}, "pybind.slxos.v17r_2_00.mpls_state.interface": {"max_lsp_priority_level": "max_lsp_priority_level", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.interface": {"max_lsp_priority_level": "max_lsp_priority_level", "interface_name": "interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_max_resv_bandwidth_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.interface": {"max_resv_bandwidth": "max_resv_bandwidth"}, "pybind.slxos.v17r_2_00.mpls_state.interface": {"max_resv_bandwidth": "max_resv_bandwidth", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.interface": {"max_resv_bandwidth": "max_resv_bandwidth", "interface_name": "interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_max_resv_bandwidth_percentage_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.interface": {"max_resv_bandwidth_percentage": "max_resv_bandwidth_percentage"}, "pybind.slxos.v17r_2_00.mpls_state.interface": {"interface_name": "interface_name", "max_resv_bandwidth_percentage": "max_resv_bandwidth_percentage"}, "pybind.slxos.v17r_1_01a.mpls_state.interface": {"interface_name": "interface_name", "max_resv_bandwidth_percentage": "max_resv_bandwidth_percentage"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_mtu_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.interface": {"mtu": "mtu"}, "pybind.slxos.v17r_2_00.mpls_state.interface": {"interface_name": "interface_name", "mtu": "mtu"}, "pybind.slxos.v17r_1_01a.mpls_state.interface": {"interface_name": "interface_name", "mtu": "mtu"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_oper_status_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.interface": {"oper_status": "oper_status"}, "pybind.slxos.v17r_2_00.mpls_state.interface": {"oper_status": "oper_status", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.interface": {"oper_status": "oper_status", "interface_name": "interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_interface_te_metric_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.interface', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.interface": {"te_metric": "te_metric"}, "pybind.slxos.v17r_2_00.mpls_state.interface": {"te_metric": "te_metric", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.interface": {"te_metric": "te_metric", "interface_name": "interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_neighbors', u'neighbor'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'prefix'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_vcs'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_prefix_prefix'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'ldp_out'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_vcid'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_summary'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs', u'vc'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_errors_instance_since_clear', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'key'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs', u'key'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_prefixes'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_stats_instance_since_clear', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.interface', u'ldp_interface_data'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'num_link_neighbors, num_targeted_neighbors'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'tot_no_of_vc_fec, tot_no_of_vc_fec_installed'}, {'leafval': 'ldp_database_peer_ip, ldp_database_own_ip'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'prefix, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_state, prefix_ingress, prefix_egress, prefix_um_dist_done, prefix_lwd, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'error_type, count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'vc_id, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_state, prefix_ingress, prefix_egress, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tot_no_of_prefix_fec, tot_no_of_prefix_fec_installed, tot_no_of_prefix_fec_filtered, tot_no_of_vc_fec_128, tot_no_of_vc_fec_129, tot_no_of_vc_fec_installed, tot_no_of_route_upd_proc_errors, tot_no_of_vc_fec_proc_errors'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'peer_id, peer_lblspc, state, vc_id, peer_vc_type, peer_fec_type, ingress, egress'}, {'leafval': 'error_type, count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}, {'leafval': 'prefix'}, {'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}, {'leafval': 'tot_no_of_prefix_fec, tot_no_of_prefix_fec_installed, tot_no_of_prefix_fec_filtered, tot_no_of_prefix_fec_lwd, filtered, prefix_filtered'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'ldp_interface_name, ldp_interface_type, ldp_interface_lbpsp, ldp_interface_nbr_cnt, ldp_interface_hello_intl, ldp_interface_hello_timeout, ldp_interface_hello_next'}, {'leafval': 'destination_route'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp": {"forwarding_state_timer_remaining": "forwarding_state_timer_remaining", "fec_128_used_for_auto_disc_configured": "fec_128_used_for_auto_disc_configured", "fec_128_used_for_auto_disc_current": "fec_128_used_for_auto_disc_current", "gr_max_peer_recovery_time": "gr_max_peer_recovery_time", "gr_max_peer_reconnect_time": "gr_max_peer_reconnect_time", "hold_time_sent_target": "hold_time_sent_target", "advertise_fecs_for_prefix_list_exists": "advertise_fecs_for_prefix_list_exists", "end_of_lib": "end_of_lib", "lsr_id_configured": "lsr_id_configured", "lsr_id": "lsr_id", "ka_timeout": "ka_timeout", "ka_interval": "ka_interval", "inbound_fecs_filtering_prefix_list": "inbound_fecs_filtering_prefix_list", "hello_interval_link": "hello_interval_link", "lwd_delay": "lwd_delay", "gr_enable": "gr_enable", "loopback": "loopback", "outbound_fecs_filtering_prefix_list": "outbound_fecs_filtering_prefix_list", "outbound_fecs_filtering_prefix_list_exists": "outbound_fecs_filtering_prefix_list_exists", "inbound_fecs_filtering_prefix_list_exists": "inbound_fecs_filtering_prefix_list_exists", "ldp_initialized": "ldp_initialized", "load_sharing": "load_sharing", "gr_reconnect_time": "gr_reconnect_time", "eol_notification_time": "eol_notification_time", "gr_recovery_time": "gr_recovery_time", "tx_silence_time": "tx_silence_time", "rx_silence_time": "rx_silence_time", "gr_helper": "gr_helper", "tunnel_metric": "tunnel_metric", "hello_interval_target": "hello_interval_target", "hold_time_sent_link": "hold_time_sent_link", "ka_timeout_default": "ka_timeout_default", "ka_multiple": "ka_multiple", "forwarding_state_timer_running": "forwarding_state_timer_running", "lwd_default": "lwd_default", "advertise_fecs_for_prefix_list": "advertise_fecs_for_prefix_list"}, "pybind.slxos.v17r_2_00.mpls_state.ldp": {"forwarding_state_timer_remaining": "forwarding_state_timer_remaining", "fec_128_used_for_auto_disc_configured": "fec_128_used_for_auto_disc_configured", "fec_128_used_for_auto_disc_current": "fec_128_used_for_auto_disc_current", "gr_max_peer_recovery_time": "gr_max_peer_recovery_time", "gr_max_peer_reconnect_time": "gr_max_peer_reconnect_time", "hold_time_sent_target": "hold_time_sent_target", "advertise_fecs_for_prefix_list_exists": "advertise_fecs_for_prefix_list_exists", "end_of_lib": "end_of_lib", "lsr_id_configured": "lsr_id_configured", "lsr_id": "lsr_id", "ka_timeout": "ka_timeout", "ka_interval": "ka_interval", "inbound_fecs_filtering_prefix_list": "inbound_fecs_filtering_prefix_list", "hello_interval_link": "hello_interval_link", "lwd_delay": "lwd_delay", "gr_enable": "gr_enable", "loopback": "loopback", "outbound_fecs_filtering_prefix_list": "outbound_fecs_filtering_prefix_list", "outbound_fecs_filtering_prefix_list_exists": "outbound_fecs_filtering_prefix_list_exists", "inbound_fecs_filtering_prefix_list_exists": "inbound_fecs_filtering_prefix_list_exists", "ldp_initialized": "ldp_initialized", "load_sharing": "load_sharing", "gr_reconnect_time": "gr_reconnect_time", "eol_notification_time": "eol_notification_time", "gr_recovery_time": "gr_recovery_time", "tx_silence_time": "tx_silence_time", "rx_silence_time": "rx_silence_time", "gr_helper": "gr_helper", "tunnel_metric": "tunnel_metric", "hello_interval_target": "hello_interval_target", "hold_time_sent_link": "hold_time_sent_link", "ka_timeout_default": "ka_timeout_default", "ka_multiple": "ka_multiple", "forwarding_state_timer_running": "forwarding_state_timer_running", "lwd_default": "lwd_default", "advertise_fecs_for_prefix_list": "advertise_fecs_for_prefix_list"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_advertise_fecs_for_prefix_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_advertise_fecs_for_prefix_list_exists_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_end_of_lib_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_eol_notification_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'prefix'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_vcs'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_prefix_prefix'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_vcid'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_summary'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs', u'vc'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'key'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs', u'key'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec', u'ldp_fec_prefixes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'tot_no_of_vc_fec, tot_no_of_vc_fec_installed'}, {'leafval': 'prefix, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_state, prefix_ingress, prefix_egress, prefix_um_dist_done, prefix_lwd, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'vc_id, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_state, prefix_ingress, prefix_egress, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tot_no_of_prefix_fec, tot_no_of_prefix_fec_installed, tot_no_of_prefix_fec_filtered, tot_no_of_vc_fec_128, tot_no_of_vc_fec_129, tot_no_of_vc_fec_installed, tot_no_of_route_upd_proc_errors, tot_no_of_vc_fec_proc_errors'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'peer_id, peer_lblspc, state, vc_id, peer_vc_type, peer_fec_type, ingress, egress'}, {'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}, {'leafval': 'prefix'}, {'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}, {'leafval': 'tot_no_of_prefix_fec, tot_no_of_prefix_fec_installed, tot_no_of_prefix_fec_filtered, tot_no_of_prefix_fec_lwd, filtered, prefix_filtered'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_128_used_for_auto_disc_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_128_used_for_auto_disc_current_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'key'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'prefix_prefix')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix_longer', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}, {'leafval': 'prefix, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_state, prefix_ingress, prefix_egress, prefix_um_dist_done, prefix_lwd, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_data_fec_type_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_inet_addr_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_inet_addr_len_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_inet_addr_type_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_prefix_len_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_type_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_agi_len_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_agi_offset_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_control_word_config_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_gen_id_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_gen_id_size_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_group_id_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_id_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_ldp_peer_id_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_saii_len_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_saii_offset_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_taii_len_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_taii_offset_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_type_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_key_vc_use_control_word_get(self, ldp_fec_prefix_longer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_fec_dm_state_dw_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_fec_filtered_state_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_fec_stale_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_feccb_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_label_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_local_ldp_lblspc_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_peer_ldp_id_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_peer_ldp_lblspc_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_downstream_state_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_egress_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_excess_dms_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_feccb_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_idx_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_ingress_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_is_ldp_o_rsvp_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_lwd_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_lwd_started_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_nexthops_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_nexthops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_nexthops: nexthop
    :param prefix_nexthops: Keyword argument tuple.

    :type nexthop: unicode
    :param nexthop: **prefix_nexthops** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_nexthops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_nexthops', 'keyval': 'nexthop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_nexthops=prefix_nexthops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_nexthops=prefix_nexthops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_nexthops_out_intf_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_nexthops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_nexthops: nexthop
    :param prefix_nexthops: Keyword argument tuple.

    :type nexthop: unicode
    :param nexthop: **prefix_nexthops** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_nexthops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_nexthops', 'keyval': 'nexthop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_nexthops=prefix_nexthops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_nexthops=prefix_nexthops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_pend_notif_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_state_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_type_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_um_dist_done_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_prefix', 'keyval': 'prefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_fec_dm_state_dw_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_fec_filtered_state_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_fec_stale_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_feccb_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_label_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_local_ldp_lblspc_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_peer_ldp_id_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_peer_ldp_lblspc_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_longer_prefix_prefix_prefix_upstream_state_get(self, ldp_fec_prefix_longer=None, prefix_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix_longer: prefix
    :param ldp_fec_prefix_longer: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **ldp_fec_prefix_longer** tuple argument.

    :type prefix_prefix: prefix
    :param prefix_prefix: Keyword argument tuple.

    :type prefix: unicode
    :param prefix: **prefix_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer', u'ldp_fec_prefix_longer'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix', u'prefix_prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_longer.prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'prefix', 'extra_keyval': ''}, {'keyval': 'prefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix_longer=ldp_fec_prefix_longer, prefix_prefix=prefix_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_get(self, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_fec_dm_state_dw_get(self, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_fec_filtered_state_get(self, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_fec_stale_get(self, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_feccb_get(self, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_label_get(self, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_local_ldp_lblspc_get(self, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_peer_ldp_id_get(self, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_peer_ldp_lblspc_get(self, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_downstream_state_get(self, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: local_ldp_id
    :param prefix_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_egress_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_excess_dms_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_feccb_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_idx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_ingress_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_is_ldp_o_rsvp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_lwd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_lwd_started_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_nexthops_get(self, prefix_nexthops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_nexthops: nexthop
    :param prefix_nexthops: Keyword argument tuple.

    :type nexthop: unicode
    :param nexthop: **prefix_nexthops** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_nexthops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_nexthops', 'keyval': 'nexthop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_nexthops=prefix_nexthops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_nexthops=prefix_nexthops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_nexthops_out_intf_get(self, prefix_nexthops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_nexthops: nexthop
    :param prefix_nexthops: Keyword argument tuple.

    :type nexthop: unicode
    :param nexthop: **prefix_nexthops** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_nexthops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_nexthops', 'keyval': 'nexthop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_nexthops=prefix_nexthops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_nexthops=prefix_nexthops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_pend_notif_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_um_dist_done_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_nexthops'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_get(self, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_fec_dm_state_dw_get(self, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_fec_filtered_state_get(self, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_fec_stale_get(self, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_feccb_get(self, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_label_get(self, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_local_ldp_lblspc_get(self, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_peer_ldp_id_get(self, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_peer_ldp_lblspc_get(self, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefix_prefix_prefix_upstream_state_get(self, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: local_ldp_id
    :param prefix_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **prefix_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefix_prefix.prefix_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'prefix'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd'}, {'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_filtered_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'prefix'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd'}, {'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_data_fec_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_inet_addr_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_inet_addr_len_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_inet_addr_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_prefix_len_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_agi_len_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_agi_offset_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_control_word_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_gen_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_gen_id_size_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_group_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_ldp_peer_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_saii_len_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_saii_offset_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_taii_len_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_taii_offset_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_key_vc_use_control_word_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_get(self, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix: destination
    :param prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', u'nexthops')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_egress_get(self, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix: destination
    :param prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', u'nexthops')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_filtered_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'prefix'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd'}, {'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_filtered_prefix_get(self, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix: destination
    :param prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', u'nexthops')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_ingress_get(self, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix: destination
    :param prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', u'nexthops')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_lwd_get(self, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix: destination
    :param prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', u'nexthops')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_nexthops_get(self, prefix=None, nexthops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type prefix: destination
    :param prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type nexthops: nexthop
    :param nexthops: Keyword argument tuple.

    :type nexthop: unicode
    :param nexthop: **nexthops** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.prefix.nexthops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nexthops', 'keyval': 'nexthop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix=prefix, nexthops=nexthops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix=prefix, nexthops=nexthops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_nexthops_out_intf_get(self, prefix=None, nexthops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type prefix: destination
    :param prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type nexthops: nexthop
    :param nexthops: Keyword argument tuple.

    :type nexthop: unicode
    :param nexthop: **nexthops** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', u'prefix')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.prefix.nexthops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nexthops', 'keyval': 'nexthop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix=prefix, nexthops=nexthops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix=prefix, nexthops=nexthops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_prefix_state_get(self, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type prefix: destination
    :param prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes.prefix', u'nexthops')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_tot_no_of_prefix_fec_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'prefix'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd'}, {'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_tot_no_of_prefix_fec_filtered_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'prefix'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd'}, {'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_tot_no_of_prefix_fec_installed_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'prefix'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd'}, {'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_prefixes_tot_no_of_prefix_fec_lwd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'prefix'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_prefixes', u'key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd'}, {'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_tot_no_of_prefix_fec_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_tot_no_of_prefix_fec_filtered_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_tot_no_of_prefix_fec_installed_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_tot_no_of_route_upd_proc_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_tot_no_of_vc_fec_128_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_tot_no_of_vc_fec_129_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_tot_no_of_vc_fec_installed_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_summary_tot_no_of_vc_fec_proc_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_get(self, ldp_fec_vcid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_prefix_egress_get(self, ldp_fec_vcid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_prefix_ingress_get(self, ldp_fec_vcid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_prefix_pend_notif_get(self, ldp_fec_vcid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_prefix_state_get(self, ldp_fec_vcid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_prefix_um_dist_done_get(self, ldp_fec_vcid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_agi_get(self, ldp_fec_vcid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_get(self, ldp_fec_vcid=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_fec_dm_state_dw_get(self, ldp_fec_vcid=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_fec_filtered_state_get(self, ldp_fec_vcid=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_fec_stale_get(self, ldp_fec_vcid=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_feccb_get(self, ldp_fec_vcid=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_label_get(self, ldp_fec_vcid=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_local_ldp_lblspc_get(self, ldp_fec_vcid=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_peer_ldp_id_get(self, ldp_fec_vcid=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_peer_ldp_lblspc_get(self, ldp_fec_vcid=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_downstream_state_get(self, ldp_fec_vcid=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: local_ldp_id
    :param vc_downstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_fec_type_get(self, ldp_fec_vcid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_feccb_get(self, ldp_fec_vcid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_grp_id_get(self, ldp_fec_vcid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_idx_get(self, ldp_fec_vcid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_local_mtu_get(self, ldp_fec_vcid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_mtu_enforcement_get(self, ldp_fec_vcid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_remote_mtu_get(self, ldp_fec_vcid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_type_get(self, ldp_fec_vcid=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_upstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vcid', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_get(self, ldp_fec_vcid=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_fec_dm_state_dw_get(self, ldp_fec_vcid=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_fec_filtered_state_get(self, ldp_fec_vcid=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_fec_stale_get(self, ldp_fec_vcid=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_feccb_get(self, ldp_fec_vcid=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_label_get(self, ldp_fec_vcid=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_local_ldp_lblspc_get(self, ldp_fec_vcid=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_peer_ldp_id_get(self, ldp_fec_vcid=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_peer_ldp_lblspc_get(self, ldp_fec_vcid=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcid_vc_upstream_state_get(self, ldp_fec_vcid=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vcid: vc_id
    :param ldp_fec_vcid: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vcid** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: local_ldp_id
    :param vc_upstream: Keyword argument tuple.

    :type local_ldp_id: unicode
    :param local_ldp_id: **vc_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid', u'ldp_fec_vcid')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcid.vc_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'local_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vcid=ldp_fec_vcid, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs', u'vc'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs', u'key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'peer_id, peer_lblspc, state, vc_id, peer_vc_type, peer_fec_type, ingress, egress'}, {'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_data_fec_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_inet_addr_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_inet_addr_len_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_inet_addr_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_prefix_len_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_agi_len_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_agi_offset_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_control_word_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_gen_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_gen_id_size_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_group_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_ldp_peer_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_saii_len_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_saii_offset_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_taii_len_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_taii_offset_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_key_vc_use_control_word_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.key', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_tot_no_of_vc_fec_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs', u'vc'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs', u'key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'peer_id, peer_lblspc, state, vc_id, peer_vc_type, peer_fec_type, ingress, egress'}, {'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_tot_no_of_vc_fec_installed_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs', u'vc'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs', u'key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'peer_id, peer_lblspc, state, vc_id, peer_vc_type, peer_fec_type, ingress, egress'}, {'leafval': 'type, prefix_len, inet_addr_type, inet_addr_len, inet_addr, vc_ldp_peer_id, data_fec_type, vc_type, vc_control_word_config, vc_use_control_word, vc_group_id, vc_id, vc_agi_offset, vc_agi_len, vc_saii_offset, vc_saii_len, vc_taii_offset, vc_taii_len, vc_gen_id_size, vc_gen_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_vc_get(self, vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc: peer_id
    :param vc: Keyword argument tuple.

    :type peer_id: unicode
    :param peer_id: **vc** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.vc', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc', 'keyval': 'peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc=vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc=vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_vc_egress_get(self, vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc: peer_id
    :param vc: Keyword argument tuple.

    :type peer_id: unicode
    :param peer_id: **vc** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.vc', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc', 'keyval': 'peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc=vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc=vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_vc_ingress_get(self, vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc: peer_id
    :param vc: Keyword argument tuple.

    :type peer_id: unicode
    :param peer_id: **vc** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.vc', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc', 'keyval': 'peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc=vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc=vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_vc_peer_fec_type_get(self, vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc: peer_id
    :param vc: Keyword argument tuple.

    :type peer_id: unicode
    :param peer_id: **vc** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.vc', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc', 'keyval': 'peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc=vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc=vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_vc_peer_lblspc_get(self, vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc: peer_id
    :param vc: Keyword argument tuple.

    :type peer_id: unicode
    :param peer_id: **vc** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.vc', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc', 'keyval': 'peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc=vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc=vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_vc_peer_vc_type_get(self, vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc: peer_id
    :param vc: Keyword argument tuple.

    :type peer_id: unicode
    :param peer_id: **vc** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.vc', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc', 'keyval': 'peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc=vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc=vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_vc_state_get(self, vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc: peer_id
    :param vc: Keyword argument tuple.

    :type peer_id: unicode
    :param peer_id: **vc** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.vc', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc', 'keyval': 'peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc=vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc=vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_fec_ldp_fec_vcs_vc_vc_id_get(self, vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc: peer_id
    :param vc: Keyword argument tuple.

    :type peer_id: unicode
    :param peer_id: **vc** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.fec.ldp_fec_vcs.vc', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc', 'keyval': 'peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc=vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc=vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_forwarding_state_timer_remaining_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_forwarding_state_timer_running_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_gr_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_gr_helper_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_gr_max_peer_reconnect_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_gr_max_peer_recovery_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_gr_reconnect_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_gr_recovery_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_hello_interval_link_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_hello_interval_target_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_hold_time_sent_link_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_hold_time_sent_target_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_inbound_fecs_filtering_prefix_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_inbound_fecs_filtering_prefix_list_exists_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_interface_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_interface_hello_interval_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_interface_hello_next_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_interface_hello_timeout_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_interface_interface_index_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_interface_label_space_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_interface_ldp_interface_data_get(self, ldp_interface_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_interface_data: ldp_interface_name, ldp_interface_type
    :param ldp_interface_data: Keyword argument tuple.

    :type ldp_interface_name: unicode
    :param ldp_interface_name: **ldp_interface_data** tuple argument.

    :type ldp_interface_type: unicode
    :param ldp_interface_type: **ldp_interface_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface.ldp_interface_data', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_interface_data', 'keyval': 'ldp_interface_name, ldp_interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_interface_data=ldp_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_interface_data=ldp_interface_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_interface_ldp_interface_data_ldp_interface_hello_intl_get(self, ldp_interface_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_interface_data: ldp_interface_name, ldp_interface_type
    :param ldp_interface_data: Keyword argument tuple.

    :type ldp_interface_name: unicode
    :param ldp_interface_name: **ldp_interface_data** tuple argument.

    :type ldp_interface_type: unicode
    :param ldp_interface_type: **ldp_interface_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface.ldp_interface_data', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_interface_data', 'keyval': 'ldp_interface_name, ldp_interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_interface_data=ldp_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_interface_data=ldp_interface_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_interface_ldp_interface_data_ldp_interface_hello_next_get(self, ldp_interface_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_interface_data: ldp_interface_name, ldp_interface_type
    :param ldp_interface_data: Keyword argument tuple.

    :type ldp_interface_name: unicode
    :param ldp_interface_name: **ldp_interface_data** tuple argument.

    :type ldp_interface_type: unicode
    :param ldp_interface_type: **ldp_interface_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface.ldp_interface_data', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_interface_data', 'keyval': 'ldp_interface_name, ldp_interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_interface_data=ldp_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_interface_data=ldp_interface_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_interface_ldp_interface_data_ldp_interface_hello_timeout_get(self, ldp_interface_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_interface_data: ldp_interface_name, ldp_interface_type
    :param ldp_interface_data: Keyword argument tuple.

    :type ldp_interface_name: unicode
    :param ldp_interface_name: **ldp_interface_data** tuple argument.

    :type ldp_interface_type: unicode
    :param ldp_interface_type: **ldp_interface_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface.ldp_interface_data', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_interface_data', 'keyval': 'ldp_interface_name, ldp_interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_interface_data=ldp_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_interface_data=ldp_interface_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_interface_ldp_interface_data_ldp_interface_lbpsp_get(self, ldp_interface_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_interface_data: ldp_interface_name, ldp_interface_type
    :param ldp_interface_data: Keyword argument tuple.

    :type ldp_interface_name: unicode
    :param ldp_interface_name: **ldp_interface_data** tuple argument.

    :type ldp_interface_type: unicode
    :param ldp_interface_type: **ldp_interface_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface.ldp_interface_data', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_interface_data', 'keyval': 'ldp_interface_name, ldp_interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_interface_data=ldp_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_interface_data=ldp_interface_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_interface_ldp_interface_data_ldp_interface_nbr_cnt_get(self, ldp_interface_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_interface_data: ldp_interface_name, ldp_interface_type
    :param ldp_interface_data: Keyword argument tuple.

    :type ldp_interface_name: unicode
    :param ldp_interface_name: **ldp_interface_data** tuple argument.

    :type ldp_interface_type: unicode
    :param ldp_interface_type: **ldp_interface_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.interface.ldp_interface_data', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_interface_data', 'keyval': 'ldp_interface_name, ldp_interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_interface_data=ldp_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_interface_data=ldp_interface_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_interface_neighbor_count_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type interface: interface_name
    :param interface: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.interface', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.interface', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ka_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ka_multiple_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ka_timeout_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ka_timeout_default_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_get(self, ldp_database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_database: peer_ip, own_ip
    :param ldp_database: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type own_ip: unicode
    :param own_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'mpls_ldp_database_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'mpls_ldp_database_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_database', 'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'label, prefix, prefix_length, fec_type, stale, index, state, filtered, lwd'}, {'leafval': 'label, prefix, prefix_length, fec_type, stale, index'}, {'leafval': 'label, prefix, prefix_length, fec_type, stale, index'}, {'leafval': 'label, prefix, prefix_length, fec_type, stale, index, state, filtered, lwd'}, {'leafval': 'mpls_ldp_database_ds_fec_label, mpls_ldp_database_ds_fec_prefix, mpls_ldp_database_ds_fec_prefix_length, mpls_ldp_database_ds_fec_type, mpls_ldp_database_ds_fec_state, mpls_ldp_database_ds_fec_filtered, mpls_ldp_database_ds_fec_stale, mpls_ldp_database_ds_fec_lwd'}, {'leafval': 'mpls_ldp_database_us_fec_label, mpls_ldp_database_us_fec_prefix, mpls_ldp_database_us_fec_prefix_length, mpls_ldp_database_us_fec_type, mpls_ldp_database_us_fec_stale'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database": {"own_ip": "ldp_database_own_ip", "peer_ip": "ldp_database_peer_ip"}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database": {"own_ip": "own_ip", "peer_ip": "peer_ip"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database": {"own_ip": "own_ip", "peer_ip": "peer_ip"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_downstream_get(self, ldp_database=None, downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: peer_ip, own_ip
    :param ldp_database: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type own_ip: unicode
    :param own_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type downstream: index
    :param downstream: Keyword argument tuple.

    :type index: long
    :param index: **downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}, {'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, downstream=downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, downstream=downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_downstream_fec_type_get(self, ldp_database=None, downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: peer_ip, own_ip
    :param ldp_database: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type own_ip: unicode
    :param own_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type downstream: index
    :param downstream: Keyword argument tuple.

    :type index: long
    :param index: **downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}, {'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, downstream=downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, downstream=downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_downstream_filtered_get(self, ldp_database=None, downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: peer_ip, own_ip
    :param ldp_database: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type own_ip: unicode
    :param own_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type downstream: index
    :param downstream: Keyword argument tuple.

    :type index: long
    :param index: **downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}, {'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, downstream=downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, downstream=downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_downstream_label_get(self, ldp_database=None, downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: peer_ip, own_ip
    :param ldp_database: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type own_ip: unicode
    :param own_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type downstream: index
    :param downstream: Keyword argument tuple.

    :type index: long
    :param index: **downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}, {'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, downstream=downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, downstream=downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_downstream_lwd_get(self, ldp_database=None, downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: peer_ip, own_ip
    :param ldp_database: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type own_ip: unicode
    :param own_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type downstream: index
    :param downstream: Keyword argument tuple.

    :type index: long
    :param index: **downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}, {'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, downstream=downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, downstream=downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_downstream_prefix_get(self, ldp_database=None, downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: peer_ip, own_ip
    :param ldp_database: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type own_ip: unicode
    :param own_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type downstream: index
    :param downstream: Keyword argument tuple.

    :type index: long
    :param index: **downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}, {'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, downstream=downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, downstream=downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_downstream_prefix_length_get(self, ldp_database=None, downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: peer_ip, own_ip
    :param ldp_database: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type own_ip: unicode
    :param own_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type downstream: index
    :param downstream: Keyword argument tuple.

    :type index: long
    :param index: **downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}, {'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, downstream=downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, downstream=downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_downstream_stale_get(self, ldp_database=None, downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: peer_ip, own_ip
    :param ldp_database: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type own_ip: unicode
    :param own_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type downstream: index
    :param downstream: Keyword argument tuple.

    :type index: long
    :param index: **downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}, {'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, downstream=downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, downstream=downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_downstream_state_get(self, ldp_database=None, downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: peer_ip, own_ip
    :param ldp_database: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type own_ip: unicode
    :param own_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type downstream: index
    :param downstream: Keyword argument tuple.

    :type index: long
    :param index: **downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database.downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}, {'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, downstream=downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, downstream=downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_ldp_database_own_ip_get(self, ldp_database=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'mpls_ldp_database_downstream'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'mpls_ldp_database_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_database', 'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mpls_ldp_database_ds_fec_label, mpls_ldp_database_ds_fec_prefix, mpls_ldp_database_ds_fec_prefix_length, mpls_ldp_database_ds_fec_type, mpls_ldp_database_ds_fec_state, mpls_ldp_database_ds_fec_filtered, mpls_ldp_database_ds_fec_stale, mpls_ldp_database_ds_fec_lwd'}, {'leafval': 'mpls_ldp_database_us_fec_label, mpls_ldp_database_us_fec_prefix, mpls_ldp_database_us_fec_prefix_length, mpls_ldp_database_us_fec_type, mpls_ldp_database_us_fec_stale'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_downstream_get(self, ldp_database=None, mpls_ldp_database_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_downstream: mpls_ldp_database_ds_fec_prefix
    :param mpls_ldp_database_downstream: Keyword argument tuple.

    :type mpls_ldp_database_ds_fec_prefix: unicode
    :param mpls_ldp_database_ds_fec_prefix: **mpls_ldp_database_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database.mpls_ldp_database_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_downstream', 'keyval': 'mpls_ldp_database_ds_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_downstream_mpls_ldp_database_ds_fec_filtered_get(self, ldp_database=None, mpls_ldp_database_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_downstream: mpls_ldp_database_ds_fec_prefix
    :param mpls_ldp_database_downstream: Keyword argument tuple.

    :type mpls_ldp_database_ds_fec_prefix: unicode
    :param mpls_ldp_database_ds_fec_prefix: **mpls_ldp_database_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database.mpls_ldp_database_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_downstream', 'keyval': 'mpls_ldp_database_ds_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_downstream_mpls_ldp_database_ds_fec_label_get(self, ldp_database=None, mpls_ldp_database_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_downstream: mpls_ldp_database_ds_fec_prefix
    :param mpls_ldp_database_downstream: Keyword argument tuple.

    :type mpls_ldp_database_ds_fec_prefix: unicode
    :param mpls_ldp_database_ds_fec_prefix: **mpls_ldp_database_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database.mpls_ldp_database_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_downstream', 'keyval': 'mpls_ldp_database_ds_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_downstream_mpls_ldp_database_ds_fec_lwd_get(self, ldp_database=None, mpls_ldp_database_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_downstream: mpls_ldp_database_ds_fec_prefix
    :param mpls_ldp_database_downstream: Keyword argument tuple.

    :type mpls_ldp_database_ds_fec_prefix: unicode
    :param mpls_ldp_database_ds_fec_prefix: **mpls_ldp_database_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database.mpls_ldp_database_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_downstream', 'keyval': 'mpls_ldp_database_ds_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_downstream_mpls_ldp_database_ds_fec_prefix_length_get(self, ldp_database=None, mpls_ldp_database_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_downstream: mpls_ldp_database_ds_fec_prefix
    :param mpls_ldp_database_downstream: Keyword argument tuple.

    :type mpls_ldp_database_ds_fec_prefix: unicode
    :param mpls_ldp_database_ds_fec_prefix: **mpls_ldp_database_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database.mpls_ldp_database_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_downstream', 'keyval': 'mpls_ldp_database_ds_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_downstream_mpls_ldp_database_ds_fec_stale_get(self, ldp_database=None, mpls_ldp_database_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_downstream: mpls_ldp_database_ds_fec_prefix
    :param mpls_ldp_database_downstream: Keyword argument tuple.

    :type mpls_ldp_database_ds_fec_prefix: unicode
    :param mpls_ldp_database_ds_fec_prefix: **mpls_ldp_database_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database.mpls_ldp_database_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_downstream', 'keyval': 'mpls_ldp_database_ds_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_downstream_mpls_ldp_database_ds_fec_state_get(self, ldp_database=None, mpls_ldp_database_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_downstream: mpls_ldp_database_ds_fec_prefix
    :param mpls_ldp_database_downstream: Keyword argument tuple.

    :type mpls_ldp_database_ds_fec_prefix: unicode
    :param mpls_ldp_database_ds_fec_prefix: **mpls_ldp_database_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database.mpls_ldp_database_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_downstream', 'keyval': 'mpls_ldp_database_ds_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_downstream_mpls_ldp_database_ds_fec_type_get(self, ldp_database=None, mpls_ldp_database_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_downstream: mpls_ldp_database_ds_fec_prefix
    :param mpls_ldp_database_downstream: Keyword argument tuple.

    :type mpls_ldp_database_ds_fec_prefix: unicode
    :param mpls_ldp_database_ds_fec_prefix: **mpls_ldp_database_downstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database.mpls_ldp_database_downstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_downstream', 'keyval': 'mpls_ldp_database_ds_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_downstream=mpls_ldp_database_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_upstream_get(self, ldp_database=None, mpls_ldp_database_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_upstream: mpls_ldp_database_us_fec_prefix
    :param mpls_ldp_database_upstream: Keyword argument tuple.

    :type mpls_ldp_database_us_fec_prefix: unicode
    :param mpls_ldp_database_us_fec_prefix: **mpls_ldp_database_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database.mpls_ldp_database_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_upstream', 'keyval': 'mpls_ldp_database_us_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_upstream_mpls_ldp_database_us_fec_label_get(self, ldp_database=None, mpls_ldp_database_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_upstream: mpls_ldp_database_us_fec_prefix
    :param mpls_ldp_database_upstream: Keyword argument tuple.

    :type mpls_ldp_database_us_fec_prefix: unicode
    :param mpls_ldp_database_us_fec_prefix: **mpls_ldp_database_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database.mpls_ldp_database_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_upstream', 'keyval': 'mpls_ldp_database_us_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_upstream_mpls_ldp_database_us_fec_prefix_length_get(self, ldp_database=None, mpls_ldp_database_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_upstream: mpls_ldp_database_us_fec_prefix
    :param mpls_ldp_database_upstream: Keyword argument tuple.

    :type mpls_ldp_database_us_fec_prefix: unicode
    :param mpls_ldp_database_us_fec_prefix: **mpls_ldp_database_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database.mpls_ldp_database_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_upstream', 'keyval': 'mpls_ldp_database_us_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_upstream_mpls_ldp_database_us_fec_stale_get(self, ldp_database=None, mpls_ldp_database_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_upstream: mpls_ldp_database_us_fec_prefix
    :param mpls_ldp_database_upstream: Keyword argument tuple.

    :type mpls_ldp_database_us_fec_prefix: unicode
    :param mpls_ldp_database_us_fec_prefix: **mpls_ldp_database_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database.mpls_ldp_database_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_upstream', 'keyval': 'mpls_ldp_database_us_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_mpls_ldp_database_upstream_mpls_ldp_database_us_fec_type_get(self, ldp_database=None, mpls_ldp_database_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: ldp_database_peer_ip
    :param ldp_database: Keyword argument tuple.

    :type ldp_database_peer_ip: unicode
    :param ldp_database_peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type mpls_ldp_database_upstream: mpls_ldp_database_us_fec_prefix
    :param mpls_ldp_database_upstream: Keyword argument tuple.

    :type mpls_ldp_database_us_fec_prefix: unicode
    :param mpls_ldp_database_us_fec_prefix: **mpls_ldp_database_upstream** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_database.mpls_ldp_database_upstream', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ldp_database_peer_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_ldp_database_upstream', 'keyval': 'mpls_ldp_database_us_fec_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, mpls_ldp_database_upstream=mpls_ldp_database_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_upstream_get(self, ldp_database=None, upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: peer_ip, own_ip
    :param ldp_database: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type own_ip: unicode
    :param own_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type upstream: index
    :param upstream: Keyword argument tuple.

    :type index: long
    :param index: **upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database.upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database.upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}, {'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'upstream', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, upstream=upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, upstream=upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_upstream_fec_type_get(self, ldp_database=None, upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: peer_ip, own_ip
    :param ldp_database: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type own_ip: unicode
    :param own_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type upstream: index
    :param upstream: Keyword argument tuple.

    :type index: long
    :param index: **upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database.upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database.upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}, {'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'upstream', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, upstream=upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, upstream=upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_upstream_label_get(self, ldp_database=None, upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: peer_ip, own_ip
    :param ldp_database: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type own_ip: unicode
    :param own_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type upstream: index
    :param upstream: Keyword argument tuple.

    :type index: long
    :param index: **upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database.upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database.upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}, {'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'upstream', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, upstream=upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, upstream=upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_upstream_prefix_get(self, ldp_database=None, upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: peer_ip, own_ip
    :param ldp_database: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type own_ip: unicode
    :param own_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type upstream: index
    :param upstream: Keyword argument tuple.

    :type index: long
    :param index: **upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database.upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database.upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}, {'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'upstream', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, upstream=upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, upstream=upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_upstream_prefix_length_get(self, ldp_database=None, upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: peer_ip, own_ip
    :param ldp_database: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type own_ip: unicode
    :param own_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type upstream: index
    :param upstream: Keyword argument tuple.

    :type index: long
    :param index: **upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database.upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database.upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}, {'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'upstream', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, upstream=upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, upstream=upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_database_upstream_stale_get(self, ldp_database=None, upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_database: peer_ip, own_ip
    :param ldp_database: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type own_ip: unicode
    :param own_ip: **ldp_database** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type upstream: index
    :param upstream: Keyword argument tuple.

    :type index: long
    :param index: **upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database', u'ldp_database')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_database.upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_database.upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}, {'keyval': 'peer_ip, own_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'upstream', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_database=ldp_database, upstream=upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_database=ldp_database, upstream=upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_egress_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_filter_type_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_filtered_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_ingress_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_longer_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_lwd_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_nexthops_get(self, ldp_fec_prefix=None, nexthops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type nexthops: nexthop
    :param nexthops: Keyword argument tuple.

    :type nexthop: unicode
    :param nexthop: **nexthops** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.nexthops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.nexthops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nexthops', 'keyval': 'nexthop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, nexthops=nexthops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, nexthops=nexthops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_nexthops_out_intf_get(self, ldp_fec_prefix=None, nexthops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type nexthops: nexthop
    :param nexthops: Keyword argument tuple.

    :type nexthop: unicode
    :param nexthop: **nexthops** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.nexthops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.nexthops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nexthops', 'keyval': 'nexthop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, nexthops=nexthops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, nexthops=nexthops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_downstream_get(self, ldp_fec_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: mapping_index
    :param prefix_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_downstream_fec_dm_state_dw_get(self, ldp_fec_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: mapping_index
    :param prefix_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_downstream_fec_filtered_state_get(self, ldp_fec_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: mapping_index
    :param prefix_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_downstream_fec_stale_get(self, ldp_fec_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: mapping_index
    :param prefix_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_downstream_feccb_get(self, ldp_fec_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: mapping_index
    :param prefix_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_downstream_label_get(self, ldp_fec_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: mapping_index
    :param prefix_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_downstream_local_ldp_id_get(self, ldp_fec_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: mapping_index
    :param prefix_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_downstream_local_ldp_lblspc_get(self, ldp_fec_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: mapping_index
    :param prefix_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_downstream_peer_ldp_id_get(self, ldp_fec_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: mapping_index
    :param prefix_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_downstream_peer_ldp_lblspc_get(self, ldp_fec_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: mapping_index
    :param prefix_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_downstream_state_get(self, ldp_fec_prefix=None, prefix_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_downstream: mapping_index
    :param prefix_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_downstream=prefix_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_excess_dms_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_feccb_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_filtered_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_idx_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_is_ldp_o_rsvp_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_lwd_started_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_pend_notif_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_type_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_um_dist_done_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_upstream_get(self, ldp_fec_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: mapping_index
    :param prefix_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_upstream_fec_dm_state_dw_get(self, ldp_fec_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: mapping_index
    :param prefix_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_upstream_fec_filtered_state_get(self, ldp_fec_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: mapping_index
    :param prefix_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_upstream_fec_stale_get(self, ldp_fec_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: mapping_index
    :param prefix_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_upstream_feccb_get(self, ldp_fec_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: mapping_index
    :param prefix_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_upstream_label_get(self, ldp_fec_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: mapping_index
    :param prefix_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_upstream_local_ldp_id_get(self, ldp_fec_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: mapping_index
    :param prefix_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_upstream_local_ldp_lblspc_get(self, ldp_fec_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: mapping_index
    :param prefix_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_upstream_peer_ldp_id_get(self, ldp_fec_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: mapping_index
    :param prefix_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_upstream_peer_ldp_lblspc_get(self, ldp_fec_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: mapping_index
    :param prefix_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_prefix_upstream_state_get(self, ldp_fec_prefix=None, prefix_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type prefix_upstream: mapping_index
    :param prefix_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **prefix_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'ldp_fec_prefix')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix.prefix_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination', 'extra_keyval': ''}, {'keyval': 'destination', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix, prefix_upstream=prefix_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_prefix_state_get(self, ldp_fec_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_prefix: destination
    :param ldp_fec_prefix: Keyword argument tuple.

    :type destination: unicode
    :param destination: **ldp_fec_prefix** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_downstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'nexthops'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_prefix', u'prefix_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_prefix', 'keyval': 'destination', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'nexthop, out_intf'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_prefix=ldp_fec_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_prefix=ldp_fec_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_statistics_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_statistics_number_of_prefix_fec_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_statistics_number_of_prefix_fec_filtered_in_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_statistics_number_of_prefix_fec_filtered_out_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_statistics_number_of_prefix_fec_installed_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_statistics_number_of_prefix_fec_lwd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_statistics_number_of_route_upd_proc_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_statistics_number_of_vc_fec_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_statistics_number_of_vc_fec_128_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_statistics_number_of_vc_fec_129_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_statistics_number_of_vc_fec_installed_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_statistics_number_of_vc_fec_proc_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc": {"ingress": "ingress", "prefix_um_dist_done": "prefix_um_dist_done", "vc_remote_mtu": "vc_remote_mtu", "vc_idx": "vc_idx", "vc_grp_id": "vc_grp_id", "vc_agi": "vc_agi", "state": "state", "vc_feccb": "vc_feccb", "vc_local_mtu": "vc_local_mtu", "vc_mtu_enforcement": "vc_mtu_enforcement", "peer_lblspc": "peer_lblspc", "egress": "egress", "vc_id": "vc_id", "peer_vc_type": "peer_vc_type", "vc_type": "vc_type", "peer_id": "peer_id", "vc_fec_type": "vc_fec_type", "prefix_pend_notif": "prefix_pend_notif"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_egress_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_ingress_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_peer_id_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_peer_lblspc_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_peer_vc_type_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_prefix_pend_notif_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_prefix_um_dist_done_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_state_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_agi_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_control_word_in_use_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_control_word_preferred_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_downstream_get(self, ldp_fec_vc=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: mapping_index
    :param vc_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_downstream_fec_dm_state_dw_get(self, ldp_fec_vc=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: mapping_index
    :param vc_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_downstream_fec_filtered_state_get(self, ldp_fec_vc=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: mapping_index
    :param vc_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_downstream_fec_stale_get(self, ldp_fec_vc=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: mapping_index
    :param vc_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_downstream_feccb_get(self, ldp_fec_vc=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: mapping_index
    :param vc_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_downstream_label_get(self, ldp_fec_vc=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: mapping_index
    :param vc_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_downstream_local_ldp_id_get(self, ldp_fec_vc=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: mapping_index
    :param vc_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_downstream_local_ldp_lblspc_get(self, ldp_fec_vc=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: mapping_index
    :param vc_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_downstream_peer_ldp_id_get(self, ldp_fec_vc=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: mapping_index
    :param vc_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_downstream_peer_ldp_lblspc_get(self, ldp_fec_vc=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: mapping_index
    :param vc_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_downstream_state_get(self, ldp_fec_vc=None, vc_downstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_downstream: mapping_index
    :param vc_downstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_downstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_downstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_downstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_downstream=vc_downstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_fec_type_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_feccb_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_grp_id_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_idx_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_local_flow_label_rx_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_local_flow_label_tx_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_local_mtu_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_mtu_enforcement_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_remote_flow_label_rx_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_remote_flow_label_tx_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_remote_mtu_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_type_get(self, ldp_fec_vc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_downstream'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_upstream'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'vc_downstream')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_fec_vc', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}, {'leafval': 'local_ldp_id, local_ldp_lblspc, peer_ldp_id, peer_ldp_lblspc, label, state, fec_filtered_state, fec_stale, feccb, fec_dm_state_dw, mapping_index'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_upstream_get(self, ldp_fec_vc=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: mapping_index
    :param vc_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_upstream_fec_dm_state_dw_get(self, ldp_fec_vc=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: mapping_index
    :param vc_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_upstream_fec_filtered_state_get(self, ldp_fec_vc=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: mapping_index
    :param vc_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_upstream_fec_stale_get(self, ldp_fec_vc=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: mapping_index
    :param vc_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_upstream_feccb_get(self, ldp_fec_vc=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: mapping_index
    :param vc_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_upstream_label_get(self, ldp_fec_vc=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: mapping_index
    :param vc_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_upstream_local_ldp_id_get(self, ldp_fec_vc=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: mapping_index
    :param vc_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_upstream_local_ldp_lblspc_get(self, ldp_fec_vc=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: mapping_index
    :param vc_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_upstream_peer_ldp_id_get(self, ldp_fec_vc=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: mapping_index
    :param vc_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_upstream_peer_ldp_lblspc_get(self, ldp_fec_vc=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: mapping_index
    :param vc_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_fec_vc_vc_upstream_state_get(self, ldp_fec_vc=None, vc_upstream=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_fec_vc: vc_id
    :param ldp_fec_vc: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **ldp_fec_vc** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_upstream: mapping_index
    :param vc_upstream: Keyword argument tuple.

    :type mapping_index: long
    :param mapping_index: **vc_upstream** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc', u'ldp_fec_vc')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_fec_vc.vc_upstream', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_upstream', 'keyval': 'mapping_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_fec_vc=ldp_fec_vc, vc_upstream=vc_upstream)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_initialized_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_get(self, ldp_neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_neighbors: neighbor_ldpid, labelspaceid
    :param ldp_neighbors: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **ldp_neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **ldp_neighbors** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_neighbors', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_neighbors=ldp_neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_neighbors=ldp_neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_configured_hold_time_get(self, ldp_neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_neighbors: neighbor_ldpid, labelspaceid
    :param ldp_neighbors: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **ldp_neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **ldp_neighbors** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_neighbors', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_neighbors=ldp_neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_neighbors=ldp_neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_interface_name_get(self, ldp_neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_neighbors: neighbor_ldpid, labelspaceid
    :param ldp_neighbors: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **ldp_neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **ldp_neighbors** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_neighbors', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_neighbors=ldp_neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_neighbors=ldp_neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_max_hold_time_get(self, ldp_neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_neighbors: neighbor_ldpid, labelspaceid
    :param ldp_neighbors: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **ldp_neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **ldp_neighbors** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_neighbors', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_neighbors=ldp_neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_neighbors=ldp_neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_get(self, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_ldpid, labelspaceid
    :param neighbor: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **neighbor** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_neighbors.neighbor', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_configured_hold_time_get(self, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_ldpid, labelspaceid
    :param neighbor: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **neighbor** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_neighbors.neighbor', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_interface_name_get(self, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_ldpid, labelspaceid
    :param neighbor: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **neighbor** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_neighbors.neighbor', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_max_hold_time_get(self, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_ldpid, labelspaceid
    :param neighbor: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **neighbor** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_neighbors.neighbor', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_neighbor_proposed_hold_time_get(self, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_ldpid, labelspaceid
    :param neighbor: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **neighbor** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_neighbors.neighbor', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_neighbor_transport_get(self, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_ldpid, labelspaceid
    :param neighbor: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **neighbor** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_neighbors.neighbor', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_proposed_hold_time_get(self, ldp_neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_neighbors: neighbor_ldpid, labelspaceid
    :param ldp_neighbors: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **ldp_neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **ldp_neighbors** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_neighbors', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_neighbors=ldp_neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_neighbors=ldp_neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_time_left_get(self, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_ldpid, labelspaceid
    :param neighbor: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **neighbor** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_neighbors.neighbor', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_transport_get(self, ldp_neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_neighbors: neighbor_ldpid, labelspaceid
    :param ldp_neighbors: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **ldp_neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **ldp_neighbors** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_neighbors', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_neighbors=ldp_neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_neighbors=ldp_neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_neighbor_up_time_get(self, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_ldpid, labelspaceid
    :param neighbor: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **neighbor** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_neighbors.neighbor', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_num_link_neighbors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_neighbors', u'neighbor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_num_targeted_neighbors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_neighbors', u'neighbor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_time_left_get(self, ldp_neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_neighbors: neighbor_ldpid, labelspaceid
    :param ldp_neighbors: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **ldp_neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **ldp_neighbors** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_neighbors', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_neighbors=ldp_neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_neighbors=ldp_neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_neighbors_up_time_get(self, ldp_neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ldp_neighbors: neighbor_ldpid, labelspaceid
    :param ldp_neighbors: Keyword argument tuple.

    :type neighbor_ldpid: unicode
    :param neighbor_ldpid: **ldp_neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type labelspaceid: int
    :param labelspaceid: **ldp_neighbors** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_neighbors', 'keyval': 'neighbor_ldpid, labelspaceid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_neighbors=ldp_neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_neighbors=ldp_neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_advertise_fecs_for_prefix_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_advertise_fecs_for_prefix_list_exists_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_end_of_lib_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_eol_notification_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_fec_128_used_for_auto_disc_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_fec_128_used_for_auto_disc_current_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_forwarding_state_timer_remaining_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_forwarding_state_timer_running_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_gr_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_gr_helper_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_gr_max_peer_reconnect_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_gr_max_peer_recovery_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_gr_reconnect_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_gr_recovery_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_hello_interval_link_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_hello_interval_target_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_hold_time_sent_link_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_hold_time_sent_target_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_inbound_fecs_filtering_prefix_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_inbound_fecs_filtering_prefix_list_exists_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_ka_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_ka_multiple_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_ka_timeout_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_ka_timeout_default_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_ldp_initialized_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_load_sharing_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_loopback_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_lsr_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_lsr_id_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_lwd_default_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_lwd_delay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_outbound_fecs_filtering_prefix_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_outbound_fecs_filtering_prefix_list_exists_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_rx_silence_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_tunnel_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_out_tx_silence_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"local_ldp_id": "local_ldp_id", "eol_notification_time_remaining": "eol_notification_time_remaining", "entity_index": "entity_index", "remote_state": "remote_state", "peer_recovery_time": "peer_recovery_time", "time_left": "time_left", "targeted_adj_added": "targeted_adj_added", "local_state": "local_state", "local_lblspc_id": "local_lblspc_id", "recovery_time_remaining": "recovery_time_remaining", "filter_prefix_list_exists": "filter_prefix_list_exists", "eol_rx_label_silence_time": "eol_rx_label_silence_time", "session_up_time": "session_up_time", "peer_proposed_keepalive_timeout": "peer_proposed_keepalive_timeout", "gr_enabled": "gr_enabled", "md5_auth_key": "md5_auth_key", "recovery_time_in_use": "recovery_time_in_use", "local_keepalive_timeout": "local_keepalive_timeout", "peer_ldp_id": "peer_ldp_id", "state": "state", "role": "role", "tcp_state": "tcp_state", "peer_reconnect_time": "peer_reconnect_time", "num_fecs_filtered_out": "num_fecs_filtered_out", "reconnect_time_in_use": "reconnect_time_in_use", "next_keepalive": "next_keepalive", "adjacency": "adjacency", "tcp_conn_remote": "tcp_conn_remote", "num_fecs_filtered_in": "num_fecs_filtered_in", "session_status": "session_status", "filter_prefix_list_name": "filter_prefix_list_name", "is_retry": "is_retry", "reconnect_time_remaining": "reconnect_time_remaining", "does_session_support_eol": "does_session_support_eol", "eol_rx_label_silence_time_remaining": "eol_rx_label_silence_time_remaining", "peer_lblspc_id": "peer_lblspc_id", "gr_state": "gr_state", "num_fecs_received_from_peer": "num_fecs_received_from_peer", "eol_notification_time": "eol_notification_time", "max_hold": "max_hold", "keepalive_interval": "keepalive_interval", "filtered": "filtered", "next_retry": "next_retry", "is_fecs_pending_uninstall": "is_fecs_pending_uninstall", "eol_tx_label_silence_time": "eol_tx_label_silence_time", "remote_eol_unrecognized_notification": "remote_eol_unrecognized_notification", "tcp_conn_local": "tcp_conn_local", "is_only_gr_valid": "is_only_gr_valid", "local_eol_unrecognized_notification": "local_eol_unrecognized_notification", "eol_tx_label_silence_time_remaining": "eol_tx_label_silence_time_remaining", "num_fecs_installed_from_peer": "num_fecs_installed_from_peer"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {"local_ldp_id": "local_ldp_id", "eol_notification_time_remaining": "eol_notification_time_remaining", "entity_index": "entity_index", "remote_state": "remote_state", "peer_recovery_time": "peer_recovery_time", "time_left": "time_left", "targeted_adj_added": "targeted_adj_added", "local_state": "local_state", "local_lblspc_id": "local_lblspc_id", "recovery_time_remaining": "recovery_time_remaining", "filter_prefix_list_exists": "filter_prefix_list_exists", "eol_rx_label_silence_time": "eol_rx_label_silence_time", "session_up_time": "session_up_time", "peer_proposed_keepalive_timeout": "peer_proposed_keepalive_timeout", "gr_enabled": "gr_enabled", "md5_auth_key": "md5_auth_key", "recovery_time_in_use": "recovery_time_in_use", "local_keepalive_timeout": "local_keepalive_timeout", "peer_ldp_id": "peer_ldp_id", "state": "state", "role": "role", "tcp_state": "tcp_state", "peer_reconnect_time": "peer_reconnect_time", "num_fecs_filtered_out": "num_fecs_filtered_out", "reconnect_time_in_use": "reconnect_time_in_use", "next_keepalive": "next_keepalive", "adjacency": "adjacency", "tcp_conn_remote": "tcp_conn_remote", "num_fecs_filtered_in": "num_fecs_filtered_in", "session_status": "session_status", "filter_prefix_list_name": "filter_prefix_list_name", "is_retry": "is_retry", "reconnect_time_remaining": "reconnect_time_remaining", "does_session_support_eol": "does_session_support_eol", "eol_rx_label_silence_time_remaining": "eol_rx_label_silence_time_remaining", "gr_state": "gr_state", "num_fecs_received_from_peer": "num_fecs_received_from_peer", "eol_notification_time": "eol_notification_time", "max_hold": "max_hold", "keepalive_interval": "keepalive_interval", "filtered": "filtered", "next_retry": "next_retry", "is_fecs_pending_uninstall": "is_fecs_pending_uninstall", "eol_tx_label_silence_time": "eol_tx_label_silence_time", "remote_eol_unrecognized_notification": "remote_eol_unrecognized_notification", "tcp_conn_local": "tcp_conn_local", "is_only_gr_valid": "is_only_gr_valid", "local_eol_unrecognized_notification": "local_eol_unrecognized_notification", "eol_tx_label_silence_time_remaining": "eol_tx_label_silence_time_remaining", "num_fecs_installed_from_peer": "num_fecs_installed_from_peer"}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"local_ldp_id": "local_ldp_id", "eol_notification_time_remaining": "eol_notification_time_remaining", "entity_index": "entity_index", "remote_state": "remote_state", "peer_recovery_time": "peer_recovery_time", "time_left": "time_left", "targeted_adj_added": "targeted_adj_added", "local_state": "local_state", "local_lblspc_id": "local_lblspc_id", "recovery_time_remaining": "recovery_time_remaining", "filter_prefix_list_exists": "filter_prefix_list_exists", "eol_rx_label_silence_time": "eol_rx_label_silence_time", "session_up_time": "session_up_time", "peer_proposed_keepalive_timeout": "peer_proposed_keepalive_timeout", "gr_enabled": "gr_enabled", "md5_auth_key": "md5_auth_key", "recovery_time_in_use": "recovery_time_in_use", "local_keepalive_timeout": "local_keepalive_timeout", "peer_ldp_id": "peer_ldp_id", "state": "state", "role": "role", "tcp_state": "tcp_state", "peer_reconnect_time": "peer_reconnect_time", "num_fecs_filtered_out": "num_fecs_filtered_out", "reconnect_time_in_use": "reconnect_time_in_use", "next_keepalive": "next_keepalive", "adjacency": "adjacency", "tcp_conn_remote": "tcp_conn_remote", "num_fecs_filtered_in": "num_fecs_filtered_in", "session_status": "session_status", "filter_prefix_list_name": "filter_prefix_list_name", "is_retry": "is_retry", "reconnect_time_remaining": "reconnect_time_remaining", "does_session_support_eol": "does_session_support_eol", "eol_rx_label_silence_time_remaining": "eol_rx_label_silence_time_remaining", "peer_lblspc_id": "peer_lblspc_id", "gr_state": "gr_state", "num_fecs_received_from_peer": "num_fecs_received_from_peer", "eol_notification_time": "eol_notification_time", "max_hold": "max_hold", "keepalive_interval": "keepalive_interval", "filtered": "filtered", "next_retry": "next_retry", "is_fecs_pending_uninstall": "is_fecs_pending_uninstall", "eol_tx_label_silence_time": "eol_tx_label_silence_time", "remote_eol_unrecognized_notification": "remote_eol_unrecognized_notification", "tcp_conn_local": "tcp_conn_local", "is_only_gr_valid": "is_only_gr_valid", "local_eol_unrecognized_notification": "local_eol_unrecognized_notification", "eol_tx_label_silence_time_remaining": "eol_tx_label_silence_time_remaining", "num_fecs_installed_from_peer": "num_fecs_installed_from_peer"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_adjacency_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "adjacency": "adjacency"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "adjacency": "adjacency"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_does_session_support_eol_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "does_session_support_eol": "does_session_support_eol"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "does_session_support_eol": "does_session_support_eol"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_entity_index_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "entity_index": "entity_index"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "entity_index": "entity_index"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_eol_notification_time_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "eol_notification_time": "eol_notification_time"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "eol_notification_time": "eol_notification_time"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_eol_notification_time_remaining_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"eol_notification_time_remaining": "eol_notification_time_remaining", "peer_ldp_id": "peer_ldp_id"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"eol_notification_time_remaining": "eol_notification_time_remaining", "peer_ldp_id": "peer_ldp_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_eol_rx_label_silence_time_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "eol_rx_label_silence_time": "eol_rx_label_silence_time"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "eol_rx_label_silence_time": "eol_rx_label_silence_time"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_eol_rx_label_silence_time_remaining_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"eol_rx_label_silence_time_remaining": "eol_rx_label_silence_time_remaining", "peer_ldp_id": "peer_ldp_id"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"eol_rx_label_silence_time_remaining": "eol_rx_label_silence_time_remaining", "peer_ldp_id": "peer_ldp_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_eol_tx_label_silence_time_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "eol_tx_label_silence_time": "eol_tx_label_silence_time"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "eol_tx_label_silence_time": "eol_tx_label_silence_time"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_eol_tx_label_silence_time_remaining_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "eol_tx_label_silence_time_remaining": "eol_tx_label_silence_time_remaining"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "eol_tx_label_silence_time_remaining": "eol_tx_label_silence_time_remaining"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filter_prefix_list_exists_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "filter_prefix_list_exists": "filter_prefix_list_exists"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "filter_prefix_list_exists": "filter_prefix_list_exists"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filter_prefix_list_name_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "filter_prefix_list_name": "filter_prefix_list_name"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "filter_prefix_list_name": "filter_prefix_list_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filtered_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "filtered": "filtered"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "filtered": "filtered"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filtered_fecs_in_get(self, ldp_session=None, filtered_fecs_in=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type filtered_fecs_in: fec_addr
    :param filtered_fecs_in: Keyword argument tuple.

    :type fec_addr: unicode
    :param fec_addr: **filtered_fecs_in** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.filtered_fecs_in', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.filtered_fecs_in', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.filtered_fecs_in', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id, peer_label_space_id', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'filtered_fecs_in', 'keyval': 'fec_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.filtered_fecs_in": {"fec_addr": "fec_addr", "prefix_len": "prefix_len", "label": "label"}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.filtered_fecs_in": {"fec_addr": "fec_addr", "prefix_len": "prefix_len", "label": "label"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.filtered_fecs_in": {"fec_addr": "fec_addr", "label": "label"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, filtered_fecs_in=filtered_fecs_in)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, filtered_fecs_in=filtered_fecs_in)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filtered_fecs_in_label_get(self, ldp_session=None, filtered_fecs_in=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type filtered_fecs_in: fec_addr
    :param filtered_fecs_in: Keyword argument tuple.

    :type fec_addr: unicode
    :param fec_addr: **filtered_fecs_in** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.filtered_fecs_in', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.filtered_fecs_in', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.filtered_fecs_in', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id, peer_label_space_id', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'filtered_fecs_in', 'keyval': 'fec_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.filtered_fecs_in": {"fec_addr": "fec_addr", "label": "label"}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.filtered_fecs_in": {"fec_addr": "fec_addr", "label": "label"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.filtered_fecs_in": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, filtered_fecs_in=filtered_fecs_in)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, filtered_fecs_in=filtered_fecs_in)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filtered_fecs_in_prefix_len_get(self, ldp_session=None, filtered_fecs_in=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type filtered_fecs_in: fec_addr
    :param filtered_fecs_in: Keyword argument tuple.

    :type fec_addr: unicode
    :param fec_addr: **filtered_fecs_in** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.filtered_fecs_in', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.filtered_fecs_in', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'filtered_fecs_in', 'keyval': 'fec_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, filtered_fecs_in=filtered_fecs_in)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, filtered_fecs_in=filtered_fecs_in)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filtered_fecs_out_get(self, ldp_session=None, filtered_fecs_out=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type filtered_fecs_out: fec_addr
    :param filtered_fecs_out: Keyword argument tuple.

    :type fec_addr: unicode
    :param fec_addr: **filtered_fecs_out** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.filtered_fecs_out', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.filtered_fecs_out', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.filtered_fecs_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id, peer_label_space_id', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'filtered_fecs_out', 'keyval': 'fec_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.filtered_fecs_out": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.filtered_fecs_out": {"fec_addr": "fec_addr", "prefix_len": "prefix_len", "label": "label"}, "pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.filtered_fecs_out": {"fec_addr": "fec_addr", "prefix_len": "prefix_len", "label": "label"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, filtered_fecs_out=filtered_fecs_out)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, filtered_fecs_out=filtered_fecs_out)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filtered_fecs_out_label_get(self, ldp_session=None, filtered_fecs_out=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type filtered_fecs_out: fec_addr
    :param filtered_fecs_out: Keyword argument tuple.

    :type fec_addr: unicode
    :param fec_addr: **filtered_fecs_out** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.filtered_fecs_out', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.filtered_fecs_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'filtered_fecs_out', 'keyval': 'fec_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, filtered_fecs_out=filtered_fecs_out)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, filtered_fecs_out=filtered_fecs_out)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_filtered_fecs_out_prefix_len_get(self, ldp_session=None, filtered_fecs_out=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type filtered_fecs_out: fec_addr
    :param filtered_fecs_out: Keyword argument tuple.

    :type fec_addr: unicode
    :param fec_addr: **filtered_fecs_out** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.filtered_fecs_out', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.filtered_fecs_out', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'filtered_fecs_out', 'keyval': 'fec_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, filtered_fecs_out=filtered_fecs_out)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, filtered_fecs_out=filtered_fecs_out)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_gr_enabled_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "gr_enabled": "gr_enabled"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "gr_enabled": "gr_enabled"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_gr_state_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "gr_state": "gr_state"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "gr_state": "gr_state"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_is_fecs_pending_uninstall_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "is_fecs_pending_uninstall": "is_fecs_pending_uninstall"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "is_fecs_pending_uninstall": "is_fecs_pending_uninstall"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_is_only_gr_valid_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"is_only_gr_valid": "is_only_gr_valid", "peer_ldp_id": "peer_ldp_id"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"is_only_gr_valid": "is_only_gr_valid", "peer_ldp_id": "peer_ldp_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_is_retry_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "is_retry": "is_retry"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "is_retry": "is_retry"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_keepalive_interval_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"keepalive_interval": "keepalive_interval", "peer_ldp_id": "peer_ldp_id"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"keepalive_interval": "keepalive_interval", "peer_ldp_id": "peer_ldp_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_local_eol_unrecognized_notification_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "local_eol_unrecognized_notification": "local_eol_unrecognized_notification"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "local_eol_unrecognized_notification": "local_eol_unrecognized_notification"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_local_keepalive_timeout_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "local_keepalive_timeout": "local_keepalive_timeout"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "local_keepalive_timeout": "local_keepalive_timeout"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_local_lblspc_id_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "local_lblspc_id": "local_lblspc_id"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "local_lblspc_id": "local_lblspc_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_local_ldp_id_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"local_ldp_id": "local_ldp_id", "peer_ldp_id": "peer_ldp_id"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"local_ldp_id": "local_ldp_id", "peer_ldp_id": "peer_ldp_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_local_state_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"local_state": "local_state", "peer_ldp_id": "peer_ldp_id"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"local_state": "local_state", "peer_ldp_id": "peer_ldp_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_max_hold_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "max_hold": "max_hold"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "max_hold": "max_hold"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_md5_auth_key_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "md5_auth_key": "md5_auth_key"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "md5_auth_key": "md5_auth_key"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_next_keepalive_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "next_keepalive": "next_keepalive"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "next_keepalive": "next_keepalive"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_next_retry_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "next_retry": "next_retry"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "next_retry": "next_retry"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_num_fecs_filtered_in_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "num_fecs_filtered_in": "num_fecs_filtered_in"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "num_fecs_filtered_in": "num_fecs_filtered_in"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_num_fecs_filtered_out_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"num_fecs_filtered_out": "num_fecs_filtered_out", "peer_ldp_id": "peer_ldp_id"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"num_fecs_filtered_out": "num_fecs_filtered_out", "peer_ldp_id": "peer_ldp_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_num_fecs_installed_from_peer_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "num_fecs_installed_from_peer": "num_fecs_installed_from_peer"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "num_fecs_installed_from_peer": "num_fecs_installed_from_peer"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_num_fecs_received_from_peer_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "num_fecs_received_from_peer": "num_fecs_received_from_peer"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "num_fecs_received_from_peer": "num_fecs_received_from_peer"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_peer_lblspc_id_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_peer_proposed_keepalive_timeout_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "peer_proposed_keepalive_timeout": "peer_proposed_keepalive_timeout"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "peer_proposed_keepalive_timeout": "peer_proposed_keepalive_timeout"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_peer_reconnect_time_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "peer_reconnect_time": "peer_reconnect_time"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "peer_reconnect_time": "peer_reconnect_time"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_peer_recovery_time_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_recovery_time": "peer_recovery_time", "peer_ldp_id": "peer_ldp_id"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_recovery_time": "peer_recovery_time", "peer_ldp_id": "peer_ldp_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_reconnect_time_in_use_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "reconnect_time_in_use": "reconnect_time_in_use"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "reconnect_time_in_use": "reconnect_time_in_use"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_reconnect_time_remaining_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "reconnect_time_remaining": "reconnect_time_remaining"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "reconnect_time_remaining": "reconnect_time_remaining"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_recovery_time_in_use_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "recovery_time_in_use": "recovery_time_in_use"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "recovery_time_in_use": "recovery_time_in_use"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_recovery_time_remaining_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "recovery_time_remaining": "recovery_time_remaining"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "recovery_time_remaining": "recovery_time_remaining"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_remote_eol_unrecognized_notification_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "remote_eol_unrecognized_notification": "remote_eol_unrecognized_notification"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "remote_eol_unrecognized_notification": "remote_eol_unrecognized_notification"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_remote_state_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"remote_state": "remote_state", "peer_ldp_id": "peer_ldp_id"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"remote_state": "remote_state", "peer_ldp_id": "peer_ldp_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_role_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "role": "role"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "role": "role"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id, peer_label_space_id', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_ldp_protocol_errors_instance_total_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_ldp_protocol_errors_instance_total_protocol_errors_get(self, ldp_session=None, protocol_errors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type protocol_errors: error_type
    :param protocol_errors: Keyword argument tuple.

    :type error_type: long
    :param error_type: **protocol_errors** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total.protocol_errors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_errors', 'keyval': 'error_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_errors=protocol_errors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_errors=protocol_errors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_ldp_protocol_errors_instance_total_protocol_errors_count_get(self, ldp_session=None, protocol_errors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type protocol_errors: error_type
    :param protocol_errors: Keyword argument tuple.

    :type error_type: long
    :param error_type: **protocol_errors** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total.protocol_errors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_errors', 'keyval': 'error_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_errors=protocol_errors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_errors=protocol_errors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_ldp_protocol_stats_instance_total_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_ldp_protocol_stats_instance_total_protocol_stats_get(self, ldp_session=None, protocol_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total.protocol_stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_stats=protocol_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_ldp_protocol_stats_instance_total_protocol_stats_rx_count_get(self, ldp_session=None, protocol_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total.protocol_stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_stats=protocol_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_ldp_protocol_stats_instance_total_protocol_stats_tx_count_get(self, ldp_session=None, protocol_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total.protocol_stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_stats=protocol_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_protocol_errors_get(self, ldp_session=None, protocol_errors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type protocol_errors: stats_group
    :param protocol_errors: Keyword argument tuple.

    :type stats_group: unicode
    :param stats_group: **protocol_errors** tuple argument.

        * enumeration restriction: ::

            ['global-stats-all',
            'per-session-stats',
            'global-stats-since-last-clear']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_errors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_errors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_errors', u'protocol_error'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_errors', u'protocol_error')]
    compositions_keyval_list = [{'keyval': 'peer_ldp_id, peer_label_space_id', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_errors', 'keyval': 'stats_group', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'error_type, count'}, {'leafval': 'error_type, count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_errors=protocol_errors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_errors=protocol_errors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_protocol_errors_protocol_error_get(self, ldp_session=None, protocol_errors=None, protocol_error=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type protocol_errors: stats_group
    :param protocol_errors: Keyword argument tuple.

    :type stats_group: unicode
    :param stats_group: **protocol_errors** tuple argument.

        * enumeration restriction: ::

            ['global-stats-all',
            'per-session-stats',
            'global-stats-since-last-clear']

    **Instance Keyword Argument Tuple**:

    :type protocol_error: error_type
    :param protocol_error: Keyword argument tuple.

    :type error_type: long
    :param error_type: **protocol_error** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_errors', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_errors', u'protocol_errors')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_errors.protocol_error', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_errors.protocol_error', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}, {'keyval': 'stats_group', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id, peer_label_space_id', 'extra_keyval': ''}, {'keyval': 'stats_group', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_error', 'keyval': 'error_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_errors=protocol_errors, protocol_error=protocol_error)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_errors=protocol_errors, protocol_error=protocol_error)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_protocol_errors_protocol_error_count_get(self, ldp_session=None, protocol_errors=None, protocol_error=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type protocol_errors: stats_group
    :param protocol_errors: Keyword argument tuple.

    :type stats_group: unicode
    :param stats_group: **protocol_errors** tuple argument.

        * enumeration restriction: ::

            ['global-stats-all',
            'per-session-stats',
            'global-stats-since-last-clear']

    **Instance Keyword Argument Tuple**:

    :type protocol_error: error_type
    :param protocol_error: Keyword argument tuple.

    :type error_type: long
    :param error_type: **protocol_error** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_errors', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_errors', u'protocol_errors')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_errors.protocol_error', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_errors.protocol_error', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}, {'keyval': 'stats_group', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id, peer_label_space_id', 'extra_keyval': ''}, {'keyval': 'stats_group', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_error', 'keyval': 'error_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_errors=protocol_errors, protocol_error=protocol_error)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_errors=protocol_errors, protocol_error=protocol_error)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_protocol_stats_get(self, ldp_session=None, protocol_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stats_group
    :param protocol_stats: Keyword argument tuple.

    :type stats_group: unicode
    :param stats_group: **protocol_stats** tuple argument.

        * enumeration restriction: ::

            ['global-stats-all',
            'per-session-stats',
            'global-stats-since-last-clear']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'ldp_session')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_stats', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_stats', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_stats', u'protocol_stat'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_stats', u'protocol_stat')]
    compositions_keyval_list = [{'keyval': 'peer_ldp_id', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id, peer_label_space_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stats_group', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'stat_type, rx_count, tx_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_stats=protocol_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_protocol_stats_protocol_stat_get(self, ldp_session=None, protocol_stats=None, protocol_stat=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type protocol_stats: stats_group
    :param protocol_stats: Keyword argument tuple.

    :type stats_group: unicode
    :param stats_group: **protocol_stats** tuple argument.

        * enumeration restriction: ::

            ['global-stats-all',
            'per-session-stats',
            'global-stats-since-last-clear']

    **Instance Keyword Argument Tuple**:

    :type protocol_stat: stat_type
    :param protocol_stat: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stat** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_stats', u'protocol_stats')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_stats.protocol_stat', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_stats.protocol_stat', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id, peer_label_space_id', 'extra_keyval': ''}, {'keyval': 'stats_group', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id', 'extra_keyval': ''}, {'keyval': 'stats_group', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_stat', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_stats=protocol_stats, protocol_stat=protocol_stat)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_stats=protocol_stats, protocol_stat=protocol_stat)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_protocol_stats_protocol_stat_rx_count_get(self, ldp_session=None, protocol_stats=None, protocol_stat=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type protocol_stats: stats_group
    :param protocol_stats: Keyword argument tuple.

    :type stats_group: unicode
    :param stats_group: **protocol_stats** tuple argument.

        * enumeration restriction: ::

            ['global-stats-all',
            'per-session-stats',
            'global-stats-since-last-clear']

    **Instance Keyword Argument Tuple**:

    :type protocol_stat: stat_type
    :param protocol_stat: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stat** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_stats', u'protocol_stats')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_stats.protocol_stat', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_stats.protocol_stat', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id, peer_label_space_id', 'extra_keyval': ''}, {'keyval': 'stats_group', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id', 'extra_keyval': ''}, {'keyval': 'stats_group', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_stat', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_stats=protocol_stats, protocol_stat=protocol_stat)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_stats=protocol_stats, protocol_stat=protocol_stat)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_ldp_stats_protocol_stats_protocol_stat_tx_count_get(self, ldp_session=None, protocol_stats=None, protocol_stat=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type protocol_stats: stats_group
    :param protocol_stats: Keyword argument tuple.

    :type stats_group: unicode
    :param stats_group: **protocol_stats** tuple argument.

        * enumeration restriction: ::

            ['global-stats-all',
            'per-session-stats',
            'global-stats-since-last-clear']

    **Instance Keyword Argument Tuple**:

    :type protocol_stat: stat_type
    :param protocol_stat: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stat** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_stats', u'protocol_stats')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_stats.protocol_stat', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats.protocol_stats.protocol_stat', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'peer_ldp_id, peer_label_space_id', 'extra_keyval': ''}, {'keyval': 'stats_group', 'extra_keyval': ''}, {'keyval': 'peer_ldp_id', 'extra_keyval': ''}, {'keyval': 'stats_group', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_stat', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session, protocol_stats=protocol_stats, protocol_stat=protocol_stat)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session, protocol_stats=protocol_stats, protocol_stat=protocol_stat)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_status_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "session_status": "session_status"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "session_status": "session_status"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_session_up_time_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "session_up_time": "session_up_time"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "session_up_time": "session_up_time"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_state_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "state": "state"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "state": "state"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_summary_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_summary_num_link_sessions_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_summary_num_operational_link_sessions_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_summary_num_operational_targeted_sessions_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_summary_num_targeted_sessions_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session_summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_targeted_adj_added_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "targeted_adj_added": "targeted_adj_added"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "targeted_adj_added": "targeted_adj_added"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_tcp_conn_local_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"tcp_conn_local": "tcp_conn_local", "peer_ldp_id": "peer_ldp_id"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"tcp_conn_local": "tcp_conn_local", "peer_ldp_id": "peer_ldp_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_tcp_conn_remote_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "tcp_conn_remote": "tcp_conn_remote"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "tcp_conn_remote": "tcp_conn_remote"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_tcp_state_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "tcp_state": "tcp_state"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "tcp_state": "tcp_state"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_ldp_session_time_left_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: peer_ldp_id
    :param ldp_session: Keyword argument tuple.

    :type peer_ldp_id: unicode
    :param peer_ldp_id: **ldp_session** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session', u'filtered_fecs_out'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session.session_ldp_stats', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_in'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session.session_ldp_stats.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session', u'filtered_fecs_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'peer_ldp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, fec_type, label'}, {'leafval': 'fec_addr, fec_type'}, {'leafval': 'stats_group'}, {'leafval': 'fec_addr, label, prefix_len'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'fec_addr, label, prefix_len'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "time_left": "time_left"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.ldp_session": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.ldp_session": {"peer_ldp_id": "peer_ldp_id", "time_left": "time_left"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_load_sharing_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_loopback_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_lsps_operational_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_lsr_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_lsr_id_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_lwd_default_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_lwd_delay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_outbound_fecs_filtering_prefix_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_outbound_fecs_filtering_prefix_list_exists_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_path_get(self, path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type path: path_key
    :param path: Keyword argument tuple.

    :type path_key: long
    :param path_key: **path** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.path', u'downstream_sessions'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.path', u'upstream_sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.path', u'upstream_sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.path', u'downstream_sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.path', u'upstream_sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.path', u'downstream_sessions')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'path', 'keyval': 'path_key', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip, labelspace, label, interface'}, {'leafval': 'ip, labelspace, label, interface'}, {'leafval': 'ip, labelspace, label'}, {'leafval': 'ip, interface, labelspace, label'}, {'leafval': 'ip, labelspace, label'}, {'leafval': 'ip, interface, labelspace, label'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.ldp.path": {"destination_route": "destination_route", "path_key": "path_key"}, "pybind.slxos.v17s_1_02.mpls_state.ldp.path": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.path": {"destination_route": "destination_route", "path_key": "path_key"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_path_destination_route_get(self, path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type path: path_key
    :param path: Keyword argument tuple.

    :type path_key: long
    :param path_key: **path** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.path', u'upstream_sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.path', u'downstream_sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.path', u'upstream_sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.path', u'downstream_sessions')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'path', 'keyval': 'path_key', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip, labelspace, label'}, {'leafval': 'ip, interface, labelspace, label'}, {'leafval': 'ip, labelspace, label'}, {'leafval': 'ip, interface, labelspace, label'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_path_downstream_sessions_get(self, path=None, downstream_sessions=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_key
    :param path: Keyword argument tuple.

    :type path_key: long
    :param path_key: **path** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type downstream_sessions: ip, interface
    :param downstream_sessions: Keyword argument tuple.

    :type ip: unicode
    :param ip: **downstream_sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface: unicode
    :param interface: **downstream_sessions** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.path', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.path', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.path', u'path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.path.downstream_sessions', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.path.downstream_sessions', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.path.downstream_sessions', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination_route', 'extra_keyval': ''}, {'keyval': 'path_key', 'extra_keyval': ''}, {'keyval': 'path_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream_sessions', 'keyval': 'ip, interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.mpls_state.ldp.path.downstream_sessions": {"interface": "interface", "ip": "ip", "labelspace": "labelspace", "label": "label"}, "pybind.slxos.v17s_1_02.mpls_state.ldp.path.downstream_sessions": {"interface": "interface", "ip": "ip", "labelspace": "labelspace", "label": "label"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.path.downstream_sessions": {"interface": "interface", "ip": "ip", "labelspace": "labelspace", "label": "label"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, downstream_sessions=downstream_sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, downstream_sessions=downstream_sessions)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_path_downstream_sessions_interface_get(self, path=None, downstream_sessions=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: destination_route
    :param path: Keyword argument tuple.

    :type destination_route: unicode
    :param destination_route: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type downstream_sessions: ip
    :param downstream_sessions: Keyword argument tuple.

    :type ip: unicode
    :param ip: **downstream_sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.path', u'path')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.path.downstream_sessions', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination_route', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream_sessions', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, downstream_sessions=downstream_sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, downstream_sessions=downstream_sessions)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_path_downstream_sessions_label_get(self, path=None, downstream_sessions=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_key
    :param path: Keyword argument tuple.

    :type path_key: long
    :param path_key: **path** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type downstream_sessions: ip, interface
    :param downstream_sessions: Keyword argument tuple.

    :type ip: unicode
    :param ip: **downstream_sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface: unicode
    :param interface: **downstream_sessions** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.path', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.path', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.path', u'path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.path.downstream_sessions', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.path.downstream_sessions', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.path.downstream_sessions', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination_route', 'extra_keyval': ''}, {'keyval': 'path_key', 'extra_keyval': ''}, {'keyval': 'path_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream_sessions', 'keyval': 'ip, interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.mpls_state.ldp.path.downstream_sessions": {"interface": "interface", "ip": "ip", "label": "label"}, "pybind.slxos.v17s_1_02.mpls_state.ldp.path.downstream_sessions": {}, "pybind.slxos.v17r_2_00.mpls_state.ldp.path.downstream_sessions": {"interface": "interface", "ip": "ip", "label": "label"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, downstream_sessions=downstream_sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, downstream_sessions=downstream_sessions)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_path_downstream_sessions_labelspace_get(self, path=None, downstream_sessions=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_key
    :param path: Keyword argument tuple.

    :type path_key: long
    :param path_key: **path** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type downstream_sessions: ip, interface
    :param downstream_sessions: Keyword argument tuple.

    :type ip: unicode
    :param ip: **downstream_sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type interface: unicode
    :param interface: **downstream_sessions** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.path', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.path', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.path', u'path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.path.downstream_sessions', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.path.downstream_sessions', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.path.downstream_sessions', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination_route', 'extra_keyval': ''}, {'keyval': 'path_key', 'extra_keyval': ''}, {'keyval': 'path_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'downstream_sessions', 'keyval': 'ip, interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.mpls_state.ldp.path.downstream_sessions": {"interface": "interface", "ip": "ip", "labelspace": "labelspace"}, "pybind.slxos.v17s_1_02.mpls_state.ldp.path.downstream_sessions": {}, "pybind.slxos.v17r_2_00.mpls_state.ldp.path.downstream_sessions": {"interface": "interface", "ip": "ip", "labelspace": "labelspace"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, downstream_sessions=downstream_sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, downstream_sessions=downstream_sessions)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_path_upstream_sessions_get(self, path=None, upstream_sessions=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_key
    :param path: Keyword argument tuple.

    :type path_key: long
    :param path_key: **path** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type upstream_sessions: ip
    :param upstream_sessions: Keyword argument tuple.

    :type ip: unicode
    :param ip: **upstream_sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.path', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.path', u'path'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.path', u'path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.path.upstream_sessions', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.path.upstream_sessions', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.path.upstream_sessions', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_key', 'extra_keyval': ''}, {'keyval': 'path_key', 'extra_keyval': ''}, {'keyval': 'destination_route', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'upstream_sessions', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.ldp.path.upstream_sessions": {}, "pybind.slxos.v17r_1_01a.mpls_state.ldp.path.upstream_sessions": {"ip": "ip", "labelspace": "labelspace", "label": "label"}, "pybind.slxos.v17r_2_00.mpls_state.ldp.path.upstream_sessions": {"ip": "ip", "labelspace": "labelspace", "label": "label"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, upstream_sessions=upstream_sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, upstream_sessions=upstream_sessions)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_path_upstream_sessions_interface_get(self, path=None, upstream_sessions=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: destination_route
    :param path: Keyword argument tuple.

    :type destination_route: unicode
    :param destination_route: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type upstream_sessions: ip
    :param upstream_sessions: Keyword argument tuple.

    :type ip: unicode
    :param ip: **upstream_sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.path', u'path')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.path.upstream_sessions', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destination_route', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'upstream_sessions', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, upstream_sessions=upstream_sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, upstream_sessions=upstream_sessions)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_path_upstream_sessions_label_get(self, path=None, upstream_sessions=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_key
    :param path: Keyword argument tuple.

    :type path_key: long
    :param path_key: **path** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type upstream_sessions: ip
    :param upstream_sessions: Keyword argument tuple.

    :type ip: unicode
    :param ip: **upstream_sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.path', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.path', u'path'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.path', u'path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.path.upstream_sessions', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.path.upstream_sessions', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.path.upstream_sessions', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_key', 'extra_keyval': ''}, {'keyval': 'path_key', 'extra_keyval': ''}, {'keyval': 'destination_route', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'upstream_sessions', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, upstream_sessions=upstream_sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, upstream_sessions=upstream_sessions)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_path_upstream_sessions_labelspace_get(self, path=None, upstream_sessions=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_key
    :param path: Keyword argument tuple.

    :type path_key: long
    :param path_key: **path** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type upstream_sessions: ip
    :param upstream_sessions: Keyword argument tuple.

    :type ip: unicode
    :param ip: **upstream_sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.path', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.path', u'path'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.path', u'path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.path.upstream_sessions', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.path.upstream_sessions', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.path.upstream_sessions', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_key', 'extra_keyval': ''}, {'keyval': 'path_key', 'extra_keyval': ''}, {'keyval': 'destination_route', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'upstream_sessions', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, upstream_sessions=upstream_sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, upstream_sessions=upstream_sessions)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_rx_silence_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_stats_instance_total', u'protocol_stats'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_errors_instance_total', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_errors_instance_since_clear', u'protocol_errors'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_stats_instance_since_clear', u'protocol_stats')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'stats_group'}, {'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'error_type, count'}, {'leafval': 'error_type, count'}, {'leafval': 'stat_type, rx_count, tx_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_errors_instance_since_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_errors_instance_since_clear', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_errors_instance_since_clear', u'protocol_errors')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'error_type, count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_errors_instance_since_clear_protocol_errors_get(self, protocol_errors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type protocol_errors: error_type
    :param protocol_errors: Keyword argument tuple.

    :type error_type: long
    :param error_type: **protocol_errors** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_errors_instance_since_clear.protocol_errors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_errors', 'keyval': 'error_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_errors=protocol_errors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_errors=protocol_errors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_errors_instance_since_clear_protocol_errors_count_get(self, protocol_errors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type protocol_errors: error_type
    :param protocol_errors: Keyword argument tuple.

    :type error_type: long
    :param error_type: **protocol_errors** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_errors_instance_since_clear.protocol_errors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_errors', 'keyval': 'error_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_errors=protocol_errors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_errors=protocol_errors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_errors_instance_total_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_errors_instance_total', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_errors_instance_total', u'protocol_errors')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'error_type, count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_errors_instance_total_protocol_errors_get(self, protocol_errors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type protocol_errors: error_type
    :param protocol_errors: Keyword argument tuple.

    :type error_type: long
    :param error_type: **protocol_errors** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_errors_instance_total.protocol_errors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_errors', 'keyval': 'error_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_errors=protocol_errors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_errors=protocol_errors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_errors_instance_total_protocol_errors_count_get(self, protocol_errors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type protocol_errors: error_type
    :param protocol_errors: Keyword argument tuple.

    :type error_type: long
    :param error_type: **protocol_errors** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_errors_instance_total.protocol_errors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_errors', 'keyval': 'error_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_errors=protocol_errors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_errors=protocol_errors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_stats_instance_since_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_stats_instance_since_clear', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_stats_instance_since_clear', u'protocol_stats')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'stat_type, rx_count, tx_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_stats_instance_since_clear_protocol_stats_get(self, protocol_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_stats_instance_since_clear.protocol_stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_stats=protocol_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_stats_instance_since_clear_protocol_stats_rx_count_get(self, protocol_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_stats_instance_since_clear.protocol_stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_stats=protocol_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_stats_instance_since_clear_protocol_stats_tx_count_get(self, protocol_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_stats_instance_since_clear.protocol_stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_stats=protocol_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_stats_instance_total_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_stats_instance_total', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_stats_instance_total', u'protocol_stats')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'stat_type, rx_count, tx_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_stats_instance_total_protocol_stats_get(self, protocol_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_stats_instance_total.protocol_stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_stats=protocol_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_stats_instance_total_protocol_stats_rx_count_get(self, protocol_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_stats_instance_total.protocol_stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_stats=protocol_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_ldp_protocol_stats_instance_total_protocol_stats_tx_count_get(self, protocol_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stat_type
    :param protocol_stats: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.statistics.ldp_protocol_stats_instance_total.protocol_stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_stats=protocol_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_protocol_errors_get(self, protocol_errors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type protocol_errors: stats_group
    :param protocol_errors: Keyword argument tuple.

    :type stats_group: unicode
    :param stats_group: **protocol_errors** tuple argument.

        * enumeration restriction: ::

            ['global-stats-all',
            'per-session-stats',
            'global-stats-since-last-clear']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics.protocol_errors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics.protocol_errors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics.protocol_errors', u'protocol_error'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics.protocol_errors', u'protocol_error')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_errors', 'keyval': 'stats_group', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'error_type, count'}, {'leafval': 'error_type, count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_errors=protocol_errors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_errors=protocol_errors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_protocol_errors_protocol_error_get(self, protocol_errors=None, protocol_error=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type protocol_errors: stats_group
    :param protocol_errors: Keyword argument tuple.

    :type stats_group: unicode
    :param stats_group: **protocol_errors** tuple argument.

        * enumeration restriction: ::

            ['global-stats-all',
            'per-session-stats',
            'global-stats-since-last-clear']

    **Instance Keyword Argument Tuple**:

    :type protocol_error: error_type
    :param protocol_error: Keyword argument tuple.

    :type error_type: long
    :param error_type: **protocol_error** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics.protocol_errors', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics.protocol_errors', u'protocol_errors')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics.protocol_errors.protocol_error', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics.protocol_errors.protocol_error', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'stats_group', 'extra_keyval': ''}, {'keyval': 'stats_group', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_error', 'keyval': 'error_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_errors=protocol_errors, protocol_error=protocol_error)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_errors=protocol_errors, protocol_error=protocol_error)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_protocol_errors_protocol_error_count_get(self, protocol_errors=None, protocol_error=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type protocol_errors: stats_group
    :param protocol_errors: Keyword argument tuple.

    :type stats_group: unicode
    :param stats_group: **protocol_errors** tuple argument.

        * enumeration restriction: ::

            ['global-stats-all',
            'per-session-stats',
            'global-stats-since-last-clear']

    **Instance Keyword Argument Tuple**:

    :type protocol_error: error_type
    :param protocol_error: Keyword argument tuple.

    :type error_type: long
    :param error_type: **protocol_error** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics.protocol_errors', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics.protocol_errors', u'protocol_errors')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics.protocol_errors.protocol_error', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics.protocol_errors.protocol_error', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'stats_group', 'extra_keyval': ''}, {'keyval': 'stats_group', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_error', 'keyval': 'error_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_errors=protocol_errors, protocol_error=protocol_error)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_errors=protocol_errors, protocol_error=protocol_error)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_protocol_stats_get(self, protocol_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type protocol_stats: stats_group
    :param protocol_stats: Keyword argument tuple.

    :type stats_group: unicode
    :param stats_group: **protocol_stats** tuple argument.

        * enumeration restriction: ::

            ['global-stats-all',
            'per-session-stats',
            'global-stats-since-last-clear']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics.protocol_stats', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics.protocol_stats', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics.protocol_stats', u'protocol_stat'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics.protocol_stats', u'protocol_stat')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'protocol_stats', 'keyval': 'stats_group', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'stat_type, rx_count, tx_count'}, {'leafval': 'stat_type, rx_count, tx_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_stats=protocol_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_stats=protocol_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_protocol_stats_protocol_stat_get(self, protocol_stats=None, protocol_stat=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type protocol_stats: stats_group
    :param protocol_stats: Keyword argument tuple.

    :type stats_group: unicode
    :param stats_group: **protocol_stats** tuple argument.

        * enumeration restriction: ::

            ['global-stats-all',
            'per-session-stats',
            'global-stats-since-last-clear']

    **Instance Keyword Argument Tuple**:

    :type protocol_stat: stat_type
    :param protocol_stat: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stat** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics.protocol_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics.protocol_stats', u'protocol_stats')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics.protocol_stats.protocol_stat', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics.protocol_stats.protocol_stat', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'stats_group', 'extra_keyval': ''}, {'keyval': 'stats_group', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_stat', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_stats=protocol_stats, protocol_stat=protocol_stat)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_stats=protocol_stats, protocol_stat=protocol_stat)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_protocol_stats_protocol_stat_rx_count_get(self, protocol_stats=None, protocol_stat=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type protocol_stats: stats_group
    :param protocol_stats: Keyword argument tuple.

    :type stats_group: unicode
    :param stats_group: **protocol_stats** tuple argument.

        * enumeration restriction: ::

            ['global-stats-all',
            'per-session-stats',
            'global-stats-since-last-clear']

    **Instance Keyword Argument Tuple**:

    :type protocol_stat: stat_type
    :param protocol_stat: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stat** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics.protocol_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics.protocol_stats', u'protocol_stats')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics.protocol_stats.protocol_stat', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics.protocol_stats.protocol_stat', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'stats_group', 'extra_keyval': ''}, {'keyval': 'stats_group', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_stat', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_stats=protocol_stats, protocol_stat=protocol_stat)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_stats=protocol_stats, protocol_stat=protocol_stat)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_statistics_protocol_stats_protocol_stat_tx_count_get(self, protocol_stats=None, protocol_stat=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type protocol_stats: stats_group
    :param protocol_stats: Keyword argument tuple.

    :type stats_group: unicode
    :param stats_group: **protocol_stats** tuple argument.

        * enumeration restriction: ::

            ['global-stats-all',
            'per-session-stats',
            'global-stats-since-last-clear']

    **Instance Keyword Argument Tuple**:

    :type protocol_stat: stat_type
    :param protocol_stat: Keyword argument tuple.

    :type stat_type: long
    :param stat_type: **protocol_stat** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics.protocol_stats', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics.protocol_stats', u'protocol_stats')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics.protocol_stats.protocol_stat', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics.protocol_stats.protocol_stat', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'stats_group', 'extra_keyval': ''}, {'keyval': 'stats_group', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'protocol_stat', 'keyval': 'stat_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, protocol_stats=protocol_stats, protocol_stat=protocol_stat)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, protocol_stats=protocol_stats, protocol_stat=protocol_stat)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_targeted_peer_get(self, targeted_peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type targeted_peer: mpls_ldp_targeted_peer_id
    :param targeted_peer: Keyword argument tuple.

    :type mpls_ldp_targeted_peer_id: unicode
    :param mpls_ldp_targeted_peer_id: **targeted_peer** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.targeted_peer', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.targeted_peer', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.targeted_peer', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'targeted_peer', 'keyval': 'mpls_ldp_targeted_peer_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, targeted_peer=targeted_peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, targeted_peer=targeted_peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_tunnel_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_tunnels_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_tunnels_ldp_tunnels_get(self, ldp_tunnels=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_tunnels: tunnel_destination, prefix_length
    :param ldp_tunnels: Keyword argument tuple.

    :type tunnel_destination: unicode
    :param tunnel_destination: **ldp_tunnels** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_length: long
    :param prefix_length: **ldp_tunnels** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_tunnels', 'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outgoing_interface, next_hop_ipaddress'}, {'leafval': 'outgoing_interface, next_hop_ipaddress'}, {'leafval': 'outgoing_interface, next_hop_ipaddress'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_tunnels=ldp_tunnels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_tunnels=ldp_tunnels)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_tunnels_ldp_tunnels_name_get(self, ldp_tunnels=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_tunnels: tunnel_destination, prefix_length
    :param ldp_tunnels: Keyword argument tuple.

    :type tunnel_destination: unicode
    :param tunnel_destination: **ldp_tunnels** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_length: long
    :param prefix_length: **ldp_tunnels** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_tunnels', 'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outgoing_interface, next_hop_ipaddress'}, {'leafval': 'outgoing_interface, next_hop_ipaddress'}, {'leafval': 'outgoing_interface, next_hop_ipaddress'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_tunnels=ldp_tunnels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_tunnels=ldp_tunnels)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_tunnels_ldp_tunnels_out_segments_get(self, ldp_tunnels=None, out_segments=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_tunnels: tunnel_destination, prefix_length
    :param ldp_tunnels: Keyword argument tuple.

    :type tunnel_destination: unicode
    :param tunnel_destination: **ldp_tunnels** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_length: long
    :param prefix_length: **ldp_tunnels** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type out_segments: outgoing_interface
    :param out_segments: Keyword argument tuple.

    :type outgoing_interface: unicode
    :param outgoing_interface: **out_segments** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels.ldp_tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels.ldp_tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels.ldp_tunnels', u'ldp_tunnels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels.ldp_tunnels.out_segments', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels.ldp_tunnels.out_segments', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels.ldp_tunnels.out_segments', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}, {'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}, {'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'out_segments', 'keyval': 'outgoing_interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_tunnels=ldp_tunnels, out_segments=out_segments)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_tunnels=ldp_tunnels, out_segments=out_segments)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_tunnels_ldp_tunnels_out_segments_next_hop_ipaddress_get(self, ldp_tunnels=None, out_segments=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ldp_tunnels: tunnel_destination, prefix_length
    :param ldp_tunnels: Keyword argument tuple.

    :type tunnel_destination: unicode
    :param tunnel_destination: **ldp_tunnels** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_length: long
    :param prefix_length: **ldp_tunnels** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type out_segments: outgoing_interface
    :param out_segments: Keyword argument tuple.

    :type outgoing_interface: unicode
    :param outgoing_interface: **out_segments** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels.ldp_tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels.ldp_tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels.ldp_tunnels', u'ldp_tunnels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels.ldp_tunnels.out_segments', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels.ldp_tunnels.out_segments', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels.ldp_tunnels.out_segments', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}, {'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}, {'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'out_segments', 'keyval': 'outgoing_interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_tunnels=ldp_tunnels, out_segments=out_segments)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_tunnels=ldp_tunnels, out_segments=out_segments)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_tunnels_ldp_tunnels_protocol_type_get(self, ldp_tunnels=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_tunnels: tunnel_destination, prefix_length
    :param ldp_tunnels: Keyword argument tuple.

    :type tunnel_destination: unicode
    :param tunnel_destination: **ldp_tunnels** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_length: long
    :param prefix_length: **ldp_tunnels** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_tunnels', 'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outgoing_interface, next_hop_ipaddress'}, {'leafval': 'outgoing_interface, next_hop_ipaddress'}, {'leafval': 'outgoing_interface, next_hop_ipaddress'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_tunnels=ldp_tunnels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_tunnels=ldp_tunnels)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_tunnels_ldp_tunnels_tunnel_interface_index_get(self, ldp_tunnels=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_tunnels: tunnel_destination, prefix_length
    :param ldp_tunnels: Keyword argument tuple.

    :type tunnel_destination: unicode
    :param tunnel_destination: **ldp_tunnels** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_length: long
    :param prefix_length: **ldp_tunnels** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_tunnels', 'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outgoing_interface, next_hop_ipaddress'}, {'leafval': 'outgoing_interface, next_hop_ipaddress'}, {'leafval': 'outgoing_interface, next_hop_ipaddress'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_tunnels=ldp_tunnels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_tunnels=ldp_tunnels)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_tunnels_ldp_tunnels_tunnel_metric_get(self, ldp_tunnels=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_tunnels: tunnel_destination, prefix_length
    :param ldp_tunnels: Keyword argument tuple.

    :type tunnel_destination: unicode
    :param tunnel_destination: **ldp_tunnels** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_length: long
    :param prefix_length: **ldp_tunnels** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_tunnels', 'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outgoing_interface, next_hop_ipaddress'}, {'leafval': 'outgoing_interface, next_hop_ipaddress'}, {'leafval': 'outgoing_interface, next_hop_ipaddress'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_tunnels=ldp_tunnels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_tunnels=ldp_tunnels)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_tunnels_ldp_tunnels_tunnel_vif_get(self, ldp_tunnels=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_tunnels: tunnel_destination, prefix_length
    :param ldp_tunnels: Keyword argument tuple.

    :type tunnel_destination: unicode
    :param tunnel_destination: **ldp_tunnels** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_length: long
    :param prefix_length: **ldp_tunnels** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels.ldp_tunnels', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels.ldp_tunnels', u'out_segments')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_tunnels', 'keyval': 'tunnel_destination, prefix_length', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'outgoing_interface, next_hop_ipaddress'}, {'leafval': 'outgoing_interface, next_hop_ipaddress'}, {'leafval': 'outgoing_interface, next_hop_ipaddress'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_tunnels=ldp_tunnels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_tunnels=ldp_tunnels)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_tunnels_total_tunnel_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17s_1_02.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_ldp_tx_silence_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'stats_group'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'instances'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'basic'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'frr'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup', u'backup_ingress'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'forwarding'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup', u'backup_transit'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'backup'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', u'include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', u'exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', u'include_all'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'backup'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup', u'backup_transit'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'forwarding'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup', u'backup_ingress'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'frr'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'basic'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'basic'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'frr'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'backup'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup', u'backup_transit'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup', u'backup_ingress'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'forwarding'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', u'admin_group_lists')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'instance_id, lsp_id, current_instance, new_instance, old_instance, is_primary, is_current_secondary, is_selected_secondary, instance_admin_up, instance_is_up, instance_is_active, is_adaptive, is_bypass, is_dynamic_bypass, config_admin_up, config_from_address_configured, config_from_address, config_to_address, config_type_bypass, config_type_dynamic, config_adaptive, config_ospf_area, config_isis_level, config_number_of_retries_configured, config_number_of_retries, config_path_select_mode, config_path_selected_path, config_path_selected_secondary_name, config_revert_time_configured, config_revert_time, config_retry_count_configured, config_retry_count, config_enable_ldp_tunnelling, config_shortcut_ospf, config_shortcut_area_configured, config_shortcut_area, config_notify_ospf, config_shortcut_isis, config_isis_shortcut_level_configured, config_isis_shortcut_level, config_notify_isis, config_metric_configured, config_metric, config_ospf_ignore_metric, config_ospf_relative_metric, config_ospf_announce_metric, config_ospf_aaf, config_isis_ignore_metric, config_isis_relative_metric, config_isis_announce_configured, config_isis_announce_metric, config_path_configured, config_path, config_reoptimize_timer_configured, config_reoptimize_time, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistenct, config_frr_global_revertive, config_frr_hold_time, config_soft_prempt, config_exclude_interface_change, config_prority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_bfd_configured, config_admin_group_configured, config_cspf_computation_mode, path_computed_by_cspf, path_computed_by_interface_constraint, cspf_computation_mode, cspf_group_computation_mode_default, cspf_group_computation_mode_add_penalty, cspf_group_computation_mode_exclude_groups, cspf_group_computation_mode_high_cost, cspf_path_cost, cspf_path_area, cspf_computation_error, cspf_exclude_hops_present, rsvp_session_present, rsvp_session_state_up, rsvp_session_state, rsvp_session_path_error_code, rsvp_session_path_error_value, rsvp_session_path_error_node_address, rsvp_session_rro_hops_present, config_exclude_interface_configured, maximum_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth, config_frr_configured, config_frr_one_to_one, config_frr_one_to_many, config_frr_priority_configured, config_frr_setup_priority, config_frr_holding_priority, config_frr_hop_limit_configured, config_frr_hop_limit, config_frr_bandwidth_configured, config_frr_bandwidth, config_frr_admin_group_configured, reoptimize_ignore_count, reoptimize_time_count, instance_frr_configured, instance_frr_up, instance_frr_active, instance_out_port_id, instance_out_port_name, instance_out_label, instance_revert_time, instance_retry_count, instance_up_down_count, instance_metric, instance_down_reason'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'tunnel_vif_index, lsp_type_bypass, lsp_type_dynamic, from_address_configured, from_address, to_address, admin_up, operational_status, lsp_is_active, lsp_has_primary_path, path_name, out_label, out_interface_name, primary_up, primary_active, lsp_has_secondary, secondary_up, secondary_active, lsp_has_selected_secondary, selected_secondary_up, selected_secondary_active, primary_is_selected, lsp_has_frr, frr_up, frr_active, up_down_count, retry_count, down_reason'}, {'leafval': 'configured, one_to_one, one_to_many, protection_type, frr_up, active, priority_configured, setup_priority, holding_priority, hop_limit_configured, hop_limit, bandwidth_configured, bandwidth, down_reason, computation_mode, group_computation_mode_default, group_computation_mode_add_penalty, group_computation_mode_exclude_groups, group_computation_mode_high_cost, out_port_id, out_port_name, out_label, path_cost, bypass_name, has_secondary_swithover_time, secondary_swithover_time, hold_time, global_revertive, revertive_timer_expired, fwdg_state_primary_up, fwdg_state_primary_active, fwdg_state_primary_down, fwdg_state_secondary_up, fwdg_state_secondary_active, fwdg_state_secondary_down, fwdg_state_detour_up, fwdg_state_detour_active, fwdg_state_detour_down, admin_group_configured'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_type_ingress, backup_type_transit, backup_is_active'}, {'leafval': 'path_name, path_up, active, instance_id, committed, is_new_instance, is_current_secondary, is_selected_secondary, config_adaptive, config_reoptimize_timer_configured, config_reoptimize_timer, config_reoptimize_timer_count, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistent, config_soft_prempt, config_priority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_cspf_computation_mode, config_admin_group_configured'}, {'leafval': 'tunnel_vif_index, lsp_id, forwarding_up, primary_active, primary_up, secondary_active, secondary_up, selected_secondary_active, selected_secondary_up, frr_active, frr_up, instance_id, out_port_id, out_port_name, out_label'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_type_ingress, backup_type_transit, backup_is_active'}, {'leafval': 'backup_present, backup_count, backup_ingress_count, backup_ingress_active_count, backup_transit_count, backup_transit_active_count'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'list_type'}, {'leafval': 'backup_present, backup_count, backup_ingress_count, backup_ingress_active_count, backup_transit_count, backup_transit_active_count'}, {'leafval': 'path_name, instance_id, path_up, active, committed, is_new_instance, is_current_secondary, is_selected_secondary, config_adaptive, config_reoptimize_timer_configured, config_reoptimize_timer, config_reoptimize_timer_count, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistent, config_soft_prempt, config_priority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_cspf_computation_mode, config_admin_group_configured'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_is_active'}, {'leafval': 'tunnel_vif_index, lsp_id, forwarding_up, primary_active, primary_up, secondary_active, secondary_up, selected_secondary_active, selected_secondary_up, frr_active, frr_up, instance_id, out_port_id, out_port_name, out_label'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_is_active'}, {'leafval': 'configured, one_to_one, one_to_many, protection_type, frr_up, active, priority_configured, setup_priority, holding_priority, hop_limit_configured, hop_limit, bandwidth_inherited, bandwidth_configured, bandwidth, down_reason, computation_mode, group_computation_mode_default, group_computation_mode_add_penalty, group_computation_mode_exclude_groups, group_computation_mode_high_cost, out_port_id, out_port_name, out_label, path_cost, bypass_name, has_secondary_swithover_time, secondary_swithover_time, hold_time, global_revertive, revertive_timer_expired, fwdg_state_primary_up, fwdg_state_primary_active, fwdg_state_primary_down, fwdg_state_secondary_up, fwdg_state_secondary_active, fwdg_state_secondary_down, fwdg_state_detour_up, fwdg_state_detour_active, fwdg_state_detour_down, admin_group_configured'}, {'leafval': 'instance_id, lsp_id, current_instance, new_instance, old_instance, is_primary, is_current_secondary, is_selected_secondary, instance_admin_up, instance_is_up, instance_is_active, is_adaptive, is_bypass, is_dynamic_bypass, config_admin_up, config_from_address_configured, config_from_address, config_to_address, config_type_bypass, config_type_dynamic, config_adaptive, config_ospf_area, config_isis_level, config_number_of_retries_configured, config_number_of_retries, config_path_select_mode, config_path_selected_path, config_path_selected_secondary_name, config_revert_time_configured, config_revert_time, config_retry_count_configured, config_retry_count, config_enable_ldp_tunnelling, config_shortcut_ospf, config_shortcut_area_configured, config_shortcut_area, config_notify_ospf, config_shortcut_isis, config_isis_shortcut_level_configured, config_isis_shortcut_level, config_notify_isis, config_metric_configured, config_metric, config_ospf_ignore_metric, config_ospf_relative_metric, config_ospf_announce_metric, config_ospf_aaf, config_isis_ignore_metric, config_isis_relative_metric, config_isis_announce_configured, config_isis_announce_metric, config_path_configured, config_path, config_reoptimize_timer_configured, config_reoptimize_time, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistenct, config_frr_global_revertive, config_frr_hold_time, config_soft_prempt, config_exclude_interface_change, config_prority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_bfd_configured, config_admin_group_configured, config_cspf_computation_mode, path_computed_by_cspf, path_computed_by_interface_constraint, cspf_computation_mode, cspf_group_computation_mode_default, cspf_group_computation_mode_add_penalty, cspf_group_computation_mode_exclude_groups, cspf_group_computation_mode_high_cost, cspf_path_cost, cspf_path_area, cspf_computation_error, cspf_exclude_hops_present, rsvp_session_present, rsvp_session_state_up, rsvp_session_state, rsvp_session_path_error_code, rsvp_session_path_error_value, rsvp_session_path_error_node_address, rsvp_session_rro_hops_present, config_exclude_interface_configured, maximum_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth, config_frr_configured, config_frr_one_to_one, config_frr_one_to_many, config_frr_priority_configured, config_frr_setup_priority, config_frr_holding_priority, config_frr_hop_limit_configured, config_frr_hop_limit, config_frr_bandwidth_inherited, config_frr_bandwidth_configured, config_frr_bandwidth, config_frr_admin_group_configured, reoptimize_ignore_count, reoptimize_time_count, instance_frr_configured, instance_frr_up, instance_frr_active, instance_out_port_id, instance_out_port_name, instance_out_label, instance_revert_time, instance_retry_count, instance_up_down_count, instance_metric, instance_down_reason, current_signaled_mean_rate'}, {'leafval': 'adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, is_adjustment_interval_inherited, is_adjustment_threshold_inherited, is_maximum_bandwidth_inherited, is_minimum_bandwidth_inherited, is_overflow_limit_inherited, is_underflow_limit_inherited, is_mode_inherited, is_sample_recording_inherited, working_status, num_samples_collected, last_sample_traffic_rate, maximum_of_samples_collected, maximum_of_underflow_samples, overflow_count, underflow_count, time_to_adjustment, adjustment_status, previous_bandwidth, new_bandwidth, adjustment_reason, time_of_last_adjustment'}, {'leafval': 'tunnel_vif_index, lsp_type_bypass, lsp_type_dynamic, from_address_configured, from_address, to_address, admin_up, operational_status, lsp_is_active, lsp_has_primary_path, path_name, out_label, out_interface_name, primary_up, primary_active, lsp_has_secondary, secondary_up, secondary_active, lsp_has_selected_secondary, selected_secondary_up, selected_secondary_active, primary_is_selected, lsp_has_frr, frr_up, frr_active, up_down_count, retry_count, down_reason'}, {'leafval': 'path_name, instance_id, path_up, active, committed, is_new_instance, is_current_secondary, is_selected_secondary, config_adaptive, config_reoptimize_timer_configured, config_reoptimize_timer, config_reoptimize_timer_count, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistent, config_soft_prempt, config_priority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_cspf_computation_mode, config_admin_group_configured'}, {'leafval': 'tunnel_vif_index, lsp_type_bypass, lsp_type_dynamic, from_address_configured, from_address, to_address, admin_up, operational_status, lsp_is_active, lsp_has_primary_path, path_name, out_label, out_interface_name, primary_up, primary_active, lsp_has_secondary, secondary_up, secondary_active, lsp_has_selected_secondary, selected_secondary_up, selected_secondary_active, primary_is_selected, lsp_has_frr, frr_up, frr_active, up_down_count, retry_count, down_reason'}, {'leafval': 'instance_id, lsp_id, current_instance, new_instance, old_instance, is_primary, is_current_secondary, is_selected_secondary, instance_admin_up, instance_is_up, instance_is_active, is_adaptive, is_bypass, is_dynamic_bypass, config_admin_up, config_from_address_configured, config_from_address, config_to_address, config_type_bypass, config_type_dynamic, config_adaptive, config_ospf_area, config_isis_level, config_number_of_retries_configured, config_number_of_retries, config_path_select_mode, config_path_selected_path, config_path_selected_secondary_name, config_revert_time_configured, config_revert_time, config_retry_count_configured, config_retry_count, config_enable_ldp_tunnelling, config_shortcut_ospf, config_shortcut_area_configured, config_shortcut_area, config_notify_ospf, config_shortcut_isis, config_isis_shortcut_level_configured, config_isis_shortcut_level, config_notify_isis, config_metric_configured, config_metric, config_ospf_ignore_metric, config_ospf_relative_metric, config_ospf_announce_metric, config_ospf_aaf, config_isis_ignore_metric, config_isis_relative_metric, config_isis_announce_configured, config_isis_announce_metric, config_path_configured, config_path, config_reoptimize_timer_configured, config_reoptimize_time, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistenct, config_frr_global_revertive, config_frr_hold_time, config_soft_prempt, config_exclude_interface_change, config_prority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_bfd_configured, config_admin_group_configured, config_cspf_computation_mode, path_computed_by_cspf, path_computed_by_interface_constraint, cspf_computation_mode, cspf_group_computation_mode_default, cspf_group_computation_mode_add_penalty, cspf_group_computation_mode_exclude_groups, cspf_group_computation_mode_high_cost, cspf_path_cost, cspf_path_area, cspf_computation_error, cspf_exclude_hops_present, rsvp_session_present, rsvp_session_state_up, rsvp_session_state, rsvp_session_path_error_code, rsvp_session_path_error_value, rsvp_session_path_error_node_address, rsvp_session_rro_hops_present, config_exclude_interface_configured, maximum_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth, config_frr_configured, config_frr_one_to_one, config_frr_one_to_many, config_frr_priority_configured, config_frr_setup_priority, config_frr_holding_priority, config_frr_hop_limit_configured, config_frr_hop_limit, config_frr_bandwidth_inherited, config_frr_bandwidth_configured, config_frr_bandwidth, config_frr_admin_group_configured, reoptimize_ignore_count, reoptimize_time_count, instance_frr_configured, instance_frr_up, instance_frr_active, instance_out_port_id, instance_out_port_name, instance_out_label, instance_revert_time, instance_retry_count, instance_up_down_count, instance_metric, instance_down_reason, current_signaled_mean_rate'}, {'leafval': 'configured, one_to_one, one_to_many, protection_type, frr_up, active, priority_configured, setup_priority, holding_priority, hop_limit_configured, hop_limit, bandwidth_inherited, bandwidth_configured, bandwidth, down_reason, computation_mode, group_computation_mode_default, group_computation_mode_add_penalty, group_computation_mode_exclude_groups, group_computation_mode_high_cost, out_port_id, out_port_name, out_label, path_cost, bypass_name, has_secondary_swithover_time, secondary_swithover_time, hold_time, global_revertive, revertive_timer_expired, fwdg_state_primary_up, fwdg_state_primary_active, fwdg_state_primary_down, fwdg_state_secondary_up, fwdg_state_secondary_active, fwdg_state_secondary_down, fwdg_state_detour_up, fwdg_state_detour_active, fwdg_state_detour_down, admin_group_configured'}, {'leafval': 'backup_present, backup_count, backup_ingress_count, backup_ingress_active_count, backup_transit_count, backup_transit_active_count'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_is_active'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_is_active'}, {'leafval': 'tunnel_vif_index, lsp_id, forwarding_up, primary_active, primary_up, secondary_active, secondary_up, selected_secondary_active, selected_secondary_up, frr_active, frr_up, instance_id, out_port_id, out_port_name, out_label'}, {'leafval': 'adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, is_adjustment_interval_inherited, is_adjustment_threshold_inherited, is_maximum_bandwidth_inherited, is_minimum_bandwidth_inherited, is_overflow_limit_inherited, is_underflow_limit_inherited, is_mode_inherited, is_sample_recording_inherited, working_status, num_samples_collected, last_sample_traffic_rate, maximum_of_samples_collected, maximum_of_underflow_samples, overflow_count, underflow_count, time_to_adjustment, adjustment_status, previous_bandwidth, new_bandwidth, adjustment_reason, time_of_last_adjustment'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_adjustment_interval_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_adjustment_reason_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_adjustment_status_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_adjustment_threshold_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_is_adjustment_interval_inherited_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_is_adjustment_threshold_inherited_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_is_maximum_bandwidth_inherited_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_is_minimum_bandwidth_inherited_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_is_mode_inherited_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_is_overflow_limit_inherited_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_is_sample_recording_inherited_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_is_underflow_limit_inherited_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_last_sample_traffic_rate_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_maximum_bandwidth_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_maximum_of_samples_collected_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_maximum_of_underflow_samples_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_minimum_bandwidth_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_mode_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_new_bandwidth_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_num_samples_collected_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_overflow_count_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_overflow_limit_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_previous_bandwidth_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_sample_recording_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_time_of_last_adjustment_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_time_to_adjustment_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_underflow_count_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_underflow_limit_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_auto_bandwidth_working_status_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_backup_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_backup_backup_count_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_backup_backup_ingress_get(self, lsp=None, backup_ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type backup_ingress: backup_from_address, backup_to_address, backup_name
    :param backup_ingress: Keyword argument tuple.

    :type backup_from_address: unicode
    :param backup_from_address: **backup_ingress** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_to_address: unicode
    :param backup_to_address: **backup_ingress** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_name: unicode
    :param backup_name: **backup_ingress** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup.backup_ingress', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup.backup_ingress', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup.backup_ingress', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'backup_ingress', 'keyval': 'backup_from_address, backup_to_address, backup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.lsp.backup.backup_ingress": {"backup_to_address": "backup_to_address", "backup_from_address": "backup_from_address", "backup_name": "backup_name", "backup_is_active": "backup_is_active"}, "pybind.slxos.v17s_1_02.mpls_state.lsp.backup.backup_ingress": {}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.backup.backup_ingress": {"backup_to_address": "backup_to_address", "backup_from_address": "backup_from_address", "backup_name": "backup_name", "backup_is_active": "backup_is_active"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, backup_ingress=backup_ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, backup_ingress=backup_ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_backup_backup_ingress_active_count_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_backup_backup_ingress_backup_is_active_get(self, lsp=None, backup_ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type backup_ingress: backup_from_address, backup_to_address, backup_name
    :param backup_ingress: Keyword argument tuple.

    :type backup_from_address: unicode
    :param backup_from_address: **backup_ingress** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_to_address: unicode
    :param backup_to_address: **backup_ingress** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_name: unicode
    :param backup_name: **backup_ingress** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup.backup_ingress', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup.backup_ingress', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup.backup_ingress', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'backup_ingress', 'keyval': 'backup_from_address, backup_to_address, backup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, backup_ingress=backup_ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, backup_ingress=backup_ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_backup_backup_ingress_backup_type_ingress_get(self, lsp=None, backup_ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type backup_ingress: backup_from_address, backup_to_address, backup_name
    :param backup_ingress: Keyword argument tuple.

    :type backup_from_address: unicode
    :param backup_from_address: **backup_ingress** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_to_address: unicode
    :param backup_to_address: **backup_ingress** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_name: unicode
    :param backup_name: **backup_ingress** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.backup.backup_ingress', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'backup_ingress', 'keyval': 'backup_from_address, backup_to_address, backup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, backup_ingress=backup_ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, backup_ingress=backup_ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_backup_backup_ingress_backup_type_transit_get(self, lsp=None, backup_ingress=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type backup_ingress: backup_from_address, backup_to_address, backup_name
    :param backup_ingress: Keyword argument tuple.

    :type backup_from_address: unicode
    :param backup_from_address: **backup_ingress** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_to_address: unicode
    :param backup_to_address: **backup_ingress** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_name: unicode
    :param backup_name: **backup_ingress** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.backup.backup_ingress', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'backup_ingress', 'keyval': 'backup_from_address, backup_to_address, backup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, backup_ingress=backup_ingress)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, backup_ingress=backup_ingress)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_backup_backup_ingress_count_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_backup_backup_present_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_backup_backup_transit_get(self, lsp=None, backup_transit=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type backup_transit: backup_from_address, backup_to_address, backup_name
    :param backup_transit: Keyword argument tuple.

    :type backup_from_address: unicode
    :param backup_from_address: **backup_transit** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_to_address: unicode
    :param backup_to_address: **backup_transit** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_name: unicode
    :param backup_name: **backup_transit** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup.backup_transit', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup.backup_transit', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup.backup_transit', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'backup_transit', 'keyval': 'backup_from_address, backup_to_address, backup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.backup.backup_transit": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.backup.backup_transit": {"backup_to_address": "backup_to_address", "backup_from_address": "backup_from_address", "backup_name": "backup_name", "backup_is_active": "backup_is_active"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.backup.backup_transit": {"backup_to_address": "backup_to_address", "backup_from_address": "backup_from_address", "backup_name": "backup_name", "backup_is_active": "backup_is_active"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, backup_transit=backup_transit)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, backup_transit=backup_transit)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_backup_backup_transit_active_count_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_backup_backup_transit_backup_is_active_get(self, lsp=None, backup_transit=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type backup_transit: backup_from_address, backup_to_address, backup_name
    :param backup_transit: Keyword argument tuple.

    :type backup_from_address: unicode
    :param backup_from_address: **backup_transit** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_to_address: unicode
    :param backup_to_address: **backup_transit** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_name: unicode
    :param backup_name: **backup_transit** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup.backup_transit', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup.backup_transit', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup.backup_transit', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'backup_transit', 'keyval': 'backup_from_address, backup_to_address, backup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, backup_transit=backup_transit)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, backup_transit=backup_transit)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_backup_backup_transit_backup_type_ingress_get(self, lsp=None, backup_transit=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type backup_transit: backup_from_address, backup_to_address, backup_name
    :param backup_transit: Keyword argument tuple.

    :type backup_from_address: unicode
    :param backup_from_address: **backup_transit** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_to_address: unicode
    :param backup_to_address: **backup_transit** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_name: unicode
    :param backup_name: **backup_transit** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.backup.backup_transit', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'backup_transit', 'keyval': 'backup_from_address, backup_to_address, backup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, backup_transit=backup_transit)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, backup_transit=backup_transit)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_backup_backup_transit_backup_type_transit_get(self, lsp=None, backup_transit=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type backup_transit: backup_from_address, backup_to_address, backup_name
    :param backup_transit: Keyword argument tuple.

    :type backup_from_address: unicode
    :param backup_from_address: **backup_transit** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_to_address: unicode
    :param backup_to_address: **backup_transit** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type backup_name: unicode
    :param backup_name: **backup_transit** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.backup.backup_transit', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'backup_transit', 'keyval': 'backup_from_address, backup_to_address, backup_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, backup_transit=backup_transit)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, backup_transit=backup_transit)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_backup_backup_transit_count_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_admin_up_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_down_reason_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_from_address_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_from_address_configured_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_frr_active_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_frr_up_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_lsp_has_frr_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_lsp_has_primary_path_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_lsp_has_secondary_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_lsp_has_selected_secondary_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_lsp_is_active_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_lsp_type_bypass_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_lsp_type_dynamic_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_operational_status_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_out_interface_name_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_out_label_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_path_name_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_primary_active_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_primary_is_selected_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_primary_up_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_retry_count_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_secondary_active_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_secondary_up_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_selected_secondary_active_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_selected_secondary_up_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_to_address_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_tunnel_vif_index_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_basic_up_down_count_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.basic', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.basic', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.basic', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_bypass_lsp_type_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'instances'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'basic'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'frr'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup', u'backup_ingress'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'forwarding'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup', u'backup_transit'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'backup'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', u'include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', u'exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', u'include_all'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'backup'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup', u'backup_transit'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'forwarding'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup', u'backup_ingress'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'frr'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'basic'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'basic'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'frr'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'backup'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup', u'backup_transit'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup', u'backup_ingress'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'forwarding'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', u'admin_group_lists')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'instance_id, lsp_id, current_instance, new_instance, old_instance, is_primary, is_current_secondary, is_selected_secondary, instance_admin_up, instance_is_up, instance_is_active, is_adaptive, is_bypass, is_dynamic_bypass, config_admin_up, config_from_address_configured, config_from_address, config_to_address, config_type_bypass, config_type_dynamic, config_adaptive, config_ospf_area, config_isis_level, config_number_of_retries_configured, config_number_of_retries, config_path_select_mode, config_path_selected_path, config_path_selected_secondary_name, config_revert_time_configured, config_revert_time, config_retry_count_configured, config_retry_count, config_enable_ldp_tunnelling, config_shortcut_ospf, config_shortcut_area_configured, config_shortcut_area, config_notify_ospf, config_shortcut_isis, config_isis_shortcut_level_configured, config_isis_shortcut_level, config_notify_isis, config_metric_configured, config_metric, config_ospf_ignore_metric, config_ospf_relative_metric, config_ospf_announce_metric, config_ospf_aaf, config_isis_ignore_metric, config_isis_relative_metric, config_isis_announce_configured, config_isis_announce_metric, config_path_configured, config_path, config_reoptimize_timer_configured, config_reoptimize_time, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistenct, config_frr_global_revertive, config_frr_hold_time, config_soft_prempt, config_exclude_interface_change, config_prority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_bfd_configured, config_admin_group_configured, config_cspf_computation_mode, path_computed_by_cspf, path_computed_by_interface_constraint, cspf_computation_mode, cspf_group_computation_mode_default, cspf_group_computation_mode_add_penalty, cspf_group_computation_mode_exclude_groups, cspf_group_computation_mode_high_cost, cspf_path_cost, cspf_path_area, cspf_computation_error, cspf_exclude_hops_present, rsvp_session_present, rsvp_session_state_up, rsvp_session_state, rsvp_session_path_error_code, rsvp_session_path_error_value, rsvp_session_path_error_node_address, rsvp_session_rro_hops_present, config_exclude_interface_configured, maximum_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth, config_frr_configured, config_frr_one_to_one, config_frr_one_to_many, config_frr_priority_configured, config_frr_setup_priority, config_frr_holding_priority, config_frr_hop_limit_configured, config_frr_hop_limit, config_frr_bandwidth_configured, config_frr_bandwidth, config_frr_admin_group_configured, reoptimize_ignore_count, reoptimize_time_count, instance_frr_configured, instance_frr_up, instance_frr_active, instance_out_port_id, instance_out_port_name, instance_out_label, instance_revert_time, instance_retry_count, instance_up_down_count, instance_metric, instance_down_reason'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'tunnel_vif_index, lsp_type_bypass, lsp_type_dynamic, from_address_configured, from_address, to_address, admin_up, operational_status, lsp_is_active, lsp_has_primary_path, path_name, out_label, out_interface_name, primary_up, primary_active, lsp_has_secondary, secondary_up, secondary_active, lsp_has_selected_secondary, selected_secondary_up, selected_secondary_active, primary_is_selected, lsp_has_frr, frr_up, frr_active, up_down_count, retry_count, down_reason'}, {'leafval': 'configured, one_to_one, one_to_many, protection_type, frr_up, active, priority_configured, setup_priority, holding_priority, hop_limit_configured, hop_limit, bandwidth_configured, bandwidth, down_reason, computation_mode, group_computation_mode_default, group_computation_mode_add_penalty, group_computation_mode_exclude_groups, group_computation_mode_high_cost, out_port_id, out_port_name, out_label, path_cost, bypass_name, has_secondary_swithover_time, secondary_swithover_time, hold_time, global_revertive, revertive_timer_expired, fwdg_state_primary_up, fwdg_state_primary_active, fwdg_state_primary_down, fwdg_state_secondary_up, fwdg_state_secondary_active, fwdg_state_secondary_down, fwdg_state_detour_up, fwdg_state_detour_active, fwdg_state_detour_down, admin_group_configured'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_type_ingress, backup_type_transit, backup_is_active'}, {'leafval': 'path_name, path_up, active, instance_id, committed, is_new_instance, is_current_secondary, is_selected_secondary, config_adaptive, config_reoptimize_timer_configured, config_reoptimize_timer, config_reoptimize_timer_count, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistent, config_soft_prempt, config_priority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_cspf_computation_mode, config_admin_group_configured'}, {'leafval': 'tunnel_vif_index, lsp_id, forwarding_up, primary_active, primary_up, secondary_active, secondary_up, selected_secondary_active, selected_secondary_up, frr_active, frr_up, instance_id, out_port_id, out_port_name, out_label'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_type_ingress, backup_type_transit, backup_is_active'}, {'leafval': 'backup_present, backup_count, backup_ingress_count, backup_ingress_active_count, backup_transit_count, backup_transit_active_count'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'list_type'}, {'leafval': 'backup_present, backup_count, backup_ingress_count, backup_ingress_active_count, backup_transit_count, backup_transit_active_count'}, {'leafval': 'path_name, instance_id, path_up, active, committed, is_new_instance, is_current_secondary, is_selected_secondary, config_adaptive, config_reoptimize_timer_configured, config_reoptimize_timer, config_reoptimize_timer_count, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistent, config_soft_prempt, config_priority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_cspf_computation_mode, config_admin_group_configured'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_is_active'}, {'leafval': 'tunnel_vif_index, lsp_id, forwarding_up, primary_active, primary_up, secondary_active, secondary_up, selected_secondary_active, selected_secondary_up, frr_active, frr_up, instance_id, out_port_id, out_port_name, out_label'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_is_active'}, {'leafval': 'configured, one_to_one, one_to_many, protection_type, frr_up, active, priority_configured, setup_priority, holding_priority, hop_limit_configured, hop_limit, bandwidth_inherited, bandwidth_configured, bandwidth, down_reason, computation_mode, group_computation_mode_default, group_computation_mode_add_penalty, group_computation_mode_exclude_groups, group_computation_mode_high_cost, out_port_id, out_port_name, out_label, path_cost, bypass_name, has_secondary_swithover_time, secondary_swithover_time, hold_time, global_revertive, revertive_timer_expired, fwdg_state_primary_up, fwdg_state_primary_active, fwdg_state_primary_down, fwdg_state_secondary_up, fwdg_state_secondary_active, fwdg_state_secondary_down, fwdg_state_detour_up, fwdg_state_detour_active, fwdg_state_detour_down, admin_group_configured'}, {'leafval': 'instance_id, lsp_id, current_instance, new_instance, old_instance, is_primary, is_current_secondary, is_selected_secondary, instance_admin_up, instance_is_up, instance_is_active, is_adaptive, is_bypass, is_dynamic_bypass, config_admin_up, config_from_address_configured, config_from_address, config_to_address, config_type_bypass, config_type_dynamic, config_adaptive, config_ospf_area, config_isis_level, config_number_of_retries_configured, config_number_of_retries, config_path_select_mode, config_path_selected_path, config_path_selected_secondary_name, config_revert_time_configured, config_revert_time, config_retry_count_configured, config_retry_count, config_enable_ldp_tunnelling, config_shortcut_ospf, config_shortcut_area_configured, config_shortcut_area, config_notify_ospf, config_shortcut_isis, config_isis_shortcut_level_configured, config_isis_shortcut_level, config_notify_isis, config_metric_configured, config_metric, config_ospf_ignore_metric, config_ospf_relative_metric, config_ospf_announce_metric, config_ospf_aaf, config_isis_ignore_metric, config_isis_relative_metric, config_isis_announce_configured, config_isis_announce_metric, config_path_configured, config_path, config_reoptimize_timer_configured, config_reoptimize_time, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistenct, config_frr_global_revertive, config_frr_hold_time, config_soft_prempt, config_exclude_interface_change, config_prority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_bfd_configured, config_admin_group_configured, config_cspf_computation_mode, path_computed_by_cspf, path_computed_by_interface_constraint, cspf_computation_mode, cspf_group_computation_mode_default, cspf_group_computation_mode_add_penalty, cspf_group_computation_mode_exclude_groups, cspf_group_computation_mode_high_cost, cspf_path_cost, cspf_path_area, cspf_computation_error, cspf_exclude_hops_present, rsvp_session_present, rsvp_session_state_up, rsvp_session_state, rsvp_session_path_error_code, rsvp_session_path_error_value, rsvp_session_path_error_node_address, rsvp_session_rro_hops_present, config_exclude_interface_configured, maximum_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth, config_frr_configured, config_frr_one_to_one, config_frr_one_to_many, config_frr_priority_configured, config_frr_setup_priority, config_frr_holding_priority, config_frr_hop_limit_configured, config_frr_hop_limit, config_frr_bandwidth_inherited, config_frr_bandwidth_configured, config_frr_bandwidth, config_frr_admin_group_configured, reoptimize_ignore_count, reoptimize_time_count, instance_frr_configured, instance_frr_up, instance_frr_active, instance_out_port_id, instance_out_port_name, instance_out_label, instance_revert_time, instance_retry_count, instance_up_down_count, instance_metric, instance_down_reason, current_signaled_mean_rate'}, {'leafval': 'adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, is_adjustment_interval_inherited, is_adjustment_threshold_inherited, is_maximum_bandwidth_inherited, is_minimum_bandwidth_inherited, is_overflow_limit_inherited, is_underflow_limit_inherited, is_mode_inherited, is_sample_recording_inherited, working_status, num_samples_collected, last_sample_traffic_rate, maximum_of_samples_collected, maximum_of_underflow_samples, overflow_count, underflow_count, time_to_adjustment, adjustment_status, previous_bandwidth, new_bandwidth, adjustment_reason, time_of_last_adjustment'}, {'leafval': 'tunnel_vif_index, lsp_type_bypass, lsp_type_dynamic, from_address_configured, from_address, to_address, admin_up, operational_status, lsp_is_active, lsp_has_primary_path, path_name, out_label, out_interface_name, primary_up, primary_active, lsp_has_secondary, secondary_up, secondary_active, lsp_has_selected_secondary, selected_secondary_up, selected_secondary_active, primary_is_selected, lsp_has_frr, frr_up, frr_active, up_down_count, retry_count, down_reason'}, {'leafval': 'path_name, instance_id, path_up, active, committed, is_new_instance, is_current_secondary, is_selected_secondary, config_adaptive, config_reoptimize_timer_configured, config_reoptimize_timer, config_reoptimize_timer_count, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistent, config_soft_prempt, config_priority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_cspf_computation_mode, config_admin_group_configured'}, {'leafval': 'tunnel_vif_index, lsp_type_bypass, lsp_type_dynamic, from_address_configured, from_address, to_address, admin_up, operational_status, lsp_is_active, lsp_has_primary_path, path_name, out_label, out_interface_name, primary_up, primary_active, lsp_has_secondary, secondary_up, secondary_active, lsp_has_selected_secondary, selected_secondary_up, selected_secondary_active, primary_is_selected, lsp_has_frr, frr_up, frr_active, up_down_count, retry_count, down_reason'}, {'leafval': 'instance_id, lsp_id, current_instance, new_instance, old_instance, is_primary, is_current_secondary, is_selected_secondary, instance_admin_up, instance_is_up, instance_is_active, is_adaptive, is_bypass, is_dynamic_bypass, config_admin_up, config_from_address_configured, config_from_address, config_to_address, config_type_bypass, config_type_dynamic, config_adaptive, config_ospf_area, config_isis_level, config_number_of_retries_configured, config_number_of_retries, config_path_select_mode, config_path_selected_path, config_path_selected_secondary_name, config_revert_time_configured, config_revert_time, config_retry_count_configured, config_retry_count, config_enable_ldp_tunnelling, config_shortcut_ospf, config_shortcut_area_configured, config_shortcut_area, config_notify_ospf, config_shortcut_isis, config_isis_shortcut_level_configured, config_isis_shortcut_level, config_notify_isis, config_metric_configured, config_metric, config_ospf_ignore_metric, config_ospf_relative_metric, config_ospf_announce_metric, config_ospf_aaf, config_isis_ignore_metric, config_isis_relative_metric, config_isis_announce_configured, config_isis_announce_metric, config_path_configured, config_path, config_reoptimize_timer_configured, config_reoptimize_time, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistenct, config_frr_global_revertive, config_frr_hold_time, config_soft_prempt, config_exclude_interface_change, config_prority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_bfd_configured, config_admin_group_configured, config_cspf_computation_mode, path_computed_by_cspf, path_computed_by_interface_constraint, cspf_computation_mode, cspf_group_computation_mode_default, cspf_group_computation_mode_add_penalty, cspf_group_computation_mode_exclude_groups, cspf_group_computation_mode_high_cost, cspf_path_cost, cspf_path_area, cspf_computation_error, cspf_exclude_hops_present, rsvp_session_present, rsvp_session_state_up, rsvp_session_state, rsvp_session_path_error_code, rsvp_session_path_error_value, rsvp_session_path_error_node_address, rsvp_session_rro_hops_present, config_exclude_interface_configured, maximum_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth, config_frr_configured, config_frr_one_to_one, config_frr_one_to_many, config_frr_priority_configured, config_frr_setup_priority, config_frr_holding_priority, config_frr_hop_limit_configured, config_frr_hop_limit, config_frr_bandwidth_inherited, config_frr_bandwidth_configured, config_frr_bandwidth, config_frr_admin_group_configured, reoptimize_ignore_count, reoptimize_time_count, instance_frr_configured, instance_frr_up, instance_frr_active, instance_out_port_id, instance_out_port_name, instance_out_label, instance_revert_time, instance_retry_count, instance_up_down_count, instance_metric, instance_down_reason, current_signaled_mean_rate'}, {'leafval': 'configured, one_to_one, one_to_many, protection_type, frr_up, active, priority_configured, setup_priority, holding_priority, hop_limit_configured, hop_limit, bandwidth_inherited, bandwidth_configured, bandwidth, down_reason, computation_mode, group_computation_mode_default, group_computation_mode_add_penalty, group_computation_mode_exclude_groups, group_computation_mode_high_cost, out_port_id, out_port_name, out_label, path_cost, bypass_name, has_secondary_swithover_time, secondary_swithover_time, hold_time, global_revertive, revertive_timer_expired, fwdg_state_primary_up, fwdg_state_primary_active, fwdg_state_primary_down, fwdg_state_secondary_up, fwdg_state_secondary_active, fwdg_state_secondary_down, fwdg_state_detour_up, fwdg_state_detour_active, fwdg_state_detour_down, admin_group_configured'}, {'leafval': 'backup_present, backup_count, backup_ingress_count, backup_ingress_active_count, backup_transit_count, backup_transit_active_count'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_is_active'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_is_active'}, {'leafval': 'tunnel_vif_index, lsp_id, forwarding_up, primary_active, primary_up, secondary_active, secondary_up, selected_secondary_active, selected_secondary_up, frr_active, frr_up, instance_id, out_port_id, out_port_name, out_label'}, {'leafval': 'adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, is_adjustment_interval_inherited, is_adjustment_threshold_inherited, is_maximum_bandwidth_inherited, is_minimum_bandwidth_inherited, is_overflow_limit_inherited, is_underflow_limit_inherited, is_mode_inherited, is_sample_recording_inherited, working_status, num_samples_collected, last_sample_traffic_rate, maximum_of_samples_collected, maximum_of_underflow_samples, overflow_count, underflow_count, time_to_adjustment, adjustment_status, previous_bandwidth, new_bandwidth, adjustment_reason, time_of_last_adjustment'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_forwarding_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.forwarding', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_forwarding_forwarding_up_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.forwarding', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_forwarding_frr_active_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.forwarding', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_forwarding_frr_up_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.forwarding', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_forwarding_instance_id_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.forwarding', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_forwarding_lsp_id_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.forwarding', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_forwarding_out_label_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.forwarding', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_forwarding_out_port_id_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.forwarding', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_forwarding_out_port_name_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.forwarding', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_forwarding_primary_active_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.forwarding', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_forwarding_primary_up_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.forwarding', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_forwarding_secondary_active_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.forwarding', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_forwarding_secondary_up_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.forwarding', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_forwarding_selected_secondary_active_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.forwarding', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_forwarding_selected_secondary_up_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.forwarding', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_forwarding_tunnel_vif_index_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.forwarding', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.forwarding', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.mpls_state.lsp.frr": {"bandwidth_configured": "bandwidth_configured", "out_port_id": "out_port_id", "path_cost": "path_cost", "configured": "configured", "bandwidth_inherited": "bandwidth_inherited", "down_reason": "down_reason", "bandwidth": "bandwidth", "fwdg_state_primary_active": "fwdg_state_primary_active", "out_port_name": "out_port_name", "global_revertive": "global_revertive", "one_to_one": "one_to_one", "computation_mode": "computation_mode", "fwdg_state_secondary_active": "fwdg_state_secondary_active", "hop_limit_configured": "hop_limit_configured", "group_computation_mode_default": "group_computation_mode_default", "group_computation_mode_high_cost": "group_computation_mode_high_cost", "fwdg_state_detour_down": "fwdg_state_detour_down", "out_label": "out_label", "frr_up": "frr_up", "admin_group_configured": "admin_group_configured", "holding_priority": "holding_priority", "has_secondary_swithover_time": "has_secondary_swithover_time", "fwdg_state_secondary_up": "fwdg_state_secondary_up", "secondary_swithover_time": "secondary_swithover_time", "revertive_timer_expired": "revertive_timer_expired", "group_computation_mode_exclude_groups": "group_computation_mode_exclude_groups", "bypass_name": "bypass_name", "protection_type": "protection_type", "active": "active", "fwdg_state_secondary_down": "fwdg_state_secondary_down", "hold_time": "hold_time", "setup_priority": "setup_priority", "fwdg_state_primary_up": "fwdg_state_primary_up", "one_to_many": "one_to_many", "group_computation_mode_add_penalty": "group_computation_mode_add_penalty", "priority_configured": "priority_configured", "fwdg_state_detour_up": "fwdg_state_detour_up", "fwdg_state_detour_active": "fwdg_state_detour_active", "fwdg_state_primary_down": "fwdg_state_primary_down", "hop_limit": "hop_limit"}, "pybind.slxos.v17r_2_00.mpls_state.lsp.frr": {"bandwidth_configured": "bandwidth_configured", "out_port_id": "out_port_id", "path_cost": "path_cost", "configured": "configured", "bandwidth_inherited": "bandwidth_inherited", "down_reason": "down_reason", "bandwidth": "bandwidth", "fwdg_state_primary_active": "fwdg_state_primary_active", "out_port_name": "out_port_name", "global_revertive": "global_revertive", "one_to_one": "one_to_one", "computation_mode": "computation_mode", "fwdg_state_secondary_active": "fwdg_state_secondary_active", "hop_limit_configured": "hop_limit_configured", "group_computation_mode_default": "group_computation_mode_default", "group_computation_mode_high_cost": "group_computation_mode_high_cost", "fwdg_state_detour_down": "fwdg_state_detour_down", "out_label": "out_label", "frr_up": "frr_up", "admin_group_configured": "admin_group_configured", "holding_priority": "holding_priority", "has_secondary_swithover_time": "has_secondary_swithover_time", "fwdg_state_secondary_up": "fwdg_state_secondary_up", "secondary_swithover_time": "secondary_swithover_time", "revertive_timer_expired": "revertive_timer_expired", "group_computation_mode_exclude_groups": "group_computation_mode_exclude_groups", "bypass_name": "bypass_name", "protection_type": "protection_type", "active": "active", "fwdg_state_secondary_down": "fwdg_state_secondary_down", "hold_time": "hold_time", "setup_priority": "setup_priority", "fwdg_state_primary_up": "fwdg_state_primary_up", "one_to_many": "one_to_many", "group_computation_mode_add_penalty": "group_computation_mode_add_penalty", "priority_configured": "priority_configured", "fwdg_state_detour_up": "fwdg_state_detour_up", "fwdg_state_detour_active": "fwdg_state_detour_active", "fwdg_state_primary_down": "fwdg_state_primary_down", "hop_limit": "hop_limit"}, "pybind.slxos.v17s_1_02.mpls_state.lsp.frr": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_active_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_admin_group_configured_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_admin_group_lists_get(self, lsp=None, admin_group_lists=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr.admin_group_lists', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr.admin_group_lists', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.frr.admin_group_lists', u'admin_group'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr.admin_group_lists', u'admin_group')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group_lists', 'keyval': 'list_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name, exclude_any, include_all, include_any'}, {'leafval': 'admin_group_id, admin_group_name, exclude_any, include_all, include_any'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, admin_group_lists=admin_group_lists)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, admin_group_lists=admin_group_lists)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_admin_group_lists_admin_group_get(self, lsp=None, admin_group_lists=None, admin_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    **Instance Keyword Argument Tuple**:

    :type admin_group: admin_group_id
    :param admin_group: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr.admin_group_lists', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr.admin_group_lists', u'admin_group_lists')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr.admin_group_lists.admin_group', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr.admin_group_lists.admin_group', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, admin_group_lists=admin_group_lists, admin_group=admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, admin_group_lists=admin_group_lists, admin_group=admin_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_admin_group_lists_admin_group_admin_group_name_get(self, lsp=None, admin_group_lists=None, admin_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    **Instance Keyword Argument Tuple**:

    :type admin_group: admin_group_id
    :param admin_group: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr.admin_group_lists', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr.admin_group_lists', u'admin_group_lists')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr.admin_group_lists.admin_group', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr.admin_group_lists.admin_group', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, admin_group_lists=admin_group_lists, admin_group=admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, admin_group_lists=admin_group_lists, admin_group=admin_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_admin_group_lists_admin_group_exclude_any_get(self, lsp=None, admin_group_lists=None, admin_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    **Instance Keyword Argument Tuple**:

    :type admin_group: admin_group_id
    :param admin_group: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr.admin_group_lists', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr.admin_group_lists', u'admin_group_lists')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr.admin_group_lists.admin_group', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr.admin_group_lists.admin_group', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, admin_group_lists=admin_group_lists, admin_group=admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, admin_group_lists=admin_group_lists, admin_group=admin_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_admin_group_lists_admin_group_include_all_get(self, lsp=None, admin_group_lists=None, admin_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    **Instance Keyword Argument Tuple**:

    :type admin_group: admin_group_id
    :param admin_group: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr.admin_group_lists', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr.admin_group_lists', u'admin_group_lists')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr.admin_group_lists.admin_group', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr.admin_group_lists.admin_group', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, admin_group_lists=admin_group_lists, admin_group=admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, admin_group_lists=admin_group_lists, admin_group=admin_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_admin_group_lists_admin_group_include_any_get(self, lsp=None, admin_group_lists=None, admin_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    **Instance Keyword Argument Tuple**:

    :type admin_group: admin_group_id
    :param admin_group: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr.admin_group_lists', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr.admin_group_lists', u'admin_group_lists')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr.admin_group_lists.admin_group', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr.admin_group_lists.admin_group', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, admin_group_lists=admin_group_lists, admin_group=admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, admin_group_lists=admin_group_lists, admin_group=admin_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_bandwidth_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_bandwidth_configured_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_bandwidth_inherited_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_bypass_name_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_computation_mode_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_configured_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_down_reason_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_exclude_any_get(self, lsp=None, exclude_any=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type exclude_any: admin_group_id
    :param exclude_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **exclude_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.frr.exclude_any', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'exclude_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, exclude_any=exclude_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, exclude_any=exclude_any)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_exclude_any_admin_group_name_get(self, lsp=None, exclude_any=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type exclude_any: admin_group_id
    :param exclude_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **exclude_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.frr.exclude_any', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'exclude_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, exclude_any=exclude_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, exclude_any=exclude_any)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_frr_up_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_detour_active_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_detour_down_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_detour_up_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_primary_active_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_primary_down_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_primary_up_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_secondary_active_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_secondary_down_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_fwdg_state_secondary_up_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_global_revertive_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_group_computation_mode_add_penalty_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_group_computation_mode_default_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_group_computation_mode_exclude_groups_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_group_computation_mode_high_cost_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_has_secondary_swithover_time_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_hold_time_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_holding_priority_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_hop_limit_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_hop_limit_configured_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_include_all_get(self, lsp=None, include_all=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type include_all: admin_group_id
    :param include_all: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **include_all** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.frr.include_all', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'include_all', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, include_all=include_all)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, include_all=include_all)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_include_all_admin_group_name_get(self, lsp=None, include_all=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type include_all: admin_group_id
    :param include_all: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **include_all** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.frr.include_all', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'include_all', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, include_all=include_all)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, include_all=include_all)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_include_any_get(self, lsp=None, include_any=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type include_any: admin_group_id
    :param include_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **include_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.frr.include_any', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'include_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, include_any=include_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, include_any=include_any)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_include_any_admin_group_name_get(self, lsp=None, include_any=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type include_any: admin_group_id
    :param include_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **include_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.frr.include_any', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'include_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, include_any=include_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, include_any=include_any)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_one_to_many_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_one_to_one_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_out_label_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_out_port_id_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_out_port_name_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_path_cost_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_priority_configured_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_protection_type_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_revertive_timer_expired_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_secondary_swithover_time_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_frr_setup_priority_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.mpls_state.lsp.instances": {"config_path_selected_path": "config_path_selected_path", "config_type_bypass": "config_type_bypass", "config_isis_shortcut_level": "config_isis_shortcut_level", "config_frr_priority_configured": "config_frr_priority_configured", "config_bfd_configured": "config_bfd_configured", "config_frr_hop_limit": "config_frr_hop_limit", "config_number_of_retries_configured": "config_number_of_retries_configured", "rsvp_session_state": "rsvp_session_state", "config_frr_setup_priority": "config_frr_setup_priority", "instance_out_label": "instance_out_label", "config_mtu_configured": "config_mtu_configured", "config_ospf_ignore_metric": "config_ospf_ignore_metric", "unreserved_priority_1_bandwidth": "unreserved_priority_1_bandwidth", "config_metric_configured": "config_metric_configured", "config_hot_standby": "config_hot_standby", "current_signaled_mean_rate": "current_signaled_mean_rate", "config_frr_global_revertive": "config_frr_global_revertive", "config_path_selected_secondary_name": "config_path_selected_secondary_name", "config_abw_configured": "config_abw_configured", "unreserved_priority_5_bandwidth": "unreserved_priority_5_bandwidth", "instance_frr_up": "instance_frr_up", "cspf_path_area": "cspf_path_area", "config_frr_hop_limit_configured": "config_frr_hop_limit_configured", "is_current_secondary": "is_current_secondary", "config_tie_break_random": "config_tie_break_random", "config_frr_hold_time": "config_frr_hold_time", "is_selected_secondary": "is_selected_secondary", "instance_is_active": "instance_is_active", "is_bypass": "is_bypass", "config_traffic_eng_max_rate": "config_traffic_eng_max_rate", "cspf_computation_error": "cspf_computation_error", "reoptimize_time_count": "reoptimize_time_count", "cspf_group_computation_mode_add_penalty": "cspf_group_computation_mode_add_penalty", "config_cos_configured": "config_cos_configured", "config_persistenct": "config_persistenct", "cspf_exclude_hops_present": "cspf_exclude_hops_present", "config_from_address_configured": "config_from_address_configured", "config_holding_prority": "config_holding_prority", "config_ospf_aaf": "config_ospf_aaf", "instance_id": "instance_id", "config_traffic_eng_mean_rate": "config_traffic_eng_mean_rate", "config_frr_bandwidth_inherited": "config_frr_bandwidth_inherited", "unreserved_priority_3_bandwidth": "unreserved_priority_3_bandwidth", "instance_frr_active": "instance_frr_active", "config_revert_time": "config_revert_time", "config_frr_one_to_many": "config_frr_one_to_many", "instance_frr_configured": "instance_frr_configured", "instance_out_port_name": "instance_out_port_name", "config_isis_relative_metric": "config_isis_relative_metric", "config_frr_bandwidth_configured": "config_frr_bandwidth_configured", "config_tie_break_least_fill": "config_tie_break_least_fill", "config_cspf_computation_mode": "config_cspf_computation_mode", "config_frr_bandwidth": "config_frr_bandwidth", "config_prority_configured": "config_prority_configured", "config_from_address": "config_from_address", "is_dynamic_bypass": "is_dynamic_bypass", "config_frr_configured": "config_frr_configured", "config_reoptimize_timer_configured": "config_reoptimize_timer_configured", "config_ospf_area": "config_ospf_area", "config_adaptive": "config_adaptive", "config_ospf_announce_metric": "config_ospf_announce_metric", "config_retry_count_configured": "config_retry_count_configured", "config_exclude_interface_change": "config_exclude_interface_change", "rsvp_session_present": "rsvp_session_present", "config_frr_admin_group_configured": "config_frr_admin_group_configured", "config_setup_prority": "config_setup_prority", "config_path_select_mode": "config_path_select_mode", "config_number_of_retries": "config_number_of_retries", "config_rro_disabled": "config_rro_disabled", "instance_up_down_count": "instance_up_down_count", "config_shortcut_ospf": "config_shortcut_ospf", "config_cos": "config_cos", "cspf_group_computation_mode_default": "cspf_group_computation_mode_default", "config_enable_ldp_tunnelling": "config_enable_ldp_tunnelling", "config_isis_level": "config_isis_level", "rsvp_session_rro_hops_present": "rsvp_session_rro_hops_present", "config_isis_announce_metric": "config_isis_announce_metric", "config_admin_up": "config_admin_up", "config_notify_ospf": "config_notify_ospf", "config_shortcut_isis": "config_shortcut_isis", "config_pinned": "config_pinned", "instance_down_reason": "instance_down_reason", "lsp_id": "lsp_id", "config_exclude_interface_configured": "config_exclude_interface_configured", "reoptimize_ignore_count": "reoptimize_ignore_count", "instance_metric": "instance_metric", "rsvp_session_path_error_value": "rsvp_session_path_error_value", "path_computed_by_interface_constraint": "path_computed_by_interface_constraint", "config_traffic_eng_rate_configured": "config_traffic_eng_rate_configured", "instance_is_up": "instance_is_up", "config_retry_count": "config_retry_count", "config_admin_group_configured": "config_admin_group_configured", "config_mtu": "config_mtu", "config_frr_holding_priority": "config_frr_holding_priority", "instance_revert_time": "instance_revert_time", "config_shortcut_area_configured": "config_shortcut_area_configured", "config_traffic_eng_max_burst": "config_traffic_eng_max_burst", "config_tspec_mtu_configured": "config_tspec_mtu_configured", "config_tie_break_most_fill": "config_tie_break_most_fill", "unreserved_priority_0_bandwidth": "unreserved_priority_0_bandwidth", "instance_admin_up": "instance_admin_up", "config_frr_one_to_one": "config_frr_one_to_one", "config_hop_limit": "config_hop_limit", "unreserved_priority_7_bandwidth": "unreserved_priority_7_bandwidth", "config_ospf_relative_metric": "config_ospf_relative_metric", "instance_retry_count": "instance_retry_count", "config_isis_ignore_metric": "config_isis_ignore_metric", "rsvp_session_path_error_code": "rsvp_session_path_error_code", "config_isis_shortcut_level_configured": "config_isis_shortcut_level_configured", "config_soft_prempt": "config_soft_prempt", "config_type_dynamic": "config_type_dynamic", "config_cspf_disabled": "config_cspf_disabled", "unreserved_priority_2_bandwidth": "unreserved_priority_2_bandwidth", "config_path": "config_path", "unreserved_priority_4_bandwidth": "unreserved_priority_4_bandwidth", "config_notify_isis": "config_notify_isis", "config_hop_limit_configured": "config_hop_limit_configured", "config_isis_announce_configured": "config_isis_announce_configured", "current_instance": "current_instance", "maximum_bandwidth": "maximum_bandwidth", "rsvp_session_state_up": "rsvp_session_state_up", "config_to_address": "config_to_address", "config_path_configured": "config_path_configured", "old_instance": "old_instance", "rsvp_session_path_error_node_address": "rsvp_session_path_error_node_address", "cspf_group_computation_mode_high_cost": "cspf_group_computation_mode_high_cost", "cspf_computation_mode": "cspf_computation_mode", "new_instance": "new_instance", "cspf_group_computation_mode_exclude_groups": "cspf_group_computation_mode_exclude_groups", "config_metric": "config_metric", "is_adaptive": "is_adaptive", "config_tie_breaking_configured": "config_tie_breaking_configured", "instance_out_port_id": "instance_out_port_id", "path_computed_by_cspf": "path_computed_by_cspf", "config_shortcut_area": "config_shortcut_area", "is_primary": "is_primary", "config_revert_time_configured": "config_revert_time_configured", "config_reoptimize_time": "config_reoptimize_time", "unreserved_priority_6_bandwidth": "unreserved_priority_6_bandwidth", "cspf_path_cost": "cspf_path_cost", "config_tspec_mtu": "config_tspec_mtu"}, "pybind.slxos.v17s_1_02.mpls_state.lsp.instances": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.instances": {"config_path_selected_path": "config_path_selected_path", "config_type_bypass": "config_type_bypass", "config_isis_shortcut_level": "config_isis_shortcut_level", "config_frr_priority_configured": "config_frr_priority_configured", "config_bfd_configured": "config_bfd_configured", "config_frr_hop_limit": "config_frr_hop_limit", "config_number_of_retries_configured": "config_number_of_retries_configured", "rsvp_session_state": "rsvp_session_state", "config_frr_setup_priority": "config_frr_setup_priority", "instance_out_label": "instance_out_label", "config_mtu_configured": "config_mtu_configured", "config_ospf_ignore_metric": "config_ospf_ignore_metric", "unreserved_priority_1_bandwidth": "unreserved_priority_1_bandwidth", "config_metric_configured": "config_metric_configured", "config_hot_standby": "config_hot_standby", "current_signaled_mean_rate": "current_signaled_mean_rate", "config_frr_global_revertive": "config_frr_global_revertive", "config_path_selected_secondary_name": "config_path_selected_secondary_name", "config_abw_configured": "config_abw_configured", "unreserved_priority_5_bandwidth": "unreserved_priority_5_bandwidth", "instance_frr_up": "instance_frr_up", "cspf_path_area": "cspf_path_area", "config_frr_hop_limit_configured": "config_frr_hop_limit_configured", "is_current_secondary": "is_current_secondary", "config_tie_break_random": "config_tie_break_random", "config_frr_hold_time": "config_frr_hold_time", "is_selected_secondary": "is_selected_secondary", "instance_is_active": "instance_is_active", "is_bypass": "is_bypass", "config_traffic_eng_max_rate": "config_traffic_eng_max_rate", "cspf_computation_error": "cspf_computation_error", "reoptimize_time_count": "reoptimize_time_count", "cspf_group_computation_mode_add_penalty": "cspf_group_computation_mode_add_penalty", "config_cos_configured": "config_cos_configured", "config_persistenct": "config_persistenct", "cspf_exclude_hops_present": "cspf_exclude_hops_present", "config_from_address_configured": "config_from_address_configured", "config_holding_prority": "config_holding_prority", "config_ospf_aaf": "config_ospf_aaf", "instance_id": "instance_id", "config_traffic_eng_mean_rate": "config_traffic_eng_mean_rate", "config_frr_bandwidth_inherited": "config_frr_bandwidth_inherited", "unreserved_priority_3_bandwidth": "unreserved_priority_3_bandwidth", "instance_frr_active": "instance_frr_active", "config_revert_time": "config_revert_time", "config_frr_one_to_many": "config_frr_one_to_many", "instance_frr_configured": "instance_frr_configured", "instance_out_port_name": "instance_out_port_name", "config_isis_relative_metric": "config_isis_relative_metric", "config_frr_bandwidth_configured": "config_frr_bandwidth_configured", "config_tie_break_least_fill": "config_tie_break_least_fill", "config_cspf_computation_mode": "config_cspf_computation_mode", "config_frr_bandwidth": "config_frr_bandwidth", "config_prority_configured": "config_prority_configured", "config_from_address": "config_from_address", "is_dynamic_bypass": "is_dynamic_bypass", "config_frr_configured": "config_frr_configured", "config_reoptimize_timer_configured": "config_reoptimize_timer_configured", "config_ospf_area": "config_ospf_area", "config_adaptive": "config_adaptive", "config_ospf_announce_metric": "config_ospf_announce_metric", "config_retry_count_configured": "config_retry_count_configured", "config_exclude_interface_change": "config_exclude_interface_change", "rsvp_session_present": "rsvp_session_present", "config_frr_admin_group_configured": "config_frr_admin_group_configured", "config_setup_prority": "config_setup_prority", "config_path_select_mode": "config_path_select_mode", "config_number_of_retries": "config_number_of_retries", "config_rro_disabled": "config_rro_disabled", "instance_up_down_count": "instance_up_down_count", "config_shortcut_ospf": "config_shortcut_ospf", "config_cos": "config_cos", "cspf_group_computation_mode_default": "cspf_group_computation_mode_default", "config_enable_ldp_tunnelling": "config_enable_ldp_tunnelling", "config_isis_level": "config_isis_level", "rsvp_session_rro_hops_present": "rsvp_session_rro_hops_present", "config_isis_announce_metric": "config_isis_announce_metric", "config_admin_up": "config_admin_up", "config_notify_ospf": "config_notify_ospf", "config_shortcut_isis": "config_shortcut_isis", "config_pinned": "config_pinned", "instance_down_reason": "instance_down_reason", "lsp_id": "lsp_id", "config_exclude_interface_configured": "config_exclude_interface_configured", "reoptimize_ignore_count": "reoptimize_ignore_count", "instance_metric": "instance_metric", "rsvp_session_path_error_value": "rsvp_session_path_error_value", "path_computed_by_interface_constraint": "path_computed_by_interface_constraint", "config_traffic_eng_rate_configured": "config_traffic_eng_rate_configured", "instance_is_up": "instance_is_up", "config_retry_count": "config_retry_count", "config_admin_group_configured": "config_admin_group_configured", "config_mtu": "config_mtu", "config_frr_holding_priority": "config_frr_holding_priority", "instance_revert_time": "instance_revert_time", "config_shortcut_area_configured": "config_shortcut_area_configured", "config_traffic_eng_max_burst": "config_traffic_eng_max_burst", "config_tspec_mtu_configured": "config_tspec_mtu_configured", "config_tie_break_most_fill": "config_tie_break_most_fill", "unreserved_priority_0_bandwidth": "unreserved_priority_0_bandwidth", "instance_admin_up": "instance_admin_up", "config_frr_one_to_one": "config_frr_one_to_one", "config_hop_limit": "config_hop_limit", "unreserved_priority_7_bandwidth": "unreserved_priority_7_bandwidth", "config_ospf_relative_metric": "config_ospf_relative_metric", "instance_retry_count": "instance_retry_count", "config_isis_ignore_metric": "config_isis_ignore_metric", "rsvp_session_path_error_code": "rsvp_session_path_error_code", "config_isis_shortcut_level_configured": "config_isis_shortcut_level_configured", "config_soft_prempt": "config_soft_prempt", "config_type_dynamic": "config_type_dynamic", "config_cspf_disabled": "config_cspf_disabled", "unreserved_priority_2_bandwidth": "unreserved_priority_2_bandwidth", "config_path": "config_path", "unreserved_priority_4_bandwidth": "unreserved_priority_4_bandwidth", "config_notify_isis": "config_notify_isis", "config_hop_limit_configured": "config_hop_limit_configured", "config_isis_announce_configured": "config_isis_announce_configured", "current_instance": "current_instance", "maximum_bandwidth": "maximum_bandwidth", "rsvp_session_state_up": "rsvp_session_state_up", "config_to_address": "config_to_address", "config_path_configured": "config_path_configured", "old_instance": "old_instance", "rsvp_session_path_error_node_address": "rsvp_session_path_error_node_address", "cspf_group_computation_mode_high_cost": "cspf_group_computation_mode_high_cost", "cspf_computation_mode": "cspf_computation_mode", "new_instance": "new_instance", "cspf_group_computation_mode_exclude_groups": "cspf_group_computation_mode_exclude_groups", "config_metric": "config_metric", "is_adaptive": "is_adaptive", "config_tie_breaking_configured": "config_tie_breaking_configured", "instance_out_port_id": "instance_out_port_id", "path_computed_by_cspf": "path_computed_by_cspf", "config_shortcut_area": "config_shortcut_area", "is_primary": "is_primary", "config_revert_time_configured": "config_revert_time_configured", "config_reoptimize_time": "config_reoptimize_time", "unreserved_priority_6_bandwidth": "unreserved_priority_6_bandwidth", "cspf_path_cost": "cspf_path_cost", "config_tspec_mtu": "config_tspec_mtu"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_admin_group_lists_get(self, lsp=None, instances=None, admin_group_lists=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.admin_group_lists', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.admin_group_lists', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.admin_group_lists', u'admin_group'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.admin_group_lists', u'admin_group')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group_lists', 'keyval': 'list_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name, exclude_any, include_all, include_any'}, {'leafval': 'admin_group_id, admin_group_name, exclude_any, include_all, include_any'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, admin_group_lists=admin_group_lists)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, admin_group_lists=admin_group_lists)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_admin_group_lists_admin_group_get(self, lsp=None, instances=None, admin_group_lists=None, admin_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    **Instance Keyword Argument Tuple**:

    :type admin_group: admin_group_id
    :param admin_group: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.admin_group_lists', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.admin_group_lists', u'admin_group_lists')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.admin_group_lists.admin_group', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.admin_group_lists.admin_group', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, admin_group_lists=admin_group_lists, admin_group=admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, admin_group_lists=admin_group_lists, admin_group=admin_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_admin_group_lists_admin_group_admin_group_name_get(self, lsp=None, instances=None, admin_group_lists=None, admin_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    **Instance Keyword Argument Tuple**:

    :type admin_group: admin_group_id
    :param admin_group: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.admin_group_lists', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.admin_group_lists', u'admin_group_lists')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.admin_group_lists.admin_group', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.admin_group_lists.admin_group', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, admin_group_lists=admin_group_lists, admin_group=admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, admin_group_lists=admin_group_lists, admin_group=admin_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_admin_group_lists_admin_group_exclude_any_get(self, lsp=None, instances=None, admin_group_lists=None, admin_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    **Instance Keyword Argument Tuple**:

    :type admin_group: admin_group_id
    :param admin_group: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.admin_group_lists', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.admin_group_lists', u'admin_group_lists')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.admin_group_lists.admin_group', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.admin_group_lists.admin_group', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, admin_group_lists=admin_group_lists, admin_group=admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, admin_group_lists=admin_group_lists, admin_group=admin_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_admin_group_lists_admin_group_include_all_get(self, lsp=None, instances=None, admin_group_lists=None, admin_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    **Instance Keyword Argument Tuple**:

    :type admin_group: admin_group_id
    :param admin_group: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.admin_group_lists', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.admin_group_lists', u'admin_group_lists')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.admin_group_lists.admin_group', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.admin_group_lists.admin_group', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, admin_group_lists=admin_group_lists, admin_group=admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, admin_group_lists=admin_group_lists, admin_group=admin_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_admin_group_lists_admin_group_include_any_get(self, lsp=None, instances=None, admin_group_lists=None, admin_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    **Instance Keyword Argument Tuple**:

    :type admin_group: admin_group_id
    :param admin_group: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.admin_group_lists', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.admin_group_lists', u'admin_group_lists')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.admin_group_lists.admin_group', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.admin_group_lists.admin_group', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, admin_group_lists=admin_group_lists, admin_group=admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, admin_group_lists=admin_group_lists, admin_group=admin_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_auto_bandwidth_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_auto_bandwidth_adjustment_interval_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_auto_bandwidth_adjustment_threshold_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_auto_bandwidth_config_template_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_auto_bandwidth_maximum_bandwidth_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_auto_bandwidth_minimum_bandwidth_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_auto_bandwidth_mode_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_auto_bandwidth_overflow_limit_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_auto_bandwidth_sample_recording_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_auto_bandwidth_underflow_limit_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_abw_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_adaptive_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_admin_group_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_admin_up_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_bfd_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_cos_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_cos_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_cspf_computation_mode_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_cspf_disabled_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_enable_ldp_tunnelling_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_exclude_any_get(self, lsp=None, instances=None, config_exclude_any=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_exclude_any: admin_group_id
    :param config_exclude_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_exclude_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.config_exclude_any', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_exclude_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_exclude_any=config_exclude_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_exclude_any=config_exclude_any)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_exclude_any_admin_group_name_get(self, lsp=None, instances=None, config_exclude_any=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_exclude_any: admin_group_id
    :param config_exclude_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_exclude_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.config_exclude_any', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_exclude_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_exclude_any=config_exclude_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_exclude_any=config_exclude_any)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_exclude_interface_change_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_exclude_interface_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_exclude_interfaces_get(self, lsp=None, instances=None, config_exclude_interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_exclude_interfaces: exclude_interface_name
    :param config_exclude_interfaces: Keyword argument tuple.

    :type exclude_interface_name: unicode
    :param exclude_interface_name: **config_exclude_interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.config_exclude_interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_exclude_interfaces', 'keyval': 'exclude_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_exclude_interfaces=config_exclude_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_exclude_interfaces=config_exclude_interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_from_address_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_from_address_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_admin_group_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_bandwidth_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_bandwidth_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_bandwidth_inherited_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_exclude_any_get(self, lsp=None, instances=None, config_frr_exclude_any=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_frr_exclude_any: admin_group_id
    :param config_frr_exclude_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_frr_exclude_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.config_frr_exclude_any', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_frr_exclude_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_frr_exclude_any=config_frr_exclude_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_frr_exclude_any=config_frr_exclude_any)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_exclude_any_admin_group_name_get(self, lsp=None, instances=None, config_frr_exclude_any=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_frr_exclude_any: admin_group_id
    :param config_frr_exclude_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_frr_exclude_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.config_frr_exclude_any', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_frr_exclude_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_frr_exclude_any=config_frr_exclude_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_frr_exclude_any=config_frr_exclude_any)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_global_revertive_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_hold_time_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_holding_priority_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_hop_limit_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_hop_limit_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_include_all_get(self, lsp=None, instances=None, config_frr_include_all=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_frr_include_all: admin_group_id
    :param config_frr_include_all: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_frr_include_all** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.config_frr_include_all', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_frr_include_all', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_frr_include_all=config_frr_include_all)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_frr_include_all=config_frr_include_all)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_include_all_admin_group_name_get(self, lsp=None, instances=None, config_frr_include_all=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_frr_include_all: admin_group_id
    :param config_frr_include_all: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_frr_include_all** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.config_frr_include_all', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_frr_include_all', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_frr_include_all=config_frr_include_all)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_frr_include_all=config_frr_include_all)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_include_any_get(self, lsp=None, instances=None, config_frr_include_any=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_frr_include_any: admin_group_id
    :param config_frr_include_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_frr_include_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.config_frr_include_any', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_frr_include_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_frr_include_any=config_frr_include_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_frr_include_any=config_frr_include_any)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_include_any_admin_group_name_get(self, lsp=None, instances=None, config_frr_include_any=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_frr_include_any: admin_group_id
    :param config_frr_include_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_frr_include_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.config_frr_include_any', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_frr_include_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_frr_include_any=config_frr_include_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_frr_include_any=config_frr_include_any)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_one_to_many_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_one_to_one_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_priority_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_frr_setup_priority_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_holding_prority_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_hop_limit_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_hop_limit_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_hot_standby_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_include_all_get(self, lsp=None, instances=None, config_include_all=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_include_all: admin_group_id
    :param config_include_all: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_include_all** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.config_include_all', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_include_all', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_include_all=config_include_all)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_include_all=config_include_all)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_include_all_admin_group_name_get(self, lsp=None, instances=None, config_include_all=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_include_all: admin_group_id
    :param config_include_all: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_include_all** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.config_include_all', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_include_all', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_include_all=config_include_all)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_include_all=config_include_all)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_include_any_get(self, lsp=None, instances=None, config_include_any=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_include_any: admin_group_id
    :param config_include_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_include_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.config_include_any', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_include_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_include_any=config_include_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_include_any=config_include_any)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_include_any_admin_group_name_get(self, lsp=None, instances=None, config_include_any=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type config_include_any: admin_group_id
    :param config_include_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_include_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.config_include_any', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_include_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, config_include_any=config_include_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, config_include_any=config_include_any)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_isis_announce_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_isis_announce_metric_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_isis_ignore_metric_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_isis_level_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_isis_relative_metric_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_isis_shortcut_level_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_isis_shortcut_level_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_metric_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_metric_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_mtu_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_mtu_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_notify_isis_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_notify_ospf_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_number_of_retries_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_number_of_retries_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_ospf_aaf_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_ospf_announce_metric_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_ospf_area_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_ospf_ignore_metric_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_ospf_relative_metric_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_path_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_path_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_path_select_mode_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_path_selected_path_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_path_selected_secondary_name_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_persistenct_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_pinned_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_prority_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_reoptimize_time_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_reoptimize_timer_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_retry_count_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_retry_count_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_revert_time_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_revert_time_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_rro_disabled_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_setup_prority_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_shortcut_area_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_shortcut_area_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_shortcut_isis_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_shortcut_ospf_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_soft_prempt_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_tie_break_least_fill_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_tie_break_most_fill_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_tie_break_random_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_tie_breaking_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_to_address_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_traffic_eng_max_burst_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_traffic_eng_max_rate_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_traffic_eng_mean_rate_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_traffic_eng_rate_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_tspec_mtu_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_tspec_mtu_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_type_bypass_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_config_type_dynamic_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_computation_error_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_computation_mode_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_exclude_hops_get(self, lsp=None, instances=None, cspf_exclude_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_exclude_hops: hop_index, hop_address
    :param cspf_exclude_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_exclude_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_exclude_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.cspf_exclude_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_exclude_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_exclude_hops_bandwidth_protection_get(self, lsp=None, instances=None, cspf_exclude_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_exclude_hops: hop_index, hop_address
    :param cspf_exclude_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_exclude_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_exclude_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.cspf_exclude_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_exclude_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_exclude_hops_hop_is_router_id_get(self, lsp=None, instances=None, cspf_exclude_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_exclude_hops: hop_index, hop_address
    :param cspf_exclude_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_exclude_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_exclude_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.cspf_exclude_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_exclude_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_exclude_hops_node_protection_get(self, lsp=None, instances=None, cspf_exclude_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_exclude_hops: hop_index, hop_address
    :param cspf_exclude_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_exclude_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_exclude_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.cspf_exclude_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_exclude_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_exclude_hops_present_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_exclude_hops_protection_get(self, lsp=None, instances=None, cspf_exclude_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_exclude_hops: hop_index, hop_address
    :param cspf_exclude_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_exclude_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_exclude_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.cspf_exclude_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_exclude_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_exclude_hops_protection_in_use_get(self, lsp=None, instances=None, cspf_exclude_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_exclude_hops: hop_index, hop_address
    :param cspf_exclude_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_exclude_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_exclude_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.cspf_exclude_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_exclude_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_exclude_hops_type_get(self, lsp=None, instances=None, cspf_exclude_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_exclude_hops: hop_index, hop_address
    :param cspf_exclude_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_exclude_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_exclude_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.cspf_exclude_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_exclude_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_exclude_hops=cspf_exclude_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_group_computation_mode_add_penalty_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_group_computation_mode_default_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_group_computation_mode_exclude_groups_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_group_computation_mode_high_cost_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_area_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_cost_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_hops_get(self, lsp=None, instances=None, cspf_path_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_path_hops: hop_index, hop_address
    :param cspf_path_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_path_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.cspf_path_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_path_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_hops_bandwidth_protection_get(self, lsp=None, instances=None, cspf_path_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_path_hops: hop_index, hop_address
    :param cspf_path_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_path_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.cspf_path_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_path_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_hops_hop_is_router_id_get(self, lsp=None, instances=None, cspf_path_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_path_hops: hop_index, hop_address
    :param cspf_path_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_path_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.cspf_path_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_path_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_hops_node_protection_get(self, lsp=None, instances=None, cspf_path_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_path_hops: hop_index, hop_address
    :param cspf_path_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_path_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.cspf_path_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_path_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_hops_protection_get(self, lsp=None, instances=None, cspf_path_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_path_hops: hop_index, hop_address
    :param cspf_path_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_path_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.cspf_path_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_path_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_hops_protection_in_use_get(self, lsp=None, instances=None, cspf_path_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_path_hops: hop_index, hop_address
    :param cspf_path_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_path_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.cspf_path_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_path_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_cspf_path_hops_type_get(self, lsp=None, instances=None, cspf_path_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type cspf_path_hops: hop_index, hop_address
    :param cspf_path_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **cspf_path_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **cspf_path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.cspf_path_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_path_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, cspf_path_hops=cspf_path_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_current_instance_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_current_signaled_mean_rate_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_instance_admin_up_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_instance_down_reason_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_instance_frr_active_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_instance_frr_configured_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_instance_frr_up_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_instance_is_active_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_instance_is_up_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_instance_metric_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_instance_out_label_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_instance_out_port_id_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_instance_out_port_name_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_instance_retry_count_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_instance_revert_time_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_instance_up_down_count_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_is_adaptive_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_is_bypass_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_is_current_secondary_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_is_dynamic_bypass_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_is_primary_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_is_selected_secondary_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_lsp_hops_get(self, lsp=None, instances=None, lsp_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_hops: hop_index, hop_address
    :param lsp_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **lsp_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **lsp_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.lsp_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.lsp_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, lsp_hops=lsp_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, lsp_hops=lsp_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_lsp_hops_bandwidth_protection_get(self, lsp=None, instances=None, lsp_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_hops: hop_index, hop_address
    :param lsp_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **lsp_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **lsp_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.lsp_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.lsp_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, lsp_hops=lsp_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, lsp_hops=lsp_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_lsp_hops_hop_is_router_id_get(self, lsp=None, instances=None, lsp_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_hops: hop_index, hop_address
    :param lsp_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **lsp_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **lsp_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.lsp_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.lsp_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, lsp_hops=lsp_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, lsp_hops=lsp_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_lsp_hops_is_strict_hop_get(self, lsp=None, instances=None, lsp_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_hops: hop_index, hop_address
    :param lsp_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **lsp_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **lsp_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.lsp_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.lsp_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, lsp_hops=lsp_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, lsp_hops=lsp_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_lsp_hops_lsp_hop_type_get(self, lsp=None, instances=None, lsp_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_hops: hop_index, hop_address
    :param lsp_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **lsp_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **lsp_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.lsp_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.lsp_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, lsp_hops=lsp_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, lsp_hops=lsp_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_lsp_hops_node_protection_get(self, lsp=None, instances=None, lsp_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_hops: hop_index, hop_address
    :param lsp_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **lsp_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **lsp_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.lsp_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.lsp_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, lsp_hops=lsp_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, lsp_hops=lsp_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_lsp_hops_protection_get(self, lsp=None, instances=None, lsp_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_hops: hop_index, hop_address
    :param lsp_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **lsp_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **lsp_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.lsp_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.lsp_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, lsp_hops=lsp_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, lsp_hops=lsp_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_lsp_hops_protection_in_use_get(self, lsp=None, instances=None, lsp_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lsp_hops: hop_index, hop_address
    :param lsp_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **lsp_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **lsp_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances.lsp_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances.lsp_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, lsp_hops=lsp_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, lsp_hops=lsp_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_maximum_bandwidth_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_new_instance_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_old_instance_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_path_computed_by_cspf_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_path_computed_by_interface_constraint_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_reoptimize_ignore_count_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_reoptimize_time_count_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_path_error_code_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_path_error_node_address_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_path_error_value_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_present_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_rro_hops_get(self, lsp=None, instances=None, rsvp_session_rro_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rsvp_session_rro_hops: hop_index, hop_address
    :param rsvp_session_rro_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **rsvp_session_rro_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **rsvp_session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.rsvp_session_rro_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rsvp_session_rro_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_rro_hops_bandwidth_protection_get(self, lsp=None, instances=None, rsvp_session_rro_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rsvp_session_rro_hops: hop_index, hop_address
    :param rsvp_session_rro_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **rsvp_session_rro_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **rsvp_session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.rsvp_session_rro_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rsvp_session_rro_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_rro_hops_hop_is_router_id_get(self, lsp=None, instances=None, rsvp_session_rro_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rsvp_session_rro_hops: hop_index, hop_address
    :param rsvp_session_rro_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **rsvp_session_rro_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **rsvp_session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.rsvp_session_rro_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rsvp_session_rro_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_rro_hops_node_protection_get(self, lsp=None, instances=None, rsvp_session_rro_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rsvp_session_rro_hops: hop_index, hop_address
    :param rsvp_session_rro_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **rsvp_session_rro_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **rsvp_session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.rsvp_session_rro_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rsvp_session_rro_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_rro_hops_present_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_rro_hops_protection_get(self, lsp=None, instances=None, rsvp_session_rro_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rsvp_session_rro_hops: hop_index, hop_address
    :param rsvp_session_rro_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **rsvp_session_rro_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **rsvp_session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.rsvp_session_rro_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rsvp_session_rro_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_rro_hops_protection_in_use_get(self, lsp=None, instances=None, rsvp_session_rro_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rsvp_session_rro_hops: hop_index, hop_address
    :param rsvp_session_rro_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **rsvp_session_rro_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **rsvp_session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.rsvp_session_rro_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rsvp_session_rro_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_rro_hops_type_get(self, lsp=None, instances=None, rsvp_session_rro_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rsvp_session_rro_hops: hop_index, hop_address
    :param rsvp_session_rro_hops: Keyword argument tuple.

    :type hop_index: long
    :param hop_index: **rsvp_session_rro_hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_address: unicode
    :param hop_address: **rsvp_session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'instances')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances.rsvp_session_rro_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rsvp_session_rro_hops', 'keyval': 'hop_index, hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances, rsvp_session_rro_hops=rsvp_session_rro_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_state_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_rsvp_session_state_up_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_unreserved_priority_0_bandwidth_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_unreserved_priority_1_bandwidth_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_unreserved_priority_2_bandwidth_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_unreserved_priority_3_bandwidth_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_unreserved_priority_4_bandwidth_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_unreserved_priority_5_bandwidth_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_unreserved_priority_6_bandwidth_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_instances_unreserved_priority_7_bandwidth_get(self, lsp=None, instances=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type instances: instance_id, lsp_id
    :param instances: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type lsp_id: long
    :param lsp_id: **instances** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_all'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'rsvp_session_rro_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_frr_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'cspf_exclude_hops'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.instances', u'config_exclude_interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.instances', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'lsp_hops'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.instances', u'admin_group_lists')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'instances', 'keyval': 'instance_id, lsp_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'hop_index, hop_address, type, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'exclude_interface_name'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'list_type'}, {'leafval': 'hop_index, hop_address, lsp_hop_type, is_strict_hop, hop_is_router_id, protection, node_protection, bandwidth_protection, protection_in_use'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, instances=instances)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, instances=instances)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_interface_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'instances'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'basic'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'frr'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup', u'backup_ingress'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'forwarding'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup', u'backup_transit'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'backup'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', u'include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', u'exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', u'include_all'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'backup'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup', u'backup_transit'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'forwarding'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup', u'backup_ingress'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'frr'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'basic'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'basic'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'frr'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'backup'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup', u'backup_transit'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup', u'backup_ingress'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'forwarding'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', u'admin_group_lists')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'instance_id, lsp_id, current_instance, new_instance, old_instance, is_primary, is_current_secondary, is_selected_secondary, instance_admin_up, instance_is_up, instance_is_active, is_adaptive, is_bypass, is_dynamic_bypass, config_admin_up, config_from_address_configured, config_from_address, config_to_address, config_type_bypass, config_type_dynamic, config_adaptive, config_ospf_area, config_isis_level, config_number_of_retries_configured, config_number_of_retries, config_path_select_mode, config_path_selected_path, config_path_selected_secondary_name, config_revert_time_configured, config_revert_time, config_retry_count_configured, config_retry_count, config_enable_ldp_tunnelling, config_shortcut_ospf, config_shortcut_area_configured, config_shortcut_area, config_notify_ospf, config_shortcut_isis, config_isis_shortcut_level_configured, config_isis_shortcut_level, config_notify_isis, config_metric_configured, config_metric, config_ospf_ignore_metric, config_ospf_relative_metric, config_ospf_announce_metric, config_ospf_aaf, config_isis_ignore_metric, config_isis_relative_metric, config_isis_announce_configured, config_isis_announce_metric, config_path_configured, config_path, config_reoptimize_timer_configured, config_reoptimize_time, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistenct, config_frr_global_revertive, config_frr_hold_time, config_soft_prempt, config_exclude_interface_change, config_prority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_bfd_configured, config_admin_group_configured, config_cspf_computation_mode, path_computed_by_cspf, path_computed_by_interface_constraint, cspf_computation_mode, cspf_group_computation_mode_default, cspf_group_computation_mode_add_penalty, cspf_group_computation_mode_exclude_groups, cspf_group_computation_mode_high_cost, cspf_path_cost, cspf_path_area, cspf_computation_error, cspf_exclude_hops_present, rsvp_session_present, rsvp_session_state_up, rsvp_session_state, rsvp_session_path_error_code, rsvp_session_path_error_value, rsvp_session_path_error_node_address, rsvp_session_rro_hops_present, config_exclude_interface_configured, maximum_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth, config_frr_configured, config_frr_one_to_one, config_frr_one_to_many, config_frr_priority_configured, config_frr_setup_priority, config_frr_holding_priority, config_frr_hop_limit_configured, config_frr_hop_limit, config_frr_bandwidth_configured, config_frr_bandwidth, config_frr_admin_group_configured, reoptimize_ignore_count, reoptimize_time_count, instance_frr_configured, instance_frr_up, instance_frr_active, instance_out_port_id, instance_out_port_name, instance_out_label, instance_revert_time, instance_retry_count, instance_up_down_count, instance_metric, instance_down_reason'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'tunnel_vif_index, lsp_type_bypass, lsp_type_dynamic, from_address_configured, from_address, to_address, admin_up, operational_status, lsp_is_active, lsp_has_primary_path, path_name, out_label, out_interface_name, primary_up, primary_active, lsp_has_secondary, secondary_up, secondary_active, lsp_has_selected_secondary, selected_secondary_up, selected_secondary_active, primary_is_selected, lsp_has_frr, frr_up, frr_active, up_down_count, retry_count, down_reason'}, {'leafval': 'configured, one_to_one, one_to_many, protection_type, frr_up, active, priority_configured, setup_priority, holding_priority, hop_limit_configured, hop_limit, bandwidth_configured, bandwidth, down_reason, computation_mode, group_computation_mode_default, group_computation_mode_add_penalty, group_computation_mode_exclude_groups, group_computation_mode_high_cost, out_port_id, out_port_name, out_label, path_cost, bypass_name, has_secondary_swithover_time, secondary_swithover_time, hold_time, global_revertive, revertive_timer_expired, fwdg_state_primary_up, fwdg_state_primary_active, fwdg_state_primary_down, fwdg_state_secondary_up, fwdg_state_secondary_active, fwdg_state_secondary_down, fwdg_state_detour_up, fwdg_state_detour_active, fwdg_state_detour_down, admin_group_configured'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_type_ingress, backup_type_transit, backup_is_active'}, {'leafval': 'path_name, path_up, active, instance_id, committed, is_new_instance, is_current_secondary, is_selected_secondary, config_adaptive, config_reoptimize_timer_configured, config_reoptimize_timer, config_reoptimize_timer_count, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistent, config_soft_prempt, config_priority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_cspf_computation_mode, config_admin_group_configured'}, {'leafval': 'tunnel_vif_index, lsp_id, forwarding_up, primary_active, primary_up, secondary_active, secondary_up, selected_secondary_active, selected_secondary_up, frr_active, frr_up, instance_id, out_port_id, out_port_name, out_label'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_type_ingress, backup_type_transit, backup_is_active'}, {'leafval': 'backup_present, backup_count, backup_ingress_count, backup_ingress_active_count, backup_transit_count, backup_transit_active_count'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'list_type'}, {'leafval': 'backup_present, backup_count, backup_ingress_count, backup_ingress_active_count, backup_transit_count, backup_transit_active_count'}, {'leafval': 'path_name, instance_id, path_up, active, committed, is_new_instance, is_current_secondary, is_selected_secondary, config_adaptive, config_reoptimize_timer_configured, config_reoptimize_timer, config_reoptimize_timer_count, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistent, config_soft_prempt, config_priority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_cspf_computation_mode, config_admin_group_configured'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_is_active'}, {'leafval': 'tunnel_vif_index, lsp_id, forwarding_up, primary_active, primary_up, secondary_active, secondary_up, selected_secondary_active, selected_secondary_up, frr_active, frr_up, instance_id, out_port_id, out_port_name, out_label'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_is_active'}, {'leafval': 'configured, one_to_one, one_to_many, protection_type, frr_up, active, priority_configured, setup_priority, holding_priority, hop_limit_configured, hop_limit, bandwidth_inherited, bandwidth_configured, bandwidth, down_reason, computation_mode, group_computation_mode_default, group_computation_mode_add_penalty, group_computation_mode_exclude_groups, group_computation_mode_high_cost, out_port_id, out_port_name, out_label, path_cost, bypass_name, has_secondary_swithover_time, secondary_swithover_time, hold_time, global_revertive, revertive_timer_expired, fwdg_state_primary_up, fwdg_state_primary_active, fwdg_state_primary_down, fwdg_state_secondary_up, fwdg_state_secondary_active, fwdg_state_secondary_down, fwdg_state_detour_up, fwdg_state_detour_active, fwdg_state_detour_down, admin_group_configured'}, {'leafval': 'instance_id, lsp_id, current_instance, new_instance, old_instance, is_primary, is_current_secondary, is_selected_secondary, instance_admin_up, instance_is_up, instance_is_active, is_adaptive, is_bypass, is_dynamic_bypass, config_admin_up, config_from_address_configured, config_from_address, config_to_address, config_type_bypass, config_type_dynamic, config_adaptive, config_ospf_area, config_isis_level, config_number_of_retries_configured, config_number_of_retries, config_path_select_mode, config_path_selected_path, config_path_selected_secondary_name, config_revert_time_configured, config_revert_time, config_retry_count_configured, config_retry_count, config_enable_ldp_tunnelling, config_shortcut_ospf, config_shortcut_area_configured, config_shortcut_area, config_notify_ospf, config_shortcut_isis, config_isis_shortcut_level_configured, config_isis_shortcut_level, config_notify_isis, config_metric_configured, config_metric, config_ospf_ignore_metric, config_ospf_relative_metric, config_ospf_announce_metric, config_ospf_aaf, config_isis_ignore_metric, config_isis_relative_metric, config_isis_announce_configured, config_isis_announce_metric, config_path_configured, config_path, config_reoptimize_timer_configured, config_reoptimize_time, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistenct, config_frr_global_revertive, config_frr_hold_time, config_soft_prempt, config_exclude_interface_change, config_prority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_bfd_configured, config_admin_group_configured, config_cspf_computation_mode, path_computed_by_cspf, path_computed_by_interface_constraint, cspf_computation_mode, cspf_group_computation_mode_default, cspf_group_computation_mode_add_penalty, cspf_group_computation_mode_exclude_groups, cspf_group_computation_mode_high_cost, cspf_path_cost, cspf_path_area, cspf_computation_error, cspf_exclude_hops_present, rsvp_session_present, rsvp_session_state_up, rsvp_session_state, rsvp_session_path_error_code, rsvp_session_path_error_value, rsvp_session_path_error_node_address, rsvp_session_rro_hops_present, config_exclude_interface_configured, maximum_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth, config_frr_configured, config_frr_one_to_one, config_frr_one_to_many, config_frr_priority_configured, config_frr_setup_priority, config_frr_holding_priority, config_frr_hop_limit_configured, config_frr_hop_limit, config_frr_bandwidth_inherited, config_frr_bandwidth_configured, config_frr_bandwidth, config_frr_admin_group_configured, reoptimize_ignore_count, reoptimize_time_count, instance_frr_configured, instance_frr_up, instance_frr_active, instance_out_port_id, instance_out_port_name, instance_out_label, instance_revert_time, instance_retry_count, instance_up_down_count, instance_metric, instance_down_reason, current_signaled_mean_rate'}, {'leafval': 'adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, is_adjustment_interval_inherited, is_adjustment_threshold_inherited, is_maximum_bandwidth_inherited, is_minimum_bandwidth_inherited, is_overflow_limit_inherited, is_underflow_limit_inherited, is_mode_inherited, is_sample_recording_inherited, working_status, num_samples_collected, last_sample_traffic_rate, maximum_of_samples_collected, maximum_of_underflow_samples, overflow_count, underflow_count, time_to_adjustment, adjustment_status, previous_bandwidth, new_bandwidth, adjustment_reason, time_of_last_adjustment'}, {'leafval': 'tunnel_vif_index, lsp_type_bypass, lsp_type_dynamic, from_address_configured, from_address, to_address, admin_up, operational_status, lsp_is_active, lsp_has_primary_path, path_name, out_label, out_interface_name, primary_up, primary_active, lsp_has_secondary, secondary_up, secondary_active, lsp_has_selected_secondary, selected_secondary_up, selected_secondary_active, primary_is_selected, lsp_has_frr, frr_up, frr_active, up_down_count, retry_count, down_reason'}, {'leafval': 'path_name, instance_id, path_up, active, committed, is_new_instance, is_current_secondary, is_selected_secondary, config_adaptive, config_reoptimize_timer_configured, config_reoptimize_timer, config_reoptimize_timer_count, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistent, config_soft_prempt, config_priority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_cspf_computation_mode, config_admin_group_configured'}, {'leafval': 'tunnel_vif_index, lsp_type_bypass, lsp_type_dynamic, from_address_configured, from_address, to_address, admin_up, operational_status, lsp_is_active, lsp_has_primary_path, path_name, out_label, out_interface_name, primary_up, primary_active, lsp_has_secondary, secondary_up, secondary_active, lsp_has_selected_secondary, selected_secondary_up, selected_secondary_active, primary_is_selected, lsp_has_frr, frr_up, frr_active, up_down_count, retry_count, down_reason'}, {'leafval': 'instance_id, lsp_id, current_instance, new_instance, old_instance, is_primary, is_current_secondary, is_selected_secondary, instance_admin_up, instance_is_up, instance_is_active, is_adaptive, is_bypass, is_dynamic_bypass, config_admin_up, config_from_address_configured, config_from_address, config_to_address, config_type_bypass, config_type_dynamic, config_adaptive, config_ospf_area, config_isis_level, config_number_of_retries_configured, config_number_of_retries, config_path_select_mode, config_path_selected_path, config_path_selected_secondary_name, config_revert_time_configured, config_revert_time, config_retry_count_configured, config_retry_count, config_enable_ldp_tunnelling, config_shortcut_ospf, config_shortcut_area_configured, config_shortcut_area, config_notify_ospf, config_shortcut_isis, config_isis_shortcut_level_configured, config_isis_shortcut_level, config_notify_isis, config_metric_configured, config_metric, config_ospf_ignore_metric, config_ospf_relative_metric, config_ospf_announce_metric, config_ospf_aaf, config_isis_ignore_metric, config_isis_relative_metric, config_isis_announce_configured, config_isis_announce_metric, config_path_configured, config_path, config_reoptimize_timer_configured, config_reoptimize_time, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistenct, config_frr_global_revertive, config_frr_hold_time, config_soft_prempt, config_exclude_interface_change, config_prority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_bfd_configured, config_admin_group_configured, config_cspf_computation_mode, path_computed_by_cspf, path_computed_by_interface_constraint, cspf_computation_mode, cspf_group_computation_mode_default, cspf_group_computation_mode_add_penalty, cspf_group_computation_mode_exclude_groups, cspf_group_computation_mode_high_cost, cspf_path_cost, cspf_path_area, cspf_computation_error, cspf_exclude_hops_present, rsvp_session_present, rsvp_session_state_up, rsvp_session_state, rsvp_session_path_error_code, rsvp_session_path_error_value, rsvp_session_path_error_node_address, rsvp_session_rro_hops_present, config_exclude_interface_configured, maximum_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth, config_frr_configured, config_frr_one_to_one, config_frr_one_to_many, config_frr_priority_configured, config_frr_setup_priority, config_frr_holding_priority, config_frr_hop_limit_configured, config_frr_hop_limit, config_frr_bandwidth_inherited, config_frr_bandwidth_configured, config_frr_bandwidth, config_frr_admin_group_configured, reoptimize_ignore_count, reoptimize_time_count, instance_frr_configured, instance_frr_up, instance_frr_active, instance_out_port_id, instance_out_port_name, instance_out_label, instance_revert_time, instance_retry_count, instance_up_down_count, instance_metric, instance_down_reason, current_signaled_mean_rate'}, {'leafval': 'configured, one_to_one, one_to_many, protection_type, frr_up, active, priority_configured, setup_priority, holding_priority, hop_limit_configured, hop_limit, bandwidth_inherited, bandwidth_configured, bandwidth, down_reason, computation_mode, group_computation_mode_default, group_computation_mode_add_penalty, group_computation_mode_exclude_groups, group_computation_mode_high_cost, out_port_id, out_port_name, out_label, path_cost, bypass_name, has_secondary_swithover_time, secondary_swithover_time, hold_time, global_revertive, revertive_timer_expired, fwdg_state_primary_up, fwdg_state_primary_active, fwdg_state_primary_down, fwdg_state_secondary_up, fwdg_state_secondary_active, fwdg_state_secondary_down, fwdg_state_detour_up, fwdg_state_detour_active, fwdg_state_detour_down, admin_group_configured'}, {'leafval': 'backup_present, backup_count, backup_ingress_count, backup_ingress_active_count, backup_transit_count, backup_transit_active_count'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_is_active'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_is_active'}, {'leafval': 'tunnel_vif_index, lsp_id, forwarding_up, primary_active, primary_up, secondary_active, secondary_up, selected_secondary_active, selected_secondary_up, frr_active, frr_up, instance_id, out_port_id, out_port_name, out_label'}, {'leafval': 'adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, is_adjustment_interval_inherited, is_adjustment_threshold_inherited, is_maximum_bandwidth_inherited, is_minimum_bandwidth_inherited, is_overflow_limit_inherited, is_underflow_limit_inherited, is_mode_inherited, is_sample_recording_inherited, working_status, num_samples_collected, last_sample_traffic_rate, maximum_of_samples_collected, maximum_of_underflow_samples, overflow_count, underflow_count, time_to_adjustment, adjustment_status, previous_bandwidth, new_bandwidth, adjustment_reason, time_of_last_adjustment'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_lsp_type_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'instances'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'basic'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'frr'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup', u'backup_ingress'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'forwarding'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.backup', u'backup_transit'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'backup'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', u'include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', u'exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.frr', u'include_all'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.frr', u'admin_group_lists'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'backup'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup', u'backup_transit'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'forwarding'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.backup', u'backup_ingress'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'frr'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'instances'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'basic'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'basic'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'instances'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'frr'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'backup'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup', u'backup_transit'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.backup', u'backup_ingress'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'forwarding'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.frr', u'admin_group_lists')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'instance_id, lsp_id, current_instance, new_instance, old_instance, is_primary, is_current_secondary, is_selected_secondary, instance_admin_up, instance_is_up, instance_is_active, is_adaptive, is_bypass, is_dynamic_bypass, config_admin_up, config_from_address_configured, config_from_address, config_to_address, config_type_bypass, config_type_dynamic, config_adaptive, config_ospf_area, config_isis_level, config_number_of_retries_configured, config_number_of_retries, config_path_select_mode, config_path_selected_path, config_path_selected_secondary_name, config_revert_time_configured, config_revert_time, config_retry_count_configured, config_retry_count, config_enable_ldp_tunnelling, config_shortcut_ospf, config_shortcut_area_configured, config_shortcut_area, config_notify_ospf, config_shortcut_isis, config_isis_shortcut_level_configured, config_isis_shortcut_level, config_notify_isis, config_metric_configured, config_metric, config_ospf_ignore_metric, config_ospf_relative_metric, config_ospf_announce_metric, config_ospf_aaf, config_isis_ignore_metric, config_isis_relative_metric, config_isis_announce_configured, config_isis_announce_metric, config_path_configured, config_path, config_reoptimize_timer_configured, config_reoptimize_time, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistenct, config_frr_global_revertive, config_frr_hold_time, config_soft_prempt, config_exclude_interface_change, config_prority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_bfd_configured, config_admin_group_configured, config_cspf_computation_mode, path_computed_by_cspf, path_computed_by_interface_constraint, cspf_computation_mode, cspf_group_computation_mode_default, cspf_group_computation_mode_add_penalty, cspf_group_computation_mode_exclude_groups, cspf_group_computation_mode_high_cost, cspf_path_cost, cspf_path_area, cspf_computation_error, cspf_exclude_hops_present, rsvp_session_present, rsvp_session_state_up, rsvp_session_state, rsvp_session_path_error_code, rsvp_session_path_error_value, rsvp_session_path_error_node_address, rsvp_session_rro_hops_present, config_exclude_interface_configured, maximum_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth, config_frr_configured, config_frr_one_to_one, config_frr_one_to_many, config_frr_priority_configured, config_frr_setup_priority, config_frr_holding_priority, config_frr_hop_limit_configured, config_frr_hop_limit, config_frr_bandwidth_configured, config_frr_bandwidth, config_frr_admin_group_configured, reoptimize_ignore_count, reoptimize_time_count, instance_frr_configured, instance_frr_up, instance_frr_active, instance_out_port_id, instance_out_port_name, instance_out_label, instance_revert_time, instance_retry_count, instance_up_down_count, instance_metric, instance_down_reason'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'tunnel_vif_index, lsp_type_bypass, lsp_type_dynamic, from_address_configured, from_address, to_address, admin_up, operational_status, lsp_is_active, lsp_has_primary_path, path_name, out_label, out_interface_name, primary_up, primary_active, lsp_has_secondary, secondary_up, secondary_active, lsp_has_selected_secondary, selected_secondary_up, selected_secondary_active, primary_is_selected, lsp_has_frr, frr_up, frr_active, up_down_count, retry_count, down_reason'}, {'leafval': 'configured, one_to_one, one_to_many, protection_type, frr_up, active, priority_configured, setup_priority, holding_priority, hop_limit_configured, hop_limit, bandwidth_configured, bandwidth, down_reason, computation_mode, group_computation_mode_default, group_computation_mode_add_penalty, group_computation_mode_exclude_groups, group_computation_mode_high_cost, out_port_id, out_port_name, out_label, path_cost, bypass_name, has_secondary_swithover_time, secondary_swithover_time, hold_time, global_revertive, revertive_timer_expired, fwdg_state_primary_up, fwdg_state_primary_active, fwdg_state_primary_down, fwdg_state_secondary_up, fwdg_state_secondary_active, fwdg_state_secondary_down, fwdg_state_detour_up, fwdg_state_detour_active, fwdg_state_detour_down, admin_group_configured'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_type_ingress, backup_type_transit, backup_is_active'}, {'leafval': 'path_name, path_up, active, instance_id, committed, is_new_instance, is_current_secondary, is_selected_secondary, config_adaptive, config_reoptimize_timer_configured, config_reoptimize_timer, config_reoptimize_timer_count, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistent, config_soft_prempt, config_priority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_cspf_computation_mode, config_admin_group_configured'}, {'leafval': 'tunnel_vif_index, lsp_id, forwarding_up, primary_active, primary_up, secondary_active, secondary_up, selected_secondary_active, selected_secondary_up, frr_active, frr_up, instance_id, out_port_id, out_port_name, out_label'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_type_ingress, backup_type_transit, backup_is_active'}, {'leafval': 'backup_present, backup_count, backup_ingress_count, backup_ingress_active_count, backup_transit_count, backup_transit_active_count'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'list_type'}, {'leafval': 'backup_present, backup_count, backup_ingress_count, backup_ingress_active_count, backup_transit_count, backup_transit_active_count'}, {'leafval': 'path_name, instance_id, path_up, active, committed, is_new_instance, is_current_secondary, is_selected_secondary, config_adaptive, config_reoptimize_timer_configured, config_reoptimize_timer, config_reoptimize_timer_count, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistent, config_soft_prempt, config_priority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_cspf_computation_mode, config_admin_group_configured'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_is_active'}, {'leafval': 'tunnel_vif_index, lsp_id, forwarding_up, primary_active, primary_up, secondary_active, secondary_up, selected_secondary_active, selected_secondary_up, frr_active, frr_up, instance_id, out_port_id, out_port_name, out_label'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_is_active'}, {'leafval': 'configured, one_to_one, one_to_many, protection_type, frr_up, active, priority_configured, setup_priority, holding_priority, hop_limit_configured, hop_limit, bandwidth_inherited, bandwidth_configured, bandwidth, down_reason, computation_mode, group_computation_mode_default, group_computation_mode_add_penalty, group_computation_mode_exclude_groups, group_computation_mode_high_cost, out_port_id, out_port_name, out_label, path_cost, bypass_name, has_secondary_swithover_time, secondary_swithover_time, hold_time, global_revertive, revertive_timer_expired, fwdg_state_primary_up, fwdg_state_primary_active, fwdg_state_primary_down, fwdg_state_secondary_up, fwdg_state_secondary_active, fwdg_state_secondary_down, fwdg_state_detour_up, fwdg_state_detour_active, fwdg_state_detour_down, admin_group_configured'}, {'leafval': 'instance_id, lsp_id, current_instance, new_instance, old_instance, is_primary, is_current_secondary, is_selected_secondary, instance_admin_up, instance_is_up, instance_is_active, is_adaptive, is_bypass, is_dynamic_bypass, config_admin_up, config_from_address_configured, config_from_address, config_to_address, config_type_bypass, config_type_dynamic, config_adaptive, config_ospf_area, config_isis_level, config_number_of_retries_configured, config_number_of_retries, config_path_select_mode, config_path_selected_path, config_path_selected_secondary_name, config_revert_time_configured, config_revert_time, config_retry_count_configured, config_retry_count, config_enable_ldp_tunnelling, config_shortcut_ospf, config_shortcut_area_configured, config_shortcut_area, config_notify_ospf, config_shortcut_isis, config_isis_shortcut_level_configured, config_isis_shortcut_level, config_notify_isis, config_metric_configured, config_metric, config_ospf_ignore_metric, config_ospf_relative_metric, config_ospf_announce_metric, config_ospf_aaf, config_isis_ignore_metric, config_isis_relative_metric, config_isis_announce_configured, config_isis_announce_metric, config_path_configured, config_path, config_reoptimize_timer_configured, config_reoptimize_time, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistenct, config_frr_global_revertive, config_frr_hold_time, config_soft_prempt, config_exclude_interface_change, config_prority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_bfd_configured, config_admin_group_configured, config_cspf_computation_mode, path_computed_by_cspf, path_computed_by_interface_constraint, cspf_computation_mode, cspf_group_computation_mode_default, cspf_group_computation_mode_add_penalty, cspf_group_computation_mode_exclude_groups, cspf_group_computation_mode_high_cost, cspf_path_cost, cspf_path_area, cspf_computation_error, cspf_exclude_hops_present, rsvp_session_present, rsvp_session_state_up, rsvp_session_state, rsvp_session_path_error_code, rsvp_session_path_error_value, rsvp_session_path_error_node_address, rsvp_session_rro_hops_present, config_exclude_interface_configured, maximum_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth, config_frr_configured, config_frr_one_to_one, config_frr_one_to_many, config_frr_priority_configured, config_frr_setup_priority, config_frr_holding_priority, config_frr_hop_limit_configured, config_frr_hop_limit, config_frr_bandwidth_inherited, config_frr_bandwidth_configured, config_frr_bandwidth, config_frr_admin_group_configured, reoptimize_ignore_count, reoptimize_time_count, instance_frr_configured, instance_frr_up, instance_frr_active, instance_out_port_id, instance_out_port_name, instance_out_label, instance_revert_time, instance_retry_count, instance_up_down_count, instance_metric, instance_down_reason, current_signaled_mean_rate'}, {'leafval': 'adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, is_adjustment_interval_inherited, is_adjustment_threshold_inherited, is_maximum_bandwidth_inherited, is_minimum_bandwidth_inherited, is_overflow_limit_inherited, is_underflow_limit_inherited, is_mode_inherited, is_sample_recording_inherited, working_status, num_samples_collected, last_sample_traffic_rate, maximum_of_samples_collected, maximum_of_underflow_samples, overflow_count, underflow_count, time_to_adjustment, adjustment_status, previous_bandwidth, new_bandwidth, adjustment_reason, time_of_last_adjustment'}, {'leafval': 'tunnel_vif_index, lsp_type_bypass, lsp_type_dynamic, from_address_configured, from_address, to_address, admin_up, operational_status, lsp_is_active, lsp_has_primary_path, path_name, out_label, out_interface_name, primary_up, primary_active, lsp_has_secondary, secondary_up, secondary_active, lsp_has_selected_secondary, selected_secondary_up, selected_secondary_active, primary_is_selected, lsp_has_frr, frr_up, frr_active, up_down_count, retry_count, down_reason'}, {'leafval': 'path_name, instance_id, path_up, active, committed, is_new_instance, is_current_secondary, is_selected_secondary, config_adaptive, config_reoptimize_timer_configured, config_reoptimize_timer, config_reoptimize_timer_count, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistent, config_soft_prempt, config_priority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_cspf_computation_mode, config_admin_group_configured'}, {'leafval': 'tunnel_vif_index, lsp_type_bypass, lsp_type_dynamic, from_address_configured, from_address, to_address, admin_up, operational_status, lsp_is_active, lsp_has_primary_path, path_name, out_label, out_interface_name, primary_up, primary_active, lsp_has_secondary, secondary_up, secondary_active, lsp_has_selected_secondary, selected_secondary_up, selected_secondary_active, primary_is_selected, lsp_has_frr, frr_up, frr_active, up_down_count, retry_count, down_reason'}, {'leafval': 'instance_id, lsp_id, current_instance, new_instance, old_instance, is_primary, is_current_secondary, is_selected_secondary, instance_admin_up, instance_is_up, instance_is_active, is_adaptive, is_bypass, is_dynamic_bypass, config_admin_up, config_from_address_configured, config_from_address, config_to_address, config_type_bypass, config_type_dynamic, config_adaptive, config_ospf_area, config_isis_level, config_number_of_retries_configured, config_number_of_retries, config_path_select_mode, config_path_selected_path, config_path_selected_secondary_name, config_revert_time_configured, config_revert_time, config_retry_count_configured, config_retry_count, config_enable_ldp_tunnelling, config_shortcut_ospf, config_shortcut_area_configured, config_shortcut_area, config_notify_ospf, config_shortcut_isis, config_isis_shortcut_level_configured, config_isis_shortcut_level, config_notify_isis, config_metric_configured, config_metric, config_ospf_ignore_metric, config_ospf_relative_metric, config_ospf_announce_metric, config_ospf_aaf, config_isis_ignore_metric, config_isis_relative_metric, config_isis_announce_configured, config_isis_announce_metric, config_path_configured, config_path, config_reoptimize_timer_configured, config_reoptimize_time, config_tspec_mtu_configured, config_tspec_mtu, config_cos_configured, config_cos, config_mtu_configured, config_mtu, config_tie_breaking_configured, config_tie_break_random, config_tie_break_least_fill, config_tie_break_most_fill, config_cspf_disabled, config_rro_disabled, config_hot_standby, config_pinned, config_persistenct, config_frr_global_revertive, config_frr_hold_time, config_soft_prempt, config_exclude_interface_change, config_prority_configured, config_setup_prority, config_holding_prority, config_hop_limit_configured, config_hop_limit, config_traffic_eng_rate_configured, config_traffic_eng_mean_rate, config_traffic_eng_max_rate, config_traffic_eng_max_burst, config_abw_configured, config_bfd_configured, config_admin_group_configured, config_cspf_computation_mode, path_computed_by_cspf, path_computed_by_interface_constraint, cspf_computation_mode, cspf_group_computation_mode_default, cspf_group_computation_mode_add_penalty, cspf_group_computation_mode_exclude_groups, cspf_group_computation_mode_high_cost, cspf_path_cost, cspf_path_area, cspf_computation_error, cspf_exclude_hops_present, rsvp_session_present, rsvp_session_state_up, rsvp_session_state, rsvp_session_path_error_code, rsvp_session_path_error_value, rsvp_session_path_error_node_address, rsvp_session_rro_hops_present, config_exclude_interface_configured, maximum_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth, config_frr_configured, config_frr_one_to_one, config_frr_one_to_many, config_frr_priority_configured, config_frr_setup_priority, config_frr_holding_priority, config_frr_hop_limit_configured, config_frr_hop_limit, config_frr_bandwidth_inherited, config_frr_bandwidth_configured, config_frr_bandwidth, config_frr_admin_group_configured, reoptimize_ignore_count, reoptimize_time_count, instance_frr_configured, instance_frr_up, instance_frr_active, instance_out_port_id, instance_out_port_name, instance_out_label, instance_revert_time, instance_retry_count, instance_up_down_count, instance_metric, instance_down_reason, current_signaled_mean_rate'}, {'leafval': 'configured, one_to_one, one_to_many, protection_type, frr_up, active, priority_configured, setup_priority, holding_priority, hop_limit_configured, hop_limit, bandwidth_inherited, bandwidth_configured, bandwidth, down_reason, computation_mode, group_computation_mode_default, group_computation_mode_add_penalty, group_computation_mode_exclude_groups, group_computation_mode_high_cost, out_port_id, out_port_name, out_label, path_cost, bypass_name, has_secondary_swithover_time, secondary_swithover_time, hold_time, global_revertive, revertive_timer_expired, fwdg_state_primary_up, fwdg_state_primary_active, fwdg_state_primary_down, fwdg_state_secondary_up, fwdg_state_secondary_active, fwdg_state_secondary_down, fwdg_state_detour_up, fwdg_state_detour_active, fwdg_state_detour_down, admin_group_configured'}, {'leafval': 'backup_present, backup_count, backup_ingress_count, backup_ingress_active_count, backup_transit_count, backup_transit_active_count'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_is_active'}, {'leafval': 'backup_from_address, backup_to_address, backup_name, backup_is_active'}, {'leafval': 'tunnel_vif_index, lsp_id, forwarding_up, primary_active, primary_up, secondary_active, secondary_up, selected_secondary_active, selected_secondary_up, frr_active, frr_up, instance_id, out_port_id, out_port_name, out_label'}, {'leafval': 'adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, is_adjustment_interval_inherited, is_adjustment_threshold_inherited, is_maximum_bandwidth_inherited, is_minimum_bandwidth_inherited, is_overflow_limit_inherited, is_underflow_limit_inherited, is_mode_inherited, is_sample_recording_inherited, working_status, num_samples_collected, last_sample_traffic_rate, maximum_of_samples_collected, maximum_of_underflow_samples, overflow_count, underflow_count, time_to_adjustment, adjustment_status, previous_bandwidth, new_bandwidth, adjustment_reason, time_of_last_adjustment'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'list_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {"path_name": "path_name", "is_selected_secondary": "is_selected_secondary", "config_cos": "config_cos", "config_traffic_eng_max_rate": "config_traffic_eng_max_rate", "config_cos_configured": "config_cos_configured", "config_traffic_eng_max_burst": "config_traffic_eng_max_burst", "config_soft_prempt": "config_soft_prempt", "committed": "committed", "config_holding_prority": "config_holding_prority", "instance_id": "instance_id", "config_cspf_disabled": "config_cspf_disabled", "config_hop_limit_configured": "config_hop_limit_configured", "config_pinned": "config_pinned", "config_mtu_configured": "config_mtu_configured", "config_persistent": "config_persistent", "config_reoptimize_timer_count": "config_reoptimize_timer_count", "is_new_instance": "is_new_instance", "config_tie_break_least_fill": "config_tie_break_least_fill", "config_cspf_computation_mode": "config_cspf_computation_mode", "config_reoptimize_timer": "config_reoptimize_timer", "config_traffic_eng_rate_configured": "config_traffic_eng_rate_configured", "config_tie_breaking_configured": "config_tie_breaking_configured", "config_mtu": "config_mtu", "active": "active", "config_traffic_eng_mean_rate": "config_traffic_eng_mean_rate", "config_hot_standby": "config_hot_standby", "config_reoptimize_timer_configured": "config_reoptimize_timer_configured", "config_adaptive": "config_adaptive", "config_priority_configured": "config_priority_configured", "config_tspec_mtu_configured": "config_tspec_mtu_configured", "config_tie_break_most_fill": "config_tie_break_most_fill", "path_up": "path_up", "config_setup_prority": "config_setup_prority", "config_abw_configured": "config_abw_configured", "config_rro_disabled": "config_rro_disabled", "config_admin_group_configured": "config_admin_group_configured", "config_hop_limit": "config_hop_limit", "is_current_secondary": "is_current_secondary", "config_tie_break_random": "config_tie_break_random", "config_tspec_mtu": "config_tspec_mtu"}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "is_selected_secondary": "is_selected_secondary", "config_cos": "config_cos", "config_traffic_eng_max_rate": "config_traffic_eng_max_rate", "config_cos_configured": "config_cos_configured", "config_traffic_eng_max_burst": "config_traffic_eng_max_burst", "config_soft_prempt": "config_soft_prempt", "committed": "committed", "config_holding_prority": "config_holding_prority", "instance_id": "instance_id", "config_cspf_disabled": "config_cspf_disabled", "config_hop_limit_configured": "config_hop_limit_configured", "config_pinned": "config_pinned", "config_mtu_configured": "config_mtu_configured", "config_persistent": "config_persistent", "config_reoptimize_timer_count": "config_reoptimize_timer_count", "is_new_instance": "is_new_instance", "config_tie_break_least_fill": "config_tie_break_least_fill", "config_cspf_computation_mode": "config_cspf_computation_mode", "config_reoptimize_timer": "config_reoptimize_timer", "config_traffic_eng_rate_configured": "config_traffic_eng_rate_configured", "config_tie_breaking_configured": "config_tie_breaking_configured", "config_mtu": "config_mtu", "active": "active", "config_traffic_eng_mean_rate": "config_traffic_eng_mean_rate", "config_hot_standby": "config_hot_standby", "config_reoptimize_timer_configured": "config_reoptimize_timer_configured", "config_adaptive": "config_adaptive", "config_priority_configured": "config_priority_configured", "config_tspec_mtu_configured": "config_tspec_mtu_configured", "config_tie_break_most_fill": "config_tie_break_most_fill", "path_up": "path_up", "config_setup_prority": "config_setup_prority", "config_abw_configured": "config_abw_configured", "config_rro_disabled": "config_rro_disabled", "config_admin_group_configured": "config_admin_group_configured", "config_hop_limit": "config_hop_limit", "is_current_secondary": "is_current_secondary", "config_tie_break_random": "config_tie_break_random", "config_tspec_mtu": "config_tspec_mtu"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "is_selected_secondary": "is_selected_secondary", "config_cos": "config_cos", "config_traffic_eng_max_rate": "config_traffic_eng_max_rate", "config_cos_configured": "config_cos_configured", "config_traffic_eng_max_burst": "config_traffic_eng_max_burst", "config_soft_prempt": "config_soft_prempt", "committed": "committed", "config_holding_prority": "config_holding_prority", "instance_id": "instance_id", "config_cspf_disabled": "config_cspf_disabled", "config_hop_limit_configured": "config_hop_limit_configured", "config_pinned": "config_pinned", "config_mtu_configured": "config_mtu_configured", "config_persistent": "config_persistent", "config_reoptimize_timer_count": "config_reoptimize_timer_count", "is_new_instance": "is_new_instance", "config_tie_break_least_fill": "config_tie_break_least_fill", "config_cspf_computation_mode": "config_cspf_computation_mode", "config_reoptimize_timer": "config_reoptimize_timer", "config_traffic_eng_rate_configured": "config_traffic_eng_rate_configured", "config_tie_breaking_configured": "config_tie_breaking_configured", "config_mtu": "config_mtu", "active": "active", "config_traffic_eng_mean_rate": "config_traffic_eng_mean_rate", "config_hot_standby": "config_hot_standby", "config_reoptimize_timer_configured": "config_reoptimize_timer_configured", "config_adaptive": "config_adaptive", "config_priority_configured": "config_priority_configured", "config_tspec_mtu_configured": "config_tspec_mtu_configured", "config_tie_break_most_fill": "config_tie_break_most_fill", "path_up": "path_up", "config_setup_prority": "config_setup_prority", "config_abw_configured": "config_abw_configured", "config_rro_disabled": "config_rro_disabled", "config_admin_group_configured": "config_admin_group_configured", "config_hop_limit": "config_hop_limit", "is_current_secondary": "is_current_secondary", "config_tie_break_random": "config_tie_break_random", "config_tspec_mtu": "config_tspec_mtu"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_active_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"active": "active", "path_name": "path_name", "instance_id": "instance_id"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"active": "active", "path_name": "path_name", "instance_id": "instance_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_admin_group_lists_get(self, lsp=None, secondary_path=None, admin_group_lists=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.admin_group_lists', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.admin_group_lists', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.admin_group_lists', u'admin_group'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.admin_group_lists', u'admin_group')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group_lists', 'keyval': 'list_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name, exclude_any, include_all, include_any'}, {'leafval': 'admin_group_id, admin_group_name, exclude_any, include_all, include_any'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, admin_group_lists=admin_group_lists)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, admin_group_lists=admin_group_lists)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_admin_group_lists_admin_group_get(self, lsp=None, secondary_path=None, admin_group_lists=None, admin_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    **Instance Keyword Argument Tuple**:

    :type admin_group: admin_group_id
    :param admin_group: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.admin_group_lists', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.admin_group_lists', u'admin_group_lists')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.admin_group_lists.admin_group', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.admin_group_lists.admin_group', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, admin_group_lists=admin_group_lists, admin_group=admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, admin_group_lists=admin_group_lists, admin_group=admin_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_admin_group_lists_admin_group_admin_group_name_get(self, lsp=None, secondary_path=None, admin_group_lists=None, admin_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    **Instance Keyword Argument Tuple**:

    :type admin_group: admin_group_id
    :param admin_group: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.admin_group_lists', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.admin_group_lists', u'admin_group_lists')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.admin_group_lists.admin_group', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.admin_group_lists.admin_group', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, admin_group_lists=admin_group_lists, admin_group=admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, admin_group_lists=admin_group_lists, admin_group=admin_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_admin_group_lists_admin_group_exclude_any_get(self, lsp=None, secondary_path=None, admin_group_lists=None, admin_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    **Instance Keyword Argument Tuple**:

    :type admin_group: admin_group_id
    :param admin_group: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.admin_group_lists', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.admin_group_lists', u'admin_group_lists')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.admin_group_lists.admin_group', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.admin_group_lists.admin_group', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, admin_group_lists=admin_group_lists, admin_group=admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, admin_group_lists=admin_group_lists, admin_group=admin_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_admin_group_lists_admin_group_include_all_get(self, lsp=None, secondary_path=None, admin_group_lists=None, admin_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    **Instance Keyword Argument Tuple**:

    :type admin_group: admin_group_id
    :param admin_group: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.admin_group_lists', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.admin_group_lists', u'admin_group_lists')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.admin_group_lists.admin_group', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.admin_group_lists.admin_group', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, admin_group_lists=admin_group_lists, admin_group=admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, admin_group_lists=admin_group_lists, admin_group=admin_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_admin_group_lists_admin_group_include_any_get(self, lsp=None, secondary_path=None, admin_group_lists=None, admin_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type admin_group_lists: list_type
    :param admin_group_lists: Keyword argument tuple.

    :type list_type: unicode
    :param list_type: **admin_group_lists** tuple argument.

        * enumeration restriction: ::

            ['lsp-admin-group-list-secondary',
            'lsp-admin-group-list-primary',
            'lsp-admin-group-list-frr']

    **Instance Keyword Argument Tuple**:

    :type admin_group: admin_group_id
    :param admin_group: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.admin_group_lists', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.admin_group_lists', u'admin_group_lists')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.admin_group_lists.admin_group', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.admin_group_lists.admin_group', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'list_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'admin_group', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, admin_group_lists=admin_group_lists, admin_group=admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, admin_group_lists=admin_group_lists, admin_group=admin_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_auto_bandwidth_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_auto_bandwidth_adjustment_interval_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_auto_bandwidth_adjustment_threshold_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_auto_bandwidth_config_template_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_auto_bandwidth_maximum_bandwidth_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_auto_bandwidth_minimum_bandwidth_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_auto_bandwidth_mode_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_auto_bandwidth_overflow_limit_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_auto_bandwidth_sample_recording_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_auto_bandwidth_underflow_limit_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path.auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name, instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_committed_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "committed": "committed"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "committed": "committed"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_abw_configured_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_abw_configured": "config_abw_configured"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_abw_configured": "config_abw_configured"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_adaptive_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"config_adaptive": "config_adaptive", "path_name": "path_name", "instance_id": "instance_id"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"config_adaptive": "config_adaptive", "path_name": "path_name", "instance_id": "instance_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_admin_group_configured_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_admin_group_configured": "config_admin_group_configured"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_admin_group_configured": "config_admin_group_configured"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_cos_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_cos": "config_cos"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_cos": "config_cos"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_cos_configured_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"config_cos_configured": "config_cos_configured", "path_name": "path_name", "instance_id": "instance_id"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"config_cos_configured": "config_cos_configured", "path_name": "path_name", "instance_id": "instance_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_cspf_computation_mode_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_cspf_computation_mode": "config_cspf_computation_mode"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_cspf_computation_mode": "config_cspf_computation_mode"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_cspf_disabled_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_cspf_disabled": "config_cspf_disabled"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_cspf_disabled": "config_cspf_disabled"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_exclude_any_get(self, lsp=None, secondary_path=None, config_exclude_any=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type config_exclude_any: admin_group_id
    :param config_exclude_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_exclude_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path.config_exclude_any', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_exclude_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, config_exclude_any=config_exclude_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, config_exclude_any=config_exclude_any)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_exclude_any_admin_group_name_get(self, lsp=None, secondary_path=None, config_exclude_any=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type config_exclude_any: admin_group_id
    :param config_exclude_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_exclude_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path.config_exclude_any', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_exclude_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, config_exclude_any=config_exclude_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, config_exclude_any=config_exclude_any)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_holding_prority_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_holding_prority": "config_holding_prority"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_holding_prority": "config_holding_prority"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_hop_limit_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_hop_limit": "config_hop_limit"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_hop_limit": "config_hop_limit"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_hop_limit_configured_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_hop_limit_configured": "config_hop_limit_configured"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_hop_limit_configured": "config_hop_limit_configured"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_hot_standby_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_hot_standby": "config_hot_standby"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_hot_standby": "config_hot_standby"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_include_all_get(self, lsp=None, secondary_path=None, config_include_all=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type config_include_all: admin_group_id
    :param config_include_all: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_include_all** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path.config_include_all', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_include_all', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, config_include_all=config_include_all)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, config_include_all=config_include_all)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_include_all_admin_group_name_get(self, lsp=None, secondary_path=None, config_include_all=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type config_include_all: admin_group_id
    :param config_include_all: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_include_all** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path.config_include_all', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_include_all', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, config_include_all=config_include_all)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, config_include_all=config_include_all)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_include_any_get(self, lsp=None, secondary_path=None, config_include_any=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type config_include_any: admin_group_id
    :param config_include_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_include_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path.config_include_any', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_include_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, config_include_any=config_include_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, config_include_any=config_include_any)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_include_any_admin_group_name_get(self, lsp=None, secondary_path=None, config_include_any=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type config_include_any: admin_group_id
    :param config_include_any: Keyword argument tuple.

    :type admin_group_id: long
    :param admin_group_id: **config_include_any** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path.config_include_any', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'config_include_any', 'keyval': 'admin_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path, config_include_any=config_include_any)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path, config_include_any=config_include_any)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_mtu_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_mtu": "config_mtu"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_mtu": "config_mtu"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_mtu_configured_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_mtu_configured": "config_mtu_configured"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_mtu_configured": "config_mtu_configured"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_persistent_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_persistent": "config_persistent"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_persistent": "config_persistent"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_pinned_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_pinned": "config_pinned"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_pinned": "config_pinned"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_priority_configured_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_priority_configured": "config_priority_configured"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_priority_configured": "config_priority_configured"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_reoptimize_timer_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_reoptimize_timer": "config_reoptimize_timer"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_reoptimize_timer": "config_reoptimize_timer"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_reoptimize_timer_configured_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_reoptimize_timer_configured": "config_reoptimize_timer_configured"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_reoptimize_timer_configured": "config_reoptimize_timer_configured"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_reoptimize_timer_count_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_reoptimize_timer_count": "config_reoptimize_timer_count"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_reoptimize_timer_count": "config_reoptimize_timer_count"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_rro_disabled_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"config_rro_disabled": "config_rro_disabled", "path_name": "path_name", "instance_id": "instance_id"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"config_rro_disabled": "config_rro_disabled", "path_name": "path_name", "instance_id": "instance_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_setup_prority_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_setup_prority": "config_setup_prority"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_setup_prority": "config_setup_prority"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_soft_prempt_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_soft_prempt": "config_soft_prempt"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_soft_prempt": "config_soft_prempt"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_tie_break_least_fill_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_tie_break_least_fill": "config_tie_break_least_fill"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_tie_break_least_fill": "config_tie_break_least_fill"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_tie_break_most_fill_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_tie_break_most_fill": "config_tie_break_most_fill"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_tie_break_most_fill": "config_tie_break_most_fill"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_tie_break_random_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_tie_break_random": "config_tie_break_random"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_tie_break_random": "config_tie_break_random"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_tie_breaking_configured_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_tie_breaking_configured": "config_tie_breaking_configured"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_tie_breaking_configured": "config_tie_breaking_configured"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_traffic_eng_max_burst_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "config_traffic_eng_max_burst": "config_traffic_eng_max_burst", "instance_id": "instance_id"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "config_traffic_eng_max_burst": "config_traffic_eng_max_burst", "instance_id": "instance_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_traffic_eng_max_rate_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"config_traffic_eng_max_rate": "config_traffic_eng_max_rate", "path_name": "path_name", "instance_id": "instance_id"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"config_traffic_eng_max_rate": "config_traffic_eng_max_rate", "path_name": "path_name", "instance_id": "instance_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_traffic_eng_mean_rate_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_traffic_eng_mean_rate": "config_traffic_eng_mean_rate"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_traffic_eng_mean_rate": "config_traffic_eng_mean_rate"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_traffic_eng_rate_configured_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_traffic_eng_rate_configured": "config_traffic_eng_rate_configured"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_traffic_eng_rate_configured": "config_traffic_eng_rate_configured"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_tspec_mtu_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_tspec_mtu": "config_tspec_mtu"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "config_tspec_mtu": "config_tspec_mtu"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_config_tspec_mtu_configured_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "config_tspec_mtu_configured": "config_tspec_mtu_configured", "instance_id": "instance_id"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "config_tspec_mtu_configured": "config_tspec_mtu_configured", "instance_id": "instance_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_instance_id_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_is_current_secondary_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "is_current_secondary": "is_current_secondary"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "is_current_secondary": "is_current_secondary"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_is_new_instance_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"is_new_instance": "is_new_instance", "path_name": "path_name", "instance_id": "instance_id"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"is_new_instance": "is_new_instance", "path_name": "path_name", "instance_id": "instance_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_is_selected_secondary_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "is_selected_secondary": "is_selected_secondary"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_name": "path_name", "instance_id": "instance_id", "is_selected_secondary": "is_selected_secondary"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsp_secondary_path_path_up_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type secondary_path: path_name, instance_id
    :param secondary_path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **secondary_path** tuple argument.

    :type instance_id: YANGBool
    :param instance_id: **secondary_path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path', u'admin_group_lists'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_exclude_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_any'), ('pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path', u'config_include_all')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'config_template, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'list_type'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}, {'leafval': 'admin_group_id, admin_group_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.lsp.secondary_path": {}, "pybind.slxos.v17r_2_00.mpls_state.lsp.secondary_path": {"path_up": "path_up", "path_name": "path_name", "instance_id": "instance_id"}, "pybind.slxos.v17r_1_01a.mpls_state.lsp.secondary_path": {"path_up": "path_up", "path_name": "path_name", "instance_id": "instance_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsps_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsps_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_lsps_operational_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17s_1_02.mpls_state.memory', u'pools'), ('pybind.slxos.v17s_1_02.mpls_state.memory', u'stats')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'pool_index'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'pool_index'}, {'leafval': 'pool_index'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_pools_get(self, pools=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type pools: pool_index
    :param pools: Keyword argument tuple.

    :type pool_index: long
    :param pool_index: **pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.pools', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.pools', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.pools', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.memory.pools', u'sub_pools'), ('pybind.slxos.v17r_1_01a.mpls_state.memory.pools', u'sub_pools'), ('pybind.slxos.v17r_2_00.mpls_state.memory.pools', u'sub_pools')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'pools', 'keyval': 'pool_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sub_pool_index, gen_size, block_size, gen_blocks, current_gens, current_blocks, free_blocks'}, {'leafval': 'sub_pool_index, gen_size, block_size, gen_blocks, current_gens, current_blocks, free_blocks'}, {'leafval': 'sub_pool_index, gen_size, block_size, gen_blocks, current_gens, current_blocks, free_blocks'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pools=pools)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pools=pools)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_pools_sub_pools_get(self, pools=None, sub_pools=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pools: pool_index
    :param pools: Keyword argument tuple.

    :type pool_index: long
    :param pool_index: **pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_pools: sub_pool_index
    :param sub_pools: Keyword argument tuple.

    :type sub_pool_index: long
    :param sub_pool_index: **sub_pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.memory.pools', u'pools'), ('pybind.slxos.v17s_1_02.mpls_state.memory.pools', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state.memory.pools', u'pools')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pool_index', 'extra_keyval': ''}, {'keyval': 'pool_index', 'extra_keyval': ''}, {'keyval': 'pool_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_pools', 'keyval': 'sub_pool_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pools=pools, sub_pools=sub_pools)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pools=pools, sub_pools=sub_pools)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_pools_sub_pools_block_size_get(self, pools=None, sub_pools=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pools: pool_index
    :param pools: Keyword argument tuple.

    :type pool_index: long
    :param pool_index: **pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_pools: sub_pool_index
    :param sub_pools: Keyword argument tuple.

    :type sub_pool_index: long
    :param sub_pool_index: **sub_pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.memory.pools', u'pools'), ('pybind.slxos.v17s_1_02.mpls_state.memory.pools', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state.memory.pools', u'pools')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pool_index', 'extra_keyval': ''}, {'keyval': 'pool_index', 'extra_keyval': ''}, {'keyval': 'pool_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_pools', 'keyval': 'sub_pool_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pools=pools, sub_pools=sub_pools)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pools=pools, sub_pools=sub_pools)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_pools_sub_pools_current_blocks_get(self, pools=None, sub_pools=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pools: pool_index
    :param pools: Keyword argument tuple.

    :type pool_index: long
    :param pool_index: **pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_pools: sub_pool_index
    :param sub_pools: Keyword argument tuple.

    :type sub_pool_index: long
    :param sub_pool_index: **sub_pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.memory.pools', u'pools'), ('pybind.slxos.v17s_1_02.mpls_state.memory.pools', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state.memory.pools', u'pools')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pool_index', 'extra_keyval': ''}, {'keyval': 'pool_index', 'extra_keyval': ''}, {'keyval': 'pool_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_pools', 'keyval': 'sub_pool_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pools=pools, sub_pools=sub_pools)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pools=pools, sub_pools=sub_pools)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_pools_sub_pools_current_gens_get(self, pools=None, sub_pools=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pools: pool_index
    :param pools: Keyword argument tuple.

    :type pool_index: long
    :param pool_index: **pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_pools: sub_pool_index
    :param sub_pools: Keyword argument tuple.

    :type sub_pool_index: long
    :param sub_pool_index: **sub_pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.memory.pools', u'pools'), ('pybind.slxos.v17s_1_02.mpls_state.memory.pools', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state.memory.pools', u'pools')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pool_index', 'extra_keyval': ''}, {'keyval': 'pool_index', 'extra_keyval': ''}, {'keyval': 'pool_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_pools', 'keyval': 'sub_pool_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pools=pools, sub_pools=sub_pools)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pools=pools, sub_pools=sub_pools)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_pools_sub_pools_free_blocks_get(self, pools=None, sub_pools=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pools: pool_index
    :param pools: Keyword argument tuple.

    :type pool_index: long
    :param pool_index: **pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_pools: sub_pool_index
    :param sub_pools: Keyword argument tuple.

    :type sub_pool_index: long
    :param sub_pool_index: **sub_pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.memory.pools', u'pools'), ('pybind.slxos.v17s_1_02.mpls_state.memory.pools', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state.memory.pools', u'pools')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pool_index', 'extra_keyval': ''}, {'keyval': 'pool_index', 'extra_keyval': ''}, {'keyval': 'pool_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_pools', 'keyval': 'sub_pool_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pools=pools, sub_pools=sub_pools)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pools=pools, sub_pools=sub_pools)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_pools_sub_pools_gen_blocks_get(self, pools=None, sub_pools=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pools: pool_index
    :param pools: Keyword argument tuple.

    :type pool_index: long
    :param pool_index: **pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_pools: sub_pool_index
    :param sub_pools: Keyword argument tuple.

    :type sub_pool_index: long
    :param sub_pool_index: **sub_pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.memory.pools', u'pools'), ('pybind.slxos.v17s_1_02.mpls_state.memory.pools', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state.memory.pools', u'pools')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pool_index', 'extra_keyval': ''}, {'keyval': 'pool_index', 'extra_keyval': ''}, {'keyval': 'pool_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_pools', 'keyval': 'sub_pool_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pools=pools, sub_pools=sub_pools)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pools=pools, sub_pools=sub_pools)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_pools_sub_pools_gen_size_get(self, pools=None, sub_pools=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pools: pool_index
    :param pools: Keyword argument tuple.

    :type pool_index: long
    :param pool_index: **pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type sub_pools: sub_pool_index
    :param sub_pools: Keyword argument tuple.

    :type sub_pool_index: long
    :param sub_pool_index: **sub_pools** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.memory.pools', u'pools'), ('pybind.slxos.v17s_1_02.mpls_state.memory.pools', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state.memory.pools', u'pools')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.pools.sub_pools', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pool_index', 'extra_keyval': ''}, {'keyval': 'pool_index', 'extra_keyval': ''}, {'keyval': 'pool_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sub_pools', 'keyval': 'sub_pool_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pools=pools, sub_pools=sub_pools)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pools=pools, sub_pools=sub_pools)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_stats_get(self, stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.stats', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.stats', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_stats_alloc_fails_get(self, stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.stats', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.stats', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_stats_free_fails_get(self, stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.stats', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.stats', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_stats_mem_type_get(self, stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.stats', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.stats', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_stats_num_alloc_get(self, stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.stats', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.stats', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_stats_peak_alloc_get(self, stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.stats', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.stats', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_stats_total_allocs_get(self, stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.stats', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.stats', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_stats_total_bytes_get(self, stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.stats', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.stats', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_stats_total_frees_get(self, stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type stats: mem_stats_index
    :param stats: Keyword argument tuple.

    :type mem_stats_index: long
    :param mem_stats_index: **stats** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory.stats', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory.stats', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory.stats', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'stats', 'keyval': 'mem_stats_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, stats=stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, stats=stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_memory_total_non_pool_memory_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.memory', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.memory', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.memory', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17s_1_02.mpls_state.memory', u'pools'), ('pybind.slxos.v17s_1_02.mpls_state.memory', u'stats')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'pool_index'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'pool_index'}, {'leafval': 'pool_index'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_path_get(self, path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.path', u'path_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.path', u'path_lsps'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17s_1_02.mpls_state.path', u'path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.path', u'path_lsps'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.path', u'path_lsps'), ('pybind.slxos.v17r_2_00.mpls_state.path', u'path_hops')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hop_address, hop_type'}, {'leafval': 'lsp_name, lsp_type'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'hop_address, hop_type'}, {'leafval': 'lsp_name, lsp_type'}, {'leafval': 'destination_route'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'lsp_name, lsp_type'}, {'leafval': 'hop_address, hop_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_path_path_hops_get(self, path=None, path_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type path_hops: hop_address
    :param path_hops: Keyword argument tuple.

    :type hop_address: unicode
    :param hop_address: **path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.path', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.path', u'path'), ('pybind.slxos.v17s_1_02.mpls_state.path', u'path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.path.path_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.path.path_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.path.path_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_hops', 'keyval': 'hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_hops=path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_hops=path_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_path_path_hops_hop_type_get(self, path=None, path_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type path_hops: hop_address
    :param path_hops: Keyword argument tuple.

    :type hop_address: unicode
    :param hop_address: **path_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.path', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.path', u'path'), ('pybind.slxos.v17s_1_02.mpls_state.path', u'path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.path.path_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.path.path_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.path.path_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_hops', 'keyval': 'hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_hops=path_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_hops=path_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_path_path_lsps_get(self, path=None, path_lsps=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type path_lsps: lsp_name
    :param path_lsps: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **path_lsps** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.path', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.path', u'path'), ('pybind.slxos.v17s_1_02.mpls_state.path', u'path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.path.path_lsps', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.path.path_lsps', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.path.path_lsps', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_lsps', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_lsps=path_lsps)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_lsps=path_lsps)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_path_path_lsps_lsp_type_get(self, path=None, path_lsps=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type path_lsps: lsp_name
    :param path_lsps: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **path_lsps** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.path', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.path', u'path'), ('pybind.slxos.v17s_1_02.mpls_state.path', u'path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.path.path_lsps', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.path.path_lsps', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.path.path_lsps', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_lsps', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_lsps=path_lsps)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_lsps=path_lsps)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_path_usage_count_get(self, path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.path', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.path', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.path', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.path', u'path_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.path', u'path_lsps'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17s_1_02.mpls_state.path', u'path_hops'), ('pybind.slxos.v17s_1_02.mpls_state.path', u'path_lsps'), ('pybind.slxos.v17s_1_02.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.path', u'path_lsps'), ('pybind.slxos.v17r_2_00.mpls_state.path', u'path_hops')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hop_address, hop_type'}, {'leafval': 'lsp_name, lsp_type'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'hop_address, hop_type'}, {'leafval': 'lsp_name, lsp_type'}, {'leafval': 'destination_route'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'lsp_name, lsp_type'}, {'leafval': 'hop_address, hop_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_paths_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.policy": {}, "pybind.slxos.v17r_1_01a.mpls_state.policy": {"rtm_route_filter_all_ibgp_enabled": "rtm_route_filter_all_ibgp_enabled", "te_policy_protocol": "te_policy_protocol", "autobw_num_sample_record": "autobw_num_sample_record", "lsp_retry_interval": "lsp_retry_interval", "ingress_tnnl_actg": "ingress_tnnl_actg", "rsvp_periodic_flooding_timer": "rsvp_periodic_flooding_timer", "qos_ttl_mode": "qos_ttl_mode", "load_interval": "load_interval", "handle_ospf_nbr_down": "handle_ospf_nbr_down", "te_policy_flags": "te_policy_flags", "auto_bandwidth_enabled": "auto_bandwidth_enabled", "cspf_group_computation_mode": "cspf_group_computation_mode", "fast_retry_on": "fast_retry_on", "soft_preempt_cleanup_timer": "soft_preempt_cleanup_timer", "max_lsp_retries": "max_lsp_retries", "cspf_comp_ignore_overload_bit": "cspf_comp_ignore_overload_bit", "rtm_route_filter_enabled": "rtm_route_filter_enabled", "cspf_comp_mode": "cspf_comp_mode", "implicit_commit_value": "implicit_commit_value", "te_policy_area": "te_policy_area", "cspf_intf": "cspf_intf", "transit_session_actg": "transit_session_actg", "handle_isis_nbr_down": "handle_isis_nbr_down", "frr_backup_retry_interval": "frr_backup_retry_interval", "autobw_sample_interval": "autobw_sample_interval"}, "pybind.slxos.v17r_2_00.mpls_state.policy": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_admin_groups_get(self, admin_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type admin_groups: name
    :param admin_groups: Keyword argument tuple.

    :type name: unicode
    :param name: **admin_groups** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy.admin_groups', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy.admin_groups', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy.admin_groups', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'admin_groups', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, admin_groups=admin_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, admin_groups=admin_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_admin_groups_group_number_get(self, admin_groups=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type admin_groups: name
    :param admin_groups: Keyword argument tuple.

    :type name: unicode
    :param name: **admin_groups** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy.admin_groups', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy.admin_groups', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy.admin_groups', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'admin_groups', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, admin_groups=admin_groups)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, admin_groups=admin_groups)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_auto_bandwidth_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_autobw_num_sample_record_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_autobw_sample_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_cspf_comp_ignore_overload_bit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_cspf_comp_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_cspf_group_computation_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_cspf_intf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_fast_retry_on_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_frr_backup_retry_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_handle_isis_nbr_down_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_handle_ospf_nbr_down_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_implicit_commit_value_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_ingress_tnnl_actg_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_label_propagate_ttl_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_load_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_lsp_retry_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_max_lsp_retries_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_propagate_ttl_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_qos_ttl_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_rsvp_flooding_thresholds_get(self, rsvp_flooding_thresholds=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type rsvp_flooding_thresholds: threshold_type
    :param rsvp_flooding_thresholds: Keyword argument tuple.

    :type threshold_type: unicode
    :param threshold_type: **rsvp_flooding_thresholds** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy.rsvp_flooding_thresholds', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy.rsvp_flooding_thresholds', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy.rsvp_flooding_thresholds', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rsvp_flooding_thresholds', 'keyval': 'threshold_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rsvp_flooding_thresholds=rsvp_flooding_thresholds)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rsvp_flooding_thresholds=rsvp_flooding_thresholds)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_rsvp_periodic_flooding_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_rtm_route_filter_all_ibgp_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_rtm_route_filter_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_soft_preempt_cleanup_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_switchover_activation_delay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_switchover_hold_tear_delay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_te_policy_area_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_te_policy_flags_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_te_policy_protocol_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_transit_session_actg_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.policy', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_policy_vrf_propagate_ttl_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17s_1_02.mpls_state.policy', u'admin_groups')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_route_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.route', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.route', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.route', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_route_dest_ip_prefix_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.route', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.route', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.route', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_route_gateway_ip_addr_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.route', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.route', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.route', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_route_metric_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.route', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.route', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.route', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_route_out_interface_name_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.route', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.route', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.route', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_route_out_label_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.route', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.route', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.route', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_route_outseg_index_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.route', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.route', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.route', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_route_protocol_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.route', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.route', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.route', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_route_use_count_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.route', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.route', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.route', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_route_vif_index_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: entry_index
    :param route: Keyword argument tuple.

    :type entry_index: long
    :param entry_index: **route** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.route', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.route', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.route', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'entry_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_backup_bandwidth_requirement_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_delay_resv_sending_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'lsp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_isis_nbr_down_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'lsp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_get(self, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'lsp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_get(self, link=None, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop')]
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "cspf_hop_count": "cspf_hop_count", "lsp_name": "lsp_name", "nbr_down_enabled": "nbr_down_enabled", "rro_enabled": "rro_enabled", "cspf_enabled": "cspf_enabled", "nbr_down_inprogress": "nbr_down_inprogress", "rro_hop_count": "rro_hop_count", "frr_enabled": "frr_enabled", "link_count": "link_count"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp": {}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "cspf_hop_count": "cspf_hop_count", "lsp_name": "lsp_name", "nbr_down_enabled": "nbr_down_enabled", "rro_enabled": "rro_enabled", "cspf_enabled": "cspf_enabled", "nbr_down_inprogress": "nbr_down_inprogress", "rro_hop_count": "rro_hop_count", "frr_enabled": "frr_enabled", "link_count": "link_count"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_count_get(self, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'lsp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_cspf_enabled_get(self, link=None, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop')]
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "cspf_enabled": "cspf_enabled"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp": {"lsp_name": "lsp_name", "cspf_enabled": "cspf_enabled"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "cspf_enabled": "cspf_enabled"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_cspf_hop_get(self, link=None, lsp=None, cspf_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type cspf_hop: index
    :param cspf_hop: Keyword argument tuple.

    :type index: long
    :param index: **cspf_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp.cspf_hop', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp.cspf_hop', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, cspf_hop=cspf_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, cspf_hop=cspf_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_cspf_hop_count_get(self, link=None, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop')]
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "cspf_hop_count": "cspf_hop_count"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp": {"lsp_name": "lsp_name", "cspf_hop_count": "cspf_hop_count"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "cspf_hop_count": "cspf_hop_count"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_cspf_hop_ip_address_get(self, link=None, lsp=None, cspf_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type cspf_hop: index
    :param cspf_hop: Keyword argument tuple.

    :type index: long
    :param index: **cspf_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp.cspf_hop', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp.cspf_hop', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, cspf_hop=cspf_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, cspf_hop=cspf_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_cspf_hop_nbr_ip_address_get(self, link=None, lsp=None, cspf_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type cspf_hop: index
    :param cspf_hop: Keyword argument tuple.

    :type index: long
    :param index: **cspf_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp.cspf_hop', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp.cspf_hop', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, cspf_hop=cspf_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, cspf_hop=cspf_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_frr_enabled_get(self, link=None, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop')]
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "frr_enabled": "frr_enabled"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp": {"lsp_name": "lsp_name", "frr_enabled": "frr_enabled"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "frr_enabled": "frr_enabled"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_hops_get(self, link=None, lsp=None, hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, lsp_instance_id
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type lsp_instance_id: long
    :param lsp_instance_id: **lsp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type hops: index, hop_type
    :param hops: Keyword argument tuple.

    :type index: long
    :param index: **hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_type: unicode
    :param hop_type: **hops** tuple argument.

        * enumeration restriction: ::

            ['igp-sync-hop-type-link',
            'igp-sync-hop-type-rro',
            'igp-sync-hop-type-cspf']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp.hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, lsp_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'hops', 'keyval': 'index, hop_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, hops=hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, hops=hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_hops_ip_address_get(self, link=None, lsp=None, hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, lsp_instance_id
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type lsp_instance_id: long
    :param lsp_instance_id: **lsp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type hops: index, hop_type
    :param hops: Keyword argument tuple.

    :type index: long
    :param index: **hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_type: unicode
    :param hop_type: **hops** tuple argument.

        * enumeration restriction: ::

            ['igp-sync-hop-type-link',
            'igp-sync-hop-type-rro',
            'igp-sync-hop-type-cspf']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp.hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, lsp_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'hops', 'keyval': 'index, hop_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, hops=hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, hops=hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_hops_nbr_ip_address_get(self, link=None, lsp=None, hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, lsp_instance_id
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type lsp_instance_id: long
    :param lsp_instance_id: **lsp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type hops: index, hop_type
    :param hops: Keyword argument tuple.

    :type index: long
    :param index: **hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_type: unicode
    :param hop_type: **hops** tuple argument.

        * enumeration restriction: ::

            ['igp-sync-hop-type-link',
            'igp-sync-hop-type-rro',
            'igp-sync-hop-type-cspf']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp.hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, lsp_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'hops', 'keyval': 'index, hop_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, hops=hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, hops=hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_link_get(self, link=None, lsp=None, link_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type link_: index
    :param link_: Keyword argument tuple.

    :type index: long
    :param index: **link_** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, link_=link_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, link_=link_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_link_count_get(self, link=None, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop')]
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "link_count": "link_count"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp": {"lsp_name": "lsp_name", "link_count": "link_count"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "link_count": "link_count"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_link_ip_address_get(self, link=None, lsp=None, link_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type link_: index
    :param link_: Keyword argument tuple.

    :type index: long
    :param index: **link_** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, link_=link_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, link_=link_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_link_nbr_ip_address_get(self, link=None, lsp=None, link_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type link_: index
    :param link_: Keyword argument tuple.

    :type index: long
    :param index: **link_** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, link_=link_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, link_=link_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_nbr_down_enabled_get(self, link=None, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop')]
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "nbr_down_enabled": "nbr_down_enabled"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp": {"lsp_name": "lsp_name", "nbr_down_enabled": "nbr_down_enabled"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "nbr_down_enabled": "nbr_down_enabled"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_nbr_down_inprogress_get(self, link=None, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop')]
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "nbr_down_inprogress": "nbr_down_inprogress"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp": {"lsp_name": "lsp_name", "nbr_down_inprogress": "nbr_down_inprogress"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "nbr_down_inprogress": "nbr_down_inprogress"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_path_name_get(self, link=None, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, lsp_instance_id
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type lsp_instance_id: long
    :param lsp_instance_id: **lsp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', u'hops')]
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, lsp_instance_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, hop_type, ip_address, nbr_ip_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_rro_enabled_get(self, link=None, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop')]
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "rro_enabled": "rro_enabled"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp": {"lsp_name": "lsp_name", "rro_enabled": "rro_enabled"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "rro_enabled": "rro_enabled"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_rro_hop_get(self, link=None, lsp=None, rro_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rro_hop: index
    :param rro_hop: Keyword argument tuple.

    :type index: long
    :param index: **rro_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp.rro_hop', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp.rro_hop', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rro_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, rro_hop=rro_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, rro_hop=rro_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_rro_hop_count_get(self, link=None, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'rro_hop')]
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "rro_hop_count": "rro_hop_count"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link.lsp": {"lsp_name": "lsp_name", "rro_hop_count": "rro_hop_count"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "rro_hop_count": "rro_hop_count"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_rro_hop_ip_address_get(self, link=None, lsp=None, rro_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rro_hop: index
    :param rro_hop: Keyword argument tuple.

    :type index: long
    :param index: **rro_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp.rro_hop', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp.rro_hop', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rro_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, rro_hop=rro_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, rro_hop=rro_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_lsp_rro_hop_nbr_ip_address_get(self, link=None, lsp=None, rro_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rro_hop: index
    :param rro_hop: Keyword argument tuple.

    :type index: long
    :param index: **rro_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link.lsp.rro_hop', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link.lsp.rro_hop', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rro_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link, lsp=lsp, rro_hop=rro_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link, lsp=lsp, rro_hop=rro_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_link_remote_ip_get(self, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type link: ip_address, nbr_ip_address
    :param link: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type nbr_ip_address: unicode
    :param nbr_ip_address: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.link', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.link', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.link', u'lsp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'ip_address, nbr_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'rro_hop')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "cspf_hop_count": "cspf_hop_count", "lsp_name": "lsp_name", "nbr_down_enabled": "nbr_down_enabled", "rro_enabled": "rro_enabled", "cspf_enabled": "cspf_enabled", "nbr_down_inprogress": "nbr_down_inprogress", "rro_hop_count": "rro_hop_count", "frr_enabled": "frr_enabled", "link_count": "link_count"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "cspf_hop_count": "cspf_hop_count", "lsp_name": "lsp_name", "nbr_down_enabled": "nbr_down_enabled", "rro_enabled": "rro_enabled", "cspf_enabled": "cspf_enabled", "nbr_down_inprogress": "nbr_down_inprogress", "rro_hop_count": "rro_hop_count", "frr_enabled": "frr_enabled", "link_count": "link_count"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_cspf_enabled_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'rro_hop')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "cspf_enabled": "cspf_enabled"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "cspf_enabled": "cspf_enabled"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp": {"lsp_name": "lsp_name", "cspf_enabled": "cspf_enabled"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_cspf_hop_get(self, lsp=None, cspf_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type cspf_hop: index
    :param cspf_hop: Keyword argument tuple.

    :type index: long
    :param index: **cspf_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp.cspf_hop', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp.cspf_hop', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, cspf_hop=cspf_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, cspf_hop=cspf_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_cspf_hop_count_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'rro_hop')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "cspf_hop_count": "cspf_hop_count"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "cspf_hop_count": "cspf_hop_count"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp": {"lsp_name": "lsp_name", "cspf_hop_count": "cspf_hop_count"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_cspf_hop_ip_address_get(self, lsp=None, cspf_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type cspf_hop: index
    :param cspf_hop: Keyword argument tuple.

    :type index: long
    :param index: **cspf_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp.cspf_hop', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp.cspf_hop', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, cspf_hop=cspf_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, cspf_hop=cspf_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_cspf_hop_nbr_ip_address_get(self, lsp=None, cspf_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type cspf_hop: index
    :param cspf_hop: Keyword argument tuple.

    :type index: long
    :param index: **cspf_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp.cspf_hop', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp.cspf_hop', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, cspf_hop=cspf_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, cspf_hop=cspf_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_frr_enabled_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'rro_hop')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "frr_enabled": "frr_enabled"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "frr_enabled": "frr_enabled"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp": {"lsp_name": "lsp_name", "frr_enabled": "frr_enabled"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_hops_get(self, lsp=None, hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, lsp_instance_id
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type lsp_instance_id: long
    :param lsp_instance_id: **lsp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type hops: index, hop_type
    :param hops: Keyword argument tuple.

    :type index: long
    :param index: **hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_type: unicode
    :param hop_type: **hops** tuple argument.

        * enumeration restriction: ::

            ['igp-sync-hop-type-link',
            'igp-sync-hop-type-rro',
            'igp-sync-hop-type-cspf']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp.hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, lsp_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'hops', 'keyval': 'index, hop_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, hops=hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, hops=hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_hops_ip_address_get(self, lsp=None, hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, lsp_instance_id
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type lsp_instance_id: long
    :param lsp_instance_id: **lsp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type hops: index, hop_type
    :param hops: Keyword argument tuple.

    :type index: long
    :param index: **hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_type: unicode
    :param hop_type: **hops** tuple argument.

        * enumeration restriction: ::

            ['igp-sync-hop-type-link',
            'igp-sync-hop-type-rro',
            'igp-sync-hop-type-cspf']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp.hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, lsp_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'hops', 'keyval': 'index, hop_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, hops=hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, hops=hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_hops_nbr_ip_address_get(self, lsp=None, hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, lsp_instance_id
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type lsp_instance_id: long
    :param lsp_instance_id: **lsp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type hops: index, hop_type
    :param hops: Keyword argument tuple.

    :type index: long
    :param index: **hops** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type hop_type: unicode
    :param hop_type: **hops** tuple argument.

        * enumeration restriction: ::

            ['igp-sync-hop-type-link',
            'igp-sync-hop-type-rro',
            'igp-sync-hop-type-cspf']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp.hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, lsp_instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'hops', 'keyval': 'index, hop_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, hops=hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, hops=hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_link_get(self, lsp=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type link: index
    :param link: Keyword argument tuple.

    :type index: long
    :param index: **link** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_link_count_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'rro_hop')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "link_count": "link_count"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "link_count": "link_count"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp": {"lsp_name": "lsp_name", "link_count": "link_count"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_link_ip_address_get(self, lsp=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type link: index
    :param link: Keyword argument tuple.

    :type index: long
    :param index: **link** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_link_nbr_ip_address_get(self, lsp=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type link: index
    :param link: Keyword argument tuple.

    :type index: long
    :param index: **link** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_nbr_down_enabled_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'rro_hop')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "nbr_down_enabled": "nbr_down_enabled"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "nbr_down_enabled": "nbr_down_enabled"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp": {"lsp_name": "lsp_name", "nbr_down_enabled": "nbr_down_enabled"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_nbr_down_inprogress_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'rro_hop')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "nbr_down_inprogress": "nbr_down_inprogress"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "nbr_down_inprogress": "nbr_down_inprogress"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp": {"lsp_name": "lsp_name", "nbr_down_inprogress": "nbr_down_inprogress"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_path_name_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, lsp_instance_id
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type lsp_instance_id: long
    :param lsp_instance_id: **lsp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', u'hops')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, lsp_instance_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, hop_type, ip_address, nbr_ip_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_rro_enabled_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'rro_hop')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "rro_enabled": "rro_enabled"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "rro_enabled": "rro_enabled"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp": {"lsp_name": "lsp_name", "rro_enabled": "rro_enabled"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_rro_hop_get(self, lsp=None, rro_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rro_hop: index
    :param rro_hop: Keyword argument tuple.

    :type index: long
    :param index: **rro_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp.rro_hop', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp.rro_hop', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rro_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, rro_hop=rro_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, rro_hop=rro_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_rro_hop_count_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'rro_hop'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp', u'hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'cspf_hop'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'rro_hop')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name, path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, hop_type, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}, {'leafval': 'index, ip_address, nbr_ip_address'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "rro_hop_count": "rro_hop_count"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp": {"path_name": "path_name", "lsp_name": "lsp_name", "rro_hop_count": "rro_hop_count"}, "pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync.lsp": {"lsp_name": "lsp_name", "rro_hop_count": "rro_hop_count"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_rro_hop_ip_address_get(self, lsp=None, rro_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rro_hop: index
    :param rro_hop: Keyword argument tuple.

    :type index: long
    :param index: **rro_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp.rro_hop', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp.rro_hop', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rro_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, rro_hop=rro_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, rro_hop=rro_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_lsp_rro_hop_nbr_ip_address_get(self, lsp=None, rro_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name, path_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument.

    :type path_name: unicode
    :param path_name: **lsp** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rro_hop: index
    :param rro_hop: Keyword argument tuple.

    :type index: long
    :param index: **rro_hop** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync.lsp.rro_hop', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync.lsp.rro_hop', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name, path_name', 'extra_keyval': ''}, {'keyval': 'lsp_name, path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rro_hop', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, rro_hop=rro_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, rro_hop=rro_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_igp_sync_ospf_nbr_down_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'lsp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_active_backup_outsegs_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"active_backup_outsegs": "active_backup_outsegs", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"active_backup_outsegs": "active_backup_outsegs", "interface_name": "interface_name"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"active_backup_outsegs": "active_backup_outsegs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_active_outsegs_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "active_outsegs": "active_outsegs"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "active_outsegs": "active_outsegs"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"active_outsegs": "active_outsegs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_admin_status_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"admin_status": "admin_status", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"admin_status": "admin_status", "interface_name": "interface_name"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"admin_status": "admin_status"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_bandwith_resv_outsegs_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"bandwith_resv_outsegs": "bandwith_resv_outsegs", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"bandwith_resv_outsegs": "bandwith_resv_outsegs", "interface_name": "interface_name"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"bandwith_resv_outsegs": "bandwith_resv_outsegs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_bundle_messages_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"bundle_messages": "bundle_messages", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"bundle_messages": "bundle_messages", "interface_name": "interface_name"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"bundle_messages": "bundle_messages"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_bypass_interface_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"bypass_interface": "bypass_interface", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"bypass_interface": "bypass_interface", "interface_name": "interface_name"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"bypass_interface": "bypass_interface"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_bypass_tunnel_interface_name_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"bypass_tunnel_interface_name": "bypass_tunnel_interface_name", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"bypass_tunnel_interface_name": "bypass_tunnel_interface_name", "interface_name": "interface_name"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"bypass_tunnel_interface_name": "bypass_tunnel_interface_name", "interface_name": "bypass_tunnel_interface_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_duplicate_preempts_dropped_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "duplicate_preempts_dropped": "duplicate_preempts_dropped"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "duplicate_preempts_dropped": "duplicate_preempts_dropped"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"duplicate_preempts_dropped": "duplicate_preempts_dropped"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_nackobject_errors_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_nackobject_errors_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_pkt_with_msgid_drop_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_pkt_with_msgid_drop_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_pkt_with_sref_drop_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_pkt_with_sref_drop_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_recv_md5_auth_errors_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_error_counters_recv_md5_auth_errors_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_hello_interval_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "hello_interval": "hello_interval"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "hello_interval": "hello_interval"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"hello_interval": "hello_interval"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_hello_status_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"hello_status": "hello_status", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"hello_status": "hello_status", "interface_name": "interface_name"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"hello_status": "hello_status"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_hello_tolerance_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "hello_tolerance": "hello_tolerance"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "hello_tolerance": "hello_tolerance"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"hello_tolerance": "hello_tolerance"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_inactive_backup_outsegs_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "inactive_backup_outsegs": "inactive_backup_outsegs"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "inactive_backup_outsegs": "inactive_backup_outsegs"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"inactive_backup_outsegs": "inactive_backup_outsegs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_inactive_outsegs_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"inactive_outsegs": "inactive_outsegs", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"inactive_outsegs": "inactive_outsegs", "interface_name": "interface_name"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"inactive_outsegs": "inactive_outsegs"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_interface_flooding_down_threshold_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"interface_flooding_down_threshold": "interface_flooding_down_threshold", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"interface_flooding_down_threshold": "interface_flooding_down_threshold", "interface_name": "interface_name"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"interface_flooding_down_threshold": "interface_flooding_down_threshold"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_interface_flooding_up_threshold_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "interface_flooding_up_threshold": "interface_flooding_up_threshold"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "interface_flooding_up_threshold": "interface_flooding_up_threshold"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"interface_flooding_up_threshold": "interface_flooding_up_threshold"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_interface_index_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_interface_name_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_index
    :param interfaces: Keyword argument tuple.

    :type interface_index: long
    :param interface_index: **interfaces** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_interface_preempts_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"interface_preempts": "interface_preempts", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"interface_preempts": "interface_preempts", "interface_name": "interface_name"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"interface_preempts": "interface_preempts"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_interface_resv_soft_preempts_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "interface_resv_soft_preempts": "interface_resv_soft_preempts"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "interface_resv_soft_preempts": "interface_resv_soft_preempts"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"interface_resv_soft_preempts": "interface_resv_soft_preempts"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_interface_tunnel_name_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "interface_tunnel_name": "interface_tunnel_name"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "interface_tunnel_name": "interface_tunnel_name"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"interface_tunnel_name": "interface_tunnel_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_interface_type_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"interface_type": "interface_type", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"interface_type": "interface_type", "interface_name": "interface_name"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"interface_type": "interface_type"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_is_md5_auth_enabled_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "is_md5_auth_enabled": "is_md5_auth_enabled"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "is_md5_auth_enabled": "is_md5_auth_enabled"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"is_md5_auth_enabled": "is_md5_auth_enabled"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_is_tunnel_interface_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"is_tunnel_interface": "is_tunnel_interface", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"is_tunnel_interface": "is_tunnel_interface", "interface_name": "interface_name"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"is_tunnel_interface": "is_tunnel_interface"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_oper_status_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"oper_status": "oper_status", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"oper_status": "oper_status", "interface_name": "interface_name"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"oper_status": "oper_status"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_ack_rx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_ack_rx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_ack_tx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_ack_tx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_bundle_rx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_bundle_rx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_bundle_tx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_bundle_tx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_hello_rx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_hello_rx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_hello_tx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_hello_tx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_path_rx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_path_rx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_path_tx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_path_tx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_patherr_rx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_patherr_rx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_patherr_tx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_patherr_tx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_pathtear_rx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_pathtear_rx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_pathtear_tx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_pathtear_tx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resv_rx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resv_rx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resv_tx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resv_tx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resvconf_rx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resvconf_rx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resvconf_tx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resvconf_tx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resverr_rx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resverr_rx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resverr_tx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resverr_tx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resvtear_rx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resvtear_rx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resvtear_tx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_resvtear_tx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_sumrefresh_rx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_sumrefresh_rx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_sumrefresh_tx_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_packet_counters_sumrefresh_tx_since_last_clear_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_name', 'extra_keyval': ''}, {'keyval': 'interface_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_reliable_messages_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"reliable_messages": "reliable_messages", "interface_name": "interface_name"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"reliable_messages": "reliable_messages", "interface_name": "interface_name"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"reliable_messages": "reliable_messages"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_interfaces_summary_refresh_get(self, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces: interface_name
    :param interfaces: Keyword argument tuple.

    :type interface_name: unicode
    :param interface_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces', u'error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces', u'error_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'recv_md5_auth_errors, pkt_with_msgid_drop, pkt_with_sref_drop, nackobject_errors, recv_md5_auth_errors_since_last_clear, pkt_with_msgid_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, nackobject_errors_since_last_clear'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "summary_refresh": "summary_refresh"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.interfaces": {"interface_name": "interface_name", "summary_refresh": "summary_refresh"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.interfaces": {"summary_refresh": "summary_refresh"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_neighbors_get(self, neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_neighbors_active_lsps_get(self, neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_neighbors_last_hello_rx_get(self, neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_neighbors_msg_id_support_get(self, neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_neighbors_neighbor_interface_get(self, neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_neighbors_neighbor_last_status_change_get(self, neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_neighbors_neighbor_local_instance_get(self, neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_neighbors_neighbor_remote_instance_get(self, neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_neighbors_neighbor_status_get(self, neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_neighbors_next_hello_req_tx_get(self, neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_neighbors_refresh_reduction_support_get(self, neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_neighbors_rsvp_hello_interval_get(self, neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_neighbors_rsvp_hello_rx_get(self, neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_neighbors_rsvp_hello_tolerance_get(self, neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_neighbors_rsvp_hello_tx_get(self, neighbors=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbors: neighbor_ip_addr
    :param neighbors: Keyword argument tuple.

    :type neighbor_ip_addr: unicode
    :param neighbor_ip_addr: **neighbors** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.neighbors', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.neighbors', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbors', 'keyval': 'neighbor_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbors=neighbors)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbors=neighbors)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_protocol_status_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_refresh_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_refresh_multiple_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_get(self, sessions=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'psbs'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'psbs'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'psbs')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'sessions', 'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_index, session_name, session_type, path_operational_status, session_in_label, session_out_label, session_out_interface, lsp_id, flap_lock, path_refresh, path_refresh_ttd, resv_refresh, resv_refresh_ttd, tspec_peak, tspec_rate, tspec_size, tspec_minimum, tspec_m, psb_setup_priority, psb_hold_priority, session_attribute_all_flags, sa_flag_label_recording, sa_flag_soft_preemption_desired, sa_flag_se_style, sa_flag_local_protect, sa_flag_bandwidth_protect, sa_flag_session_protection_type, session_soft_preemption_wait_timer, session_preemption_wait_timer, frr_detour, frr_facility, frr_unknown_backup_mode_desired, frr_unknown_flags, frr_psb_setup_priority, frr_psb_hold_priority, frr_bandwidth, frr_hoplimit, frr_facility_method, frr_nh_node_protection_available, frr_nh_node_protection_in_use, frr_nh_link_protection_available, frr_nh_link_protection_in_use, frr_bandwidth_protection_available, frr_lsp_bringup_abandoned, frr_updown_transitions, frr_retries, frr_session_protection_available, frr_next_retry, frr_cost, frr_cspf_group_computation_mode, frr_cspf_group_computation_mode_use_bypass_liberal, is_downstream_backup_psb, is_backup_psb, is_upstream_psb, is_ps_frr_detour_sent, is_ps_frr_backup_sent, is_ps_frr_detour_received, is_ps_frr_backup_received, path_received_from_ip, path_received_interface, path_received_auth_on, path_received_message_id, path_downstream_only, path_sent_to_ip, path_sent_interface, path_sent_auth_on, path_sent_message_id, resv_received_from_ip, resv_received_interface, resv_received_auth_on, resv_received_message_id, session_riding_bypass_name, session_style'}, {'leafval': 'path_index, session_name, session_type, path_operational_status, session_in_label, session_out_label, session_out_interface, lsp_id, flap_lock, path_refresh, path_refresh_ttd, resv_refresh, resv_refresh_ttd, tspec_peak, tspec_rate, tspec_size, tspec_minimum, tspec_m, psb_setup_priority, psb_hold_priority, session_attribute_all_flags, sa_flag_label_recording, sa_flag_soft_preemption_desired, sa_flag_se_style, sa_flag_local_protect, sa_flag_bandwidth_protect, sa_flag_session_protection_type, session_soft_preemption_wait_timer, session_preemption_wait_timer, frr_detour, frr_facility, frr_unknown_backup_mode_desired, frr_unknown_flags, frr_psb_setup_priority, frr_psb_hold_priority, frr_bandwidth, frr_hoplimit, frr_method, frr_nh_node_protection_available, frr_nh_node_protection_in_use, frr_nh_link_protection_available, frr_nh_link_protection_in_use, frr_bandwidth_protection_available, frr_lsp_bringup_abandoned, frr_updown_transitions, frr_retries, frr_session_protection_available, frr_next_retry, frr_cost, frr_cspf_group_computation_mode, frr_cspf_group_computation_mode_use_bypass_liberal, is_downstream_backup_psb, is_backup_psb, is_upstream_psb, is_ps_frr_detour_sent, is_ps_frr_backup_sent, is_ps_frr_detour_received, is_ps_frr_backup_received, path_received_from_ip, path_received_interface, path_received_auth_on, path_received_message_id, path_downstream_only, path_sent_to_ip, path_sent_interface, path_sent_auth_on, path_sent_message_id, resv_received_from_ip, resv_received_interface, resv_received_auth_on, resv_received_message_id, session_riding_bypass_name, session_style'}, {'leafval': 'path_index, session_name, session_type, path_operational_status, session_in_label, session_out_label, session_out_interface, lsp_id, flap_lock, path_refresh, path_refresh_ttd, resv_refresh, resv_refresh_ttd, tspec_peak, tspec_rate, tspec_size, tspec_minimum, tspec_m, psb_setup_priority, psb_hold_priority, session_attribute_all_flags, sa_flag_label_recording, sa_flag_soft_preemption_desired, sa_flag_se_style, sa_flag_local_protect, sa_flag_bandwidth_protect, sa_flag_session_protection_type, session_soft_preemption_wait_timer, session_preemption_wait_timer, frr_detour, frr_facility, frr_unknown_backup_mode_desired, frr_unknown_flags, frr_psb_setup_priority, frr_psb_hold_priority, frr_bandwidth, frr_hoplimit, frr_method, frr_nh_node_protection_available, frr_nh_node_protection_in_use, frr_nh_link_protection_available, frr_nh_link_protection_in_use, frr_bandwidth_protection_available, frr_lsp_bringup_abandoned, frr_updown_transitions, frr_retries, frr_session_protection_available, frr_next_retry, frr_cost, frr_cspf_group_computation_mode, frr_cspf_group_computation_mode_use_bypass_liberal, is_downstream_backup_psb, is_backup_psb, is_upstream_psb, is_ps_frr_detour_sent, is_ps_frr_backup_sent, is_ps_frr_detour_received, is_ps_frr_backup_received, path_received_from_ip, path_received_interface, path_received_auth_on, path_received_message_id, path_downstream_only, path_sent_to_ip, path_sent_interface, path_sent_auth_on, path_sent_message_id, resv_received_from_ip, resv_received_interface, resv_received_auth_on, resv_received_message_id, session_riding_bypass_name, session_style'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs": {"is_ps_frr_backup_sent": "is_ps_frr_backup_sent", "psb_setup_priority": "psb_setup_priority", "frr_facility": "frr_facility", "frr_method": "frr_method", "frr_bandwidth": "frr_bandwidth", "is_backup_psb": "is_backup_psb", "frr_retries": "frr_retries", "path_sent_interface": "path_sent_interface", "frr_cost": "frr_cost", "session_riding_bypass_name": "session_riding_bypass_name", "path_received_auth_on": "path_received_auth_on", "resv_received_auth_on": "resv_received_auth_on", "sa_flag_label_recording": "sa_flag_label_recording", "path_operational_status": "path_operational_status", "session_out_label": "session_out_label", "is_ps_frr_detour_received": "is_ps_frr_detour_received", "path_sent_message_id": "path_sent_message_id", "is_ps_frr_backup_received": "is_ps_frr_backup_received", "sa_flag_local_protect": "sa_flag_local_protect", "path_received_message_id": "path_received_message_id", "frr_unknown_flags": "frr_unknown_flags", "psb_hold_priority": "psb_hold_priority", "session_out_interface": "session_out_interface", "frr_nh_link_protection_available": "frr_nh_link_protection_available", "is_ps_frr_detour_sent": "is_ps_frr_detour_sent", "sa_flag_se_style": "sa_flag_se_style", "path_refresh": "path_refresh", "frr_nh_node_protection_available": "frr_nh_node_protection_available", "session_soft_preemption_wait_timer": "session_soft_preemption_wait_timer", "sa_flag_soft_preemption_desired": "sa_flag_soft_preemption_desired", "frr_next_retry": "frr_next_retry", "path_received_from_ip": "path_received_from_ip", "path_downstream_only": "path_downstream_only", "resv_received_from_ip": "resv_received_from_ip", "frr_bandwidth_protection_available": "frr_bandwidth_protection_available", "lsp_id": "lsp_id", "resv_received_message_id": "resv_received_message_id", "tspec_peak": "tspec_peak", "path_received_interface": "path_received_interface", "resv_received_interface": "resv_received_interface", "flap_lock": "flap_lock", "is_upstream_psb": "is_upstream_psb", "sa_flag_bandwidth_protect": "sa_flag_bandwidth_protect", "session_type": "session_type", "tspec_m": "tspec_m", "frr_psb_setup_priority": "frr_psb_setup_priority", "frr_unknown_backup_mode_desired": "frr_unknown_backup_mode_desired", "frr_psb_hold_priority": "frr_psb_hold_priority", "session_style": "session_style", "frr_detour": "frr_detour", "is_downstream_backup_psb": "is_downstream_backup_psb", "path_sent_to_ip": "path_sent_to_ip", "path_refresh_ttd": "path_refresh_ttd", "frr_hoplimit": "frr_hoplimit", "session_name": "session_name", "resv_refresh": "resv_refresh", "frr_updown_transitions": "frr_updown_transitions", "resv_refresh_ttd": "resv_refresh_ttd", "path_index": "path_index", "frr_cspf_group_computation_mode_use_bypass_liberal": "frr_cspf_group_computation_mode_use_bypass_liberal", "frr_cspf_group_computation_mode": "frr_cspf_group_computation_mode", "path_sent_auth_on": "path_sent_auth_on", "session_in_label": "session_in_label", "sa_flag_session_protection_type": "sa_flag_session_protection_type", "tspec_size": "tspec_size", "frr_nh_node_protection_in_use": "frr_nh_node_protection_in_use", "frr_lsp_bringup_abandoned": "frr_lsp_bringup_abandoned", "tspec_minimum": "tspec_minimum", "session_attribute_all_flags": "session_attribute_all_flags", "frr_session_protection_available": "frr_session_protection_available", "tspec_rate": "tspec_rate", "session_preemption_wait_timer": "session_preemption_wait_timer", "frr_nh_link_protection_in_use": "frr_nh_link_protection_in_use"}, "pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs": {"is_ps_frr_backup_sent": "is_ps_frr_backup_sent", "psb_setup_priority": "psb_setup_priority", "frr_facility": "frr_facility", "frr_method": "frr_method", "frr_bandwidth": "frr_bandwidth", "is_backup_psb": "is_backup_psb", "frr_retries": "frr_retries", "path_sent_interface": "path_sent_interface", "frr_cost": "frr_cost", "session_riding_bypass_name": "session_riding_bypass_name", "path_received_auth_on": "path_received_auth_on", "resv_received_auth_on": "resv_received_auth_on", "sa_flag_label_recording": "sa_flag_label_recording", "path_operational_status": "path_operational_status", "session_out_label": "session_out_label", "is_ps_frr_detour_received": "is_ps_frr_detour_received", "path_sent_message_id": "path_sent_message_id", "is_ps_frr_backup_received": "is_ps_frr_backup_received", "sa_flag_local_protect": "sa_flag_local_protect", "path_received_message_id": "path_received_message_id", "frr_unknown_flags": "frr_unknown_flags", "psb_hold_priority": "psb_hold_priority", "session_out_interface": "session_out_interface", "frr_nh_link_protection_available": "frr_nh_link_protection_available", "is_ps_frr_detour_sent": "is_ps_frr_detour_sent", "sa_flag_se_style": "sa_flag_se_style", "path_refresh": "path_refresh", "frr_nh_node_protection_available": "frr_nh_node_protection_available", "session_soft_preemption_wait_timer": "session_soft_preemption_wait_timer", "sa_flag_soft_preemption_desired": "sa_flag_soft_preemption_desired", "frr_next_retry": "frr_next_retry", "path_received_from_ip": "path_received_from_ip", "path_downstream_only": "path_downstream_only", "resv_received_from_ip": "resv_received_from_ip", "frr_bandwidth_protection_available": "frr_bandwidth_protection_available", "lsp_id": "lsp_id", "resv_received_message_id": "resv_received_message_id", "tspec_peak": "tspec_peak", "path_received_interface": "path_received_interface", "resv_received_interface": "resv_received_interface", "flap_lock": "flap_lock", "is_upstream_psb": "is_upstream_psb", "sa_flag_bandwidth_protect": "sa_flag_bandwidth_protect", "session_type": "session_type", "tspec_m": "tspec_m", "frr_psb_setup_priority": "frr_psb_setup_priority", "frr_unknown_backup_mode_desired": "frr_unknown_backup_mode_desired", "frr_psb_hold_priority": "frr_psb_hold_priority", "session_style": "session_style", "frr_detour": "frr_detour", "is_downstream_backup_psb": "is_downstream_backup_psb", "path_sent_to_ip": "path_sent_to_ip", "path_refresh_ttd": "path_refresh_ttd", "frr_hoplimit": "frr_hoplimit", "session_name": "session_name", "resv_refresh": "resv_refresh", "frr_updown_transitions": "frr_updown_transitions", "resv_refresh_ttd": "resv_refresh_ttd", "path_index": "path_index", "frr_cspf_group_computation_mode_use_bypass_liberal": "frr_cspf_group_computation_mode_use_bypass_liberal", "frr_cspf_group_computation_mode": "frr_cspf_group_computation_mode", "path_sent_auth_on": "path_sent_auth_on", "session_in_label": "session_in_label", "sa_flag_session_protection_type": "sa_flag_session_protection_type", "tspec_size": "tspec_size", "frr_nh_node_protection_in_use": "frr_nh_node_protection_in_use", "frr_lsp_bringup_abandoned": "frr_lsp_bringup_abandoned", "tspec_minimum": "tspec_minimum", "session_attribute_all_flags": "session_attribute_all_flags", "frr_session_protection_available": "frr_session_protection_available", "tspec_rate": "tspec_rate", "session_preemption_wait_timer": "session_preemption_wait_timer", "frr_nh_link_protection_in_use": "frr_nh_link_protection_in_use"}, "pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs": {"is_ps_frr_backup_sent": "is_ps_frr_backup_sent", "psb_setup_priority": "psb_setup_priority", "frr_facility": "frr_facility", "frr_bandwidth": "frr_bandwidth", "is_backup_psb": "is_backup_psb", "frr_retries": "frr_retries", "path_sent_interface": "path_sent_interface", "frr_cost": "frr_cost", "session_riding_bypass_name": "session_riding_bypass_name", "path_received_auth_on": "path_received_auth_on", "resv_received_auth_on": "resv_received_auth_on", "sa_flag_label_recording": "sa_flag_label_recording", "path_operational_status": "path_operational_status", "session_out_label": "session_out_label", "is_ps_frr_detour_received": "is_ps_frr_detour_received", "path_sent_message_id": "path_sent_message_id", "is_ps_frr_backup_received": "is_ps_frr_backup_received", "sa_flag_local_protect": "sa_flag_local_protect", "path_received_message_id": "path_received_message_id", "frr_unknown_flags": "frr_unknown_flags", "psb_hold_priority": "psb_hold_priority", "session_out_interface": "session_out_interface", "frr_nh_link_protection_available": "frr_nh_link_protection_available", "is_ps_frr_detour_sent": "is_ps_frr_detour_sent", "sa_flag_se_style": "sa_flag_se_style", "path_refresh": "path_refresh", "frr_nh_node_protection_available": "frr_nh_node_protection_available", "session_soft_preemption_wait_timer": "session_soft_preemption_wait_timer", "sa_flag_soft_preemption_desired": "sa_flag_soft_preemption_desired", "frr_next_retry": "frr_next_retry", "path_received_from_ip": "path_received_from_ip", "path_downstream_only": "path_downstream_only", "resv_received_from_ip": "resv_received_from_ip", "frr_bandwidth_protection_available": "frr_bandwidth_protection_available", "lsp_id": "lsp_id", "resv_received_message_id": "resv_received_message_id", "tspec_peak": "tspec_peak", "path_received_interface": "path_received_interface", "resv_received_interface": "resv_received_interface", "flap_lock": "flap_lock", "is_upstream_psb": "is_upstream_psb", "sa_flag_bandwidth_protect": "sa_flag_bandwidth_protect", "session_type": "session_type", "tspec_m": "tspec_m", "frr_psb_setup_priority": "frr_psb_setup_priority", "frr_unknown_backup_mode_desired": "frr_unknown_backup_mode_desired", "frr_psb_hold_priority": "frr_psb_hold_priority", "session_style": "session_style", "frr_detour": "frr_detour", "is_downstream_backup_psb": "is_downstream_backup_psb", "path_sent_to_ip": "path_sent_to_ip", "path_refresh_ttd": "path_refresh_ttd", "frr_hoplimit": "frr_hoplimit", "session_name": "session_name", "resv_refresh": "resv_refresh", "frr_updown_transitions": "frr_updown_transitions", "resv_refresh_ttd": "resv_refresh_ttd", "path_index": "path_index", "frr_cspf_group_computation_mode_use_bypass_liberal": "frr_cspf_group_computation_mode_use_bypass_liberal", "frr_cspf_group_computation_mode": "frr_cspf_group_computation_mode", "path_sent_auth_on": "path_sent_auth_on", "session_in_label": "session_in_label", "sa_flag_session_protection_type": "sa_flag_session_protection_type", "tspec_size": "tspec_size", "frr_nh_node_protection_in_use": "frr_nh_node_protection_in_use", "frr_lsp_bringup_abandoned": "frr_lsp_bringup_abandoned", "tspec_minimum": "tspec_minimum", "session_attribute_all_flags": "session_attribute_all_flags", "frr_session_protection_available": "frr_session_protection_available", "tspec_rate": "tspec_rate", "session_preemption_wait_timer": "session_preemption_wait_timer", "frr_nh_link_protection_in_use": "frr_nh_link_protection_in_use"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_flap_lock_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_bandwidth_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_bandwidth_protection_available_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_cost_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_cspf_group_computation_mode_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_cspf_group_computation_mode_use_bypass_liberal_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_detour_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_facility_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_facility_method_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_hoplimit_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_lsp_bringup_abandoned_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_method_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_next_retry_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_nh_link_protection_available_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_nh_link_protection_in_use_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_nh_node_protection_available_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_nh_node_protection_in_use_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_psb_hold_priority_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_psb_setup_priority_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_retries_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_session_protection_available_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_unknown_backup_mode_desired_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_unknown_flags_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_frr_updown_transitions_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_is_backup_psb_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_is_downstream_backup_psb_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_is_ps_frr_backup_received_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_is_ps_frr_backup_sent_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_is_ps_frr_detour_received_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_is_ps_frr_detour_sent_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_is_upstream_psb_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_lsp_id_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_downstream_only_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_operational_status_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_received_auth_on_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_received_from_ip_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_received_interface_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_received_message_id_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_refresh_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_refresh_ttd_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_sent_auth_on_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_sent_interface_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_sent_message_id_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_path_sent_to_ip_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_psb_hold_priority_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_psb_setup_priority_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_resv_received_auth_on_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_resv_received_from_ip_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_resv_received_interface_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_resv_received_message_id_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_resv_refresh_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_resv_refresh_ttd_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_sa_flag_bandwidth_protect_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_sa_flag_label_recording_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_sa_flag_local_protect_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_sa_flag_se_style_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_sa_flag_session_protection_type_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_sa_flag_soft_preemption_desired_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_attribute_all_flags_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_ero_hops_get(self, sessions=None, psbs=None, session_ero_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type session_ero_hops: ip_addr
    :param session_ero_hops: Keyword argument tuple.

    :type ip_addr: unicode
    :param ip_addr: **session_ero_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'psbs'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'psbs'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'psbs')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs.session_ero_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs.session_ero_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs.session_ero_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'session_ero_hops', 'keyval': 'ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs, session_ero_hops=session_ero_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs, session_ero_hops=session_ero_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_ero_hops_ero_flag_is_strict_hop_get(self, sessions=None, psbs=None, session_ero_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type session_ero_hops: ip_addr
    :param session_ero_hops: Keyword argument tuple.

    :type ip_addr: unicode
    :param ip_addr: **session_ero_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'psbs'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'psbs'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'psbs')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs.session_ero_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs.session_ero_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs.session_ero_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'session_ero_hops', 'keyval': 'ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs, session_ero_hops=session_ero_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs, session_ero_hops=session_ero_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_in_label_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_name_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_out_interface_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_out_label_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_preemption_wait_timer_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_riding_bypass_name_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_rro_hops_get(self, sessions=None, psbs=None, session_rro_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type session_rro_hops: ip_addr
    :param session_rro_hops: Keyword argument tuple.

    :type ip_addr: unicode
    :param ip_addr: **session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'psbs'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'psbs'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'psbs')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'session_rro_hops', 'keyval': 'ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_rro_hops_rro_flag_is_local_protect_available_get(self, sessions=None, psbs=None, session_rro_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type session_rro_hops: ip_addr
    :param session_rro_hops: Keyword argument tuple.

    :type ip_addr: unicode
    :param ip_addr: **session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'psbs'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'psbs'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'psbs')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'session_rro_hops', 'keyval': 'ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_rro_hops_rro_flag_is_local_protect_in_use_get(self, sessions=None, psbs=None, session_rro_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type session_rro_hops: ip_addr
    :param session_rro_hops: Keyword argument tuple.

    :type ip_addr: unicode
    :param ip_addr: **session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'psbs'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'psbs'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'psbs')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'session_rro_hops', 'keyval': 'ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_rro_hops_rro_flag_rro_bandwidth_protect_get(self, sessions=None, psbs=None, session_rro_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type session_rro_hops: ip_addr
    :param session_rro_hops: Keyword argument tuple.

    :type ip_addr: unicode
    :param ip_addr: **session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'psbs'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'psbs'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'psbs')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'session_rro_hops', 'keyval': 'ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_rro_hops_rro_flag_rro_is_router_id_get(self, sessions=None, psbs=None, session_rro_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type session_rro_hops: ip_addr
    :param session_rro_hops: Keyword argument tuple.

    :type ip_addr: unicode
    :param ip_addr: **session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'psbs'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'psbs'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'psbs')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'session_rro_hops', 'keyval': 'ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_rro_hops_rro_flag_rro_node_protect_get(self, sessions=None, psbs=None, session_rro_hops=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type session_rro_hops: ip_addr
    :param session_rro_hops: Keyword argument tuple.

    :type ip_addr: unicode
    :param ip_addr: **session_rro_hops** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'psbs'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'psbs'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'psbs')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs.session_rro_hops', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'path_index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'session_rro_hops', 'keyval': 'ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs, session_rro_hops=session_rro_hops)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_soft_preemption_wait_timer_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_style_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_session_type_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_tspec_m_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_tspec_minimum_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_tspec_peak_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_tspec_rate_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_psbs_tspec_size_get(self, sessions=None, psbs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    **Instance Keyword Argument Tuple**:

    :type psbs: path_index
    :param psbs: Keyword argument tuple.

    :type path_index: long
    :param path_index: **psbs** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'sessions')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_rro_hops'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_ero_hops'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions.psbs', u'session_rro_hops')]
    compositions_keyval_list = [{'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}, {'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'psbs', 'keyval': 'path_index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, ero_flag_is_strict_hop'}, {'leafval': 'ip_addr, rro_flag_is_local_protect_available, rro_flag_is_local_protect_in_use, rro_flag_rro_is_router_id, rro_flag_rro_node_protect, rro_flag_rro_bandwidth_protect'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions, psbs=psbs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions, psbs=psbs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_sessions_session_operational_status_get(self, sessions=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type sessions: dest_ip_addr, src_ip_addr, tunnel_id, session_role
    :param sessions: Keyword argument tuple.

    :type dest_ip_addr: unicode
    :param dest_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip_addr: unicode
    :param src_ip_addr: **sessions** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type tunnel_id: int
    :param tunnel_id: **sessions** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type session_role: unicode
    :param session_role: **sessions** tuple argument.

        * enumeration restriction: ::

            ['session-role-transit',
            'session-role-ingress',
            'session-role-egress',
            'session-role-unspecified']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.sessions', u'psbs'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.sessions', u'psbs'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.sessions', u'psbs')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'sessions', 'keyval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_index, session_name, session_type, path_operational_status, session_in_label, session_out_label, session_out_interface, lsp_id, flap_lock, path_refresh, path_refresh_ttd, resv_refresh, resv_refresh_ttd, tspec_peak, tspec_rate, tspec_size, tspec_minimum, tspec_m, psb_setup_priority, psb_hold_priority, session_attribute_all_flags, sa_flag_label_recording, sa_flag_soft_preemption_desired, sa_flag_se_style, sa_flag_local_protect, sa_flag_bandwidth_protect, sa_flag_session_protection_type, session_soft_preemption_wait_timer, session_preemption_wait_timer, frr_detour, frr_facility, frr_unknown_backup_mode_desired, frr_unknown_flags, frr_psb_setup_priority, frr_psb_hold_priority, frr_bandwidth, frr_hoplimit, frr_facility_method, frr_nh_node_protection_available, frr_nh_node_protection_in_use, frr_nh_link_protection_available, frr_nh_link_protection_in_use, frr_bandwidth_protection_available, frr_lsp_bringup_abandoned, frr_updown_transitions, frr_retries, frr_session_protection_available, frr_next_retry, frr_cost, frr_cspf_group_computation_mode, frr_cspf_group_computation_mode_use_bypass_liberal, is_downstream_backup_psb, is_backup_psb, is_upstream_psb, is_ps_frr_detour_sent, is_ps_frr_backup_sent, is_ps_frr_detour_received, is_ps_frr_backup_received, path_received_from_ip, path_received_interface, path_received_auth_on, path_received_message_id, path_downstream_only, path_sent_to_ip, path_sent_interface, path_sent_auth_on, path_sent_message_id, resv_received_from_ip, resv_received_interface, resv_received_auth_on, resv_received_message_id, session_riding_bypass_name, session_style'}, {'leafval': 'path_index, session_name, session_type, path_operational_status, session_in_label, session_out_label, session_out_interface, lsp_id, flap_lock, path_refresh, path_refresh_ttd, resv_refresh, resv_refresh_ttd, tspec_peak, tspec_rate, tspec_size, tspec_minimum, tspec_m, psb_setup_priority, psb_hold_priority, session_attribute_all_flags, sa_flag_label_recording, sa_flag_soft_preemption_desired, sa_flag_se_style, sa_flag_local_protect, sa_flag_bandwidth_protect, sa_flag_session_protection_type, session_soft_preemption_wait_timer, session_preemption_wait_timer, frr_detour, frr_facility, frr_unknown_backup_mode_desired, frr_unknown_flags, frr_psb_setup_priority, frr_psb_hold_priority, frr_bandwidth, frr_hoplimit, frr_method, frr_nh_node_protection_available, frr_nh_node_protection_in_use, frr_nh_link_protection_available, frr_nh_link_protection_in_use, frr_bandwidth_protection_available, frr_lsp_bringup_abandoned, frr_updown_transitions, frr_retries, frr_session_protection_available, frr_next_retry, frr_cost, frr_cspf_group_computation_mode, frr_cspf_group_computation_mode_use_bypass_liberal, is_downstream_backup_psb, is_backup_psb, is_upstream_psb, is_ps_frr_detour_sent, is_ps_frr_backup_sent, is_ps_frr_detour_received, is_ps_frr_backup_received, path_received_from_ip, path_received_interface, path_received_auth_on, path_received_message_id, path_downstream_only, path_sent_to_ip, path_sent_interface, path_sent_auth_on, path_sent_message_id, resv_received_from_ip, resv_received_interface, resv_received_auth_on, resv_received_message_id, session_riding_bypass_name, session_style'}, {'leafval': 'path_index, session_name, session_type, path_operational_status, session_in_label, session_out_label, session_out_interface, lsp_id, flap_lock, path_refresh, path_refresh_ttd, resv_refresh, resv_refresh_ttd, tspec_peak, tspec_rate, tspec_size, tspec_minimum, tspec_m, psb_setup_priority, psb_hold_priority, session_attribute_all_flags, sa_flag_label_recording, sa_flag_soft_preemption_desired, sa_flag_se_style, sa_flag_local_protect, sa_flag_bandwidth_protect, sa_flag_session_protection_type, session_soft_preemption_wait_timer, session_preemption_wait_timer, frr_detour, frr_facility, frr_unknown_backup_mode_desired, frr_unknown_flags, frr_psb_setup_priority, frr_psb_hold_priority, frr_bandwidth, frr_hoplimit, frr_method, frr_nh_node_protection_available, frr_nh_node_protection_in_use, frr_nh_link_protection_available, frr_nh_link_protection_in_use, frr_bandwidth_protection_available, frr_lsp_bringup_abandoned, frr_updown_transitions, frr_retries, frr_session_protection_available, frr_next_retry, frr_cost, frr_cspf_group_computation_mode, frr_cspf_group_computation_mode_use_bypass_liberal, is_downstream_backup_psb, is_backup_psb, is_upstream_psb, is_ps_frr_detour_sent, is_ps_frr_backup_sent, is_ps_frr_detour_received, is_ps_frr_backup_received, path_received_from_ip, path_received_interface, path_received_auth_on, path_received_message_id, path_downstream_only, path_sent_to_ip, path_sent_interface, path_sent_auth_on, path_sent_message_id, resv_received_from_ip, resv_received_interface, resv_received_auth_on, resv_received_message_id, session_riding_bypass_name, session_style'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sessions=sessions)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sessions=sessions)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_ack_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_ack_rx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_ack_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_ack_tx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_bundle_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_bundle_rx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_bundle_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_bundle_tx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_hello_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_hello_rx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_hello_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_hello_tx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_path_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_path_rx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_path_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_path_tx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_patherr_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_patherr_rx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_patherr_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_patherr_tx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_pathtear_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_pathtear_rx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_pathtear_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_pathtear_tx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resv_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resv_rx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resv_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resv_tx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resvconf_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resvconf_rx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resvconf_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resvconf_tx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resverr_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resverr_rx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resverr_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resverr_tx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resvtear_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resvtear_rx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resvtear_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_resvtear_tx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_sumrefresh_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_sumrefresh_rx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_sumrefresh_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_counters_sumrefresh_tx_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_ack_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_ack_errors_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_bundle_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_bundle_errors_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_hello_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_hello_errors_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_mem_alloc_fail_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_mem_alloc_fail_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_nackobject_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_nackobject_errors_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_path_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_path_errors_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_path_state_timeout_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_path_state_timeout_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_patherr_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_patherr_errors_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_pathtear_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_pathtear_errors_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_pkt_with_msg_id_drop_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_pkt_with_msg_id_drop_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_pkt_with_sref_drop_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_pkt_with_sref_drop_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resv_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resv_errors_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resv_state_timeout_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resv_state_timeout_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resvconf_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resvconf_errors_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resverr_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resverr_errors_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resvtear_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_resvtear_errors_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_md5_auth_error_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_md5_auth_error_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_pkt_bad_checksum_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_pkt_bad_checksum_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_pkt_bad_length_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_pkt_bad_length_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_pkt_bad_version_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_pkt_bad_version_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_pkt_unknown_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_rx_pkt_unknown_type_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_sumrefresh_errors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_statistics_packet_error_counters_sumrefresh_errors_since_last_clear_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics.packet_error_counters', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_rsvp_transport_address_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17s_1_02.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_statistics_oam_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'name, number, tx_count, rx_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_statistics_oam_echo_req_received_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'name, number, tx_count, rx_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_statistics_oam_echo_req_sent_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'name, number, tx_count, rx_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_statistics_oam_echo_req_timeout_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'name, number, tx_count, rx_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_statistics_oam_echo_resp_received_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'name, number, tx_count, rx_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_statistics_oam_echo_resp_sent_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'name, number, tx_count, rx_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_statistics_oam_return_codes_get(self, return_codes=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type return_codes: number
    :param return_codes: Keyword argument tuple.

    :type number: long
    :param number: **return_codes** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam.return_codes', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam.return_codes', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.statistics_oam.return_codes', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'return_codes', 'keyval': 'number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, return_codes=return_codes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, return_codes=return_codes)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_statistics_oam_return_codes_name_get(self, return_codes=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type return_codes: number
    :param return_codes: Keyword argument tuple.

    :type number: long
    :param number: **return_codes** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam.return_codes', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam.return_codes', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.statistics_oam.return_codes', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'return_codes', 'keyval': 'number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, return_codes=return_codes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, return_codes=return_codes)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_statistics_oam_return_codes_rx_count_get(self, return_codes=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type return_codes: number
    :param return_codes: Keyword argument tuple.

    :type number: long
    :param number: **return_codes** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam.return_codes', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam.return_codes', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.statistics_oam.return_codes', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'return_codes', 'keyval': 'number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, return_codes=return_codes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, return_codes=return_codes)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_statistics_oam_return_codes_tx_count_get(self, return_codes=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type return_codes: number
    :param return_codes: Keyword argument tuple.

    :type number: long
    :param number: **return_codes** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam.return_codes', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam.return_codes', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.statistics_oam.return_codes', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'return_codes', 'keyval': 'number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, return_codes=return_codes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, return_codes=return_codes)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_statistics_oam_usr_ping_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'name, number, tx_count, rx_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_statistics_oam_usr_traceroute_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'name, number, tx_count, rx_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_auto_bw_templates_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_auto_bw_templates_supported_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_backup_lsps_up_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_bypass_lsps_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_bypass_lsps_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_bypass_lsps_up_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_cross_connects_allocated_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_cross_connects_supported_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_cspf_groups_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_detour_lsps_up_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_ldp_lsps_operational_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_lsps_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_lsps_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_lsps_operational_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_paths_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_times_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_transit_lsps_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_transit_lsps_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_transit_lsps_operational_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_tunnels_allocated_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_summary_tunnels_supported_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.summary', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17s_1_02.mpls_state.te', u'database'), ('pybind.slxos.v17s_1_02.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17s_1_02.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'router_id'}, {'leafval': 'router_id'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'router_id'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_get(self, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'node')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_host_name_get(self, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'node')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_igp_isis_get(self, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'node')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_igp_ospf_get(self, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'node')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_get(self, area=None, node=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'link')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_area_id_get(self, area=None, node=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'link')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_gen_code_get(self, area=None, node=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'link')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_host_name_get(self, area=None, node=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'link')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_igp_isis_get(self, area=None, node=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'link')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_igp_ospf_get(self, area=None, node=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'link')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_level_id_get(self, area=None, node=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'link')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_admin_group_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_area_id_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_gen_code_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_igp_isis_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_igp_metric_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_igp_ospf_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_level_id_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_local_host_name_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_lsa_id_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_max_bandwidth_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_max_reservable_bandwidth_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_network_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_p2mp_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_p2p_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_pending_delete_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_remote_host_name_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_router_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_srlg_get(self, area=None, node=None, link=None, srlg=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type srlg: name
    :param srlg: Keyword argument tuple.

    :type name: unicode
    :param name: **srlg** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link.srlg', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link.srlg', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link.srlg', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'srlg', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link, srlg=srlg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link, srlg=srlg)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_srlg_penalty_get(self, area=None, node=None, link=None, srlg=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type srlg: name
    :param srlg: Keyword argument tuple.

    :type name: unicode
    :param name: **srlg** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link.srlg', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link.srlg', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link.srlg', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'srlg', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link, srlg=srlg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link, srlg=srlg)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_te_metric_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_unreserved_priority_0_bandwidth_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_unreserved_priority_1_bandwidth_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_unreserved_priority_2_bandwidth_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_unreserved_priority_3_bandwidth_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_unreserved_priority_4_bandwidth_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_unreserved_priority_5_bandwidth_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_unreserved_priority_6_bandwidth_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_link_unreserved_priority_7_bandwidth_get(self, area=None, node=None, link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type link: local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip
    :param link: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **link** tuple argument.

    :type remote_node_id: unicode
    :param remote_node_id: **link** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_router_id: unicode
    :param remote_router_id: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type local_ip: unicode
    :param local_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type remote_ip: unicode
    :param remote_ip: **link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.link', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.link', u'srlg')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link', 'keyval': 'local_node_id, remote_node_id, local_router_id, remote_router_id, local_ip, remote_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}, {'leafval': 'name, penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, link=link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, link=link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_lsa_id_get(self, area=None, node=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'link')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_network_get(self, area=None, node=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'link')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_overloaded_get(self, area=None, node=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'link')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_router_get(self, area=None, node=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'link')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_srlg_get(self, area=None, node=None, srlg=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type srlg: name
    :param srlg: Keyword argument tuple.

    :type name: unicode
    :param name: **srlg** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.srlg', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.srlg', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.srlg', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'srlg', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, srlg=srlg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, srlg=srlg)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_srlg_penalty_get(self, area=None, node=None, srlg=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type srlg: name
    :param srlg: Keyword argument tuple.

    :type name: unicode
    :param name: **srlg** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'node'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'node')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node.srlg', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node.srlg', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node.srlg', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'srlg', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node, srlg=srlg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node, srlg=srlg)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_total_p2mp_links_get(self, area=None, node=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'link')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_node_total_p2p_links_get(self, area=None, node=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type node: local_node_id, local_router_id
    :param node: Keyword argument tuple.

    :type local_node_id: unicode
    :param local_node_id: **node** tuple argument.

    :type local_router_id: unicode
    :param local_router_id: **node** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area.node', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'srlg'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area.node', u'link')]
    compositions_keyval_list = [{'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}, {'keyval': 'area_id, level_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'node', 'keyval': 'local_node_id, local_router_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}, {'leafval': 'name, penalty'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, local_node_id, remote_node_id, local_router_id, remote_router_id, local_host_name, remote_host_name, router, network, p2p, p2mp, local_ip, remote_ip, gen_code, lsa_id, pending_delete, igp_metric, te_metric, admin_group, max_bandwidth, max_reservable_bandwidth, unreserved_priority_0_bandwidth, unreserved_priority_1_bandwidth, unreserved_priority_2_bandwidth, unreserved_priority_3_bandwidth, unreserved_priority_4_bandwidth, unreserved_priority_5_bandwidth, unreserved_priority_6_bandwidth, unreserved_priority_7_bandwidth'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area, node=node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area, node=node)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_router_id_get(self, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'node')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_total_network_nodes_get(self, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'node')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_total_p2mp_links_get(self, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'node')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_total_p2p_links_get(self, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'node')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_area_total_router_nodes_get(self, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type area: area_id, level_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type level_id: long
    :param level_id: **area** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database.area', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_2_00.mpls_state.te.database.area', u'node'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database.area', u'node')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id, level_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, router, network, host_name, local_node_id, local_router_id, gen_code, lsa_id, total_p2p_links, total_p2mp_links, overloaded'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_database_router_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.database', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.database', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_isis_level_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17s_1_02.mpls_state.te', u'database'), ('pybind.slxos.v17s_1_02.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17s_1_02.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'router_id'}, {'leafval': 'router_id'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'router_id'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_isis_te_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17s_1_02.mpls_state.te', u'database'), ('pybind.slxos.v17s_1_02.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17s_1_02.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'router_id'}, {'leafval': 'router_id'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'router_id'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_ospf_area_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17s_1_02.mpls_state.te', u'database'), ('pybind.slxos.v17s_1_02.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17s_1_02.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'router_id'}, {'leafval': 'router_id'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'router_id'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_ospf_te_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17s_1_02.mpls_state.te', u'database'), ('pybind.slxos.v17s_1_02.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17s_1_02.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'router_id'}, {'leafval': 'router_id'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'router_id'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_router_id_map_get(self, router_id_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.router_id_map', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.router_id_map', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.router_id_map', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_router_id_map_igp_isis_get(self, router_id_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.router_id_map', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.router_id_map', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.router_id_map', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_router_id_map_igp_ospf_get(self, router_id_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.router_id_map', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.router_id_map', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.router_id_map', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_router_id_map_isis_level_get(self, router_id_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.router_id_map', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.router_id_map', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.router_id_map', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_router_id_map_origin_lsp_get(self, router_id_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.router_id_map', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.router_id_map', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.router_id_map', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_router_id_map_origin_other_get(self, router_id_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.router_id_map', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.router_id_map', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.router_id_map', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_router_id_map_origin_path_get(self, router_id_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.router_id_map', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.router_id_map', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.router_id_map', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_router_id_map_origin_ted_get(self, router_id_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.router_id_map', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.router_id_map', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.router_id_map', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_router_id_map_ospf_area_get(self, router_id_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.router_id_map', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.router_id_map', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.router_id_map', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_router_id_map_resolved_get(self, router_id_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.router_id_map', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.router_id_map', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.router_id_map', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_te_router_id_map_router_id_get(self, router_id_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type router_id_map: ip_address
    :param router_id_map: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **router_id_map** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.te.router_id_map', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.te.router_id_map', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.te.router_id_map', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'router_id_map', 'keyval': 'ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, router_id_map=router_id_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, router_id_map=router_id_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_times_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_lsps_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_lsps_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_lsps_operational_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics', u'statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'transit_traffic_statistics', 'keyval': 'in_label', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics": {}, "pybind.slxos.v17r_1_01a.mpls_state.transit_traffic_statistics": {"in_label": "in_label", "protocol": "protocol", "number_of_packets": "number_of_packets", "packets_per_second": "packets_per_second", "number_of_bytes": "number_of_bytes", "number_of_bytes_since_clear": "number_of_bytes_since_clear", "averaging_interval_seconds": "averaging_interval_seconds", "bytes_per_second": "bytes_per_second", "number_of_packets_since_clear": "number_of_packets_since_clear", "statistics_valid": "statistics_valid"}, "pybind.slxos.v17r_2_00.mpls_state.transit_traffic_statistics": {"in_label": "in_label", "protocol": "protocol", "number_of_packets": "number_of_packets", "packets_per_second": "packets_per_second", "number_of_bytes": "number_of_bytes", "number_of_bytes_since_clear": "number_of_bytes_since_clear", "averaging_interval_seconds": "averaging_interval_seconds", "bytes_per_second": "bytes_per_second", "number_of_packets_since_clear": "number_of_packets_since_clear", "statistics_valid": "statistics_valid"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_averaging_interval_seconds_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'transit_traffic_statistics', 'keyval': 'in_label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_bytes_per_second_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'transit_traffic_statistics', 'keyval': 'in_label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_number_of_bytes_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'transit_traffic_statistics', 'keyval': 'in_label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_number_of_bytes_since_clear_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'transit_traffic_statistics', 'keyval': 'in_label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_number_of_packets_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'transit_traffic_statistics', 'keyval': 'in_label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_number_of_packets_since_clear_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'transit_traffic_statistics', 'keyval': 'in_label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_packets_per_second_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'transit_traffic_statistics', 'keyval': 'in_label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_protocol_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics', u'statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'transit_traffic_statistics', 'keyval': 'in_label', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics', u'transit_traffic_statistics')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'in_label', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_averaging_interval_seconds_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics', u'transit_traffic_statistics')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'in_label', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_bytes_per_second_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics', u'transit_traffic_statistics')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'in_label', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_number_of_bytes_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics', u'transit_traffic_statistics')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'in_label', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_number_of_bytes_since_clear_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics', u'transit_traffic_statistics')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'in_label', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_number_of_packets_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics', u'transit_traffic_statistics')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'in_label', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_number_of_packets_since_clear_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics', u'transit_traffic_statistics')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'in_label', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_packets_per_second_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics', u'transit_traffic_statistics')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'in_label', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_transit_traffic_statistics_statistics_valid_get(self, transit_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type transit_traffic_statistics: in_label
    :param transit_traffic_statistics: Keyword argument tuple.

    :type in_label: long
    :param in_label: **transit_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.transit_traffic_statistics', u'statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'transit_traffic_statistics', 'keyval': 'in_label', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, transit_traffic_statistics=transit_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, transit_traffic_statistics=transit_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', u'statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.mpls_state.tunnel_traffic_statistics": {"index": "index", "protocol": "protocol", "name": "name", "number_of_packets": "number_of_packets", "packets_per_second": "packets_per_second", "number_of_bytes": "number_of_bytes", "number_of_bytes_since_clear": "number_of_bytes_since_clear", "averaging_interval_seconds": "averaging_interval_seconds", "is_bypass": "is_bypass", "bytes_per_second": "bytes_per_second", "number_of_packets_since_clear": "number_of_packets_since_clear", "statistics_valid": "statistics_valid"}, "pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics": {}, "pybind.slxos.v17r_2_00.mpls_state.tunnel_traffic_statistics": {"index": "index", "protocol": "protocol", "name": "name", "number_of_packets": "number_of_packets", "packets_per_second": "packets_per_second", "number_of_bytes": "number_of_bytes", "number_of_bytes_since_clear": "number_of_bytes_since_clear", "averaging_interval_seconds": "averaging_interval_seconds", "is_bypass": "is_bypass", "bytes_per_second": "bytes_per_second", "number_of_packets_since_clear": "number_of_packets_since_clear", "statistics_valid": "statistics_valid"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_averaging_interval_seconds_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_bytes_per_second_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_is_bypass_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', u'statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_name_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', u'statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_number_of_bytes_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_number_of_bytes_since_clear_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_number_of_packets_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_number_of_packets_since_clear_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_packets_per_second_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_protocol_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', u'statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', u'tunnel_traffic_statistics')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_averaging_interval_seconds_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', u'tunnel_traffic_statistics')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_bytes_per_second_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', u'tunnel_traffic_statistics')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_number_of_bytes_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', u'tunnel_traffic_statistics')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_number_of_bytes_since_clear_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', u'tunnel_traffic_statistics')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_number_of_packets_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', u'tunnel_traffic_statistics')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_number_of_packets_since_clear_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', u'tunnel_traffic_statistics')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_packets_per_second_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', u'tunnel_traffic_statistics')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics.statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnel_traffic_statistics_statistics_valid_get(self, tunnel_traffic_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tunnel_traffic_statistics: index
    :param tunnel_traffic_statistics: Keyword argument tuple.

    :type index: long
    :param index: **tunnel_traffic_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', 'pybind.slxos.v17s_1_02.brocade_mpls_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_state.tunnel_traffic_statistics', u'statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tunnel_traffic_statistics', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_traffic_statistics=tunnel_traffic_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_traffic_statistics=tunnel_traffic_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnels_allocated_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mpls_state_tunnels_supported_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_state', 'pybind.slxos.v17r_1_01a.brocade_mpls_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_state', u'memory'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.tunnels', u'ldp_tunnels'), ('pybind.slxos.v17r_2_00.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state', u'route'), ('pybind.slxos.v17r_2_00.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_2_00.mpls_state', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_2_00.mpls_state', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_2_00.mpls_state', u'te'), ('pybind.slxos.v17r_2_00.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'bfd'), ('pybind.slxos.v17r_2_00.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_2_00.mpls_state', u'path'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_2_00.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_2_00.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_2_00.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_2_00.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_2_00.mpls_state', u'ldp'), ('pybind.slxos.v17r_2_00.mpls_state.te', u'database'), ('pybind.slxos.v17r_2_00.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_2_00.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_2_00.mpls_state', u'policy'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_2_00.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_2_00.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_2_00.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_2_00.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_prefix'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_error_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state', u'ldp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'router_id_map'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_global'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'link'), ('pybind.slxos.v17r_1_01a.mpls_state.dynamic_bypass', u'dynamic_bypass_interface'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_session_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_summary'), ('pybind.slxos.v17r_1_01a.mpls_state', u'tunnel_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.te', u'database'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_state', u'memory'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'stats'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'interfaces'), ('pybind.slxos.v17r_1_01a.mpls_state', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state', u'route'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'sessions'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.statistics', u'packet_counters'), ('pybind.slxos.v17r_1_01a.mpls_state', u'transit_traffic_statistics'), ('pybind.slxos.v17r_1_01a.mpls_state.statistics_oam', u'return_codes'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'igp_sync'), ('pybind.slxos.v17r_1_01a.mpls_state', u'autobw_threshold_table_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.memory', u'pools'), ('pybind.slxos.v17r_1_01a.mpls_state', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_state.te.database', u'area'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_database'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'rsvp_flooding_thresholds'), ('pybind.slxos.v17r_1_01a.mpls_state.policy', u'admin_groups'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_stats'), ('pybind.slxos.v17r_1_01a.mpls_state', u'auto_bandwidth_template'), ('pybind.slxos.v17r_1_01a.mpls_state', u'interface'), ('pybind.slxos.v17r_1_01a.mpls_state', u'statistics_oam'), ('pybind.slxos.v17r_1_01a.mpls_state', u'te'), ('pybind.slxos.v17r_1_01a.mpls_state', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'path'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.statistics', u'protocol_errors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'tunnels'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp.igp_sync', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_state.rsvp', u'neighbors'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp', u'ldp_fec_vc'), ('pybind.slxos.v17r_1_01a.mpls_state', u'forwarding_entry'), ('pybind.slxos.v17r_1_01a.mpls_state.ldp.tunnels', u'ldp_tunnels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'total_non_pool_memory'}, {'leafval': 'threshold_type'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'lsp_name, lsp_instance_id, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'peer_ldp_id, peer_label_space_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'stats_group'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'pool_index'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi, vc_local_flow_label_tx, vc_local_flow_label_rx, vc_remote_flow_label_tx, vc_remote_flow_label_rx, vc_control_word_preferred, vc_control_word_in_use'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'name, group_number'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'router_id'}, {'leafval': 'stats_group'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'destination, state, ingress, egress, filtered, lwd, filter_type, prefix_filtered, longer, prefix_feccb, prefix_idx, prefix_type, prefix_pend_notif, prefix_um_dist_done, prefix_lwd_started, prefix_is_ldp_o_rsvp, prefix_excess_dms'}, {'leafval': 'rx_pkt_bad_length, rx_pkt_unknown_type, rx_pkt_bad_version, rx_pkt_bad_checksum, mem_alloc_fail, rx_md5_auth_error, path_state_timeout, resv_state_timeout, pkt_with_msg_id_drop, pkt_with_sref_drop, rx_pkt_bad_length_since_last_clear, rx_pkt_unknown_type_since_last_clear, rx_pkt_bad_version_since_last_clear, rx_pkt_bad_checksum_since_last_clear, mem_alloc_fail_since_last_clear, rx_md5_auth_error_since_last_clear, path_state_timeout_since_last_clear, resv_state_timeout_since_last_clear, pkt_with_msg_id_drop_since_last_clear, pkt_with_sref_drop_since_last_clear, path_errors, resv_errors, patherr_errors, resverr_errors, pathtear_errors, resvtear_errors, resvconf_errors, bundle_errors, ack_errors, sumrefresh_errors, hello_errors, nackobject_errors, path_errors_since_last_clear, resv_errors_since_last_clear, patherr_errors_since_last_clear, resverr_errors_since_last_clear, pathtear_errors_since_last_clear, resvtear_errors_since_last_clear, resvconf_errors_since_last_clear, bundle_errors_since_last_clear, ack_errors_since_last_clear, sumrefresh_errors_since_last_clear, hello_errors_since_last_clear, nackobject_errors_since_last_clear'}, {'leafval': 'path_name, usage_count'}, {'leafval': 'ldp_initialized, lsr_id, lsr_id_configured, loopback, hello_interval_link, hello_interval_target, hold_time_sent_link, hold_time_sent_target, ka_interval, ka_multiple, ka_timeout, ka_timeout_default, load_sharing, advertise_fecs_for_prefix_list, advertise_fecs_for_prefix_list_exists, inbound_fecs_filtering_prefix_list, inbound_fecs_filtering_prefix_list_exists, outbound_fecs_filtering_prefix_list, outbound_fecs_filtering_prefix_list_exists, tunnel_metric, fec_128_used_for_auto_disc_current, fec_128_used_for_auto_disc_configured, end_of_lib, eol_notification_time, tx_silence_time, rx_silence_time, gr_enable, gr_helper, gr_reconnect_time, gr_max_peer_reconnect_time, gr_recovery_time, gr_max_peer_recovery_time, forwarding_state_timer_running, forwarding_state_timer_remaining, lwd_delay, lwd_default'}, {'leafval': 'neighbor_ldpid, labelspaceid, neighbor_transport, interface_name, max_hold_time, time_left, up_time, configured_hold_time, neighbor_proposed_hold_time'}, {'leafval': 'number_of_prefix_fec, number_of_prefix_fec_installed, number_of_prefix_fec_filtered_in, number_of_prefix_fec_filtered_out, number_of_vc_fec_128, number_of_vc_fec_129, number_of_vc_fec_installed, number_of_route_upd_proc_errors, number_of_vc_fec_proc_errors, number_of_prefix_fec_lwd, number_of_vc_fec'}, {'leafval': 'interface_index, interface_name, label_space, neighbor_count, hello_interval, hello_timeout, hello_next'}, {'leafval': 'admin_status, min_tx_interval, min_rx_interval, detection_time_multiplier'}, {'leafval': 'ip_address, router_id, resolved, igp_isis, igp_ospf, isis_level, ospf_area, origin_ted, origin_path, origin_lsp, origin_other'}, {'leafval': 'config_enable, config_enable_all, reoptimize_timer, max_bypasses_per_mp, max_bypasses, bypass_count'}, {'leafval': 'peer_ldp_id, peer_lblspc_id, state, adjacency, role, max_hold, time_left, session_status, local_ldp_id, local_lblspc_id, next_keepalive, entity_index, targeted_adj_added, is_retry, next_retry, keepalive_interval, local_keepalive_timeout, peer_proposed_keepalive_timeout, session_up_time, md5_auth_key, tcp_conn_local, tcp_conn_remote, tcp_state, num_fecs_received_from_peer, num_fecs_installed_from_peer, is_fecs_pending_uninstall, num_fecs_filtered_out, num_fecs_filtered_in, filter_prefix_list_name, filter_prefix_list_exists, is_only_gr_valid, gr_enabled, peer_reconnect_time, peer_recovery_time, reconnect_time_in_use, reconnect_time_remaining, recovery_time_in_use, recovery_time_remaining, gr_state, local_eol_unrecognized_notification, remote_eol_unrecognized_notification, does_session_support_eol, local_state, remote_state, eol_notification_time, eol_notification_time_remaining, eol_tx_label_silence_time, eol_tx_label_silence_time_remaining, eol_rx_label_silence_time, eol_rx_label_silence_time_remaining, filtered'}, {'leafval': 'ip_address, nbr_ip_address, remote_ip, lsp_count'}, {'leafval': 'if_index, if_name, if_type, active_status, admin_type, admin_status, hop_limit, tie_breaking, cos, cspf_comp_mode, setup_priority, hold_priority, traffic_eng_max_rate, traffic_eng_mean_rate, traffic_eng_max_burst, from_addr, reoptimize_timer, adaptive, record_route, name_prefix, primary_path, max_bypasses_per_mp, bypass_count, exclude_any, include_all, include_any, status_flags, mp_count'}, {'leafval': 'num_link_sessions, num_operational_link_sessions, num_targeted_sessions, num_operational_targeted_sessions'}, {'leafval': 'total_number_of_autobw_threshold_table_entries'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, index, protocol, name, is_bypass, statistics_valid'}, {'leafval': 'router_id'}, {'leafval': 'mpls_ldp_targeted_peer_id'}, {'leafval': 'total_non_pool_memory'}, {'leafval': 'mem_stats_index, mem_type, num_alloc, total_bytes, total_allocs, total_frees, peak_alloc, alloc_fails, free_fails'}, {'leafval': 'interface_name, interface_type, interface_index, admin_status, oper_status, is_tunnel_interface, hello_interval, hello_tolerance, hello_status, is_md5_auth_enabled, reliable_messages, bundle_messages, summary_refresh, active_outsegs, inactive_outsegs, bandwith_resv_outsegs, active_backup_outsegs, inactive_backup_outsegs, interface_preempts, interface_resv_soft_preempts, interface_flooding_up_threshold, interface_flooding_down_threshold, duplicate_preempts_dropped, bypass_interface, interface_tunnel_name, bypass_tunnel_interface_name'}, {'leafval': 'lsp_name, lsp_type, bypass_lsp_type, interface'}, {'leafval': 'entry_index, outseg_index, dest_ip_prefix, gateway_ip_addr, out_interface_name, out_label, protocol, vif_index, metric, use_count'}, {'leafval': 'dest_ip_addr, src_ip_addr, tunnel_id, session_role, session_operational_status'}, {'leafval': 'path_tx, resv_tx, patherr_tx, resverr_tx, pathtear_tx, resvtear_tx, resvconf_tx, bundle_tx, ack_tx, sumrefresh_tx, hello_tx, path_rx, resv_rx, patherr_rx, resverr_rx, pathtear_rx, resvtear_rx, resvconf_rx, bundle_rx, ack_rx, sumrefresh_rx, hello_rx, path_tx_since_last_clear, resv_tx_since_last_clear, patherr_tx_since_last_clear, resverr_tx_since_last_clear, pathtear_tx_since_last_clear, resvtear_tx_since_last_clear, resvconf_tx_since_last_clear, bundle_tx_since_last_clear, ack_tx_since_last_clear, sumrefresh_tx_since_last_clear, hello_tx_since_last_clear, path_rx_since_last_clear, resv_rx_since_last_clear, patherr_rx_since_last_clear, resverr_rx_since_last_clear, pathtear_rx_since_last_clear, resvtear_rx_since_last_clear, resvconf_rx_since_last_clear, bundle_rx_since_last_clear, ack_rx_since_last_clear, sumrefresh_rx_since_last_clear, hello_rx_since_last_clear'}, {'leafval': 'number_of_packets, number_of_packets_since_clear, number_of_bytes, number_of_bytes_since_clear, packets_per_second, bytes_per_second, averaging_interval_seconds, in_label, protocol, statistics_valid'}, {'leafval': 'name, number, tx_count, rx_count'}, {'leafval': 'isis_nbr_down_enabled, ospf_nbr_down_enabled'}, {'leafval': 'bandwidth, threshold, is_percentage_threshold'}, {'leafval': 'pool_index'}, {'leafval': 'cspf_intf, cspf_group_computation_mode, cspf_comp_mode, cspf_comp_ignore_overload_bit, implicit_commit_value, qos_ttl_mode, rtm_route_filter_enabled, rtm_route_filter_all_ibgp_enabled, ingress_tnnl_actg, transit_session_actg, load_interval, te_policy_protocol, te_policy_flags, te_policy_area, handle_isis_nbr_down, handle_ospf_nbr_down, max_lsp_retries, fast_retry_on, lsp_retry_interval, frr_backup_retry_interval, auto_bandwidth_enabled, autobw_sample_interval, autobw_num_sample_record, soft_preempt_cleanup_timer, rsvp_periodic_flooding_timer'}, {'leafval': 'igp_isis, igp_ospf, area_id, level_id, host_name, router_id, total_network_nodes, total_router_nodes, total_p2p_links, total_p2mp_links'}, {'leafval': 'peer_ip, own_ip'}, {'leafval': 'threshold_type'}, {'leafval': 'name, group_number'}, {'leafval': 'stats_group'}, {'leafval': 'name, adjustment_interval, adjustment_threshold, maximum_bandwidth, minimum_bandwidth, overflow_limit, underflow_limit, mode, sample_recording, associated_paths_count'}, {'leafval': 'interface_index, interface_name, admin_status, oper_status, mtu, bypass_lsp_count, max_lsp_priority_level, is_ldp_enabled, ldp_tunnel_count, ldp_transit_tunnel_count, is_gre_port, admin_group, admin_group_max, admin_group_min, te_metric, max_bandwidth, max_resv_bandwidth, max_resv_bandwidth_percentage'}, {'leafval': 'usr_ping_count, usr_traceroute_count, echo_req_sent_count, echo_req_received_count, echo_req_timeout_count, echo_resp_sent_count, echo_resp_received_count'}, {'leafval': 'ospf_te_enabled, isis_te_enabled, ospf_area_id, isis_level_id'}, {'leafval': 'protocol_status, refresh_interval, refresh_multiple, transport_address, delay_resv_sending, backup_bandwidth_requirement'}, {'leafval': 'path_key, destination_route'}, {'leafval': 'stats_group'}, {'leafval': 'total_tunnel_count'}, {'leafval': 'lsp_name, path_name, cspf_enabled, rro_enabled, frr_enabled, nbr_down_enabled, link_count, nbr_down_inprogress, cspf_hop_count, rro_hop_count'}, {'leafval': 'neighbor_ip_addr, neighbor_interface, neighbor_status, neighbor_last_status_change, rsvp_hello_tx, rsvp_hello_rx, refresh_reduction_support, msg_id_support, active_lsps, rsvp_hello_interval, rsvp_hello_tolerance, neighbor_remote_instance, neighbor_local_instance, last_hello_rx, next_hello_req_tx'}, {'leafval': 'vc_id, peer_id, peer_lblspc, state, peer_vc_type, ingress, egress, vc_feccb, vc_idx, vc_fec_type, prefix_pend_notif, prefix_um_dist_done, vc_type, vc_grp_id, vc_local_mtu, vc_remote_mtu, vc_mtu_enforcement, vc_agi'}, {'leafval': 'entry_index, sync_index, dest_ip_prefix, in_label, out_label, protocol, out_interface_name, nexthop_ip_addr, type'}, {'leafval': 'tunnel_interface_index, tunnel_metric, name, tunnel_vif, protocol_type, tunnel_destination, prefix_length'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def mtu_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.global_mtu_conf', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_2_00.global_mtu_conf', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.global_mtu_conf', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.global_mtu_conf', u'ip'), ('pybind.slxos.v17r_2_00.global_mtu_conf', u'ipv6'), ('pybind.slxos.v17s_1_02.global_mtu_conf', u'ipv6'), ('pybind.slxos.v17s_1_02.global_mtu_conf', u'ip'), ('pybind.nos.v7_2_0.global_mtu_conf', u'ipv6'), ('pybind.nos.v7_2_0.global_mtu_conf', u'ip')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'global_ip_mtu'}, {'leafval': 'global_ipv6_mtu'}, {'leafval': 'global_ipv6_mtu'}, {'leafval': 'global_ip_mtu'}, {'leafval': 'global_ipv6_mtu'}, {'leafval': 'global_ip_mtu'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def nas_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.nas', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.nas', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.nas', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.nas', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.nas', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.nas.auto_qos', u'set'), ('pybind.nos.v6_0_2f.nas', u'server_ip'), ('pybind.slxos.v17s_1_02.nas', u'server_ip'), ('pybind.slxos.v17s_1_02.nas.auto_qos', u'set'), ('pybind.nos.v7_2_0.nas.auto_qos', u'set'), ('pybind.nos.v7_2_0.nas', u'server_ip'), ('pybind.slxos.v17r_1_01a.nas.auto_qos', u'set'), ('pybind.slxos.v17r_1_01a.nas', u'server_ip'), ('pybind.slxos.v17r_2_00.nas.auto_qos', u'set'), ('pybind.slxos.v17r_2_00.nas', u'server_ip')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cos, dscp'}, {'leafval': 'server_ip'}, {'leafval': 'server_ip'}, {'leafval': 'cos, dscp'}, {'leafval': 'cos, dscp'}, {'leafval': 'server_ip'}, {'leafval': 'cos, dscp'}, {'leafval': 'server_ip'}, {'leafval': 'cos, dscp'}, {'leafval': 'server_ip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def nas_auto_qos_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.nas.auto_qos', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.nas.auto_qos', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.nas.auto_qos', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.nas.auto_qos', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.nas.auto_qos', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.nas.auto_qos', u'set'), ('pybind.slxos.v17s_1_02.nas.auto_qos', u'set'), ('pybind.nos.v7_2_0.nas.auto_qos', u'set'), ('pybind.nos.v6_0_2f.nas.auto_qos', u'set'), ('pybind.slxos.v17r_2_00.nas.auto_qos', u'set')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cos, dscp'}, {'leafval': 'cos, dscp'}, {'leafval': 'cos, dscp'}, {'leafval': 'cos, dscp'}, {'leafval': 'cos, dscp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def nas_auto_qos_set_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.nas.auto_qos.set_', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.nas.auto_qos.set_', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.nas.auto_qos.set_', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.nas.auto_qos.set_', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.nas.auto_qos.set_', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def nas_auto_qos_set_cos_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.nas.auto_qos.set_', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.nas.auto_qos.set_', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.nas.auto_qos.set_', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.nas.auto_qos.set_', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.nas.auto_qos.set_', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def nas_auto_qos_set_dscp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.nas.auto_qos.set_', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.nas.auto_qos.set_', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.nas.auto_qos.set_', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.nas.auto_qos.set_', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.nas.auto_qos.set_', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def nas_server_ip_get(self, server_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type server_ip: server_ip
    :param server_ip: Keyword argument tuple.

    :type server_ip: unicode
    :param server_ip: **server_ip** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.nas.server_ip', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.nas.server_ip', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.nas.server_ip', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.nas.server_ip', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.nas.server_ip', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.nas.server_ip', u'vlan'), ('pybind.slxos.v17s_1_02.nas.server_ip', u'vrf'), ('pybind.nos.v7_2_0.nas.server_ip', u'vrf'), ('pybind.nos.v7_2_0.nas.server_ip', u'vlan'), ('pybind.nos.v6_0_2f.nas.server_ip', u'vlan'), ('pybind.nos.v6_0_2f.nas.server_ip', u'vrf'), ('pybind.slxos.v17r_2_00.nas.server_ip', u'vrf'), ('pybind.slxos.v17r_2_00.nas.server_ip', u'vlan'), ('pybind.slxos.v17r_1_01a.nas.server_ip', u'vrf'), ('pybind.slxos.v17r_1_01a.nas.server_ip', u'vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'server_ip', 'keyval': 'server_ip', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_number'}, {'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}, {'leafval': 'vlan_number'}, {'leafval': 'vlan_number'}, {'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}, {'leafval': 'vlan_number'}, {'leafval': 'vrf_name'}, {'leafval': 'vlan_number'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server_ip=server_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server_ip=server_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def nas_server_ip_vlan_get(self, server_ip=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type server_ip: server_ip
    :param server_ip: Keyword argument tuple.

    :type server_ip: unicode
    :param server_ip: **server_ip** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    **Instance Keyword Argument Tuple**:

    :type vlan: vlan_number
    :param vlan: Keyword argument tuple.

    :type vlan_number: long
    :param vlan_number: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.nas.server_ip', u'server_ip'), ('pybind.slxos.v17r_2_00.nas.server_ip', u'server_ip'), ('pybind.nos.v7_2_0.nas.server_ip', u'server_ip'), ('pybind.nos.v6_0_2f.nas.server_ip', u'server_ip'), ('pybind.slxos.v17r_1_01a.nas.server_ip', u'server_ip')]
    bindings_list = [('pybind.nos.v6_0_2f.nas.server_ip.vlan', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.nas.server_ip.vlan', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.nas.server_ip.vlan', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.nas.server_ip.vlan', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.nas.server_ip.vlan', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'server_ip', 'extra_keyval': ''}, {'keyval': 'server_ip', 'extra_keyval': ''}, {'keyval': 'server_ip', 'extra_keyval': ''}, {'keyval': 'server_ip', 'extra_keyval': ''}, {'keyval': 'server_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'vlan_number', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server_ip=server_ip, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server_ip=server_ip, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def nas_server_ip_vrf_get(self, server_ip=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type server_ip: server_ip
    :param server_ip: Keyword argument tuple.

    :type server_ip: unicode
    :param server_ip: **server_ip** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    **Instance Keyword Argument Tuple**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument.

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.nas.server_ip', u'server_ip'), ('pybind.slxos.v17r_1_01a.nas.server_ip', u'server_ip'), ('pybind.slxos.v17s_1_02.nas.server_ip', u'server_ip'), ('pybind.nos.v7_2_0.nas.server_ip', u'server_ip'), ('pybind.slxos.v17r_2_00.nas.server_ip', u'server_ip')]
    bindings_list = [('pybind.nos.v6_0_2f.nas.server_ip.vrf', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.nas.server_ip.vrf', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.nas.server_ip.vrf', 'pybind.slxos.v17r_1_01a.brocade_qos_cee', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.nas.server_ip.vrf', 'pybind.slxos.v17r_2_00.brocade_qos_cee', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.nas.server_ip.vrf', 'pybind.slxos.v17s_1_02.brocade_qos_cee', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'server_ip', 'extra_keyval': ''}, {'keyval': 'server_ip', 'extra_keyval': ''}, {'keyval': 'server_ip', 'extra_keyval': ''}, {'keyval': 'server_ip', 'extra_keyval': ''}, {'keyval': 'server_ip', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrf', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server_ip=server_ip, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server_ip=server_ip, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def no_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.no', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.no', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.no', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.no', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.no', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def no_crypto_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.no.nocrypto', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.no.nocrypto', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.no.nocrypto', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.no.nocrypto', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.no.nocrypto', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def no_fcsp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.no.fcsp', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.no.fcsp', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.no.fcsp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.no.fcsp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def no_tpvm_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.no.tpvm', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def node_id_get(self, node_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type node_id: node_id
    :param node_id: Keyword argument tuple.

    :type node_id: long
    :param node_id: **node_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.node_id', 'pybind.slxos.v17r_2_00.brocade_node', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.node_id', 'pybind.slxos.v17s_1_02.brocade_node', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.node_id.cluster', u'management'), ('pybind.slxos.v17r_2_00.node_id.cluster', u'management')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'node_id', 'keyval': 'node_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'principal_priority'}, {'leafval': 'principal_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, node_id=node_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, node_id=node_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def node_id_cluster_get(self, node_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type node_id: node_id
    :param node_id: Keyword argument tuple.

    :type node_id: long
    :param node_id: **node_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.node_id', 'node_id'), ('pybind.slxos.v17s_1_02.node_id', 'node_id')]
    bindings_list = [('pybind.slxos.v17r_2_00.node_id.cluster', 'pybind.slxos.v17r_2_00.brocade_node', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.node_id.cluster', 'pybind.slxos.v17s_1_02.brocade_node', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'node_id', 'extra_keyval': ''}, {'keyval': 'node_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, node_id=node_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, node_id=node_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def node_id_cluster_management_get(self, node_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type node_id: node_id
    :param node_id: Keyword argument tuple.

    :type node_id: long
    :param node_id: **node_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.node_id', 'node_id'), ('pybind.slxos.v17r_2_00.node_id', 'node_id')]
    bindings_list = [('pybind.slxos.v17r_2_00.node_id.cluster.management', 'pybind.slxos.v17r_2_00.brocade_node', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.node_id.cluster.management', 'pybind.slxos.v17s_1_02.brocade_node', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'node_id', 'extra_keyval': ''}, {'keyval': 'node_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, node_id=node_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, node_id=node_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def node_id_cluster_management_principal_priority_get(self, node_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type node_id: node_id
    :param node_id: Keyword argument tuple.

    :type node_id: long
    :param node_id: **node_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.node_id', 'node_id'), ('pybind.slxos.v17r_2_00.node_id', 'node_id')]
    bindings_list = [('pybind.slxos.v17r_2_00.node_id.cluster.management', 'pybind.slxos.v17r_2_00.brocade_node', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.node_id.cluster.management', 'pybind.slxos.v17s_1_02.brocade_node', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'node_id', 'extra_keyval': ''}, {'keyval': 'node_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, node_id=node_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, node_id=node_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def nsx_controller_get(self, nsx_controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type nsx_controller: name
    :param nsx_controller: Keyword argument tuple.

    :type name: unicode
    :param name: **nsx_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.nsx_controller', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.nsx_controller', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.nsx_controller', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.nsx_controller', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.nsx_controller', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.nsx_controller', u'connection_addr'), ('pybind.nos.v7_2_0.nsx_controller', u'connection_addr'), ('pybind.slxos.v17s_1_02.nsx_controller', u'connection_addr'), ('pybind.slxos.v17r_1_01a.nsx_controller', u'connection_addr'), ('pybind.nos.v6_0_2f.nsx_controller', u'connection_addr')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'nsx_controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'address, port, method'}, {'leafval': 'address, port, method'}, {'leafval': 'address, port, method'}, {'leafval': 'address, port, method'}, {'leafval': 'address, port, method'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsx_controller=nsx_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsx_controller=nsx_controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def nsx_controller_activate_get(self, nsx_controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type nsx_controller: name
    :param nsx_controller: Keyword argument tuple.

    :type name: unicode
    :param name: **nsx_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.nsx_controller', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.nsx_controller', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.nsx_controller', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.nsx_controller', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.nsx_controller', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.nsx_controller', u'connection_addr'), ('pybind.nos.v7_2_0.nsx_controller', u'connection_addr'), ('pybind.slxos.v17s_1_02.nsx_controller', u'connection_addr'), ('pybind.slxos.v17r_1_01a.nsx_controller', u'connection_addr'), ('pybind.nos.v6_0_2f.nsx_controller', u'connection_addr')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'nsx_controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'address, port, method'}, {'leafval': 'address, port, method'}, {'leafval': 'address, port, method'}, {'leafval': 'address, port, method'}, {'leafval': 'address, port, method'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsx_controller=nsx_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsx_controller=nsx_controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def nsx_controller_ip_get(self, nsx_controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type nsx_controller: name
    :param nsx_controller: Keyword argument tuple.

    :type name: unicode
    :param name: **nsx_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.nsx_controller', 'nsx_controller'), ('pybind.nos.v7_2_0.nsx_controller', 'nsx_controller'), ('pybind.slxos.v17r_2_00.nsx_controller', 'nsx_controller'), ('pybind.slxos.v17r_1_01a.nsx_controller', 'nsx_controller'), ('pybind.slxos.v17s_1_02.nsx_controller', 'nsx_controller')]
    bindings_list = [('pybind.nos.v6_0_2f.nsx_controller.connection_addr', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.nsx_controller.connection_addr', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.nsx_controller.connection_addr', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.nsx_controller.connection_addr', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.nsx_controller.connection_addr', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'address, port, method'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsx_controller=nsx_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsx_controller=nsx_controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def nsx_controller_ip_address_get(self, nsx_controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type nsx_controller: name
    :param nsx_controller: Keyword argument tuple.

    :type name: unicode
    :param name: **nsx_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.nsx_controller', 'nsx_controller'), ('pybind.nos.v7_2_0.nsx_controller', 'nsx_controller'), ('pybind.slxos.v17r_2_00.nsx_controller', 'nsx_controller'), ('pybind.slxos.v17r_1_01a.nsx_controller', 'nsx_controller'), ('pybind.slxos.v17s_1_02.nsx_controller', 'nsx_controller')]
    bindings_list = [('pybind.nos.v6_0_2f.nsx_controller.connection_addr', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.nsx_controller.connection_addr', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.nsx_controller.connection_addr', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.nsx_controller.connection_addr', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.nsx_controller.connection_addr', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsx_controller=nsx_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsx_controller=nsx_controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def nsx_controller_ip_method_get(self, nsx_controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type nsx_controller: name
    :param nsx_controller: Keyword argument tuple.

    :type name: unicode
    :param name: **nsx_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.nsx_controller', 'nsx_controller'), ('pybind.nos.v7_2_0.nsx_controller', 'nsx_controller'), ('pybind.slxos.v17r_2_00.nsx_controller', 'nsx_controller'), ('pybind.slxos.v17r_1_01a.nsx_controller', 'nsx_controller'), ('pybind.slxos.v17s_1_02.nsx_controller', 'nsx_controller')]
    bindings_list = [('pybind.nos.v6_0_2f.nsx_controller.connection_addr', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.nsx_controller.connection_addr', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.nsx_controller.connection_addr', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.nsx_controller.connection_addr', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.nsx_controller.connection_addr', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsx_controller=nsx_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsx_controller=nsx_controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def nsx_controller_ip_port_get(self, nsx_controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type nsx_controller: name
    :param nsx_controller: Keyword argument tuple.

    :type name: unicode
    :param name: **nsx_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.nsx_controller', 'nsx_controller'), ('pybind.nos.v7_2_0.nsx_controller', 'nsx_controller'), ('pybind.slxos.v17r_2_00.nsx_controller', 'nsx_controller'), ('pybind.slxos.v17r_1_01a.nsx_controller', 'nsx_controller'), ('pybind.slxos.v17s_1_02.nsx_controller', 'nsx_controller')]
    bindings_list = [('pybind.nos.v6_0_2f.nsx_controller.connection_addr', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.nsx_controller.connection_addr', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.nsx_controller.connection_addr', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.nsx_controller.connection_addr', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.nsx_controller.connection_addr', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsx_controller=nsx_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsx_controller=nsx_controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def nsx_controller_reconnect_interval_get(self, nsx_controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type nsx_controller: name
    :param nsx_controller: Keyword argument tuple.

    :type name: unicode
    :param name: **nsx_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.nsx_controller', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.nsx_controller', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.nsx_controller', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.nsx_controller', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.nsx_controller', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.nsx_controller', u'connection_addr'), ('pybind.nos.v7_2_0.nsx_controller', u'connection_addr'), ('pybind.slxos.v17s_1_02.nsx_controller', u'connection_addr'), ('pybind.slxos.v17r_1_01a.nsx_controller', u'connection_addr'), ('pybind.nos.v6_0_2f.nsx_controller', u'connection_addr')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'nsx_controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'address, port, method'}, {'leafval': 'address, port, method'}, {'leafval': 'address, port, method'}, {'leafval': 'address, port, method'}, {'leafval': 'address, port, method'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, nsx_controller=nsx_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, nsx_controller=nsx_controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ntp', 'pybind.nos.v6_0_2f.brocade_ntp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ntp', 'pybind.nos.v7_2_0.brocade_ntp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ntp', 'pybind.slxos.v17r_1_01a.brocade_ntp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ntp', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ntp', 'pybind.slxos.v17s_1_02.brocade_ntp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.ntp', u'server'), ('pybind.nos.v6_0_2f.ntp', u'authentication_key'), ('pybind.slxos.v17s_1_02.ntp', u'authentication_key'), ('pybind.slxos.v17s_1_02.ntp', u'server'), ('pybind.slxos.v17r_2_00.ntp', u'server'), ('pybind.slxos.v17r_2_00.ntp', u'disable'), ('pybind.slxos.v17r_2_00.ntp', u'authentication_key'), ('pybind.slxos.v17r_2_00.ntp', u'peer'), ('pybind.nos.v7_2_0.ntp', u'authentication_key'), ('pybind.nos.v7_2_0.ntp', u'server'), ('pybind.slxos.v17r_1_01a.ntp', u'server'), ('pybind.slxos.v17r_1_01a.ntp', u'authentication_key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip, key'}, {'leafval': 'keyid, md5, sha1, encryption_level'}, {'leafval': 'keyid, md5'}, {'leafval': 'ip, use_vrf'}, {'leafval': 'ip, use_vrf, key, version, minpoll, maxpoll'}, {'leafval': 'all, serve'}, {'leafval': 'keyid, md5'}, {'leafval': 'peer_ip, peer_use_vrf, peer_key, peer_version, peer_minpoll, peer_maxpoll'}, {'leafval': 'keyid, md5, sha1, encryption_level'}, {'leafval': 'ip, key, use_vrf'}, {'leafval': 'ip, use_vrf'}, {'leafval': 'keyid, md5'}]
    leafval_map = {"pybind.slxos.v17r_2_00.ntp": {}, "pybind.slxos.v17s_1_02.ntp": {"source_ip": "source_ip"}, "pybind.nos.v7_2_0.ntp": {"source_ip": "source_ip"}, "pybind.nos.v6_0_2f.ntp": {"source_ip": "source_ip"}, "pybind.slxos.v17r_1_01a.ntp": {"source_ip": "source_ip"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_authenticate_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.ntp', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ntp', u'server'), ('pybind.slxos.v17r_2_00.ntp', u'disable'), ('pybind.slxos.v17r_2_00.ntp', u'authentication_key'), ('pybind.slxos.v17r_2_00.ntp', u'peer')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip, use_vrf, key, version, minpoll, maxpoll'}, {'leafval': 'all, serve'}, {'leafval': 'keyid, md5'}, {'leafval': 'peer_ip, peer_use_vrf, peer_key, peer_version, peer_minpoll, peer_maxpoll'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_authentication_key_get(self, authentication_key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type authentication_key: keyid, md5, sha1, encryption_level
    :param authentication_key: Keyword argument tuple.

    :type keyid: long
    :param keyid: **authentication_key** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type md5: unicode
    :param md5: **authentication_key** tuple argument:  MD5 Encryption

        * length restriction: ::

            ['1 .. max']

    :type sha1: unicode
    :param sha1: **authentication_key** tuple argument:  SHA1 Encryption

        * length restriction: ::

            ['1 .. max']

    :type encryption_level: unicode
    :param encryption_level: **authentication_key** tuple argument:  Level of encryption of the md5 key (default=7)

        * enumeration restriction: ::

            ['0', '7']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ntp.authentication_key', 'pybind.nos.v6_0_2f.brocade_ntp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ntp.authentication_key', 'pybind.nos.v7_2_0.brocade_ntp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ntp.authentication_key', 'pybind.slxos.v17r_1_01a.brocade_ntp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ntp.authentication_key', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ntp.authentication_key', 'pybind.slxos.v17s_1_02.brocade_ntp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'authentication_key', 'keyval': 'keyid', 'extra_keyval': 'keyid, md5, sha1, encryption_level'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.ntp.authentication_key": {}, "pybind.nos.v7_2_0.ntp.authentication_key": {"encryption_level": "encryption_level", "sha1": "sha1", "keyid": "keyid", "md5": "md5"}, "pybind.slxos.v17r_1_01a.ntp.authentication_key": {}, "pybind.slxos.v17r_2_00.ntp.authentication_key": {}, "pybind.nos.v6_0_2f.ntp.authentication_key": {"encryption_level": "encryption_level", "sha1": "sha1", "keyid": "keyid", "md5": "md5"}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.ntp.authentication_key': [u'md5', u'sha1'], 'pybind.nos.v6_0_2f.ntp.authentication_key': [u'md5', u'sha1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, authentication_key=authentication_key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, authentication_key=authentication_key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_authentication_key_encryption_level_get(self, authentication_key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type authentication_key: keyid
    :param authentication_key: Keyword argument tuple.

    :type keyid: long
    :param keyid: **authentication_key** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ntp.authentication_key', 'pybind.nos.v6_0_2f.brocade_ntp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ntp.authentication_key', 'pybind.nos.v7_2_0.brocade_ntp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'authentication_key', 'keyval': 'keyid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, authentication_key=authentication_key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, authentication_key=authentication_key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_authentication_key_md5_get(self, authentication_key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type authentication_key: keyid
    :param authentication_key: Keyword argument tuple.

    :type keyid: long
    :param keyid: **authentication_key** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ntp.authentication_key', 'pybind.nos.v6_0_2f.brocade_ntp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ntp.authentication_key', 'pybind.nos.v7_2_0.brocade_ntp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ntp.authentication_key', 'pybind.slxos.v17r_1_01a.brocade_ntp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ntp.authentication_key', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ntp.authentication_key', 'pybind.slxos.v17s_1_02.brocade_ntp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'authentication_key', 'keyval': 'keyid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, authentication_key=authentication_key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, authentication_key=authentication_key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_authentication_key_sha1_get(self, authentication_key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type authentication_key: keyid
    :param authentication_key: Keyword argument tuple.

    :type keyid: long
    :param keyid: **authentication_key** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ntp.authentication_key', 'pybind.nos.v6_0_2f.brocade_ntp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ntp.authentication_key', 'pybind.nos.v7_2_0.brocade_ntp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'authentication_key', 'keyval': 'keyid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, authentication_key=authentication_key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, authentication_key=authentication_key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.ntp.disable', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_disable_all_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.ntp.disable', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_disable_serve_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.ntp.disable', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_master_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.ntp', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ntp', u'server'), ('pybind.slxos.v17r_2_00.ntp', u'disable'), ('pybind.slxos.v17r_2_00.ntp', u'authentication_key'), ('pybind.slxos.v17r_2_00.ntp', u'peer')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip, use_vrf, key, version, minpoll, maxpoll'}, {'leafval': 'all, serve'}, {'leafval': 'keyid, md5'}, {'leafval': 'peer_ip, peer_use_vrf, peer_key, peer_version, peer_minpoll, peer_maxpoll'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_peer_get(self, peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type peer: peer_ip, peer_use_vrf, peer_key, peer_version, peer_minpoll, peer_maxpoll
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  Peer IPV4/IPV6 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type peer_use_vrf: unicode
    :param peer_use_vrf: **peer** tuple argument:  VRF to use for synchronizing the time with server.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type peer_key: long
    :param peer_key: **peer** tuple argument:  NTP Key-id

        * range restriction: ::

            ['0..4294967295']

    :type peer_version: long
    :param peer_version: **peer** tuple argument:  NTP version supported.

        * range restriction: ::

            ['0..4294967295']

    :type peer_minpoll: long
    :param peer_minpoll: **peer** tuple argument:  Shortest polling interval.Argument is power of 2

        * range restriction: ::

            ['0..4294967295']

    :type peer_maxpoll: long
    :param peer_maxpoll: **peer** tuple argument:  Longest polling interval.Argument is power of 2

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.ntp.peer', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'peer', 'keyval': 'peer_ip', 'extra_keyval': 'peer_ip, peer_use_vrf, peer_key, peer_version, peer_minpoll, peer_maxpoll'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, peer=peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_peer_key_get(self, peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  Peer IPV4/IPV6 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.ntp.peer', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'peer', 'keyval': 'peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, peer=peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_peer_maxpoll_get(self, peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  Peer IPV4/IPV6 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.ntp.peer', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'peer', 'keyval': 'peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, peer=peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_peer_minpoll_get(self, peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  Peer IPV4/IPV6 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.ntp.peer', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'peer', 'keyval': 'peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, peer=peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_peer_use_vrf_get(self, peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  Peer IPV4/IPV6 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.ntp.peer', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'peer', 'keyval': 'peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, peer=peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_peer_version_get(self, peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type peer: peer_ip
    :param peer: Keyword argument tuple.

    :type peer_ip: unicode
    :param peer_ip: **peer** tuple argument:  Peer IPV4/IPV6 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.ntp.peer', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'peer', 'keyval': 'peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, peer=peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, peer=peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_server_get(self, server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type server: ip
    :param server: Keyword argument tuple.

    :type ip: unicode
    :param ip: **server** tuple argument:  Network Time Protocol server ip address(es)

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ntp.server', 'pybind.nos.v6_0_2f.brocade_ntp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ntp.server', 'pybind.nos.v7_2_0.brocade_ntp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ntp.server', 'pybind.slxos.v17r_1_01a.brocade_ntp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ntp.server', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ntp.server', 'pybind.slxos.v17s_1_02.brocade_ntp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.ntp.server', u'server_key'), ('pybind.slxos.v17s_1_02.ntp.server', u'server_key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'server', 'keyval': 'ip, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'key'}, {'leafval': 'key'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.ntp.server": {"ip": "ip"}, "pybind.nos.v6_0_2f.ntp.server": {"ip": "ip", "key": "key"}, "pybind.slxos.v17s_1_02.ntp.server": {"ip": "ip"}, "pybind.nos.v7_2_0.ntp.server": {}, "pybind.slxos.v17r_2_00.ntp.server": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server=server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server=server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_server_key_get(self, server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type server: ip
    :param server: Keyword argument tuple.

    :type ip: unicode
    :param ip: **server** tuple argument:  Network Time Protocol server ip address(es)

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ntp.server', u'server'), ('pybind.slxos.v17r_1_01a.ntp.server', u'server')]
    bindings_list = [('pybind.nos.v6_0_2f.ntp.server', 'pybind.nos.v6_0_2f.brocade_ntp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ntp.server', 'pybind.nos.v7_2_0.brocade_ntp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ntp.server.server_key', 'pybind.slxos.v17r_1_01a.brocade_ntp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ntp.server', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ntp.server.server_key', 'pybind.slxos.v17s_1_02.brocade_ntp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip, use_vrf', 'extra_keyval': ''}, {'keyval': 'ip, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'server', 'keyval': 'ip, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.ntp.server.server_key": {}, "pybind.nos.v6_0_2f.ntp.server": {"ip": "ip", "key": "key"}, "pybind.slxos.v17r_2_00.ntp.server": {"ip": "ip", "key": "key"}, "pybind.nos.v7_2_0.ntp.server": {}, "pybind.slxos.v17r_1_01a.ntp.server.server_key": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server=server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server=server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_server_maxpoll_get(self, server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type server: ip
    :param server: Keyword argument tuple.

    :type ip: unicode
    :param ip: **server** tuple argument:  Network Time Protocol server IPV4/IPV6 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.ntp.server', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'server', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server=server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server=server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_server_minpoll_get(self, server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type server: ip
    :param server: Keyword argument tuple.

    :type ip: unicode
    :param ip: **server** tuple argument:  Network Time Protocol server IPV4/IPV6 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.ntp.server', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'server', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server=server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server=server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_server_use_vrf_get(self, server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type server: ip
    :param server: Keyword argument tuple.

    :type ip: unicode
    :param ip: **server** tuple argument:  Network Time Protocol server IPV4/IPV6 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.ntp.server', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'server', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server=server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server=server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_server_version_get(self, server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type server: ip
    :param server: Keyword argument tuple.

    :type ip: unicode
    :param ip: **server** tuple argument:  Network Time Protocol server IPV4/IPV6 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.ntp.server', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'server', 'keyval': 'ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server=server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server=server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ntp_source_ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ntp', 'pybind.nos.v6_0_2f.brocade_ntp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ntp', 'pybind.nos.v7_2_0.brocade_ntp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ntp', 'pybind.slxos.v17r_1_01a.brocade_ntp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ntp', 'pybind.slxos.v17r_2_00.brocade_ntp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ntp', 'pybind.slxos.v17s_1_02.brocade_ntp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.ntp', u'server'), ('pybind.nos.v6_0_2f.ntp', u'authentication_key'), ('pybind.slxos.v17s_1_02.ntp', u'authentication_key'), ('pybind.slxos.v17s_1_02.ntp', u'server'), ('pybind.slxos.v17r_2_00.ntp', u'server'), ('pybind.slxos.v17r_2_00.ntp', u'disable'), ('pybind.slxos.v17r_2_00.ntp', u'authentication_key'), ('pybind.slxos.v17r_2_00.ntp', u'peer'), ('pybind.nos.v7_2_0.ntp', u'authentication_key'), ('pybind.nos.v7_2_0.ntp', u'server'), ('pybind.slxos.v17r_1_01a.ntp', u'server'), ('pybind.slxos.v17r_1_01a.ntp', u'authentication_key')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip, key'}, {'leafval': 'keyid, md5, sha1, encryption_level'}, {'leafval': 'keyid, md5'}, {'leafval': 'ip, use_vrf'}, {'leafval': 'ip, use_vrf, key, version, minpoll, maxpoll'}, {'leafval': 'all, serve'}, {'leafval': 'keyid, md5'}, {'leafval': 'peer_ip, peer_use_vrf, peer_key, peer_version, peer_minpoll, peer_maxpoll'}, {'leafval': 'keyid, md5, sha1, encryption_level'}, {'leafval': 'ip, key, use_vrf'}, {'leafval': 'ip, use_vrf'}, {'leafval': 'keyid, md5'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_global.openflow', 'pybind.slxos.v17s_1_02.brocade_openflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_global.openflow.mirror.destination', u'mirror_interface'), ('pybind.slxos.v17r_2_00.openflow_global.openflow', u'default_behavior'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.ingress_replication', u'group_id_range'), ('pybind.slxos.v17r_2_00.openflow_global.openflow', u'enable'), ('pybind.slxos.v17r_2_00.openflow_global.openflow', u'controller'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.mirror.destination', u'mirror_interface'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow', u'default_behavior'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow', u'controller'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.ingress_replication', u'group_id_range'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow', u'enable'), ('pybind.slxos.v17s_1_02.openflow_global.openflow', u'controller'), ('pybind.slxos.v17s_1_02.openflow_global.openflow', u'default_behavior'), ('pybind.slxos.v17s_1_02.openflow_global.openflow', u'enable')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_value'}, {'leafval': 'send_to_controller'}, {'leafval': 'min_group_id, max_group_id'}, {'leafval': 'ofVerType'}, {'leafval': 'controller_name'}, {'leafval': 'interface_type, interface_value'}, {'leafval': 'send_to_controller'}, {'leafval': 'controller_name'}, {'leafval': 'min_group_id, max_group_id'}, {'leafval': 'ofVerType'}, {'leafval': 'controller_name'}, {'leafval': 'send_to_controller'}, {'leafval': 'ofVerType'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_controller_get(self, openflow_controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type openflow_controller: controller_name
    :param openflow_controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **openflow_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.openflow_controller', 'pybind.nos.v6_0_2f.brocade_openflow', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.openflow_controller', 'pybind.nos.v7_2_0.brocade_openflow', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.controller', 'pybind.slxos.v17s_1_02.brocade_openflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller', u'passive'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller', u'active_controller'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller', u'active_controller'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller', u'passive'), ('pybind.nos.v7_2_0.openflow_controller', u'connection_address'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.controller', u'passive'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.controller', u'active_controller'), ('pybind.nos.v6_0_2f.openflow_controller', u'connection_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'openflow_controller', 'keyval': 'controller_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'passive_connection_method, passive_controller_address, passive_connection_port, passive_controller_vrf'}, {'leafval': 'controller_address, connection_method, connection_port, active_controller_vrf'}, {'leafval': 'controller_address, connection_method, connection_port, active_controller_vrf'}, {'leafval': 'passive_connection_method, passive_controller_address, passive_connection_port, passive_controller_vrf'}, {'leafval': 'controller_address, connection_method, connection_port, active_controller_vrf'}, {'leafval': 'passive_connection_method, passive_controller_address, passive_connection_port, passive_controller_vrf'}, {'leafval': 'controller_address, connection_method, connection_port, active_controller_vrf'}, {'leafval': 'controller_address, connection_method, connection_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, openflow_controller=openflow_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, openflow_controller=openflow_controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_controller_connection_method_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.controller', u'controller')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller.active_controller', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller.active_controller', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.controller.active_controller', 'pybind.slxos.v17s_1_02.brocade_openflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_controller_ip_get(self, openflow_controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type openflow_controller: controller_name
    :param openflow_controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **openflow_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.openflow_controller', 'openflow_controller'), ('pybind.nos.v6_0_2f.openflow_controller', 'openflow_controller')]
    bindings_list = [('pybind.nos.v6_0_2f.openflow_controller.connection_address', 'pybind.nos.v6_0_2f.brocade_openflow', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.openflow_controller.connection_address', 'pybind.nos.v7_2_0.brocade_openflow', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': ''}, {'keyval': 'controller_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'controller_address, connection_method, connection_port'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.openflow_controller.connection_address": {}, "pybind.nos.v6_0_2f.openflow_controller.connection_address": {"connection_method": "connection_method", "controller_address": "controller_address", "connection_port": "connection_port"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, openflow_controller=openflow_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, openflow_controller=openflow_controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_controller_ip_address_get(self, openflow_controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type openflow_controller: controller_name
    :param openflow_controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **openflow_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.openflow_controller', 'openflow_controller'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.controller', u'controller'), ('pybind.nos.v6_0_2f.openflow_controller', 'openflow_controller')]
    bindings_list = [('pybind.nos.v6_0_2f.openflow_controller.connection_address', 'pybind.nos.v6_0_2f.brocade_openflow', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.openflow_controller.connection_address', 'pybind.nos.v7_2_0.brocade_openflow', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller.active_controller', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller.active_controller', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.controller.active_controller', 'pybind.slxos.v17s_1_02.brocade_openflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': ''}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, openflow_controller=openflow_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, openflow_controller=openflow_controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_controller_ip_method_get(self, openflow_controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type openflow_controller: controller_name
    :param openflow_controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **openflow_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.openflow_controller', 'openflow_controller'), ('pybind.nos.v6_0_2f.openflow_controller', 'openflow_controller')]
    bindings_list = [('pybind.nos.v6_0_2f.openflow_controller.connection_address', 'pybind.nos.v6_0_2f.brocade_openflow', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.openflow_controller.connection_address', 'pybind.nos.v7_2_0.brocade_openflow', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': ''}, {'keyval': 'controller_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, openflow_controller=openflow_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, openflow_controller=openflow_controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_controller_ip_port_get(self, openflow_controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type openflow_controller: controller_name
    :param openflow_controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **openflow_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.openflow_controller', 'openflow_controller'), ('pybind.nos.v6_0_2f.openflow_controller', 'openflow_controller')]
    bindings_list = [('pybind.nos.v6_0_2f.openflow_controller.connection_address', 'pybind.nos.v6_0_2f.brocade_openflow', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.openflow_controller.connection_address', 'pybind.nos.v7_2_0.brocade_openflow', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': ''}, {'keyval': 'controller_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, openflow_controller=openflow_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, openflow_controller=openflow_controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_controller_ip_use_vrf_get(self, openflow_controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type openflow_controller: controller_name
    :param openflow_controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **openflow_controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.openflow_controller', 'openflow_controller')]
    bindings_list = [('pybind.nos.v7_2_0.openflow_controller.connection_address', 'pybind.nos.v7_2_0.brocade_openflow', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, openflow_controller=openflow_controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, openflow_controller=openflow_controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_controller_passive_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller', u'controller')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller.passive', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller.passive', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.controller.passive', 'pybind.slxos.v17s_1_02.brocade_openflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'passive_connection_method, passive_controller_address, passive_connection_port, passive_controller_vrf'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_controller_passive_ip_address_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller', u'controller')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller.passive', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller.passive', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.controller.passive', 'pybind.slxos.v17s_1_02.brocade_openflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_controller_passive_passive_connection_method_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller', u'controller')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller.passive', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller.passive', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.controller.passive', 'pybind.slxos.v17s_1_02.brocade_openflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_controller_passive_port_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller', u'controller')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller.passive', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller.passive', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.controller.passive', 'pybind.slxos.v17s_1_02.brocade_openflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_controller_passive_use_vrf_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller', u'controller')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller.passive', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller.passive', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.controller.passive', 'pybind.slxos.v17s_1_02.brocade_openflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_controller_port_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.controller', u'controller')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller.active_controller', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller.active_controller', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.controller.active_controller', 'pybind.slxos.v17s_1_02.brocade_openflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_controller_use_vrf_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller', u'controller'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.controller', u'controller')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.controller.active_controller', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.controller.active_controller', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.controller.active_controller', 'pybind.slxos.v17s_1_02.brocade_openflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}, {'keyval': 'controller_name', 'extra_keyval': 'controller_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_default_behavior_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.default_behavior', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.default_behavior', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.default_behavior', 'pybind.slxos.v17s_1_02.brocade_openflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_default_behavior_send_to_controller_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.default_behavior', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.default_behavior', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.default_behavior', 'pybind.slxos.v17s_1_02.brocade_openflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.enable', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.enable', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.enable', 'pybind.slxos.v17s_1_02.brocade_openflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_enable_ofvertype_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.enable', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.enable', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_global.openflow.enable', 'pybind.slxos.v17s_1_02.brocade_openflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_global_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_global', 'pybind.slxos.v17s_1_02.brocade_openflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_global.openflow.mirror.destination', u'mirror_interface'), ('pybind.slxos.v17r_2_00.openflow_global.openflow', u'default_behavior'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.ingress_replication', u'group_id_range'), ('pybind.slxos.v17r_2_00.openflow_global.openflow', u'enable'), ('pybind.slxos.v17r_2_00.openflow_global.openflow', u'controller'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.mirror.destination', u'mirror_interface'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow', u'default_behavior'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow', u'controller'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.ingress_replication', u'group_id_range'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow', u'enable'), ('pybind.slxos.v17s_1_02.openflow_global.openflow', u'controller'), ('pybind.slxos.v17s_1_02.openflow_global.openflow', u'default_behavior'), ('pybind.slxos.v17s_1_02.openflow_global.openflow', u'enable')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_value'}, {'leafval': 'send_to_controller'}, {'leafval': 'min_group_id, max_group_id'}, {'leafval': 'ofVerType'}, {'leafval': 'controller_name'}, {'leafval': 'interface_type, interface_value'}, {'leafval': 'send_to_controller'}, {'leafval': 'controller_name'}, {'leafval': 'min_group_id, max_group_id'}, {'leafval': 'ofVerType'}, {'leafval': 'controller_name'}, {'leafval': 'send_to_controller'}, {'leafval': 'ofVerType'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_ingress_replication_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.ingress_replication', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.ingress_replication', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_global.openflow.ingress_replication', u'group_id_range'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.ingress_replication', u'group_id_range')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'min_group_id, max_group_id'}, {'leafval': 'min_group_id, max_group_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_ingress_replication_group_id_range_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.ingress_replication.group_id_range', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.ingress_replication.group_id_range', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'min_group_id, max_group_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_ingress_replication_group_id_range_max_group_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.ingress_replication.group_id_range', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.ingress_replication.group_id_range', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_ingress_replication_group_id_range_min_group_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.ingress_replication.group_id_range', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.ingress_replication.group_id_range', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_mirror_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.mirror', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.mirror', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_global.openflow.mirror.destination', u'mirror_interface'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.mirror.destination', u'mirror_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_value'}, {'leafval': 'interface_type, interface_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_mirror_destination_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.mirror.destination', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.mirror.destination', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_global.openflow.mirror.destination', u'mirror_interface'), ('pybind.slxos.v17r_1_01a.openflow_global.openflow.mirror.destination', u'mirror_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_value'}, {'leafval': 'interface_type, interface_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_mirror_destination_mirror_interface_get(self, mirror_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mirror_interface: interface_type, interface_value
    :param mirror_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mirror_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet']

    :type interface_value: unicode
    :param interface_value: **mirror_interface** tuple argument.

        * pattern restriction: ::

            '(((([0-9]|1[0-6])/([1-9]|[1-9][0-9])(:[1-4])?)|('
            '[1-9]|[1-9][0-9]|[1-4][0-9][0-9]|50[0-9]|51[0-2]'
            ')))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_global.openflow.mirror.destination.mirror_interface', 'pybind.slxos.v17r_1_01a.brocade_openflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_global.openflow.mirror.destination.mirror_interface', 'pybind.slxos.v17r_2_00.brocade_openflow', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mirror_interface', 'keyval': 'interface_type, interface_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mirror_interface=mirror_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mirror_interface=mirror_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.meter', u'meter_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17s_1_02.openflow_state.queues_interface', u'queue_info_list'), ('pybind.slxos.v17s_1_02.openflow_state', u'group_id'), ('pybind.slxos.v17s_1_02.openflow_state', u'meter'), ('pybind.slxos.v17s_1_02.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17s_1_02.openflow_state', u'queues_interface'), ('pybind.slxos.v17s_1_02.openflow_state', u'meter_id'), ('pybind.slxos.v17s_1_02.openflow_state', u'flow'), ('pybind.slxos.v17s_1_02.openflow_state.resources', u'group_resouces_list'), ('pybind.slxos.v17s_1_02.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17s_1_02.openflow_state', u'group'), ('pybind.slxos.v17s_1_02.openflow_state', u'detail'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17s_1_02.openflow_state', u'interface'), ('pybind.slxos.v17s_1_02.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state', u'flow_interface'), ('pybind.slxos.v17s_1_02.openflow_state', u'flow_id'), ('pybind.slxos.v17s_1_02.openflow_state', u'controller'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state', u'resources'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state', u'detail'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state', u'meter_id'), ('pybind.slxos.v17r_1_01a.openflow_state', u'interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state', u'flow_id'), ('pybind.slxos.v17r_1_01a.openflow_state.meter', u'meter_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state', u'controller'), ('pybind.slxos.v17r_1_01a.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.queues_interface', u'queue_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state', u'group_id'), ('pybind.slxos.v17r_1_01a.openflow_state', u'queues_interface'), ('pybind.slxos.v17r_1_01a.openflow_state', u'meter'), ('pybind.slxos.v17r_1_01a.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state', u'group'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_1_01a.openflow_state', u'flow'), ('pybind.slxos.v17r_1_01a.openflow_state', u'resources'), ('pybind.slxos.v17r_1_01a.openflow_state', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources', u'group_resouces_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_2_00.openflow_state', u'resources'), ('pybind.slxos.v17r_2_00.openflow_state', u'meter_id'), ('pybind.slxos.v17r_2_00.openflow_state', u'detail'), ('pybind.slxos.v17r_2_00.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17r_2_00.openflow_state', u'interface'), ('pybind.slxos.v17r_2_00.openflow_state', u'meter'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state', u'group_id'), ('pybind.slxos.v17r_2_00.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17r_2_00.openflow_state', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state', u'controller'), ('pybind.slxos.v17r_2_00.openflow_state', u'flow_id'), ('pybind.slxos.v17r_2_00.openflow_state', u'group'), ('pybind.slxos.v17r_2_00.openflow_state.resources', u'group_resouces_list'), ('pybind.slxos.v17r_2_00.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17r_2_00.openflow_state', u'flow'), ('pybind.slxos.v17r_2_00.openflow_state', u'queues_interface'), ('pybind.slxos.v17r_2_00.openflow_state.queues_interface', u'queue_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter', u'meter_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'meter_id, transaction_id, meterflags_type, flow_count, num_of_bands, in_packet_count, in_byte_count'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'interface, num, tx_packets, tx_bytes'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts'}, {'leafval': 'num_of_meters'}, {'leafval': 'slot_id, module'}, {'leafval': 'interface_value'}, {'leafval': 'meter_id, transaction_id, meterflags_type, flow_count, num_of_bands, in_packet_count, in_byte_count'}, {'leafval': 'data_packets_sent, data_bytes_sent, port_based_flows, hw_generic_flows, l2_interfaces, l3_interfaces, l23_interfaces'}, {'leafval': 'max_, used, free, group_type'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'max_groups, max_bkts_per_group, max_actions_per_bucket, total_groups_all, total_groups_select, total_groups_indirect, total_groups_fast_failover'}, {'leafval': 'admin_status, ssl_status, num_controllers, data_path, l2_match, l3_match, max_l2_flows, active_flows, enabled_ports, default_action'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'port, link, port_state, speed, mac, port_id, mode'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts'}, {'leafval': 'interface_type, interface_value'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'name, mode, type, connection_type, ip_addr, port, vrf_name, status, role'}, {'leafval': 'controller_idx'}, {'leafval': 'meter_max, meter_used, meter_free, tcam_profile'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'admin_status, ssl_status, num_controllers, data_path, l2_match, l3_match, max_l2_flows, active_flows, enabled_ports, enabled_lags, mirror_ports, min_group_id, max_group_id, default_action'}, {'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'meter_id, transaction_id, meterflags_type, flow_count, num_of_bands, in_packet_count, in_byte_count'}, {'leafval': 'port, link, port_state, speed, mac, port_id, mode'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'meter_id, transaction_id, meterflags_type, flow_count, num_of_bands, in_packet_count, in_byte_count'}, {'leafval': 'name, mode, type, connection_type, ip_addr, port, vrf_name, status, role'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'interface, num, tx_packets, tx_bytes'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'interface_value'}, {'leafval': 'num_of_meters'}, {'leafval': 'slot_id, module'}, {'leafval': 'max_groups, max_bkts_per_group, max_actions_per_bucket, total_groups_all, total_groups_select, total_groups_indirect, total_groups_fast_failover'}, {'leafval': 'controller_idx'}, {'leafval': 'data_packets_sent, data_bytes_sent, port_based_flows, hw_generic_flows, l2_interfaces, l3_interfaces, l23_interfaces, lag_interfaces'}, {'leafval': 'meter_max, meter_used, meter_free, tcam_profile'}, {'leafval': 'interface_type, interface_value'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'max_, used, free, group_type'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'meter_max, meter_used, meter_free, tcam_profile'}, {'leafval': 'meter_id, transaction_id, meterflags_type, flow_count, num_of_bands, in_packet_count, in_byte_count'}, {'leafval': 'admin_status, ssl_status, num_controllers, data_path, l2_match, l3_match, max_l2_flows, active_flows, enabled_ports, enabled_lags, mirror_ports, min_group_id, max_group_id, default_action'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'port, interface_type, interface_name, link, port_state, speed, mac, port_id, mode'}, {'leafval': 'num_of_meters'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'slot_id, module'}, {'leafval': 'interface_type, interface_value'}, {'leafval': 'name, mode, type, connection_type, ip_addr, port, vrf_name, status, role'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'max_groups, max_bkts_per_group, max_actions_per_bucket, total_groups_all, total_groups_select, total_groups_indirect, total_groups_fast_failover'}, {'leafval': 'max_, used, free, group_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'data_packets_sent, data_bytes_sent, port_based_flows, hw_generic_flows, l2_interfaces, l3_interfaces, l23_interfaces, lag_interfaces'}, {'leafval': 'interface_value'}, {'leafval': 'interface, num, tx_packets, tx_bytes'}, {'leafval': 'meter_id, transaction_id, meterflags_type, flow_count, num_of_bands, in_packet_count, in_byte_count'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_controller_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.controller', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.controller', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.controller', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_controller_connection_type_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.controller', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.controller', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.controller', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_controller_ip_addr_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.controller', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.controller', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.controller', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_controller_mode_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.controller', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.controller', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.controller', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_controller_port_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.controller', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.controller', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.controller', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_controller_role_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.controller', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.controller', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.controller', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_controller_status_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.controller', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.controller', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.controller', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_controller_type_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.controller', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.controller', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.controller', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_controller_vrf_name_get(self, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type controller: name
    :param controller: Keyword argument tuple.

    :type name: unicode
    :param name: **controller** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.controller', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.controller', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.controller', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'controller_detail_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}]
    leafval_map = {"pybind.slxos.v17s_1_02.openflow_state.detail": {}, "pybind.slxos.v17r_1_01a.openflow_state.detail": {"mirror_ports": "mirror_ports", "active_flows": "active_flows", "num_controllers": "num_controllers", "max_group_id": "max_group_id", "data_path": "data_path", "admin_status": "admin_status", "enabled_lags": "enabled_lags", "min_group_id": "min_group_id", "l3_match": "l3_match", "l2_match": "l2_match", "default_action": "default_action", "enabled_ports": "enabled_ports", "max_l2_flows": "max_l2_flows", "ssl_status": "ssl_status"}, "pybind.slxos.v17r_2_00.openflow_state.detail": {"mirror_ports": "mirror_ports", "active_flows": "active_flows", "num_controllers": "num_controllers", "max_group_id": "max_group_id", "data_path": "data_path", "admin_status": "admin_status", "enabled_lags": "enabled_lags", "min_group_id": "min_group_id", "l3_match": "l3_match", "l2_match": "l2_match", "default_action": "default_action", "enabled_ports": "enabled_ports", "max_l2_flows": "max_l2_flows", "ssl_status": "ssl_status"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_active_flows_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'hybrid_interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_admin_status_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'hybrid_interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_get(self, controller_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list', u'controller_async_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list', u'controller_info'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list', u'controller_async_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list', u'controller_info'), ('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list', u'controller_info'), ('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list', u'controller_async_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'controller_detail_list', 'keyval': 'controller_idx', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'async_type, config_data'}, {'leafval': 'name, mode, type, connection_type, ip_addr, port, vrf_name, status, role'}, {'leafval': 'async_type, config_data'}, {'leafval': 'name, mode, type, connection_type, ip_addr, port, vrf_name, status, role'}, {'leafval': 'name, mode, type, connection_type, ip_addr, port, vrf_name, status, role'}, {'leafval': 'async_type, config_data'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_async_list_get(self, controller_detail_list=None, controller_async_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type controller_async_list: async_type
    :param controller_async_list: Keyword argument tuple.

    :type async_type: unicode
    :param async_type: **controller_async_list** tuple argument.

        * enumeration restriction: ::

            ['dcm-async-invalid',
            'dcm-packet-in',
            'dcm-port-status',
            'dcm-flow-removed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list.controller_async_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list.controller_async_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list.controller_async_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'controller_async_list', 'keyval': 'async_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list, controller_async_list=controller_async_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list, controller_async_list=controller_async_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_async_list_config_data_get(self, controller_detail_list=None, controller_async_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type controller_async_list: async_type
    :param controller_async_list: Keyword argument tuple.

    :type async_type: unicode
    :param async_type: **controller_async_list** tuple argument.

        * enumeration restriction: ::

            ['dcm-async-invalid',
            'dcm-packet-in',
            'dcm-port-status',
            'dcm-flow-removed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list.controller_async_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list.controller_async_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list.controller_async_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'controller_async_list', 'keyval': 'async_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list, controller_async_list=controller_async_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list, controller_async_list=controller_async_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_get(self, controller_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_connection_type_get(self, controller_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_ip_addr_get(self, controller_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_mode_get(self, controller_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_name_get(self, controller_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_port_get(self, controller_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_role_get(self, controller_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_status_get(self, controller_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_type_get(self, controller_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_controller_detail_list_controller_info_vrf_name_get(self, controller_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type controller_detail_list: controller_idx
    :param controller_detail_list: Keyword argument tuple.

    :type controller_idx: long
    :param controller_idx: **controller_detail_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list', u'controller_detail_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail.controller_detail_list.controller_info', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}, {'keyval': 'controller_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, controller_detail_list=controller_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, controller_detail_list=controller_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_data_path_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'hybrid_interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_default_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'hybrid_interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_enabled_lags_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'hybrid_interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_enabled_ports_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'hybrid_interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_hybrid_interfaces_get(self, hybrid_interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type hybrid_interfaces: hybrid_interface
    :param hybrid_interfaces: Keyword argument tuple.

    :type hybrid_interface: unicode
    :param hybrid_interface: **hybrid_interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.hybrid_interfaces', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail.hybrid_interfaces', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail.hybrid_interfaces', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hybrid_interfaces', 'keyval': 'hybrid_interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hybrid_interfaces=hybrid_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hybrid_interfaces=hybrid_interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_hybrid_interfaces_protected_vlans_get(self, hybrid_interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type hybrid_interfaces: hybrid_interface
    :param hybrid_interfaces: Keyword argument tuple.

    :type hybrid_interface: unicode
    :param hybrid_interface: **hybrid_interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail.hybrid_interfaces', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail.hybrid_interfaces', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail.hybrid_interfaces', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'hybrid_interfaces', 'keyval': 'hybrid_interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, hybrid_interfaces=hybrid_interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, hybrid_interfaces=hybrid_interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_l2_match_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'hybrid_interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_l3_match_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'hybrid_interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_max_group_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'hybrid_interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_max_l2_flows_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'hybrid_interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_min_group_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'hybrid_interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_mirror_ports_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'hybrid_interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_num_controllers_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'hybrid_interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_detail_ssl_status_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.detail', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.detail', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17r_1_01a.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'hybrid_interfaces'), ('pybind.slxos.v17s_1_02.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'controller_detail_list'), ('pybind.slxos.v17r_2_00.openflow_state.detail', u'hybrid_interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}, {'leafval': 'controller_idx'}, {'leafval': 'controller_idx'}, {'leafval': 'hybrid_interface, protected_vlans'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow', u'flow_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.openflow_state.flow": {"port_based_flows": "port_based_flows", "l3_interfaces": "l3_interfaces", "data_bytes_sent": "data_bytes_sent", "hw_generic_flows": "hw_generic_flows", "l2_interfaces": "l2_interfaces", "l23_interfaces": "l23_interfaces", "lag_interfaces": "lag_interfaces", "data_packets_sent": "data_packets_sent"}, "pybind.slxos.v17r_2_00.openflow_state.flow": {"port_based_flows": "port_based_flows", "l3_interfaces": "l3_interfaces", "data_bytes_sent": "data_bytes_sent", "hw_generic_flows": "hw_generic_flows", "l2_interfaces": "l2_interfaces", "l23_interfaces": "l23_interfaces", "lag_interfaces": "lag_interfaces", "data_packets_sent": "data_packets_sent"}, "pybind.slxos.v17s_1_02.openflow_state.flow": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_data_bytes_sent_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow', u'flow_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_data_packets_sent_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow', u'flow_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {"pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list": {"ether_type": "ether_type", "destination_ipv6": "destination_ipv6", "total_bytes": "total_bytes", "ip_protocol_destination_port": "ip_protocol_destination_port", "action_data": "action_data", "ip_protocol_source_port": "ip_protocol_source_port", "priority": "priority", "total_packets": "total_packets", "source_ipv6": "source_ipv6", "flow_id": "flow_id", "destination_mac": "destination_mac", "in_port": "in_port", "status": "status", "destination_ip": "destination_ip", "ip_protocol": "ip_protocol", "source_mac": "source_mac", "nw_tos": "nw_tos", "meter_id": "meter_id", "instructions": "instructions", "in_vlan": "in_vlan", "source_ip": "source_ip", "source_ip_mask": "source_ip_mask", "destination_ip_mask": "destination_ip_mask", "vlan_upbits": "vlan_upbits"}, "pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list": {"ether_type": "ether_type", "destination_ipv6": "destination_ipv6", "total_bytes": "total_bytes", "ip_protocol_destination_port": "ip_protocol_destination_port", "action_data": "action_data", "ip_protocol_source_port": "ip_protocol_source_port", "priority": "priority", "total_packets": "total_packets", "source_ipv6": "source_ipv6", "flow_id": "flow_id", "destination_mac": "destination_mac", "in_port": "in_port", "status": "status", "destination_ip": "destination_ip", "ip_protocol": "ip_protocol", "source_mac": "source_mac", "nw_tos": "nw_tos", "meter_id": "meter_id", "instructions": "instructions", "in_vlan": "in_vlan", "source_ip": "source_ip", "source_ip_mask": "source_ip_mask", "destination_ip_mask": "destination_ip_mask", "vlan_upbits": "vlan_upbits"}, "pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_action_data_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_destination_ip_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_destination_ip_mask_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_destination_ipv6_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_destination_mac_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_ether_type_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_flow_action_list_get(self, flow_info_list=None, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_flow_action_list_action_vlan_upbits_get(self, flow_info_list=None, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_flow_action_list_group_id_get(self, flow_info_list=None, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_flow_action_list_out_ports_get(self, flow_info_list=None, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_flow_action_list_out_vlan_etype_get(self, flow_info_list=None, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_flow_action_list_out_vlan_tag_get(self, flow_info_list=None, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_flow_action_list_queue_id_get(self, flow_info_list=None, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_flow_action_list_vlan_id_get(self, flow_info_list=None, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_in_port_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_in_vlan_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_instructions_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_ip_protocol_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_ip_protocol_destination_port_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_ip_protocol_source_port_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_meter_id_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_nw_tos_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_priority_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_source_ip_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_source_ip_mask_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_source_ipv6_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_source_mac_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_status_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_total_bytes_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_total_packets_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_flow_info_list_vlan_upbits_get(self, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_hw_generic_flows_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow', u'flow_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {"pybind.slxos.v17s_1_02.openflow_state.flow_id": {}, "pybind.slxos.v17r_1_01a.openflow_state.flow_id": {"ether_type": "ether_type", "destination_ipv6": "destination_ipv6", "total_bytes": "total_bytes", "ip_protocol_destination_port": "ip_protocol_destination_port", "action_data": "action_data", "ip_protocol_source_port": "ip_protocol_source_port", "priority": "priority", "total_packets": "total_packets", "source_ipv6": "source_ipv6", "flow_id": "flow_id", "destination_mac": "destination_mac", "in_port": "in_port", "status": "status", "destination_ip": "destination_ip", "ip_protocol": "ip_protocol", "source_mac": "source_mac", "nw_tos": "nw_tos", "meter_id": "meter_id", "instructions": "instructions", "in_vlan": "in_vlan", "source_ip": "source_ip", "source_ip_mask": "source_ip_mask", "destination_ip_mask": "destination_ip_mask", "vlan_upbits": "vlan_upbits"}, "pybind.slxos.v17r_2_00.openflow_state.flow_id": {"ether_type": "ether_type", "destination_ipv6": "destination_ipv6", "total_bytes": "total_bytes", "ip_protocol_destination_port": "ip_protocol_destination_port", "action_data": "action_data", "ip_protocol_source_port": "ip_protocol_source_port", "priority": "priority", "total_packets": "total_packets", "source_ipv6": "source_ipv6", "flow_id": "flow_id", "destination_mac": "destination_mac", "in_port": "in_port", "status": "status", "destination_ip": "destination_ip", "ip_protocol": "ip_protocol", "source_mac": "source_mac", "nw_tos": "nw_tos", "meter_id": "meter_id", "instructions": "instructions", "in_vlan": "in_vlan", "source_ip": "source_ip", "source_ip_mask": "source_ip_mask", "destination_ip_mask": "destination_ip_mask", "vlan_upbits": "vlan_upbits"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_action_data_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_destination_ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_destination_ip_mask_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_destination_ipv6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_destination_mac_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_ether_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_flow_action_list_get(self, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_flow_action_list_action_vlan_upbits_get(self, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_flow_action_list_group_id_get(self, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_flow_action_list_out_ports_get(self, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_flow_action_list_out_vlan_etype_get(self, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_flow_action_list_out_vlan_tag_get(self, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_flow_action_list_queue_id_get(self, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_flow_action_list_vlan_id_get(self, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_flow_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_in_port_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_in_vlan_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_instructions_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_ip_protocol_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_ip_protocol_destination_port_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_ip_protocol_source_port_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_meter_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_nw_tos_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_priority_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_source_ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_source_ip_mask_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_source_ipv6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_source_mac_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_status_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_total_bytes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_total_packets_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_id_vlan_upbits_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_id', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_id', u'flow_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_get(self, flow_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'flow_interface', 'keyval': 'interface_type, interface_value', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {"pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list": {}, "pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list": {"ether_type": "ether_type", "destination_ipv6": "destination_ipv6", "total_bytes": "total_bytes", "ip_protocol_destination_port": "ip_protocol_destination_port", "action_data": "action_data", "ip_protocol_source_port": "ip_protocol_source_port", "priority": "priority", "total_packets": "total_packets", "source_ipv6": "source_ipv6", "flow_id": "flow_id", "destination_mac": "destination_mac", "in_port": "in_port", "status": "status", "destination_ip": "destination_ip", "ip_protocol": "ip_protocol", "source_mac": "source_mac", "nw_tos": "nw_tos", "meter_id": "meter_id", "instructions": "instructions", "in_vlan": "in_vlan", "source_ip": "source_ip", "source_ip_mask": "source_ip_mask", "destination_ip_mask": "destination_ip_mask", "vlan_upbits": "vlan_upbits"}, "pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list": {"ether_type": "ether_type", "destination_ipv6": "destination_ipv6", "total_bytes": "total_bytes", "ip_protocol_destination_port": "ip_protocol_destination_port", "action_data": "action_data", "ip_protocol_source_port": "ip_protocol_source_port", "priority": "priority", "total_packets": "total_packets", "source_ipv6": "source_ipv6", "flow_id": "flow_id", "destination_mac": "destination_mac", "in_port": "in_port", "status": "status", "destination_ip": "destination_ip", "ip_protocol": "ip_protocol", "source_mac": "source_mac", "nw_tos": "nw_tos", "meter_id": "meter_id", "instructions": "instructions", "in_vlan": "in_vlan", "source_ip": "source_ip", "source_ip_mask": "source_ip_mask", "destination_ip_mask": "destination_ip_mask", "vlan_upbits": "vlan_upbits"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_action_data_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_destination_ip_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_destination_ip_mask_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_destination_ipv6_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_destination_mac_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_ether_type_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_flow_action_list_get(self, flow_interface=None, flow_info_list=None, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_flow_action_list_action_vlan_upbits_get(self, flow_interface=None, flow_info_list=None, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_flow_action_list_group_id_get(self, flow_interface=None, flow_info_list=None, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_flow_action_list_out_ports_get(self, flow_interface=None, flow_info_list=None, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_flow_action_list_out_vlan_etype_get(self, flow_interface=None, flow_info_list=None, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_flow_action_list_out_vlan_tag_get(self, flow_interface=None, flow_info_list=None, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_flow_action_list_queue_id_get(self, flow_interface=None, flow_info_list=None, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_flow_action_list_vlan_id_get(self, flow_interface=None, flow_info_list=None, flow_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type flow_action_list: action_idx
    :param flow_action_list: Keyword argument tuple.

    :type action_idx: long
    :param action_idx: **flow_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list.flow_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'flow_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_action_list', 'keyval': 'action_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list, flow_action_list=flow_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_in_port_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_in_vlan_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_instructions_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_ip_protocol_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_ip_protocol_destination_port_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_ip_protocol_source_port_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_meter_id_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_nw_tos_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_priority_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_source_ip_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_source_ip_mask_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_source_ipv6_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_source_mac_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_status_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_total_bytes_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_total_packets_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_interface_flow_info_list_vlan_upbits_get(self, flow_interface=None, flow_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type flow_interface: interface_type, interface_value
    :param flow_interface: Keyword argument tuple.

    :type interface_type: long
    :param interface_type: **flow_interface** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type interface_value: unicode
    :param interface_value: **flow_interface** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type flow_info_list: flow_id
    :param flow_info_list: Keyword argument tuple.

    :type flow_id: long
    :param flow_id: **flow_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface', u'flow_interface'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface', u'flow_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow_interface.flow_info_list', u'flow_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow_interface.flow_info_list', u'flow_action_list')]
    compositions_keyval_list = [{'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'flow_info_list', 'keyval': 'flow_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_idx, group_id, queue_id, out_ports, vlan_id, action_vlan_upbits, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, flow_interface=flow_interface, flow_info_list=flow_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, flow_interface=flow_interface, flow_info_list=flow_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_l23_interfaces_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow', u'flow_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_l2_interfaces_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow', u'flow_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_l3_interfaces_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow', u'flow_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_lag_interfaces_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow', u'flow_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_flow_port_based_flows_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.flow', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.flow', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.flow', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.flow', u'flow_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.flow', u'flow_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}, {'leafval': 'flow_id, priority, status, in_port, in_vlan, source_mac, destination_mac, ether_type, ip_protocol, ip_protocol_source_port, ip_protocol_destination_port, source_ip, destination_ip, source_ipv6, destination_ipv6, instructions, action_data, meter_id, vlan_upbits, nw_tos, source_ip_mask, destination_ip_mask, total_packets, total_bytes'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.group', u'group_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_get(self, group_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_bucket_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_info_list', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {"pybind.slxos.v17r_2_00.openflow_state.group.group_info_list": {"byte_count": "byte_count", "replication_type": "replication_type", "packet_count": "packet_count", "transaction_id": "transaction_id", "flow_count": "flow_count", "num_of_bkts": "num_of_bkts", "group_id": "group_id", "mcast_group_id": "mcast_group_id", "group_type": "group_type"}, "pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list": {"byte_count": "byte_count", "replication_type": "replication_type", "packet_count": "packet_count", "transaction_id": "transaction_id", "flow_count": "flow_count", "num_of_bkts": "num_of_bkts", "group_id": "group_id", "mcast_group_id": "mcast_group_id", "group_type": "group_type"}, "pybind.slxos.v17s_1_02.openflow_state.group.group_info_list": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_byte_count_get(self, group_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_bucket_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_info_list', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_flow_count_get(self, group_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_bucket_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_info_list', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_group_bucket_list_get(self, group_info_list=None, group_bucket_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', u'group_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list.group_bucket_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list.group_bucket_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list.group_bucket_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list.group_bucket_list', u'group_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list.group_bucket_list', u'group_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list.group_bucket_list', u'group_action_list')]
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_bucket_list', 'keyval': 'bucket_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_group_bucket_list_group_action_list_get(self, group_info_list=None, group_bucket_list=None, group_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_group_bucket_list_group_action_list_out_port_get(self, group_info_list=None, group_bucket_list=None, group_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_group_bucket_list_group_action_list_out_vlan_etype_get(self, group_info_list=None, group_bucket_list=None, group_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_group_bucket_list_group_action_list_out_vlan_tag_get(self, group_info_list=None, group_bucket_list=None, group_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_group_bucket_list_group_action_list_vlan_id_get(self, group_info_list=None, group_bucket_list=None, group_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list.group_bucket_list.group_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_group_bucket_list_watch_port_get(self, group_info_list=None, group_bucket_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', u'group_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list.group_bucket_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list.group_bucket_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list.group_bucket_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list.group_bucket_list', u'group_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list.group_bucket_list', u'group_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list.group_bucket_list', u'group_action_list')]
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_bucket_list', 'keyval': 'bucket_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_group_bucket_list_weight_get(self, group_info_list=None, group_bucket_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', u'group_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list.group_bucket_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list.group_bucket_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list.group_bucket_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list.group_bucket_list', u'group_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list.group_bucket_list', u'group_action_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list.group_bucket_list', u'group_action_list')]
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_bucket_list', 'keyval': 'bucket_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list, group_bucket_list=group_bucket_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_group_type_get(self, group_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_bucket_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_info_list', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_mcast_group_id_get(self, group_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_info_list', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_num_of_bkts_get(self, group_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_bucket_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_info_list', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_packet_count_get(self, group_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_bucket_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_info_list', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_replication_type_get(self, group_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_info_list', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_group_info_list_transaction_id_get(self, group_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group_info_list: group_id
    :param group_info_list: Keyword argument tuple.

    :type group_id: long
    :param group_id: **group_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group.group_info_list', u'group_bucket_list'), ('pybind.slxos.v17s_1_02.openflow_state.group.group_info_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group.group_info_list', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_info_list', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_info_list=group_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_info_list=group_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {"pybind.slxos.v17s_1_02.openflow_state.group_id": {}, "pybind.slxos.v17r_2_00.openflow_state.group_id": {"byte_count": "byte_count", "replication_type": "replication_type", "packet_count": "packet_count", "transaction_id": "transaction_id", "flow_count": "flow_count", "num_of_bkts": "num_of_bkts", "group_id": "group_id", "mcast_group_id": "mcast_group_id", "group_type": "group_type"}, "pybind.slxos.v17r_1_01a.openflow_state.group_id": {"byte_count": "byte_count", "replication_type": "replication_type", "packet_count": "packet_count", "transaction_id": "transaction_id", "flow_count": "flow_count", "num_of_bkts": "num_of_bkts", "group_id": "group_id", "mcast_group_id": "mcast_group_id", "group_type": "group_type"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_byte_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_flow_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_group_bucket_list_get(self, group_bucket_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id.group_bucket_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id.group_bucket_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group_id.group_bucket_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.group_id.group_bucket_list', u'group_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id.group_bucket_list', u'group_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id.group_bucket_list', u'group_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_bucket_list', 'keyval': 'bucket_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_bucket_list=group_bucket_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_bucket_list=group_bucket_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_group_bucket_list_group_action_list_get(self, group_bucket_list=None, group_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.group_id.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_group_bucket_list_group_action_list_out_port_get(self, group_bucket_list=None, group_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.group_id.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_group_bucket_list_group_action_list_out_vlan_etype_get(self, group_bucket_list=None, group_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.group_id.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_group_bucket_list_group_action_list_out_vlan_tag_get(self, group_bucket_list=None, group_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.group_id.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_group_bucket_list_group_action_list_vlan_id_get(self, group_bucket_list=None, group_action_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type group_action_list: action_id
    :param group_action_list: Keyword argument tuple.

    :type action_id: long
    :param action_id: **group_action_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.group_id.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id.group_bucket_list', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id.group_bucket_list', u'group_bucket_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group_id.group_bucket_list.group_action_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}, {'keyval': 'bucket_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_action_list', 'keyval': 'action_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_bucket_list=group_bucket_list, group_action_list=group_action_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_group_bucket_list_watch_port_get(self, group_bucket_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id.group_bucket_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id.group_bucket_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group_id.group_bucket_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.group_id.group_bucket_list', u'group_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id.group_bucket_list', u'group_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id.group_bucket_list', u'group_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_bucket_list', 'keyval': 'bucket_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_bucket_list=group_bucket_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_bucket_list=group_bucket_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_group_bucket_list_weight_get(self, group_bucket_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group_bucket_list: bucket_id
    :param group_bucket_list: Keyword argument tuple.

    :type bucket_id: long
    :param bucket_id: **group_bucket_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id.group_bucket_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id.group_bucket_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group_id.group_bucket_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.group_id.group_bucket_list', u'group_action_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id.group_bucket_list', u'group_action_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id.group_bucket_list', u'group_action_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_bucket_list', 'keyval': 'bucket_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}, {'leafval': 'action_id, out_port, vlan_id, out_vlan_tag, out_vlan_etype'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_bucket_list=group_bucket_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_bucket_list=group_bucket_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_group_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_group_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_mcast_group_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_num_of_bkts_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_packet_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_replication_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_id_transaction_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group_id', u'group_bucket_list'), ('pybind.slxos.v17r_2_00.openflow_state.group_id', u'group_bucket_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}, {'leafval': 'bucket_id, weight, watch_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_max_actions_per_bucket_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.group', u'group_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_max_bkts_per_group_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.group', u'group_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_max_groups_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.group', u'group_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_total_groups_all_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.group', u'group_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_total_groups_fast_failover_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.group', u'group_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_total_groups_indirect_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.group', u'group_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_group_total_groups_select_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.group', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.group', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.group', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.group', u'group_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.group', u'group_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts, mcast_group_id, replication_type'}, {'leafval': 'group_id, transaction_id, group_type, packet_count, byte_count, flow_count, num_of_bkts'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_interface_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: port
    :param interface: Keyword argument tuple.

    :type port: unicode
    :param port: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.interface', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.interface', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.interface', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'port, interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.openflow_state.interface": {"port_id": "port_id", "port_state": "port_state", "mac": "mac", "link": "link", "mode": "mode", "speed": "speed", "port": "port"}, "pybind.slxos.v17r_1_01a.openflow_state.interface": {"port_id": "port_id", "port_state": "port_state", "mac": "mac", "link": "link", "mode": "mode", "speed": "speed", "port": "port"}, "pybind.slxos.v17r_2_00.openflow_state.interface": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_interface_link_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: port
    :param interface: Keyword argument tuple.

    :type port: unicode
    :param port: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.interface', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.interface', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.interface', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'port, interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.openflow_state.interface": {"link": "link", "port": "port"}, "pybind.slxos.v17r_1_01a.openflow_state.interface": {"link": "link", "port": "port"}, "pybind.slxos.v17r_2_00.openflow_state.interface": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_interface_mac_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: port
    :param interface: Keyword argument tuple.

    :type port: unicode
    :param port: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.interface', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.interface', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.interface', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'port, interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.openflow_state.interface": {"mac": "mac", "port": "port"}, "pybind.slxos.v17r_1_01a.openflow_state.interface": {"mac": "mac", "port": "port"}, "pybind.slxos.v17r_2_00.openflow_state.interface": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_interface_mode_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: port
    :param interface: Keyword argument tuple.

    :type port: unicode
    :param port: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.interface', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.interface', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.interface', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'port, interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.openflow_state.interface": {"mode": "mode", "port": "port"}, "pybind.slxos.v17r_1_01a.openflow_state.interface": {"mode": "mode", "port": "port"}, "pybind.slxos.v17r_2_00.openflow_state.interface": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_interface_port_id_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: port
    :param interface: Keyword argument tuple.

    :type port: unicode
    :param port: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.interface', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.interface', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.interface', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'port, interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.openflow_state.interface": {"port_id": "port_id", "port": "port"}, "pybind.slxos.v17r_1_01a.openflow_state.interface": {"port_id": "port_id", "port": "port"}, "pybind.slxos.v17r_2_00.openflow_state.interface": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_interface_port_state_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: port
    :param interface: Keyword argument tuple.

    :type port: unicode
    :param port: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.interface', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.interface', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.interface', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'port, interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.openflow_state.interface": {"port_state": "port_state", "port": "port"}, "pybind.slxos.v17r_1_01a.openflow_state.interface": {"port_state": "port_state", "port": "port"}, "pybind.slxos.v17r_2_00.openflow_state.interface": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_interface_speed_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: port
    :param interface: Keyword argument tuple.

    :type port: unicode
    :param port: **interface** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.interface', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.interface', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.interface', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'port, interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.openflow_state.interface": {"speed": "speed", "port": "port"}, "pybind.slxos.v17r_1_01a.openflow_state.interface": {"speed": "speed", "port": "port"}, "pybind.slxos.v17r_2_00.openflow_state.interface": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.meter', u'meter_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.meter', u'meter_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.meter', u'meter_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'meter_id, transaction_id, meterflags_type, flow_count, num_of_bands, in_packet_count, in_byte_count'}, {'leafval': 'meter_id, transaction_id, meterflags_type, flow_count, num_of_bands, in_packet_count, in_byte_count'}, {'leafval': 'meter_id, transaction_id, meterflags_type, flow_count, num_of_bands, in_packet_count, in_byte_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', u'meterband_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_id_flow_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', u'meterband_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_id_in_byte_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', u'meterband_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_id_in_packet_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', u'meterband_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_id_meter_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', u'meterband_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_id_meterband_info_list_get(self, meterband_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meterband_info_list=meterband_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_id_meterband_info_list_burst_size_get(self, meterband_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meterband_info_list=meterband_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_id_meterband_info_list_in_byte_band_count_get(self, meterband_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meterband_info_list=meterband_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_id_meterband_info_list_in_packet_band_count_get(self, meterband_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meterband_info_list=meterband_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_id_meterband_info_list_rate_get(self, meterband_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id.meterband_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meterband_info_list=meterband_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_id_meterflags_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', u'meterband_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_id_num_of_bands_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', u'meterband_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_id_transaction_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter_id', u'meterband_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.meter_id', u'meterband_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_meter_info_list_get(self, meter_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', u'meterband_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', u'meterband_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', u'meterband_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meter_info_list', 'keyval': 'meter_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_meter_info_list_flow_count_get(self, meter_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', u'meterband_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', u'meterband_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', u'meterband_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meter_info_list', 'keyval': 'meter_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_meter_info_list_in_byte_count_get(self, meter_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', u'meterband_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', u'meterband_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', u'meterband_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meter_info_list', 'keyval': 'meter_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_meter_info_list_in_packet_count_get(self, meter_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', u'meterband_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', u'meterband_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', u'meterband_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meter_info_list', 'keyval': 'meter_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_meter_info_list_meterband_info_list_get(self, meter_info_list=None, meterband_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', u'meter_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', u'meter_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', u'meter_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'meter_id', 'extra_keyval': ''}, {'keyval': 'meter_id', 'extra_keyval': ''}, {'keyval': 'meter_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_meter_info_list_meterband_info_list_burst_size_get(self, meter_info_list=None, meterband_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', u'meter_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', u'meter_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', u'meter_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'meter_id', 'extra_keyval': ''}, {'keyval': 'meter_id', 'extra_keyval': ''}, {'keyval': 'meter_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_meter_info_list_meterband_info_list_in_byte_band_count_get(self, meter_info_list=None, meterband_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', u'meter_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', u'meter_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', u'meter_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'meter_id', 'extra_keyval': ''}, {'keyval': 'meter_id', 'extra_keyval': ''}, {'keyval': 'meter_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_meter_info_list_meterband_info_list_in_packet_band_count_get(self, meter_info_list=None, meterband_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', u'meter_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', u'meter_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', u'meter_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'meter_id', 'extra_keyval': ''}, {'keyval': 'meter_id', 'extra_keyval': ''}, {'keyval': 'meter_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_meter_info_list_meterband_info_list_rate_get(self, meter_info_list=None, meterband_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type meterband_info_list: band_type
    :param meterband_info_list: Keyword argument tuple.

    :type band_type: long
    :param band_type: **meterband_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', u'meter_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', u'meter_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', u'meter_info_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list.meterband_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'meter_id', 'extra_keyval': ''}, {'keyval': 'meter_id', 'extra_keyval': ''}, {'keyval': 'meter_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'meterband_info_list', 'keyval': 'band_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list, meterband_info_list=meterband_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_meter_info_list_meterflags_type_get(self, meter_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', u'meterband_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', u'meterband_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', u'meterband_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meter_info_list', 'keyval': 'meter_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_meter_info_list_num_of_bands_get(self, meter_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', u'meterband_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', u'meterband_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', u'meterband_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meter_info_list', 'keyval': 'meter_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_meter_info_list_transaction_id_get(self, meter_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type meter_info_list: meter_id
    :param meter_info_list: Keyword argument tuple.

    :type meter_id: long
    :param meter_id: **meter_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.meter.meter_info_list', u'meterband_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.meter.meter_info_list', u'meterband_info_list'), ('pybind.slxos.v17r_2_00.openflow_state.meter.meter_info_list', u'meterband_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'meter_info_list', 'keyval': 'meter_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}, {'leafval': 'band_type, rate, burst_size, in_packet_band_count, in_byte_band_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, meter_info_list=meter_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, meter_info_list=meter_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_meter_num_of_meters_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.meter', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.meter', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.meter', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.meter', u'meter_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.meter', u'meter_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.meter', u'meter_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'meter_id, transaction_id, meterflags_type, flow_count, num_of_bands, in_packet_count, in_byte_count'}, {'leafval': 'meter_id, transaction_id, meterflags_type, flow_count, num_of_bands, in_packet_count, in_byte_count'}, {'leafval': 'meter_id, transaction_id, meterflags_type, flow_count, num_of_bands, in_packet_count, in_byte_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_queues_interface_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.queues_interface', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.queues_interface', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.queues_interface', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.queues_interface', u'queue_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.queues_interface', u'queue_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.queues_interface', u'queue_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface, num, tx_packets, tx_bytes'}, {'leafval': 'interface, num, tx_packets, tx_bytes'}, {'leafval': 'interface, num, tx_packets, tx_bytes'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_queues_interface_interface_value_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.queues_interface', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.queues_interface', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.queues_interface', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.queues_interface', u'queue_info_list'), ('pybind.slxos.v17s_1_02.openflow_state.queues_interface', u'queue_info_list'), ('pybind.slxos.v17r_1_01a.openflow_state.queues_interface', u'queue_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface, num, tx_packets, tx_bytes'}, {'leafval': 'interface, num, tx_packets, tx_bytes'}, {'leafval': 'interface, num, tx_packets, tx_bytes'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_queues_interface_queue_info_list_get(self, queue_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type queue_info_list: interface, num
    :param queue_info_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **queue_info_list** tuple argument.

    :type num: long
    :param num: **queue_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.queues_interface.queue_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.queues_interface.queue_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.queues_interface.queue_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue_info_list', 'keyval': 'interface, num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue_info_list=queue_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue_info_list=queue_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_queues_interface_queue_info_list_tx_bytes_get(self, queue_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type queue_info_list: interface, num
    :param queue_info_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **queue_info_list** tuple argument.

    :type num: long
    :param num: **queue_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.queues_interface.queue_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.queues_interface.queue_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.queues_interface.queue_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue_info_list', 'keyval': 'interface, num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue_info_list=queue_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue_info_list=queue_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_queues_interface_queue_info_list_tx_packets_get(self, queue_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type queue_info_list: interface, num
    :param queue_info_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **queue_info_list** tuple argument.

    :type num: long
    :param num: **queue_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.queues_interface.queue_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.queues_interface.queue_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.queues_interface.queue_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue_info_list', 'keyval': 'interface, num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue_info_list=queue_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue_info_list=queue_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources', u'group_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources', u'group_resouces_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources', u'group_resouces_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'slot_id, module'}, {'leafval': 'max_, used, free, group_type'}, {'leafval': 'slot_id, module'}, {'leafval': 'max_, used, free, group_type'}, {'leafval': 'slot_id, module'}, {'leafval': 'max_, used, free, group_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_group_resouces_list_get(self, group_resouces_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group_resouces_list: group_type
    :param group_resouces_list: Keyword argument tuple.

    :type group_type: unicode
    :param group_type: **group_resouces_list** tuple argument.

        * enumeration restriction: ::

            ['dcm-group-type-all',
            'dcm-group-type-select',
            'dcm-group-type-invalid',
            'dcm-group-type-indirect',
            'dcm-group-type-fast-failover']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.group_resouces_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources.group_resouces_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources.group_resouces_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_resouces_list', 'keyval': 'group_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_resouces_list=group_resouces_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_resouces_list=group_resouces_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_group_resouces_list_free_get(self, group_resouces_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group_resouces_list: group_type
    :param group_resouces_list: Keyword argument tuple.

    :type group_type: unicode
    :param group_type: **group_resouces_list** tuple argument.

        * enumeration restriction: ::

            ['dcm-group-type-all',
            'dcm-group-type-select',
            'dcm-group-type-invalid',
            'dcm-group-type-indirect',
            'dcm-group-type-fast-failover']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.group_resouces_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources.group_resouces_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources.group_resouces_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_resouces_list', 'keyval': 'group_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_resouces_list=group_resouces_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_resouces_list=group_resouces_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_group_resouces_list_max_get(self, group_resouces_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group_resouces_list: group_type
    :param group_resouces_list: Keyword argument tuple.

    :type group_type: unicode
    :param group_type: **group_resouces_list** tuple argument.

        * enumeration restriction: ::

            ['dcm-group-type-all',
            'dcm-group-type-select',
            'dcm-group-type-invalid',
            'dcm-group-type-indirect',
            'dcm-group-type-fast-failover']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.group_resouces_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources.group_resouces_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources.group_resouces_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_resouces_list', 'keyval': 'group_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_resouces_list=group_resouces_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_resouces_list=group_resouces_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_group_resouces_list_used_get(self, group_resouces_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group_resouces_list: group_type
    :param group_resouces_list: Keyword argument tuple.

    :type group_type: unicode
    :param group_type: **group_resouces_list** tuple argument.

        * enumeration restriction: ::

            ['dcm-group-type-all',
            'dcm-group-type-select',
            'dcm-group-type-invalid',
            'dcm-group-type-indirect',
            'dcm-group-type-fast-failover']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.group_resouces_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources.group_resouces_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources.group_resouces_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group_resouces_list', 'keyval': 'group_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group_resouces_list=group_resouces_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group_resouces_list=group_resouces_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_meter_free_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources', u'group_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources', u'group_resouces_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources', u'group_resouces_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'slot_id, module'}, {'leafval': 'max_, used, free, group_type'}, {'leafval': 'slot_id, module'}, {'leafval': 'max_, used, free, group_type'}, {'leafval': 'slot_id, module'}, {'leafval': 'max_, used, free, group_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_meter_max_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources', u'group_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources', u'group_resouces_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources', u'group_resouces_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'slot_id, module'}, {'leafval': 'max_, used, free, group_type'}, {'leafval': 'slot_id, module'}, {'leafval': 'max_, used, free, group_type'}, {'leafval': 'slot_id, module'}, {'leafval': 'max_, used, free, group_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_meter_used_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources', u'group_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources', u'group_resouces_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources', u'group_resouces_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'slot_id, module'}, {'leafval': 'max_, used, free, group_type'}, {'leafval': 'slot_id, module'}, {'leafval': 'max_, used, free, group_type'}, {'leafval': 'slot_id, module'}, {'leafval': 'max_, used, free, group_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_get(self, slot_resouces_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list', u'slot_match_profile_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list', u'slot_match_profile_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list', u'slot_match_profile_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slot_resouces_list', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'slot_match_profile_idx, max_flows, used_flows, free_flows'}, {'leafval': 'slot_match_profile_idx, max_flows, used_flows, free_flows'}, {'leafval': 'slot_match_profile_idx, max_flows, used_flows, free_flows'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_module_get(self, slot_resouces_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list', u'slot_match_profile_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list', u'slot_match_profile_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list', u'slot_match_profile_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slot_resouces_list', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'slot_match_profile_idx, max_flows, used_flows, free_flows'}, {'leafval': 'slot_match_profile_idx, max_flows, used_flows, free_flows'}, {'leafval': 'slot_match_profile_idx, max_flows, used_flows, free_flows'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_slot_match_profile_list_get(self, slot_resouces_list=None, slot_match_profile_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slot_match_profile_list: slot_match_profile_idx
    :param slot_match_profile_list: Keyword argument tuple.

    :type slot_match_profile_idx: long
    :param slot_match_profile_idx: **slot_match_profile_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list', u'slot_resouces_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list.slot_match_profile_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list.slot_match_profile_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list.slot_match_profile_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_chip_resource_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_chip_resource_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_chip_resource_list')]
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slot_match_profile_list', 'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'slot_chip_idx, max_flows, used_flows, free_flows'}, {'leafval': 'slot_chip_idx, max_flows, used_flows, free_flows'}, {'leafval': 'slot_chip_idx, max_flows, used_flows, free_flows'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_slot_match_profile_list_free_flows_get(self, slot_resouces_list=None, slot_match_profile_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slot_match_profile_list: slot_match_profile_idx
    :param slot_match_profile_list: Keyword argument tuple.

    :type slot_match_profile_idx: long
    :param slot_match_profile_idx: **slot_match_profile_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list', u'slot_resouces_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list.slot_match_profile_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list.slot_match_profile_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list.slot_match_profile_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_chip_resource_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_chip_resource_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_chip_resource_list')]
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slot_match_profile_list', 'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'slot_chip_idx, max_flows, used_flows, free_flows'}, {'leafval': 'slot_chip_idx, max_flows, used_flows, free_flows'}, {'leafval': 'slot_chip_idx, max_flows, used_flows, free_flows'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_slot_match_profile_list_max_flows_get(self, slot_resouces_list=None, slot_match_profile_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slot_match_profile_list: slot_match_profile_idx
    :param slot_match_profile_list: Keyword argument tuple.

    :type slot_match_profile_idx: long
    :param slot_match_profile_idx: **slot_match_profile_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list', u'slot_resouces_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list.slot_match_profile_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list.slot_match_profile_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list.slot_match_profile_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_chip_resource_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_chip_resource_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_chip_resource_list')]
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slot_match_profile_list', 'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'slot_chip_idx, max_flows, used_flows, free_flows'}, {'leafval': 'slot_chip_idx, max_flows, used_flows, free_flows'}, {'leafval': 'slot_chip_idx, max_flows, used_flows, free_flows'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_slot_match_profile_list_slot_chip_resource_list_get(self, slot_resouces_list=None, slot_match_profile_list=None, slot_chip_resource_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type slot_match_profile_list: slot_match_profile_idx
    :param slot_match_profile_list: Keyword argument tuple.

    :type slot_match_profile_idx: long
    :param slot_match_profile_idx: **slot_match_profile_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slot_chip_resource_list: slot_chip_idx
    :param slot_chip_resource_list: Keyword argument tuple.

    :type slot_chip_idx: long
    :param slot_chip_idx: **slot_chip_resource_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_match_profile_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_match_profile_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_match_profile_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list.slot_match_profile_list.slot_chip_resource_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list.slot_match_profile_list.slot_chip_resource_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list.slot_match_profile_list.slot_chip_resource_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slot_chip_resource_list', 'keyval': 'slot_chip_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list, slot_chip_resource_list=slot_chip_resource_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list, slot_chip_resource_list=slot_chip_resource_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_slot_match_profile_list_slot_chip_resource_list_free_flows_get(self, slot_resouces_list=None, slot_match_profile_list=None, slot_chip_resource_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type slot_match_profile_list: slot_match_profile_idx
    :param slot_match_profile_list: Keyword argument tuple.

    :type slot_match_profile_idx: long
    :param slot_match_profile_idx: **slot_match_profile_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slot_chip_resource_list: slot_chip_idx
    :param slot_chip_resource_list: Keyword argument tuple.

    :type slot_chip_idx: long
    :param slot_chip_idx: **slot_chip_resource_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_match_profile_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_match_profile_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_match_profile_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list.slot_match_profile_list.slot_chip_resource_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list.slot_match_profile_list.slot_chip_resource_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list.slot_match_profile_list.slot_chip_resource_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slot_chip_resource_list', 'keyval': 'slot_chip_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list, slot_chip_resource_list=slot_chip_resource_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list, slot_chip_resource_list=slot_chip_resource_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_slot_match_profile_list_slot_chip_resource_list_max_flows_get(self, slot_resouces_list=None, slot_match_profile_list=None, slot_chip_resource_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type slot_match_profile_list: slot_match_profile_idx
    :param slot_match_profile_list: Keyword argument tuple.

    :type slot_match_profile_idx: long
    :param slot_match_profile_idx: **slot_match_profile_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slot_chip_resource_list: slot_chip_idx
    :param slot_chip_resource_list: Keyword argument tuple.

    :type slot_chip_idx: long
    :param slot_chip_idx: **slot_chip_resource_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_match_profile_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_match_profile_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_match_profile_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list.slot_match_profile_list.slot_chip_resource_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list.slot_match_profile_list.slot_chip_resource_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list.slot_match_profile_list.slot_chip_resource_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slot_chip_resource_list', 'keyval': 'slot_chip_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list, slot_chip_resource_list=slot_chip_resource_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list, slot_chip_resource_list=slot_chip_resource_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_slot_match_profile_list_slot_chip_resource_list_used_flows_get(self, slot_resouces_list=None, slot_match_profile_list=None, slot_chip_resource_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type slot_match_profile_list: slot_match_profile_idx
    :param slot_match_profile_list: Keyword argument tuple.

    :type slot_match_profile_idx: long
    :param slot_match_profile_idx: **slot_match_profile_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slot_chip_resource_list: slot_chip_idx
    :param slot_chip_resource_list: Keyword argument tuple.

    :type slot_chip_idx: long
    :param slot_chip_idx: **slot_chip_resource_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_match_profile_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_match_profile_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_match_profile_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list.slot_match_profile_list.slot_chip_resource_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list.slot_match_profile_list.slot_chip_resource_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list.slot_match_profile_list.slot_chip_resource_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slot_chip_resource_list', 'keyval': 'slot_chip_idx', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list, slot_chip_resource_list=slot_chip_resource_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list, slot_chip_resource_list=slot_chip_resource_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_slot_resouces_list_slot_match_profile_list_used_flows_get(self, slot_resouces_list=None, slot_match_profile_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot_resouces_list: slot_id
    :param slot_resouces_list: Keyword argument tuple.

    :type slot_id: long
    :param slot_id: **slot_resouces_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type slot_match_profile_list: slot_match_profile_idx
    :param slot_match_profile_list: Keyword argument tuple.

    :type slot_match_profile_idx: long
    :param slot_match_profile_idx: **slot_match_profile_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list', u'slot_resouces_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list', u'slot_resouces_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list.slot_match_profile_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list.slot_match_profile_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list.slot_match_profile_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_chip_resource_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_chip_resource_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources.slot_resouces_list.slot_match_profile_list', u'slot_chip_resource_list')]
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'slot_match_profile_list', 'keyval': 'slot_match_profile_idx', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'slot_chip_idx, max_flows, used_flows, free_flows'}, {'leafval': 'slot_chip_idx, max_flows, used_flows, free_flows'}, {'leafval': 'slot_chip_idx, max_flows, used_flows, free_flows'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot_resouces_list=slot_resouces_list, slot_match_profile_list=slot_match_profile_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def openflow_state_resources_tcam_profile_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.openflow_state.resources', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.openflow_state.resources', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.openflow_state.resources', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17r_2_00.openflow_state.resources', u'group_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17r_1_01a.openflow_state.resources', u'group_resouces_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources', u'slot_resouces_list'), ('pybind.slxos.v17s_1_02.openflow_state.resources', u'group_resouces_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'slot_id, module'}, {'leafval': 'max_, used, free, group_type'}, {'leafval': 'slot_id, module'}, {'leafval': 'max_, used, free, group_type'}, {'leafval': 'slot_id, module'}, {'leafval': 'max_, used, free, group_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.opstest_state.arpentries', u'arpe'), ('pybind.slxos.v17s_1_02.opstest_state', u'summary'), ('pybind.slxos.v17s_1_02.opstest_state.routes', u'route'), ('pybind.slxos.v17r_1_01a.opstest_state.arpentries', u'arpe'), ('pybind.slxos.v17r_1_01a.opstest_state.routes', u'route'), ('pybind.slxos.v17r_1_01a.opstest_state', u'summary'), ('pybind.slxos.v17r_2_00.opstest_state.arpentries', u'arpe'), ('pybind.slxos.v17r_2_00.opstest_state', u'summary'), ('pybind.slxos.v17r_2_00.opstest_state.routes', u'route')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip, ifname, hwaddr, permanent, published'}, {'leafval': 'paths_configured, lsps_configured, lsps_enabled, lsps_operational, detour_lsps_up, backup_lsps_up, bypass_lsps, bypass_lspsUp, bypass_lspsEnabled, ldp_lsps_operational, transit_lsps_configured, transit_lsps_enabled, transit_lsps_operational, cspf_groups_configured, tunnels_supported, tunnels_allocated, cross_connects_supported, cross_connects_allocated, autobw_templates_supported, autobw_templates_configured, times_enabled'}, {'leafval': 'destPrefix, entryMultipathIndex, prefixLength, gateway, outInterfaceName, outLabel, protocol, vifIndex, metric, useCount'}, {'leafval': 'ip, ifname, hwaddr, permanent, published'}, {'leafval': 'destPrefix, entryMultipathIndex, prefixLength, gateway, outInterfaceName, outLabel, protocol, vifIndex, metric, useCount'}, {'leafval': 'paths_configured, lsps_configured, lsps_enabled, lsps_operational, detour_lsps_up, backup_lsps_up, bypass_lsps, bypass_lspsUp, bypass_lspsEnabled, ldp_lsps_operational, transit_lsps_configured, transit_lsps_enabled, transit_lsps_operational, cspf_groups_configured, tunnels_supported, tunnels_allocated, cross_connects_supported, cross_connects_allocated, autobw_templates_supported, autobw_templates_configured, times_enabled'}, {'leafval': 'ip, ifname, hwaddr, permanent, published'}, {'leafval': 'paths_configured, lsps_configured, lsps_enabled, lsps_operational, detour_lsps_up, backup_lsps_up, bypass_lsps, bypass_lspsUp, bypass_lspsEnabled, ldp_lsps_operational, transit_lsps_configured, transit_lsps_enabled, transit_lsps_operational, cspf_groups_configured, tunnels_supported, tunnels_allocated, cross_connects_supported, cross_connects_allocated, autobw_templates_supported, autobw_templates_configured, times_enabled'}, {'leafval': 'destPrefix, entryMultipathIndex, prefixLength, gateway, outInterfaceName, outLabel, protocol, vifIndex, metric, useCount'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_arpentries_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.arpentries', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.arpentries', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.arpentries', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.opstest_state.arpentries', u'arpe'), ('pybind.slxos.v17r_2_00.opstest_state.arpentries', u'arpe'), ('pybind.slxos.v17s_1_02.opstest_state.arpentries', u'arpe')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ip, ifname, hwaddr, permanent, published'}, {'leafval': 'ip, ifname, hwaddr, permanent, published'}, {'leafval': 'ip, ifname, hwaddr, permanent, published'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_arpentries_arpe_get(self, arpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type arpe: ip, ifname
    :param arpe: Keyword argument tuple.

    :type ip: unicode
    :param ip: **arpe** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ifname: unicode
    :param ifname: **arpe** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.arpentries.arpe', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.arpentries.arpe', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.arpentries.arpe', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arpe', 'keyval': 'ip, ifname', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arpe=arpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arpe=arpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_arpentries_arpe_hwaddr_get(self, arpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type arpe: ip, ifname
    :param arpe: Keyword argument tuple.

    :type ip: unicode
    :param ip: **arpe** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ifname: unicode
    :param ifname: **arpe** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.arpentries.arpe', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.arpentries.arpe', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.arpentries.arpe', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arpe', 'keyval': 'ip, ifname', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arpe=arpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arpe=arpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_arpentries_arpe_permanent_get(self, arpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type arpe: ip, ifname
    :param arpe: Keyword argument tuple.

    :type ip: unicode
    :param ip: **arpe** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ifname: unicode
    :param ifname: **arpe** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.arpentries.arpe', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.arpentries.arpe', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.arpentries.arpe', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arpe', 'keyval': 'ip, ifname', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arpe=arpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arpe=arpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_arpentries_arpe_published_get(self, arpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type arpe: ip, ifname
    :param arpe: Keyword argument tuple.

    :type ip: unicode
    :param ip: **arpe** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ifname: unicode
    :param ifname: **arpe** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.arpentries.arpe', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.arpentries.arpe', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.arpentries.arpe', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'arpe', 'keyval': 'ip, ifname', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, arpe=arpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, arpe=arpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.opstest_state.routes', u'route'), ('pybind.slxos.v17r_1_01a.opstest_state.routes', u'route'), ('pybind.slxos.v17s_1_02.opstest_state.routes', u'route')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'destPrefix, entryMultipathIndex, prefixLength, gateway, outInterfaceName, outLabel, protocol, vifIndex, metric, useCount'}, {'leafval': 'destPrefix, entryMultipathIndex, prefixLength, gateway, outInterfaceName, outLabel, protocol, vifIndex, metric, useCount'}, {'leafval': 'destPrefix, entryMultipathIndex, prefixLength, gateway, outInterfaceName, outLabel, protocol, vifIndex, metric, useCount'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'children'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'children'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'children')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_children_get(self, route=None, children=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'route'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'route'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children', u'layer2'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children', u'layer2'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children', u'layer2')]
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'children', 'keyval': 'keyid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'layer2id, parentkeyid, grandparentKey, attr3, attr4'}, {'leafval': 'layer2id, parentkeyid, grandparentKey, attr3, attr4'}, {'leafval': 'layer2id, parentkeyid, grandparentKey, attr3, attr4'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_children_attr1_get(self, route=None, children=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'route'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'route'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children', u'layer2'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children', u'layer2'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children', u'layer2')]
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'children', 'keyval': 'keyid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'layer2id, parentkeyid, grandparentKey, attr3, attr4'}, {'leafval': 'layer2id, parentkeyid, grandparentKey, attr3, attr4'}, {'leafval': 'layer2id, parentkeyid, grandparentKey, attr3, attr4'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_children_attr2_get(self, route=None, children=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'route'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'route'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children', u'layer2'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children', u'layer2'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children', u'layer2')]
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'children', 'keyval': 'keyid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'layer2id, parentkeyid, grandparentKey, attr3, attr4'}, {'leafval': 'layer2id, parentkeyid, grandparentKey, attr3, attr4'}, {'leafval': 'layer2id, parentkeyid, grandparentKey, attr3, attr4'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_children_layer2_get(self, route=None, children=None, layer2=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type layer2: layer2id
    :param layer2: Keyword argument tuple.

    :type layer2id: long
    :param layer2id: **layer2** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'route'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children', u'children'), ('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'route'), ('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children', u'children'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'route'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children', u'children')]
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children.layer2', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children.layer2', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children.layer2', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'layer2', 'keyval': 'layer2id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children, layer2=layer2)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children, layer2=layer2)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_children_layer2_attr3_get(self, route=None, children=None, layer2=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type layer2: layer2id
    :param layer2: Keyword argument tuple.

    :type layer2id: long
    :param layer2id: **layer2** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'route'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children', u'children'), ('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'route'), ('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children', u'children'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'route'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children', u'children')]
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children.layer2', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children.layer2', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children.layer2', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'layer2', 'keyval': 'layer2id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children, layer2=layer2)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children, layer2=layer2)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_children_layer2_attr4_get(self, route=None, children=None, layer2=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type layer2: layer2id
    :param layer2: Keyword argument tuple.

    :type layer2id: long
    :param layer2id: **layer2** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'route'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children', u'children'), ('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'route'), ('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children', u'children'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'route'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children', u'children')]
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children.layer2', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children.layer2', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children.layer2', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'layer2', 'keyval': 'layer2id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children, layer2=layer2)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children, layer2=layer2)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_children_layer2_grandparentkey_get(self, route=None, children=None, layer2=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type layer2: layer2id
    :param layer2: Keyword argument tuple.

    :type layer2id: long
    :param layer2id: **layer2** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'route'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children', u'children'), ('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'route'), ('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children', u'children'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'route'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children', u'children')]
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children.layer2', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children.layer2', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children.layer2', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'layer2', 'keyval': 'layer2id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children, layer2=layer2)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children, layer2=layer2)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_children_layer2_parentkeyid_get(self, route=None, children=None, layer2=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type layer2: layer2id
    :param layer2: Keyword argument tuple.

    :type layer2id: long
    :param layer2id: **layer2** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'route'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children', u'children'), ('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'route'), ('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children', u'children'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'route'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children', u'children')]
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children.layer2', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children.layer2', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children.layer2', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'keyid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'layer2', 'keyval': 'layer2id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children, layer2=layer2)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children, layer2=layer2)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_children_parentkey_get(self, route=None, children=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type children: keyid
    :param children: Keyword argument tuple.

    :type keyid: long
    :param keyid: **children** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'route'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'route'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route.children', u'layer2'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route.children', u'layer2'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route.children', u'layer2')]
    compositions_keyval_list = [{'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}, {'keyval': 'destPrefix', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'children', 'keyval': 'keyid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'layer2id, parentkeyid, grandparentKey, attr3, attr4'}, {'leafval': 'layer2id, parentkeyid, grandparentKey, attr3, attr4'}, {'leafval': 'layer2id, parentkeyid, grandparentKey, attr3, attr4'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route, children=children)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route, children=children)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_entrymultipathindex_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'children'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'children'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'children')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_gateway_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'children'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'children'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'children')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_metric_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'children'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'children'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'children')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_outinterfacename_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'children'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'children'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'children')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_outlabel_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'children'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'children'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'children')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_prefixlength_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'children'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'children'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'children')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_protocol_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'children'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'children'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'children')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_usecount_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'children'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'children'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'children')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_routes_route_vifindex_get(self, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route: destPrefix
    :param route: Keyword argument tuple.

    :type destPrefix: unicode
    :param destPrefix: **route** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.opstest_state.routes.route', u'children'), ('pybind.slxos.v17s_1_02.opstest_state.routes.route', u'children'), ('pybind.slxos.v17r_2_00.opstest_state.routes.route', u'children')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'destPrefix', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}, {'leafval': 'keyid, parentKey, attr1, attr2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_autobw_templates_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_autobw_templates_supported_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_backup_lsps_up_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_bypass_lsps_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_bypass_lspsenabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_bypass_lspsup_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_cross_connects_allocated_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_cross_connects_supported_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_cspf_groups_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_detour_lsps_up_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_ldp_lsps_operational_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_lsps_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_lsps_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_lsps_operational_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_paths_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_times_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_transit_lsps_configured_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_transit_lsps_enabled_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_transit_lsps_operational_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_tunnels_allocated_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def opstest_state_summary_tunnels_supported_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.opstest_state.summary', 'pybind.slxos.v17r_1_01a.brocade_opstest', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.opstest_state.summary', 'pybind.slxos.v17r_2_00.brocade_opstest', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.opstest_state.summary', 'pybind.slxos.v17s_1_02.brocade_opstest', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.capabilities.overlay', u'vxlan'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan', u'extended'), ('pybind.slxos.v17r_2_00.capabilities', u'overlay'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan', u'standard'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan', u'standard'), ('pybind.slxos.v17s_1_02.capabilities', u'overlay'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan', u'standard'), ('pybind.slxos.v17s_1_02.capabilities.overlay', u'vxlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hardware_vtep, vtep_ip_ve, vxlan_tunnel_bfd, vxlan_tunnel_mac_learn_protocol_bgp'}, {'leafval': 'ext_user_acl_name'}, {'leafval': 'gre'}, {'leafval': 'user_acl_name'}, {'leafval': 'ext_user_acl_name'}, {'leafval': 'user_acl_name'}, {'leafval': 'gre, hardware_vtep'}, {'leafval': 'ext_user_acl_name'}, {'leafval': 'user_acl_name'}, {'leafval': 'mac_learn_protocol_bgp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan', u'standard'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan', u'standard'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan', u'extended'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan', u'standard')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ext_user_acl_name'}, {'leafval': 'user_acl_name'}, {'leafval': 'ext_user_acl_name'}, {'leafval': 'user_acl_name'}, {'leafval': 'ext_user_acl_name'}, {'leafval': 'user_acl_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan', u'standard'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan', u'standard'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan', u'extended'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan', u'standard')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ext_user_acl_name'}, {'leafval': 'user_acl_name'}, {'leafval': 'ext_user_acl_name'}, {'leafval': 'user_acl_name'}, {'leafval': 'ext_user_acl_name'}, {'leafval': 'user_acl_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan', u'standard'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan', u'standard'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan', u'extended'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan', u'standard')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ext_user_acl_name'}, {'leafval': 'user_acl_name'}, {'leafval': 'ext_user_acl_name'}, {'leafval': 'user_acl_name'}, {'leafval': 'ext_user_acl_name'}, {'leafval': 'user_acl_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_get(self, extended=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'ext_seq'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'ext_seq'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'ext_seq')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'ext_user_acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ext_seq_num, ext_permit_deny, ext_dst_vtep_ip, ext_dst_vtep_ip_any, ext_src_vtep_ip, ext_src_vtep_ip_any, ext_vni, ext_vni_any, ext_vni_mask, ext_count, ext_mirror, ext_redirect, ext_sflow, native, tag, dst_ip_host, dst_ip, dst_ip_any, src_ip_host, src_ip, src_ip_any, dst_port, dst_port_any, src_port, src_port_any'}, {'leafval': 'ext_seq_num, ext_permit_deny, ext_dst_vtep_ip, ext_dst_vtep_ip_any, ext_src_vtep_ip, ext_src_vtep_ip_any, ext_vni, ext_vni_any, ext_vni_mask, ext_count, ext_mirror, ext_redirect, ext_sflow, native, tag, dst_ip_host, dst_ip, dst_ip_any, src_ip_host, src_ip, src_ip_any, dst_port, dst_port_any, src_port, src_port_any'}, {'leafval': 'ext_seq_num, ext_permit_deny, ext_dst_vtep_ip, ext_dst_vtep_ip_any, ext_src_vtep_ip, ext_src_vtep_ip_any, ext_vni, ext_vni_any, ext_vni_mask, ext_count, ext_mirror, ext_redirect, ext_sflow, native, tag, dst_ip_host, dst_ip, dst_ip_any, src_ip_host, src_ip, src_ip_any, dst_port, dst_port_any, src_port, src_port_any'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num, ext_permit_deny, ext_dst_vtep_ip, ext_dst_vtep_ip_any, ext_src_vtep_ip, ext_src_vtep_ip_any, ext_vni, ext_vni_any, ext_vni_mask, ext_count, ext_mirror, ext_redirect, ext_sflow, native, tag, dst_ip_host, dst_ip, dst_ip_any, src_ip_host, src_ip, src_ip_any, dst_port, dst_port_any, src_port, src_port_any
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ext_permit_deny: unicode
    :param ext_permit_deny: **ext_seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ext_dst_vtep_ip: unicode
    :param ext_dst_vtep_ip: **ext_seq** tuple argument:  dst vtep ip address: A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ext_dst_vtep_ip_any: YANGBool
    :param ext_dst_vtep_ip_any: **ext_seq** tuple argument:  dst vtep ip address: any

    :type ext_src_vtep_ip: unicode
    :param ext_src_vtep_ip: **ext_seq** tuple argument:  src vtep ip address: A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type ext_src_vtep_ip_any: YANGBool
    :param ext_src_vtep_ip_any: **ext_seq** tuple argument:  src vtep ip address: any

    :type ext_vni: long
    :param ext_vni: **ext_seq** tuple argument:  vni number: 1..16777215

        * range restriction: ::

            ['0..4294967295']

    :type ext_vni_any: YANGBool
    :param ext_vni_any: **ext_seq** tuple argument:  vni any

    :type ext_vni_mask: unicode
    :param ext_vni_mask: **ext_seq** tuple argument:  vni mask:Hexadecimal 0..FFFFFF

        * pattern restriction: ::

            '0|[1-9a-fA-F][0-9a-fA-F]{0,5}'

    :type ext_count: YANGBool
    :param ext_count: **ext_seq** tuple argument:  count

    :type ext_mirror: unicode
    :param ext_mirror: **ext_seq** tuple argument:  mirror <interface-name>

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ext_redirect: unicode
    :param ext_redirect: **ext_seq** tuple argument:  redirect <interface-name>

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type ext_sflow: YANGBool
    :param ext_sflow: **ext_seq** tuple argument:  sflow

    :type native: YANGBool
    :param native: **ext_seq** tuple argument.

    :type tag: unicode
    :param tag: **ext_seq** tuple argument.

        * enumeration restriction: ::

            ['none', 'single', 'any']

    :type dst_ip_host: unicode
    :param dst_ip_host: **ext_seq** tuple argument:  dst ip host: A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type dst_ip: unicode
    :param dst_ip: **ext_seq** tuple argument:  dst ip: A.B.C.D/mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type dst_ip_any: YANGBool
    :param dst_ip_any: **ext_seq** tuple argument:  dst ip address: any

    :type src_ip_host: unicode
    :param src_ip_host: **ext_seq** tuple argument:  src ip host: A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_ip: unicode
    :param src_ip: **ext_seq** tuple argument:  src ip: A.B.C.D/mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type src_ip_any: YANGBool
    :param src_ip_any: **ext_seq** tuple argument:  src ip address: any

    :type dst_port: long
    :param dst_port: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type dst_port_any: YANGBool
    :param dst_port_any: **ext_seq** tuple argument:  dst-port-any

    :type src_port: long
    :param src_port: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type src_port_any: YANGBool
    :param src_port_any: **ext_seq** tuple argument:  src-port-any

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': 'ext_seq_num, ext_permit_deny, ext_dst_vtep_ip, ext_dst_vtep_ip_any, ext_src_vtep_ip, ext_src_vtep_ip_any, ext_vni, ext_vni_any, ext_vni_mask, ext_count, ext_mirror, ext_redirect, ext_sflow, native, tag, dst_ip_host, dst_ip, dst_ip_any, src_ip_host, src_ip, src_ip_any, dst_port, dst_port_any, src_port, src_port_any'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq': [u'ext_dst_vtep_ip_any', u'ext_dst_vtep_ip', u'ext_src_vtep_ip_any', u'ext_src_vtep_ip', u'ext_vni', u'ext_vni_any', u'dst_ip_host', u'dst_ip_any', u'dst_ip', u'src_ip_host', u'src_ip', u'src_ip_any', u'dst_port_any', u'dst_port', u'src_port_any', u'src_port'], 'pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq': [u'ext_dst_vtep_ip_any', u'ext_dst_vtep_ip', u'ext_src_vtep_ip_any', u'ext_src_vtep_ip', u'ext_vni', u'ext_vni_any', u'dst_ip_host', u'dst_ip_any', u'dst_ip', u'src_ip_host', u'src_ip', u'src_ip_any', u'dst_port_any', u'dst_port', u'src_port_any', u'src_port'], 'pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq': [u'ext_dst_vtep_ip_any', u'ext_dst_vtep_ip', u'ext_src_vtep_ip_any', u'ext_src_vtep_ip', u'ext_vni', u'ext_vni_any', u'dst_ip_host', u'dst_ip_any', u'dst_ip', u'src_ip_host', u'src_ip', u'src_ip_any', u'dst_port_any', u'dst_port', u'src_port_any', u'src_port']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_count_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_dst_ip_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_dst_ip_any_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_dst_ip_host_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_dst_port_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_dst_port_any_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_dst_vtep_ip_any_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_dst_vtep_ip_host_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_ext_permit_deny_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_mirror_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_native_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_redirect_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_sflow_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_src_ip_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_src_ip_any_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_src_ip_host_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_src_port_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_src_port_any_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_src_vtep_ip_any_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_src_vtep_ip_host_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_tag_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_vni_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_vni_any_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_extended_seq_vni_mask_get(self, extended=None, ext_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: ext_user_acl_name
    :param extended: Keyword argument tuple.

    :type ext_user_acl_name: unicode
    :param ext_user_acl_name: **extended** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type ext_seq: ext_seq_num
    :param ext_seq: Keyword argument tuple.

    :type ext_seq_num: long
    :param ext_seq_num: **ext_seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended', u'extended'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.extended.ext_seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}, {'keyval': 'ext_user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ext_seq', 'keyval': 'ext_seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, ext_seq=ext_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, ext_seq=ext_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_get(self, standard=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard', u'seq'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard', u'seq'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard', u'seq')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'user_acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_num, permit_deny, dst_vtep_ip, dst_vtep_ip_any, src_vtep_ip, src_vtep_ip_any, vni, vni_any, vni_mask, count, redirect, sflow'}, {'leafval': 'seq_num, permit_deny, dst_vtep_ip, dst_vtep_ip_any, src_vtep_ip, src_vtep_ip_any, vni, vni_any, vni_mask, count, redirect, sflow'}, {'leafval': 'seq_num, permit_deny, dst_vtep_ip, dst_vtep_ip_any, src_vtep_ip, src_vtep_ip_any, vni, vni_any, vni_mask, count, redirect, sflow'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num, permit_deny, dst_vtep_ip, dst_vtep_ip_any, src_vtep_ip, src_vtep_ip_any, vni, vni_any, vni_mask, count, redirect, sflow
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type permit_deny: unicode
    :param permit_deny: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type dst_vtep_ip: unicode
    :param dst_vtep_ip: **seq** tuple argument:  dst vtep ip address: A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type dst_vtep_ip_any: YANGBool
    :param dst_vtep_ip_any: **seq** tuple argument:  dst vtep ip address: any

    :type src_vtep_ip: unicode
    :param src_vtep_ip: **seq** tuple argument:  src vtep ip address: A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type src_vtep_ip_any: YANGBool
    :param src_vtep_ip_any: **seq** tuple argument:  src vtep ip address: any

    :type vni: long
    :param vni: **seq** tuple argument:  vni number: 1..16777215

        * range restriction: ::

            ['0..4294967295']

    :type vni_any: YANGBool
    :param vni_any: **seq** tuple argument:  vni any

    :type vni_mask: unicode
    :param vni_mask: **seq** tuple argument:  vni mask:Hexadecimal 0..FFFFFF

        * pattern restriction: ::

            '0|[1-9a-fA-F][0-9a-fA-F]{0,5}'

    :type count: YANGBool
    :param count: **seq** tuple argument:  count

    :type redirect: unicode
    :param redirect: **seq** tuple argument:  redirect <interface-name>

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type sflow: YANGBool
    :param sflow: **seq** tuple argument:  sflow

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': 'seq_num, permit_deny, dst_vtep_ip, dst_vtep_ip_any, src_vtep_ip, src_vtep_ip_any, vni, vni_any, vni_mask, count, redirect, sflow'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard.seq': [u'src_vtep_ip_any', u'src_vtep_ip', u'vni', u'vni_any', u'dst_vtep_ip', u'dst_vtep_ip_any'], 'pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard.seq': [u'src_vtep_ip_any', u'src_vtep_ip', u'vni', u'vni_any', u'dst_vtep_ip', u'dst_vtep_ip_any'], 'pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard.seq': [u'src_vtep_ip_any', u'src_vtep_ip', u'vni', u'vni_any', u'dst_vtep_ip', u'dst_vtep_ip_any']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_count_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_dst_vtep_ip_any_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_dst_vtep_ip_host_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_permit_deny_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_redirect_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_sflow_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_src_vtep_ip_any_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_src_vtep_ip_host_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_vni_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_vni_any_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_access_list_type_vxlan_standard_seq_vni_mask_get(self, standard=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type standard: user_acl_name
    :param standard: Keyword argument tuple.

    :type user_acl_name: unicode
    :param user_acl_name: **standard** tuple argument:  Access List Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_num
    :param seq: Keyword argument tuple.

    :type seq_num: long
    :param seq_num: **seq** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard', u'standard'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard', u'standard')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay.access_list.type.vxlan.standard.seq', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}, {'keyval': 'user_acl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, standard=standard, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, standard=standard, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_get(self, overlay_class_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_class_map: cmap_name
    :param overlay_class_map: Keyword argument tuple.

    :type cmap_name: unicode
    :param cmap_name: **overlay_class_map** tuple argument:  Overlay Class Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_class_map', u'cmap_seq')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_class_map', 'keyval': 'cmap_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cmap_seq_num'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map=overlay_class_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map=overlay_class_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_get_next_cookie_state_get(self, overlay_class_map_get_next_cookie_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_class_map_get_next_cookie_state: class_map_name
    :param overlay_class_map_get_next_cookie_state: Keyword argument tuple.

    :type class_map_name: unicode
    :param class_map_name: **overlay_class_map_get_next_cookie_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map_get_next_cookie_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_class_map_get_next_cookie_state', 'keyval': 'class_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map_get_next_cookie_state=overlay_class_map_get_next_cookie_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map_get_next_cookie_state=overlay_class_map_get_next_cookie_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_seq_get(self, overlay_class_map=None, cmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map: cmap_name
    :param overlay_class_map: Keyword argument tuple.

    :type cmap_name: unicode
    :param cmap_name: **overlay_class_map** tuple argument:  Overlay Class Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type cmap_seq: cmap_seq_num
    :param cmap_seq: Keyword argument tuple.

    :type cmap_seq_num: long
    :param cmap_seq_num: **cmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map', 'overlay_class_map')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq', u'match'), ('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq.match', u'contn_src_dst')]
    compositions_keyval_list = [{'keyval': 'cmap_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cmap_seq', 'keyval': 'cmap_seq_num', 'extra_keyval': 'cmap_seq_num'}
    composed_child_leafval_list = [{'leafval': 'any, endpoint, source, destination, encap_type, vni, vni_mask'}, {'leafval': 'source, destination'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_seq_match_get(self, overlay_class_map=None, cmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map: cmap_name
    :param overlay_class_map: Keyword argument tuple.

    :type cmap_name: unicode
    :param cmap_name: **overlay_class_map** tuple argument:  Overlay Class Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type cmap_seq: cmap_seq_num
    :param cmap_seq: Keyword argument tuple.

    :type cmap_seq_num: long
    :param cmap_seq_num: **cmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map', 'overlay_class_map'), ('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq', u'cmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq.match', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cmap_name', 'extra_keyval': ''}, {'keyval': 'cmap_seq_num', 'extra_keyval': 'cmap_seq_num'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'any, endpoint, source, destination, encap_type, vni, vni_mask'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq.match': [u'destination', u'source', u'contn_src_dst', u'any', u'endpoint']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_seq_match_any_get(self, overlay_class_map=None, cmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map: cmap_name
    :param overlay_class_map: Keyword argument tuple.

    :type cmap_name: unicode
    :param cmap_name: **overlay_class_map** tuple argument:  Overlay Class Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type cmap_seq: cmap_seq_num
    :param cmap_seq: Keyword argument tuple.

    :type cmap_seq_num: long
    :param cmap_seq_num: **cmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map', 'overlay_class_map'), ('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq', u'cmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq.match', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cmap_name', 'extra_keyval': ''}, {'keyval': 'cmap_seq_num', 'extra_keyval': 'cmap_seq_num'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_seq_match_contn_src_dst_get(self, overlay_class_map=None, cmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map: cmap_name
    :param overlay_class_map: Keyword argument tuple.

    :type cmap_name: unicode
    :param cmap_name: **overlay_class_map** tuple argument:  Overlay Class Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type cmap_seq: cmap_seq_num
    :param cmap_seq: Keyword argument tuple.

    :type cmap_seq_num: long
    :param cmap_seq_num: **cmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map', 'overlay_class_map'), ('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq', u'cmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq.match.contn_src_dst', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cmap_name', 'extra_keyval': ''}, {'keyval': 'cmap_seq_num', 'extra_keyval': 'cmap_seq_num'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'source, destination'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq.match.contn_src_dst': [u'source']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_seq_match_destination_get(self, overlay_class_map=None, cmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map: cmap_name
    :param overlay_class_map: Keyword argument tuple.

    :type cmap_name: unicode
    :param cmap_name: **overlay_class_map** tuple argument:  Overlay Class Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type cmap_seq: cmap_seq_num
    :param cmap_seq: Keyword argument tuple.

    :type cmap_seq_num: long
    :param cmap_seq_num: **cmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map', 'overlay_class_map'), ('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq', u'cmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq.match', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cmap_name', 'extra_keyval': ''}, {'keyval': 'cmap_seq_num', 'extra_keyval': 'cmap_seq_num'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_seq_match_destination_contn_src_dst_get(self, overlay_class_map=None, cmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map: cmap_name
    :param overlay_class_map: Keyword argument tuple.

    :type cmap_name: unicode
    :param cmap_name: **overlay_class_map** tuple argument:  Overlay Class Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type cmap_seq: cmap_seq_num
    :param cmap_seq: Keyword argument tuple.

    :type cmap_seq_num: long
    :param cmap_seq_num: **cmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map', 'overlay_class_map'), ('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq', u'cmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq.match.contn_src_dst', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cmap_name', 'extra_keyval': ''}, {'keyval': 'cmap_seq_num', 'extra_keyval': 'cmap_seq_num'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_seq_match_encap_type_get(self, overlay_class_map=None, cmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map: cmap_name
    :param overlay_class_map: Keyword argument tuple.

    :type cmap_name: unicode
    :param cmap_name: **overlay_class_map** tuple argument:  Overlay Class Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type cmap_seq: cmap_seq_num
    :param cmap_seq: Keyword argument tuple.

    :type cmap_seq_num: long
    :param cmap_seq_num: **cmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map', 'overlay_class_map'), ('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq', u'cmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq.match', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cmap_name', 'extra_keyval': ''}, {'keyval': 'cmap_seq_num', 'extra_keyval': 'cmap_seq_num'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_seq_match_endpoint_get(self, overlay_class_map=None, cmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map: cmap_name
    :param overlay_class_map: Keyword argument tuple.

    :type cmap_name: unicode
    :param cmap_name: **overlay_class_map** tuple argument:  Overlay Class Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type cmap_seq: cmap_seq_num
    :param cmap_seq: Keyword argument tuple.

    :type cmap_seq_num: long
    :param cmap_seq_num: **cmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map', 'overlay_class_map'), ('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq', u'cmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq.match', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cmap_name', 'extra_keyval': ''}, {'keyval': 'cmap_seq_num', 'extra_keyval': 'cmap_seq_num'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_seq_match_source_get(self, overlay_class_map=None, cmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map: cmap_name
    :param overlay_class_map: Keyword argument tuple.

    :type cmap_name: unicode
    :param cmap_name: **overlay_class_map** tuple argument:  Overlay Class Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type cmap_seq: cmap_seq_num
    :param cmap_seq: Keyword argument tuple.

    :type cmap_seq_num: long
    :param cmap_seq_num: **cmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map', 'overlay_class_map'), ('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq', u'cmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq.match', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cmap_name', 'extra_keyval': ''}, {'keyval': 'cmap_seq_num', 'extra_keyval': 'cmap_seq_num'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_seq_match_source_contn_src_dst_get(self, overlay_class_map=None, cmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map: cmap_name
    :param overlay_class_map: Keyword argument tuple.

    :type cmap_name: unicode
    :param cmap_name: **overlay_class_map** tuple argument:  Overlay Class Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type cmap_seq: cmap_seq_num
    :param cmap_seq: Keyword argument tuple.

    :type cmap_seq_num: long
    :param cmap_seq_num: **cmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map', 'overlay_class_map'), ('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq', u'cmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq.match.contn_src_dst', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cmap_name', 'extra_keyval': ''}, {'keyval': 'cmap_seq_num', 'extra_keyval': 'cmap_seq_num'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_seq_match_vni_get(self, overlay_class_map=None, cmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map: cmap_name
    :param overlay_class_map: Keyword argument tuple.

    :type cmap_name: unicode
    :param cmap_name: **overlay_class_map** tuple argument:  Overlay Class Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type cmap_seq: cmap_seq_num
    :param cmap_seq: Keyword argument tuple.

    :type cmap_seq_num: long
    :param cmap_seq_num: **cmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map', 'overlay_class_map'), ('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq', u'cmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq.match', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cmap_name', 'extra_keyval': ''}, {'keyval': 'cmap_seq_num', 'extra_keyval': 'cmap_seq_num'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_seq_match_vni_mask_get(self, overlay_class_map=None, cmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map: cmap_name
    :param overlay_class_map: Keyword argument tuple.

    :type cmap_name: unicode
    :param cmap_name: **overlay_class_map** tuple argument:  Overlay Class Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type cmap_seq: cmap_seq_num
    :param cmap_seq: Keyword argument tuple.

    :type cmap_seq_num: long
    :param cmap_seq_num: **cmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map', 'overlay_class_map'), ('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq', u'cmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map.cmap_seq.match', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cmap_name', 'extra_keyval': ''}, {'keyval': 'cmap_seq_num', 'extra_keyval': 'cmap_seq_num'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map=overlay_class_map, cmap_seq=cmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_state_get(self, overlay_class_map_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_class_map_state: class_map_name
    :param overlay_class_map_state: Keyword argument tuple.

    :type class_map_name: unicode
    :param class_map_name: **overlay_class_map_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state', u'rules'), ('pybind.slxos.v17s_1_02.overlay_class_map_state', u'policies')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_class_map_state', 'keyval': 'class_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, source, destination, endpoint, encap_type, vni'}, {'leafval': 'seq_id, name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map_state=overlay_class_map_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map_state=overlay_class_map_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_state_policies_get(self, overlay_class_map_state=None, policies=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map_state: class_map_name
    :param overlay_class_map_state: Keyword argument tuple.

    :type class_map_name: unicode
    :param class_map_name: **overlay_class_map_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type policies: seq_id
    :param policies: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **policies** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state', 'overlay_class_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state.policies', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'class_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'policies', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map_state=overlay_class_map_state, policies=policies)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map_state=overlay_class_map_state, policies=policies)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_state_policies_name_get(self, overlay_class_map_state=None, policies=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map_state: class_map_name
    :param overlay_class_map_state: Keyword argument tuple.

    :type class_map_name: unicode
    :param class_map_name: **overlay_class_map_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type policies: seq_id
    :param policies: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **policies** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state', 'overlay_class_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state.policies', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'class_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'policies', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map_state=overlay_class_map_state, policies=policies)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map_state=overlay_class_map_state, policies=policies)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_state_rules_get(self, overlay_class_map_state=None, rules=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map_state: class_map_name
    :param overlay_class_map_state: Keyword argument tuple.

    :type class_map_name: unicode
    :param class_map_name: **overlay_class_map_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rules: seq_id
    :param rules: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **rules** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state', 'overlay_class_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state.rules', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'class_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rules', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map_state=overlay_class_map_state, rules=rules)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map_state=overlay_class_map_state, rules=rules)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_state_rules_destination_get(self, overlay_class_map_state=None, rules=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map_state: class_map_name
    :param overlay_class_map_state: Keyword argument tuple.

    :type class_map_name: unicode
    :param class_map_name: **overlay_class_map_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rules: seq_id
    :param rules: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **rules** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state', 'overlay_class_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state.rules', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'class_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rules', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map_state=overlay_class_map_state, rules=rules)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map_state=overlay_class_map_state, rules=rules)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_state_rules_encap_type_get(self, overlay_class_map_state=None, rules=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map_state: class_map_name
    :param overlay_class_map_state: Keyword argument tuple.

    :type class_map_name: unicode
    :param class_map_name: **overlay_class_map_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rules: seq_id
    :param rules: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **rules** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state', 'overlay_class_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state.rules', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'class_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rules', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map_state=overlay_class_map_state, rules=rules)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map_state=overlay_class_map_state, rules=rules)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_state_rules_endpoint_get(self, overlay_class_map_state=None, rules=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map_state: class_map_name
    :param overlay_class_map_state: Keyword argument tuple.

    :type class_map_name: unicode
    :param class_map_name: **overlay_class_map_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rules: seq_id
    :param rules: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **rules** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state', 'overlay_class_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state.rules', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'class_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rules', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map_state=overlay_class_map_state, rules=rules)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map_state=overlay_class_map_state, rules=rules)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_state_rules_source_get(self, overlay_class_map_state=None, rules=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map_state: class_map_name
    :param overlay_class_map_state: Keyword argument tuple.

    :type class_map_name: unicode
    :param class_map_name: **overlay_class_map_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rules: seq_id
    :param rules: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **rules** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state', 'overlay_class_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state.rules', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'class_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rules', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map_state=overlay_class_map_state, rules=rules)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map_state=overlay_class_map_state, rules=rules)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_class_map_state_rules_vni_get(self, overlay_class_map_state=None, rules=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_class_map_state: class_map_name
    :param overlay_class_map_state: Keyword argument tuple.

    :type class_map_name: unicode
    :param class_map_name: **overlay_class_map_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type rules: seq_id
    :param rules: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **rules** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state', 'overlay_class_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_class_map_state.rules', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'class_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rules', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_class_map_state=overlay_class_map_state, rules=rules)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_class_map_state=overlay_class_map_state, rules=rules)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_gateway', u'overlay_service_policy'), ('pybind.slxos.v17s_1_02.overlay_gateway.ip.interface', u've'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_', u'bd_vni_mapping'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_.vlan_and_bd', u'vni'), ('pybind.slxos.v17s_1_02.overlay_gateway.ip.interface', u'loopback'), ('pybind.slxos.v17s_1_02.overlay_gateway', u'site'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_', u'vlan_vni_mapping'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_', u'bd_vni_mapping'), ('pybind.slxos.v17r_2_00.overlay_gateway.ip.interface', u've'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_.vlan_and_bd', u'vni'), ('pybind.slxos.v17r_2_00.overlay_gateway.access_lists', u'overlay_acl_in'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_', u'vlan_vni_mapping'), ('pybind.slxos.v17r_2_00.overlay_gateway', u'site'), ('pybind.slxos.v17r_2_00.overlay_gateway.ip.interface', u'loopback'), ('pybind.nos.v6_0_2f.overlay_gateway.attach', u'vlan'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv6', u'in_'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.mac', u'in_'), ('pybind.nos.v6_0_2f.overlay_gateway', u'site'), ('pybind.nos.v6_0_2f.overlay_gateway.map_.vlan', u'vni'), ('pybind.nos.v6_0_2f.overlay_gateway.attach', u'rbridge_id'), ('pybind.nos.v6_0_2f.overlay_gateway.map_', u'vlan_vni_mapping'), ('pybind.nos.v6_0_2f.overlay_gateway.enable', u'statistics'), ('pybind.nos.v6_0_2f.overlay_gateway.ip.interface', u'loopback'), ('pybind.nos.v6_0_2f.overlay_gateway', u'monitor'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv4', u'out'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv6', u'out'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.mac', u'out'), ('pybind.nos.v6_0_2f.overlay_gateway.ip.interface', u've'), ('pybind.nos.v6_0_2f.overlay_gateway', u'sflow'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv4', u'in_'), ('pybind.slxos.v17r_1_01a.overlay_gateway.ip.interface', u'loopback'), ('pybind.slxos.v17r_1_01a.overlay_gateway', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway.map_', u'vlan_vni_mapping'), ('pybind.slxos.v17r_1_01a.overlay_gateway.access_lists', u'overlay_acl_in'), ('pybind.slxos.v17r_1_01a.overlay_gateway.map_.vlan_and_bd', u'vni'), ('pybind.slxos.v17r_1_01a.overlay_gateway.ip.interface', u've'), ('pybind.slxos.v17r_1_01a.overlay_gateway.map_', u'bd_vni_mapping'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.mac', u'out'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv4', u'in_'), ('pybind.nos.v7_2_0.overlay_gateway', u'sflow'), ('pybind.nos.v7_2_0.overlay_gateway.attach', u'rbridge_id'), ('pybind.nos.v7_2_0.overlay_gateway.ip.interface', u'loopback'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv6', u'in_'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.mac', u'in_'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv4', u'out'), ('pybind.nos.v7_2_0.overlay_gateway.ip.interface', u've'), ('pybind.nos.v7_2_0.overlay_gateway.map_.vlan', u'vni'), ('pybind.nos.v7_2_0.overlay_gateway.map_', u'vlan_vni_mapping'), ('pybind.nos.v7_2_0.overlay_gateway.enable', u'statistics'), ('pybind.nos.v7_2_0.overlay_gateway', u'site'), ('pybind.nos.v7_2_0.overlay_gateway.attach', u'vlan'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv6', u'out'), ('pybind.nos.v7_2_0.overlay_gateway', u'monitor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_gateway', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'policy_in'}, {'leafval': 've_id, vrrp_extended_group'}, {'leafval': 'bdid, vni'}, {'leafval': 'auto'}, {'leafval': 'loopback_id'}, {'leafval': 'name, description, bfd_enable, shutdown'}, {'leafval': 'vid, vni'}, {'leafval': 'bdid, vni'}, {'leafval': 've_id, vrrp_extended_group'}, {'leafval': 'auto'}, {'leafval': 'in_name, in_dir'}, {'leafval': 'vid, vni'}, {'leafval': 'name, description, bfd_enable, shutdown'}, {'leafval': 'loopback_id'}, {'leafval': 'vid, mac'}, {'leafval': 'ipv6_acl_in_name, ipv6_acl_in_dir'}, {'leafval': 'mac_acl_in_name, mac_acl_in_dir'}, {'leafval': 'name, bfd_enable, shutdown'}, {'leafval': 'auto'}, {'leafval': 'rb_add, rb_remove'}, {'leafval': 'vid, vni'}, {'leafval': 'stats_direction, vlan_action, vlan_list'}, {'leafval': 'loopback_id'}, {'leafval': 'session, direction, remote_endpoint, vlan_leaf, vlan_add_remove, vlan_range'}, {'leafval': 'ipv4_acl_out_name, ipv4_acl_out_dir'}, {'leafval': 'ipv6_acl_out_name, ipv6_acl_out_dir'}, {'leafval': 'mac_acl_out_name, mac_acl_out_dir'}, {'leafval': 've_id, vrrp_extended_group'}, {'leafval': 'sflow_profile_name, sflow_remote_endpoint, sflow_vlan_action, sflow_vlan_range'}, {'leafval': 'ipv4_acl_in_name, ipv4_acl_in_dir'}, {'leafval': 'loopback_id'}, {'leafval': 'name, bfd_enable, shutdown'}, {'leafval': 'vid, vni'}, {'leafval': 'in_name, in_dir'}, {'leafval': 'auto'}, {'leafval': 've_id, vrrp_extended_group'}, {'leafval': 'bdid, vni'}, {'leafval': 'mac_acl_out_name, mac_acl_out_dir'}, {'leafval': 'ipv4_acl_in_name, ipv4_acl_in_dir'}, {'leafval': 'sflow_profile_name, sflow_remote_endpoint, sflow_vlan_action, sflow_vlan_range'}, {'leafval': 'rb_add, rb_remove'}, {'leafval': 'loopback_id'}, {'leafval': 'ipv6_acl_in_name, ipv6_acl_in_dir'}, {'leafval': 'mac_acl_in_name, mac_acl_in_dir'}, {'leafval': 'ipv4_acl_out_name, ipv4_acl_out_dir'}, {'leafval': 've_id, vrrp_extended_group'}, {'leafval': 'auto'}, {'leafval': 'vid, vni'}, {'leafval': 'stats_direction, vlan_action, vlan_list'}, {'leafval': 'name, bfd_enable, shutdown'}, {'leafval': 'vid, mac'}, {'leafval': 'ipv6_acl_out_name, ipv6_acl_out_dir'}, {'leafval': 'session, direction, remote_endpoint, vlan_leaf, vlan_add_remove, vlan_range'}]
    leafval_map = {"pybind.slxos.v17s_1_02.overlay_gateway": {"activate": "activate", "name": "name", "gw_type": "gw_type"}, "pybind.nos.v7_2_0.overlay_gateway": {"activate": "activate", "name": "name", "gw_type": "gw_type"}, "pybind.slxos.v17r_2_00.overlay_gateway": {}, "pybind.slxos.v17r_1_01a.overlay_gateway": {"activate": "activate", "name": "name", "gw_type": "gw_type"}, "pybind.nos.v6_0_2f.overlay_gateway": {"activate": "activate", "name": "name", "gw_type": "gw_type"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_activate_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_gateway', u'overlay_service_policy'), ('pybind.slxos.v17s_1_02.overlay_gateway.ip.interface', u've'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_', u'bd_vni_mapping'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_.vlan_and_bd', u'vni'), ('pybind.slxos.v17s_1_02.overlay_gateway.ip.interface', u'loopback'), ('pybind.slxos.v17s_1_02.overlay_gateway', u'site'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_', u'vlan_vni_mapping'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_', u'bd_vni_mapping'), ('pybind.slxos.v17r_2_00.overlay_gateway.ip.interface', u've'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_.vlan_and_bd', u'vni'), ('pybind.slxos.v17r_2_00.overlay_gateway.access_lists', u'overlay_acl_in'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_', u'vlan_vni_mapping'), ('pybind.slxos.v17r_2_00.overlay_gateway', u'site'), ('pybind.slxos.v17r_2_00.overlay_gateway.ip.interface', u'loopback'), ('pybind.nos.v6_0_2f.overlay_gateway.attach', u'vlan'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv6', u'in_'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.mac', u'in_'), ('pybind.nos.v6_0_2f.overlay_gateway', u'site'), ('pybind.nos.v6_0_2f.overlay_gateway.map_.vlan', u'vni'), ('pybind.nos.v6_0_2f.overlay_gateway.attach', u'rbridge_id'), ('pybind.nos.v6_0_2f.overlay_gateway.map_', u'vlan_vni_mapping'), ('pybind.nos.v6_0_2f.overlay_gateway.enable', u'statistics'), ('pybind.nos.v6_0_2f.overlay_gateway.ip.interface', u'loopback'), ('pybind.nos.v6_0_2f.overlay_gateway', u'monitor'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv4', u'out'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv6', u'out'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.mac', u'out'), ('pybind.nos.v6_0_2f.overlay_gateway.ip.interface', u've'), ('pybind.nos.v6_0_2f.overlay_gateway', u'sflow'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv4', u'in_'), ('pybind.slxos.v17r_1_01a.overlay_gateway.ip.interface', u'loopback'), ('pybind.slxos.v17r_1_01a.overlay_gateway', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway.map_', u'vlan_vni_mapping'), ('pybind.slxos.v17r_1_01a.overlay_gateway.access_lists', u'overlay_acl_in'), ('pybind.slxos.v17r_1_01a.overlay_gateway.map_.vlan_and_bd', u'vni'), ('pybind.slxos.v17r_1_01a.overlay_gateway.ip.interface', u've'), ('pybind.slxos.v17r_1_01a.overlay_gateway.map_', u'bd_vni_mapping'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.mac', u'out'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv4', u'in_'), ('pybind.nos.v7_2_0.overlay_gateway', u'sflow'), ('pybind.nos.v7_2_0.overlay_gateway.attach', u'rbridge_id'), ('pybind.nos.v7_2_0.overlay_gateway.ip.interface', u'loopback'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv6', u'in_'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.mac', u'in_'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv4', u'out'), ('pybind.nos.v7_2_0.overlay_gateway.ip.interface', u've'), ('pybind.nos.v7_2_0.overlay_gateway.map_.vlan', u'vni'), ('pybind.nos.v7_2_0.overlay_gateway.map_', u'vlan_vni_mapping'), ('pybind.nos.v7_2_0.overlay_gateway.enable', u'statistics'), ('pybind.nos.v7_2_0.overlay_gateway', u'site'), ('pybind.nos.v7_2_0.overlay_gateway.attach', u'vlan'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv6', u'out'), ('pybind.nos.v7_2_0.overlay_gateway', u'monitor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_gateway', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'policy_in'}, {'leafval': 've_id, vrrp_extended_group'}, {'leafval': 'bdid, vni'}, {'leafval': 'auto'}, {'leafval': 'loopback_id'}, {'leafval': 'name, description, bfd_enable, shutdown'}, {'leafval': 'vid, vni'}, {'leafval': 'bdid, vni'}, {'leafval': 've_id, vrrp_extended_group'}, {'leafval': 'auto'}, {'leafval': 'in_name, in_dir'}, {'leafval': 'vid, vni'}, {'leafval': 'name, description, bfd_enable, shutdown'}, {'leafval': 'loopback_id'}, {'leafval': 'vid, mac'}, {'leafval': 'ipv6_acl_in_name, ipv6_acl_in_dir'}, {'leafval': 'mac_acl_in_name, mac_acl_in_dir'}, {'leafval': 'name, bfd_enable, shutdown'}, {'leafval': 'auto'}, {'leafval': 'rb_add, rb_remove'}, {'leafval': 'vid, vni'}, {'leafval': 'stats_direction, vlan_action, vlan_list'}, {'leafval': 'loopback_id'}, {'leafval': 'session, direction, remote_endpoint, vlan_leaf, vlan_add_remove, vlan_range'}, {'leafval': 'ipv4_acl_out_name, ipv4_acl_out_dir'}, {'leafval': 'ipv6_acl_out_name, ipv6_acl_out_dir'}, {'leafval': 'mac_acl_out_name, mac_acl_out_dir'}, {'leafval': 've_id, vrrp_extended_group'}, {'leafval': 'sflow_profile_name, sflow_remote_endpoint, sflow_vlan_action, sflow_vlan_range'}, {'leafval': 'ipv4_acl_in_name, ipv4_acl_in_dir'}, {'leafval': 'loopback_id'}, {'leafval': 'name, bfd_enable, shutdown'}, {'leafval': 'vid, vni'}, {'leafval': 'in_name, in_dir'}, {'leafval': 'auto'}, {'leafval': 've_id, vrrp_extended_group'}, {'leafval': 'bdid, vni'}, {'leafval': 'mac_acl_out_name, mac_acl_out_dir'}, {'leafval': 'ipv4_acl_in_name, ipv4_acl_in_dir'}, {'leafval': 'sflow_profile_name, sflow_remote_endpoint, sflow_vlan_action, sflow_vlan_range'}, {'leafval': 'rb_add, rb_remove'}, {'leafval': 'loopback_id'}, {'leafval': 'ipv6_acl_in_name, ipv6_acl_in_dir'}, {'leafval': 'mac_acl_in_name, mac_acl_in_dir'}, {'leafval': 'ipv4_acl_out_name, ipv4_acl_out_dir'}, {'leafval': 've_id, vrrp_extended_group'}, {'leafval': 'auto'}, {'leafval': 'vid, vni'}, {'leafval': 'stats_direction, vlan_action, vlan_list'}, {'leafval': 'name, bfd_enable, shutdown'}, {'leafval': 'vid, mac'}, {'leafval': 'ipv6_acl_out_name, ipv6_acl_out_dir'}, {'leafval': 'session, direction, remote_endpoint, vlan_leaf, vlan_add_remove, vlan_range'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_attach_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.attach', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.attach', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_attach_rbridge_id_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.attach.rbridge_id', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.attach.rbridge_id', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_attach_rbridge_id_add_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.attach.rbridge_id', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.attach.rbridge_id', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_attach_rbridge_id_remove_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.attach.rbridge_id', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.attach.rbridge_id', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_attach_vlan_get(self, overlay_gateway=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type vlan: vid, mac
    :param vlan: Keyword argument tuple.

    :type vid: long
    :param vid: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type mac: unicode
    :param mac: **vlan** tuple argument:  Configure VLAN-MAC attachment

        * pattern restriction: ::

            '[0-9a-fA-F]{4}(\.[0-9a-fA-F]{4}){2}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.attach.vlan', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.attach.vlan', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'vid, mac', 'extra_keyval': 'vid, mac'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_enable_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.enable', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.enable', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_enable_statistics_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.enable.statistics', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.enable.statistics', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'stats_direction, vlan_action, vlan_list'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_enable_statistics_direction_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.enable.statistics', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.enable.statistics', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_enable_statistics_vlan_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.enable.statistics', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.enable.statistics', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_enable_statistics_vlan_list_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.enable.statistics', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.enable.statistics', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ip_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv4', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv4', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.ip', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.ip', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.ip', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ip_2_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.ip', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.ip', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ip_access_group_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv4.in_', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv4.in_', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ip_access_group_out_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv4.out', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv4.out', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ip_in_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv4.in_', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv4.in_', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ip_in__get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv4.in_', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv4.in_', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ip_interface_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.ip.interface', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.ip.interface', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.ip.interface', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.ip.interface', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.ip.interface', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ip_interface_loopback_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.ip.interface.loopback', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.ip.interface.loopback', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.ip.interface.loopback', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.ip.interface.loopback', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.ip.interface.loopback', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ip_interface_loopback_loopback_id_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.ip.interface.loopback', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.ip.interface.loopback', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.ip.interface.loopback', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.ip.interface.loopback', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.ip.interface.loopback', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ip_interface_ve_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.ip.interface.ve', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.ip.interface.ve', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.ip.interface.ve', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.ip.interface.ve', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.ip.interface.ve', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ip_interface_ve_ve_id_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.ip.interface.ve', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.ip.interface.ve', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.ip.interface.ve', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.ip.interface.ve', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.ip.interface.ve', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ip_interface_ve_vrrp_extended_group_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.ip.interface.ve', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.ip.interface.ve', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.ip.interface.ve', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.ip.interface.ve', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.ip.interface.ve', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ip_out_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv4.out', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv4.out', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ipv6_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv6', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv6', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ipv6_access_group_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv6.in_', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv6.in_', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ipv6_access_group_out_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv6.out', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv6.out', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ipv6_in_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv6.in_', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv6.in_', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ipv6_in__get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv6.in_', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv6.in_', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_ipv6_out_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv6.out', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv6.out', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_mac_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.mac', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.mac', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_mac_access_group_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.mac.in_', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.mac.in_', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_mac_access_group_out_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.mac.out', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.mac.out', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_mac_in_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.mac.in_', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.mac.in_', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_mac_in__get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.mac.in_', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.mac.in_', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_mac_out_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.access_lists.mac.out', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.mac.out', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_map_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.map_', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.map_', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.map_', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_map_bd_vni_mapping_get(self, overlay_gateway=None, bd_vni_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type bd_vni_mapping: bdid
    :param bd_vni_mapping: Keyword argument tuple.

    :type bdid: long
    :param bdid: **bd_vni_mapping** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay_gateway.map_.bd_vni_mapping', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_.bd_vni_mapping', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_.bd_vni_mapping', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vni_mapping', 'keyval': 'bdid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, bd_vni_mapping=bd_vni_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, bd_vni_mapping=bd_vni_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_map_bd_vni_mapping_vni_get(self, overlay_gateway=None, bd_vni_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type bd_vni_mapping: bdid
    :param bd_vni_mapping: Keyword argument tuple.

    :type bdid: long
    :param bdid: **bd_vni_mapping** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay_gateway.map_.bd_vni_mapping', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_.bd_vni_mapping', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_.bd_vni_mapping', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_vni_mapping', 'keyval': 'bdid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, bd_vni_mapping=bd_vni_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, bd_vni_mapping=bd_vni_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_map_vlan_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.map_.vlan', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.map_.vlan', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_map_vlan_and_bd_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay_gateway.map_.vlan_and_bd', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_.vlan_and_bd', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_.vlan_and_bd', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_map_vlan_vni_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.map_.vlan.vni', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.map_.vlan.vni', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_map_vlan_vni_auto_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.map_.vlan.vni', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.map_.vlan.vni', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_map_vlan_vni_mapping_get(self, overlay_gateway=None, vlan_vni_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type vlan_vni_mapping: vid
    :param vlan_vni_mapping: Keyword argument tuple.

    :type vid: long
    :param vid: **vlan_vni_mapping** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.map_.vlan_vni_mapping', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.map_.vlan_vni_mapping', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.map_.vlan_vni_mapping', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_.vlan_vni_mapping', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_.vlan_vni_mapping', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_vni_mapping', 'keyval': 'vid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, vlan_vni_mapping=vlan_vni_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, vlan_vni_mapping=vlan_vni_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_map_vlan_vni_mapping_vni_get(self, overlay_gateway=None, vlan_vni_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type vlan_vni_mapping: vid
    :param vlan_vni_mapping: Keyword argument tuple.

    :type vid: long
    :param vid: **vlan_vni_mapping** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.map_.vlan_vni_mapping', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.map_.vlan_vni_mapping', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.map_.vlan_vni_mapping', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_.vlan_vni_mapping', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_.vlan_vni_mapping', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_vni_mapping', 'keyval': 'vid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, vlan_vni_mapping=vlan_vni_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, vlan_vni_mapping=vlan_vni_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_map_vni_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay_gateway.map_.vlan_and_bd.vni', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_.vlan_and_bd.vni', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_.vlan_and_bd.vni', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_map_vni_auto_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay_gateway.map_.vlan_and_bd.vni', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_.vlan_and_bd.vni', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_.vlan_and_bd.vni', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_monitor_get(self, overlay_gateway=None, monitor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type monitor: session, direction, remote_endpoint, vlan_leaf, vlan_add_remove, vlan_range
    :param monitor: Keyword argument tuple.

    :type session: long
    :param session: **monitor** tuple argument:  Session number

        * range restriction: ::

            ['0..4294967295']

    :type direction: unicode
    :param direction: **monitor** tuple argument:  Specify flow direction

        * enumeration restriction: ::

            ['both', 'rx', 'tx']

    :type remote_endpoint: unicode
    :param remote_endpoint: **monitor** tuple argument:  Tunnel destination end point address

        * enumeration restriction: ::

            ['any']

    :type vlan_leaf: unicode
    :param vlan_leaf: **monitor** tuple argument:  Target VLAN IDs

        * enumeration restriction: ::

            ['vlan']

    :type vlan_add_remove: unicode
    :param vlan_add_remove: **monitor** tuple argument.

        * enumeration restriction: ::

            ['add', 'remove']

    :type vlan_range: unicode
    :param vlan_range: **monitor** tuple argument.

        * pattern restriction: ::

            '[0-9]+(-[0-9]+)?(,[0-9]+(-[0-9]+)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.monitor', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.monitor', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'monitor', 'keyval': 'session', 'extra_keyval': 'session, direction, remote_endpoint, vlan_leaf, vlan_add_remove, vlan_range'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, monitor=monitor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, monitor=monitor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_monitor_direction_get(self, overlay_gateway=None, monitor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type monitor: session
    :param monitor: Keyword argument tuple.

    :type session: long
    :param session: **monitor** tuple argument:  Session number

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.monitor', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.monitor', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'monitor', 'keyval': 'session', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, monitor=monitor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, monitor=monitor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_monitor_remote_endpoint_get(self, overlay_gateway=None, monitor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type monitor: session
    :param monitor: Keyword argument tuple.

    :type session: long
    :param session: **monitor** tuple argument:  Session number

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.monitor', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.monitor', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'monitor', 'keyval': 'session', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, monitor=monitor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, monitor=monitor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_monitor_vlan_add_remove_get(self, overlay_gateway=None, monitor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type monitor: session
    :param monitor: Keyword argument tuple.

    :type session: long
    :param session: **monitor** tuple argument:  Session number

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.monitor', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.monitor', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'monitor', 'keyval': 'session', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, monitor=monitor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, monitor=monitor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_monitor_vlan_leaf_get(self, overlay_gateway=None, monitor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type monitor: session
    :param monitor: Keyword argument tuple.

    :type session: long
    :param session: **monitor** tuple argument:  Session number

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.monitor', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.monitor', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'monitor', 'keyval': 'session', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, monitor=monitor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, monitor=monitor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_monitor_vlan_range_get(self, overlay_gateway=None, monitor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type monitor: session
    :param monitor: Keyword argument tuple.

    :type session: long
    :param session: **monitor** tuple argument:  Session number

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.monitor', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.monitor', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'monitor', 'keyval': 'session', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, monitor=monitor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, monitor=monitor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_overlay_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay_gateway.access_lists.overlay_acl_in', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.access_lists.overlay_acl_in', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'in_name, in_dir'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_overlay_access_group_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay_gateway.access_lists.overlay_acl_in', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.access_lists.overlay_acl_in', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_overlay_in_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay_gateway.access_lists.overlay_acl_in', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.access_lists.overlay_acl_in', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_overlay_service_policy_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_gateway.overlay_service_policy', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_overlay_service_policy_in_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_gateway.overlay_service_policy', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_qos_ttl_mode_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.overlay_gateway', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.overlay_gateway.map_', u'bd_vni_mapping'), ('pybind.slxos.v17r_2_00.overlay_gateway.ip.interface', u've'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_.vlan_and_bd', u'vni'), ('pybind.slxos.v17r_2_00.overlay_gateway.access_lists', u'overlay_acl_in'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_', u'vlan_vni_mapping'), ('pybind.slxos.v17r_2_00.overlay_gateway', u'site'), ('pybind.slxos.v17r_2_00.overlay_gateway.ip.interface', u'loopback')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_gateway', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bdid, vni'}, {'leafval': 've_id, vrrp_extended_group'}, {'leafval': 'auto'}, {'leafval': 'in_name, in_dir'}, {'leafval': 'vid, vni'}, {'leafval': 'name, description, bfd_enable, shutdown'}, {'leafval': 'loopback_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_sflow_get(self, overlay_gateway=None, sflow=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type sflow: sflow_profile_name, sflow_remote_endpoint, sflow_vlan_action, sflow_vlan_range
    :param sflow: Keyword argument tuple.

    :type sflow_profile_name: unicode
    :param sflow_profile_name: **sflow** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type sflow_remote_endpoint: unicode
    :param sflow_remote_endpoint: **sflow** tuple argument:  Tunnel destination end point address

        * enumeration restriction: ::

            ['any']

    :type sflow_vlan_action: unicode
    :param sflow_vlan_action: **sflow** tuple argument:  Target VLAN IDs

        * enumeration restriction: ::

            ['add', 'remove']

    :type sflow_vlan_range: unicode
    :param sflow_vlan_range: **sflow** tuple argument.

        * pattern restriction: ::

            '[0-9]+(-[0-9]+)?(,[0-9]+(-[0-9]+)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.sflow', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.sflow', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sflow', 'keyval': 'sflow_profile_name', 'extra_keyval': 'sflow_profile_name, sflow_remote_endpoint, sflow_vlan_action, sflow_vlan_range'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, sflow=sflow)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, sflow=sflow)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_sflow_remote_endpoint_get(self, overlay_gateway=None, sflow=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type sflow: sflow_profile_name
    :param sflow: Keyword argument tuple.

    :type sflow_profile_name: unicode
    :param sflow_profile_name: **sflow** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.sflow', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.sflow', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sflow', 'keyval': 'sflow_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, sflow=sflow)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, sflow=sflow)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_sflow_sflow_vlan_range_get(self, overlay_gateway=None, sflow=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type sflow: sflow_profile_name
    :param sflow: Keyword argument tuple.

    :type sflow_profile_name: unicode
    :param sflow_profile_name: **sflow** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.sflow', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.sflow', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sflow', 'keyval': 'sflow_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, sflow=sflow)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, sflow=sflow)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_sflow_vlan_get(self, overlay_gateway=None, sflow=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type sflow: sflow_profile_name
    :param sflow: Keyword argument tuple.

    :type sflow_profile_name: unicode
    :param sflow_profile_name: **sflow** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.sflow', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.sflow', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'sflow', 'keyval': 'sflow_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, sflow=sflow)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, sflow=sflow)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.site', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.site', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.overlay_gateway.site.extend', u'vlan'), ('pybind.nos.v6_0_2f.overlay_gateway.site.bfd.params', u'interval'), ('pybind.nos.v6_0_2f.overlay_gateway.site.bfd', u'params'), ('pybind.nos.v6_0_2f.overlay_gateway.site', u'tunnel_dst'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'tunnel_dst'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'static'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'mac_learning'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.extend', u'bridge_domain'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.extend', u'vlan'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.bfd', u'params'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.bfd.params', u'interval'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.extend', u'bridge_domain'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.bfd.params', u'interval'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.extend', u'vlan'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'tunnel_dst'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.bfd', u'params'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'mac_learning'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.bfd', u'params'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'static'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.extend', u'vlan'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'mac_learning'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'tunnel_dst'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.bfd.params', u'interval'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.extend', u'bridge_domain'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'mac_learning'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'tunnel_dst'), ('pybind.nos.v7_2_0.overlay_gateway.site.extend', u'vlan'), ('pybind.nos.v7_2_0.overlay_gateway.site.bfd.params', u'interval'), ('pybind.nos.v7_2_0.overlay_gateway.site.bfd', u'params')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'site', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'add_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'address'}, {'leafval': 'address'}, {'leafval': 'mac_address, vni_num'}, {'leafval': 'protocol'}, {'leafval': 'bd_add, bd_remove'}, {'leafval': 'add_, remove_'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bd_add, bd_remove'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'add_, remove_'}, {'leafval': 'address'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'protocol'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'mac_address, vni_num'}, {'leafval': 'add_, remove_'}, {'leafval': 'protocol'}, {'leafval': 'address'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bd_add, bd_remove'}, {'leafval': 'protocol'}, {'leafval': 'address'}, {'leafval': 'add_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_shutdown'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.overlay_gateway.site": {"bfd_enable": "bfd_enable", "name": "name", "shutdown": "shutdown"}, "pybind.slxos.v17r_2_00.overlay_gateway.site": {}, "pybind.nos.v7_2_0.overlay_gateway.site": {"bfd_enable": "bfd_enable", "name": "name", "shutdown": "shutdown"}, "pybind.slxos.v17s_1_02.overlay_gateway.site": {}, "pybind.nos.v6_0_2f.overlay_gateway.site": {"bfd_enable": "bfd_enable", "name": "name", "shutdown": "shutdown"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_bfd_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.site', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.site', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.overlay_gateway.site.extend', u'vlan'), ('pybind.nos.v6_0_2f.overlay_gateway.site.bfd.params', u'interval'), ('pybind.nos.v6_0_2f.overlay_gateway.site.bfd', u'params'), ('pybind.nos.v6_0_2f.overlay_gateway.site', u'tunnel_dst'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'tunnel_dst'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'static'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'mac_learning'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.extend', u'bridge_domain'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.extend', u'vlan'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.bfd', u'params'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.bfd.params', u'interval'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.extend', u'bridge_domain'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.bfd.params', u'interval'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.extend', u'vlan'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'tunnel_dst'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.bfd', u'params'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'mac_learning'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.bfd', u'params'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'static'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.extend', u'vlan'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'mac_learning'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'tunnel_dst'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.bfd.params', u'interval'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.extend', u'bridge_domain'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'mac_learning'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'tunnel_dst'), ('pybind.nos.v7_2_0.overlay_gateway.site.extend', u'vlan'), ('pybind.nos.v7_2_0.overlay_gateway.site.bfd.params', u'interval'), ('pybind.nos.v7_2_0.overlay_gateway.site.bfd', u'params')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'site', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'add_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'address'}, {'leafval': 'address'}, {'leafval': 'mac_address, vni_num'}, {'leafval': 'protocol'}, {'leafval': 'bd_add, bd_remove'}, {'leafval': 'add_, remove_'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bd_add, bd_remove'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'add_, remove_'}, {'leafval': 'address'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'protocol'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'mac_address, vni_num'}, {'leafval': 'add_, remove_'}, {'leafval': 'protocol'}, {'leafval': 'address'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bd_add, bd_remove'}, {'leafval': 'protocol'}, {'leafval': 'address'}, {'leafval': 'add_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_bfd_interval_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'site'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.bfd.params.interval', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.bfd.params.interval', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.bfd.params.interval', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_bfd_interval_min_rx_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'site'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.bfd.params.interval', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.bfd.params.interval', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.bfd.params.interval', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_bfd_interval_min_tx_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'site'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.bfd.params.interval', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.bfd.params.interval', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.bfd.params.interval', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_bfd_interval_multiplier_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'site'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.site.bfd.params.interval', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.bfd.params.interval', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.bfd.params.interval', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.bfd.params.interval', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_bfd_shutdown_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'site'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'site'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.site.bfd.params', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.site.bfd.params', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.bfd.params', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.bfd.params', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.bfd.params', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_description_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.slxos.v17r_2_00.overlay_gateway.site', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.overlay_gateway.site.bfd', u'params'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'static'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.extend', u'vlan'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'mac_learning'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'tunnel_dst'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.bfd.params', u'interval'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.extend', u'bridge_domain'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.extend', u'bridge_domain'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.bfd.params', u'interval'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.extend', u'vlan'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'tunnel_dst'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.bfd', u'params'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'mac_learning')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'site', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_shutdown'}, {'leafval': 'mac_address, vni_num'}, {'leafval': 'add_, remove_'}, {'leafval': 'protocol'}, {'leafval': 'address'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bd_add, bd_remove'}, {'leafval': 'bd_add, bd_remove'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'add_, remove_'}, {'leafval': 'address'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'protocol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_extend_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'site'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.site.extend', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.site.extend', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.extend', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.extend', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.extend', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_extend_bridge_domain_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'site'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay_gateway.site.extend.bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.extend.bridge_domain', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.extend.bridge_domain', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_extend_bridge_domain_add_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'site'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay_gateway.site.extend.bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.extend.bridge_domain', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.extend.bridge_domain', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_extend_bridge_domain_remove_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'site'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay_gateway.site.extend.bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.extend.bridge_domain', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.extend.bridge_domain', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_extend_vlan_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'site'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.site.extend.vlan', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.site.extend.vlan', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.extend.vlan', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.extend.vlan', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.extend.vlan', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_extend_vlan_add_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'site'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.site.extend.vlan', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.site.extend.vlan', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.extend.vlan', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.extend.vlan', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.extend.vlan', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_extend_vlan_remove_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'site'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.site.extend.vlan', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.site.extend.vlan', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.extend.vlan', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.extend.vlan', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.extend.vlan', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_ip_get(self, overlay_gateway=None, site=None, tunnel_dst=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    **Instance Keyword Argument Tuple**:

    :type tunnel_dst: address
    :param tunnel_dst: Keyword argument tuple.

    :type address: unicode
    :param address: **tunnel_dst** tuple argument:  Tunnel destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'site'), ('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v6_0_2f.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'site'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'site'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.site.tunnel_dst', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.site.tunnel_dst', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.tunnel_dst', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.tunnel_dst', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.tunnel_dst', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tunnel_dst', 'keyval': 'address', 'extra_keyval': 'address'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site, tunnel_dst=tunnel_dst)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site, tunnel_dst=tunnel_dst)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_mac_learning_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'site'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'site'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v7_2_0.overlay_gateway.site.mac_learning', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.mac_learning', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.mac_learning', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.mac_learning', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_mac_learning_protocol_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'site'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'site'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.nos.v7_2_0.overlay_gateway.site.mac_learning', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.mac_learning', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.mac_learning', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.mac_learning', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_shutdown_get(self, overlay_gateway=None, site=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    **Instance Keyword Argument Tuple**:

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.nos.v7_2_0.overlay_gateway', 'overlay_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway.site', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway.site', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.overlay_gateway.site.extend', u'vlan'), ('pybind.nos.v6_0_2f.overlay_gateway.site.bfd.params', u'interval'), ('pybind.nos.v6_0_2f.overlay_gateway.site.bfd', u'params'), ('pybind.nos.v6_0_2f.overlay_gateway.site', u'tunnel_dst'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'tunnel_dst'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'static'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'mac_learning'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.extend', u'bridge_domain'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.extend', u'vlan'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.bfd', u'params'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site.bfd.params', u'interval'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.extend', u'bridge_domain'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.bfd.params', u'interval'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.extend', u'vlan'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'tunnel_dst'), ('pybind.slxos.v17s_1_02.overlay_gateway.site.bfd', u'params'), ('pybind.slxos.v17s_1_02.overlay_gateway.site', u'mac_learning'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.bfd', u'params'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'static'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.extend', u'vlan'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'mac_learning'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'tunnel_dst'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.bfd.params', u'interval'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.extend', u'bridge_domain'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'mac_learning'), ('pybind.nos.v7_2_0.overlay_gateway.site', u'tunnel_dst'), ('pybind.nos.v7_2_0.overlay_gateway.site.extend', u'vlan'), ('pybind.nos.v7_2_0.overlay_gateway.site.bfd.params', u'interval'), ('pybind.nos.v7_2_0.overlay_gateway.site.bfd', u'params')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'site', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'add_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'address'}, {'leafval': 'address'}, {'leafval': 'mac_address, vni_num'}, {'leafval': 'protocol'}, {'leafval': 'bd_add, bd_remove'}, {'leafval': 'add_, remove_'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bd_add, bd_remove'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'add_, remove_'}, {'leafval': 'address'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'protocol'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'mac_address, vni_num'}, {'leafval': 'add_, remove_'}, {'leafval': 'protocol'}, {'leafval': 'address'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bd_add, bd_remove'}, {'leafval': 'protocol'}, {'leafval': 'address'}, {'leafval': 'add_, remove_'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_site_static_get(self, overlay_gateway=None, site=None, static=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type site: name
    :param site: Keyword argument tuple.

    :type name: unicode
    :param name: **site** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,63}'

    **Instance Keyword Argument Tuple**:

    :type static: mac_address, vni_num
    :param static: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **static** tuple argument:  Specifify the Static MAC for the site

    :type vni_num: long
    :param vni_num: **static** tuple argument:  Specify the VNI number for the Static MAC

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_1_01a.overlay_gateway.site', u'site'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'overlay_gateway'), ('pybind.slxos.v17r_2_00.overlay_gateway.site', u'site')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay_gateway.site.static', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway.site.static', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static', 'keyval': 'mac_address, vni_num', 'extra_keyval': 'mac_address, vni_num'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway, site=site, static=static)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway, site=site, static=static)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_gateway_type_get(self, overlay_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_gateway: name
    :param overlay_gateway: Keyword argument tuple.

    :type name: unicode
    :param name: **overlay_gateway** tuple argument.

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.overlay_gateway', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.overlay_gateway', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.overlay_gateway', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_gateway', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_gateway', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_gateway', u'overlay_service_policy'), ('pybind.slxos.v17s_1_02.overlay_gateway.ip.interface', u've'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_', u'bd_vni_mapping'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_.vlan_and_bd', u'vni'), ('pybind.slxos.v17s_1_02.overlay_gateway.ip.interface', u'loopback'), ('pybind.slxos.v17s_1_02.overlay_gateway', u'site'), ('pybind.slxos.v17s_1_02.overlay_gateway.map_', u'vlan_vni_mapping'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_', u'bd_vni_mapping'), ('pybind.slxos.v17r_2_00.overlay_gateway.ip.interface', u've'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_.vlan_and_bd', u'vni'), ('pybind.slxos.v17r_2_00.overlay_gateway.access_lists', u'overlay_acl_in'), ('pybind.slxos.v17r_2_00.overlay_gateway.map_', u'vlan_vni_mapping'), ('pybind.slxos.v17r_2_00.overlay_gateway', u'site'), ('pybind.slxos.v17r_2_00.overlay_gateway.ip.interface', u'loopback'), ('pybind.nos.v6_0_2f.overlay_gateway.attach', u'vlan'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv6', u'in_'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.mac', u'in_'), ('pybind.nos.v6_0_2f.overlay_gateway', u'site'), ('pybind.nos.v6_0_2f.overlay_gateway.map_.vlan', u'vni'), ('pybind.nos.v6_0_2f.overlay_gateway.attach', u'rbridge_id'), ('pybind.nos.v6_0_2f.overlay_gateway.map_', u'vlan_vni_mapping'), ('pybind.nos.v6_0_2f.overlay_gateway.enable', u'statistics'), ('pybind.nos.v6_0_2f.overlay_gateway.ip.interface', u'loopback'), ('pybind.nos.v6_0_2f.overlay_gateway', u'monitor'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv4', u'out'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv6', u'out'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.mac', u'out'), ('pybind.nos.v6_0_2f.overlay_gateway.ip.interface', u've'), ('pybind.nos.v6_0_2f.overlay_gateway', u'sflow'), ('pybind.nos.v6_0_2f.overlay_gateway.access_lists.ipv4', u'in_'), ('pybind.slxos.v17r_1_01a.overlay_gateway.ip.interface', u'loopback'), ('pybind.slxos.v17r_1_01a.overlay_gateway', u'site'), ('pybind.slxos.v17r_1_01a.overlay_gateway.map_', u'vlan_vni_mapping'), ('pybind.slxos.v17r_1_01a.overlay_gateway.access_lists', u'overlay_acl_in'), ('pybind.slxos.v17r_1_01a.overlay_gateway.map_.vlan_and_bd', u'vni'), ('pybind.slxos.v17r_1_01a.overlay_gateway.ip.interface', u've'), ('pybind.slxos.v17r_1_01a.overlay_gateway.map_', u'bd_vni_mapping'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.mac', u'out'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv4', u'in_'), ('pybind.nos.v7_2_0.overlay_gateway', u'sflow'), ('pybind.nos.v7_2_0.overlay_gateway.attach', u'rbridge_id'), ('pybind.nos.v7_2_0.overlay_gateway.ip.interface', u'loopback'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv6', u'in_'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.mac', u'in_'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv4', u'out'), ('pybind.nos.v7_2_0.overlay_gateway.ip.interface', u've'), ('pybind.nos.v7_2_0.overlay_gateway.map_.vlan', u'vni'), ('pybind.nos.v7_2_0.overlay_gateway.map_', u'vlan_vni_mapping'), ('pybind.nos.v7_2_0.overlay_gateway.enable', u'statistics'), ('pybind.nos.v7_2_0.overlay_gateway', u'site'), ('pybind.nos.v7_2_0.overlay_gateway.attach', u'vlan'), ('pybind.nos.v7_2_0.overlay_gateway.access_lists.ipv6', u'out'), ('pybind.nos.v7_2_0.overlay_gateway', u'monitor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_gateway', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'policy_in'}, {'leafval': 've_id, vrrp_extended_group'}, {'leafval': 'bdid, vni'}, {'leafval': 'auto'}, {'leafval': 'loopback_id'}, {'leafval': 'name, description, bfd_enable, shutdown'}, {'leafval': 'vid, vni'}, {'leafval': 'bdid, vni'}, {'leafval': 've_id, vrrp_extended_group'}, {'leafval': 'auto'}, {'leafval': 'in_name, in_dir'}, {'leafval': 'vid, vni'}, {'leafval': 'name, description, bfd_enable, shutdown'}, {'leafval': 'loopback_id'}, {'leafval': 'vid, mac'}, {'leafval': 'ipv6_acl_in_name, ipv6_acl_in_dir'}, {'leafval': 'mac_acl_in_name, mac_acl_in_dir'}, {'leafval': 'name, bfd_enable, shutdown'}, {'leafval': 'auto'}, {'leafval': 'rb_add, rb_remove'}, {'leafval': 'vid, vni'}, {'leafval': 'stats_direction, vlan_action, vlan_list'}, {'leafval': 'loopback_id'}, {'leafval': 'session, direction, remote_endpoint, vlan_leaf, vlan_add_remove, vlan_range'}, {'leafval': 'ipv4_acl_out_name, ipv4_acl_out_dir'}, {'leafval': 'ipv6_acl_out_name, ipv6_acl_out_dir'}, {'leafval': 'mac_acl_out_name, mac_acl_out_dir'}, {'leafval': 've_id, vrrp_extended_group'}, {'leafval': 'sflow_profile_name, sflow_remote_endpoint, sflow_vlan_action, sflow_vlan_range'}, {'leafval': 'ipv4_acl_in_name, ipv4_acl_in_dir'}, {'leafval': 'loopback_id'}, {'leafval': 'name, bfd_enable, shutdown'}, {'leafval': 'vid, vni'}, {'leafval': 'in_name, in_dir'}, {'leafval': 'auto'}, {'leafval': 've_id, vrrp_extended_group'}, {'leafval': 'bdid, vni'}, {'leafval': 'mac_acl_out_name, mac_acl_out_dir'}, {'leafval': 'ipv4_acl_in_name, ipv4_acl_in_dir'}, {'leafval': 'sflow_profile_name, sflow_remote_endpoint, sflow_vlan_action, sflow_vlan_range'}, {'leafval': 'rb_add, rb_remove'}, {'leafval': 'loopback_id'}, {'leafval': 'ipv6_acl_in_name, ipv6_acl_in_dir'}, {'leafval': 'mac_acl_in_name, mac_acl_in_dir'}, {'leafval': 'ipv4_acl_out_name, ipv4_acl_out_dir'}, {'leafval': 've_id, vrrp_extended_group'}, {'leafval': 'auto'}, {'leafval': 'vid, vni'}, {'leafval': 'stats_direction, vlan_action, vlan_list'}, {'leafval': 'name, bfd_enable, shutdown'}, {'leafval': 'vid, mac'}, {'leafval': 'ipv6_acl_out_name, ipv6_acl_out_dir'}, {'leafval': 'session, direction, remote_endpoint, vlan_leaf, vlan_add_remove, vlan_range'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_gateway=overlay_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_gateway=overlay_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_get(self, overlay_policy_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_policy_map: pmap_name
    :param overlay_policy_map: Keyword argument tuple.

    :type pmap_name: unicode
    :param pmap_name: **overlay_policy_map** tuple argument:  Overlay Policy Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_policy_map', u'pmap_seq')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_policy_map', 'keyval': 'pmap_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'pmap_seq_num, overlay_class'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map=overlay_policy_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map=overlay_policy_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_get_next_cookie_state_get(self, overlay_policy_map_get_next_cookie_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_policy_map_get_next_cookie_state: seq_id
    :param overlay_policy_map_get_next_cookie_state: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **overlay_policy_map_get_next_cookie_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_get_next_cookie_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_policy_map_get_next_cookie_state', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map_get_next_cookie_state=overlay_policy_map_get_next_cookie_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map_get_next_cookie_state=overlay_policy_map_get_next_cookie_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_get_next_cookie_state_policy_name_get(self, overlay_policy_map_get_next_cookie_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_policy_map_get_next_cookie_state: seq_id
    :param overlay_policy_map_get_next_cookie_state: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **overlay_policy_map_get_next_cookie_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_get_next_cookie_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_policy_map_get_next_cookie_state', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map_get_next_cookie_state=overlay_policy_map_get_next_cookie_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map_get_next_cookie_state=overlay_policy_map_get_next_cookie_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_seq_get(self, overlay_policy_map=None, pmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map: pmap_name
    :param overlay_policy_map: Keyword argument tuple.

    :type pmap_name: unicode
    :param pmap_name: **overlay_policy_map** tuple argument:  Overlay Policy Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type pmap_seq: pmap_seq_num, overlay_class
    :param pmap_seq: Keyword argument tuple.

    :type pmap_seq_num: long
    :param pmap_seq_num: **pmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type overlay_class: unicode
    :param overlay_class: **pmap_seq** tuple argument:  Attach overlay-class-map

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map', 'overlay_policy_map')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq.ipv6_acl.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq.ip_acl.ip', u'access_group'), ('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq', u'service_policy'), ('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq.mac_acl.mac', u'access_group')]
    compositions_keyval_list = [{'keyval': 'pmap_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pmap_seq', 'keyval': 'pmap_seq_num, overlay_class', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_access_list'}, {'leafval': 'ip_access_list'}, {'leafval': 'sp_name'}, {'leafval': 'mac_access_list'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_seq_ip_get(self, overlay_policy_map=None, pmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map: pmap_name
    :param overlay_policy_map: Keyword argument tuple.

    :type pmap_name: unicode
    :param pmap_name: **overlay_policy_map** tuple argument:  Overlay Policy Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type pmap_seq: pmap_seq_num, overlay_class
    :param pmap_seq: Keyword argument tuple.

    :type pmap_seq_num: long
    :param pmap_seq_num: **pmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type overlay_class: unicode
    :param overlay_class: **pmap_seq** tuple argument:  Attach overlay-class-map

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map', 'overlay_policy_map'), ('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq', u'pmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq.ip_acl.ip', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pmap_name', 'extra_keyval': ''}, {'keyval': 'pmap_seq_num, overlay_class', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_seq_ip_access_group_get(self, overlay_policy_map=None, pmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map: pmap_name
    :param overlay_policy_map: Keyword argument tuple.

    :type pmap_name: unicode
    :param pmap_name: **overlay_policy_map** tuple argument:  Overlay Policy Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type pmap_seq: pmap_seq_num, overlay_class
    :param pmap_seq: Keyword argument tuple.

    :type pmap_seq_num: long
    :param pmap_seq_num: **pmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type overlay_class: unicode
    :param overlay_class: **pmap_seq** tuple argument:  Attach overlay-class-map

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map', 'overlay_policy_map'), ('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq', u'pmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq.ip_acl.ip.access_group', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pmap_name', 'extra_keyval': ''}, {'keyval': 'pmap_seq_num, overlay_class', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_seq_ip_access_group_ip_access_list_get(self, overlay_policy_map=None, pmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map: pmap_name
    :param overlay_policy_map: Keyword argument tuple.

    :type pmap_name: unicode
    :param pmap_name: **overlay_policy_map** tuple argument:  Overlay Policy Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type pmap_seq: pmap_seq_num, overlay_class
    :param pmap_seq: Keyword argument tuple.

    :type pmap_seq_num: long
    :param pmap_seq_num: **pmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type overlay_class: unicode
    :param overlay_class: **pmap_seq** tuple argument:  Attach overlay-class-map

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map', 'overlay_policy_map'), ('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq', u'pmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq.ip_acl.ip.access_group', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pmap_name', 'extra_keyval': ''}, {'keyval': 'pmap_seq_num, overlay_class', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_seq_ipv6_get(self, overlay_policy_map=None, pmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map: pmap_name
    :param overlay_policy_map: Keyword argument tuple.

    :type pmap_name: unicode
    :param pmap_name: **overlay_policy_map** tuple argument:  Overlay Policy Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type pmap_seq: pmap_seq_num, overlay_class
    :param pmap_seq: Keyword argument tuple.

    :type pmap_seq_num: long
    :param pmap_seq_num: **pmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type overlay_class: unicode
    :param overlay_class: **pmap_seq** tuple argument:  Attach overlay-class-map

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map', 'overlay_policy_map'), ('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq', u'pmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq.ipv6_acl.ipv6', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pmap_name', 'extra_keyval': ''}, {'keyval': 'pmap_seq_num, overlay_class', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_seq_ipv6_access_group_get(self, overlay_policy_map=None, pmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map: pmap_name
    :param overlay_policy_map: Keyword argument tuple.

    :type pmap_name: unicode
    :param pmap_name: **overlay_policy_map** tuple argument:  Overlay Policy Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type pmap_seq: pmap_seq_num, overlay_class
    :param pmap_seq: Keyword argument tuple.

    :type pmap_seq_num: long
    :param pmap_seq_num: **pmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type overlay_class: unicode
    :param overlay_class: **pmap_seq** tuple argument:  Attach overlay-class-map

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map', 'overlay_policy_map'), ('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq', u'pmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq.ipv6_acl.ipv6.access_group', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pmap_name', 'extra_keyval': ''}, {'keyval': 'pmap_seq_num, overlay_class', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_seq_ipv6_access_group_ipv6_access_list_get(self, overlay_policy_map=None, pmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map: pmap_name
    :param overlay_policy_map: Keyword argument tuple.

    :type pmap_name: unicode
    :param pmap_name: **overlay_policy_map** tuple argument:  Overlay Policy Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type pmap_seq: pmap_seq_num, overlay_class
    :param pmap_seq: Keyword argument tuple.

    :type pmap_seq_num: long
    :param pmap_seq_num: **pmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type overlay_class: unicode
    :param overlay_class: **pmap_seq** tuple argument:  Attach overlay-class-map

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map', 'overlay_policy_map'), ('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq', u'pmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq.ipv6_acl.ipv6.access_group', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pmap_name', 'extra_keyval': ''}, {'keyval': 'pmap_seq_num, overlay_class', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_seq_ipv6_acl_get(self, overlay_policy_map=None, pmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map: pmap_name
    :param overlay_policy_map: Keyword argument tuple.

    :type pmap_name: unicode
    :param pmap_name: **overlay_policy_map** tuple argument:  Overlay Policy Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type pmap_seq: pmap_seq_num, overlay_class
    :param pmap_seq: Keyword argument tuple.

    :type pmap_seq_num: long
    :param pmap_seq_num: **pmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type overlay_class: unicode
    :param overlay_class: **pmap_seq** tuple argument:  Attach overlay-class-map

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map', 'overlay_policy_map'), ('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq', u'pmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq.ipv6_acl', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pmap_name', 'extra_keyval': ''}, {'keyval': 'pmap_seq_num, overlay_class', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_seq_mac_get(self, overlay_policy_map=None, pmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map: pmap_name
    :param overlay_policy_map: Keyword argument tuple.

    :type pmap_name: unicode
    :param pmap_name: **overlay_policy_map** tuple argument:  Overlay Policy Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type pmap_seq: pmap_seq_num, overlay_class
    :param pmap_seq: Keyword argument tuple.

    :type pmap_seq_num: long
    :param pmap_seq_num: **pmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type overlay_class: unicode
    :param overlay_class: **pmap_seq** tuple argument:  Attach overlay-class-map

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map', 'overlay_policy_map'), ('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq', u'pmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq.mac_acl.mac', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pmap_name', 'extra_keyval': ''}, {'keyval': 'pmap_seq_num, overlay_class', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_seq_mac_access_group_get(self, overlay_policy_map=None, pmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map: pmap_name
    :param overlay_policy_map: Keyword argument tuple.

    :type pmap_name: unicode
    :param pmap_name: **overlay_policy_map** tuple argument:  Overlay Policy Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type pmap_seq: pmap_seq_num, overlay_class
    :param pmap_seq: Keyword argument tuple.

    :type pmap_seq_num: long
    :param pmap_seq_num: **pmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type overlay_class: unicode
    :param overlay_class: **pmap_seq** tuple argument:  Attach overlay-class-map

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map', 'overlay_policy_map'), ('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq', u'pmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq.mac_acl.mac.access_group', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pmap_name', 'extra_keyval': ''}, {'keyval': 'pmap_seq_num, overlay_class', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_seq_mac_access_group_mac_access_list_get(self, overlay_policy_map=None, pmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map: pmap_name
    :param overlay_policy_map: Keyword argument tuple.

    :type pmap_name: unicode
    :param pmap_name: **overlay_policy_map** tuple argument:  Overlay Policy Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type pmap_seq: pmap_seq_num, overlay_class
    :param pmap_seq: Keyword argument tuple.

    :type pmap_seq_num: long
    :param pmap_seq_num: **pmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type overlay_class: unicode
    :param overlay_class: **pmap_seq** tuple argument:  Attach overlay-class-map

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map', 'overlay_policy_map'), ('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq', u'pmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq.mac_acl.mac.access_group', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pmap_name', 'extra_keyval': ''}, {'keyval': 'pmap_seq_num, overlay_class', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_seq_mac_acl_get(self, overlay_policy_map=None, pmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map: pmap_name
    :param overlay_policy_map: Keyword argument tuple.

    :type pmap_name: unicode
    :param pmap_name: **overlay_policy_map** tuple argument:  Overlay Policy Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type pmap_seq: pmap_seq_num, overlay_class
    :param pmap_seq: Keyword argument tuple.

    :type pmap_seq_num: long
    :param pmap_seq_num: **pmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type overlay_class: unicode
    :param overlay_class: **pmap_seq** tuple argument:  Attach overlay-class-map

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map', 'overlay_policy_map'), ('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq', u'pmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq.mac_acl', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pmap_name', 'extra_keyval': ''}, {'keyval': 'pmap_seq_num, overlay_class', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_seq_service_policy_get(self, overlay_policy_map=None, pmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map: pmap_name
    :param overlay_policy_map: Keyword argument tuple.

    :type pmap_name: unicode
    :param pmap_name: **overlay_policy_map** tuple argument:  Overlay Policy Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type pmap_seq: pmap_seq_num, overlay_class
    :param pmap_seq: Keyword argument tuple.

    :type pmap_seq_num: long
    :param pmap_seq_num: **pmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type overlay_class: unicode
    :param overlay_class: **pmap_seq** tuple argument:  Attach overlay-class-map

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map', 'overlay_policy_map'), ('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq', u'pmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq.service_policy', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pmap_name', 'extra_keyval': ''}, {'keyval': 'pmap_seq_num, overlay_class', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_seq_service_policy_sp_name_get(self, overlay_policy_map=None, pmap_seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map: pmap_name
    :param overlay_policy_map: Keyword argument tuple.

    :type pmap_name: unicode
    :param pmap_name: **overlay_policy_map** tuple argument:  Overlay Policy Map Name (Max Size - 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type pmap_seq: pmap_seq_num, overlay_class
    :param pmap_seq: Keyword argument tuple.

    :type pmap_seq_num: long
    :param pmap_seq_num: **pmap_seq** tuple argument:  Sequence number

        * range restriction: ::

            ['0..18446744073709551615']

    :type overlay_class: unicode
    :param overlay_class: **pmap_seq** tuple argument:  Attach overlay-class-map

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map', 'overlay_policy_map'), ('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq', u'pmap_seq')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map.pmap_seq.service_policy', 'pybind.slxos.v17s_1_02.brocade_overlay_policy', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pmap_name', 'extra_keyval': ''}, {'keyval': 'pmap_seq_num, overlay_class', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map=overlay_policy_map, pmap_seq=pmap_seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_state_get(self, overlay_policy_map_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_policy_map_state: policy_name
    :param overlay_policy_map_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_policy_map_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state', u'overlay_class'), ('pybind.slxos.v17s_1_02.overlay_policy_map_state', u'active_on')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_policy_map_state', 'keyval': 'policy_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, overlay_class_name, mac_acl_name, ip_acl_name, ipv6_acl_name, service_policy_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map_state=overlay_policy_map_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map_state=overlay_policy_map_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_state_active_on_get(self, overlay_policy_map_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map_state: policy_name
    :param overlay_policy_map_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_policy_map_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state', 'overlay_policy_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state.active_on', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map_state=overlay_policy_map_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map_state=overlay_policy_map_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_state_active_on_interface_name_get(self, overlay_policy_map_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map_state: policy_name
    :param overlay_policy_map_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_policy_map_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state', 'overlay_policy_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state.active_on', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map_state=overlay_policy_map_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map_state=overlay_policy_map_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_state_active_on_interface_type_get(self, overlay_policy_map_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map_state: policy_name
    :param overlay_policy_map_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_policy_map_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state', 'overlay_policy_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state.active_on', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map_state=overlay_policy_map_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map_state=overlay_policy_map_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_state_overlay_class_get(self, overlay_policy_map_state=None, overlay_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map_state: policy_name
    :param overlay_policy_map_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_policy_map_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type overlay_class: seq_id
    :param overlay_class: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **overlay_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state', 'overlay_policy_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state.overlay_class', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'overlay_class', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map_state=overlay_policy_map_state, overlay_class=overlay_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map_state=overlay_policy_map_state, overlay_class=overlay_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_state_overlay_class_ip_acl_name_get(self, overlay_policy_map_state=None, overlay_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map_state: policy_name
    :param overlay_policy_map_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_policy_map_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type overlay_class: seq_id
    :param overlay_class: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **overlay_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state', 'overlay_policy_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state.overlay_class', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'overlay_class', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map_state=overlay_policy_map_state, overlay_class=overlay_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map_state=overlay_policy_map_state, overlay_class=overlay_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_state_overlay_class_ipv6_acl_name_get(self, overlay_policy_map_state=None, overlay_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map_state: policy_name
    :param overlay_policy_map_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_policy_map_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type overlay_class: seq_id
    :param overlay_class: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **overlay_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state', 'overlay_policy_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state.overlay_class', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'overlay_class', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map_state=overlay_policy_map_state, overlay_class=overlay_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map_state=overlay_policy_map_state, overlay_class=overlay_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_state_overlay_class_mac_acl_name_get(self, overlay_policy_map_state=None, overlay_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map_state: policy_name
    :param overlay_policy_map_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_policy_map_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type overlay_class: seq_id
    :param overlay_class: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **overlay_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state', 'overlay_policy_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state.overlay_class', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'overlay_class', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map_state=overlay_policy_map_state, overlay_class=overlay_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map_state=overlay_policy_map_state, overlay_class=overlay_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_state_overlay_class_overlay_class_name_get(self, overlay_policy_map_state=None, overlay_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map_state: policy_name
    :param overlay_policy_map_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_policy_map_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type overlay_class: seq_id
    :param overlay_class: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **overlay_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state', 'overlay_policy_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state.overlay_class', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'overlay_class', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map_state=overlay_policy_map_state, overlay_class=overlay_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map_state=overlay_policy_map_state, overlay_class=overlay_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_policy_map_state_overlay_class_service_policy_name_get(self, overlay_policy_map_state=None, overlay_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_policy_map_state: policy_name
    :param overlay_policy_map_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_policy_map_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type overlay_class: seq_id
    :param overlay_class: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **overlay_class** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state', 'overlay_policy_map_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_policy_map_state.overlay_class', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'overlay_class', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_policy_map_state=overlay_policy_map_state, overlay_class=overlay_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_policy_map_state=overlay_policy_map_state, overlay_class=overlay_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_brief_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_brief_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_brief_state', u'active_interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, direction, policy_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_brief_state_active_interfaces_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_brief_state.active_interfaces', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_brief_state_active_interfaces_direction_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_brief_state.active_interfaces', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_brief_state_active_interfaces_interface_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_brief_state.active_interfaces', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_brief_state_active_interfaces_interface_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_brief_state.active_interfaces', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_brief_state_active_interfaces_policy_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_brief_state.active_interfaces', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_get_next_cookie_state_get(self, overlay_service_policy_get_next_cookie_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_service_policy_get_next_cookie_state: seq_id
    :param overlay_service_policy_get_next_cookie_state: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **overlay_service_policy_get_next_cookie_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_get_next_cookie_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_service_policy_get_next_cookie_state', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_get_next_cookie_state=overlay_service_policy_get_next_cookie_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_get_next_cookie_state=overlay_service_policy_get_next_cookie_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_get_next_cookie_state_direction_get(self, overlay_service_policy_get_next_cookie_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_service_policy_get_next_cookie_state: seq_id
    :param overlay_service_policy_get_next_cookie_state: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **overlay_service_policy_get_next_cookie_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_get_next_cookie_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_service_policy_get_next_cookie_state', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_get_next_cookie_state=overlay_service_policy_get_next_cookie_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_get_next_cookie_state=overlay_service_policy_get_next_cookie_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_get_next_cookie_state_interface_name_get(self, overlay_service_policy_get_next_cookie_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_service_policy_get_next_cookie_state: seq_id
    :param overlay_service_policy_get_next_cookie_state: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **overlay_service_policy_get_next_cookie_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_get_next_cookie_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_service_policy_get_next_cookie_state', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_get_next_cookie_state=overlay_service_policy_get_next_cookie_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_get_next_cookie_state=overlay_service_policy_get_next_cookie_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_get_next_cookie_state_interface_type_get(self, overlay_service_policy_get_next_cookie_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_service_policy_get_next_cookie_state: seq_id
    :param overlay_service_policy_get_next_cookie_state: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **overlay_service_policy_get_next_cookie_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_get_next_cookie_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_service_policy_get_next_cookie_state', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_get_next_cookie_state=overlay_service_policy_get_next_cookie_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_get_next_cookie_state=overlay_service_policy_get_next_cookie_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_get_next_cookie_state_policy_name_get(self, overlay_service_policy_get_next_cookie_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_service_policy_get_next_cookie_state: seq_id
    :param overlay_service_policy_get_next_cookie_state: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **overlay_service_policy_get_next_cookie_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_get_next_cookie_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_service_policy_get_next_cookie_state', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_get_next_cookie_state=overlay_service_policy_get_next_cookie_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_get_next_cookie_state=overlay_service_policy_get_next_cookie_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_get(self, overlay_service_policy_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', u'bind_interfaces'), ('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces', u'class_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_service_policy_state', 'keyval': 'policy_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, direction'}, {'leafval': 'seq_id, overlay_class_name, overlay_class_status, mac_acl_name, mac_acl_status, ip_acl_name, ip_acl_status, ipv6_acl_name, ipv6_acl_status, service_policy_name, service_policy_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_get(self, overlay_service_policy_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_get(self, overlay_service_policy_state=None, class_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'rules_list')]
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'class_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, source, destination, endpoint, encap_type, vni, status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_ip_acl_name_get(self, overlay_service_policy_state=None, class_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'rules_list')]
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'class_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, source, destination, endpoint, encap_type, vni, status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_ip_acl_status_get(self, overlay_service_policy_state=None, class_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'rules_list')]
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'class_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, source, destination, endpoint, encap_type, vni, status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_ipv6_acl_name_get(self, overlay_service_policy_state=None, class_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'rules_list')]
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'class_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, source, destination, endpoint, encap_type, vni, status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_ipv6_acl_status_get(self, overlay_service_policy_state=None, class_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'rules_list')]
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'class_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, source, destination, endpoint, encap_type, vni, status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_mac_acl_name_get(self, overlay_service_policy_state=None, class_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'rules_list')]
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'class_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, source, destination, endpoint, encap_type, vni, status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_mac_acl_status_get(self, overlay_service_policy_state=None, class_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'rules_list')]
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'class_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, source, destination, endpoint, encap_type, vni, status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_overlay_class_name_get(self, overlay_service_policy_state=None, class_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'rules_list')]
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'class_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, source, destination, endpoint, encap_type, vni, status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_overlay_class_status_get(self, overlay_service_policy_state=None, class_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'rules_list')]
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'class_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, source, destination, endpoint, encap_type, vni, status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_rules_list_get(self, overlay_service_policy_state=None, class_list=None, rules_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rules_list: seq_id
    :param rules_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **rules_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state'), ('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'class_list')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list.rules_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}, {'keyval': 'seq_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rules_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list, rules_list=rules_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list, rules_list=rules_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_rules_list_destination_get(self, overlay_service_policy_state=None, class_list=None, rules_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rules_list: seq_id
    :param rules_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **rules_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state'), ('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'class_list')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list.rules_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}, {'keyval': 'seq_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rules_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list, rules_list=rules_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list, rules_list=rules_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_rules_list_encap_type_get(self, overlay_service_policy_state=None, class_list=None, rules_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rules_list: seq_id
    :param rules_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **rules_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state'), ('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'class_list')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list.rules_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}, {'keyval': 'seq_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rules_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list, rules_list=rules_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list, rules_list=rules_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_rules_list_endpoint_get(self, overlay_service_policy_state=None, class_list=None, rules_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rules_list: seq_id
    :param rules_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **rules_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state'), ('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'class_list')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list.rules_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}, {'keyval': 'seq_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rules_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list, rules_list=rules_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list, rules_list=rules_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_rules_list_source_get(self, overlay_service_policy_state=None, class_list=None, rules_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rules_list: seq_id
    :param rules_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **rules_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state'), ('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'class_list')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list.rules_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}, {'keyval': 'seq_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rules_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list, rules_list=rules_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list, rules_list=rules_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_rules_list_status_get(self, overlay_service_policy_state=None, class_list=None, rules_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rules_list: seq_id
    :param rules_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **rules_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state'), ('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'class_list')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list.rules_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}, {'keyval': 'seq_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rules_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list, rules_list=rules_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list, rules_list=rules_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_rules_list_vni_get(self, overlay_service_policy_state=None, class_list=None, rules_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rules_list: seq_id
    :param rules_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **rules_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state'), ('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'class_list')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list.rules_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}, {'keyval': 'seq_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rules_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list, rules_list=rules_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list, rules_list=rules_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_service_policy_name_get(self, overlay_service_policy_state=None, class_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'rules_list')]
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'class_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, source, destination, endpoint, encap_type, vni, status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_class_list_service_policy_status_get(self, overlay_service_policy_state=None, class_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type class_list: seq_id
    :param class_list: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **class_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces.class_list', u'rules_list')]
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'class_list', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, source, destination, endpoint, encap_type, vni, status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state, class_list=class_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_direction_get(self, overlay_service_policy_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_interface_name_get(self, overlay_service_policy_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_bind_interfaces_interface_type_get(self, overlay_service_policy_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'overlay_service_policy_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_service_policy_state_details_get(self, overlay_service_policy_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_service_policy_state: policy_name
    :param overlay_service_policy_state: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **overlay_service_policy_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_service_policy_state', u'bind_interfaces'), ('pybind.slxos.v17s_1_02.overlay_service_policy_state.bind_interfaces', u'class_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_service_policy_state', 'keyval': 'policy_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, direction'}, {'leafval': 'seq_id, overlay_class_name, overlay_class_status, mac_acl_name, mac_acl_status, ip_acl_name, ip_acl_status, ipv6_acl_name, ipv6_acl_status, service_policy_name, service_policy_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_service_policy_state=overlay_service_policy_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_service_policy_state=overlay_service_policy_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_get(self, overlay_transit=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type overlay_transit: user_transit_name
    :param overlay_transit: Keyword argument tuple.

    :type user_transit_name: unicode
    :param user_transit_name: **overlay_transit** tuple argument:  User Transit Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay_transit', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_transit', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_transit', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.overlay_transit', u'transit_overlay'), ('pybind.slxos.v17r_2_00.overlay_transit', u'transit_overlay'), ('pybind.slxos.v17s_1_02.overlay_transit', u'overlay_service_policy'), ('pybind.slxos.v17s_1_02.overlay_transit', u'transit_overlay')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_transit', 'keyval': 'user_transit_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'access_group, in_out'}, {'leafval': 'access_group, in_out'}, {'leafval': 'overlay_sp_direction, overlay_sp_pmap_name'}, {'leafval': 'access_group, in_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_transit=overlay_transit)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_transit=overlay_transit)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_overlay_get(self, overlay_transit=None, transit_overlay=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type overlay_transit: user_transit_name
    :param overlay_transit: Keyword argument tuple.

    :type user_transit_name: unicode
    :param user_transit_name: **overlay_transit** tuple argument:  User Transit Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type transit_overlay: access_group, in_out
    :param transit_overlay: Keyword argument tuple.

    :type access_group: unicode
    :param access_group: **transit_overlay** tuple argument:  Access Group Name (Max 63)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,62})'

    :type in_out: unicode
    :param in_out: **transit_overlay** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.overlay_transit', 'overlay_transit'), ('pybind.slxos.v17r_2_00.overlay_transit', 'overlay_transit'), ('pybind.slxos.v17r_1_01a.overlay_transit', 'overlay_transit')]
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay_transit.transit_overlay', 'pybind.slxos.v17r_1_01a.brocade_vxlan_visibility', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_transit.transit_overlay', 'pybind.slxos.v17r_2_00.brocade_vxlan_visibility', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.overlay_transit.transit_overlay', 'pybind.slxos.v17s_1_02.brocade_vxlan_visibility', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'user_transit_name', 'extra_keyval': ''}, {'keyval': 'user_transit_name', 'extra_keyval': ''}, {'keyval': 'user_transit_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'transit_overlay', 'keyval': 'access_group, in_out', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_transit=overlay_transit, transit_overlay=transit_overlay)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_transit=overlay_transit, transit_overlay=transit_overlay)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_get(self, overlay_transit_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type overlay_transit_state: overlay_transit_name
    :param overlay_transit_state: Keyword argument tuple.

    :type overlay_transit_name: unicode
    :param overlay_transit_name: **overlay_transit_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay_transit_state', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_transit_state', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_transit_state', 'keyval': 'overlay_transit_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_transit_state=overlay_transit_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_transit_state=overlay_transit_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_binded_overlay_acl_get(self, overlay_transit_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type overlay_transit_state: overlay_transit_name
    :param overlay_transit_state: Keyword argument tuple.

    :type overlay_transit_name: unicode
    :param overlay_transit_name: **overlay_transit_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.overlay_transit_state', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.overlay_transit_state', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'overlay_transit_state', 'keyval': 'overlay_transit_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, overlay_transit_state=overlay_transit_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, overlay_transit_state=overlay_transit_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_byte_count_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_count_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_dst_ip_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_dst_ip_mask_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_dst_port_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_dst_vtep_ip_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_mirror_interface_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_native_tag_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_permit_deny_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_redir_interface_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_sflow_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_src_ip_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_src_ip_mask_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_src_port_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_src_vtep_ip_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_transit_name_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_vni_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_extended_data_vni_mask_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name, seq_num
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state.extended_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def overlay_transit_state_overlay_transit_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.overlay_transit_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.overlay_transit_state', u'extended_data')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'acl_name, seq_num, permit_deny, dst_vtep_ip, src_vtep_ip, vni, vni_mask, native_tag, dst_ip, dst_ip_mask, src_ip, src_ip_mask, dst_port, src_port, count, byte_count, transit_name, sflow, redir_interface, mirror_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ovsdb_server_get(self, ovsdb_server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ovsdb_server: name
    :param ovsdb_server: Keyword argument tuple.

    :type name: unicode
    :param name: **ovsdb_server** tuple argument:  Ovsdb server name

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.ovsdb_server', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ovsdb_server', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ovsdb_server', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ovsdb_server', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.ovsdb_server', u'ip')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'ovsdb_server', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'address'}]
    leafval_map = {"pybind.slxos.v17s_1_02.ovsdb_server": {}, "pybind.nos.v7_2_0.ovsdb_server": {"port": "port", "activate": "activate", "name": "name", "method": "method"}, "pybind.slxos.v17r_1_01a.ovsdb_server": {}, "pybind.slxos.v17r_2_00.ovsdb_server": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ovsdb_server=ovsdb_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ovsdb_server=ovsdb_server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ovsdb_server_activate_get(self, ovsdb_server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ovsdb_server: name
    :param ovsdb_server: Keyword argument tuple.

    :type name: unicode
    :param name: **ovsdb_server** tuple argument:  Ovsdb server name

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.ovsdb_server', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ovsdb_server', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ovsdb_server', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ovsdb_server', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.ovsdb_server', u'ip')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'ovsdb_server', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ovsdb_server=ovsdb_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ovsdb_server=ovsdb_server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ovsdb_server_ip_get(self, ovsdb_server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ovsdb_server: name
    :param ovsdb_server: Keyword argument tuple.

    :type name: unicode
    :param name: **ovsdb_server** tuple argument:  Ovsdb server name

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ovsdb_server', 'ovsdb_server')]
    bindings_list = [('pybind.nos.v7_2_0.ovsdb_server.ip', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ovsdb_server=ovsdb_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ovsdb_server=ovsdb_server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ovsdb_server_ip_address_get(self, ovsdb_server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ovsdb_server: name
    :param ovsdb_server: Keyword argument tuple.

    :type name: unicode
    :param name: **ovsdb_server** tuple argument:  Ovsdb server name

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.ovsdb_server', 'ovsdb_server')]
    bindings_list = [('pybind.nos.v7_2_0.ovsdb_server.ip', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ovsdb_server=ovsdb_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ovsdb_server=ovsdb_server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ovsdb_server_method_get(self, ovsdb_server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type ovsdb_server: name
    :param ovsdb_server: Keyword argument tuple.

    :type name: unicode
    :param name: **ovsdb_server** tuple argument:  Ovsdb server name

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.ovsdb_server', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.ovsdb_server', u'ip')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'ovsdb_server', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ovsdb_server=ovsdb_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ovsdb_server=ovsdb_server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ovsdb_server_port_get(self, ovsdb_server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ovsdb_server: name
    :param ovsdb_server: Keyword argument tuple.

    :type name: unicode
    :param name: **ovsdb_server** tuple argument:  Ovsdb server name

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.ovsdb_server', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ovsdb_server', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ovsdb_server', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ovsdb_server', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.ovsdb_server', u'ip')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'ovsdb_server', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ovsdb_server=ovsdb_server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ovsdb_server=ovsdb_server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def packet_encap_processing_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.packet_encap_processing_state', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.packet_encap_processing_state', u'packet_encap_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'port_name, link_status, encap_type, strip_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def packet_encap_processing_state_packet_encap_info_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.packet_encap_processing_state.packet_encap_info_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def packet_encap_processing_state_packet_encap_info_list_encap_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.packet_encap_processing_state.packet_encap_info_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def packet_encap_processing_state_packet_encap_info_list_link_status_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.packet_encap_processing_state.packet_encap_info_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def packet_encap_processing_state_packet_encap_info_list_port_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.packet_encap_processing_state.packet_encap_info_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def packet_encap_processing_state_packet_encap_info_list_strip_status_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.packet_encap_processing_state.packet_encap_info_list', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def password_attributes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.password_attributes', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.password_attributes', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.password_attributes', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.password_attributes', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.password_attributes', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.password_attributes', u'character_restriction'), ('pybind.slxos.v17r_1_01a.password_attributes', u'character_restriction'), ('pybind.slxos.v17r_2_00.password_attributes', u'character_restriction'), ('pybind.nos.v7_2_0.password_attributes', u'character_restriction'), ('pybind.nos.v6_0_2f.password_attributes', u'character_restriction')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def password_attributes_admin_lockout_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.password_attributes', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.password_attributes', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.password_attributes', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.password_attributes', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.password_attributes', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.password_attributes', u'character_restriction'), ('pybind.slxos.v17r_1_01a.password_attributes', u'character_restriction'), ('pybind.slxos.v17r_2_00.password_attributes', u'character_restriction'), ('pybind.nos.v7_2_0.password_attributes', u'character_restriction'), ('pybind.nos.v6_0_2f.password_attributes', u'character_restriction')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def password_attributes_character_restriction_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.password_attributes.character_restriction', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.password_attributes.character_restriction', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.password_attributes.character_restriction', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.password_attributes.character_restriction', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.password_attributes.character_restriction', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def password_attributes_character_restriction_lower_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.password_attributes.character_restriction', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.password_attributes.character_restriction', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.password_attributes.character_restriction', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.password_attributes.character_restriction', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.password_attributes.character_restriction', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def password_attributes_character_restriction_numeric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.password_attributes.character_restriction', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.password_attributes.character_restriction', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.password_attributes.character_restriction', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.password_attributes.character_restriction', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.password_attributes.character_restriction', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def password_attributes_character_restriction_special_char_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.password_attributes.character_restriction', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.password_attributes.character_restriction', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.password_attributes.character_restriction', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.password_attributes.character_restriction', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.password_attributes.character_restriction', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def password_attributes_character_restriction_upper_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.password_attributes.character_restriction', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.password_attributes.character_restriction', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.password_attributes.character_restriction', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.password_attributes.character_restriction', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.password_attributes.character_restriction', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def password_attributes_max_lockout_duration_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.password_attributes', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.password_attributes', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.password_attributes', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.password_attributes', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.password_attributes', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.password_attributes', u'character_restriction'), ('pybind.slxos.v17r_1_01a.password_attributes', u'character_restriction'), ('pybind.slxos.v17r_2_00.password_attributes', u'character_restriction'), ('pybind.nos.v7_2_0.password_attributes', u'character_restriction'), ('pybind.nos.v6_0_2f.password_attributes', u'character_restriction')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def password_attributes_max_retry_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.password_attributes', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.password_attributes', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.password_attributes', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.password_attributes', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.password_attributes', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.password_attributes', u'character_restriction'), ('pybind.slxos.v17r_1_01a.password_attributes', u'character_restriction'), ('pybind.slxos.v17r_2_00.password_attributes', u'character_restriction'), ('pybind.nos.v7_2_0.password_attributes', u'character_restriction'), ('pybind.nos.v6_0_2f.password_attributes', u'character_restriction')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def password_attributes_min_length_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.password_attributes', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.password_attributes', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.password_attributes', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.password_attributes', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.password_attributes', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.password_attributes', u'character_restriction'), ('pybind.slxos.v17r_1_01a.password_attributes', u'character_restriction'), ('pybind.slxos.v17r_2_00.password_attributes', u'character_restriction'), ('pybind.nos.v7_2_0.password_attributes', u'character_restriction'), ('pybind.nos.v6_0_2f.password_attributes', u'character_restriction')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}, {'leafval': 'upper, lower, numeric, special_char'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_anycast_state_get(self, pim_anycast_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_anycast_state: vrf_name, anycast_rp
    :param pim_anycast_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_anycast_state** tuple argument.

    :type anycast_rp: unicode
    :param anycast_rp: **pim_anycast_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_anycast_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_anycast_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_anycast_state', u'peer_list'), ('pybind.slxos.v17r_2_00.pim_anycast_state', u'peer_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_anycast_state', 'keyval': 'vrf_name, anycast_rp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv4_addr'}, {'leafval': 'ipv4_addr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_anycast_state=pim_anycast_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_anycast_state=pim_anycast_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_anycast_state_peer_list_get(self, pim_anycast_state=None, peer_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_anycast_state: vrf_name, anycast_rp
    :param pim_anycast_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_anycast_state** tuple argument.

    :type anycast_rp: unicode
    :param anycast_rp: **pim_anycast_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type peer_list: ipv4_addr
    :param peer_list: Keyword argument tuple.

    :type ipv4_addr: unicode
    :param ipv4_addr: **peer_list** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.pim_anycast_state', 'pim_anycast_state'), ('pybind.slxos.v17r_2_00.pim_anycast_state', 'pim_anycast_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_anycast_state.peer_list', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_anycast_state.peer_list', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name, anycast_rp', 'extra_keyval': ''}, {'keyval': 'vrf_name, anycast_rp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'peer_list', 'keyval': 'ipv4_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_anycast_state=pim_anycast_state, peer_list=peer_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_anycast_state=pim_anycast_state, peer_list=peer_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_anycast_state_prefix_name_get(self, pim_anycast_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_anycast_state: vrf_name, anycast_rp
    :param pim_anycast_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_anycast_state** tuple argument.

    :type anycast_rp: unicode
    :param anycast_rp: **pim_anycast_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_anycast_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_anycast_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_anycast_state', u'peer_list'), ('pybind.slxos.v17r_2_00.pim_anycast_state', u'peer_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_anycast_state', 'keyval': 'vrf_name, anycast_rp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv4_addr'}, {'leafval': 'ipv4_addr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_anycast_state=pim_anycast_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_anycast_state=pim_anycast_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_ecmp_state_get(self, pim_ecmp_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_ecmp_state: vrf_name, addr_filter
    :param pim_ecmp_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_ecmp_state** tuple argument.

    :type addr_filter: unicode
    :param addr_filter: **pim_ecmp_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_ecmp_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_ecmp_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_ecmp_state', u'pim_ecmp'), ('pybind.slxos.v17r_1_01a.pim_ecmp_state', u'pim_ecmp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_ecmp_state', 'keyval': 'vrf_name, addr_filter', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name, src_ip, rp_addr, upstream_nbr, interface_name, interface_count'}, {'leafval': 'vrf_name, src_ip, rp_addr, upstream_nbr, interface_name, interface_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_ecmp_state=pim_ecmp_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_ecmp_state=pim_ecmp_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_ecmp_state_pim_ecmp_get(self, pim_ecmp_state=None, pim_ecmp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_ecmp_state: vrf_name, addr_filter
    :param pim_ecmp_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_ecmp_state** tuple argument.

    :type addr_filter: unicode
    :param addr_filter: **pim_ecmp_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type pim_ecmp: vrf_name, src_ip, rp_addr
    :param pim_ecmp: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_ecmp** tuple argument.

    :type src_ip: unicode
    :param src_ip: **pim_ecmp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type rp_addr: unicode
    :param rp_addr: **pim_ecmp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.pim_ecmp_state', 'pim_ecmp_state'), ('pybind.slxos.v17r_2_00.pim_ecmp_state', 'pim_ecmp_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_ecmp_state.pim_ecmp', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_ecmp_state.pim_ecmp', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name, addr_filter', 'extra_keyval': ''}, {'keyval': 'vrf_name, addr_filter', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_ecmp', 'keyval': 'vrf_name, src_ip, rp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_ecmp_state=pim_ecmp_state, pim_ecmp=pim_ecmp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_ecmp_state=pim_ecmp_state, pim_ecmp=pim_ecmp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_ecmp_state_pim_ecmp_interface_count_get(self, pim_ecmp_state=None, pim_ecmp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_ecmp_state: vrf_name, addr_filter
    :param pim_ecmp_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_ecmp_state** tuple argument.

    :type addr_filter: unicode
    :param addr_filter: **pim_ecmp_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type pim_ecmp: vrf_name, src_ip, rp_addr
    :param pim_ecmp: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_ecmp** tuple argument.

    :type src_ip: unicode
    :param src_ip: **pim_ecmp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type rp_addr: unicode
    :param rp_addr: **pim_ecmp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.pim_ecmp_state', 'pim_ecmp_state'), ('pybind.slxos.v17r_2_00.pim_ecmp_state', 'pim_ecmp_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_ecmp_state.pim_ecmp', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_ecmp_state.pim_ecmp', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name, addr_filter', 'extra_keyval': ''}, {'keyval': 'vrf_name, addr_filter', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_ecmp', 'keyval': 'vrf_name, src_ip, rp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_ecmp_state=pim_ecmp_state, pim_ecmp=pim_ecmp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_ecmp_state=pim_ecmp_state, pim_ecmp=pim_ecmp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_ecmp_state_pim_ecmp_interface_name_get(self, pim_ecmp_state=None, pim_ecmp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_ecmp_state: vrf_name, addr_filter
    :param pim_ecmp_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_ecmp_state** tuple argument.

    :type addr_filter: unicode
    :param addr_filter: **pim_ecmp_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type pim_ecmp: vrf_name, src_ip, rp_addr
    :param pim_ecmp: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_ecmp** tuple argument.

    :type src_ip: unicode
    :param src_ip: **pim_ecmp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type rp_addr: unicode
    :param rp_addr: **pim_ecmp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.pim_ecmp_state', 'pim_ecmp_state'), ('pybind.slxos.v17r_2_00.pim_ecmp_state', 'pim_ecmp_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_ecmp_state.pim_ecmp', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_ecmp_state.pim_ecmp', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name, addr_filter', 'extra_keyval': ''}, {'keyval': 'vrf_name, addr_filter', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_ecmp', 'keyval': 'vrf_name, src_ip, rp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_ecmp_state=pim_ecmp_state, pim_ecmp=pim_ecmp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_ecmp_state=pim_ecmp_state, pim_ecmp=pim_ecmp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_ecmp_state_pim_ecmp_upstream_nbr_get(self, pim_ecmp_state=None, pim_ecmp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_ecmp_state: vrf_name, addr_filter
    :param pim_ecmp_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_ecmp_state** tuple argument.

    :type addr_filter: unicode
    :param addr_filter: **pim_ecmp_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type pim_ecmp: vrf_name, src_ip, rp_addr
    :param pim_ecmp: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_ecmp** tuple argument.

    :type src_ip: unicode
    :param src_ip: **pim_ecmp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type rp_addr: unicode
    :param rp_addr: **pim_ecmp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.pim_ecmp_state', 'pim_ecmp_state'), ('pybind.slxos.v17r_2_00.pim_ecmp_state', 'pim_ecmp_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_ecmp_state.pim_ecmp', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_ecmp_state.pim_ecmp', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name, addr_filter', 'extra_keyval': ''}, {'keyval': 'vrf_name, addr_filter', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_ecmp', 'keyval': 'vrf_name, src_ip, rp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_ecmp_state=pim_ecmp_state, pim_ecmp=pim_ecmp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_ecmp_state=pim_ecmp_state, pim_ecmp=pim_ecmp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_current_count_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_enable_status_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_hello_interval_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_hw_drop_status_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_inact_interval_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_interfaces_get(self, pim_global_state=None, interfaces=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interfaces: vrf_name
    :param interfaces: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **interfaces** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pim_global_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state.interfaces', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_global_state.interfaces', u'pim_interface_data'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces', u'pim_interface_data')]
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interfaces', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name, interface_name, interface_type, enable_status, local_ip_addr, pim_version, mode, dr_info, ttl_threshold, multicast_boundry, dr_priority'}, {'leafval': 'vrf_name, interface_name, interface_type, enable_status, local_ip_addr, pim_version, mode, dr_info, ttl_threshold, multicast_boundry, dr_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state, interfaces=interfaces)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state, interfaces=interfaces)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_get(self, pim_global_state=None, interfaces=None, pim_interface_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type interfaces: vrf_name
    :param interfaces: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: vrf_name, interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_interface_data** tuple argument.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_1_01a.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'vrf_name, interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_dr_info_get(self, pim_global_state=None, interfaces=None, pim_interface_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type interfaces: vrf_name
    :param interfaces: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: vrf_name, interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_interface_data** tuple argument.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_1_01a.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'vrf_name, interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_dr_priority_get(self, pim_global_state=None, interfaces=None, pim_interface_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type interfaces: vrf_name
    :param interfaces: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: vrf_name, interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_interface_data** tuple argument.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_1_01a.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'vrf_name, interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_enable_status_get(self, pim_global_state=None, interfaces=None, pim_interface_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type interfaces: vrf_name
    :param interfaces: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: vrf_name, interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_interface_data** tuple argument.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_1_01a.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'vrf_name, interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_local_ip_addr_get(self, pim_global_state=None, interfaces=None, pim_interface_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type interfaces: vrf_name
    :param interfaces: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: vrf_name, interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_interface_data** tuple argument.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_1_01a.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'vrf_name, interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_mode_get(self, pim_global_state=None, interfaces=None, pim_interface_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type interfaces: vrf_name
    :param interfaces: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: vrf_name, interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_interface_data** tuple argument.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_1_01a.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'vrf_name, interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_multicast_boundry_get(self, pim_global_state=None, interfaces=None, pim_interface_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type interfaces: vrf_name
    :param interfaces: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: vrf_name, interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_interface_data** tuple argument.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_1_01a.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'vrf_name, interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_pim_version_get(self, pim_global_state=None, interfaces=None, pim_interface_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type interfaces: vrf_name
    :param interfaces: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: vrf_name, interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_interface_data** tuple argument.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_1_01a.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'vrf_name, interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_interfaces_pim_interface_data_ttl_threshold_get(self, pim_global_state=None, interfaces=None, pim_interface_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type interfaces: vrf_name
    :param interfaces: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **interfaces** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type pim_interface_data: vrf_name, interface_name, interface_type
    :param pim_interface_data: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_interface_data** tuple argument.

    :type interface_name: unicode
    :param interface_name: **pim_interface_data** tuple argument.

    :type interface_type: unicode
    :param interface_type: **pim_interface_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', 'pim_global_state'), ('pybind.slxos.v17r_1_01a.pim_global_state.interfaces', u'interfaces')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state.interfaces.pim_interface_data', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_interface_data', 'keyval': 'vrf_name, interface_name, interface_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state, interfaces=interfaces, pim_interface_data=pim_interface_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_jp_interval_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_max_mcache_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_nbr_timeout_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_prune_wait_interval_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_reg_probe_time_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_reg_stop_delay_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_reg_suppress_interval_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_reg_suppress_time_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_route_precedence_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_spt_threshold_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_ssm_default_prefix_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_ssm_prefix_name_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_global_state_ssm_status_get(self, pim_global_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_global_state: vrf_name
    :param pim_global_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_global_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_global_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_global_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.pim_global_state', u'interfaces'), ('pybind.slxos.v17r_1_01a.pim_global_state', u'interfaces')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_global_state', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name'}, {'leafval': 'vrf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_global_state=pim_global_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_global_state=pim_global_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_age_mask_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_flag_bmp_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_incoming_if_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_is_w_g_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_join_desired_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_kat_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_lrcv_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_lsrc_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_need_rte_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_pim_oif_get(self, pim_mcache_state=None, pim_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type pim_oif: oif_name
    :param pim_oif: Keyword argument tuple.

    :type oif_name: unicode
    :param oif_name: **pim_oif** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.pim_mcache_state', 'pim_mcache_state'), ('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pim_mcache_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state.pim_oif', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state.pim_oif', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}, {'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_oif', 'keyval': 'oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state, pim_oif=pim_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state, pim_oif=pim_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_pim_oif_age_get(self, pim_mcache_state=None, pim_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type pim_oif: oif_name
    :param pim_oif: Keyword argument tuple.

    :type oif_name: unicode
    :param oif_name: **pim_oif** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.pim_mcache_state', 'pim_mcache_state'), ('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pim_mcache_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state.pim_oif', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state.pim_oif', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}, {'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_oif', 'keyval': 'oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state, pim_oif=pim_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state, pim_oif=pim_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_pim_oif_expiry_time_get(self, pim_mcache_state=None, pim_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type pim_oif: oif_name
    :param pim_oif: Keyword argument tuple.

    :type oif_name: unicode
    :param oif_name: **pim_oif** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.pim_mcache_state', 'pim_mcache_state'), ('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pim_mcache_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state.pim_oif', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state.pim_oif', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}, {'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_oif', 'keyval': 'oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state, pim_oif=pim_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state, pim_oif=pim_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_pim_oif_oif_flags_get(self, pim_mcache_state=None, pim_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    **Instance Keyword Argument Tuple**:

    :type pim_oif: oif_name
    :param pim_oif: Keyword argument tuple.

    :type oif_name: unicode
    :param oif_name: **pim_oif** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.pim_mcache_state', 'pim_mcache_state'), ('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pim_mcache_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state.pim_oif', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state.pim_oif', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}, {'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pim_oif', 'keyval': 'oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state, pim_oif=pim_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state, pim_oif=pim_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_reg_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_regprobe_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_regsupp_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_rp_addr_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_rpf_info_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_rpt_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_sp_mode_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_spt_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_ssm_mode_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_tot_entry_count_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pim_mcache_state_uptime_get(self, pim_mcache_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim_mcache_state: vrf_name, src_addr, grp_addr
    :param pim_mcache_state: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **pim_mcache_state** tuple argument.

    :type src_addr: unicode
    :param src_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type grp_addr: unicode
    :param grp_addr: **pim_mcache_state** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', 'pybind.slxos.v17r_1_01a.brocade_pim_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pim_mcache_state', 'pybind.slxos.v17r_2_00.brocade_pim_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pim_mcache_state', u'pim_oif'), ('pybind.slxos.v17r_2_00.pim_mcache_state', u'pim_oif')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pim_mcache_state', 'keyval': 'vrf_name, src_addr, grp_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oif_name, age, expiry_time, oif_flags'}, {'leafval': 'oif_name, age, expiry_time, oif_flags'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim_mcache_state=pim_mcache_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim_mcache_state=pim_mcache_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.police_priority_map', u'conform'), ('pybind.nos.v7_2_0.police_priority_map', u'exceed'), ('pybind.nos.v6_0_2f.police_priority_map', u'exceed'), ('pybind.nos.v6_0_2f.police_priority_map', u'conform')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'police_priority_map', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'map_pri0_conform, map_pri1_conform, map_pri2_conform, map_pri3_conform, map_pri4_conform, map_pri5_conform, map_pri6_conform, map_pri7_conform'}, {'leafval': 'map_pri0_exceed, map_pri1_exceed, map_pri2_exceed, map_pri3_exceed, map_pri4_exceed, map_pri5_exceed, map_pri6_exceed, map_pri7_exceed'}, {'leafval': 'map_pri0_exceed, map_pri1_exceed, map_pri2_exceed, map_pri3_exceed, map_pri4_exceed, map_pri5_exceed, map_pri6_exceed, map_pri7_exceed'}, {'leafval': 'map_pri0_conform, map_pri1_conform, map_pri2_conform, map_pri3_conform, map_pri4_conform, map_pri5_conform, map_pri6_conform, map_pri7_conform'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_conform_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.conform', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.conform', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'map_pri0_conform, map_pri1_conform, map_pri2_conform, map_pri3_conform, map_pri4_conform, map_pri5_conform, map_pri6_conform, map_pri7_conform'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_conform_map_pri0_conform_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.conform', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.conform', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_conform_map_pri1_conform_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.conform', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.conform', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_conform_map_pri2_conform_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.conform', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.conform', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_conform_map_pri3_conform_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.conform', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.conform', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_conform_map_pri4_conform_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.conform', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.conform', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_conform_map_pri5_conform_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.conform', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.conform', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_conform_map_pri6_conform_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.conform', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.conform', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_conform_map_pri7_conform_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.conform', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.conform', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_exceed_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.exceed', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.exceed', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'map_pri0_exceed, map_pri1_exceed, map_pri2_exceed, map_pri3_exceed, map_pri4_exceed, map_pri5_exceed, map_pri6_exceed, map_pri7_exceed'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_exceed_map_pri0_exceed_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.exceed', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.exceed', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_exceed_map_pri1_exceed_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.exceed', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.exceed', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_exceed_map_pri2_exceed_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.exceed', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.exceed', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_exceed_map_pri3_exceed_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.exceed', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.exceed', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_exceed_map_pri4_exceed_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.exceed', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.exceed', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_exceed_map_pri5_exceed_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.exceed', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.exceed', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_exceed_map_pri6_exceed_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.exceed', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.exceed', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_priority_map_exceed_map_pri7_exceed_get(self, police_priority_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_priority_map: name
    :param police_priority_map: Keyword argument tuple.

    :type name: unicode
    :param name: **police_priority_map** tuple argument:  Policer Priority Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.police_priority_map', 'police_priority_map'), ('pybind.nos.v6_0_2f.police_priority_map', 'police_priority_map')]
    bindings_list = [('pybind.nos.v6_0_2f.police_priority_map.exceed', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.police_priority_map.exceed', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_priority_map=police_priority_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_priority_map=police_priority_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_remark_profile_get(self, police_remark_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type police_remark_profile: profile_name
    :param police_remark_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **police_remark_profile** tuple argument:  Name for the profile(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.police_remark_profile', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.police_remark_profile', u'action')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'police_remark_profile', 'keyval': 'profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'classification_type, action_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_remark_profile=police_remark_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_remark_profile=police_remark_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_remark_profile_action_get(self, police_remark_profile=None, action=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_remark_profile: profile_name
    :param police_remark_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **police_remark_profile** tuple argument:  Name for the profile(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type action: classification_type, action_type
    :param action: Keyword argument tuple.

    :type classification_type: unicode
    :param classification_type: **action** tuple argument.

        * enumeration restriction: ::

            ['color',
            'color-and-traffic-class',
            'color-and-dscp',
            'color-and-cos']

    :type action_type: unicode
    :param action_type: **action** tuple argument.

        * enumeration restriction: ::

            ['conform', 'exceed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.police_remark_profile', 'police_remark_profile')]
    bindings_list = [('pybind.slxos.v17s_1_02.police_remark_profile.action', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.police_remark_profile.action', u'map'), ('pybind.slxos.v17s_1_02.police_remark_profile.action', u'set')]
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'action', 'keyval': 'classification_type, action_type', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cos_mutation, cos_traffic_class, cos_dscp, traffic_class_mutation, traffic_class_cos, traffic_class_dscp, dscp_mutation, dscp_traffic_class, dscp_cos'}, {'leafval': 'cos, traffic_class, dscp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_remark_profile=police_remark_profile, action=action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_remark_profile=police_remark_profile, action=action)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_remark_profile_action_map_get(self, police_remark_profile=None, action=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_remark_profile: profile_name
    :param police_remark_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **police_remark_profile** tuple argument:  Name for the profile(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type action: classification_type, action_type
    :param action: Keyword argument tuple.

    :type classification_type: unicode
    :param classification_type: **action** tuple argument.

        * enumeration restriction: ::

            ['color',
            'color-and-traffic-class',
            'color-and-dscp',
            'color-and-cos']

    :type action_type: unicode
    :param action_type: **action** tuple argument.

        * enumeration restriction: ::

            ['conform', 'exceed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.police_remark_profile', 'police_remark_profile'), ('pybind.slxos.v17s_1_02.police_remark_profile.action', u'action')]
    bindings_list = [('pybind.slxos.v17s_1_02.police_remark_profile.action.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'classification_type, action_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_remark_profile=police_remark_profile, action=action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_remark_profile=police_remark_profile, action=action)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_remark_profile_action_map_cos_dscp_get(self, police_remark_profile=None, action=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_remark_profile: profile_name
    :param police_remark_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **police_remark_profile** tuple argument:  Name for the profile(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type action: classification_type, action_type
    :param action: Keyword argument tuple.

    :type classification_type: unicode
    :param classification_type: **action** tuple argument.

        * enumeration restriction: ::

            ['color',
            'color-and-traffic-class',
            'color-and-dscp',
            'color-and-cos']

    :type action_type: unicode
    :param action_type: **action** tuple argument.

        * enumeration restriction: ::

            ['conform', 'exceed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.police_remark_profile', 'police_remark_profile'), ('pybind.slxos.v17s_1_02.police_remark_profile.action', u'action')]
    bindings_list = [('pybind.slxos.v17s_1_02.police_remark_profile.action.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'classification_type, action_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_remark_profile=police_remark_profile, action=action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_remark_profile=police_remark_profile, action=action)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_remark_profile_action_map_cos_mutation_get(self, police_remark_profile=None, action=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_remark_profile: profile_name
    :param police_remark_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **police_remark_profile** tuple argument:  Name for the profile(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type action: classification_type, action_type
    :param action: Keyword argument tuple.

    :type classification_type: unicode
    :param classification_type: **action** tuple argument.

        * enumeration restriction: ::

            ['color',
            'color-and-traffic-class',
            'color-and-dscp',
            'color-and-cos']

    :type action_type: unicode
    :param action_type: **action** tuple argument.

        * enumeration restriction: ::

            ['conform', 'exceed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.police_remark_profile', 'police_remark_profile'), ('pybind.slxos.v17s_1_02.police_remark_profile.action', u'action')]
    bindings_list = [('pybind.slxos.v17s_1_02.police_remark_profile.action.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'classification_type, action_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_remark_profile=police_remark_profile, action=action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_remark_profile=police_remark_profile, action=action)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_remark_profile_action_map_cos_traffic_class_get(self, police_remark_profile=None, action=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_remark_profile: profile_name
    :param police_remark_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **police_remark_profile** tuple argument:  Name for the profile(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type action: classification_type, action_type
    :param action: Keyword argument tuple.

    :type classification_type: unicode
    :param classification_type: **action** tuple argument.

        * enumeration restriction: ::

            ['color',
            'color-and-traffic-class',
            'color-and-dscp',
            'color-and-cos']

    :type action_type: unicode
    :param action_type: **action** tuple argument.

        * enumeration restriction: ::

            ['conform', 'exceed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.police_remark_profile', 'police_remark_profile'), ('pybind.slxos.v17s_1_02.police_remark_profile.action', u'action')]
    bindings_list = [('pybind.slxos.v17s_1_02.police_remark_profile.action.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'classification_type, action_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_remark_profile=police_remark_profile, action=action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_remark_profile=police_remark_profile, action=action)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_remark_profile_action_map_dscp_cos_get(self, police_remark_profile=None, action=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_remark_profile: profile_name
    :param police_remark_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **police_remark_profile** tuple argument:  Name for the profile(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type action: classification_type, action_type
    :param action: Keyword argument tuple.

    :type classification_type: unicode
    :param classification_type: **action** tuple argument.

        * enumeration restriction: ::

            ['color',
            'color-and-traffic-class',
            'color-and-dscp',
            'color-and-cos']

    :type action_type: unicode
    :param action_type: **action** tuple argument.

        * enumeration restriction: ::

            ['conform', 'exceed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.police_remark_profile', 'police_remark_profile'), ('pybind.slxos.v17s_1_02.police_remark_profile.action', u'action')]
    bindings_list = [('pybind.slxos.v17s_1_02.police_remark_profile.action.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'classification_type, action_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_remark_profile=police_remark_profile, action=action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_remark_profile=police_remark_profile, action=action)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_remark_profile_action_map_dscp_mutation_get(self, police_remark_profile=None, action=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_remark_profile: profile_name
    :param police_remark_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **police_remark_profile** tuple argument:  Name for the profile(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type action: classification_type, action_type
    :param action: Keyword argument tuple.

    :type classification_type: unicode
    :param classification_type: **action** tuple argument.

        * enumeration restriction: ::

            ['color',
            'color-and-traffic-class',
            'color-and-dscp',
            'color-and-cos']

    :type action_type: unicode
    :param action_type: **action** tuple argument.

        * enumeration restriction: ::

            ['conform', 'exceed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.police_remark_profile', 'police_remark_profile'), ('pybind.slxos.v17s_1_02.police_remark_profile.action', u'action')]
    bindings_list = [('pybind.slxos.v17s_1_02.police_remark_profile.action.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'classification_type, action_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_remark_profile=police_remark_profile, action=action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_remark_profile=police_remark_profile, action=action)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_remark_profile_action_map_dscp_traffic_class_get(self, police_remark_profile=None, action=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_remark_profile: profile_name
    :param police_remark_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **police_remark_profile** tuple argument:  Name for the profile(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type action: classification_type, action_type
    :param action: Keyword argument tuple.

    :type classification_type: unicode
    :param classification_type: **action** tuple argument.

        * enumeration restriction: ::

            ['color',
            'color-and-traffic-class',
            'color-and-dscp',
            'color-and-cos']

    :type action_type: unicode
    :param action_type: **action** tuple argument.

        * enumeration restriction: ::

            ['conform', 'exceed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.police_remark_profile', 'police_remark_profile'), ('pybind.slxos.v17s_1_02.police_remark_profile.action', u'action')]
    bindings_list = [('pybind.slxos.v17s_1_02.police_remark_profile.action.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'classification_type, action_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_remark_profile=police_remark_profile, action=action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_remark_profile=police_remark_profile, action=action)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_remark_profile_action_map_traffic_class_cos_get(self, police_remark_profile=None, action=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_remark_profile: profile_name
    :param police_remark_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **police_remark_profile** tuple argument:  Name for the profile(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type action: classification_type, action_type
    :param action: Keyword argument tuple.

    :type classification_type: unicode
    :param classification_type: **action** tuple argument.

        * enumeration restriction: ::

            ['color',
            'color-and-traffic-class',
            'color-and-dscp',
            'color-and-cos']

    :type action_type: unicode
    :param action_type: **action** tuple argument.

        * enumeration restriction: ::

            ['conform', 'exceed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.police_remark_profile', 'police_remark_profile'), ('pybind.slxos.v17s_1_02.police_remark_profile.action', u'action')]
    bindings_list = [('pybind.slxos.v17s_1_02.police_remark_profile.action.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'classification_type, action_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_remark_profile=police_remark_profile, action=action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_remark_profile=police_remark_profile, action=action)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_remark_profile_action_map_traffic_class_dscp_get(self, police_remark_profile=None, action=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_remark_profile: profile_name
    :param police_remark_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **police_remark_profile** tuple argument:  Name for the profile(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type action: classification_type, action_type
    :param action: Keyword argument tuple.

    :type classification_type: unicode
    :param classification_type: **action** tuple argument.

        * enumeration restriction: ::

            ['color',
            'color-and-traffic-class',
            'color-and-dscp',
            'color-and-cos']

    :type action_type: unicode
    :param action_type: **action** tuple argument.

        * enumeration restriction: ::

            ['conform', 'exceed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.police_remark_profile', 'police_remark_profile'), ('pybind.slxos.v17s_1_02.police_remark_profile.action', u'action')]
    bindings_list = [('pybind.slxos.v17s_1_02.police_remark_profile.action.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'classification_type, action_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_remark_profile=police_remark_profile, action=action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_remark_profile=police_remark_profile, action=action)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_remark_profile_action_map_traffic_class_mutation_get(self, police_remark_profile=None, action=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_remark_profile: profile_name
    :param police_remark_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **police_remark_profile** tuple argument:  Name for the profile(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type action: classification_type, action_type
    :param action: Keyword argument tuple.

    :type classification_type: unicode
    :param classification_type: **action** tuple argument.

        * enumeration restriction: ::

            ['color',
            'color-and-traffic-class',
            'color-and-dscp',
            'color-and-cos']

    :type action_type: unicode
    :param action_type: **action** tuple argument.

        * enumeration restriction: ::

            ['conform', 'exceed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.police_remark_profile', 'police_remark_profile'), ('pybind.slxos.v17s_1_02.police_remark_profile.action', u'action')]
    bindings_list = [('pybind.slxos.v17s_1_02.police_remark_profile.action.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'classification_type, action_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_remark_profile=police_remark_profile, action=action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_remark_profile=police_remark_profile, action=action)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_remark_profile_action_set_get(self, police_remark_profile=None, action=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_remark_profile: profile_name
    :param police_remark_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **police_remark_profile** tuple argument:  Name for the profile(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type action: classification_type, action_type
    :param action: Keyword argument tuple.

    :type classification_type: unicode
    :param classification_type: **action** tuple argument.

        * enumeration restriction: ::

            ['color',
            'color-and-traffic-class',
            'color-and-dscp',
            'color-and-cos']

    :type action_type: unicode
    :param action_type: **action** tuple argument.

        * enumeration restriction: ::

            ['conform', 'exceed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.police_remark_profile', 'police_remark_profile'), ('pybind.slxos.v17s_1_02.police_remark_profile.action', u'action')]
    bindings_list = [('pybind.slxos.v17s_1_02.police_remark_profile.action.set_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'classification_type, action_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_remark_profile=police_remark_profile, action=action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_remark_profile=police_remark_profile, action=action)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_remark_profile_action_set_cos_get(self, police_remark_profile=None, action=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_remark_profile: profile_name
    :param police_remark_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **police_remark_profile** tuple argument:  Name for the profile(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type action: classification_type, action_type
    :param action: Keyword argument tuple.

    :type classification_type: unicode
    :param classification_type: **action** tuple argument.

        * enumeration restriction: ::

            ['color',
            'color-and-traffic-class',
            'color-and-dscp',
            'color-and-cos']

    :type action_type: unicode
    :param action_type: **action** tuple argument.

        * enumeration restriction: ::

            ['conform', 'exceed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.police_remark_profile', 'police_remark_profile'), ('pybind.slxos.v17s_1_02.police_remark_profile.action', u'action')]
    bindings_list = [('pybind.slxos.v17s_1_02.police_remark_profile.action.set_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'classification_type, action_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_remark_profile=police_remark_profile, action=action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_remark_profile=police_remark_profile, action=action)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_remark_profile_action_set_dscp_get(self, police_remark_profile=None, action=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_remark_profile: profile_name
    :param police_remark_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **police_remark_profile** tuple argument:  Name for the profile(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type action: classification_type, action_type
    :param action: Keyword argument tuple.

    :type classification_type: unicode
    :param classification_type: **action** tuple argument.

        * enumeration restriction: ::

            ['color',
            'color-and-traffic-class',
            'color-and-dscp',
            'color-and-cos']

    :type action_type: unicode
    :param action_type: **action** tuple argument.

        * enumeration restriction: ::

            ['conform', 'exceed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.police_remark_profile', 'police_remark_profile'), ('pybind.slxos.v17s_1_02.police_remark_profile.action', u'action')]
    bindings_list = [('pybind.slxos.v17s_1_02.police_remark_profile.action.set_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'classification_type, action_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_remark_profile=police_remark_profile, action=action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_remark_profile=police_remark_profile, action=action)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def police_remark_profile_action_set_traffic_class_get(self, police_remark_profile=None, action=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type police_remark_profile: profile_name
    :param police_remark_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **police_remark_profile** tuple argument:  Name for the profile(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type action: classification_type, action_type
    :param action: Keyword argument tuple.

    :type classification_type: unicode
    :param classification_type: **action** tuple argument.

        * enumeration restriction: ::

            ['color',
            'color-and-traffic-class',
            'color-and-dscp',
            'color-and-cos']

    :type action_type: unicode
    :param action_type: **action** tuple argument.

        * enumeration restriction: ::

            ['conform', 'exceed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.police_remark_profile', 'police_remark_profile'), ('pybind.slxos.v17s_1_02.police_remark_profile.action', u'action')]
    bindings_list = [('pybind.slxos.v17s_1_02.police_remark_profile.action.set_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'classification_type, action_type', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, police_remark_profile=police_remark_profile, action=action)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, police_remark_profile=police_remark_profile, action=action)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_get(self, policy_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.policy_map', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.policy_map', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', u'class_'), ('pybind.nos.v6_0_2f.policy_map', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', u'class_')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'policy_map', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cl_name'}, {'leafval': 'cl_name, sflow_profile'}, {'leafval': 'cl_name, sflow_profile'}, {'leafval': 'cl_name'}, {'leafval': 'cl_name, sflow_profile'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.policy_map": {"po_name": "name"}, "pybind.nos.v6_0_2f.policy_map": {"po_name": "po_name"}, "pybind.slxos.v17s_1_02.policy_map": {"po_name": "name"}, "pybind.nos.v7_2_0.policy_map": {"po_name": "po_name"}, "pybind.slxos.v17r_2_00.policy_map": {"po_name": "name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.policy_map.class_', u'map'), ('pybind.slxos.v17r_2_00.policy_map.class_.set_', u'set_dscp'), ('pybind.slxos.v17r_2_00.policy_map.class_.set_', u'set_cos_tc'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'police'), ('pybind.slxos.v17r_2_00.policy_map.class_.priority_mapping_table', u'import_'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'shape'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'span'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler', u'strict_priority'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler', u'strict_priority'), ('pybind.slxos.v17s_1_02.policy_map.class_.set_', u'set_dscp'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'shape'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'map'), ('pybind.slxos.v17s_1_02.policy_map.class_.set_', u'set_cos_tc'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'span'), ('pybind.slxos.v17s_1_02.policy_map.class_.priority_mapping_table', u'import_'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'police'), ('pybind.nos.v7_2_0.policy_map.class_', u'span'), ('pybind.nos.v7_2_0.policy_map.class_.priority_mapping_table', u'import_'), ('pybind.nos.v7_2_0.policy_map.class_', u'map'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler', u'strict_priority'), ('pybind.nos.v7_2_0.policy_map.class_', u'shape'), ('pybind.nos.v7_2_0.policy_map.class_', u'police'), ('pybind.nos.v7_2_0.policy_map.class_.set_', u'set_dscp'), ('pybind.nos.v7_2_0.policy_map.class_.set_', u'set_cos_tc'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'span'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'map'), ('pybind.slxos.v17r_1_01a.policy_map.class_.set_', u'set_dscp'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler', u'strict_priority'), ('pybind.slxos.v17r_1_01a.policy_map.class_.set_', u'set_cos_tc'), ('pybind.slxos.v17r_1_01a.policy_map.class_.priority_mapping_table', u'import_'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'police'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'shape'), ('pybind.nos.v6_0_2f.policy_map.class_.set_', u'set_cos_tc'), ('pybind.nos.v6_0_2f.policy_map.class_.set_', u'set_dscp'), ('pybind.nos.v6_0_2f.policy_map.class_', u'map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'span'), ('pybind.nos.v6_0_2f.policy_map.class_', u'shape'), ('pybind.nos.v6_0_2f.policy_map.class_.priority_mapping_table', u'import_'), ('pybind.nos.v6_0_2f.policy_map.class_', u'police'), ('pybind.nos.v6_0_2f.policy_map.class_.scheduler', u'strict_priority')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'class_', 'keyval': 'cl_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cos_mutation, cos_traffic_class, dscp_cos, dscp_traffic_class, dscp_mutation'}, {'leafval': 'dscp'}, {'leafval': 'cos, traffic_class'}, {'leafval': 'cir, cbs, eir, ebs'}, {'leafval': 'cee'}, {'leafval': 'shaping_rate'}, {'leafval': 'session'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last, TC1, TC2, TC3, TC4, TC5, TC6, TC7'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last, TC1, TC2, TC3, TC4, TC5, TC6, TC7'}, {'leafval': 'dscp'}, {'leafval': 'shaping_rate'}, {'leafval': 'cos_mutation, cos_traffic_class, dscp_cos, dscp_traffic_class, dscp_mutation'}, {'leafval': 'cos, traffic_class'}, {'leafval': 'session'}, {'leafval': 'cee'}, {'leafval': 'cir, cbs, eir, ebs, classification_type, remark_profile'}, {'leafval': 'session'}, {'leafval': 'cee'}, {'leafval': 'cos_mutation, cos_traffic_class, dscp_cos, dscp_traffic_class, dscp_mutation, sflow'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last, TC1, TC2, TC3, TC4, TC5, TC6, TC7'}, {'leafval': 'shaping_rate'}, {'leafval': 'cir, cbs, eir, ebs, set_priority, conform_set_dscp, conform_set_prec, conform_set_tc, exceed_set_dscp, exceed_set_prec, exceed_set_tc'}, {'leafval': 'dscp'}, {'leafval': 'cos, traffic_class'}, {'leafval': 'session'}, {'leafval': 'cos_mutation, cos_traffic_class, dscp_cos, dscp_traffic_class, dscp_mutation'}, {'leafval': 'dscp'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last, TC1, TC2, TC3, TC4, TC5, TC6, TC7'}, {'leafval': 'cos, traffic_class'}, {'leafval': 'cee'}, {'leafval': 'cir, cbs, eir, ebs'}, {'leafval': 'shaping_rate'}, {'leafval': 'cos, traffic_class'}, {'leafval': 'dscp'}, {'leafval': 'cos_mutation, cos_traffic_class, dscp_cos, dscp_traffic_class, dscp_mutation, sflow'}, {'leafval': 'session'}, {'leafval': 'shaping_rate'}, {'leafval': 'cee'}, {'leafval': 'cir, cbs, eir, ebs, set_priority, conform_set_dscp, conform_set_prec, conform_set_tc, exceed_set_dscp, exceed_set_prec, exceed_set_tc'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last, TC1, TC2, TC3, TC4, TC5, TC6, TC7'}]
    leafval_map = {"pybind.nos.v6_0_2f.policy_map.class_": {"cl_name": "cl_name"}, "pybind.nos.v7_2_0.policy_map.class_": {"cl_name": "cl_name"}, "pybind.slxos.v17r_2_00.policy_map.class_": {}, "pybind.slxos.v17s_1_02.policy_map.class_": {}, "pybind.slxos.v17r_1_01a.policy_map.class_": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_map_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.map_', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.map_', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.map_', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.map_', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.policy_map.class_.map_": {}, "pybind.slxos.v17r_2_00.policy_map.class_.map_": {}, "pybind.nos.v7_2_0.policy_map.class_.map_": {"cos_mutation": "cos_mutation", "sflow": "sflow", "dscp_mutation": "dscp_mutation", "dscp_traffic_class": "dscp_traffic_class", "cos_traffic_class": "cos_traffic_class", "dscp_cos": "dscp_cos"}, "pybind.nos.v6_0_2f.policy_map.class_.map_": {"cos_mutation": "cos_mutation", "sflow": "sflow", "dscp_mutation": "dscp_mutation", "dscp_traffic_class": "dscp_traffic_class", "cos_traffic_class": "cos_traffic_class", "dscp_cos": "dscp_cos"}, "pybind.slxos.v17r_1_01a.policy_map.class_.map_": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_map_cos_mutation_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.map_', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.map_', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.map_', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.map_', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_map_cos_traffic_class_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.map_', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.map_', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.map_', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.map_', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_map_dscp_cos_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.map_', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.map_', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.map_', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.map_', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_map_dscp_mutation_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.map_', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.map_', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.map_', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.map_', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_map_dscp_traffic_class_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.map_', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.map_', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.map_', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.map_', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_map_sflow_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.map_', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.map_', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_police_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.police', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.police', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.police', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.police', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.police', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'cir, cbs, eir, ebs, classification_type, remark_profile'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.policy_map.class_.police": {}, "pybind.slxos.v17s_1_02.policy_map.class_.police": {}, "pybind.nos.v7_2_0.policy_map.class_.police": {"exceed_set_tc": "exceed_set_tc", "eir": "eir", "cbs": "cbs", "ebs": "ebs", "conform_set_prec": "conform_set_prec", "cir": "cir", "conform_set_dscp": "conform_set_dscp", "exceed_set_dscp": "exceed_set_dscp", "set_priority": "set_priority", "conform_set_tc": "conform_set_tc", "exceed_set_prec": "exceed_set_prec"}, "pybind.slxos.v17r_2_00.policy_map.class_.police": {}, "pybind.nos.v6_0_2f.policy_map.class_.police": {"exceed_set_tc": "exceed_set_tc", "eir": "eir", "cbs": "cbs", "ebs": "ebs", "conform_set_prec": "conform_set_prec", "cir": "cir", "conform_set_dscp": "conform_set_dscp", "exceed_set_dscp": "exceed_set_dscp", "set_priority": "set_priority", "conform_set_tc": "conform_set_tc", "exceed_set_prec": "exceed_set_prec"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_police_cbs_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.police', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.police', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.police', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.police', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.police', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_police_cir_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.police', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.police', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.police', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.police', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.police', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_police_classification_type_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: name
    :param policy_map: Keyword argument tuple.

    :type name: unicode
    :param name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_')]
    bindings_list = [('pybind.slxos.v17s_1_02.policy_map.class_.police', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_police_conform_set_dscp_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.police', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.police', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_police_conform_set_prec_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.police', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.police', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_police_conform_set_tc_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.police', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.police', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_police_ebs_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.police', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.police', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.police', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.police', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.police', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_police_eir_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.police', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.police', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.police', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.police', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.police', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_police_exceed_set_dscp_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.police', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.police', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_police_exceed_set_prec_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.police', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.police', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_police_exceed_set_tc_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.police', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.police', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_police_remark_profile_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: name
    :param policy_map: Keyword argument tuple.

    :type name: unicode
    :param name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_')]
    bindings_list = [('pybind.slxos.v17s_1_02.policy_map.class_.police', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_police_set_priority_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.police', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.police', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_priority_mapping_table_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.priority_mapping_table', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.priority_mapping_table', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.priority_mapping_table', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.priority_mapping_table', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.priority_mapping_table', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_priority_mapping_table_import_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.priority_mapping_table.import_', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.priority_mapping_table.import_', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.priority_mapping_table.import_', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.priority_mapping_table.import_', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.priority_mapping_table.import_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_priority_mapping_table_import_cee_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.priority_mapping_table.import_', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.priority_mapping_table.import_', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.priority_mapping_table.import_', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.priority_mapping_table.import_', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.priority_mapping_table.import_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last, TC1, TC2, TC3, TC4, TC5, TC6, TC7'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_dwrr_traffic_class0_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_dwrr_traffic_class1_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_dwrr_traffic_class2_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_dwrr_traffic_class3_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_dwrr_traffic_class4_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_dwrr_traffic_class5_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_dwrr_traffic_class6_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_dwrr_traffic_class_last_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_priority_number_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_scheduler_type_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_tc1_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_tc2_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_tc3_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_tc4_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_tc5_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_tc6_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_scheduler_strict_priority_tc7_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_set_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.set_', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.set_', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.set_', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.set_', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.set_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_set_cos_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.set_.set_cos_tc', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.set_.set_cos_tc', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.set_.set_cos_tc', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.set_.set_cos_tc', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.set_.set_cos_tc', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_set_dscp_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.set_.set_dscp', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.set_.set_dscp', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.set_.set_dscp', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.set_.set_dscp', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.set_.set_dscp', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_set_set_cos_tc_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.set_.set_cos_tc', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.set_.set_cos_tc', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.set_.set_cos_tc', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.set_.set_cos_tc', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.set_.set_cos_tc', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'cos, traffic_class'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_set_set_dscp_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.set_.set_dscp', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.set_.set_dscp', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.set_.set_dscp', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.set_.set_dscp', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.set_.set_dscp', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_set_traffic_class_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.set_.set_cos_tc', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.set_.set_cos_tc', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.set_.set_cos_tc', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.set_.set_cos_tc', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.set_.set_cos_tc', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_sflow_profile_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: name
    :param policy_map: Keyword argument tuple.

    :type name: unicode
    :param name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.policy_map.class_', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.policy_map.class_', u'span'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'map'), ('pybind.slxos.v17r_1_01a.policy_map.class_.set_', u'set_dscp'), ('pybind.slxos.v17r_1_01a.policy_map.class_.scheduler', u'strict_priority'), ('pybind.slxos.v17r_1_01a.policy_map.class_.set_', u'set_cos_tc'), ('pybind.slxos.v17r_1_01a.policy_map.class_.priority_mapping_table', u'import_'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'police'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'shape'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'map'), ('pybind.slxos.v17r_2_00.policy_map.class_.set_', u'set_dscp'), ('pybind.slxos.v17r_2_00.policy_map.class_.set_', u'set_cos_tc'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'police'), ('pybind.slxos.v17r_2_00.policy_map.class_.priority_mapping_table', u'import_'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'shape'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'span'), ('pybind.slxos.v17r_2_00.policy_map.class_.scheduler', u'strict_priority'), ('pybind.slxos.v17s_1_02.policy_map.class_.scheduler', u'strict_priority'), ('pybind.slxos.v17s_1_02.policy_map.class_.set_', u'set_dscp'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'shape'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'map'), ('pybind.slxos.v17s_1_02.policy_map.class_.set_', u'set_cos_tc'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'span'), ('pybind.slxos.v17s_1_02.policy_map.class_.priority_mapping_table', u'import_'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'police')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'class_', 'keyval': 'cl_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'session'}, {'leafval': 'cos_mutation, cos_traffic_class, dscp_cos, dscp_traffic_class, dscp_mutation'}, {'leafval': 'dscp'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last, TC1, TC2, TC3, TC4, TC5, TC6, TC7'}, {'leafval': 'cos, traffic_class'}, {'leafval': 'cee'}, {'leafval': 'cir, cbs, eir, ebs'}, {'leafval': 'shaping_rate'}, {'leafval': 'cos_mutation, cos_traffic_class, dscp_cos, dscp_traffic_class, dscp_mutation'}, {'leafval': 'dscp'}, {'leafval': 'cos, traffic_class'}, {'leafval': 'cir, cbs, eir, ebs'}, {'leafval': 'cee'}, {'leafval': 'shaping_rate'}, {'leafval': 'session'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last, TC1, TC2, TC3, TC4, TC5, TC6, TC7'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last, TC1, TC2, TC3, TC4, TC5, TC6, TC7'}, {'leafval': 'dscp'}, {'leafval': 'shaping_rate'}, {'leafval': 'cos_mutation, cos_traffic_class, dscp_cos, dscp_traffic_class, dscp_mutation'}, {'leafval': 'cos, traffic_class'}, {'leafval': 'session'}, {'leafval': 'cee'}, {'leafval': 'cir, cbs, eir, ebs, classification_type, remark_profile'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_shape_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.shape', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.shape', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.shape', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.shape', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.shape', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_shape_shaping_rate_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.shape', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.shape', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.shape', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.shape', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.shape', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_span_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.span', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.span', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.span', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.span', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.span', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def policy_map_class_span_session_get(self, policy_map=None, class_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy_map: po_name
    :param policy_map: Keyword argument tuple.

    :type po_name: unicode
    :param po_name: **policy_map** tuple argument:  Policy Map Name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type class_: cl_name
    :param class_: Keyword argument tuple.

    :type cl_name: unicode
    :param cl_name: **class_** tuple argument:  Policy Map Class Name (Max Size -64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.policy_map', 'policy_map'), ('pybind.nos.v7_2_0.policy_map.class_', u'class_'), ('pybind.slxos.v17r_1_01a.policy_map', 'policy_map'), ('pybind.slxos.v17r_1_01a.policy_map.class_', u'class_'), ('pybind.slxos.v17r_2_00.policy_map', 'policy_map'), ('pybind.slxos.v17r_2_00.policy_map.class_', u'class_'), ('pybind.nos.v6_0_2f.policy_map', 'policy_map'), ('pybind.nos.v6_0_2f.policy_map.class_', u'class_'), ('pybind.slxos.v17s_1_02.policy_map', 'policy_map'), ('pybind.slxos.v17s_1_02.policy_map.class_', u'class_')]
    bindings_list = [('pybind.nos.v6_0_2f.policy_map.class_.span', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.policy_map.class_.span', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.policy_map.class_.span', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.policy_map.class_.span', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.policy_map.class_.span', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'po_name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'cl_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_map=policy_map, class_=class_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_map=policy_map, class_=class_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_channel_redundancy_group_get(self, port_channel_redundancy_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_channel_redundancy_group: group_id
    :param port_channel_redundancy_group: Keyword argument tuple.

    :type group_id: long
    :param group_id: **port_channel_redundancy_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.port_channel_redundancy_group', 'pybind.nos.v6_0_2f.brocade_lag', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_channel_redundancy_group', 'pybind.nos.v7_2_0.brocade_lag', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_channel_redundancy_group', 'pybind.slxos.v17r_1_01a.brocade_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_channel_redundancy_group', 'pybind.slxos.v17r_2_00.brocade_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_channel_redundancy_group', 'pybind.slxos.v17s_1_02.brocade_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.port_channel_redundancy_group', u'port_channel'), ('pybind.slxos.v17s_1_02.port_channel_redundancy_group', u'port_channel'), ('pybind.slxos.v17r_2_00.port_channel_redundancy_group', u'port_channel'), ('pybind.nos.v7_2_0.port_channel_redundancy_group', u'port_channel'), ('pybind.nos.v6_0_2f.port_channel_redundancy_group', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'port_channel_redundancy_group', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, port_channel_active'}, {'leafval': 'name, port_channel_active'}, {'leafval': 'name, port_channel_active'}, {'leafval': 'name, port_channel_active'}, {'leafval': 'name, port_channel_active'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel_redundancy_group=port_channel_redundancy_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel_redundancy_group=port_channel_redundancy_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_channel_redundancy_group_activate_get(self, port_channel_redundancy_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_channel_redundancy_group: group_id
    :param port_channel_redundancy_group: Keyword argument tuple.

    :type group_id: long
    :param group_id: **port_channel_redundancy_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.port_channel_redundancy_group', 'pybind.nos.v6_0_2f.brocade_lag', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_channel_redundancy_group', 'pybind.nos.v7_2_0.brocade_lag', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_channel_redundancy_group', 'pybind.slxos.v17r_1_01a.brocade_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_channel_redundancy_group', 'pybind.slxos.v17r_2_00.brocade_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_channel_redundancy_group', 'pybind.slxos.v17s_1_02.brocade_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.port_channel_redundancy_group', u'port_channel'), ('pybind.slxos.v17s_1_02.port_channel_redundancy_group', u'port_channel'), ('pybind.slxos.v17r_2_00.port_channel_redundancy_group', u'port_channel'), ('pybind.nos.v7_2_0.port_channel_redundancy_group', u'port_channel'), ('pybind.nos.v6_0_2f.port_channel_redundancy_group', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'port_channel_redundancy_group', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, port_channel_active'}, {'leafval': 'name, port_channel_active'}, {'leafval': 'name, port_channel_active'}, {'leafval': 'name, port_channel_active'}, {'leafval': 'name, port_channel_active'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel_redundancy_group=port_channel_redundancy_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel_redundancy_group=port_channel_redundancy_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_channel_redundancy_group_port_channel_get(self, port_channel_redundancy_group=None, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel_redundancy_group: group_id
    :param port_channel_redundancy_group: Keyword argument tuple.

    :type group_id: long
    :param group_id: **port_channel_redundancy_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_channel: name, port_channel_active
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type port_channel_active: YANGBool
    :param port_channel_active: **port_channel** tuple argument:  Select port-channel as active in port-channel redundancy group.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.port_channel_redundancy_group', 'port_channel_redundancy_group'), ('pybind.slxos.v17s_1_02.port_channel_redundancy_group', 'port_channel_redundancy_group'), ('pybind.nos.v7_2_0.port_channel_redundancy_group', 'port_channel_redundancy_group'), ('pybind.slxos.v17r_1_01a.port_channel_redundancy_group', 'port_channel_redundancy_group'), ('pybind.slxos.v17r_2_00.port_channel_redundancy_group', 'port_channel_redundancy_group')]
    bindings_list = [('pybind.nos.v6_0_2f.port_channel_redundancy_group.port_channel', 'pybind.nos.v6_0_2f.brocade_lag', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_channel_redundancy_group.port_channel', 'pybind.nos.v7_2_0.brocade_lag', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_channel_redundancy_group.port_channel', 'pybind.slxos.v17r_1_01a.brocade_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_channel_redundancy_group.port_channel', 'pybind.slxos.v17r_2_00.brocade_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_channel_redundancy_group.port_channel', 'pybind.slxos.v17s_1_02.brocade_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': 'name, port_channel_active'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel_redundancy_group=port_channel_redundancy_group, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel_redundancy_group=port_channel_redundancy_group, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_channel_redundancy_group_port_channel_active_get(self, port_channel_redundancy_group=None, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_channel_redundancy_group: group_id
    :param port_channel_redundancy_group: Keyword argument tuple.

    :type group_id: long
    :param group_id: **port_channel_redundancy_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_channel: name
    :param port_channel: Keyword argument tuple.

    :type name: long
    :param name: **port_channel** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.port_channel_redundancy_group', 'port_channel_redundancy_group'), ('pybind.slxos.v17s_1_02.port_channel_redundancy_group', 'port_channel_redundancy_group'), ('pybind.nos.v7_2_0.port_channel_redundancy_group', 'port_channel_redundancy_group'), ('pybind.slxos.v17r_1_01a.port_channel_redundancy_group', 'port_channel_redundancy_group'), ('pybind.slxos.v17r_2_00.port_channel_redundancy_group', 'port_channel_redundancy_group')]
    bindings_list = [('pybind.nos.v6_0_2f.port_channel_redundancy_group.port_channel', 'pybind.nos.v6_0_2f.brocade_lag', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_channel_redundancy_group.port_channel', 'pybind.nos.v7_2_0.brocade_lag', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_channel_redundancy_group.port_channel', 'pybind.slxos.v17r_1_01a.brocade_lag', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_channel_redundancy_group.port_channel', 'pybind.slxos.v17r_2_00.brocade_lag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_channel_redundancy_group.port_channel', 'pybind.slxos.v17s_1_02.brocade_lag', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_channel_redundancy_group=port_channel_redundancy_group, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_channel_redundancy_group=port_channel_redundancy_group, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.port_profile', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport', u'trunk'), ('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.port_profile.security_profile.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.port_profile_global', u'port_profile'), ('pybind.nos.v6_0_2f.port_profile.qos_profile.qos.flowcontrol', u'flowcontrolglobal'), ('pybind.nos.v6_0_2f.port_profile.security_profile.ip', u'access_group'), ('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport', u'mode'), ('pybind.nos.v6_0_2f.port_profile.qos_profile.qos', u'trust'), ('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v6_0_2f.port_profile.qos_profile.qos.flowcontrol', u'pfc'), ('pybind.nos.v6_0_2f.port_profile', u'restrict_flooding_container'), ('pybind.nos.v6_0_2f.port_profile', u'allow'), ('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v6_0_2f.port_profile.security_profile.mac', u'access_group'), ('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v6_0_2f.port_profile.fcoe_profile', u'fcoeport'), ('pybind.nos.v6_0_2f.port_profile.qos_profile', u'qos'), ('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v6_0_2f.port_profile.vlan_profile', u'switchport_basic'), ('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.access', u'vlan'), ('pybind.nos.v6_0_2f.port_profile', u'qos_profile'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17s_1_02.port_profile.fcoe_profile', u'fcoeport'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile.qos', u'trust'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17s_1_02.port_profile.security_profile.ip', u'access_group'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17s_1_02.port_profile', u'allow'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile', u'qos'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile.qos.flowcontrol', u'flowcontrolglobal'), ('pybind.slxos.v17s_1_02.port_profile', u'qos_profile'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport', u'trunk'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.access', u'vlan'), ('pybind.slxos.v17s_1_02.port_profile.security_profile.ipv6', u'access_group'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17s_1_02.port_profile', u'restrict_flooding_container'), ('pybind.slxos.v17s_1_02.port_profile.security_profile.mac', u'access_group'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17s_1_02.port_profile_global', u'port_profile'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile', u'switchport_basic'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport', u'mode'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_2_00.port_profile', u'allow'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.port_profile', u'qos_profile'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_2_00.port_profile.security_profile.ip', u'access_group'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile.qos.flowcontrol', u'flowcontrolglobal'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.access', u'vlan'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport', u'trunk'), ('pybind.slxos.v17r_2_00.port_profile.fcoe_profile', u'fcoeport'), ('pybind.slxos.v17r_2_00.port_profile.security_profile.ipv6', u'access_group'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport', u'mode'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile.qos', u'trust'), ('pybind.slxos.v17r_2_00.port_profile_global', u'port_profile'), ('pybind.slxos.v17r_2_00.port_profile.security_profile.mac', u'access_group'), ('pybind.slxos.v17r_2_00.port_profile', u'restrict_flooding_container'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile', u'qos'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile', u'switchport_basic'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.port_profile.qos_profile.qos.flowcontrol', u'pfc'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.nos.v7_2_0.port_profile.security_profile.ipv6', u'access_group'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.nos.v7_2_0.port_profile.vlan_profile', u'switchport_basic'), ('pybind.nos.v7_2_0.port_profile', u'restrict_flooding_container'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.access', u'vlan'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk.allowed', u'vlan'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport', u'trunk'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.nos.v7_2_0.port_profile.fcoe_profile', u'fcoeport'), ('pybind.nos.v7_2_0.port_profile.security_profile.mac', u'access_group'), ('pybind.nos.v7_2_0.port_profile.qos_profile', u'qos'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk', u'native_vlan_classification'), ('pybind.nos.v7_2_0.port_profile.security_profile.ip', u'access_group'), ('pybind.nos.v7_2_0.port_profile_global', u'port_profile'), ('pybind.nos.v7_2_0.port_profile', u'qos_profile'), ('pybind.nos.v7_2_0.port_profile', u'allow'), ('pybind.nos.v7_2_0.port_profile.qos_profile.qos', u'trust'), ('pybind.nos.v7_2_0.port_profile.qos_profile.qos.flowcontrol', u'flowcontrolglobal'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.access', u'vlan'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.port_profile', u'allow'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'remove'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk.allowed', u'vlan'), ('pybind.slxos.v17r_1_01a.port_profile.security_profile.ip', u'access_group'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', u'add'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile.qos', u'trust'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile', u'qos'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile', u'switchport_basic'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access', u'vlan'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile.qos.flowcontrol', u'pfc'), ('pybind.slxos.v17r_1_01a.port_profile', u'qos_profile'), ('pybind.slxos.v17r_1_01a.port_profile.security_profile.ipv6', u'access_group'), ('pybind.slxos.v17r_1_01a.port_profile', u'restrict_flooding_container'), ('pybind.slxos.v17r_1_01a.port_profile.security_profile.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport', u'mode'), ('pybind.slxos.v17r_1_01a.port_profile_global', u'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport', u'trunk'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk', u'native_vlan_classification'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile.qos.flowcontrol', u'flowcontrolglobal'), ('pybind.slxos.v17r_1_01a.port_profile.fcoe_profile', u'fcoeport')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'port_profile', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'native_vlan'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'ipv6_access_group_name, ipv6_in'}, {'leafval': 'name, activate'}, {'leafval': 'tx, rx'}, {'leafval': 'ipv4_access_group_name, ipv4_in'}, {'leafval': 'vlan_mode'}, {'leafval': 'trust_cos'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'pfc_cos, pfc_tx, pfc_rx'}, {'leafval': 'restrict_flooding'}, {'leafval': 'nonprofiledmacs'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'access_group_name, in_'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'fcoe_map_name'}, {'leafval': 'cos, cos_mutation, cos_traffic_class'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'basic'}, {'leafval': 'name'}, {'leafval': 'cee'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'fcoe_map_name'}, {'leafval': 'trust_cos'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv4_access_group_name, ipv4_in'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'nonprofiledmacs'}, {'leafval': 'cos, cos_mutation, cos_traffic_class'}, {'leafval': 'tx, rx'}, {'leafval': 'cee'}, {'leafval': 'native_vlan'}, {'leafval': 'name'}, {'leafval': 'ipv6_access_group_name, ipv6_in'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'restrict_flooding'}, {'leafval': 'access_group_name, in_'}, {'leafval': 'pfc_cos, pfc_tx, pfc_rx'}, {'leafval': 'name, activate'}, {'leafval': 'basic'}, {'leafval': 'vlan_mode'}, {'leafval': 'pfc_cos, pfc_tx, pfc_rx'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'nonprofiledmacs'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'cee'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'ipv4_access_group_name, ipv4_in'}, {'leafval': 'tx, rx'}, {'leafval': 'name'}, {'leafval': 'native_vlan'}, {'leafval': 'fcoe_map_name'}, {'leafval': 'ipv6_access_group_name, ipv6_in'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'vlan_mode'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'trust_cos'}, {'leafval': 'name, activate'}, {'leafval': 'access_group_name, in_'}, {'leafval': 'restrict_flooding'}, {'leafval': 'cos, cos_mutation, cos_traffic_class'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'basic'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'pfc_cos, pfc_tx, pfc_rx'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'ipv6_access_group_name, ipv6_in'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'basic'}, {'leafval': 'restrict_flooding'}, {'leafval': 'name'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'native_vlan'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'fcoe_map_name'}, {'leafval': 'access_group_name, in_'}, {'leafval': 'cos, cos_mutation, cos_traffic_class'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'ipv4_access_group_name, ipv4_in'}, {'leafval': 'name, activate'}, {'leafval': 'cee'}, {'leafval': 'nonprofiledmacs'}, {'leafval': 'trust_cos'}, {'leafval': 'tx, rx'}, {'leafval': 'vlan_mode'}, {'leafval': 'name'}, {'leafval': 'access_vlan_id, access_mac_group'}, {'leafval': 'nonprofiledmacs'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'all, none, add_, except_, remove_'}, {'leafval': 'ipv4_access_group_name, ipv4_in'}, {'leafval': 'trunk_vlan_id, trunk_ctag_id'}, {'leafval': 'trust_cos'}, {'leafval': 'cos, cos_mutation, cos_traffic_class'}, {'leafval': 'basic'}, {'leafval': 'access_vlan_id, access_mac_address'}, {'leafval': 'pfc_cos, pfc_tx, pfc_rx'}, {'leafval': 'cee'}, {'leafval': 'ipv6_access_group_name, ipv6_in'}, {'leafval': 'restrict_flooding'}, {'leafval': 'access_group_name, in_'}, {'leafval': 'vlan_mode'}, {'leafval': 'name, activate'}, {'leafval': 'native_vlan'}, {'leafval': 'native_vlan_id, native_vlan_ctag_id'}, {'leafval': 'tx, rx'}, {'leafval': 'fcoe_map_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_activate_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.port_profile_global.port_profile', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile_global.port_profile', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile_global.port_profile', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile_global.port_profile', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile_global.port_profile', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.port_profile_global.port_profile', u'static'), ('pybind.slxos.v17s_1_02.port_profile_global.port_profile', u'static'), ('pybind.nos.v6_0_2f.port_profile_global.port_profile', u'static'), ('pybind.slxos.v17r_1_01a.port_profile_global.port_profile', u'static'), ('pybind.slxos.v17r_2_00.port_profile_global.port_profile', u'static')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_profile', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_address'}, {'leafval': 'mac_address'}, {'leafval': 'mac_address'}, {'leafval': 'mac_address'}, {'leafval': 'mac_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_allow_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.allow', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.allow', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.allow', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.allow', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.allow', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_allow_non_profiled_macs_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.allow', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.allow', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.allow', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.allow', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.allow', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_domain_get(self, port_profile_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_profile_domain: port_profile_domain_name
    :param port_profile_domain: Keyword argument tuple.

    :type port_profile_domain_name: unicode
    :param port_profile_domain_name: **port_profile_domain** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.port_profile_domain', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile_domain', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile_domain', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile_domain', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile_domain', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.port_profile_domain', u'profile'), ('pybind.nos.v7_2_0.port_profile_domain', u'profile'), ('pybind.slxos.v17s_1_02.port_profile_domain', u'profile'), ('pybind.slxos.v17r_1_01a.port_profile_domain', u'profile'), ('pybind.nos.v6_0_2f.port_profile_domain', u'profile')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'port_profile_domain', 'keyval': 'port_profile_domain_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'profile_name'}, {'leafval': 'profile_name'}, {'leafval': 'profile_name'}, {'leafval': 'profile_name'}, {'leafval': 'profile_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile_domain=port_profile_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile_domain=port_profile_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_domain_port_profile_get(self, port_profile_domain=None, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile_domain: port_profile_domain_name
    :param port_profile_domain: Keyword argument tuple.

    :type port_profile_domain_name: unicode
    :param port_profile_domain_name: **port_profile_domain** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.port_profile_domain', 'port_profile_domain'), ('pybind.slxos.v17r_2_00.port_profile_domain', 'port_profile_domain'), ('pybind.nos.v7_2_0.port_profile_domain', 'port_profile_domain'), ('pybind.slxos.v17s_1_02.port_profile_domain', 'port_profile_domain'), ('pybind.nos.v6_0_2f.port_profile_domain', 'port_profile_domain')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile_domain.profile', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile_domain.profile', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile_domain.profile', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile_domain.profile', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile_domain.profile', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'port_profile_domain_name', 'extra_keyval': ''}, {'keyval': 'port_profile_domain_name', 'extra_keyval': ''}, {'keyval': 'port_profile_domain_name', 'extra_keyval': ''}, {'keyval': 'port_profile_domain_name', 'extra_keyval': ''}, {'keyval': 'port_profile_domain_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'profile', 'keyval': 'profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile_domain=port_profile_domain, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile_domain=port_profile_domain, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_fcoe_profile_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.fcoe_profile', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.fcoe_profile', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.fcoe_profile', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.fcoe_profile', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.fcoe_profile', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_fcoe_profile_fcoeport_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.fcoe_profile.fcoeport', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.fcoe_profile.fcoeport', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.fcoe_profile.fcoeport', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.fcoe_profile.fcoeport', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.fcoe_profile.fcoeport', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_fcoe_profile_fcoeport_fcoe_map_name_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.fcoe_profile.fcoeport', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.fcoe_profile.fcoeport', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.fcoe_profile.fcoeport', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.fcoe_profile.fcoeport', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.fcoe_profile.fcoeport', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_global_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.port_profile_global', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile_global', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile_global', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile_global', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile_global', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.port_profile_global', u'port_profile'), ('pybind.slxos.v17r_2_00.port_profile_global', u'port_profile'), ('pybind.nos.v6_0_2f.port_profile_global', u'port_profile'), ('pybind.slxos.v17s_1_02.port_profile_global', u'port_profile'), ('pybind.nos.v7_2_0.port_profile_global', u'port_profile')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, activate'}, {'leafval': 'name, activate'}, {'leafval': 'name, activate'}, {'leafval': 'name, activate'}, {'leafval': 'name, activate'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_port_profile_global_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.port_profile_global.port_profile', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile_global.port_profile', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile_global.port_profile', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile_global.port_profile', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile_global.port_profile', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.port_profile_global.port_profile', u'static'), ('pybind.slxos.v17s_1_02.port_profile_global.port_profile', u'static'), ('pybind.nos.v6_0_2f.port_profile_global.port_profile', u'static'), ('pybind.slxos.v17r_1_01a.port_profile_global.port_profile', u'static'), ('pybind.slxos.v17r_2_00.port_profile_global.port_profile', u'static')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_profile', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_address'}, {'leafval': 'mac_address'}, {'leafval': 'mac_address'}, {'leafval': 'mac_address'}, {'leafval': 'mac_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_qos_profile_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.qos_profile', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.qos_profile', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_qos_profile_cee_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.qos_profile', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.qos_profile', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_qos_profile_qos_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.qos_profile.qos', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.qos_profile.qos', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile.qos', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile.qos', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile.qos', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_qos_profile_qos_cos_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.qos_profile.qos', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.qos_profile.qos', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile.qos', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile.qos', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile.qos', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_qos_profile_qos_cos_mutation_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.qos_profile.qos', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.qos_profile.qos', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile.qos', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile.qos', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile.qos', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_qos_profile_qos_cos_traffic_class_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.qos_profile.qos', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.qos_profile.qos', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile.qos', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile.qos', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile.qos', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_qos_profile_qos_flowcontrol_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.qos_profile.qos.flowcontrol', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.qos_profile.qos.flowcontrol', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile.qos.flowcontrol', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile.qos.flowcontrol', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile.qos.flowcontrol', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_qos_profile_qos_flowcontrol_flowcontrolglobal_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_qos_profile_qos_flowcontrol_pfc_get(self, port_profile=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_qos_profile_qos_flowcontrol_pfc_rx_get(self, port_profile=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_qos_profile_qos_flowcontrol_pfc_tx_get(self, port_profile=None, pfc=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type pfc: pfc_cos
    :param pfc: Keyword argument tuple.

    :type pfc_cos: long
    :param pfc_cos: **pfc** tuple argument:  CoS value

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile.qos.flowcontrol.pfc', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pfc', 'keyval': 'pfc_cos', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, pfc=pfc)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, pfc=pfc)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_qos_profile_qos_flowcontrol_rx_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_qos_profile_qos_flowcontrol_tx_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile.qos.flowcontrol.flowcontrolglobal', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_qos_profile_qos_trust_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.qos_profile.qos.trust', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.qos_profile.qos.trust', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile.qos.trust', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile.qos.trust', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile.qos.trust', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_qos_profile_qos_trust_cos_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.qos_profile.qos.trust', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.qos_profile.qos.trust', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.qos_profile.qos.trust', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.qos_profile.qos.trust', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.qos_profile.qos.trust', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_restrict_flooding_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.restrict_flooding_container', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.restrict_flooding_container', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.restrict_flooding_container', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.restrict_flooding_container', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.restrict_flooding_container', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_security_profile_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.security_profile', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.security_profile', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.security_profile', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.security_profile', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.security_profile', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_security_profile_ip_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.security_profile.ip', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.security_profile.ip', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.security_profile.ip', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.security_profile.ip', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.security_profile.ip', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_security_profile_ip_access_group_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.security_profile.ip.access_group', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.security_profile.ip.access_group', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.security_profile.ip.access_group', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.security_profile.ip.access_group', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.security_profile.ip.access_group', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ipv4_access_group_name, ipv4_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_security_profile_ip_access_group_in_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.security_profile.ip.access_group', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.security_profile.ip.access_group', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.security_profile.ip.access_group', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.security_profile.ip.access_group', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.security_profile.ip.access_group', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_security_profile_ip_access_group_ipv4_access_group_name_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.security_profile.ip.access_group', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.security_profile.ip.access_group', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.security_profile.ip.access_group', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.security_profile.ip.access_group', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.security_profile.ip.access_group', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_security_profile_ipv6_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.security_profile.ipv6', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.security_profile.ipv6', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.security_profile.ipv6', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.security_profile.ipv6', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.security_profile.ipv6', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_security_profile_ipv6_access_group_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.security_profile.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.security_profile.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.security_profile.ipv6.access_group', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.security_profile.ipv6.access_group', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.security_profile.ipv6.access_group', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ipv6_access_group_name, ipv6_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_security_profile_ipv6_access_group_in_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.security_profile.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.security_profile.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.security_profile.ipv6.access_group', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.security_profile.ipv6.access_group', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.security_profile.ipv6.access_group', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_security_profile_ipv6_access_group_ipv6_access_group_name_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.security_profile.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.security_profile.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.security_profile.ipv6.access_group', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.security_profile.ipv6.access_group', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.security_profile.ipv6.access_group', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_security_profile_mac_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.security_profile.mac', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.security_profile.mac', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.security_profile.mac', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.security_profile.mac', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.security_profile.mac', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_security_profile_mac_access_group_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.security_profile.mac.access_group', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.security_profile.mac.access_group', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.security_profile.mac.access_group', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.security_profile.mac.access_group', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.security_profile.mac.access_group', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'access_group_name, in_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_security_profile_mac_access_group_access_group_name_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.security_profile.mac.access_group', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.security_profile.mac.access_group', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.security_profile.mac.access_group', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.security_profile.mac.access_group', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.security_profile.mac.access_group', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_security_profile_mac_access_group_in_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.security_profile.mac.access_group', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.security_profile.mac.access_group', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.security_profile.mac.access_group', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.security_profile.mac.access_group', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.security_profile.mac.access_group', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_static_get(self, port_profile=None, static=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type static: mac_address
    :param static: Keyword argument tuple.

    :type mac_address: unicode
    :param mac_address: **static** tuple argument:  mac address in HHHH.HHHH.HHHH format

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.port_profile_global.port_profile', u'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile_global.port_profile', u'port_profile'), ('pybind.slxos.v17s_1_02.port_profile_global.port_profile', u'port_profile'), ('pybind.nos.v7_2_0.port_profile_global.port_profile', u'port_profile'), ('pybind.slxos.v17r_2_00.port_profile_global.port_profile', u'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile_global.port_profile.static', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile_global.port_profile.static', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile_global.port_profile.static', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile_global.port_profile.static', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile_global.port_profile.static', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static', 'keyval': 'mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, static=static)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, static=static)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport_basic', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport_basic', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport_basic', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport_basic', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport_basic', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_access_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.access', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.access', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.access', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.access', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.access', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_access_access_mac_group_vlan_classification_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_access_access_mac_vlan_classification_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_access_mac_group_vlan_classification_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_access_mac_vlan_classification_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.access_mac_vlan_classification', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.access_mac_vlan_classification', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.access_mac_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.access_mac_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.access_mac_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_access_vlan_get(self, port_profile=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_group
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_group: long
    :param access_mac_group: **vlan** tuple argument:  Associate a Mac group with a vlan

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.access_mac_group_vlan_classification.access.vlan', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_access_vlan_access_mac_vlan_classification_get(self, port_profile=None, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type vlan: access_vlan_id, access_mac_address
    :param vlan: Keyword argument tuple.

    :type access_vlan_id: long
    :param access_vlan_id: **vlan** tuple argument:  Set the default VLAN for the interface

        * range restriction: ::

            ['0..4294967295']

    :type access_mac_address: unicode
    :param access_mac_address: **vlan** tuple argument:  Associate the Mac address with a vlan

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access.vlan', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access.vlan', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access.vlan', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.access_mac_vlan_classification.access.vlan', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'access_vlan_id, access_mac_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_access_vlan_name_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.access.vlan', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.access.vlan', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.access.vlan', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.access.vlan', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.access.vlan', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_basic_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport_basic', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport_basic', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport_basic', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport_basic', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport_basic', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_mode_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.mode', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.mode', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.mode', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.mode', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.mode', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_mode_vlan_mode_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.mode', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.mode', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.mode', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.mode', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.mode', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk.allowed', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk.allowed', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk.allowed', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk.allowed', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk.allowed', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_trunk_vlan_classification_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_vlan_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_vlan_add_get(self, port_profile=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type add: trunk_vlan_id, trunk_ctag_id
    :param add: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **add** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.add_', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_vlan_all_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_vlan_except_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_vlan_none_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_vlan_remove_get(self, port_profile=None, remove=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    **Instance Keyword Argument Tuple**:

    :type remove: trunk_vlan_id, trunk_ctag_id
    :param remove: Keyword argument tuple.

    :type trunk_vlan_id: long
    :param trunk_vlan_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type trunk_ctag_id: long
    :param trunk_ctag_id: **remove** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan.remove_', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remove', 'keyval': 'trunk_vlan_id, trunk_ctag_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile, remove=remove)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile, remove=remove)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_allowed_vlan_trunk_vlan_classification_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification.allowed.vlan', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_ctag_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_native_vlan_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_native_vlan_classification_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'native_vlan_id, native_vlan_ctag_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_native_vlan_native_vlan_classification_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk.native_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def port_profile_vlan_profile_switchport_trunk_trunk_vlan_classification_get(self, port_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type port_profile: name
    :param port_profile: Keyword argument tuple.

    :type name: unicode
    :param name: **port_profile** tuple argument:  Port-profile name (Max Size - 128)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,127})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.port_profile', 'port_profile'), ('pybind.slxos.v17r_2_00.port_profile', 'port_profile'), ('pybind.slxos.v17s_1_02.port_profile', 'port_profile'), ('pybind.nos.v7_2_0.port_profile', 'port_profile'), ('pybind.nos.v6_0_2f.port_profile', 'port_profile')]
    bindings_list = [('pybind.nos.v6_0_2f.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v6_0_2f.brocade_port_profile', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification', 'pybind.nos.v7_2_0.brocade_port_profile', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification', 'pybind.slxos.v17r_1_01a.brocade_port_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification', 'pybind.slxos.v17r_2_00.brocade_port_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.port_profile.vlan_profile.switchport.trunk.trunk_vlan_classification', 'pybind.slxos.v17s_1_02.brocade_port_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_profile=port_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_profile=port_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def preprovision_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.preprovision', 'pybind.nos.v6_0_2f.brocade_preprovision', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.preprovision', 'pybind.nos.v7_2_0.brocade_preprovision', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.preprovision', 'pybind.slxos.v17r_1_01a.brocade_preprovision', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.preprovision', 'pybind.slxos.v17r_2_00.brocade_preprovision', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.preprovision', 'pybind.slxos.v17s_1_02.brocade_preprovision', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.preprovision', u'rbridge_id'), ('pybind.nos.v7_2_0.preprovision', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.preprovision', u'rbridge_id'), ('pybind.slxos.v17r_2_00.preprovision', u'rbridge_id'), ('pybind.slxos.v17s_1_02.preprovision', u'rbridge_id')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rbridge_id, wwn'}, {'leafval': 'rbridge_id, wwn'}, {'leafval': 'rbridge_id, wwn'}, {'leafval': 'rbridge_id, wwn'}, {'leafval': 'rbridge_id, wwn'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def preprovision_rbridge_id_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id, wwn
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type wwn: unicode
    :param wwn: **rbridge_id** tuple argument:  World Wide Name (WWN)

        * pattern restriction: ::

            '[0-9a-fA-F][0-9a-fA-F]:[0-9a-fA-F][0-9a-fA-F]:[0'
            '-9a-fA-F][0-9a-fA-F]:[0-9a-fA-F][0-9a-fA-F]:[0-9'
            'a-fA-F][0-9a-fA-F]:[0-9a-fA-F][0-9a-fA-F]:[0-9a-'
            'fA-F][0-9a-fA-F]:[0-9a-fA-F][0-9a-fA-F]'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.preprovision.rbridge_id', 'pybind.nos.v6_0_2f.brocade_preprovision', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.preprovision.rbridge_id', 'pybind.nos.v7_2_0.brocade_preprovision', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.preprovision.rbridge_id', 'pybind.slxos.v17r_1_01a.brocade_preprovision', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.preprovision.rbridge_id', 'pybind.slxos.v17r_2_00.brocade_preprovision', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.preprovision.rbridge_id', 'pybind.slxos.v17s_1_02.brocade_preprovision', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rbridge_id', 'keyval': 'rbridge_id, wwn', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree', u'stp'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'system_id'), ('pybind.nos.v7_2_0.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree', u'mstp'), ('pybind.nos.v7_2_0.protocol.spanning_tree', u'pvst'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.lldp', u'profile'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree', u'rpvst'), ('pybind.nos.v7_2_0.protocol.lldp', u'advertise'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree', u'rstp'), ('pybind.nos.v7_2_0.protocol', u'udld'), ('pybind.nos.v7_2_0.protocol', u'edge_loop_detection'), ('pybind.nos.v7_2_0.protocol', u'lldp'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'system_id'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol', u'edge_loop_detection'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree', u'stp'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol', u'ptp'), ('pybind.slxos.v17s_1_02.protocol', u'udld'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'advertise'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.cfm', u'domain_name'), ('pybind.slxos.v17s_1_02.protocol', u'lldp'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.routing_system.protocol', u'hide_vrrp_holder'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree', u'mstp'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree', u'rstp'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree', u'pvst'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree', u'rpvst'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.cfm', u'domain_name'), ('pybind.slxos.v17r_1_01a.routing_system.protocol', u'hide_vrrp_holder'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree', u'pvst'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree', u'rstp'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731', u'action_profile_name'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree', u'rpvst'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol', u'link_oam'), ('pybind.slxos.v17r_1_01a.protocol', u'edge_loop_detection'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree', u'stp'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree', u'mstp'), ('pybind.slxos.v17r_1_01a.protocol.lldp', u'profile'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol', u'udld'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol', u'lldp'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol', u'udld'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree', u'mstp'), ('pybind.nos.v6_0_2f.protocol.lldp', u'profile'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree', u'stp'), ('pybind.nos.v6_0_2f.protocol.spanning_tree', u'rstp'), ('pybind.nos.v6_0_2f.protocol.spanning_tree', u'pvst'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.lldp', u'advertise'), ('pybind.nos.v6_0_2f.protocol', u'lldp'), ('pybind.nos.v6_0_2f.protocol.spanning_tree', u'rpvst'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.nos.v6_0_2f.protocol', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731', u'action_profile_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731', u'test_profile')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time'}, {'leafval': 'oui'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time, cisco_interoperability, region, revision, max_hops, transmit_holdcount'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'path_cost'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time, transmit_holdcount'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv, bgp_auto_nbr_tlv'}, {'leafval': 'oui'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time, transmit_holdcount'}, {'leafval': 'hello, multiplier, shutdown'}, {'leafval': 'pdu_rx_limit, hello_interval, shutdown_time'}, {'leafval': 'description, hello, mode, multiplier, system_name, system_description, iscsi_priority, disable'}, {'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'pdu_rx_limit, hello_interval, shutdown_time'}, {'leafval': 'description, cluster_system_id, bridge_priority, shutdown'}, {'leafval': 'id, priority'}, {'leafval': 'path_cost'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'path_cost'}, {'leafval': 'enable, domain, priority1, priority2, source_ip'}, {'leafval': 'hello, multiplier, shutdown'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'path_cost'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'domain_name, domain_level'}, {'leafval': 'description, hello, mode, multiplier, system_name, system_description, iscsi_priority, disable'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'enable, interval'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'description, cluster_system_id, bridge_priority, shutdown, cisco_interoperability, region, revision, max_hops, transmit_holdcount'}, {'leafval': 'description, cluster_system_id, bridge_priority, shutdown, transmit_holdcount'}, {'leafval': 'description, cluster_system_id, bridge_priority, shutdown'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'description, cluster_system_id, bridge_priority, shutdown, transmit_holdcount'}, {'leafval': 'path_cost'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'path_cost'}, {'leafval': 'domain_name, domain_level'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'description, bridge_priority, shutdown'}, {'leafval': 'enable, interval'}, {'leafval': 'description, bridge_priority, shutdown, transmit_holdcount'}, {'leafval': 'action_profile_name'}, {'leafval': 'description, bridge_priority, shutdown, transmit_holdcount'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'test_profile, profile_type'}, {'leafval': 'path_cost'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'id, priority'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'id, priority'}, {'leafval': 'shutdown, pdu_rate, time_out'}, {'leafval': 'pdu_rx_limit, hello_interval, shutdown_time, raslog_duration'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'description, bridge_priority, shutdown'}, {'leafval': 'description, bridge_priority, shutdown, cisco_interoperability, region, revision, max_hops, transmit_holdcount'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'hello, multiplier, shutdown'}, {'leafval': 'enable, interval'}, {'leafval': 'description, hello, mode, multiplier, system_name, system_description, iscsi_priority, disable'}, {'leafval': 'enable, interval'}, {'leafval': 'hello, multiplier, shutdown'}, {'leafval': 'path_cost'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time, cisco_interoperability, region, revision, max_hops, transmit_holdcount'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'path_cost'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time, transmit_holdcount'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'description, hello, mode, multiplier, system_name, system_description, iscsi_priority, disable'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time, transmit_holdcount'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'pdu_rx_limit, hello_interval, shutdown_time'}, {'leafval': 'domain_name, domain_id, domain_level'}, {'leafval': 'action_profile_name'}, {'leafval': 'test_profile, profile_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.protocol', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm', u'domain_name'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'vlan'), ('pybind.slxos.v17r_2_00.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol', u'link_oam'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731', u'action_profile_name'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol', u'edge_loop_detection'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree', u'stp'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731', u'test_profile'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.routing_system.protocol', u'hide_vrrp_holder'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'profile'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree', u'pvst'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree', u'mstp'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree', u'rpvst'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol', u'lldp'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree', u'rstp'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol', u'udld'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'error_disable_timeout')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'domain_name, domain_id, domain_level'}, {'leafval': 'id, priority'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'path_cost'}, {'leafval': 'shutdown, pdu_rate, time_out'}, {'leafval': 'path_cost'}, {'leafval': 'path_cost'}, {'leafval': 'action_profile_name'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'pdu_rx_limit, hello_interval, shutdown_time, raslog_duration'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'description, bridge_priority, shutdown'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'test_profile, profile_type'}, {'leafval': 'enable, interval'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'description, bridge_priority, shutdown'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'enable, interval'}, {'leafval': 'description, bridge_priority, shutdown, cisco_interoperability, region, revision, max_hops, transmit_holdcount'}, {'leafval': 'id, priority'}, {'leafval': 'path_cost'}, {'leafval': 'description, bridge_priority, shutdown, transmit_holdcount'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'description, hello, mode, multiplier, system_name, system_description, iscsi_priority, disable'}, {'leafval': 'description, bridge_priority, shutdown, transmit_holdcount'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello, multiplier, shutdown'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731', u'action_profile_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731', u'test_profile'), ('pybind.slxos.v17s_1_02.protocol.cfm', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731', u'action_profile_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731', u'test_profile')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'domain_name, domain_id, domain_level'}, {'leafval': 'action_profile_name'}, {'leafval': 'test_profile, profile_type'}, {'leafval': 'domain_name, domain_level'}, {'leafval': 'domain_name, domain_level'}, {'leafval': 'action_profile_name'}, {'leafval': 'test_profile, profile_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_get(self, domain_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', u'ma_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'ma_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'ma_name')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain_name', 'keyval': 'domain_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ma_name, ma_id, ma_vlan_vid, ma_bd_vid, ma_priority'}, {'leafval': 'ma_name, ma_id, ma_vlan_vid, ma_bd_vid, ma_priority'}, {'leafval': 'ma_name, ma_id, ma_vlan_vid, ma_bd_vid, ma_priority'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.protocol.cfm.domain_name": {"domain_name": "domain_name", "domain_level": "domain_level"}, "pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name": {}, "pybind.slxos.v17s_1_02.protocol.cfm.domain_name": {"domain_name": "domain_name", "domain_level": "domain_level"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_id_get(self, domain_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'ma_name')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain_name', 'keyval': 'domain_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ma_name, ma_id, ma_vlan_vid, ma_bd_vid, ma_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_level_get(self, domain_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'ma_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'ma_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', u'ma_name')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'domain_name', 'keyval': 'domain_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ma_name, ma_id, ma_vlan_vid, ma_bd_vid, ma_priority'}, {'leafval': 'ma_name, ma_id, ma_vlan_vid, ma_bd_vid, ma_priority'}, {'leafval': 'ma_name, ma_id, ma_vlan_vid, ma_bd_vid, ma_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_get(self, domain_name=None, ma_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', u'cfm_ma_sub_commands'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', u'mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'cfm_ma_sub_commands'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', u'mep'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'cfm_ma_sub_commands'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', u'mep')]
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma_name', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ccm_interval, mip_policy'}, {'leafval': 'mep_id, mep_down_up, vlan, mep_intf_type, mep_intf_name'}, {'leafval': 'ccm_interval, mip_policy, maid_format'}, {'leafval': 'mep_id, mep_down_up, vlan, inner_vlan, mep_intf_type, mep_intf_name'}, {'leafval': 'ccm_interval, mip_policy, maid_format'}, {'leafval': 'mep_id, mep_down_up, vlan, inner_vlan, mep_intf_type, mep_intf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name': [u'ma_vlan_vid', u'ma_bd_vid'], 'pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name': [u'ma_vlan_vid', u'ma_bd_vid'], 'pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name': [u'ma_vlan_vid', u'ma_bd_vid']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_bridge_domain_get(self, domain_name=None, ma_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', u'cfm_ma_sub_commands'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', u'mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'cfm_ma_sub_commands'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', u'mep'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'cfm_ma_sub_commands'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', u'mep')]
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma_name', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ccm_interval, mip_policy'}, {'leafval': 'mep_id, mep_down_up, vlan, mep_intf_type, mep_intf_name'}, {'leafval': 'ccm_interval, mip_policy, maid_format'}, {'leafval': 'mep_id, mep_down_up, vlan, inner_vlan, mep_intf_type, mep_intf_name'}, {'leafval': 'ccm_interval, mip_policy, maid_format'}, {'leafval': 'mep_id, mep_down_up, vlan, inner_vlan, mep_intf_type, mep_intf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_ccm_interval_get(self, domain_name=None, ma_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'ma_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_id_get(self, domain_name=None, ma_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', u'cfm_ma_sub_commands'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', u'mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'cfm_ma_sub_commands'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', u'mep'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'cfm_ma_sub_commands'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', u'mep')]
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma_name', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ccm_interval, mip_policy'}, {'leafval': 'mep_id, mep_down_up, vlan, mep_intf_type, mep_intf_name'}, {'leafval': 'ccm_interval, mip_policy, maid_format'}, {'leafval': 'mep_id, mep_down_up, vlan, inner_vlan, mep_intf_type, mep_intf_name'}, {'leafval': 'ccm_interval, mip_policy, maid_format'}, {'leafval': 'mep_id, mep_down_up, vlan, inner_vlan, mep_intf_type, mep_intf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_maid_format_get(self, domain_name=None, ma_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'ma_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_get(self, domain_name=None, ma_name=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'ma_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands')]
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'tlv_type'}, {'leafval': 'remote_mep, action_profile_association'}, {'leafval': 'tlv_type'}, {'leafval': 'remote_mep'}, {'leafval': 'remote_mep, action_profile_association'}, {'leafval': 'tlv_type'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep": {"inner_vlan": "inner_vlan", "mep_down_up": "mep_down_up", "mep_intf_name": "mep_intf_name", "vlan": "vlan", "mep_intf_type": "mep_intf_type", "mep_id": "mep_id"}, "pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep": {}, "pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep": {"inner_vlan": "inner_vlan", "mep_down_up": "mep_down_up", "mep_intf_name": "mep_intf_name", "vlan": "vlan", "mep_intf_type": "mep_intf_type", "mep_id": "mep_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_inner_vlan_get(self, domain_name=None, ma_name=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'ma_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands')]
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'tlv_type'}, {'leafval': 'remote_mep, action_profile_association'}, {'leafval': 'remote_mep, action_profile_association'}, {'leafval': 'tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_mep_down_up_get(self, domain_name=None, ma_name=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'ma_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands')]
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'tlv_type'}, {'leafval': 'remote_mep, action_profile_association'}, {'leafval': 'tlv_type'}, {'leafval': 'remote_mep'}, {'leafval': 'remote_mep, action_profile_association'}, {'leafval': 'tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_mep_intf_name_get(self, domain_name=None, ma_name=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'ma_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands')]
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'tlv_type'}, {'leafval': 'remote_mep, action_profile_association'}, {'leafval': 'tlv_type'}, {'leafval': 'remote_mep'}, {'leafval': 'remote_mep, action_profile_association'}, {'leafval': 'tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_mep_intf_type_get(self, domain_name=None, ma_name=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'ma_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands')]
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'tlv_type'}, {'leafval': 'remote_mep, action_profile_association'}, {'leafval': 'tlv_type'}, {'leafval': 'remote_mep'}, {'leafval': 'remote_mep, action_profile_association'}, {'leafval': 'tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_remote_mep_get(self, domain_name=None, ma_name=None, mep=None, remote_mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type remote_mep: remote_mep
    :param remote_mep: Keyword argument tuple.

    :type remote_mep: long
    :param remote_mep: **remote_mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'mep'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'mep'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep', u'rmep_test_profile'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep', u'rmep_test_profile')]
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remote_mep', 'keyval': 'remote_mep', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_test_profile, mode'}, {'leafval': 'rmep_test_profile, mode'}]
    leafval_map = {"pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep": {}, "pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep": {"action_profile_association": "action_profile_association", "remote_mep": "remote_mep"}, "pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep": {"action_profile_association": "action_profile_association", "remote_mep": "remote_mep"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep, remote_mep=remote_mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep, remote_mep=remote_mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_remote_mep_action_profile_get(self, domain_name=None, ma_name=None, mep=None, remote_mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type remote_mep: remote_mep
    :param remote_mep: Keyword argument tuple.

    :type remote_mep: long
    :param remote_mep: **remote_mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'mep'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep', u'rmep_test_profile'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep', u'rmep_test_profile')]
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'remote_mep', 'keyval': 'remote_mep', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rmep_test_profile, mode'}, {'leafval': 'rmep_test_profile, mode'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep, remote_mep=remote_mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep, remote_mep=remote_mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_remote_mep_test_profile_get(self, domain_name=None, ma_name=None, mep=None, remote_mep=None, rmep_test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type remote_mep: remote_mep
    :param remote_mep: Keyword argument tuple.

    :type remote_mep: long
    :param remote_mep: **remote_mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rmep_test_profile: rmep_test_profile, mode
    :param rmep_test_profile: Keyword argument tuple.

    :type rmep_test_profile: unicode
    :param rmep_test_profile: **rmep_test_profile** tuple argument:  Configure test profile name for Remote-MEP

        * length restriction: ::

            ['1..32']

    :type mode: unicode
    :param mode: **rmep_test_profile** tuple argument:  Configure Remote-MEP test profile mode as Initiator/Responder

        * enumeration restriction: ::

            ['initiator', 'responder']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'mep'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep', u'remote_mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep', u'remote_mep')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep.rmep_test_profile', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands.remote_mep.rmep_test_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'remote_mep', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'remote_mep', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rmep_test_profile', 'keyval': 'rmep_test_profile, mode', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep, remote_mep=remote_mep, rmep_test_profile=rmep_test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep, remote_mep=remote_mep, rmep_test_profile=rmep_test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_tlv_type_get(self, domain_name=None, ma_name=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'mep'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'mep')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'mep_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mep_vlan_get(self, domain_name=None, ma_name=None, mep=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type mep: mep_id
    :param mep: Keyword argument tuple.

    :type mep_id: long
    :param mep_id: **mep** tuple argument:  DECIMAL :: <1-8191>

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'ma_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep.cfm_mep_sub_commands', u'remote_mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands.mep', u'cfm_mep_sub_commands')]
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mep', 'keyval': 'mep_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'tlv_type'}, {'leafval': 'remote_mep, action_profile_association'}, {'leafval': 'tlv_type'}, {'leafval': 'remote_mep'}, {'leafval': 'remote_mep, action_profile_association'}, {'leafval': 'tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name, mep=mep)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name, mep=mep)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_mip_policy_get(self, domain_name=None, ma_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'ma_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'ma_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'ma_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_priority_get(self, domain_name=None, ma_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', u'cfm_ma_sub_commands'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', u'mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'cfm_ma_sub_commands'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', u'mep'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'cfm_ma_sub_commands'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', u'mep')]
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma_name', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ccm_interval, mip_policy'}, {'leafval': 'mep_id, mep_down_up, vlan, mep_intf_type, mep_intf_name'}, {'leafval': 'ccm_interval, mip_policy, maid_format'}, {'leafval': 'mep_id, mep_down_up, vlan, inner_vlan, mep_intf_type, mep_intf_name'}, {'leafval': 'ccm_interval, mip_policy, maid_format'}, {'leafval': 'mep_id, mep_down_up, vlan, inner_vlan, mep_intf_type, mep_intf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_domain_name_ma_name_vlan_get(self, domain_name=None, ma_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type domain_name: domain_name
    :param domain_name: Keyword argument tuple.

    :type domain_name: unicode
    :param domain_name: **domain_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    **Instance Keyword Argument Tuple**:

    :type ma_name: ma_name
    :param ma_name: Keyword argument tuple.

    :type ma_name: unicode
    :param ma_name: **ma_name** tuple argument:  String length 21 char

        * length restriction: ::

            ['1..21']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name', u'domain_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name', u'domain_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name', u'cfm_ma_sub_commands'), ('pybind.slxos.v17s_1_02.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', u'mep'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name', u'cfm_ma_sub_commands'), ('pybind.slxos.v17r_1_01a.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', u'mep'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name', u'cfm_ma_sub_commands'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.domain_name.ma_name.cfm_ma_sub_commands', u'mep')]
    compositions_keyval_list = [{'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}, {'keyval': 'domain_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ma_name', 'keyval': 'ma_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ccm_interval, mip_policy'}, {'leafval': 'mep_id, mep_down_up, vlan, mep_intf_type, mep_intf_name'}, {'leafval': 'ccm_interval, mip_policy, maid_format'}, {'leafval': 'mep_id, mep_down_up, vlan, inner_vlan, mep_intf_type, mep_intf_name'}, {'leafval': 'ccm_interval, mip_policy, maid_format'}, {'leafval': 'mep_id, mep_down_up, vlan, inner_vlan, mep_intf_type, mep_intf_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, domain_name=domain_name, ma_name=ma_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, domain_name=domain_name, ma_name=ma_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731', u'action_profile_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731', u'action_profile_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731', u'test_profile')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'action_profile_name'}, {'leafval': 'test_profile, profile_type'}, {'leafval': 'action_profile_name'}, {'leafval': 'test_profile, profile_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_action_profile_get(self, action_profile_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type action_profile_name: action_profile_name
    :param action_profile_name: Keyword argument tuple.

    :type action_profile_name: unicode
    :param action_profile_name: **action_profile_name** tuple argument:  String length 32 char

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name.event', u'ccm_up'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name.event', u'avg_threshold'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name.event', u'ccm_down'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name.event', u'max_threshold'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name.event', u'avg_threshold'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name.event', u'ccm_up'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name.event', u'max_threshold'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name.event', u'ccm_down')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'action_profile_name', 'keyval': 'action_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ccm_up_actions'}, {'leafval': 'avg_threshold_actions'}, {'leafval': 'ccm_down_actions'}, {'leafval': 'max_threshold_actions'}, {'leafval': 'avg_threshold_actions'}, {'leafval': 'ccm_up_actions'}, {'leafval': 'max_threshold_actions'}, {'leafval': 'ccm_down_actions'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, action_profile_name=action_profile_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, action_profile_name=action_profile_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_action_profile_event_get(self, action_profile_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type action_profile_name: action_profile_name
    :param action_profile_name: Keyword argument tuple.

    :type action_profile_name: unicode
    :param action_profile_name: **action_profile_name** tuple argument:  String length 32 char

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name', u'action_profile_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name', u'action_profile_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name.event', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name.event', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'action_profile_name', 'extra_keyval': ''}, {'keyval': 'action_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, action_profile_name=action_profile_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, action_profile_name=action_profile_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_action_profile_event_avg_threshold_get(self, action_profile_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type action_profile_name: action_profile_name
    :param action_profile_name: Keyword argument tuple.

    :type action_profile_name: unicode
    :param action_profile_name: **action_profile_name** tuple argument:  String length 32 char

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name', u'action_profile_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name', u'action_profile_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name.event.avg_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name.event.avg_threshold', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'action_profile_name', 'extra_keyval': ''}, {'keyval': 'action_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'avg_threshold_actions'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, action_profile_name=action_profile_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, action_profile_name=action_profile_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_action_profile_event_avg_threshold_actions_get(self, action_profile_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type action_profile_name: action_profile_name
    :param action_profile_name: Keyword argument tuple.

    :type action_profile_name: unicode
    :param action_profile_name: **action_profile_name** tuple argument:  String length 32 char

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name', u'action_profile_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name', u'action_profile_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name.event.avg_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name.event.avg_threshold', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'action_profile_name', 'extra_keyval': ''}, {'keyval': 'action_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, action_profile_name=action_profile_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, action_profile_name=action_profile_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_action_profile_event_ccm_down_get(self, action_profile_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type action_profile_name: action_profile_name
    :param action_profile_name: Keyword argument tuple.

    :type action_profile_name: unicode
    :param action_profile_name: **action_profile_name** tuple argument:  String length 32 char

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name', u'action_profile_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name', u'action_profile_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name.event.ccm_down', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name.event.ccm_down', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'action_profile_name', 'extra_keyval': ''}, {'keyval': 'action_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ccm_down_actions'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, action_profile_name=action_profile_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, action_profile_name=action_profile_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_action_profile_event_ccm_down_actions_get(self, action_profile_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type action_profile_name: action_profile_name
    :param action_profile_name: Keyword argument tuple.

    :type action_profile_name: unicode
    :param action_profile_name: **action_profile_name** tuple argument:  String length 32 char

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name', u'action_profile_name'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name', u'action_profile_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name.event.ccm_down', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name.event.ccm_down', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'action_profile_name', 'extra_keyval': ''}, {'keyval': 'action_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, action_profile_name=action_profile_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, action_profile_name=action_profile_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_action_profile_event_ccm_up_get(self, action_profile_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type action_profile_name: action_profile_name
    :param action_profile_name: Keyword argument tuple.

    :type action_profile_name: unicode
    :param action_profile_name: **action_profile_name** tuple argument:  String length 32 char

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name', u'action_profile_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name', u'action_profile_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name.event.ccm_up', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name.event.ccm_up', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'action_profile_name', 'extra_keyval': ''}, {'keyval': 'action_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ccm_up_actions'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, action_profile_name=action_profile_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, action_profile_name=action_profile_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_action_profile_event_ccm_up_actions_get(self, action_profile_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type action_profile_name: action_profile_name
    :param action_profile_name: Keyword argument tuple.

    :type action_profile_name: unicode
    :param action_profile_name: **action_profile_name** tuple argument:  String length 32 char

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name', u'action_profile_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name', u'action_profile_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name.event.ccm_up', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name.event.ccm_up', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'action_profile_name', 'extra_keyval': ''}, {'keyval': 'action_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, action_profile_name=action_profile_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, action_profile_name=action_profile_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_action_profile_event_max_threshold_get(self, action_profile_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type action_profile_name: action_profile_name
    :param action_profile_name: Keyword argument tuple.

    :type action_profile_name: unicode
    :param action_profile_name: **action_profile_name** tuple argument:  String length 32 char

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name', u'action_profile_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name', u'action_profile_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name.event.max_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name.event.max_threshold', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'action_profile_name', 'extra_keyval': ''}, {'keyval': 'action_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_threshold_actions'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, action_profile_name=action_profile_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, action_profile_name=action_profile_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_action_profile_event_max_threshold_actions_get(self, action_profile_name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type action_profile_name: action_profile_name
    :param action_profile_name: Keyword argument tuple.

    :type action_profile_name: unicode
    :param action_profile_name: **action_profile_name** tuple argument:  String length 32 char

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name', u'action_profile_name'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name', u'action_profile_name')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.action_profile_name.event.max_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.action_profile_name.event.max_threshold', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'action_profile_name', 'extra_keyval': ''}, {'keyval': 'action_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, action_profile_name=action_profile_name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, action_profile_name=action_profile_name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile_params'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params', u'stop'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold', u'forward'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold', u'backward'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params', u'start'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params', u'dmm_threshold'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile_params'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params', u'stop'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params', u'start'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold', u'forward'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold', u'backward'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params', u'dmm_threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'test_profile', 'keyval': 'test_profile', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'direction, tx_interval, measurement_interval, cos, tx_frame_count, timeout'}, {'leafval': 'stop_type, stop_time'}, {'leafval': 'thr_fwd_avg_value, thr_fwd_max_value'}, {'leafval': 'thr_bwd_avg_value, thr_bwd_max_value'}, {'leafval': 'start_type, start_time, start_periodic'}, {'leafval': 'thr_avg_value, thr_max_value'}, {'leafval': 'direction, tx_interval, measurement_interval, cos, tx_frame_count, timeout'}, {'leafval': 'stop_type, stop_time'}, {'leafval': 'start_type, start_time, start_periodic'}, {'leafval': 'thr_fwd_avg_value, thr_fwd_max_value'}, {'leafval': 'thr_bwd_avg_value, thr_bwd_max_value'}, {'leafval': 'thr_avg_value, thr_max_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_cos_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_direction_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_measurement_interval_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_start_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.start', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.start', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'start_type, start_time, start_periodic'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_start_start_periodic_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.start', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.start', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_start_start_time_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.start', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.start', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_start_start_type_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.start', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.start', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_stop_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.stop', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.stop', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'stop_type, stop_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_stop_stop_time_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.stop', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.stop', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_stop_stop_type_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.stop', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.stop', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_threshold_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.dmm_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.dmm_threshold', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_threshold_average_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.dmm_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.dmm_threshold', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_threshold_backward_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold.backward', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold.backward', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_threshold_backward_average_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold.backward', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold.backward', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_threshold_backward_maximum_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold.backward', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold.backward', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_threshold_forward_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold.forward', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold.forward', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_threshold_forward_average_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold.forward', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold.forward', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_threshold_forward_maximum_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold.forward', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold.forward', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_threshold_maximum_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.dmm_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.dmm_threshold', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_threshold_slm_threshold_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_timeout_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_tx_frame_count_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_tx_interval_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'test_profile', 'extra_keyval': ''}, {'keyval': 'test_profile', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_cfm_y1731_test_profile_type_get(self, test_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type test_profile: test_profile
    :param test_profile: Keyword argument tuple.

    :type test_profile: unicode
    :param test_profile: **test_profile** tuple argument:  Configure test profile name [1-32 characters]

        * length restriction: ::

            ['1..32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', 'pybind.slxos.v17r_2_00.brocade_dot1ag', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile', u'test_profile_params'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params', u'stop'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold', u'forward'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold', u'backward'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params', u'start'), ('pybind.slxos.v17r_1_01a.protocol.cfm.y1731.test_profile.test_profile_params', u'dmm_threshold'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile', u'test_profile_params'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params', u'stop'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params', u'start'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold', u'forward'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params.slm_threshold', u'backward'), ('pybind.slxos.v17r_2_00.cfm_config.protocol.cfm.y1731.test_profile.test_profile_params', u'dmm_threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'test_profile', 'keyval': 'test_profile', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'direction, tx_interval, measurement_interval, cos, tx_frame_count, timeout'}, {'leafval': 'stop_type, stop_time'}, {'leafval': 'thr_fwd_avg_value, thr_fwd_max_value'}, {'leafval': 'thr_bwd_avg_value, thr_bwd_max_value'}, {'leafval': 'start_type, start_time, start_periodic'}, {'leafval': 'thr_avg_value, thr_max_value'}, {'leafval': 'direction, tx_interval, measurement_interval, cos, tx_frame_count, timeout'}, {'leafval': 'stop_type, stop_time'}, {'leafval': 'start_type, start_time, start_periodic'}, {'leafval': 'thr_fwd_avg_value, thr_fwd_max_value'}, {'leafval': 'thr_bwd_avg_value, thr_bwd_max_value'}, {'leafval': 'thr_avg_value, thr_max_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, test_profile=test_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, test_profile=test_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_edge_loop_detection_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.protocol.edge_loop_detection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.slxos.v17s_1_02.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.nos.v6_0_2f.protocol.edge_loop_detection', u'mac_refresh_time_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_edge_loop_detection_hello_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.protocol.edge_loop_detection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.slxos.v17s_1_02.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.nos.v6_0_2f.protocol.edge_loop_detection', u'mac_refresh_time_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_edge_loop_detection_mac_refresh_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_edge_loop_detection_mac_refresh_mac_refresh_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_edge_loop_detection_mac_refresh_mac_refresh_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_edge_loop_detection_pdu_rx_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.protocol.edge_loop_detection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.slxos.v17s_1_02.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.nos.v6_0_2f.protocol.edge_loop_detection', u'mac_refresh_time_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_edge_loop_detection_shutdown_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.edge_loop_detection', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.edge_loop_detection', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.protocol.edge_loop_detection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.slxos.v17s_1_02.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.nos.v6_0_2f.protocol.edge_loop_detection', u'mac_refresh_time_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_hide_vrrp_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.protocol.hide_vrrp_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.protocol.hide_vrrp_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.protocol.hide_vrrp_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_link_oam_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.link_oam', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.link_oam', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_link_oam_pdu_rate_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.link_oam', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.link_oam', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_link_oam_shutdown_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.link_oam', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.link_oam', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_link_oam_time_out_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.link_oam', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.link_oam', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'advertise'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v6_0_2f.protocol.lldp', u'profile'), ('pybind.nos.v6_0_2f.protocol.lldp', u'advertise'), ('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'advertise')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv, bgp_auto_nbr_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_advertise_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}]
    leafval_map = {"pybind.slxos.v17s_1_02.protocol.lldp.advertise": {"dcbx_fcoe_logical_link_tlv": "dcbx_fcoe_logical_link_tlv", "dot1_tlv": "dot1_tlv", "dcbx_tlv": "dcbx_tlv", "dcbx_fcoe_app_tlv": "dcbx_fcoe_app_tlv", "dcbx_iscsi_app_tlv": "dcbx_iscsi_app_tlv", "dot3_tlv": "dot3_tlv"}, "pybind.slxos.v17r_2_00.protocol.lldp.advertise": {"dcbx_fcoe_logical_link_tlv": "dcbx_fcoe_logical_link_tlv", "dot1_tlv": "dot1_tlv", "dcbx_tlv": "dcbx_tlv", "dcbx_fcoe_app_tlv": "dcbx_fcoe_app_tlv", "dcbx_iscsi_app_tlv": "dcbx_iscsi_app_tlv", "dot3_tlv": "dot3_tlv"}, "pybind.slxos.v17r_1_01a.protocol.lldp.advertise": {"dcbx_fcoe_logical_link_tlv": "dcbx_fcoe_logical_link_tlv", "dot1_tlv": "dot1_tlv", "dcbx_tlv": "dcbx_tlv", "dcbx_fcoe_app_tlv": "dcbx_fcoe_app_tlv", "dcbx_iscsi_app_tlv": "dcbx_iscsi_app_tlv", "dot3_tlv": "dot3_tlv"}, "pybind.nos.v6_0_2f.protocol.lldp.advertise": {"dcbx_fcoe_logical_link_tlv": "dcbx_fcoe_logical_link_tlv", "dot1_tlv": "dot1_tlv", "dcbx_tlv": "dcbx_tlv", "dcbx_fcoe_app_tlv": "dcbx_fcoe_app_tlv", "dcbx_iscsi_app_tlv": "dcbx_iscsi_app_tlv", "dot3_tlv": "dot3_tlv"}, "pybind.nos.v7_2_0.protocol.lldp.advertise": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_advertise_bgp_auto_nbr_tlv_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.protocol.lldp.advertise', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_advertise_dcbx_fcoe_app_tlv_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_advertise_dcbx_fcoe_logical_link_tlv_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_advertise_dcbx_iscsi_app_tlv_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_advertise_dcbx_tlv_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_advertise_dot1_tlv_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_advertise_dot3_tlv_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_advertise_optional_tlv_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_advertise_optional_tlv_management_address_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_advertise_optional_tlv_port_description_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_advertise_optional_tlv_system_capabilities_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_advertise_optional_tlv_system_description_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_advertise_optional_tlv_system_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.advertise.optional_tlv', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise.optional_tlv', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_description_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'advertise'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v6_0_2f.protocol.lldp', u'profile'), ('pybind.nos.v6_0_2f.protocol.lldp', u'advertise'), ('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'advertise')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv, bgp_auto_nbr_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'advertise'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v6_0_2f.protocol.lldp', u'profile'), ('pybind.nos.v6_0_2f.protocol.lldp', u'advertise'), ('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'advertise')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv, bgp_auto_nbr_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_hello_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'advertise'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v6_0_2f.protocol.lldp', u'profile'), ('pybind.nos.v6_0_2f.protocol.lldp', u'advertise'), ('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'advertise')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv, bgp_auto_nbr_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_iscsi_priority_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'advertise'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v6_0_2f.protocol.lldp', u'profile'), ('pybind.nos.v6_0_2f.protocol.lldp', u'advertise'), ('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'advertise')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv, bgp_auto_nbr_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'advertise'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v6_0_2f.protocol.lldp', u'profile'), ('pybind.nos.v6_0_2f.protocol.lldp', u'advertise'), ('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'advertise')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv, bgp_auto_nbr_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_multiplier_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'advertise'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v6_0_2f.protocol.lldp', u'profile'), ('pybind.nos.v6_0_2f.protocol.lldp', u'advertise'), ('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'advertise')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv, bgp_auto_nbr_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.nos.v6_0_2f.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'advertise'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise', u'optional_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'profile', 'keyval': 'profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv, bgp_auto_nbr_tlv'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_advertise_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise": {"dcbx_fcoe_logical_link_tlv": "dcbx_fcoe_logical_link_tlv", "dot1_tlv": "dot1_tlv", "dcbx_tlv": "dcbx_tlv", "dcbx_fcoe_app_tlv": "dcbx_fcoe_app_tlv", "dcbx_iscsi_app_tlv": "dcbx_iscsi_app_tlv", "dot3_tlv": "dot3_tlv"}, "pybind.nos.v7_2_0.protocol.lldp.profile.advertise": {}, "pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise": {"dcbx_fcoe_logical_link_tlv": "dcbx_fcoe_logical_link_tlv", "dot1_tlv": "dot1_tlv", "dcbx_tlv": "dcbx_tlv", "dcbx_fcoe_app_tlv": "dcbx_fcoe_app_tlv", "dcbx_iscsi_app_tlv": "dcbx_iscsi_app_tlv", "dot3_tlv": "dot3_tlv"}, "pybind.nos.v6_0_2f.protocol.lldp.profile.advertise": {"dcbx_fcoe_logical_link_tlv": "dcbx_fcoe_logical_link_tlv", "dot1_tlv": "dot1_tlv", "dcbx_tlv": "dcbx_tlv", "dcbx_fcoe_app_tlv": "dcbx_fcoe_app_tlv", "dcbx_iscsi_app_tlv": "dcbx_iscsi_app_tlv", "dot3_tlv": "dot3_tlv"}, "pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise": {"dcbx_fcoe_logical_link_tlv": "dcbx_fcoe_logical_link_tlv", "dot1_tlv": "dot1_tlv", "dcbx_tlv": "dcbx_tlv", "dcbx_fcoe_app_tlv": "dcbx_fcoe_app_tlv", "dcbx_iscsi_app_tlv": "dcbx_iscsi_app_tlv", "dot3_tlv": "dot3_tlv"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_advertise_bgp_auto_nbr_tlv_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v7_2_0.protocol.lldp.profile.advertise', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_advertise_dcbx_fcoe_app_tlv_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_advertise_dcbx_fcoe_logical_link_tlv_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_advertise_dcbx_iscsi_app_tlv_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_advertise_dcbx_tlv_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_advertise_dot1_tlv_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_advertise_dot3_tlv_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_advertise_optional_tlv_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2f.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_advertise_optional_tlv_management_address_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2f.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_advertise_optional_tlv_port_description_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2f.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_advertise_optional_tlv_system_capabilities_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2f.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_advertise_optional_tlv_system_description_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2f.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_advertise_optional_tlv_system_name_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'profile'), ('pybind.nos.v6_0_2f.protocol.lldp.profile', u'profile')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise.optional_tlv', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise.optional_tlv', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}, {'keyval': 'profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_description_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.nos.v6_0_2f.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'advertise'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise', u'optional_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'profile', 'keyval': 'profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv, bgp_auto_nbr_tlv'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_hello_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.nos.v6_0_2f.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'advertise'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise', u'optional_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'profile', 'keyval': 'profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv, bgp_auto_nbr_tlv'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_mode_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.nos.v6_0_2f.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'advertise'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise', u'optional_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'profile', 'keyval': 'profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv, bgp_auto_nbr_tlv'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_profile_multiplier_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type profile: profile_name
    :param profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **profile** tuple argument.

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '(\S)+'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp.profile', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.nos.v6_0_2f.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.slxos.v17s_1_02.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp.profile', u'advertise'), ('pybind.nos.v7_2_0.protocol.lldp.profile.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.profile.advertise', u'optional_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'profile', 'keyval': 'profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv, bgp_auto_nbr_tlv'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_system_description_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'advertise'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v6_0_2f.protocol.lldp', u'profile'), ('pybind.nos.v6_0_2f.protocol.lldp', u'advertise'), ('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'advertise')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv, bgp_auto_nbr_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_lldp_system_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.lldp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.lldp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.lldp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.lldp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.lldp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_1_01a.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_1_01a.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'profile'), ('pybind.slxos.v17s_1_02.protocol.lldp', u'advertise'), ('pybind.slxos.v17s_1_02.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v6_0_2f.protocol.lldp', u'profile'), ('pybind.nos.v6_0_2f.protocol.lldp', u'advertise'), ('pybind.nos.v6_0_2f.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'profile'), ('pybind.nos.v7_2_0.protocol.lldp.advertise', u'optional_tlv'), ('pybind.nos.v7_2_0.protocol.lldp', u'advertise'), ('pybind.slxos.v17r_2_00.protocol.lldp.advertise', u'optional_tlv'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'profile'), ('pybind.slxos.v17r_2_00.protocol.lldp', u'advertise')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv, bgp_auto_nbr_tlv'}, {'leafval': 'management_address, port_description, system_capabilities, adv_tlv_system_description, adv_tlv_system_name'}, {'leafval': 'profile_name, description, hello, mode, multiplier'}, {'leafval': 'dcbx_fcoe_app_tlv, dcbx_fcoe_logical_link_tlv, dcbx_iscsi_app_tlv, dcbx_tlv, dot1_tlv, dot3_tlv'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_loop_detection_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.edge_loop_detection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.edge_loop_detection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.slxos.v17r_1_01a.protocol.edge_loop_detection', u'mac_refresh_time_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_loop_detection_hello_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.edge_loop_detection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.edge_loop_detection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.slxos.v17r_1_01a.protocol.edge_loop_detection', u'mac_refresh_time_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_loop_detection_mac_refresh_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_loop_detection_mac_refresh_mac_refresh_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_loop_detection_mac_refresh_mac_refresh_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.edge_loop_detection.mac_refresh_time_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_loop_detection_pdu_rx_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.edge_loop_detection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.edge_loop_detection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.slxos.v17r_1_01a.protocol.edge_loop_detection', u'mac_refresh_time_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_loop_detection_raslog_duration_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.edge_loop_detection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.edge_loop_detection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.slxos.v17r_1_01a.protocol.edge_loop_detection', u'mac_refresh_time_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_loop_detection_shutdown_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.edge_loop_detection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.edge_loop_detection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.protocol.edge_loop_detection', u'mac_refresh_time_config'), ('pybind.slxos.v17r_1_01a.protocol.edge_loop_detection', u'mac_refresh_time_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mac_refresh_time, mac_refresh_type'}, {'leafval': 'mac_refresh_time, mac_refresh_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_ptp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_ptp_domain_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_ptp_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_ptp_priority1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_ptp_priority2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_ptp_source_ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.protocol.ptp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_routing_system_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.protocol', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.protocol', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.protocol', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.protocol', u'hide_vrrp_holder'), ('pybind.slxos.v17s_1_02.routing_system.protocol', u'hide_vrrp_holder'), ('pybind.slxos.v17r_1_01a.routing_system.protocol', u'hide_vrrp_holder')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'vrrp, vrrp_extended'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree', u'stp'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree', u'mstp'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree', u'rstp'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree', u'pvst'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree', u'rpvst'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'vlan'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree', u'stp'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree', u'pvst'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree', u'mstp'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree', u'rpvst'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree', u'rstp'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree', u'stp'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree', u'mstp'), ('pybind.nos.v7_2_0.protocol.spanning_tree', u'pvst'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree', u'rpvst'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree', u'rstp'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'system_id'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree', u'pvst'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree', u'rstp'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree', u'rpvst'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree', u'stp'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree', u'mstp'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree', u'mstp'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree', u'stp'), ('pybind.nos.v6_0_2f.protocol.spanning_tree', u'rstp'), ('pybind.nos.v6_0_2f.protocol.spanning_tree', u'pvst'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree', u'rpvst'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'error_disable_timeout')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'description, cluster_system_id, bridge_priority, shutdown'}, {'leafval': 'id, priority'}, {'leafval': 'path_cost'}, {'leafval': 'path_cost'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'description, cluster_system_id, bridge_priority, shutdown, cisco_interoperability, region, revision, max_hops, transmit_holdcount'}, {'leafval': 'description, cluster_system_id, bridge_priority, shutdown, transmit_holdcount'}, {'leafval': 'description, cluster_system_id, bridge_priority, shutdown'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'description, cluster_system_id, bridge_priority, shutdown, transmit_holdcount'}, {'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'path_cost'}, {'leafval': 'path_cost'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'description, bridge_priority, shutdown'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'description, bridge_priority, shutdown'}, {'leafval': 'enable, interval'}, {'leafval': 'description, bridge_priority, shutdown, cisco_interoperability, region, revision, max_hops, transmit_holdcount'}, {'leafval': 'id, priority'}, {'leafval': 'path_cost'}, {'leafval': 'description, bridge_priority, shutdown, transmit_holdcount'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'description, bridge_priority, shutdown, transmit_holdcount'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time'}, {'leafval': 'oui'}, {'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time, cisco_interoperability, region, revision, max_hops, transmit_holdcount'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'path_cost'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time, transmit_holdcount'}, {'leafval': 'oui'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time, transmit_holdcount'}, {'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'description, bridge_priority, shutdown'}, {'leafval': 'enable, interval'}, {'leafval': 'description, bridge_priority, shutdown, transmit_holdcount'}, {'leafval': 'description, bridge_priority, shutdown, transmit_holdcount'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'id, priority'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'description, bridge_priority, shutdown'}, {'leafval': 'description, bridge_priority, shutdown, cisco_interoperability, region, revision, max_hops, transmit_holdcount'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time, cisco_interoperability, region, revision, max_hops, transmit_holdcount'}, {'leafval': 'path_cost'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time, transmit_holdcount'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'description, bridge_priority, forward_delay, max_age, shutdown, hello_time, transmit_holdcount'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'timer_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}]
    leafval_map = {"pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp": {}, "pybind.nos.v7_2_0.protocol.spanning_tree.mstp": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "region": "region", "max_hops": "max_hops", "cisco_interoperability": "cisco_interoperability", "shutdown": "shutdown", "transmit_holdcount": "transmit_holdcount", "forward_delay": "forward_delay", "revision": "revision"}, "pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp": {}, "pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp": {}, "pybind.nos.v6_0_2f.protocol.spanning_tree.mstp": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "region": "region", "max_hops": "max_hops", "cisco_interoperability": "cisco_interoperability", "shutdown": "shutdown", "transmit_holdcount": "transmit_holdcount", "forward_delay": "forward_delay", "revision": "revision"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_bridge_priority_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'timer_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_cisco_interoperability_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'timer_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_cluster_system_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'timer_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_description_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'timer_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_error_disable_timeout_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_error_disable_timeout_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_error_disable_timeout_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp.error_disable_timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_forward_delay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_hello_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_instance_get(self, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp.instance', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp.instance', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp.instance', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_instance_priority_get(self, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp.instance', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp.instance', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp.instance', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_instance_vlan_get(self, instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type instance: id
    :param instance: Keyword argument tuple.

    :type id: int
    :param id: **instance** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp.instance', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp.instance', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp.instance', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp.instance', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp.instance', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'instance', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, instance=instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, instance=instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_max_age_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_max_hops_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'timer_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_port_channel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_port_channel_path_cost_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_region_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'timer_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_revision_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'timer_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_shutdown_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'timer_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_system_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.mstp.system_id', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_system_id_oui_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.mstp.system_id', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_timer_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hello_time, forward_delay, max_age'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_mstp_transmit_holdcount_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v7_2_0.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.mstp', u'instance'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'instance'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.mstp', u'timer_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'id, vlan, priority'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'system_id'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'vlan'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'error_disable_timeout')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'id, priority'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'id, priority'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}]
    leafval_map = {"pybind.nos.v7_2_0.protocol.spanning_tree.pvst": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "forward_delay": "forward_delay"}, "pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst": {}, "pybind.nos.v6_0_2f.protocol.spanning_tree.pvst": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "forward_delay": "forward_delay"}, "pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst": {}, "pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_bridge_priority_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'system_id'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'vlan'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'error_disable_timeout')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'id, priority'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'id, priority'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_cluster_system_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'timer_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_description_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'system_id'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'vlan'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'error_disable_timeout')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'id, priority'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'id, priority'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_error_disable_timeout_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_error_disable_timeout_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_error_disable_timeout_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.error_disable_timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_forward_delay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'system_id'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'error_disable_timeout')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_hello_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'system_id'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'error_disable_timeout')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_max_age_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'system_id'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'error_disable_timeout')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_port_channel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_port_channel_path_cost_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_shutdown_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst', u'system_id'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'vlan'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'vlan'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst', u'error_disable_timeout')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'id, priority'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'id, priority'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_system_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.pvst.system_id', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_system_id_oui_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.pvst.system_id', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_timer_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hello_time, forward_delay, max_age'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_vlan_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.vlan', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.vlan', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.vlan', u'timer_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}]
    leafval_map = {"pybind.nos.v7_2_0.protocol.spanning_tree.pvst.vlan": {"priority": "priority", "max_age": "max_age", "hello_time": "hello_time", "id": "id", "forward_delay": "forward_delay"}, "pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.vlan": {}, "pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.vlan": {}, "pybind.nos.v6_0_2f.protocol.spanning_tree.pvst.vlan": {"priority": "priority", "max_age": "max_age", "hello_time": "hello_time", "id": "id", "forward_delay": "forward_delay"}, "pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.vlan": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_vlan_forward_delay_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.vlan.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.vlan.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.vlan.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.protocol.spanning_tree.pvst.vlan": {"id": "id", "forward_delay": "forward_delay"}, "pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.vlan.timer_config": {}, "pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.vlan.timer_config": {}, "pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.vlan.timer_config": {}, "pybind.nos.v6_0_2f.protocol.spanning_tree.pvst.vlan": {"id": "id", "forward_delay": "forward_delay"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_vlan_hello_time_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.vlan.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.vlan.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.vlan.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.protocol.spanning_tree.pvst.vlan": {"id": "id", "hello_time": "hello_time"}, "pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.vlan.timer_config": {}, "pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.vlan.timer_config": {}, "pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.vlan.timer_config": {}, "pybind.nos.v6_0_2f.protocol.spanning_tree.pvst.vlan": {"id": "id", "hello_time": "hello_time"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_vlan_max_age_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.vlan.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.vlan.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.vlan.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.protocol.spanning_tree.pvst.vlan": {"max_age": "max_age", "id": "id"}, "pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.vlan.timer_config": {}, "pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.vlan.timer_config": {}, "pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.vlan.timer_config": {}, "pybind.nos.v6_0_2f.protocol.spanning_tree.pvst.vlan": {"max_age": "max_age", "id": "id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_pvst_vlan_priority_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.pvst.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.pvst.vlan', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.pvst.vlan', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.pvst.vlan', u'timer_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'id, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}]
    leafval_map = {"pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst": {}, "pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst": {}, "pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst": {}, "pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "transmit_holdcount": "transmit_holdcount", "forward_delay": "forward_delay"}, "pybind.nos.v7_2_0.protocol.spanning_tree.rpvst": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "transmit_holdcount": "transmit_holdcount", "forward_delay": "forward_delay"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_bridge_priority_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'id, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_cluster_system_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'timer_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'id, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_description_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'id, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_error_disable_timeout_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_error_disable_timeout_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_error_disable_timeout_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.error_disable_timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_forward_delay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_hello_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_max_age_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_port_channel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_port_channel_path_cost_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_shutdown_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'id, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_system_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst.system_id', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_system_id_oui_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst.system_id', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_timer_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hello_time, forward_delay, max_age'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_transmit_holdcount_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst', u'vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}, {'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'id, priority'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'id, priority'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'id, priority, forward_delay, max_age, hello_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_vlan_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.vlan', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.vlan', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.vlan', u'timer_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}]
    leafval_map = {"pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.vlan": {}, "pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.vlan": {}, "pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst.vlan": {"priority": "priority", "max_age": "max_age", "hello_time": "hello_time", "id": "id", "forward_delay": "forward_delay"}, "pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.vlan": {}, "pybind.nos.v7_2_0.protocol.spanning_tree.rpvst.vlan": {"priority": "priority", "max_age": "max_age", "hello_time": "hello_time", "id": "id", "forward_delay": "forward_delay"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_vlan_forward_delay_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.vlan.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.vlan.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.vlan.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.vlan.timer_config": {}, "pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.vlan.timer_config": {}, "pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst.vlan": {"id": "id", "forward_delay": "forward_delay"}, "pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.vlan.timer_config": {}, "pybind.nos.v7_2_0.protocol.spanning_tree.rpvst.vlan": {"id": "id", "forward_delay": "forward_delay"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_vlan_hello_time_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.vlan.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.vlan.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.vlan.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.vlan.timer_config": {}, "pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.vlan.timer_config": {}, "pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst.vlan": {"id": "id", "hello_time": "hello_time"}, "pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.vlan.timer_config": {}, "pybind.nos.v7_2_0.protocol.spanning_tree.rpvst.vlan": {"id": "id", "hello_time": "hello_time"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_vlan_max_age_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.vlan', u'vlan')]
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.vlan.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.vlan.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.vlan.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.vlan.timer_config": {}, "pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.vlan.timer_config": {}, "pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst.vlan": {"max_age": "max_age", "id": "id"}, "pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.vlan.timer_config": {}, "pybind.nos.v7_2_0.protocol.spanning_tree.rpvst.vlan": {"max_age": "max_age", "id": "id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rpvst_vlan_priority_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan: id
    :param vlan: Keyword argument tuple.

    :type id: long
    :param id: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rpvst.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rpvst.vlan', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rpvst.vlan', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rpvst.vlan', u'timer_config')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'system_id'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}]
    leafval_map = {"pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp": {}, "pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp": {}, "pybind.nos.v7_2_0.protocol.spanning_tree.rstp": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "transmit_holdcount": "transmit_holdcount", "forward_delay": "forward_delay"}, "pybind.nos.v6_0_2f.protocol.spanning_tree.rstp": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "transmit_holdcount": "transmit_holdcount", "forward_delay": "forward_delay"}, "pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_bridge_priority_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'system_id'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_cluster_system_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_description_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'system_id'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_error_disable_timeout_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_error_disable_timeout_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_error_disable_timeout_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp.error_disable_timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_forward_delay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'system_id'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_hello_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'system_id'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_max_age_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'system_id'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_port_channel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_port_channel_path_cost_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_shutdown_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'system_id'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_system_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rstp.system_id', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_system_id_oui_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rstp.system_id', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_timer_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hello_time, forward_delay, max_age'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_rstp_transmit_holdcount_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.rstp', u'system_id'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.rstp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'error_disable_timeout'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.rstp', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_stp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'error_disable_timeout')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}]
    leafval_map = {"pybind.slxos.v17r_2_00.protocol.spanning_tree.stp": {}, "pybind.slxos.v17s_1_02.protocol.spanning_tree.stp": {}, "pybind.nos.v6_0_2f.protocol.spanning_tree.stp": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "forward_delay": "forward_delay"}, "pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp": {}, "pybind.nos.v7_2_0.protocol.spanning_tree.stp": {"max_age": "max_age", "description": "description", "hello_time": "hello_time", "bridge_priority": "bridge_priority", "shutdown": "shutdown", "forward_delay": "forward_delay"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_stp_bridge_priority_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'error_disable_timeout')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_stp_cluster_system_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_stp_description_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'error_disable_timeout')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_stp_error_disable_timeout_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_stp_error_disable_timeout_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_stp_error_disable_timeout_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp.error_disable_timeout', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_stp_forward_delay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_stp_hello_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_stp_max_age_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'port_channel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_stp_port_channel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_stp_port_channel_path_cost_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp.port_channel', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp.port_channel', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp.port_channel', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp.port_channel', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp.port_channel', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_stp_shutdown_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'port_channel'), ('pybind.nos.v6_0_2f.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp', u'port_channel'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'system_id'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'error_disable_timeout'), ('pybind.nos.v7_2_0.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'port_channel'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'timer_config'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp', u'error_disable_timeout')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_cost'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}, {'leafval': 'enable, interval'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'path_cost'}, {'leafval': 'oui'}, {'leafval': 'enable, interval'}, {'leafval': 'path_cost'}, {'leafval': 'path_cost'}, {'leafval': 'hello_time, forward_delay, max_age'}, {'leafval': 'enable, interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_stp_system_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.stp.system_id', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_stp_system_id_oui_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.protocol.spanning_tree.stp.system_id', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_spanning_tree_stp_timer_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.protocol.spanning_tree.stp.timer_config', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.spanning_tree.stp.timer_config', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.spanning_tree.stp.timer_config', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hello_time, forward_delay, max_age'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_udld_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.udld', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.udld', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.udld', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.udld', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.udld', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_udld_hello_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.udld', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.udld', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.udld', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.udld', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.udld', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_udld_multiplier_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.udld', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.udld', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.udld', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.udld', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.udld', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_udld_shutdown_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol.udld', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol.udld', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol.udld', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol.udld', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol.udld', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_vrrp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.protocol.hide_vrrp_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.protocol.hide_vrrp_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.protocol.hide_vrrp_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_vrrp_extended_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.protocol.hide_vrrp_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.protocol.hide_vrrp_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.protocol.hide_vrrp_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def protocol_vrrpv3_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.protocol_vrrpv3', 'pybind.nos.v6_0_2f.brocade_vrrpv3', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.protocol_vrrpv3', 'pybind.nos.v7_2_0.brocade_vrrpv3', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.protocol_vrrpv3', 'pybind.slxos.v17r_1_01a.brocade_vrrpv3', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.protocol_vrrpv3', 'pybind.slxos.v17r_2_00.brocade_vrrpv3', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.protocol_vrrpv3', 'pybind.slxos.v17s_1_02.brocade_vrrpv3', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state', u'time_property'), ('pybind.slxos.v17s_1_02.ptp_state', u'interfaces_detail'), ('pybind.slxos.v17s_1_02.ptp_state', u'clock'), ('pybind.slxos.v17s_1_02.ptp_state.clock', u'quality'), ('pybind.slxos.v17s_1_02.ptp_state', u'parent_port_detail'), ('pybind.slxos.v17s_1_02.ptp_state.corrections', u'correction_detail_list'), ('pybind.slxos.v17s_1_02.ptp_state.clock_foreign_masters', u'foreign_master_detail_list'), ('pybind.slxos.v17s_1_02.ptp_state.brief', u'port_detail_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'utc_offset_valid, utc_offset, leap59, leap61, time_traceable, frequency_traceable, timescale, timesource'}, {'leafval': 'interface_key'}, {'leafval': 'type, identity, domain, clock_state, ptp_port_count, priority1, priority2, offset_from_master, mpd, steps_removed, local_time'}, {'leafval': 'clock_class, accuracy, offset'}, {'leafval': 'parent_clock_identity, parent_port_number, parent_ip_address, parent_offset, parent_cpcr, grandparent_identity, grandparent_quality_class, grandparent_quality_accuracy, grandparent_quality_oslv, grandparent_quality_priority1, grandparent_quality_priority2'}, {'leafval': 'slave_port, sup_time, correction'}, {'leafval': 'interface, clock_id, priority1, priority2, clock_class, accuracy, oslv, steps_removed'}, {'leafval': 'port, ptp_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_brief_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.brief', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state.brief', u'port_detail_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'port, ptp_state'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_brief_port_detail_list_get(self, port_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_detail_list: port
    :param port_detail_list: Keyword argument tuple.

    :type port: unicode
    :param port: **port_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.brief.port_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_detail_list', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_detail_list=port_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_detail_list=port_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_brief_port_detail_list_ptp_state_get(self, port_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type port_detail_list: port
    :param port_detail_list: Keyword argument tuple.

    :type port: unicode
    :param port: **port_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.brief.port_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'port_detail_list', 'keyval': 'port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, port_detail_list=port_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, port_detail_list=port_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', u'quality')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'clock_class, accuracy, offset'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_clock_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', u'quality')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'clock_class, accuracy, offset'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_domain_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', u'quality')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'clock_class, accuracy, offset'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_foreign_masters_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock_foreign_masters', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state.clock_foreign_masters', u'foreign_master_detail_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface, clock_id, priority1, priority2, clock_class, accuracy, oslv, steps_removed'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_foreign_masters_foreign_master_detail_list_get(self, foreign_master_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type foreign_master_detail_list: interface
    :param foreign_master_detail_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **foreign_master_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock_foreign_masters.foreign_master_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'foreign_master_detail_list', 'keyval': 'interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, foreign_master_detail_list=foreign_master_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, foreign_master_detail_list=foreign_master_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_foreign_masters_foreign_master_detail_list_accuracy_get(self, foreign_master_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type foreign_master_detail_list: interface
    :param foreign_master_detail_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **foreign_master_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock_foreign_masters.foreign_master_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'foreign_master_detail_list', 'keyval': 'interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, foreign_master_detail_list=foreign_master_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, foreign_master_detail_list=foreign_master_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_foreign_masters_foreign_master_detail_list_clock_class_get(self, foreign_master_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type foreign_master_detail_list: interface
    :param foreign_master_detail_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **foreign_master_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock_foreign_masters.foreign_master_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'foreign_master_detail_list', 'keyval': 'interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, foreign_master_detail_list=foreign_master_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, foreign_master_detail_list=foreign_master_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_foreign_masters_foreign_master_detail_list_clock_id_get(self, foreign_master_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type foreign_master_detail_list: interface
    :param foreign_master_detail_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **foreign_master_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock_foreign_masters.foreign_master_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'foreign_master_detail_list', 'keyval': 'interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, foreign_master_detail_list=foreign_master_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, foreign_master_detail_list=foreign_master_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_foreign_masters_foreign_master_detail_list_oslv_get(self, foreign_master_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type foreign_master_detail_list: interface
    :param foreign_master_detail_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **foreign_master_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock_foreign_masters.foreign_master_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'foreign_master_detail_list', 'keyval': 'interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, foreign_master_detail_list=foreign_master_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, foreign_master_detail_list=foreign_master_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_foreign_masters_foreign_master_detail_list_priority1_get(self, foreign_master_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type foreign_master_detail_list: interface
    :param foreign_master_detail_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **foreign_master_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock_foreign_masters.foreign_master_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'foreign_master_detail_list', 'keyval': 'interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, foreign_master_detail_list=foreign_master_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, foreign_master_detail_list=foreign_master_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_foreign_masters_foreign_master_detail_list_priority2_get(self, foreign_master_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type foreign_master_detail_list: interface
    :param foreign_master_detail_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **foreign_master_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock_foreign_masters.foreign_master_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'foreign_master_detail_list', 'keyval': 'interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, foreign_master_detail_list=foreign_master_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, foreign_master_detail_list=foreign_master_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_foreign_masters_foreign_master_detail_list_steps_removed_get(self, foreign_master_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type foreign_master_detail_list: interface
    :param foreign_master_detail_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **foreign_master_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock_foreign_masters.foreign_master_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'foreign_master_detail_list', 'keyval': 'interface', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, foreign_master_detail_list=foreign_master_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, foreign_master_detail_list=foreign_master_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_identity_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', u'quality')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'clock_class, accuracy, offset'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_local_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', u'quality')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'clock_class, accuracy, offset'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_mpd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', u'quality')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'clock_class, accuracy, offset'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_offset_from_master_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', u'quality')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'clock_class, accuracy, offset'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_priority1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', u'quality')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'clock_class, accuracy, offset'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_priority2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', u'quality')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'clock_class, accuracy, offset'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_ptp_port_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', u'quality')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'clock_class, accuracy, offset'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_quality_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock.quality', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_quality_accuracy_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock.quality', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_quality_clock_class_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock.quality', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_quality_offset_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock.quality', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_steps_removed_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', u'quality')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'clock_class, accuracy, offset'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_clock_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state.clock', u'quality')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'clock_class, accuracy, offset'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_corrections_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.corrections', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state.corrections', u'correction_detail_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'slave_port, sup_time, correction'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_corrections_correction_detail_list_get(self, correction_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type correction_detail_list: slave_port, sup_time
    :param correction_detail_list: Keyword argument tuple.

    :type slave_port: unicode
    :param slave_port: **correction_detail_list** tuple argument.

    :type sup_time: unicode
    :param sup_time: **correction_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.corrections.correction_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'correction_detail_list', 'keyval': 'slave_port, sup_time', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, correction_detail_list=correction_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, correction_detail_list=correction_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_corrections_correction_detail_list_correction_get(self, correction_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type correction_detail_list: slave_port, sup_time
    :param correction_detail_list: Keyword argument tuple.

    :type slave_port: unicode
    :param slave_port: **correction_detail_list** tuple argument.

    :type sup_time: unicode
    :param sup_time: **correction_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.corrections.correction_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'correction_detail_list', 'keyval': 'slave_port, sup_time', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, correction_detail_list=correction_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, correction_detail_list=correction_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_get(self, interfaces_detail=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interface_detail_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interfaces_detail', 'keyval': 'interface_key', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'id, port_dataset, clock_identity, port_number, ptp_version, port_state, port_type, vlan_info, dri, arto, pmpd, annouce_interval, sync_interval, delay_mechanism, transport_mode, announce_msg_sent, announce_msg_received, sync_msg_sent, sync_msg_received, followup_msg_sent, followup_msg_received, delay_req_msg_sent, delay_req_msg_received, delay_res_msg_sent, delay_res_msg_received, peer_delay_req_msg_sent, peer_delay_req_msg_received, peer_delay_res_msg_sent, peer_delay_res_msg_received, peer_delay_res_fm_sent, peer_delay_res_fm_received'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_annouce_interval_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_announce_msg_received_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_announce_msg_sent_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_arto_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_clock_identity_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_delay_mechanism_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_delay_req_msg_received_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_delay_req_msg_sent_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_delay_res_msg_received_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_delay_res_msg_sent_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_dri_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_followup_msg_received_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_followup_msg_sent_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_peer_delay_req_msg_received_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_peer_delay_req_msg_sent_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_peer_delay_res_fm_received_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_peer_delay_res_fm_sent_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_peer_delay_res_msg_received_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_peer_delay_res_msg_sent_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_pmpd_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_port_dataset_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_port_number_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_port_state_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_port_type_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_ptp_version_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_sync_interval_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_sync_msg_received_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_sync_msg_sent_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_transport_mode_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_interfaces_detail_interface_detail_list_vlan_info_get(self, interfaces_detail=None, interface_detail_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interfaces_detail: interface_key
    :param interfaces_detail: Keyword argument tuple.

    :type interface_key: unicode
    :param interface_key: **interfaces_detail** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type interface_detail_list: id
    :param interface_detail_list: Keyword argument tuple.

    :type id: unicode
    :param id: **interface_detail_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail', u'interfaces_detail')]
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.interfaces_detail.interface_detail_list', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_key', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_detail_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interfaces_detail=interfaces_detail, interface_detail_list=interface_detail_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_parent_port_detail_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.parent_port_detail', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_parent_port_detail_grandparent_identity_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.parent_port_detail', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_parent_port_detail_grandparent_quality_accuracy_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.parent_port_detail', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_parent_port_detail_grandparent_quality_class_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.parent_port_detail', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_parent_port_detail_grandparent_quality_oslv_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.parent_port_detail', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_parent_port_detail_grandparent_quality_priority1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.parent_port_detail', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_parent_port_detail_grandparent_quality_priority2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.parent_port_detail', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_parent_port_detail_parent_clock_identity_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.parent_port_detail', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_parent_port_detail_parent_cpcr_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.parent_port_detail', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_parent_port_detail_parent_ip_address_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.parent_port_detail', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_parent_port_detail_parent_offset_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.parent_port_detail', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_parent_port_detail_parent_port_number_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.parent_port_detail', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_time_property_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.time_property', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_time_property_frequency_traceable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.time_property', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_time_property_leap59_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.time_property', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_time_property_leap61_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.time_property', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_time_property_time_traceable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.time_property', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_time_property_timescale_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.time_property', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_time_property_timesource_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.time_property', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_time_property_utc_offset_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.time_property', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ptp_state_time_property_utc_offset_valid_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.ptp_state.time_property', 'pybind.slxos.v17s_1_02.brocade_ptp_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pw_profile_get(self, pw_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type pw_profile: pw_profile_name
    :param pw_profile: Keyword argument tuple.

    :type pw_profile_name: unicode
    :param pw_profile_name: **pw_profile** tuple argument:  Pw-profile name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pw_profile', 'pybind.slxos.v17r_1_01a.brocade_pw_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pw_profile', 'pybind.slxos.v17r_2_00.brocade_pw_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.pw_profile', 'pybind.slxos.v17s_1_02.brocade_pw_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pw_profile', u'mtu'), ('pybind.slxos.v17r_1_01a.pw_profile', u'vc_mode'), ('pybind.slxos.v17s_1_02.pw_profile', u'mtu'), ('pybind.slxos.v17s_1_02.pw_profile', u'vc_mode')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pw_profile', 'keyval': 'pw_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mtu_value'}, {'leafval': 'vc_mode'}, {'leafval': 'mtu_value'}, {'leafval': 'vc_mode'}]
    leafval_map = {"pybind.slxos.v17s_1_02.pw_profile": {"pw_profile_name": "pw_profile_name", "mtu_enforce": "mtu_enforce"}, "pybind.slxos.v17r_1_01a.pw_profile": {"pw_profile_name": "pw_profile_name", "mtu_enforce": "mtu_enforce"}, "pybind.slxos.v17r_2_00.pw_profile": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pw_profile=pw_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pw_profile=pw_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pw_profile_control_word_get(self, pw_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pw_profile: pw_profile_name
    :param pw_profile: Keyword argument tuple.

    :type pw_profile_name: unicode
    :param pw_profile_name: **pw_profile** tuple argument:  Pw-profile name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.pw_profile', 'pybind.slxos.v17r_2_00.brocade_pw_profile', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pw_profile', 'keyval': 'pw_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pw_profile=pw_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pw_profile=pw_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pw_profile_flow_label_get(self, pw_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pw_profile: pw_profile_name
    :param pw_profile: Keyword argument tuple.

    :type pw_profile_name: unicode
    :param pw_profile_name: **pw_profile** tuple argument:  Pw-profile name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.pw_profile', 'pybind.slxos.v17r_2_00.brocade_pw_profile', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pw_profile', 'keyval': 'pw_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pw_profile=pw_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pw_profile=pw_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pw_profile_mtu_get(self, pw_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pw_profile: pw_profile_name
    :param pw_profile: Keyword argument tuple.

    :type pw_profile_name: unicode
    :param pw_profile_name: **pw_profile** tuple argument:  Pw-profile name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.pw_profile', 'pybind.slxos.v17r_2_00.brocade_pw_profile', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pw_profile', 'keyval': 'pw_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pw_profile=pw_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pw_profile=pw_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pw_profile_mtu_enforce_get(self, pw_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type pw_profile: pw_profile_name
    :param pw_profile: Keyword argument tuple.

    :type pw_profile_name: unicode
    :param pw_profile_name: **pw_profile** tuple argument:  Pw-profile name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.pw_profile', 'pybind.slxos.v17r_1_01a.brocade_pw_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.pw_profile', 'pybind.slxos.v17r_2_00.brocade_pw_profile', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.pw_profile', 'pybind.slxos.v17s_1_02.brocade_pw_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.pw_profile', u'mtu'), ('pybind.slxos.v17r_1_01a.pw_profile', u'vc_mode'), ('pybind.slxos.v17s_1_02.pw_profile', u'mtu'), ('pybind.slxos.v17s_1_02.pw_profile', u'vc_mode')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pw_profile', 'keyval': 'pw_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mtu_value'}, {'leafval': 'vc_mode'}, {'leafval': 'mtu_value'}, {'leafval': 'vc_mode'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pw_profile=pw_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pw_profile=pw_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pw_profile_mtu_mtu_value_get(self, pw_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pw_profile: pw_profile_name
    :param pw_profile: Keyword argument tuple.

    :type pw_profile_name: unicode
    :param pw_profile_name: **pw_profile** tuple argument:  Pw-profile name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.pw_profile', 'pw_profile'), ('pybind.slxos.v17r_1_01a.pw_profile', 'pw_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pw_profile.mtu', 'pybind.slxos.v17r_1_01a.brocade_pw_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.pw_profile.mtu', 'pybind.slxos.v17s_1_02.brocade_pw_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pw_profile_name', 'extra_keyval': ''}, {'keyval': 'pw_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pw_profile=pw_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pw_profile=pw_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pw_profile_vc_mode_get(self, pw_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pw_profile: pw_profile_name
    :param pw_profile: Keyword argument tuple.

    :type pw_profile_name: unicode
    :param pw_profile_name: **pw_profile** tuple argument:  Pw-profile name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.pw_profile', 'pybind.slxos.v17r_2_00.brocade_pw_profile', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'pw_profile', 'keyval': 'pw_profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pw_profile=pw_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pw_profile=pw_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def pw_profile_vc_mode_vc_mode_get(self, pw_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pw_profile: pw_profile_name
    :param pw_profile: Keyword argument tuple.

    :type pw_profile_name: unicode
    :param pw_profile_name: **pw_profile** tuple argument:  Pw-profile name (Max Size - 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.pw_profile', 'pw_profile'), ('pybind.slxos.v17s_1_02.pw_profile', 'pw_profile')]
    bindings_list = [('pybind.slxos.v17r_1_01a.pw_profile.vc_mode', 'pybind.slxos.v17r_1_01a.brocade_pw_profile', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.pw_profile.vc_mode', 'pybind.slxos.v17s_1_02.brocade_pw_profile', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'pw_profile_name', 'extra_keyval': ''}, {'keyval': 'pw_profile_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pw_profile=pw_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pw_profile=pw_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.qos', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.qos.map_', u'cos_traffic_class'), ('pybind.slxos.v17r_2_00.qos.cpu', u'slot'), ('pybind.slxos.v17r_2_00.qos.map_', u'cos_mutation'), ('pybind.slxos.v17r_2_00.system_qos.qos', u'service_policy'), ('pybind.slxos.v17r_2_00.qos.map_', u'dscp_traffic_class'), ('pybind.slxos.v17r_2_00.capabilities.qos.mls', u'flowcontrol'), ('pybind.slxos.v17r_2_00.qos.tx_queue.scheduler', u'strict_priority'), ('pybind.slxos.v17r_2_00.capabilities.qos', u'mls'), ('pybind.slxos.v17r_2_00.qos.map_', u'traffic_class_cos'), ('pybind.slxos.v17r_2_00.qos', u'tx_queue'), ('pybind.slxos.v17r_2_00.qos.map_', u'dscp_cos'), ('pybind.slxos.v17r_2_00.capabilities.qos', u'mqc'), ('pybind.slxos.v17r_2_00.qos.map_', u'dscp_mutation'), ('pybind.slxos.v17r_2_00.qos', u'red_profile'), ('pybind.slxos.v17r_2_00.qos', u'rx_queue'), ('pybind.slxos.v17s_1_02.capabilities.qos', u'cee'), ('pybind.slxos.v17s_1_02.qos.qos_cpu_queue.cpu', u'queue'), ('pybind.slxos.v17s_1_02.qos.map_', u'dscp_traffic_class'), ('pybind.slxos.v17s_1_02.qos.map_', u'traffic_class_cos'), ('pybind.slxos.v17s_1_02.qos.map_', u'cos_traffic_class'), ('pybind.slxos.v17s_1_02.qos.map_', u'dscp_mutation'), ('pybind.slxos.v17s_1_02.capabilities.qos', u'cpu'), ('pybind.slxos.v17s_1_02.system_qos.qos', u'service_policy'), ('pybind.slxos.v17s_1_02.qos.map_', u'traffic_class_mutation'), ('pybind.slxos.v17s_1_02.qos.map_', u'cos_mutation'), ('pybind.slxos.v17s_1_02.qos', u'red_profile'), ('pybind.slxos.v17s_1_02.qos.cpu', u'slot'), ('pybind.slxos.v17s_1_02.capabilities', u'qos'), ('pybind.slxos.v17s_1_02.qos.map_', u'dscp_cos'), ('pybind.slxos.v17s_1_02.qos', u'tx_queue'), ('pybind.slxos.v17s_1_02.qos', u'rx_queue'), ('pybind.slxos.v17s_1_02.qos.tx_queue.scheduler', u'strict_priority'), ('pybind.slxos.v17s_1_02.qos.map_', u'traffic_class_dscp'), ('pybind.slxos.v17s_1_02.qos.map_', u'cos_dscp'), ('pybind.nos.v6_0_2f.qos.map_', u'cos_mutation'), ('pybind.nos.v6_0_2f.system_qos.qos', u'service_policy'), ('pybind.nos.v6_0_2f.qos.map_', u'cos_traffic_class'), ('pybind.nos.v6_0_2f.qos.map_', u'dscp_traffic_class'), ('pybind.nos.v6_0_2f.qos.queue.scheduler', u'strict_priority'), ('pybind.nos.v6_0_2f.qos.map_', u'dscp_cos'), ('pybind.nos.v6_0_2f.qos', u'red_profile'), ('pybind.nos.v6_0_2f.qos.queue.multicast.scheduler', u'dwrr'), ('pybind.nos.v6_0_2f.qos.map_', u'dscp_mutation'), ('pybind.nos.v6_0_2f.qos.rcv_queue.multicast', u'threshold'), ('pybind.nos.v6_0_2f.qos.rcv_queue.multicast', u'rate_limit'), ('pybind.nos.v7_2_0.qos.map_', u'cos_mutation'), ('pybind.nos.v7_2_0.qos.queue.multicast.scheduler', u'dwrr'), ('pybind.nos.v7_2_0.qos.map_', u'dscp_cos'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast', u'threshold'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast', u'rate_limit'), ('pybind.nos.v7_2_0.qos.map_', u'dscp_mutation'), ('pybind.nos.v7_2_0.qos.ecn.red_profile', u'red_profile_ecn'), ('pybind.nos.v7_2_0.system_qos.qos', u'service_policy'), ('pybind.nos.v7_2_0.qos.queue.scheduler', u'strict_priority'), ('pybind.nos.v7_2_0.qos.map_', u'dscp_traffic_class'), ('pybind.nos.v7_2_0.qos', u'red_profile'), ('pybind.nos.v7_2_0.qos.map_', u'cos_traffic_class'), ('pybind.slxos.v17r_1_01a.qos.map_', u'cos_traffic_class'), ('pybind.slxos.v17r_1_01a.qos.map_', u'dscp_cos'), ('pybind.slxos.v17r_1_01a.qos.tx_queue.scheduler', u'strict_priority'), ('pybind.slxos.v17r_1_01a.qos.map_', u'dscp_mutation'), ('pybind.slxos.v17r_1_01a.qos.map_', u'traffic_class_cos'), ('pybind.slxos.v17r_1_01a.qos', u'red_profile'), ('pybind.slxos.v17r_1_01a.qos', u'rx_queue'), ('pybind.slxos.v17r_1_01a.capabilities.qos', u'mqc'), ('pybind.slxos.v17r_1_01a.qos.map_', u'dscp_traffic_class'), ('pybind.slxos.v17r_1_01a.system_qos.qos', u'service_policy'), ('pybind.slxos.v17r_1_01a.qos', u'tx_queue'), ('pybind.slxos.v17r_1_01a.qos.cpu', u'slot'), ('pybind.slxos.v17r_1_01a.qos.map_', u'cos_mutation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}, {'leafval': 'slot_id'}, {'leafval': 'name'}, {'leafval': 'direction, policy_map_name'}, {'leafval': 'dscp_traffic_class_map_name'}, {'leafval': 'clear_qos_flowcontrol_statistics'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}, {'leafval': 'qos_intf_default_cos, qos_intf_default_traffic_class'}, {'leafval': 'traffic_class_cos_map_name'}, {'leafval': 'tx_queue_limit'}, {'leafval': 'dscp_cos_map_name'}, {'leafval': 'span, vlan_based_actions, bd_based_actions'}, {'leafval': 'dscp_mutation_map_name'}, {'leafval': 'profile_id, min_threshold, max_threshold, drop_probability'}, {'leafval': 'rx_queue_limit'}, {'leafval': 'nas'}, {'leafval': 'id, rate_limit'}, {'leafval': 'dscp_traffic_class_map_name'}, {'leafval': 'traffic_class_cos_map_name'}, {'leafval': 'name'}, {'leafval': 'dscp_mutation_map_name'}, {'leafval': 'slot, queue'}, {'leafval': 'direction, policy_map_name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'profile_id, min_threshold, max_threshold, drop_probability'}, {'leafval': 'slot_id'}, {'leafval': 'system_rx_queue_limit, system_tx_queue_limit, show_rx_queue_interface, conf_rx_queue_interface'}, {'leafval': 'dscp_cos_map_name'}, {'leafval': 'tx_queue_limit'}, {'leafval': 'rx_queue_limit'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name, cos0, cos1, cos2, cos3, cos4, cos5, cos6, cos7'}, {'leafval': 'direction, policy_map_name'}, {'leafval': 'name, cos0, cos1, cos2, cos3, cos4, cos5, cos6, cos7'}, {'leafval': 'dscp_traffic_class_map_name'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}, {'leafval': 'dscp_cos_map_name'}, {'leafval': 'profile_id, min_threshold, max_threshold, drop_probability'}, {'leafval': 'dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class7'}, {'leafval': 'dscp_mutation_map_name'}, {'leafval': 'traffic_class0, traffic_class1, traffic_class2, traffic_class3, traffic_class4, traffic_class5, traffic_class6, traffic_class7'}, {'leafval': 'limit, burst'}, {'leafval': 'name, cos0, cos1, cos2, cos3, cos4, cos5, cos6, cos7'}, {'leafval': 'dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class7'}, {'leafval': 'dscp_cos_map_name'}, {'leafval': 'traffic_class0, traffic_class1, traffic_class2, traffic_class3, traffic_class4, traffic_class5, traffic_class6, traffic_class7'}, {'leafval': 'limit, burst'}, {'leafval': 'dscp_mutation_map_name'}, {'leafval': 'min_threshold, max_threshold, drop_probability'}, {'leafval': 'direction, policy_map_name'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}, {'leafval': 'dscp_traffic_class_map_name'}, {'leafval': 'profile_id, min_threshold, max_threshold, drop_probability'}, {'leafval': 'name, cos0, cos1, cos2, cos3, cos4, cos5, cos6, cos7'}, {'leafval': 'name'}, {'leafval': 'dscp_cos_map_name'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}, {'leafval': 'dscp_mutation_map_name'}, {'leafval': 'traffic_class_cos_map_name'}, {'leafval': 'profile_id, min_threshold, max_threshold, drop_probability'}, {'leafval': 'rx_queue_limit'}, {'leafval': 'span, vlan_based_actions, bd_based_actions'}, {'leafval': 'dscp_traffic_class_map_name'}, {'leafval': 'direction, policy_map_name'}, {'leafval': 'tx_queue_limit'}, {'leafval': 'slot_id'}, {'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.qos.cpu', u'slot'), ('pybind.slxos.v17r_1_01a.qos.cpu', u'slot'), ('pybind.slxos.v17s_1_02.qos.qos_cpu_queue.cpu', u'queue'), ('pybind.slxos.v17s_1_02.capabilities.qos', u'cpu'), ('pybind.slxos.v17s_1_02.qos.cpu', u'slot')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'slot_id'}, {'leafval': 'slot_id'}, {'leafval': 'id, rate_limit'}, {'leafval': 'slot, queue'}, {'leafval': 'slot_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_qos_cpu_queue_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.qos.qos_cpu_queue.cpu', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos.qos_cpu_queue.cpu', u'queue')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'id, rate_limit'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_queue_get(self, queue=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type queue: id
    :param queue: Keyword argument tuple.

    :type id: int
    :param id: **queue** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.qos.qos_cpu_queue.cpu.queue', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue=queue)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_queue_rate_limit_get(self, queue=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type queue: id
    :param queue: Keyword argument tuple.

    :type id: int
    :param id: **queue** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.qos.qos_cpu_queue.cpu.queue', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue=queue)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_get(self, slot=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.port', u'port_shaper'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group', u'group'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group', u'group'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.port', u'port_shaper'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.port', u'port_shaper'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group', u'group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'slot', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'port_shaper_rate, port_shaper_burst_size'}, {'leafval': 'group_id'}, {'leafval': 'group_id'}, {'leafval': 'port_shaper_rate, port_shaper_burst_size'}, {'leafval': 'port_shaper_rate, port_shaper_burst_size'}, {'leafval': 'group_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_group_get(self, slot=None, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    **Instance Keyword Argument Tuple**:

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot', u'slot'), ('pybind.slxos.v17s_1_02.qos.cpu.slot', u'slot')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq', u'group_prio'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq', u'group_shaper'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq', u'group_wfq'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq', u'group_shaper'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq', u'group_prio'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq', u'group_wfq'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq', u'group_shaper'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq', u'group_wfq'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq', u'group_prio')]
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'group_prio_id'}, {'leafval': 'group_shaper_rate, group_shaper_burst_size'}, {'leafval': 'group_wfq_weight'}, {'leafval': 'group_shaper_rate, group_shaper_burst_size'}, {'leafval': 'group_prio_id'}, {'leafval': 'group_wfq_weight'}, {'leafval': 'group_shaper_rate, group_shaper_burst_size'}, {'leafval': 'group_wfq_weight'}, {'leafval': 'group_prio_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_group_prio_get(self, slot=None, group=None, group_prio=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    **Instance Keyword Argument Tuple**:

    :type group_prio: group_prio_id
    :param group_prio: Keyword argument tuple.

    :type group_prio_id: unicode
    :param group_prio_id: **group_prio** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17s_1_02.qos.cpu.slot', u'slot'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group', u'group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq', u'group_prio_wfq'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq', u'group_prio_shaper'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq', u'group_prio_shaper'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq', u'group_prio_wfq'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq', u'group_prio_wfq'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq', u'group_prio_shaper')]
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'group_prio', 'keyval': 'group_prio_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'group_prio_wfq_weight'}, {'leafval': 'group_prio_shaper_rate, group_prio_shaper_burst_size'}, {'leafval': 'group_prio_shaper_rate, group_prio_shaper_burst_size'}, {'leafval': 'group_prio_wfq_weight'}, {'leafval': 'group_prio_wfq_weight'}, {'leafval': 'group_prio_shaper_rate, group_prio_shaper_burst_size'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group, group_prio=group_prio)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group, group_prio=group_prio)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_group_prio_shaper_get(self, slot=None, group=None, group_prio=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group_prio: group_prio_id
    :param group_prio: Keyword argument tuple.

    :type group_prio_id: unicode
    :param group_prio_id: **group_prio** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio'), ('pybind.slxos.v17s_1_02.qos.cpu.slot', u'slot'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio'), ('pybind.slxos.v17r_2_00.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_shaper', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_shaper', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_shaper', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group, group_prio=group_prio)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group, group_prio=group_prio)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_group_prio_shaper_burst_get(self, slot=None, group=None, group_prio=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group_prio: group_prio_id
    :param group_prio: Keyword argument tuple.

    :type group_prio_id: unicode
    :param group_prio_id: **group_prio** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio'), ('pybind.slxos.v17s_1_02.qos.cpu.slot', u'slot'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio'), ('pybind.slxos.v17r_2_00.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_shaper', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_shaper', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_shaper', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group, group_prio=group_prio)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group, group_prio=group_prio)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_group_prio_shaper_rate_get(self, slot=None, group=None, group_prio=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group_prio: group_prio_id
    :param group_prio: Keyword argument tuple.

    :type group_prio_id: unicode
    :param group_prio_id: **group_prio** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio'), ('pybind.slxos.v17s_1_02.qos.cpu.slot', u'slot'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio'), ('pybind.slxos.v17r_2_00.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_shaper', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_shaper', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_shaper', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group, group_prio=group_prio)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group, group_prio=group_prio)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_group_prio_wfq_get(self, slot=None, group=None, group_prio=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group_prio: group_prio_id
    :param group_prio: Keyword argument tuple.

    :type group_prio_id: unicode
    :param group_prio_id: **group_prio** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio'), ('pybind.slxos.v17s_1_02.qos.cpu.slot', u'slot'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_wfq', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_wfq', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_wfq', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group, group_prio=group_prio)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group, group_prio=group_prio)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_group_prio_wfq_weight_get(self, slot=None, group=None, group_prio=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group_prio: group_prio_id
    :param group_prio: Keyword argument tuple.

    :type group_prio_id: unicode
    :param group_prio_id: **group_prio** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio'), ('pybind.slxos.v17s_1_02.qos.cpu.slot', u'slot'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio', u'group_prio')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_wfq', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_wfq', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_prio.group_prio_config_shaper_wfq.group_prio_wfq', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'group_prio_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group, group_prio=group_prio)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group, group_prio=group_prio)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_group_shaper_get(self, slot=None, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17s_1_02.qos.cpu.slot', u'slot'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group', u'group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_shaper', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_shaper', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_shaper', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_group_shaper_burst_get(self, slot=None, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17s_1_02.qos.cpu.slot', u'slot'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group', u'group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_shaper', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_shaper', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_shaper', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_group_shaper_rate_get(self, slot=None, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17s_1_02.qos.cpu.slot', u'slot'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group', u'group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_shaper', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_shaper', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_shaper', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_group_wfq_get(self, slot=None, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17s_1_02.qos.cpu.slot', u'slot'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group', u'group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_wfq', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_wfq', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_wfq', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_group_wfq_weight_get(self, slot=None, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type group: group_id
    :param group: Keyword argument tuple.

    :type group_id: unicode
    :param group_id: **group** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group', u'group'), ('pybind.slxos.v17s_1_02.qos.cpu.slot', u'slot'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group', u'group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_wfq', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_wfq', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.group.group_config_shaper_wfq.group_wfq', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_port_get(self, slot=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_2_00.qos.cpu.slot', u'slot'), ('pybind.slxos.v17s_1_02.qos.cpu.slot', u'slot')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.port', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.port', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.port', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_port_shaper_get(self, slot=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_2_00.qos.cpu.slot', u'slot')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.port.port_shaper', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.port.port_shaper', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.port.port_shaper', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_port_shaper_burst_get(self, slot=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_2_00.qos.cpu.slot', u'slot')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.port.port_shaper', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.port.port_shaper', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.port.port_shaper', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_cpu_slot_port_shaper_rate_get(self, slot=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type slot: slot_id
    :param slot: Keyword argument tuple.

    :type slot_id: unicode
    :param slot_id: **slot** tuple argument.

        * length restriction: ::

            ['1..3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_1_01a.qos.cpu.slot', u'slot'), ('pybind.slxos.v17r_2_00.qos.cpu.slot', u'slot')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.cpu.slot.port_group.port.port_shaper', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.cpu.slot.port_group.port.port_shaper', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.cpu.slot.port_group.port.port_shaper', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}, {'keyval': 'slot_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, slot=slot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, slot=slot)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_ecn_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.qos.ecn', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.qos.ecn.red_profile', u'red_profile_ecn')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'min_threshold, max_threshold, drop_probability'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.qos.map_', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.qos.map_', u'cos_traffic_class'), ('pybind.slxos.v17r_1_01a.qos.map_', u'dscp_cos'), ('pybind.slxos.v17r_1_01a.qos.map_', u'dscp_mutation'), ('pybind.slxos.v17r_1_01a.qos.map_', u'traffic_class_cos'), ('pybind.slxos.v17r_1_01a.qos.map_', u'dscp_traffic_class'), ('pybind.slxos.v17r_1_01a.qos.map_', u'cos_mutation'), ('pybind.nos.v6_0_2f.qos.map_', u'cos_mutation'), ('pybind.nos.v6_0_2f.qos.map_', u'cos_traffic_class'), ('pybind.nos.v6_0_2f.qos.map_', u'dscp_traffic_class'), ('pybind.nos.v6_0_2f.qos.map_', u'dscp_cos'), ('pybind.nos.v6_0_2f.qos.map_', u'dscp_mutation'), ('pybind.slxos.v17s_1_02.qos.map_', u'dscp_traffic_class'), ('pybind.slxos.v17s_1_02.qos.map_', u'traffic_class_cos'), ('pybind.slxos.v17s_1_02.qos.map_', u'cos_traffic_class'), ('pybind.slxos.v17s_1_02.qos.map_', u'dscp_mutation'), ('pybind.slxos.v17s_1_02.qos.map_', u'traffic_class_mutation'), ('pybind.slxos.v17s_1_02.qos.map_', u'cos_mutation'), ('pybind.slxos.v17s_1_02.qos.map_', u'dscp_cos'), ('pybind.slxos.v17s_1_02.qos.map_', u'traffic_class_dscp'), ('pybind.slxos.v17s_1_02.qos.map_', u'cos_dscp'), ('pybind.nos.v7_2_0.qos.map_', u'cos_mutation'), ('pybind.nos.v7_2_0.qos.map_', u'dscp_cos'), ('pybind.nos.v7_2_0.qos.map_', u'dscp_mutation'), ('pybind.nos.v7_2_0.qos.map_', u'dscp_traffic_class'), ('pybind.nos.v7_2_0.qos.map_', u'cos_traffic_class'), ('pybind.slxos.v17r_2_00.qos.map_', u'cos_traffic_class'), ('pybind.slxos.v17r_2_00.qos.map_', u'cos_mutation'), ('pybind.slxos.v17r_2_00.qos.map_', u'dscp_traffic_class'), ('pybind.slxos.v17r_2_00.qos.map_', u'traffic_class_cos'), ('pybind.slxos.v17r_2_00.qos.map_', u'dscp_cos'), ('pybind.slxos.v17r_2_00.qos.map_', u'dscp_mutation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}, {'leafval': 'dscp_cos_map_name'}, {'leafval': 'dscp_mutation_map_name'}, {'leafval': 'traffic_class_cos_map_name'}, {'leafval': 'dscp_traffic_class_map_name'}, {'leafval': 'name'}, {'leafval': 'name, cos0, cos1, cos2, cos3, cos4, cos5, cos6, cos7'}, {'leafval': 'name, cos0, cos1, cos2, cos3, cos4, cos5, cos6, cos7'}, {'leafval': 'dscp_traffic_class_map_name'}, {'leafval': 'dscp_cos_map_name'}, {'leafval': 'dscp_mutation_map_name'}, {'leafval': 'dscp_traffic_class_map_name'}, {'leafval': 'traffic_class_cos_map_name'}, {'leafval': 'name'}, {'leafval': 'dscp_mutation_map_name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'dscp_cos_map_name'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'name, cos0, cos1, cos2, cos3, cos4, cos5, cos6, cos7'}, {'leafval': 'dscp_cos_map_name'}, {'leafval': 'dscp_mutation_map_name'}, {'leafval': 'dscp_traffic_class_map_name'}, {'leafval': 'name, cos0, cos1, cos2, cos3, cos4, cos5, cos6, cos7'}, {'leafval': 'name'}, {'leafval': 'name'}, {'leafval': 'dscp_traffic_class_map_name'}, {'leafval': 'traffic_class_cos_map_name'}, {'leafval': 'dscp_cos_map_name'}, {'leafval': 'dscp_mutation_map_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_dscp_get(self, cos_dscp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cos_dscp: name
    :param cos_dscp: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_dscp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.qos.map_.cos_dscp', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos.map_.cos_dscp', u'cos_to_dscp_mappings')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_dscp', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'from_cos'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_dscp=cos_dscp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_dscp=cos_dscp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_dscp_map_get(self, cos_dscp=None, cos_to_dscp_mappings=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cos_dscp: name
    :param cos_dscp: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_dscp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type cos_to_dscp_mappings: from_cos
    :param cos_to_dscp_mappings: Keyword argument tuple.

    :type from_cos: int
    :param from_cos: **cos_to_dscp_mappings** tuple argument:  In CoS

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos.map_.cos_dscp', u'cos_dscp')]
    bindings_list = [('pybind.slxos.v17s_1_02.qos.map_.cos_dscp.cos_to_dscp_mappings', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos.map_.cos_dscp.cos_to_dscp_mappings', u'to')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cos_to_dscp_mappings', 'keyval': 'from_cos', 'extra_keyval': 'from_cos'}
    composed_child_leafval_list = [{'leafval': 'to_dscp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_dscp=cos_dscp, cos_to_dscp_mappings=cos_to_dscp_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_dscp=cos_dscp, cos_to_dscp_mappings=cos_to_dscp_mappings)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_dscp_map_to_get(self, cos_dscp=None, cos_to_dscp_mappings=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cos_dscp: name
    :param cos_dscp: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_dscp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type cos_to_dscp_mappings: from_cos
    :param cos_to_dscp_mappings: Keyword argument tuple.

    :type from_cos: int
    :param from_cos: **cos_to_dscp_mappings** tuple argument:  In CoS

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos.map_.cos_dscp', u'cos_dscp'), ('pybind.slxos.v17s_1_02.qos.map_.cos_dscp.cos_to_dscp_mappings', u'cos_to_dscp_mappings')]
    bindings_list = [('pybind.slxos.v17s_1_02.qos.map_.cos_dscp.cos_to_dscp_mappings.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'to_dscp'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_dscp=cos_dscp, cos_to_dscp_mappings=cos_to_dscp_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_dscp=cos_dscp, cos_to_dscp_mappings=cos_to_dscp_mappings)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_dscp_map_to_dscp_get(self, cos_dscp=None, cos_to_dscp_mappings=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cos_dscp: name
    :param cos_dscp: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_dscp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type cos_to_dscp_mappings: from_cos
    :param cos_to_dscp_mappings: Keyword argument tuple.

    :type from_cos: int
    :param from_cos: **cos_to_dscp_mappings** tuple argument:  In CoS

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos.map_.cos_dscp', u'cos_dscp'), ('pybind.slxos.v17s_1_02.qos.map_.cos_dscp.cos_to_dscp_mappings', u'cos_to_dscp_mappings')]
    bindings_list = [('pybind.slxos.v17s_1_02.qos.map_.cos_dscp.cos_to_dscp_mappings.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_dscp=cos_dscp, cos_to_dscp_mappings=cos_to_dscp_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_dscp=cos_dscp, cos_to_dscp_mappings=cos_to_dscp_mappings)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_mutation_get(self, cos_mutation=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name, cos0, cos1, cos2, cos3, cos4, cos5, cos6, cos7
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type cos0: long
    :param cos0: **cos_mutation** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos1: long
    :param cos1: **cos_mutation** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos2: long
    :param cos2: **cos_mutation** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos3: long
    :param cos3: **cos_mutation** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos4: long
    :param cos4: **cos_mutation** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos5: long
    :param cos5: **cos_mutation** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos6: long
    :param cos6: **cos_mutation** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos7: long
    :param cos7: **cos_mutation** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_mutation', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_mutation', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.qos.map_.cos_mutation', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.cos_mutation', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.cos_mutation', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.qos.map_.cos_mutation', u'cos_to_cos_mappings'), ('pybind.slxos.v17s_1_02.qos.map_.cos_mutation', u'cos_to_cos_mappings'), ('pybind.slxos.v17r_2_00.qos.map_.cos_mutation', u'cos_to_cos_mappings')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'from_cos'}, {'leafval': 'from_cos'}, {'leafval': 'from_cos'}]
    leafval_map = {"pybind.slxos.v17r_2_00.qos.map_.cos_mutation": {}, "pybind.nos.v7_2_0.qos.map_.cos_mutation": {"name": "name", "cos7": "cos7", "cos6": "cos6", "cos5": "cos5", "cos4": "cos4", "cos3": "cos3", "cos2": "cos2", "cos1": "cos1", "cos0": "cos0"}, "pybind.slxos.v17s_1_02.qos.map_.cos_mutation": {}, "pybind.slxos.v17r_1_01a.qos.map_.cos_mutation": {}, "pybind.nos.v6_0_2f.qos.map_.cos_mutation": {"name": "name", "cos7": "cos7", "cos6": "cos6", "cos5": "cos5", "cos4": "cos4", "cos3": "cos3", "cos2": "cos2", "cos1": "cos1", "cos0": "cos0"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_mutation_cos0_get(self, cos_mutation=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_mutation', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_mutation', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_mutation_cos1_get(self, cos_mutation=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_mutation', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_mutation', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_mutation_cos2_get(self, cos_mutation=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_mutation', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_mutation', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_mutation_cos3_get(self, cos_mutation=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_mutation', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_mutation', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_mutation_cos4_get(self, cos_mutation=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_mutation', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_mutation', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_mutation_cos5_get(self, cos_mutation=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_mutation', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_mutation', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_mutation_cos6_get(self, cos_mutation=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_mutation', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_mutation', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_mutation_cos7_get(self, cos_mutation=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_mutation', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_mutation', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_mutation_map_get(self, cos_mutation=None, cos_to_cos_mappings=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type cos_to_cos_mappings: from_cos
    :param cos_to_cos_mappings: Keyword argument tuple.

    :type from_cos: int
    :param from_cos: **cos_to_cos_mappings** tuple argument:  In CoS

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos.map_.cos_mutation', u'cos_mutation'), ('pybind.slxos.v17s_1_02.qos.map_.cos_mutation', u'cos_mutation'), ('pybind.slxos.v17r_2_00.qos.map_.cos_mutation', u'cos_mutation')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.cos_mutation.cos_to_cos_mappings', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.cos_mutation.cos_to_cos_mappings', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.cos_mutation.cos_to_cos_mappings', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.qos.map_.cos_mutation.cos_to_cos_mappings', u'to'), ('pybind.slxos.v17s_1_02.qos.map_.cos_mutation.cos_to_cos_mappings', u'to'), ('pybind.slxos.v17r_2_00.qos.map_.cos_mutation.cos_to_cos_mappings', u'to')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cos_to_cos_mappings', 'keyval': 'from_cos', 'extra_keyval': 'from_cos'}
    composed_child_leafval_list = [{'leafval': 'to_cos'}, {'leafval': 'to_cos'}, {'leafval': 'to_cos'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation, cos_to_cos_mappings=cos_to_cos_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation, cos_to_cos_mappings=cos_to_cos_mappings)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_mutation_map_to_get(self, cos_mutation=None, cos_to_cos_mappings=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type cos_to_cos_mappings: from_cos
    :param cos_to_cos_mappings: Keyword argument tuple.

    :type from_cos: int
    :param from_cos: **cos_to_cos_mappings** tuple argument:  In CoS

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.map_.cos_mutation', u'cos_mutation'), ('pybind.slxos.v17r_2_00.qos.map_.cos_mutation.cos_to_cos_mappings', u'cos_to_cos_mappings'), ('pybind.slxos.v17r_1_01a.qos.map_.cos_mutation', u'cos_mutation'), ('pybind.slxos.v17r_1_01a.qos.map_.cos_mutation.cos_to_cos_mappings', u'cos_to_cos_mappings'), ('pybind.slxos.v17s_1_02.qos.map_.cos_mutation', u'cos_mutation'), ('pybind.slxos.v17s_1_02.qos.map_.cos_mutation.cos_to_cos_mappings', u'cos_to_cos_mappings')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.cos_mutation.cos_to_cos_mappings.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.cos_mutation.cos_to_cos_mappings.to', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.cos_mutation.cos_to_cos_mappings.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'to_cos'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation, cos_to_cos_mappings=cos_to_cos_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation, cos_to_cos_mappings=cos_to_cos_mappings)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_mutation_map_to_cos_get(self, cos_mutation=None, cos_to_cos_mappings=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cos_mutation: name
    :param cos_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type cos_to_cos_mappings: from_cos
    :param cos_to_cos_mappings: Keyword argument tuple.

    :type from_cos: int
    :param from_cos: **cos_to_cos_mappings** tuple argument:  In CoS

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.map_.cos_mutation', u'cos_mutation'), ('pybind.slxos.v17r_2_00.qos.map_.cos_mutation.cos_to_cos_mappings', u'cos_to_cos_mappings'), ('pybind.slxos.v17r_1_01a.qos.map_.cos_mutation', u'cos_mutation'), ('pybind.slxos.v17r_1_01a.qos.map_.cos_mutation.cos_to_cos_mappings', u'cos_to_cos_mappings'), ('pybind.slxos.v17s_1_02.qos.map_.cos_mutation', u'cos_mutation'), ('pybind.slxos.v17s_1_02.qos.map_.cos_mutation.cos_to_cos_mappings', u'cos_to_cos_mappings')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.cos_mutation.cos_to_cos_mappings.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.cos_mutation.cos_to_cos_mappings.to', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.cos_mutation.cos_to_cos_mappings.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_mutation=cos_mutation, cos_to_cos_mappings=cos_to_cos_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_mutation=cos_mutation, cos_to_cos_mappings=cos_to_cos_mappings)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_traffic_class_get(self, cos_traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name, cos0, cos1, cos2, cos3, cos4, cos5, cos6, cos7
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type cos0: long
    :param cos0: **cos_traffic_class** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos1: long
    :param cos1: **cos_traffic_class** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos2: long
    :param cos2: **cos_traffic_class** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos3: long
    :param cos3: **cos_traffic_class** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos4: long
    :param cos4: **cos_traffic_class** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos5: long
    :param cos5: **cos_traffic_class** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos6: long
    :param cos6: **cos_traffic_class** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type cos7: long
    :param cos7: **cos_traffic_class** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.qos.map_.cos_traffic_class', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.cos_traffic_class', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.cos_traffic_class', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.qos.map_.cos_traffic_class', u'cos_to_tc_dp_mappings'), ('pybind.slxos.v17s_1_02.qos.map_.cos_traffic_class', u'cos_to_tc_dp_mappings'), ('pybind.slxos.v17r_1_01a.qos.map_.cos_traffic_class', u'cos_to_tc_dp_mappings')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'from_cos'}, {'leafval': 'from_cos'}, {'leafval': 'from_cos'}]
    leafval_map = {"pybind.slxos.v17r_2_00.qos.map_.cos_traffic_class": {}, "pybind.nos.v6_0_2f.qos.map_.cos_traffic_class": {"name": "name", "cos7": "cos7", "cos6": "cos6", "cos5": "cos5", "cos4": "cos4", "cos3": "cos3", "cos2": "cos2", "cos1": "cos1", "cos0": "cos0"}, "pybind.slxos.v17r_1_01a.qos.map_.cos_traffic_class": {}, "pybind.slxos.v17s_1_02.qos.map_.cos_traffic_class": {}, "pybind.nos.v7_2_0.qos.map_.cos_traffic_class": {"name": "name", "cos7": "cos7", "cos6": "cos6", "cos5": "cos5", "cos4": "cos4", "cos3": "cos3", "cos2": "cos2", "cos1": "cos1", "cos0": "cos0"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_traffic_class_cos0_get(self, cos_traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_traffic_class_cos1_get(self, cos_traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_traffic_class_cos2_get(self, cos_traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_traffic_class_cos3_get(self, cos_traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_traffic_class_cos4_get(self, cos_traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_traffic_class_cos5_get(self, cos_traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_traffic_class_cos6_get(self, cos_traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_traffic_class_cos7_get(self, cos_traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.cos_traffic_class', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.cos_traffic_class', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cos_traffic_class', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_traffic_class_map_get(self, cos_traffic_class=None, cos_to_tc_dp_mappings=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type cos_to_tc_dp_mappings: from_cos
    :param cos_to_tc_dp_mappings: Keyword argument tuple.

    :type from_cos: int
    :param from_cos: **cos_to_tc_dp_mappings** tuple argument:  In CoS

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.map_.cos_traffic_class', u'cos_traffic_class'), ('pybind.slxos.v17r_1_01a.qos.map_.cos_traffic_class', u'cos_traffic_class'), ('pybind.slxos.v17s_1_02.qos.map_.cos_traffic_class', u'cos_traffic_class')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', u'to'), ('pybind.slxos.v17r_1_01a.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', u'to'), ('pybind.slxos.v17s_1_02.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', u'to')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cos_to_tc_dp_mappings', 'keyval': 'from_cos', 'extra_keyval': 'from_cos'}
    composed_child_leafval_list = [{'leafval': 'to_traffic_class, to_drop_precedence'}, {'leafval': 'to_traffic_class, to_drop_precedence'}, {'leafval': 'to_traffic_class, to_drop_precedence'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class, cos_to_tc_dp_mappings=cos_to_tc_dp_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class, cos_to_tc_dp_mappings=cos_to_tc_dp_mappings)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_traffic_class_map_to_get(self, cos_traffic_class=None, cos_to_tc_dp_mappings=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type cos_to_tc_dp_mappings: from_cos
    :param cos_to_tc_dp_mappings: Keyword argument tuple.

    :type from_cos: int
    :param from_cos: **cos_to_tc_dp_mappings** tuple argument:  In CoS

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.map_.cos_traffic_class', u'cos_traffic_class'), ('pybind.slxos.v17r_2_00.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', u'cos_to_tc_dp_mappings'), ('pybind.slxos.v17r_1_01a.qos.map_.cos_traffic_class', u'cos_traffic_class'), ('pybind.slxos.v17r_1_01a.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', u'cos_to_tc_dp_mappings'), ('pybind.slxos.v17s_1_02.qos.map_.cos_traffic_class', u'cos_traffic_class'), ('pybind.slxos.v17s_1_02.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', u'cos_to_tc_dp_mappings')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings.to', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'to_traffic_class, to_drop_precedence'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class, cos_to_tc_dp_mappings=cos_to_tc_dp_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class, cos_to_tc_dp_mappings=cos_to_tc_dp_mappings)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_traffic_class_map_to_drop_precedence_get(self, cos_traffic_class=None, cos_to_tc_dp_mappings=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type cos_to_tc_dp_mappings: from_cos
    :param cos_to_tc_dp_mappings: Keyword argument tuple.

    :type from_cos: int
    :param from_cos: **cos_to_tc_dp_mappings** tuple argument:  In CoS

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.map_.cos_traffic_class', u'cos_traffic_class'), ('pybind.slxos.v17r_2_00.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', u'cos_to_tc_dp_mappings'), ('pybind.slxos.v17r_1_01a.qos.map_.cos_traffic_class', u'cos_traffic_class'), ('pybind.slxos.v17r_1_01a.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', u'cos_to_tc_dp_mappings'), ('pybind.slxos.v17s_1_02.qos.map_.cos_traffic_class', u'cos_traffic_class'), ('pybind.slxos.v17s_1_02.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', u'cos_to_tc_dp_mappings')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings.to', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class, cos_to_tc_dp_mappings=cos_to_tc_dp_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class, cos_to_tc_dp_mappings=cos_to_tc_dp_mappings)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_cos_traffic_class_map_to_traffic_class_get(self, cos_traffic_class=None, cos_to_tc_dp_mappings=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cos_traffic_class: name
    :param cos_traffic_class: Keyword argument tuple.

    :type name: unicode
    :param name: **cos_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type cos_to_tc_dp_mappings: from_cos
    :param cos_to_tc_dp_mappings: Keyword argument tuple.

    :type from_cos: int
    :param from_cos: **cos_to_tc_dp_mappings** tuple argument:  In CoS

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.map_.cos_traffic_class', u'cos_traffic_class'), ('pybind.slxos.v17r_2_00.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', u'cos_to_tc_dp_mappings'), ('pybind.slxos.v17r_1_01a.qos.map_.cos_traffic_class', u'cos_traffic_class'), ('pybind.slxos.v17r_1_01a.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', u'cos_to_tc_dp_mappings'), ('pybind.slxos.v17s_1_02.qos.map_.cos_traffic_class', u'cos_traffic_class'), ('pybind.slxos.v17s_1_02.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings', u'cos_to_tc_dp_mappings')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings.to', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.cos_traffic_class.cos_to_tc_dp_mappings.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_cos', 'extra_keyval': 'from_cos'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cos_traffic_class=cos_traffic_class, cos_to_tc_dp_mappings=cos_to_tc_dp_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cos_traffic_class=cos_traffic_class, cos_to_tc_dp_mappings=cos_to_tc_dp_mappings)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_cos_get(self, dscp_cos=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dscp_cos: dscp_cos_map_name
    :param dscp_cos: Keyword argument tuple.

    :type dscp_cos_map_name: unicode
    :param dscp_cos_map_name: **dscp_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.dscp_cos', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.dscp_cos', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_cos', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_cos', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_cos', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.qos.map_.dscp_cos', u'mark'), ('pybind.nos.v6_0_2f.qos.map_.dscp_cos', u'mark'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_cos', u'dscp_to_cos_mapping'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_cos', u'dscp_to_cos_mapping'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_cos', u'dscp_to_cos_mapping')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dscp_cos', 'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dscp_in_values, to'}, {'leafval': 'dscp_in_values, to'}, {'leafval': 'dscp_in_values'}, {'leafval': 'dscp_in_values'}, {'leafval': 'dscp_in_values'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_cos=dscp_cos)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_cos=dscp_cos)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_cos_map_get(self, dscp_cos=None, dscp_to_cos_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_cos: dscp_cos_map_name
    :param dscp_cos: Keyword argument tuple.

    :type dscp_cos_map_name: unicode
    :param dscp_cos_map_name: **dscp_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type dscp_to_cos_mapping: dscp_in_values
    :param dscp_to_cos_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_cos_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.map_.dscp_cos', u'dscp_cos'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_cos', u'dscp_cos'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_cos', u'dscp_cos')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.dscp_cos.dscp_to_cos_mapping', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_cos.dscp_to_cos_mapping', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_cos.dscp_to_cos_mapping', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.qos.map_.dscp_cos.dscp_to_cos_mapping', u'to'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_cos.dscp_to_cos_mapping', u'to'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_cos.dscp_to_cos_mapping', u'to')]
    compositions_keyval_list = [{'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dscp_to_cos_mapping', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'to_value'}, {'leafval': 'to_value'}, {'leafval': 'to_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_cos=dscp_cos, dscp_to_cos_mapping=dscp_to_cos_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_cos=dscp_cos, dscp_to_cos_mapping=dscp_to_cos_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_cos_map_to_get(self, dscp_cos=None, dscp_to_cos_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_cos: dscp_cos_map_name
    :param dscp_cos: Keyword argument tuple.

    :type dscp_cos_map_name: unicode
    :param dscp_cos_map_name: **dscp_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp_to_cos_mapping: dscp_in_values
    :param dscp_to_cos_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_cos_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos.map_.dscp_cos', u'dscp_cos'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_cos.dscp_to_cos_mapping', u'dscp_to_cos_mapping'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_cos', u'dscp_cos'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_cos.dscp_to_cos_mapping', u'dscp_to_cos_mapping'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_cos', u'dscp_cos'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_cos.dscp_to_cos_mapping', u'dscp_to_cos_mapping')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.dscp_cos.dscp_to_cos_mapping.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_cos.dscp_to_cos_mapping.to', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_cos.dscp_to_cos_mapping.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'to_value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_cos=dscp_cos, dscp_to_cos_mapping=dscp_to_cos_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_cos=dscp_cos, dscp_to_cos_mapping=dscp_to_cos_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_cos_map_to_cos_get(self, dscp_cos=None, dscp_to_cos_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_cos: dscp_cos_map_name
    :param dscp_cos: Keyword argument tuple.

    :type dscp_cos_map_name: unicode
    :param dscp_cos_map_name: **dscp_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp_to_cos_mapping: dscp_in_values
    :param dscp_to_cos_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_cos_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos.map_.dscp_cos', u'dscp_cos'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_cos.dscp_to_cos_mapping', u'dscp_to_cos_mapping'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_cos', u'dscp_cos'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_cos.dscp_to_cos_mapping', u'dscp_to_cos_mapping'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_cos', u'dscp_cos'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_cos.dscp_to_cos_mapping', u'dscp_to_cos_mapping')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.dscp_cos.dscp_to_cos_mapping.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_cos.dscp_to_cos_mapping.to', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_cos.dscp_to_cos_mapping.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_cos=dscp_cos, dscp_to_cos_mapping=dscp_to_cos_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_cos=dscp_cos, dscp_to_cos_mapping=dscp_to_cos_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_cos_mark_get(self, dscp_cos=None, mark=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_cos: dscp_cos_map_name
    :param dscp_cos: Keyword argument tuple.

    :type dscp_cos_map_name: unicode
    :param dscp_cos_map_name: **dscp_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type mark: dscp_in_values
    :param mark: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **mark** tuple argument:  0-63;;Incoming DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.qos.map_.dscp_cos', u'dscp_cos'), ('pybind.nos.v6_0_2f.qos.map_.dscp_cos', u'dscp_cos')]
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.dscp_cos.mark', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.dscp_cos.mark', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mark', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_cos=dscp_cos, mark=mark)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_cos=dscp_cos, mark=mark)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_cos_mark_to_get(self, dscp_cos=None, mark=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_cos: dscp_cos_map_name
    :param dscp_cos: Keyword argument tuple.

    :type dscp_cos_map_name: unicode
    :param dscp_cos_map_name: **dscp_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type mark: dscp_in_values
    :param mark: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **mark** tuple argument:  0-63;;Incoming DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.qos.map_.dscp_cos', u'dscp_cos'), ('pybind.nos.v6_0_2f.qos.map_.dscp_cos', u'dscp_cos')]
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.dscp_cos.mark', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.dscp_cos.mark', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_cos_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mark', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_cos=dscp_cos, mark=mark)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_cos=dscp_cos, mark=mark)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_mutation_get(self, dscp_mutation=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dscp_mutation: dscp_mutation_map_name
    :param dscp_mutation: Keyword argument tuple.

    :type dscp_mutation_map_name: unicode
    :param dscp_mutation_map_name: **dscp_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.dscp_mutation', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.dscp_mutation', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_mutation', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_mutation', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_mutation', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.qos.map_.dscp_mutation', u'mark'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_mutation', u'dscp_to_dscp_mapping'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_mutation', u'dscp_to_dscp_mapping'), ('pybind.nos.v7_2_0.qos.map_.dscp_mutation', u'mark'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_mutation', u'dscp_to_dscp_mapping')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dscp_mutation', 'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dscp_in_values, to'}, {'leafval': 'dscp_in_values'}, {'leafval': 'dscp_in_values'}, {'leafval': 'dscp_in_values, to'}, {'leafval': 'dscp_in_values'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_mutation=dscp_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_mutation=dscp_mutation)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_mutation_map_get(self, dscp_mutation=None, dscp_to_dscp_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_mutation: dscp_mutation_map_name
    :param dscp_mutation: Keyword argument tuple.

    :type dscp_mutation_map_name: unicode
    :param dscp_mutation_map_name: **dscp_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type dscp_to_dscp_mapping: dscp_in_values
    :param dscp_to_dscp_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_dscp_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos.map_.dscp_mutation', u'dscp_mutation'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_mutation', u'dscp_mutation'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_mutation', u'dscp_mutation')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.dscp_mutation.dscp_to_dscp_mapping', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_mutation.dscp_to_dscp_mapping', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_mutation.dscp_to_dscp_mapping', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos.map_.dscp_mutation.dscp_to_dscp_mapping', u'to'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_mutation.dscp_to_dscp_mapping', u'to'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_mutation.dscp_to_dscp_mapping', u'to')]
    compositions_keyval_list = [{'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dscp_to_dscp_mapping', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'to_value'}, {'leafval': 'to_value'}, {'leafval': 'to_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_mutation=dscp_mutation, dscp_to_dscp_mapping=dscp_to_dscp_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_mutation=dscp_mutation, dscp_to_dscp_mapping=dscp_to_dscp_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_mutation_map_to_get(self, dscp_mutation=None, dscp_to_dscp_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_mutation: dscp_mutation_map_name
    :param dscp_mutation: Keyword argument tuple.

    :type dscp_mutation_map_name: unicode
    :param dscp_mutation_map_name: **dscp_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp_to_dscp_mapping: dscp_in_values
    :param dscp_to_dscp_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_dscp_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos.map_.dscp_mutation', u'dscp_mutation'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_mutation.dscp_to_dscp_mapping', u'dscp_to_dscp_mapping'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_mutation', u'dscp_mutation'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_mutation.dscp_to_dscp_mapping', u'dscp_to_dscp_mapping'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_mutation', u'dscp_mutation'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_mutation.dscp_to_dscp_mapping', u'dscp_to_dscp_mapping')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.dscp_mutation.dscp_to_dscp_mapping.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_mutation.dscp_to_dscp_mapping.to', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_mutation.dscp_to_dscp_mapping.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'to_value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_mutation=dscp_mutation, dscp_to_dscp_mapping=dscp_to_dscp_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_mutation=dscp_mutation, dscp_to_dscp_mapping=dscp_to_dscp_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_mutation_map_to_dscp_get(self, dscp_mutation=None, dscp_to_dscp_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_mutation: dscp_mutation_map_name
    :param dscp_mutation: Keyword argument tuple.

    :type dscp_mutation_map_name: unicode
    :param dscp_mutation_map_name: **dscp_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp_to_dscp_mapping: dscp_in_values
    :param dscp_to_dscp_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_dscp_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos.map_.dscp_mutation', u'dscp_mutation'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_mutation.dscp_to_dscp_mapping', u'dscp_to_dscp_mapping'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_mutation', u'dscp_mutation'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_mutation.dscp_to_dscp_mapping', u'dscp_to_dscp_mapping'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_mutation', u'dscp_mutation'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_mutation.dscp_to_dscp_mapping', u'dscp_to_dscp_mapping')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.dscp_mutation.dscp_to_dscp_mapping.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_mutation.dscp_to_dscp_mapping.to', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_mutation.dscp_to_dscp_mapping.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_mutation=dscp_mutation, dscp_to_dscp_mapping=dscp_to_dscp_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_mutation=dscp_mutation, dscp_to_dscp_mapping=dscp_to_dscp_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_mutation_mark_get(self, dscp_mutation=None, mark=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_mutation: dscp_mutation_map_name
    :param dscp_mutation: Keyword argument tuple.

    :type dscp_mutation_map_name: unicode
    :param dscp_mutation_map_name: **dscp_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type mark: dscp_in_values
    :param mark: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **mark** tuple argument:  0-63;;Incoming DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.qos.map_.dscp_mutation', u'dscp_mutation'), ('pybind.nos.v6_0_2f.qos.map_.dscp_mutation', u'dscp_mutation')]
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.dscp_mutation.mark', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.dscp_mutation.mark', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mark', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_mutation=dscp_mutation, mark=mark)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_mutation=dscp_mutation, mark=mark)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_mutation_mark_to_get(self, dscp_mutation=None, mark=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_mutation: dscp_mutation_map_name
    :param dscp_mutation: Keyword argument tuple.

    :type dscp_mutation_map_name: unicode
    :param dscp_mutation_map_name: **dscp_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type mark: dscp_in_values
    :param mark: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **mark** tuple argument:  0-63;;Incoming DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.qos.map_.dscp_mutation', u'dscp_mutation'), ('pybind.nos.v6_0_2f.qos.map_.dscp_mutation', u'dscp_mutation')]
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.dscp_mutation.mark', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.dscp_mutation.mark', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_mutation_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mark', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_mutation=dscp_mutation, mark=mark)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_mutation=dscp_mutation, mark=mark)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_traffic_class_get(self, dscp_traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dscp_traffic_class: dscp_traffic_class_map_name
    :param dscp_traffic_class: Keyword argument tuple.

    :type dscp_traffic_class_map_name: unicode
    :param dscp_traffic_class_map_name: **dscp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.dscp_traffic_class', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.dscp_traffic_class', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_traffic_class', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_traffic_class', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_traffic_class', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.qos.map_.dscp_traffic_class', u'dscp_to_tc_dp_mapping'), ('pybind.nos.v6_0_2f.qos.map_.dscp_traffic_class', u'mark'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_traffic_class', u'dscp_to_tc_dp_mapping'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_traffic_class', u'dscp_to_tc_dp_mapping'), ('pybind.nos.v7_2_0.qos.map_.dscp_traffic_class', u'mark')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dscp_traffic_class', 'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dscp_in_values'}, {'leafval': 'dscp_in_values, to'}, {'leafval': 'dscp_in_values'}, {'leafval': 'dscp_in_values'}, {'leafval': 'dscp_in_values, to'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_traffic_class=dscp_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_traffic_class=dscp_traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_traffic_class_map_get(self, dscp_traffic_class=None, dscp_to_tc_dp_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_traffic_class: dscp_traffic_class_map_name
    :param dscp_traffic_class: Keyword argument tuple.

    :type dscp_traffic_class_map_name: unicode
    :param dscp_traffic_class_map_name: **dscp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type dscp_to_tc_dp_mapping: dscp_in_values
    :param dscp_to_tc_dp_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_tc_dp_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_traffic_class', u'dscp_traffic_class')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', u'to'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', u'to'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', u'to')]
    compositions_keyval_list = [{'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dscp_to_tc_dp_mapping', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'to_value, to_drop_precedence'}, {'leafval': 'to_value, to_drop_precedence'}, {'leafval': 'to_value, to_drop_precedence'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_traffic_class=dscp_traffic_class, dscp_to_tc_dp_mapping=dscp_to_tc_dp_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_traffic_class=dscp_traffic_class, dscp_to_tc_dp_mapping=dscp_to_tc_dp_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_traffic_class_map_to_get(self, dscp_traffic_class=None, dscp_to_tc_dp_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_traffic_class: dscp_traffic_class_map_name
    :param dscp_traffic_class: Keyword argument tuple.

    :type dscp_traffic_class_map_name: unicode
    :param dscp_traffic_class_map_name: **dscp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp_to_tc_dp_mapping: dscp_in_values
    :param dscp_to_tc_dp_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_tc_dp_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', u'dscp_to_tc_dp_mapping'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', u'dscp_to_tc_dp_mapping'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', u'dscp_to_tc_dp_mapping')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping.to', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'to_value, to_drop_precedence'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_traffic_class=dscp_traffic_class, dscp_to_tc_dp_mapping=dscp_to_tc_dp_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_traffic_class=dscp_traffic_class, dscp_to_tc_dp_mapping=dscp_to_tc_dp_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_traffic_class_map_to_drop_precedence_get(self, dscp_traffic_class=None, dscp_to_tc_dp_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_traffic_class: dscp_traffic_class_map_name
    :param dscp_traffic_class: Keyword argument tuple.

    :type dscp_traffic_class_map_name: unicode
    :param dscp_traffic_class_map_name: **dscp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp_to_tc_dp_mapping: dscp_in_values
    :param dscp_to_tc_dp_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_tc_dp_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', u'dscp_to_tc_dp_mapping'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', u'dscp_to_tc_dp_mapping'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', u'dscp_to_tc_dp_mapping')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping.to', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_traffic_class=dscp_traffic_class, dscp_to_tc_dp_mapping=dscp_to_tc_dp_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_traffic_class=dscp_traffic_class, dscp_to_tc_dp_mapping=dscp_to_tc_dp_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_traffic_class_map_to_traffic_class_get(self, dscp_traffic_class=None, dscp_to_tc_dp_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_traffic_class: dscp_traffic_class_map_name
    :param dscp_traffic_class: Keyword argument tuple.

    :type dscp_traffic_class_map_name: unicode
    :param dscp_traffic_class_map_name: **dscp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp_to_tc_dp_mapping: dscp_in_values
    :param dscp_to_tc_dp_mapping: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **dscp_to_tc_dp_mapping** tuple argument:  In DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.slxos.v17r_1_01a.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', u'dscp_to_tc_dp_mapping'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', u'dscp_to_tc_dp_mapping'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping', u'dscp_to_tc_dp_mapping')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping.to', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.dscp_traffic_class.dscp_to_tc_dp_mapping.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_traffic_class=dscp_traffic_class, dscp_to_tc_dp_mapping=dscp_to_tc_dp_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_traffic_class=dscp_traffic_class, dscp_to_tc_dp_mapping=dscp_to_tc_dp_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_traffic_class_mark_get(self, dscp_traffic_class=None, mark=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_traffic_class: dscp_traffic_class_map_name
    :param dscp_traffic_class: Keyword argument tuple.

    :type dscp_traffic_class_map_name: unicode
    :param dscp_traffic_class_map_name: **dscp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type mark: dscp_in_values
    :param mark: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **mark** tuple argument:  0-63;;Incoming DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.nos.v7_2_0.qos.map_.dscp_traffic_class', u'dscp_traffic_class')]
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.dscp_traffic_class.mark', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.dscp_traffic_class.mark', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mark', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_traffic_class=dscp_traffic_class, mark=mark)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_traffic_class=dscp_traffic_class, mark=mark)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_dscp_traffic_class_mark_to_get(self, dscp_traffic_class=None, mark=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_traffic_class: dscp_traffic_class_map_name
    :param dscp_traffic_class: Keyword argument tuple.

    :type dscp_traffic_class_map_name: unicode
    :param dscp_traffic_class_map_name: **dscp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type mark: dscp_in_values
    :param mark: Keyword argument tuple.

    :type dscp_in_values: unicode
    :param dscp_in_values: **mark** tuple argument:  0-63;;Incoming DSCP

        * pattern restriction: ::

            '(([0-9])|([1-5][0-9])|(6[0-3]))(-(([0-9])|([1-5]'
            '[0-9])|(6[0-3])))?((,(([0-9])|([1-5][0-9])|(6[0-'
            '3]))(-(([0-9])|([1-5][0-9])|(6[0-3])))?)?)*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.qos.map_.dscp_traffic_class', u'dscp_traffic_class'), ('pybind.nos.v7_2_0.qos.map_.dscp_traffic_class', u'dscp_traffic_class')]
    bindings_list = [('pybind.nos.v6_0_2f.qos.map_.dscp_traffic_class.mark', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.map_.dscp_traffic_class.mark', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_traffic_class_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mark', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_traffic_class=dscp_traffic_class, mark=mark)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_traffic_class=dscp_traffic_class, mark=mark)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_traffic_class_cos_get(self, traffic_class_cos=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type traffic_class_cos: traffic_class_cos_map_name
    :param traffic_class_cos: Keyword argument tuple.

    :type traffic_class_cos_map_name: unicode
    :param traffic_class_cos_map_name: **traffic_class_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.traffic_class_cos', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.traffic_class_cos', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.traffic_class_cos', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_cos', u'tc_dp_to_cos_mapping'), ('pybind.slxos.v17r_1_01a.qos.map_.traffic_class_cos', u'tc_dp_to_cos_mapping'), ('pybind.slxos.v17r_2_00.qos.map_.traffic_class_cos', u'tc_dp_to_cos_mapping')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'traffic_class_cos', 'keyval': 'traffic_class_cos_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'from_traffic_class, from_drop_precedence'}, {'leafval': 'from_traffic_class, from_drop_precedence'}, {'leafval': 'from_traffic_class, from_drop_precedence'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_cos=traffic_class_cos)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_cos=traffic_class_cos)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_traffic_class_cos_map_get(self, traffic_class_cos=None, tc_dp_to_cos_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_cos: traffic_class_cos_map_name
    :param traffic_class_cos: Keyword argument tuple.

    :type traffic_class_cos_map_name: unicode
    :param traffic_class_cos_map_name: **traffic_class_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type tc_dp_to_cos_mapping: from_traffic_class, from_drop_precedence
    :param tc_dp_to_cos_mapping: Keyword argument tuple.

    :type from_traffic_class: int
    :param from_traffic_class: **tc_dp_to_cos_mapping** tuple argument:  In Traffic-Class

        * range restriction: ::

            ['0..255']

    :type from_drop_precedence: int
    :param from_drop_precedence: **tc_dp_to_cos_mapping** tuple argument:  In Drop-Precedence

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos.map_.traffic_class_cos', u'traffic_class_cos'), ('pybind.slxos.v17r_2_00.qos.map_.traffic_class_cos', u'traffic_class_cos'), ('pybind.slxos.v17s_1_02.qos.map_.traffic_class_cos', u'traffic_class_cos')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping', u'to'), ('pybind.slxos.v17r_2_00.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping', u'to'), ('pybind.slxos.v17s_1_02.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping', u'to')]
    compositions_keyval_list = [{'keyval': 'traffic_class_cos_map_name', 'extra_keyval': ''}, {'keyval': 'traffic_class_cos_map_name', 'extra_keyval': ''}, {'keyval': 'traffic_class_cos_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'tc_dp_to_cos_mapping', 'keyval': 'from_traffic_class, from_drop_precedence', 'extra_keyval': 'from_traffic_class, from_drop_precedence'}
    composed_child_leafval_list = [{'leafval': 'to_cos'}, {'leafval': 'to_cos'}, {'leafval': 'to_cos'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_cos=traffic_class_cos, tc_dp_to_cos_mapping=tc_dp_to_cos_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_cos=traffic_class_cos, tc_dp_to_cos_mapping=tc_dp_to_cos_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_traffic_class_cos_map_to_get(self, traffic_class_cos=None, tc_dp_to_cos_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_cos: traffic_class_cos_map_name
    :param traffic_class_cos: Keyword argument tuple.

    :type traffic_class_cos_map_name: unicode
    :param traffic_class_cos_map_name: **traffic_class_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type tc_dp_to_cos_mapping: from_traffic_class, from_drop_precedence
    :param tc_dp_to_cos_mapping: Keyword argument tuple.

    :type from_traffic_class: int
    :param from_traffic_class: **tc_dp_to_cos_mapping** tuple argument:  In Traffic-Class

        * range restriction: ::

            ['0..255']

    :type from_drop_precedence: int
    :param from_drop_precedence: **tc_dp_to_cos_mapping** tuple argument:  In Drop-Precedence

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.map_.traffic_class_cos', u'traffic_class_cos'), ('pybind.slxos.v17r_2_00.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping', u'tc_dp_to_cos_mapping'), ('pybind.slxos.v17r_1_01a.qos.map_.traffic_class_cos', u'traffic_class_cos'), ('pybind.slxos.v17r_1_01a.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping', u'tc_dp_to_cos_mapping'), ('pybind.slxos.v17s_1_02.qos.map_.traffic_class_cos', u'traffic_class_cos'), ('pybind.slxos.v17s_1_02.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping', u'tc_dp_to_cos_mapping')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping.to', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'traffic_class_cos_map_name', 'extra_keyval': ''}, {'keyval': 'from_traffic_class, from_drop_precedence', 'extra_keyval': 'from_traffic_class, from_drop_precedence'}, {'keyval': 'traffic_class_cos_map_name', 'extra_keyval': ''}, {'keyval': 'from_traffic_class, from_drop_precedence', 'extra_keyval': 'from_traffic_class, from_drop_precedence'}, {'keyval': 'traffic_class_cos_map_name', 'extra_keyval': ''}, {'keyval': 'from_traffic_class, from_drop_precedence', 'extra_keyval': 'from_traffic_class, from_drop_precedence'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'to_cos'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_cos=traffic_class_cos, tc_dp_to_cos_mapping=tc_dp_to_cos_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_cos=traffic_class_cos, tc_dp_to_cos_mapping=tc_dp_to_cos_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_traffic_class_cos_map_to_cos_get(self, traffic_class_cos=None, tc_dp_to_cos_mapping=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_cos: traffic_class_cos_map_name
    :param traffic_class_cos: Keyword argument tuple.

    :type traffic_class_cos_map_name: unicode
    :param traffic_class_cos_map_name: **traffic_class_cos** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type tc_dp_to_cos_mapping: from_traffic_class, from_drop_precedence
    :param tc_dp_to_cos_mapping: Keyword argument tuple.

    :type from_traffic_class: int
    :param from_traffic_class: **tc_dp_to_cos_mapping** tuple argument:  In Traffic-Class

        * range restriction: ::

            ['0..255']

    :type from_drop_precedence: int
    :param from_drop_precedence: **tc_dp_to_cos_mapping** tuple argument:  In Drop-Precedence

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos.map_.traffic_class_cos', u'traffic_class_cos'), ('pybind.slxos.v17r_2_00.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping', u'tc_dp_to_cos_mapping'), ('pybind.slxos.v17r_1_01a.qos.map_.traffic_class_cos', u'traffic_class_cos'), ('pybind.slxos.v17r_1_01a.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping', u'tc_dp_to_cos_mapping'), ('pybind.slxos.v17s_1_02.qos.map_.traffic_class_cos', u'traffic_class_cos'), ('pybind.slxos.v17s_1_02.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping', u'tc_dp_to_cos_mapping')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping.to', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.map_.traffic_class_cos.tc_dp_to_cos_mapping.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'traffic_class_cos_map_name', 'extra_keyval': ''}, {'keyval': 'from_traffic_class, from_drop_precedence', 'extra_keyval': 'from_traffic_class, from_drop_precedence'}, {'keyval': 'traffic_class_cos_map_name', 'extra_keyval': ''}, {'keyval': 'from_traffic_class, from_drop_precedence', 'extra_keyval': 'from_traffic_class, from_drop_precedence'}, {'keyval': 'traffic_class_cos_map_name', 'extra_keyval': ''}, {'keyval': 'from_traffic_class, from_drop_precedence', 'extra_keyval': 'from_traffic_class, from_drop_precedence'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_cos=traffic_class_cos, tc_dp_to_cos_mapping=tc_dp_to_cos_mapping)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_cos=traffic_class_cos, tc_dp_to_cos_mapping=tc_dp_to_cos_mapping)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_traffic_class_dscp_get(self, traffic_class_dscp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type traffic_class_dscp: name
    :param traffic_class_dscp: Keyword argument tuple.

    :type name: unicode
    :param name: **traffic_class_dscp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_dscp', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_dscp', u'traffic_class_to_dscp_mappings')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'traffic_class_dscp', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'from_traffic_class'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_dscp=traffic_class_dscp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_dscp=traffic_class_dscp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_traffic_class_dscp_map_get(self, traffic_class_dscp=None, traffic_class_to_dscp_mappings=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_dscp: name
    :param traffic_class_dscp: Keyword argument tuple.

    :type name: unicode
    :param name: **traffic_class_dscp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type traffic_class_to_dscp_mappings: from_traffic_class
    :param traffic_class_to_dscp_mappings: Keyword argument tuple.

    :type from_traffic_class: int
    :param from_traffic_class: **traffic_class_to_dscp_mappings** tuple argument:  In Traffic-Class

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_dscp', u'traffic_class_dscp')]
    bindings_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_dscp.traffic_class_to_dscp_mappings', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_dscp.traffic_class_to_dscp_mappings', u'to')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class_to_dscp_mappings', 'keyval': 'from_traffic_class', 'extra_keyval': 'from_traffic_class'}
    composed_child_leafval_list = [{'leafval': 'to_dscp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_dscp=traffic_class_dscp, traffic_class_to_dscp_mappings=traffic_class_to_dscp_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_dscp=traffic_class_dscp, traffic_class_to_dscp_mappings=traffic_class_to_dscp_mappings)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_traffic_class_dscp_map_to_get(self, traffic_class_dscp=None, traffic_class_to_dscp_mappings=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_dscp: name
    :param traffic_class_dscp: Keyword argument tuple.

    :type name: unicode
    :param name: **traffic_class_dscp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type traffic_class_to_dscp_mappings: from_traffic_class
    :param traffic_class_to_dscp_mappings: Keyword argument tuple.

    :type from_traffic_class: int
    :param from_traffic_class: **traffic_class_to_dscp_mappings** tuple argument:  In Traffic-Class

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_dscp', u'traffic_class_dscp'), ('pybind.slxos.v17s_1_02.qos.map_.traffic_class_dscp.traffic_class_to_dscp_mappings', u'traffic_class_to_dscp_mappings')]
    bindings_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_dscp.traffic_class_to_dscp_mappings.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_traffic_class', 'extra_keyval': 'from_traffic_class'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'to_dscp'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_dscp=traffic_class_dscp, traffic_class_to_dscp_mappings=traffic_class_to_dscp_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_dscp=traffic_class_dscp, traffic_class_to_dscp_mappings=traffic_class_to_dscp_mappings)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_traffic_class_dscp_map_to_dscp_get(self, traffic_class_dscp=None, traffic_class_to_dscp_mappings=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_dscp: name
    :param traffic_class_dscp: Keyword argument tuple.

    :type name: unicode
    :param name: **traffic_class_dscp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type traffic_class_to_dscp_mappings: from_traffic_class
    :param traffic_class_to_dscp_mappings: Keyword argument tuple.

    :type from_traffic_class: int
    :param from_traffic_class: **traffic_class_to_dscp_mappings** tuple argument:  In Traffic-Class

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_dscp', u'traffic_class_dscp'), ('pybind.slxos.v17s_1_02.qos.map_.traffic_class_dscp.traffic_class_to_dscp_mappings', u'traffic_class_to_dscp_mappings')]
    bindings_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_dscp.traffic_class_to_dscp_mappings.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_traffic_class', 'extra_keyval': 'from_traffic_class'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_dscp=traffic_class_dscp, traffic_class_to_dscp_mappings=traffic_class_to_dscp_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_dscp=traffic_class_dscp, traffic_class_to_dscp_mappings=traffic_class_to_dscp_mappings)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_traffic_class_mutation_get(self, traffic_class_mutation=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type traffic_class_mutation: name
    :param traffic_class_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **traffic_class_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_mutation', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_mutation', u'traffic_class_mutation_mappings')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'traffic_class_mutation', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'from_traffic_class'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_mutation=traffic_class_mutation)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_mutation=traffic_class_mutation)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_traffic_class_mutation_map_get(self, traffic_class_mutation=None, traffic_class_mutation_mappings=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_mutation: name
    :param traffic_class_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **traffic_class_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type traffic_class_mutation_mappings: from_traffic_class
    :param traffic_class_mutation_mappings: Keyword argument tuple.

    :type from_traffic_class: int
    :param from_traffic_class: **traffic_class_mutation_mappings** tuple argument:  In Traffic-Class

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_mutation', u'traffic_class_mutation')]
    bindings_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_mutation.traffic_class_mutation_mappings', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_mutation.traffic_class_mutation_mappings', u'to')]
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'traffic_class_mutation_mappings', 'keyval': 'from_traffic_class', 'extra_keyval': 'from_traffic_class'}
    composed_child_leafval_list = [{'leafval': 'to_traffic_class'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_mutation=traffic_class_mutation, traffic_class_mutation_mappings=traffic_class_mutation_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_mutation=traffic_class_mutation, traffic_class_mutation_mappings=traffic_class_mutation_mappings)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_traffic_class_mutation_map_to_get(self, traffic_class_mutation=None, traffic_class_mutation_mappings=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_mutation: name
    :param traffic_class_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **traffic_class_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type traffic_class_mutation_mappings: from_traffic_class
    :param traffic_class_mutation_mappings: Keyword argument tuple.

    :type from_traffic_class: int
    :param from_traffic_class: **traffic_class_mutation_mappings** tuple argument:  In Traffic-Class

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_mutation', u'traffic_class_mutation'), ('pybind.slxos.v17s_1_02.qos.map_.traffic_class_mutation.traffic_class_mutation_mappings', u'traffic_class_mutation_mappings')]
    bindings_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_mutation.traffic_class_mutation_mappings.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_traffic_class', 'extra_keyval': 'from_traffic_class'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'to_traffic_class'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_mutation=traffic_class_mutation, traffic_class_mutation_mappings=traffic_class_mutation_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_mutation=traffic_class_mutation, traffic_class_mutation_mappings=traffic_class_mutation_mappings)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_map_traffic_class_mutation_map_to_traffic_class_get(self, traffic_class_mutation=None, traffic_class_mutation_mappings=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_mutation: name
    :param traffic_class_mutation: Keyword argument tuple.

    :type name: unicode
    :param name: **traffic_class_mutation** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type traffic_class_mutation_mappings: from_traffic_class
    :param traffic_class_mutation_mappings: Keyword argument tuple.

    :type from_traffic_class: int
    :param from_traffic_class: **traffic_class_mutation_mappings** tuple argument:  In Traffic-Class

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_mutation', u'traffic_class_mutation'), ('pybind.slxos.v17s_1_02.qos.map_.traffic_class_mutation.traffic_class_mutation_mappings', u'traffic_class_mutation_mappings')]
    bindings_list = [('pybind.slxos.v17s_1_02.qos.map_.traffic_class_mutation.traffic_class_mutation_mappings.to', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'from_traffic_class', 'extra_keyval': 'from_traffic_class'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_mutation=traffic_class_mutation, traffic_class_mutation_mappings=traffic_class_mutation_mappings)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_mutation=traffic_class_mutation, traffic_class_mutation_mappings=traffic_class_mutation_mappings)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.qos_mpls.map_apply', u'apply_dscp_exp_map_name'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply', u'apply_traffic_class_exp_map_name'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply', u'apply_exp_dscp_map_name'), ('pybind.slxos.v17r_2_00.qos_mpls.map_', u'traffic_class_exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_', u'dscp_exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_', u'inexp_outexp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply', u'apply_exp_traffic_class_map_name'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply', u'apply_inexp_outexp_map_name'), ('pybind.slxos.v17r_2_00.qos_mpls.map_', u'exp_dscp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_', u'exp_traffic_class'), ('pybind.slxos.v17s_1_02.qos_mpls.map_', u'traffic_class_exp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_', u'exp_traffic_class'), ('pybind.slxos.v17s_1_02.qos_mpls.map_', u'exp_dscp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply', u'apply_exp_traffic_class_map_name'), ('pybind.slxos.v17s_1_02.qos_mpls.map_', u'dscp_exp'), ('pybind.slxos.v17s_1_02.traffic_class_exp_state', u'qos_mpls'), ('pybind.slxos.v17s_1_02.exp_dscp_state', u'qos_mpls'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply', u'apply_inexp_outexp_map_name'), ('pybind.slxos.v17s_1_02.exp_traffic_class_state', u'qos_mpls'), ('pybind.slxos.v17s_1_02.dscp_exp_state', u'qos_mpls'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply', u'apply_traffic_class_exp_map_name'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply', u'apply_exp_dscp_map_name'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply', u'apply_dscp_exp_map_name'), ('pybind.slxos.v17s_1_02.qos_mpls.map_', u'inexp_outexp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_', u'exp_traffic_class'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_', u'dscp_exp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_', u'traffic_class_exp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_apply', u'apply_traffic_class_exp_map_name'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_apply', u'apply_exp_dscp_map_name'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_', u'inexp_outexp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_apply', u'apply_exp_traffic_class_map_name'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_', u'exp_dscp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_apply', u'apply_dscp_exp_map_name'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_apply', u'apply_inexp_outexp_map_name')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'map_name_cmd3, all_zero_map_cmd3, default_map_cmd3, All_cmd3'}, {'leafval': 'map_name_cmd2, all_zero_map_cmd2, default_map_cmd2, All_cmd2'}, {'leafval': 'map_name_cmd4, all_zero_map_cmd4, default_map_cmd4, All_cmd4'}, {'leafval': 'traffic_class_exp_map_name'}, {'leafval': 'dscp_exp_map_name'}, {'leafval': 'inexp_outexp_map_name'}, {'leafval': 'map_name_cmd1, all_zero_map_cmd1, default_map_cmd1, All_cmd1'}, {'leafval': 'map_name_cmd5, all_zero_map_cmd5, default_map_cmd5, All_cmd5'}, {'leafval': 'exp_dscp_map_name'}, {'leafval': 'exp_traffic_class_map_name'}, {'leafval': 'traffic_class_exp_map_name'}, {'leafval': 'exp_traffic_class_map_name'}, {'leafval': 'exp_dscp_map_name'}, {'leafval': 'map_name_cmd1, all_zero_map_cmd1, default_map_cmd1, All_cmd1'}, {'leafval': 'dscp_exp_map_name'}, {'leafval': 'map_type, map_name, enabled_slots'}, {'leafval': 'map_type, map_name, enabled_slots'}, {'leafval': 'map_name_cmd5, all_zero_map_cmd5, default_map_cmd5, All_cmd5'}, {'leafval': 'map_type, map_name, enabled_slots'}, {'leafval': 'map_type, map_name, enabled_slots'}, {'leafval': 'map_name_cmd2, all_zero_map_cmd2, default_map_cmd2, All_cmd2'}, {'leafval': 'map_name_cmd4, all_zero_map_cmd4, default_map_cmd4, All_cmd4'}, {'leafval': 'map_name_cmd3, all_zero_map_cmd3, default_map_cmd3, All_cmd3'}, {'leafval': 'inexp_outexp_map_name'}, {'leafval': 'exp_traffic_class_map_name'}, {'leafval': 'dscp_exp_map_name'}, {'leafval': 'traffic_class_exp_map_name'}, {'leafval': 'map_name_cmd2, all_zero_map_cmd2, default_map_cmd2, All_cmd2'}, {'leafval': 'map_name_cmd4, all_zero_map_cmd4, default_map_cmd4, All_cmd4'}, {'leafval': 'inexp_outexp_map_name'}, {'leafval': 'map_name_cmd1, all_zero_map_cmd1, default_map_cmd1, All_cmd1'}, {'leafval': 'exp_dscp_map_name'}, {'leafval': 'map_name_cmd3, all_zero_map_cmd3, default_map_cmd3, All_cmd3'}, {'leafval': 'map_name_cmd5, all_zero_map_cmd5, default_map_cmd5, All_cmd5'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_', u'exp_traffic_class'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_', u'dscp_exp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_', u'traffic_class_exp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_', u'inexp_outexp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_', u'exp_dscp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_', u'traffic_class_exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_', u'dscp_exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_', u'inexp_outexp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_', u'exp_dscp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_', u'exp_traffic_class'), ('pybind.slxos.v17s_1_02.qos_mpls.map_', u'traffic_class_exp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_', u'exp_traffic_class'), ('pybind.slxos.v17s_1_02.qos_mpls.map_', u'exp_dscp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_', u'dscp_exp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_', u'inexp_outexp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'exp_traffic_class_map_name'}, {'leafval': 'dscp_exp_map_name'}, {'leafval': 'traffic_class_exp_map_name'}, {'leafval': 'inexp_outexp_map_name'}, {'leafval': 'exp_dscp_map_name'}, {'leafval': 'traffic_class_exp_map_name'}, {'leafval': 'dscp_exp_map_name'}, {'leafval': 'inexp_outexp_map_name'}, {'leafval': 'exp_dscp_map_name'}, {'leafval': 'exp_traffic_class_map_name'}, {'leafval': 'traffic_class_exp_map_name'}, {'leafval': 'exp_traffic_class_map_name'}, {'leafval': 'exp_dscp_map_name'}, {'leafval': 'dscp_exp_map_name'}, {'leafval': 'inexp_outexp_map_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.qos_mpls.map_apply', u'apply_dscp_exp_map_name'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply', u'apply_traffic_class_exp_map_name'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply', u'apply_exp_dscp_map_name'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply', u'apply_exp_traffic_class_map_name'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply', u'apply_inexp_outexp_map_name'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_apply', u'apply_traffic_class_exp_map_name'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_apply', u'apply_exp_dscp_map_name'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_apply', u'apply_exp_traffic_class_map_name'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_apply', u'apply_dscp_exp_map_name'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_apply', u'apply_inexp_outexp_map_name'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply', u'apply_exp_traffic_class_map_name'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply', u'apply_inexp_outexp_map_name'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply', u'apply_traffic_class_exp_map_name'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply', u'apply_exp_dscp_map_name'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply', u'apply_dscp_exp_map_name')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'map_name_cmd3, all_zero_map_cmd3, default_map_cmd3, All_cmd3'}, {'leafval': 'map_name_cmd2, all_zero_map_cmd2, default_map_cmd2, All_cmd2'}, {'leafval': 'map_name_cmd4, all_zero_map_cmd4, default_map_cmd4, All_cmd4'}, {'leafval': 'map_name_cmd1, all_zero_map_cmd1, default_map_cmd1, All_cmd1'}, {'leafval': 'map_name_cmd5, all_zero_map_cmd5, default_map_cmd5, All_cmd5'}, {'leafval': 'map_name_cmd2, all_zero_map_cmd2, default_map_cmd2, All_cmd2'}, {'leafval': 'map_name_cmd4, all_zero_map_cmd4, default_map_cmd4, All_cmd4'}, {'leafval': 'map_name_cmd1, all_zero_map_cmd1, default_map_cmd1, All_cmd1'}, {'leafval': 'map_name_cmd3, all_zero_map_cmd3, default_map_cmd3, All_cmd3'}, {'leafval': 'map_name_cmd5, all_zero_map_cmd5, default_map_cmd5, All_cmd5'}, {'leafval': 'map_name_cmd1, all_zero_map_cmd1, default_map_cmd1, All_cmd1'}, {'leafval': 'map_name_cmd5, all_zero_map_cmd5, default_map_cmd5, All_cmd5'}, {'leafval': 'map_name_cmd2, all_zero_map_cmd2, default_map_cmd2, All_cmd2'}, {'leafval': 'map_name_cmd4, all_zero_map_cmd4, default_map_cmd4, All_cmd4'}, {'leafval': 'map_name_cmd3, all_zero_map_cmd3, default_map_cmd3, All_cmd3'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_dscp_exp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_dscp_exp_map_name': [u'map_name_cmd3', u'all_zero_map_cmd3', u'default_map_cmd3'], 'pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_dscp_exp_map_name': [u'map_name_cmd3', u'all_zero_map_cmd3', u'default_map_cmd3'], 'pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_dscp_exp_map_name': [u'map_name_cmd3', u'all_zero_map_cmd3', u'default_map_cmd3']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_dscp_exp_all_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_dscp_exp_all_zero_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_dscp_exp_default_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_dscp_exp_map_name_cmd3_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_dscp_exp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_exp_dscp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_exp_dscp_map_name': [u'all_zero_map_cmd4', u'map_name_cmd4', u'default_map_cmd4'], 'pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_exp_dscp_map_name': [u'all_zero_map_cmd4', u'map_name_cmd4', u'default_map_cmd4'], 'pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_exp_dscp_map_name': [u'all_zero_map_cmd4', u'map_name_cmd4', u'default_map_cmd4']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_exp_dscp_all_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_exp_dscp_all_zero_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_exp_dscp_default_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_exp_dscp_map_name_cmd4_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_exp_dscp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_exp_traffic_class_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_exp_traffic_class_map_name': [u'map_name_cmd1', u'all_zero_map_cmd1', u'default_map_cmd1'], 'pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_exp_traffic_class_map_name': [u'map_name_cmd1', u'all_zero_map_cmd1', u'default_map_cmd1'], 'pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_exp_traffic_class_map_name': [u'map_name_cmd1', u'all_zero_map_cmd1', u'default_map_cmd1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_exp_traffic_class_all_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_exp_traffic_class_all_zero_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_exp_traffic_class_default_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_exp_traffic_class_map_name_cmd1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_exp_traffic_class_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_inexp_outexp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_inexp_outexp_map_name': [u'all_zero_map_cmd5', u'default_map_cmd5', u'map_name_cmd5'], 'pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_inexp_outexp_map_name': [u'all_zero_map_cmd5', u'default_map_cmd5', u'map_name_cmd5'], 'pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_inexp_outexp_map_name': [u'all_zero_map_cmd5', u'default_map_cmd5', u'map_name_cmd5']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_inexp_outexp_all_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_inexp_outexp_all_zero_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_inexp_outexp_default_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_inexp_outexp_map_name_cmd5_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_inexp_outexp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_traffic_class_exp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_traffic_class_exp_map_name': [u'map_name_cmd2', u'all_zero_map_cmd2', u'default_map_cmd2'], 'pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_traffic_class_exp_map_name': [u'map_name_cmd2', u'all_zero_map_cmd2', u'default_map_cmd2'], 'pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_traffic_class_exp_map_name': [u'map_name_cmd2', u'all_zero_map_cmd2', u'default_map_cmd2']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_traffic_class_exp_all_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_traffic_class_exp_all_zero_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_traffic_class_exp_default_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_apply_traffic_class_exp_map_name_cmd2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_apply.apply_traffic_class_exp_map_name', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_dscp_exp_get(self, dscp_exp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type dscp_exp: dscp_exp_map_name
    :param dscp_exp: Keyword argument tuple.

    :type dscp_exp_map_name: unicode
    :param dscp_exp_map_name: **dscp_exp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.dscp_exp', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.dscp_exp', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.dscp_exp', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.qos_mpls.map_.dscp_exp', u'dscp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.dscp_exp', u'dscp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.dscp_exp', u'dscp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'dscp_exp', 'keyval': 'dscp_exp_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dscp_in_values'}, {'leafval': 'dscp_in_values'}, {'leafval': 'dscp_in_values'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_exp=dscp_exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_exp=dscp_exp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_dscp_exp_dscp_get(self, dscp_exp=None, dscp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_exp: dscp_exp_map_name
    :param dscp_exp: Keyword argument tuple.

    :type dscp_exp_map_name: unicode
    :param dscp_exp_map_name: **dscp_exp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type dscp: dscp_in_values
    :param dscp: Keyword argument tuple.

    :type dscp_in_values: long
    :param dscp_in_values: **dscp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.dscp_exp', u'dscp_exp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.dscp_exp', u'dscp_exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.dscp_exp', u'dscp_exp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.dscp_exp.dscp', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.dscp_exp.dscp', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.dscp_exp.dscp', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.dscp_exp.dscp', u'to'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.dscp_exp.dscp', u'to'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.dscp_exp.dscp', u'to')]
    compositions_keyval_list = [{'keyval': 'dscp_exp_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_exp_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_exp_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'dscp', 'keyval': 'dscp_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'exp'}, {'leafval': 'exp'}, {'leafval': 'exp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_exp=dscp_exp, dscp=dscp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_exp=dscp_exp, dscp=dscp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_dscp_exp_dscp_to_get(self, dscp_exp=None, dscp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_exp: dscp_exp_map_name
    :param dscp_exp: Keyword argument tuple.

    :type dscp_exp_map_name: unicode
    :param dscp_exp_map_name: **dscp_exp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp: dscp_in_values
    :param dscp: Keyword argument tuple.

    :type dscp_in_values: long
    :param dscp_in_values: **dscp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.dscp_exp', u'dscp_exp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.dscp_exp.dscp', u'dscp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.dscp_exp', u'dscp_exp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.dscp_exp.dscp', u'dscp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.dscp_exp', u'dscp_exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.dscp_exp.dscp', u'dscp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.dscp_exp.dscp.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.dscp_exp.dscp.to', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.dscp_exp.dscp.to', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_exp_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_exp_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_exp_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'exp'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_exp=dscp_exp, dscp=dscp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_exp=dscp_exp, dscp=dscp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_dscp_exp_dscp_to_exp_get(self, dscp_exp=None, dscp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type dscp_exp: dscp_exp_map_name
    :param dscp_exp: Keyword argument tuple.

    :type dscp_exp_map_name: unicode
    :param dscp_exp_map_name: **dscp_exp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type dscp: dscp_in_values
    :param dscp: Keyword argument tuple.

    :type dscp_in_values: long
    :param dscp_in_values: **dscp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.dscp_exp', u'dscp_exp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.dscp_exp.dscp', u'dscp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.dscp_exp', u'dscp_exp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.dscp_exp.dscp', u'dscp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.dscp_exp', u'dscp_exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.dscp_exp.dscp', u'dscp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.dscp_exp.dscp.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.dscp_exp.dscp.to', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.dscp_exp.dscp.to', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'dscp_exp_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_exp_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}, {'keyval': 'dscp_exp_map_name', 'extra_keyval': ''}, {'keyval': 'dscp_in_values', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, dscp_exp=dscp_exp, dscp=dscp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, dscp_exp=dscp_exp, dscp=dscp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_exp_dscp_get(self, exp_dscp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type exp_dscp: exp_dscp_map_name
    :param exp_dscp: Keyword argument tuple.

    :type exp_dscp_map_name: unicode
    :param exp_dscp_map_name: **exp_dscp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_dscp', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_dscp', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_dscp', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_dscp', u'exp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_dscp', u'exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_dscp', u'exp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'exp_dscp', 'keyval': 'exp_dscp_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'exp_in_values'}, {'leafval': 'exp_in_values'}, {'leafval': 'exp_in_values'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, exp_dscp=exp_dscp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, exp_dscp=exp_dscp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_exp_dscp_exp_get(self, exp_dscp=None, exp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type exp_dscp: exp_dscp_map_name
    :param exp_dscp: Keyword argument tuple.

    :type exp_dscp_map_name: unicode
    :param exp_dscp_map_name: **exp_dscp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type exp: exp_in_values
    :param exp: Keyword argument tuple.

    :type exp_in_values: long
    :param exp_in_values: **exp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_dscp', u'exp_dscp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_dscp', u'exp_dscp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_dscp', u'exp_dscp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_dscp.exp', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_dscp.exp', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_dscp.exp', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_dscp.exp', u'to'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_dscp.exp', u'to'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_dscp.exp', u'to')]
    compositions_keyval_list = [{'keyval': 'exp_dscp_map_name', 'extra_keyval': ''}, {'keyval': 'exp_dscp_map_name', 'extra_keyval': ''}, {'keyval': 'exp_dscp_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'exp', 'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}
    composed_child_leafval_list = [{'leafval': 'dscp'}, {'leafval': 'dscp'}, {'leafval': 'dscp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, exp_dscp=exp_dscp, exp=exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, exp_dscp=exp_dscp, exp=exp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_exp_dscp_exp_to_get(self, exp_dscp=None, exp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type exp_dscp: exp_dscp_map_name
    :param exp_dscp: Keyword argument tuple.

    :type exp_dscp_map_name: unicode
    :param exp_dscp_map_name: **exp_dscp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type exp: exp_in_values
    :param exp: Keyword argument tuple.

    :type exp_in_values: long
    :param exp_in_values: **exp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_dscp', u'exp_dscp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_dscp.exp', u'exp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_dscp', u'exp_dscp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_dscp.exp', u'exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_dscp', u'exp_dscp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_dscp.exp', u'exp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_dscp.exp.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_dscp.exp.to', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_dscp.exp.to', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'exp_dscp_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}, {'keyval': 'exp_dscp_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}, {'keyval': 'exp_dscp_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'dscp'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, exp_dscp=exp_dscp, exp=exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, exp_dscp=exp_dscp, exp=exp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_exp_dscp_exp_to_dscp_get(self, exp_dscp=None, exp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type exp_dscp: exp_dscp_map_name
    :param exp_dscp: Keyword argument tuple.

    :type exp_dscp_map_name: unicode
    :param exp_dscp_map_name: **exp_dscp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type exp: exp_in_values
    :param exp: Keyword argument tuple.

    :type exp_in_values: long
    :param exp_in_values: **exp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_dscp', u'exp_dscp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_dscp.exp', u'exp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_dscp', u'exp_dscp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_dscp.exp', u'exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_dscp', u'exp_dscp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_dscp.exp', u'exp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_dscp.exp.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_dscp.exp.to', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_dscp.exp.to', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'exp_dscp_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}, {'keyval': 'exp_dscp_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}, {'keyval': 'exp_dscp_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, exp_dscp=exp_dscp, exp=exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, exp_dscp=exp_dscp, exp=exp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_exp_traffic_class_get(self, exp_traffic_class=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type exp_traffic_class: exp_traffic_class_map_name
    :param exp_traffic_class: Keyword argument tuple.

    :type exp_traffic_class_map_name: unicode
    :param exp_traffic_class_map_name: **exp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_traffic_class', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_traffic_class', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_traffic_class', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_traffic_class', u'exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_traffic_class', u'exp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_traffic_class', u'exp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'exp_traffic_class', 'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'exp_in_values'}, {'leafval': 'exp_in_values'}, {'leafval': 'exp_in_values'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, exp_traffic_class=exp_traffic_class)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, exp_traffic_class=exp_traffic_class)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_exp_traffic_class_exp_get(self, exp_traffic_class=None, exp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type exp_traffic_class: exp_traffic_class_map_name
    :param exp_traffic_class: Keyword argument tuple.

    :type exp_traffic_class_map_name: unicode
    :param exp_traffic_class_map_name: **exp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type exp: exp_in_values
    :param exp: Keyword argument tuple.

    :type exp_in_values: long
    :param exp_in_values: **exp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_traffic_class', u'exp_traffic_class'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_traffic_class', u'exp_traffic_class'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_traffic_class', u'exp_traffic_class')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_traffic_class.exp', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_traffic_class.exp', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_traffic_class.exp', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_traffic_class.exp', u'to'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_traffic_class.exp', u'to'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_traffic_class.exp', u'to')]
    compositions_keyval_list = [{'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'exp', 'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}
    composed_child_leafval_list = [{'leafval': 'priority, drop_precedence'}, {'leafval': 'priority, drop_precedence'}, {'leafval': 'priority, drop_precedence'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, exp_traffic_class=exp_traffic_class, exp=exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, exp_traffic_class=exp_traffic_class, exp=exp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_exp_traffic_class_exp_to_get(self, exp_traffic_class=None, exp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type exp_traffic_class: exp_traffic_class_map_name
    :param exp_traffic_class: Keyword argument tuple.

    :type exp_traffic_class_map_name: unicode
    :param exp_traffic_class_map_name: **exp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type exp: exp_in_values
    :param exp: Keyword argument tuple.

    :type exp_in_values: long
    :param exp_in_values: **exp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_traffic_class', u'exp_traffic_class'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_traffic_class.exp', u'exp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_traffic_class', u'exp_traffic_class'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_traffic_class.exp', u'exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_traffic_class', u'exp_traffic_class'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_traffic_class.exp', u'exp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_traffic_class.exp.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_traffic_class.exp.to', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_traffic_class.exp.to', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}, {'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}, {'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'priority, drop_precedence'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, exp_traffic_class=exp_traffic_class, exp=exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, exp_traffic_class=exp_traffic_class, exp=exp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_exp_traffic_class_exp_to_drop_precedence_get(self, exp_traffic_class=None, exp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type exp_traffic_class: exp_traffic_class_map_name
    :param exp_traffic_class: Keyword argument tuple.

    :type exp_traffic_class_map_name: unicode
    :param exp_traffic_class_map_name: **exp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type exp: exp_in_values
    :param exp: Keyword argument tuple.

    :type exp_in_values: long
    :param exp_in_values: **exp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_traffic_class', u'exp_traffic_class'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_traffic_class.exp', u'exp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_traffic_class', u'exp_traffic_class'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_traffic_class.exp', u'exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_traffic_class', u'exp_traffic_class'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_traffic_class.exp', u'exp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_traffic_class.exp.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_traffic_class.exp.to', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_traffic_class.exp.to', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}, {'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}, {'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, exp_traffic_class=exp_traffic_class, exp=exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, exp_traffic_class=exp_traffic_class, exp=exp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_exp_traffic_class_exp_to_traffic_class_get(self, exp_traffic_class=None, exp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type exp_traffic_class: exp_traffic_class_map_name
    :param exp_traffic_class: Keyword argument tuple.

    :type exp_traffic_class_map_name: unicode
    :param exp_traffic_class_map_name: **exp_traffic_class** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type exp: exp_in_values
    :param exp: Keyword argument tuple.

    :type exp_in_values: long
    :param exp_in_values: **exp** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_traffic_class', u'exp_traffic_class'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_traffic_class.exp', u'exp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_traffic_class', u'exp_traffic_class'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_traffic_class.exp', u'exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_traffic_class', u'exp_traffic_class'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_traffic_class.exp', u'exp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.exp_traffic_class.exp.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.exp_traffic_class.exp.to', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.exp_traffic_class.exp.to', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}, {'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}, {'keyval': 'exp_traffic_class_map_name', 'extra_keyval': ''}, {'keyval': 'exp_in_values', 'extra_keyval': 'exp_in_values'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, exp_traffic_class=exp_traffic_class, exp=exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, exp_traffic_class=exp_traffic_class, exp=exp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_inexp_outexp_get(self, inexp_outexp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type inexp_outexp: inexp_outexp_map_name
    :param inexp_outexp: Keyword argument tuple.

    :type inexp_outexp_map_name: unicode
    :param inexp_outexp_map_name: **inexp_outexp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.inexp_outexp', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.inexp_outexp', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.inexp_outexp', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.inexp_outexp', u'in_exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.inexp_outexp', u'in_exp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.inexp_outexp', u'in_exp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'inexp_outexp', 'keyval': 'inexp_outexp_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'in_exp_in_values'}, {'leafval': 'in_exp_in_values'}, {'leafval': 'in_exp_in_values'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inexp_outexp=inexp_outexp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inexp_outexp=inexp_outexp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_inexp_outexp_in_exp_get(self, inexp_outexp=None, in_exp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type inexp_outexp: inexp_outexp_map_name
    :param inexp_outexp: Keyword argument tuple.

    :type inexp_outexp_map_name: unicode
    :param inexp_outexp_map_name: **inexp_outexp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type in_exp: in_exp_in_values
    :param in_exp: Keyword argument tuple.

    :type in_exp_in_values: long
    :param in_exp_in_values: **in_exp** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.qos_mpls.map_.inexp_outexp', u'inexp_outexp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.inexp_outexp', u'inexp_outexp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.inexp_outexp', u'inexp_outexp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.inexp_outexp.in_exp', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.inexp_outexp.in_exp', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.inexp_outexp.in_exp', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.qos_mpls.map_.inexp_outexp.in_exp', u'to'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.inexp_outexp.in_exp', u'to'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.inexp_outexp.in_exp', u'to')]
    compositions_keyval_list = [{'keyval': 'inexp_outexp_map_name', 'extra_keyval': ''}, {'keyval': 'inexp_outexp_map_name', 'extra_keyval': ''}, {'keyval': 'inexp_outexp_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'in_exp', 'keyval': 'in_exp_in_values', 'extra_keyval': 'in_exp_in_values'}
    composed_child_leafval_list = [{'leafval': 'out_exp'}, {'leafval': 'out_exp'}, {'leafval': 'out_exp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inexp_outexp=inexp_outexp, in_exp=in_exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inexp_outexp=inexp_outexp, in_exp=in_exp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_inexp_outexp_in_exp_to_get(self, inexp_outexp=None, in_exp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type inexp_outexp: inexp_outexp_map_name
    :param inexp_outexp: Keyword argument tuple.

    :type inexp_outexp_map_name: unicode
    :param inexp_outexp_map_name: **inexp_outexp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type in_exp: in_exp_in_values
    :param in_exp: Keyword argument tuple.

    :type in_exp_in_values: long
    :param in_exp_in_values: **in_exp** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.inexp_outexp', u'inexp_outexp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.inexp_outexp.in_exp', u'in_exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.inexp_outexp', u'inexp_outexp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.inexp_outexp.in_exp', u'in_exp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.inexp_outexp', u'inexp_outexp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.inexp_outexp.in_exp', u'in_exp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.inexp_outexp.in_exp.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.inexp_outexp.in_exp.to', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.inexp_outexp.in_exp.to', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'inexp_outexp_map_name', 'extra_keyval': ''}, {'keyval': 'in_exp_in_values', 'extra_keyval': 'in_exp_in_values'}, {'keyval': 'inexp_outexp_map_name', 'extra_keyval': ''}, {'keyval': 'in_exp_in_values', 'extra_keyval': 'in_exp_in_values'}, {'keyval': 'inexp_outexp_map_name', 'extra_keyval': ''}, {'keyval': 'in_exp_in_values', 'extra_keyval': 'in_exp_in_values'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inexp_outexp=inexp_outexp, in_exp=in_exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inexp_outexp=inexp_outexp, in_exp=in_exp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_inexp_outexp_in_exp_to_out_exp_get(self, inexp_outexp=None, in_exp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type inexp_outexp: inexp_outexp_map_name
    :param inexp_outexp: Keyword argument tuple.

    :type inexp_outexp_map_name: unicode
    :param inexp_outexp_map_name: **inexp_outexp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type in_exp: in_exp_in_values
    :param in_exp: Keyword argument tuple.

    :type in_exp_in_values: long
    :param in_exp_in_values: **in_exp** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.inexp_outexp', u'inexp_outexp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.inexp_outexp.in_exp', u'in_exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.inexp_outexp', u'inexp_outexp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.inexp_outexp.in_exp', u'in_exp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.inexp_outexp', u'inexp_outexp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.inexp_outexp.in_exp', u'in_exp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.inexp_outexp.in_exp.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.inexp_outexp.in_exp.to', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.inexp_outexp.in_exp.to', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'inexp_outexp_map_name', 'extra_keyval': ''}, {'keyval': 'in_exp_in_values', 'extra_keyval': 'in_exp_in_values'}, {'keyval': 'inexp_outexp_map_name', 'extra_keyval': ''}, {'keyval': 'in_exp_in_values', 'extra_keyval': 'in_exp_in_values'}, {'keyval': 'inexp_outexp_map_name', 'extra_keyval': ''}, {'keyval': 'in_exp_in_values', 'extra_keyval': 'in_exp_in_values'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, inexp_outexp=inexp_outexp, in_exp=in_exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, inexp_outexp=inexp_outexp, in_exp=in_exp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_traffic_class_exp_get(self, traffic_class_exp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type traffic_class_exp: traffic_class_exp_map_name
    :param traffic_class_exp: Keyword argument tuple.

    :type traffic_class_exp_map_name: unicode
    :param traffic_class_exp_map_name: **traffic_class_exp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.traffic_class_exp', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.traffic_class_exp', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.traffic_class_exp', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.qos_mpls.map_.traffic_class_exp', u'priority'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.traffic_class_exp', u'priority'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.traffic_class_exp', u'priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'traffic_class_exp', 'keyval': 'traffic_class_exp_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'priority_in_values, drop_precedence'}, {'leafval': 'priority_in_values, drop_precedence'}, {'leafval': 'priority_in_values, drop_precedence, to, exp'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_exp=traffic_class_exp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_exp=traffic_class_exp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_traffic_class_exp_traffic_class_get(self, traffic_class_exp=None, priority=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_exp: traffic_class_exp_map_name
    :param traffic_class_exp: Keyword argument tuple.

    :type traffic_class_exp_map_name: unicode
    :param traffic_class_exp_map_name: **traffic_class_exp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type priority: priority_in_values, drop_precedence
    :param priority: Keyword argument tuple.

    :type priority_in_values: long
    :param priority_in_values: **priority** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type drop_precedence: long
    :param drop_precedence: **priority** tuple argument:  drop-precedence value 0-3

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.traffic_class_exp', u'traffic_class_exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.traffic_class_exp', u'traffic_class_exp'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.traffic_class_exp', u'traffic_class_exp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.traffic_class_exp.priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.traffic_class_exp.priority', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos_mpls.map_.traffic_class_exp.priority', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.traffic_class_exp.priority', u'to'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.traffic_class_exp.priority', u'to')]
    compositions_keyval_list = [{'keyval': 'traffic_class_exp_map_name', 'extra_keyval': ''}, {'keyval': 'traffic_class_exp_map_name', 'extra_keyval': ''}, {'keyval': 'traffic_class_exp_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'priority', 'keyval': 'priority_in_values', 'extra_keyval': 'priority_in_values, drop_precedence, to, exp'}
    composed_child_leafval_list = [{'leafval': 'exp'}, {'leafval': 'exp'}]
    leafval_map = {"pybind.slxos.v17s_1_02.qos_mpls.map_.traffic_class_exp.priority": {}, "pybind.slxos.v17r_1_01a.qos_mpls.map_.traffic_class_exp.priority": {"priority_in_values": "priority_in_values", "drop_precedence": "drop_precedence"}, "pybind.slxos.v17r_2_00.qos_mpls.map_.traffic_class_exp.priority": {"priority_in_values": "priority_in_values", "drop_precedence": "drop_precedence"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_exp=traffic_class_exp, priority=priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_exp=traffic_class_exp, priority=priority)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_traffic_class_exp_traffic_class_drop_precedence_get(self, traffic_class_exp=None, priority=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_exp: traffic_class_exp_map_name
    :param traffic_class_exp: Keyword argument tuple.

    :type traffic_class_exp_map_name: unicode
    :param traffic_class_exp_map_name: **traffic_class_exp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type priority: priority_in_values
    :param priority: Keyword argument tuple.

    :type priority_in_values: long
    :param priority_in_values: **priority** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.traffic_class_exp', u'traffic_class_exp')]
    bindings_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.traffic_class_exp.priority', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'traffic_class_exp_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'priority', 'keyval': 'priority_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_exp=traffic_class_exp, priority=priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_exp=traffic_class_exp, priority=priority)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_traffic_class_exp_traffic_class_exp_get(self, traffic_class_exp=None, priority=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_exp: traffic_class_exp_map_name
    :param traffic_class_exp: Keyword argument tuple.

    :type traffic_class_exp_map_name: unicode
    :param traffic_class_exp_map_name: **traffic_class_exp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type priority: priority_in_values
    :param priority: Keyword argument tuple.

    :type priority_in_values: long
    :param priority_in_values: **priority** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.traffic_class_exp', u'traffic_class_exp')]
    bindings_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.traffic_class_exp.priority', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'traffic_class_exp_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'priority', 'keyval': 'priority_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_exp=traffic_class_exp, priority=priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_exp=traffic_class_exp, priority=priority)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_traffic_class_exp_traffic_class_to_get(self, traffic_class_exp=None, priority=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_exp: traffic_class_exp_map_name
    :param traffic_class_exp: Keyword argument tuple.

    :type traffic_class_exp_map_name: unicode
    :param traffic_class_exp_map_name: **traffic_class_exp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type priority: priority_in_values
    :param priority: Keyword argument tuple.

    :type priority_in_values: long
    :param priority_in_values: **priority** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.traffic_class_exp', u'traffic_class_exp')]
    bindings_list = [('pybind.slxos.v17s_1_02.qos_mpls.map_.traffic_class_exp.priority', 'pybind.slxos.v17s_1_02.brocade_qos_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'traffic_class_exp_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'priority', 'keyval': 'priority_in_values', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_exp=traffic_class_exp, priority=priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_exp=traffic_class_exp, priority=priority)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_map_traffic_class_exp_traffic_class_to_exp_get(self, traffic_class_exp=None, priority=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type traffic_class_exp: traffic_class_exp_map_name
    :param traffic_class_exp: Keyword argument tuple.

    :type traffic_class_exp_map_name: unicode
    :param traffic_class_exp_map_name: **traffic_class_exp** tuple argument:  Name for the MAP(Max 64)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type priority: priority_in_values, drop_precedence
    :param priority: Keyword argument tuple.

    :type priority_in_values: long
    :param priority_in_values: **priority** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type drop_precedence: long
    :param drop_precedence: **priority** tuple argument:  drop-precedence value 0-3

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.traffic_class_exp', u'traffic_class_exp'), ('pybind.slxos.v17r_1_01a.qos_mpls.map_.traffic_class_exp.priority', u'priority'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.traffic_class_exp', u'traffic_class_exp'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.traffic_class_exp.priority', u'priority')]
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls.map_.traffic_class_exp.priority.to', 'pybind.slxos.v17r_1_01a.brocade_qos_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls.map_.traffic_class_exp.priority.to', 'pybind.slxos.v17r_2_00.brocade_qos_mpls', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'traffic_class_exp_map_name', 'extra_keyval': ''}, {'keyval': 'priority_in_values, drop_precedence', 'extra_keyval': 'priority_in_values, drop_precedence'}, {'keyval': 'traffic_class_exp_map_name', 'extra_keyval': ''}, {'keyval': 'priority_in_values, drop_precedence', 'extra_keyval': 'priority_in_values, drop_precedence'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, traffic_class_exp=traffic_class_exp, priority=priority)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, traffic_class_exp=traffic_class_exp, priority=priority)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_state_get(self, qos_mpls_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls_state: map_type
    :param qos_mpls_state: Keyword argument tuple.

    :type map_type: unicode
    :param map_type: **qos_mpls_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls_state', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls_state', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'qos_mpls_state', 'keyval': 'map_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls_state=qos_mpls_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls_state=qos_mpls_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_state_enabled_slots_get(self, qos_mpls_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls_state: map_type
    :param qos_mpls_state: Keyword argument tuple.

    :type map_type: unicode
    :param map_type: **qos_mpls_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls_state', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls_state', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'qos_mpls_state', 'keyval': 'map_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls_state=qos_mpls_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls_state=qos_mpls_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_mpls_state_map_name_get(self, qos_mpls_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls_state: map_type
    :param qos_mpls_state: Keyword argument tuple.

    :type map_type: unicode
    :param map_type: **qos_mpls_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos_mpls_state', 'pybind.slxos.v17r_1_01a.brocade_qos_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos_mpls_state', 'pybind.slxos.v17r_2_00.brocade_qos_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'qos_mpls_state', 'keyval': 'map_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls_state=qos_mpls_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls_state=qos_mpls_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_qos_cpu_queue_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.qos.qos_cpu_queue', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos.qos_cpu_queue.cpu', u'queue')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'id, rate_limit'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.qos.queue.multicast.scheduler', u'dwrr'), ('pybind.nos.v7_2_0.qos.queue.scheduler', u'strict_priority'), ('pybind.nos.v6_0_2f.qos.queue.scheduler', u'strict_priority'), ('pybind.nos.v6_0_2f.qos.queue.multicast.scheduler', u'dwrr')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class7'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}, {'leafval': 'dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class7'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_multicast_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.multicast', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.multicast', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.qos.queue.multicast.scheduler', u'dwrr'), ('pybind.nos.v7_2_0.qos.queue.multicast.scheduler', u'dwrr')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class7'}, {'leafval': 'dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class7'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_multicast_scheduler_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.multicast.scheduler', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.multicast.scheduler', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.qos.queue.multicast.scheduler', u'dwrr'), ('pybind.nos.v7_2_0.qos.queue.multicast.scheduler', u'dwrr')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class7'}, {'leafval': 'dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class7'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class7'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_dwrr_traffic_class0_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_dwrr_traffic_class1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_dwrr_traffic_class2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_dwrr_traffic_class3_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_dwrr_traffic_class4_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_dwrr_traffic_class5_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_dwrr_traffic_class6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_multicast_scheduler_dwrr_dwrr_traffic_class7_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.multicast.scheduler.dwrr', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_scheduler_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.scheduler', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.scheduler', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.qos.queue.multicast.scheduler', u'dwrr'), ('pybind.nos.v7_2_0.qos.queue.scheduler', u'strict_priority'), ('pybind.nos.v6_0_2f.qos.queue.scheduler', u'strict_priority'), ('pybind.nos.v6_0_2f.qos.queue.multicast.scheduler', u'dwrr')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class7'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}, {'leafval': 'dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class7'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_dwrr_traffic_class0_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_dwrr_traffic_class1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_dwrr_traffic_class2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_dwrr_traffic_class3_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_dwrr_traffic_class4_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_dwrr_traffic_class5_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_dwrr_traffic_class6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_dwrr_traffic_class_last_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_priority_number_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_queue_scheduler_strict_priority_scheduler_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.queue.scheduler.strict_priority', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.queue.scheduler.strict_priority', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_rcv_queue_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.rcv_queue', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.rcv_queue', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.qos.rcv_queue.multicast', u'threshold'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast', u'rate_limit'), ('pybind.nos.v6_0_2f.qos.rcv_queue.multicast', u'threshold'), ('pybind.nos.v6_0_2f.qos.rcv_queue.multicast', u'rate_limit')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'traffic_class0, traffic_class1, traffic_class2, traffic_class3, traffic_class4, traffic_class5, traffic_class6, traffic_class7'}, {'leafval': 'limit, burst'}, {'leafval': 'traffic_class0, traffic_class1, traffic_class2, traffic_class3, traffic_class4, traffic_class5, traffic_class6, traffic_class7'}, {'leafval': 'limit, burst'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_rcv_queue_multicast_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.rcv_queue.multicast', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.qos.rcv_queue.multicast', u'threshold'), ('pybind.nos.v6_0_2f.qos.rcv_queue.multicast', u'rate_limit'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast', u'threshold'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast', u'rate_limit')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'traffic_class0, traffic_class1, traffic_class2, traffic_class3, traffic_class4, traffic_class5, traffic_class6, traffic_class7'}, {'leafval': 'limit, burst'}, {'leafval': 'traffic_class0, traffic_class1, traffic_class2, traffic_class3, traffic_class4, traffic_class5, traffic_class6, traffic_class7'}, {'leafval': 'limit, burst'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_rcv_queue_multicast_rate_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.rcv_queue.multicast.rate_limit', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast.rate_limit', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'limit, burst'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_rcv_queue_multicast_rate_limit_burst_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.rcv_queue.multicast.rate_limit', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast.rate_limit', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_rcv_queue_multicast_rate_limit_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.rcv_queue.multicast.rate_limit', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast.rate_limit', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'traffic_class0, traffic_class1, traffic_class2, traffic_class3, traffic_class4, traffic_class5, traffic_class6, traffic_class7'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_traffic_class0_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_traffic_class1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_traffic_class2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_traffic_class3_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_traffic_class4_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_traffic_class5_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_traffic_class6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_rcv_queue_multicast_threshold_traffic_class7_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.rcv_queue.multicast.threshold', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.rcv_queue.multicast.threshold', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_red_profile_get(self, red_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type red_profile: profile_id, min_threshold, max_threshold, drop_probability
    :param red_profile: Keyword argument tuple.

    :type profile_id: long
    :param profile_id: **red_profile** tuple argument:  0-383;;Profile Id

        * range restriction: ::

            ['-2147483648..2147483647']

    :type min_threshold: long
    :param min_threshold: **red_profile** tuple argument:  Minimum Threshold in Percentage

        * range restriction: ::

            ['-2147483648..2147483647']

    :type max_threshold: long
    :param max_threshold: **red_profile** tuple argument:  Maximum Threshold in Percentage

        * range restriction: ::

            ['-2147483648..2147483647']

    :type drop_probability: long
    :param drop_probability: **red_profile** tuple argument:  Drop Probability in Percentage

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.red_profile', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.red_profile', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.qos.red_profile', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.red_profile', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.red_profile', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.qos.ecn.red_profile', u'red_profile_ecn')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'red_profile', 'keyval': 'profile_id', 'extra_keyval': 'profile_id, min_threshold, max_threshold, drop_probability'}
    composed_child_leafval_list = [{'leafval': 'min_threshold, max_threshold, drop_probability'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, red_profile=red_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, red_profile=red_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_red_profile_drop_probability_get(self, red_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type red_profile: profile_id
    :param red_profile: Keyword argument tuple.

    :type profile_id: long
    :param profile_id: **red_profile** tuple argument:  0-383;;Profile Id

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.red_profile', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.red_profile', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.qos.red_profile', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.red_profile', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.red_profile', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.qos.ecn.red_profile', u'red_profile_ecn')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'red_profile', 'keyval': 'profile_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'min_threshold, max_threshold, drop_probability'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, red_profile=red_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, red_profile=red_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_red_profile_ecn_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.qos.ecn.red_profile.red_profile_ecn', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_red_profile_ecn_drop_probability_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.qos.ecn.red_profile.red_profile_ecn', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_red_profile_ecn_max_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.qos.ecn.red_profile.red_profile_ecn', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_red_profile_ecn_min_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.qos.ecn.red_profile.red_profile_ecn', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_red_profile_max_threshold_get(self, red_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type red_profile: profile_id
    :param red_profile: Keyword argument tuple.

    :type profile_id: long
    :param profile_id: **red_profile** tuple argument:  0-383;;Profile Id

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.red_profile', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.red_profile', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.qos.red_profile', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.red_profile', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.red_profile', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.qos.ecn.red_profile', u'red_profile_ecn')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'red_profile', 'keyval': 'profile_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'min_threshold, max_threshold, drop_probability'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, red_profile=red_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, red_profile=red_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_red_profile_min_threshold_get(self, red_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type red_profile: profile_id
    :param red_profile: Keyword argument tuple.

    :type profile_id: long
    :param profile_id: **red_profile** tuple argument:  0-383;;Profile Id

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.qos.red_profile', 'pybind.nos.v6_0_2f.brocade_qos', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.qos.red_profile', 'pybind.nos.v7_2_0.brocade_qos', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.qos.red_profile', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.red_profile', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.red_profile', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.qos.ecn.red_profile', u'red_profile_ecn')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'red_profile', 'keyval': 'profile_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'min_threshold, max_threshold, drop_probability'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, red_profile=red_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, red_profile=red_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_rx_queue_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.rx_queue', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.rx_queue', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.rx_queue', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_rx_queue_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.rx_queue', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.rx_queue', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.rx_queue', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_service_policy_get(self, service_policy=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type service_policy: direction, policy_map_name
    :param service_policy: Keyword argument tuple.

    :type direction: unicode
    :param direction: **service_policy** tuple argument.

        * enumeration restriction: ::

            ['in']

    :type policy_map_name: unicode
    :param policy_map_name: **service_policy** tuple argument:  MAP_NAME;;Qos Policy map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_qos.qos.service_policy', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_qos.qos.service_policy', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_qos.qos.service_policy', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_qos.qos.service_policy', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_qos.qos.service_policy', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.system_qos.qos.service_policy.attach.rbridge_id', u'remove'), ('pybind.nos.v6_0_2f.system_qos.qos.service_policy.attach.rbridge_id', u'add'), ('pybind.nos.v7_2_0.system_qos.qos.service_policy.attach.rbridge_id', u'remove'), ('pybind.nos.v7_2_0.system_qos.qos.service_policy.attach.rbridge_id', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'service_policy', 'keyval': 'direction, policy_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rb_remove_range'}, {'leafval': 'rb_add_range'}, {'leafval': 'rb_remove_range'}, {'leafval': 'rb_add_range'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, service_policy=service_policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, service_policy=service_policy)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_service_policy_attach_get(self, service_policy=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type service_policy: direction, policy_map_name
    :param service_policy: Keyword argument tuple.

    :type direction: unicode
    :param direction: **service_policy** tuple argument.

        * enumeration restriction: ::

            ['in']

    :type policy_map_name: unicode
    :param policy_map_name: **service_policy** tuple argument:  MAP_NAME;;Qos Policy map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v7_2_0.system_qos.qos.service_policy', u'service_policy')]
    bindings_list = [('pybind.nos.v6_0_2f.system_qos.qos.service_policy.attach', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_qos.qos.service_policy.attach', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, service_policy=service_policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, service_policy=service_policy)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_service_policy_attach_rbridge_id_get(self, service_policy=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type service_policy: direction, policy_map_name
    :param service_policy: Keyword argument tuple.

    :type direction: unicode
    :param direction: **service_policy** tuple argument.

        * enumeration restriction: ::

            ['in']

    :type policy_map_name: unicode
    :param policy_map_name: **service_policy** tuple argument:  MAP_NAME;;Qos Policy map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v7_2_0.system_qos.qos.service_policy', u'service_policy')]
    bindings_list = [('pybind.nos.v6_0_2f.system_qos.qos.service_policy.attach.rbridge_id', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_qos.qos.service_policy.attach.rbridge_id', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, service_policy=service_policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, service_policy=service_policy)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_service_policy_attach_rbridge_id_add_get(self, service_policy=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type service_policy: direction, policy_map_name
    :param service_policy: Keyword argument tuple.

    :type direction: unicode
    :param direction: **service_policy** tuple argument.

        * enumeration restriction: ::

            ['in']

    :type policy_map_name: unicode
    :param policy_map_name: **service_policy** tuple argument:  MAP_NAME;;Qos Policy map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v7_2_0.system_qos.qos.service_policy', u'service_policy')]
    bindings_list = [('pybind.nos.v6_0_2f.system_qos.qos.service_policy.attach.rbridge_id.add_', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_qos.qos.service_policy.attach.rbridge_id.add_', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, service_policy=service_policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, service_policy=service_policy)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_service_policy_attach_rbridge_id_add_rb_add_range_get(self, service_policy=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type service_policy: direction, policy_map_name
    :param service_policy: Keyword argument tuple.

    :type direction: unicode
    :param direction: **service_policy** tuple argument.

        * enumeration restriction: ::

            ['in']

    :type policy_map_name: unicode
    :param policy_map_name: **service_policy** tuple argument:  MAP_NAME;;Qos Policy map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v7_2_0.system_qos.qos.service_policy', u'service_policy')]
    bindings_list = [('pybind.nos.v6_0_2f.system_qos.qos.service_policy.attach.rbridge_id.add_', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_qos.qos.service_policy.attach.rbridge_id.add_', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, service_policy=service_policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, service_policy=service_policy)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_service_policy_attach_rbridge_id_remove_get(self, service_policy=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type service_policy: direction, policy_map_name
    :param service_policy: Keyword argument tuple.

    :type direction: unicode
    :param direction: **service_policy** tuple argument.

        * enumeration restriction: ::

            ['in']

    :type policy_map_name: unicode
    :param policy_map_name: **service_policy** tuple argument:  MAP_NAME;;Qos Policy map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v7_2_0.system_qos.qos.service_policy', u'service_policy')]
    bindings_list = [('pybind.nos.v6_0_2f.system_qos.qos.service_policy.attach.rbridge_id.remove_', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_qos.qos.service_policy.attach.rbridge_id.remove_', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, service_policy=service_policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, service_policy=service_policy)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_service_policy_attach_rbridge_id_remove_rb_remove_range_get(self, service_policy=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type service_policy: direction, policy_map_name
    :param service_policy: Keyword argument tuple.

    :type direction: unicode
    :param direction: **service_policy** tuple argument.

        * enumeration restriction: ::

            ['in']

    :type policy_map_name: unicode
    :param policy_map_name: **service_policy** tuple argument:  MAP_NAME;;Qos Policy map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.system_qos.qos.service_policy', u'service_policy'), ('pybind.nos.v7_2_0.system_qos.qos.service_policy', u'service_policy')]
    bindings_list = [('pybind.nos.v6_0_2f.system_qos.qos.service_policy.attach.rbridge_id.remove_', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_qos.qos.service_policy.attach.rbridge_id.remove_', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'direction, policy_map_name', 'extra_keyval': ''}, {'keyval': 'direction, policy_map_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, service_policy=service_policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, service_policy=service_policy)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_system_qos_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_qos.qos', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_qos.qos', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_qos.qos', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_qos.qos', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_qos.qos', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.system_qos.qos', u'service_policy'), ('pybind.nos.v7_2_0.system_qos.qos', u'service_policy'), ('pybind.slxos.v17r_1_01a.system_qos.qos', u'service_policy'), ('pybind.slxos.v17r_2_00.system_qos.qos', u'service_policy'), ('pybind.nos.v6_0_2f.system_qos.qos', u'service_policy')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'direction, policy_map_name'}, {'leafval': 'direction, policy_map_name'}, {'leafval': 'direction, policy_map_name'}, {'leafval': 'direction, policy_map_name'}, {'leafval': 'direction, policy_map_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_tx_queue_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.tx_queue', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.tx_queue', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.tx_queue', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.qos.tx_queue.scheduler', u'strict_priority'), ('pybind.slxos.v17s_1_02.qos.tx_queue.scheduler', u'strict_priority'), ('pybind.slxos.v17r_1_01a.qos.tx_queue.scheduler', u'strict_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_tx_queue_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.tx_queue', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.tx_queue', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.tx_queue', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.qos.tx_queue.scheduler', u'strict_priority'), ('pybind.slxos.v17s_1_02.qos.tx_queue.scheduler', u'strict_priority'), ('pybind.slxos.v17r_1_01a.qos.tx_queue.scheduler', u'strict_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_tx_queue_scheduler_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.tx_queue.scheduler', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.tx_queue.scheduler', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.tx_queue.scheduler', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.qos.tx_queue.scheduler', u'strict_priority'), ('pybind.slxos.v17r_2_00.qos.tx_queue.scheduler', u'strict_priority'), ('pybind.slxos.v17r_1_01a.qos.tx_queue.scheduler', u'strict_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}, {'leafval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'priority_number, scheduler_type, dwrr_traffic_class0, dwrr_traffic_class1, dwrr_traffic_class2, dwrr_traffic_class3, dwrr_traffic_class4, dwrr_traffic_class5, dwrr_traffic_class6, dwrr_traffic_class_last'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_dwrr_traffic_class0_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_dwrr_traffic_class1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_dwrr_traffic_class2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_dwrr_traffic_class3_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_dwrr_traffic_class4_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_dwrr_traffic_class5_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_dwrr_traffic_class6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_dwrr_traffic_class_last_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_priority_number_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def qos_tx_queue_scheduler_strict_priority_scheduler_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_1_01a.brocade_qos_mls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17r_2_00.brocade_qos_mls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.qos.tx_queue.scheduler.strict_priority', 'pybind.slxos.v17s_1_02.brocade_qos_mls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def queues_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.queues_state', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.queues_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.queues_state', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.queues_state', u'queue_interface_list'), ('pybind.slxos.v17r_1_01a.queues_state', u'queue_interface_list'), ('pybind.slxos.v17s_1_02.queues_state', u'queue_interface_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_value'}, {'leafval': 'interface_value'}, {'leafval': 'interface_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def queues_state_queue_interface_list_get(self, queue_interface_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type queue_interface_list: interface_value
    :param queue_interface_list: Keyword argument tuple.

    :type interface_value: unicode
    :param interface_value: **queue_interface_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.queues_state.queue_interface_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.queues_state.queue_interface_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.queues_state.queue_interface_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.queues_state.queue_interface_list', u'queue_info_list'), ('pybind.slxos.v17r_1_01a.queues_state.queue_interface_list', u'queue_info_list'), ('pybind.slxos.v17r_2_00.queues_state.queue_interface_list', u'queue_info_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue_interface_list', 'keyval': 'interface_value', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface, num, tx_packets, tx_bytes'}, {'leafval': 'interface, num, tx_packets, tx_bytes'}, {'leafval': 'interface, num, tx_packets, tx_bytes'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue_interface_list=queue_interface_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue_interface_list=queue_interface_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def queues_state_queue_interface_list_queue_info_list_get(self, queue_interface_list=None, queue_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type queue_interface_list: interface_value
    :param queue_interface_list: Keyword argument tuple.

    :type interface_value: unicode
    :param interface_value: **queue_interface_list** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type queue_info_list: interface, num
    :param queue_info_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **queue_info_list** tuple argument.

    :type num: long
    :param num: **queue_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.queues_state.queue_interface_list', u'queue_interface_list'), ('pybind.slxos.v17r_1_01a.queues_state.queue_interface_list', u'queue_interface_list'), ('pybind.slxos.v17r_2_00.queues_state.queue_interface_list', u'queue_interface_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.queues_state.queue_interface_list.queue_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.queues_state.queue_interface_list.queue_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.queues_state.queue_interface_list.queue_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_value', 'extra_keyval': ''}, {'keyval': 'interface_value', 'extra_keyval': ''}, {'keyval': 'interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_info_list', 'keyval': 'interface, num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue_interface_list=queue_interface_list, queue_info_list=queue_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue_interface_list=queue_interface_list, queue_info_list=queue_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def queues_state_queue_interface_list_queue_info_list_tx_bytes_get(self, queue_interface_list=None, queue_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type queue_interface_list: interface_value
    :param queue_interface_list: Keyword argument tuple.

    :type interface_value: unicode
    :param interface_value: **queue_interface_list** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type queue_info_list: interface, num
    :param queue_info_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **queue_info_list** tuple argument.

    :type num: long
    :param num: **queue_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.queues_state.queue_interface_list', u'queue_interface_list'), ('pybind.slxos.v17r_1_01a.queues_state.queue_interface_list', u'queue_interface_list'), ('pybind.slxos.v17r_2_00.queues_state.queue_interface_list', u'queue_interface_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.queues_state.queue_interface_list.queue_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.queues_state.queue_interface_list.queue_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.queues_state.queue_interface_list.queue_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_value', 'extra_keyval': ''}, {'keyval': 'interface_value', 'extra_keyval': ''}, {'keyval': 'interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_info_list', 'keyval': 'interface, num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue_interface_list=queue_interface_list, queue_info_list=queue_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue_interface_list=queue_interface_list, queue_info_list=queue_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def queues_state_queue_interface_list_queue_info_list_tx_packets_get(self, queue_interface_list=None, queue_info_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type queue_interface_list: interface_value
    :param queue_interface_list: Keyword argument tuple.

    :type interface_value: unicode
    :param interface_value: **queue_interface_list** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type queue_info_list: interface, num
    :param queue_info_list: Keyword argument tuple.

    :type interface: unicode
    :param interface: **queue_info_list** tuple argument.

    :type num: long
    :param num: **queue_info_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.queues_state.queue_interface_list', u'queue_interface_list'), ('pybind.slxos.v17r_1_01a.queues_state.queue_interface_list', u'queue_interface_list'), ('pybind.slxos.v17r_2_00.queues_state.queue_interface_list', u'queue_interface_list')]
    bindings_list = [('pybind.slxos.v17r_1_01a.queues_state.queue_interface_list.queue_info_list', 'pybind.slxos.v17r_1_01a.brocade_openflow_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.queues_state.queue_interface_list.queue_info_list', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.queues_state.queue_interface_list.queue_info_list', 'pybind.slxos.v17s_1_02.brocade_openflow_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_value', 'extra_keyval': ''}, {'keyval': 'interface_value', 'extra_keyval': ''}, {'keyval': 'interface_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue_info_list', 'keyval': 'interface, num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue_interface_list=queue_interface_list, queue_info_list=queue_info_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue_interface_list=queue_interface_list, queue_info_list=queue_info_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def radius_server_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.radius_server', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.radius_server', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.radius_server', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.radius_server', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.radius_server', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.radius_server', u'host'), ('pybind.slxos.v17s_1_02.radius_server', u'host'), ('pybind.nos.v6_0_2f.radius_server', u'host'), ('pybind.slxos.v17r_2_00.radius_server', u'host'), ('pybind.nos.v7_2_0.radius_server', u'host')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hostname, use_vrf'}, {'leafval': 'hostname, use_vrf'}, {'leafval': 'hostname, auth_port, protocol, key, encryption_level, retries, timeout'}, {'leafval': 'hostname, use_vrf'}, {'leafval': 'hostname, use_vrf, auth_port, protocol, key, encryption_level, retries, timeout'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def radius_server_host_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.radius_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.radius_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.radius_server.host', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.radius_server.host', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.radius_server.host', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.radius_server.host.radius_server_options', u'source_interface'), ('pybind.slxos.v17r_2_00.radius_server.host', u'radius_server_options'), ('pybind.slxos.v17r_1_01a.radius_server.host', u'radius_server_options'), ('pybind.slxos.v17r_1_01a.radius_server.host.radius_server_options', u'source_interface'), ('pybind.slxos.v17s_1_02.radius_server.host', u'radius_server_options')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'source_interface_name, source_interface_value'}, {'leafval': 'auth_port, protocol, key, encryption_level, retries, timeout'}, {'leafval': 'auth_port, protocol, key, encryption_level, retries, timeout'}, {'leafval': 'source_interface_name, source_interface_value'}, {'leafval': 'auth_port, protocol, key, encryption_level, retries, timeout'}]
    leafval_map = {"pybind.slxos.v17r_2_00.radius_server.host": {}, "pybind.nos.v7_2_0.radius_server.host": {}, "pybind.slxos.v17r_1_01a.radius_server.host": {}, "pybind.slxos.v17s_1_02.radius_server.host": {}, "pybind.nos.v6_0_2f.radius_server.host": {"encryption_level": "encryption_level", "retries": "retries", "protocol": "protocol", "timeout": "timeout", "hostname": "hostname", "auth_port": "auth_port", "key": "key"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def radius_server_host_auth_port_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.radius_server.host', u'host'), ('pybind.slxos.v17r_2_00.radius_server.host', u'host'), ('pybind.slxos.v17r_1_01a.radius_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.radius_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.radius_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.radius_server.host.radius_server_options', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.radius_server.host.radius_server_options', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.radius_server.host.radius_server_options', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.radius_server.host.radius_server_options": {}, "pybind.slxos.v17r_1_01a.radius_server.host.radius_server_options": {}, "pybind.nos.v7_2_0.radius_server.host": {}, "pybind.slxos.v17r_2_00.radius_server.host.radius_server_options": {}, "pybind.nos.v6_0_2f.radius_server.host": {"hostname": "hostname", "auth_port": "auth_port"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def radius_server_host_encryption_level_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.radius_server.host', u'host'), ('pybind.slxos.v17r_2_00.radius_server.host', u'host'), ('pybind.slxos.v17r_1_01a.radius_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.radius_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.radius_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.radius_server.host.radius_server_options', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.radius_server.host.radius_server_options', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.radius_server.host.radius_server_options', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.radius_server.host.radius_server_options": {}, "pybind.slxos.v17r_1_01a.radius_server.host.radius_server_options": {}, "pybind.nos.v7_2_0.radius_server.host": {}, "pybind.slxos.v17r_2_00.radius_server.host.radius_server_options": {}, "pybind.nos.v6_0_2f.radius_server.host": {"encryption_level": "encryption_level", "hostname": "hostname"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def radius_server_host_key_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.radius_server.host', u'host'), ('pybind.slxos.v17r_2_00.radius_server.host', u'host'), ('pybind.slxos.v17r_1_01a.radius_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.radius_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.radius_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.radius_server.host.radius_server_options', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.radius_server.host.radius_server_options', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.radius_server.host.radius_server_options', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.radius_server.host.radius_server_options": {}, "pybind.slxos.v17r_1_01a.radius_server.host.radius_server_options": {}, "pybind.nos.v7_2_0.radius_server.host": {}, "pybind.slxos.v17r_2_00.radius_server.host.radius_server_options": {}, "pybind.nos.v6_0_2f.radius_server.host": {"hostname": "hostname", "key": "key"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def radius_server_host_protocol_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.radius_server.host', u'host'), ('pybind.slxos.v17r_2_00.radius_server.host', u'host'), ('pybind.slxos.v17r_1_01a.radius_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.radius_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.radius_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.radius_server.host.radius_server_options', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.radius_server.host.radius_server_options', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.radius_server.host.radius_server_options', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.radius_server.host.radius_server_options": {}, "pybind.slxos.v17r_1_01a.radius_server.host.radius_server_options": {}, "pybind.nos.v7_2_0.radius_server.host": {}, "pybind.slxos.v17r_2_00.radius_server.host.radius_server_options": {}, "pybind.nos.v6_0_2f.radius_server.host": {"hostname": "hostname", "protocol": "protocol"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def radius_server_host_retries_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.radius_server.host', u'host'), ('pybind.slxos.v17r_2_00.radius_server.host', u'host'), ('pybind.slxos.v17r_1_01a.radius_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.radius_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.radius_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.radius_server.host.radius_server_options', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.radius_server.host.radius_server_options', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.radius_server.host.radius_server_options', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.radius_server.host.radius_server_options": {}, "pybind.slxos.v17r_1_01a.radius_server.host.radius_server_options": {}, "pybind.nos.v7_2_0.radius_server.host": {}, "pybind.slxos.v17r_2_00.radius_server.host.radius_server_options": {}, "pybind.nos.v6_0_2f.radius_server.host": {"retries": "retries", "hostname": "hostname"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def radius_server_host_source_interface_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type host: hostname, use_vrf
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address ofthis RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type use_vrf: unicode
    :param use_vrf: **host** tuple argument:  VRF to choose for server connection(Default=mgmt-vrf)

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.radius_server.host', u'host'), ('pybind.slxos.v17r_2_00.radius_server.host', u'host')]
    bindings_list = [('pybind.slxos.v17r_1_01a.radius_server.host.radius_server_options.source_interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.radius_server.host.radius_server_options.source_interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def radius_server_host_source_interface_source_interface_name_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type host: hostname, use_vrf
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address ofthis RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type use_vrf: unicode
    :param use_vrf: **host** tuple argument:  VRF to choose for server connection(Default=mgmt-vrf)

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.radius_server.host', u'host'), ('pybind.slxos.v17r_2_00.radius_server.host', u'host')]
    bindings_list = [('pybind.slxos.v17r_1_01a.radius_server.host.radius_server_options.source_interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.radius_server.host.radius_server_options.source_interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def radius_server_host_source_interface_source_interface_value_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type host: hostname, use_vrf
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address ofthis RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type use_vrf: unicode
    :param use_vrf: **host** tuple argument:  VRF to choose for server connection(Default=mgmt-vrf)

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.radius_server.host', u'host'), ('pybind.slxos.v17r_2_00.radius_server.host', u'host')]
    bindings_list = [('pybind.slxos.v17r_1_01a.radius_server.host.radius_server_options.source_interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.radius_server.host.radius_server_options.source_interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def radius_server_host_timeout_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this RADIUS server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.radius_server.host', u'host'), ('pybind.slxos.v17r_2_00.radius_server.host', u'host'), ('pybind.slxos.v17r_1_01a.radius_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.radius_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.radius_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.radius_server.host.radius_server_options', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.radius_server.host.radius_server_options', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.radius_server.host.radius_server_options', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.radius_server.host.radius_server_options": {}, "pybind.slxos.v17r_1_01a.radius_server.host.radius_server_options": {}, "pybind.nos.v7_2_0.radius_server.host": {}, "pybind.slxos.v17r_2_00.radius_server.host.radius_server_options": {}, "pybind.nos.v6_0_2f.radius_server.host": {"hostname": "hostname", "timeout": "timeout"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.SFM', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric.login_policy', u'duplicatewwn'), ('pybind.slxos.v17r_1_01a.rbridge_id', u'logical_chassis'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.cid_card', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.ip.community_list', u'extended'), ('pybind.slxos.v17r_1_01a.diag.post', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.ip.community_list', u'standard'), ('pybind.slxos.v17r_1_01a.rbridge_id.vcs', u'auto_shut'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag', u'counter'), ('pybind.slxos.v17r_1_01a.rbridge_id', u'interface_nodespecific'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric', u'port_channel'), ('pybind.slxos.v17r_1_01a.rbridge_id', u'fcoe_config'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.temp', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag', u'timeout'), ('pybind.slxos.v17r_1_01a.rbridge_id', u'ag'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor', u'sfp'), ('pybind.slxos.v17r_1_01a.rbridge_id', u'default_config'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.LineCard', u'alert'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.compact_flash', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.fan', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.LineCard', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor', u'buffer'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.power', u'alert'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.fan', u'alert'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.cid_card', u'alert'), ('pybind.slxos.v17r_1_01a.rbridge_id.chassis', u'oper_address'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric.route', u'mcast'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor', u'security'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17r_1_01a.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.nport_menu.nport_interface', u'nport'), ('pybind.slxos.v17r_1_01a.rbridge_id.ipv6.ipv6route', u'route'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag', u'pg'), ('pybind.slxos.v17r_1_01a.rbridge_id', u'chassis'), ('pybind.slxos.v17r_1_01a.preprovision', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.power', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor', u'memory'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric', u'ecmp'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor', u'cpu'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.MM', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.fcoe_config', u'fcoe_enode_fabric_map'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route', u'static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id.resource_monitor', u'memory'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server', u'engineid'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.nos.v7_2_0.rbridge_id.crypto', u'key'), ('pybind.nos.v7_2_0.rbridge_id.crypto', u'ca'), ('pybind.nos.v7_2_0.rbridge_id.telnet.server', u'standby'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.ssh', u'client'), ('pybind.nos.v7_2_0.preprovision', u'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', u'listen_range'), ('pybind.nos.v7_2_0.rbridge_id.secpolicy.active_policy', u'policies'), ('pybind.nos.v7_2_0.rbridge_id.host_table', u'aging_time'), ('pybind.nos.v7_2_0.rbridge_id.ipv6', u'prefix_list'), ('pybind.nos.v7_2_0.rbridge_id.ip.as_path', u'access_list'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor', u'memory'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.MM', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server', u'offline_if'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route', u'link_local_static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp', u'router_bgp_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', u'arp_entry'), ('pybind.nos.v7_2_0.rbridge_id.ip.dhcp.relay', u'information'), ('pybind.nos.v7_2_0.rbridge_id', u'root'), ('pybind.nos.v7_2_0.rbridge_id.vcs', u'auto_shut'), ('pybind.nos.v7_2_0.rbridge_id.openflow', u'logical_instance'), ('pybind.nos.v7_2_0.rbridge_id.ag', u'timeout'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.rbridge_id.maps.email', u'email_list'), ('pybind.nos.v7_2_0.rbridge_id.fcsp.auth', u'proto'), ('pybind.nos.v7_2_0.rbridge_id.qos', u'tx_queue'), ('pybind.nos.v7_2_0.rbridge_id', u'filter_change_update_delay'), ('pybind.nos.v7_2_0.rbridge_id.ag', u'pg'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.interface', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id.global_lc_holder.linecard', u'linecards'), ('pybind.nos.v7_2_0.rbridge_id', u'vrrp'), ('pybind.nos.v7_2_0.rbridge_id', u'clock'), ('pybind.nos.v7_2_0.rbridge_id', u'system_max'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor', u'sfp'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ag.nport_menu.nport_interface', u'nport'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.ssh', u'server'), ('pybind.nos.v7_2_0.rbridge_id.bp_rate_limit', u'queue'), ('pybind.nos.v7_2_0.rbridge_id.interface', u've'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.fan', u'alert'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.ipv6_global_cmds.nd_global', u'dad'), ('pybind.nos.v7_2_0.rbridge_id.qos.rcv_queue', u'multicast'), ('pybind.nos.v7_2_0.rbridge_id.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id', u'dhcpd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.nos.v7_2_0.rbridge_id.resource_monitor', u'cpu'), ('pybind.nos.v7_2_0.rbridge_id.spanning_tree', u'ieee_bpdu'), ('pybind.nos.v7_2_0.rbridge_id.maps', u'logicalgroup'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.http', u'server'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.SFM', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.LineCard', u'alert'), ('pybind.nos.v7_2_0.rbridge_id.host_table', u'aging_mode'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.nos.v7_2_0.rbridge_id.fabric.login_policy', u'duplicatewwn'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.power', u'alert'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.ip.static_ag_ip_config', u'anycast_gateway_mac'), ('pybind.nos.v7_2_0.rbridge_id.ipv6', u'proto_vrrpv3'), ('pybind.nos.v7_2_0.rbridge_id.fabric', u'ecmp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.secpolicy.defined_policy', u'policies'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.nos.v7_2_0.rbridge_id.chassis', u'oper_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.nos.v7_2_0.rbridge_id', u'vrrp_rbridge_global'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.qos', u'rcv_queue'), ('pybind.nos.v7_2_0.rbridge_id.maps', u'relay'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.vlan_classification', u'predefined'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.sfp', u'alert'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder', u'pim'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.ipv6route', u'route'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.temp', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.route_table', u'predefined'), ('pybind.nos.v7_2_0.rbridge_id.ip', u'extcommunity_list'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.static_ag_ipv6_config', u'anycast_gateway_mac'), ('pybind.nos.v7_2_0.system.switch_attributes', u'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', u'evpn_instance'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route', u'static_route_oif'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.import_', u'routes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate', u'name'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor', u'security'), ('pybind.nos.v7_2_0.rbridge_id', u'default_config'), ('pybind.nos.v7_2_0.rbridge_id.resource_monitor.process', u'memory'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.compact_flash', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server', u'user'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim', u'rp_address'), ('pybind.nos.v7_2_0.rbridge_id', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.http.server.http_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.nos.v7_2_0.rbridge_id.ip.receive', u'access_group'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.nos.v7_2_0.rbridge_id.fcoe_config', u'fcoe_enode_fabric_map'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.tcam', u'predefined'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor', u'cpu'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.protocol', u'hide_vrrp_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.kap', u'predefined'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.route_table.predefined', u'routing_parameter'), ('pybind.nos.v7_2_0.rbridge_id.ip', u'prefix_list'), ('pybind.nos.v7_2_0.rbridge_id.ip', u'rtm_config'), ('pybind.nos.v7_2_0.rbridge_id', u'ag'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.bp_rate_limit.heavy', u'module'), ('pybind.nos.v7_2_0.rbridge_id', u'switch_attributes'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server', u'three_tuple_if'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.kap', u'customized'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', u'fcoe_config'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.receive', u'access_group'), ('pybind.nos.v7_2_0.rbridge_id', u'bfd_session_setup_delay'), ('pybind.nos.v7_2_0.rbridge_id.fcsp.auth', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.ag', u'counter'), ('pybind.nos.v7_2_0.rbridge_id.fabric', u'port_channel'), ('pybind.nos.v7_2_0.rbridge_id.telnet', u'server'), ('pybind.nos.v7_2_0.rbridge_id', u'fabric'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.cid_card', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id', u'chassis'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server', u'standby'), ('pybind.nos.v7_2_0.rbridge_id', u'interface_nodespecific'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route', u'static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server', u'v3host'), ('pybind.nos.v7_2_0.rbridge_id.maps', u'enable'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id.ip.import_', u'routes'), ('pybind.nos.v7_2_0.rbridge_id.ip.community_list', u'extended'), ('pybind.nos.v7_2_0.rbridge_id.maps', u'rule'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', u'logical_chassis'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.LineCard', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.nos.v7_2_0.rbridge_id.ip.community_list', u'standard'), ('pybind.nos.v7_2_0.rbridge_id.fabric.route', u'mcast'), ('pybind.nos.v7_2_0.rbridge_id.maps', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id', u'system_mode'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.cid_card', u'alert'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.fan', u'threshold'), ('pybind.nos.v7_2_0.fabric.route.mcast', u'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.power', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route', u'static_route_oif'), ('pybind.nos.v7_2_0.diag.post', u'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server', u'key'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.protocol', u'hide_vrrp_holder'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.sfp', u'alert'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.ipv6_global_cmds.nd_global', u'dad'), ('pybind.nos.v6_0_2f.rbridge_id.ip.import_', u'routes'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.crypto', u'key'), ('pybind.nos.v6_0_2f.rbridge_id.global_lc_holder.linecard', u'linecards'), ('pybind.nos.v6_0_2f.rbridge_id', u'ag'), ('pybind.nos.v6_0_2f.fabric.route.mcast', u'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.qos', u'rcv_queue'), ('pybind.nos.v6_0_2f.rbridge_id.secpolicy.defined_policy', u'policies'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.chassis', u'oper_address'), ('pybind.nos.v6_0_2f.rbridge_id.ag', u'timeout'), ('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.kap', u'predefined'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.temp', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.nos.v6_0_2f.diag.post', u'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.nos.v6_0_2f.system.switch_attributes', u'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vcs', u'auto_shut'), ('pybind.nos.v6_0_2f.rbridge_id.ip', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.fcsp.auth', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.ip.as_path', u'access_list'), ('pybind.nos.v6_0_2f.rbridge_id', u'default_config'), ('pybind.nos.v6_0_2f.rbridge_id.ip.dhcp.relay', u'information'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route', u'link_local_static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.MM', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.snmp_server', u'engineid'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor', u'security'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.nos.v6_0_2f.rbridge_id.ssh', u'client'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor', u'cpu'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.nos.v6_0_2f.rbridge_id.ip', u'extcommunity_list'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.cid_card', u'alert'), ('pybind.nos.v6_0_2f.rbridge_id.ag', u'pg'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.bp_rate_limit', u'queue'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.receive', u'access_group'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.LineCard', u'alert'), ('pybind.nos.v6_0_2f.rbridge_id.snmp_server', u'user'), ('pybind.nos.v6_0_2f.rbridge_id.bp_rate_limit.heavy', u'module'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.fan', u'alert'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.vlan_classification', u'predefined'), ('pybind.nos.v6_0_2f.rbridge_id', u'root'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.compact_flash', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor', u'sfp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.nos.v6_0_2f.rbridge_id.qos.rcv_queue', u'multicast'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate', u'name'), ('pybind.nos.v6_0_2f.rbridge_id', u'system_max'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.fabric', u'port_channel'), ('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.kap', u'customized'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface', u've'), ('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.tcam', u'predefined'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.import_', u'routes'), ('pybind.nos.v6_0_2f.rbridge_id', u'fcoe_config'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route', u'static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.ip.community_list', u'extended'), ('pybind.nos.v6_0_2f.rbridge_id.telnet', u'server'), ('pybind.nos.v6_0_2f.rbridge_id.maps.email', u'email_list'), ('pybind.nos.v6_0_2f.rbridge_id', u'logical_chassis'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route', u'static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.power', u'alert'), ('pybind.nos.v6_0_2f.rbridge_id.interface', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6', u'proto_vrrpv3'), ('pybind.nos.v6_0_2f.rbridge_id.http', u'server'), ('pybind.nos.v6_0_2f.rbridge_id.ag.nport_menu.nport_interface', u'nport'), ('pybind.nos.v6_0_2f.rbridge_id.snmp_server', u'v3host'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.nos.v6_0_2f.rbridge_id.ip.community_list', u'standard'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.fcsp.auth', u'proto'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp', u'router_bgp_attributes'), ('pybind.nos.v6_0_2f.rbridge_id', u'clock'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.telnet.server', u'standby'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_interface'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route', u'static_route_nh_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.nos.v6_0_2f.rbridge_id.qos', u'tx_queue'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.nos.v6_0_2f.rbridge_id.fabric.login_policy', u'duplicatewwn'), ('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.ip', u'rtm_config'), ('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.route_table', u'predefined'), ('pybind.nos.v6_0_2f.rbridge_id', u'interface_nodespecific'), ('pybind.nos.v6_0_2f.rbridge_id.router', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.power', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.snmp_server', u'offline_if'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.fan', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.nos.v6_0_2f.rbridge_id', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.LineCard', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.snmp_server', u'three_tuple_if'), ('pybind.nos.v6_0_2f.rbridge_id', u'filter_change_update_delay'), ('pybind.nos.v6_0_2f.rbridge_id.ssh.server', u'key'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor', u'memory'), ('pybind.nos.v6_0_2f.rbridge_id', u'arp_entry'), ('pybind.nos.v6_0_2f.rbridge_id.fabric.route', u'mcast'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.SFM', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.spanning_tree', u'ieee_bpdu'), ('pybind.nos.v6_0_2f.rbridge_id', u'chassis'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.ipv6route', u'route'), ('pybind.nos.v6_0_2f.rbridge_id.fabric', u'ecmp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.cid_card', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.ip.receive', u'access_group'), ('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim', u'rp_address'), ('pybind.nos.v6_0_2f.rbridge_id.ssh', u'server'), ('pybind.nos.v6_0_2f.rbridge_id.ssh.server', u'standby'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.maps', u'enable'), ('pybind.nos.v6_0_2f.rbridge_id.ag', u'counter'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id', u'vrrp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.crypto', u'ca'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id', u'switch_attributes'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder', u'pim'), ('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.route_table.predefined', u'routing_parameter'), ('pybind.nos.v6_0_2f.rbridge_id.maps', u'relay'), ('pybind.nos.v6_0_2f.preprovision', u'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.openflow', u'logical_instance'), ('pybind.nos.v6_0_2f.rbridge_id.secpolicy.active_policy', u'policies'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id.fcoe_config', u'fcoe_enode_fabric_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id', u'vrrp_rbridge_global'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric.route', u'mcast'), ('pybind.slxos.v17r_2_00.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor', u'memory'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.SFM', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id', u'logical_chassis'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor', u'sfp'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.fan', u'alert'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.power', u'alert'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.nport_menu.nport_interface', u'nport'), ('pybind.slxos.v17r_2_00.rbridge_id.ag', u'timeout'), ('pybind.slxos.v17r_2_00.rbridge_id.ip.community_list', u'standard'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.cid_card', u'alert'), ('pybind.slxos.v17r_2_00.diag.post', u'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', u'chassis'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.temp', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor', u'buffer'), ('pybind.slxos.v17r_2_00.rbridge_id', u'fcoe_config'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric', u'port_channel'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.compact_flash', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.ag', u'pg'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.MM', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.ag', u'counter'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.ip.community_list', u'extended'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor', u'interface'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.fan', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.chassis', u'oper_address'), ('pybind.slxos.v17r_2_00.rbridge_id', u'default_config'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric.login_policy', u'duplicatewwn'), ('pybind.slxos.v17r_2_00.preprovision', u'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', u'ag'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id', u'interface_nodespecific'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric', u'ecmp'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.LineCard', u'alert'), ('pybind.slxos.v17r_2_00.rbridge_id.ipv6.ipv6route', u'route'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor', u'cpu'), ('pybind.slxos.v17r_2_00.rbridge_id.vcs', u'auto_shut'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor', u'security'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.LineCard', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.power', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.cid_card', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.fcoe_config', u'fcoe_enode_fabric_map'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.fan', u'alert'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.SFM', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor', u'buffer'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.fan', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.cid_card', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.compact_flash', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.LineCard', u'alert'), ('pybind.slxos.v17s_1_02.rbridge_id', u'chassis'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.LineCard', u'threshold'), ('pybind.slxos.v17s_1_02.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.ipv6.ipv6route', u'route'), ('pybind.slxos.v17s_1_02.rbridge_id.ip.community_list', u'extended'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric', u'ecmp'), ('pybind.slxos.v17s_1_02.rbridge_id', u'logical_chassis'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.vcs', u'auto_shut'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric.route', u'mcast'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor', u'cpu'), ('pybind.slxos.v17s_1_02.rbridge_id.ag', u'timeout'), ('pybind.slxos.v17s_1_02.rbridge_id', u'interface_nodespecific'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor', u'memory'), ('pybind.slxos.v17s_1_02.rbridge_id', u'default_config'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor', u'sfp'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.nport_menu.nport_interface', u'nport'), ('pybind.slxos.v17s_1_02.rbridge_id', u'ag'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.power', u'alert'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.temp', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor', u'security'), ('pybind.slxos.v17s_1_02.rbridge_id.fcoe_config', u'fcoe_enode_fabric_map'), ('pybind.slxos.v17s_1_02.preprovision', u'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', u'fcoe_config'), ('pybind.slxos.v17s_1_02.rbridge_id.ag', u'pg'), ('pybind.slxos.v17s_1_02.rbridge_id.ag', u'counter'), ('pybind.slxos.v17s_1_02.rbridge_id.ip.community_list', u'standard'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.cid_card', u'alert'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric.login_policy', u'duplicatewwn'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric', u'port_channel'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor', u'interface'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.power', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.MM', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.chassis', u'oper_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'rbridge_id', 'keyval': 'rbridge_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'precedence'}, {'leafval': 'principal_priority'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'enable, rbridge_id'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'lag'}, {'leafval': 'reliabilitycountervalue'}, {'leafval': 'ns_vlan, ns_ethernet'}, {'leafval': 'po_id, vlag_load_balance'}, {'leafval': 'fcoe_max_enode'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'fnmtovalue'}, {'leafval': 'enable'}, {'leafval': 'policy_name'}, {'leafval': 'apply, pause'}, {'leafval': 'enable'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'state, action'}, {'leafval': 'state, action'}, {'leafval': 'state, action'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'priority'}, {'leafval': 'apply, pause'}, {'leafval': 'policy_name'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'agNPortNb'}, {'leafval': 'dest, next_hop'}, {'leafval': 'sec_policy_name'}, {'leafval': 'pgid, rename'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'rbridge_id, wwn'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'ecmp_load_balance, load_balance_hash_swap'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'fcoe_enode_fabric_map_name'}, {'leafval': 'apply, pause'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'enable_memory, threshold_memory, action_memory, sample_rate_memory, logging_rate_memory, grace_period_memory, offset_memory'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'local_'}, {'leafval': 'identifier'}, {'leafval': 'label, type, modulus'}, {'leafval': 'trustpoint, keypair'}, {'leafval': 'enable'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'policy_name'}, {'leafval': 'cipher, mac, key_exchange'}, {'leafval': 'rbridge_id, wwn'}, {'leafval': 'listen_range_prefix, peer_group, limit'}, {'leafval': 'policy'}, {'leafval': 'conversational_timeout'}, {'leafval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'offline_if_display_enable'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'local_as, always_compare_med, compare_med_empty_aspath, med_missing_as_worst, as_path_ignore, compare_routerid, install_igp_cost, default_local_preference, enforce_first_as, fast_external_fallover, log_dampening_debug, auto_shutdown_new_neighbors, listen_limit'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, Port_channel, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve'}, {'leafval': 'option'}, {'leafval': 'enable, access'}, {'leafval': 'lag'}, {'leafval': 'instance_id, default_forwarding_action, activate'}, {'leafval': 'fnmtovalue'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'email'}, {'leafval': 'auth_type, group, hash'}, {'leafval': 'tx_queue_limit'}, {'leafval': 'filter_delay_value'}, {'leafval': 'pgid, rename'}, {'leafval': 'policy_name'}, {'leafval': 'id'}, {'leafval': 'linecardName, linecardType'}, {'leafval': 'early_startup'}, {'leafval': 'timezone'}, {'leafval': 'arp'}, {'leafval': 'apply, pause'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'agNPortNb'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id, rp_cand_priority'}, {'leafval': 'holdover_interval'}, {'leafval': 'shutdown, key_exchange, rekey_interval, cipher, mac, max_sessions'}, {'leafval': 'queue_id, limit_percent'}, {'leafval': 'name, shutdown'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'state, action'}, {'leafval': 'global_dad_time'}, {'leafval': 'rx_queue_bum_mode'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'enable'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'enable_cpu, threshold_cpu, action_cpu, sample_rate_cpu, logging_rate_cpu, grace_period_cpu, offset_cpu'}, {'leafval': 'limit_vlan_flood'}, {'leafval': 'logicalgroupname, elementtype, members'}, {'leafval': 'sec_policy_name'}, {'leafval': 'shutdown'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'state, action'}, {'leafval': 'conversational'}, {'leafval': 'holdover_interval'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'precedence'}, {'leafval': 'apply, pause'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'state, action'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ip_anycast_gateway_mac, ip_anycast_default_mac'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'ecmp_load_balance, load_balance_hash_swap'}, {'leafval': 'table_map_route_map'}, {'leafval': 'policy'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'evpn_neighbor_ipv6_address, activate, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'evpn_neighbor_ipv4_address, activate, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check'}, {'leafval': 'vrrp_acceptmode_disable'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'rcv_queue_limit'}, {'leafval': 'hostip, domainname'}, {'leafval': 'vlan_profiletype'}, {'leafval': 'as4_enable'}, {'leafval': 'state, action'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'always_use_register, reset_tracking_bit, max_mcache, hello_interval, nbr_timeout, inactivity_timer, message_interval, bsr_msg_interval, rp_adv_interval, spt_threshold'}, {'leafval': 'dest, next_hop'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'routing_profiletype'}, {'leafval': 'extcommunity_list_num, ext_community_action, ext_community_regex, ext_community_expr'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'name, action_rm, instance'}, {'leafval': 'ipv6_anycast_gateway_mac, ipv6_anycast_default_mac'}, {'leafval': 'rbridge_id, chassis_name, host_name'}, {'leafval': 'instance_name, df_delay_timer'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'name, delay, iterations, interval, run_mode, trigger_mode, action_timeout'}, {'leafval': 'apply, pause'}, {'leafval': 'enable'}, {'leafval': 'enable_process, thresh_mem_alarm, thresh_mem_critic'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'username, groupname, auth, auth_password, priv, priv_password, encrypted'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'rp_ip_addr, prefix_list'}, {'leafval': 'vrf_name, route_distiniguisher, vni'}, {'leafval': 'use_vrf_name, secure_and_plain, http_vrf_shutdown'}, {'leafval': 'table_map_route_map'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'vrf, database_overflow_interval, default_passive_interface, default_metric, external_lsdb_limit, ospf_metric_type, vrf_lite_capability, nonstop_routing, maximum_paths'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'ip_access_list, ip_direction'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'fcoe_enode_fabric_map_name'}, {'leafval': 'tcam_profiletype'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'num_as_in_path'}, {'leafval': 'kap_profiletype'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'router_id, load_sharing'}, {'leafval': 'enable'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'add_, remove_'}, {'leafval': 'chassis_name, host_name'}, {'leafval': 'three_tuple_if_display_enable'}, {'leafval': 'kap_profilename'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'fcoe_max_enode'}, {'leafval': 'ipv6_access_list, ip_direction'}, {'leafval': 'delay'}, {'leafval': 'switch'}, {'leafval': 'reliabilitycountervalue'}, {'leafval': 'po_id, vlag_load_balance'}, {'leafval': 'shutdown'}, {'leafval': 'neighbor_discovery'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'enable'}, {'leafval': 'ns_vlan, ns_ethernet'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'hostip, username, udp_port, notifytype, engineid, severity_level'}, {'leafval': 'policy, actions'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'rulename, targetgroup, monitor, timebase, op, threshold'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'principal_priority'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'evpn_neighbor_peergroup_name, activate, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, accept_lldp_neighbors, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'all'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'priority'}, {'leafval': 'policyname'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'maintenance'}, {'leafval': 'rp_cand_grp_prefix_ip, rp_cand_grp_prefix_length'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'enable, rbridge_id'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'state, action'}, {'leafval': 'global_dad_time'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'vrf_name, route_distiniguisher'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'label, type, modulus'}, {'leafval': 'linecardName, linecardType'}, {'leafval': 'enable'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rcv_queue_limit'}, {'leafval': 'policy'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'fnmtovalue'}, {'leafval': 'kap_profiletype'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'enable, rbridge_id'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rbridge_id, chassis_name, host_name'}, {'leafval': 'lag'}, {'leafval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'switch'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'enable'}, {'leafval': 'option'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'local_'}, {'leafval': 'num_as_in_path'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'apply, pause'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'cipher, mac, key_exchange'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'sec_policy_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'holdover_interval'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'extcommunity_list_num, ext_community_action, ext_community_expr'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'state, action'}, {'leafval': 'pgid, rename'}, {'leafval': 'table_map_route_map'}, {'leafval': 'queue_id, limit_percent'}, {'leafval': 'ipv6_access_list, ip_direction'}, {'leafval': 'state, action'}, {'leafval': 'username, groupname, auth, auth_password, priv, priv_password, encrypted'}, {'leafval': 'add_, remove_'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'state, action'}, {'leafval': 'identifier'}, {'leafval': 'vlan_profiletype'}, {'leafval': 'enable, access'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'apply, pause'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'rx_queue_bum_mode'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'name, delay, iterations, interval, run_mode, trigger_mode'}, {'leafval': 'arp'}, {'leafval': 'policy_name'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'po_id, vlag_load_balance'}, {'leafval': 'kap_profilename'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, allowas_in, activate, route_reflector_client, af_nei_weight'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'name, shutdown'}, {'leafval': 'tcam_profiletype'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'fcoe_max_enode'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'af_ipv6_neighbor_address, allowas_in, activate, route_reflector_client, af_nei_weight'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'shutdown'}, {'leafval': 'email'}, {'leafval': 'principal_priority'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'state, action'}, {'leafval': 'id'}, {'leafval': 'as4_enable'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'shutdown'}, {'leafval': 'agNPortNb'}, {'leafval': 'hostip, username, udp_port, notifytype, engineid, severity_level, use_vrf'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'holdover_interval'}, {'leafval': 'auth_type, group, hash'}, {'leafval': 'local_as, always_compare_med, compare_med_empty_aspath, med_missing_as_worst, as_path_ignore, compare_routerid, install_igp_cost, default_local_preference, enforce_first_as, fast_external_fallover, log_dampening_debug'}, {'leafval': 'timezone'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'enable'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'tx_queue_limit'}, {'leafval': 'policy_name'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'precedence'}, {'leafval': 'rp_cand_grp_prefix_action, rp_cand_grp_prefix_ip, rp_cand_grp_prefix_length'}, {'leafval': 'router_id, load_sharing'}, {'leafval': 'routing_profiletype'}, {'leafval': 'ns_vlan, ns_ethernet'}, {'leafval': 'vrf, database_overflow_interval, default_passive_interface, default_metric, external_lsdb_limit, ospf_metric_type, vrf_lite_capability, nonstop_routing, maximum_paths'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'offline_if_display_enable'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'name, action_rm, instance'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'three_tuple_if_display_enable'}, {'leafval': 'filter_delay_value'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve'}, {'leafval': 'priority'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'limit_vlan_flood'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'dest, next_hop'}, {'leafval': 'ecmp_load_balance, load_balance_hash_swap'}, {'leafval': 'af_ipv4_neighbor_address, allowas_in, activate, route_reflector_client, af_nei_weight'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'apply, pause'}, {'leafval': 'ip_access_list, ip_direction'}, {'leafval': 'rp_ip_addr, prefix_list'}, {'leafval': 'shutdown, key_exchange, rekey_interval, cipher, mac'}, {'leafval': 'enable'}, {'leafval': 'table_map_route_map'}, {'leafval': 'policy, actions'}, {'leafval': 'reliabilitycountervalue'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'early_startup'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'trustpoint, keypair'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'chassis_name, host_name'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'max_mcache, hello_interval, nbr_timeout, inactivity_timer, message_interval, spt_threshold'}, {'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'hostip, domainname'}, {'leafval': 'rbridge_id, wwn'}, {'leafval': 'instance_id, default_forwarding_action, activate'}, {'leafval': 'policy'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, allowas_in, activate, route_reflector_client, af_nei_weight'}, {'leafval': 'fcoe_enode_fabric_map_name'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'vrrp_acceptmode_disable'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'principal_priority'}, {'leafval': 'apply, pause'}, {'leafval': 'state, action'}, {'leafval': 'state, action'}, {'leafval': 'agNPortNb'}, {'leafval': 'fnmtovalue'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'state, action'}, {'leafval': 'enable, rbridge_id'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'fcoe_max_enode'}, {'leafval': 'po_id, vlag_load_balance'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'pgid, rename'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'reliabilitycountervalue'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'apply, pause'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'enable'}, {'leafval': 'precedence'}, {'leafval': 'rbridge_id, wwn'}, {'leafval': 'enable'}, {'leafval': 'sec_policy_name'}, {'leafval': 'ns_vlan, ns_ethernet'}, {'leafval': 'ecmp_load_balance, load_balance_hash_swap'}, {'leafval': 'state, action'}, {'leafval': 'dest, next_hop'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'lag'}, {'leafval': 'apply, pause'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'fcoe_enode_fabric_map_name'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'sec_policy_name'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'policy_name'}, {'leafval': 'state, action'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'dest, next_hop'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'ecmp_load_balance, load_balance_hash_swap'}, {'leafval': 'principal_priority'}, {'leafval': 'policy_name'}, {'leafval': 'lag'}, {'leafval': 'priority'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'fnmtovalue'}, {'leafval': 'ns_vlan, ns_ethernet'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'enable'}, {'leafval': 'apply, pause'}, {'leafval': 'agNPortNb'}, {'leafval': 'enable'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'apply, pause'}, {'leafval': 'fcoe_enode_fabric_map_name'}, {'leafval': 'rbridge_id, wwn'}, {'leafval': 'fcoe_max_enode'}, {'leafval': 'pgid, rename'}, {'leafval': 'reliabilitycountervalue'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'state, action'}, {'leafval': 'precedence'}, {'leafval': 'po_id, vlag_load_balance'}, {'leafval': 'apply, pause'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'virtual_oper_Vip_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ag_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ag', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ag', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ag', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ag', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ag_counter_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ag.counter', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ag.counter', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.counter', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.counter', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.counter', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ag_counter_reliability_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ag.counter', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ag.counter', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.counter', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.counter', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.counter', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ag_enable_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ag', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ag', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ag', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ag', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ag_nport_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ag.nport_menu', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ag.nport_menu', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.nport_menu', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.nport_menu', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.nport_menu', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ag_nport_interface_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ag.nport_menu.nport_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ag.nport_menu.nport_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.nport_menu.nport_interface', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.nport_menu.nport_interface', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.nport_menu.nport_interface', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ag_nport_interface_fiberchannel_get(self, rbridge_id=None, nport=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type nport: agNPortNb
    :param nport: Keyword argument tuple.

    :type agNPortNb: unicode
    :param agNPortNb: **nport** tuple argument.

        * length restriction: ::

            ['1..250']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ag.nport_menu.nport_interface.nport', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ag.nport_menu.nport_interface.nport', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.nport_menu.nport_interface.nport', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.nport_menu.nport_interface.nport', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.nport_menu.nport_interface.nport', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'nport', 'keyval': 'agNPortNb', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, nport=nport)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, nport=nport)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ag_nport_interface_fiberchannel_map_get(self, rbridge_id=None, nport=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type nport: agNPortNb
    :param nport: Keyword argument tuple.

    :type agNPortNb: unicode
    :param agNPortNb: **nport** tuple argument.

        * length restriction: ::

            ['1..250']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ag.nport_menu.nport_interface.nport.map_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ag.nport_menu.nport_interface.nport.map_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.nport_menu.nport_interface.nport.map_', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.nport_menu.nport_interface.nport.map_', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.nport_menu.nport_interface.nport.map_', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, nport=nport)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, nport=nport)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ag_nport_interface_fiberchannel_map_fport_get(self, rbridge_id=None, nport=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type nport: agNPortNb
    :param nport: Keyword argument tuple.

    :type agNPortNb: unicode
    :param agNPortNb: **nport** tuple argument.

        * length restriction: ::

            ['1..250']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, nport=nport)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, nport=nport)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ag_nport_interface_fiberchannel_map_fport_interface_get(self, rbridge_id=None, nport=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type nport: agNPortNb
    :param nport: Keyword argument tuple.

    :type agNPortNb: unicode
    :param agNPortNb: **nport** tuple argument.

        * length restriction: ::

            ['1..250']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.nport_menu.nport_interface.nport', u'nport')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport.map_fport_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport.map_fport_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport.map_fport_interface', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport.map_fport_interface', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.nport_menu.nport_interface.nport.map_.map_fport.map_fport_interface', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'agNPortNb', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, nport=nport)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, nport=nport)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ag_pg_get(self, rbridge_id=None, pg=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pg: pgid
    :param pg: Keyword argument tuple.

    :type pgid: long
    :param pgid: **pg** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ag.pg', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ag.pg', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.pg', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.pg', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.pg', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pg', 'keyval': 'pgid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, pg=pg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, pg=pg)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ag_pg_nport_get(self, rbridge_id=None, pg=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type pg: pgid
    :param pg: Keyword argument tuple.

    :type pgid: long
    :param pgid: **pg** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ag.pg', u'pg'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.pg', u'pg'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.pg', u'pg'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.pg', u'pg'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ag.pg', u'pg')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ag.pg.nport', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ag.pg.nport', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.pg.nport', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.pg.nport', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.pg.nport', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, pg=pg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, pg=pg)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ag_pg_nport_interface_get(self, rbridge_id=None, pg=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type pg: pgid
    :param pg: Keyword argument tuple.

    :type pgid: long
    :param pgid: **pg** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.pg', u'pg'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.pg', u'pg'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.pg', u'pg'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ag.pg', u'pg'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ag.pg', u'pg')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ag.pg.nport.pg_nport_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ag.pg.nport.pg_nport_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.pg.nport.pg_nport_interface', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.pg.nport.pg_nport_interface', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.pg.nport.pg_nport_interface', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'pgid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, pg=pg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, pg=pg)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ag_pg_rename_get(self, rbridge_id=None, pg=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type pg: pgid
    :param pg: Keyword argument tuple.

    :type pgid: long
    :param pgid: **pg** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ag.pg', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ag.pg', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.pg', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.pg', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.pg', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'pg', 'keyval': 'pgid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, pg=pg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, pg=pg)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ag_timeout_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ag.timeout', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ag.timeout', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.timeout', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.timeout', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.timeout', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ag_timeout_fnm_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ag.timeout', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ag.timeout', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.timeout', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.timeout', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.timeout', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_arp_get(self, rbridge_id=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address, mac_address_value, interfacename, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac_address_value: unicode
    :param mac_address_value: **arp_entry** tuple argument.

    :type interfacename: unicode
    :param interfacename: **arp_entry** tuple argument.

        * enumeration restriction: ::

            ['interface']

    :type GigabitEthernet: unicode
    :param GigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type TenGigabitEthernet: unicode
    :param TenGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type FortyGigabitEthernet: unicode
    :param FortyGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type HundredGigabitEthernet: unicode
    :param HundredGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type Ve: long
    :param Ve: **arp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.arp_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': 'arp_ip_address, mac_address_value, interfacename, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.rbridge_id.arp_entry": {}, "pybind.nos.v6_0_2f.rbridge_id.arp_entry": {"mac_address_value": "mac_address_value", "interfacename": "interfacename", "FortyGigabitEthernet": "FortyGigabitEthernet", "GigabitEthernet": "GigabitEthernet", "TenGigabitEthernet": "TenGigabitEthernet", "arp_ip_address": "arp_ip_address", "HundredGigabitEthernet": "HundredGigabitEthernet", "Ve": "Ve"}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.arp_entry': [u'Port_channel', u'Ve', u'FortyGigabitEthernet', u'GigabitEthernet', u'TenGigabitEthernet', u'HundredGigabitEthernet'], 'pybind.nos.v6_0_2f.rbridge_id.arp_entry': [u'FortyGigabitEthernet', u'GigabitEthernet', u'TenGigabitEthernet', u'HundredGigabitEthernet', u'Ve']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_arp_fortygigabitethernet_get(self, rbridge_id=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.arp_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_arp_gigabitethernet_get(self, rbridge_id=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.arp_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_arp_hundredgigabitethernet_get(self, rbridge_id=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.arp_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_arp_interfacename_get(self, rbridge_id=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.arp_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_arp_mac_address_value_get(self, rbridge_id=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.arp_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_arp_port_channel_get(self, rbridge_id=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_arp_tengigabitethernet_get(self, rbridge_id=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.arp_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_arp_ve_get(self, rbridge_id=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.arp_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_bfd_session_setup_delay_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.bfd_session_setup_delay', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_bfd_session_setup_delay_delay_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.bfd_session_setup_delay', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_bp_rate_limit_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.bp_rate_limit', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.bp_rate_limit', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_bp_rate_limit_heavy_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.bp_rate_limit.heavy', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.bp_rate_limit.heavy', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_bp_rate_limit_heavy_module_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.bp_rate_limit.heavy.module', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.bp_rate_limit.heavy.module', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_bp_rate_limit_heavy_module_add_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.bp_rate_limit.heavy.module', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.bp_rate_limit.heavy.module', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_bp_rate_limit_heavy_module_remove_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.bp_rate_limit.heavy.module', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.bp_rate_limit.heavy.module', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_bp_rate_limit_queue_get(self, rbridge_id=None, queue=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type queue: queue_id
    :param queue: Keyword argument tuple.

    :type queue_id: long
    :param queue_id: **queue** tuple argument:  BP queue number (only queue 0 is supported)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.bp_rate_limit.queue', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.bp_rate_limit.queue', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'queue_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, queue=queue)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_bp_rate_limit_queue_limit_percent_get(self, rbridge_id=None, queue=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type queue: queue_id
    :param queue: Keyword argument tuple.

    :type queue_id: long
    :param queue_id: **queue** tuple argument:  BP queue number (only queue 0 is supported)

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.bp_rate_limit.queue', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.bp_rate_limit.queue', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'queue_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, queue=queue)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_chassis_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.chassis', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.chassis', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.chassis', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.chassis', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.chassis', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_chassis_oper_address_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.chassis.oper_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.chassis.oper_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_chassis_virtual_ip_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.chassis', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.chassis', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.chassis', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.chassis', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.chassis', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_chassis_virtual_ip_oper_address_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.chassis.oper_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.chassis.oper_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_chassis_virtual_ip_v4_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.slxos.v17r_1_01a.rbridge_id.chassis.oper_address', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.chassis.oper_address', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.chassis.oper_address', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_chassis_virtual_ipv6_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.chassis', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.chassis', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.chassis', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.chassis', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.chassis', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_clock_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.clock', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.clock', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_clock_timezone_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.clock', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.clock', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_crypto_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.crypto', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.crypto', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_crypto_ca_get(self, rbridge_id=None, ca=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ca: trustpoint
    :param ca: Keyword argument tuple.

    :type trustpoint: unicode
    :param trustpoint: **ca** tuple argument:  Trustpoint name

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.crypto.ca', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.crypto.ca', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ca', 'keyval': 'trustpoint', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ca=ca)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ca=ca)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_crypto_ca_keypair_get(self, rbridge_id=None, ca=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ca: trustpoint
    :param ca: Keyword argument tuple.

    :type trustpoint: unicode
    :param trustpoint: **ca** tuple argument:  Trustpoint name

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.crypto.ca', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.crypto.ca', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ca', 'keyval': 'trustpoint', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ca=ca)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ca=ca)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_crypto_key_get(self, rbridge_id=None, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type key: label, type, modulus
    :param key: Keyword argument tuple.

    :type label: unicode
    :param label: **key** tuple argument:  Key Label

        * length restriction: ::

            ['1..64']

    :type type: unicode
    :param type: **key** tuple argument:  Key Type

        * enumeration restriction: ::

            ['dsa', 'rsa', 'ecdsa']

    :type modulus: long
    :param modulus: **key** tuple argument:  Key Size

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.crypto.key', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.crypto.key', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'key', 'keyval': 'label', 'extra_keyval': 'label, type, modulus'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_crypto_key_modulus_get(self, rbridge_id=None, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type key: label
    :param key: Keyword argument tuple.

    :type label: unicode
    :param label: **key** tuple argument:  Key Label

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.crypto.key', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.crypto.key', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'key', 'keyval': 'label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_crypto_key_type_get(self, rbridge_id=None, key=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type key: label
    :param key: Keyword argument tuple.

    :type label: unicode
    :param label: **key** tuple argument:  Key Label

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.crypto.key', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.crypto.key', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'key', 'keyval': 'label', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, key=key)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, key=key)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_default_config_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.default_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.default_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.default_config', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.default_config', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.default_config', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_default_config_enable_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.default_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.default_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.default_config', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.default_config', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.default_config', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_dhcpd_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.dhcpd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_dhcpd_enable_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.dhcpd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_event_handler_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.event_handler', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.event_handler', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_event_handler_activate_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_get(self, rbridge_id=None, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name', u'trigger_function_container'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name', u'trigger_function')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}]
    leafval_map = {"pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name": {}, "pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name": {"name": "name", "interval": "interval", "trigger_mode": "trigger_mode", "delay": "delay", "iterations": "iterations", "run_mode": "run_mode"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_action_timeout_get(self, rbridge_id=None, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name', u'trigger_function')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trigger_function, time_window'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_delay_get(self, rbridge_id=None, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name', u'trigger_function_container'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name', u'trigger_function')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_interval_get(self, rbridge_id=None, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name', u'trigger_function_container'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name', u'trigger_function')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_iterations_get(self, rbridge_id=None, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name', u'trigger_function_container'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name', u'trigger_function')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_run_mode_get(self, rbridge_id=None, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name', u'trigger_function_container'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name', u'trigger_function')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_time_window_get(self, rbridge_id=None, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name', u'name')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name.trigger_function_container', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_trigger_function_get(self, rbridge_id=None, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name', u'name')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name.trigger_function_container', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_trigger_function_time_window_get(self, rbridge_id=None, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name', u'name')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name.trigger_function', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_trigger_function_trigger_function_get(self, rbridge_id=None, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name', u'name')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name.trigger_function', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_event_handler_activate_name_trigger_mode_get(self, rbridge_id=None, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument:  Event handler name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate.name', u'trigger_function_container'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate.name', u'trigger_function')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trigger_function, time_window'}, {'leafval': 'trigger_function, time_window'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_get(self, rbridge_id=None, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.route_target', u'both'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance.route_target', u'export'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'duplicate_mac_timer'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni', u'vni_add'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni', u'evpn_vni'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'route_distinguisher'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance.route_target', u'import_')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_instance', 'keyval': 'instance_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'target_community, ignore_as'}, {'leafval': 'target_community'}, {'leafval': 'duplicate_mac_timer_value, max_count'}, {'leafval': 'add_, remove_'}, {'leafval': 'vni_number, rd'}, {'leafval': 'auto'}, {'leafval': 'target_community, ignore_as'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_df_delay_timer_get(self, rbridge_id=None, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.route_target', u'both'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance.route_target', u'export'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'duplicate_mac_timer'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni', u'vni_add'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni', u'evpn_vni'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'route_distinguisher'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance.route_target', u'import_')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_instance', 'keyval': 'instance_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'target_community, ignore_as'}, {'leafval': 'target_community'}, {'leafval': 'duplicate_mac_timer_value, max_count'}, {'leafval': 'add_, remove_'}, {'leafval': 'vni_number, rd'}, {'leafval': 'auto'}, {'leafval': 'target_community, ignore_as'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_duplicate_mac_timer_get(self, rbridge_id=None, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.duplicate_mac_timer', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'duplicate_mac_timer_value, max_count'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_duplicate_mac_timer_duplicate_mac_timer_value_get(self, rbridge_id=None, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.duplicate_mac_timer', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_duplicate_mac_timer_max_count_get(self, rbridge_id=None, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.duplicate_mac_timer', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_rd_get(self, rbridge_id=None, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.route_distinguisher', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'auto'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.evpn_instance.route_distinguisher': [u'auto']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_rd_auto_get(self, rbridge_id=None, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.route_distinguisher', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_route_target_get(self, rbridge_id=None, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.route_target', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_route_target_both_get(self, rbridge_id=None, evpn_instance=None, both=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type both: target_community
    :param both: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **both** tuple argument:  auto;; Target VPN Extended Community

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.route_target.both', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'both', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, both=both)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, both=both)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_route_target_both_ignore_as_get(self, rbridge_id=None, evpn_instance=None, both=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type both: target_community
    :param both: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **both** tuple argument:  auto;; Target VPN Extended Community

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.route_target.both', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'both', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, both=both)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, both=both)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_route_target_export_get(self, rbridge_id=None, evpn_instance=None, export=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type export: target_community
    :param export: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **export** tuple argument:  auto;; Target VPN Extended Community

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.route_target.export', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'export', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, export=export)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, export=export)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_route_target_import_get(self, rbridge_id=None, evpn_instance=None, import_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type import_: target_community
    :param import_: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **import_** tuple argument:  auto ;; Target VPN Extended Community

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.route_target.import_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'import_', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, import_=import_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, import_=import_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_route_target_import_ignore_as_get(self, rbridge_id=None, evpn_instance=None, import_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type import_: target_community
    :param import_: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **import_** tuple argument:  auto ;; Target VPN Extended Community

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.route_target.import_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'import_', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, import_=import_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, import_=import_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_get(self, rbridge_id=None, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_add_get(self, rbridge_id=None, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.vni_add', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_evpn_vni_get(self, rbridge_id=None, evpn_instance=None, evpn_vni=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type evpn_vni: vni_number
    :param evpn_vni: Keyword argument tuple.

    :type vni_number: long
    :param vni_number: **evpn_vni** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.evpn_vni', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.evpn_vni.route_target', u'both'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.evpn_vni.route_target', u'import_'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.evpn_vni.route_target', u'export')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_vni', 'keyval': 'vni_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_evpn_vni_rd_get(self, rbridge_id=None, evpn_instance=None, evpn_vni=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    **Instance Keyword Argument Tuple**:

    :type evpn_vni: vni_number
    :param evpn_vni: Keyword argument tuple.

    :type vni_number: long
    :param vni_number: **evpn_vni** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.evpn_vni', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.evpn_vni.route_target', u'both'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.evpn_vni.route_target', u'import_'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.evpn_vni.route_target', u'export')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_vni', 'keyval': 'vni_number', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'target_community'}, {'leafval': 'target_community'}, {'leafval': 'target_community'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_evpn_vni_route_target_get(self, rbridge_id=None, evpn_instance=None, evpn_vni=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type evpn_vni: vni_number
    :param evpn_vni: Keyword argument tuple.

    :type vni_number: long
    :param vni_number: **evpn_vni** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.evpn_vni', u'evpn_vni')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.evpn_vni.route_target', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vni_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_evpn_vni_route_target_both_get(self, rbridge_id=None, evpn_instance=None, evpn_vni=None, both=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type evpn_vni: vni_number
    :param evpn_vni: Keyword argument tuple.

    :type vni_number: long
    :param vni_number: **evpn_vni** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type both: target_community
    :param both: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **both** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '(((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4][0-9'
            ']{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(6553[0-'
            '5])):(([0-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1]['
            '0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4'
            '294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|(429496[0'
            '-6][0-9]{3})|(4294967[0-1][0-9]{2})|(42949672[0-'
            '8][0-9])|(429496729[0-5])))|((([1-9][0-9]{0,8})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])):(([1-9][0-9]{0,3})|([1-5][0-9]'
            '{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2'
            '][0-9])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9'
            ']{2}|2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9]['
            '0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9'
            ']{0,3})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4'
            '][0-9]{2})|(655[0-2][0-9])|(6553[0-5]))))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.evpn_vni', u'evpn_vni')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.evpn_vni.route_target.both', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vni_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'both', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni, both=both)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni, both=both)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_evpn_vni_route_target_export_get(self, rbridge_id=None, evpn_instance=None, evpn_vni=None, export=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type evpn_vni: vni_number
    :param evpn_vni: Keyword argument tuple.

    :type vni_number: long
    :param vni_number: **evpn_vni** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type export: target_community
    :param export: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **export** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '(((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4][0-9'
            ']{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(6553[0-'
            '5])):(([0-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1]['
            '0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4'
            '294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|(429496[0'
            '-6][0-9]{3})|(4294967[0-1][0-9]{2})|(42949672[0-'
            '8][0-9])|(429496729[0-5])))|((([1-9][0-9]{0,8})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])):(([1-9][0-9]{0,3})|([1-5][0-9]'
            '{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2'
            '][0-9])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9'
            ']{2}|2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9]['
            '0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9'
            ']{0,3})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4'
            '][0-9]{2})|(655[0-2][0-9])|(6553[0-5]))))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.evpn_vni', u'evpn_vni')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.evpn_vni.route_target.export', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vni_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'export', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni, export=export)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni, export=export)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_evpn_vni_route_target_import_get(self, rbridge_id=None, evpn_instance=None, evpn_vni=None, import_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type evpn_vni: vni_number
    :param evpn_vni: Keyword argument tuple.

    :type vni_number: long
    :param vni_number: **evpn_vni** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type import_: target_community
    :param import_: Keyword argument tuple.

    :type target_community: unicode
    :param target_community: **import_** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '(((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4][0-9'
            ']{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(6553[0-'
            '5])):(([0-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1]['
            '0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4'
            '294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|(429496[0'
            '-6][0-9]{3})|(4294967[0-1][0-9]{2})|(42949672[0-'
            '8][0-9])|(429496729[0-5])))|((([1-9][0-9]{0,8})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])):(([1-9][0-9]{0,3})|([1-5][0-9]'
            '{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2'
            '][0-9])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9'
            ']{2}|2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9]['
            '0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9'
            ']{0,3})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4'
            '][0-9]{2})|(655[0-2][0-9])|(6553[0-5]))))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.evpn_vni', u'evpn_vni')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.evpn_vni.route_target.import_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}, {'keyval': 'vni_number', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'import_', 'keyval': 'target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni, import_=import_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance, evpn_vni=evpn_vni, import_=import_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_remove_get(self, rbridge_id=None, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.vni_add', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_evpn_instance_vni_vni_add_get(self, rbridge_id=None, evpn_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_instance: instance_name
    :param evpn_instance: Keyword argument tuple.

    :type instance_name: unicode
    :param instance_name: **evpn_instance** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.evpn_instance', u'evpn_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.evpn_instance.vni.vni_add', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_instance=evpn_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fabric_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fabric', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fabric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.fabric.route.mcast', u'rbridge_id'), ('pybind.nos.v6_0_2f.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17r_2_00.fabric.route.mcast', u'rbridge_id'), ('pybind.nos.v7_2_0.fabric.route.mcast', u'rbridge_id')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}]
    leafval_map = {"pybind.slxos.v17r_2_00.rbridge_id.fabric": {}, "pybind.slxos.v17s_1_02.rbridge_id.fabric": {}, "pybind.nos.v7_2_0.rbridge_id.fabric": {"neighbor_discovery": "neighbor_discovery"}, "pybind.nos.v6_0_2f.rbridge_id.fabric": {}, "pybind.slxos.v17r_1_01a.rbridge_id.fabric": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fabric_ecmp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fabric.ecmp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fabric.ecmp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric.ecmp', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric.ecmp', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric.ecmp', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fabric_ecmp_load_balance_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fabric.ecmp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fabric.ecmp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric.ecmp', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric.ecmp', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric.ecmp', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fabric_ecmp_load_balance_hash_swap_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fabric.ecmp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fabric.ecmp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric.ecmp', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric.ecmp', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric.ecmp', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fabric_login_policy_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fabric.login_policy', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fabric.login_policy', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric.login_policy', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric.login_policy', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric.login_policy', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fabric_login_policy_duplicatewwn_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fabric_login_policy_duplicatewwn_precedence_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric.login_policy.duplicateWWN', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fabric_neighbor_discovery_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.fabric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.fabric.route.mcast', u'rbridge_id')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rbridge_id, priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fabric_port_channel_get(self, rbridge_id=None, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_channel: po_id
    :param port_channel: Keyword argument tuple.

    :type po_id: long
    :param po_id: **port_channel** tuple argument:  Port-channel id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fabric.port_channel', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fabric.port_channel', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric.port_channel', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric.port_channel', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric.port_channel', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'po_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fabric_port_channel_load_balance_get(self, rbridge_id=None, port_channel=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_channel: po_id
    :param port_channel: Keyword argument tuple.

    :type po_id: long
    :param po_id: **port_channel** tuple argument:  Port-channel id

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fabric.port_channel', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fabric.port_channel', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric.port_channel', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric.port_channel', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric.port_channel', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_channel', 'keyval': 'po_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, port_channel=port_channel)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, port_channel=port_channel)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fabric_route_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fabric.route', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fabric.route', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric.route', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric.route', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric.route', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.fabric.route.mcast', u'rbridge_id'), ('pybind.nos.v6_0_2f.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17r_2_00.fabric.route.mcast', u'rbridge_id'), ('pybind.nos.v7_2_0.fabric.route.mcast', u'rbridge_id')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fabric_route_mcast_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fabric.route.mcast', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fabric.route.mcast', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric.route.mcast', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric.route.mcast', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric.route.mcast', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.fabric.route.mcast', u'rbridge_id'), ('pybind.nos.v6_0_2f.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17r_2_00.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17s_1_02.fabric.route.mcast', u'rbridge_id')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fabric_route_mcast_priority_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fabric.route.mcast', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fabric.route.mcast', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric.route.mcast', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric.route.mcast', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric.route.mcast', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.fabric.route.mcast', u'rbridge_id'), ('pybind.nos.v6_0_2f.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17r_2_00.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17s_1_02.fabric.route.mcast', u'rbridge_id')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rbridge_id, priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fcoe_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fcoe_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fcoe_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.fcoe_config', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.fcoe_config', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.fcoe_config', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fcoe_fabric_map_get(self, rbridge_id=None, fcoe_enode_fabric_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type fcoe_enode_fabric_map: fcoe_enode_fabric_map_name
    :param fcoe_enode_fabric_map: Keyword argument tuple.

    :type fcoe_enode_fabric_map_name: unicode
    :param fcoe_enode_fabric_map_name: **fcoe_enode_fabric_map** tuple argument:  Configure an FCoE Fabric-map 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            'default'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fcoe_config.fcoe_enode_fabric_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fcoe_config.fcoe_enode_fabric_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.fcoe_config.fcoe_enode_fabric_map', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.fcoe_config.fcoe_enode_fabric_map', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.fcoe_config.fcoe_enode_fabric_map', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'fcoe_enode_fabric_map', 'keyval': 'fcoe_enode_fabric_map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, fcoe_enode_fabric_map=fcoe_enode_fabric_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, fcoe_enode_fabric_map=fcoe_enode_fabric_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fcoe_fcoe_enodes_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fcoe_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fcoe_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.fcoe_config', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.fcoe_config', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.fcoe_config', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fcsp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fcsp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fcsp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fcsp_auth_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fcsp.auth', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fcsp.auth', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fcsp_auth_auth_type_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fcsp.auth.proto', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fcsp.auth.proto', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fcsp_auth_group_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fcsp.auth.proto', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fcsp.auth.proto', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fcsp_auth_hash_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fcsp.auth.proto', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fcsp.auth.proto', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fcsp_auth_policy_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fcsp.auth.policy', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fcsp.auth.policy', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fcsp_auth_policy_switch_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fcsp.auth.policy', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fcsp.auth.policy', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_fcsp_auth_proto_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.fcsp.auth.proto', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.fcsp.auth.proto', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_filter_change_update_delay_get(self, rbridge_id=None, filter_change_update_delay=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type filter_change_update_delay: filter_delay_value
    :param filter_change_update_delay: Keyword argument tuple.

    :type filter_delay_value: long
    :param filter_delay_value: **filter_change_update_delay** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.filter_change_update_delay', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.filter_change_update_delay', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'filter_change_update_delay', 'keyval': 'filter_delay_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, filter_change_update_delay=filter_change_update_delay)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, filter_change_update_delay=filter_change_update_delay)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_kap_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.kap', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.kap', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_kap_custom_profile_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.kap.customized', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.kap.customized', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_kap_custom_profile_kap_profilename_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.kap.customized', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.kap.customized', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_kap_kap_profiletype_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.kap.predefined', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.kap.predefined', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_kap_predefined_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.kap.predefined', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.kap.predefined', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_route_table_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.route_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.route_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_route_table_maximum_paths_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.route_table.predefined.routing_parameter', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.route_table.predefined.routing_parameter', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_route_table_openflow_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.route_table.predefined.routing_parameter', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.route_table.predefined.routing_parameter', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_route_table_predefined_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.route_table.predefined', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.route_table.predefined', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'routing_profiletype'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_route_table_routing_parameter_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.route_table.predefined.routing_parameter', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.route_table.predefined.routing_parameter', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'maximum_paths, openflow_enable'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_route_table_routing_profiletype_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.route_table.predefined', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.route_table.predefined', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_tcam_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.tcam', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.tcam', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_tcam_predefined_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.tcam.predefined', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.tcam.predefined', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_tcam_tcam_profiletype_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.tcam.predefined', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.tcam.predefined', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_vlan_classification_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.vlan_classification', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.vlan_classification', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_vlan_classification_predefined_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.vlan_classification.predefined', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.vlan_classification.predefined', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_hardware_profile_vlan_classification_vlan_profiletype_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.vlan_classification.predefined', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.vlan_classification.predefined', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_host_table_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.host_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_host_table_aging_mode_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.host_table.aging_mode', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_host_table_aging_mode_conversational_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.host_table.aging_mode', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_host_table_aging_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.host_table.aging_time', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_host_table_aging_time_conversational_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.host_table.aging_time', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_http_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.http', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.http', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_http_server_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.http.server', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.http.server', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_http_server_http_vrf_cont_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.http.server.http_vrf_cont', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_http_server_shutdown_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.http.server', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.http.server', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_http_server_use_vrf_get(self, rbridge_id=None, use_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name, secure_and_plain, http_vrf_shutdown
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0..max']

    :type secure_and_plain: YANGBool
    :param secure_and_plain: **use_vrf** tuple argument:  Enable/Disable HTTP server when HTTPS certificate is installed.

    :type http_vrf_shutdown: YANGBool
    :param http_vrf_shutdown: **use_vrf** tuple argument:  Shutdown HTTP/HTTPS server on the given vrf

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.http.server.http_vrf_cont.use_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': 'use_vrf_name, secure_and_plain, http_vrf_shutdown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, use_vrf=use_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_http_server_use_vrf_secure_and_plain_get(self, rbridge_id=None, use_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0..max']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.http.server.http_vrf_cont.use_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, use_vrf=use_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_http_server_use_vrf_shutdown_get(self, rbridge_id=None, use_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0..max']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.http.server.http_vrf_cont.use_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, use_vrf=use_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'intf_loopback'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.snmp', u'trap'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'intf_loopback'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.snmp', u'trap'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.ipv6_config.address', u'ipv6_address')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'loopback', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'address'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'multinet_enable'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'shutdown'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'address, eui64, anycast'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'forwarding'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'bfd_enable'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'use_link_local_only'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'address'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'use_link_local_only'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'bfd_enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'shutdown'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'forwarding'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'address, eui64, anycast'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_address_get(self, rbridge_id=None, loopback=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/32'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_interface_loopback_ospf_conf_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ip_config_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.ip_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_multicast_boundary_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_active_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_area_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_auth_change_wait_time_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_authentication_key_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_authentication_key_auth_key_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_authentication_key_auth_key_table_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_authentication_key_encrypttype_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_authentication_key_no_encrypt_auth_key_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_authentication_key_no_encrypt_auth_key_table_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_bfd_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_bfd_intf_bfd_enable_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_cost_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_database_filter_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_database_filter_all_external_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_database_filter_all_out_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_database_filter_all_summary_external_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_dead_interval_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_hello_interval_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_md5_authentication_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_md5_authentication_key_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_md5_authentication_key_activation_wait_time_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_md5_authentication_key_id_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_md5_authentication_key_id_key_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_md5_authentication_key_id_key_id_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_md5_authentication_key_id_md5_authentication_key_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_md5_authentication_no_encrypt_key_table_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_encrypt_key_id, no_encrypt_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_mtu_ignore_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_network_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_passive_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_priority_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_retransmit_interval_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_ospf_transmit_delay_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.interface_loopback_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_pim_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_pim_dr_priority_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_pim_int_cmd_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_pim_intf_lo_cont_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_pim_multinet_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_pim_multinet_enable_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_pim_neighbor_filter_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ip_pim_sparse_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ip.pim_intf_lo_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_address_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_address_ipv6_address_get(self, rbridge_id=None, loopback=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, eui64, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type eui64: YANGBool
    :param eui64: **ipv6_address** tuple argument:  Configure ipv6 address with an automatically computed EUI-64 interface Id

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, eui64, anycast'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_address_ipv6_address_anycast_get(self, rbridge_id=None, loopback=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_address_ipv6_address_eui_64_get(self, rbridge_id=None, loopback=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_address_link_local_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_address_link_local_address_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_address_link_local_config_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_address_use_link_local_only_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.ipv6_config.address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ipv6_config_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.ipv6_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.ipv6_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_active_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_area_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_ah_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_esp_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_esp_auth_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_esp_key_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_esp_no_encrypt_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_ipsec_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_ipsec_auth_key_config_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_ipsec_disable_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_ipsec_key_add_remove_interval_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_key_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_no_encrypt_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_authentication_spi_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_bfd_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_bfd_bfd_enable_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_cost_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_dead_interval_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_hello_interval_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_hello_jitter_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_instance_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_link_interval_properties_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_mtu_ignore_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_network_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_passive_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_priority_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_retransmit_interval_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_suppress_linklsa_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_ipv6_ospf_transmit_delay_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_shutdown_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.intf_loopback', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.intf_loopback', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_snmp_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.snmp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.snmp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_snmp_trap_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.snmp.trap', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.snmp.trap', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_snmp_trap_link_status_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.snmp.trap', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.snmp.trap', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_vrf_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_loopback_vrf_forwarding_get(self, rbridge_id=None, loopback=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type loopback: id
    :param loopback: Keyword argument tuple.

    :type id: long
    :param id: **loopback** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.loopback', u'loopback')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.loopback.vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.loopback.vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, loopback=loopback)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, loopback=loopback)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_nodespecific_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface_nodespecific', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface_nodespecific', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.interface_nodespecific', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.interface_nodespecific', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.interface_nodespecific', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_nodespecific_ns_ethernet_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface_nodespecific', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface_nodespecific', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.interface_nodespecific', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.interface_nodespecific', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.interface_nodespecific', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_nodespecific_ns_vlan_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface_nodespecific', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface_nodespecific', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.interface_nodespecific', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.interface_nodespecific', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.interface_nodespecific', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'vrrpv3'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'access_group'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u'vrrp'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'ipv6_anycast_address'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u'vrrpe'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.igmp', u'static_group'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip', u'ip_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip', u'icmp'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip', u'ip_config'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.snmp', u'trap'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip', u'ip_anycast_address'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'ipv6_ve_intf_cmds'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip', u'igmp'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'vrrpv3e'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u'rpf'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.pim_intf_vlan_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', u'ipv6_local_anycast_gateway'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip', u'ip_config'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.snmp', u'trap'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip', u'icmp'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u'vrrpe'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip', u'ip_local_anycast_gateway'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u'vrrp'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip', u'igmp'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', u'vrrpv3'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', u'vrrpv3e'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', u'ipv6_ve_intf_cmds'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.igmp', u'static_group'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', u'link_interval_properties')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u've', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'route_map_name'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'multinet_enable'}, {'leafval': 'ipv6_address'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'attempts, time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'sg_addr'}, {'leafval': 'gateway'}, {'leafval': 'mtu'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'local_ip_gw_id, enable_local, disable_local'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'learn_any'}, {'leafval': 'expire'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'ip_address'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'bfd_enable'}, {'leafval': 'local_ipv6_gw_id, enable_local, disable_local'}, {'leafval': 'max_interval, min_'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'log, mode'}, {'leafval': 'use_link_local_only'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'forwarding'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'local_ipv6_gw_id, enable_local, disable_local'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'mtu'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'forwarding'}, {'leafval': 'local_ip_gw_id, enable_local, disable_local'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'gateway'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'use_link_local_only'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'expire'}, {'leafval': 'max_interval, min_'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'bfd_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'route_map_name'}, {'leafval': 'attempts, time'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sg_addr'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_bfd_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_bfd_interval_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_bfd_interval_min_rx_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_bfd_interval_min_tx_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_bfd_interval_multiplier_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_bfd_shutdown_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_access_group_get(self, rbridge_id=None, ve=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip_acl_interface.ip.access_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': 'ip_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_access_group_traffic_type_get(self, rbridge_id=None, ve=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ip_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ip_access_list: unicode
    :param ip_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip_acl_interface.ip.access_group', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip_acl_interface.ip.access_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ip_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_address_get(self, rbridge_id=None, ve=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address, secondary, ospf_passive, ospf_ignore
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type secondary: YANGBool
    :param secondary: **address** tuple argument:  Secondary ip address on the specific interface

    :type ospf_passive: YANGBool
    :param ospf_passive: **address** tuple argument:  ospf pasive address on the specific interface

    :type ospf_ignore: YANGBool
    :param ospf_ignore: **address** tuple argument:  ospf active address on the specific interface

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': 'address, secondary, ospf_passive, ospf_ignore'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_address_ospf_ignore_get(self, rbridge_id=None, ve=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_address_ospf_passive_get(self, rbridge_id=None, ve=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_address_secondary_get(self, rbridge_id=None, ve=None, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_config.address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_anycast_address_get(self, rbridge_id=None, ve=None, ip_anycast_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_anycast_address: ip_address
    :param ip_anycast_address: Keyword argument tuple.

    :type ip_address: unicode
    :param ip_address: **ip_anycast_address** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_anycast_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_anycast_address', 'keyval': 'ip_address', 'extra_keyval': 'ip_address'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_anycast_address=ip_anycast_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_anycast_address=ip_anycast_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_arp_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_config.arp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_arp_aging_timeout_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_arp_learn_any_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_config.arp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_dhcp_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_dhcp_relay_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_dhcp_relay_gateway_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_dhcp_relay_servers_get(self, rbridge_id=None, ve=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  A.B.C.D;; IP address of the DHCP server

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCP server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr, server_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_directed_broadcast_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_get(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'load_balancing'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'next_hop'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'load_balancing'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'next_hop'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_local_anycast_gateway', 'keyval': 'local_ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, threshold_priority'}, {'leafval': 'interface_type, interface_name, interface_priority'}, {'leafval': 'next_hop_address, next_hop_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'next_hop_address, next_hop_priority'}, {'leafval': 'interface_type, interface_name, interface_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_disable_get(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'load_balancing'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'next_hop'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'load_balancing'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'next_hop'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_local_anycast_gateway', 'keyval': 'local_ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, threshold_priority'}, {'leafval': 'interface_type, interface_name, interface_priority'}, {'leafval': 'next_hop_address, next_hop_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'next_hop_address, next_hop_priority'}, {'leafval': 'interface_type, interface_name, interface_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_enable_get(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'load_balancing'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'next_hop'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'load_balancing'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'next_hop'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ip_local_anycast_gateway', 'keyval': 'local_ip_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'basic, threshold_priority'}, {'leafval': 'interface_type, interface_name, interface_priority'}, {'leafval': 'next_hop_address, next_hop_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'next_hop_address, next_hop_priority'}, {'leafval': 'interface_type, interface_name, interface_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_load_balancing_get(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_load_balancing_basic_get(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_load_balancing_threshold_priority_get(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.load_balancing', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_track_get(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_track_interface_get(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_track_interface_priority_get(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_track_network_get(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_track_network_priority_get(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument.

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_track_next_hop_get(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, next_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type next_hop: next_hop_address
    :param next_hop: Keyword argument tuple.

    :type next_hop_address: unicode
    :param next_hop_address: **next_hop** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop', 'keyval': 'next_hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, next_hop=next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, next_hop=next_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_fabric_virtual_gateway_track_next_hop_priority_get(self, rbridge_id=None, ve=None, ip_local_anycast_gateway=None, next_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ip_local_anycast_gateway: local_ip_gw_id
    :param ip_local_anycast_gateway: Keyword argument tuple.

    :type local_ip_gw_id: long
    :param local_ip_gw_id: **ip_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type next_hop: next_hop_address
    :param next_hop: Keyword argument tuple.

    :type next_hop_address: unicode
    :param next_hop_address: **next_hop** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway', u'ip_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_local_anycast_gateway.track.next_hop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ip_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop', 'keyval': 'next_hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, next_hop=next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ip_local_anycast_gateway=ip_local_anycast_gateway, next_hop=next_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_icmp_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_icmp_address_mask_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_icmp_echo_reply_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_icmp_rate_limiting_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_icmp_redirect_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_icmp_unreachable_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.icmp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_igmp_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_igmp_immediate_leave_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_igmp_last_member_query_interval_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_igmp_query_interval_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_igmp_query_max_response_time_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.igmp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_igmp_static_group_get(self, rbridge_id=None, ve=None, static_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_group: sg_addr
    :param static_group: Keyword argument tuple.

    :type sg_addr: unicode
    :param sg_addr: **static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.igmp.static_group', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.igmp.static_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'sg_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, static_group=static_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_interface_ve_dhcp_conf_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_interface_vlan_ospf_conf_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ip_acl_interface_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip_acl_interface.ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip_acl_interface.ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ip_config_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ip_pbr_interface_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip_pbr_interface.ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip_pbr_interface.ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_mtu_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_multicast_boundary_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_active_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_area_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_auth_change_wait_time_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_authentication_key_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_authentication_key_auth_key_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_authentication_key_auth_key_table_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_authentication_key_encrypttype_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_authentication_key_no_encrypt_auth_key_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_authentication_key_no_encrypt_auth_key_table_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_bfd_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_bfd_intf_bfd_enable_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_cost_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_database_filter_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_database_filter_all_external_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_database_filter_all_out_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_database_filter_all_summary_external_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.database_filter', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_dead_interval_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_hello_interval_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_md5_authentication_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_md5_authentication_key_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_md5_authentication_key_activation_wait_time_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_md5_authentication_key_id_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_md5_authentication_key_id_key_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_md5_authentication_key_id_key_id_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_md5_authentication_key_id_md5_authentication_key_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_md5_authentication_no_encrypt_key_table_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_encrypt_key_id, no_encrypt_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_mtu_ignore_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_network_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_passive_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_priority_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_retransmit_interval_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_ospf_transmit_delay_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_pbr_interface_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip_pbr_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip_pbr_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_pim_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_pim_dr_priority_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_pim_int_cmd_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_pim_intf_vlan_cont_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.pim_intf_vlan_cont', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_pim_multinet_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_pim_multinet_enable_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim.multinet', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_pim_neighbor_filter_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_pim_sparse_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_policy_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip_pbr_interface.ip.policy', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip_pbr_interface.ip.policy', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_policy_route_map_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_policy_route_map_route_map_name_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip_pbr_interface.ip.policy.route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ip_proxy_arp_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_access_group_get(self, rbridge_id=None, ve=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': 'ipv6_access_list, ip_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_access_group_traffic_type_get(self, rbridge_id=None, ve=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: ipv6_access_list, ip_direction
    :param access_group: Keyword argument tuple.

    :type ipv6_access_list: unicode
    :param ipv6_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type ip_direction: unicode
    :param ip_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.access_group', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.access_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'ipv6_access_list, ip_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_ipv6_address_get(self, rbridge_id=None, ve=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_ipv6_address_anycast_get(self, rbridge_id=None, ve=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_ipv6_address_eui_64_get(self, rbridge_id=None, ve=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_ipv6_address_secondary_get(self, rbridge_id=None, ve=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_address: address
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'eui_config'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'eui_config')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'eui64, eui_secondary'}, {'leafval': 'eui64, eui_secondary'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_ipv6_address_secondary_eui_config_get(self, rbridge_id=None, ve=None, ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_address: address, secondary, anycast
    :param ipv6_address: Keyword argument tuple.

    :type address: unicode
    :param address: **ipv6_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type secondary: YANGBool
    :param secondary: **ipv6_address** tuple argument:  Configure Secondary ipv6 address on an interface

    :type anycast: YANGBool
    :param anycast: **ipv6_address** tuple argument:  Configure ipv6 address as anycast

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address', u'ipv6_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.ipv6_address.eui_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': 'address, secondary, anycast'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_address=ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_link_local_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_link_local_address_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_link_local_config_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address.link_local_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'link_local_address, link_local'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_address_use_link_local_only_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_anycast_address_get(self, rbridge_id=None, ve=None, ipv6_anycast_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_anycast_address: ipv6_address
    :param ipv6_anycast_address: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **ipv6_anycast_address** tuple argument:  A:B::C:D/LEN;; IPv6 prefix format: xxxx:xxxx/ml, xxxx:xxxx::/ml, xxxx::xx/128

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_anycast_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_anycast_address', 'keyval': 'ipv6_address', 'extra_keyval': 'ipv6_address'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_anycast_address=ipv6_anycast_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_anycast_address=ipv6_anycast_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_dhcp_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_dhcp_relay_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_dhcp_relay_servers_get(self, rbridge_id=None, ve=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_dhcp_relay_servers_interface_get(self, rbridge_id=None, ve=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_dhcp_relay_servers_interface_interface_get(self, rbridge_id=None, ve=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_dhcp_relay_servers_interface_interface_name_get(self, rbridge_id=None, ve=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type servers: relay_ip_addr, server_vrf_name
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type server_vrf_name: unicode
    :param server_vrf_name: **servers** tuple argument:  VRF name of the DHCPv6 server

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'servers')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'relay_ip_addr', 'extra_keyval': 'relay_ip_addr, server_vrf_name'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_dhcp_relay_servers_use_vrf_get(self, rbridge_id=None, ve=None, servers=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type servers: relay_ip_addr
    :param servers: Keyword argument tuple.

    :type relay_ip_addr: unicode
    :param relay_ip_addr: **servers** tuple argument:  IPv6 address of the DHCPv6 server

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay.servers', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'servers', 'keyval': 'relay_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, servers=servers)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, servers=servers)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_get(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_next_hop'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'load_balancing'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_next_hop'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'load_balancing')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_local_anycast_gateway', 'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_network_address, ipv6_network_priority'}, {'leafval': 'ipv6_interface_type, ipv6_interface_name, ipv6_interface_priority'}, {'leafval': 'ipv6_next_hop_address, ipv6_next_hop_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'ipv6_next_hop_address, ipv6_next_hop_priority'}, {'leafval': 'ipv6_network_address, ipv6_network_priority'}, {'leafval': 'ipv6_interface_type, ipv6_interface_name, ipv6_interface_priority'}, {'leafval': 'basic, threshold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_disable_get(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_next_hop'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'load_balancing'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_next_hop'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'load_balancing')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_local_anycast_gateway', 'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_network_address, ipv6_network_priority'}, {'leafval': 'ipv6_interface_type, ipv6_interface_name, ipv6_interface_priority'}, {'leafval': 'ipv6_next_hop_address, ipv6_next_hop_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'ipv6_next_hop_address, ipv6_next_hop_priority'}, {'leafval': 'ipv6_network_address, ipv6_network_priority'}, {'leafval': 'ipv6_interface_type, ipv6_interface_name, ipv6_interface_priority'}, {'leafval': 'basic, threshold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_enable_get(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_next_hop'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'load_balancing'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_next_hop'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', u'ipv6_interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'load_balancing')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_local_anycast_gateway', 'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_network_address, ipv6_network_priority'}, {'leafval': 'ipv6_interface_type, ipv6_interface_name, ipv6_interface_priority'}, {'leafval': 'ipv6_next_hop_address, ipv6_next_hop_priority'}, {'leafval': 'basic, threshold_priority'}, {'leafval': 'ipv6_next_hop_address, ipv6_next_hop_priority'}, {'leafval': 'ipv6_network_address, ipv6_network_priority'}, {'leafval': 'ipv6_interface_type, ipv6_interface_name, ipv6_interface_priority'}, {'leafval': 'basic, threshold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_load_balancing_get(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_load_balancing_basic_get(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_load_balancing_threshold_priority_get(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.load_balancing', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_track_get(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_track_interface_get(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, ipv6_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_interface: ipv6_interface_type, ipv6_interface_name
    :param ipv6_interface: Keyword argument tuple.

    :type ipv6_interface_type: unicode
    :param ipv6_interface_type: **ipv6_interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type ipv6_interface_name: unicode
    :param ipv6_interface_name: **ipv6_interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_interface', 'keyval': 'ipv6_interface_type, ipv6_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_interface=ipv6_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_interface=ipv6_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_track_interface_priority_get(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, ipv6_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_interface: ipv6_interface_type, ipv6_interface_name
    :param ipv6_interface: Keyword argument tuple.

    :type ipv6_interface_type: unicode
    :param ipv6_interface_type: **ipv6_interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type ipv6_interface_name: unicode
    :param ipv6_interface_name: **ipv6_interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_interface', 'keyval': 'ipv6_interface_type, ipv6_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_interface=ipv6_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_interface=ipv6_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_track_network_get(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, ipv6_network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_network: ipv6_network_address
    :param ipv6_network: Keyword argument tuple.

    :type ipv6_network_address: unicode
    :param ipv6_network_address: **ipv6_network** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_network', 'keyval': 'ipv6_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_network=ipv6_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_network=ipv6_network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_track_network_priority_get(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, ipv6_network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_network: ipv6_network_address
    :param ipv6_network: Keyword argument tuple.

    :type ipv6_network_address: unicode
    :param ipv6_network_address: **ipv6_network** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_network', 'keyval': 'ipv6_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_network=ipv6_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_network=ipv6_network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_track_next_hop_get(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, ipv6_next_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_next_hop: ipv6_next_hop_address
    :param ipv6_next_hop: Keyword argument tuple.

    :type ipv6_next_hop_address: unicode
    :param ipv6_next_hop_address: **ipv6_next_hop** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_next_hop', 'keyval': 'ipv6_next_hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_next_hop=ipv6_next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_next_hop=ipv6_next_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_fabric_virtual_gateway_track_next_hop_priority_get(self, rbridge_id=None, ve=None, ipv6_local_anycast_gateway=None, ipv6_next_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ipv6_local_anycast_gateway: local_ipv6_gw_id
    :param ipv6_local_anycast_gateway: Keyword argument tuple.

    :type local_ipv6_gw_id: long
    :param local_ipv6_gw_id: **ipv6_local_anycast_gateway** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_next_hop: ipv6_next_hop_address
    :param ipv6_next_hop: Keyword argument tuple.

    :type ipv6_next_hop_address: unicode
    :param ipv6_next_hop_address: **ipv6_next_hop** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway', u'ipv6_local_anycast_gateway')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_local_anycast_gateway.ipv6_track.ipv6_next_hop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'local_ipv6_gw_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_next_hop', 'keyval': 'ipv6_next_hop_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_next_hop=ipv6_next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, ipv6_local_anycast_gateway=ipv6_local_anycast_gateway, ipv6_next_hop=ipv6_next_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_hop_by_hop_trap_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_icmpv6_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_icmpv6_echo_reply_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_icmpv6_rate_limiting_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_icmpv6_redirect_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_icmpv6_unreachable_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.icmpv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_interface_ve_dhcp_conf_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ipv6_config_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ipv6_intf_cmds_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ipv6_nd_ra_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ipv6_ve_intf_cmds_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_ve_intf_cmds', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_mtu_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd": {"managed_config_flag": "managed_config_flag", "broadcast_mac_trap": "broadcast_mac_trap", "ra_lifetime": "ra_lifetime", "hoplimit": "hoplimit", "mtu": "mtu", "retrans_timer": "retrans_timer", "other_config_flag": "other_config_flag", "ns_interval": "ns_interval", "reachable_time": "reachable_time", "proxy": "proxy"}, "pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_broadcast_mac_trap_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_cache_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'expire'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_cache_expire_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.cache', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_dad_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_dad_attempts_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_dad_time_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.dad', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_hoplimit_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_managed_config_flag_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_mtu_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_ns_interval_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_nud_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_nud_retry_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'base, interval, max_attempts'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_nud_retry_base_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_nud_retry_interval_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_nud_retry_max_attempts_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud.retry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_other_config_flag_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_get(self, rbridge_id=None, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', u'prefix_flags'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'lifetime'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', u'preferred')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix', 'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_autoconfig, no_onlink, off_link'}, {'leafval': 'preferred_lifetime, preferred_infinite'}, {'leafval': 'no_advertise, valid_lifetime, valid_infinite'}, {'leafval': 'no_autoconfig, no_onlink, off_link'}, {'leafval': 'no_advertise, valid_lifetime, valid_infinite'}, {'leafval': 'preferred_lifetime, preferred_infinite'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_infinite_get(self, rbridge_id=None, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_infinite_preferred_get(self, rbridge_id=None, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_no_advertise_get(self, rbridge_id=None, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_no_autoconfig_get(self, rbridge_id=None, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_no_onlink_get(self, rbridge_id=None, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_off_link_get(self, rbridge_id=None, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_preferred_get(self, rbridge_id=None, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'preferred_lifetime, preferred_infinite'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime'], 'pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred': [u'preferred_infinite', u'preferred_lifetime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_preferred_lifetime_get(self, rbridge_id=None, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_prefix_flags_get(self, rbridge_id=None, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime.preferred.prefix_flags', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_autoconfig, no_onlink, off_link'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_prefix_valid_lifetime_get(self, rbridge_id=None, ve=None, prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type prefix: prefix_ipv6_address
    :param prefix: Keyword argument tuple.

    :type prefix_ipv6_address: unicode
    :param prefix_ipv6_address: **prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix', u'prefix')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.prefix.lifetime', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'prefix_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, prefix=prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_proxy_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_ra_interval_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_interval, min_'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_ra_interval_max_interval_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_ra_interval_min_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.ra_interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_ra_lifetime_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_reachable_time_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_retrans_timer_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_set_cache_expire_time_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_set_hoplimit_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_suppress_ra_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_suppress_ra_all_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_suppress_ra_mtu_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_nd_suppress_ra_suppress_ra_flag_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.suppress_ra', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_neighbor_get(self, rbridge_id=None, ve=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_neighbor_hardware_address_get(self, rbridge_id=None, ve=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor: ipv6_address
    :param neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **neighbor** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.neighbor', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_active_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_area_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_ah_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_esp_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_esp_auth_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_esp_key_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_esp_no_encrypt_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_ipsec_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_ipsec_auth_key_config_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config': [u'ah', u'esp']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_ipsec_disable_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_ipsec_key_add_remove_interval_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_key_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_no_encrypt_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_authentication_spi_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_bfd_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_bfd_bfd_enable_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_cost_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_dead_interval_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_hello_interval_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_hello_jitter_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_instance_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_link_interval_properties_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_mtu_ignore_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_network_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_passive_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_priority_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_retransmit_interval_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_suppress_linklsa_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_ospf_transmit_delay_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_policy_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.policy', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.policy', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_policy_route_map_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.policy.route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.policy.route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_policy_route_map_ipv6_route_map_name_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.policy.route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.policy.route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_advertise_backup_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_advertisement_interval_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_advertisement_interval_scale_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_backup_advertisement_interval_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_description_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_enable_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_hold_time_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_nd_advertisement_timer_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_preempt_mode_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_priority_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'virtual_mac'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3e', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'vmac'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_short_path_forwarding_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_short_path_forwarding_basic_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_short_path_forwarding_revert_priority_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_track_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_track_interface_get(self, rbridge_id=None, ve=None, vrrpv3e=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_track_interface_priority_get(self, rbridge_id=None, ve=None, vrrpv3e=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_track_network_get(self, rbridge_id=None, ve=None, vrrpv3e=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  XXXX::YYYY/L;;IPv6 global address prefix in ipv6-address/Prefix length format

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_track_network_priority_get(self, rbridge_id=None, ve=None, vrrpv3e=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  XXXX::YYYY/L;;IPv6 global address prefix in ipv6-address/Prefix length format

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.track.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_virtual_ip_get(self, rbridge_id=None, ve=None, vrrpv3e=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.virtual_ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.virtual_ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_virtual_mac_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.virtual_mac', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.virtual_mac', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_extended_group_virtual_mac_02e0_5200_00xx_get(self, rbridge_id=None, ve=None, vrrpv3e=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3e: vrid
    :param vrrpv3e: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3e** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e', u'vrrpv3e')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3e.virtual_mac', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3e.virtual_mac', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3e=vrrpv3e)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_get(self, rbridge_id=None, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_advertisement_interval_get(self, rbridge_id=None, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_description_get(self, rbridge_id=None, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_enable_get(self, rbridge_id=None, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_hold_time_get(self, rbridge_id=None, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_preempt_mode_get(self, rbridge_id=None, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_priority_get(self, rbridge_id=None, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_track_get(self, rbridge_id=None, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3.track', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3.track', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_track_interface_get(self, rbridge_id=None, ve=None, vrrpv3=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_track_interface_priority_get(self, rbridge_id=None, ve=None, vrrpv3=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3.track.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_use_v2_checksum_get(self, rbridge_id=None, ve=None, vrrpv3=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpv3', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_group_virtual_ip_get(self, rbridge_id=None, ve=None, vrrpv3=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpv3: vrid
    :param vrrpv3: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpv3** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3', u'vrrpv3')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.vrrpv3.virtual_ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.vrrpv3.virtual_ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpv3=vrrpv3, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_ipv6_vrrp_suppress_interface_ra_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_log_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.rpf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_rpf_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.rpf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_rpf_mode_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.rpf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_shutdown_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'vrrpv3'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'access_group'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont', u'pim_int_cmd'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u'vrrp'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', u'pim'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd.pim', u'multinet'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'ipv6_anycast_address'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u'vrrpe'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', u'link_interval_properties'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.igmp', u'static_group'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'ipv6_config'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.policy', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip', u'ip_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip', u'icmp'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_config', u'address'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip', u'ip_config'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.ip_config', u'arp'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.snmp', u'trap'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip', u'ip_anycast_address'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'ipv6_ve_intf_cmds'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip', u'igmp'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'ipv6_local_anycast_gateway'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'vrrpv3e'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6', u'icmpv6'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u'rpf'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_config', u'address'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip_acl_interface.ip', u'access_group'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.pim_intf_vlan_cont', u'pim_int_cmd'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', u'ipv6_local_anycast_gateway'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip', u'ip_config'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf', u'ospf_interface_config'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.snmp', u'trap'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', u'ipv6_config'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip', u'icmp'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u'vrrpe'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', u'interface_ospfv3_conf'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip', u'ip_local_anycast_gateway'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address', u'link_local_config'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp', u'relay'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u'vrrp'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config', u'address'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.ip_config', u'address'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'cache'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'ra_interval'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', u'icmpv6'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip', u'igmp'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'nd'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra', u'ipv6_intf_cmds'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key', u'auth_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', u'database_filter'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ve_dhcp_conf.dhcp.relay', u'servers'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_config.address', u'ipv6_address'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds', u'neighbor'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'prefix'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.policy', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', u'md5_authentication'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd.nud', u'retry'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'suppress_ra'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip_pbr_interface.ip.policy', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.ipv6_nd_ra.ipv6_intf_cmds.nd', u'dad'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', u'vrrpv3'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', u'vrrpv3e'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.pim_intf_vlan_cont.pim_int_cmd', u'pim'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', u'ipv6_ve_intf_cmds'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6', u'access_group'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf.authentication', u'ipsec'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.igmp', u'static_group'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ip.interface_vlan_ospf_conf.ospf_interface_config', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.ipv6.interface_ospfv3_conf', u'link_interval_properties')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u've', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'route_map_name'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'multinet_enable'}, {'leafval': 'ipv6_address'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'attempts, time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'sg_addr'}, {'leafval': 'gateway'}, {'leafval': 'mtu'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, set_hoplimit, set_cache_expire_time, ns_interval, proxy'}, {'leafval': 'local_ip_gw_id, enable_local, disable_local'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'learn_any'}, {'leafval': 'expire'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'ip_address'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'bfd_enable'}, {'leafval': 'local_ipv6_gw_id, enable_local, disable_local'}, {'leafval': 'max_interval, min_'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'log, mode'}, {'leafval': 'use_link_local_only'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'forwarding'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'ip_access_list, ip_direction, traffic_type'}, {'leafval': 'pim_sparse, mcast_bdry_prefix_list'}, {'leafval': 'local_ipv6_gw_id, enable_local, disable_local'}, {'leafval': 'mtu, directed_broadcast, proxy_arp, arp_aging_timeout'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'area, auth_change_wait_time, dead_interval, hello_interval, retransmit_interval, transmit_delay, cost, mtu_ignore, network, active, passive, priority'}, {'leafval': 'link_snmp_trap_status'}, {'leafval': 'mtu'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect, address_mask'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'vrid, virtual_mac, advertisement_interval, enable, hold_time, preempt_mode, priority, description, advertise_backup, vrrpe_garp_timer, backup_advertisement_interval, advertisement_interval_scale'}, {'leafval': 'interface_area, active, passive, cost, instance, mtu_ignore, network, priority, suppress_linklsa'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'forwarding'}, {'leafval': 'local_ip_gw_id, enable_local, disable_local'}, {'leafval': 'link_local_address, link_local'}, {'leafval': 'gateway'}, {'leafval': 'vrid, version, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'use_link_local_only'}, {'leafval': 'address, secondary, ospf_passive, ospf_ignore'}, {'leafval': 'expire'}, {'leafval': 'max_interval, min_'}, {'leafval': 'echo_reply, rate_limiting, unreachable, redirect'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time, immediate_leave'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'managed_config_flag, other_config_flag, broadcast_mac_trap, ra_lifetime, reachable_time, mtu, retrans_timer, hoplimit, ns_interval, proxy'}, {'leafval': 'vrrp_suppress_interface_ra'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'all_out, all_external, all_summary_external'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'relay_ip_addr, server_vrf_name'}, {'leafval': 'address, secondary, anycast'}, {'leafval': 'ipv6_address, hardware_address'}, {'leafval': 'bfd_shutdown'}, {'leafval': 'prefix_ipv6_address'}, {'leafval': 'bfd_enable'}, {'leafval': 'ipv6_route_map_name'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'base, interval, max_attempts'}, {'leafval': 'suppress_ra_flag, suppress_ra_mtu, suppress_ra_all'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'route_map_name'}, {'leafval': 'attempts, time'}, {'leafval': 'vrid, use_v2_checksum, advertisement_interval, enable, hold_time, preempt_mode, priority, description'}, {'leafval': 'vrid, enable, hold_time, preempt_mode, priority, description, advertise_backup, nd_advertisement_timer, advertisement_interval_scale, backup_advertisement_interval, vrrpe_advertisement_interval'}, {'leafval': 'neighbor_filter, dr_priority'}, {'leafval': 'hop_by_hop_trap'}, {'leafval': 'ipv6_access_list, ip_direction, traffic_type'}, {'leafval': 'ipsec_authentication_disable, ifc_key_add_remove_interval'}, {'leafval': 'sg_addr'}, {'leafval': 'intf_bfd_enable'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_snmp_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.snmp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.snmp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_snmp_trap_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.snmp.trap', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.snmp.trap', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_snmp_trap_link_status_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.snmp.trap', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.snmp.trap', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrf_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrf_forwarding_get(self, rbridge_id=None, ve=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_advertise_backup_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_advertisement_interval_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_advertisement_interval_scale_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_arp_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.arp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.arp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_arp_unicast_request_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.arp.unicast_request', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.arp.unicast_request', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_arp_unicast_request_receive_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.arp.unicast_request', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.arp.unicast_request', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_backup_advertisement_interval_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_description_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_enable_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_hold_time_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_preempt_mode_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_priority_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_short_path_forwarding_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'basic, revert_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_short_path_forwarding_basic_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_short_path_forwarding_revert_priority_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.short_path_forwarding', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.short_path_forwarding', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_track_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_track_interface_get(self, rbridge_id=None, ve=None, vrrpe=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_track_interface_priority_get(self, rbridge_id=None, ve=None, vrrpe=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_track_network_get(self, rbridge_id=None, ve=None, vrrpe=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  IPv4 global address

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_track_network_priority_get(self, rbridge_id=None, ve=None, vrrpe=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_address
    :param network: Keyword argument tuple.

    :type network_address: unicode
    :param network_address: **network** tuple argument:  IPv4 global address

        * pattern restriction: ::

            '(([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]'
            '|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0'
            '-4][0-9]|25[0-5])/(([1-9])|([1-2][0-9])|(3[0-1])'
            ')'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_virtual_ip_get(self, rbridge_id=None, ve=None, vrrpe=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'vrrpe'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'vrrpe')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.virtual_ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.virtual_ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_virtual_mac_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_extended_group_vrrpe_garp_timer_get(self, rbridge_id=None, ve=None, vrrpe=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrpe: vrid
    :param vrrpe: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrpe** tuple argument.

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'network'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.track', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'short_path_forwarding'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrpe', u'virtual_ip')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrpe', 'keyval': 'vrid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'network_address, network_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'network_address, network_priority'}, {'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'basic, revert_priority'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrpe=vrrpe)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_get(self, rbridge_id=None, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_advertisement_interval_get(self, rbridge_id=None, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_arp_get(self, rbridge_id=None, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', u'vrrp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.arp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.arp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_arp_unicast_request_get(self, rbridge_id=None, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.arp.unicast_request', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_arp_unicast_request_receive_get(self, rbridge_id=None, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.arp.unicast_request', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.arp.unicast_request', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_description_get(self, rbridge_id=None, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_enable_get(self, rbridge_id=None, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_hold_time_get(self, rbridge_id=None, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_preempt_mode_get(self, rbridge_id=None, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_priority_get(self, rbridge_id=None, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_track_get(self, rbridge_id=None, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.track', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.track', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_track_interface_get(self, rbridge_id=None, ve=None, vrrp=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.track.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.track.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_track_interface_priority_get(self, rbridge_id=None, ve=None, vrrp=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type interface: interface_type, interface_name
    :param interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'port-channel']

    :type interface_name: unicode
    :param interface_name: **interface** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.track.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.track.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_use_v2_checksum_get(self, rbridge_id=None, ve=None, vrrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.track', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', u'virtual_ip'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.arp', u'unicast_request'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', u'virtual_ip'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.track', u'interface')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrrp', 'keyval': 'vrid, version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name, track_priority'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'receive'}, {'leafval': 'receive'}, {'leafval': 'virtual_ipaddr'}, {'leafval': 'interface_type, interface_name, track_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_interface_ve_vrrp_group_virtual_ip_get(self, rbridge_id=None, ve=None, vrrp=None, virtual_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ve: name
    :param ve: Keyword argument tuple.

    :type name: long
    :param name: **ve** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrrp: vrid, version
    :param vrrp: Keyword argument tuple.

    :type vrid: int
    :param vrid: **vrrp** tuple argument.

        * range restriction: ::

            ['0..255']

    :type version: int
    :param version: **vrrp** tuple argument:  Set VRRP version 2/3

        * range restriction: ::

            ['0..255']

    **Instance Keyword Argument Tuple**:

    :type virtual_ip: virtual_ipaddr
    :param virtual_ip: Keyword argument tuple.

    :type virtual_ipaddr: unicode
    :param virtual_ipaddr: **virtual_ip** tuple argument:  Virtual IPv4 address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve', u've'), ('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp', u'vrrp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve', u've'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp', u'vrrp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.interface.ve.vrrp.virtual_ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.interface.ve.vrrp.virtual_ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'vrid, version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_ip', 'keyval': 'virtual_ipaddr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp, virtual_ip=virtual_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ve=ve, vrrp=vrrp, virtual_ip=virtual_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ip', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ip', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ip', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_anycast_gateway_mac_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.ip.static_ag_ip_config.anycast_gateway_mac', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_anycast_gateway_mac_default_mac_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.ip.static_ag_ip_config.anycast_gateway_mac', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_anycast_gateway_mac_ip_anycast_gateway_mac_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.ip.static_ag_ip_config.anycast_gateway_mac', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_as_path_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.as_path', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.as_path', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_as_path_access_list_get(self, rbridge_id=None, access_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_list: name, seq_keyword, instance, ip_action, ip_reg_expr
    :param access_list: Keyword argument tuple.

    :type name: unicode
    :param name: **access_list** tuple argument.

        * length restriction: ::

            ['1..32']

    :type seq_keyword: unicode
    :param seq_keyword: **access_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **access_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ip_action: unicode
    :param ip_action: **access_list** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ip_reg_expr: unicode
    :param ip_reg_expr: **access_list** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.as_path.access_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.as_path.access_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, access_list=access_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, access_list=access_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_as_path_access_list_ip_action_get(self, rbridge_id=None, access_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_list: name, seq_keyword, instance
    :param access_list: Keyword argument tuple.

    :type name: unicode
    :param name: **access_list** tuple argument.

        * length restriction: ::

            ['1..32']

    :type seq_keyword: unicode
    :param seq_keyword: **access_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **access_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.as_path.access_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.as_path.access_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, access_list=access_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, access_list=access_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_as_path_access_list_ip_reg_expr_get(self, rbridge_id=None, access_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_list: name, seq_keyword, instance
    :param access_list: Keyword argument tuple.

    :type name: unicode
    :param name: **access_list** tuple argument.

        * length restriction: ::

            ['1..32']

    :type seq_keyword: unicode
    :param seq_keyword: **access_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **access_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.as_path.access_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.as_path.access_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, access_list=access_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, access_list=access_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_community_list_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.community_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.community_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ip.community_list', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ip.community_list', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ip.community_list', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_community_list_extended_get(self, rbridge_id=None, extended=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type extended: name, seq_keyword, instance, ip_action, ip_community_reg_expr
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **extended** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **extended** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ip_action: unicode
    :param ip_action: **extended** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ip_community_reg_expr: unicode
    :param ip_community_reg_expr: **extended** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.community_list.extended', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.community_list.extended', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ip.community_list.extended', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ip.community_list.extended', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ip.community_list.extended', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, extended=extended)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_community_list_extended_ip_action_get(self, rbridge_id=None, extended=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type extended: name, seq_keyword, instance
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **extended** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **extended** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.community_list.extended', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.community_list.extended', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ip.community_list.extended', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ip.community_list.extended', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ip.community_list.extended', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, extended=extended)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_community_list_extended_ip_community_reg_expr_get(self, rbridge_id=None, extended=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type extended: name, seq_keyword, instance
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **extended** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **extended** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.community_list.extended', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.community_list.extended', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ip.community_list.extended', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ip.community_list.extended', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ip.community_list.extended', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, extended=extended)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_community_list_standard_get(self, rbridge_id=None, standard=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type standard: name, seq_keyword, instance, ip_action, std_community_expr
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **standard** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **standard** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ip_action: unicode
    :param ip_action: **standard** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type std_community_expr: unicode
    :param std_community_expr: **standard** tuple argument.

        * pattern restriction: ::

            '(\s*)|(\s*((local\-as)|(internet)|(no\-export)|('
            'no\-advertise)|((([1-9][0-9]{0,3})|([1-5][0-9]{4'
            '})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2]['
            '0-9])|(6553[0-5])):(([0-9][0-9]{0,3})|([1-5][0-9'
            ']{4})|(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-'
            '2][0-9])|(6553[0-5])))|([1-9][0-9]{0,8})|([1-3]['
            '0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429'
            '[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5][0'
            '-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9]'
            '{2})|(42949672[0-8][0-9])|(429496729[0-5])))((\s'
            '+((local\-as)|(internet)|(no\-export)|(no\-adver'
            'tise)|((([1-9][0-9]{0,3})|([1-5][0-9]{4})|(6[0-4'
            '][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|(65'
            '53[0-5])):(([0-9][0-9]{0,3})|([1-5][0-9]{4})|(6['
            '0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9])|'
            '(6553[0-5])))|([1-9][0-9]{0,8})|([1-3][0-9]{9})|'
            '(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(429[0-3][0-9'
            ']{6})|(4294[0-8][0-9]{5})|(42949[0-5][0-9]{4})|('
            '429496[0-6][0-9]{3})|(4294967[0-1][0-9]{2})|(429'
            '49672[0-8][0-9])|(429496729[0-5])))*)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.community_list.standard', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.community_list.standard', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ip.community_list.standard', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ip.community_list.standard', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ip.community_list.standard', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, ip_action, std_community_expr'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, standard=standard)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_community_list_standard_ip_action_get(self, rbridge_id=None, standard=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type standard: name, seq_keyword, instance
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **standard** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **standard** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.community_list.standard', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.community_list.standard', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ip.community_list.standard', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ip.community_list.standard', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ip.community_list.standard', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, standard=standard)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_community_list_standard_std_community_expr_get(self, rbridge_id=None, standard=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type standard: name, seq_keyword, instance
    :param standard: Keyword argument tuple.

    :type name: unicode
    :param name: **standard** tuple argument.

    :type seq_keyword: unicode
    :param seq_keyword: **standard** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **standard** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.community_list.standard', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.community_list.standard', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ip.community_list.standard', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ip.community_list.standard', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ip.community_list.standard', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'standard', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, standard=standard)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, standard=standard)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_dhcp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.dhcp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.dhcp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_dhcp_relay_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.dhcp.relay', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.dhcp.relay', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_dhcp_relay_information_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.dhcp.relay.information', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.dhcp.relay.information', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_dhcp_relay_information_option_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.dhcp.relay.information', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.dhcp.relay.information', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_extcommunity_list_get(self, rbridge_id=None, extcommunity_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type extcommunity_list: extcommunity_list_num, ext_community_action, ext_community_expr
    :param extcommunity_list: Keyword argument tuple.

    :type extcommunity_list_num: int
    :param extcommunity_list_num: **extcommunity_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ext_community_action: unicode
    :param ext_community_action: **extcommunity_list** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ext_community_expr: unicode
    :param ext_community_expr: **extcommunity_list** tuple argument:  Ext-community-list

        * pattern restriction: ::

            '(\s*)|(\s*((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|((([0-9]|[1-9][0-9]|1[0-9]{2'
            '}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1['
            '0-9]{2}|2[0-4][0-9]|25[0-5]):(([1-9][0-9]{0,8})|'
            '([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7'
            '})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949'
            '[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-'
            '1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-5]'
            ')))))((\s+((rt)|(soo)|((([1-9][0-9]{0,8})|([1-3]'
            '[0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]{7})|(42'
            '9[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(42949[0-5]['
            '0-9]{4})|(429496[0-6][0-9]{3})|(4294967[0-1][0-9'
            ']{2})|(42949672[0-8][0-9])|(429496729[0-5])):((['
            '1-9][0-9]{0,8})|([1-3][0-9]{9})|(4[0-1][0-9]{8})'
            '|(42[0-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8]'
            '[0-9]{5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]'
            '{3})|(4294967[0-1][0-9]{2})|(42949672[0-8][0-9])'
            '|(429496729[0-5])))|(((([0-9]|[1-9][0-9]|1[0-9]{'
            '2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1'
            '[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,8}'
            ')|([1-3][0-9]{9})|(4[0-1][0-9]{8})|(42[0-8][0-9]'
            '{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{5})|(429'
            '49[0-5][0-9]{4})|(429496[0-6][0-9]{3})|(4294967['
            '0-1][0-9]{2})|(42949672[0-8][0-9])|(429496729[0-'
            '5])))))*)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.extcommunity_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.extcommunity_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extcommunity_list', 'keyval': 'extcommunity_list_num', 'extra_keyval': 'extcommunity_list_num, ext_community_action, ext_community_expr'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.rbridge_id.ip.extcommunity_list": {"ext_community_action": "ext_community_action", "ext_community_expr": "ext_community_expr", "extcommunity_list_num": "extcommunity_list_num"}, "pybind.nos.v7_2_0.rbridge_id.ip.extcommunity_list": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, extcommunity_list=extcommunity_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, extcommunity_list=extcommunity_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_extcommunity_list_ext_community_action_get(self, rbridge_id=None, extcommunity_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type extcommunity_list: extcommunity_list_num
    :param extcommunity_list: Keyword argument tuple.

    :type extcommunity_list_num: int
    :param extcommunity_list_num: **extcommunity_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.extcommunity_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.extcommunity_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extcommunity_list', 'keyval': 'extcommunity_list_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, extcommunity_list=extcommunity_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, extcommunity_list=extcommunity_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_extcommunity_list_ext_community_expr_get(self, rbridge_id=None, extcommunity_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type extcommunity_list: extcommunity_list_num
    :param extcommunity_list: Keyword argument tuple.

    :type extcommunity_list_num: int
    :param extcommunity_list_num: **extcommunity_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.extcommunity_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.extcommunity_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extcommunity_list', 'keyval': 'extcommunity_list_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, extcommunity_list=extcommunity_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, extcommunity_list=extcommunity_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_extcommunity_list_ext_community_regex_get(self, rbridge_id=None, extcommunity_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type extcommunity_list: extcommunity_list_num
    :param extcommunity_list: Keyword argument tuple.

    :type extcommunity_list_num: int
    :param extcommunity_list_num: **extcommunity_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.ip.extcommunity_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'extcommunity_list', 'keyval': 'extcommunity_list_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, extcommunity_list=extcommunity_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, extcommunity_list=extcommunity_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_import_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.import_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.import_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_import_routes_get(self, rbridge_id=None, routes=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type routes: src_vrf, route_map
    :param routes: Keyword argument tuple.

    :type src_vrf: unicode
    :param src_vrf: **routes** tuple argument:  ASCII string;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type route_map: unicode
    :param route_map: **routes** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.import_.routes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.import_.routes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'routes', 'keyval': 'src_vrf, route_map', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, routes=routes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, routes=routes)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_load_sharing_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_prefix_list_get(self, rbridge_id=None, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type action_ipp: unicode
    :param action_ipp: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type prefix_ipp: unicode
    :param prefix_ipp: **prefix_list** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type ge_ipp: long
    :param ge_ipp: **prefix_list** tuple argument:  Minimum IP prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type le_ipp: long
    :param le_ipp: **prefix_list** tuple argument:  Maximum IP prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_prefix_list_action_ipp_get(self, rbridge_id=None, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_prefix_list_ge_get(self, rbridge_id=None, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_prefix_list_le_get(self, rbridge_id=None, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_prefix_list_prefix_ipp_get(self, rbridge_id=None, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_receive_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.receive', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.receive', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_receive_access_group_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.receive.access_group', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.receive.access_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ip_access_list, ip_direction'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_receive_access_group_ip_access_list_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.receive.access_group', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.receive.access_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_receive_access_group_ip_direction_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.receive.access_group', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.receive.access_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_bfd_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_bfd_bfd_static_route_get(self, rbridge_id=None, bfd_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_interval_attributes'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_interval_attributes')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_static_route', 'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bfd_static_route=bfd_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_bfd_bfd_static_route_interval_get(self, rbridge_id=None, bfd_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bfd_static_route=bfd_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_bfd_bfd_static_route_min_rx_get(self, rbridge_id=None, bfd_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bfd_static_route=bfd_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_bfd_bfd_static_route_multiplier_get(self, rbridge_id=None, bfd_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route', u'bfd_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bfd_static_route=bfd_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_bfd_holdover_interval_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_route_nh_get(self, rbridge_id=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_nh', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_nh', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_nh', u'route_attributes'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_nh', u'route_attributes')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh', 'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_route_nh_distance_get(self, rbridge_id=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_route_nh_metric_get(self, rbridge_id=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_route_nh_tag_get(self, rbridge_id=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_route_nh_vrf_get(self, rbridge_id=None, static_route_nh_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop
    :param static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_nh_vrf** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh_vrf** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_nh_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_nh_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh_vrf=static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh_vrf=static_route_nh_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_route_oif_get(self, rbridge_id=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_oif', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_oif', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_oif', u'route_attributes'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_oif', u'route_attributes')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif', 'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_route_oif_distance_get(self, rbridge_id=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_route_oif_metric_get(self, rbridge_id=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_route_oif_tag_get(self, rbridge_id=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_oif.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_route_static_route_oif_vrf_get(self, rbridge_id=None, static_route_oif_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_route_oif_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name
    :param static_route_oif_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_oif_vrf** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_oif_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static_route_oif_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static_route_oif_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif_vrf=static_route_oif_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif_vrf=static_route_oif_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_router_id_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_rtm_config_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ip_static_ag_ip_config_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.ip.static_ag_ip_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ipv6', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ipv6', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ipv6', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_anycast_gateway_mac_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.static_ag_ipv6_config.anycast_gateway_mac', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_anycast_gateway_mac_default_mac_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.static_ag_ipv6_config.anycast_gateway_mac', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_anycast_gateway_mac_ipv6_anycast_gateway_mac_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.static_ag_ipv6_config.anycast_gateway_mac', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_import_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.import_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.import_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_import_routes_get(self, rbridge_id=None, routes=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type routes: src_vrf, route_map
    :param routes: Keyword argument tuple.

    :type src_vrf: unicode
    :param src_vrf: **routes** tuple argument:  ASCII string;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type route_map: unicode
    :param route_map: **routes** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.import_.routes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.import_.routes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'routes', 'keyval': 'src_vrf, route_map', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, routes=routes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, routes=routes)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_ipv6_global_cmds_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.ipv6_global_cmds', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.ipv6_global_cmds', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_ipv6route_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.ipv6route', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.ipv6route', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ipv6.ipv6route', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ipv6.ipv6route', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ipv6.ipv6route', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_nd_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.ipv6_global_cmds.nd_global', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.ipv6_global_cmds.nd_global', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_nd_dad_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_nd_dad_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.ipv6_global_cmds.nd_global.dad', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_prefix_list_get(self, rbridge_id=None, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type action_ipp: unicode
    :param action_ipp: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type ipv6_prefix_ipp: unicode
    :param ipv6_prefix_ipp: **prefix_list** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type ge_ipp: long
    :param ge_ipp: **prefix_list** tuple argument:  Minimum IPv6 prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type le_ipp: long
    :param le_ipp: **prefix_list** tuple argument:  Maximum IPv6 prefix length.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_prefix_list_action_ipp_get(self, rbridge_id=None, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_prefix_list_ge_get(self, rbridge_id=None, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_prefix_list_ipv6_prefix_ipp_get(self, rbridge_id=None, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_prefix_list_le_get(self, rbridge_id=None, prefix_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type prefix_list: name, seq_keyword, instance
    :param prefix_list: Keyword argument tuple.

    :type name: unicode
    :param name: **prefix_list** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type seq_keyword: unicode
    :param seq_keyword: **prefix_list** tuple argument.

        * enumeration restriction: ::

            ['seq']

    :type instance: int
    :param instance: **prefix_list** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'prefix_list', 'keyval': 'name, seq_keyword, instance', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, prefix_list=prefix_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, prefix_list=prefix_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_protocol_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.proto_vrrpv3', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.proto_vrrpv3', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_protocol_vrrp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.proto_vrrpv3', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.proto_vrrpv3', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_protocol_vrrp_extended_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.proto_vrrpv3', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.proto_vrrpv3', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_receive_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.receive', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.receive', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_receive_access_group_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.receive.access_group', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.receive.access_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ipv6_access_list, ip_direction'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_receive_access_group_ip_direction_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.receive.access_group', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.receive.access_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_receive_access_group_ipv6_access_list_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.receive.access_group', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.receive.access_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_get(self, rbridge_id=None, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type route: dest
    :param route: Keyword argument tuple.

    :type dest: unicode
    :param dest: **route** tuple argument:  IPv6Address/prefix.;; Destination IPv6 address-prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.ipv6route.route', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.ipv6route.route', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ipv6.ipv6route.route', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ipv6.ipv6route.route', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ipv6.ipv6route.route', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'dest', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.ipv6.ipv6route.route': [u'next_hop'], 'pybind.slxos.v17s_1_02.rbridge_id.ipv6.ipv6route.route': [u'next_hop'], 'pybind.slxos.v17r_1_01a.rbridge_id.ipv6.ipv6route.route': [u'next_hop'], 'pybind.nos.v6_0_2f.rbridge_id.ipv6.ipv6route.route': [u'next_hop'], 'pybind.slxos.v17r_2_00.rbridge_id.ipv6.ipv6route.route': [u'next_hop']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_ipv6_static_route_oif_vrf_get(self, rbridge_id=None, ipv6_static_route_oif_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ipv6_static_route_oif_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name
    :param ipv6_static_route_oif_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **ipv6_static_route_oif_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **ipv6_static_route_oif_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **ipv6_static_route_oif_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **ipv6_static_route_oif_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_static_route_oif_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ipv6_static_route_oif_vrf=ipv6_static_route_oif_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ipv6_static_route_oif_vrf=ipv6_static_route_oif_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_link_local_static_route_nh_get(self, rbridge_id=None, link_local_static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.link_local_static_route_nh', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.link_local_static_route_nh', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.route.link_local_static_route_nh', u'route_attributes'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.link_local_static_route_nh', u'route_attributes')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_local_static_route_nh', 'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_link_local_static_route_nh_distance_get(self, rbridge_id=None, link_local_static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_link_local_static_route_nh_metric_get(self, rbridge_id=None, link_local_static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_link_local_static_route_nh_tag_get(self, rbridge_id=None, link_local_static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_link_local_static_route_nh_vrf_get(self, rbridge_id=None, link_local_static_route_nh_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type link_local_static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **link_local_static_route_nh_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **link_local_static_route_nh_vrf** tuple argument:  WORD 1-63;;Next Hop Vrf Name

    :type link_local_next_hop: unicode
    :param link_local_next_hop: **link_local_static_route_nh_vrf** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.link_local_static_route_nh_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.link_local_static_route_nh_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_local_static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, link_local_static_route_nh_vrf=link_local_static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, link_local_static_route_nh_vrf=link_local_static_route_nh_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_next_hop_get(self, rbridge_id=None, route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type route: dest
    :param route: Keyword argument tuple.

    :type dest: unicode
    :param dest: **route** tuple argument:  IPv6Address/prefix.;; Destination IPv6 address-prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.ipv6route.route', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.ipv6route.route', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.ipv6.ipv6route.route', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.ipv6.ipv6route.route', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.ipv6.ipv6route.route', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route', 'keyval': 'dest', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route=route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route=route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_bfd_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_get(self, rbridge_id=None, bfd_ipv6_link_local_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_interval_attributes'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_interval_attributes')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_ipv6_link_local_static_route', 'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_interval_get(self, rbridge_id=None, bfd_ipv6_link_local_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_min_rx_get(self, rbridge_id=None, bfd_ipv6_link_local_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_multiplier_get(self, rbridge_id=None, bfd_ipv6_link_local_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_bfd_bfd_ipv6_static_route_get(self, rbridge_id=None, bfd_ipv6_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_interval_attributes'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_interval_attributes')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_ipv6_static_route', 'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_bfd_bfd_ipv6_static_route_interval_get(self, rbridge_id=None, bfd_ipv6_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_bfd_bfd_ipv6_static_route_min_rx_get(self, rbridge_id=None, bfd_ipv6_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_bfd_bfd_ipv6_static_route_multiplier_get(self, rbridge_id=None, bfd_ipv6_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_bfd_holdover_interval_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_nh_get(self, rbridge_id=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_nh', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_nh', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_nh', u'route_attributes'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_nh', u'route_attributes')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh', 'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_nh_distance_get(self, rbridge_id=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_nh_metric_get(self, rbridge_id=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_nh_tag_get(self, rbridge_id=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_nh_vrf_get(self, rbridge_id=None, static_route_nh_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop
    :param static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_nh_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh_vrf** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_nh_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_nh_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_nh_vrf=static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_nh_vrf=static_route_nh_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_oif_get(self, rbridge_id=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_oif', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_oif', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_oif', u'route_attributes'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_oif', u'route_attributes')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif', 'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_oif_distance_get(self, rbridge_id=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_oif_metric_get(self, rbridge_id=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_route_static_route_oif_tag_get(self, rbridge_id=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'external_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'area_id, normal'}, {'leafval': 'external_lsa_value'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_bad_packet_checksum'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'nssa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area_range'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.nssa', u'area_default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'stub'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.nssa', u'metric'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area_range'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.nssa', u'area_default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'stub'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'nssa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'virtual_link'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.nssa', u'metric')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_redistribution, nssa_area_no_summary, translator_always, translator_interval'}, {'leafval': 'virtual_link_neighbor'}, {'leafval': 'range_address, range_effect, range_cost'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'area_default_information_originate_metric, area_default_information_originate_metric_type'}, {'leafval': 'stub_area_no_summary, stub_area_metric'}, {'leafval': 'nssa_area_metric'}, {'leafval': 'range_address, range_effect, range_cost'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'area_default_information_originate_metric, area_default_information_originate_metric_type'}, {'leafval': 'stub_area_no_summary, stub_area_metric'}, {'leafval': 'no_redistribution, nssa_area_no_summary, translator_always, translator_interval'}, {'leafval': 'virtual_link_neighbor'}, {'leafval': 'nssa_area_metric'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.authentication', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.authentication', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_ah_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_esp_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_esp_auth_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_esp_key_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_esp_no_encrypt_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_ipsec_auth_key_config_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config': [u'ah', u'esp']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_key_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_no_encrypt_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_authentication_spi_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_normal_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'nssa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area_range'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.nssa', u'area_default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'stub'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.nssa', u'metric'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area_range'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.nssa', u'area_default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'stub'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'nssa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'virtual_link'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.nssa', u'metric')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_redistribution, nssa_area_no_summary, translator_always, translator_interval'}, {'leafval': 'virtual_link_neighbor'}, {'leafval': 'range_address, range_effect, range_cost'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'area_default_information_originate_metric, area_default_information_originate_metric_type'}, {'leafval': 'stub_area_no_summary, stub_area_metric'}, {'leafval': 'nssa_area_metric'}, {'leafval': 'range_address, range_effect, range_cost'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'area_default_information_originate_metric, area_default_information_originate_metric_type'}, {'leafval': 'stub_area_no_summary, stub_area_metric'}, {'leafval': 'no_redistribution, nssa_area_no_summary, translator_always, translator_interval'}, {'leafval': 'virtual_link_neighbor'}, {'leafval': 'nssa_area_metric'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_redistribution, nssa_area_no_summary, translator_always, translator_interval'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_default_information_originate_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'area_default_information_originate_metric, area_default_information_originate_metric_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_default_information_originate_metric_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_default_information_originate_metric_type_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.nssa.area_default_information_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_metric_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.nssa.metric', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.nssa.metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_no_redistribution_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_no_summary_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_nssa_area_metric_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.nssa.metric', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.nssa.metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_translator_always_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_nssa_translator_interval_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.nssa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_range_get(self, rbridge_id=None, ospf=None, area=None, area_range=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type area_range: range_address, range_effect, range_cost
    :param area_range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **area_range** tuple argument:  A:B::C:D/LEN;; IPv6 address to match

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type range_effect: unicode
    :param range_effect: **area_range** tuple argument:  Advertise/Do not advertise this type-3 summarization

        * enumeration restriction: ::

            ['advertise', 'not-advertise']

    :type range_cost: long
    :param range_cost: **area_range** tuple argument:  Configure area range cost

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.area_range', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.area_range', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area_range', 'keyval': 'range_address', 'extra_keyval': 'range_address, range_effect, range_cost'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, area_range=area_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, area_range=area_range)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_range_cost_get(self, rbridge_id=None, ospf=None, area=None, area_range=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type area_range: range_address
    :param area_range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **area_range** tuple argument:  A:B::C:D/LEN;; IPv6 address to match

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.area_range', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.area_range', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area_range', 'keyval': 'range_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, area_range=area_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, area_range=area_range)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_range_range_effect_get(self, rbridge_id=None, ospf=None, area=None, area_range=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type area_range: range_address
    :param area_range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **area_range** tuple argument:  A:B::C:D/LEN;; IPv6 address to match

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.area_range', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.area_range', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area_range', 'keyval': 'range_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, area_range=area_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, area_range=area_range)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_stub_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.stub', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.stub', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'stub_area_no_summary, stub_area_metric'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_stub_no_summary_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.stub', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.stub', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_stub_stub_area_metric_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.stub', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.stub', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties', u'link_interval_properties'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication', u'ipsec_auth_key_config'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties', u'link_interval_properties')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}, {'leafval': 'hello_interval, dead_interval, hello_jitter, retransmit_interval, transmit_delay'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_ah_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_esp_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_esp_auth_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_esp_key_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_esp_no_encrypt_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_ipsec_auth_key_config_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spi, ah, ah_no_encrypt, ah_key, esp, esp_no_encrypt, esp_key, esp_auth, esp_auth_no_encrypt, esp_auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config': [u'ah', u'esp'], 'pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config': [u'ah', u'esp']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_key_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_no_encrypt_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_authentication_spi_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.authentication.ipsec_auth_key_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_dead_interval_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_hello_interval_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_hello_jitter_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_link_interval_properties_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_retransmit_interval_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_area_virtual_link_transmit_delay_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virtual_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virtual_link_neighbor: unicode
    :param virtual_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.area.virtual_link.link_properties.link_interval_properties', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virtual_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_auto_cost_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.auto_cost', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.auto_cost', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_auto_cost_reference_bandwidth_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.auto_cost', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.auto_cost', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_bfd_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_bfd_bfd_enable_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_bfd_holdover_interval_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_database_overflow_interval_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'external_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'area_id, normal'}, {'leafval': 'external_lsa_value'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_bad_packet_checksum'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_default_information_originate_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_default_information_originate_always_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_default_information_originate_metric_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_default_information_originate_metric_type_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.global_default_information_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_default_metric_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'external_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'area_id, normal'}, {'leafval': 'external_lsa_value'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_bad_packet_checksum'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_default_passive_interface_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'external_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'area_id, normal'}, {'leafval': 'external_lsa_value'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_bad_packet_checksum'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distance_get(self, rbridge_id=None, ospf=None, distance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propagation

        * enumeration restriction: ::

            ['intra-area', 'external', 'inter-area']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distance', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distance', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, distance=distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, distance=distance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distance_distance_value_get(self, rbridge_id=None, ospf=None, distance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propagation

        * enumeration restriction: ::

            ['intra-area', 'external', 'inter-area']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distance', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distance', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, distance=distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, distance=distance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distribute_list_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distribute_list_prefix_list_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distribute_list_prefix_list_distribute_list_prefix_list_name_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distribute_list_prefix_list_in_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distribute_list_route_map_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list.route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list.route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'distribute_list_route_map_name, distribute_list_route_map_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distribute_list_route_map_distribute_list_route_map_name_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list.route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list.route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_distribute_list_route_map_in_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list.route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list.route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_external_lsdb_limit_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'external_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'area_id, normal'}, {'leafval': 'external_lsa_value'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_bad_packet_checksum'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_graceful_restart_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.graceful_restart', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_graceful_restart_helper_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.graceful_restart.helper', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.graceful_restart.helper', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_graceful_restart_helper_disable_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.graceful_restart.helper', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.graceful_restart.helper', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_graceful_restart_helper_strict_lsa_checking_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.graceful_restart.helper', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.graceful_restart.helper', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_key_add_remove_interval_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'external_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'area_id, normal'}, {'leafval': 'external_lsa_value'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_bad_packet_checksum'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_key_rollover_interval_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'external_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'area_id, normal'}, {'leafval': 'external_lsa_value'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_bad_packet_checksum'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_adjacency_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log.log_adjacency', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log.log_adjacency', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_adjacency_dr_only_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log.log_adjacency', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log.log_adjacency', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_all_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_bad_packet_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log.log_bad_packet', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log.log_bad_packet', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_bad_packet_checksum_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log.log_bad_packet', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log.log_bad_packet', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_database_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_retransmit_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_log_status_change_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'external_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'area_id, normal'}, {'leafval': 'external_lsa_value'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_bad_packet_checksum'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_all_lsas_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_external_lsa_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_external_lsa_external_lsa_value_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_include_stub_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_on_startup_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_on_startup_on_startup_time_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_on_startup_wait_for_bgp_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_summary_lsa_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_max_metric_router_lsa_summary_lsa_summary_lsa_value_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_maximum_paths_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'external_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'area_id, normal'}, {'leafval': 'external_lsa_value'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_bad_packet_checksum'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_metric_type_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'external_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'area_id, normal'}, {'leafval': 'external_lsa_value'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_bad_packet_checksum'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_nonstop_routing_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_connected'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'auto_cost'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.graceful_restart', u'helper'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.distribute_list', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_bgp'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.timers', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', u'redistribute_static'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'global_default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.log', u'log_bad_packet')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'summary_address_value'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'external_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'log_bad_packet_checksum'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'connected_route_map, redistribute_connected_metric, redistribute_connected_metric_type'}, {'leafval': 'summary_lsa_value'}, {'leafval': 'bfd_enable, bfd_holdover_interval'}, {'leafval': 'reference_bandwidth'}, {'leafval': 'distribute_list_route_map_name, distribute_list_route_map_in'}, {'leafval': 'graceful_restart_helper_disable, graceful_restart_helper_strict_lsa_checking'}, {'leafval': 'area_id, normal'}, {'leafval': 'external_lsa_value'}, {'leafval': 'summary_address_value'}, {'leafval': 'log_adjacency_dr_only'}, {'leafval': 'all_lsas, include_stub'}, {'leafval': 'distribute_list_prefix_list_name, distribute_list_prefix_list_in'}, {'leafval': 'bgp_route_map, redistribute_bgp_metric, redistribute_bgp_metric_type'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'spf_delay, spf_hold_time'}, {'leafval': 'on_startup_time, wait_for_bgp'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'route_type, distance_value'}, {'leafval': 'ospf_route_map, redistribute_ospf_metric, redistribute_ospf_metric_type'}, {'leafval': 'static_route_map, redistribute_static_metric, redistribute_static_metric_type'}, {'leafval': 'global_default_information_originate_always, global_default_information_originate_metric, global_default_information_originate_metric_type'}, {'leafval': 'log_bad_packet_checksum'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_bgp_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_bgp_metric_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_bgp_metric_type_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_bgp_route_map_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_connected_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_connected_metric_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_connected_metric_type_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_connected_route_map_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_ospf_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_ospf_metric_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_ospf_metric_type_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_ospf_route_map_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_static_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_static_metric_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_static_metric_type_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_redistribute_static_route_map_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.redistribute.redistribute_static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_summary_address_get(self, rbridge_id=None, ospf=None, summary_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type summary_address: summary_address_value
    :param summary_address: Keyword argument tuple.

    :type summary_address_value: unicode
    :param summary_address_value: **summary_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.summary_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.summary_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'summary_address', 'keyval': 'summary_address_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, summary_address=summary_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, summary_address=summary_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_timers_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_timers_lsa_group_pacing_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_timers_spf_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.timers.spf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.timers.spf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'spf_delay, spf_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_timers_spf_spf_delay_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.timers.spf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.timers.spf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_router_ospf_timers_spf_spf_hold_time_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  OSPF instance for the VRF 

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ipv6.router.ospf.timers.spf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router.ospf.timers.spf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ipv6_static_ag_ipv6_config_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.ipv6.static_ag_ipv6_config', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_linecard_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.global_lc_holder.linecard', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.global_lc_holder.linecard', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_linecard_linecards_get(self, rbridge_id=None, linecards=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type linecards: linecardName, linecardType
    :param linecards: Keyword argument tuple.

    :type linecardName: unicode
    :param linecardName: **linecards** tuple argument.

        * pattern restriction: ::

            '([1-9]|[1][0-6])'

    :type linecardType: unicode
    :param linecardType: **linecards** tuple argument.

        * enumeration restriction: ::

            ['LC27X40G',
            'LC48X10G',
            'LC6X100G',
            'LC48X10GT',
            'LC12X40G',
            'LC48X1G']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.global_lc_holder.linecard.linecards', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.global_lc_holder.linecard.linecards', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'linecards', 'keyval': 'linecardName', 'extra_keyval': 'linecardName, linecardType'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, linecards=linecards)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, linecards=linecards)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_linecard_linecards_linecardtype_get(self, rbridge_id=None, linecards=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type linecards: linecardName
    :param linecards: Keyword argument tuple.

    :type linecardName: unicode
    :param linecardName: **linecards** tuple argument.

        * pattern restriction: ::

            '([1-9]|[1][0-6])'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.global_lc_holder.linecard.linecards', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.global_lc_holder.linecard.linecards', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'linecards', 'keyval': 'linecardName', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, linecards=linecards)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, linecards=linecards)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_logical_chassis_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.logical_chassis', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.logical_chassis', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.logical_chassis', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.logical_chassis', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.logical_chassis', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_logical_chassis_principal_priority_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.logical_chassis', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.logical_chassis', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.logical_chassis', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.logical_chassis', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.logical_chassis', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.maps', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.maps', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_email_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.maps.email', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.maps.email', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_email_email_list_get(self, rbridge_id=None, email_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type email_list: email
    :param email_list: Keyword argument tuple.

    :type email: unicode
    :param email: **email_list** tuple argument:  <email:string>  e-mail address for MAPS alerts

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.maps.email.email_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.maps.email.email_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'email_list', 'keyval': 'email', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, email_list=email_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, email_list=email_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_enable_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.maps.enable', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.maps.enable', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_enable_actions_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.maps.enable', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.maps.enable', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_enable_policy_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.maps.enable', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.maps.enable', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_group_get(self, rbridge_id=None, logicalgroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logicalgroup: logicalgroupname, elementtype, members
    :param logicalgroup: Keyword argument tuple.

    :type logicalgroupname: unicode
    :param logicalgroupname: **logicalgroup** tuple argument:  Configure group name

    :type elementtype: unicode
    :param elementtype: **logicalgroup** tuple argument.

        * enumeration restriction: ::

            ['interface', 'sfp']

    :type members: unicode
    :param members: **logicalgroup** tuple argument:  Configure memberlist

        * length restriction: ::

            ['1..253']

        * pattern restriction: ::

            '(((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?'
            '(([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9]))((-([1-9]|[1-9][0-9]|[1-9][0-9][0-9]))?)(('
            '(,([1-9]|[1-9][0-9]|[1-9][0-9][0-9])(-([1-9]|[1-'
            '9][0-9]|[1-9][0-9][0-9]))?){1})+|((([1-9]|[1-9]['
            '0-9]|1[0-9][0-9]|2[0-3][0-9])/)?(([0-9]|[1][0-6]'
            '))/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]))(-([1-9]|['
            '1-9][0-9]|[1-9][0-9][0-9])){1}|((([1-9]|[1-9][0-'
            '9]|1[0-9][0-9]|2[0-3][0-9])/)?(([0-9]|[1][0-6]))'
            '/([1-9]|[1-9][0-9]|[1-9][0-9][0-9])(:((([1-4])(-'
            '([1-4]))?)(((,([1-4])(-([1-4]))?){1})+)|([1-4])('
            '-([1-4]))))))*)(,(((([1-9]|[1-9][0-9]|1[0-9][0-9'
            ']|2[0-3][0-9])/)?(([0-9]|[1][0-6]))/([1-9]|[1-9]'
            '[0-9]|[1-9][0-9][0-9]))((-([1-9]|[1-9][0-9]|[1-9'
            '][0-9][0-9]))?)(((,([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(-([1-9]|[1-9][0-9]|[1-9][0-9][0-9]))?){1})'
            '+|((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)'
            '?(([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9]))(-([1-9]|[1-9][0-9]|[1-9][0-9][0-9])){1}|'
            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:((([1-4])(-([1-4]))?)(((,([1-4])(-([1-4]))'
            '?){1})+)|([1-4])(-([1-4]))))))*))*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.maps.logicalgroup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logicalgroup', 'keyval': 'logicalgroupname', 'extra_keyval': 'logicalgroupname, elementtype, members'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logicalgroup=logicalgroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logicalgroup=logicalgroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_group_members_get(self, rbridge_id=None, logicalgroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logicalgroup: logicalgroupname
    :param logicalgroup: Keyword argument tuple.

    :type logicalgroupname: unicode
    :param logicalgroupname: **logicalgroup** tuple argument:  Configure group name

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.maps.logicalgroup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logicalgroup', 'keyval': 'logicalgroupname', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logicalgroup=logicalgroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logicalgroup=logicalgroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_group_type_get(self, rbridge_id=None, logicalgroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logicalgroup: logicalgroupname
    :param logicalgroup: Keyword argument tuple.

    :type logicalgroupname: unicode
    :param logicalgroupname: **logicalgroup** tuple argument:  Configure group name

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.maps.logicalgroup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logicalgroup', 'keyval': 'logicalgroupname', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logicalgroup=logicalgroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logicalgroup=logicalgroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_policy_get(self, rbridge_id=None, policy=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type policy: policyname
    :param policy: Keyword argument tuple.

    :type policyname: unicode
    :param policyname: **policy** tuple argument:  Configure policy name

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.maps.policy', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.maps.policy', u'ruleaction')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'policy', 'keyval': 'policyname', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'policyrule, policyaction'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_policy_rule_get(self, rbridge_id=None, policy=None, ruleaction=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policyname
    :param policy: Keyword argument tuple.

    :type policyname: unicode
    :param policyname: **policy** tuple argument:  Configure policy name

    **Instance Keyword Argument Tuple**:

    :type ruleaction: policyrule, policyaction
    :param ruleaction: Keyword argument tuple.

    :type policyrule: unicode
    :param policyrule: **ruleaction** tuple argument:  rule name

    :type policyaction: unicode
    :param policyaction: **ruleaction** tuple argument:  rule actions

        * enumeration restriction: ::

            ['NONE',
            'SNMP',
            'RASLOG',
            'SW_CRITICAL',
            'SFP_MARGINAL',
            'EMAIL',
            'SW_MARGINAL']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.maps.policy', u'policy')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.maps.policy.ruleaction', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policyname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ruleaction', 'keyval': 'policyrule', 'extra_keyval': 'policyrule, policyaction'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, ruleaction=ruleaction)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, ruleaction=ruleaction)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_policy_rule_actions_get(self, rbridge_id=None, policy=None, ruleaction=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policyname
    :param policy: Keyword argument tuple.

    :type policyname: unicode
    :param policyname: **policy** tuple argument:  Configure policy name

    **Instance Keyword Argument Tuple**:

    :type ruleaction: policyrule
    :param ruleaction: Keyword argument tuple.

    :type policyrule: unicode
    :param policyrule: **ruleaction** tuple argument:  rule name

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.maps.policy', u'policy')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.maps.policy.ruleaction', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policyname', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ruleaction', 'keyval': 'policyrule', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, ruleaction=ruleaction)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, ruleaction=ruleaction)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_relay_get(self, rbridge_id=None, relay=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type relay: hostip
    :param relay: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **relay** tuple argument:  <IP:Address> IP address of Relay Host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.maps.relay', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.maps.relay', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'relay', 'keyval': 'hostip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, relay=relay)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, relay=relay)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_relay_domainname_get(self, rbridge_id=None, relay=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type relay: hostip
    :param relay: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **relay** tuple argument:  <IP:Address> IP address of Relay Host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.maps.relay', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.maps.relay', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'relay', 'keyval': 'hostip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, relay=relay)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, relay=relay)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_rule_get(self, rbridge_id=None, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rule: rulename, targetgroup, monitor, timebase, op, threshold
    :param rule: Keyword argument tuple.

    :type rulename: unicode
    :param rulename: **rule** tuple argument:  Configure rule name

    :type targetgroup: unicode
    :param targetgroup: **rule** tuple argument:  target group for rule

    :type monitor: unicode
    :param monitor: **rule** tuple argument.

        * enumeration restriction: ::

            ['MEMORY_USAGE',
            'FLASH_USAGE',
            'HA_SYNC',
            'BAD_PWR',
            'ETH_MGMT_PORT_STATE',
            'BAD_FAN',
            'CPU',
            'SFP_TEMP',
            'SEC_TELNET',
            'TEMP',
            'RX_SYM_ERR',
            'CRCALN',
            'VOLTAGE',
            'SFP_STATE',
            'ASIC_PKTDROP',
            'TXP',
            'WWN_DOWN',
            'FAN_STATE',
            'CURRENT',
            'RX_ABN_FRAME',
            'RXP',
            'FAULTY_BLADE',
            'BLADE_STATE',
            'BAD_TEMP',
            'PS_STATE',
            'SEC_LV',
            'WWN',
            'DOWN_SFM']

    :type timebase: unicode
    :param timebase: **rule** tuple argument.

        * enumeration restriction: ::

            ['none', 'day', 'hour', 'min']

    :type op: unicode
    :param op: **rule** tuple argument.

        * enumeration restriction: ::

            ['gt', 'lt', 'le', 'eq', 'ge']

    :type threshold: unicode
    :param threshold: **rule** tuple argument:  threshold value

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.maps.rule', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rule', 'keyval': 'rulename', 'extra_keyval': 'rulename, targetgroup, monitor, timebase, op, threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_rule_group_get(self, rbridge_id=None, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rule: rulename
    :param rule: Keyword argument tuple.

    :type rulename: unicode
    :param rulename: **rule** tuple argument:  Configure rule name

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.maps.rule', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rule', 'keyval': 'rulename', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_rule_interval_get(self, rbridge_id=None, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rule: rulename
    :param rule: Keyword argument tuple.

    :type rulename: unicode
    :param rulename: **rule** tuple argument:  Configure rule name

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.maps.rule', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rule', 'keyval': 'rulename', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_rule_monitor_get(self, rbridge_id=None, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rule: rulename
    :param rule: Keyword argument tuple.

    :type rulename: unicode
    :param rulename: **rule** tuple argument:  Configure rule name

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.maps.rule', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rule', 'keyval': 'rulename', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_rule_op_get(self, rbridge_id=None, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rule: rulename
    :param rule: Keyword argument tuple.

    :type rulename: unicode
    :param rulename: **rule** tuple argument:  Configure rule name

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.maps.rule', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rule', 'keyval': 'rulename', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_maps_rule_value_get(self, rbridge_id=None, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rule: rulename
    :param rule: Keyword argument tuple.

    :type rulename: unicode
    :param rulename: **rule** tuple argument:  Configure rule name

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.maps.rule', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rule', 'keyval': 'rulename', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_openflow_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.openflow', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.openflow', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_get(self, rbridge_id=None, logical_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance', u'controller'), ('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance', u'version'), ('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance.passive', u'no_ssl'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance.passive', u'no_ssl'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', u'version'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', u'controller')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_instance', 'keyval': 'instance_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'controller_name'}, {'leafval': 'version_name'}, {'leafval': 'passive_controller_flag, passive_controller_ip_address, passive_controller_port'}, {'leafval': 'passive_controller_flag, passive_controller_ip_address, passive_controller_port, passive_controller_vrf'}, {'leafval': 'version_name'}, {'leafval': 'controller_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_activate_get(self, rbridge_id=None, logical_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance', u'controller'), ('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance', u'version'), ('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance.passive', u'no_ssl'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance.passive', u'no_ssl'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', u'version'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', u'controller')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_instance', 'keyval': 'instance_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'controller_name'}, {'leafval': 'version_name'}, {'leafval': 'passive_controller_flag, passive_controller_ip_address, passive_controller_port'}, {'leafval': 'passive_controller_flag, passive_controller_ip_address, passive_controller_port, passive_controller_vrf'}, {'leafval': 'version_name'}, {'leafval': 'controller_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_controller_get(self, rbridge_id=None, logical_instance=None, controller=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type controller: controller_name
    :param controller: Keyword argument tuple.

    :type controller_name: unicode
    :param controller_name: **controller** tuple argument:  OpenFlow controller name

        * pattern restriction: ::

            '[-_a-zA-Z0-9]{1,32}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance', u'logical_instance')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance.controller', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance.controller', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'controller', 'keyval': 'controller_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance, controller=controller)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance, controller=controller)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_default_behavior_get(self, rbridge_id=None, logical_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance', u'controller'), ('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance', u'version'), ('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance.passive', u'no_ssl'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance.passive', u'no_ssl'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', u'version'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', u'controller')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'logical_instance', 'keyval': 'instance_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'controller_name'}, {'leafval': 'version_name'}, {'leafval': 'passive_controller_flag, passive_controller_ip_address, passive_controller_port'}, {'leafval': 'passive_controller_flag, passive_controller_ip_address, passive_controller_port, passive_controller_vrf'}, {'leafval': 'version_name'}, {'leafval': 'controller_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_passive_get(self, rbridge_id=None, logical_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', u'logical_instance')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance.passive', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance.passive', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_passive_no_ssl_get(self, rbridge_id=None, logical_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance', u'logical_instance')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'passive_controller_flag, passive_controller_ip_address, passive_controller_port'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance.passive.no_ssl": {}, "pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance.passive.no_ssl": {"passive_controller_flag": "passive_controller_flag", "passive_controller_ip_address": "passive_controller_ip_address", "passive_controller_port": "passive_controller_port"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_passive_no_ssl_ip_address_get(self, rbridge_id=None, logical_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance', u'logical_instance')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_passive_no_ssl_passive_controller_flag_get(self, rbridge_id=None, logical_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance', u'logical_instance')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_passive_no_ssl_port_get(self, rbridge_id=None, logical_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance', u'logical_instance')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_passive_no_ssl_use_vrf_get(self, rbridge_id=None, logical_instance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', u'logical_instance')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance.passive.no_ssl', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_openflow_logical_instance_version_get(self, rbridge_id=None, logical_instance=None, version=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type logical_instance: instance_id
    :param logical_instance: Keyword argument tuple.

    :type instance_id: long
    :param instance_id: **logical_instance** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type version: version_name
    :param version: Keyword argument tuple.

    :type version_name: unicode
    :param version_name: **version** tuple argument.

        * enumeration restriction: ::

            ['ofv130']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance', u'logical_instance'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance', u'logical_instance')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.openflow.logical_instance.version', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.openflow.logical_instance.version', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'instance_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'version', 'keyval': 'version_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, logical_instance=logical_instance, version=version)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, logical_instance=logical_instance, version=version)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_protocol_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.protocol', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.protocol', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_protocol_hide_vrrp_holder_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.protocol.hide_vrrp_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.protocol.hide_vrrp_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_protocol_vrrp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.protocol.hide_vrrp_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.protocol.hide_vrrp_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_protocol_vrrp_extended_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.protocol.hide_vrrp_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.protocol.hide_vrrp_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_qos_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.qos', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.qos', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_qos_rcv_queue_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.qos.rcv_queue', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.qos.rcv_queue', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_qos_rcv_queue_limit_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.qos.rcv_queue', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.qos.rcv_queue', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_qos_rcv_queue_multicast_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.qos.rcv_queue.multicast', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.qos.rcv_queue.multicast', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_qos_rcv_queue_multicast_mode_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.qos.rcv_queue.multicast', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.qos.rcv_queue.multicast', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_qos_tx_queue_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.qos.tx_queue', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.qos.tx_queue', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_qos_tx_queue_limit_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.qos.tx_queue', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.qos.tx_queue', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_cpu_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.cpu', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable_cpu, threshold_cpu, action_cpu, sample_rate_cpu, logging_rate_cpu, grace_period_cpu, offset_cpu'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_cpu_action_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.cpu', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_cpu_enable_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.cpu', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_cpu_grace_period_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.cpu', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_cpu_logging_rate_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.cpu', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_cpu_sample_rate_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.cpu', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_cpu_thresh_offset_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.cpu', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_cpu_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.cpu', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_memory_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable_memory, threshold_memory, action_memory, sample_rate_memory, logging_rate_memory, grace_period_memory, offset_memory'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_memory_action_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_memory_enable_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_memory_grace_period_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_memory_logging_rate_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_memory_sample_rate_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_memory_thresh_offset_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_memory_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_process_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.process', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_process_memory_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.process.memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable_process, thresh_mem_alarm, thresh_mem_critic'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_process_memory_alarm_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.process.memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_process_memory_critical_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.process.memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_resource_monitor_process_memory_enable_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.resource_monitor.process.memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_root_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.root', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.root', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_root_access_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.root', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.root', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_root_enable_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.root', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.root', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_', u'local_preference'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ip', u'address'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_', u'weight'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match', u'as_path'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_', u'automatic_tag'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_', u'metric_type'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.protocol', u'protocol_static_container'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content', u'continue_holder'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip', u'next_hop'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match', u'route_type'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match', u'next_hop'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ipv6.global_', u'next_global_hop'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_', u'metric'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match', u'community'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ipv6', u'route_source'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_', u'tag'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_', u'community'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip.next_vrf', u'next_vrf_list'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip', u'dscp'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match', u'extcommunity'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ipv6', u'next_hop'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip.global_', u'next_global_hop'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ipv6.next_ip', u'next_hop'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match', u'metric'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_', u'route_type'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ip', u'route_source'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content', u'match'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ip', u'next_hop'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.protocol', u'bgp_protocol_container'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ipv6.next_vrf', u'next_vrf_list'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip.next_ip', u'next_hop'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.extcommunity', u'soo'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.extcommunity', u'rt'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_', u'as_path'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_', u'origin'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ipv6', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_', u'comm_list'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ipv6', u'address'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ipv6', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match', u'community'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ip', u'address'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.protocol', u'bgp_protocol_container'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ip', u'next_hop'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ipv6.next_ip', u'next_hop'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ipv6', u'address'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match', u'metric'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match', u'extcommunity'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ipv6.global_', u'next_global_hop'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.extcommunity', u'soo'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.extcommunity', u'rt'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match', u'next_hop'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_', u'community'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ipv6', u'next_hop'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match', u'route_type'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_', u'origin'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_', u'local_preference'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_', u'automatic_tag'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_', u'tag'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_', u'metric_type'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_', u'route_type'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ipv6', u'route_source'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_', u'weight'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_', u'comm_list'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip.global_', u'next_global_hop'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_', u'as_path'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip.next_vrf', u'next_vrf_list'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content', u'continue_holder'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip', u'next_hop'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_', u'metric'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip', u'dscp'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ip', u'route_source'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip.next_ip', u'next_hop'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ipv6.next_vrf', u'next_vrf_list'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_', u'dampening'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match', u'as_path'), ('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.protocol', u'protocol_static_container')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_map', 'keyval': 'name, action_rm, instance', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_life, reuse, suppress, max_suppress_time'}, {'leafval': 'local_preference_value'}, {'leafval': 'prefix_list_rmm, acl_rmm'}, {'leafval': 'weight_value'}, {'leafval': 'as_path_access_list_name'}, {'leafval': 'tag_empty'}, {'leafval': 'external, internal, type_1, type_2'}, {'leafval': 'static'}, {'leafval': 'continue_, continue_val'}, {'leafval': 'peer_address'}, {'leafval': 'route_type_rmm'}, {'leafval': 'next_hop_filter_val'}, {'leafval': 'next_hop'}, {'leafval': 'delta_rms, metric_rms'}, {'leafval': 'community_access_list_name'}, {'leafval': 'ipv6_prefix_list_rmrs'}, {'leafval': 'tag_rms'}, {'leafval': 'set_community_expr'}, {'leafval': 'vrf, next_hop'}, {'leafval': 'dscp_rms'}, {'leafval': 'extcommunity_num'}, {'leafval': 'ipv6_prefix_list_rmm_n'}, {'leafval': 'next_hop'}, {'leafval': 'next_hop'}, {'leafval': 'metric_rmm'}, {'leafval': 'route_type_rms'}, {'leafval': 'prefix_list_rmrs'}, {'leafval': 'vrf'}, {'leafval': 'prefix_list_rmm_n'}, {'leafval': 'protocol_bgp, bgp_route_type'}, {'leafval': 'vrf, next_hop'}, {'leafval': 'next_hop'}, {'leafval': 'ASN_NN_soo'}, {'leafval': 'ASN_NN_rt'}, {'leafval': 'aspath_tag, prepend'}, {'leafval': 'origin_igp, origin_incomplete'}, {'leafval': 'dist_rms'}, {'leafval': 'ipv6_null0'}, {'leafval': 'null0'}, {'leafval': 'comm_list_name, match_comm_delete'}, {'leafval': 'ipv6_prefix_list_rmm, ipv6_acl_rmm'}, {'leafval': 'ipv6_null0'}, {'leafval': 'community_access_list_name'}, {'leafval': 'prefix_list_rmm, acl_rmm'}, {'leafval': 'protocol_bgp, bgp_route_type'}, {'leafval': 'prefix_list_rmm_n'}, {'leafval': 'next_hop'}, {'leafval': 'ipv6_prefix_list_rmm, ipv6_acl_rmm'}, {'leafval': 'metric_rmm'}, {'leafval': 'extcommunity_num'}, {'leafval': 'next_hop'}, {'leafval': 'ASN_NN_soo'}, {'leafval': 'null0'}, {'leafval': 'ASN_NN_rt'}, {'leafval': 'next_hop_filter_val'}, {'leafval': 'dist_rms'}, {'leafval': 'set_community_expr'}, {'leafval': 'ipv6_prefix_list_rmm_n'}, {'leafval': 'route_type_rmm'}, {'leafval': 'origin_igp, origin_incomplete'}, {'leafval': 'local_preference_value'}, {'leafval': 'tag_empty'}, {'leafval': 'vrf'}, {'leafval': 'tag_rms'}, {'leafval': 'external, internal, type_1, type_2'}, {'leafval': 'route_type_rms'}, {'leafval': 'ipv6_prefix_list_rmrs'}, {'leafval': 'weight_value'}, {'leafval': 'comm_list_name, match_comm_delete'}, {'leafval': 'next_hop'}, {'leafval': 'aspath_tag, prepend'}, {'leafval': 'vrf, next_hop'}, {'leafval': 'continue_, continue_val'}, {'leafval': 'peer_address'}, {'leafval': 'delta_rms, metric_rms'}, {'leafval': 'dscp_rms'}, {'leafval': 'prefix_list_rmrs'}, {'leafval': 'next_hop'}, {'leafval': 'vrf, next_hop'}, {'leafval': 'half_life, reuse, suppress, max_suppress_time'}, {'leafval': 'as_path_access_list_name'}, {'leafval': 'static'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_continue_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.continue_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.continue_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_continue_holder_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.continue_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.continue_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'continue_, continue_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_continue_val_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.continue_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.continue_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_as_path_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.as_path', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.as_path', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_as_path_as_path_access_list_name_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.as_path', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.as_path', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_community_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'community_access_list_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_community_community_access_list_name_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_extcommunity_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.extcommunity', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.extcommunity', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_extcommunity_extcommunity_num_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.extcommunity', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.extcommunity', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_interface_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_ip_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_ip_address_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ip.address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ip.address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_ip_address_acl_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ip.address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ip.address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_ip_address_prefix_list_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ip.address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ip.address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_ip_next_hop_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ip.next_hop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ip.next_hop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_ip_next_hop_prefix_list_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ip.next_hop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ip.next_hop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_ip_route_source_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ip.route_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ip.route_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_ip_route_source_prefix_list_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ip.route_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ip.route_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_ipv6_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ipv6', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ipv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_ipv6_address_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ipv6.address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ipv6.address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_ipv6_address_acl_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ipv6.address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ipv6.address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_ipv6_address_prefix_list_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ipv6.address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ipv6.address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_ipv6_next_hop_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ipv6.next_hop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ipv6.next_hop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_ipv6_next_hop_prefix_list_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ipv6.next_hop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ipv6.next_hop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_ipv6_route_source_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ipv6.route_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ipv6.route_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_ipv6_route_source_prefix_list_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.ipv6.route_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.ipv6.route_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_metric_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.metric', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_metric_metric_rmm_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.metric', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_next_hop_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.next_hop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.next_hop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_next_hop_next_hop_filter_val_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.next_hop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.next_hop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_protocol_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.protocol', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.protocol', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_protocol_bgp_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_protocol_bgp_protocol_container_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_protocol_bgp_route_type_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_protocol_protocol_static_container_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_protocol_static_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_route_type_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.route_type', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.route_type', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_route_type_route_type_rmm_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.route_type', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.route_type', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_tag_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match.tag', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match.tag', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_match_vrf_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_as_path_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.as_path', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.as_path', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_as_path_prepend_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.as_path', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.as_path', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_as_path_tag_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.as_path', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.as_path', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_automatic_tag_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.automatic_tag', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.automatic_tag', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_automatic_tag_tag_empty_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.automatic_tag', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.automatic_tag', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_comm_list_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.comm_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.comm_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'comm_list_name, match_comm_delete'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_comm_list_comm_list_name_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.comm_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.comm_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_comm_list_delete_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.comm_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.comm_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_community_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_community_set_community_expr_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_dampening_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_life, reuse, suppress, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_dampening_half_life_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_dampening_max_suppress_time_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_dampening_reuse_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_dampening_suppress_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_distance_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.distance', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.distance', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_distance_dist_rms_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.distance', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.distance', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_extcommunity_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.extcommunity', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.extcommunity', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_extcommunity_rt_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.extcommunity.rt', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.extcommunity.rt', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_extcommunity_rt_asn_nn_rt_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.extcommunity.rt', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.extcommunity.rt', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_extcommunity_soo_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.extcommunity.soo', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.extcommunity.soo', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_extcommunity_soo_asn_nn_soo_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.extcommunity.soo', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.extcommunity.soo', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ip_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ip_dscp_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip.dscp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip.dscp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ip_dscp_dscp_rms_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip.dscp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip.dscp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ip_global_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip.global_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip.global_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ip_global_next_global_hop_get(self, rbridge_id=None, route_map=None, next_global_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_global_hop: next_hop
    :param next_global_hop: Keyword argument tuple.

    :type next_hop: unicode
    :param next_hop: **next_global_hop** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip.global_.next_global_hop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip.global_.next_global_hop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_global_hop', 'keyval': 'next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map, next_global_hop=next_global_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map, next_global_hop=next_global_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ip_interface_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ip_interface_null0_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ip_next_hop_get(self, rbridge_id=None, route_map=None, next_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_hop: next_hop
    :param next_hop: Keyword argument tuple.

    :type next_hop: unicode
    :param next_hop: **next_hop** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip.next_ip.next_hop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip.next_ip.next_hop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop', 'keyval': 'next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map, next_hop=next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map, next_hop=next_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ip_next_hop_peer_address_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip.next_hop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip.next_hop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ip_next_ip_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip.next_ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip.next_ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ip_next_vrf_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip.next_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip.next_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ip_next_vrf_list_get(self, rbridge_id=None, route_map=None, next_vrf_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_vrf_list: vrf, next_hop
    :param next_vrf_list: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **next_vrf_list** tuple argument:  Next Hop Vrf Name

    :type next_hop: unicode
    :param next_hop: **next_vrf_list** tuple argument:  A.B.C.D;;IP address of next hop

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ip.next_vrf.next_vrf_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ip.next_vrf.next_vrf_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_vrf_list', 'keyval': 'vrf, next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map, next_vrf_list=next_vrf_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map, next_vrf_list=next_vrf_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ipv6_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ipv6', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ipv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ipv6_global_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ipv6.global_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ipv6.global_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ipv6_global_next_global_hop_get(self, rbridge_id=None, route_map=None, next_global_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_global_hop: next_hop
    :param next_global_hop: Keyword argument tuple.

    :type next_hop: unicode
    :param next_hop: **next_global_hop** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ipv6.global_.next_global_hop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ipv6.global_.next_global_hop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_global_hop', 'keyval': 'next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map, next_global_hop=next_global_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map, next_global_hop=next_global_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ipv6_interface_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ipv6.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ipv6.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ipv6_interface_null0_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ipv6.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ipv6.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ipv6_next_hop_get(self, rbridge_id=None, route_map=None, next_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_hop: next_hop
    :param next_hop: Keyword argument tuple.

    :type next_hop: unicode
    :param next_hop: **next_hop** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ipv6.next_ip.next_hop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ipv6.next_ip.next_hop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop', 'keyval': 'next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map, next_hop=next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map, next_hop=next_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ipv6_next_ip_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ipv6.next_ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ipv6.next_ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ipv6_next_vrf_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ipv6.next_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ipv6.next_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_ipv6_next_vrf_list_get(self, rbridge_id=None, route_map=None, next_vrf_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_vrf_list: vrf, next_hop
    :param next_vrf_list: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **next_vrf_list** tuple argument:  WORD 1-63;;Next Hop Vrf Name

    :type next_hop: unicode
    :param next_hop: **next_vrf_list** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.ipv6.next_vrf.next_vrf_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.ipv6.next_vrf.next_vrf_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_vrf_list', 'keyval': 'vrf, next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map, next_vrf_list=next_vrf_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map, next_vrf_list=next_vrf_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_local_preference_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.local_preference', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.local_preference', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_local_preference_local_preference_value_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.local_preference', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.local_preference', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_metric_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.metric', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'delta_rms, metric_rms'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_metric_delta_rms_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.metric', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_metric_metric_rms_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.metric', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_metric_type_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_metric_type_external_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_metric_type_internal_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_metric_type_type_1_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_metric_type_type_2_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.metric_type', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_origin_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.origin', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.origin', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_origin_igp_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.origin', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.origin', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_origin_incomplete_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.origin', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.origin', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_route_type_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.route_type', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.route_type', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_route_type_route_type_rms_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.route_type', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.route_type', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_tag_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.tag', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.tag', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_tag_tag_rms_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.tag', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.tag', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_weight_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.weight', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.weight', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_route_map_set_weight_weight_value_get(self, rbridge_id=None, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.route_map', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.route_map.content.set_.weight', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.route_map.content.set_.weight', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_af_common_cmds_holder_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_af_ipv4_uc_and_vrf_cmds_call_point_holder_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_aggregate_address_get(self, rbridge_id=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_aggregate_address_advertise_map_get(self, rbridge_id=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_aggregate_address_as_set_get(self, rbridge_id=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_aggregate_address_attribute_map_get(self, rbridge_id=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_aggregate_address_summary_only_get(self, rbridge_id=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_aggregate_address_suppress_map_get(self, rbridge_id=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_always_propagate_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_bgp_redistribute_internal_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_client_to_client_reflection_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_dampening_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening': [u'dampening_flag', u'values', u'dampening_route_map'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening': [u'dampening_flag', u'values', u'dampening_route_map']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_dampening_dampening_flag_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_dampening_half_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_dampening_max_suppress_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_dampening_reuse_value_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_dampening_route_map_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_dampening_start_suppress_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_dampening_values_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time'], 'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_default_information_originate_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_default_metric_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_default_vrf_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_default_vrf_selected_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_graceful_restart_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_graceful_restart_graceful_restart_status_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_graceful_restart_purge_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_graceful_restart_restart_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_graceful_restart_stale_routes_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_maximum_paths_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_maximum_paths_ebgp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_maximum_paths_ibgp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_maximum_paths_load_sharing_value_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_maximum_paths_use_load_sharing_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_multipath_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_multipath_ebgp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_multipath_ibgp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_multipath_multi_as_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'best, all'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}]
    leafval_map = {"pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address": {"af_nei_weight": "af_nei_weight", "af_ipv4_neighbor_address": "af_ipv4_neighbor_address", "activate": "activate", "allowas_in": "allowas_in", "route_reflector_client": "route_reflector_client"}, "pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_activate_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'best, all'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_additional_paths_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_additional_paths_advertise_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.advertise': [u'all', u'best']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_additional_paths_advertise_all_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_additional_paths_advertise_best_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_allowas_in_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'best, all'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_additional_paths_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_additional_paths_add_path_both_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_additional_paths_receive_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_additional_paths_send_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_orf_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_orf_prefixlist_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_orf_prefixlist_prefixlist_status_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_orf_prefixlist_receive_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_orf_prefixlist_send_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_default_originate_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_originate_status, default_originate_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_default_originate_default_originate_status_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_default_originate_route_map_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_enable_peer_as_check_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'best, all'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_filter_list_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_filter_list_direction_in_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_filter_list_direction_out_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_filter_list_filter_list_direction_in_acl_name_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_filter_list_filter_list_direction_out_acl_name_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_filter_list_in_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_filter_list_out_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_holder_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_prefix_limit'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_max_prefix_limit_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_teardown_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_threshold_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_threshold_holder_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_direction_in_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_direction_out_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_in_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_ip_access_number_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_ip_access_number_direction_out_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_out_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_prefix_list_direction_in_prefix_name_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_prefix_list_direction_out_prefix_name_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_map_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_map_in_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_map_in_neighbor_route_map_name_direction_in_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_map_out_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_map_out_neighbor_route_map_name_direction_out_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_reflector_client_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'best, all'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_both_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_extended_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_send_community_status_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_standard_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_unsuppress_map_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.unsuppress_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.unsuppress_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_unsuppress_map_map_name_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.unsuppress_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.unsuppress_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_weight_get(self, rbridge_id=None, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'best, all'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'best, all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'threshold, teardown'}]
    leafval_map = {"pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup": {"af_nei_weight": "af_nei_weight", "af_ipv4_neighbor_peergroup_name": "af_ipv4_neighbor_peergroup_name", "activate": "activate", "allowas_in": "allowas_in", "route_reflector_client": "route_reflector_client"}, "pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_activate_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'best, all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'threshold, teardown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_additional_paths_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_additional_paths_advertise_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.advertise': [u'all', u'best']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_additional_paths_advertise_all_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_additional_paths_advertise_best_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_allowas_in_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'best, all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'threshold, teardown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_additional_paths_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_additional_paths_add_path_both_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_additional_paths_receive_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_additional_paths_send_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_orf_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_orf_prefixlist_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_orf_prefixlist_prefixlist_status_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_orf_prefixlist_receive_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_orf_prefixlist_send_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_default_originate_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_originate_status, default_originate_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_default_originate_default_originate_status_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_default_originate_route_map_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_enable_peer_as_check_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'best, all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'map_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_filter_list_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_filter_list_direction_in_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_filter_list_direction_out_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_filter_list_filter_list_direction_in_acl_name_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_filter_list_filter_list_direction_out_acl_name_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_filter_list_in_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_filter_list_out_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_holder_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_prefix_limit'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_max_prefix_limit_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_teardown_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_threshold_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_threshold_holder_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_direction_in_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_direction_out_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_in_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_ip_access_number_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_ip_access_number_direction_out_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_out_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_prefix_list_direction_in_prefix_name_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_prefix_list_direction_out_prefix_name_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_map_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_map_in_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_map_in_neighbor_route_map_name_direction_in_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_map_out_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_map_out_neighbor_route_map_name_direction_out_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_reflector_client_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'best, all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'threshold, teardown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_both_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_extended_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_send_community_status_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_standard_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_unsuppress_map_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.unsuppress_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.unsuppress_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_unsuppress_map_map_name_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.unsuppress_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.unsuppress_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_weight_get(self, rbridge_id=None, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'best, all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'threshold, teardown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_network_get(self, rbridge_id=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_network_backdoor_get(self, rbridge_id=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_network_route_map_get(self, rbridge_id=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_network_weight_get(self, rbridge_id=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_next_hop_enable_default_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_next_hop_recursion_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_bgp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_bgp_metric_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_bgp_redistribute_bgp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_bgp_route_map_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_connected_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_connected_metric_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_connected_redistribute_connected_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_connected_route_map_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_ospf_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_ospf_match_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_ospf_match_external1_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_ospf_match_external2_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_ospf_match_internal_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_ospf_metric_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_ospf_redistribute_ospf_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_ospf_route_map_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_static_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_static_metric_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_static_redistribute_static_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_redistribute_static_route_map_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_rib_route_limit_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_static_network_get(self, rbridge_id=None, static_network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_network: static_network_address
    :param static_network: Keyword argument tuple.

    :type static_network_address: unicode
    :param static_network_address: **static_network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_network', 'keyval': 'static_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_network=static_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_network=static_network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_static_network_distance_get(self, rbridge_id=None, static_network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_network: static_network_address
    :param static_network: Keyword argument tuple.

    :type static_network_address: unicode
    :param static_network_address: **static_network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_network', 'keyval': 'static_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, static_network=static_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, static_network=static_network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_table_map_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_table_map_route_map_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_update_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'listen_range'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'listen_range_prefix, peer_group, limit'}, {'leafval': 'num_as_in_path'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_get(self, rbridge_id=None, af_vrf=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_advertise_map_get(self, rbridge_id=None, af_vrf=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_as_set_get(self, rbridge_id=None, af_vrf=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_attribute_map_get(self, rbridge_id=None, af_vrf=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_summary_only_get(self, rbridge_id=None, af_vrf=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_suppress_map_get(self, rbridge_id=None, af_vrf=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_always_propagate_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'listen_range'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'listen_range_prefix, peer_group, limit'}, {'leafval': 'num_as_in_path'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_bgp_redistribute_internal_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_client_to_client_reflection_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'listen_range'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'listen_range_prefix, peer_group, limit'}, {'leafval': 'num_as_in_path'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_dampening_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening': [u'dampening_flag', u'values', u'dampening_route_map'], 'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening': [u'dampening_flag', u'values', u'dampening_route_map']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_dampening_dampening_flag_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_dampening_half_time_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_dampening_max_suppress_time_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_dampening_reuse_value_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_dampening_route_map_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_dampening_start_suppress_time_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_dampening_values_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values': [u'half_time'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values': [u'half_time']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_default_information_originate_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'listen_range'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'listen_range_prefix, peer_group, limit'}, {'leafval': 'num_as_in_path'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_default_metric_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'listen_range'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'listen_range_prefix, peer_group, limit'}, {'leafval': 'num_as_in_path'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_graceful_restart_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'listen_range'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'listen_range_prefix, peer_group, limit'}, {'leafval': 'num_as_in_path'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_listen_range_get(self, rbridge_id=None, af_vrf=None, listen_range=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type listen_range: listen_range_prefix, peer_group, limit
    :param listen_range: Keyword argument tuple.

    :type listen_range_prefix: unicode
    :param listen_range_prefix: **listen_range** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type peer_group: unicode
    :param peer_group: **listen_range** tuple argument:  Peer group name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type limit: long
    :param limit: **listen_range** tuple argument:  Limit the neighbor

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.listen_range', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'listen_range', 'keyval': 'listen_range_prefix, peer_group', 'extra_keyval': 'listen_range_prefix, peer_group, limit'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, listen_range=listen_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, listen_range=listen_range)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_listen_range_limit_get(self, rbridge_id=None, af_vrf=None, listen_range=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type listen_range: listen_range_prefix, peer_group
    :param listen_range: Keyword argument tuple.

    :type listen_range_prefix: unicode
    :param listen_range_prefix: **listen_range** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type peer_group: unicode
    :param peer_group: **listen_range** tuple argument:  Peer group name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.listen_range', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'listen_range', 'keyval': 'listen_range_prefix, peer_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, listen_range=listen_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, listen_range=listen_range)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_local_as_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'listen_range'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'listen_range_prefix, peer_group, limit'}, {'leafval': 'num_as_in_path'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_maxas_limit_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_maxas_limit_in_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_maxas_limit_in_num_as_in_path_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_ebgp_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_ibgp_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_load_sharing_value_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_use_load_sharing_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_multipath_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_multipath_ebgp_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_multipath_ibgp_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_multipath_multi_as_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'best, all'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'map_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {"pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr": {"static_network_edge": "static_network_edge", "activate": "activate", "remote_as": "remote_as", "associate_peer_group": "associate_peer_group", "ebgp_btsh": "ebgp_btsh", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "af_ipv4_neighbor_address": "af_ipv4_neighbor_address", "route_reflector_client": "route_reflector_client", "remove_private_as": "remove_private_as", "password": "password", "as_override": "as_override", "description": "description"}, "pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_activate_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'best, all'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'map_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_additional_paths_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_additional_paths_advertise_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.advertise': [u'all', u'best']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_additional_paths_advertise_all_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_additional_paths_advertise_best_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_advertisement_interval_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_advertisement_interval_value_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_allowas_in_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'best, all'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'map_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_as_override_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'best, all'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'map_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_bfd_enable_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_holdover_interval_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_interval_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_interval_min_rx_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_interval_min_tx_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_interval_multiplier_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_additional_paths_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_additional_paths_add_path_both_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_additional_paths_receive_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_additional_paths_send_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_as4_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_as4_disable_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_as4_enable_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_orf_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_orf_prefixlist_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_orf_prefixlist_prefixlist_status_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_orf_prefixlist_receive_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_orf_prefixlist_send_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_default_originate_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_originate_status, default_originate_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_default_originate_default_originate_status_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_default_originate_route_map_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_description_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'best, all'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'map_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_ebgp_btsh_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'best, all'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'map_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_ebgp_multihop_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_ebgp_multihop_ebgp_multihop_count_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_ebgp_multihop_ebgp_multihop_flag_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_enable_peer_as_check_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'best, all'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'map_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_enforce_first_as_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_enforce_first_as_disable_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_enforce_first_as_enable_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_filter_list_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_filter_list_direction_in_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_filter_list_direction_out_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_filter_list_filter_list_direction_in_acl_name_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_filter_list_filter_list_direction_out_acl_name_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_filter_list_in_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_filter_list_out_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_local_as_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_local_as_local_as_value_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_local_as_no_prepend_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maxas_limit_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maxas_limit_in_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'num_as_in_as_path, maxas_limit_disable'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maxas_limit_in_disable_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maxas_limit_in_num_as_in_as_path_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_prefix_limit'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_max_prefix_limit_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_teardown_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_threshold_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_threshold_holder_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_next_hop_self_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status'], 'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_next_hop_self_always_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_next_hop_self_next_hop_self_status_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_password_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'best, all'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'map_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_peer_group_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'best, all'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'map_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_direction_in_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_direction_out_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_in_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_ip_access_number_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_ip_access_number_direction_out_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_out_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_prefix_list_direction_in_prefix_name_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_prefix_list_direction_out_prefix_name_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_remote_as_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'best, all'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'map_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_remove_private_as_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'best, all'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'map_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_map_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_map_in_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_map_in_neighbor_route_map_name_direction_in_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_map_out_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_map_out_neighbor_route_map_name_direction_out_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_reflector_client_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'best, all'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'map_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_both_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_extended_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_send_community_status_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_standard_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_shutdown_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'shutdown_status, generate_rib_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_shutdown_generate_rib_out_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_shutdown_shutdown_status_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_soft_reconfiguration_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.soft_reconfiguration', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.soft_reconfiguration', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_soft_reconfiguration_inbound_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.soft_reconfiguration', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.soft_reconfiguration', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_static_network_edge_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'best, all'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'map_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_timers_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'nei_keep_alive, nei_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_timers_hold_time_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_timers_keep_alive_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_unsuppress_map_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.unsuppress_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.unsuppress_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_unsuppress_map_map_name_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.unsuppress_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.unsuppress_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source": {"ve_interface": "ve_interface", "sip_ipv4_address": "sip_ipv4_address", "loopback": "loopback"}, "pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source': [u'ethernet_interface', u've_interface', u'sip_ipv4_address', u'loopback'], 'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source': [u'ethernet_interface', u've_interface', u'loopback', u'sip_ipv4_address', u'port_channel']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_ethernet_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_ethernet_interface_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, ethernet'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_interface_type_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_loopback_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_port_channel_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_sip_ipv4_address_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_ve_interface_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_weight_get(self, rbridge_id=None, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'best, all'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'map_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_vrf_neighbor_address_holder_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_network_get(self, rbridge_id=None, af_vrf=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_network_backdoor_get(self, rbridge_id=None, af_vrf=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_network_route_map_get(self, rbridge_id=None, af_vrf=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_network_weight_get(self, rbridge_id=None, af_vrf=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_next_hop_enable_default_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'listen_range'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'listen_range_prefix, peer_group, limit'}, {'leafval': 'num_as_in_path'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_next_hop_recursion_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'listen_range'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'listen_range_prefix, peer_group, limit'}, {'leafval': 'num_as_in_path'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_bgp_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_bgp_metric_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_bgp_redistribute_bgp_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_bgp_route_map_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_connected_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_connected_metric_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_connected_redistribute_connected_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_connected_route_map_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_match_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_match_external1_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_match_external2_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_match_internal_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_metric_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_redistribute_ospf_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_route_map_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_static_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_static_metric_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_static_redistribute_static_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_redistribute_static_route_map_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_rib_route_limit_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'listen_range'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'listen_range_prefix, peer_group, limit'}, {'leafval': 'num_as_in_path'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_static_network_get(self, rbridge_id=None, af_vrf=None, static_network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type static_network: static_network_address
    :param static_network: Keyword argument tuple.

    :type static_network_address: unicode
    :param static_network_address: **static_network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_network', 'keyval': 'static_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, static_network=static_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, static_network=static_network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_static_network_distance_get(self, rbridge_id=None, af_vrf=None, static_network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type static_network: static_network_address
    :param static_network: Keyword argument tuple.

    :type static_network_address: unicode
    :param static_network_address: **static_network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_network', 'keyval': 'static_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf, static_network=static_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf, static_network=static_network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_table_map_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.table_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.table_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_table_map_route_map_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.table_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.table_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv4_unicast_vrf_update_time_get(self, rbridge_id=None, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'listen_range'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'listen_range_prefix, peer_group, limit'}, {'leafval': 'num_as_in_path'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_af_common_cmds_holder_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_af_ipv6_uc_and_vrf_cmds_call_point_holder_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_aggregate_address_get(self, rbridge_id=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_aggregate_address_advertise_map_get(self, rbridge_id=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_aggregate_address_as_set_get(self, rbridge_id=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_aggregate_address_attribute_map_get(self, rbridge_id=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_aggregate_address_summary_only_get(self, rbridge_id=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_aggregate_address_suppress_map_get(self, rbridge_id=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_always_propagate_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_bgp_redistribute_internal_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_client_to_client_reflection_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_dampening_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening': [u'dampening_flag', u'values', u'dampening_route_map'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening': [u'dampening_flag', u'values', u'dampening_route_map']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_dampening_dampening_flag_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_dampening_half_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_dampening_max_suppress_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_dampening_reuse_value_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_dampening_route_map_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_dampening_start_suppress_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_dampening_values_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_default_information_originate_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_default_metric_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_default_vrf_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_default_vrf_selected_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_graceful_restart_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_graceful_restart_graceful_restart_status_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_graceful_restart_purge_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_graceful_restart_restart_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_graceful_restart_stale_routes_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_maximum_paths_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_maximum_paths_ebgp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_maximum_paths_ibgp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_maximum_paths_load_sharing_value_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_maximum_paths_use_load_sharing_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_multipath_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_multipath_ebgp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_multipath_ibgp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_multipath_multi_as_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {"pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address": {"af_ipv6_neighbor_address": "af_ipv6_neighbor_address", "af_nei_weight": "af_nei_weight", "activate": "activate", "allowas_in": "allowas_in", "route_reflector_client": "route_reflector_client"}, "pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_activate_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_additional_paths_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_additional_paths_advertise_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.advertise': [u'all', u'best']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_additional_paths_advertise_all_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_additional_paths_advertise_best_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_allowas_in_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_additional_paths_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_additional_paths_add_path_both_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_additional_paths_receive_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_additional_paths_send_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_orf_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_orf_prefixlist_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_orf_prefixlist_prefixlist_status_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_orf_prefixlist_receive_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_orf_prefixlist_send_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_default_originate_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_originate_status, default_originate_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_default_originate_default_originate_status_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_default_originate_route_map_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_enable_peer_as_check_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_filter_list_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_filter_list_direction_in_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_filter_list_direction_out_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_filter_list_filter_list_direction_in_acl_name_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_filter_list_filter_list_direction_out_acl_name_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_filter_list_in_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_filter_list_out_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_holder_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_prefix_limit'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_max_prefix_limit_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_teardown_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_threshold_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_threshold_holder_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_direction_in_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_direction_out_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_in_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_ip_access_number_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_ip_access_number_direction_out_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_out_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_prefix_list_direction_in_prefix_name_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_prefix_list_direction_out_prefix_name_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_map_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_map_in_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_map_in_neighbor_route_map_name_direction_in_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_map_out_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_map_out_neighbor_route_map_name_direction_out_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_reflector_client_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_both_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_extended_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_send_community_status_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_standard_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_unsuppress_map_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.unsuppress_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.unsuppress_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_unsuppress_map_map_name_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.unsuppress_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.unsuppress_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_weight_get(self, rbridge_id=None, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}]
    leafval_map = {"pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup": {"af_nei_weight": "af_nei_weight", "activate": "activate", "af_ipv6_neighbor_peergroup_name": "af_ipv6_neighbor_peergroup_name", "route_reflector_client": "route_reflector_client", "allowas_in": "allowas_in"}, "pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_activate_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_additional_paths_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_additional_paths_advertise_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.advertise': [u'all', u'best']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_additional_paths_advertise_all_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_additional_paths_advertise_best_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_allowas_in_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_additional_paths_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_additional_paths_add_path_both_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_additional_paths_receive_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_additional_paths_send_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_orf_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_orf_prefixlist_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_orf_prefixlist_prefixlist_status_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_orf_prefixlist_receive_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_orf_prefixlist_send_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_default_originate_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_originate_status, default_originate_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_default_originate_default_originate_status_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_default_originate_route_map_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_enable_peer_as_check_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_filter_list_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_filter_list_direction_in_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_filter_list_direction_out_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_filter_list_filter_list_direction_in_acl_name_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_filter_list_filter_list_direction_out_acl_name_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_filter_list_in_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_filter_list_out_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_holder_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_prefix_limit'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_max_prefix_limit_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_teardown_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_threshold_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_threshold_holder_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_direction_in_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_direction_out_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_in_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_ip_access_number_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_ip_access_number_direction_out_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_out_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_prefix_list_direction_in_prefix_name_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_prefix_list_direction_out_prefix_name_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_map_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_map_in_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_map_in_neighbor_route_map_name_direction_in_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_map_out_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_map_out_neighbor_route_map_name_direction_out_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_reflector_client_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_both_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_extended_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_send_community_status_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_standard_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_unsuppress_map_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.unsuppress_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.unsuppress_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_unsuppress_map_map_name_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.unsuppress_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.unsuppress_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_weight_get(self, rbridge_id=None, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_network_get(self, rbridge_id=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_network_backdoor_get(self, rbridge_id=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_network_route_map_get(self, rbridge_id=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_network_weight_get(self, rbridge_id=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_next_hop_enable_default_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_next_hop_recursion_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_bgp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_bgp_metric_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_bgp_redistribute_bgp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_bgp_route_map_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_connected_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_connected_metric_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_connected_redistribute_connected_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_connected_route_map_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_ospf_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_ospf_match_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_ospf_match_external1_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_ospf_match_external2_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_ospf_match_internal_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_ospf_metric_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_ospf_redistribute_ospf_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_ospf_route_map_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_static_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_static_metric_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_static_redistribute_static_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_redistribute_static_route_map_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_rib_route_limit_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_table_map_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_table_map_route_map_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_update_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_get(self, rbridge_id=None, af_ipv6_vrf=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_advertise_map_get(self, rbridge_id=None, af_ipv6_vrf=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_as_set_get(self, rbridge_id=None, af_ipv6_vrf=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_attribute_map_get(self, rbridge_id=None, af_ipv6_vrf=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_summary_only_get(self, rbridge_id=None, af_ipv6_vrf=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_suppress_map_get(self, rbridge_id=None, af_ipv6_vrf=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_always_propagate_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_bgp_redistribute_internal_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_client_to_client_reflection_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_dampening_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening': [u'dampening_flag', u'values', u'dampening_route_map'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening': [u'dampening_flag', u'values', u'dampening_route_map']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_dampening_dampening_flag_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_dampening_half_time_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_dampening_max_suppress_time_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_dampening_reuse_value_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_dampening_route_map_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_dampening_start_suppress_time_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_dampening_values_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values': [u'half_time'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values': [u'half_time']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_default_information_originate_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_default_metric_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_graceful_restart_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_ebgp_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_ibgp_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_load_sharing_value_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_use_load_sharing_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_multipath_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_multipath_ebgp_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_multipath_ibgp_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_multipath_multi_as_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'map_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}]
    leafval_map = {"pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr": {"static_network_edge": "static_network_edge", "activate": "activate", "remote_as": "remote_as", "associate_peer_group": "associate_peer_group", "af_ipv6_neighbor_address": "af_ipv6_neighbor_address", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "route_reflector_client": "route_reflector_client", "ebgp_btsh": "ebgp_btsh", "remove_private_as": "remove_private_as", "password": "password", "as_override": "as_override", "description": "description"}, "pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_activate_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'map_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_additional_paths_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_additional_paths_advertise_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.advertise': [u'all', u'best']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_additional_paths_advertise_all_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_additional_paths_advertise_best_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.advertise', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_advertisement_interval_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_advertisement_interval_value_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_allowas_in_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'map_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_as_override_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'map_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_bfd_enable_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_holdover_interval_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_interval_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_interval_min_rx_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_interval_min_tx_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_interval_multiplier_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_additional_paths_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_additional_paths_add_path_both_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_additional_paths_receive_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_additional_paths_send_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_as4_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_as4_disable_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_as4_enable_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_orf_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_orf_prefixlist_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_orf_prefixlist_prefixlist_status_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_orf_prefixlist_receive_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_orf_prefixlist_send_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_default_originate_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_originate_status, default_originate_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_default_originate_default_originate_status_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_default_originate_route_map_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_description_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'map_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_ebgp_btsh_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'map_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_ebgp_multihop_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_ebgp_multihop_ebgp_multihop_count_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_ebgp_multihop_ebgp_multihop_flag_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_enable_peer_as_check_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_enforce_first_as_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_enforce_first_as_disable_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_enforce_first_as_enable_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_filter_list_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_filter_list_direction_in_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_filter_list_direction_out_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_filter_list_filter_list_direction_in_acl_name_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_filter_list_filter_list_direction_out_acl_name_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_filter_list_in_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_filter_list_out_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_local_as_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_local_as_local_as_value_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_local_as_no_prepend_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maxas_limit_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maxas_limit_in_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'num_as_in_as_path, maxas_limit_disable'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable'], 'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maxas_limit_in_disable_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maxas_limit_in_num_as_in_as_path_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_prefix_limit'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_max_prefix_limit_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_teardown_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_threshold_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_threshold_holder_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_next_hop_self_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_next_hop_self_always_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_next_hop_self_next_hop_self_status_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_password_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'map_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_peer_group_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'map_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_direction_in_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_direction_out_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_in_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_ip_access_number_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_ip_access_number_direction_out_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_out_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_prefix_list_direction_in_prefix_name_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_prefix_list_direction_out_prefix_name_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_remote_as_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'map_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_remove_private_as_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'map_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_map_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_map_in_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_map_in_neighbor_route_map_name_direction_in_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_map_out_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_map_out_neighbor_route_map_name_direction_out_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_reflector_client_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'map_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_both_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_extended_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_send_community_status_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_standard_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_shutdown_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'shutdown_status, generate_rib_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_shutdown_generate_rib_out_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_shutdown_shutdown_status_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_soft_reconfiguration_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.soft_reconfiguration', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.soft_reconfiguration', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_soft_reconfiguration_inbound_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.soft_reconfiguration', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.soft_reconfiguration', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_static_network_edge_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'map_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_timers_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'nei_keep_alive, nei_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_timers_hold_time_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_timers_keep_alive_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_unsuppress_map_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.unsuppress_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.unsuppress_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_unsuppress_map_map_name_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.unsuppress_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.unsuppress_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source": {}, "pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source": {"sip_ipv6_address": "sip_ipv6_address", "ve_interface": "ve_interface", "loopback": "loopback"}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source': [u'ethernet_interface', u'sip_ipv6_address', u've_interface', u'port_channel', u'loopback'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source': [u'ethernet_interface', u'sip_ipv6_address', u've_interface', u'loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_ethernet_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_ethernet_interface_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, ethernet'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_interface_type_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_loopback_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_port_channel_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_sip_ipv6_address_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_ve_interface_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_weight_get(self, rbridge_id=None, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'map_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'map_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_vrf_neighbor_address_holder_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_network_get(self, rbridge_id=None, af_ipv6_vrf=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_network_backdoor_get(self, rbridge_id=None, af_ipv6_vrf=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_network_route_map_get(self, rbridge_id=None, af_ipv6_vrf=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_network_weight_get(self, rbridge_id=None, af_ipv6_vrf=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_next_hop_enable_default_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_next_hop_recursion_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_bgp_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_bgp_metric_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_bgp_redistribute_bgp_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_bgp_route_map_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_connected_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_connected_metric_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_connected_redistribute_connected_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_connected_route_map_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_match_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_match_external1_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_match_external2_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_match_internal_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_metric_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_redistribute_ospf_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_route_map_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_static_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_static_metric_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_static_redistribute_static_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_redistribute_static_route_map_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_rib_route_limit_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_table_map_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.table_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.table_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_table_map_route_map_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.table_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.table_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_ipv6_unicast_vrf_update_time_get(self, rbridge_id=None, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, allowas_in, activate, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_client_to_client_reflection_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_graceful_restart_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_graceful_restart_graceful_restart_status_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_graceful_restart_purge_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_graceful_restart_restart_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_graceful_restart_stale_routes_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_activate_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_allowas_in_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_enable_peer_as_check_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_maximum_prefix_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_next_hop_unchanged_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_route_map_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_route_map_in_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_route_map_in_route_map_name_direction_in_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_route_map_out_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_route_map_out_route_map_name_direction_out_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_route_reflector_client_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_send_community_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_send_community_both_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_send_community_extended_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_send_community_send_community_status_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_send_community_standard_get(self, rbridge_id=None, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_activate_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_allowas_in_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_enable_peer_as_check_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_maximum_prefix_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_next_hop_unchanged_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_route_map_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_route_map_in_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_route_map_in_route_map_name_direction_in_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_route_map_out_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_route_map_out_route_map_name_direction_out_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_route_reflector_client_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_send_community_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_send_community_both_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_send_community_extended_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_send_community_send_community_status_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_send_community_standard_get(self, rbridge_id=None, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_activate_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_allowas_in_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_enable_peer_as_check_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_maximum_prefix_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_next_hop_unchanged_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_route_map_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_route_map_in_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_route_map_in_route_map_name_direction_in_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_route_map_out_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_route_map_out_route_map_name_direction_out_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_route_reflector_client_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_send_community_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_send_community_both_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_send_community_extended_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_send_community_send_community_status_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_send_community_standard_get(self, rbridge_id=None, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_retain_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.retain', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_retain_route_target_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.retain.route_target', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_retain_route_target_all_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.retain.route_target', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_address_family_l2vpn_evpn_vtep_discovery_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_always_compare_med_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_as_path_ignore_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_auto_shutdown_new_neighbors_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_bfd_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_bfd_holdover_interval_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_bfd_interval_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_bfd_interval_min_rx_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_bfd_interval_min_tx_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_bfd_interval_multiplier_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_capability_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.capability', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.capability', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_capability_as4_enable_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.capability', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.capability', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_cluster_id_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id': [u'cluster_id_value', u'cluster_id_ipv4_address'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id': [u'cluster_id_value', u'cluster_id_ipv4_address']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_cluster_id_id_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_cluster_id_ipv4_address_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_compare_med_empty_aspath_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_compare_routerid_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_confederation_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.confederation', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.confederation', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_confederation_identifier_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.confederation', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.confederation', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_default_local_preference_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_distance_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.distance', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.distance', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ext_route_distance, int_route_distance, lcl_route_distance'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_distance_ext_route_distance_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.distance', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.distance', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_distance_int_route_distance_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.distance', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.distance', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_distance_lcl_route_distance_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.distance', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.distance', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_enforce_first_as_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_fast_external_fallover_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_graceful_shutdown_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.graceful_shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'gshut_timer_value, gshut_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.graceful_shutdown': [u'gshut_timer_attributes', u'gshut_route_map']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_graceful_shutdown_community_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.graceful_shutdown.gshut_timer_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_graceful_shutdown_gshut_timer_attributes_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.graceful_shutdown.gshut_timer_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'gshut_local_pref, gshut_community'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.graceful_shutdown.gshut_timer_attributes': [u'gshut_local_pref']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_graceful_shutdown_gshut_timer_value_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.graceful_shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_graceful_shutdown_local_preference_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.graceful_shutdown.gshut_timer_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_graceful_shutdown_route_map_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.graceful_shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_install_igp_cost_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_listen_limit_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_listen_range_get(self, rbridge_id=None, listen_range=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type listen_range: listen_range_prefix, peer_group, limit
    :param listen_range: Keyword argument tuple.

    :type listen_range_prefix: unicode
    :param listen_range_prefix: **listen_range** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type peer_group: unicode
    :param peer_group: **listen_range** tuple argument:  Peer group name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type limit: long
    :param limit: **listen_range** tuple argument:  Limit the neighbor

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.listen_range', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'listen_range', 'keyval': 'listen_range_prefix, peer_group', 'extra_keyval': 'listen_range_prefix, peer_group, limit'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, listen_range=listen_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, listen_range=listen_range)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_listen_range_limit_get(self, rbridge_id=None, listen_range=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type listen_range: listen_range_prefix, peer_group
    :param listen_range: Keyword argument tuple.

    :type listen_range_prefix: unicode
    :param listen_range_prefix: **listen_range** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type peer_group: unicode
    :param peer_group: **listen_range** tuple argument:  Peer group name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.listen_range', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'listen_range', 'keyval': 'listen_range_prefix, peer_group', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, listen_range=listen_range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, listen_range=listen_range)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_local_as_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_log_dampening_debug_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_maxas_limit_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.maxas_limit', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.maxas_limit', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_maxas_limit_in_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_maxas_limit_in_num_as_in_path_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_med_missing_as_worst_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'value'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_advertisement_interval_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_advertisement_interval_value_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_as_override_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'value'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_bfd_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_bfd_bfd_enable_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_bfd_holdover_interval_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_bfd_interval_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_bfd_interval_min_rx_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_bfd_interval_min_tx_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_bfd_interval_multiplier_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_capability_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_capability_as4_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_capability_as4_disable_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_capability_as4_enable_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_description_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'value'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_ebgp_btsh_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'value'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_ebgp_multihop_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_ebgp_multihop_ebgp_multihop_count_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_ebgp_multihop_ebgp_multihop_flag_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_enforce_first_as_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_enforce_first_as_disable_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_enforce_first_as_enable_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_graceful_shutdown_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'gshut_timer_value, gshut_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown': [u'gshut_timer_attributes', u'gshut_route_map']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_graceful_shutdown_community_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown.gshut_timer_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_graceful_shutdown_gshut_timer_attributes_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown.gshut_timer_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'gshut_local_pref, gshut_community'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown.gshut_timer_attributes': [u'gshut_local_pref']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_graceful_shutdown_gshut_timer_value_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_graceful_shutdown_local_preference_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown.gshut_timer_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_graceful_shutdown_route_map_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_local_as_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_local_as_local_as_value_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_local_as_no_prepend_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_maxas_limit_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_maxas_limit_in_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'num_as_in_as_path, maxas_limit_disable'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_maxas_limit_in_disable_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_maxas_limit_in_num_as_in_as_path_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_next_hop_self_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_next_hop_self_always_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_next_hop_self_next_hop_self_status_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_password_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'value'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_peer_group_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'value'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_remote_as_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'value'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_remove_private_as_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'value'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_shutdown_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'shutdown_status, generate_rib_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_shutdown_generate_rib_out_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_shutdown_shutdown_status_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_soft_reconfiguration_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.soft_reconfiguration', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.soft_reconfiguration', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_soft_reconfiguration_inbound_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.soft_reconfiguration', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.soft_reconfiguration', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_static_network_edge_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'value'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_timers_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'nei_keep_alive, nei_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_timers_hold_time_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_timers_keep_alive_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_update_source_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source": {"ve_interface": "ve_interface", "sip_ipv4_address": "sip_ipv4_address", "loopback": "loopback"}, "pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source': [u'ethernet_interface', u've_interface', u'loopback', u'sip_ipv4_address', u'port_channel'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source': [u'ethernet_interface', u've_interface', u'sip_ipv4_address', u'loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_update_source_ethernet_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_update_source_ethernet_interface_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, ethernet'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_update_source_interface_type_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_update_source_loopback_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_update_source_port_channel_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_update_source_sip_ipv4_address_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_addr_update_source_ve_interface_get(self, rbridge_id=None, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ips_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_advertisement_interval_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_advertisement_interval_value_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_as_override_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_bfd_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_bfd_bfd_enable_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_bfd_holdover_interval_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_bfd_interval_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_bfd_interval_min_rx_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_bfd_interval_min_tx_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_bfd_interval_multiplier_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_capability_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_capability_as4_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_capability_as4_disable_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_capability_as4_enable_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_description_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_ebgp_btsh_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_ebgp_multihop_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_ebgp_multihop_ebgp_multihop_count_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_ebgp_multihop_ebgp_multihop_flag_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_enforce_first_as_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_enforce_first_as_disable_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_enforce_first_as_enable_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_graceful_shutdown_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'gshut_timer_value, gshut_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown': [u'gshut_timer_attributes', u'gshut_route_map']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_graceful_shutdown_community_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown.gshut_timer_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_graceful_shutdown_gshut_timer_attributes_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown.gshut_timer_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'gshut_local_pref, gshut_community'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown.gshut_timer_attributes': [u'gshut_local_pref']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_graceful_shutdown_gshut_timer_value_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_graceful_shutdown_local_preference_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown.gshut_timer_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_graceful_shutdown_route_map_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_local_as_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_local_as_local_as_value_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_local_as_no_prepend_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_maxas_limit_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_maxas_limit_in_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'num_as_in_as_path, maxas_limit_disable'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_maxas_limit_in_disable_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_maxas_limit_in_num_as_in_as_path_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_next_hop_self_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_next_hop_self_always_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_next_hop_self_next_hop_self_status_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_password_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_peer_group_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_remote_as_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_remove_private_as_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_shutdown_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'shutdown_status, generate_rib_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_shutdown_generate_rib_out_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_shutdown_shutdown_status_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_soft_reconfiguration_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.soft_reconfiguration', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.soft_reconfiguration', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_soft_reconfiguration_inbound_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.soft_reconfiguration', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.soft_reconfiguration', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_static_network_edge_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_timers_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'nei_keep_alive, nei_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_timers_hold_time_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_timers_keep_alive_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_update_source_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source": {}, "pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source": {"sip_ipv6_address": "sip_ipv6_address", "ve_interface": "ve_interface", "loopback": "loopback"}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source': [u'ethernet_interface', u'sip_ipv6_address', u've_interface', u'port_channel', u'loopback'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source': [u'ethernet_interface', u'sip_ipv6_address', u've_interface', u'loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_update_source_ethernet_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_update_source_ethernet_interface_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, ethernet'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_update_source_interface_type_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_update_source_loopback_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_update_source_port_channel_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_update_source_sip_ipv6_address_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6_addr_update_source_ve_interface_get(self, rbridge_id=None, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_ipv6s_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'alternate_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'value'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'inbound'}, {'leafval': 'add_, remove_'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {"pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp": {}, "pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp": {"static_network_edge": "static_network_edge", "remote_as": "remote_as", "description": "description", "ebgp_btsh": "ebgp_btsh", "router_bgp_neighbor_peer_grp": "router_bgp_neighbor_peer_grp", "peer_group_name": "peer_group_name", "remove_private_as": "remove_private_as", "password": "password", "as_override": "as_override"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_accept_lldp_neighbors_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'alternate_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'value'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'inbound'}, {'leafval': 'add_, remove_'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, sip_ipv6_address, port_channel, loopback, ve_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_advertisement_interval_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_advertisement_interval_value_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_alternate_as_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.alternate_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_alternate_as_add_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.alternate_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_alternate_as_remove_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.alternate_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_as_override_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'alternate_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'value'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'inbound'}, {'leafval': 'add_, remove_'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_bfd_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_bfd_bfd_enable_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_bfd_holdover_interval_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_bfd_interval_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_bfd_interval_min_rx_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_bfd_interval_min_tx_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_bfd_interval_multiplier_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_capability_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_capability_as4_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_capability_as4_disable_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_capability_as4_enable_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_description_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'alternate_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'value'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'inbound'}, {'leafval': 'add_, remove_'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_ebgp_btsh_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'alternate_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'value'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'inbound'}, {'leafval': 'add_, remove_'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_ebgp_multihop_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_ebgp_multihop_ebgp_multihop_count_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_ebgp_multihop_ebgp_multihop_flag_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_enforce_first_as_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_enforce_first_as_disable_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_enforce_first_as_enable_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_graceful_shutdown_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'gshut_timer_value, gshut_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown': [u'gshut_timer_attributes', u'gshut_route_map']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_graceful_shutdown_community_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown.gshut_timer_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_graceful_shutdown_gshut_timer_attributes_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown.gshut_timer_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'gshut_local_pref, gshut_community'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown.gshut_timer_attributes': [u'gshut_local_pref']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_graceful_shutdown_gshut_timer_value_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_graceful_shutdown_local_preference_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown.gshut_timer_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_graceful_shutdown_route_map_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_local_as_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_local_as_local_as_value_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_local_as_no_prepend_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_maxas_limit_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_maxas_limit_in_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'num_as_in_as_path, maxas_limit_disable'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable'], 'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_maxas_limit_in_disable_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_maxas_limit_in_num_as_in_as_path_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_next_hop_self_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status'], 'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_next_hop_self_always_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_next_hop_self_next_hop_self_status_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_password_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'alternate_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'value'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'inbound'}, {'leafval': 'add_, remove_'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_peer_group_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'alternate_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'value'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'inbound'}, {'leafval': 'add_, remove_'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_remote_as_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'alternate_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'value'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'inbound'}, {'leafval': 'add_, remove_'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_remove_private_as_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'alternate_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'value'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'inbound'}, {'leafval': 'add_, remove_'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_shutdown_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'shutdown_status, generate_rib_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_shutdown_generate_rib_out_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_shutdown_shutdown_status_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_soft_reconfiguration_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.soft_reconfiguration', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.soft_reconfiguration', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_soft_reconfiguration_inbound_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.soft_reconfiguration', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.soft_reconfiguration', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_static_network_edge_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'alternate_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'value'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'inbound'}, {'leafval': 'add_, remove_'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'value'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'interface_type, ethernet'}, {'leafval': 'inbound'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_timers_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'nei_keep_alive, nei_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_timers_hold_time_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_timers_keep_alive_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_update_source_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source": {"ve_interface": "ve_interface", "sip_ipv4_address": "sip_ipv4_address", "loopback": "loopback"}, "pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source': [u'ethernet_interface', u've_interface', u'sip_ipv4_address', u'loopback'], 'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source': [u'ethernet_interface', u'sip_ipv6_address', u'sip_ipv4_address', u'port_channel', u've_interface', u'loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_update_source_ethernet_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_update_source_ethernet_interface_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, ethernet'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface': [u'interface_type'], 'pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_update_source_interface_type_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_update_source_loopback_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_update_source_port_channel_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_update_source_sip_ipv4_address_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_update_source_sip_ipv6_address_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_neighbor_peer_grp_update_source_ve_interface_get(self, rbridge_id=None, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_neighbor_peer_grps_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_router_bgp_attributes_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes": {}, "pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes": {"fast_external_fallover": "fast_external_fallover", "compare_med_empty_aspath": "compare_med_empty_aspath", "default_local_preference": "default_local_preference", "med_missing_as_worst": "med_missing_as_worst", "enforce_first_as": "enforce_first_as", "always_compare_med": "always_compare_med", "local_as": "local_as", "log_dampening_debug": "log_dampening_debug", "install_igp_cost": "install_igp_cost", "compare_routerid": "compare_routerid", "as_path_ignore": "as_path_ignore"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_timers_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'keep_alive, hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_timers_hold_time_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_bgp_timers_keep_alive_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_hide_pim_holder_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'timers')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_addr'}, {'leafval': 'bgp_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'connected_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'static_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'route_map, direction_in'}, {'leafval': 'log_checksum'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'graceful_restart_enable, helper_disable, helper_strict_lsa_checking, restart_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'ospf_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'connected_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'neighbor_addr'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'route_map, in_'}, {'leafval': 'log_checksum'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'bgp_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'static_route_map'}, {'leafval': 'area_id, normal'}, {'leafval': 'lsa_group_pacing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.nssa', u'metric'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'nssa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.nssa', u'default_information_metric'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'range'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.stub', u'metric'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.nssa', u'metric'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'range'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'virtual_link'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.stub', u'metric'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'nssa')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'nssa_value, nssa_no_summary'}, {'leafval': 'default_information_originate, no_redistribution, translator_always, translator_interval'}, {'leafval': 'default_information_metric_value, default_information_metric_type'}, {'leafval': 'range_address, range_mask, range_effect, range_cost'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'virt_link_neighbor, dead_interval, hello_interval, retransmit_interval, transmit_delay'}, {'leafval': 'stub_value, no_summary'}, {'leafval': 'nssa_value, nssa_no_summary'}, {'leafval': 'range_address, range_mask, range_effect, range_cost'}, {'leafval': 'virt_link_neighbor, dead_interval, hello_interval, retransmit_interval, transmit_delay'}, {'leafval': 'stub_value, no_summary'}, {'leafval': 'default_information_originate'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_normal_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.prefix_list', u'direction_out'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.nssa', u'metric'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'nssa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.nssa', u'default_information_metric'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'range'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.prefix_list', u'direction_in'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.stub', u'metric'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.nssa', u'metric'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'range'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'virtual_link'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.stub', u'metric'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'nssa')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'nssa_value, nssa_no_summary'}, {'leafval': 'default_information_originate, no_redistribution, translator_always, translator_interval'}, {'leafval': 'default_information_metric_value, default_information_metric_type'}, {'leafval': 'range_address, range_mask, range_effect, range_cost'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'virt_link_neighbor, dead_interval, hello_interval, retransmit_interval, transmit_delay'}, {'leafval': 'stub_value, no_summary'}, {'leafval': 'nssa_value, nssa_no_summary'}, {'leafval': 'range_address, range_mask, range_effect, range_cost'}, {'leafval': 'virt_link_neighbor, dead_interval, hello_interval, retransmit_interval, transmit_delay'}, {'leafval': 'stub_value, no_summary'}, {'leafval': 'default_information_originate'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.nssa": {"default_information_originate": "default_information_originate"}, "pybind.nos.v7_2_0.rbridge_id.router.ospf.area.nssa": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_default_information_metric_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.nssa.default_information_metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_information_metric_value, default_information_metric_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_default_information_metric_metric_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.nssa.default_information_metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_default_information_metric_metric_type_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.nssa.default_information_metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_default_information_originate_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_metric_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.nssa.metric', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.nssa.metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'nssa_value, nssa_no_summary'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_no_redistribution_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_no_summary_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.nssa.metric', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.nssa.metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_nssa_value_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.nssa.metric', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.nssa.metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_translator_always_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_nssa_translator_interval_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.nssa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_prefix_list_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.prefix_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_prefix_list_direction_in_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_prefix_list_direction_out_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_prefix_list_in_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_prefix_list_out_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_prefix_list_prefix_list_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.prefix_list.direction_in', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_prefix_list_prefix_list_direction_out_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.prefix_list.direction_out', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_range_get(self, rbridge_id=None, ospf=None, area=None, range=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type range: range_address, range_mask, range_effect, range_cost
    :param range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **range** tuple argument:  A.B.C.D   IP address to match

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type range_mask: unicode
    :param range_mask: **range** tuple argument:  A.B.C.D   IP mask for address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type range_effect: unicode
    :param range_effect: **range** tuple argument:  Advertise/Do not advertise this type-3 summarization

        * enumeration restriction: ::

            ['advertise', 'not-advertise']

    :type range_cost: long
    :param range_cost: **range** tuple argument:  Configure area range cost

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.range', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.range', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'range', 'keyval': 'range_address, range_mask', 'extra_keyval': 'range_address, range_mask, range_effect, range_cost'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, range=range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, range=range)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_range_cost_get(self, rbridge_id=None, ospf=None, area=None, range=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type range: range_address, range_mask
    :param range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **range** tuple argument:  A.B.C.D   IP address to match

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type range_mask: unicode
    :param range_mask: **range** tuple argument:  A.B.C.D   IP mask for address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.range', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.range', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'range', 'keyval': 'range_address, range_mask', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, range=range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, range=range)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_range_range_effect_get(self, rbridge_id=None, ospf=None, area=None, range=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type range: range_address, range_mask
    :param range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **range** tuple argument:  A.B.C.D   IP address to match

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type range_mask: unicode
    :param range_mask: **range** tuple argument:  A.B.C.D   IP mask for address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.range', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.range', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'range', 'keyval': 'range_address, range_mask', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, range=range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, range=range)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_stub_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.stub', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.stub', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_stub_metric_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.stub.metric', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.stub.metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'stub_value, no_summary'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_stub_no_summary_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.stub.metric', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.stub.metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_stub_stub_value_get(self, rbridge_id=None, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.stub.metric', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.stub.metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'key_table')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'key_id, key, md5_authentication_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_authentication_key_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.authentication_key', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.authentication_key', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_authentication_key_auth_key_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_authentication_key_auth_key_table_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_authentication_key_encrypttype_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_authentication_key_no_encrypt_auth_key_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_authentication_key_no_encrypt_auth_key_table_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_dead_interval_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'key_table')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'key_id, key, md5_authentication_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_hello_interval_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'key_table')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'key_id, key, md5_authentication_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_md5_authentication_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_md5_authentication_key_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_md5_authentication_key_activation_wait_time_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_md5_authentication_key_id_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_md5_authentication_key_id_key_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_md5_authentication_key_id_key_id_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_md5_authentication_key_id_md5_authentication_key_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_md5_authentication_no_encrypt_key_table_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_encrypt_key_id, no_encrypt_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_retransmit_interval_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'key_table')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'key_id, key, md5_authentication_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_area_virtual_link_transmit_delay_get(self, rbridge_id=None, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'key_table'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.area.virtual_link.md5_authentication', u'key_table')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'key_id, key, md5_authentication_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_auto_cost_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.auto_cost', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.auto_cost', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_auto_cost_reference_bandwidth_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.auto_cost.reference_bandwidth', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.auto_cost.reference_bandwidth', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_auto_cost_reference_bandwidth_ref_bandwidth_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.auto_cost.reference_bandwidth', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.auto_cost.reference_bandwidth', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_auto_cost_reference_bandwidth_use_active_ports_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.auto_cost.reference_bandwidth', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.auto_cost.reference_bandwidth', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_bfd_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.global_bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.global_bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_bfd_bfd_enable_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.global_bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.global_bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_bfd_holdover_interval_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.global_bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.global_bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_database_overflow_interval_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'timers')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_addr'}, {'leafval': 'bgp_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'connected_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'static_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'route_map, direction_in'}, {'leafval': 'log_checksum'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'graceful_restart_enable, helper_disable, helper_strict_lsa_checking, restart_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'ospf_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'connected_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'neighbor_addr'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'route_map, in_'}, {'leafval': 'log_checksum'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'bgp_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'static_route_map'}, {'leafval': 'area_id, normal'}, {'leafval': 'lsa_group_pacing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_default_information_originate_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_default_information_originate_always_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_default_information_originate_metric_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_default_information_originate_metric_type_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_default_information_originate_route_map_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.default_information_originate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_default_metric_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'timers')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_addr'}, {'leafval': 'bgp_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'connected_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'static_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'route_map, direction_in'}, {'leafval': 'log_checksum'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'graceful_restart_enable, helper_disable, helper_strict_lsa_checking, restart_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'ospf_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'connected_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'neighbor_addr'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'route_map, in_'}, {'leafval': 'log_checksum'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'bgp_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'static_route_map'}, {'leafval': 'area_id, normal'}, {'leafval': 'lsa_group_pacing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_default_passive_interface_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'timers')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_addr'}, {'leafval': 'bgp_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'connected_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'static_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'route_map, direction_in'}, {'leafval': 'log_checksum'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'graceful_restart_enable, helper_disable, helper_strict_lsa_checking, restart_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'ospf_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'connected_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'neighbor_addr'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'route_map, in_'}, {'leafval': 'log_checksum'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'bgp_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'static_route_map'}, {'leafval': 'area_id, normal'}, {'leafval': 'lsa_group_pacing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_deny_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.deny', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.deny', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_deny_redistribute_get(self, rbridge_id=None, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option, address, mask, set_metric_val, match_metric_val
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type address: unicode
    :param address: **redistribute** tuple argument:  IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mask: unicode
    :param mask: **redistribute** tuple argument:  Subnet Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type set_metric_val: long
    :param set_metric_val: **redistribute** tuple argument:  Metric value

        * range restriction: ::

            ['0..4294967295']

    :type match_metric_val: long
    :param match_metric_val: **redistribute** tuple argument:  Metric value

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_deny_redistribute_address_get(self, rbridge_id=None, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_deny_redistribute_mask_get(self, rbridge_id=None, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_deny_redistribute_match_metric_get(self, rbridge_id=None, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_deny_redistribute_set_metric_get(self, rbridge_id=None, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.deny.redistribute', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_distance_get(self, rbridge_id=None, ospf=None, distance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propogation

        * enumeration restriction: ::

            ['intra-area', 'external', 'inter-area']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.distance', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.distance', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, distance=distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, distance=distance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_distance_dist_value_get(self, rbridge_id=None, ospf=None, distance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propogation

        * enumeration restriction: ::

            ['intra-area', 'external', 'inter-area']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.distance', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.distance', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, distance=distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, distance=distance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_distribute_list_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.distribute_list', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.distribute_list', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_distribute_list_route_map_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.distribute_list.route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.distribute_list.route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'route_map, in_'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.rbridge_id.router.ospf.distribute_list.route_map": {"route_map": "route_map"}, "pybind.nos.v6_0_2f.rbridge_id.router.ospf.distribute_list.route_map": {"route_map": "route_map", "in_": "in_"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_distribute_list_route_map_in_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.distribute_list.route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.distribute_list.route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.rbridge_id.router.ospf.distribute_list.route_map": {}, "pybind.nos.v6_0_2f.rbridge_id.router.ospf.distribute_list.route_map": {"in_": "in_"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_distribute_list_route_map_route_map_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.distribute_list.route_map', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.distribute_list.route_map', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_external_lsdb_limit_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'timers')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_addr'}, {'leafval': 'bgp_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'connected_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'static_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'route_map, direction_in'}, {'leafval': 'log_checksum'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'graceful_restart_enable, helper_disable, helper_strict_lsa_checking, restart_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'ospf_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'connected_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'neighbor_addr'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'route_map, in_'}, {'leafval': 'log_checksum'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'bgp_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'static_route_map'}, {'leafval': 'area_id, normal'}, {'leafval': 'lsa_group_pacing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_graceful_restart_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.rbridge_id.router.ospf.graceful_restart": {"graceful_restart_enable": "graceful_restart_enable", "restart_time": "restart_time", "helper_disable": "helper_disable"}, "pybind.nos.v7_2_0.rbridge_id.router.ospf.graceful_restart": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_graceful_restart_graceful_restart_enable_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_graceful_restart_helper_disable_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_graceful_restart_helper_strict_lsa_checking_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_graceful_restart_restart_time_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.graceful_restart', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_log_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_log_adjacency_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log.adjacency', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log.adjacency', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_log_adjacency_dr_only_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log.adjacency', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log.adjacency', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_log_all_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_log_bad_packet_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log.bad_packet', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log.bad_packet', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_log_bad_packet_checksum_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log.bad_packet', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log.bad_packet', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_log_database_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_log_retransmit_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_all_lsas_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_all_vrfs_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_external_lsa_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_external_lsa_external_lsa_val_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_link_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_link_all_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_link_ptp_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_link_stub_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_link_transit_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.link', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_all_lsas_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_external_lsa_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_external_lsa_external_lsa_val_onstartup_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_link_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_link_all_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_link_ptp_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_link_stub_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_link_transit_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_summary_lsa_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_summary_lsa_summary_lsa_val_onstartup_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_time_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_on_startup_wait_for_bgp_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_summary_lsa_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_max_metric_router_lsa_summary_lsa_summary_lsa_val_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_maximum_paths_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'timers')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_addr'}, {'leafval': 'bgp_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'connected_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'static_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'route_map, direction_in'}, {'leafval': 'log_checksum'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'graceful_restart_enable, helper_disable, helper_strict_lsa_checking, restart_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'ospf_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'connected_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'neighbor_addr'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'route_map, in_'}, {'leafval': 'log_checksum'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'bgp_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'static_route_map'}, {'leafval': 'area_id, normal'}, {'leafval': 'lsa_group_pacing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_metric_type_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'timers')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_addr'}, {'leafval': 'bgp_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'connected_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'static_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'route_map, direction_in'}, {'leafval': 'log_checksum'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'graceful_restart_enable, helper_disable, helper_strict_lsa_checking, restart_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'ospf_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'connected_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'neighbor_addr'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'route_map, in_'}, {'leafval': 'log_checksum'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'bgp_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'static_route_map'}, {'leafval': 'area_id, normal'}, {'leafval': 'lsa_group_pacing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_neighbor_get(self, rbridge_id=None, ospf=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_addr
    :param neighbor: Keyword argument tuple.

    :type neighbor_addr: unicode
    :param neighbor_addr: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.neighbor', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.neighbor', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_nonstop_routing_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'timers')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_addr'}, {'leafval': 'bgp_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'connected_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'static_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'route_map, direction_in'}, {'leafval': 'log_checksum'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'graceful_restart_enable, helper_disable, helper_strict_lsa_checking, restart_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'ospf_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'connected_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'neighbor_addr'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'route_map, in_'}, {'leafval': 'log_checksum'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'bgp_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'static_route_map'}, {'leafval': 'area_id, normal'}, {'leafval': 'lsa_group_pacing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_permit_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.permit', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.permit', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_permit_redistribute_get(self, rbridge_id=None, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option, address, mask, set_metric_val, match_metric_val
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type address: unicode
    :param address: **redistribute** tuple argument:  IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mask: unicode
    :param mask: **redistribute** tuple argument:  Subnet Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type set_metric_val: long
    :param set_metric_val: **redistribute** tuple argument:  Metric value

        * range restriction: ::

            ['0..4294967295']

    :type match_metric_val: long
    :param match_metric_val: **redistribute** tuple argument:  Metric value

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_permit_redistribute_address_get(self, rbridge_id=None, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_permit_redistribute_mask_get(self, rbridge_id=None, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_permit_redistribute_match_metric_get(self, rbridge_id=None, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_permit_redistribute_set_metric_get(self, rbridge_id=None, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.permit.redistribute', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_bgp_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_bgp_route_map_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute.bgp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute.bgp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_connected_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_connected_route_map_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute.connected', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute.connected', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_ospf_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_ospf_route_map_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute.redistribute_ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_static_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_redistribute_static_route_map_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_rfc1583_compatibility_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.rfc1583_compatibility', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.rfc1583_compatibility', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_rfc1583_compatibility_rfc1583_compatibility_flag_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.rfc1583_compatibility', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.rfc1583_compatibility', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_summary_address_get(self, rbridge_id=None, ospf=None, summary_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type summary_address: sum_address, sum_address_mask
    :param summary_address: Keyword argument tuple.

    :type sum_address: unicode
    :param sum_address: **summary_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type sum_address_mask: unicode
    :param sum_address_mask: **summary_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.summary_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.summary_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'summary_address', 'keyval': 'sum_address, sum_address_mask', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf, summary_address=summary_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf, summary_address=summary_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_timers_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_timers_lsa_group_pacing_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.timers', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.timers', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_timers_throttle_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.timers.throttle', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.timers.throttle', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_timers_throttle_spf_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'init_delay, hold_time, max_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_timers_throttle_spf_hold_time_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_timers_throttle_spf_init_delay_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_timers_throttle_spf_max_hold_time_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'ospf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.timers.throttle.spf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_ospf_vrf_lite_capability_get(self, rbridge_id=None, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.ospf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'log'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'area'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v7_2_0.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'adjacency'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric', u'router_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'default_information_originate'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'link'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.permit', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'graceful_restart'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'rfc1583_compatibility'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.deny', u'redistribute'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'neighbor'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.timers.throttle', u'spf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'global_bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.distribute_list', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.log', u'bad_packet'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'log'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'summary_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.router.ospf', u'timers')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_addr'}, {'leafval': 'bgp_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'connected_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'static_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'route_map, direction_in'}, {'leafval': 'log_checksum'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'area_id, normal'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'graceful_restart_enable, helper_disable, helper_strict_lsa_checking, restart_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'ospf_route_map'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'connected_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'neighbor_addr'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'route_map, in_'}, {'leafval': 'log_checksum'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'bgp_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'static_route_map'}, {'leafval': 'area_id, normal'}, {'leafval': 'lsa_group_pacing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim": {"nbr_timeout": "nbr_timeout", "max_mcache": "max_mcache", "hello_interval": "hello_interval", "message_interval": "message_interval", "spt_threshold": "spt_threshold", "inactivity_timer": "inactivity_timer"}, "pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_always_use_register_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_bsr_candidate_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim.bsr_candidate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.bsr_candidate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_bsr_candidate_interface_get(self, rbridge_id=None, bsr_cand_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bsr_cand_interface: bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority
    :param bsr_cand_interface: Keyword argument tuple.

    :type bsr_cand_intf_type: unicode
    :param bsr_cand_intf_type: **bsr_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['port-channel',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet']

    :type bsr_cand_intf_id: unicode
    :param bsr_cand_intf_id: **bsr_cand_interface** tuple argument:  String;;Interface ID

    :type hash_mask_length: int
    :param hash_mask_length: **bsr_cand_interface** tuple argument:  BSR hash mask

        * range restriction: ::

            ['0..65535']

    :type bsr_cand_priority: long
    :param bsr_cand_priority: **bsr_cand_interface** tuple argument:  BSR priority

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bsr_cand_interface', 'keyval': 'bsr_cand_intf_type, bsr_cand_intf_id', 'extra_keyval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bsr_cand_interface=bsr_cand_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bsr_cand_interface=bsr_cand_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_bsr_candidate_interface_mask_get(self, rbridge_id=None, bsr_cand_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bsr_cand_interface: bsr_cand_intf_type, bsr_cand_intf_id
    :param bsr_cand_interface: Keyword argument tuple.

    :type bsr_cand_intf_type: unicode
    :param bsr_cand_intf_type: **bsr_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['port-channel',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet']

    :type bsr_cand_intf_id: unicode
    :param bsr_cand_intf_id: **bsr_cand_interface** tuple argument:  String;;Interface ID

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bsr_cand_interface', 'keyval': 'bsr_cand_intf_type, bsr_cand_intf_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bsr_cand_interface=bsr_cand_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bsr_cand_interface=bsr_cand_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_bsr_candidate_interface_priority_get(self, rbridge_id=None, bsr_cand_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bsr_cand_interface: bsr_cand_intf_type, bsr_cand_intf_id
    :param bsr_cand_interface: Keyword argument tuple.

    :type bsr_cand_intf_type: unicode
    :param bsr_cand_intf_type: **bsr_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['port-channel',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet']

    :type bsr_cand_intf_id: unicode
    :param bsr_cand_intf_id: **bsr_cand_interface** tuple argument:  String;;Interface ID

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bsr_cand_interface', 'keyval': 'bsr_cand_intf_type, bsr_cand_intf_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, bsr_cand_interface=bsr_cand_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, bsr_cand_interface=bsr_cand_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_bsr_msg_interval_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_hello_interval_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_inactivity_timer_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_max_mcache_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_message_interval_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_nbr_timeout_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_reset_tracking_bit_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_rp_address_get(self, rbridge_id=None, rp_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rp_address: rp_ip_addr, prefix_list
    :param rp_address: Keyword argument tuple.

    :type rp_ip_addr: unicode
    :param rp_ip_addr: **rp_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type prefix_list: unicode
    :param prefix_list: **rp_address** tuple argument:  Prefix list

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim.rp_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.rp_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rp_address', 'keyval': 'rp_ip_addr', 'extra_keyval': 'rp_ip_addr, prefix_list'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rp_address=rp_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rp_address=rp_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_rp_address_prefix_list_get(self, rbridge_id=None, rp_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rp_address: rp_ip_addr
    :param rp_address: Keyword argument tuple.

    :type rp_ip_addr: unicode
    :param rp_ip_addr: **rp_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim.rp_address', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.rp_address', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rp_address', 'keyval': 'rp_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rp_address=rp_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rp_address=rp_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_rp_adv_interval_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_rp_candidate_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim.rp_candidate', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.rp_candidate', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_rp_candidate_group_range_get(self, rbridge_id=None, rp_cand_grp_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rp_cand_grp_prefix: rp_cand_grp_prefix_ip, rp_cand_grp_prefix_length
    :param rp_cand_grp_prefix: Keyword argument tuple.

    :type rp_cand_grp_prefix_ip: unicode
    :param rp_cand_grp_prefix_ip: **rp_cand_grp_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type rp_cand_grp_prefix_length: int
    :param rp_cand_grp_prefix_length: **rp_cand_grp_prefix** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_grp_prefix', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rp_cand_grp_prefix', 'keyval': 'rp_cand_grp_prefix_ip, rp_cand_grp_prefix_length', 'extra_keyval': 'rp_cand_grp_prefix_ip, rp_cand_grp_prefix_length'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rp_cand_grp_prefix=rp_cand_grp_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rp_cand_grp_prefix=rp_cand_grp_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_rp_candidate_interface_get(self, rbridge_id=None, rp_cand_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rp_cand_interface: rp_cand_intf_type, rp_cand_intf_id
    :param rp_cand_interface: Keyword argument tuple.

    :type rp_cand_intf_type: unicode
    :param rp_cand_intf_type: **rp_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['port-channel',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet']

    :type rp_cand_intf_id: unicode
    :param rp_cand_intf_id: **rp_cand_interface** tuple argument:  Interface ID

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rp_cand_interface', 'keyval': 'rp_cand_intf_type, rp_cand_intf_id', 'extra_keyval': 'rp_cand_intf_type, rp_cand_intf_id, rp_cand_priority'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_interface": {}, "pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_interface": {"rp_cand_intf_id": "rp_cand_intf_id", "rp_cand_intf_type": "rp_cand_intf_type"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rp_cand_interface=rp_cand_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rp_cand_interface=rp_cand_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_rp_candidate_interface_priority_get(self, rbridge_id=None, rp_cand_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rp_cand_interface: rp_cand_intf_type, rp_cand_intf_id
    :param rp_cand_interface: Keyword argument tuple.

    :type rp_cand_intf_type: unicode
    :param rp_cand_intf_type: **rp_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['port-channel',
            've',
            'loopback',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet']

    :type rp_cand_intf_id: unicode
    :param rp_cand_intf_id: **rp_cand_interface** tuple argument:  Interface ID

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rp_cand_interface', 'keyval': 'rp_cand_intf_type, rp_cand_intf_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rp_cand_interface=rp_cand_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rp_cand_interface=rp_cand_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_rp_candidate_rp_cand_grp_prefix_get(self, rbridge_id=None, rp_cand_grp_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type rp_cand_grp_prefix: rp_cand_grp_prefix_action, rp_cand_grp_prefix_ip, rp_cand_grp_prefix_length
    :param rp_cand_grp_prefix: Keyword argument tuple.

    :type rp_cand_grp_prefix_action: unicode
    :param rp_cand_grp_prefix_action: **rp_cand_grp_prefix** tuple argument.

        * enumeration restriction: ::

            ['add', 'delete']

    :type rp_cand_grp_prefix_ip: unicode
    :param rp_cand_grp_prefix_ip: **rp_cand_grp_prefix** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type rp_cand_grp_prefix_length: int
    :param rp_cand_grp_prefix_length: **rp_cand_grp_prefix** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim.rp_candidate.rp_cand_grp_prefix', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rp_cand_grp_prefix', 'keyval': 'rp_cand_grp_prefix_action, rp_cand_grp_prefix_ip, rp_cand_grp_prefix_length', 'extra_keyval': 'rp_cand_grp_prefix_action, rp_cand_grp_prefix_ip, rp_cand_grp_prefix_length'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, rp_cand_grp_prefix=rp_cand_grp_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, rp_cand_grp_prefix=rp_cand_grp_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_router_pim_spt_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_secpolicy_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.secpolicy', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.secpolicy', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_secpolicy_active_policy_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.secpolicy.active_policy', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.secpolicy.active_policy', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_secpolicy_active_policy_policies_get(self, rbridge_id=None, policies=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type policies: policy
    :param policies: Keyword argument tuple.

    :type policy: unicode
    :param policy: **policies** tuple argument.

        * pattern restriction: ::

            'SCC_POLICY'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.secpolicy.active_policy.policies', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.secpolicy.active_policy.policies', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.secpolicy.active_policy.policies', u'member_entry'), ('pybind.nos.v6_0_2f.rbridge_id.secpolicy.active_policy.policies', u'member_entry')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'policies', 'keyval': 'policy', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'member'}, {'leafval': 'member'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policies=policies)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policies=policies)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_secpolicy_active_policy_policies_member_entry_get(self, rbridge_id=None, policies=None, member_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policies: policy
    :param policies: Keyword argument tuple.

    :type policy: unicode
    :param policy: **policies** tuple argument.

        * pattern restriction: ::

            'SCC_POLICY'

    **Instance Keyword Argument Tuple**:

    :type member_entry: member
    :param member_entry: Keyword argument tuple.

    :type member: unicode
    :param member: **member_entry** tuple argument:  WWN of the switch

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.secpolicy.active_policy.policies', u'policies'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.secpolicy.active_policy.policies', u'policies')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.secpolicy.active_policy.policies.member_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.secpolicy.active_policy.policies.member_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_entry', 'keyval': 'member', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policies=policies, member_entry=member_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policies=policies, member_entry=member_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_secpolicy_defined_policy_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.secpolicy.defined_policy', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.secpolicy.defined_policy', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_secpolicy_defined_policy_policies_get(self, rbridge_id=None, policies=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type policies: policy
    :param policies: Keyword argument tuple.

    :type policy: unicode
    :param policy: **policies** tuple argument.

        * pattern restriction: ::

            'SCC_POLICY'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.secpolicy.defined_policy.policies', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.secpolicy.defined_policy.policies', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.secpolicy.defined_policy.policies', u'member_entry'), ('pybind.nos.v7_2_0.rbridge_id.secpolicy.defined_policy.policies', u'member_entry')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'policies', 'keyval': 'policy', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'member'}, {'leafval': 'member'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policies=policies)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policies=policies)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_secpolicy_defined_policy_policies_member_entry_get(self, rbridge_id=None, policies=None, member_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policies: policy
    :param policies: Keyword argument tuple.

    :type policy: unicode
    :param policy: **policies** tuple argument.

        * pattern restriction: ::

            'SCC_POLICY'

    **Instance Keyword Argument Tuple**:

    :type member_entry: member
    :param member_entry: Keyword argument tuple.

    :type member: unicode
    :param member: **member_entry** tuple argument:  WWN of the switch

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.secpolicy.defined_policy.policies', u'policies'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.secpolicy.defined_policy.policies', u'policies')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.secpolicy.defined_policy.policies.member_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.secpolicy.defined_policy.policies.member_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_entry', 'keyval': 'member', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policies=policies, member_entry=member_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policies=policies, member_entry=member_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_engineid_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.engineID', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.engineID', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_engineid_local_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.engineID', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.engineID', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_offline_if_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.offline_if', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.offline_if', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_offline_if_enable_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.offline_if', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.offline_if', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_three_tuple_if_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.three_tuple_if', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.three_tuple_if', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_three_tuple_if_enable_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.three_tuple_if', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.three_tuple_if', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_user_get(self, rbridge_id=None, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type user: username, groupname, auth, auth_password, priv, priv_password, encrypted
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type groupname: unicode
    :param groupname: **user** tuple argument.

    :type auth: unicode
    :param auth: **user** tuple argument:  Authorization protocol for username(Default=noauth)

        * enumeration restriction: ::

            ['sha', 'noauth', 'md5']

    :type auth_password: unicode
    :param auth_password: **user** tuple argument:  Authorization password associated withusername

    :type priv: unicode
    :param priv: **user** tuple argument:  Privacy protocol for username (Default=nopriv)

        * enumeration restriction: ::

            ['AES128', 'DES', 'nopriv']

    :type priv_password: unicode
    :param priv_password: **user** tuple argument:  Privacy password associated with username

    :type encrypted: YANGBool
    :param encrypted: **user** tuple argument:  This flag is used to enter the auth/privpasswords as encrypted.(Default=disable)

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.user', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.user', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': 'username, groupname, auth, auth_password, priv, priv_password, encrypted'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_user_auth_get(self, rbridge_id=None, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.user', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.user', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_user_auth_password_get(self, rbridge_id=None, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.user', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.user', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_user_encrypted_get(self, rbridge_id=None, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.user', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.user', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_user_groupname_get(self, rbridge_id=None, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.user', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.user', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_user_priv_get(self, rbridge_id=None, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.user', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.user', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_user_priv_password_get(self, rbridge_id=None, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.user', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.user', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_v3host_get(self, rbridge_id=None, v3host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.v3host', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.v3host', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.rbridge_id.snmp_server.v3host": {"username": "username", "severity_level": "severity_level", "udp_port": "udp_port", "use_vrf": "use_vrf", "notifytype": "notifytype", "hostip": "hostip", "engineid": "engineid"}, "pybind.nos.v7_2_0.rbridge_id.snmp_server.v3host": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, v3host=v3host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_v3host_engineid_get(self, rbridge_id=None, v3host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.v3host', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.v3host', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, v3host=v3host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_v3host_notifytype_get(self, rbridge_id=None, v3host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.v3host', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.v3host', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, v3host=v3host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_v3host_severity_level_get(self, rbridge_id=None, v3host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.v3host', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.v3host', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, v3host=v3host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_v3host_udp_port_get(self, rbridge_id=None, v3host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.v3host', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server.v3host', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, v3host=v3host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_snmp_server_v3host_use_vrf_get(self, rbridge_id=None, v3host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.snmp_server.v3host', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, v3host=v3host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_spanning_tree_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.spanning_tree', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.spanning_tree', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_spanning_tree_ieee_bpdu_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.spanning_tree.ieee_bpdu', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.spanning_tree.ieee_bpdu', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_spanning_tree_ieee_bpdu_limit_vlan_flood_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.spanning_tree.ieee_bpdu', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.spanning_tree.ieee_bpdu', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_client_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.client', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.client', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_client_cipher_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.client', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.client', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_client_key_exchange_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.client', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.client', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_client_mac_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.client', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.client', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_server_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.server', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.rbridge_id.ssh.server": {"mac": "mac", "cipher": "cipher", "key_exchange": "key_exchange", "rekey_interval": "rekey_interval", "shutdown": "shutdown"}, "pybind.nos.v7_2_0.rbridge_id.ssh.server": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_server_cipher_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.server', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_server_key_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.server.key', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server.key', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_server_key_dsa_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.server.key', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server.key', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_server_key_ecdsa_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.server.key', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server.key', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_server_key_exchange_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.server', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_server_key_rsa_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.server.key', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server.key', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_server_mac_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.server', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_server_max_sessions_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.ssh.server', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_server_rekey_interval_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.server', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_server_shutdown_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.server', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_server_ssh_vrf_cont_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.server.ssh_vrf_cont', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server.ssh_vrf_cont', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_server_standby_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.server.standby', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server.standby', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_server_standby_enable_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.server.standby', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server.standby', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_server_use_vrf_get(self, rbridge_id=None, use_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name, ssh_vrf_shutdown
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0 .. max']

    :type ssh_vrf_shutdown: YANGBool
    :param ssh_vrf_shutdown: **use_vrf** tuple argument:  Shutdown SSH server on given vrf

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': 'use_vrf_name, ssh_vrf_shutdown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, use_vrf=use_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_ssh_server_use_vrf_shutdown_get(self, rbridge_id=None, use_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0 .. max']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, use_vrf=use_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_swbd_number_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.SFM', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric.login_policy', u'duplicatewwn'), ('pybind.slxos.v17r_1_01a.rbridge_id', u'logical_chassis'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.cid_card', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.ip.community_list', u'extended'), ('pybind.slxos.v17r_1_01a.diag.post', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.ip.community_list', u'standard'), ('pybind.slxos.v17r_1_01a.rbridge_id.vcs', u'auto_shut'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag', u'counter'), ('pybind.slxos.v17r_1_01a.rbridge_id', u'interface_nodespecific'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric', u'port_channel'), ('pybind.slxos.v17r_1_01a.rbridge_id', u'fcoe_config'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.temp', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag', u'timeout'), ('pybind.slxos.v17r_1_01a.rbridge_id', u'ag'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor', u'sfp'), ('pybind.slxos.v17r_1_01a.rbridge_id', u'default_config'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.LineCard', u'alert'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.compact_flash', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.fan', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.LineCard', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor', u'buffer'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.power', u'alert'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.fan', u'alert'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.cid_card', u'alert'), ('pybind.slxos.v17r_1_01a.rbridge_id.chassis', u'oper_address'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric.route', u'mcast'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor', u'security'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17r_1_01a.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag.nport_menu.nport_interface', u'nport'), ('pybind.slxos.v17r_1_01a.rbridge_id.ipv6.ipv6route', u'route'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.ag', u'pg'), ('pybind.slxos.v17r_1_01a.rbridge_id', u'chassis'), ('pybind.slxos.v17r_1_01a.preprovision', u'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.power', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor', u'memory'), ('pybind.slxos.v17r_1_01a.rbridge_id.fabric', u'ecmp'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor', u'cpu'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.MM', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.fcoe_config', u'fcoe_enode_fabric_map'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route', u'static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id.resource_monitor', u'memory'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server', u'engineid'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.nos.v7_2_0.rbridge_id.crypto', u'key'), ('pybind.nos.v7_2_0.rbridge_id.crypto', u'ca'), ('pybind.nos.v7_2_0.rbridge_id.telnet.server', u'standby'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.ssh', u'client'), ('pybind.nos.v7_2_0.preprovision', u'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', u'listen_range'), ('pybind.nos.v7_2_0.rbridge_id.secpolicy.active_policy', u'policies'), ('pybind.nos.v7_2_0.rbridge_id.host_table', u'aging_time'), ('pybind.nos.v7_2_0.rbridge_id.ipv6', u'prefix_list'), ('pybind.nos.v7_2_0.rbridge_id.ip.as_path', u'access_list'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor', u'memory'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.MM', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server', u'offline_if'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route', u'link_local_static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp', u'router_bgp_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id', u'arp_entry'), ('pybind.nos.v7_2_0.rbridge_id.ip.dhcp.relay', u'information'), ('pybind.nos.v7_2_0.rbridge_id', u'root'), ('pybind.nos.v7_2_0.rbridge_id.vcs', u'auto_shut'), ('pybind.nos.v7_2_0.rbridge_id.openflow', u'logical_instance'), ('pybind.nos.v7_2_0.rbridge_id.ag', u'timeout'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.rbridge_id.maps.email', u'email_list'), ('pybind.nos.v7_2_0.rbridge_id.fcsp.auth', u'proto'), ('pybind.nos.v7_2_0.rbridge_id.qos', u'tx_queue'), ('pybind.nos.v7_2_0.rbridge_id', u'filter_change_update_delay'), ('pybind.nos.v7_2_0.rbridge_id.ag', u'pg'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.interface', u'loopback'), ('pybind.nos.v7_2_0.rbridge_id.global_lc_holder.linecard', u'linecards'), ('pybind.nos.v7_2_0.rbridge_id', u'vrrp'), ('pybind.nos.v7_2_0.rbridge_id', u'clock'), ('pybind.nos.v7_2_0.rbridge_id', u'system_max'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor', u'sfp'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.router', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ag.nport_menu.nport_interface', u'nport'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_interface'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.ssh', u'server'), ('pybind.nos.v7_2_0.rbridge_id.bp_rate_limit', u'queue'), ('pybind.nos.v7_2_0.rbridge_id.interface', u've'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.fan', u'alert'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.ipv6_global_cmds.nd_global', u'dad'), ('pybind.nos.v7_2_0.rbridge_id.qos.rcv_queue', u'multicast'), ('pybind.nos.v7_2_0.rbridge_id.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id', u'dhcpd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.nos.v7_2_0.rbridge_id.resource_monitor', u'cpu'), ('pybind.nos.v7_2_0.rbridge_id.spanning_tree', u'ieee_bpdu'), ('pybind.nos.v7_2_0.rbridge_id.maps', u'logicalgroup'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.http', u'server'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.SFM', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.LineCard', u'alert'), ('pybind.nos.v7_2_0.rbridge_id.host_table', u'aging_mode'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.nos.v7_2_0.rbridge_id.fabric.login_policy', u'duplicatewwn'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor', u'interface'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.power', u'alert'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.ip.static_ag_ip_config', u'anycast_gateway_mac'), ('pybind.nos.v7_2_0.rbridge_id.ipv6', u'proto_vrrpv3'), ('pybind.nos.v7_2_0.rbridge_id.fabric', u'ecmp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.secpolicy.defined_policy', u'policies'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.nos.v7_2_0.rbridge_id.chassis', u'oper_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.nos.v7_2_0.rbridge_id', u'vrrp_rbridge_global'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.qos', u'rcv_queue'), ('pybind.nos.v7_2_0.rbridge_id.maps', u'relay'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.vlan_classification', u'predefined'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.sfp', u'alert'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder', u'pim'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.ipv6route', u'route'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.temp', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.route_table', u'predefined'), ('pybind.nos.v7_2_0.rbridge_id.ip', u'extcommunity_list'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id', u'route_map'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.static_ag_ipv6_config', u'anycast_gateway_mac'), ('pybind.nos.v7_2_0.system.switch_attributes', u'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', u'evpn_instance'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route', u'static_route_oif'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.import_', u'routes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.graceful_shutdown', u'gshut_timer_attributes'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.nos.v7_2_0.rbridge_id.event_handler.activate', u'name'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor', u'security'), ('pybind.nos.v7_2_0.rbridge_id', u'default_config'), ('pybind.nos.v7_2_0.rbridge_id.resource_monitor.process', u'memory'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.compact_flash', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server', u'user'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', u'graceful_shutdown'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim', u'rp_address'), ('pybind.nos.v7_2_0.rbridge_id', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.http.server.http_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.nos.v7_2_0.rbridge_id.router', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.nos.v7_2_0.rbridge_id.ip.receive', u'access_group'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.nos.v7_2_0.rbridge_id.fcoe_config', u'fcoe_enode_fabric_map'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.tcam', u'predefined'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor', u'cpu'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v7_2_0.rbridge_id.protocol', u'hide_vrrp_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.kap', u'predefined'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.route_table.predefined', u'routing_parameter'), ('pybind.nos.v7_2_0.rbridge_id.ip', u'prefix_list'), ('pybind.nos.v7_2_0.rbridge_id.ip', u'rtm_config'), ('pybind.nos.v7_2_0.rbridge_id', u'ag'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.bp_rate_limit.heavy', u'module'), ('pybind.nos.v7_2_0.rbridge_id', u'switch_attributes'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server', u'three_tuple_if'), ('pybind.nos.v7_2_0.rbridge_id.hardware_profile.kap', u'customized'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.nos.v7_2_0.rbridge_id', u'fcoe_config'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.receive', u'access_group'), ('pybind.nos.v7_2_0.rbridge_id', u'bfd_session_setup_delay'), ('pybind.nos.v7_2_0.rbridge_id.fcsp.auth', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.ag', u'counter'), ('pybind.nos.v7_2_0.rbridge_id.fabric', u'port_channel'), ('pybind.nos.v7_2_0.rbridge_id.telnet', u'server'), ('pybind.nos.v7_2_0.rbridge_id', u'fabric'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.cid_card', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id', u'chassis'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server', u'standby'), ('pybind.nos.v7_2_0.rbridge_id', u'interface_nodespecific'), ('pybind.nos.v7_2_0.rbridge_id.ip.rtm_config.route', u'static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id.snmp_server', u'v3host'), ('pybind.nos.v7_2_0.rbridge_id.maps', u'enable'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id.ip.import_', u'routes'), ('pybind.nos.v7_2_0.rbridge_id.ip.community_list', u'extended'), ('pybind.nos.v7_2_0.rbridge_id.maps', u'rule'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v7_2_0.rbridge_id', u'logical_chassis'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.LineCard', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.nos.v7_2_0.rbridge_id.ip.community_list', u'standard'), ('pybind.nos.v7_2_0.rbridge_id.fabric.route', u'mcast'), ('pybind.nos.v7_2_0.rbridge_id.maps', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route.static', u'bfd'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.nos.v7_2_0.rbridge_id', u'system_mode'), ('pybind.nos.v7_2_0.rbridge_id.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.cid_card', u'alert'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.fan', u'threshold'), ('pybind.nos.v7_2_0.fabric.route.mcast', u'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.power', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.nos.v7_2_0.rbridge_id.ipv6.route', u'static_route_oif'), ('pybind.nos.v7_2_0.diag.post', u'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.nos.v7_2_0.rbridge_id.ssh.server', u'key'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.nos.v6_0_2f.rbridge_id.protocol', u'hide_vrrp_holder'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.sfp', u'alert'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.ipv6_global_cmds.nd_global', u'dad'), ('pybind.nos.v6_0_2f.rbridge_id.ip.import_', u'routes'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.crypto', u'key'), ('pybind.nos.v6_0_2f.rbridge_id.global_lc_holder.linecard', u'linecards'), ('pybind.nos.v6_0_2f.rbridge_id', u'ag'), ('pybind.nos.v6_0_2f.fabric.route.mcast', u'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.qos', u'rcv_queue'), ('pybind.nos.v6_0_2f.rbridge_id.secpolicy.defined_policy', u'policies'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.chassis', u'oper_address'), ('pybind.nos.v6_0_2f.rbridge_id.ag', u'timeout'), ('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.kap', u'predefined'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.temp', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route', u'static_route_oif_vrf'), ('pybind.nos.v6_0_2f.diag.post', u'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.nos.v6_0_2f.system.switch_attributes', u'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vcs', u'auto_shut'), ('pybind.nos.v6_0_2f.rbridge_id.ip', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.fcsp.auth', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.ip.as_path', u'access_list'), ('pybind.nos.v6_0_2f.rbridge_id', u'default_config'), ('pybind.nos.v6_0_2f.rbridge_id.ip.dhcp.relay', u'information'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route', u'link_local_static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.MM', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.snmp_server', u'engineid'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route', u'static_route_nh_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor', u'security'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.nos.v6_0_2f.rbridge_id.ssh', u'client'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.router', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor', u'cpu'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.nos.v6_0_2f.rbridge_id.ip', u'extcommunity_list'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.cid_card', u'alert'), ('pybind.nos.v6_0_2f.rbridge_id.ag', u'pg'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.bp_rate_limit', u'queue'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.receive', u'access_group'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.LineCard', u'alert'), ('pybind.nos.v6_0_2f.rbridge_id.snmp_server', u'user'), ('pybind.nos.v6_0_2f.rbridge_id.bp_rate_limit.heavy', u'module'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.fan', u'alert'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.vlan_classification', u'predefined'), ('pybind.nos.v6_0_2f.rbridge_id', u'root'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.compact_flash', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor', u'sfp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.nos.v6_0_2f.rbridge_id.qos.rcv_queue', u'multicast'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.nos.v6_0_2f.rbridge_id.event_handler.activate', u'name'), ('pybind.nos.v6_0_2f.rbridge_id', u'system_max'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.fabric', u'port_channel'), ('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.kap', u'customized'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.nos.v6_0_2f.rbridge_id.interface', u've'), ('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.tcam', u'predefined'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.import_', u'routes'), ('pybind.nos.v6_0_2f.rbridge_id', u'fcoe_config'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route', u'static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.ip.community_list', u'extended'), ('pybind.nos.v6_0_2f.rbridge_id.telnet', u'server'), ('pybind.nos.v6_0_2f.rbridge_id.maps.email', u'email_list'), ('pybind.nos.v6_0_2f.rbridge_id', u'logical_chassis'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route', u'static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.power', u'alert'), ('pybind.nos.v6_0_2f.rbridge_id.interface', u'loopback'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6', u'proto_vrrpv3'), ('pybind.nos.v6_0_2f.rbridge_id.http', u'server'), ('pybind.nos.v6_0_2f.rbridge_id.ag.nport_menu.nport_interface', u'nport'), ('pybind.nos.v6_0_2f.rbridge_id.snmp_server', u'v3host'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.nos.v6_0_2f.rbridge_id.ip.community_list', u'standard'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id.fcsp.auth', u'proto'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp', u'router_bgp_attributes'), ('pybind.nos.v6_0_2f.rbridge_id', u'clock'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.nos.v6_0_2f.rbridge_id.telnet.server', u'standby'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_interface'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route', u'static_route_nh_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.nos.v6_0_2f.rbridge_id.qos', u'tx_queue'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.nos.v6_0_2f.rbridge_id.fabric.login_policy', u'duplicatewwn'), ('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.nos.v6_0_2f.rbridge_id.ip', u'rtm_config'), ('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.route_table', u'predefined'), ('pybind.nos.v6_0_2f.rbridge_id', u'interface_nodespecific'), ('pybind.nos.v6_0_2f.rbridge_id.router', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.power', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.snmp_server', u'offline_if'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.fan', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.ip.rtm_config.route.static.bfd', u'bfd_static_route'), ('pybind.nos.v6_0_2f.rbridge_id', u'route_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.LineCard', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.nos.v6_0_2f.rbridge_id.snmp_server', u'three_tuple_if'), ('pybind.nos.v6_0_2f.rbridge_id', u'filter_change_update_delay'), ('pybind.nos.v6_0_2f.rbridge_id.ssh.server', u'key'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor', u'memory'), ('pybind.nos.v6_0_2f.rbridge_id', u'arp_entry'), ('pybind.nos.v6_0_2f.rbridge_id.fabric.route', u'mcast'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.SFM', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6', u'prefix_list'), ('pybind.nos.v6_0_2f.rbridge_id.spanning_tree', u'ieee_bpdu'), ('pybind.nos.v6_0_2f.rbridge_id', u'chassis'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.ipv6route', u'route'), ('pybind.nos.v6_0_2f.rbridge_id.fabric', u'ecmp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.nos.v6_0_2f.rbridge_id.system_monitor.cid_card', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor', u'interface'), ('pybind.nos.v6_0_2f.rbridge_id.ip.receive', u'access_group'), ('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder.pim', u'rp_address'), ('pybind.nos.v6_0_2f.rbridge_id.ssh', u'server'), ('pybind.nos.v6_0_2f.rbridge_id.ssh.server', u'standby'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.nos.v6_0_2f.rbridge_id.maps', u'enable'), ('pybind.nos.v6_0_2f.rbridge_id.ag', u'counter'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.nos.v6_0_2f.rbridge_id', u'vrrp'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.nos.v6_0_2f.rbridge_id.crypto', u'ca'), ('pybind.nos.v6_0_2f.rbridge_id.ipv6.route.static', u'bfd'), ('pybind.nos.v6_0_2f.rbridge_id', u'switch_attributes'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.nos.v6_0_2f.rbridge_id.router.hide_pim_holder', u'pim'), ('pybind.nos.v6_0_2f.rbridge_id.hardware_profile.route_table.predefined', u'routing_parameter'), ('pybind.nos.v6_0_2f.rbridge_id.maps', u'relay'), ('pybind.nos.v6_0_2f.preprovision', u'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.openflow', u'logical_instance'), ('pybind.nos.v6_0_2f.rbridge_id.secpolicy.active_policy', u'policies'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.nos.v6_0_2f.rbridge_id.fcoe_config', u'fcoe_enode_fabric_map'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.nos.v6_0_2f.rbridge_id', u'vrrp_rbridge_global'), ('pybind.nos.v6_0_2f.rbridge_id.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric.route', u'mcast'), ('pybind.slxos.v17r_2_00.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor', u'memory'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.SFM', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id', u'logical_chassis'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor', u'sfp'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.fan', u'alert'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.power', u'alert'), ('pybind.slxos.v17r_2_00.rbridge_id.ag.nport_menu.nport_interface', u'nport'), ('pybind.slxos.v17r_2_00.rbridge_id.ag', u'timeout'), ('pybind.slxos.v17r_2_00.rbridge_id.ip.community_list', u'standard'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.cid_card', u'alert'), ('pybind.slxos.v17r_2_00.diag.post', u'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', u'chassis'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.temp', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor', u'buffer'), ('pybind.slxos.v17r_2_00.rbridge_id', u'fcoe_config'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric', u'port_channel'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.compact_flash', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.ag', u'pg'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.MM', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.ag', u'counter'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.ip.community_list', u'extended'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor', u'interface'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.fan', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.chassis', u'oper_address'), ('pybind.slxos.v17r_2_00.rbridge_id', u'default_config'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric.login_policy', u'duplicatewwn'), ('pybind.slxos.v17r_2_00.preprovision', u'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', u'ag'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id', u'interface_nodespecific'), ('pybind.slxos.v17r_2_00.rbridge_id.fabric', u'ecmp'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.LineCard', u'alert'), ('pybind.slxos.v17r_2_00.rbridge_id.ipv6.ipv6route', u'route'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor', u'cpu'), ('pybind.slxos.v17r_2_00.rbridge_id.vcs', u'auto_shut'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor', u'security'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.LineCard', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.power', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.cid_card', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.fcoe_config', u'fcoe_enode_fabric_map'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.fan', u'alert'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.SFM', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor', u'buffer'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.fan', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.cid_card', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.compact_flash', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.LineCard', u'alert'), ('pybind.slxos.v17s_1_02.rbridge_id', u'chassis'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.LineCard', u'threshold'), ('pybind.slxos.v17s_1_02.fabric.route.mcast', u'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.ipv6.ipv6route', u'route'), ('pybind.slxos.v17s_1_02.rbridge_id.ip.community_list', u'extended'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric', u'ecmp'), ('pybind.slxos.v17s_1_02.rbridge_id', u'logical_chassis'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.vcs', u'auto_shut'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric.route', u'mcast'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor', u'cpu'), ('pybind.slxos.v17s_1_02.rbridge_id.ag', u'timeout'), ('pybind.slxos.v17s_1_02.rbridge_id', u'interface_nodespecific'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor', u'memory'), ('pybind.slxos.v17s_1_02.rbridge_id', u'default_config'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor', u'sfp'), ('pybind.slxos.v17s_1_02.rbridge_id.ag.nport_menu.nport_interface', u'nport'), ('pybind.slxos.v17s_1_02.rbridge_id', u'ag'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.power', u'alert'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.temp', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor', u'security'), ('pybind.slxos.v17s_1_02.rbridge_id.fcoe_config', u'fcoe_enode_fabric_map'), ('pybind.slxos.v17s_1_02.preprovision', u'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', u'fcoe_config'), ('pybind.slxos.v17s_1_02.rbridge_id.ag', u'pg'), ('pybind.slxos.v17s_1_02.rbridge_id.ag', u'counter'), ('pybind.slxos.v17s_1_02.rbridge_id.ip.community_list', u'standard'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.cid_card', u'alert'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric.login_policy', u'duplicatewwn'), ('pybind.slxos.v17s_1_02.rbridge_id.fabric', u'port_channel'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor', u'interface'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.power', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.MM', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.chassis', u'oper_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'rbridge_id', 'keyval': 'rbridge_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'precedence'}, {'leafval': 'principal_priority'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'enable, rbridge_id'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'lag'}, {'leafval': 'reliabilitycountervalue'}, {'leafval': 'ns_vlan, ns_ethernet'}, {'leafval': 'po_id, vlag_load_balance'}, {'leafval': 'fcoe_max_enode'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'fnmtovalue'}, {'leafval': 'enable'}, {'leafval': 'policy_name'}, {'leafval': 'apply, pause'}, {'leafval': 'enable'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'state, action'}, {'leafval': 'state, action'}, {'leafval': 'state, action'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'priority'}, {'leafval': 'apply, pause'}, {'leafval': 'policy_name'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'agNPortNb'}, {'leafval': 'dest, next_hop'}, {'leafval': 'sec_policy_name'}, {'leafval': 'pgid, rename'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'rbridge_id, wwn'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'ecmp_load_balance, load_balance_hash_swap'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'fcoe_enode_fabric_map_name'}, {'leafval': 'apply, pause'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'enable_memory, threshold_memory, action_memory, sample_rate_memory, logging_rate_memory, grace_period_memory, offset_memory'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'local_'}, {'leafval': 'identifier'}, {'leafval': 'label, type, modulus'}, {'leafval': 'trustpoint, keypair'}, {'leafval': 'enable'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'policy_name'}, {'leafval': 'cipher, mac, key_exchange'}, {'leafval': 'rbridge_id, wwn'}, {'leafval': 'listen_range_prefix, peer_group, limit'}, {'leafval': 'policy'}, {'leafval': 'conversational_timeout'}, {'leafval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'offline_if_display_enable'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'local_as, always_compare_med, compare_med_empty_aspath, med_missing_as_worst, as_path_ignore, compare_routerid, install_igp_cost, default_local_preference, enforce_first_as, fast_external_fallover, log_dampening_debug, auto_shutdown_new_neighbors, listen_limit'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, Port_channel, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve'}, {'leafval': 'option'}, {'leafval': 'enable, access'}, {'leafval': 'lag'}, {'leafval': 'instance_id, default_forwarding_action, activate'}, {'leafval': 'fnmtovalue'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'email'}, {'leafval': 'auth_type, group, hash'}, {'leafval': 'tx_queue_limit'}, {'leafval': 'filter_delay_value'}, {'leafval': 'pgid, rename'}, {'leafval': 'policy_name'}, {'leafval': 'id'}, {'leafval': 'linecardName, linecardType'}, {'leafval': 'early_startup'}, {'leafval': 'timezone'}, {'leafval': 'arp'}, {'leafval': 'apply, pause'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'agNPortNb'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id, rp_cand_priority'}, {'leafval': 'holdover_interval'}, {'leafval': 'shutdown, key_exchange, rekey_interval, cipher, mac, max_sessions'}, {'leafval': 'queue_id, limit_percent'}, {'leafval': 'name, shutdown'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'state, action'}, {'leafval': 'global_dad_time'}, {'leafval': 'rx_queue_bum_mode'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'enable'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'enable_cpu, threshold_cpu, action_cpu, sample_rate_cpu, logging_rate_cpu, grace_period_cpu, offset_cpu'}, {'leafval': 'limit_vlan_flood'}, {'leafval': 'logicalgroupname, elementtype, members'}, {'leafval': 'sec_policy_name'}, {'leafval': 'shutdown'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'state, action'}, {'leafval': 'conversational'}, {'leafval': 'holdover_interval'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'precedence'}, {'leafval': 'apply, pause'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'state, action'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ip_anycast_gateway_mac, ip_anycast_default_mac'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'ecmp_load_balance, load_balance_hash_swap'}, {'leafval': 'table_map_route_map'}, {'leafval': 'policy'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'evpn_neighbor_ipv6_address, activate, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'evpn_neighbor_ipv4_address, activate, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check'}, {'leafval': 'vrrp_acceptmode_disable'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'rcv_queue_limit'}, {'leafval': 'hostip, domainname'}, {'leafval': 'vlan_profiletype'}, {'leafval': 'as4_enable'}, {'leafval': 'state, action'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'always_use_register, reset_tracking_bit, max_mcache, hello_interval, nbr_timeout, inactivity_timer, message_interval, bsr_msg_interval, rp_adv_interval, spt_threshold'}, {'leafval': 'dest, next_hop'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'routing_profiletype'}, {'leafval': 'extcommunity_list_num, ext_community_action, ext_community_regex, ext_community_expr'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'name, action_rm, instance'}, {'leafval': 'ipv6_anycast_gateway_mac, ipv6_anycast_default_mac'}, {'leafval': 'rbridge_id, chassis_name, host_name'}, {'leafval': 'instance_name, df_delay_timer'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'gshut_local_pref, gshut_community'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'name, delay, iterations, interval, run_mode, trigger_mode, action_timeout'}, {'leafval': 'apply, pause'}, {'leafval': 'enable'}, {'leafval': 'enable_process, thresh_mem_alarm, thresh_mem_critic'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'username, groupname, auth, auth_password, priv, priv_password, encrypted'}, {'leafval': 'gshut_timer_value, gshut_route_map'}, {'leafval': 'rp_ip_addr, prefix_list'}, {'leafval': 'vrf_name, route_distiniguisher, vni'}, {'leafval': 'use_vrf_name, secure_and_plain, http_vrf_shutdown'}, {'leafval': 'table_map_route_map'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'vrf, database_overflow_interval, default_passive_interface, default_metric, external_lsdb_limit, ospf_metric_type, vrf_lite_capability, nonstop_routing, maximum_paths'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'ip_access_list, ip_direction'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'fcoe_enode_fabric_map_name'}, {'leafval': 'tcam_profiletype'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'num_as_in_path'}, {'leafval': 'kap_profiletype'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'router_id, load_sharing'}, {'leafval': 'enable'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'add_, remove_'}, {'leafval': 'chassis_name, host_name'}, {'leafval': 'three_tuple_if_display_enable'}, {'leafval': 'kap_profilename'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'fcoe_max_enode'}, {'leafval': 'ipv6_access_list, ip_direction'}, {'leafval': 'delay'}, {'leafval': 'switch'}, {'leafval': 'reliabilitycountervalue'}, {'leafval': 'po_id, vlag_load_balance'}, {'leafval': 'shutdown'}, {'leafval': 'neighbor_discovery'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'enable'}, {'leafval': 'ns_vlan, ns_ethernet'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'hostip, username, udp_port, notifytype, engineid, severity_level'}, {'leafval': 'policy, actions'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'rulename, targetgroup, monitor, timebase, op, threshold'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'principal_priority'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'evpn_neighbor_peergroup_name, activate, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, accept_lldp_neighbors, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'all'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'priority'}, {'leafval': 'policyname'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'maintenance'}, {'leafval': 'rp_cand_grp_prefix_ip, rp_cand_grp_prefix_length'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'enable, rbridge_id'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'state, action'}, {'leafval': 'global_dad_time'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'vrf_name, route_distiniguisher'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'label, type, modulus'}, {'leafval': 'linecardName, linecardType'}, {'leafval': 'enable'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'rcv_queue_limit'}, {'leafval': 'policy'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'fnmtovalue'}, {'leafval': 'kap_profiletype'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'enable, rbridge_id'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rbridge_id, chassis_name, host_name'}, {'leafval': 'lag'}, {'leafval': 'name, seq_keyword, instance, action_ipp, prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'switch'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_reg_expr'}, {'leafval': 'enable'}, {'leafval': 'option'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'local_'}, {'leafval': 'num_as_in_path'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'apply, pause'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'cipher, mac, key_exchange'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'sec_policy_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'holdover_interval'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'extcommunity_list_num, ext_community_action, ext_community_expr'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'state, action'}, {'leafval': 'pgid, rename'}, {'leafval': 'table_map_route_map'}, {'leafval': 'queue_id, limit_percent'}, {'leafval': 'ipv6_access_list, ip_direction'}, {'leafval': 'state, action'}, {'leafval': 'username, groupname, auth, auth_password, priv, priv_password, encrypted'}, {'leafval': 'add_, remove_'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'state, action'}, {'leafval': 'identifier'}, {'leafval': 'vlan_profiletype'}, {'leafval': 'enable, access'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'apply, pause'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'rx_queue_bum_mode'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'name, delay, iterations, interval, run_mode, trigger_mode'}, {'leafval': 'arp'}, {'leafval': 'policy_name'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'po_id, vlag_load_balance'}, {'leafval': 'kap_profilename'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, allowas_in, activate, route_reflector_client, af_nei_weight'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'name, shutdown'}, {'leafval': 'tcam_profiletype'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'fcoe_max_enode'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'af_ipv6_neighbor_address, allowas_in, activate, route_reflector_client, af_nei_weight'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'shutdown'}, {'leafval': 'email'}, {'leafval': 'principal_priority'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'state, action'}, {'leafval': 'id'}, {'leafval': 'as4_enable'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'shutdown'}, {'leafval': 'agNPortNb'}, {'leafval': 'hostip, username, udp_port, notifytype, engineid, severity_level, use_vrf'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'holdover_interval'}, {'leafval': 'auth_type, group, hash'}, {'leafval': 'local_as, always_compare_med, compare_med_empty_aspath, med_missing_as_worst, as_path_ignore, compare_routerid, install_igp_cost, default_local_preference, enforce_first_as, fast_external_fallover, log_dampening_debug'}, {'leafval': 'timezone'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'enable'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'tx_queue_limit'}, {'leafval': 'policy_name'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'precedence'}, {'leafval': 'rp_cand_grp_prefix_action, rp_cand_grp_prefix_ip, rp_cand_grp_prefix_length'}, {'leafval': 'router_id, load_sharing'}, {'leafval': 'routing_profiletype'}, {'leafval': 'ns_vlan, ns_ethernet'}, {'leafval': 'vrf, database_overflow_interval, default_passive_interface, default_metric, external_lsdb_limit, ospf_metric_type, vrf_lite_capability, nonstop_routing, maximum_paths'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'offline_if_display_enable'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'name, action_rm, instance'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'three_tuple_if_display_enable'}, {'leafval': 'filter_delay_value'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve'}, {'leafval': 'priority'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'limit_vlan_flood'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'dest, next_hop'}, {'leafval': 'ecmp_load_balance, load_balance_hash_swap'}, {'leafval': 'af_ipv4_neighbor_address, allowas_in, activate, route_reflector_client, af_nei_weight'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'apply, pause'}, {'leafval': 'ip_access_list, ip_direction'}, {'leafval': 'rp_ip_addr, prefix_list'}, {'leafval': 'shutdown, key_exchange, rekey_interval, cipher, mac'}, {'leafval': 'enable'}, {'leafval': 'table_map_route_map'}, {'leafval': 'policy, actions'}, {'leafval': 'reliabilitycountervalue'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'early_startup'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'trustpoint, keypair'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'chassis_name, host_name'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'max_mcache, hello_interval, nbr_timeout, inactivity_timer, message_interval, spt_threshold'}, {'leafval': 'maximum_paths, openflow_enable'}, {'leafval': 'hostip, domainname'}, {'leafval': 'rbridge_id, wwn'}, {'leafval': 'instance_id, default_forwarding_action, activate'}, {'leafval': 'policy'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, allowas_in, activate, route_reflector_client, af_nei_weight'}, {'leafval': 'fcoe_enode_fabric_map_name'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'vrrp_acceptmode_disable'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'priority'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'principal_priority'}, {'leafval': 'apply, pause'}, {'leafval': 'state, action'}, {'leafval': 'state, action'}, {'leafval': 'agNPortNb'}, {'leafval': 'fnmtovalue'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'state, action'}, {'leafval': 'enable, rbridge_id'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'fcoe_max_enode'}, {'leafval': 'po_id, vlag_load_balance'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'pgid, rename'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'reliabilitycountervalue'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'apply, pause'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'virtual_oper_Vip_address'}, {'leafval': 'enable'}, {'leafval': 'precedence'}, {'leafval': 'rbridge_id, wwn'}, {'leafval': 'enable'}, {'leafval': 'sec_policy_name'}, {'leafval': 'ns_vlan, ns_ethernet'}, {'leafval': 'ecmp_load_balance, load_balance_hash_swap'}, {'leafval': 'state, action'}, {'leafval': 'dest, next_hop'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'lag'}, {'leafval': 'apply, pause'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'fcoe_enode_fabric_map_name'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'sec_policy_name'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'policy_name'}, {'leafval': 'state, action'}, {'leafval': 'virtual_ip, virtual_ipv6'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'rbridge_id, priority'}, {'leafval': 'dest, next_hop'}, {'leafval': 'name, seq_keyword, instance, ip_action, ip_community_reg_expr'}, {'leafval': 'ecmp_load_balance, load_balance_hash_swap'}, {'leafval': 'principal_priority'}, {'leafval': 'policy_name'}, {'leafval': 'lag'}, {'leafval': 'priority'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'fnmtovalue'}, {'leafval': 'ns_vlan, ns_ethernet'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'enable'}, {'leafval': 'apply, pause'}, {'leafval': 'agNPortNb'}, {'leafval': 'enable'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'apply, pause'}, {'leafval': 'fcoe_enode_fabric_map_name'}, {'leafval': 'rbridge_id, wwn'}, {'leafval': 'fcoe_max_enode'}, {'leafval': 'pgid, rename'}, {'leafval': 'reliabilitycountervalue'}, {'leafval': 'name, seq_keyword, instance, ip_action, std_community_expr'}, {'leafval': 'state, action'}, {'leafval': 'precedence'}, {'leafval': 'po_id, vlag_load_balance'}, {'leafval': 'apply, pause'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'virtual_oper_Vip_address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_switch_attributes_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.switch_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.switch_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.system.switch_attributes', u'rbridge_id'), ('pybind.nos.v6_0_2f.system.switch_attributes', u'rbridge_id')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rbridge_id, chassis_name, host_name'}, {'leafval': 'rbridge_id, chassis_name, host_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_switch_attributes_chassis_name_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.switch_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.switch_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.system.switch_attributes', u'rbridge_id'), ('pybind.nos.v6_0_2f.system.switch_attributes', u'rbridge_id')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rbridge_id, chassis_name, host_name'}, {'leafval': 'rbridge_id, chassis_name, host_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_switch_attributes_host_name_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.switch_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.switch_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.system.switch_attributes', u'rbridge_id'), ('pybind.nos.v6_0_2f.system.switch_attributes', u'rbridge_id')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rbridge_id, chassis_name, host_name'}, {'leafval': 'rbridge_id, chassis_name, host_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_max_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_max', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_max', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_max_arp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_max', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_max', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_mode_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.system_mode', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_mode_maintenance_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.system_mode', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_cid_card_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.cid_card', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.cid_card', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.cid_card', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.cid_card', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.cid_card', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_cid_card_alert_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.cid_card.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.cid_card.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.cid_card.alert', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.cid_card.alert', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.cid_card.alert', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'state, action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_cid_card_alert_action_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.cid_card.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.cid_card.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.cid_card.alert', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.cid_card.alert', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.cid_card.alert', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_cid_card_alert_state_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.cid_card.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.cid_card.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.cid_card.alert', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.cid_card.alert', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.cid_card.alert', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_cid_card_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.cid_card.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.cid_card.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.cid_card.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.cid_card.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.cid_card.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'marginal_threshold, down_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_cid_card_threshold_down_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.cid_card.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.cid_card.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.cid_card.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.cid_card.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.cid_card.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_cid_card_threshold_marginal_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.cid_card.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.cid_card.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.cid_card.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.cid_card.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.cid_card.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_compact_flash_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.compact_flash', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.compact_flash', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.compact_flash', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.compact_flash', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.compact_flash', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_compact_flash_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'marginal_threshold, down_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_compact_flash_threshold_down_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_compact_flash_threshold_marginal_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.compact_flash.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_fan_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.fan', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.fan', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.fan', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.fan', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.fan', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_fan_alert_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.fan.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.fan.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.fan.alert', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.fan.alert', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.fan.alert', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'state, action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_fan_alert_action_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.fan.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.fan.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.fan.alert', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.fan.alert', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.fan.alert', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_fan_alert_state_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.fan.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.fan.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.fan.alert', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.fan.alert', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.fan.alert', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_fan_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.fan.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.fan.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.fan.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.fan.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.fan.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'marginal_threshold, down_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_fan_threshold_down_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.fan.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.fan.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.fan.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.fan.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.fan.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_fan_threshold_marginal_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.fan.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.fan.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.fan.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.fan.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.fan.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_linecard_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.LineCard', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.LineCard', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.LineCard', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.LineCard', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.LineCard', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_linecard_alert_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.LineCard.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.LineCard.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.LineCard.alert', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.LineCard.alert', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.LineCard.alert', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'state, action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_linecard_alert_action_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.LineCard.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.LineCard.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.LineCard.alert', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.LineCard.alert', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.LineCard.alert', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_linecard_alert_state_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.LineCard.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.LineCard.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.LineCard.alert', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.LineCard.alert', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.LineCard.alert', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_linecard_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.LineCard.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.LineCard.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.LineCard.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.LineCard.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.LineCard.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'marginal_threshold, down_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_linecard_threshold_down_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.LineCard.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.LineCard.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.LineCard.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.LineCard.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.LineCard.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_linecard_threshold_marginal_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.LineCard.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.LineCard.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.LineCard.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.LineCard.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.LineCard.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_mm_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.MM', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.MM', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.MM', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.MM', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.MM', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_mm_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.MM.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.MM.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.MM.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.MM.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.MM.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'marginal_threshold, down_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_mm_threshold_down_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.MM.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.MM.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.MM.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.MM.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.MM.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_mm_threshold_marginal_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.MM.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.MM.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.MM.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.MM.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.MM.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_power_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.power', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.power', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.power', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.power', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.power', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_power_alert_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.power.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.power.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.power.alert', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.power.alert', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.power.alert', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'state, action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_power_alert_action_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.power.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.power.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.power.alert', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.power.alert', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.power.alert', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_power_alert_state_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.power.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.power.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.power.alert', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.power.alert', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.power.alert', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_power_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.power.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.power.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.power.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.power.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.power.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'marginal_threshold, down_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_power_threshold_down_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.power.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.power.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.power.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.power.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.power.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_power_threshold_marginal_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.power.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.power.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.power.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.power.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.power.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_sfm_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.SFM', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.SFM', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.SFM', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.SFM', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.SFM', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_sfm_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.SFM.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.SFM.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.SFM.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.SFM.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.SFM.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'marginal_threshold, down_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_sfm_threshold_down_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.SFM.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.SFM.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.SFM.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.SFM.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.SFM.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_sfm_threshold_marginal_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.SFM.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.SFM.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.SFM.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.SFM.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.SFM.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_sfp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.sfp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.sfp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_sfp_alert_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.sfp.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.sfp.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'state, action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_sfp_alert_action_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.sfp.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.sfp.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_sfp_alert_state_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.sfp.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.sfp.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_temp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.temp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.temp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.temp', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.temp', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.temp', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_temp_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.temp.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.temp.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.temp.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.temp.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.temp.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'marginal_threshold, down_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_temp_threshold_down_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.temp.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.temp.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.temp.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.temp.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.temp.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_system_monitor_temp_threshold_marginal_threshold_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.system_monitor.temp.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.system_monitor.temp.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.system_monitor.temp.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.system_monitor.temp.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.system_monitor.temp.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_telnet_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.telnet', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.telnet', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_telnet_server_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.telnet.server', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.telnet.server', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_telnet_server_shutdown_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.telnet.server', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.telnet.server', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_telnet_server_standby_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.telnet.server.standby', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.telnet.server.standby', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_telnet_server_standby_enable_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.telnet.server.standby', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.telnet.server.standby', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_telnet_server_telnet_vrf_cont_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.telnet.server.telnet_vrf_cont', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.telnet.server.telnet_vrf_cont', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_telnet_server_use_vrf_get(self, rbridge_id=None, use_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name, telnet_vrf_shutdown
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0 .. max']

    :type telnet_vrf_shutdown: YANGBool
    :param telnet_vrf_shutdown: **use_vrf** tuple argument:  Shutdown telnet server on given vrf

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': 'use_vrf_name, telnet_vrf_shutdown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, use_vrf=use_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_telnet_server_use_vrf_shutdown_get(self, rbridge_id=None, use_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0 .. max']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, use_vrf=use_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_buffer_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'poll, retry, limit, actions'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_buffer_actions_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_buffer_limit_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_buffer_poll_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_buffer_retry_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Buffer', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_cpu_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'poll, retry, limit, actions'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_cpu_actions_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_cpu_limit_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_cpu_poll_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_cpu_retry_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.Cpu', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Cpu', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_apply_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_pause_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_get(self, rbridge_id=None, policy=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy', u'area')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'policy', 'keyval': 'policy_name', 'extra_keyval': 'policy_name'}
    composed_child_leafval_list = [{'leafval': 'type, area_value'}, {'leafval': 'type, area_value'}, {'leafval': 'type, area_value'}, {'leafval': 'type, area_value'}, {'leafval': 'type, area_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy', u'policy')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area.alert', u'above'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area.alert', u'below'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area.alert', u'below'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area.alert', u'above'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area.alert', u'below'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area.alert', u'above'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area.alert', u'above'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area.alert', u'below'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area.alert', u'above'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area.alert', u'below'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area', u'threshold')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'type, area_value', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'above_highthresh_action, above_lowthresh_action'}, {'leafval': 'timebase_value, high_threshold, low_threshold, buffer'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'timebase_value, high_threshold, low_threshold, buffer'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'above_highthresh_action, above_lowthresh_action'}, {'leafval': 'timebase_value, high_threshold, low_threshold, buffer'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'above_highthresh_action, above_lowthresh_action'}, {'leafval': 'timebase_value, high_threshold, low_threshold, buffer'}, {'leafval': 'above_highthresh_action, above_lowthresh_action'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'above_highthresh_action, above_lowthresh_action'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'timebase_value, high_threshold, low_threshold, buffer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_alert_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area.alert', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area.alert', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area.alert', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_alert_above_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_alert_above_highthresh_action_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_alert_above_lowthresh_action_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_alert_below_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_alert_below_highthresh_action_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_alert_below_lowthresh_action_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_threshold_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'timebase_value, high_threshold, low_threshold, buffer'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_threshold_buffer_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_threshold_high_threshold_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_threshold_low_threshold_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_interface_policy_area_threshold_timebase_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_memory_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'poll, retry, limit, high_limit, low_limit, actions'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_memory_actions_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_memory_high_limit_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_memory_limit_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_memory_low_limit_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_memory_poll_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_memory_retry_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.Memory', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.Memory', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_apply_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_pause_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_get(self, rbridge_id=None, policy=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy', u'area'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy', u'area')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'policy', 'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}
    composed_child_leafval_list = [{'leafval': 'sec_area_value, timebase'}, {'leafval': 'sec_area_value, timebase'}, {'leafval': 'sec_area_value, timebase'}, {'leafval': 'sec_area_value, timebase'}, {'leafval': 'sec_area_value, timebase'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy', u'policy')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area.alert', u'above')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'sec_area_value', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_above_highthresh_action'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_alert_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area.alert', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area.alert', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area.alert', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_alert_above_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area.alert.above', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area.alert.above', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area.alert.above', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area.alert.above', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area.alert.above', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_alert_above_highthresh_action_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area.alert.above', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area.alert.above', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area.alert.above', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area.alert.above', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area.alert.above', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_alert_below_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_alert_below_highthresh_action_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_alert_below_lowthresh_action_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_threshold_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_threshold_buffer_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_threshold_high_threshold_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_threshold_low_threshold_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_security_policy_area_timebase_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy', u'policy')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.security.policy.area', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.security.policy.area', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area', u'threshold'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.security.policy.area.alert', u'above')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'sec_area_value', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_above_highthresh_action'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_apply_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_pause_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_get(self, rbridge_id=None, policy=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy', u'area'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy', u'area')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'policy', 'keyval': 'policy_name', 'extra_keyval': 'policy_name'}
    composed_child_leafval_list = [{'leafval': 'type, area_value'}, {'leafval': 'type, area_value'}, {'leafval': 'type, area_value'}, {'leafval': 'type, area_value'}, {'leafval': 'type, area_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy', u'policy')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area.alert', u'above'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area.alert', u'below'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area', u'threshold'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area.alert', u'below'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area.alert', u'above'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area', u'threshold'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area.alert', u'below'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area.alert', u'above'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area', u'threshold'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area.alert', u'below'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area.alert', u'above'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area.alert', u'above'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area', u'threshold'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area.alert', u'below')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'type, area_value', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'above_highthresh_action'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'high_threshold, low_threshold, buffer'}, {'leafval': 'high_threshold, low_threshold, buffer'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'above_highthresh_action'}, {'leafval': 'high_threshold, low_threshold, buffer'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'above_highthresh_action'}, {'leafval': 'high_threshold, low_threshold, buffer'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'above_highthresh_action'}, {'leafval': 'above_highthresh_action'}, {'leafval': 'high_threshold, low_threshold, buffer'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_alert_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area.alert', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area.alert', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area.alert', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area.alert', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area.alert', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_alert_above_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area.alert.above', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area.alert.above', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area.alert.above', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area.alert.above', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area.alert.above', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_alert_above_highthresh_action_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area.alert.above', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area.alert.above', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area.alert.above', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area.alert.above', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area.alert.above', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_alert_below_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_alert_below_highthresh_action_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_alert_below_lowthresh_action_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_threshold_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'high_threshold, low_threshold, buffer'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_threshold_buffer_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_threshold_high_threshold_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_threshold_monitor_sfp_policy_area_threshold_low_threshold_get(self, rbridge_id=None, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vcs_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vcs', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vcs', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.vcs', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.vcs', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.vcs', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vcs_auto_shut_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vcs.auto_shut', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vcs.auto_shut', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.vcs.auto_shut', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.vcs.auto_shut', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.vcs.auto_shut', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vcs_auto_shut_lag_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_1_01a.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17s_1_02.rbridge_id', 'rbridge_id'), ('pybind.slxos.v17r_2_00.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vcs.auto_shut', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vcs.auto_shut', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rbridge_id.vcs.auto_shut', 'pybind.slxos.v17r_1_01a.brocade_rbridge', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rbridge_id.vcs.auto_shut', 'pybind.slxos.v17r_2_00.brocade_rbridge', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rbridge_id.vcs.auto_shut', 'pybind.slxos.v17s_1_02.brocade_rbridge', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'route_target'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.import_', u'routes'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd', u'bfd_static_route'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6', u'unicast'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'ip'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_oif_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.import_', u'routes'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast', u'arp_entry'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_nh_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip', u'unicast'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast', u'import_'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'ip'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast', u'route_target'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'route_target'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd', u'bfd_static_route'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6', u'unicast'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast', u'export'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip', u'unicast'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_oif_vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.import_', u'routes'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.import_', u'routes'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast', u'route_target'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast', u'import_'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_oif'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_oif'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast', u'export'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast', u'arp_entry')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrf', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'action, target_community'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'max_route'}, {'leafval': 'vrf_router_id'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'max_route'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'map_import, evpn_import'}, {'leafval': 'vrf_router_id'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'action, target_community'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'max_route'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'map_export, evpn_export'}, {'leafval': 'max_route'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'map_import, evpn_import'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'map_export, evpn_export'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, Port_channel, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve'}]
    leafval_map = {"pybind.nos.v7_2_0.rbridge_id.vrf": {}, "pybind.nos.v6_0_2f.rbridge_id.vrf": {"vrf_name": "vrf_name", "route_distiniguisher": "route_distiniguisher"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_get(self, rbridge_id=None, vrf=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address, mac_address_value, interfacename, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac_address_value: unicode
    :param mac_address_value: **arp_entry** tuple argument.

    :type interfacename: unicode
    :param interfacename: **arp_entry** tuple argument.

        * enumeration restriction: ::

            ['interface']

    :type GigabitEthernet: unicode
    :param GigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type TenGigabitEthernet: unicode
    :param TenGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type FortyGigabitEthernet: unicode
    :param FortyGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type HundredGigabitEthernet: unicode
    :param HundredGigabitEthernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9])/)?('
            '([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(:[1-4])?)'

    :type Ve: long
    :param Ve: **arp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': 'arp_ip_address, mac_address_value, interfacename, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry": {}, "pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.arp_entry": {"mac_address_value": "mac_address_value", "interfacename": "interfacename", "FortyGigabitEthernet": "FortyGigabitEthernet", "GigabitEthernet": "GigabitEthernet", "TenGigabitEthernet": "TenGigabitEthernet", "arp_ip_address": "arp_ip_address", "HundredGigabitEthernet": "HundredGigabitEthernet", "Ve": "Ve"}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry': [u'Port_channel', u'Ve', u'FortyGigabitEthernet', u'GigabitEthernet', u'TenGigabitEthernet', u'HundredGigabitEthernet'], 'pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.arp_entry': [u'FortyGigabitEthernet', u'GigabitEthernet', u'TenGigabitEthernet', u'HundredGigabitEthernet', u'Ve']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_fortygigabitethernet_get(self, rbridge_id=None, vrf=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_gigabitethernet_get(self, rbridge_id=None, vrf=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_hundredgigabitethernet_get(self, rbridge_id=None, vrf=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_interfacename_get(self, rbridge_id=None, vrf=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_mac_address_value_get(self, rbridge_id=None, vrf=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_port_channel_get(self, rbridge_id=None, vrf=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_tengigabitethernet_get(self, rbridge_id=None, vrf=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_arp_ve_get(self, rbridge_id=None, vrf=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.arp_entry', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_export_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.export', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'map_export, evpn_export'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_export_evpn_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.export', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_export_map_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.export', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_import_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.import_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'map_import, evpn_import'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_import_evpn_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.import_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_import_map_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.import_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_import_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.import_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.import_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_import_routes_get(self, rbridge_id=None, vrf=None, routes=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type routes: src_vrf, route_map
    :param routes: Keyword argument tuple.

    :type src_vrf: unicode
    :param src_vrf: **routes** tuple argument:  ASCII string;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type route_map: unicode
    :param route_map: **routes** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.import_.routes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.import_.routes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'routes', 'keyval': 'src_vrf, route_map', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, routes=routes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, routes=routes)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_bfd_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_bfd_bfd_static_route_get(self, rbridge_id=None, vrf=None, bfd_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_interval_attributes'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_interval_attributes')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_static_route', 'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, bfd_static_route=bfd_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_bfd_bfd_static_route_interval_get(self, rbridge_id=None, vrf=None, bfd_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, bfd_static_route=bfd_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_bfd_bfd_static_route_min_rx_get(self, rbridge_id=None, vrf=None, bfd_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, bfd_static_route=bfd_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_bfd_bfd_static_route_multiplier_get(self, rbridge_id=None, vrf=None, bfd_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, bfd_static_route=bfd_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_nh_get(self, rbridge_id=None, vrf=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'route_attributes'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'route_attributes')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh', 'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_nh_distance_get(self, rbridge_id=None, vrf=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_nh_metric_get(self, rbridge_id=None, vrf=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_nh_tag_get(self, rbridge_id=None, vrf=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_nh_vrf_get(self, rbridge_id=None, vrf=None, static_route_nh_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop
    :param static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_nh_vrf** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh_vrf** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_nh_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh_vrf=static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh_vrf=static_route_nh_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_oif_get(self, rbridge_id=None, vrf=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'route_attributes'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'route_attributes')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif', 'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_oif_distance_get(self, rbridge_id=None, vrf=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_oif_metric_get(self, rbridge_id=None, vrf=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_oif_tag_get(self, rbridge_id=None, vrf=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_ip_route_static_route_oif_vrf_get(self, rbridge_id=None, vrf=None, static_route_oif_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_oif_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name
    :param static_route_oif_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_oif_vrf** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_oif_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static_route_oif_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif_vrf=static_route_oif_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif_vrf=static_route_oif_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_max_route_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_route_target_get(self, rbridge_id=None, vrf=None, route_target=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target: action, target_community
    :param route_target: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target** tuple argument:  ASN:nn;; Target VPN Extended Community

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.route_target', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, route_target=route_target)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, route_target=route_target)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv4_unicast_route_target_evpn_get(self, rbridge_id=None, vrf=None, route_target=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target: action, target_community
    :param route_target: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target** tuple argument:  ASN:nn;; Target VPN Extended Community

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.route_target', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, route_target=route_target)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, route_target=route_target)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_export_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.export', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'map_export, evpn_export'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_export_evpn_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.export', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_export_map_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.export', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_import_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.import_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'map_import, evpn_import'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_import_evpn_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.import_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_import_map_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.import_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_import_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.import_', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.import_', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_import_routes_get(self, rbridge_id=None, vrf=None, routes=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type routes: src_vrf, route_map
    :param routes: Keyword argument tuple.

    :type src_vrf: unicode
    :param src_vrf: **routes** tuple argument:  ASCII string;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type route_map: unicode
    :param route_map: **routes** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.import_.routes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.import_.routes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'routes', 'keyval': 'src_vrf, route_map', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, routes=routes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, routes=routes)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_ipv6_static_route_oif_vrf_get(self, rbridge_id=None, vrf=None, ipv6_static_route_oif_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type ipv6_static_route_oif_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name
    :param ipv6_static_route_oif_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **ipv6_static_route_oif_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **ipv6_static_route_oif_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **ipv6_static_route_oif_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **ipv6_static_route_oif_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_static_route_oif_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, ipv6_static_route_oif_vrf=ipv6_static_route_oif_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, ipv6_static_route_oif_vrf=ipv6_static_route_oif_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_get(self, rbridge_id=None, vrf=None, link_local_static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'route_attributes'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'route_attributes')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_local_static_route_nh', 'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_distance_get(self, rbridge_id=None, vrf=None, link_local_static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_metric_get(self, rbridge_id=None, vrf=None, link_local_static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_tag_get(self, rbridge_id=None, vrf=None, link_local_static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_vrf_get(self, rbridge_id=None, vrf=None, link_local_static_route_nh_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type link_local_static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **link_local_static_route_nh_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **link_local_static_route_nh_vrf** tuple argument:  WORD 1-63;;Next Hop Vrf Name

    :type link_local_next_hop: unicode
    :param link_local_next_hop: **link_local_static_route_nh_vrf** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['management',
            've',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_local_static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh_vrf=link_local_static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, link_local_static_route_nh_vrf=link_local_static_route_nh_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_get(self, rbridge_id=None, vrf=None, bfd_ipv6_link_local_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_interval_attributes'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_interval_attributes')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_ipv6_link_local_static_route', 'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_interval_get(self, rbridge_id=None, vrf=None, bfd_ipv6_link_local_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_min_rx_get(self, rbridge_id=None, vrf=None, bfd_ipv6_link_local_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_multiplier_get(self, rbridge_id=None, vrf=None, bfd_ipv6_link_local_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_static_route_get(self, rbridge_id=None, vrf=None, bfd_ipv6_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_interval_attributes'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_interval_attributes')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_ipv6_static_route', 'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_static_route_interval_get(self, rbridge_id=None, vrf=None, bfd_ipv6_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_static_route_min_rx_get(self, rbridge_id=None, vrf=None, bfd_ipv6_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_static_route_multiplier_get(self, rbridge_id=None, vrf=None, bfd_ipv6_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_get(self, rbridge_id=None, vrf=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'route_attributes'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'route_attributes')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh', 'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_distance_get(self, rbridge_id=None, vrf=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_metric_get(self, rbridge_id=None, vrf=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_tag_get(self, rbridge_id=None, vrf=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_vrf_get(self, rbridge_id=None, vrf=None, static_route_nh_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop
    :param static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_nh_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh_vrf** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh_vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh_vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh_vrf=static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_nh_vrf=static_route_nh_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_oif_get(self, rbridge_id=None, vrf=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'route_attributes'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'route_attributes')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif', 'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_oif_distance_get(self, rbridge_id=None, vrf=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_oif_metric_get(self, rbridge_id=None, vrf=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_ipv6_route_static_route_oif_tag_get(self, rbridge_id=None, vrf=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ve',
            'fortygigabitethernet',
            'gigabitethernet',
            'tengigabitethernet',
            'hundredgigabitethernet',
            'null']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_max_route_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_route_target_get(self, rbridge_id=None, vrf=None, route_target=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target: action, target_community
    :param route_target: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target** tuple argument:  ASN:nn;; Target VPN Extended Community

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.route_target', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, route_target=route_target)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, route_target=route_target)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_address_family_ipv6_unicast_route_target_evpn_get(self, rbridge_id=None, vrf=None, route_target=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target: action, target_community
    :param route_target: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target** tuple argument:  ASN:nn;; Target VPN Extended Community

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.route_target', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, route_target=route_target)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, route_target=route_target)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_ip_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_ip_router_id_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.ip', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.ip', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_rd_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'route_target'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.import_', u'routes'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd', u'bfd_static_route'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6', u'unicast'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'ip'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_oif_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.import_', u'routes'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_oif'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast', u'arp_entry'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_nh_vrf'), ('pybind.nos.v6_0_2f.rbridge_id.vrf.address_family.ip', u'unicast'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast', u'import_'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'ip'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast', u'route_target'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'route_target'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd', u'bfd_static_route'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6', u'unicast'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast', u'export'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip', u'unicast'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_oif_vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.import_', u'routes'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.import_', u'routes'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast', u'route_target'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast', u'import_'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_oif'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_oif'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast', u'export'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast', u'arp_entry')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrf', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'action, target_community'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'max_route'}, {'leafval': 'vrf_router_id'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'max_route'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'map_import, evpn_import'}, {'leafval': 'vrf_router_id'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'action, target_community'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'max_route'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'map_export, evpn_export'}, {'leafval': 'max_route'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'map_import, evpn_import'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'map_export, evpn_export'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, Port_channel, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_route_target_get(self, rbridge_id=None, vrf=None, route_target=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target: action, target_community
    :param route_target: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target** tuple argument:  ASN:nn;; Target VPN Extended Community

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'vrf'), ('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v6_0_2f.rbridge_id.vrf', u'vrf')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrf.route_target', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrf.route_target', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf, route_target=route_target)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf, route_target=route_target)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrf_vni_get(self, rbridge_id=None, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v7_2_0.rbridge_id.vrf', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast', u'import_'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'ip'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_nh_vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast', u'route_target'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id.vrf', u'route_target'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route.static.bfd', u'bfd_static_route'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6', u'unicast'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast', u'export'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip', u'unicast'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_oif_vrf'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.import_', u'routes'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.import_', u'routes'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast', u'route_target'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast', u'import_'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast.ip.route', u'static_route_oif'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_oif'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast', u'export'), ('pybind.nos.v7_2_0.rbridge_id.vrf.address_family.ip.unicast', u'arp_entry')]
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vrf', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'map_import, evpn_import'}, {'leafval': 'vrf_router_id'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'action, target_community'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'max_route'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'map_export, evpn_export'}, {'leafval': 'max_route'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'map_import, evpn_import'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'map_export, evpn_export'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, Port_channel, GigabitEthernet, TenGigabitEthernet, FortyGigabitEthernet, HundredGigabitEthernet, Ve'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrrp_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrrp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrrp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrrp_acceptmode_disable_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrrp_rbridge_global', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrrp_rbridge_global', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrrp_early_startup_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrrp', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrrp', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rbridge_id_vrrp_rbridge_global_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: long
    :param rbridge_id: **rbridge_id** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rbridge_id', 'rbridge_id'), ('pybind.nos.v7_2_0.rbridge_id', 'rbridge_id')]
    bindings_list = [('pybind.nos.v6_0_2f.rbridge_id.vrrp_rbridge_global', 'pybind.nos.v6_0_2f.brocade_rbridge', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rbridge_id.vrrp_rbridge_global', 'pybind.nos.v7_2_0.brocade_rbridge', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'rbridge_id', 'extra_keyval': ''}, {'keyval': 'rbridge_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def reserved_vlan_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.reserved_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.reserved_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'reserved_vlan_start, reserved_vlan_end'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def reserved_vlan_reserved_vlan_end_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.reserved_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.reserved_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def reserved_vlan_reserved_vlan_start_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.reserved_vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.reserved_vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.resource_monitor', u'cpu'), ('pybind.slxos.v17s_1_02.resource_monitor.process', u'memory'), ('pybind.slxos.v17s_1_02.resource_monitor', u'memory')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable_cpu, threshold_cpu, action_cpu, sample_rate_cpu, logging_rate_cpu, grace_period_cpu, offset_cpu'}, {'leafval': 'enable_process, thresh_mem_alarm, thresh_mem_critic'}, {'leafval': 'enable_memory, threshold_memory, action_memory, sample_rate_memory, logging_rate_memory, grace_period_memory, offset_memory'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_cpu_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.cpu', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable_cpu, threshold_cpu, action_cpu, sample_rate_cpu, logging_rate_cpu, grace_period_cpu, offset_cpu'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_cpu_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.cpu', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_cpu_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.cpu', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_cpu_grace_period_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.cpu', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_cpu_logging_rate_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.cpu', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_cpu_sample_rate_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.cpu', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_cpu_thresh_offset_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.cpu', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_cpu_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.cpu', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_memory_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.memory', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.resource_monitor.process', u'memory')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable_memory, threshold_memory, action_memory, sample_rate_memory, logging_rate_memory, grace_period_memory, offset_memory'}
    composed_child_leafval_list = [{'leafval': 'enable_process, thresh_mem_alarm, thresh_mem_critic'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_memory_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.memory', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.resource_monitor.process', u'memory')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable_process, thresh_mem_alarm, thresh_mem_critic'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_memory_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.memory', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.resource_monitor.process', u'memory')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable_process, thresh_mem_alarm, thresh_mem_critic'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_memory_grace_period_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.memory', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.resource_monitor.process', u'memory')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable_process, thresh_mem_alarm, thresh_mem_critic'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_memory_logging_rate_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.memory', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.resource_monitor.process', u'memory')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable_process, thresh_mem_alarm, thresh_mem_critic'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_memory_sample_rate_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.memory', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.resource_monitor.process', u'memory')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable_process, thresh_mem_alarm, thresh_mem_critic'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_memory_thresh_offset_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.memory', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.resource_monitor.process', u'memory')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable_process, thresh_mem_alarm, thresh_mem_critic'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_memory_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.memory', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.resource_monitor.process', u'memory')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable_process, thresh_mem_alarm, thresh_mem_critic'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_process_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.process', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.resource_monitor.process', u'memory')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable_process, thresh_mem_alarm, thresh_mem_critic'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_process_memory_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.process.memory', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'enable_process, thresh_mem_alarm, thresh_mem_critic'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_process_memory_alarm_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.process.memory', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_process_memory_critical_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.process.memory', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def resource_monitor_process_memory_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.resource_monitor.process.memory', 'pybind.slxos.v17s_1_02.brocade_resource_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rmon_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rmon', 'pybind.nos.v6_0_2f.brocade_rmon', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rmon', 'pybind.nos.v7_2_0.brocade_rmon', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rmon', 'pybind.slxos.v17r_1_01a.brocade_rmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rmon', 'pybind.slxos.v17r_2_00.brocade_rmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rmon', 'pybind.slxos.v17s_1_02.brocade_rmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.rmon', u'event_entry'), ('pybind.slxos.v17r_1_01a.rmon', u'alarm_entry'), ('pybind.slxos.v17r_2_00.rmon', u'event_entry'), ('pybind.slxos.v17r_2_00.rmon', u'alarm_entry'), ('pybind.nos.v6_0_2f.rmon', u'alarm_entry'), ('pybind.nos.v6_0_2f.rmon', u'event_entry'), ('pybind.slxos.v17s_1_02.rmon', u'alarm_entry'), ('pybind.slxos.v17s_1_02.rmon', u'event_entry'), ('pybind.nos.v7_2_0.rmon', u'event_entry'), ('pybind.nos.v7_2_0.rmon', u'alarm_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'event_index, event_description, log, event_community, event_owner'}, {'leafval': 'alarm_index, snmp_oid, alarm_interval, alarm_sample, alarm_rising_threshold, alarm_rising_event_index, alarm_falling_threshold, alarm_falling_event_index, alarm_owner'}, {'leafval': 'event_index, event_description, log, event_community, event_owner'}, {'leafval': 'alarm_index, snmp_oid, alarm_interval, alarm_sample, alarm_rising_threshold, alarm_rising_event_index, alarm_falling_threshold, alarm_falling_event_index, alarm_owner'}, {'leafval': 'alarm_index, snmp_oid, alarm_interval, alarm_sample, alarm_rising_threshold, alarm_rising_event_index, alarm_falling_threshold, alarm_falling_event_index, alarm_owner'}, {'leafval': 'event_index, event_description, log, event_community, event_owner'}, {'leafval': 'alarm_index, snmp_oid, alarm_interval, alarm_sample, alarm_rising_threshold, alarm_rising_event_index, alarm_falling_threshold, alarm_falling_event_index, alarm_owner'}, {'leafval': 'event_index, event_description, log, event_community, event_owner'}, {'leafval': 'event_index, event_description, log, event_community, event_owner'}, {'leafval': 'alarm_index, snmp_oid, alarm_interval, alarm_sample, alarm_rising_threshold, alarm_rising_event_index, alarm_falling_threshold, alarm_falling_event_index, alarm_owner'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rmon_alarm_get(self, alarm_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type alarm_entry: alarm_index, snmp_oid, alarm_interval, alarm_sample, alarm_rising_threshold, alarm_rising_event_index, alarm_falling_threshold, alarm_falling_event_index, alarm_owner
    :param alarm_entry: Keyword argument tuple.

    :type alarm_index: long
    :param alarm_index: **alarm_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type snmp_oid: unicode
    :param snmp_oid: **alarm_entry** tuple argument.

        * length restriction: ::

            ['min .. 35']

    :type alarm_interval: long
    :param alarm_interval: **alarm_entry** tuple argument:  Alarm sample interval

        * range restriction: ::

            ['0..4294967295']

    :type alarm_sample: unicode
    :param alarm_sample: **alarm_entry** tuple argument.

        * enumeration restriction: ::

            ['absolute', 'delta']

    :type alarm_rising_threshold: long
    :param alarm_rising_threshold: **alarm_entry** tuple argument:  Alarm rising threshold

        * range restriction: ::

            ['0..4294967295']

    :type alarm_rising_event_index: long
    :param alarm_rising_event_index: **alarm_entry** tuple argument:  Event for rising alarm

        * range restriction: ::

            ['-2147483648..2147483647']

    :type alarm_falling_threshold: long
    :param alarm_falling_threshold: **alarm_entry** tuple argument:  Alarm falling threshold

        * range restriction: ::

            ['0..4294967295']

    :type alarm_falling_event_index: long
    :param alarm_falling_event_index: **alarm_entry** tuple argument:  Event for falling alarm

        * range restriction: ::

            ['-2147483648..2147483647']

    :type alarm_owner: unicode
    :param alarm_owner: **alarm_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rmon.alarm_entry', 'pybind.nos.v6_0_2f.brocade_rmon', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rmon.alarm_entry', 'pybind.nos.v7_2_0.brocade_rmon', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rmon.alarm_entry', 'pybind.slxos.v17r_1_01a.brocade_rmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rmon.alarm_entry', 'pybind.slxos.v17r_2_00.brocade_rmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rmon.alarm_entry', 'pybind.slxos.v17s_1_02.brocade_rmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alarm_entry', 'keyval': 'alarm_index', 'extra_keyval': 'alarm_index, snmp_oid, alarm_interval, alarm_sample, alarm_rising_threshold, alarm_rising_event_index, alarm_falling_threshold, alarm_falling_event_index, alarm_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alarm_entry=alarm_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alarm_entry=alarm_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rmon_alarm_event_get(self, alarm_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type alarm_entry: alarm_index
    :param alarm_entry: Keyword argument tuple.

    :type alarm_index: long
    :param alarm_index: **alarm_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rmon.alarm_entry', 'pybind.nos.v6_0_2f.brocade_rmon', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rmon.alarm_entry', 'pybind.nos.v7_2_0.brocade_rmon', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rmon.alarm_entry', 'pybind.slxos.v17r_1_01a.brocade_rmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rmon.alarm_entry', 'pybind.slxos.v17r_2_00.brocade_rmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rmon.alarm_entry', 'pybind.slxos.v17s_1_02.brocade_rmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alarm_entry', 'keyval': 'alarm_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alarm_entry=alarm_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alarm_entry=alarm_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rmon_alarm_falling_threshold_get(self, alarm_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type alarm_entry: alarm_index
    :param alarm_entry: Keyword argument tuple.

    :type alarm_index: long
    :param alarm_index: **alarm_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rmon.alarm_entry', 'pybind.nos.v6_0_2f.brocade_rmon', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rmon.alarm_entry', 'pybind.nos.v7_2_0.brocade_rmon', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rmon.alarm_entry', 'pybind.slxos.v17r_1_01a.brocade_rmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rmon.alarm_entry', 'pybind.slxos.v17r_2_00.brocade_rmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rmon.alarm_entry', 'pybind.slxos.v17s_1_02.brocade_rmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alarm_entry', 'keyval': 'alarm_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alarm_entry=alarm_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alarm_entry=alarm_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rmon_alarm_interval_get(self, alarm_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type alarm_entry: alarm_index
    :param alarm_entry: Keyword argument tuple.

    :type alarm_index: long
    :param alarm_index: **alarm_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rmon.alarm_entry', 'pybind.nos.v6_0_2f.brocade_rmon', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rmon.alarm_entry', 'pybind.nos.v7_2_0.brocade_rmon', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rmon.alarm_entry', 'pybind.slxos.v17r_1_01a.brocade_rmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rmon.alarm_entry', 'pybind.slxos.v17r_2_00.brocade_rmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rmon.alarm_entry', 'pybind.slxos.v17s_1_02.brocade_rmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alarm_entry', 'keyval': 'alarm_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alarm_entry=alarm_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alarm_entry=alarm_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rmon_alarm_owner_get(self, alarm_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type alarm_entry: alarm_index
    :param alarm_entry: Keyword argument tuple.

    :type alarm_index: long
    :param alarm_index: **alarm_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rmon.alarm_entry', 'pybind.nos.v6_0_2f.brocade_rmon', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rmon.alarm_entry', 'pybind.nos.v7_2_0.brocade_rmon', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rmon.alarm_entry', 'pybind.slxos.v17r_1_01a.brocade_rmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rmon.alarm_entry', 'pybind.slxos.v17r_2_00.brocade_rmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rmon.alarm_entry', 'pybind.slxos.v17s_1_02.brocade_rmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alarm_entry', 'keyval': 'alarm_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alarm_entry=alarm_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alarm_entry=alarm_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rmon_alarm_rising_threshold_get(self, alarm_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type alarm_entry: alarm_index
    :param alarm_entry: Keyword argument tuple.

    :type alarm_index: long
    :param alarm_index: **alarm_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rmon.alarm_entry', 'pybind.nos.v6_0_2f.brocade_rmon', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rmon.alarm_entry', 'pybind.nos.v7_2_0.brocade_rmon', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rmon.alarm_entry', 'pybind.slxos.v17r_1_01a.brocade_rmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rmon.alarm_entry', 'pybind.slxos.v17r_2_00.brocade_rmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rmon.alarm_entry', 'pybind.slxos.v17s_1_02.brocade_rmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alarm_entry', 'keyval': 'alarm_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alarm_entry=alarm_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alarm_entry=alarm_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rmon_alarm_snmp_oid_get(self, alarm_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type alarm_entry: alarm_index
    :param alarm_entry: Keyword argument tuple.

    :type alarm_index: long
    :param alarm_index: **alarm_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rmon.alarm_entry', 'pybind.nos.v6_0_2f.brocade_rmon', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rmon.alarm_entry', 'pybind.nos.v7_2_0.brocade_rmon', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rmon.alarm_entry', 'pybind.slxos.v17r_1_01a.brocade_rmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rmon.alarm_entry', 'pybind.slxos.v17r_2_00.brocade_rmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rmon.alarm_entry', 'pybind.slxos.v17s_1_02.brocade_rmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alarm_entry', 'keyval': 'alarm_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alarm_entry=alarm_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alarm_entry=alarm_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rmon_alarm_type_get(self, alarm_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type alarm_entry: alarm_index
    :param alarm_entry: Keyword argument tuple.

    :type alarm_index: long
    :param alarm_index: **alarm_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rmon.alarm_entry', 'pybind.nos.v6_0_2f.brocade_rmon', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rmon.alarm_entry', 'pybind.nos.v7_2_0.brocade_rmon', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rmon.alarm_entry', 'pybind.slxos.v17r_1_01a.brocade_rmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rmon.alarm_entry', 'pybind.slxos.v17r_2_00.brocade_rmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rmon.alarm_entry', 'pybind.slxos.v17s_1_02.brocade_rmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alarm_entry', 'keyval': 'alarm_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alarm_entry=alarm_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alarm_entry=alarm_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rmon_event_get(self, event_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type event_entry: event_index, event_description, log, event_community, event_owner
    :param event_entry: Keyword argument tuple.

    :type event_index: long
    :param event_index: **event_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type event_description: unicode
    :param event_description: **event_entry** tuple argument:  Event description

        * length restriction: ::

            ['min .. 127']

    :type log: YANGBool
    :param log: **event_entry** tuple argument:  Log the event

    :type event_community: unicode
    :param event_community: **event_entry** tuple argument:  Send trap for the event

        * length restriction: ::

            ['1 .. 127']

    :type event_owner: unicode
    :param event_owner: **event_entry** tuple argument:  Owner identity

        * length restriction: ::

            ['1 .. 15']

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,14})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rmon.event_entry', 'pybind.nos.v6_0_2f.brocade_rmon', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rmon.event_entry', 'pybind.nos.v7_2_0.brocade_rmon', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rmon.event_entry', 'pybind.slxos.v17r_1_01a.brocade_rmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rmon.event_entry', 'pybind.slxos.v17r_2_00.brocade_rmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rmon.event_entry', 'pybind.slxos.v17s_1_02.brocade_rmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'event_entry', 'keyval': 'event_index', 'extra_keyval': 'event_index, event_description, log, event_community, event_owner'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_entry=event_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_entry=event_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rmon_event_description_get(self, event_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type event_entry: event_index
    :param event_entry: Keyword argument tuple.

    :type event_index: long
    :param event_index: **event_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rmon.event_entry', 'pybind.nos.v6_0_2f.brocade_rmon', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rmon.event_entry', 'pybind.nos.v7_2_0.brocade_rmon', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rmon.event_entry', 'pybind.slxos.v17r_1_01a.brocade_rmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rmon.event_entry', 'pybind.slxos.v17r_2_00.brocade_rmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rmon.event_entry', 'pybind.slxos.v17s_1_02.brocade_rmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'event_entry', 'keyval': 'event_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_entry=event_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_entry=event_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rmon_event_log_get(self, event_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type event_entry: event_index
    :param event_entry: Keyword argument tuple.

    :type event_index: long
    :param event_index: **event_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rmon.event_entry', 'pybind.nos.v6_0_2f.brocade_rmon', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rmon.event_entry', 'pybind.nos.v7_2_0.brocade_rmon', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rmon.event_entry', 'pybind.slxos.v17r_1_01a.brocade_rmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rmon.event_entry', 'pybind.slxos.v17r_2_00.brocade_rmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rmon.event_entry', 'pybind.slxos.v17s_1_02.brocade_rmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'event_entry', 'keyval': 'event_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_entry=event_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_entry=event_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rmon_event_owner_get(self, event_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type event_entry: event_index
    :param event_entry: Keyword argument tuple.

    :type event_index: long
    :param event_index: **event_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rmon.event_entry', 'pybind.nos.v6_0_2f.brocade_rmon', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rmon.event_entry', 'pybind.nos.v7_2_0.brocade_rmon', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rmon.event_entry', 'pybind.slxos.v17r_1_01a.brocade_rmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rmon.event_entry', 'pybind.slxos.v17r_2_00.brocade_rmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rmon.event_entry', 'pybind.slxos.v17s_1_02.brocade_rmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'event_entry', 'keyval': 'event_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_entry=event_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_entry=event_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rmon_event_trap_get(self, event_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type event_entry: event_index
    :param event_entry: Keyword argument tuple.

    :type event_index: long
    :param event_index: **event_entry** tuple argument.

        * range restriction: ::

            ['-2147483648..2147483647']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rmon.event_entry', 'pybind.nos.v6_0_2f.brocade_rmon', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rmon.event_entry', 'pybind.nos.v7_2_0.brocade_rmon', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rmon.event_entry', 'pybind.slxos.v17r_1_01a.brocade_rmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rmon.event_entry', 'pybind.slxos.v17r_2_00.brocade_rmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rmon.event_entry', 'pybind.slxos.v17s_1_02.brocade_rmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'event_entry', 'keyval': 'event_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, event_entry=event_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, event_entry=event_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def role_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.role', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.role', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.role', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.role', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.role', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.role', u'name'), ('pybind.nos.v7_2_0.role', u'name'), ('pybind.nos.v6_0_2f.role', u'name'), ('pybind.slxos.v17s_1_02.role', u'name'), ('pybind.slxos.v17r_2_00.role', u'name')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, desc'}, {'leafval': 'name, desc'}, {'leafval': 'name, desc'}, {'leafval': 'name, desc'}, {'leafval': 'name, desc'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def role_name_get(self, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type name: name, desc
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument.

        * length restriction: ::

            ['4 .. 32']

    :type desc: unicode
    :param desc: **name** tuple argument:  Description of the role (default='')

        * length restriction: ::

            ['0 .. 64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.role.name', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.role.name', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.role.name', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.role.name', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.role.name', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': 'name, desc'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def role_name_desc_get(self, name=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type name: name
    :param name: Keyword argument tuple.

    :type name: unicode
    :param name: **name** tuple argument.

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.role.name', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.role.name', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.role.name', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.role.name', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.role.name', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'name', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, name=name)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, name=name)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def root_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.root_sa.root', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.root_sa.root', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.root_sa.root', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.root_sa.root', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.root_sa.root', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def root_access_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.root_sa.root', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.root_sa.root', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.root_sa.root', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.root_sa.root', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.root_sa.root', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def root_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.root_sa.root', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.root_sa.root', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.root_sa.root', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.root_sa.root', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.root_sa.root', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def root_sa_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.root_sa', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.root_sa', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.root_sa', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.root_sa', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.root_sa', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.root_sa', u'root'), ('pybind.nos.v7_2_0.root_sa', u'root'), ('pybind.slxos.v17r_2_00.root_sa', u'root'), ('pybind.nos.v6_0_2f.root_sa', u'root'), ('pybind.slxos.v17r_1_01a.root_sa', u'root')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable, access'}, {'leafval': 'enable, access'}, {'leafval': 'enable, access'}, {'leafval': 'enable, access'}, {'leafval': 'enable, access'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip.next_vrf', u'next_vrf_list'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.extcommunity', u'rt'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ip', u'route_source'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ipv6.next_ip', u'next_hop'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ipv6', u'address'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match', u'route_type'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.additional_paths.advertise_set', u'best_range'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip', u'dscp'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ipv6.global_', u'next_global_hop'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_', u'level'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ipv6', u'interface'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ip', u'next_hop'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_', u'community'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ipv6', u'route_source'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_', u'as_path'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.protocol', u'ospf_protocol_container'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_', u'origin'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ip', u'address'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ipv6', u'next_hop'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match', u'next_hop'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.protocol', u'bgp_protocol_container'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_', u'automatic_tag'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match', u'as_path'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_', u'route_type'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_', u'comm_list'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.protocol', u'isis_protocol_container'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.additional_paths', u'advertise_set'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_', u'tag'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.extcommunity', u'soo'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_', u'weight'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content', u'continue_holder'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ipv6.next_vrf', u'next_vrf_list'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_', u'metric'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match', u'metric'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match', u'community'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip.global_', u'next_global_hop'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip', u'next_hop'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip.next_hop', u'next_hop_list'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_', u'metric_type'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match', u'extcommunity'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_', u'local_preference'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.protocol', u'protocol_static_container'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.protocol', u'ospf_protocol_container'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ip', u'address'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ipv6', u'next_hop'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content', u'continue_holder'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_', u'tag'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_', u'origin'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.additional_paths', u'advertise_set'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.extcommunity', u'rt'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_', u'level'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_', u'community'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match', u'next_hop'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ipv6', u'address'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ipv6.global_', u'next_global_hop'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.protocol', u'protocol_static_container'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip', u'next_hop'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip.global_', u'next_global_hop'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_', u'comm_list'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_', u'local_preference'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ip', u'next_hop'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_', u'automatic_tag'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ipv6.next_vrf', u'next_vrf_list'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.protocol', u'bgp_protocol_container'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ip', u'route_source'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content', u'match'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_', u'route_type'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.protocol', u'isis_protocol_container'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.additional_paths.advertise_set', u'best_range'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match', u'metric'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match', u'extcommunity'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ipv6', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip', u'interface'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_', u'metric_type'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_', u'metric'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip.next_vrf', u'next_vrf_list'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_', u'as_path'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ipv6.next_ip', u'next_hop'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.extcommunity', u'soo'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match', u'as_path'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ipv6', u'route_source'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip.next_hop', u'next_hop_list'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip', u'dscp'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_', u'weight'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match', u'route_type'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match', u'community'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_', u'as_path'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ipv6', u'next_hop'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ip', u'next_hop'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match', u'extcommunity'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ip.global_', u'next_global_hop'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.protocol', u'bgp_protocol_container'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match', u'next_hop'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ipv6', u'route_source'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match', u'route_type'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_', u'local_preference'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_', u'community'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ipv6', u'address'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.extcommunity', u'rt'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ipv6.next_ip', u'next_hop'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ip', u'route_source'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content', u'continue_holder'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match', u'community'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match', u'metric'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_', u'weight'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.protocol', u'protocol_static_container'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ip', u'next_hop'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_', u'comm_list'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_', u'route_type'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.extcommunity', u'soo'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_', u'metric'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_', u'tag'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ip', u'dscp'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_', u'metric_type'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content', u'precedence'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ipv6.next_vrf', u'next_vrf_list'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ip.next_vrf', u'next_vrf_list'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ip', u'address'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.mac', u'address'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_', u'automatic_tag'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content', u'match'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ipv6.global_', u'next_global_hop'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match', u'as_path'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_', u'interface'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ip.next_hop', u'next_hop_list'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_', u'origin'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_', u'community'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content', u'match'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ipv6', u'address'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content', u'continue_holder'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match', u'extcommunity'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match', u'next_hop'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match', u'metric'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip', u'dscp'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip.next_vrf', u'next_vrf_list'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_', u'distance'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ip', u'next_hop'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ip', u'route_source'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ipv6.next_ip', u'next_hop'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ipv6', u'route_source'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match', u'community'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ip', u'address'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ipv6', u'next_hop'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip', u'interface'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match', u'as_path'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match', u'route_type'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ipv6.global_', u'next_global_hop'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_', u'tag'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_', u'as_path'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip.next_ip', u'next_hop'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.protocol', u'protocol_static_container'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_', u'route_type'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_', u'dampening'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_', u'metric_type'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_', u'comm_list'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.extcommunity', u'soo'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_', u'weight'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ipv6', u'interface'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.extcommunity', u'rt'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip.global_', u'next_global_hop'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip', u'next_hop'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_', u'local_preference'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.protocol', u'bgp_protocol_container'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ipv6.next_vrf', u'next_vrf_list'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_', u'automatic_tag'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_', u'origin'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_', u'metric'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_', u'local_preference'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match', u'as_path'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match', u'route_type'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ipv6.global_', u'next_global_hop'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_', u'as_path'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip', u'next_hop'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip', u'interface'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_', u'origin'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip.global_', u'next_global_hop'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ipv6', u'route_source'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ipv6.next_ip', u'next_hop'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_', u'comm_list'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_', u'automatic_tag'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ip', u'route_source'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_', u'metric_type'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ipv6', u'next_hop'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.extcommunity', u'soo'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_', u'distance'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ip', u'address'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_', u'metric'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_', u'weight'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ipv6', u'address'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content', u'continue_holder'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match', u'metric'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_', u'tag'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_', u'route_type'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content', u'match'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ipv6.next_vrf', u'next_vrf_list'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip.next_vrf', u'next_vrf_list'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.protocol', u'bgp_protocol_container'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.protocol', u'protocol_static_container'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_', u'community'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip', u'dscp'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match', u'extcommunity'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ip', u'next_hop'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match', u'community'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.extcommunity', u'rt'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_', u'dampening'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip.next_ip', u'next_hop'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match', u'next_hop'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ipv6', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'route_map', 'keyval': 'name, action_rm, instance', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf, next_hop'}, {'leafval': 'null0'}, {'leafval': 'ASN_NN_rt'}, {'leafval': 'prefix_list_rmrs'}, {'leafval': 'next_hop'}, {'leafval': 'ipv6_prefix_list_rmm, ipv6_acl_rmm'}, {'leafval': 'dist_rms'}, {'leafval': 'half_life, reuse, suppress, max_suppress_time'}, {'leafval': 'route_type_rmm'}, {'leafval': 'range_start, range_end'}, {'leafval': 'dscp_rms'}, {'leafval': 'next_hop'}, {'leafval': 'set_isis_level'}, {'leafval': 'ipv6_null0'}, {'leafval': 'prefix_list_rmm_n'}, {'leafval': 'set_community_expr'}, {'leafval': 'vrf'}, {'leafval': 'ipv6_prefix_list_rmrs'}, {'leafval': 'aspath_tag, prepend'}, {'leafval': 'protocol_ospf, ospf_route_type'}, {'leafval': 'origin_igp, origin_incomplete'}, {'leafval': 'prefix_list_rmm, acl_rmm'}, {'leafval': 'ipv6_prefix_list_rmm_n'}, {'leafval': 'next_hop_filter_val'}, {'leafval': 'protocol_bgp, bgp_route_type'}, {'leafval': 'tag_empty'}, {'leafval': 'as_path_access_list_name'}, {'leafval': 'route_type_rms'}, {'leafval': 'comm_list_name, match_comm_delete'}, {'leafval': 'protocol_isis, match_isis_level'}, {'leafval': 'all, best, group_best'}, {'leafval': 'tag_rms'}, {'leafval': 'ASN_NN_soo'}, {'leafval': 'weight_value'}, {'leafval': 'continue_, continue_val'}, {'leafval': 'vrf, next_hop'}, {'leafval': 'delta_rms, metric_rms'}, {'leafval': 'metric_rmm'}, {'leafval': 'community_access_list_name'}, {'leafval': 'next_hop'}, {'leafval': 'peer_address'}, {'leafval': 'next_hop_addr'}, {'leafval': 'external, internal, type_1, type_2'}, {'leafval': 'extcommunity_name'}, {'leafval': 'local_preference_value'}, {'leafval': 'static'}, {'leafval': 'protocol_ospf, ospf_route_type'}, {'leafval': 'prefix_list_rmm, acl_rmm'}, {'leafval': 'ipv6_prefix_list_rmm_n'}, {'leafval': 'continue_, continue_val'}, {'leafval': 'dist_rms'}, {'leafval': 'tag_rms'}, {'leafval': 'origin_igp, origin_incomplete'}, {'leafval': 'half_life, reuse, suppress, max_suppress_time'}, {'leafval': 'all, best, group_best'}, {'leafval': 'ASN_NN_rt'}, {'leafval': 'set_isis_level'}, {'leafval': 'set_community_expr'}, {'leafval': 'next_hop_filter_val'}, {'leafval': 'ipv6_prefix_list_rmm, ipv6_acl_rmm'}, {'leafval': 'next_hop'}, {'leafval': 'static'}, {'leafval': 'peer_address'}, {'leafval': 'next_hop'}, {'leafval': 'comm_list_name, match_comm_delete'}, {'leafval': 'local_preference_value'}, {'leafval': 'prefix_list_rmm_n'}, {'leafval': 'tag_empty'}, {'leafval': 'vrf, next_hop'}, {'leafval': 'protocol_bgp, bgp_route_type'}, {'leafval': 'prefix_list_rmrs'}, {'leafval': 'vrf'}, {'leafval': 'route_type_rms'}, {'leafval': 'protocol_isis, match_isis_level'}, {'leafval': 'range_start, range_end'}, {'leafval': 'metric_rmm'}, {'leafval': 'extcommunity_name'}, {'leafval': 'ipv6_null0'}, {'leafval': 'null0'}, {'leafval': 'external, internal, type_1, type_2'}, {'leafval': 'delta_rms, metric_rms'}, {'leafval': 'vrf, next_hop'}, {'leafval': 'aspath_tag, prepend'}, {'leafval': 'next_hop'}, {'leafval': 'ASN_NN_soo'}, {'leafval': 'as_path_access_list_name'}, {'leafval': 'ipv6_prefix_list_rmrs'}, {'leafval': 'next_hop_addr'}, {'leafval': 'dscp_rms'}, {'leafval': 'weight_value'}, {'leafval': 'route_type_rmm'}, {'leafval': 'community_access_list_name'}, {'leafval': 'aspath_tag, prepend'}, {'leafval': 'ipv6_prefix_list_rmm_n'}, {'leafval': 'dist_rms'}, {'leafval': 'prefix_list_rmm_n'}, {'leafval': 'extcommunity_name'}, {'leafval': 'next_hop'}, {'leafval': 'protocol_bgp, bgp_route_type'}, {'leafval': 'next_hop_filter_val'}, {'leafval': 'ipv6_prefix_list_rmrs'}, {'leafval': 'route_type_rmm'}, {'leafval': 'local_preference_value'}, {'leafval': 'set_community_expr'}, {'leafval': 'ipv6_prefix_list_rmm, ipv6_acl_rmm'}, {'leafval': 'ASN_NN_rt'}, {'leafval': 'next_hop'}, {'leafval': 'prefix_list_rmrs'}, {'leafval': 'continue_, continue_val'}, {'leafval': 'community_access_list_name'}, {'leafval': 'metric_rmm'}, {'leafval': 'weight_value'}, {'leafval': 'static'}, {'leafval': 'peer_address'}, {'leafval': 'comm_list_name, match_comm_delete'}, {'leafval': 'route_type_rms'}, {'leafval': 'ASN_NN_soo'}, {'leafval': 'delta_rms, metric_rms'}, {'leafval': 'tag_rms'}, {'leafval': 'dscp_rms'}, {'leafval': 'external, internal, type_1, type_2'}, {'leafval': 'precedence_value'}, {'leafval': 'vrf, next_hop'}, {'leafval': 'half_life, reuse, suppress, max_suppress_time'}, {'leafval': 'vrf, next_hop'}, {'leafval': 'prefix_list_rmm, acl_rmm'}, {'leafval': 'mac_acl'}, {'leafval': 'tag_empty'}, {'leafval': 'vrf'}, {'leafval': 'next_hop'}, {'leafval': 'as_path_access_list_name'}, {'leafval': 'null0'}, {'leafval': 'next_hop_addr'}, {'leafval': 'origin_igp, origin_incomplete'}, {'leafval': 'set_community_expr'}, {'leafval': 'vrf'}, {'leafval': 'ipv6_prefix_list_rmm, ipv6_acl_rmm'}, {'leafval': 'continue_, continue_val'}, {'leafval': 'extcommunity_num'}, {'leafval': 'next_hop_filter_val'}, {'leafval': 'metric_rmm'}, {'leafval': 'dscp_rms'}, {'leafval': 'vrf, next_hop'}, {'leafval': 'dist_rms'}, {'leafval': 'prefix_list_rmm_n'}, {'leafval': 'prefix_list_rmrs'}, {'leafval': 'next_hop'}, {'leafval': 'ipv6_prefix_list_rmrs'}, {'leafval': 'community_access_list_name'}, {'leafval': 'prefix_list_rmm, acl_rmm'}, {'leafval': 'ipv6_prefix_list_rmm_n'}, {'leafval': 'null0'}, {'leafval': 'as_path_access_list_name'}, {'leafval': 'route_type_rmm'}, {'leafval': 'next_hop'}, {'leafval': 'tag_rms'}, {'leafval': 'aspath_tag, prepend'}, {'leafval': 'next_hop'}, {'leafval': 'static'}, {'leafval': 'route_type_rms'}, {'leafval': 'half_life, reuse, suppress, max_suppress_time'}, {'leafval': 'external, internal, type_1, type_2'}, {'leafval': 'comm_list_name, match_comm_delete'}, {'leafval': 'ASN_NN_soo'}, {'leafval': 'weight_value'}, {'leafval': 'ipv6_null0'}, {'leafval': 'ASN_NN_rt'}, {'leafval': 'next_hop'}, {'leafval': 'peer_address'}, {'leafval': 'local_preference_value'}, {'leafval': 'protocol_bgp, bgp_route_type'}, {'leafval': 'vrf, next_hop'}, {'leafval': 'tag_empty'}, {'leafval': 'origin_igp, origin_incomplete'}, {'leafval': 'delta_rms, metric_rms'}, {'leafval': 'local_preference_value'}, {'leafval': 'as_path_access_list_name'}, {'leafval': 'route_type_rmm'}, {'leafval': 'next_hop'}, {'leafval': 'aspath_tag, prepend'}, {'leafval': 'peer_address'}, {'leafval': 'null0'}, {'leafval': 'origin_igp, origin_incomplete'}, {'leafval': 'next_hop'}, {'leafval': 'ipv6_prefix_list_rmrs'}, {'leafval': 'next_hop'}, {'leafval': 'comm_list_name, match_comm_delete'}, {'leafval': 'tag_empty'}, {'leafval': 'prefix_list_rmrs'}, {'leafval': 'external, internal, type_1, type_2'}, {'leafval': 'ipv6_prefix_list_rmm_n'}, {'leafval': 'ASN_NN_soo'}, {'leafval': 'dist_rms'}, {'leafval': 'prefix_list_rmm, acl_rmm'}, {'leafval': 'delta_rms, metric_rms'}, {'leafval': 'weight_value'}, {'leafval': 'ipv6_prefix_list_rmm, ipv6_acl_rmm'}, {'leafval': 'continue_, continue_val'}, {'leafval': 'metric_rmm'}, {'leafval': 'tag_rms'}, {'leafval': 'route_type_rms'}, {'leafval': 'vrf'}, {'leafval': 'vrf, next_hop'}, {'leafval': 'vrf, next_hop'}, {'leafval': 'protocol_bgp, bgp_route_type'}, {'leafval': 'static'}, {'leafval': 'set_community_expr'}, {'leafval': 'dscp_rms'}, {'leafval': 'extcommunity_num'}, {'leafval': 'prefix_list_rmm_n'}, {'leafval': 'community_access_list_name'}, {'leafval': 'ASN_NN_rt'}, {'leafval': 'half_life, reuse, suppress, max_suppress_time'}, {'leafval': 'next_hop'}, {'leafval': 'next_hop_filter_val'}, {'leafval': 'ipv6_null0'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_continue_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.continue_holder', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.continue_holder', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.continue_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.continue_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.continue_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_continue_holder_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.continue_holder', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.continue_holder', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.continue_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.continue_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.continue_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'continue_, continue_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_continue_val_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.continue_holder', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.continue_holder', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.continue_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.continue_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.continue_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_additional_paths_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_additional_paths_advertise_set_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.additional_paths.advertise_set', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.additional_paths.advertise_set', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_additional_paths_advertise_set_all_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.additional_paths.advertise_set', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.additional_paths.advertise_set', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_additional_paths_advertise_set_best_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.additional_paths.advertise_set', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.additional_paths.advertise_set', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_additional_paths_advertise_set_best_range_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.additional_paths.advertise_set.best_range', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.additional_paths.advertise_set.best_range', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'range_start, range_end'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_additional_paths_advertise_set_best_range_range_end_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.additional_paths.advertise_set.best_range', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.additional_paths.advertise_set.best_range', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_additional_paths_advertise_set_best_range_range_start_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.additional_paths.advertise_set.best_range', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.additional_paths.advertise_set.best_range', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_additional_paths_advertise_set_group_best_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.additional_paths.advertise_set', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.additional_paths.advertise_set', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_as_path_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.as_path', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.as_path', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.as_path', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.as_path', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.as_path', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_as_path_as_path_access_list_name_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.as_path', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.as_path', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.as_path', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.as_path', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.as_path', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_community_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.community', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.community', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'community_access_list_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_community_community_access_list_name_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.community', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.community', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_extcommunity_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.extcommunity', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.extcommunity', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.extcommunity', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.extcommunity', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.extcommunity', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.extcommunity": {"extcommunity_num": "extcommunity_num"}, "pybind.slxos.v17s_1_02.routing_system.route_map.content.match.extcommunity": {}, "pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.extcommunity": {}, "pybind.slxos.v17r_2_00.routing_system.route_map.content.match.extcommunity": {}, "pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.extcommunity": {"extcommunity_num": "extcommunity_num"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_extcommunity_extcommunity_name_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.extcommunity', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.extcommunity', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.extcommunity', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_extcommunity_extcommunity_num_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.extcommunity', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.extcommunity', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_interface_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.interface', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.interface', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_ip_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ip', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ip', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ip', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ip', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ip', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_ip_address_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ip.address', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ip.address', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ip.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ip.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ip.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_ip_address_acl_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ip.address', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ip.address', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ip.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ip.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ip.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_ip_address_prefix_list_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ip.address', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ip.address', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ip.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ip.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ip.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_ip_next_hop_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ip.next_hop', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ip.next_hop', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ip.next_hop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ip.next_hop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ip.next_hop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_ip_next_hop_prefix_list_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ip.next_hop', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ip.next_hop', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ip.next_hop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ip.next_hop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ip.next_hop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_ip_route_source_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ip.route_source', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ip.route_source', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ip.route_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ip.route_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ip.route_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_ip_route_source_prefix_list_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ip.route_source', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ip.route_source', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ip.route_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ip.route_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ip.route_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_ipv6_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ipv6', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ipv6', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_ipv6_address_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ipv6.address', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ipv6.address', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ipv6.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ipv6.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ipv6.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_ipv6_address_acl_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ipv6.address', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ipv6.address', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ipv6.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ipv6.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ipv6.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_ipv6_address_prefix_list_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ipv6.address', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ipv6.address', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ipv6.address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ipv6.address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ipv6.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_ipv6_next_hop_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ipv6.next_hop', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ipv6.next_hop', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ipv6.next_hop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ipv6.next_hop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ipv6.next_hop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_ipv6_next_hop_prefix_list_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ipv6.next_hop', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ipv6.next_hop', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ipv6.next_hop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ipv6.next_hop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ipv6.next_hop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_ipv6_route_source_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ipv6.route_source', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ipv6.route_source', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ipv6.route_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ipv6.route_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ipv6.route_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_ipv6_route_source_prefix_list_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.ipv6.route_source', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.ipv6.route_source', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.ipv6.route_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.ipv6.route_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.ipv6.route_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_mac_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.mac', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_mac_address_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.mac.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_mac_address_acl_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.mac.address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_metric_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.metric', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.metric', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_metric_metric_rmm_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.metric', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.metric', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_next_hop_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.next_hop', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.next_hop', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.next_hop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.next_hop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.next_hop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_next_hop_next_hop_filter_val_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.next_hop', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.next_hop', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.next_hop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.next_hop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.next_hop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_protocol_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.protocol', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.protocol', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.protocol', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.protocol', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.protocol', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_protocol_bgp_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.protocol.bgp_protocol_container', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.protocol.bgp_protocol_container', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.protocol.bgp_protocol_container', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_protocol_bgp_protocol_container_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.protocol.bgp_protocol_container', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.protocol.bgp_protocol_container', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.protocol.bgp_protocol_container', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_protocol_bgp_route_type_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.protocol.bgp_protocol_container', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.protocol.bgp_protocol_container', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.protocol.bgp_protocol_container', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.protocol.bgp_protocol_container', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_protocol_isis_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.protocol.isis_protocol_container', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.protocol.isis_protocol_container', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_protocol_isis_protocol_container_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.protocol.isis_protocol_container', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.protocol.isis_protocol_container', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'protocol_isis, match_isis_level'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_protocol_match_isis_level_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.protocol.isis_protocol_container', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.protocol.isis_protocol_container', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_protocol_ospf_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.protocol.ospf_protocol_container', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.protocol.ospf_protocol_container', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_protocol_ospf_protocol_container_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.protocol.ospf_protocol_container', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.protocol.ospf_protocol_container', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'protocol_ospf, ospf_route_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_protocol_ospf_route_type_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.protocol.ospf_protocol_container', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.protocol.ospf_protocol_container', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_protocol_protocol_static_container_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.protocol.protocol_static_container', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.protocol.protocol_static_container', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.protocol.protocol_static_container', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_protocol_static_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.protocol.protocol_static_container', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.protocol.protocol_static_container', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.protocol.protocol_static_container', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.protocol.protocol_static_container', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_route_type_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.route_type', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.route_type', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.route_type', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.route_type', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.route_type', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_route_type_route_type_rmm_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.route_type', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.route_type', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.route_type', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.route_type', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.route_type', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_tag_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match.tag', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match.tag', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match.tag', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match.tag', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match.tag', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_match_vrf_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.match', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.match', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_precedence_get(self, route_map=None, precedence=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type precedence: precedence_value
    :param precedence: Keyword argument tuple.

    :type precedence_value: int
    :param precedence_value: **precedence** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence.set_.interface', u'port_channel_container'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence.set_.interface', u'ethernet_container'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence.set_', u'next_hop_tvf_domain_container')]
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'precedence', 'keyval': 'precedence_value', 'extra_keyval': 'precedence_value'}
    composed_child_leafval_list = [{'leafval': 'port_channel, strip_vlan_po'}, {'leafval': 'ethernet, strip_vlan_eth'}, {'leafval': 'next_hop_tvf_domain, strip_vlan_tvf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, precedence=precedence)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, precedence=precedence)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_precedence_set_get(self, route_map=None, precedence=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type precedence: precedence_value
    :param precedence: Keyword argument tuple.

    :type precedence_value: int
    :param precedence_value: **precedence** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence', u'precedence')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence.set_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'precedence_value', 'extra_keyval': 'precedence_value'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, precedence=precedence)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, precedence=precedence)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_precedence_set_interface_get(self, route_map=None, precedence=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type precedence: precedence_value
    :param precedence: Keyword argument tuple.

    :type precedence_value: int
    :param precedence_value: **precedence** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence', u'precedence')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence.set_.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'precedence_value', 'extra_keyval': 'precedence_value'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, precedence=precedence)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, precedence=precedence)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_precedence_set_interface_ethernet_get(self, route_map=None, precedence=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type precedence: precedence_value
    :param precedence: Keyword argument tuple.

    :type precedence_value: int
    :param precedence_value: **precedence** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence', u'precedence')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence.set_.interface.ethernet_container', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'precedence_value', 'extra_keyval': 'precedence_value'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, precedence=precedence)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, precedence=precedence)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_precedence_set_interface_ethernet_container_get(self, route_map=None, precedence=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type precedence: precedence_value
    :param precedence: Keyword argument tuple.

    :type precedence_value: int
    :param precedence_value: **precedence** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence', u'precedence')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence.set_.interface.ethernet_container', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'precedence_value', 'extra_keyval': 'precedence_value'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ethernet, strip_vlan_eth'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, precedence=precedence)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, precedence=precedence)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_precedence_set_interface_port_channel_get(self, route_map=None, precedence=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type precedence: precedence_value
    :param precedence: Keyword argument tuple.

    :type precedence_value: int
    :param precedence_value: **precedence** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence', u'precedence')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence.set_.interface.port_channel_container', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'precedence_value', 'extra_keyval': 'precedence_value'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, precedence=precedence)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, precedence=precedence)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_precedence_set_interface_port_channel_container_get(self, route_map=None, precedence=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type precedence: precedence_value
    :param precedence: Keyword argument tuple.

    :type precedence_value: int
    :param precedence_value: **precedence** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence', u'precedence')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence.set_.interface.port_channel_container', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'precedence_value', 'extra_keyval': 'precedence_value'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'port_channel, strip_vlan_po'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, precedence=precedence)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, precedence=precedence)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_precedence_set_interface_strip_vlan_get(self, route_map=None, precedence=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type precedence: precedence_value
    :param precedence: Keyword argument tuple.

    :type precedence_value: int
    :param precedence_value: **precedence** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence', u'precedence')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence.set_.interface.ethernet_container', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'precedence_value', 'extra_keyval': 'precedence_value'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, precedence=precedence)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, precedence=precedence)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_precedence_set_interface_strip_vlan_port_channel_container_get(self, route_map=None, precedence=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type precedence: precedence_value
    :param precedence: Keyword argument tuple.

    :type precedence_value: int
    :param precedence_value: **precedence** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence', u'precedence')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence.set_.interface.port_channel_container', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'precedence_value', 'extra_keyval': 'precedence_value'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, precedence=precedence)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, precedence=precedence)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_precedence_set_next_hop_tvf_domain_get(self, route_map=None, precedence=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type precedence: precedence_value
    :param precedence: Keyword argument tuple.

    :type precedence_value: int
    :param precedence_value: **precedence** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence', u'precedence')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence.set_.next_hop_tvf_domain_container', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'precedence_value', 'extra_keyval': 'precedence_value'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, precedence=precedence)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, precedence=precedence)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_precedence_set_next_hop_tvf_domain_container_get(self, route_map=None, precedence=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type precedence: precedence_value
    :param precedence: Keyword argument tuple.

    :type precedence_value: int
    :param precedence_value: **precedence** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence', u'precedence')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence.set_.next_hop_tvf_domain_container', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'precedence_value', 'extra_keyval': 'precedence_value'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'next_hop_tvf_domain, strip_vlan_tvf'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, precedence=precedence)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, precedence=precedence)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_precedence_set_strip_vlan_get(self, route_map=None, precedence=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type precedence: precedence_value
    :param precedence: Keyword argument tuple.

    :type precedence_value: int
    :param precedence_value: **precedence** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence', u'precedence')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.precedence.set_.next_hop_tvf_domain_container', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'precedence_value', 'extra_keyval': 'precedence_value'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, precedence=precedence)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, precedence=precedence)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_as_path_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.as_path', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.as_path', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.as_path', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.as_path', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.as_path', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_as_path_prepend_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.as_path', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.as_path', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.as_path', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.as_path', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.as_path', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_as_path_tag_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.as_path', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.as_path', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.as_path', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.as_path', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.as_path', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_automatic_tag_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.automatic_tag', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.automatic_tag', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.automatic_tag', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.automatic_tag', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.automatic_tag', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_automatic_tag_tag_empty_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.automatic_tag', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.automatic_tag', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.automatic_tag', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.automatic_tag', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.automatic_tag', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_comm_list_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.comm_list', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.comm_list', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.comm_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.comm_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.comm_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'comm_list_name, match_comm_delete'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_comm_list_comm_list_name_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.comm_list', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.comm_list', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.comm_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.comm_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.comm_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_comm_list_delete_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.comm_list', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.comm_list', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.comm_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.comm_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.comm_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_community_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.community', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.community', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_community_set_community_expr_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.community', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.community', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_dampening_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_life, reuse, suppress, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_dampening_half_life_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_dampening_max_suppress_time_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_dampening_reuse_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_dampening_suppress_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.dampening', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_distance_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.distance', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.distance', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.distance', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.distance', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.distance', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_distance_dist_rms_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.distance', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.distance', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.distance', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.distance', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.distance', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_extcommunity_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.extcommunity', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.extcommunity', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.extcommunity', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.extcommunity', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.extcommunity', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_extcommunity_rt_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.extcommunity.rt', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.extcommunity.rt', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.extcommunity.rt', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.extcommunity.rt', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.extcommunity.rt', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_extcommunity_rt_asn_nn_rt_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.extcommunity.rt', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.extcommunity.rt', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.extcommunity.rt', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.extcommunity.rt', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.extcommunity.rt', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_extcommunity_soo_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.extcommunity.soo', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.extcommunity.soo', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.extcommunity.soo', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.extcommunity.soo', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.extcommunity.soo', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_extcommunity_soo_asn_nn_soo_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.extcommunity.soo', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.extcommunity.soo', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.extcommunity.soo', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.extcommunity.soo', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.extcommunity.soo', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_interface_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_interface_null0_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ip_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ip', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ip_dscp_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip.dscp', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip.dscp', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip.dscp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip.dscp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ip.dscp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ip_dscp_dscp_rms_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip.dscp', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip.dscp', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip.dscp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip.dscp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ip.dscp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ip_global_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip.global_', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip.global_', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip.global_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip.global_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ip.global_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ip_global_next_global_hop_get(self, route_map=None, next_global_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_global_hop: next_hop
    :param next_global_hop: Keyword argument tuple.

    :type next_hop: unicode
    :param next_hop: **next_global_hop** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip.global_.next_global_hop', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip.global_.next_global_hop', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip.global_.next_global_hop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip.global_.next_global_hop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ip.global_.next_global_hop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_global_hop', 'keyval': 'next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, next_global_hop=next_global_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, next_global_hop=next_global_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ip_interface_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip.interface', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip.interface', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ip_interface_null0_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip.interface', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip.interface', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ip_next_hop_get(self, route_map=None, next_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_hop: next_hop
    :param next_hop: Keyword argument tuple.

    :type next_hop: unicode
    :param next_hop: **next_hop** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip.next_ip.next_hop', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip.next_ip.next_hop', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop', 'keyval': 'next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, next_hop=next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, next_hop=next_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ip_next_hop_next_hop_list_get(self, route_map=None, next_hop_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_hop_list: next_hop_addr
    :param next_hop_list: Keyword argument tuple.

    :type next_hop_addr: unicode
    :param next_hop_addr: **next_hop_list** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip.next_hop.next_hop_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip.next_hop.next_hop_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ip.next_hop.next_hop_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop_list', 'keyval': 'next_hop_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, next_hop_list=next_hop_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, next_hop_list=next_hop_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ip_next_hop_peer_address_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip.next_hop', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip.next_hop', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip.next_hop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip.next_hop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ip.next_hop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ip_next_ip_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip.next_ip', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip.next_ip', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ip_next_vrf_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip.next_vrf', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip.next_vrf', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip.next_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip.next_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ip.next_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ip_next_vrf_list_get(self, route_map=None, next_vrf_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_vrf_list: vrf, next_hop
    :param next_vrf_list: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **next_vrf_list** tuple argument:  Next Hop Vrf Name

    :type next_hop: unicode
    :param next_hop: **next_vrf_list** tuple argument:  A.B.C.D;;IP address of next hop

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ip.next_vrf.next_vrf_list', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ip.next_vrf.next_vrf_list', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ip.next_vrf.next_vrf_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ip.next_vrf.next_vrf_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ip.next_vrf.next_vrf_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_vrf_list', 'keyval': 'vrf, next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, next_vrf_list=next_vrf_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, next_vrf_list=next_vrf_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ipv6_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ipv6', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ipv6', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ipv6_global_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ipv6.global_', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ipv6.global_', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ipv6.global_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ipv6.global_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ipv6.global_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ipv6_global_next_global_hop_get(self, route_map=None, next_global_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_global_hop: next_hop
    :param next_global_hop: Keyword argument tuple.

    :type next_hop: unicode
    :param next_hop: **next_global_hop** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ipv6.global_.next_global_hop', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ipv6.global_.next_global_hop', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ipv6.global_.next_global_hop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ipv6.global_.next_global_hop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ipv6.global_.next_global_hop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_global_hop', 'keyval': 'next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, next_global_hop=next_global_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, next_global_hop=next_global_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ipv6_interface_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ipv6.interface', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ipv6.interface', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ipv6.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ipv6.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ipv6_interface_null0_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ipv6.interface', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ipv6.interface', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ipv6.interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ipv6.interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ipv6_next_hop_get(self, route_map=None, next_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_hop: next_hop
    :param next_hop: Keyword argument tuple.

    :type next_hop: unicode
    :param next_hop: **next_hop** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ipv6.next_ip.next_hop', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ipv6.next_ip.next_hop', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ipv6.next_ip.next_hop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ipv6.next_ip.next_hop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ipv6.next_ip.next_hop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_hop', 'keyval': 'next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, next_hop=next_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, next_hop=next_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ipv6_next_ip_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ipv6.next_ip', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ipv6.next_ip', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ipv6.next_ip', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ipv6.next_ip', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ipv6.next_ip', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ipv6_next_vrf_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ipv6.next_vrf', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ipv6.next_vrf', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ipv6.next_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ipv6.next_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ipv6.next_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_ipv6_next_vrf_list_get(self, route_map=None, next_vrf_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type next_vrf_list: vrf, next_hop
    :param next_vrf_list: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **next_vrf_list** tuple argument:  WORD 1-63;;Next Hop Vrf Name

    :type next_hop: unicode
    :param next_hop: **next_vrf_list** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.ipv6.next_vrf.next_vrf_list', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.ipv6.next_vrf.next_vrf_list', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.ipv6.next_vrf.next_vrf_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.ipv6.next_vrf.next_vrf_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.ipv6.next_vrf.next_vrf_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'next_vrf_list', 'keyval': 'vrf, next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map, next_vrf_list=next_vrf_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map, next_vrf_list=next_vrf_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_level_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.level', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.level', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_level_set_isis_level_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.level', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.level', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_local_preference_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.local_preference', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.local_preference', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.local_preference', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.local_preference', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.local_preference', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_local_preference_local_preference_value_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.local_preference', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.local_preference', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.local_preference', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.local_preference', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.local_preference', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_metric_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.metric', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.metric', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'delta_rms, metric_rms'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_metric_delta_rms_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.metric', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.metric', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_metric_metric_rms_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.metric', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.metric', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_metric_type_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_metric_type_external_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_metric_type_internal_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_metric_type_type_1_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_metric_type_type_2_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.metric_type', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.metric_type', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_origin_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.origin', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.origin', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.origin', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.origin', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.origin', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_origin_igp_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.origin', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.origin', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.origin', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.origin', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.origin', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_origin_incomplete_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.origin', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.origin', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.origin', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.origin', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.origin', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_route_type_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.route_type', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.route_type', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.route_type', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.route_type', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.route_type', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_route_type_route_type_rms_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.route_type', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.route_type', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.route_type', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.route_type', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.route_type', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_tag_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.tag', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.tag', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.tag', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.tag', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.tag', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_tag_tag_rms_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.tag', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.tag', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.tag', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.tag', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.tag', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_weight_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.weight', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.weight', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.weight', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.weight', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.weight', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def route_map_set_weight_weight_value_get(self, route_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type route_map: name, action_rm, instance
    :param route_map: Keyword argument tuple.

    :type name: unicode
    :param name: **route_map** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type action_rm: unicode
    :param action_rm: **route_map** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type instance: int
    :param instance: **route_map** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.route_map', u'route_map'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.route_map', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.route_map', u'route_map'), ('pybind.nos.v6_0_2f.hide_routemap_holder.route_map', u'route_map')]
    bindings_list = [('pybind.nos.v6_0_2f.hide_routemap_holder.route_map.content.set_.weight', 'pybind.nos.v6_0_2f.brocade_ip_policy', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_routemap_holder.route_map.content.set_.weight', 'pybind.nos.v7_2_0.brocade_ip_policy', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.routing_system.route_map.content.set_.weight', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.route_map.content.set_.weight', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.route_map.content.set_.weight', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}, {'keyval': 'name, action_rm, instance', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, route_map=route_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, route_map=route_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.router', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.router', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.mpls_config.router', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family', u'ipv4'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'bypass_lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'lsp_xc_traps'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'autobw_template'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'cspf_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'bypass_lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'policy'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'lsp_xc_traps'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'rsvp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'autobw_template'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'cspf_group'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family', u'ipv4'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'bypass_lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'lsp_xc_traps'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'policy'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'cspf_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'autobw_template'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'timer'}, {'leafval': 'enable_global, gateway_mac_address, accept_unicast_arp_request'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'timer'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'lsp_name, lsp_dest_address, lsp_cspf, lsp_ipmtu, lsp_metric, lsp_revert_timer, lsp_tie_breaking, lsp_src_address, lsp_primary_path, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, lsp_soft_preemption, lsp_enable'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'interface_type, interface_name, mpls_interface_ldp_enable'}, {'leafval': 'bypass_lsp_name, bypass_lsp_dest_address, bypass_lsp_src_address, bypass_lsp_tie_breaking, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, bypass_lsp_primary_path, bypass_lsp_enable'}, {'leafval': 'refresh_interval, refresh_multiple, global_rsvp_hello_acknowledgements, global_rsvp_hello_unprioritize, g_rsvp_backup_bw_guarantee, delay_resv_send'}, {'leafval': 'lsp_xc_traps_enable'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'autobw_template_name, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'cspf_group_name'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'path_name'}, {'leafval': 'backup_retry_time, cspf_interface_constraint, handle_isis_neighbor_down, handle_ospf_neighbor_down, load_interval, retry_time, retry_limit, rapid_retry, rsvp_periodic_flooding_time, qos_ttl_mode, ingress_tunnel_accounting, transit_session_accounting'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'add_penalty'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'path_name'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'isis_set_level'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'add_penalty'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'lsp_name, lsp_dest_address, lsp_cspf, lsp_ipmtu, lsp_metric, lsp_revert_timer, lsp_tie_breaking, lsp_src_address, lsp_primary_path, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, lsp_soft_preemption, lsp_enable'}, {'leafval': 'bypass_lsp_name, bypass_lsp_dest_address, bypass_lsp_src_address, bypass_lsp_tie_breaking, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, bypass_lsp_primary_path, bypass_lsp_enable'}, {'leafval': 'backup_retry_time, cspf_interface_constraint, handle_isis_neighbor_down, handle_ospf_neighbor_down, load_interval, retry_time, retry_limit, rapid_retry, rsvp_periodic_flooding_time, qos_ttl_mode, ingress_tunnel_accounting, transit_session_accounting'}, {'leafval': 'lsp_xc_traps_enable'}, {'leafval': 'refresh_interval, refresh_multiple, global_rsvp_hello_acknowledgements, global_rsvp_hello_unprioritize, g_rsvp_backup_bw_guarantee'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'interface_type, interface_name, mpls_interface_ldp_enable'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'autobw_template_name, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'cspf_group_name'}, {'leafval': 'timer'}, {'leafval': 'enable_global, gateway_mac_address, accept_unicast_arp_request'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'timer'}, {'leafval': 'bypass_lsp_name, bypass_lsp_dest_address, bypass_lsp_src_address, bypass_lsp_tie_breaking, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, bypass_lsp_primary_path, bypass_lsp_enable'}, {'leafval': 'lsp_xc_traps_enable'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'interface_type, interface_name, mpls_interface_ldp_enable'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'add_penalty'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'backup_retry_time, cspf_interface_constraint, handle_isis_neighbor_down, handle_ospf_neighbor_down, load_interval, retry_time, retry_limit, rapid_retry, rsvp_periodic_flooding_time, qos_ttl_mode, ingress_tunnel_accounting, transit_session_accounting, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'cspf_group_name'}, {'leafval': 'lsp_name, lsp_dest_address, lsp_cspf, lsp_ipmtu, lsp_metric, lsp_revert_timer, lsp_tie_breaking, lsp_src_address, lsp_primary_path, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, lsp_soft_preemption, lsp_enable'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_template_name, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'refresh_interval, refresh_multiple, global_rsvp_hello_acknowledgements, global_rsvp_hello_unprioritize, g_rsvp_backup_bw_guarantee, delay_resv_send'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'path_name'}, {'leafval': 'bundle_send_delay'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.router', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.router', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.router', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'bypass_lsp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'lsp_xc_traps'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4u_ipv6_attr_holder', u'af_ipv4u_ipv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'mpls_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'policy'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.suppress', u'ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'cspf_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'lsp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family', u'ipv4'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6', u'vpnv6_unicast'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'autobw_template'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router', u'pim'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder', u'router_isis_attributes'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'rsvp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'path'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder', u'net'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp', u'router_bgp_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4', u'vpnv4_unicast'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'lsp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'bypass_lsp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6', u'vpnv6_unicast'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'lsp_xc_traps'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder', u'net'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'autobw_template'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'cspf_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'path'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'policy'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4', u'vpnv4_unicast'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.routing_system.router', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.routing_system.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp', u'router_bgp_attributes'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder', u'router_isis_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family', u'ipv4'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'rp_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family', u'ipv4'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp', u'router_bgp_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'path'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder', u'router_isis_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'route_precedence'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'bypass_lsp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'policy'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'lsp_xc_traps'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'rsvp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'ssm_enable'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp_ip'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'mpls_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'autobw_template'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder', u'net'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder', u'pim'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'cspf_group'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rpf', u'ecmp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'table_map_route_map'}, {'leafval': 'bypass_lsp_name, bypass_lsp_dest_address, bypass_lsp_src_address, bypass_lsp_tie_breaking, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, bypass_lsp_primary_path, bypass_lsp_enable'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'lsp_xc_traps_enable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'ipv6_address, activate'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'isis_set_level'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'interface_type, interface_name, mpls_interface_ldp_enable'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'nsr'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability, auth_transition'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'timer'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'add_penalty'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'backup_retry_time, cspf_interface_constraint, handle_isis_neighbor_down, handle_ospf_neighbor_down, load_interval, retry_time, retry_limit, rapid_retry, rsvp_periodic_flooding_time, qos_ttl_mode, ingress_tunnel_accounting, transit_session_accounting, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'timer'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'host_route'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'cspf_group_name'}, {'leafval': 'lsp_name, lsp_dest_address, lsp_cspf, lsp_ipmtu, lsp_metric, lsp_revert_timer, lsp_tie_breaking, lsp_src_address, lsp_primary_path, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, lsp_soft_preemption, lsp_enable'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'enable_global, gateway_mac_address, accept_unicast_arp_request'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'identifier'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'vrf, database_overflow_interval, default_passive_interface, default_metric, external_lsdb_limit, ospf_metric_type, vrf_lite_capability, nonstop_routing, maximum_paths, auth_transition'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'cleanup_timer'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'fast_flood_value'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'autobw_template_name, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'all'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'vrf, max_mcache, hello_interval, prune_wait, nbr_timeout, inactivity_timer, message_interval, spt_threshold'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'csnp_interval, disable_inc_stct_spf_opt, disable_incremental_spf_opt, disable_partial_spf_opt, is_type, lsp_gen_interval, lsp_interval, lsp_refresh_interval, max_lsp_lifetime, nonstop_routing, retransmit_interval'}, {'leafval': 'refresh_interval, refresh_multiple, global_rsvp_hello_acknowledgements, global_rsvp_hello_unprioritize, g_rsvp_backup_bw_guarantee, delay_resv_send'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'holdover_interval'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'path_name'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'net_cmd'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'local_as, always_compare_med, compare_med_empty_aspath, med_missing_as_worst, as_path_ignore, compare_routerid, install_igp_cost, default_local_preference, enforce_first_as, fast_external_fallover, log_dampening_debug, auto_shutdown_new_neighbors'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'lsp_name, lsp_dest_address, lsp_cspf, lsp_ipmtu, lsp_metric, lsp_revert_timer, lsp_tie_breaking, lsp_src_address, lsp_primary_path, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, lsp_soft_preemption, lsp_enable'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'interface_type, interface_name, mpls_interface_ldp_enable'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bypass_lsp_name, bypass_lsp_dest_address, bypass_lsp_src_address, bypass_lsp_tie_breaking, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, bypass_lsp_primary_path, bypass_lsp_enable'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'table_map_route_map'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'refresh_interval, refresh_multiple, global_rsvp_hello_acknowledgements, global_rsvp_hello_unprioritize, g_rsvp_backup_bw_guarantee, delay_resv_send'}, {'leafval': 'lsp_xc_traps_enable'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'net_cmd'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'holdover_interval'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'identifier'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'autobw_template_name, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'cspf_group_name'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'path_name'}, {'leafval': 'fast_flood_value'}, {'leafval': 'backup_retry_time, cspf_interface_constraint, handle_isis_neighbor_down, handle_ospf_neighbor_down, load_interval, retry_time, retry_limit, rapid_retry, rsvp_periodic_flooding_time, qos_ttl_mode, ingress_tunnel_accounting, transit_session_accounting'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'timer'}, {'leafval': 'vrf, max_mcache, hello_interval, prune_wait, nbr_timeout, inactivity_timer, message_interval, spt_threshold'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'vrf, database_overflow_interval, default_passive_interface, default_metric, external_lsdb_limit, ospf_metric_type, vrf_lite_capability, nonstop_routing, maximum_paths'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'isis_set_level'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'local_as, always_compare_med, compare_med_empty_aspath, med_missing_as_worst, as_path_ignore, compare_routerid, install_igp_cost, default_local_preference, enforce_first_as, fast_external_fallover, log_dampening_debug, auto_shutdown_new_neighbors'}, {'leafval': 'cleanup_timer'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'hostname_disable'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'num_as_in_path'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'timer'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'csnp_interval, disable_inc_stct_spf_opt, disable_incremental_spf_opt, disable_partial_spf_opt, is_type, lsp_gen_interval, lsp_interval, lsp_refresh_interval, max_lsp_lifetime, nonstop_routing, retransmit_interval'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'nsr'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'add_penalty'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'enable_global, gateway_mac_address, accept_unicast_arp_request'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'timer'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'enable_global, gateway_mac_address, accept_unicast_arp_request'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'cleanup_timer'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'identifier'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'hostname_disable'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'local_as, always_compare_med, compare_med_empty_aspath, med_missing_as_worst, as_path_ignore, compare_routerid, install_igp_cost, default_local_preference, enforce_first_as, fast_external_fallover, log_dampening_debug, auto_shutdown_new_neighbors'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'fast_flood_value'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'all'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'timer'}, {'leafval': 'as4_enable'}, {'leafval': 'path_name'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'isis_set_level'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'csnp_interval, disable_inc_stct_spf_opt, disable_incremental_spf_opt, disable_partial_spf_opt, is_type, lsp_gen_interval, lsp_interval, lsp_refresh_interval, max_lsp_lifetime, nonstop_routing, retransmit_interval'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'add_penalty'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'lsp_name, lsp_dest_address, lsp_cspf, lsp_ipmtu, lsp_metric, lsp_revert_timer, lsp_tie_breaking, lsp_src_address, lsp_primary_path, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, lsp_soft_preemption, lsp_enable'}, {'leafval': 'bypass_lsp_name, bypass_lsp_dest_address, bypass_lsp_src_address, bypass_lsp_tie_breaking, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, bypass_lsp_primary_path, bypass_lsp_enable'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'backup_retry_time, cspf_interface_constraint, handle_isis_neighbor_down, handle_ospf_neighbor_down, load_interval, retry_time, retry_limit, rapid_retry, rsvp_periodic_flooding_time, qos_ttl_mode, ingress_tunnel_accounting, transit_session_accounting'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'nsr'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'lsp_xc_traps_enable'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'refresh_interval, refresh_multiple, global_rsvp_hello_acknowledgements, global_rsvp_hello_unprioritize, g_rsvp_backup_bw_guarantee'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'range'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'interface_type, interface_name, mpls_interface_ldp_enable'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'autobw_template_name, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'vrf, database_overflow_interval, default_passive_interface, default_metric, external_lsdb_limit, ospf_metric_type, vrf_lite_capability, nonstop_routing, maximum_paths'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'net_cmd'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'max_mcache, hello_interval, prune_wait, nbr_timeout, inactivity_timer, message_interval, spt_threshold'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'table_map_route_map'}, {'leafval': 'holdover_interval'}, {'leafval': 'cspf_group_name'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'rebalance'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6', u'vpnv6_unicast'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4', u'vpnv4_unicast'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp', u'router_bgp_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4u_ipv6_attr_holder', u'af_ipv4u_ipv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.suppress', u'ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6', u'vpnv6_unicast'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp', u'router_bgp_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4', u'vpnv4_unicast'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp', u'router_bgp_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'table_map_route_map'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'holdover_interval'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'identifier'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'local_as, always_compare_med, compare_med_empty_aspath, med_missing_as_worst, as_path_ignore, compare_routerid, install_igp_cost, default_local_preference, enforce_first_as, fast_external_fallover, log_dampening_debug, auto_shutdown_new_neighbors'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'num_as_in_path'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'ipv6_address, activate'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'host_route'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'all'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'holdover_interval'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'local_as, always_compare_med, compare_med_empty_aspath, med_missing_as_worst, as_path_ignore, compare_routerid, install_igp_cost, default_local_preference, enforce_first_as, fast_external_fallover, log_dampening_debug, auto_shutdown_new_neighbors'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'identifier'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'local_as, always_compare_med, compare_med_empty_aspath, med_missing_as_worst, as_path_ignore, compare_routerid, install_igp_cost, default_local_preference, enforce_first_as, fast_external_fallover, log_dampening_debug, auto_shutdown_new_neighbors'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'all'}, {'leafval': 'as4_enable'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'table_map_route_map'}, {'leafval': 'holdover_interval'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6', u'vpnv6_unicast'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4', u'vpnv4_unicast'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4u_ipv6_attr_holder', u'af_ipv4u_ipv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.suppress', u'ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6', u'vpnv6_unicast'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4', u'vpnv4_unicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'all'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'table_map_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'table_map_route_map'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'ipv6_address, activate'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'host_route'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'all'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4u_ipv6_attr_holder', u'af_ipv4u_ipv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.suppress', u'ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'table_map_route_map'}, {'leafval': 'ipv6_address, activate'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'host_route'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4u_ipv6_attr_holder', u'af_ipv4u_ipv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'table_map_route_map'}, {'leafval': 'ipv6_address, activate'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_additional_paths_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_additional_paths_addpath_txrx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_send, addpath_receive'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_additional_paths_receive_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_additional_paths_select_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_additional_paths_select_all_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_additional_paths_select_best_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_additional_paths_select_group_best_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_additional_paths_send_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_advertise_best_external_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_af_common_cmds_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}]
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder": {}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder": {"client_to_client_reflection": "client_to_client_reflection", "default_metric": "default_metric", "next_hop_enable_default": "next_hop_enable_default", "always_propagate": "always_propagate", "update_time": "update_time", "advertise_best_external": "advertise_best_external", "default_information_originate": "default_information_originate", "rib_route_limit": "rib_route_limit"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_af_ipv4_uc_and_vrf_cmds_call_point_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder": {"bgp_redistribute_internal": "bgp_redistribute_internal"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder": {"bgp_redistribute_internal": "bgp_redistribute_internal"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_aggregate_address_get(self, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_aggregate_address_advertise_map_get(self, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_aggregate_address_as_set_get(self, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_aggregate_address_attribute_map_get(self, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_aggregate_address_summary_only_get(self, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_aggregate_address_suppress_map_get(self, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.aggregate_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_always_propagate_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_bgp_redistribute_internal_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_client_to_client_reflection_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_dampening_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening': [u'dampening_flag', u'values', u'dampening_route_map'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening': [u'dampening_flag', u'values', u'dampening_route_map'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening': [u'dampening_flag', u'values', u'dampening_route_map']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_dampening_dampening_flag_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_dampening_half_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_dampening_max_suppress_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_dampening_reuse_value_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_dampening_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_dampening_start_suppress_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_dampening_values_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_default_information_originate_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_default_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_default_vrf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4u_ipv6_attr_holder', u'af_ipv4u_ipv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'table_map_route_map'}, {'leafval': 'ipv6_address, activate'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_default_vrf_selected_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4u_ipv6_attr_holder', u'af_ipv4u_ipv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'table_map_route_map'}, {'leafval': 'ipv6_address, activate'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_graceful_restart_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_graceful_restart_graceful_restart_status_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_graceful_restart_purge_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_graceful_restart_restart_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_graceful_restart_stale_routes_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_maximum_paths_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_maximum_paths_ebgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_maximum_paths_ibgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_maximum_paths_load_sharing_value_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_maximum_paths_use_load_sharing_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_multipath_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_multipath_ebgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_multipath_ibgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_multipath_multi_as_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4u_ipv6_attr_holder', u'af_ipv4u_ipv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'ipv6_address, activate'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'best, all'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}]
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address": {"enable_peer_as_check": "enable_peer_as_check", "activate": "activate", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "af_ipv4_neighbor_address": "af_ipv4_neighbor_address", "route_reflector_client": "route_reflector_client"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address": {"enable_peer_as_check": "enable_peer_as_check", "activate": "activate", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "af_ipv4_neighbor_address": "af_ipv4_neighbor_address", "route_reflector_client": "route_reflector_client"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address": {"enable_peer_as_check": "enable_peer_as_check", "activate": "activate", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "af_ipv4_neighbor_address": "af_ipv4_neighbor_address", "route_reflector_client": "route_reflector_client"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_activate_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'best, all'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_additional_paths_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths": {"addpath_disable": "addpath_disable"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths": {"addpath_disable": "addpath_disable"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_additional_paths_addpath_txrx_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_send, addpath_receive'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_additional_paths_advertise_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.advertise": {}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all", "addpath_adv_groupbest": "addpath_adv_groupbest", "addpath_adv_best": "addpath_adv_best"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all", "addpath_adv_groupbest": "addpath_adv_groupbest", "addpath_adv_best": "addpath_adv_best"}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.advertise': [u'all', u'best']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_additional_paths_advertise_all_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.advertise": {"addpath_adv_all": "all"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_additional_paths_advertise_best_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.advertise": {"addpath_adv_best": "best"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_advertise": {"addpath_adv_best": "addpath_adv_best"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_advertise": {"addpath_adv_best": "addpath_adv_best"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_additional_paths_advertise_group_best_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_additional_paths_disable_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_additional_paths_receive_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_additional_paths_send_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_allowas_in_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'best, all'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_additional_paths_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_additional_paths_add_path_both_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_additional_paths_receive_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_additional_paths_send_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_orf_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_orf_prefixlist_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_orf_prefixlist_prefixlist_status_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_orf_prefixlist_receive_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_capability_orf_prefixlist_send_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_default_originate_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_originate_status, default_originate_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_default_originate_default_originate_status_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_default_originate_route_map_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_enable_peer_as_check_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'best, all'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_filter_list_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_filter_list_direction_in_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_filter_list_direction_out_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_filter_list_filter_list_direction_in_acl_name_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_filter_list_filter_list_direction_out_acl_name_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_filter_list_in_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_filter_list_out_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_prefix_limit'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_max_prefix_limit_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_teardown_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_threshold_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_maximum_prefix_threshold_holder_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_direction_in_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_direction_out_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_in_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_ip_access_number_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_ip_access_number_direction_out_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_out_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_prefix_list_direction_in_prefix_name_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_prefix_list_prefix_list_direction_out_prefix_name_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_map_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_map_in_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_map_in_neighbor_route_map_name_direction_in_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_map_out_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_map_out_neighbor_route_map_name_direction_out_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_route_reflector_client_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'best, all'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_both_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_extended_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_send_community_status_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_send_community_standard_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_unsuppress_map_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.unsuppress_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.unsuppress_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.unsuppress_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_unsuppress_map_map_name_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'af_ipv4_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.unsuppress_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.unsuppress_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.unsuppress_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_address_weight_get(self, af_ipv4_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_address: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_address: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_address** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder.af_ipv4_neighbor_address.filter_list', u'direction_in')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_address', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'best, all'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_address=af_ipv4_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}]
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup": {"enable_peer_as_check": "enable_peer_as_check", "activate": "activate", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "route_reflector_client": "route_reflector_client", "af_ipv4_neighbor_peergroup_name": "af_ipv4_neighbor_peergroup_name"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup": {"enable_peer_as_check": "enable_peer_as_check", "activate": "activate", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "route_reflector_client": "route_reflector_client", "af_ipv4_neighbor_peergroup_name": "af_ipv4_neighbor_peergroup_name"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup": {"enable_peer_as_check": "enable_peer_as_check", "activate": "activate", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "route_reflector_client": "route_reflector_client", "af_ipv4_neighbor_peergroup_name": "af_ipv4_neighbor_peergroup_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_activate_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_additional_paths_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths": {"addpath_disable": "addpath_disable"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths": {"addpath_disable": "addpath_disable"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_additional_paths_addpath_txrx_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_send, addpath_receive'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_additional_paths_advertise_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.advertise": {}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all", "addpath_adv_groupbest": "addpath_adv_groupbest", "addpath_adv_best": "addpath_adv_best"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all", "addpath_adv_groupbest": "addpath_adv_groupbest", "addpath_adv_best": "addpath_adv_best"}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.advertise': [u'all', u'best']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_additional_paths_advertise_all_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.advertise": {"addpath_adv_all": "all"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_additional_paths_advertise_best_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.advertise": {"addpath_adv_best": "best"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_advertise": {"addpath_adv_best": "addpath_adv_best"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_advertise": {"addpath_adv_best": "addpath_adv_best"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_additional_paths_advertise_group_best_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_additional_paths_disable_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_additional_paths_receive_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_additional_paths_send_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_allowas_in_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_additional_paths_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_additional_paths_add_path_both_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_additional_paths_receive_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_additional_paths_send_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_orf_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_orf_prefixlist_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_orf_prefixlist_prefixlist_status_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_orf_prefixlist_receive_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_capability_orf_prefixlist_send_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_default_originate_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_originate_status, default_originate_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_default_originate_default_originate_status_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_default_originate_route_map_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_enable_peer_as_check_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_filter_list_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_filter_list_direction_in_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_filter_list_direction_out_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_filter_list_filter_list_direction_in_acl_name_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_filter_list_filter_list_direction_out_acl_name_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_filter_list_in_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_filter_list_out_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_prefix_limit'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_max_prefix_limit_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_teardown_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_threshold_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_maximum_prefix_threshold_holder_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_direction_in_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_direction_out_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_in_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_ip_access_number_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_ip_access_number_direction_out_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_out_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_prefix_list_direction_in_prefix_name_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_prefix_list_prefix_list_direction_out_prefix_name_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_map_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_map_in_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_map_in_neighbor_route_map_name_direction_in_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_map_out_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_map_out_neighbor_route_map_name_direction_out_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_route_reflector_client_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_both_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_extended_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_send_community_status_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_send_community_standard_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_unsuppress_map_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.unsuppress_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.unsuppress_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.unsuppress_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_unsuppress_map_map_name_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'af_ipv4_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.unsuppress_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.unsuppress_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.unsuppress_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4_neighbor_peergroup_weight_get(self, af_ipv4_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_peergroup: af_ipv4_neighbor_peergroup_name
    :param af_ipv4_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv4_neighbor_peergroup_name: unicode
    :param af_ipv4_neighbor_peergroup_name: **af_ipv4_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder.af_ipv4_neighbor_peergroup', u'send_community')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_peergroup', 'keyval': 'af_ipv4_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4_neighbor_peergroup=af_ipv4_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4u_ipv6_attr_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4u_ipv6_attr_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4u_ipv6_attr_holder', u'af_ipv4u_ipv6_neighbor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_address, activate'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4u_ipv6_neighbor_get(self, af_ipv4u_ipv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4u_ipv6_neighbor: ipv6_address
    :param af_ipv4u_ipv6_neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **af_ipv4u_ipv6_neighbor** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4u_ipv6_attr_holder.af_ipv4u_ipv6_neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4u_ipv6_neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4u_ipv6_neighbor=af_ipv4u_ipv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4u_ipv6_neighbor=af_ipv4u_ipv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_neighbor_af_ipv4u_ipv6_neighbor_activate_get(self, af_ipv4u_ipv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_ipv4u_ipv6_neighbor: ipv6_address
    :param af_ipv4u_ipv6_neighbor: Keyword argument tuple.

    :type ipv6_address: unicode
    :param ipv6_address: **af_ipv4u_ipv6_neighbor** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4u_ipv6_attr_holder.af_ipv4u_ipv6_neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv4u_ipv6_neighbor', 'keyval': 'ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv4u_ipv6_neighbor=af_ipv4u_ipv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv4u_ipv6_neighbor=af_ipv4u_ipv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_network_get(self, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_network_backdoor_get(self, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_network_route_map_get(self, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_network_weight_get(self, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_next_hop_enable_default_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_next_hop_mpls_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.next_hop_mpls', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.next_hop_mpls', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.next_hop_mpls', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.next_hop_mpls': [u'compare_lsp_metric', u'follow_igp'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.next_hop_mpls': [u'compare_lsp_metric', u'follow_igp'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.next_hop_mpls': [u'compare_lsp_metric', u'follow_igp']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_next_hop_mpls_compare_lsp_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.next_hop_mpls', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.next_hop_mpls', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.next_hop_mpls', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_next_hop_mpls_follow_igp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.next_hop_mpls', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.next_hop_mpls', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.next_hop_mpls', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_next_hop_recursion_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4u_ipv6_attr_holder', u'af_ipv4u_ipv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'table_map_route_map'}, {'leafval': 'ipv6_address, activate'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_bgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_bgp_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_bgp_redistribute_bgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_bgp_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_connected_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_connected_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_connected_redistribute_connected_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_connected_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_isis_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis': [u'level_2', u'level_1', u'level_1_2'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis': [u'level_2', u'level_1', u'level_1_2'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis': [u'level_2', u'level_1', u'level_1_2']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_isis_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_isis_level_1_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_isis_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_isis_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_isis_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_ospf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_ospf_match_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_ospf_match_external1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_ospf_match_external2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_ospf_match_internal_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_ospf_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_ospf_redistribute_ospf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_ospf_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_static_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_static_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_static_redistribute_static_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_redistribute_static_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_rib_route_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_static_network_get(self, static_network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type static_network: static_network_address
    :param static_network: Keyword argument tuple.

    :type static_network_address: unicode
    :param static_network_address: **static_network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_network', 'keyval': 'static_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_network=static_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_network=static_network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_static_network_distance_get(self, static_network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type static_network: static_network_address
    :param static_network: Keyword argument tuple.

    :type static_network_address: unicode
    :param static_network_address: **static_network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.static_network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'static_network', 'keyval': 'static_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, static_network=static_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, static_network=static_network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_table_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_table_map_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_update_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'num_as_in_path'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'num_as_in_path'}]
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf": {}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf": {"client_to_client_reflection": "client_to_client_reflection", "af_vrf_name": "af_vrf_name", "default_metric": "default_metric", "local_as": "local_as", "advertise_best_external": "advertise_best_external", "always_propagate": "always_propagate", "update_time": "update_time", "graceful_restart_status": "graceful_restart_status", "default_information_originate": "default_information_originate", "next_hop_enable_default": "next_hop_enable_default", "next_hop_recursion": "next_hop_recursion", "rib_route_limit": "rib_route_limit"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_additional_paths_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_additional_paths_addpath_txrx_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_send, addpath_receive'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_additional_paths_receive_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_additional_paths_select_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths.addpath_select', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_additional_paths_select_all_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths.addpath_select', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_additional_paths_select_best_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths.addpath_select', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_additional_paths_select_group_best_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths.addpath_select', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_additional_paths_send_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_advertise_best_external_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map')]
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf": {"advertise_best_external": "advertise_best_external", "af_vrf_name": "af_vrf_name"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_get(self, af_vrf=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_advertise_map_get(self, af_vrf=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_as_set_get(self, af_vrf=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_attribute_map_get(self, af_vrf=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_summary_only_get(self, af_vrf=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_aggregate_address_suppress_map_get(self, af_vrf=None, aggregate_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_address: aggregate_ip_prefix
    :param aggregate_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.aggregate_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, aggregate_address=aggregate_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, aggregate_address=aggregate_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_always_propagate_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'num_as_in_path'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'num_as_in_path'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_bgp_redistribute_internal_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_client_to_client_reflection_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'num_as_in_path'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'num_as_in_path'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_dampening_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening': [u'dampening_flag', u'values', u'dampening_route_map'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening': [u'dampening_flag', u'values', u'dampening_route_map'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening': [u'dampening_flag', u'values', u'dampening_route_map']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_dampening_dampening_flag_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_dampening_half_time_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_dampening_max_suppress_time_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_dampening_reuse_value_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_dampening_route_map_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_dampening_start_suppress_time_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_dampening_values_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values': [u'half_time'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values': [u'half_time'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening.values': [u'half_time']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_default_information_originate_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'num_as_in_path'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'num_as_in_path'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_default_metric_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'num_as_in_path'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'num_as_in_path'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_graceful_restart_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'num_as_in_path'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'num_as_in_path'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_local_as_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'num_as_in_path'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'num_as_in_path'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_maxas_limit_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_maxas_limit_in_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_maxas_limit_in_num_as_in_path_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_ebgp_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_ibgp_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_load_sharing_value_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_maximum_paths_use_load_sharing_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_multipath_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_multipath_ebgp_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_multipath_ibgp_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_multipath_multi_as_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.multipath', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'value'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'addpath_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'addpath_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr": {"static_network_edge": "static_network_edge", "enable_peer_as_check": "enable_peer_as_check", "activate": "activate", "remote_as": "remote_as", "associate_peer_group": "associate_peer_group", "ebgp_btsh": "ebgp_btsh", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "af_ipv4_neighbor_address": "af_ipv4_neighbor_address", "route_reflector_client": "route_reflector_client", "remove_private_as": "remove_private_as", "password": "password", "as_override": "as_override", "description": "description"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr": {"static_network_edge": "static_network_edge", "enable_peer_as_check": "enable_peer_as_check", "activate": "activate", "remote_as": "remote_as", "associate_peer_group": "associate_peer_group", "ebgp_btsh": "ebgp_btsh", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "af_ipv4_neighbor_address": "af_ipv4_neighbor_address", "route_reflector_client": "route_reflector_client", "remove_private_as": "remove_private_as", "password": "password", "as_override": "as_override", "description": "description"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr": {"static_network_edge": "static_network_edge", "enable_peer_as_check": "enable_peer_as_check", "activate": "activate", "remote_as": "remote_as", "associate_peer_group": "associate_peer_group", "ebgp_btsh": "ebgp_btsh", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "af_ipv4_neighbor_address": "af_ipv4_neighbor_address", "route_reflector_client": "route_reflector_client", "remove_private_as": "remove_private_as", "password": "password", "as_override": "as_override", "description": "description"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_activate_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'value'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'addpath_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'addpath_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_additional_paths_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths": {"addpath_disable": "addpath_disable"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths": {}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths": {"addpath_disable": "addpath_disable"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_additional_paths_addpath_txrx_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_send, addpath_receive'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_additional_paths_advertise_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all", "addpath_adv_groupbest": "addpath_adv_groupbest", "addpath_adv_best": "addpath_adv_best"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all", "addpath_adv_groupbest": "addpath_adv_groupbest", "addpath_adv_best": "addpath_adv_best"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.advertise": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.advertise': [u'all', u'best']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_additional_paths_advertise_all_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.advertise": {"addpath_adv_all": "all"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_additional_paths_advertise_best_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_advertise": {"addpath_adv_best": "addpath_adv_best"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_advertise": {"addpath_adv_best": "addpath_adv_best"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.advertise": {"addpath_adv_best": "best"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_additional_paths_advertise_group_best_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_additional_paths_disable_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_additional_paths_receive_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_additional_paths_send_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_advertisement_interval_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_advertisement_interval_value_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.advertisement_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_allowas_in_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'value'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'addpath_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'addpath_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_as_override_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'value'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'addpath_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'addpath_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_bfd_enable_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_holdover_interval_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_interval_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_interval_min_rx_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_interval_min_tx_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_bfd_interval_multiplier_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_additional_paths_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_additional_paths_add_path_both_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_additional_paths_receive_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_additional_paths_send_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_as4_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_as4_disable_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_as4_enable_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_orf_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_orf_prefixlist_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_orf_prefixlist_prefixlist_status_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_orf_prefixlist_receive_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_capability_orf_prefixlist_send_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_default_originate_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_originate_status, default_originate_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_default_originate_default_originate_status_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_default_originate_route_map_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_description_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'value'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'addpath_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'addpath_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_ebgp_btsh_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'value'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'addpath_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'addpath_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_ebgp_multihop_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_ebgp_multihop_ebgp_multihop_count_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_ebgp_multihop_ebgp_multihop_flag_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_enable_peer_as_check_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'value'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'addpath_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'addpath_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_enforce_first_as_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_enforce_first_as_disable_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_enforce_first_as_enable_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.enforce_first_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_filter_list_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_filter_list_direction_in_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_filter_list_direction_out_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_filter_list_filter_list_direction_in_acl_name_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_filter_list_filter_list_direction_out_acl_name_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_filter_list_in_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_filter_list_out_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_local_as_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_local_as_local_as_value_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_local_as_no_prepend_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.local_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maxas_limit_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maxas_limit_in_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'num_as_in_as_path, maxas_limit_disable'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maxas_limit_in_disable_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maxas_limit_in_num_as_in_as_path_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_prefix_limit'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_max_prefix_limit_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_teardown_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_threshold_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_maximum_prefix_threshold_holder_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_next_hop_self_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_next_hop_self_always_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_next_hop_self_next_hop_self_status_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.next_hop_self', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_password_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'value'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'addpath_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'addpath_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_peer_group_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'value'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'addpath_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'addpath_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_direction_in_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_direction_out_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_in_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_ip_access_number_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_ip_access_number_direction_out_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_out_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_prefix_list_direction_in_prefix_name_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_prefix_list_prefix_list_direction_out_prefix_name_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_remote_as_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'value'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'addpath_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'addpath_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_remove_private_as_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'value'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'addpath_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'addpath_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_map_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_map_in_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_map_in_neighbor_route_map_name_direction_in_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_map_out_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_map_out_neighbor_route_map_name_direction_out_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_route_reflector_client_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'value'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'addpath_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'addpath_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_both_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_extended_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_send_community_status_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_send_community_standard_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_shutdown_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'shutdown_status, generate_rib_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_shutdown_generate_rib_out_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_shutdown_shutdown_status_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.shutdown', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_soft_reconfiguration_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_soft_reconfiguration_inbound_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_static_network_edge_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'value'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'addpath_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'addpath_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_timers_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'nei_keep_alive, nei_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_timers_hold_time_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_timers_keep_alive_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_unsuppress_map_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.unsuppress_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.unsuppress_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.unsuppress_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_unsuppress_map_map_name_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.unsuppress_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.unsuppress_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.unsuppress_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source": {"ve_interface": "ve_interface", "sip_ipv4_address": "sip_ipv4_address", "loopback": "loopback"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source": {}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source": {"ve_interface": "ve_interface", "sip_ipv4_address": "sip_ipv4_address", "loopback": "loopback"}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source': [u'ethernet_interface', u've_interface', u'sip_ipv4_address', u'loopback'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source': [u'ethernet_interface', u've_interface', u'loopback', u'sip_ipv4_address', u'port_channel'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source': [u'ethernet_interface', u've_interface', u'sip_ipv4_address', u'loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_ethernet_interface_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_interface_name_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_interface_type_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_loopback_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_port_channel_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_sip_ipv4_address_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_update_source_ve_interface_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'af_ipv4_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_neighbor_addr_weight_get(self, af_vrf=None, af_ipv4_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv4_neighbor_addr: af_ipv4_neighbor_address
    :param af_ipv4_neighbor_addr: Keyword argument tuple.

    :type af_ipv4_neighbor_address: unicode
    :param af_ipv4_neighbor_address: **af_ipv4_neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder.af_ipv4_neighbor_addr.filter_list', u'direction_out')]
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv4_neighbor_addr', 'keyval': 'af_ipv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'value'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'inbound'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'value'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'map_name'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'addpath_disable'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'value'}, {'leafval': 'addpath_disable'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'map_name'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'threshold, teardown'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, af_ipv4_neighbor_addr=af_ipv4_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_neighbor_af_ipv4_vrf_neighbor_address_holder_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_network_get(self, af_vrf=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_network_backdoor_get(self, af_vrf=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_network_route_map_get(self, af_vrf=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_network_weight_get(self, af_vrf=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv4_address
    :param network: Keyword argument tuple.

    :type network_ipv4_address: unicode
    :param network_ipv4_address: **network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_next_hop_enable_default_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'num_as_in_path'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'num_as_in_path'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_next_hop_recursion_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'num_as_in_path'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'num_as_in_path'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_bgp_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_bgp_metric_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_bgp_redistribute_bgp_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_bgp_route_map_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_connected_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_connected_metric_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_connected_redistribute_connected_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_connected_route_map_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_isis_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis': [u'level_2', u'level_1', u'level_1_2'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis': [u'level_2', u'level_1', u'level_1_2']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_isis_level_1_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_isis_level_1_2_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_isis_level_2_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_isis_metric_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_isis_route_map_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_match_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_match_external1_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_match_external2_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_match_internal_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_metric_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_redistribute_ospf_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_ospf_route_map_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_static_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_static_metric_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_static_redistribute_static_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_redistribute_static_route_map_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_rib_route_limit_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'num_as_in_path'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'num_as_in_path'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_static_network_get(self, af_vrf=None, static_network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type static_network: static_network_address
    :param static_network: Keyword argument tuple.

    :type static_network_address: unicode
    :param static_network_address: **static_network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_network', 'keyval': 'static_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, static_network=static_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, static_network=static_network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_static_network_distance_get(self, af_vrf=None, static_network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type static_network: static_network_address
    :param static_network: Keyword argument tuple.

    :type static_network_address: unicode
    :param static_network_address: **static_network** tuple argument:  A.B.C.D/M IP address in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.static_network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_network', 'keyval': 'static_network_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf, static_network=static_network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf, static_network=static_network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_table_map_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.table_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.table_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.table_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_table_map_route_map_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.table_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.table_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.table_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv4_unicast_vrf_update_time_get(self, af_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_vrf: af_vrf_name
    :param af_vrf: Keyword argument tuple.

    :type af_vrf_name: unicode
    :param af_vrf_name: **af_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.neighbor.af_ipv4_vrf_neighbor_address_holder', u'af_ipv4_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.af_vrf', u'aggregate_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vrf', 'keyval': 'af_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'num_as_in_path'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_ipv4_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'num_as_in_path'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'num_as_in_path'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv4_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'table_map_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vrf=af_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vrf=af_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'table_map_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'table_map_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_additional_paths_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'addpath_send, addpath_receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_additional_paths_addpath_txrx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_send, addpath_receive'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_additional_paths_receive_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_additional_paths_select_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_additional_paths_select_all_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_additional_paths_select_best_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_additional_paths_select_group_best_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_additional_paths_send_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_advertise_best_external_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_af_common_cmds_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}]
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder": {}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder": {"client_to_client_reflection": "client_to_client_reflection", "default_metric": "default_metric", "next_hop_enable_default": "next_hop_enable_default", "always_propagate": "always_propagate", "update_time": "update_time", "advertise_best_external": "advertise_best_external", "default_information_originate": "default_information_originate", "rib_route_limit": "rib_route_limit"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_af_ipv6_uc_and_vrf_cmds_call_point_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}]
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder": {}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder": {"bgp_redistribute_internal": "bgp_redistribute_internal"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder": {"bgp_redistribute_internal": "bgp_redistribute_internal"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_aggregate_address_get(self, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_aggregate_address_advertise_map_get(self, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_aggregate_address_as_set_get(self, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_aggregate_address_attribute_map_get(self, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_aggregate_address_summary_only_get(self, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_aggregate_address_suppress_map_get(self, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.aggregate_ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_always_propagate_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_bgp_redistribute_internal_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_client_to_client_reflection_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_dampening_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening': [u'dampening_flag', u'values', u'dampening_route_map'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening': [u'dampening_flag', u'values', u'dampening_route_map'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening': [u'dampening_flag', u'values', u'dampening_route_map']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_dampening_dampening_flag_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_dampening_half_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_dampening_max_suppress_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_dampening_reuse_value_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_dampening_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_dampening_start_suppress_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_dampening_values_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening.values': [u'half_time']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_default_information_originate_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_default_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_default_vrf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'table_map_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_default_vrf_selected_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'table_map_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_graceful_restart_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_graceful_restart_graceful_restart_status_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_graceful_restart_purge_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_graceful_restart_restart_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_graceful_restart_stale_routes_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_maximum_paths_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_maximum_paths_ebgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_maximum_paths_ibgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_maximum_paths_load_sharing_value_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_maximum_paths_use_load_sharing_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_multipath_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_multipath_ebgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_multipath_ibgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_multipath_multi_as_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.multipath', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'addpath_disable'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}]
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address": {"enable_peer_as_check": "enable_peer_as_check", "activate": "activate", "af_ipv6_neighbor_address": "af_ipv6_neighbor_address", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "route_reflector_client": "route_reflector_client"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address": {"enable_peer_as_check": "enable_peer_as_check", "activate": "activate", "af_ipv6_neighbor_address": "af_ipv6_neighbor_address", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "route_reflector_client": "route_reflector_client"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address": {"enable_peer_as_check": "enable_peer_as_check", "activate": "activate", "af_ipv6_neighbor_address": "af_ipv6_neighbor_address", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "route_reflector_client": "route_reflector_client"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_activate_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'addpath_disable'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_additional_paths_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths": {}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths": {"addpath_disable": "addpath_disable"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths": {"addpath_disable": "addpath_disable"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_additional_paths_addpath_txrx_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_send, addpath_receive'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_additional_paths_advertise_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all", "addpath_adv_groupbest": "addpath_adv_groupbest", "addpath_adv_best": "addpath_adv_best"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.advertise": {}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all", "addpath_adv_groupbest": "addpath_adv_groupbest", "addpath_adv_best": "addpath_adv_best"}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.advertise': [u'all', u'best']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_additional_paths_advertise_all_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.advertise": {"addpath_adv_all": "all"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_additional_paths_advertise_best_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_advertise": {"addpath_adv_best": "addpath_adv_best"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.advertise": {"addpath_adv_best": "best"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_advertise": {"addpath_adv_best": "addpath_adv_best"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_additional_paths_advertise_group_best_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_additional_paths_disable_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_additional_paths_receive_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_additional_paths_send_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_allowas_in_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'addpath_disable'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_additional_paths_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_additional_paths_add_path_both_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_additional_paths_receive_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_additional_paths_send_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_orf_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_orf_prefixlist_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_orf_prefixlist_prefixlist_status_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_orf_prefixlist_receive_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_capability_orf_prefixlist_send_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_default_originate_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_originate_status, default_originate_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_default_originate_default_originate_status_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_default_originate_route_map_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_enable_peer_as_check_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'addpath_disable'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_filter_list_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_filter_list_direction_in_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_filter_list_direction_out_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_filter_list_filter_list_direction_in_acl_name_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_filter_list_filter_list_direction_out_acl_name_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_filter_list_in_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_filter_list_out_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_prefix_limit'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_max_prefix_limit_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_teardown_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_threshold_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_maximum_prefix_threshold_holder_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_direction_in_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_direction_out_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_in_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_ip_access_number_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_ip_access_number_direction_out_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_out_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_prefix_list_direction_in_prefix_name_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_prefix_list_prefix_list_direction_out_prefix_name_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_map_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_map_in_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_map_in_neighbor_route_map_name_direction_in_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_map_out_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_map_out_neighbor_route_map_name_direction_out_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_route_reflector_client_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'addpath_disable'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_both_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_extended_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_send_community_status_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_send_community_standard_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_unsuppress_map_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.unsuppress_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.unsuppress_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.unsuppress_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_unsuppress_map_map_name_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'af_ipv6_neighbor_address')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.unsuppress_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.unsuppress_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.unsuppress_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_address_weight_get(self, af_ipv6_neighbor_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_address: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_address: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_address** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder.af_ipv6_neighbor_address.af_neighbor_capability.orf', u'prefixlist')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_address', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'addpath_disable'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_address=af_ipv6_neighbor_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'addpath_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'best, all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'map_name'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}]
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup": {"activate": "activate", "af_nei_weight": "af_nei_weight", "allowas_in": "allowas_in", "enable_peer_as_check": "enable_peer_as_check", "af_ipv6_neighbor_peergroup_name": "af_ipv6_neighbor_peergroup_name", "route_reflector_client": "route_reflector_client"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup": {"activate": "activate", "af_nei_weight": "af_nei_weight", "allowas_in": "allowas_in", "enable_peer_as_check": "enable_peer_as_check", "af_ipv6_neighbor_peergroup_name": "af_ipv6_neighbor_peergroup_name", "route_reflector_client": "route_reflector_client"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup": {"activate": "activate", "af_nei_weight": "af_nei_weight", "allowas_in": "allowas_in", "enable_peer_as_check": "enable_peer_as_check", "af_ipv6_neighbor_peergroup_name": "af_ipv6_neighbor_peergroup_name", "route_reflector_client": "route_reflector_client"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_activate_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'addpath_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'map_name'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_additional_paths_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths": {}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths": {"addpath_disable": "addpath_disable"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths": {"addpath_disable": "addpath_disable"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_additional_paths_addpath_txrx_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_send, addpath_receive'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_additional_paths_advertise_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all", "addpath_adv_groupbest": "addpath_adv_groupbest", "addpath_adv_best": "addpath_adv_best"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.advertise": {}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all", "addpath_adv_groupbest": "addpath_adv_groupbest", "addpath_adv_best": "addpath_adv_best"}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.advertise': [u'all', u'best']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_additional_paths_advertise_all_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.advertise": {"addpath_adv_all": "all"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_additional_paths_advertise_best_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_advertise": {"addpath_adv_best": "addpath_adv_best"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.advertise": {"addpath_adv_best": "best"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_advertise": {"addpath_adv_best": "addpath_adv_best"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_additional_paths_advertise_group_best_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_additional_paths_disable_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_additional_paths_receive_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_additional_paths_send_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_allowas_in_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'addpath_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'map_name'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_additional_paths_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_additional_paths_add_path_both_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_additional_paths_receive_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_additional_paths_send_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_orf_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_orf_prefixlist_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_orf_prefixlist_prefixlist_status_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_orf_prefixlist_receive_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_capability_orf_prefixlist_send_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_default_originate_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_originate_status, default_originate_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_default_originate_default_originate_status_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_default_originate_route_map_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_enable_peer_as_check_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'addpath_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'map_name'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_filter_list_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_filter_list_direction_in_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_filter_list_direction_out_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_filter_list_filter_list_direction_in_acl_name_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_filter_list_filter_list_direction_out_acl_name_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_filter_list_in_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_filter_list_out_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_prefix_limit'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_max_prefix_limit_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_teardown_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_threshold_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_maximum_prefix_threshold_holder_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_direction_in_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_direction_out_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_in_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_ip_access_number_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_ip_access_number_direction_out_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_out_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_prefix_list_direction_in_prefix_name_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_prefix_list_prefix_list_direction_out_prefix_name_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_map_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_map_in_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_map_in_neighbor_route_map_name_direction_in_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_map_out_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_map_out_neighbor_route_map_name_direction_out_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_route_reflector_client_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'addpath_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'map_name'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_both_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_extended_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_send_community_status_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_send_community_standard_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_unsuppress_map_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.unsuppress_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.unsuppress_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.unsuppress_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_unsuppress_map_map_name_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'af_ipv6_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.unsuppress_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.unsuppress_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.unsuppress_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_neighbor_af_ipv6_neighbor_peergroup_weight_get(self, af_ipv6_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_peergroup: af_ipv6_neighbor_peergroup_name
    :param af_ipv6_neighbor_peergroup: Keyword argument tuple.

    :type af_ipv6_neighbor_peergroup_name: unicode
    :param af_ipv6_neighbor_peergroup_name: **af_ipv6_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.af_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder.af_ipv6_neighbor_peergroup.prefix_list', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_peergroup', 'keyval': 'af_ipv6_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'map_name'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'addpath_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'map_name'}, {'leafval': 'threshold, teardown'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'best, all'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'map_name'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'threshold, teardown'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_neighbor_peergroup=af_ipv6_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_network_get(self, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_network_backdoor_get(self, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_network_route_map_get(self, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_network_weight_get(self, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_next_hop_enable_default_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_next_hop_recursion_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'table_map_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_bgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_bgp_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_bgp_redistribute_bgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_bgp_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_connected_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_connected_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_connected_redistribute_connected_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_connected_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_isis_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis': [u'level_2', u'level_1', u'level_1_2'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis': [u'level_2', u'level_1', u'level_1_2'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis': [u'level_2', u'level_1', u'level_1_2']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_isis_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_isis_level_1_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_isis_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_isis_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_isis_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_ospf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_ospf_match_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_ospf_match_external1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_ospf_match_external2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_ospf_match_internal_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_ospf_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_ospf_redistribute_ospf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_ospf_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_static_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_static_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_static_redistribute_static_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_redistribute_static_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_rib_route_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_table_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_table_map_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.table_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_update_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'table_map_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}]
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf": {}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf": {}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf": {"client_to_client_reflection": "client_to_client_reflection", "advertise_best_external": "advertise_best_external", "default_metric": "default_metric", "next_hop_enable_default": "next_hop_enable_default", "always_propagate": "always_propagate", "update_time": "update_time", "graceful_restart_status": "graceful_restart_status", "default_information_originate": "default_information_originate", "af_ipv6_vrf_name": "af_ipv6_vrf_name", "next_hop_recursion": "next_hop_recursion", "rib_route_limit": "rib_route_limit"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_additional_paths_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_additional_paths_addpath_txrx_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_send, addpath_receive'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_additional_paths_receive_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_additional_paths_select_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths.addpath_select', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_additional_paths_select_all_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths.addpath_select', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_additional_paths_select_best_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths.addpath_select', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_additional_paths_select_group_best_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths.addpath_select', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_select', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_additional_paths_send_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_advertise_best_external_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values')]
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}]
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder": {}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf": {"advertise_best_external": "advertise_best_external", "af_ipv6_vrf_name": "af_ipv6_vrf_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_get(self, af_ipv6_vrf=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_advertise_map_get(self, af_ipv6_vrf=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_as_set_get(self, af_ipv6_vrf=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_attribute_map_get(self, af_ipv6_vrf=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_summary_only_get(self, af_ipv6_vrf=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_aggregate_address_suppress_map_get(self, af_ipv6_vrf=None, aggregate_ipv6_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type aggregate_ipv6_address: aggregate_ip_prefix
    :param aggregate_ipv6_address: Keyword argument tuple.

    :type aggregate_ip_prefix: unicode
    :param aggregate_ip_prefix: **aggregate_ipv6_address** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.aggregate_ipv6_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'aggregate_ipv6_address', 'keyval': 'aggregate_ip_prefix', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, aggregate_ipv6_address=aggregate_ipv6_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_always_propagate_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_bgp_redistribute_internal_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_client_to_client_reflection_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_dampening_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening': [u'dampening_flag', u'values', u'dampening_route_map'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening': [u'dampening_flag', u'values', u'dampening_route_map'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening': [u'dampening_flag', u'values', u'dampening_route_map']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_dampening_dampening_flag_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_dampening_half_time_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_dampening_max_suppress_time_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_dampening_reuse_value_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_dampening_route_map_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_dampening_start_suppress_time_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_dampening_values_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values': [u'half_time'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values': [u'half_time'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening.values': [u'half_time']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_default_information_originate_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_default_metric_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_graceful_restart_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_ebgp_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_ibgp_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_load_sharing_value_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_maximum_paths_use_load_sharing_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.maximum_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_multipath_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_multipath_ebgp_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_multipath_ibgp_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_multipath_multi_as_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.multipath', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'value'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr": {"static_network_edge": "static_network_edge", "activate": "activate", "remote_as": "remote_as", "associate_peer_group": "associate_peer_group", "af_ipv6_neighbor_address": "af_ipv6_neighbor_address", "enable_peer_as_check": "enable_peer_as_check", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "route_reflector_client": "route_reflector_client", "ebgp_btsh": "ebgp_btsh", "remove_private_as": "remove_private_as", "password": "password", "as_override": "as_override", "description": "description"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr": {"static_network_edge": "static_network_edge", "activate": "activate", "remote_as": "remote_as", "associate_peer_group": "associate_peer_group", "af_ipv6_neighbor_address": "af_ipv6_neighbor_address", "enable_peer_as_check": "enable_peer_as_check", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "route_reflector_client": "route_reflector_client", "ebgp_btsh": "ebgp_btsh", "remove_private_as": "remove_private_as", "password": "password", "as_override": "as_override", "description": "description"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr": {"static_network_edge": "static_network_edge", "activate": "activate", "remote_as": "remote_as", "associate_peer_group": "associate_peer_group", "af_ipv6_neighbor_address": "af_ipv6_neighbor_address", "enable_peer_as_check": "enable_peer_as_check", "allowas_in": "allowas_in", "af_nei_weight": "af_nei_weight", "route_reflector_client": "route_reflector_client", "ebgp_btsh": "ebgp_btsh", "remove_private_as": "remove_private_as", "password": "password", "as_override": "as_override", "description": "description"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_activate_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'value'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_additional_paths_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths": {"addpath_disable": "addpath_disable"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths": {}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths": {"addpath_disable": "addpath_disable"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_additional_paths_addpath_txrx_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_send, addpath_receive'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_additional_paths_advertise_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all", "addpath_adv_groupbest": "addpath_adv_groupbest", "addpath_adv_best": "addpath_adv_best"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all", "addpath_adv_groupbest": "addpath_adv_groupbest", "addpath_adv_best": "addpath_adv_best"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.advertise": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.advertise': [u'all', u'best']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_additional_paths_advertise_all_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_advertise": {"addpath_adv_all": "addpath_adv_all"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.advertise": {"addpath_adv_all": "all"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_additional_paths_advertise_best_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.advertise', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_advertise": {"addpath_adv_best": "addpath_adv_best"}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_advertise": {"addpath_adv_best": "addpath_adv_best"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.advertise": {"addpath_adv_best": "best"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_additional_paths_advertise_group_best_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_advertise', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_advertise', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_additional_paths_disable_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_additional_paths_receive_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_additional_paths_send_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_txrx', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths.addpath_txrx', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_advertisement_interval_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_advertisement_interval_value_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.advertisement_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_allowas_in_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'value'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_as_override_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'value'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_bfd_enable_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_holdover_interval_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_interval_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_interval_min_rx_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_interval_min_tx_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_bfd_interval_multiplier_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_additional_paths_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_additional_paths_add_path_both_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_additional_paths_receive_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_additional_paths_send_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.additional_paths', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_as4_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_as4_disable_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_as4_enable_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.as4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_orf_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_orf_prefixlist_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_orf_prefixlist_prefixlist_status_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_orf_prefixlist_receive_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_capability_orf_prefixlist_send_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf.prefixlist', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_default_originate_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'default_originate_status, default_originate_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_default_originate_default_originate_status_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_default_originate_route_map_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.default_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_description_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'value'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_ebgp_btsh_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'value'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_ebgp_multihop_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_ebgp_multihop_ebgp_multihop_count_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_ebgp_multihop_ebgp_multihop_flag_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.ebgp_multihop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_enable_peer_as_check_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'value'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_enforce_first_as_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_enforce_first_as_disable_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_enforce_first_as_enable_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.enforce_first_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_filter_list_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_filter_list_direction_in_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_filter_list_direction_out_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_filter_list_filter_list_direction_in_acl_name_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_filter_list_filter_list_direction_out_acl_name_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_filter_list_in_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_filter_list_out_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_local_as_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_local_as_local_as_value_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_local_as_no_prepend_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.local_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maxas_limit_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maxas_limit_in_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'num_as_in_as_path, maxas_limit_disable'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maxas_limit_in_disable_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maxas_limit_in_num_as_in_as_path_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'max_prefix_limit'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_max_prefix_limit_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_teardown_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_threshold_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_maximum_prefix_threshold_holder_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix.threshold_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'threshold, teardown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_next_hop_self_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_next_hop_self_always_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_next_hop_self_next_hop_self_status_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.next_hop_self', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_password_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'value'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_peer_group_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'value'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_direction_in_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_direction_out_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_in_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_ip_access_number_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_ip_access_number_direction_out_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_out_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_prefix_list_direction_in_prefix_name_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_prefix_list_prefix_list_direction_out_prefix_name_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_remote_as_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'value'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_remove_private_as_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'value'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_map_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_map_in_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_map_in_neighbor_route_map_name_direction_in_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_map_out_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_map_out_neighbor_route_map_name_direction_out_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_route_reflector_client_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'value'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_both_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_extended_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_send_community_status_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_send_community_standard_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_shutdown_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'shutdown_status, generate_rib_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_shutdown_generate_rib_out_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_shutdown_shutdown_status_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.shutdown', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_soft_reconfiguration_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_soft_reconfiguration_inbound_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_static_network_edge_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'value'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_timers_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'nei_keep_alive, nei_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_timers_hold_time_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_timers_keep_alive_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_unsuppress_map_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.unsuppress_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.unsuppress_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.unsuppress_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_unsuppress_map_map_name_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.unsuppress_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.unsuppress_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.unsuppress_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source": {"sip_ipv6_address": "sip_ipv6_address", "ve_interface": "ve_interface", "loopback": "loopback"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source": {"sip_ipv6_address": "sip_ipv6_address", "ve_interface": "ve_interface", "loopback": "loopback"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source': [u'ethernet_interface', u'sip_ipv6_address', u've_interface', u'loopback'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source': [u'ethernet_interface', u'sip_ipv6_address', u've_interface', u'loopback'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source': [u'ethernet_interface', u'sip_ipv6_address', u've_interface', u'port_channel', u'loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_ethernet_interface_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_interface_name_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_interface_type_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_loopback_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_port_channel_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_sip_ipv6_address_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_update_source_ve_interface_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'af_ipv6_neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_neighbor_addr_weight_get(self, af_ipv6_vrf=None, af_ipv6_neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_neighbor_addr: af_ipv6_neighbor_address
    :param af_ipv6_neighbor_addr: Keyword argument tuple.

    :type af_ipv6_neighbor_address: unicode
    :param af_ipv6_neighbor_address: **af_ipv6_neighbor_addr** tuple argument:  A:B::C:D;;Neighbor Ipv6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'additional_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'advertise'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'maximum_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'unsuppress_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'default_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'additional_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.maximum_prefix', u'threshold_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.additional_paths', u'addpath_advertise'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr.af_vrf_neighbor_capability.orf', u'prefixlist'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder.af_ipv6_neighbor_addr', u'shutdown')]
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_neighbor_addr', 'keyval': 'af_ipv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'inbound'}, {'leafval': 'addpath_disable'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'map_name'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'threshold, teardown'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'add_path_both, send, receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'best, all'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'value'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'max_prefix_limit'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'map_name'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'value'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'default_originate_status, default_originate_route_map'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'addpath_disable'}, {'leafval': 'inbound'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'threshold, teardown'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'addpath_adv_best, addpath_adv_groupbest, addpath_adv_all'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, af_ipv6_neighbor_addr=af_ipv6_neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_neighbor_af_ipv6_vrf_neighbor_address_holder_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_network_get(self, af_ipv6_vrf=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_network_backdoor_get(self, af_ipv6_vrf=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_network_route_map_get(self, af_ipv6_vrf=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_network_weight_get(self, af_ipv6_vrf=None, network=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    **Instance Keyword Argument Tuple**:

    :type network: network_ipv6_address
    :param network: Keyword argument tuple.

    :type network_ipv6_address: unicode
    :param network_ipv6_address: **network** tuple argument:  A:B::C:D/M IPV6 address in dotted decimal/Mask

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.network', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'network', 'keyval': 'network_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf, network=network)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf, network=network)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_next_hop_enable_default_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_next_hop_recursion_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_bgp_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_bgp_metric_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_bgp_redistribute_bgp_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_bgp_route_map_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_connected_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_connected_metric_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_connected_redistribute_connected_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_connected_route_map_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_isis_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis': [u'level_2', u'level_1', u'level_1_2'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis': [u'level_2', u'level_1', u'level_1_2']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_isis_level_1_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_isis_level_1_2_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_isis_level_2_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_isis_metric_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_isis_route_map_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.redistribute_isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_match_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_match_external1_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_match_external2_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_match_internal_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_metric_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_redistribute_ospf_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_ospf_route_map_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_static_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_static_metric_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_static_redistribute_static_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_redistribute_static_route_map_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_rib_route_limit_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_table_map_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.table_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.table_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.table_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_table_map_route_map_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.table_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.table_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.table_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}, {'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_ipv6_unicast_vrf_update_time_get(self, af_ipv6_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type af_ipv6_vrf: af_ipv6_vrf_name
    :param af_ipv6_vrf: Keyword argument tuple.

    :type af_ipv6_vrf_name: unicode
    :param af_ipv6_vrf_name: **af_ipv6_vrf** tuple argument:  VRF name

        * length restriction: ::

            ['1..255']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf.neighbor.af_ipv6_vrf_neighbor_address_holder', u'af_ipv6_neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.af_ipv6_vrf', u'maximum_paths')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_ipv6_vrf', 'keyval': 'af_ipv6_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_neighbor_address, associate_peer_group, remote_as, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'af_ipv6_neighbor_address, remote_as, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge, activate'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_ipv6_vrf=af_ipv6_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_ipv6_vrf=af_ipv6_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.suppress', u'ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'host_route'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.suppress', u'ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'host_route'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_client_to_client_reflection_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.suppress', u'ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'host_route'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_graceful_restart_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_graceful_restart_graceful_restart_status_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_graceful_restart_purge_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_graceful_restart_restart_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_graceful_restart_stale_routes_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_activate_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_allowas_in_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_enable_peer_as_check_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_encapsulation_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_maximum_prefix_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_next_hop_unchanged_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_route_map_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_route_map_in_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_route_map_in_route_map_name_direction_in_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_route_map_out_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_route_map_out_route_map_name_direction_out_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_route_reflector_client_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv4', 'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_send_community_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_send_community_both_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_send_community_extended_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_send_community_send_community_status_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv4_send_community_standard_get(self, evpn_neighbor_ipv4=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv4: evpn_neighbor_ipv4_address
    :param evpn_neighbor_ipv4: Keyword argument tuple.

    :type evpn_neighbor_ipv4_address: unicode
    :param evpn_neighbor_ipv4_address: **evpn_neighbor_ipv4** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4', u'evpn_neighbor_ipv4')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv4.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv4_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv4=evpn_neighbor_ipv4)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_activate_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_allowas_in_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_enable_peer_as_check_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_encapsulation_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_maximum_prefix_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_next_hop_unchanged_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_route_map_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_route_map_in_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_route_map_in_route_map_name_direction_in_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_route_map_out_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_route_map_out_route_map_name_direction_out_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_route_reflector_client_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_neighbor_ipv6', 'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_out'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_send_community_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_send_community_both_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_send_community_extended_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_send_community_send_community_status_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_neighbor_ipv6_send_community_standard_get(self, evpn_neighbor_ipv6=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_neighbor_ipv6: evpn_neighbor_ipv6_address
    :param evpn_neighbor_ipv6: Keyword argument tuple.

    :type evpn_neighbor_ipv6_address: unicode
    :param evpn_neighbor_ipv6_address: **evpn_neighbor_ipv6** tuple argument:  A:B::C:D;;Neighbor Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6', u'evpn_neighbor_ipv6')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_neighbor_ipv6.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_neighbor_ipv6=evpn_neighbor_ipv6)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_activate_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_allowas_in_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_enable_peer_as_check_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_encapsulation_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_maximum_prefix_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_next_hop_unchanged_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_route_map_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_route_map_in_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_route_map_in_route_map_name_direction_in_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_route_map_out_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_route_map_out_route_map_name_direction_out_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_route_reflector_client_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.route_map', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'evpn_peer_group', 'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'route_map_name_direction_in'}, {'leafval': 'route_map_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_send_community_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_send_community_both_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_send_community_extended_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_send_community_send_community_status_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_neighbor_evpn_peer_group_send_community_standard_get(self, evpn_peer_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type evpn_peer_group: evpn_neighbor_peergroup_name
    :param evpn_peer_group: Keyword argument tuple.

    :type evpn_neighbor_peergroup_name: unicode
    :param evpn_neighbor_peergroup_name: **evpn_peer_group** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group', u'evpn_peer_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor.evpn_peer_group.send_community', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}, {'keyval': 'evpn_neighbor_peergroup_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, evpn_peer_group=evpn_peer_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, evpn_peer_group=evpn_peer_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_retain_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'all'}, {'leafval': 'all'}, {'leafval': 'all'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_retain_route_target_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain.route_target', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain.route_target', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain.route_target', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_retain_route_target_all_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain.route_target', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain.route_target', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain.route_target', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_suppress_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.suppress', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.suppress', u'ipv4')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'host_route'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_suppress_ipv4_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.suppress.ipv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_suppress_ipv4_host_route_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.suppress.ipv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_l2vpn_evpn_vtep_discovery_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.suppress', u'ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'host_route'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4', u'vpnv4_unicast'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4', u'vpnv4_unicast'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_af_vpn_neighbor_peergroup_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_af_vpnv4_neighbor_address_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_export_vrf_leaked_routes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_in')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vpn_neighbor_peergroup', 'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_activate_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_in')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vpn_neighbor_peergroup', 'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_activate_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', u'extended_community')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vpnv4_neighbor', 'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', u'extended_community')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vpnv4_neighbor', 'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_af_neighbor_capability_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_orf_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_orf_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_orf_extended_community_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_orf_extended_community_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_orf_extended_community_receive_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_orf_extended_community_receive_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_orf_extended_community_send_vrf_filter_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_orf_extended_community_send_vrf_filter_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_orf_prefix_list_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_orf_prefix_list_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_orf_prefix_list_prefixlist_status_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_orf_prefix_list_prefixlist_status_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_orf_prefix_list_receive_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_orf_prefix_list_receive_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_orf_prefix_list_send_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_capability_orf_prefix_list_send_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_filter_list_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_filter_list_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_filter_list_direction_in_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_filter_list_direction_out_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_filter_list_filter_list_direction_in_acl_name_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_filter_list_filter_list_direction_in_acl_name_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_filter_list_filter_list_direction_out_acl_name_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_filter_list_filter_list_direction_out_acl_name_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_filter_list_in_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_filter_list_in_direction_in_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_filter_list_out_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_filter_list_out_direction_out_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_prefix_list_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_prefix_list_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_prefix_list_direction_in_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_prefix_list_direction_out_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_prefix_list_in_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_prefix_list_in_direction_in_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_prefix_list_ip_access_number_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_prefix_list_ip_access_number_direction_in_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_prefix_list_ip_access_number_direction_out_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_prefix_list_out_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_prefix_list_out_direction_out_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_route_map_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_route_map_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_route_map_in_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_route_map_in_neighbor_route_map_direction_in_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_route_map_in_neighbor_route_map_name_direction_in_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_route_map_in_neighbor_route_map_name_direction_in_neighbor_route_map_direction_in_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_route_map_out_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_route_map_out_neighbor_route_map_direction_out_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_route_map_out_neighbor_route_map_name_direction_out_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_route_map_out_neighbor_route_map_name_direction_out_neighbor_route_map_direction_out_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_route_reflector_client_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_in')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vpn_neighbor_peergroup', 'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_route_reflector_client_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', u'extended_community')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vpnv4_neighbor', 'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_send_community_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_send_community_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_send_community_both_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_send_community_both_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_send_community_extended_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_send_community_extended_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_send_community_send_community_status_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_send_community_send_community_status_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_send_community_standard_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_send_community_standard_af_vpnv4_neighbor_address_holder_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'af_vpnv4_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_weight_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_in')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vpn_neighbor_peergroup', 'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_neighbor_weight_af_vpnv4_neighbor_get(self, af_vpnv4_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vpnv4_neighbor: af_vpnv4_neighbor_address
    :param af_vpnv4_neighbor: Keyword argument tuple.

    :type af_vpnv4_neighbor_address: unicode
    :param af_vpnv4_neighbor_address: **af_vpnv4_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder.af_vpnv4_neighbor.af_neighbor_capability.orf', u'extended_community')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vpnv4_neighbor', 'keyval': 'af_vpnv4_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv4_neighbor=af_vpnv4_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv4_neighbor=af_vpnv4_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv4_unicast_rr_group_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6', u'vpnv6_unicast'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6', u'vpnv6_unicast'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_af_vpn_neighbor_peergroup_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_af_vpnv6_neighbor_address_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_export_vrf_leaked_routes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vpn_neighbor_peergroup', 'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_activate_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vpn_neighbor_peergroup', 'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_activate_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vpnv6_neighbor', 'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vpnv6_neighbor', 'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_af_neighbor_capability_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_orf_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_orf_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_orf_extended_community_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_orf_extended_community_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_orf_extended_community_receive_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_orf_extended_community_receive_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_orf_extended_community_send_vrf_filter_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_orf_extended_community_send_vrf_filter_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf.extended_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_orf_prefix_list_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_orf_prefix_list_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_orf_prefix_list_prefixlist_status_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_orf_prefix_list_prefixlist_status_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_orf_prefix_list_receive_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_orf_prefix_list_receive_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_orf_prefix_list_send_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_capability_orf_prefix_list_send_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_filter_list_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_filter_list_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_filter_list_direction_in_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_filter_list_direction_out_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_filter_list_filter_list_direction_in_acl_name_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_filter_list_filter_list_direction_in_acl_name_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_filter_list_filter_list_direction_out_acl_name_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_filter_list_filter_list_direction_out_acl_name_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_filter_list_in_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_filter_list_in_direction_in_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_filter_list_out_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_filter_list_out_direction_out_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_prefix_list_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_prefix_list_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_prefix_list_direction_in_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_prefix_list_direction_out_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_prefix_list_in_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_prefix_list_in_direction_in_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_prefix_list_ip_access_number_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_prefix_list_ip_access_number_direction_in_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_prefix_list_ip_access_number_direction_out_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_prefix_list_out_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_prefix_list_out_direction_out_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_route_map_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_route_map_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_route_map_in_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_route_map_in_neighbor_route_map_direction_in_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_route_map_in_neighbor_route_map_name_direction_in_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_route_map_in_neighbor_route_map_name_direction_in_neighbor_route_map_direction_in_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map.neighbor_route_map_direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_route_map_out_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_route_map_out_neighbor_route_map_direction_out_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_route_map_out_neighbor_route_map_name_direction_out_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_route_map_out_neighbor_route_map_name_direction_out_neighbor_route_map_direction_out_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map.neighbor_route_map_direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_route_reflector_client_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vpn_neighbor_peergroup', 'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_route_reflector_client_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vpnv6_neighbor', 'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_send_community_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_send_community_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_send_community_both_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_send_community_both_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_send_community_extended_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_send_community_extended_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_send_community_send_community_status_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_send_community_send_community_status_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_send_community_standard_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'af_vpn_neighbor_peergroup')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}, {'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_send_community_standard_af_vpnv6_neighbor_address_holder_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'af_vpnv6_neighbor')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.send_community', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.send_community', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}, {'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_weight_get(self, af_vpn_neighbor_peergroup=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vpn_neighbor_peergroup: af_vpn_neighbor_peergroup_address
    :param af_vpn_neighbor_peergroup: Keyword argument tuple.

    :type af_vpn_neighbor_peergroup_address: unicode
    :param af_vpn_neighbor_peergroup_address: **af_vpn_neighbor_peergroup** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder.af_vpn_neighbor_peergroup.filter_list', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vpn_neighbor_peergroup', 'keyval': 'af_vpn_neighbor_peergroup_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpn_neighbor_peergroup=af_vpn_neighbor_peergroup)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_neighbor_weight_af_vpnv6_neighbor_get(self, af_vpnv6_neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type af_vpnv6_neighbor: af_vpnv6_neighbor_address
    :param af_vpnv6_neighbor: Keyword argument tuple.

    :type af_vpnv6_neighbor_address: unicode
    :param af_vpnv6_neighbor_address: **af_vpnv6_neighbor** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'send_community'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', u'neighbor_route_map_direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor', u'send_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', u'prefix_list'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.af_neighbor_capability.orf', u'extended_community'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.neighbor_route_map', u'neighbor_route_map_direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder.af_vpnv6_neighbor.filter_list', u'direction_out')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'af_vpnv6_neighbor', 'keyval': 'af_vpnv6_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'neighbor_route_map_name_direction_out'}, {'leafval': 'send_community_status, both, extended, standard'}, {'leafval': 'filter_list_direction_in_acl_name, filter_list_name_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'prefixlist_status, prefixlist_send, prefixlist_receive'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'ext_community_receive, ext_community_send_vrf'}, {'leafval': 'neighbor_route_map_name_direction_in'}, {'leafval': 'filter_list_direction_out_acl_name, filter_list_name_direction_out'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, af_vpnv6_neighbor=af_vpnv6_neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, af_vpnv6_neighbor=af_vpnv6_neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_address_family_vpnv6_unicast_rr_group_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_always_compare_med_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keep_alive, hold_time'}, {'leafval': 'identifier'}, {'leafval': 'as4_enable'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'holdover_interval'}, {'leafval': 'holdover_interval'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'num_as_in_path'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'holdover_interval'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_as_path_ignore_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keep_alive, hold_time'}, {'leafval': 'identifier'}, {'leafval': 'as4_enable'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'holdover_interval'}, {'leafval': 'holdover_interval'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'num_as_in_path'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'holdover_interval'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_auto_shutdown_new_neighbors_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keep_alive, hold_time'}, {'leafval': 'identifier'}, {'leafval': 'as4_enable'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'holdover_interval'}, {'leafval': 'holdover_interval'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'num_as_in_path'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'holdover_interval'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_bfd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'min_tx, min_rx, multiplier'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_bfd_holdover_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'min_tx, min_rx, multiplier'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_bfd_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_bfd_interval_min_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_bfd_interval_min_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_bfd_interval_multiplier_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_capability_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.capability', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.capability', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.capability', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_capability_as4_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.capability', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.capability', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.capability', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_cluster_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.cluster_id': [u'cluster_id_value', u'cluster_id_ipv4_address'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.cluster_id': [u'cluster_id_value', u'cluster_id_ipv4_address'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.cluster_id': [u'cluster_id_value', u'cluster_id_ipv4_address']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_cluster_id_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_cluster_id_ipv4_address_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.cluster_id', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_compare_med_empty_aspath_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keep_alive, hold_time'}, {'leafval': 'identifier'}, {'leafval': 'as4_enable'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'holdover_interval'}, {'leafval': 'holdover_interval'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'num_as_in_path'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'holdover_interval'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_compare_routerid_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keep_alive, hold_time'}, {'leafval': 'identifier'}, {'leafval': 'as4_enable'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'holdover_interval'}, {'leafval': 'holdover_interval'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'num_as_in_path'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'holdover_interval'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_confederation_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.confederation', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.confederation', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.confederation', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_confederation_identifier_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.confederation', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.confederation', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.confederation', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_default_local_preference_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keep_alive, hold_time'}, {'leafval': 'identifier'}, {'leafval': 'as4_enable'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'holdover_interval'}, {'leafval': 'holdover_interval'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'num_as_in_path'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'holdover_interval'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_distance_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.distance', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.distance', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.distance', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ext_route_distance, int_route_distance, lcl_route_distance'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_distance_ext_route_distance_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.distance', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.distance', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.distance', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_distance_int_route_distance_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.distance', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.distance', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.distance', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_distance_lcl_route_distance_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.distance', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.distance', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.distance', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_enforce_first_as_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keep_alive, hold_time'}, {'leafval': 'identifier'}, {'leafval': 'as4_enable'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'holdover_interval'}, {'leafval': 'holdover_interval'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'num_as_in_path'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'holdover_interval'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_fast_external_fallover_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keep_alive, hold_time'}, {'leafval': 'identifier'}, {'leafval': 'as4_enable'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'holdover_interval'}, {'leafval': 'holdover_interval'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'num_as_in_path'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'holdover_interval'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_install_igp_cost_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keep_alive, hold_time'}, {'leafval': 'identifier'}, {'leafval': 'as4_enable'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'holdover_interval'}, {'leafval': 'holdover_interval'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'num_as_in_path'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'holdover_interval'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_local_as_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keep_alive, hold_time'}, {'leafval': 'identifier'}, {'leafval': 'as4_enable'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'holdover_interval'}, {'leafval': 'holdover_interval'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'num_as_in_path'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'holdover_interval'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_log_dampening_debug_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keep_alive, hold_time'}, {'leafval': 'identifier'}, {'leafval': 'as4_enable'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'holdover_interval'}, {'leafval': 'holdover_interval'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'num_as_in_path'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'holdover_interval'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_maxas_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_path'}, {'leafval': 'num_as_in_path'}, {'leafval': 'num_as_in_path'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_maxas_limit_in_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_maxas_limit_in_num_as_in_path_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_med_missing_as_worst_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keep_alive, hold_time'}, {'leafval': 'identifier'}, {'leafval': 'as4_enable'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'holdover_interval'}, {'leafval': 'holdover_interval'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'num_as_in_path'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'holdover_interval'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_advertisement_interval_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_advertisement_interval_value_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.advertisement_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_as_override_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_bfd_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_bfd_bfd_enable_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_bfd_holdover_interval_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_bfd_interval_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_bfd_interval_min_rx_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_bfd_interval_min_tx_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_bfd_interval_multiplier_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_capability_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_capability_as4_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_capability_as4_disable_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_capability_as4_enable_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability.as4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_description_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_ebgp_btsh_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_ebgp_multihop_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_ebgp_multihop_ebgp_multihop_count_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_ebgp_multihop_ebgp_multihop_flag_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.ebgp_multihop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_enforce_first_as_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_enforce_first_as_disable_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_enforce_first_as_enable_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.enforce_first_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_local_as_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_local_as_local_as_value_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_local_as_no_prepend_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.local_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_maxas_limit_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_maxas_limit_in_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'num_as_in_as_path, maxas_limit_disable'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_maxas_limit_in_disable_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_maxas_limit_in_num_as_in_as_path_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_next_hop_self_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_next_hop_self_always_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_next_hop_self_next_hop_self_status_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.next_hop_self', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_password_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_peer_group_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_remote_as_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_remove_private_as_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_shutdown_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'shutdown_status, generate_rib_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_shutdown_generate_rib_out_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_shutdown_shutdown_status_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.shutdown', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_soft_reconfiguration_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_soft_reconfiguration_inbound_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.soft_reconfiguration', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_static_network_edge_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'next_hop_self')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_addr', 'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'inbound'}, {'leafval': 'inbound'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_timers_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'nei_keep_alive, nei_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_timers_hold_time_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_timers_keep_alive_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_update_source_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source": {"ve_interface": "ve_interface", "sip_ipv4_address": "sip_ipv4_address", "loopback": "loopback"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source": {"ve_interface": "ve_interface", "sip_ipv4_address": "sip_ipv4_address", "loopback": "loopback"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source': [u'ethernet_interface', u've_interface', u'sip_ipv4_address', u'loopback'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source': [u'ethernet_interface', u've_interface', u'sip_ipv4_address', u'loopback'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source': [u'ethernet_interface', u've_interface', u'loopback', u'sip_ipv4_address', u'port_channel']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_update_source_ethernet_interface_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_update_source_interface_name_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_update_source_interface_type_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source.ethernet_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_update_source_loopback_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_update_source_port_channel_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_update_source_sip_ipv4_address_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_addr_update_source_ve_interface_get(self, neighbor_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_addr: router_bgp_neighbor_address
    :param neighbor_addr: Keyword argument tuple.

    :type router_bgp_neighbor_address: unicode
    :param router_bgp_neighbor_address: **neighbor_addr** tuple argument:  A.B.C.D;;Neighbor Address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr', u'neighbor_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips.neighbor_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_addr=neighbor_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_addr=neighbor_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ips_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'value'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_advertisement_interval_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_advertisement_interval_value_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.advertisement_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_as_override_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'value'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_bfd_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_bfd_bfd_enable_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_bfd_holdover_interval_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_bfd_interval_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_bfd_interval_min_rx_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_bfd_interval_min_tx_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_bfd_interval_multiplier_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_capability_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_capability_as4_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_capability_as4_disable_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_capability_as4_enable_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability.as4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_description_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'value'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_ebgp_btsh_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'value'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_ebgp_multihop_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_ebgp_multihop_ebgp_multihop_count_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_ebgp_multihop_ebgp_multihop_flag_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.ebgp_multihop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_enforce_first_as_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_enforce_first_as_disable_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_enforce_first_as_enable_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.enforce_first_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_local_as_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_local_as_local_as_value_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_local_as_no_prepend_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.local_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_maxas_limit_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_maxas_limit_in_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'num_as_in_as_path, maxas_limit_disable'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_maxas_limit_in_disable_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_maxas_limit_in_num_as_in_as_path_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_next_hop_self_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_next_hop_self_always_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_next_hop_self_next_hop_self_status_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.next_hop_self', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_password_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'value'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_peer_group_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'value'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_remote_as_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'value'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_remove_private_as_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'value'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_shutdown_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'shutdown_status, generate_rib_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_shutdown_generate_rib_out_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_shutdown_shutdown_status_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.shutdown', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_soft_reconfiguration_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.soft_reconfiguration', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.soft_reconfiguration', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.soft_reconfiguration', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_soft_reconfiguration_inbound_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.soft_reconfiguration', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.soft_reconfiguration', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.soft_reconfiguration', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_static_network_edge_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'shutdown'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'bfd')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_ipv6_addr', 'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'value'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'inbound'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv6_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'sip_ipv6_address, port_channel, loopback, ve_interface'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'bfd_enable, holdover_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_timers_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'nei_keep_alive, nei_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_timers_hold_time_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_timers_keep_alive_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_update_source_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source": {"sip_ipv6_address": "sip_ipv6_address", "ve_interface": "ve_interface", "loopback": "loopback"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source": {"sip_ipv6_address": "sip_ipv6_address", "ve_interface": "ve_interface", "loopback": "loopback"}, "pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source': [u'ethernet_interface', u'sip_ipv6_address', u've_interface', u'loopback'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source': [u'ethernet_interface', u'sip_ipv6_address', u've_interface', u'loopback'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source': [u'ethernet_interface', u'sip_ipv6_address', u've_interface', u'port_channel', u'loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_update_source_ethernet_interface_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface': [u'interface_type'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_update_source_interface_name_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_update_source_interface_type_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source.ethernet_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_update_source_loopback_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_update_source_port_channel_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_update_source_sip_ipv6_address_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6_addr_update_source_ve_interface_get(self, neighbor_ipv6_addr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_ipv6_addr: router_bgp_neighbor_ipv6_address
    :param neighbor_ipv6_addr: Keyword argument tuple.

    :type router_bgp_neighbor_ipv6_address: unicode
    :param router_bgp_neighbor_ipv6_address: **neighbor_ipv6_addr** tuple argument:  A:B::C:D;;Neighbor IPV6 Address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr', u'neighbor_ipv6_addr')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s.neighbor_ipv6_addr.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_ipv6_address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_ipv6_addr=neighbor_ipv6_addr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_ipv6_addr=neighbor_ipv6_addr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_ipv6s_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_advertisement_interval_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_advertisement_interval_value_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.advertisement_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_as_override_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_bfd_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_bfd_bfd_enable_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_bfd_holdover_interval_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_bfd_interval_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_bfd_interval_min_rx_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_bfd_interval_min_tx_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_bfd_interval_multiplier_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd.interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_capability_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_capability_as4_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_capability_as4_disable_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_capability_as4_enable_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability.as4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_description_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_ebgp_btsh_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_ebgp_multihop_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop': [u'ebgp_multihop_flag', u'ebgp_multihop_count']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_ebgp_multihop_ebgp_multihop_count_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_ebgp_multihop_ebgp_multihop_flag_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.ebgp_multihop', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_enforce_first_as_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_enforce_first_as_disable_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_enforce_first_as_enable_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.enforce_first_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_local_as_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'local_as_value, no_prepend'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_local_as_local_as_value_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_local_as_no_prepend_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.local_as', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_maxas_limit_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_maxas_limit_in_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'num_as_in_as_path, maxas_limit_disable'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable'], 'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_': [u'num_as_in_as_path', u'maxas_limit_disable']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_maxas_limit_in_disable_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_maxas_limit_in_num_as_in_as_path_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit.in_', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_next_hop_self_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self': [u'next_hop_self_always', u'next_hop_self_status']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_next_hop_self_always_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_next_hop_self_next_hop_self_status_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.next_hop_self', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_password_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_peer_group_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_remote_as_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_remove_private_as_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_shutdown_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'shutdown_status, generate_rib_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_shutdown_generate_rib_out_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_shutdown_shutdown_status_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.shutdown', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_soft_reconfiguration_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.soft_reconfiguration', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.soft_reconfiguration', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.soft_reconfiguration', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_soft_reconfiguration_inbound_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.soft_reconfiguration', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.soft_reconfiguration', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.soft_reconfiguration', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_static_network_edge_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'ebgp_multihop'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'update_source'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'next_hop_self'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.af_neighbor_capability', u'as4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'local_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'soft_reconfiguration'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'advertisement_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'enforce_first_as'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', u'ethernet_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'shutdown'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.maxas_limit', u'in_')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'neighbor_peer_grp', 'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'sip_ipv4_address, port_channel, loopback, ve_interface'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'inbound'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'inbound'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'value'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'ebgp_multihop_flag, ebgp_multihop_count'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'sip_ipv4_address, loopback, ve_interface'}, {'leafval': 'next_hop_self_always, next_hop_self_status'}, {'leafval': 'neighbor_as4_enable, neighbor_as4_disable'}, {'leafval': 'local_as_value, no_prepend'}, {'leafval': 'inbound'}, {'leafval': 'value'}, {'leafval': 'nei_enforce_first_as, nei_enforce_first_as_disable'}, {'leafval': 'nei_keep_alive, nei_hold_time'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown_status, generate_rib_out'}, {'leafval': 'num_as_in_as_path, maxas_limit_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_timers_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'nei_keep_alive, nei_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_timers_hold_time_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_timers_keep_alive_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_update_source_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source": {}, "pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source": {"ve_interface": "ve_interface", "sip_ipv4_address": "sip_ipv4_address", "loopback": "loopback"}, "pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source": {"ve_interface": "ve_interface", "sip_ipv4_address": "sip_ipv4_address", "loopback": "loopback"}}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source': [u'ethernet_interface', u've_interface', u'loopback', u'sip_ipv4_address', u'port_channel'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source': [u'ethernet_interface', u've_interface', u'sip_ipv4_address', u'loopback'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source': [u'ethernet_interface', u've_interface', u'sip_ipv4_address', u'loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_update_source_ethernet_interface_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface': [u'interface_type'], 'pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface': [u'interface_type'], 'pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface': [u'interface_type']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_update_source_interface_name_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_update_source_interface_type_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source.ethernet_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_update_source_loopback_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_update_source_port_channel_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_update_source_sip_ipv4_address_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_neighbor_peer_grp_update_source_ve_interface_get(self, neighbor_peer_grp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type neighbor_peer_grp: router_bgp_neighbor_peer_grp
    :param neighbor_peer_grp: Keyword argument tuple.

    :type router_bgp_neighbor_peer_grp: unicode
    :param router_bgp_neighbor_peer_grp: **neighbor_peer_grp** tuple argument:  Word:1-63;;Peer Group Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\\\\@#\+\*\(\)=\{~\}%<>=$'
            '_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp', u'neighbor_peer_grp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps.neighbor_peer_grp.update_source', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}, {'keyval': 'router_bgp_neighbor_peer_grp', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, neighbor_peer_grp=neighbor_peer_grp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, neighbor_peer_grp=neighbor_peer_grp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_neighbor_peer_grps_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_router_bgp_attributes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'keep_alive, hold_time'}, {'leafval': 'identifier'}, {'leafval': 'as4_enable'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'holdover_interval'}, {'leafval': 'holdover_interval'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'num_as_in_path'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'identifier'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'holdover_interval'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_timers_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'keep_alive, hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_timers_hold_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_bgp_timers_keep_alive_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_fabric_virtual_gateway_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.router.fabric_virtual_gateway', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family', u'ipv4'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family', u'ipv4'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family', u'ipv4'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family', u'ipv4'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family', u'ipv4'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'timer'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'timer'}, {'leafval': 'enable_global, gateway_mac_address, accept_unicast_arp_request'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'enable_global, gateway_mac_address, accept_unicast_arp_request'}, {'leafval': 'timer'}, {'leafval': 'enable_global, gateway_mac_address, accept_unicast_arp_request'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'enable_global, gateway_mac_address, accept_unicast_arp_request'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'enable_global, gateway_mac_address, accept_unicast_arp_request'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family', u'ipv4'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family', u'ipv4'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family', u'ipv4'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family', u'ipv4'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family', u'ipv6'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family', u'ipv4')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'enable_global, gateway_mac_address, accept_unicast_arp_request'}, {'leafval': 'timer'}, {'leafval': 'enable_global, gateway_mac_address, accept_unicast_arp_request'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'enable_global, gateway_mac_address, accept_unicast_arp_request'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'enable_global, gateway_mac_address, accept_unicast_arp_request'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'enable_global, gateway_mac_address'}, {'leafval': 'timer'}, {'leafval': 'enable_global, gateway_mac_address, accept_unicast_arp_request'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv4_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv4_accept_unicast_arp_request_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv4_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv4_gateway_mac_address_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv4', u'gratuitous_arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv4_gratuitous_arp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv4_gratuitous_arp_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv4.gratuitous_arp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv6_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv6_gateway_mac_address_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv6', u'gratuitous_arp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}, {'leafval': 'timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv6_gratuitous_arp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_fabric_virtual_gateway_address_family_ipv6_gratuitous_arp_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.router.fabric_virtual_gateway.address_family.ipv6.gratuitous_arp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_hide_pim_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'rp_address'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'route_precedence'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'ssm_enable'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp_ip'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder', u'pim'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rpf', u'ecmp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'range'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'max_mcache, hello_interval, prune_wait, nbr_timeout, inactivity_timer, message_interval, spt_threshold'}, {'leafval': 'rebalance'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder', u'router_isis_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder', u'net'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder', u'net'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder', u'router_isis_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder', u'router_isis_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder', u'net'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'hostname_disable'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'fast_flood_value'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'csnp_interval, disable_inc_stct_spf_opt, disable_incremental_spf_opt, disable_partial_spf_opt, is_type, lsp_gen_interval, lsp_interval, lsp_refresh_interval, max_lsp_lifetime, nonstop_routing, retransmit_interval'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'nsr'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'net_cmd'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'net_cmd'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'fast_flood_value'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'hostname_disable'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'csnp_interval, disable_inc_stct_spf_opt, disable_incremental_spf_opt, disable_partial_spf_opt, is_type, lsp_gen_interval, lsp_interval, lsp_refresh_interval, max_lsp_lifetime, nonstop_routing, retransmit_interval'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'nsr'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'nsr'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'fast_flood_value'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'csnp_interval, disable_inc_stct_spf_opt, disable_incremental_spf_opt, disable_partial_spf_opt, is_type, lsp_gen_interval, lsp_interval, lsp_refresh_interval, max_lsp_lifetime, nonstop_routing, retransmit_interval'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'net_cmd'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'default_information_originate_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_af_common_attributes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_af_ipv4_attributes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_default_information_originate_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.default_information_originate": {"default_information_originate_route_map": "default_information_originate_route_map"}, "pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.default_information_originate": {"default_information_originate_route_map": "default_information_originate_route_map"}, "pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.default_information_originate": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_default_information_originate_default_information_originate_cr_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_default_information_originate_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_default_link_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.default_link_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.default_link_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.default_link_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_default_link_metric_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.default_link_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.default_link_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.default_link_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_default_link_metric_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.default_link_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.default_link_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.default_link_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_default_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_distance_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_ldp_sync_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.ldp_sync', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.ldp_sync', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.ldp_sync', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_ldp_sync_hold_down_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.ldp_sync', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.ldp_sync', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.ldp_sync', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_maximum_paths_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_metric_style_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_metric_style_wide_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style.wide', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style.wide', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style.wide', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_metric_style_wide_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style.wide', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style.wide', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style.wide', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_metric_style_wide_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style.wide', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style.wide', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style.wide', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_bgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp': [u'bgp_level2', u'bgp_level1', u'bgp_level12'], 'pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp': [u'bgp_level2', u'bgp_level1', u'bgp_level12'], 'pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp': [u'bgp_level2', u'bgp_level1', u'bgp_level12']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_bgp_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_bgp_level_1_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_bgp_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_bgp_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_bgp_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_bgp_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_connected_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected': [u'connected_level12', u'connected_level2', u'connected_level1'], 'pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected': [u'connected_level12', u'connected_level2', u'connected_level1'], 'pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected': [u'connected_level12', u'connected_level2', u'connected_level1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_connected_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_connected_level_1_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_connected_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_connected_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_connected_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_connected_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_1_into_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_1_into_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2': [u'level1_into_level2_disable', u'prefix_list_level1'], 'pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2': [u'level1_into_level2_disable', u'prefix_list_level1'], 'pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2': [u'level1_into_level2_disable', u'prefix_list_level1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_1_into_level_2_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_1_into_level_2_prefix_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'prefix_list_level2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_2_into_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'prefix_list_level2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_2_into_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into.level2_into_level1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into.level2_into_level1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into.level2_into_level1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_isis_level_2_into_level_1_prefix_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into.level2_into_level1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into.level2_into_level1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into.level2_into_level1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf': [u'ospf_level2', u'ospf_level12', u'ospf_level1'], 'pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf': [u'ospf_level2', u'ospf_level12', u'ospf_level1'], 'pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf': [u'ospf_level2', u'ospf_level12', u'ospf_level1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_level_1_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_match_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_match_external1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_match_external2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_match_internal_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_ospf_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_static_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static': [u'static_level2', u'static_level12', u'static_level1'], 'pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static': [u'static_level2', u'static_level12', u'static_level1'], 'pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static': [u'static_level2', u'static_level12', u'static_level1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_static_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_static_level_1_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_static_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_static_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_static_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_redistribute_static_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_summary_address_get(self, summary_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type summary_address: summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2
    :param summary_address: Keyword argument tuple.

    :type summary_ip: unicode
    :param summary_ip: **summary_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type summary_ip_mask: unicode
    :param summary_ip_mask: **summary_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type summary_ip_level1: YANGBool
    :param summary_ip_level1: **summary_address** tuple argument:  For Level-1

    :type summary_ip_level2: YANGBool
    :param summary_ip_level2: **summary_address** tuple argument:  For Level-2

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.summary_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.summary_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.summary_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_address', 'keyval': 'summary_ip, summary_ip_mask', 'extra_keyval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_address=summary_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_address=summary_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_summary_address_level_1_get(self, summary_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type summary_address: summary_ip, summary_ip_mask
    :param summary_address: Keyword argument tuple.

    :type summary_ip: unicode
    :param summary_ip: **summary_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type summary_ip_mask: unicode
    :param summary_ip_mask: **summary_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.summary_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.summary_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.summary_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_address', 'keyval': 'summary_ip, summary_ip_mask', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_address=summary_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_address=summary_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv4_unicast_summary_address_level_2_get(self, summary_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type summary_address: summary_ip, summary_ip_mask
    :param summary_address: Keyword argument tuple.

    :type summary_ip: unicode
    :param summary_ip: **summary_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type summary_ip_mask: unicode
    :param summary_ip_mask: **summary_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.summary_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.summary_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.summary_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_address', 'keyval': 'summary_ip, summary_ip_mask', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_address=summary_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_address=summary_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'default_information_originate_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'default_metric, distance, maximum_paths'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'default_metric, distance, maximum_paths'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_af_common_attributes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_af_ipv6_attributes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_default_information_originate_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.default_information_originate": {}, "pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.default_information_originate": {"default_information_originate_route_map": "default_information_originate_route_map"}, "pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.default_information_originate": {"default_information_originate_route_map": "default_information_originate_route_map"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_default_information_originate_default_information_originate_cr_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_default_information_originate_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_default_link_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.ipv6_default_link_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.ipv6_default_link_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.ipv6_default_link_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_default_link_metric_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.ipv6_default_link_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.ipv6_default_link_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.ipv6_default_link_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_default_link_metric_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.ipv6_default_link_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.ipv6_default_link_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.ipv6_default_link_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_default_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_disable_adjacency_check_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_distance_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_maximum_paths_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_multi_topology_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.multi_topology', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.multi_topology', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.multi_topology', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_multi_topology_transition_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.multi_topology', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.multi_topology', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.multi_topology', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_partial_spf_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.partial6_spf_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.partial6_spf_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.partial6_spf_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_partial_spf_interval_pspf_hold_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.partial6_spf_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.partial6_spf_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.partial6_spf_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_partial_spf_interval_pspf_init_delay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.partial6_spf_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.partial6_spf_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.partial6_spf_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_partial_spf_interval_pspf_max_hold_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.partial6_spf_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.partial6_spf_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.partial6_spf_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_bgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp': [u'bgp_level2', u'bgp_level1', u'bgp_level12'], 'pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp': [u'bgp_level2', u'bgp_level1', u'bgp_level12'], 'pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp': [u'bgp_level2', u'bgp_level1', u'bgp_level12']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_bgp_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_bgp_level_1_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_bgp_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_bgp_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_bgp_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_bgp_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_connected_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected': [u'connected_level12', u'connected_level2', u'connected_level1'], 'pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected': [u'connected_level12', u'connected_level2', u'connected_level1'], 'pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected': [u'connected_level12', u'connected_level2', u'connected_level1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_connected_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_connected_level_1_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_connected_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_connected_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_connected_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_connected_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_1_into_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_1_into_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2': [u'level1_into_level2_disable', u'prefix_list_level1'], 'pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2': [u'level1_into_level2_disable', u'prefix_list_level1'], 'pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2': [u'level1_into_level2_disable', u'prefix_list_level1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_1_into_level_2_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_1_into_level_2_prefix_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into.level1_into_level2', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'prefix_list_level2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_2_into_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'prefix_list_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'prefix_list_level2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_2_into_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into.level2_into_level1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into.level2_into_level1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into.level2_into_level1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_isis_level_2_into_level_1_prefix_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into.level2_into_level1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into.level2_into_level1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into.level2_into_level1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf': [u'ospf_level2', u'ospf_level12', u'ospf_level1'], 'pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf': [u'ospf_level2', u'ospf_level12', u'ospf_level1'], 'pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf': [u'ospf_level2', u'ospf_level12', u'ospf_level1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_level_1_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_match_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_match_external1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_match_external2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_match_internal_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf.match', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_ospf_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_static_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static': [u'static_level2', u'static_level12', u'static_level1'], 'pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static': [u'static_level2', u'static_level12', u'static_level1'], 'pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static': [u'static_level2', u'static_level12', u'static_level1']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_static_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_static_level_1_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_static_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_static_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_static_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_redistribute_static_route_map_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_spf_interval_get(self, spf6_interval=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type spf6_interval: spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time
    :param spf6_interval: Keyword argument tuple.

    :type spf6_interval_level: unicode
    :param spf6_interval_level: **spf6_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type spf6_interval_max_hold_time: long
    :param spf6_interval_max_hold_time: **spf6_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type spf6_interval_initial_delay: long
    :param spf6_interval_initial_delay: **spf6_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type spf6_interval_hold_time: long
    :param spf6_interval_hold_time: **spf6_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.spf6_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.spf6_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.spf6_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'spf6_interval', 'keyval': 'spf6_interval_level', 'extra_keyval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf6_interval=spf6_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf6_interval=spf6_interval)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_spf_interval_spf6_interval_hold_time_get(self, spf6_interval=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type spf6_interval: spf6_interval_level
    :param spf6_interval: Keyword argument tuple.

    :type spf6_interval_level: unicode
    :param spf6_interval_level: **spf6_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.spf6_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.spf6_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.spf6_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'spf6_interval', 'keyval': 'spf6_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf6_interval=spf6_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf6_interval=spf6_interval)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_spf_interval_spf6_interval_initial_delay_get(self, spf6_interval=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type spf6_interval: spf6_interval_level
    :param spf6_interval: Keyword argument tuple.

    :type spf6_interval_level: unicode
    :param spf6_interval_level: **spf6_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.spf6_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.spf6_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.spf6_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'spf6_interval', 'keyval': 'spf6_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf6_interval=spf6_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf6_interval=spf6_interval)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_spf_interval_spf6_interval_max_hold_time_get(self, spf6_interval=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type spf6_interval: spf6_interval_level
    :param spf6_interval: Keyword argument tuple.

    :type spf6_interval_level: unicode
    :param spf6_interval_level: **spf6_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.spf6_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.spf6_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.spf6_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'spf6_interval', 'keyval': 'spf6_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf6_interval=spf6_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf6_interval=spf6_interval)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_summary_prefix_get(self, summary_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type summary_prefix: summary_prefix_ipv6
    :param summary_prefix: Keyword argument tuple.

    :type summary_prefix_ipv6: unicode
    :param summary_prefix_ipv6: **summary_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.summary_prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.summary_prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.summary_prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_prefix', 'keyval': 'summary_prefix_ipv6', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_prefix=summary_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_prefix=summary_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_summary_prefix_level_1_get(self, summary_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type summary_prefix: summary_prefix_ipv6
    :param summary_prefix: Keyword argument tuple.

    :type summary_prefix_ipv6: unicode
    :param summary_prefix_ipv6: **summary_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.summary_prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.summary_prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.summary_prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_prefix', 'keyval': 'summary_prefix_ipv6', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_prefix=summary_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_prefix=summary_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_address_family_ipv6_unicast_summary_prefix_level_2_get(self, summary_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type summary_prefix: summary_prefix_ipv6
    :param summary_prefix: Keyword argument tuple.

    :type summary_prefix_ipv6: unicode
    :param summary_prefix_ipv6: **summary_prefix** tuple argument.

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.summary_prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.summary_prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.summary_prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'summary_prefix', 'keyval': 'summary_prefix_ipv6', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, summary_prefix=summary_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, summary_prefix=summary_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_auth_check_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'auth_check_level1_disable'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'auth_check_level2_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_auth_check_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check.auth_check_level1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check.auth_check_level1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check.auth_check_level1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_auth_check_level_1_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check.auth_check_level1', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check.auth_check_level1', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check.auth_check_level1', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_auth_check_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check.auth_check_level2', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check.auth_check_level2', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check.auth_check_level2', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_auth_check_level_2_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check.auth_check_level2', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check.auth_check_level2', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check.auth_check_level2', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_auth_key_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_key', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_key', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_key', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_auth_key_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_key', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_key', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_key', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_auth_key_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_key', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_key', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_key', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_auth_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_auth_mode_md5_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode.md5', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode.md5', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode.md5', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_auth_mode_md5_level_1_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode.md5', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode.md5', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode.md5', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_auth_mode_md5_level_2_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode.md5', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode.md5', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode.md5', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_bfd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.bfd": {"bfd_global_enable": "bfd_global_enable", "bfd_holdover_interval": "bfd_holdover_interval"}, "pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.bfd": {"bfd_global_enable": "bfd_global_enable", "bfd_holdover_interval": "bfd_holdover_interval"}, "pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.bfd": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_bfd_all_interfaces_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_bfd_bfd_global_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_bfd_holdover_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_csnp_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'nsr'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'fast_flood_value'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'fast_flood_value'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hostname_disable'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'nsr'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hostname_disable'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'fast_flood_value'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'nsr'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_disable_inc_stct_spf_opt_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'nsr'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'fast_flood_value'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'fast_flood_value'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hostname_disable'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'nsr'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hostname_disable'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'fast_flood_value'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'nsr'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_disable_incremental_spf_opt_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'nsr'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'fast_flood_value'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'fast_flood_value'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hostname_disable'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'nsr'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hostname_disable'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'fast_flood_value'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'nsr'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_disable_partial_spf_opt_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'nsr'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'fast_flood_value'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'fast_flood_value'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hostname_disable'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'nsr'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hostname_disable'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'fast_flood_value'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'nsr'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_fast_flood_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.fast_flood', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.fast_flood', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.fast_flood', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'fast_flood_value'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_fast_flood_fast_flood_value_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.fast_flood', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.fast_flood', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.fast_flood', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_graceful_restart_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_graceful_restart_helper_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_hello_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_hello_padding_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_ptp_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_hello_padding_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_ptp_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_hello_padding_point_to_point_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding.hello_padding_point_to_point', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding.hello_padding_point_to_point', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding.hello_padding_point_to_point', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_hello_padding_point_to_point_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding.hello_padding_point_to_point', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding.hello_padding_point_to_point', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding.hello_padding_point_to_point', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_hostname_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hostname', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hostname', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hostname', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_hostname_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hostname', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hostname', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hostname', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_is_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'nsr'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'fast_flood_value'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'fast_flood_value'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hostname_disable'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'nsr'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hostname_disable'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'fast_flood_value'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'nsr'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_log_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.log', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.log', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.log', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_log_adjacency_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.log', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.log', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.log', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_log_invalid_lsp_packets_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.log', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.log', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.log', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_lsp_gen_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'nsr'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'fast_flood_value'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'fast_flood_value'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hostname_disable'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'nsr'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hostname_disable'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'fast_flood_value'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'nsr'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_lsp_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'nsr'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'fast_flood_value'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'fast_flood_value'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hostname_disable'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'nsr'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hostname_disable'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'fast_flood_value'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'nsr'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_lsp_refresh_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'nsr'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'fast_flood_value'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'fast_flood_value'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hostname_disable'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'nsr'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hostname_disable'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'fast_flood_value'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'nsr'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_max_lsp_lifetime_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'nsr'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'fast_flood_value'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'fast_flood_value'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hostname_disable'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'nsr'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hostname_disable'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'fast_flood_value'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'nsr'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_net_get(self, net=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type net: net_cmd
    :param net: Keyword argument tuple.

    :type net_cmd: unicode
    :param net_cmd: **net** tuple argument.

        * pattern restriction: ::

            '([0-9a-fA-F]{2}((\.[0-9a-fA-F]{4}){3,9})\.00)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.net', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.net', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.net', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'net', 'keyval': 'net_cmd', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, net=net)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, net=net)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_nonstop_routing_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'nsr'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'fast_flood_value'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'fast_flood_value'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hostname_disable'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'nsr'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hostname_disable'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'fast_flood_value'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'nsr'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_partial_spf_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.partial_spf_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.partial_spf_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.partial_spf_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_partial_spf_interval_pspf_hold_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.partial_spf_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.partial_spf_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.partial_spf_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_partial_spf_interval_pspf_init_delay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.partial_spf_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.partial_spf_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.partial_spf_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_partial_spf_interval_pspf_max_hold_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.partial_spf_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.partial_spf_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.partial_spf_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_retransmit_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'nsr'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'fast_flood_value'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'fast_flood_value'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hostname_disable'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'nsr'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hostname_disable'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'fast_flood_value'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'nsr'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_reverse_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_reverse_metric_rev_metric_common_attributes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_reverse_metric_rev_metric_val_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_reverse_metric_reverse_metric_tlv_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.reverse_metric_tlv', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.reverse_metric_tlv', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.reverse_metric_tlv', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_reverse_metric_te_def_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_reverse_metric_tlv_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.reverse_metric_tlv', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.reverse_metric_tlv', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.reverse_metric_tlv', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_reverse_metric_whole_lan_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric.rev_metric_common_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_router_isis_attributes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'nsr'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'fast_flood_value'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'fast_flood_value'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hostname_disable'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'nsr'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'hostname_disable'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'fast_flood_value'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'nsr'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_tlv_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_router_isis_cmds_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder', u'router_isis_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder', u'net'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder', u'router_isis_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder', u'net'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder', u'net'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder', u'router_isis_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'hostname_disable'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'fast_flood_value'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'csnp_interval, disable_inc_stct_spf_opt, disable_incremental_spf_opt, disable_partial_spf_opt, is_type, lsp_gen_interval, lsp_interval, lsp_refresh_interval, max_lsp_lifetime, nonstop_routing, retransmit_interval'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'nsr'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'net_cmd'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'nsr'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'fast_flood_value'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'csnp_interval, disable_inc_stct_spf_opt, disable_incremental_spf_opt, disable_partial_spf_opt, is_type, lsp_gen_interval, lsp_interval, lsp_refresh_interval, max_lsp_lifetime, nonstop_routing, retransmit_interval'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'net_cmd'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'net_cmd'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'fast_flood_value'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'hostname_disable'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'csnp_interval, disable_inc_stct_spf_opt, disable_incremental_spf_opt, disable_partial_spf_opt, is_type, lsp_gen_interval, lsp_interval, lsp_refresh_interval, max_lsp_lifetime, nonstop_routing, retransmit_interval'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'nsr'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_set_debug_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_debug', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_debug', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_debug', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_set_debug_nsr_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_debug', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_debug', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_debug', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_set_overload_bit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'on_startup_overloadtime'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'wait_for_bgp_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_set_overload_bit_on_startup_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'wait_for_bgp_value'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'wait_for_bgp_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup': [u'wait_for_bgp', u'on_startup_overloadtime'], 'pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup': [u'wait_for_bgp', u'on_startup_overloadtime'], 'pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup': [u'wait_for_bgp', u'on_startup_overloadtime']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_set_overload_bit_on_startup_on_startup_overloadtime_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'wait_for_bgp_value'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'wait_for_bgp_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_set_overload_bit_on_startup_wait_for_bgp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup.wait_for_bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup.wait_for_bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup.wait_for_bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup.wait_for_bgp': [u'wait_for_bgp_value'], 'pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup.wait_for_bgp': [u'wait_for_bgp_value'], 'pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup.wait_for_bgp': [u'wait_for_bgp_value']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_set_overload_bit_on_startup_wait_for_bgp_wait_for_bgp_value_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup.wait_for_bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup.wait_for_bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup.wait_for_bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_spf_interval_get(self, spf_interval=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type spf_interval: spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time
    :param spf_interval: Keyword argument tuple.

    :type spf_interval_level: unicode
    :param spf_interval_level: **spf_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type spf_interval_max_hold_time: long
    :param spf_interval_max_hold_time: **spf_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type spf_interval_initial_delay: long
    :param spf_interval_initial_delay: **spf_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type spf_interval_hold_time: long
    :param spf_interval_hold_time: **spf_interval** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.spf_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.spf_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.spf_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'spf_interval', 'keyval': 'spf_interval_level', 'extra_keyval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_interval=spf_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_interval=spf_interval)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_spf_interval_spf_interval_hold_time_get(self, spf_interval=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type spf_interval: spf_interval_level
    :param spf_interval: Keyword argument tuple.

    :type spf_interval_level: unicode
    :param spf_interval_level: **spf_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.spf_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.spf_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.spf_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'spf_interval', 'keyval': 'spf_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_interval=spf_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_interval=spf_interval)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_spf_interval_spf_interval_initial_delay_get(self, spf_interval=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type spf_interval: spf_interval_level
    :param spf_interval: Keyword argument tuple.

    :type spf_interval_level: unicode
    :param spf_interval_level: **spf_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.spf_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.spf_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.spf_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'spf_interval', 'keyval': 'spf_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_interval=spf_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_interval=spf_interval)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_isis_spf_interval_spf_interval_max_hold_time_get(self, spf_interval=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type spf_interval: spf_interval_level
    :param spf_interval: Keyword argument tuple.

    :type spf_interval_level: unicode
    :param spf_interval_level: **spf_interval** tuple argument.

        * enumeration restriction: ::

            ['level-2', 'level-1']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.spf_interval', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.spf_interval', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.spf_interval', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'spf_interval', 'keyval': 'spf_interval_level', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_interval=spf_interval)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_interval=spf_interval)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'bypass_lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'policy'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'lsp_xc_traps'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'rsvp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'autobw_template'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'cspf_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'bypass_lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'lsp_xc_traps'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'policy'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'cspf_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'autobw_template'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'bypass_lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'lsp_xc_traps'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'autobw_template'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'cspf_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'path_name'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'isis_set_level'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'add_penalty'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'lsp_name, lsp_dest_address, lsp_cspf, lsp_ipmtu, lsp_metric, lsp_revert_timer, lsp_tie_breaking, lsp_src_address, lsp_primary_path, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, lsp_soft_preemption, lsp_enable'}, {'leafval': 'bypass_lsp_name, bypass_lsp_dest_address, bypass_lsp_src_address, bypass_lsp_tie_breaking, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, bypass_lsp_primary_path, bypass_lsp_enable'}, {'leafval': 'backup_retry_time, cspf_interface_constraint, handle_isis_neighbor_down, handle_ospf_neighbor_down, load_interval, retry_time, retry_limit, rapid_retry, rsvp_periodic_flooding_time, qos_ttl_mode, ingress_tunnel_accounting, transit_session_accounting'}, {'leafval': 'lsp_xc_traps_enable'}, {'leafval': 'refresh_interval, refresh_multiple, global_rsvp_hello_acknowledgements, global_rsvp_hello_unprioritize, g_rsvp_backup_bw_guarantee'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'interface_type, interface_name, mpls_interface_ldp_enable'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'autobw_template_name, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'cspf_group_name'}, {'leafval': 'bypass_lsp_name, bypass_lsp_dest_address, bypass_lsp_src_address, bypass_lsp_tie_breaking, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, bypass_lsp_primary_path, bypass_lsp_enable'}, {'leafval': 'lsp_xc_traps_enable'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'interface_type, interface_name, mpls_interface_ldp_enable'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'add_penalty'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'backup_retry_time, cspf_interface_constraint, handle_isis_neighbor_down, handle_ospf_neighbor_down, load_interval, retry_time, retry_limit, rapid_retry, rsvp_periodic_flooding_time, qos_ttl_mode, ingress_tunnel_accounting, transit_session_accounting, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'cspf_group_name'}, {'leafval': 'lsp_name, lsp_dest_address, lsp_cspf, lsp_ipmtu, lsp_metric, lsp_revert_timer, lsp_tie_breaking, lsp_src_address, lsp_primary_path, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, lsp_soft_preemption, lsp_enable'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_template_name, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'refresh_interval, refresh_multiple, global_rsvp_hello_acknowledgements, global_rsvp_hello_unprioritize, g_rsvp_backup_bw_guarantee, delay_resv_send'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'path_name'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'lsp_name, lsp_dest_address, lsp_cspf, lsp_ipmtu, lsp_metric, lsp_revert_timer, lsp_tie_breaking, lsp_src_address, lsp_primary_path, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, lsp_soft_preemption, lsp_enable'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'interface_type, interface_name, mpls_interface_ldp_enable'}, {'leafval': 'bypass_lsp_name, bypass_lsp_dest_address, bypass_lsp_src_address, bypass_lsp_tie_breaking, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, bypass_lsp_primary_path, bypass_lsp_enable'}, {'leafval': 'refresh_interval, refresh_multiple, global_rsvp_hello_acknowledgements, global_rsvp_hello_unprioritize, g_rsvp_backup_bw_guarantee, delay_resv_send'}, {'leafval': 'lsp_xc_traps_enable'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'autobw_template_name, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'cspf_group_name'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'path_name'}, {'leafval': 'backup_retry_time, cspf_interface_constraint, handle_isis_neighbor_down, handle_ospf_neighbor_down, load_interval, retry_time, retry_limit, rapid_retry, rsvp_periodic_flooding_time, qos_ttl_mode, ingress_tunnel_accounting, transit_session_accounting'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'add_penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_template_get(self, autobw_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'adjustment_threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'threshold_percentage, use_threshold_table'}]
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_template": {}, "pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template": {"overflow_limit": "overflow_limit", "max_bandwidth": "max_bandwidth", "adjustment_interval": "adjustment_interval", "mode": "mode", "sample_recording": "sample_recording", "underflow_limit": "underflow_limit", "autobw_template_name": "autobw_template_name", "min_bandwidth": "min_bandwidth"}, "pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template": {"overflow_limit": "overflow_limit", "max_bandwidth": "max_bandwidth", "adjustment_interval": "adjustment_interval", "mode": "mode", "sample_recording": "sample_recording", "underflow_limit": "underflow_limit", "autobw_template_name": "autobw_template_name", "min_bandwidth": "min_bandwidth"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_template_adjustment_interval_get(self, autobw_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'adjustment_threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'threshold_percentage, use_threshold_table'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_template_adjustment_threshold_get(self, autobw_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_template_adjustment_threshold_threshold_percentage_get(self, autobw_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'autobw_template'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'autobw_template')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template.adjustment_threshold', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template.adjustment_threshold', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'autobw_template_name', 'extra_keyval': ''}, {'keyval': 'autobw_template_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_template_adjustment_threshold_use_threshold_table_get(self, autobw_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'autobw_template'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'autobw_template')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template.adjustment_threshold', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template.adjustment_threshold', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'autobw_template_name', 'extra_keyval': ''}, {'keyval': 'autobw_template_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_template_max_bandwidth_get(self, autobw_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'adjustment_threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'threshold_percentage, use_threshold_table'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_template_min_bandwidth_get(self, autobw_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'adjustment_threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'threshold_percentage, use_threshold_table'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_template_mode_get(self, autobw_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'adjustment_threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'threshold_percentage, use_threshold_table'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_template_overflow_limit_get(self, autobw_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'adjustment_threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'threshold_percentage, use_threshold_table'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_template_sample_recording_get(self, autobw_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'adjustment_threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'threshold_percentage, use_threshold_table'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_template_underflow_limit_get(self, autobw_template=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type autobw_template: autobw_template_name
    :param autobw_template: Keyword argument tuple.

    :type autobw_template_name: unicode
    :param autobw_template_name: **autobw_template** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_template', u'adjustment_threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_template', 'keyval': 'autobw_template_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'threshold_percentage, use_threshold_table'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_template=autobw_template)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_template=autobw_template)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_threshold_table_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_threshold_table_bandwidth_get(self, autobw_threshold_table_bandwidth=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type autobw_threshold_table_bandwidth: bandwidth_value, autobw_threshold_table_threshold
    :param autobw_threshold_table_bandwidth: Keyword argument tuple.

    :type bandwidth_value: long
    :param bandwidth_value: **autobw_threshold_table_bandwidth** tuple argument:  DECIMAL;;Bandwidth upto which threshold will apply

        * range restriction: ::

            ['0..4294967295']

    :type autobw_threshold_table_threshold: long
    :param autobw_threshold_table_threshold: **autobw_threshold_table_bandwidth** tuple argument:  DECIMAL;;Absolute threshold value for the bandwidth

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.autobw_threshold_table_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.autobw_threshold_table_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.autobw_threshold_table_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_threshold_table_bandwidth', 'keyval': 'bandwidth_value', 'extra_keyval': 'bandwidth_value, autobw_threshold_table_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_threshold_table_bandwidth=autobw_threshold_table_bandwidth)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_threshold_table_bandwidth=autobw_threshold_table_bandwidth)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_threshold_table_bandwidth_threshold_get(self, autobw_threshold_table_bandwidth=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type autobw_threshold_table_bandwidth: bandwidth_value
    :param autobw_threshold_table_bandwidth: Keyword argument tuple.

    :type bandwidth_value: long
    :param bandwidth_value: **autobw_threshold_table_bandwidth** tuple argument:  DECIMAL;;Bandwidth upto which threshold will apply

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.autobw_threshold_table_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.autobw_threshold_table_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.autobw_threshold_table_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'autobw_threshold_table_bandwidth', 'keyval': 'bandwidth_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, autobw_threshold_table_bandwidth=autobw_threshold_table_bandwidth)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, autobw_threshold_table_bandwidth=autobw_threshold_table_bandwidth)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_threshold_table_max_bw_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.max_bw_threshold', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.max_bw_threshold', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.max_bw_threshold', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.max_bw_threshold': [u'max_bw_threshold_percentage', u'max_bw_threshold_absolute'], 'pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.max_bw_threshold': [u'max_bw_threshold_percentage', u'max_bw_threshold_absolute'], 'pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.max_bw_threshold': [u'max_bw_threshold_percentage', u'max_bw_threshold_absolute']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_threshold_table_max_bw_threshold_absolute_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.max_bw_threshold', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.max_bw_threshold', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.max_bw_threshold', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_autobw_threshold_table_max_bw_threshold_percentage_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.max_bw_threshold', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.max_bw_threshold', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table.max_bw_threshold', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bfd_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bfd', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bfd', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bfd', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bfd_bfd_sub_cmds_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bfd_min_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds.bfd_min_tx', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds.bfd_min_tx', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds.bfd_min_tx', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bfd_min_tx_bfd_min_tx_val_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds.bfd_min_tx', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds.bfd_min_tx', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds.bfd_min_tx', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bfd_min_tx_min_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds.bfd_min_tx', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds.bfd_min_tx', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds.bfd_min_tx', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bfd_min_tx_multiplier_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds.bfd_min_tx', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds.bfd_min_tx', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds.bfd_min_tx', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_adaptive_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_commit_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_cos_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_cspf_computation_mode_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_enable_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_exclude_interface_get(self, bypass_lsp=None, exclude_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type exclude_interface: bypass_exclude_interface_type, bypass_exclude_interface_name
    :param exclude_interface: Keyword argument tuple.

    :type bypass_exclude_interface_type: unicode
    :param bypass_exclude_interface_type: **exclude_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type bypass_exclude_interface_name: unicode
    :param bypass_exclude_interface_name: **exclude_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.exclude_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.exclude_interface', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.exclude_interface', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bypass_lsp_name', 'extra_keyval': ''}, {'keyval': 'bypass_lsp_name', 'extra_keyval': ''}, {'keyval': 'bypass_lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'exclude_interface', 'keyval': 'bypass_exclude_interface_type, bypass_exclude_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp, exclude_interface=exclude_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp, exclude_interface=exclude_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_from_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_hop_limit_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_primary_path_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_priority_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.priority', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.priority', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.priority', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bypass_lsp_name', 'extra_keyval': ''}, {'keyval': 'bypass_lsp_name', 'extra_keyval': ''}, {'keyval': 'bypass_lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_priority_lsp_hold_priority_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.priority', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.priority', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.priority', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bypass_lsp_name', 'extra_keyval': ''}, {'keyval': 'bypass_lsp_name', 'extra_keyval': ''}, {'keyval': 'bypass_lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_priority_lsp_setup_priority_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.priority', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.priority', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.priority', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bypass_lsp_name', 'extra_keyval': ''}, {'keyval': 'bypass_lsp_name', 'extra_keyval': ''}, {'keyval': 'bypass_lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_record_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_reoptimize_timer_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_tie_breaking_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_to_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'exclude_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bypass_lsp', 'keyval': 'bypass_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'bypass_exclude_interface_type, bypass_exclude_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_traffic_engineering_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.lsp_traffic_engineering', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.lsp_traffic_engineering', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.lsp_traffic_engineering', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bypass_lsp_name', 'extra_keyval': ''}, {'keyval': 'bypass_lsp_name', 'extra_keyval': ''}, {'keyval': 'bypass_lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_traffic_engineering_max_burst_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.lsp_traffic_engineering', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.lsp_traffic_engineering', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.lsp_traffic_engineering', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bypass_lsp_name', 'extra_keyval': ''}, {'keyval': 'bypass_lsp_name', 'extra_keyval': ''}, {'keyval': 'bypass_lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_traffic_engineering_max_rate_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.lsp_traffic_engineering', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.lsp_traffic_engineering', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.lsp_traffic_engineering', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bypass_lsp_name', 'extra_keyval': ''}, {'keyval': 'bypass_lsp_name', 'extra_keyval': ''}, {'keyval': 'bypass_lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_bypass_lsp_traffic_engineering_mean_rate_get(self, bypass_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bypass_lsp: bypass_lsp_name
    :param bypass_lsp: Keyword argument tuple.

    :type bypass_lsp_name: unicode
    :param bypass_lsp_name: **bypass_lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp', u'bypass_lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.lsp_traffic_engineering', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.lsp_traffic_engineering', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bypass_lsp.lsp_traffic_engineering', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bypass_lsp_name', 'extra_keyval': ''}, {'keyval': 'bypass_lsp_name', 'extra_keyval': ''}, {'keyval': 'bypass_lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bypass_lsp=bypass_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bypass_lsp=bypass_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_cspf_group_get(self, cspf_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cspf_group: cspf_group_name
    :param cspf_group: Keyword argument tuple.

    :type cspf_group_name: unicode
    :param cspf_group_name: **cspf_group** tuple argument:  ASCII string;;Name (up to 128 characters)

        * length restriction: ::

            ['1..128']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group_subnet'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group_penalty_n'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group_ip'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group_link'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group_node'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group_penalty_n'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group_link'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group_ip'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group_node'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group_subnet'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group_penalty_n'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group_subnet'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group_ip'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group_link'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group_node')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cspf_group', 'keyval': 'cspf_group_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cspf_group_subnet_ip'}, {'leafval': 'cspf_group_penalty'}, {'leafval': 'cspf_group_ip_address'}, {'leafval': 'cspf_group_link_from, cspf_group_link_to'}, {'leafval': 'cspf_group_node_ip'}, {'leafval': 'cspf_group_penalty'}, {'leafval': 'cspf_group_link_from, cspf_group_link_to'}, {'leafval': 'cspf_group_ip_address'}, {'leafval': 'cspf_group_node_ip'}, {'leafval': 'cspf_group_subnet_ip'}, {'leafval': 'cspf_group_penalty'}, {'leafval': 'cspf_group_subnet_ip'}, {'leafval': 'cspf_group_ip_address'}, {'leafval': 'cspf_group_link_from, cspf_group_link_to'}, {'leafval': 'cspf_group_node_ip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cspf_group=cspf_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cspf_group=cspf_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_cspf_group_from_get(self, cspf_group=None, cspf_group_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cspf_group: cspf_group_name
    :param cspf_group: Keyword argument tuple.

    :type cspf_group_name: unicode
    :param cspf_group_name: **cspf_group** tuple argument:  ASCII string;;Name (up to 128 characters)

        * length restriction: ::

            ['1..128']

    **Instance Keyword Argument Tuple**:

    :type cspf_group_ip: cspf_group_ip_address
    :param cspf_group_ip: Keyword argument tuple.

    :type cspf_group_ip_address: unicode
    :param cspf_group_ip_address: **cspf_group_ip** tuple argument:  A.B.C.D;;ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_ip', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_ip', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_ip', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cspf_group_name', 'extra_keyval': ''}, {'keyval': 'cspf_group_name', 'extra_keyval': ''}, {'keyval': 'cspf_group_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_group_ip', 'keyval': 'cspf_group_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cspf_group=cspf_group, cspf_group_ip=cspf_group_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cspf_group=cspf_group, cspf_group_ip=cspf_group_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_cspf_group_link_get(self, cspf_group=None, cspf_group_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cspf_group: cspf_group_name
    :param cspf_group: Keyword argument tuple.

    :type cspf_group_name: unicode
    :param cspf_group_name: **cspf_group** tuple argument:  ASCII string;;Name (up to 128 characters)

        * length restriction: ::

            ['1..128']

    **Instance Keyword Argument Tuple**:

    :type cspf_group_link: cspf_group_link_from, cspf_group_link_to
    :param cspf_group_link: Keyword argument tuple.

    :type cspf_group_link_from: unicode
    :param cspf_group_link_from: **cspf_group_link** tuple argument:  A.B.C.D;;from ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type cspf_group_link_to: unicode
    :param cspf_group_link_to: **cspf_group_link** tuple argument:  A.B.C.D;;to ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_link', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_link', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_link', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cspf_group_name', 'extra_keyval': ''}, {'keyval': 'cspf_group_name', 'extra_keyval': ''}, {'keyval': 'cspf_group_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_group_link', 'keyval': 'cspf_group_link_from, cspf_group_link_to', 'extra_keyval': 'cspf_group_link_from, cspf_group_link_to'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cspf_group=cspf_group, cspf_group_link=cspf_group_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cspf_group=cspf_group, cspf_group_link=cspf_group_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_cspf_group_node_get(self, cspf_group=None, cspf_group_node=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cspf_group: cspf_group_name
    :param cspf_group: Keyword argument tuple.

    :type cspf_group_name: unicode
    :param cspf_group_name: **cspf_group** tuple argument:  ASCII string;;Name (up to 128 characters)

        * length restriction: ::

            ['1..128']

    **Instance Keyword Argument Tuple**:

    :type cspf_group_node: cspf_group_node_ip
    :param cspf_group_node: Keyword argument tuple.

    :type cspf_group_node_ip: unicode
    :param cspf_group_node_ip: **cspf_group_node** tuple argument:  A.B.C.D;;node ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_node', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_node', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_node', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cspf_group_name', 'extra_keyval': ''}, {'keyval': 'cspf_group_name', 'extra_keyval': ''}, {'keyval': 'cspf_group_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_group_node', 'keyval': 'cspf_group_node_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cspf_group=cspf_group, cspf_group_node=cspf_group_node)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cspf_group=cspf_group, cspf_group_node=cspf_group_node)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_cspf_group_penalty_get(self, cspf_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cspf_group: cspf_group_name
    :param cspf_group: Keyword argument tuple.

    :type cspf_group_name: unicode
    :param cspf_group_name: **cspf_group** tuple argument:  ASCII string;;Name (up to 128 characters)

        * length restriction: ::

            ['1..128']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_penalty_n', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_penalty_n', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_penalty_n', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cspf_group_name', 'extra_keyval': ''}, {'keyval': 'cspf_group_name', 'extra_keyval': ''}, {'keyval': 'cspf_group_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cspf_group=cspf_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cspf_group=cspf_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_cspf_group_subnet_get(self, cspf_group=None, cspf_group_subnet=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cspf_group: cspf_group_name
    :param cspf_group: Keyword argument tuple.

    :type cspf_group_name: unicode
    :param cspf_group_name: **cspf_group** tuple argument:  ASCII string;;Name (up to 128 characters)

        * length restriction: ::

            ['1..128']

    **Instance Keyword Argument Tuple**:

    :type cspf_group_subnet: cspf_group_subnet_ip
    :param cspf_group_subnet: Keyword argument tuple.

    :type cspf_group_subnet_ip: unicode
    :param cspf_group_subnet_ip: **cspf_group_subnet** tuple argument:  A.B.C.D/M;;Subnet address (with host part zero) in dotted decimal/Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.cspf_group', u'cspf_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_subnet', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_subnet', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.cspf_group.cspf_group_subnet', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cspf_group_name', 'extra_keyval': ''}, {'keyval': 'cspf_group_name', 'extra_keyval': ''}, {'keyval': 'cspf_group_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'cspf_group_subnet', 'keyval': 'cspf_group_subnet_ip', 'extra_keyval': 'cspf_group_subnet_ip'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cspf_group=cspf_group, cspf_group_subnet=cspf_group_subnet)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cspf_group=cspf_group, cspf_group_subnet=cspf_group_subnet)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_dynamic_bypass_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_dynamic_bypass_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_dynamic_bypass_enable_all_interfaces_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_dynamic_bypass_max_bypasses_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_dynamic_bypass_max_bypasses_per_mp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_dynamic_bypass_mpls_dynamic_bypass_sub_cmds_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_dynamic_bypass_reoptimize_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass.mpls_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_advertise_fec_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_eol_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_eol', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_eol', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_eol', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_eol_notification_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_eol', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_eol', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_eol', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_eol_tx_label_silence_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_eol', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_eol', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_eol', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_fec_128_for_auto_discovered_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_filter_fec_in_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_filter_fec_out_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_graceful_restart_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_graceful_restart_helper_only_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_graceful_restart_max_neighbor_reconnect_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_graceful_restart_max_neighbor_recovery_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_graceful_restart_reconnect_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_graceful_restart_recovery_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_gr', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_hello_interval_link_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_hello_interval_target_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_hello_timeout_link_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_hello_timeout_target_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_ka_int_count_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_ka_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_ka_timeout_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_label_withdrawal_delay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_ldp_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_ldp_startup_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_load_sharing_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_lsr_id_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_rx_label_silence_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_session_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: ldp_session_ip
    :param ldp_session: Keyword argument tuple.

    :type ldp_session_ip: unicode
    :param ldp_session_ip: **ldp_session** tuple argument:  Define LDP peer ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'ldp_session_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_session_filter_fec_out_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: ldp_session_ip
    :param ldp_session: Keyword argument tuple.

    :type ldp_session_ip: unicode
    :param ldp_session_ip: **ldp_session** tuple argument:  Define LDP peer ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'ldp_session_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_session_key_get(self, ldp_session=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_session: ldp_session_ip
    :param ldp_session: Keyword argument tuple.

    :type ldp_session_ip: unicode
    :param ldp_session_ip: **ldp_session** tuple argument:  Define LDP peer ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_session', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_session', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_session', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_session', 'keyval': 'ldp_session_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_session=ldp_session)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_session=ldp_session)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_targeted_peer_get(self, ldp_targeted_peer=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ldp_targeted_peer: ldp_targeted_peer_ip
    :param ldp_targeted_peer: Keyword argument tuple.

    :type ldp_targeted_peer_ip: unicode
    :param ldp_targeted_peer_ip: **ldp_targeted_peer** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_targeted_peer', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_targeted_peer', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder.ldp_targeted_peer', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ldp_targeted_peer', 'keyval': 'ldp_targeted_peer_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ldp_targeted_peer=ldp_targeted_peer)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ldp_targeted_peer=ldp_targeted_peer)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_ldp_tunnel_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_adaptive_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_autobw_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth": {}, "pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth": {"overflow_limit": "overflow_limit", "max_bandwidth": "max_bandwidth", "adjustment_interval": "adjustment_interval", "mode": "mode", "sample_recording": "sample_recording", "underflow_limit": "underflow_limit", "lsp_autobw_template": "lsp_autobw_template", "min_bandwidth": "min_bandwidth"}, "pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth": {"overflow_limit": "overflow_limit", "max_bandwidth": "max_bandwidth", "adjustment_interval": "adjustment_interval", "mode": "mode", "sample_recording": "sample_recording", "underflow_limit": "underflow_limit", "lsp_autobw_template": "lsp_autobw_template", "min_bandwidth": "min_bandwidth"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_autobw_adjustment_interval_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_autobw_adjustment_threshold_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_autobw_adjustment_threshold_threshold_percentage_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth.adjustment_threshold', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth.adjustment_threshold', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_autobw_adjustment_threshold_use_threshold_table_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth.adjustment_threshold', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth.adjustment_threshold', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_autobw_max_bandwidth_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_autobw_min_bandwidth_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_autobw_mode_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_autobw_overflow_limit_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_autobw_sample_recording_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_autobw_template_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_autobw_underflow_limit_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_commit_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_cos_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_cspf_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_cspf_computation_mode_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_enable_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_from_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_frr_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_frr_bandwidth_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_bandwidth': [u'lsp_frr_bandwidth', u'lsp_frr_bandwidth_inherit'], 'pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_bandwidth': [u'lsp_frr_bandwidth', u'lsp_frr_bandwidth_inherit'], 'pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_bandwidth': [u'lsp_frr_bandwidth', u'lsp_frr_bandwidth_inherit']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_frr_bandwidth_inherit_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_frr_bandwidth_lsp_frr_bandwidth_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_frr_facility_backup_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_frr_hop_limit_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_frr_link_protection_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_frr_priority_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_priority', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_priority', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_priority', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_frr_priority_lsp_frr_hold_priority_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_priority', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_priority', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_priority', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_frr_priority_lsp_frr_setup_priority_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_priority', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_priority', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_priority', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_frr_revertive_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_revertive', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_revertive', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_revertive', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_frr_revertive_global_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_revertive', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_revertive', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_revertive', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_frr_revertive_holdtime_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_revertive', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_revertive', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr.lsp_frr_revertive', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_hop_limit_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_ipmtu_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_metric_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_primary_path_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_priority_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.priority', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.priority', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.priority', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_priority_lsp_hold_priority_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.priority', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.priority', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.priority', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_priority_lsp_setup_priority_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.priority', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.priority', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.priority', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_record_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_reoptimize_timer_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_revert_timer_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_adaptive_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth": {"lsp_secpath_autobw_template": "lsp_secpath_autobw_template", "overflow_limit": "overflow_limit", "max_bandwidth": "max_bandwidth", "adjustment_interval": "adjustment_interval", "mode": "mode", "sample_recording": "sample_recording", "underflow_limit": "underflow_limit", "min_bandwidth": "min_bandwidth"}, "pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth": {"lsp_secpath_autobw_template": "lsp_secpath_autobw_template", "overflow_limit": "overflow_limit", "max_bandwidth": "max_bandwidth", "adjustment_interval": "adjustment_interval", "mode": "mode", "sample_recording": "sample_recording", "underflow_limit": "underflow_limit", "min_bandwidth": "min_bandwidth"}, "pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_adjustment_interval_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_adjustment_threshold_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_adjustment_threshold_threshold_percentage_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth.adjustment_threshold', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth.adjustment_threshold', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_adjustment_threshold_use_threshold_table_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth.adjustment_threshold', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth.adjustment_threshold', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_max_bandwidth_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_min_bandwidth_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_mode_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_overflow_limit_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_sample_recording_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_template_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_autobw_underflow_limit_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_bfd_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_commit_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_cos_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_cspf_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_cspf_computation_mode_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_hop_limit_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_ipmtu_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_priority_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.priority', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.priority', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.priority', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_priority_lsp_hold_priority_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.priority', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.priority', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.priority', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_priority_lsp_setup_priority_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.priority', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.priority', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.priority', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_record_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_reoptimize_timer_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_soft_preemption_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_standby_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_secpath_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_secpath_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'lsp_traffic_engineering')]
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'secondary_path', 'keyval': 'secpath_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_secpath_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_traffic_engineering_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_traffic_engineering', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_traffic_engineering', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_traffic_engineering', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_traffic_engineering_max_burst_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_traffic_engineering', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_traffic_engineering', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_traffic_engineering', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_traffic_engineering_max_rate_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_traffic_engineering', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_traffic_engineering', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_traffic_engineering', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_secondary_path_traffic_engineering_mean_rate_get(self, lsp=None, secondary_path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type secondary_path: secpath_name
    :param secondary_path: Keyword argument tuple.

    :type secpath_name: unicode
    :param secpath_name: **secondary_path** tuple argument:  Set secondary explicit path

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path', u'secondary_path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_traffic_engineering', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_traffic_engineering', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.secondary_path.lsp_traffic_engineering', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'secpath_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp, secondary_path=secondary_path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp, secondary_path=secondary_path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_select_path_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path': [u'lsp_select_path_secondary_name', u'lsp_select_path_primary'], 'pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path': [u'lsp_select_path_secondary_name', u'lsp_select_path_primary'], 'pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path': [u'lsp_select_path_secondary_name', u'lsp_select_path_primary']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_select_path_lsp_select_path_mode_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_select_path_primary_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_select_path_secondary_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_select_path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_soft_preemption_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_tie_breaking_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_to_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_auto_bandwidth', u'adjustment_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_frr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_revertive'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_select_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'secondary_path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_frr', u'lsp_frr_priority')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'lsp', 'keyval': 'lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'lsp_autobw_template, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}, {'leafval': 'threshold_percentage, use_threshold_table'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_frr_hop_limit, lsp_frr_facility_backup, lsp_frr_link_protection'}, {'leafval': 'lsp_frr_revertive_holdtime, lsp_frr_revertive_mode_global'}, {'leafval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}, {'leafval': 'lsp_setup_priority, lsp_hold_priority'}, {'leafval': 'lsp_select_path_mode, lsp_select_path_primary, lsp_select_path_secondary_name'}, {'leafval': 'lsp_autobw_template, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'lsp_frr_bandwidth, lsp_frr_bandwidth_inherit'}, {'leafval': 'secpath_name, secpath_standby, secpath_bfd, secpath_cspf, secpath_ipmtu, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, secpath_soft_preemption'}, {'leafval': 'lsp_frr_setup_priority, lsp_frr_hold_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_traffic_engineering_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_traffic_engineering', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_traffic_engineering', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_traffic_engineering', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'lsp_te_mean_rate, lsp_te_max_rate, lsp_te_max_burst'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_traffic_engineering_max_burst_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_traffic_engineering', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_traffic_engineering', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_traffic_engineering', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_traffic_engineering_max_rate_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_traffic_engineering', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_traffic_engineering', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_traffic_engineering', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_traffic_engineering_mean_rate_get(self, lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type lsp: lsp_name
    :param lsp: Keyword argument tuple.

    :type lsp_name: unicode
    :param lsp_name: **lsp** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp', u'lsp')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_traffic_engineering', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_traffic_engineering', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp.lsp_traffic_engineering', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}, {'keyval': 'lsp_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, lsp=lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, lsp=lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_xc_traps_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp_xc_traps', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp_xc_traps', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp_xc_traps', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_lsp_xc_traps_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.lsp_xc_traps', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.lsp_xc_traps', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.lsp_xc_traps', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_cmds_holder_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'bypass_lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'lsp_xc_traps'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'policy'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'cspf_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'lsp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'autobw_template'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder', u'path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'bypass_lsp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'policy'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'lsp_xc_traps'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'rsvp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'autobw_template'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder', u'cspf_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_targeted_peer'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'bypass_lsp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'rsvp'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'lsp_xc_traps'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'autobw_template'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'cspf_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_eol'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder', u'policy'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_gr'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp.ldp_holder', u'ldp_session'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'max_bw_threshold'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.bfd.bfd_sub_cmds', u'bfd_min_tx'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.ldp', u'ldp_holder'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.autobw_threshold_table', u'autobw_threshold_table_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.dynamic_bypass', u'mpls_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bypass_lsp_name, bypass_lsp_dest_address, bypass_lsp_src_address, bypass_lsp_tie_breaking, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, bypass_lsp_primary_path, bypass_lsp_enable'}, {'leafval': 'lsp_xc_traps_enable'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'interface_type, interface_name, mpls_interface_ldp_enable'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'add_penalty'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'backup_retry_time, cspf_interface_constraint, handle_isis_neighbor_down, handle_ospf_neighbor_down, load_interval, retry_time, retry_limit, rapid_retry, rsvp_periodic_flooding_time, qos_ttl_mode, ingress_tunnel_accounting, transit_session_accounting, switchover_activation_delay, switchover_hold_tear_delay'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'cspf_group_name'}, {'leafval': 'lsp_name, lsp_dest_address, lsp_cspf, lsp_ipmtu, lsp_metric, lsp_revert_timer, lsp_tie_breaking, lsp_src_address, lsp_primary_path, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, lsp_soft_preemption, lsp_enable'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_template_name, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'refresh_interval, refresh_multiple, global_rsvp_hello_acknowledgements, global_rsvp_hello_unprioritize, g_rsvp_backup_bw_guarantee, delay_resv_send'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'path_name'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'path_name'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'isis_set_level'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'add_penalty'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'lsp_name, lsp_dest_address, lsp_cspf, lsp_ipmtu, lsp_metric, lsp_revert_timer, lsp_tie_breaking, lsp_src_address, lsp_primary_path, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, lsp_soft_preemption, lsp_enable'}, {'leafval': 'bypass_lsp_name, bypass_lsp_dest_address, bypass_lsp_src_address, bypass_lsp_tie_breaking, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, bypass_lsp_primary_path, bypass_lsp_enable'}, {'leafval': 'backup_retry_time, cspf_interface_constraint, handle_isis_neighbor_down, handle_ospf_neighbor_down, load_interval, retry_time, retry_limit, rapid_retry, rsvp_periodic_flooding_time, qos_ttl_mode, ingress_tunnel_accounting, transit_session_accounting'}, {'leafval': 'lsp_xc_traps_enable'}, {'leafval': 'refresh_interval, refresh_multiple, global_rsvp_hello_acknowledgements, global_rsvp_hello_unprioritize, g_rsvp_backup_bw_guarantee'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'interface_type, interface_name, mpls_interface_ldp_enable'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'autobw_template_name, adjustment_interval, adjustment_threshold, min_bandwidth, max_bandwidth, overflow_limit, mode, sample_recording, underflow_limit'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'cspf_group_name'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'lsp_name, lsp_dest_address, lsp_cspf, lsp_ipmtu, lsp_metric, lsp_revert_timer, lsp_tie_breaking, lsp_src_address, lsp_primary_path, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, lsp_soft_preemption, lsp_enable'}, {'leafval': 'ldp_targeted_peer_ip'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'interface_type, interface_name, mpls_interface_ldp_enable'}, {'leafval': 'bypass_lsp_name, bypass_lsp_dest_address, bypass_lsp_src_address, bypass_lsp_tie_breaking, lsp_adaptive, lsp_reoptimize_timer, lsp_commit, lsp_record, lsp_cos, lsp_hop_limit, lsp_cspf_computation_mode, bypass_lsp_primary_path, bypass_lsp_enable'}, {'leafval': 'refresh_interval, refresh_multiple, global_rsvp_hello_acknowledgements, global_rsvp_hello_unprioritize, g_rsvp_backup_bw_guarantee, delay_resv_send'}, {'leafval': 'lsp_xc_traps_enable'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'autobw_template_name, adjustment_interval, min_bandwidth, max_bandwidth, overflow_limit, underflow_limit, mode, sample_recording'}, {'leafval': 'cspf_group_name'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'ldp_eol_tx_silence, ldp_eol_notification'}, {'leafval': 'path_name'}, {'leafval': 'backup_retry_time, cspf_interface_constraint, handle_isis_neighbor_down, handle_ospf_neighbor_down, load_interval, retry_time, retry_limit, rapid_retry, rsvp_periodic_flooding_time, qos_ttl_mode, ingress_tunnel_accounting, transit_session_accounting'}, {'leafval': 'ldp_gr_helper_only, ldp_gr_max_neighbor_reconnect_time, ldp_gr_max_neighbor_recovery_time, ldp_gr_reconnect_time, ldp_gr_recovery_time'}, {'leafval': 'ldp_session_ip, ldp_session_fec_filter_out, ldp_session_auth_key'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'max_bw_threshold_absolute, max_bw_threshold_percentage'}, {'leafval': 'bfd_min_tx_val, bfd_min_rx, bfd_multiplier'}, {'leafval': 'ldp_ecmp, ldp_hello_interval_basic, ldp_hello_interval_target, ldp_hello_timeout_basic, ldp_hello_timeout_target, ldp_ka_int, ldp_ka_int_cnt, ldp_ka_timeout, ldp_fec_filter_in, ldp_fec_filter_out, ldp_advertise_label, ldp_fec_128_for_auto_discovered, ldp_lsr_id, ldp_rcv_label_silence_time, ldp_startup_time, ldp_tunnel_metric, ldp_lw_delay'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'bandwidth_value, autobw_threshold_table_threshold'}, {'leafval': 'dynamic_bypass_max_bypasses, dynamic_bypass_max_bypasses_per_mp, dynamic_bypass_enable_all_interfaces, dynamic_bypass_reoptimize_timer, dynamic_bypass_disable'}, {'leafval': 'add_penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params', u'ldp_param_cmds'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_reliable_messaging'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_refresh_reduction'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'rsvp_reservable_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'rsvp_authentication'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass', u'mpls_interface_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_rsvp_hello'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', u'traffic_eng'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', u'traffic_eng'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_rsvp_hello'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass', u'mpls_interface_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'rsvp_reservable_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'rsvp_authentication'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params', u'ldp_param_cmds'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_refresh_reduction'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', u'priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_reliable_messaging'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'rsvp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_rsvp_hello'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'rsvp_authentication'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'rsvp_reservable_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass', u'mpls_interface_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_reliable_messaging'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', u'traffic_eng'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params', u'ldp_param_cmds'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'rsvp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_refresh_reduction')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mpls_interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_interval, hello_timeout'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit, rsvp_reliable_messaging_disable'}, {'leafval': 'refresh_reduction_all, summary_refresh, rsvp_refresh_reduction_disable'}, {'leafval': 'reservable_bandwidth, reservable_bandwidth_percentage'}, {'leafval': 'rsvp_hello_disable, rsvp_te_metric'}, {'leafval': 'rsvp_authentication_key'}, {'leafval': 'interface_dynamic_bypass_disable, interface_dynamic_bypass_max_bypasses, interface_dynamic_bypass_max_bypasses_per_mp, interface_dynamic_bypass_reoptimize_timer, interface_dynamic_bypass_cos, interface_dynamic_bypass_from, interface_dynamic_bypass_adaptive, interface_dynamic_bypass_record_route, interface_dynamic_bypass_hop_limit, interface_dynamic_bypass_primary_path, interface_dynamic_bypass_name_prefix, interface_dynamic_bypass_tie_breaking, interface_dynamic_bypass_cspf_computation_mode'}, {'leafval': 'interface_dynamic_bypass_setup_priority, interface_dynamic_bypass_holding_priority'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rsvp_hello_interval, rsvp_hello_tolerance'}, {'leafval': 'interface_dynamic_bypass_traffic_eng_max_burst, interface_dynamic_bypass_traffic_eng_max_rate, interface_dynamic_bypass_traffic_eng_mean_rate'}, {'leafval': 'interface_dynamic_bypass_traffic_eng_max_burst, interface_dynamic_bypass_traffic_eng_max_rate, interface_dynamic_bypass_traffic_eng_mean_rate'}, {'leafval': 'rsvp_hello_interval, rsvp_hello_tolerance'}, {'leafval': 'interface_dynamic_bypass_disable, interface_dynamic_bypass_max_bypasses, interface_dynamic_bypass_max_bypasses_per_mp, interface_dynamic_bypass_reoptimize_timer, interface_dynamic_bypass_cos, interface_dynamic_bypass_from, interface_dynamic_bypass_adaptive, interface_dynamic_bypass_record_route, interface_dynamic_bypass_hop_limit, interface_dynamic_bypass_primary_path, interface_dynamic_bypass_name_prefix, interface_dynamic_bypass_tie_breaking, interface_dynamic_bypass_cspf_computation_mode'}, {'leafval': 'reservable_bandwidth, reservable_bandwidth_percentage'}, {'leafval': 'rsvp_authentication_key'}, {'leafval': 'hello_interval, hello_timeout'}, {'leafval': 'refresh_reduction_all, summary_refresh, rsvp_refresh_reduction_disable'}, {'leafval': 'interface_dynamic_bypass_setup_priority, interface_dynamic_bypass_holding_priority'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit, rsvp_reliable_messaging_disable'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rsvp_hello_disable, rsvp_te_metric'}, {'leafval': 'rsvp_hello_interval, rsvp_hello_tolerance'}, {'leafval': 'rsvp_authentication_key'}, {'leafval': 'interface_dynamic_bypass_setup_priority, interface_dynamic_bypass_holding_priority'}, {'leafval': 'reservable_bandwidth, reservable_bandwidth_percentage'}, {'leafval': 'interface_dynamic_bypass_disable, interface_dynamic_bypass_max_bypasses, interface_dynamic_bypass_max_bypasses_per_mp, interface_dynamic_bypass_reoptimize_timer, interface_dynamic_bypass_cos, interface_dynamic_bypass_from, interface_dynamic_bypass_adaptive, interface_dynamic_bypass_record_route, interface_dynamic_bypass_hop_limit, interface_dynamic_bypass_primary_path, interface_dynamic_bypass_name_prefix, interface_dynamic_bypass_tie_breaking, interface_dynamic_bypass_cspf_computation_mode'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit, rsvp_reliable_messaging_disable'}, {'leafval': 'interface_dynamic_bypass_traffic_eng_max_burst, interface_dynamic_bypass_traffic_eng_max_rate, interface_dynamic_bypass_traffic_eng_mean_rate'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'hello_interval, hello_timeout'}, {'leafval': 'rsvp_hello_disable, rsvp_te_metric'}, {'leafval': 'refresh_reduction_all, summary_refresh, rsvp_refresh_reduction_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_adaptive_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_cos_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_cspf_computation_mode_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_disable_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_from_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_hop_limit_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_max_bypasses_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_max_bypasses_per_mp_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_mpls_interface_dynamic_bypass_sub_cmds_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_name_prefix_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_primary_path_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_priority_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.priority', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.priority', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.priority', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_dynamic_bypass_setup_priority, interface_dynamic_bypass_holding_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_priority_interface_dynamic_bypass_holding_priority_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.priority', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.priority', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.priority', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_priority_interface_dynamic_bypass_setup_priority_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.priority', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.priority', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.priority', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_record_route_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_reoptimize_timer_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_tie_breaking_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_traffic_eng_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.traffic_eng', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.traffic_eng', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.traffic_eng', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_dynamic_bypass_traffic_eng_max_burst, interface_dynamic_bypass_traffic_eng_max_rate, interface_dynamic_bypass_traffic_eng_mean_rate'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_traffic_eng_max_burst_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.traffic_eng', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.traffic_eng', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.traffic_eng', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_traffic_eng_max_rate_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.traffic_eng', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.traffic_eng', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.traffic_eng', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_dynamic_bypass_traffic_eng_mean_rate_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.traffic_eng', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.traffic_eng', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds.traffic_eng', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_ldp_enable_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params', u'ldp_param_cmds'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_reliable_messaging'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_refresh_reduction'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'rsvp_reservable_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'rsvp'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'rsvp_authentication'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass', u'mpls_interface_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', u'priority'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_rsvp_hello'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', u'traffic_eng'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', u'traffic_eng'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_rsvp_hello'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass', u'mpls_interface_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'rsvp_reservable_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'rsvp_authentication'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params', u'ldp_param_cmds'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_refresh_reduction'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', u'priority'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_reliable_messaging'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'rsvp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_rsvp_hello'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'rsvp_authentication'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', u'priority'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'rsvp_reservable_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass', u'mpls_interface_dynamic_bypass_sub_cmds'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_reliable_messaging'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.interface_dynamic_bypass.mpls_interface_dynamic_bypass_sub_cmds', u'traffic_eng'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params', u'ldp_param_cmds'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'rsvp'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', u'interface_refresh_reduction')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mpls_interface', 'keyval': 'interface_type, interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hello_interval, hello_timeout'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit, rsvp_reliable_messaging_disable'}, {'leafval': 'refresh_reduction_all, summary_refresh, rsvp_refresh_reduction_disable'}, {'leafval': 'reservable_bandwidth, reservable_bandwidth_percentage'}, {'leafval': 'rsvp_hello_disable, rsvp_te_metric'}, {'leafval': 'rsvp_authentication_key'}, {'leafval': 'interface_dynamic_bypass_disable, interface_dynamic_bypass_max_bypasses, interface_dynamic_bypass_max_bypasses_per_mp, interface_dynamic_bypass_reoptimize_timer, interface_dynamic_bypass_cos, interface_dynamic_bypass_from, interface_dynamic_bypass_adaptive, interface_dynamic_bypass_record_route, interface_dynamic_bypass_hop_limit, interface_dynamic_bypass_primary_path, interface_dynamic_bypass_name_prefix, interface_dynamic_bypass_tie_breaking, interface_dynamic_bypass_cspf_computation_mode'}, {'leafval': 'interface_dynamic_bypass_setup_priority, interface_dynamic_bypass_holding_priority'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rsvp_hello_interval, rsvp_hello_tolerance'}, {'leafval': 'interface_dynamic_bypass_traffic_eng_max_burst, interface_dynamic_bypass_traffic_eng_max_rate, interface_dynamic_bypass_traffic_eng_mean_rate'}, {'leafval': 'interface_dynamic_bypass_traffic_eng_max_burst, interface_dynamic_bypass_traffic_eng_max_rate, interface_dynamic_bypass_traffic_eng_mean_rate'}, {'leafval': 'rsvp_hello_interval, rsvp_hello_tolerance'}, {'leafval': 'interface_dynamic_bypass_disable, interface_dynamic_bypass_max_bypasses, interface_dynamic_bypass_max_bypasses_per_mp, interface_dynamic_bypass_reoptimize_timer, interface_dynamic_bypass_cos, interface_dynamic_bypass_from, interface_dynamic_bypass_adaptive, interface_dynamic_bypass_record_route, interface_dynamic_bypass_hop_limit, interface_dynamic_bypass_primary_path, interface_dynamic_bypass_name_prefix, interface_dynamic_bypass_tie_breaking, interface_dynamic_bypass_cspf_computation_mode'}, {'leafval': 'reservable_bandwidth, reservable_bandwidth_percentage'}, {'leafval': 'rsvp_authentication_key'}, {'leafval': 'hello_interval, hello_timeout'}, {'leafval': 'refresh_reduction_all, summary_refresh, rsvp_refresh_reduction_disable'}, {'leafval': 'interface_dynamic_bypass_setup_priority, interface_dynamic_bypass_holding_priority'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit, rsvp_reliable_messaging_disable'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rsvp_hello_disable, rsvp_te_metric'}, {'leafval': 'rsvp_hello_interval, rsvp_hello_tolerance'}, {'leafval': 'rsvp_authentication_key'}, {'leafval': 'interface_dynamic_bypass_setup_priority, interface_dynamic_bypass_holding_priority'}, {'leafval': 'reservable_bandwidth, reservable_bandwidth_percentage'}, {'leafval': 'interface_dynamic_bypass_disable, interface_dynamic_bypass_max_bypasses, interface_dynamic_bypass_max_bypasses_per_mp, interface_dynamic_bypass_reoptimize_timer, interface_dynamic_bypass_cos, interface_dynamic_bypass_from, interface_dynamic_bypass_adaptive, interface_dynamic_bypass_record_route, interface_dynamic_bypass_hop_limit, interface_dynamic_bypass_primary_path, interface_dynamic_bypass_name_prefix, interface_dynamic_bypass_tie_breaking, interface_dynamic_bypass_cspf_computation_mode'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit, rsvp_reliable_messaging_disable'}, {'leafval': 'interface_dynamic_bypass_traffic_eng_max_burst, interface_dynamic_bypass_traffic_eng_max_rate, interface_dynamic_bypass_traffic_eng_mean_rate'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'hello_interval, hello_timeout'}, {'leafval': 'rsvp_hello_disable, rsvp_te_metric'}, {'leafval': 'refresh_reduction_all, summary_refresh, rsvp_refresh_reduction_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_ldp_params_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_ldp_params_hello_interval_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params.ldp_param_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params.ldp_param_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params.ldp_param_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_ldp_params_hello_timeout_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params.ldp_param_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params.ldp_param_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params.ldp_param_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_ldp_params_ldp_param_cmds_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params.ldp_param_cmds', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params.ldp_param_cmds', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.ldp_params.ldp_param_cmds', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hello_interval, hello_timeout'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_authentication_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_authentication', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_authentication', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_authentication', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_authentication_key_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_authentication', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_authentication', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_authentication', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_hello_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_rsvp_hello', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_rsvp_hello', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_rsvp_hello', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'rsvp_hello_interval, rsvp_hello_tolerance'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_hello_disable_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_hello_interval_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_rsvp_hello', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_rsvp_hello', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_rsvp_hello', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_hello_tolerance_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_rsvp_hello', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_rsvp_hello', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_rsvp_hello', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_refresh_reduction_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_refresh_reduction_all_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_refresh_reduction_bundle_message_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction.bundle_message', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction.bundle_message', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction.bundle_message', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_refresh_reduction_bundle_message_bundle_send_delay_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction.bundle_message', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction.bundle_message', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction.bundle_message', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_refresh_reduction_disable_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_refresh_reduction_summary_refresh_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_refresh_reduction', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_reliable_messaging_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_reliable_messaging_disable_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_reliable_messaging_rapid_retrans_decay_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_reliable_messaging_rapid_retrans_interval_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_reliable_messaging_rapid_retry_limit_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.interface_reliable_messaging', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_reservable_bandwidth_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_reservable_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_reservable_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_reservable_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_reservable_bandwidth': [u'reservable_bandwidth_percentage', u'reservable_bandwidth'], 'pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_reservable_bandwidth': [u'reservable_bandwidth_percentage', u'reservable_bandwidth'], 'pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_reservable_bandwidth': [u'reservable_bandwidth_percentage', u'reservable_bandwidth']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_reservable_bandwidth_percentage_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_reservable_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_reservable_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_reservable_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_reservable_bandwidth_reservable_bandwidth_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_reservable_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_reservable_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_reservable_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_rsvp_intf_flooding_threshold_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_intf_flooding_threshold', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_intf_flooding_threshold', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp.rsvp_intf_flooding_threshold', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_mpls_interface_rsvp_te_metric_get(self, mpls_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_interface: interface_type, interface_name
    :param mpls_interface: Keyword argument tuple.

    :type interface_type: unicode
    :param interface_type: **mpls_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 've']

    :type interface_name: unicode
    :param interface_name: **mpls_interface** tuple argument:  The Interface value.

        * length restriction: ::

            ['1..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6])/([1-9]|[1-9][0-9]|[1-9][0-9]['
            '0-9])(:[1-4])?)|([0-9]([0-9])?([0-9])?([0-9])?))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface', u'mpls_interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.mpls_interface.rsvp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}, {'keyval': 'interface_type, interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_interface=mpls_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_interface=mpls_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_path_get(self, path=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.path', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.path', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.path', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.path', u'path_insert'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.path', u'path_hop'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.path', u'path_insert'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.path', u'path_hop'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.path', u'path_hop'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.path', u'path_insert')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'path', 'keyval': 'path_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'path_insert_ip, path_insert_type, path_insert_before_hop_ip'}, {'leafval': 'path_hop_ip, path_hop_type'}, {'leafval': 'path_insert_ip, path_insert_type, path_insert_before_hop_ip'}, {'leafval': 'path_hop_ip, path_hop_type'}, {'leafval': 'path_hop_ip, path_hop_type'}, {'leafval': 'path_insert_ip, path_insert_type, path_insert_before_hop_ip'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_path_hop_get(self, path=None, path_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type path_hop: path_hop_ip, path_hop_type
    :param path_hop: Keyword argument tuple.

    :type path_hop_ip: unicode
    :param path_hop_ip: **path_hop** tuple argument:  A.B.C.D;;path hop ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type path_hop_type: unicode
    :param path_hop_type: **path_hop** tuple argument:  path hop type

        * enumeration restriction: ::

            ['strict', 'loose']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.path', u'path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.path', u'path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.path', u'path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.path.path_hop', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.path.path_hop', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.path.path_hop', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_hop', 'keyval': 'path_hop_ip', 'extra_keyval': 'path_hop_ip, path_hop_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_hop=path_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_hop=path_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_path_hop_path_hop_type_get(self, path=None, path_hop=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type path_hop: path_hop_ip
    :param path_hop: Keyword argument tuple.

    :type path_hop_ip: unicode
    :param path_hop_ip: **path_hop** tuple argument:  A.B.C.D;;path hop ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.path', u'path'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.path', u'path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.path', u'path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.path.path_hop', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.path.path_hop', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.path.path_hop', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_hop', 'keyval': 'path_hop_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_hop=path_hop)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_hop=path_hop)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_path_insert_get(self, path=None, path_insert=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type path_insert: path_insert_ip
    :param path_insert: Keyword argument tuple.

    :type path_insert_ip: unicode
    :param path_insert_ip: **path_insert** tuple argument:  A.B.C.D;;path hop ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.path', u'path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.path', u'path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.path', u'path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.path.path_insert', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.path.path_insert', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.path.path_insert', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_insert', 'keyval': 'path_insert_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_insert=path_insert)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_insert=path_insert)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_path_insert_before_get(self, path=None, path_insert=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type path_insert: path_insert_ip
    :param path_insert: Keyword argument tuple.

    :type path_insert_ip: unicode
    :param path_insert_ip: **path_insert** tuple argument:  A.B.C.D;;path hop ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.path', u'path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.path', u'path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.path', u'path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.path.path_insert', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.path.path_insert', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.path.path_insert', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_insert', 'keyval': 'path_insert_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_insert=path_insert)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_insert=path_insert)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_path_insert_path_insert_type_get(self, path=None, path_insert=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type path: path_name
    :param path: Keyword argument tuple.

    :type path_name: unicode
    :param path_name: **path** tuple argument:  ASCII string;;Name (up to 64 characters)

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type path_insert: path_insert_ip
    :param path_insert: Keyword argument tuple.

    :type path_insert_ip: unicode
    :param path_insert_ip: **path_insert** tuple argument:  A.B.C.D;;path hop ip address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.path', u'path'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.path', u'path'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.path', u'path')]
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.path.path_insert', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.path.path_insert', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.path.path_insert', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}, {'keyval': 'path_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'path_insert', 'keyval': 'path_insert_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, path=path, path_insert=path_insert)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, path=path, path_insert=path_insert)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'add_penalty'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'add_penalty'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'add_penalty'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy": {"qos_ttl_mode": "qos_ttl_mode", "load_interval": "load_interval", "ingress_tunnel_accounting": "ingress_tunnel_accounting", "rapid_retry": "rapid_retry", "rsvp_periodic_flooding_time": "rsvp_periodic_flooding_time", "handle_ospf_neighbor_down": "handle_ospf_neighbor_down", "backup_retry_time": "backup_retry_time", "transit_session_accounting": "transit_session_accounting", "retry_time": "retry_time", "cspf_interface_constraint": "cspf_interface_constraint", "handle_isis_neighbor_down": "handle_isis_neighbor_down", "retry_limit": "retry_limit"}, "pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy": {}, "pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy": {"qos_ttl_mode": "qos_ttl_mode", "load_interval": "load_interval", "ingress_tunnel_accounting": "ingress_tunnel_accounting", "rapid_retry": "rapid_retry", "rsvp_periodic_flooding_time": "rsvp_periodic_flooding_time", "handle_ospf_neighbor_down": "handle_ospf_neighbor_down", "backup_retry_time": "backup_retry_time", "transit_session_accounting": "transit_session_accounting", "retry_time": "retry_time", "cspf_interface_constraint": "cspf_interface_constraint", "handle_isis_neighbor_down": "handle_isis_neighbor_down", "retry_limit": "retry_limit"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_activation_delay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'add_penalty'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_admin_group_get(self, policy_admin_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type policy_admin_group: admin_group_name, admin_group_number
    :param policy_admin_group: Keyword argument tuple.

    :type admin_group_name: unicode
    :param admin_group_name: **policy_admin_group** tuple argument.

        * length restriction: ::

            ['1..32']

    :type admin_group_number: long
    :param admin_group_number: **policy_admin_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.policy_admin_group', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.policy_admin_group', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.policy_admin_group', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'policy_admin_group', 'keyval': 'admin_group_name, admin_group_number', 'extra_keyval': 'admin_group_name, admin_group_number'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy_admin_group=policy_admin_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy_admin_group=policy_admin_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_auto_bandwidth_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.global_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.global_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.global_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_auto_bandwidth_num_sample_record_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.global_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.global_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.global_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_auto_bandwidth_sample_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.global_auto_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.global_auto_bandwidth', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.global_auto_bandwidth', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_backup_retry_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'add_penalty'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'add_penalty'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'add_penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_cspf_computation_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_cspf_computation_mode_ignore_overload_bit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_cspf_computation_mode_metric_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_cspf_computation_mode_use_bypass_liberal_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_cspf_computation_mode_use_bypass_metric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_computation_mode', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_cspf_group_computation_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_group_computation', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_group_computation', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_group_computation', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_cspf_group_computation_add_penalty_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_group_computation', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_group_computation', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.cspf_group_computation', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_cspf_interface_constraint_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'add_penalty'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'add_penalty'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'add_penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_handle_isis_neighbor_down_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'add_penalty'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'add_penalty'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'add_penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_handle_ospf_neighbor_down_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'add_penalty'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'add_penalty'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'add_penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_hold_tear_delay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'add_penalty'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_implicit_commit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit': [u'implicit_commit_all', u'implicit_commit_autobw_adjustment'], 'pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit': [u'implicit_commit_all', u'implicit_commit_autobw_adjustment'], 'pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit': [u'implicit_commit_all', u'implicit_commit_autobw_adjustment']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_implicit_commit_all_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_implicit_commit_auto_bandwidth_adjustment_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_implicit_commit_lsp_reoptimize_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.implicit_commit', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_ingress_tunnel_accounting_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'add_penalty'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'add_penalty'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'add_penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_load_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'add_penalty'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'add_penalty'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'add_penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_qos_ttl_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'add_penalty'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'add_penalty'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'add_penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_rapid_retry_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'add_penalty'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'add_penalty'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'add_penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_retry_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'add_penalty'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'add_penalty'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'add_penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_retry_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'add_penalty'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'add_penalty'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'add_penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_rsvp_flooding_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.rsvp_flooding_threshold', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.rsvp_flooding_threshold', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.rsvp_flooding_threshold', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_rsvp_periodic_flooding_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'add_penalty'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'add_penalty'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'add_penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_soft_preemption_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.soft_preemption', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.soft_preemption', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.soft_preemption', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_soft_preemption_cleanup_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.soft_preemption', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.soft_preemption', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.soft_preemption', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_traffic_engineering_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_traffic_engineering_isis_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_traffic_engineering_ospf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_traffic_engineering_ospf_area_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area': [u'ospf_area_as_decimal', u'ospf_area_as_ip_address', u'ospf_area_all'], 'pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area': [u'ospf_area_as_decimal', u'ospf_area_as_ip_address', u'ospf_area_all'], 'pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area': [u'ospf_area_as_decimal', u'ospf_area_as_ip_address', u'ospf_area_all']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_traffic_engineering_ospf_area_all_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_traffic_engineering_ospf_area_ospf_area_as_decimal_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_traffic_engineering_ospf_area_ospf_area_as_ip_address_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf.area', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_policy_transit_session_accounting_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'soft_preemption'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'implicit_commit'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'global_auto_bandwidth'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_computation_mode'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy.traffic_engineering.traffic_eng_ospf', u'area'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'traffic_engineering'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'policy_admin_group'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.policy', u'cspf_group_computation')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'isis_set_level'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'add_penalty'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'cleanup_timer'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'add_penalty'}, {'leafval': 'cleanup_timer'}, {'leafval': 'implicit_commit_all, implicit_commit_autobw_adjustment, implicit_commit_lsp_reoptimize_timer'}, {'leafval': 'autobw_sample_interval, autobw_num_sample_record'}, {'leafval': 'use_bypass_liberal, use_bypass_metric, ignore_overload_bit, cspf_metric_type'}, {'leafval': 'ospf_area_as_ip_address, ospf_area_as_decimal, ospf_area_all'}, {'leafval': 'isis_set_level'}, {'leafval': 'admin_group_name, admin_group_number'}, {'leafval': 'add_penalty'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}]
    leafval_map = {"pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp": {"global_rsvp_hello_acknowledgements": "global_rsvp_hello_acknowledgements", "g_rsvp_backup_bw_guarantee": "g_rsvp_backup_bw_guarantee", "delay_resv_send": "delay_resv_send", "global_rsvp_hello_unprioritize": "global_rsvp_hello_unprioritize", "refresh_multiple": "refresh_multiple", "refresh_interval": "refresh_interval"}, "pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp": {}, "pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp": {"global_rsvp_hello_acknowledgements": "global_rsvp_hello_acknowledgements", "g_rsvp_backup_bw_guarantee": "g_rsvp_backup_bw_guarantee", "delay_resv_send": "delay_resv_send", "global_rsvp_hello_unprioritize": "global_rsvp_hello_unprioritize", "refresh_multiple": "refresh_multiple", "refresh_interval": "refresh_interval"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_backup_bw_guarantee_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_delay_resv_send_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'bundle_send_delay'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_hello_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.global_rsvp_hello', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.global_rsvp_hello', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.global_rsvp_hello', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_hello_acknowledgements_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_hello_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.global_rsvp_hello', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.global_rsvp_hello', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.global_rsvp_hello', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_hello_tolerance_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.global_rsvp_hello', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.global_rsvp_hello', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.global_rsvp_hello', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_hello_unprioritize_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_refresh_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_refresh_multiple_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_reliable_messaging'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'g_refresh_reduction'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp', u'global_rsvp_hello')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'rapid_retrans_decay, rapid_retrans_interval, rapid_retry_limit'}, {'leafval': 'refresh_reduction_all, summary_refresh'}, {'leafval': 'global_rsvp_hello_interval, global_rsvp_hello_tolerance'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_refresh_reduction_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bundle_send_delay'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'bundle_send_delay'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_refresh_reduction_all_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bundle_send_delay'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'bundle_send_delay'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_refresh_reduction_bundle_message_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction.bundle_message', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction.bundle_message', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction.bundle_message', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_refresh_reduction_bundle_message_bundle_send_delay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction.bundle_message', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction.bundle_message', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction.bundle_message', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_refresh_reduction_summary_refresh_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_refresh_reduction', u'bundle_message')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bundle_send_delay'}, {'leafval': 'bundle_send_delay'}, {'leafval': 'bundle_send_delay'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_reliable_messaging_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_reliable_messaging', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_reliable_messaging', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_reliable_messaging', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_reliable_messaging_rapid_retrans_decay_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_reliable_messaging', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_reliable_messaging', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_reliable_messaging', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_reliable_messaging_rapid_retrans_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_reliable_messaging', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_reliable_messaging', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_reliable_messaging', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_mpls_rsvp_reliable_messaging_rapid_retry_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_reliable_messaging', 'pybind.slxos.v17r_1_01a.brocade_mpls', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_reliable_messaging', 'pybind.slxos.v17r_2_00.brocade_mpls', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.mpls_config.router.mpls.mpls_cmds_holder.rsvp.g_reliable_messaging', 'pybind.slxos.v17s_1_02.brocade_mpls', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'external_lsa_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability, auth_transition'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'neighbor_addr'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_checksum'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'ospf_route_map'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'connected_route_map'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'route_map, input'}, {'leafval': 'bgp_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'dr_only'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'route_type, route_map_name, dist_value, source_ip, source_ip_mask'}, {'leafval': 'route_map, input'}, {'leafval': 'neighbor_addr'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'ospf_route_map'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'log_checksum'}, {'leafval': 'external_lsa_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'area_id, normal'}, {'leafval': 'neighbor_addr'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'external_lsa_val'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_checksum'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'route_map, input'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'dr_only'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'bgp_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}]
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.ospf": {}, "pybind.slxos.v17r_1_01a.routing_system.router.ospf": {"vrf_lite_capability": "vrf_lite_capability", "database_overflow_interval": "database_overflow_interval", "default_metric": "default_metric", "maximum_paths": "maximum_paths", "ospf_metric_type": "ospf_metric_type", "default_passive_interface": "default_passive_interface", "vrf": "vrf", "external_lsdb_limit": "external_lsdb_limit", "nonstop_routing": "nonstop_routing"}, "pybind.slxos.v17s_1_02.routing_system.router.ospf": {"vrf_lite_capability": "vrf_lite_capability", "database_overflow_interval": "database_overflow_interval", "default_metric": "default_metric", "maximum_paths": "maximum_paths", "ospf_metric_type": "ospf_metric_type", "default_passive_interface": "default_passive_interface", "vrf": "vrf", "external_lsdb_limit": "external_lsdb_limit", "nonstop_routing": "nonstop_routing"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.nssa', u'metric'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.stub', u'metric'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'nssa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'range'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'nssa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.stub', u'metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'range'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.nssa', u'metric'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'nssa'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.stub', u'metric'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'range'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.nssa', u'metric')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nssa_value, no_summary1'}, {'leafval': 'stub_value, no_summary'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_information_originate'}, {'leafval': 'range_address, range_mask, range_effect, range_cost'}, {'leafval': 'virt_link_neighbor, hello_interval, dead_interval, retransmit_interval, transmit_delay'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_information_originate'}, {'leafval': 'virt_link_neighbor, hello_interval, dead_interval, retransmit_interval, transmit_delay'}, {'leafval': 'stub_value, no_summary'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'range_address, range_mask, range_effect, range_cost'}, {'leafval': 'nssa_value, no_summary1'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'virt_link_neighbor, hello_interval, dead_interval, retransmit_interval, transmit_delay'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_information_originate'}, {'leafval': 'stub_value, no_summary'}, {'leafval': 'range_address, range_mask, range_effect, range_cost'}, {'leafval': 'nssa_value, no_summary1'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_normal_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.nssa', u'metric'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.stub', u'metric'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.prefix_list', u'direction_in'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.prefix_list', u'direction_out'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'nssa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'range'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.prefix_list', u'direction_out'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'nssa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.stub', u'metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.prefix_list', u'direction_in'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'range'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.nssa', u'metric'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.prefix_list', u'direction_in'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.prefix_list', u'direction_out'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'nssa'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.stub', u'metric'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'range'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.nssa', u'metric')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'area_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'nssa_value, no_summary1'}, {'leafval': 'stub_value, no_summary'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_information_originate'}, {'leafval': 'range_address, range_mask, range_effect, range_cost'}, {'leafval': 'virt_link_neighbor, hello_interval, dead_interval, retransmit_interval, transmit_delay'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_information_originate'}, {'leafval': 'virt_link_neighbor, hello_interval, dead_interval, retransmit_interval, transmit_delay'}, {'leafval': 'stub_value, no_summary'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'range_address, range_mask, range_effect, range_cost'}, {'leafval': 'nssa_value, no_summary1'}, {'leafval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}, {'leafval': 'virt_link_neighbor, hello_interval, dead_interval, retransmit_interval, transmit_delay'}, {'leafval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}, {'leafval': 'default_information_originate'}, {'leafval': 'stub_value, no_summary'}, {'leafval': 'range_address, range_mask, range_effect, range_cost'}, {'leafval': 'nssa_value, no_summary1'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_nssa_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.nssa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.nssa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.nssa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_nssa_default_information_originate_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.nssa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.nssa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.nssa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_nssa_metric_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.nssa.metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.nssa.metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.nssa.metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'nssa_value, no_summary1'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_nssa_no_summary_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.nssa.metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.nssa.metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.nssa.metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_nssa_nssa_value_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.nssa.metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.nssa.metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.nssa.metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_prefix_list_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.prefix_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.prefix_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.prefix_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_prefix_list_direction_in_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_in_prefix_name, prefix_list_direction_in'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_prefix_list_direction_out_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'prefix_list_direction_out_prefix_name, prefix_list_direction_out'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_prefix_list_in_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_prefix_list_out_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_prefix_list_prefix_list_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.prefix_list.direction_in', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.prefix_list.direction_in', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.prefix_list.direction_in', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_prefix_list_prefix_list_direction_out_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.prefix_list.direction_out', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.prefix_list.direction_out', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.prefix_list.direction_out', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_range_get(self, ospf=None, area=None, range=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type range: range_address, range_mask, range_effect, range_cost
    :param range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **range** tuple argument:  A.B.C.D   IP address to match

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type range_mask: unicode
    :param range_mask: **range** tuple argument:  A.B.C.D   IP mask for address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type range_effect: unicode
    :param range_effect: **range** tuple argument:  Advertise/Do not advertise this type-3 summarization

        * enumeration restriction: ::

            ['advertise', 'not-advertise']

    :type range_cost: long
    :param range_cost: **range** tuple argument:  Configure area range cost

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.range', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.range', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.range', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'range', 'keyval': 'range_address, range_mask', 'extra_keyval': 'range_address, range_mask, range_effect, range_cost'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, range=range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, range=range)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_range_cost_get(self, ospf=None, area=None, range=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type range: range_address, range_mask
    :param range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **range** tuple argument:  A.B.C.D   IP address to match

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type range_mask: unicode
    :param range_mask: **range** tuple argument:  A.B.C.D   IP mask for address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.range', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.range', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.range', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'range', 'keyval': 'range_address, range_mask', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, range=range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, range=range)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_range_range_effect_get(self, ospf=None, area=None, range=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type range: range_address, range_mask
    :param range: Keyword argument tuple.

    :type range_address: unicode
    :param range_address: **range** tuple argument:  A.B.C.D   IP address to match

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type range_mask: unicode
    :param range_mask: **range** tuple argument:  A.B.C.D   IP mask for address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.range', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.range', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.range', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'range', 'keyval': 'range_address, range_mask', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, range=range)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, range=range)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_stub_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.stub', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.stub', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.stub', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_stub_metric_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.stub.metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.stub.metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.stub.metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'stub_value, no_summary'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_stub_no_summary_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.stub.metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.stub.metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.stub.metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_stub_stub_value_get(self, ospf=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.stub.metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.stub.metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.stub.metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'authentication'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication', u'key_table')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'key_chain'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'key_id, key, md5_authentication_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_authentication_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_authentication_key_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.authentication_key', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication_key', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.authentication_key', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_authentication_key_auth_key_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_authentication_key_auth_key_table_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'encrypttype, auth_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_authentication_key_chain_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_authentication_key_encrypttype_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.authentication_key.auth_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_authentication_key_no_encrypt_auth_key_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_authentication_key_no_encrypt_auth_key_table_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.authentication_key.no_encrypt_auth_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_dead_interval_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'authentication'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication', u'key_table')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'key_chain'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'key_id, key, md5_authentication_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_hello_interval_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'authentication'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication', u'key_table')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'key_chain'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'key_id, key, md5_authentication_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_md5_authentication_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_md5_authentication_key_activation_wait_time_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_md5_authentication_key_id_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'key_id, key, md5_authentication_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_md5_authentication_key_id_key_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_md5_authentication_key_id_key_id_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication.key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_md5_authentication_no_encrypt_key_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_md5_authentication_no_encrypt_key_id_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_md5_authentication_no_encrypt_key_table_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'virtual_link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'virtual_link')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication.no_encrypt_key_table', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'virt_link_neighbor', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'no_encrypt_key_id, no_encrypt_key'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_retransmit_interval_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'authentication'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication', u'key_table')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'key_chain'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'key_id, key, md5_authentication_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_area_virtual_link_transmit_delay_get(self, ospf=None, area=None, virtual_link=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type area: area_id
    :param area: Keyword argument tuple.

    :type area_id: unicode
    :param area_id: **area** tuple argument.

        * pattern restriction: ::

            '((([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0'
            '-5])\.)(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9'
            ']|25[0-5])\.){2}([0-9]|[1-9][0-9]|1[0-9][0-9]|2['
            '0-4][0-9]|25[0-5]))|(([0-9])|([1-9]([0-9]{1,8}))'
            '|([1]([0-9]{1,9}))|([2][0]([0-9]{1,8}))|([2][1]['
            '0-3]([0-9]{1,7}))|([2][1][4][0-6]([0-9]{1,6}))|('
            '[2][1][4][7][0-3]([0-9]{1,5}))|([2][1][4][7][4]['
            '0-7]([0-9]{1,4}))|([2][1][4][7][4][8][0-2]([0-9]'
            '{1,3}))|([2][1][4][7][4][8][3][0-5]([0-9]{1,2}))'
            '|([2][1][4][7][4][8][3][6][0-3][0-9])|([2][1][4]'
            '[7][4][8][3][6][4][0-7]))'

    **Instance Keyword Argument Tuple**:

    :type virtual_link: virt_link_neighbor
    :param virtual_link: Keyword argument tuple.

    :type virt_link_neighbor: unicode
    :param virt_link_neighbor: **virtual_link** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area', u'area')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.md5_authentication', u'key_table'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication', u'key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.area.virtual_link', u'authentication'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link', u'md5_authentication'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.authentication_key', u'no_encrypt_auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication', u'no_encrypt_key_table'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.authentication_key', u'auth_key_table'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.area.virtual_link.md5_authentication', u'key_table')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'area_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'virtual_link', 'keyval': 'virt_link_neighbor', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'key_id, key, md5_authentication_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'key_chain'}, {'leafval': 'key_activation_wait_time'}, {'leafval': 'no_encrypt_auth_key'}, {'leafval': 'no_encrypt_key_id, no_encrypt_key'}, {'leafval': 'encrypttype, auth_key'}, {'leafval': 'key_id, key, md5_authentication_key'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, area=area, virtual_link=virtual_link)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, area=area, virtual_link=virtual_link)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_auth_transition_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'adjacency')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'external_lsa_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability, auth_transition'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'neighbor_addr'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_checksum'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'ospf_route_map'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'connected_route_map'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'route_map, input'}, {'leafval': 'bgp_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'dr_only'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_auto_cost_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.auto_cost', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.auto_cost', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.auto_cost', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_auto_cost_reference_bandwidth_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.auto_cost.reference_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.auto_cost.reference_bandwidth', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.auto_cost.reference_bandwidth', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_auto_cost_reference_bandwidth_ref_bandwidth_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.auto_cost.reference_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.auto_cost.reference_bandwidth', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.auto_cost.reference_bandwidth', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_auto_cost_reference_bandwidth_use_active_ports_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.auto_cost.reference_bandwidth', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.auto_cost.reference_bandwidth', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.auto_cost.reference_bandwidth', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_bfd_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.global_bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.global_bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.global_bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_bfd_bfd_enable_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.global_bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.global_bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.global_bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_bfd_holdover_interval_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.global_bfd', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.global_bfd', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.global_bfd', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_database_overflow_interval_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'adjacency')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'route_type, route_map_name, dist_value, source_ip, source_ip_mask'}, {'leafval': 'route_map, input'}, {'leafval': 'neighbor_addr'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'ospf_route_map'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'log_checksum'}, {'leafval': 'external_lsa_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'area_id, normal'}, {'leafval': 'neighbor_addr'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'external_lsa_val'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_checksum'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'route_map, input'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'dr_only'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'bgp_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'external_lsa_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability, auth_transition'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'neighbor_addr'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_checksum'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'ospf_route_map'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'connected_route_map'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'route_map, input'}, {'leafval': 'bgp_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'dr_only'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_default_information_originate_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_default_information_originate_always_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_default_information_originate_metric_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_default_information_originate_metric_type_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_default_information_originate_route_map_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.default_information_originate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_default_metric_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'adjacency')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'route_type, route_map_name, dist_value, source_ip, source_ip_mask'}, {'leafval': 'route_map, input'}, {'leafval': 'neighbor_addr'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'ospf_route_map'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'log_checksum'}, {'leafval': 'external_lsa_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'area_id, normal'}, {'leafval': 'neighbor_addr'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'external_lsa_val'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_checksum'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'route_map, input'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'dr_only'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'bgp_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'external_lsa_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability, auth_transition'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'neighbor_addr'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_checksum'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'ospf_route_map'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'connected_route_map'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'route_map, input'}, {'leafval': 'bgp_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'dr_only'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_default_passive_interface_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'adjacency')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'route_type, route_map_name, dist_value, source_ip, source_ip_mask'}, {'leafval': 'route_map, input'}, {'leafval': 'neighbor_addr'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'ospf_route_map'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'log_checksum'}, {'leafval': 'external_lsa_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'area_id, normal'}, {'leafval': 'neighbor_addr'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'external_lsa_val'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_checksum'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'route_map, input'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'dr_only'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'bgp_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'external_lsa_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability, auth_transition'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'neighbor_addr'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_checksum'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'ospf_route_map'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'connected_route_map'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'route_map, input'}, {'leafval': 'bgp_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'dr_only'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_deny_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.deny', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.deny', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.deny', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_deny_redistribute_get(self, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option, address, mask, set_metric_val, match_metric_val
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type address: unicode
    :param address: **redistribute** tuple argument:  IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mask: unicode
    :param mask: **redistribute** tuple argument:  Subnet Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type set_metric_val: long
    :param set_metric_val: **redistribute** tuple argument:  Metric value

        * range restriction: ::

            ['0..4294967295']

    :type match_metric_val: long
    :param match_metric_val: **redistribute** tuple argument:  Metric value

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_deny_redistribute_address_get(self, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_deny_redistribute_mask_get(self, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_deny_redistribute_match_metric_get(self, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_deny_redistribute_set_metric_get(self, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.deny.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_distance_get(self, ospf=None, distance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propogation

        * enumeration restriction: ::

            ['intra-area', 'external', 'inter-area']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.distance', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.distance', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.distance', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': 'route_type, route_map_name, dist_value, source_ip, source_ip_mask'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.routing_system.router.ospf.distance": {"route_type": "route_type", "dist_value": "dist_value"}, "pybind.slxos.v17r_1_01a.routing_system.router.ospf.distance": {"route_type": "route_type", "dist_value": "dist_value"}, "pybind.slxos.v17s_1_02.routing_system.router.ospf.distance": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, distance=distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, distance=distance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_distance_dist_value_get(self, ospf=None, distance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propogation

        * enumeration restriction: ::

            ['intra-area', 'external', 'inter-area']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.distance', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.distance', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.distance', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, distance=distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, distance=distance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_distance_route_map_name_get(self, ospf=None, distance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propogation

        * enumeration restriction: ::

            ['route-map',
            'intra-area',
            'external',
            'inter-area']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf.distance', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, distance=distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, distance=distance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_distance_source_ip_get(self, ospf=None, distance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propogation

        * enumeration restriction: ::

            ['route-map',
            'intra-area',
            'external',
            'inter-area']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf.distance', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, distance=distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, distance=distance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_distance_source_ip_mask_get(self, ospf=None, distance=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type distance: route_type
    :param distance: Keyword argument tuple.

    :type route_type: unicode
    :param route_type: **distance** tuple argument:  The type of route propogation

        * enumeration restriction: ::

            ['route-map',
            'intra-area',
            'external',
            'inter-area']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf.distance', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'distance', 'keyval': 'route_type', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, distance=distance)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, distance=distance)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_distribute_list_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.distribute_list', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.distribute_list', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.distribute_list', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_distribute_list_route_map_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.distribute_list.route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.distribute_list.route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.distribute_list.route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'route_map, input'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_distribute_list_route_map_in_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.distribute_list.route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.distribute_list.route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.distribute_list.route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_distribute_list_route_map_route_map_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.distribute_list.route_map', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.distribute_list.route_map', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.distribute_list.route_map', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_external_lsdb_limit_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'adjacency')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'route_type, route_map_name, dist_value, source_ip, source_ip_mask'}, {'leafval': 'route_map, input'}, {'leafval': 'neighbor_addr'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'ospf_route_map'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'log_checksum'}, {'leafval': 'external_lsa_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'area_id, normal'}, {'leafval': 'neighbor_addr'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'external_lsa_val'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_checksum'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'route_map, input'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'dr_only'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'bgp_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'external_lsa_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability, auth_transition'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'neighbor_addr'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_checksum'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'ospf_route_map'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'connected_route_map'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'route_map, input'}, {'leafval': 'bgp_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'dr_only'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_graceful_restart_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_graceful_restart_graceful_restart_enable_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_graceful_restart_helper_disable_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_graceful_restart_restart_time_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.graceful_restart', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.graceful_restart', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.graceful_restart', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_ldp_sync_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.ldp_sync', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.ldp_sync', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.ldp_sync', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'ldp_sync_hold_down'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_ldp_sync_hold_down_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.ldp_sync', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.ldp_sync', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.ldp_sync', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_log_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_log_adjacency_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log.adjacency', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log.adjacency', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log.adjacency', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_log_adjacency_dr_only_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log.adjacency', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log.adjacency', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log.adjacency', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_log_all_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_log_bad_packet_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log.bad_packet', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log.bad_packet', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log.bad_packet', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_log_bad_packet_checksum_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log.bad_packet', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log.bad_packet', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log.bad_packet', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_log_database_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_log_retransmit_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_all_lsas_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_all_vrfs_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_external_lsa_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_external_lsa_external_lsa_val_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.external_lsa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_link_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_link_all_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_link_ptp_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_link_stub_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_link_transit_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.link', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_all_lsas_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_external_lsa_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_external_lsa_external_lsa_val_onstartup_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup.external_lsa_onstartup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_link_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_link_all_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_link_ptp_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_link_stub_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_link_transit_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup.link_onstartup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_summary_lsa_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_summary_lsa_summary_lsa_val_onstartup_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup.summary_lsa_onstartup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_time_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_on_startup_wait_for_bgp_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_summary_lsa_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_max_metric_router_lsa_summary_lsa_summary_lsa_val_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.summary_lsa', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_maximum_paths_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'adjacency')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'route_type, route_map_name, dist_value, source_ip, source_ip_mask'}, {'leafval': 'route_map, input'}, {'leafval': 'neighbor_addr'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'ospf_route_map'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'log_checksum'}, {'leafval': 'external_lsa_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'area_id, normal'}, {'leafval': 'neighbor_addr'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'external_lsa_val'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_checksum'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'route_map, input'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'dr_only'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'bgp_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'external_lsa_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability, auth_transition'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'neighbor_addr'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_checksum'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'ospf_route_map'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'connected_route_map'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'route_map, input'}, {'leafval': 'bgp_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'dr_only'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_metric_type_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'adjacency')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'route_type, route_map_name, dist_value, source_ip, source_ip_mask'}, {'leafval': 'route_map, input'}, {'leafval': 'neighbor_addr'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'ospf_route_map'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'log_checksum'}, {'leafval': 'external_lsa_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'area_id, normal'}, {'leafval': 'neighbor_addr'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'external_lsa_val'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_checksum'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'route_map, input'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'dr_only'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'bgp_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'external_lsa_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability, auth_transition'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'neighbor_addr'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_checksum'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'ospf_route_map'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'connected_route_map'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'route_map, input'}, {'leafval': 'bgp_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'dr_only'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_neighbor_get(self, ospf=None, neighbor=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type neighbor: neighbor_addr
    :param neighbor: Keyword argument tuple.

    :type neighbor_addr: unicode
    :param neighbor_addr: **neighbor** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.neighbor', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.neighbor', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.neighbor', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'neighbor', 'keyval': 'neighbor_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, neighbor=neighbor)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, neighbor=neighbor)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_nonstop_routing_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'adjacency')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'route_type, route_map_name, dist_value, source_ip, source_ip_mask'}, {'leafval': 'route_map, input'}, {'leafval': 'neighbor_addr'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'ospf_route_map'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'log_checksum'}, {'leafval': 'external_lsa_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'area_id, normal'}, {'leafval': 'neighbor_addr'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'external_lsa_val'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_checksum'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'route_map, input'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'dr_only'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'bgp_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'external_lsa_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability, auth_transition'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'neighbor_addr'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_checksum'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'ospf_route_map'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'connected_route_map'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'route_map, input'}, {'leafval': 'bgp_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'dr_only'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_permit_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.permit', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.permit', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.permit', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_permit_redistribute_get(self, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option, address, mask, set_metric_val, match_metric_val
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type address: unicode
    :param address: **redistribute** tuple argument:  IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mask: unicode
    :param mask: **redistribute** tuple argument:  Subnet Mask

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type set_metric_val: long
    :param set_metric_val: **redistribute** tuple argument:  Metric value

        * range restriction: ::

            ['0..4294967295']

    :type match_metric_val: long
    :param match_metric_val: **redistribute** tuple argument:  Metric value

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_permit_redistribute_address_get(self, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_permit_redistribute_mask_get(self, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_permit_redistribute_match_metric_get(self, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_permit_redistribute_set_metric_get(self, ospf=None, redistribute=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type redistribute: redist_value, route_option
    :param redistribute: Keyword argument tuple.

    :type redist_value: long
    :param redist_value: **redistribute** tuple argument:  Number

        * range restriction: ::

            ['0..4294967295']

    :type route_option: unicode
    :param route_option: **redistribute** tuple argument:  OSPF route option

        * enumeration restriction: ::

            ['connected', 'all', 'static']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.permit.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'redistribute', 'keyval': 'redist_value, route_option', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, redistribute=redistribute)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, redistribute=redistribute)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_redistribute_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_redistribute_bgp_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_redistribute_bgp_route_map_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute.bgp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute.bgp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute.bgp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_redistribute_connected_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_redistribute_connected_route_map_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute.connected', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute.connected', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute.connected', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_redistribute_isis_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute.isis': [u'isis_level_two', u'isis_level_one', u'isis_level_one_and_two'], 'pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute.isis': [u'isis_level_two', u'isis_level_one', u'isis_level_one_and_two'], 'pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute.isis': [u'isis_level_two', u'isis_level_one', u'isis_level_one_and_two']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_redistribute_isis_level_1_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_redistribute_isis_level_1_2_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_redistribute_isis_level_2_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_redistribute_isis_route_map_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute.isis', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_redistribute_ospf_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_redistribute_ospf_route_map_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute.redistribute_ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_redistribute_static_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_redistribute_static_route_map_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute.static', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute.static', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute.static', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_rfc1583_compatibility_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.rfc1583_compatibility', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.rfc1583_compatibility', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.rfc1583_compatibility', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_rfc1583_compatibility_rfc1583_compatibility_flag_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.rfc1583_compatibility', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.rfc1583_compatibility', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.rfc1583_compatibility', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_summary_address_get(self, ospf=None, summary_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    **Instance Keyword Argument Tuple**:

    :type summary_address: sum_address, sum_address_mask
    :param summary_address: Keyword argument tuple.

    :type sum_address: unicode
    :param sum_address: **summary_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type sum_address_mask: unicode
    :param sum_address_mask: **summary_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.summary_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.summary_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.summary_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'summary_address', 'keyval': 'sum_address, sum_address_mask', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf, summary_address=summary_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf, summary_address=summary_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_timers_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_timers_lsa_group_pacing_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.timers', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.timers', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_timers_throttle_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.timers.throttle', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers.throttle', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.timers.throttle', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_timers_throttle_spf_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.timers.throttle.spf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers.throttle.spf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.timers.throttle.spf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'init_delay, hold_time, max_hold_time'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_timers_throttle_spf_hold_time_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.timers.throttle.spf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers.throttle.spf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.timers.throttle.spf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_timers_throttle_spf_init_delay_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.timers.throttle.spf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers.throttle.spf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.timers.throttle.spf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_timers_throttle_spf_max_hold_time_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ospf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf.timers.throttle.spf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers.throttle.spf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.timers.throttle.spf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_ospf_vrf_lite_capability_get(self, ospf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type ospf: vrf
    :param ospf: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **ospf** tuple argument:  Create a VRF

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.ospf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'area'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17s_1_02.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.log', u'adjacency'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric', u'router_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'link'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'area'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'external_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'link_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'global_bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.permit', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'bad_packet'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'isis'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.auto_cost', u'reference_bandwidth'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'rfc1583_compatibility'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'redistribute_ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'summary_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa.on_startup', u'external_lsa_onstartup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.max_metric.router_lsa', u'summary_lsa'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.distribute_list', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.deny', u'redistribute'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.timers.throttle', u'spf'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.ospf.log', u'adjacency')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'ospf', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'route_type, route_map_name, dist_value, source_ip, source_ip_mask'}, {'leafval': 'route_map, input'}, {'leafval': 'neighbor_addr'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'static_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'ospf_route_map'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'dr_only'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'log_checksum'}, {'leafval': 'external_lsa_val'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_route_map'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'area_id, normal'}, {'leafval': 'neighbor_addr'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'external_lsa_val'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'log_checksum'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'ospf_route_map'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'route_map, input'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'connected_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'dr_only'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'bgp_route_map'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'all_vrfs, all_lsas'}, {'leafval': 'all, ptp, stub, transit'}, {'leafval': 'area_id, normal'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'sum_address, sum_address_mask'}, {'leafval': 'external_lsa_val'}, {'leafval': 'log_all, log_database, log_retransmit'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability, auth_transition'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'static_route_map'}, {'leafval': 'all_link_onstartup, ptp_link_onstartup, stub_link_onstartup, transit_link_onstartup'}, {'leafval': 'bfd_enable, holdover_interval'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'neighbor_addr'}, {'leafval': 'lsa_group_pacing'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'log_checksum'}, {'leafval': 'isis_level_one, isis_level_two, isis_level_one_and_two, isis_route_map'}, {'leafval': 'always, def_orig_metric, def_orig_metric_type, def_orig_route_map'}, {'leafval': 'ref_bandwidth, use_active_ports'}, {'leafval': 'rfc1583_compatibility_flag'}, {'leafval': 'ospf_route_map'}, {'leafval': 'summary_lsa_val_onstartup'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'external_lsa_val_onstartup'}, {'leafval': 'connected_route_map'}, {'leafval': 'route_type, dist_value'}, {'leafval': 'time, wait_for_bgp, all_lsas_onstartup'}, {'leafval': 'summary_lsa_val'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'route_map, input'}, {'leafval': 'bgp_route_map'}, {'leafval': 'redist_value, route_option, address, mask, set_metric_val, match_metric_val'}, {'leafval': 'init_delay, hold_time, max_hold_time'}, {'leafval': 'graceful_restart_enable, helper_disable, restart_time'}, {'leafval': 'dr_only'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, ospf=ospf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, ospf=ospf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'rp_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'route_precedence'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'ssm_enable'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'anycast_rp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'anycast_rp_ip'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'route_precedence'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'rp_address'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'anycast_rp_ip'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'ssm_enable'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'anycast_rp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'pim', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'range'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'rebalance'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rebalance'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'range'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_anycast_rp_get(self, pim=None, anycast_rp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type anycast_rp: anycast_ip_addr, anycast_prefix_list
    :param anycast_rp: Keyword argument tuple.

    :type anycast_ip_addr: unicode
    :param anycast_ip_addr: **anycast_rp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type anycast_prefix_list: unicode
    :param anycast_prefix_list: **anycast_rp** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.anycast_rp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.anycast_rp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.anycast_rp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'anycast_rp', 'keyval': 'anycast_ip_addr', 'extra_keyval': 'anycast_ip_addr, anycast_prefix_list'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim, anycast_rp=anycast_rp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim, anycast_rp=anycast_rp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_anycast_rp_anycast_prefix_list_get(self, pim=None, anycast_rp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type anycast_rp: anycast_ip_addr
    :param anycast_rp: Keyword argument tuple.

    :type anycast_ip_addr: unicode
    :param anycast_ip_addr: **anycast_rp** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.anycast_rp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.anycast_rp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.anycast_rp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'anycast_rp', 'keyval': 'anycast_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim, anycast_rp=anycast_rp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim, anycast_rp=anycast_rp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_anycast_rp_ip_get(self, pim=None, anycast_rp_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type anycast_rp_ip: anycast_rp_ip_addr
    :param anycast_rp_ip: Keyword argument tuple.

    :type anycast_rp_ip_addr: unicode
    :param anycast_rp_ip_addr: **anycast_rp_ip** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.anycast_rp_ip', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.anycast_rp_ip', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.anycast_rp_ip', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'anycast_rp_ip', 'keyval': 'anycast_rp_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim, anycast_rp_ip=anycast_rp_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim, anycast_rp_ip=anycast_rp_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_anycast_rp_ip_anycast_peer_ip_addr_get(self, pim=None, anycast_rp_ip=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type anycast_rp_ip: anycast_rp_ip_addr
    :param anycast_rp_ip: Keyword argument tuple.

    :type anycast_rp_ip_addr: unicode
    :param anycast_rp_ip_addr: **anycast_rp_ip** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.anycast_rp_ip', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.anycast_rp_ip', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.anycast_rp_ip', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'anycast_rp_ip', 'keyval': 'anycast_rp_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim, anycast_rp_ip=anycast_rp_ip)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim, anycast_rp_ip=anycast_rp_ip)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_bsr_candidate_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.bsr_candidate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.bsr_candidate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.bsr_candidate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.bsr_candidate', u'bsr_cand_interface')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_bsr_candidate_interface_get(self, pim=None, bsr_cand_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type bsr_cand_interface: bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority
    :param bsr_cand_interface: Keyword argument tuple.

    :type bsr_cand_intf_type: unicode
    :param bsr_cand_intf_type: **bsr_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel', 've', 'loopback']

    :type bsr_cand_intf_id: unicode
    :param bsr_cand_intf_id: **bsr_cand_interface** tuple argument:  Interface name in slot/port format for ethernet or port-channel/ve/loopback interface number

    :type hash_mask_length: int
    :param hash_mask_length: **bsr_cand_interface** tuple argument:  BSR hash mask

        * range restriction: ::

            ['0..65535']

    :type bsr_cand_priority: long
    :param bsr_cand_priority: **bsr_cand_interface** tuple argument:  BSR priority

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.bsr_candidate.bsr_cand_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.bsr_candidate.bsr_cand_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bsr_cand_interface', 'keyval': 'bsr_cand_intf_type, bsr_cand_intf_id', 'extra_keyval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim, bsr_cand_interface=bsr_cand_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim, bsr_cand_interface=bsr_cand_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_bsr_candidate_interface_mask_get(self, pim=None, bsr_cand_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type bsr_cand_interface: bsr_cand_intf_type, bsr_cand_intf_id
    :param bsr_cand_interface: Keyword argument tuple.

    :type bsr_cand_intf_type: unicode
    :param bsr_cand_intf_type: **bsr_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel', 've', 'loopback']

    :type bsr_cand_intf_id: unicode
    :param bsr_cand_intf_id: **bsr_cand_interface** tuple argument:  Interface name in slot/port format for ethernet or port-channel/ve/loopback interface number

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.bsr_candidate.bsr_cand_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.bsr_candidate.bsr_cand_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bsr_cand_interface', 'keyval': 'bsr_cand_intf_type, bsr_cand_intf_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim, bsr_cand_interface=bsr_cand_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim, bsr_cand_interface=bsr_cand_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_bsr_candidate_interface_priority_get(self, pim=None, bsr_cand_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type bsr_cand_interface: bsr_cand_intf_type, bsr_cand_intf_id
    :param bsr_cand_interface: Keyword argument tuple.

    :type bsr_cand_intf_type: unicode
    :param bsr_cand_intf_type: **bsr_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel', 've', 'loopback']

    :type bsr_cand_intf_id: unicode
    :param bsr_cand_intf_id: **bsr_cand_interface** tuple argument:  Interface name in slot/port format for ethernet or port-channel/ve/loopback interface number

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.bsr_candidate.bsr_cand_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.bsr_candidate.bsr_cand_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.bsr_candidate.bsr_cand_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bsr_cand_interface', 'keyval': 'bsr_cand_intf_type, bsr_cand_intf_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim, bsr_cand_interface=bsr_cand_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim, bsr_cand_interface=bsr_cand_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_hello_interval_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'rp_address'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'route_precedence'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'ssm_enable'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp_ip'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'rp_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'route_precedence'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'ssm_enable'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'anycast_rp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'anycast_rp_ip'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'route_precedence'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'rp_address'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'anycast_rp_ip'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'ssm_enable'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'anycast_rp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'pim', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'range'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'rebalance'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'range'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'rebalance'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rebalance'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'range'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}]
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim": {}, "pybind.slxos.v17r_1_01a.routing_system.router.pim": {"vrf": "vrf", "hello_interval": "hello_interval"}, "pybind.slxos.v17r_2_00.routing_system.router.pim": {"vrf": "vrf", "hello_interval": "hello_interval"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_inactivity_timer_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'rp_address'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'route_precedence'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'ssm_enable'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp_ip'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'rp_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'route_precedence'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'ssm_enable'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'anycast_rp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'anycast_rp_ip'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'route_precedence'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'rp_address'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'anycast_rp_ip'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'ssm_enable'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'anycast_rp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'pim', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'range'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'rebalance'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'range'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'rebalance'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rebalance'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'range'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}]
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim": {}, "pybind.slxos.v17r_1_01a.routing_system.router.pim": {"inactivity_timer": "inactivity_timer", "vrf": "vrf"}, "pybind.slxos.v17r_2_00.routing_system.router.pim": {"inactivity_timer": "inactivity_timer", "vrf": "vrf"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_max_mcache_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'rp_address'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'route_precedence'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'ssm_enable'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp_ip'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'rp_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'route_precedence'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'ssm_enable'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'anycast_rp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'anycast_rp_ip'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'route_precedence'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'rp_address'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'anycast_rp_ip'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'ssm_enable'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'anycast_rp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'pim', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'range'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'rebalance'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'range'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'rebalance'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rebalance'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'range'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}]
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim": {}, "pybind.slxos.v17r_1_01a.routing_system.router.pim": {"max_mcache": "max_mcache", "vrf": "vrf"}, "pybind.slxos.v17r_2_00.routing_system.router.pim": {"max_mcache": "max_mcache", "vrf": "vrf"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_message_interval_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'rp_address'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'route_precedence'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'ssm_enable'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp_ip'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'rp_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'route_precedence'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'ssm_enable'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'anycast_rp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'anycast_rp_ip'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'route_precedence'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'rp_address'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'anycast_rp_ip'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'ssm_enable'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'anycast_rp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'pim', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'range'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'rebalance'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'range'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'rebalance'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rebalance'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'range'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}]
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim": {}, "pybind.slxos.v17r_1_01a.routing_system.router.pim": {"message_interval": "message_interval", "vrf": "vrf"}, "pybind.slxos.v17r_2_00.routing_system.router.pim": {"message_interval": "message_interval", "vrf": "vrf"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_nbr_timeout_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'rp_address'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'route_precedence'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'ssm_enable'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp_ip'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'rp_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'route_precedence'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'ssm_enable'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'anycast_rp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'anycast_rp_ip'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'route_precedence'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'rp_address'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'anycast_rp_ip'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'ssm_enable'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'anycast_rp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'pim', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'range'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'rebalance'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'range'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'rebalance'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rebalance'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'range'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}]
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim": {}, "pybind.slxos.v17r_1_01a.routing_system.router.pim": {"nbr_timeout": "nbr_timeout", "vrf": "vrf"}, "pybind.slxos.v17r_2_00.routing_system.router.pim": {"nbr_timeout": "nbr_timeout", "vrf": "vrf"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_prune_wait_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'rp_address'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'route_precedence'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'ssm_enable'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp_ip'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'rp_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'route_precedence'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'ssm_enable'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'anycast_rp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'anycast_rp_ip'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'route_precedence'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'rp_address'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'anycast_rp_ip'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'ssm_enable'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'anycast_rp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'pim', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'range'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'rebalance'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'range'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'rebalance'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rebalance'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'range'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}]
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim": {}, "pybind.slxos.v17r_1_01a.routing_system.router.pim": {"prune_wait": "prune_wait", "vrf": "vrf"}, "pybind.slxos.v17r_2_00.routing_system.router.pim": {"prune_wait": "prune_wait", "vrf": "vrf"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_route_precedence_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.route_precedence', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.route_precedence', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.route_precedence', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'uc_default, uc_non_default, none'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_route_precedence_none_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.route_precedence', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.route_precedence', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.route_precedence', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_route_precedence_uc_default_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.route_precedence', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.route_precedence', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.route_precedence', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_route_precedence_uc_non_default_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.route_precedence', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.route_precedence', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.route_precedence', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_rp_address_get(self, pim=None, rp_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type rp_address: rp_ip_addr, rp_addr_prefix_list
    :param rp_address: Keyword argument tuple.

    :type rp_ip_addr: unicode
    :param rp_ip_addr: **rp_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type rp_addr_prefix_list: unicode
    :param rp_addr_prefix_list: **rp_address** tuple argument:  Prefix list

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rp_address', 'keyval': 'rp_ip_addr', 'extra_keyval': 'rp_ip_addr, rp_addr_prefix_list'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim, rp_address=rp_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim, rp_address=rp_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_rp_address_prefix_list_get(self, pim=None, rp_address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type rp_address: rp_ip_addr
    :param rp_address: Keyword argument tuple.

    :type rp_ip_addr: unicode
    :param rp_ip_addr: **rp_address** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_address', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_address', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_address', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rp_address', 'keyval': 'rp_ip_addr', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim, rp_address=rp_address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim, rp_address=rp_address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_rp_candidate_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_interface')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_rp_candidate_interface_get(self, pim=None, rp_cand_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type rp_cand_interface: rp_cand_intf_type, rp_cand_intf_id
    :param rp_cand_interface: Keyword argument tuple.

    :type rp_cand_intf_type: unicode
    :param rp_cand_intf_type: **rp_cand_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel', 've', 'loopback']

    :type rp_cand_intf_id: unicode
    :param rp_cand_intf_id: **rp_cand_interface** tuple argument:  Interface name in slot/port format for ethernet or port-channel/ve/loopback interface number

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate.rp_cand_interface', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate.rp_cand_interface', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate.rp_cand_interface', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rp_cand_interface', 'keyval': 'rp_cand_intf_type, rp_cand_intf_id', 'extra_keyval': 'rp_cand_intf_type, rp_cand_intf_id'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim, rp_cand_interface=rp_cand_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim, rp_cand_interface=rp_cand_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_rp_candidate_prefix_get(self, pim=None, rp_cand_grp_prefix=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type rp_cand_grp_prefix: rp_cand_prefix_name
    :param rp_cand_grp_prefix: Keyword argument tuple.

    :type rp_cand_prefix_name: unicode
    :param rp_cand_prefix_name: **rp_cand_grp_prefix** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate.rp_cand_grp_prefix', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate.rp_cand_grp_prefix', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate.rp_cand_grp_prefix', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'rp_cand_grp_prefix', 'keyval': 'rp_cand_prefix_name', 'extra_keyval': 'rp_cand_prefix_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim, rp_cand_grp_prefix=rp_cand_grp_prefix)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim, rp_cand_grp_prefix=rp_cand_grp_prefix)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_rpf_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.rpf', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rpf', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rpf', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rpf', u'ecmp')]
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rebalance'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_rpf_ecmp_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.rpf.ecmp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rpf.ecmp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rpf.ecmp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_rpf_ecmp_rebalance_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.rpf.ecmp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rpf.ecmp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rpf.ecmp', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_spt_threshold_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'rp_address'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'route_precedence'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'ssm_enable'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp_ip'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'rp_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'route_precedence'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'ssm_enable'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'anycast_rp'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'anycast_rp_ip'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'route_precedence'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'rp_address'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'anycast_rp_ip'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.rpf', u'ecmp'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'ssm_enable'), ('pybind.slxos.v17r_2_00.routing_system.router.pim', u'anycast_rp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'pim', 'keyval': 'vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'range'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'rebalance'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'range'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'rebalance'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'rebalance'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'range'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}]
    leafval_map = {"pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim": {}, "pybind.slxos.v17r_1_01a.routing_system.router.pim": {"vrf": "vrf", "spt_threshold": "spt_threshold"}, "pybind.slxos.v17r_2_00.routing_system.router.pim": {"vrf": "vrf", "spt_threshold": "spt_threshold"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_ssm_enable_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.ssm_enable', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.ssm_enable', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.ssm_enable', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_pim_ssm_enable_range_get(self, pim=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type pim: vrf
    :param pim: Keyword argument tuple.

    :type vrf: unicode
    :param vrf: **pim** tuple argument:  VRF Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.routing_system.router.pim', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.pim', u'pim')]
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router.pim.ssm_enable', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router.pim.ssm_enable', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.ssm_enable', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf', 'extra_keyval': ''}, {'keyval': 'vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, pim=pim)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, pim=pim)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def router_routing_system_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system.router', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system.router', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system.router', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4u_ipv6_attr_holder', u'af_ipv4u_ipv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.suppress', u'ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6', u'vpnv6_unicast'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router', u'pim'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder', u'router_isis_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder', u'net'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp', u'router_bgp_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4', u'vpnv4_unicast'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6', u'vpnv6_unicast'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder', u'net'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4', u'vpnv4_unicast'), ('pybind.slxos.v17r_1_01a.routing_system.router', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp', u'router_bgp_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder', u'router_isis_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'rp_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp', u'router_bgp_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder', u'router_isis_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'route_precedence'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'ssm_enable'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp_ip'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder', u'net'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder', u'pim'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rpf', u'ecmp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'table_map_route_map'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'ipv6_address, activate'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'nsr'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability, auth_transition'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'host_route'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'identifier'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'vrf, database_overflow_interval, default_passive_interface, default_metric, external_lsdb_limit, ospf_metric_type, vrf_lite_capability, nonstop_routing, maximum_paths, auth_transition'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'fast_flood_value'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'all'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'vrf, max_mcache, hello_interval, prune_wait, nbr_timeout, inactivity_timer, message_interval, spt_threshold'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'csnp_interval, disable_inc_stct_spf_opt, disable_incremental_spf_opt, disable_partial_spf_opt, is_type, lsp_gen_interval, lsp_interval, lsp_refresh_interval, max_lsp_lifetime, nonstop_routing, retransmit_interval'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'holdover_interval'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'net_cmd'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'local_as, always_compare_med, compare_med_empty_aspath, med_missing_as_worst, as_path_ignore, compare_routerid, install_igp_cost, default_local_preference, enforce_first_as, fast_external_fallover, log_dampening_debug, auto_shutdown_new_neighbors'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'table_map_route_map'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'net_cmd'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'holdover_interval'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'identifier'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'fast_flood_value'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'vrf, max_mcache, hello_interval, prune_wait, nbr_timeout, inactivity_timer, message_interval, spt_threshold'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'vrf, database_overflow_interval, default_passive_interface, default_metric, external_lsdb_limit, ospf_metric_type, vrf_lite_capability, nonstop_routing, maximum_paths'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'local_as, always_compare_med, compare_med_empty_aspath, med_missing_as_worst, as_path_ignore, compare_routerid, install_igp_cost, default_local_preference, enforce_first_as, fast_external_fallover, log_dampening_debug, auto_shutdown_new_neighbors'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'hostname_disable'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'num_as_in_path'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'csnp_interval, disable_inc_stct_spf_opt, disable_incremental_spf_opt, disable_partial_spf_opt, is_type, lsp_gen_interval, lsp_interval, lsp_refresh_interval, max_lsp_lifetime, nonstop_routing, retransmit_interval'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'nsr'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'identifier'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'hostname_disable'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'local_as, always_compare_med, compare_med_empty_aspath, med_missing_as_worst, as_path_ignore, compare_routerid, install_igp_cost, default_local_preference, enforce_first_as, fast_external_fallover, log_dampening_debug, auto_shutdown_new_neighbors'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'fast_flood_value'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'all'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'as4_enable'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'csnp_interval, disable_inc_stct_spf_opt, disable_incremental_spf_opt, disable_partial_spf_opt, is_type, lsp_gen_interval, lsp_interval, lsp_refresh_interval, max_lsp_lifetime, nonstop_routing, retransmit_interval'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'nsr'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'range'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'vrf, database_overflow_interval, default_passive_interface, default_metric, external_lsdb_limit, ospf_metric_type, vrf_lite_capability, nonstop_routing, maximum_paths'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'net_cmd'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'max_mcache, hello_interval, prune_wait, nbr_timeout, inactivity_timer, message_interval, spt_threshold'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'table_map_route_map'}, {'leafval': 'holdover_interval'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'rebalance'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def routing_system_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.routing_system', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.routing_system', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.routing_system', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'rp_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17s_1_02.routing_system', u'route_map'), ('pybind.slxos.v17s_1_02.routing_system.interface', u've'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp', u'router_bgp_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.ip.receive', u'access_group'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17s_1_02.routing_system.evpn_config.evpn', u'evpn_instance'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_grp_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rp_candidate', u'rp_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.receive', u'access_group'), ('pybind.slxos.v17s_1_02.routing_system.ip.dhcp.relay', u'information'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder', u'router_isis_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'route_precedence'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.static_ag_ipv6_config', u'anycast_gateway_mac'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.bsr_candidate', u'bsr_cand_interface'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'ssm_enable'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.ipv6', u'prefix_list'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim', u'anycast_rp_ip'), ('pybind.slxos.v17s_1_02.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.protocol', u'hide_vrrp_holder'), ('pybind.slxos.v17s_1_02.routing_system.interface', u'loopback'), ('pybind.slxos.v17s_1_02.routing_system.router', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder', u'net'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17s_1_02.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17s_1_02.routing_system.ip.static_ag_ip_config', u'anycast_gateway_mac'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder', u'pim'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17s_1_02.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17s_1_02.routing_system.router.hide_pim_holder.pim.rpf', u'ecmp'), ('pybind.slxos.v17s_1_02.routing_system.mac.receive', u'access_group'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4u_ipv6_attr_holder', u'af_ipv4u_ipv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system', u'route_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_2_00.routing_system.ip.receive', u'access_group'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.receive', u'access_group'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_2_00.routing_system.ip.static_ag_ip_config', u'anycast_gateway_mac'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.interface', u'loopback'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.interface', u've'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.suppress', u'ipv4'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.ipv6.static_ag_ipv6_config', u'anycast_gateway_mac'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_2_00.routing_system.protocol', u'hide_vrrp_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv6', u'vpnv6_unicast'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router', u'pim'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_2_00.routing_system.ip.dhcp.relay', u'information'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder', u'router_isis_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_2_00.routing_system.evpn_config.evpn', u'evpn_instance'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder', u'net'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp', u'router_bgp_attributes'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17r_2_00.routing_system.router.router_bgp.address_family.vpnv4', u'vpnv4_unicast'), ('pybind.slxos.v17r_2_00.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.interface', u'loopback'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit', u'on_startup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'af_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_peer_group'), ('pybind.slxos.v17r_1_01a.routing_system.protocol', u'hide_vrrp_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_address_holder', u'af_ipv4_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv6'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.retain', u'route_target'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_mode', u'md5'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'log'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6', u'vpnv6_unicast'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'rev_metric_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.evpn_config.evpn', u'evpn_instance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'network'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_common_cmds_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'aggregate_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder', u'net'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'bfd'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.peer_grps', u'neighbor_peer_grp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'confederation'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.metric_style', u'wide'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ips', u'neighbor_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'spf6_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.auth_check', u'auth_check_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'redistribute_isis'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.reverse_metric', u'reverse_metric_tlv'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system', u'route_map'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'next_hop_mpls'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'af_ipv4_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.ip.dhcp.relay', u'information'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_peergroup_holder', u'af_ipv6_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'fast_flood'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast', u'af_ipv6_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn.evpn.neighbor', u'evpn_neighbor_ipv4'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.neighbor.neighbor_ipv6s', u'neighbor_ipv6_addr'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.set_overload_bit.on_startup', u'wait_for_bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4', u'vpnv4_unicast'), ('pybind.slxos.v17r_1_01a.routing_system.router', u'pim'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'default_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpn_neighbor_peergroup_holder', u'af_vpn_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello.padding', u'hello_padding_point_to_point'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'auth_key'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv4.vpnv4_unicast.af_vpnv4_neighbor_address_holder', u'af_vpnv4_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'aggregate_ipv6_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'multipath'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp', u'router_bgp_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'connected'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.dampening', u'values'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'hostname'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'dampening'), ('pybind.slxos.v17r_1_01a.routing_system.interface', u've'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.vpnv6.vpnv6_unicast.af_vpnv6_neighbor_address_holder', u'af_vpnv6_neighbor'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.neighbor.af_ipv4_neighbor_peergroup_holder', u'af_ipv4_neighbor_peergroup'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute.isis.level_2.into', u'level2_into_level1'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'capability'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.bfd', u'interval'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.receive', u'access_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'distance'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_ipv4_uc_and_vrf_cmds_call_point_holder.redistribute.ospf', u'match'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'summary_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf', u'af_ipv6_uc_and_vrf_cmds_call_point_holder'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes.maxas_limit', u'in_'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'ipv6_default_link_metric'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'summary_prefix'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_txrx'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'graceful_restart'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'timers'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'table_map'), ('pybind.slxos.v17r_1_01a.routing_system.ip.receive', u'access_group'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder', u'router_isis_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.ipv6.router', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'partial_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes', u'default_information_originate'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'set_debug'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'af_common_attributes'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute.isis.level_1.into', u'level1_into_level2'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_ipv6_uc_and_vrf_cmds_call_point_holder.redistribute', u'bgp'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf', u'static_network'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes', u'ldp_sync'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'multi_topology'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes', u'spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes', u'partial6_spf_interval'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder.af_additional_paths', u'addpath_select'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv4.ipv4_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.l2vpn', u'evpn'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.af_common_cmds_holder', u'maximum_paths'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.router_bgp_attributes', u'cluster_id'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast.default_vrf.neighbor.af_ipv6_neighbor_address_holder', u'af_ipv6_neighbor_address'), ('pybind.slxos.v17r_1_01a.routing_system.router.router_bgp.address_family.ipv6.ipv6_unicast', u'af_ipv6_vrf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'ospf'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.router_isis_attributes.hello', u'padding'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv6.af_ipv6_unicast.af_ipv6_attributes.af_common_attributes.redistribute', u'static'), ('pybind.slxos.v17r_1_01a.routing_system.router.isis.router_isis_cmds_holder.address_family.ipv4.af_ipv4_unicast.af_ipv4_attributes.af_common_attributes.redistribute', u'bgp')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rp_ip_addr, rp_addr_prefix_list'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'identifier'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'name, action_rm, instance'}, {'leafval': 'name, shutdown'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'hostname_disable'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'local_as, always_compare_med, compare_med_empty_aspath, med_missing_as_worst, as_path_ignore, compare_routerid, install_igp_cost, default_local_preference, enforce_first_as, fast_external_fallover, log_dampening_debug, auto_shutdown_new_neighbors'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'fast_flood_value'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'ip_access_list, ip_direction'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'instance_name, df_delay_timer'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'rp_cand_prefix_name'}, {'leafval': 'all'}, {'leafval': 'rp_cand_intf_type, rp_cand_intf_id'}, {'leafval': 'as4_enable'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'ipv6_access_list, ip_direction'}, {'leafval': 'option'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'csnp_interval, disable_inc_stct_spf_opt, disable_incremental_spf_opt, disable_partial_spf_opt, is_type, lsp_gen_interval, lsp_interval, lsp_refresh_interval, max_lsp_lifetime, nonstop_routing, retransmit_interval'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'uc_default, uc_non_default, none'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'table_map_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'nsr'}, {'leafval': 'ipv6_anycast_gateway_mac, ipv6_anycast_default_mac'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'bsr_cand_intf_type, bsr_cand_intf_id, hash_mask_length, bsr_cand_priority'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'num_as_in_path'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'range'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'name, seq_keyword, instance, action_ipp, ipv6_prefix_ipp, ge_ipp, le_ipp'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'anycast_ip_addr, anycast_prefix_list'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'anycast_rp_ip_addr, anycast_peer_ip_addr'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'id, shutdown'}, {'leafval': 'vrf, database_overflow_interval, default_passive_interface, default_metric, external_lsdb_limit, ospf_metric_type, vrf_lite_capability, nonstop_routing, maximum_paths'}, {'leafval': 'bfd_all_interfaces'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'net_cmd'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'default_information_originate_route_map, default_information_originate_cr'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'ip_anycast_gateway_mac, ip_anycast_default_mac'}, {'leafval': 'max_mcache, hello_interval, prune_wait, nbr_timeout, inactivity_timer, message_interval, spt_threshold'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'table_map_route_map'}, {'leafval': 'holdover_interval'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, enable_peer_as_check, route_reflector_client, af_nei_weight'}, {'leafval': 'rebalance'}, {'leafval': 'mac_access_list, mac_direction'}, {'leafval': 'table_map_route_map'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'ipv6_address, activate'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'name, action_rm, instance'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'acl_name'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'acl_name'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'nsr'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability, auth_transition'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'ip_anycast_gateway_mac, ip_anycast_default_mac'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'id, shutdown'}, {'leafval': 'hostname_disable'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'name, shutdown'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'host_route'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ipv6_anycast_gateway_mac, ipv6_anycast_default_mac'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'identifier'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'vrf, database_overflow_interval, default_passive_interface, default_metric, external_lsdb_limit, ospf_metric_type, vrf_lite_capability, nonstop_routing, maximum_paths, auth_transition'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'fast_flood_value'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'all'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'vrf, max_mcache, hello_interval, prune_wait, nbr_timeout, inactivity_timer, message_interval, spt_threshold'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'as4_enable'}, {'leafval': 'num_as_in_path'}, {'leafval': 'option'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'csnp_interval, disable_inc_stct_spf_opt, disable_incremental_spf_opt, disable_partial_spf_opt, is_type, lsp_gen_interval, lsp_interval, lsp_refresh_interval, max_lsp_lifetime, nonstop_routing, retransmit_interval'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'holdover_interval'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'bgp_redistribute_internal, advertise_best_external'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'instance_name, df_delay_timer'}, {'leafval': 'net_cmd'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'local_as, always_compare_med, compare_med_empty_aspath, med_missing_as_worst, as_path_ignore, compare_routerid, install_igp_cost, default_local_preference, enforce_first_as, fast_external_fallover, log_dampening_debug, auto_shutdown_new_neighbors'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'id, shutdown'}, {'leafval': 'bfd_global_enable, bfd_holdover_interval'}, {'leafval': 'network_ipv6_address, network_weight, backdoor, network_route_map'}, {'leafval': 'on_startup_overloadtime'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'af_vrf_name, local_as, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'evpn_neighbor_peergroup_name, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'vrrp, vrrp_extended'}, {'leafval': 'table_map_route_map'}, {'leafval': 'af_ipv4_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'evpn_neighbor_ipv6_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'all'}, {'leafval': 'auth_mode_md5_level1, auth_mode_md5_level2'}, {'leafval': 'adjacency, invalid_lsp_packets'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'rev_metric_val, rev_metric_whole_lan, rev_metric_te_def_metric'}, {'leafval': 'instance_name, df_delay_timer'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'network_ipv4_address, network_weight, backdoor, network_route_map'}, {'leafval': 'always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'net_cmd'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'auth_check_level1_disable'}, {'leafval': 'holdover_interval'}, {'leafval': 'router_bgp_neighbor_peer_grp, peer_group_name, remote_as, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'identifier'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'metric_style_wide_level1, metric_style_wide_level2'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'router_bgp_neighbor_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'spf6_interval_level, spf6_interval_max_hold_time, spf6_interval_initial_delay, spf6_interval_hold_time'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'default_vrf_selected, next_hop_recursion'}, {'leafval': 'auth_check_level2_disable'}, {'leafval': 'redistribute_isis_route_map, level_1, level_2, level_1_2, redistribute_isis_metric'}, {'leafval': 'default_link_metric_level1, default_link_metric_level2'}, {'leafval': 'rev_metric_tlv_type'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'name, action_rm, instance'}, {'leafval': 'compare_lsp_metric, follow_igp'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'option'}, {'leafval': 'redistribute_connected, unicast_metric, redistribute_route_map'}, {'leafval': 'af_ipv6_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'fast_flood_value'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'disable_adjacency_check'}, {'leafval': 'evpn_neighbor_ipv4_address, encapsulation, maximum_prefix, route_reflector_client, allowas_in, next_hop_unchanged, enable_peer_as_check, activate'}, {'leafval': 'router_bgp_neighbor_ipv6_address, remote_as, associate_peer_group, description, ebgp_btsh, password, remove_private_as, as_override, static_network_edge'}, {'leafval': 'wait_for_bgp_value'}, {'leafval': 'gr_helper_disable'}, {'leafval': 'rr_group, export_vrf_leaked_routes'}, {'leafval': 'vrf, max_mcache, hello_interval, prune_wait, nbr_timeout, inactivity_timer, message_interval, spt_threshold'}, {'leafval': 'default_vrf_selected, ipv6_ucast_next_hop_recursion'}, {'leafval': 'af_vpn_neighbor_peergroup_address, activate, weight, route_reflector_client'}, {'leafval': 'hello_padding_ptp_disable'}, {'leafval': 'auth_key_level1_str, auth_key_level2_str'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'vrf, database_overflow_interval, default_passive_interface, default_metric, external_lsdb_limit, ospf_metric_type, vrf_lite_capability, nonstop_routing, maximum_paths'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'af_vpnv4_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'aggregate_ip_prefix, advertise_map, as_set, attribute_map, summary_only, suppress_map'}, {'leafval': 'multipath_ebgp, multipath_ibgp, multi_as'}, {'leafval': 'local_as, always_compare_med, compare_med_empty_aspath, med_missing_as_worst, as_path_ignore, compare_routerid, install_igp_cost, default_local_preference, enforce_first_as, fast_external_fallover, log_dampening_debug, auto_shutdown_new_neighbors'}, {'leafval': 'connected_metric, connected_route_map, connected_level1, connected_level2, connected_level12, connected_metric_type'}, {'leafval': 'half_time, reuse_value, start_suppress_time, max_suppress_time'}, {'leafval': 'hostname_disable'}, {'leafval': 'redistribute_static, unicast_static_metric, static_route_map'}, {'leafval': 'dampening_flag, dampening_route_map'}, {'leafval': 'name, shutdown'}, {'leafval': 'af_vpnv6_neighbor_address, activate, weight, route_reflector_client'}, {'leafval': 'af_ipv4_neighbor_peergroup_name, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'prefix_list_level2'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'as4_enable'}, {'leafval': 'min_tx, min_rx, multiplier'}, {'leafval': 'acl_name'}, {'leafval': 'ext_route_distance, int_route_distance, lcl_route_distance'}, {'leafval': 'ospf_internal, ospf_external1, ospf_external2'}, {'leafval': 'summary_ip, summary_ip_mask, summary_ip_level1, summary_ip_level2'}, {'leafval': 'redistribute_ospf, ospf_metric, ospf_route_map'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'bgp_redistribute_internal'}, {'leafval': 'num_as_in_path'}, {'leafval': 'ipv6_default_link_metric_level1, ipv6_default_link_metric_level2'}, {'leafval': 'summary_prefix_ipv6, summary_prefix_level1, summary_prefix_level2'}, {'leafval': 'addpath_send, addpath_receive'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}, {'leafval': 'graceful_restart_status, restart_time, purge_time, stale_routes_time'}, {'leafval': 'keep_alive, hold_time'}, {'leafval': 'table_map_route_map'}, {'leafval': 'acl_name'}, {'leafval': 'csnp_interval, disable_inc_stct_spf_opt, disable_incremental_spf_opt, disable_partial_spf_opt, is_type, lsp_gen_interval, lsp_interval, lsp_refresh_interval, max_lsp_lifetime, nonstop_routing, retransmit_interval'}, {'leafval': 'vrf, database_overflow_interval, default_metric, default_passive_interface, external_lsdb_limit, key_add_remove_interval, key_rollover_interval, log_status_change, global_metric_type, nonstop_routing, maximum_paths, vrf_lite_capability'}, {'leafval': 'pspf_max_hold_time, pspf_init_delay, pspf_hold_time'}, {'leafval': 'default_information_originate_route_map'}, {'leafval': 'nsr'}, {'leafval': 'default_metric, distance, maximum_paths'}, {'leafval': 'prefix_list_level1, level1_into_level2_disable'}, {'leafval': 'redistribute_bgp, bgp_metric, bgp_route_map'}, {'leafval': 'static_network_address, static_network_distance'}, {'leafval': 'ldp_sync_hold_down'}, {'leafval': 'multi_topology_transition'}, {'leafval': 'spf_interval_level, spf_interval_max_hold_time, spf_interval_initial_delay, spf_interval_hold_time'}, {'leafval': 'pspf6_max_hold_time, pspf6_init_delay, pspf6_hold_time'}, {'leafval': 'addpath_sel_best, addpath_sel_groupbest, addpath_sel_all'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'client_to_client_reflection, vtep_discovery'}, {'leafval': 'load_sharing_value, ebgp, ibgp, use_load_sharing'}, {'leafval': 'cluster_id_value, cluster_id_ipv4_address'}, {'leafval': 'af_ipv6_neighbor_address, activate, allowas_in, route_reflector_client, af_nei_weight, enable_peer_as_check'}, {'leafval': 'af_ipv6_vrf_name, next_hop_recursion, graceful_restart_status, always_propagate, default_information_originate, rib_route_limit, advertise_best_external, client_to_client_reflection, default_metric, next_hop_enable_default, update_time'}, {'leafval': 'ospf_metric, ospf_route_map, ospf_level1, ospf_level2, ospf_level12, ospf_metric_type'}, {'leafval': 'hello_padding_disable'}, {'leafval': 'static_metric, static_route_map, static_level1, static_level2, static_level12, static_metric_type'}, {'leafval': 'bgp_metric, bgp_route_map, bgp_level1, bgp_level2, bgp_level12, bgp_metric_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rpf_config_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.rpf_config', 'pybind.nos.v7_2_0.brocade_rpf', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rpf_config', 'pybind.slxos.v17r_1_01a.brocade_rpf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rpf_config', 'pybind.slxos.v17r_2_00.brocade_rpf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rpf_config', 'pybind.slxos.v17s_1_02.brocade_rpf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rule', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.rule.command.interface_pc_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_ve_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_eth_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_fc_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule', u'command'), ('pybind.slxos.v17s_1_02.rule.command.interface_management_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_vlan_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_loopback_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_vlan_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_fcoe_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_te_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_ve_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_he_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_pc_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_loopback_leaf', u'interface'), ('pybind.nos.v7_2_0.rule', u'command'), ('pybind.nos.v7_2_0.rule.command.interface_fc_leaf', u'interface'), ('pybind.nos.v7_2_0.vlan.classifier', u'rule'), ('pybind.nos.v7_2_0.rule.command.interface_ge_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_management_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_fe_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_management_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_vlan_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_ve_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_eth_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_pc_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_fc_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule', u'command'), ('pybind.slxos.v17r_2_00.rule.command.interface_loopback_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule', u'command'), ('pybind.slxos.v17r_1_01a.rule.command.interface_fc_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_eth_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_management_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_vlan_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_loopback_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_ve_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_pc_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_he_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_ge_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_fe_leaf', u'interface'), ('pybind.nos.v6_0_2f.vlan.classifier', u'rule'), ('pybind.nos.v6_0_2f.rule', u'command'), ('pybind.nos.v6_0_2f.rule.command.interface_loopback_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_te_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_management_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_ve_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_pc_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_fcoe_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_fc_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_vlan_leaf', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'rule', 'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}
    composed_child_leafval_list = [{'leafval': 'port_channel_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'ethernet_leaf'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'enumList'}, {'leafval': 'management_leaf'}, {'leafval': 'vlan_leaf'}, {'leafval': 'loopback_leaf'}, {'leafval': 'vlan_leaf'}, {'leafval': 'fcoe_leaf'}, {'leafval': 'tengigabitethernet_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'hundredgigabitethernet_leaf'}, {'leafval': 'port_channel_leaf'}, {'leafval': 'loopback_leaf'}, {'leafval': 'enumList'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'ruleid'}, {'leafval': 'gigabitethernet_leaf'}, {'leafval': 'management_leaf'}, {'leafval': 'fortygigabitethernet_leaf'}, {'leafval': 'management_leaf'}, {'leafval': 'vlan_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'ethernet_leaf'}, {'leafval': 'port_channel_leaf'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'enumList'}, {'leafval': 'loopback_leaf'}, {'leafval': 'enumList'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'ethernet_leaf'}, {'leafval': 'management_leaf'}, {'leafval': 'vlan_leaf'}, {'leafval': 'loopback_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'port_channel_leaf'}, {'leafval': 'hundredgigabitethernet_leaf'}, {'leafval': 'gigabitethernet_leaf'}, {'leafval': 'fortygigabitethernet_leaf'}, {'leafval': 'ruleid'}, {'leafval': 'enumList'}, {'leafval': 'loopback_leaf'}, {'leafval': 'tengigabitethernet_leaf'}, {'leafval': 'management_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'port_channel_leaf'}, {'leafval': 'fcoe_leaf'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'vlan_leaf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_action_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type rule: index
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rule', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.rule.command.interface_pc_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_ve_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_eth_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_fc_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule', u'command'), ('pybind.slxos.v17s_1_02.rule.command.interface_management_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_vlan_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_loopback_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_vlan_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_fcoe_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_te_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_ve_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_he_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_pc_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_loopback_leaf', u'interface'), ('pybind.nos.v7_2_0.rule', u'command'), ('pybind.nos.v7_2_0.rule.command.interface_fc_leaf', u'interface'), ('pybind.nos.v7_2_0.vlan.classifier', u'rule'), ('pybind.nos.v7_2_0.rule.command.interface_ge_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_management_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_fe_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_management_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_vlan_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_ve_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_eth_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_pc_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_fc_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule', u'command'), ('pybind.slxos.v17r_2_00.rule.command.interface_loopback_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule', u'command'), ('pybind.slxos.v17r_1_01a.rule.command.interface_fc_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_eth_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_management_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_vlan_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_loopback_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_ve_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_pc_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_he_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_ge_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_fe_leaf', u'interface'), ('pybind.nos.v6_0_2f.vlan.classifier', u'rule'), ('pybind.nos.v6_0_2f.rule', u'command'), ('pybind.nos.v6_0_2f.rule.command.interface_loopback_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_te_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_management_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_ve_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_pc_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_fcoe_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_fc_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_vlan_leaf', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'rule', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'port_channel_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'ethernet_leaf'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'enumList'}, {'leafval': 'management_leaf'}, {'leafval': 'vlan_leaf'}, {'leafval': 'loopback_leaf'}, {'leafval': 'vlan_leaf'}, {'leafval': 'fcoe_leaf'}, {'leafval': 'tengigabitethernet_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'hundredgigabitethernet_leaf'}, {'leafval': 'port_channel_leaf'}, {'leafval': 'loopback_leaf'}, {'leafval': 'enumList'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'ruleid'}, {'leafval': 'gigabitethernet_leaf'}, {'leafval': 'management_leaf'}, {'leafval': 'fortygigabitethernet_leaf'}, {'leafval': 'management_leaf'}, {'leafval': 'vlan_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'ethernet_leaf'}, {'leafval': 'port_channel_leaf'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'enumList'}, {'leafval': 'loopback_leaf'}, {'leafval': 'enumList'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'ethernet_leaf'}, {'leafval': 'management_leaf'}, {'leafval': 'vlan_leaf'}, {'leafval': 'loopback_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'port_channel_leaf'}, {'leafval': 'hundredgigabitethernet_leaf'}, {'leafval': 'gigabitethernet_leaf'}, {'leafval': 'fortygigabitethernet_leaf'}, {'leafval': 'ruleid'}, {'leafval': 'enumList'}, {'leafval': 'loopback_leaf'}, {'leafval': 'tengigabitethernet_leaf'}, {'leafval': 'management_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'port_channel_leaf'}, {'leafval': 'fcoe_leaf'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'vlan_leaf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_2_00.rule.command': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17r_1_01a.rule.command': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17s_1_02.rule.command': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_clear_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.clear_logging.clear', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.clear_logging.clear', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.clear_logging.clear', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.clear_logging.clear', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.clear_logging.clear', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.clear_logging.clear': [u'clear'], 'pybind.slxos.v17s_1_02.rule.command.clear_logging.clear': [u'clear'], 'pybind.nos.v6_0_2f.rule.command.clear_logging.clear': [u'clear'], 'pybind.slxos.v17r_2_00.rule.command.clear_logging.clear': [u'clear'], 'pybind.slxos.v17r_1_01a.rule.command.clear_logging.clear': [u'clear']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_clear_cl_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.clear_cl', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.clear_cl', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.clear_cl', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.clear_cl', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.clear_cl', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.rule.command.clear_cl': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2f.rule.command.clear_cl': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_1_01a.rule.command.clear_cl': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17r_2_00.rule.command.clear_cl': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command.clear_cl': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_clear_clear_support_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.clear_support.clear', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.clear_support.clear', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.clear_support.clear', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.clear_support.clear', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.clear_support.clear', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.rule.command.clear_support.clear': [u'clear'], 'pybind.nos.v7_2_0.rule.command.clear_support.clear': [u'clear'], 'pybind.slxos.v17s_1_02.rule.command.clear_support.clear': [u'clear'], 'pybind.nos.v6_0_2f.rule.command.clear_support.clear': [u'clear'], 'pybind.slxos.v17r_2_00.rule.command.clear_support.clear': [u'clear']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_clear_logging_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.clear_logging', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.clear_logging', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.clear_logging', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.clear_logging', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.clear_logging', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.clear_logging': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_1_01a.rule.command.clear_logging': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17s_1_02.rule.command.clear_logging': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command.clear_logging': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_2_00.rule.command.clear_logging': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_clear_support_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.clear_support', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.clear_support', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.clear_support', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.clear_support', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.clear_support', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.rule.command.clear_support': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2f.rule.command.clear_support': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_1_01a.rule.command.clear_support': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17s_1_02.rule.command.clear_support': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command.clear_support': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_copy_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.copy_running.copy', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.copy_running.copy', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.copy_running.copy', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.copy_running.copy', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.copy_running.copy', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.copy_running.copy': [u'copy'], 'pybind.slxos.v17r_2_00.rule.command.copy_running.copy': [u'copy'], 'pybind.slxos.v17r_1_01a.rule.command.copy_running.copy': [u'copy'], 'pybind.nos.v6_0_2f.rule.command.copy_running.copy': [u'copy'], 'pybind.slxos.v17s_1_02.rule.command.copy_running.copy': [u'copy']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_copy_copy_support_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.copy_support.copy', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.copy_support.copy', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.copy_support.copy', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.copy_support.copy', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.copy_support.copy', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.rule.command.copy_support.copy': [u'copy'], 'pybind.nos.v6_0_2f.rule.command.copy_support.copy': [u'copy'], 'pybind.slxos.v17r_2_00.rule.command.copy_support.copy': [u'copy'], 'pybind.nos.v7_2_0.rule.command.copy_support.copy': [u'copy'], 'pybind.slxos.v17s_1_02.rule.command.copy_support.copy': [u'copy']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_copy_cp_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.copy_cp', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.copy_cp', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.copy_cp', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.copy_cp', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.copy_cp', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.rule.command.copy_cp': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2f.rule.command.copy_cp': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_1_01a.rule.command.copy_cp': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17s_1_02.rule.command.copy_cp': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command.copy_cp': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_copy_running_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.copy_running', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.copy_running', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.copy_running', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.copy_running', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.copy_running', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.rule.command.copy_running': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17r_1_01a.rule.command.copy_running': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17r_2_00.rule.command.copy_running': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2f.rule.command.copy_running': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_2_0.rule.command.copy_running': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_copy_support_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.copy_support', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.copy_support', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.copy_support', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.copy_support', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.copy_support', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.rule.command.copy_support': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2f.rule.command.copy_support': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_1_01a.rule.command.copy_support': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17r_2_00.rule.command.copy_support': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command.copy_support': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_enumlist_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_fc.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_fc.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_eth.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_eth.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_eth.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.rule.command.interface_eth.interface': [u'interface'], 'pybind.nos.v7_2_0.rule.command.interface_fc.interface': [u'interface'], 'pybind.slxos.v17r_2_00.rule.command.interface_eth.interface': [u'interface'], 'pybind.slxos.v17r_1_01a.rule.command.interface_eth.interface': [u'interface'], 'pybind.nos.v6_0_2f.rule.command.interface_fc.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_eth_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.slxos.v17r_1_01a.rule.command.interface_eth', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_eth', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_eth', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.rule.command.interface_eth': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17r_2_00.rule.command.interface_eth': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17s_1_02.rule.command.interface_eth': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_eth_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule')]
    bindings_list = [('pybind.slxos.v17r_1_01a.rule.command.interface_eth_leaf', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_eth_leaf', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_eth_leaf', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.rule.command.interface_eth_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17r_1_01a.rule.command.interface_eth_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17r_2_00.rule.command.interface_eth_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_ethernet_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule')]
    bindings_list = [('pybind.slxos.v17r_1_01a.rule.command.interface_eth_leaf.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_eth_leaf.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_eth_leaf.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_fc_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_fc', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_fc', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_fc', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_fc', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_fc', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_fc': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17s_1_02.rule.command.interface_fc': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command.interface_fc': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_1_01a.rule.command.interface_fc': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17r_2_00.rule.command.interface_fc': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_fc_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_fc_leaf', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_fc_leaf', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_fc_leaf', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_fc_leaf', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_fc_leaf', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.interface_fc_leaf': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_2_00.rule.command.interface_fc_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17r_1_01a.rule.command.interface_fc_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2f.rule.command.interface_fc_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17s_1_02.rule.command.interface_fc_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_fcoe_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_fcoe_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_fcoe_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_fcoe_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_fcoe_leaf', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_fcoe_leaf', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.interface_fcoe_leaf': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2f.rule.command.interface_fcoe_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_fe_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_fe', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_fe', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.interface_fe': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2f.rule.command.interface_fe': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_fe_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_fe_leaf', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_fe_leaf', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_fe_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_2_0.rule.command.interface_fe_leaf': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_fibrechannel_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_fc_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_fc_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_fc_leaf.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_fc_leaf.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_fc_leaf.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_fortygigabitethernet_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_fe_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_fe_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_ge_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_ge', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_ge', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_ge': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_2_0.rule.command.interface_ge': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_ge_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_ge_leaf', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_ge_leaf', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_ge_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_2_0.rule.command.interface_ge_leaf': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_gigabitethernet_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_ge_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_ge_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_he_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_he', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_he', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.interface_he': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2f.rule.command.interface_he': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_he_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_he_leaf', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_he_leaf', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.interface_he_leaf': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2f.rule.command.interface_he_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_hundredgigabitethernet_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_he_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_he_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_int_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_int', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_int', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_int', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_int', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_int', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.rule.command.interface_int': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17s_1_02.rule.command.interface_int': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command.interface_int': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_1_01a.rule.command.interface_int': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2f.rule.command.interface_int': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_eth_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule')]
    bindings_list = [('pybind.slxos.v17r_1_01a.rule.command.interface_eth_leaf.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_eth_leaf.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_eth_leaf.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.rule.command.interface_eth_leaf.interface': [u'ethernet_leaf'], 'pybind.slxos.v17s_1_02.rule.command.interface_eth_leaf.interface': [u'ethernet_leaf'], 'pybind.slxos.v17r_1_01a.rule.command.interface_eth_leaf.interface': [u'ethernet_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_fc_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule')]
    bindings_list = [('pybind.slxos.v17r_1_01a.rule.command.interface_fc.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_fc.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_fc.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.rule.command.interface_fc.interface': [u'interface'], 'pybind.slxos.v17r_1_01a.rule.command.interface_fc.interface': [u'interface'], 'pybind.slxos.v17r_2_00.rule.command.interface_fc.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_fc_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_fc_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_fc_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_fc_leaf.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_fc_leaf.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_fc_leaf.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.rule.command.interface_fc_leaf.interface': [u'fibrechannel_leaf'], 'pybind.slxos.v17r_2_00.rule.command.interface_fc_leaf.interface': [u'fibrechannel_leaf'], 'pybind.nos.v6_0_2f.rule.command.interface_fc_leaf.interface': [u'fibrechannel_leaf'], 'pybind.slxos.v17s_1_02.rule.command.interface_fc_leaf.interface': [u'fibrechannel_leaf'], 'pybind.nos.v7_2_0.rule.command.interface_fc_leaf.interface': [u'fibrechannel_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_fcoe_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_fcoe.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_fcoe.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_fcoe.interface': [u'interface'], 'pybind.nos.v7_2_0.rule.command.interface_fcoe.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_fcoe_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_fcoe_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_fcoe_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_fcoe_leaf.interface': [u'fcoe_leaf'], 'pybind.nos.v7_2_0.rule.command.interface_fcoe_leaf.interface': [u'fcoe_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_fe_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_fe.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_fe.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_fe.interface': [u'interface'], 'pybind.nos.v7_2_0.rule.command.interface_fe.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_fe_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_fe_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_fe_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_fe_leaf.interface': [u'fortygigabitethernet_leaf'], 'pybind.nos.v7_2_0.rule.command.interface_fe_leaf.interface': [u'fortygigabitethernet_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_ge_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_ge.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_ge.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_ge.interface': [u'interface'], 'pybind.nos.v7_2_0.rule.command.interface_ge.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_ge_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_ge_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_ge_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_ge_leaf.interface': [u'gigabitethernet_leaf'], 'pybind.nos.v7_2_0.rule.command.interface_ge_leaf.interface': [u'gigabitethernet_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_he_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_he.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_he.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.interface_he.interface': [u'interface'], 'pybind.nos.v6_0_2f.rule.command.interface_he.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_he_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_he_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_he_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.interface_he_leaf.interface': [u'hundredgigabitethernet_leaf'], 'pybind.nos.v6_0_2f.rule.command.interface_he_leaf.interface': [u'hundredgigabitethernet_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_loopback_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_loopback.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_loopback.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_loopback.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_loopback.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_loopback.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.rule.command.interface_loopback.interface': [u'interface'], 'pybind.nos.v6_0_2f.rule.command.interface_loopback.interface': [u'interface'], 'pybind.slxos.v17r_2_00.rule.command.interface_loopback.interface': [u'interface'], 'pybind.slxos.v17s_1_02.rule.command.interface_loopback.interface': [u'interface'], 'pybind.nos.v7_2_0.rule.command.interface_loopback.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_loopback_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_loopback_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_loopback_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_loopback_leaf.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_loopback_leaf.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_loopback_leaf.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.rule.command.interface_loopback_leaf.interface': [u'loopback_leaf'], 'pybind.slxos.v17r_2_00.rule.command.interface_loopback_leaf.interface': [u'loopback_leaf'], 'pybind.nos.v6_0_2f.rule.command.interface_loopback_leaf.interface': [u'loopback_leaf'], 'pybind.slxos.v17s_1_02.rule.command.interface_loopback_leaf.interface': [u'loopback_leaf'], 'pybind.nos.v7_2_0.rule.command.interface_loopback_leaf.interface': [u'loopback_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_management_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_management_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_management_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_management_leaf.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_management_leaf.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_management_leaf.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_management_leaf.interface': [u'management_leaf'], 'pybind.slxos.v17s_1_02.rule.command.interface_management_leaf.interface': [u'management_leaf'], 'pybind.nos.v7_2_0.rule.command.interface_management_leaf.interface': [u'management_leaf'], 'pybind.slxos.v17r_1_01a.rule.command.interface_management_leaf.interface': [u'management_leaf'], 'pybind.slxos.v17r_2_00.rule.command.interface_management_leaf.interface': [u'management_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_mgmt_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_mgmt.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_mgmt.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_mgmt.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_mgmt.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_mgmt.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.interface_mgmt.interface': [u'interface'], 'pybind.slxos.v17r_2_00.rule.command.interface_mgmt.interface': [u'interface'], 'pybind.slxos.v17r_1_01a.rule.command.interface_mgmt.interface': [u'interface'], 'pybind.nos.v6_0_2f.rule.command.interface_mgmt.interface': [u'interface'], 'pybind.slxos.v17s_1_02.rule.command.interface_mgmt.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_pc_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_pc.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_pc.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_pc.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_pc.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_pc.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.rule.command.interface_pc.interface': [u'interface'], 'pybind.slxos.v17r_1_01a.rule.command.interface_pc.interface': [u'interface'], 'pybind.nos.v6_0_2f.rule.command.interface_pc.interface': [u'interface'], 'pybind.slxos.v17r_2_00.rule.command.interface_pc.interface': [u'interface'], 'pybind.nos.v7_2_0.rule.command.interface_pc.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_pc_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_pc_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_pc_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_pc_leaf.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_pc_leaf.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_pc_leaf.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.rule.command.interface_pc_leaf.interface': [u'port_channel_leaf'], 'pybind.nos.v6_0_2f.rule.command.interface_pc_leaf.interface': [u'port_channel_leaf'], 'pybind.slxos.v17r_2_00.rule.command.interface_pc_leaf.interface': [u'port_channel_leaf'], 'pybind.slxos.v17r_1_01a.rule.command.interface_pc_leaf.interface': [u'port_channel_leaf'], 'pybind.nos.v7_2_0.rule.command.interface_pc_leaf.interface': [u'port_channel_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_te_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_te.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_te.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_te.interface': [u'interface'], 'pybind.nos.v7_2_0.rule.command.interface_te.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_te_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_te_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_te_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_te_leaf.interface': [u'tengigabitethernet_leaf'], 'pybind.nos.v7_2_0.rule.command.interface_te_leaf.interface': [u'tengigabitethernet_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_ve_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_ve.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_ve.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_ve.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_ve.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_ve.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.rule.command.interface_ve.interface': [u'interface'], 'pybind.slxos.v17r_1_01a.rule.command.interface_ve.interface': [u'interface'], 'pybind.nos.v6_0_2f.rule.command.interface_ve.interface': [u'interface'], 'pybind.slxos.v17s_1_02.rule.command.interface_ve.interface': [u'interface'], 'pybind.nos.v7_2_0.rule.command.interface_ve.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_ve_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_ve_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_ve_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_ve_leaf.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_ve_leaf.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_ve_leaf.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.rule.command.interface_ve_leaf.interface': [u've_leaf'], 'pybind.nos.v6_0_2f.rule.command.interface_ve_leaf.interface': [u've_leaf'], 'pybind.slxos.v17s_1_02.rule.command.interface_ve_leaf.interface': [u've_leaf'], 'pybind.nos.v7_2_0.rule.command.interface_ve_leaf.interface': [u've_leaf'], 'pybind.slxos.v17r_1_01a.rule.command.interface_ve_leaf.interface': [u've_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_vlan_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_vlan.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_vlan.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_vlan.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_vlan.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_vlan.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.rule.command.interface_vlan.interface': [u'interface'], 'pybind.nos.v7_2_0.rule.command.interface_vlan.interface': [u'interface'], 'pybind.slxos.v17r_2_00.rule.command.interface_vlan.interface': [u'interface'], 'pybind.slxos.v17s_1_02.rule.command.interface_vlan.interface': [u'interface'], 'pybind.nos.v6_0_2f.rule.command.interface_vlan.interface': [u'interface']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_interface_vlan_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_vlan_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_vlan_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_vlan_leaf.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_vlan_leaf.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_vlan_leaf.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.rule.command.interface_vlan_leaf.interface': [u'vlan_leaf'], 'pybind.slxos.v17r_2_00.rule.command.interface_vlan_leaf.interface': [u'vlan_leaf'], 'pybind.nos.v6_0_2f.rule.command.interface_vlan_leaf.interface': [u'vlan_leaf'], 'pybind.slxos.v17s_1_02.rule.command.interface_vlan_leaf.interface': [u'vlan_leaf'], 'pybind.nos.v7_2_0.rule.command.interface_vlan_leaf.interface': [u'vlan_leaf']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_loopback_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_loopback_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_loopback_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_loopback_leaf.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_loopback_leaf.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_loopback_leaf.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_loopback_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_loopback_leaf', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_loopback_leaf', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_loopback_leaf', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_loopback_leaf', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_loopback_leaf', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.rule.command.interface_loopback_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command.interface_loopback_leaf': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17s_1_02.rule.command.interface_loopback_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2f.rule.command.interface_loopback_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_2_00.rule.command.interface_loopback_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_management_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_management_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_management_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_management_leaf.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_management_leaf.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_management_leaf.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_management_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_management_leaf', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_management_leaf', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_management_leaf', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_management_leaf', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_management_leaf', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.rule.command.interface_management_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2f.rule.command.interface_management_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17s_1_02.rule.command.interface_management_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command.interface_management_leaf': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_2_00.rule.command.interface_management_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_mgmt_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_mgmt', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_mgmt', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_mgmt', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_mgmt', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_mgmt', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_mgmt': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_1_01a.rule.command.interface_mgmt': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17s_1_02.rule.command.interface_mgmt': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command.interface_mgmt': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_2_00.rule.command.interface_mgmt': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_pc_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_pc', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_pc', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_pc', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_pc', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_pc', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17s_1_02.rule.command.interface_pc': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2f.rule.command.interface_pc': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_1_01a.rule.command.interface_pc': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17r_2_00.rule.command.interface_pc': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command.interface_pc': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_pc_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_pc_leaf', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_pc_leaf', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_pc_leaf', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_pc_leaf', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_pc_leaf', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.interface_pc_leaf': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17s_1_02.rule.command.interface_pc_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17r_1_01a.rule.command.interface_pc_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2f.rule.command.interface_pc_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_2_00.rule.command.interface_pc_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_port_channel_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_pc_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_pc_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_pc_leaf.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_pc_leaf.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_pc_leaf.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_te_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_te', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_te', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_te': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_2_0.rule.command.interface_te': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_te_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_te_leaf', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_te_leaf', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_te_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v7_2_0.rule.command.interface_te_leaf': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_tengigabitethernet_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_te_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_te_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_ve_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_ve_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_ve_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_ve_leaf.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_ve_leaf.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_ve_leaf.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_ve_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_ve_leaf', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_ve_leaf', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_ve_leaf', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_ve_leaf', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_ve_leaf', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.interface_ve_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_2_00.rule.command.interface_ve_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17r_1_01a.rule.command.interface_ve_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command.interface_ve_leaf': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17s_1_02.rule.command.interface_ve_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_vlan_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_vlan_leaf.interface', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_vlan_leaf.interface', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_vlan_leaf.interface', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_vlan_leaf.interface', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_vlan_leaf.interface', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_interface_vlan_leaf_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.interface_vlan_leaf', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.interface_vlan_leaf', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.interface_vlan_leaf', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.interface_vlan_leaf', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.interface_vlan_leaf', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.rule.command.interface_vlan_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command.interface_vlan_leaf': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17s_1_02.rule.command.interface_vlan_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2f.rule.command.interface_vlan_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_2_00.rule.command.interface_vlan_leaf': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_protocol_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.protocol_lldp.protocol', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.protocol_lldp.protocol', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.protocol_lldp.protocol', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.protocol_lldp.protocol', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.protocol_lldp.protocol', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.rule.command.protocol_lldp.protocol': [u'protocol'], 'pybind.slxos.v17r_2_00.rule.command.protocol_lldp.protocol': [u'protocol'], 'pybind.nos.v7_2_0.rule.command.protocol_lldp.protocol': [u'protocol'], 'pybind.slxos.v17r_1_01a.rule.command.protocol_lldp.protocol': [u'protocol'], 'pybind.slxos.v17s_1_02.rule.command.protocol_lldp.protocol': [u'protocol']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_protocol_lldp_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.protocol_lldp', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.protocol_lldp', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.protocol_lldp', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.protocol_lldp', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.protocol_lldp', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.rule.command.protocol_lldp': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2f.rule.command.protocol_lldp': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_1_01a.rule.command.protocol_lldp': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17s_1_02.rule.command.protocol_lldp': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command.protocol_lldp': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_protocol_pr_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.protocol_pr', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.protocol_pr', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.protocol_pr', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.protocol_pr', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.protocol_pr', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.rule.command.protocol_pr': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v6_0_2f.rule.command.protocol_pr': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17s_1_02.rule.command.protocol_pr': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command.protocol_pr': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17r_1_01a.rule.command.protocol_pr': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_protocol_protocol_spanning_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.protocol_spanning.protocol', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.protocol_spanning.protocol', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.protocol_spanning.protocol', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.protocol_spanning.protocol', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.protocol_spanning.protocol', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_2_00.rule.command.protocol_spanning.protocol': [u'protocol'], 'pybind.nos.v7_2_0.rule.command.protocol_spanning.protocol': [u'protocol'], 'pybind.slxos.v17s_1_02.rule.command.protocol_spanning.protocol': [u'protocol'], 'pybind.nos.v6_0_2f.rule.command.protocol_spanning.protocol': [u'protocol'], 'pybind.slxos.v17r_1_01a.rule.command.protocol_spanning.protocol': [u'protocol']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_protocol_spanning_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.rule', 'rule'), ('pybind.slxos.v17r_2_00.rule', 'rule'), ('pybind.slxos.v17r_1_01a.rule', 'rule'), ('pybind.nos.v7_2_0.rule', 'rule'), ('pybind.slxos.v17s_1_02.rule', 'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.rule.command.protocol_spanning', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule.command.protocol_spanning', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule.command.protocol_spanning', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule.command.protocol_spanning', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule.command.protocol_spanning', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}, {'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.rule.command.protocol_spanning': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.nos.v7_2_0.rule.command.protocol_spanning': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.nos.v6_0_2f.rule.command.protocol_spanning': [u'clear_support', u'clear_logging', u'clear_cl', u'copy_cp', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback'], 'pybind.slxos.v17s_1_02.rule.command.protocol_spanning': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr'], 'pybind.slxos.v17r_2_00.rule.command.protocol_spanning': [u'clear_support', u'clear_logging', u'clear_cl', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'protocol_lldp', u'interface_int', u'interface_eth', u'protocol_spanning', u'interface_eth_leaf', u'copy_support', u'copy_cp', u'interface_pc', u'copy_running', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback', u'interface_mgmt', u'interface_fc', u'protocol_pr']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_show_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_2_0.rule.command.show_cli_history.show', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.show_cli_history.show': [u'show']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_show_cli_history_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_2_0.rule.command.show_cli_history', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.show_cli_history': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_show_lcl_runcfg_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_2_0.rule.command.show_lcl_runcfg', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.show_lcl_runcfg': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_show_legacy_runcfg_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_2_0.rule.command.show_legacy_runcfg', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.show_legacy_runcfg': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_show_rb_local_runcfg_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_2_0.rule.command.show_rb_local_runcfg', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.show_rb_local_runcfg': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_show_rb_runcfg_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_2_0.rule.command.show_rb_runcfg', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.show_rb_runcfg': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_show_running_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_2_0.rule.command.show_running', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.show_running': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_show_show_lcl_runcfg_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_2_0.rule.command.show_lcl_runcfg.show', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.show_lcl_runcfg.show': [u'show']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_show_show_legacy_runcfg_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_2_0.rule.command.show_legacy_runcfg.show', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.show_legacy_runcfg.show': [u'show']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_show_show_rb_local_runcfg_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_2_0.rule.command.show_rb_local_runcfg.show', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.show_rb_local_runcfg.show': [u'show']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_show_show_rb_runcfg_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_2_0.rule.command.show_rb_runcfg.show', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.show_rb_runcfg.show': [u'show']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_show_show_running_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_2_0.rule.command.show_running.show', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.show_running.show': [u'show']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_show_show_startupcfg_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_2_0.rule.command.show_startupcfg.show', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.show_startupcfg.show': [u'show']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_show_show_startupdb_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_2_0.rule.command.show_startupdb.show', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.show_startupdb.show': [u'show']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_show_startupcfg_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_2_0.rule.command.show_startupcfg', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.show_startupcfg': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_command_show_startupdb_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: index, action, operation, role
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type action: unicode
    :param action: **rule** tuple argument:  Action for the command

        * enumeration restriction: ::

            ['accept', 'reject']

    :type operation: unicode
    :param operation: **rule** tuple argument:  Operation for the command

        * enumeration restriction: ::

            ['read-write', 'read-only']

    :type role: unicode
    :param role: **rule** tuple argument:  One of the existing roles

        * length restriction: ::

            ['4 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.rule', 'rule')]
    bindings_list = [('pybind.nos.v7_2_0.rule.command.show_startupdb', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'index', 'extra_keyval': 'index, action, operation, role'}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.rule.command.show_startupdb': [u'show_lcl_runcfg', u'show_cli_history', u'clear_support', u'clear_logging', u'clear_cl', u'show_running', u'show_startupcfg', u'copy_cp', u'show_rb_runcfg', u'show_legacy_runcfg', u'show_startupdb', u'show_rb_local_runcfg', u'interface_fc', u'interface_ge_leaf', u'protocol_spanning', u'protocol_pr', u'interface_ve_leaf', u'interface_ve', u'interface_fc_leaf', u'enumList', u'interface_fe_leaf', u'interface_fe', u'interface_he_leaf', u'interface_he', u'interface_te', u'interface_int', u'copy_support', u'protocol_lldp', u'interface_fcoe', u'copy_running', u'interface_fcoe_leaf', u'interface_ge', u'interface_mgmt', u'interface_pc', u'interface_te_leaf', u'interface_vlan', u'interface_pc_leaf', u'interface_management_leaf', u'interface_vlan_leaf', u'interface_loopback_leaf', u'interface_loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_operation_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type rule: index
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rule', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.rule.command.interface_pc_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_ve_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_eth_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_fc_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule', u'command'), ('pybind.slxos.v17s_1_02.rule.command.interface_management_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_vlan_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_loopback_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_vlan_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_fcoe_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_te_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_ve_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_he_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_pc_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_loopback_leaf', u'interface'), ('pybind.nos.v7_2_0.rule', u'command'), ('pybind.nos.v7_2_0.rule.command.interface_fc_leaf', u'interface'), ('pybind.nos.v7_2_0.vlan.classifier', u'rule'), ('pybind.nos.v7_2_0.rule.command.interface_ge_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_management_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_fe_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_management_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_vlan_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_ve_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_eth_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_pc_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_fc_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule', u'command'), ('pybind.slxos.v17r_2_00.rule.command.interface_loopback_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule', u'command'), ('pybind.slxos.v17r_1_01a.rule.command.interface_fc_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_eth_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_management_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_vlan_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_loopback_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_ve_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_pc_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_he_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_ge_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_fe_leaf', u'interface'), ('pybind.nos.v6_0_2f.vlan.classifier', u'rule'), ('pybind.nos.v6_0_2f.rule', u'command'), ('pybind.nos.v6_0_2f.rule.command.interface_loopback_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_te_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_management_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_ve_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_pc_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_fcoe_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_fc_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_vlan_leaf', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'rule', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'port_channel_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'ethernet_leaf'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'enumList'}, {'leafval': 'management_leaf'}, {'leafval': 'vlan_leaf'}, {'leafval': 'loopback_leaf'}, {'leafval': 'vlan_leaf'}, {'leafval': 'fcoe_leaf'}, {'leafval': 'tengigabitethernet_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'hundredgigabitethernet_leaf'}, {'leafval': 'port_channel_leaf'}, {'leafval': 'loopback_leaf'}, {'leafval': 'enumList'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'ruleid'}, {'leafval': 'gigabitethernet_leaf'}, {'leafval': 'management_leaf'}, {'leafval': 'fortygigabitethernet_leaf'}, {'leafval': 'management_leaf'}, {'leafval': 'vlan_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'ethernet_leaf'}, {'leafval': 'port_channel_leaf'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'enumList'}, {'leafval': 'loopback_leaf'}, {'leafval': 'enumList'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'ethernet_leaf'}, {'leafval': 'management_leaf'}, {'leafval': 'vlan_leaf'}, {'leafval': 'loopback_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'port_channel_leaf'}, {'leafval': 'hundredgigabitethernet_leaf'}, {'leafval': 'gigabitethernet_leaf'}, {'leafval': 'fortygigabitethernet_leaf'}, {'leafval': 'ruleid'}, {'leafval': 'enumList'}, {'leafval': 'loopback_leaf'}, {'leafval': 'tengigabitethernet_leaf'}, {'leafval': 'management_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'port_channel_leaf'}, {'leafval': 'fcoe_leaf'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'vlan_leaf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def rule_role_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type rule: index
    :param rule: Keyword argument tuple.

    :type index: long
    :param index: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.rule', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.rule', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rule', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rule', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rule', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.rule.command.interface_pc_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_ve_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_eth_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_fc_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule', u'command'), ('pybind.slxos.v17s_1_02.rule.command.interface_management_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_vlan_leaf', u'interface'), ('pybind.slxos.v17s_1_02.rule.command.interface_loopback_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_vlan_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_fcoe_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_te_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_ve_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_he_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_pc_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_loopback_leaf', u'interface'), ('pybind.nos.v7_2_0.rule', u'command'), ('pybind.nos.v7_2_0.rule.command.interface_fc_leaf', u'interface'), ('pybind.nos.v7_2_0.vlan.classifier', u'rule'), ('pybind.nos.v7_2_0.rule.command.interface_ge_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_management_leaf', u'interface'), ('pybind.nos.v7_2_0.rule.command.interface_fe_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_management_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_vlan_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_ve_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_eth_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_pc_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule.command.interface_fc_leaf', u'interface'), ('pybind.slxos.v17r_2_00.rule', u'command'), ('pybind.slxos.v17r_2_00.rule.command.interface_loopback_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule', u'command'), ('pybind.slxos.v17r_1_01a.rule.command.interface_fc_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_eth_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_management_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_vlan_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_loopback_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_ve_leaf', u'interface'), ('pybind.slxos.v17r_1_01a.rule.command.interface_pc_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_he_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_ge_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_fe_leaf', u'interface'), ('pybind.nos.v6_0_2f.vlan.classifier', u'rule'), ('pybind.nos.v6_0_2f.rule', u'command'), ('pybind.nos.v6_0_2f.rule.command.interface_loopback_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_te_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_management_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_ve_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_pc_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_fcoe_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_fc_leaf', u'interface'), ('pybind.nos.v6_0_2f.rule.command.interface_vlan_leaf', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'rule', 'keyval': 'index', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'port_channel_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'ethernet_leaf'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'enumList'}, {'leafval': 'management_leaf'}, {'leafval': 'vlan_leaf'}, {'leafval': 'loopback_leaf'}, {'leafval': 'vlan_leaf'}, {'leafval': 'fcoe_leaf'}, {'leafval': 'tengigabitethernet_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'hundredgigabitethernet_leaf'}, {'leafval': 'port_channel_leaf'}, {'leafval': 'loopback_leaf'}, {'leafval': 'enumList'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'ruleid'}, {'leafval': 'gigabitethernet_leaf'}, {'leafval': 'management_leaf'}, {'leafval': 'fortygigabitethernet_leaf'}, {'leafval': 'management_leaf'}, {'leafval': 'vlan_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'ethernet_leaf'}, {'leafval': 'port_channel_leaf'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'enumList'}, {'leafval': 'loopback_leaf'}, {'leafval': 'enumList'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'ethernet_leaf'}, {'leafval': 'management_leaf'}, {'leafval': 'vlan_leaf'}, {'leafval': 'loopback_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'port_channel_leaf'}, {'leafval': 'hundredgigabitethernet_leaf'}, {'leafval': 'gigabitethernet_leaf'}, {'leafval': 'fortygigabitethernet_leaf'}, {'leafval': 'ruleid'}, {'leafval': 'enumList'}, {'leafval': 'loopback_leaf'}, {'leafval': 'tengigabitethernet_leaf'}, {'leafval': 'management_leaf'}, {'leafval': 've_leaf'}, {'leafval': 'port_channel_leaf'}, {'leafval': 'fcoe_leaf'}, {'leafval': 'fibrechannel_leaf'}, {'leafval': 'vlan_leaf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def secpolicy_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.secpolicy', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.secpolicy', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.secpolicy', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.secpolicy', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.active_policy', u'policies'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.defined_policy', u'policies'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.defined_policy', u'policies'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.active_policy', u'policies'), ('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.defined_policy', u'policies'), ('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.active_policy', u'policies'), ('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.active_policy', u'policies'), ('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.defined_policy', u'policies')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def secpolicy_active_policy_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.active_policy', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.active_policy', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.active_policy', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.active_policy', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.active_policy', u'policies'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.active_policy', u'policies'), ('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.active_policy', u'policies'), ('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.active_policy', u'policies')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def secpolicy_active_policy_policies_get(self, policies=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type policies: policy
    :param policies: Keyword argument tuple.

    :type policy: unicode
    :param policy: **policies** tuple argument.

        * pattern restriction: ::

            'SCC_POLICY'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.active_policy.policies', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.active_policy.policies', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.active_policy.policies', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.active_policy.policies', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.active_policy.policies', u'member_entry'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.active_policy.policies', u'member_entry'), ('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.active_policy.policies', u'member_entry'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.active_policy.policies', u'member_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'policies', 'keyval': 'policy', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'member'}, {'leafval': 'member'}, {'leafval': 'member'}, {'leafval': 'member'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policies=policies)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policies=policies)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def secpolicy_active_policy_policies_member_entry_get(self, policies=None, member_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policies: policy
    :param policies: Keyword argument tuple.

    :type policy: unicode
    :param policy: **policies** tuple argument.

        * pattern restriction: ::

            'SCC_POLICY'

    **Instance Keyword Argument Tuple**:

    :type member_entry: member
    :param member_entry: Keyword argument tuple.

    :type member: unicode
    :param member: **member_entry** tuple argument:  WWN of the switch

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.active_policy.policies', u'policies'), ('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.active_policy.policies', u'policies'), ('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.active_policy.policies', u'policies'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.active_policy.policies', u'policies')]
    bindings_list = [('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.active_policy.policies.member_entry', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.active_policy.policies.member_entry', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.active_policy.policies.member_entry', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.active_policy.policies.member_entry', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_entry', 'keyval': 'member', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policies=policies, member_entry=member_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policies=policies, member_entry=member_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def secpolicy_defined_policy_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.defined_policy', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.defined_policy', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.defined_policy', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.defined_policy', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.defined_policy', u'policies'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.defined_policy', u'policies'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.defined_policy', u'policies'), ('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.defined_policy', u'policies')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def secpolicy_defined_policy_policies_get(self, policies=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type policies: policy
    :param policies: Keyword argument tuple.

    :type policy: unicode
    :param policy: **policies** tuple argument.

        * pattern restriction: ::

            'SCC_POLICY'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.defined_policy.policies', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.defined_policy.policies', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.defined_policy.policies', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.defined_policy.policies', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.defined_policy.policies', u'member_entry'), ('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.defined_policy.policies', u'member_entry'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.defined_policy.policies', u'member_entry'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.defined_policy.policies', u'member_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'policies', 'keyval': 'policy', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'member'}, {'leafval': 'member'}, {'leafval': 'member'}, {'leafval': 'member'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policies=policies)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policies=policies)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def secpolicy_defined_policy_policies_member_entry_get(self, policies=None, member_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policies: policy
    :param policies: Keyword argument tuple.

    :type policy: unicode
    :param policy: **policies** tuple argument.

        * pattern restriction: ::

            'SCC_POLICY'

    **Instance Keyword Argument Tuple**:

    :type member_entry: member
    :param member_entry: Keyword argument tuple.

    :type member: unicode
    :param member: **member_entry** tuple argument:  WWN of the switch

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.defined_policy.policies', u'policies'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.defined_policy.policies', u'policies'), ('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.defined_policy.policies', u'policies'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.defined_policy.policies', u'policies')]
    bindings_list = [('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.defined_policy.policies.member_entry', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.defined_policy.policies.member_entry', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.defined_policy.policies.member_entry', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.defined_policy.policies.member_entry', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}, {'keyval': 'policy', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_entry', 'keyval': 'member', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policies=policies, member_entry=member_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policies=policies, member_entry=member_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def secpolicy_sa_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.secpolicy_sa', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.secpolicy_sa', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.secpolicy_sa', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.secpolicy_sa', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.active_policy', u'policies'), ('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.defined_policy', u'policies'), ('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.defined_policy', u'policies'), ('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.active_policy', u'policies'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.defined_policy', u'policies'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.active_policy', u'policies'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.active_policy', u'policies'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.defined_policy', u'policies')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def secpolicy_secpolicy_sa_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy', 'pybind.nos.v6_0_2f.brocade_fc_auth', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.secpolicy_sa.secpolicy', 'pybind.nos.v7_2_0.brocade_fc_auth', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy', 'pybind.slxos.v17r_1_01a.brocade_fc_auth', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy', 'pybind.slxos.v17r_2_00.brocade_fc_auth', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.active_policy', u'policies'), ('pybind.nos.v7_2_0.secpolicy_sa.secpolicy.defined_policy', u'policies'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.defined_policy', u'policies'), ('pybind.slxos.v17r_1_01a.secpolicy_sa.secpolicy.active_policy', u'policies'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.active_policy', u'policies'), ('pybind.slxos.v17r_2_00.secpolicy_sa.secpolicy.defined_policy', u'policies'), ('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.defined_policy', u'policies'), ('pybind.nos.v6_0_2f.secpolicy_sa.secpolicy.active_policy', u'policies')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}, {'leafval': 'policy'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def service_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.service', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.service', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.service', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.service', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.service', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def service_password_encryption_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.service', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.service', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.service', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.service', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.service', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.sflow', 'pybind.nos.v6_0_2f.brocade_sflow', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.sflow', 'pybind.nos.v7_2_0.brocade_sflow', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.sflow', 'pybind.slxos.v17r_1_01a.brocade_sflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sflow', 'pybind.slxos.v17r_2_00.brocade_sflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sflow', 'pybind.slxos.v17s_1_02.brocade_sflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.sflow', u'source_interface'), ('pybind.slxos.v17r_1_01a.sflow', u'collector'), ('pybind.nos.v6_0_2f.sflow', u'collector'), ('pybind.nos.v7_2_0.sflow', u'collector'), ('pybind.slxos.v17s_1_02.sflow', u'source_interface'), ('pybind.slxos.v17s_1_02.sflow', u'collector'), ('pybind.slxos.v17r_2_00.sflow', u'collector'), ('pybind.slxos.v17r_2_00.sflow', u'agent_address'), ('pybind.slxos.v17r_2_00.sflow', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'agent_addr_type, agent_interface_type, agent_interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {"pybind.nos.v7_2_0.sflow": {"sample_rate": "sample_rate", "enable": "enable", "source_ip": "source_ip", "polling_interval": "polling_interval"}, "pybind.slxos.v17r_2_00.sflow": {}, "pybind.slxos.v17r_1_01a.sflow": {}, "pybind.nos.v6_0_2f.sflow": {"sample_rate": "sample_rate", "enable": "enable", "source_ip": "source_ip", "polling_interval": "polling_interval"}, "pybind.slxos.v17s_1_02.sflow": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_agent_address_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.sflow.agent_address', 'pybind.slxos.v17r_2_00.brocade_sflow', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'agent_addr_type, agent_interface_type, agent_interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_agent_address_agent_addr_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.sflow.agent_address', 'pybind.slxos.v17r_2_00.brocade_sflow', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_agent_address_agent_interface_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.sflow.agent_address', 'pybind.slxos.v17r_2_00.brocade_sflow', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_agent_address_agent_interface_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.sflow.agent_address', 'pybind.slxos.v17r_2_00.brocade_sflow', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_collector_get(self, collector=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type collector: collector_ip_address, collector_port_number, use_vrf
    :param collector: Keyword argument tuple.

    :type collector_ip_address: unicode
    :param collector_ip_address: **collector** tuple argument:  <ipv4/v6 address>; The IPv4/IPv6 address of the Sflow collector

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type collector_port_number: long
    :param collector_port_number: **collector** tuple argument:  <1-65535> The port number used by the Sflow collector (default = 6343)

        * range restriction: ::

            ['0..4294967295']

    :type use_vrf: unicode
    :param use_vrf: **collector** tuple argument:  Vrf to use for sending data to the collector (default = mgmt-vrf)

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.sflow.collector', 'pybind.nos.v6_0_2f.brocade_sflow', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.sflow.collector', 'pybind.nos.v7_2_0.brocade_sflow', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.sflow.collector', 'pybind.slxos.v17r_1_01a.brocade_sflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sflow.collector', 'pybind.slxos.v17r_2_00.brocade_sflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sflow.collector', 'pybind.slxos.v17s_1_02.brocade_sflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'collector', 'keyval': 'collector_ip_address, collector_port_number, use_vrf', 'extra_keyval': 'collector_ip_address, collector_port_number, use_vrf'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, collector=collector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, collector=collector)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_collector_vrf_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sflow', 'pybind.slxos.v17r_1_01a.brocade_sflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sflow', 'pybind.slxos.v17r_2_00.brocade_sflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sflow', 'pybind.slxos.v17s_1_02.brocade_sflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.sflow', u'collector'), ('pybind.slxos.v17r_2_00.sflow', u'agent_address'), ('pybind.slxos.v17r_2_00.sflow', u'source_interface'), ('pybind.slxos.v17r_1_01a.sflow', u'source_interface'), ('pybind.slxos.v17r_1_01a.sflow', u'collector'), ('pybind.slxos.v17s_1_02.sflow', u'source_interface'), ('pybind.slxos.v17s_1_02.sflow', u'collector')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'agent_addr_type, agent_interface_type, agent_interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.sflow', 'pybind.nos.v6_0_2f.brocade_sflow', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.sflow', 'pybind.nos.v7_2_0.brocade_sflow', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.sflow', 'pybind.slxos.v17r_1_01a.brocade_sflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sflow', 'pybind.slxos.v17r_2_00.brocade_sflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sflow', 'pybind.slxos.v17s_1_02.brocade_sflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.sflow', u'source_interface'), ('pybind.slxos.v17r_1_01a.sflow', u'collector'), ('pybind.nos.v6_0_2f.sflow', u'collector'), ('pybind.nos.v7_2_0.sflow', u'collector'), ('pybind.slxos.v17s_1_02.sflow', u'source_interface'), ('pybind.slxos.v17s_1_02.sflow', u'collector'), ('pybind.slxos.v17r_2_00.sflow', u'collector'), ('pybind.slxos.v17r_2_00.sflow', u'agent_address'), ('pybind.slxos.v17r_2_00.sflow', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'agent_addr_type, agent_interface_type, agent_interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_null0_sampling_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sflow', 'pybind.slxos.v17r_1_01a.brocade_sflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sflow', 'pybind.slxos.v17r_2_00.brocade_sflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sflow', 'pybind.slxos.v17s_1_02.brocade_sflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.sflow', u'collector'), ('pybind.slxos.v17r_2_00.sflow', u'agent_address'), ('pybind.slxos.v17r_2_00.sflow', u'source_interface'), ('pybind.slxos.v17r_1_01a.sflow', u'source_interface'), ('pybind.slxos.v17r_1_01a.sflow', u'collector'), ('pybind.slxos.v17s_1_02.sflow', u'source_interface'), ('pybind.slxos.v17s_1_02.sflow', u'collector')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'agent_addr_type, agent_interface_type, agent_interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_polling_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.sflow', 'pybind.nos.v6_0_2f.brocade_sflow', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.sflow', 'pybind.nos.v7_2_0.brocade_sflow', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.sflow', 'pybind.slxos.v17r_1_01a.brocade_sflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sflow', 'pybind.slxos.v17r_2_00.brocade_sflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sflow', 'pybind.slxos.v17s_1_02.brocade_sflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.sflow', u'source_interface'), ('pybind.slxos.v17r_1_01a.sflow', u'collector'), ('pybind.nos.v6_0_2f.sflow', u'collector'), ('pybind.nos.v7_2_0.sflow', u'collector'), ('pybind.slxos.v17s_1_02.sflow', u'source_interface'), ('pybind.slxos.v17s_1_02.sflow', u'collector'), ('pybind.slxos.v17r_2_00.sflow', u'collector'), ('pybind.slxos.v17r_2_00.sflow', u'agent_address'), ('pybind.slxos.v17r_2_00.sflow', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'agent_addr_type, agent_interface_type, agent_interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_profile_get(self, sflow_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type sflow_profile: profile_name, profile_sampling_rate
    :param sflow_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **sflow_profile** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type profile_sampling_rate: long
    :param profile_sampling_rate: **sflow_profile** tuple argument:  Sflow profile sampling-rate

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.sflow_profile', 'pybind.nos.v6_0_2f.brocade_sflow', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.sflow_profile', 'pybind.nos.v7_2_0.brocade_sflow', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.sflow_profile', 'pybind.slxos.v17r_1_01a.brocade_sflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sflow_profile', 'pybind.slxos.v17r_2_00.brocade_sflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sflow_profile', 'pybind.slxos.v17s_1_02.brocade_sflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'sflow_profile', 'keyval': 'profile_name', 'extra_keyval': 'profile_name, profile_sampling_rate'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sflow_profile=sflow_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sflow_profile=sflow_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_profile_sampling_rate_get(self, sflow_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type sflow_profile: profile_name
    :param sflow_profile: Keyword argument tuple.

    :type profile_name: unicode
    :param profile_name: **sflow_profile** tuple argument.

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9_]{0,63})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.sflow_profile', 'pybind.nos.v6_0_2f.brocade_sflow', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.sflow_profile', 'pybind.nos.v7_2_0.brocade_sflow', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.sflow_profile', 'pybind.slxos.v17r_1_01a.brocade_sflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sflow_profile', 'pybind.slxos.v17r_2_00.brocade_sflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sflow_profile', 'pybind.slxos.v17s_1_02.brocade_sflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'sflow_profile', 'keyval': 'profile_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, sflow_profile=sflow_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, sflow_profile=sflow_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_sample_rate_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.sflow', 'pybind.nos.v6_0_2f.brocade_sflow', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.sflow', 'pybind.nos.v7_2_0.brocade_sflow', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.sflow', 'pybind.slxos.v17r_1_01a.brocade_sflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sflow', 'pybind.slxos.v17r_2_00.brocade_sflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sflow', 'pybind.slxos.v17s_1_02.brocade_sflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.sflow', u'source_interface'), ('pybind.slxos.v17r_1_01a.sflow', u'collector'), ('pybind.nos.v6_0_2f.sflow', u'collector'), ('pybind.nos.v7_2_0.sflow', u'collector'), ('pybind.slxos.v17s_1_02.sflow', u'source_interface'), ('pybind.slxos.v17s_1_02.sflow', u'collector'), ('pybind.slxos.v17r_2_00.sflow', u'collector'), ('pybind.slxos.v17r_2_00.sflow', u'agent_address'), ('pybind.slxos.v17r_2_00.sflow', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'agent_addr_type, agent_interface_type, agent_interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_source_interface_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sflow.source_interface', 'pybind.slxos.v17r_1_01a.brocade_sflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sflow.source_interface', 'pybind.slxos.v17r_2_00.brocade_sflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sflow.source_interface', 'pybind.slxos.v17s_1_02.brocade_sflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'interface_type, interface_name'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_source_interface_interface_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sflow.source_interface', 'pybind.slxos.v17r_1_01a.brocade_sflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sflow.source_interface', 'pybind.slxos.v17r_2_00.brocade_sflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sflow.source_interface', 'pybind.slxos.v17s_1_02.brocade_sflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_source_interface_interface_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sflow.source_interface', 'pybind.slxos.v17r_1_01a.brocade_sflow', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sflow.source_interface', 'pybind.slxos.v17r_2_00.brocade_sflow', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sflow.source_interface', 'pybind.slxos.v17s_1_02.brocade_sflow', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sflow_source_ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.sflow', 'pybind.nos.v6_0_2f.brocade_sflow', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.sflow', 'pybind.nos.v7_2_0.brocade_sflow', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.sflow', u'collector'), ('pybind.nos.v6_0_2f.sflow', u'collector')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'collector_ip_address, collector_port_number, use_vrf'}, {'leafval': 'collector_ip_address, collector_port_number, use_vrf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.sfm_state', u'statistics'), ('pybind.slxos.v17r_2_00.sfm_state', u'thresholds'), ('pybind.slxos.v17r_2_00.sfm_state', u'queue'), ('pybind.slxos.v17r_2_00.sfm_state', u'mcast'), ('pybind.slxos.v17r_2_00.sfm_state', u'connectivity'), ('pybind.slxos.v17r_2_00.sfm_state', u'links'), ('pybind.slxos.v17r_2_00.sfm_state', u'serdesmode'), ('pybind.slxos.v17r_1_01a.sfm_state', u'queue'), ('pybind.slxos.v17r_1_01a.sfm_state', u'mcast'), ('pybind.slxos.v17r_1_01a.sfm_state', u'connectivity'), ('pybind.slxos.v17r_1_01a.sfm_state', u'serdesmode'), ('pybind.slxos.v17r_1_01a.sfm_state', u'links'), ('pybind.slxos.v17r_1_01a.sfm_state', u'statistics'), ('pybind.slxos.v17r_1_01a.sfm_state', u'thresholds'), ('pybind.slxos.v17s_1_02.sfm_state', u'mcast'), ('pybind.slxos.v17s_1_02.sfm_state', u'serdesmode'), ('pybind.slxos.v17s_1_02.sfm_state', u'links'), ('pybind.slxos.v17s_1_02.sfm_state', u'queue'), ('pybind.slxos.v17s_1_02.sfm_state', u'statistics'), ('pybind.slxos.v17s_1_02.sfm_state', u'thresholds'), ('pybind.slxos.v17s_1_02.sfm_state', u'connectivity')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'statistics_sfmid, statistics_feid, statistics_pipe, statistics_dch_total_in, statistics_dch_total_out, statistics_dch_fifo_discard, statistics_dch_reorder_discard, statistics_dch_unreach_discard, statistics_dch_max_q_size, statistics_dcm_tot, statistics_dcm_drop, statistics_dcm_max, statistics_dcl_tot_in, statistics_dcl_tot_out, statistics_dcl_dropped, statistics_dcl_max'}, {'leafval': 'thresholds_sfmid, thresholds_feid, thresholds_port'}, {'leafval': 'queue_sfmid, queue_feid, queue_pipe, queue_dch_count, queue_dcm_count, queue_dcl_count'}, {'leafval': 'mcastid, mcast_count, mcast_sfmid, mcast_feid, mcast_sfmcount'}, {'leafval': 'connectivity_count, connectivity_sfmid, connectivity_feid, connectivity_type'}, {'leafval': 'links_count, links_sfmid, links_feid'}, {'leafval': 'serdesmode, serdesmode_sfmid, serdesmode_feid'}, {'leafval': 'queue_sfmid, queue_feid, queue_pipe, queue_dch_count, queue_dcm_count, queue_dcl_count'}, {'leafval': 'mcastid, mcast_count, mcast_sfmid, mcast_feid, mcast_sfmcount'}, {'leafval': 'connectivity_count, connectivity_sfmid, connectivity_feid, connectivity_type'}, {'leafval': 'serdesmode, serdesmode_sfmid, serdesmode_feid'}, {'leafval': 'links_count, links_sfmid, links_feid'}, {'leafval': 'statistics_sfmid, statistics_feid, statistics_pipe, statistics_dch_total_in, statistics_dch_total_out, statistics_dch_fifo_discard, statistics_dch_reorder_discard, statistics_dch_unreach_discard, statistics_dch_max_q_size, statistics_dcm_tot, statistics_dcm_drop, statistics_dcm_max, statistics_dcl_tot_in, statistics_dcl_tot_out, statistics_dcl_dropped, statistics_dcl_max'}, {'leafval': 'thresholds_sfmid, thresholds_feid, thresholds_port'}, {'leafval': 'mcastid, mcast_count, mcast_sfmid, mcast_feid, mcast_sfmcount'}, {'leafval': 'serdesmode, serdesmode_sfmid, serdesmode_feid'}, {'leafval': 'links_count, links_sfmid, links_feid'}, {'leafval': 'queue_sfmid, queue_feid, queue_pipe, queue_dch_count, queue_dcm_count, queue_dcl_count'}, {'leafval': 'statistics_sfmid, statistics_feid, statistics_pipe, statistics_dch_total_in, statistics_dch_total_out, statistics_dch_fifo_discard, statistics_dch_reorder_discard, statistics_dch_unreach_discard, statistics_dch_max_q_size, statistics_dcm_tot, statistics_dcm_drop, statistics_dcm_max, statistics_dcl_tot_in, statistics_dcl_tot_out, statistics_dcl_dropped, statistics_dcl_max'}, {'leafval': 'thresholds_sfmid, thresholds_feid, thresholds_port'}, {'leafval': 'connectivity_count, connectivity_sfmid, connectivity_feid, connectivity_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_connectivity_get(self, connectivity=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type connectivity: connectivity_sfmid
    :param connectivity: Keyword argument tuple.

    :type connectivity_sfmid: long
    :param connectivity_sfmid: **connectivity** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.connectivity', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.connectivity', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.connectivity', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'connectivity', 'keyval': 'connectivity_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connectivity=connectivity)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connectivity=connectivity)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_connectivity_connectivity_count_get(self, connectivity=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type connectivity: connectivity_sfmid
    :param connectivity: Keyword argument tuple.

    :type connectivity_sfmid: long
    :param connectivity_sfmid: **connectivity** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.connectivity', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.connectivity', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.connectivity', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'connectivity', 'keyval': 'connectivity_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connectivity=connectivity)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connectivity=connectivity)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_connectivity_connectivity_feid_get(self, connectivity=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type connectivity: connectivity_sfmid
    :param connectivity: Keyword argument tuple.

    :type connectivity_sfmid: long
    :param connectivity_sfmid: **connectivity** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.connectivity', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.connectivity', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.connectivity', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'connectivity', 'keyval': 'connectivity_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connectivity=connectivity)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connectivity=connectivity)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_connectivity_connectivity_type_get(self, connectivity=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type connectivity: connectivity_sfmid
    :param connectivity: Keyword argument tuple.

    :type connectivity_sfmid: long
    :param connectivity_sfmid: **connectivity** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.connectivity', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.connectivity', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.connectivity', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'connectivity', 'keyval': 'connectivity_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, connectivity=connectivity)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, connectivity=connectivity)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_links_get(self, links=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type links: links_sfmid
    :param links: Keyword argument tuple.

    :type links_sfmid: long
    :param links_sfmid: **links** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.links', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.links', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.links', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'links', 'keyval': 'links_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, links=links)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, links=links)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_links_links_count_get(self, links=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type links: links_sfmid
    :param links: Keyword argument tuple.

    :type links_sfmid: long
    :param links_sfmid: **links** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.links', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.links', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.links', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'links', 'keyval': 'links_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, links=links)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, links=links)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_links_links_feid_get(self, links=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type links: links_sfmid
    :param links: Keyword argument tuple.

    :type links_sfmid: long
    :param links_sfmid: **links** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.links', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.links', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.links', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'links', 'keyval': 'links_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, links=links)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, links=links)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_mcast_get(self, mcast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type mcast: mcastid
    :param mcast: Keyword argument tuple.

    :type mcastid: long
    :param mcastid: **mcast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.mcast', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.mcast', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.mcast', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mcast', 'keyval': 'mcastid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mcast=mcast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mcast=mcast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_mcast_mcast_count_get(self, mcast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type mcast: mcastid
    :param mcast: Keyword argument tuple.

    :type mcastid: long
    :param mcastid: **mcast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.mcast', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.mcast', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.mcast', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mcast', 'keyval': 'mcastid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mcast=mcast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mcast=mcast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_mcast_mcast_feid_get(self, mcast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type mcast: mcastid
    :param mcast: Keyword argument tuple.

    :type mcastid: long
    :param mcastid: **mcast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.mcast', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.mcast', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.mcast', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mcast', 'keyval': 'mcastid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mcast=mcast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mcast=mcast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_mcast_mcast_sfmcount_get(self, mcast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type mcast: mcastid
    :param mcast: Keyword argument tuple.

    :type mcastid: long
    :param mcastid: **mcast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.mcast', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.mcast', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.mcast', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mcast', 'keyval': 'mcastid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mcast=mcast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mcast=mcast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_mcast_mcast_sfmid_get(self, mcast=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type mcast: mcastid
    :param mcast: Keyword argument tuple.

    :type mcastid: long
    :param mcastid: **mcast** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.mcast', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.mcast', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.mcast', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mcast', 'keyval': 'mcastid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mcast=mcast)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mcast=mcast)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_queue_get(self, queue=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type queue: queue_sfmid
    :param queue: Keyword argument tuple.

    :type queue_sfmid: long
    :param queue_sfmid: **queue** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.queue', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.queue', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.queue', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'queue_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue=queue)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_queue_queue_dch_count_get(self, queue=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type queue: queue_sfmid
    :param queue: Keyword argument tuple.

    :type queue_sfmid: long
    :param queue_sfmid: **queue** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.queue', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.queue', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.queue', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'queue_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue=queue)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_queue_queue_dcl_count_get(self, queue=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type queue: queue_sfmid
    :param queue: Keyword argument tuple.

    :type queue_sfmid: long
    :param queue_sfmid: **queue** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.queue', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.queue', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.queue', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'queue_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue=queue)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_queue_queue_dcm_count_get(self, queue=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type queue: queue_sfmid
    :param queue: Keyword argument tuple.

    :type queue_sfmid: long
    :param queue_sfmid: **queue** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.queue', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.queue', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.queue', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'queue_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue=queue)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_queue_queue_feid_get(self, queue=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type queue: queue_sfmid
    :param queue: Keyword argument tuple.

    :type queue_sfmid: long
    :param queue_sfmid: **queue** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.queue', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.queue', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.queue', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'queue_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue=queue)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_queue_queue_pipe_get(self, queue=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type queue: queue_sfmid
    :param queue: Keyword argument tuple.

    :type queue_sfmid: long
    :param queue_sfmid: **queue** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.queue', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.queue', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.queue', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'queue', 'keyval': 'queue_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, queue=queue)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, queue=queue)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_serdesmode_get(self, serdesmode=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type serdesmode: serdesmode_sfmid
    :param serdesmode: Keyword argument tuple.

    :type serdesmode_sfmid: long
    :param serdesmode_sfmid: **serdesmode** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.serdesmode', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.serdesmode', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.serdesmode', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'serdesmode', 'keyval': 'serdesmode_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, serdesmode=serdesmode)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, serdesmode=serdesmode)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_serdesmode_serdesmode_get(self, serdesmode=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type serdesmode: serdesmode_sfmid
    :param serdesmode: Keyword argument tuple.

    :type serdesmode_sfmid: long
    :param serdesmode_sfmid: **serdesmode** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.serdesmode', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.serdesmode', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.serdesmode', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'serdesmode', 'keyval': 'serdesmode_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, serdesmode=serdesmode)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, serdesmode=serdesmode)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_serdesmode_serdesmode_feid_get(self, serdesmode=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type serdesmode: serdesmode_sfmid
    :param serdesmode: Keyword argument tuple.

    :type serdesmode_sfmid: long
    :param serdesmode_sfmid: **serdesmode** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.serdesmode', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.serdesmode', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.serdesmode', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'serdesmode', 'keyval': 'serdesmode_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, serdesmode=serdesmode)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, serdesmode=serdesmode)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_statistics_get(self, statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.statistics', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.statistics', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.statistics', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_statistics_statistics_dch_fifo_discard_get(self, statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.statistics', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.statistics', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.statistics', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_statistics_statistics_dch_max_q_size_get(self, statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.statistics', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.statistics', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.statistics', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_statistics_statistics_dch_reorder_discard_get(self, statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.statistics', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.statistics', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.statistics', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_statistics_statistics_dch_total_in_get(self, statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.statistics', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.statistics', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.statistics', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_statistics_statistics_dch_total_out_get(self, statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.statistics', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.statistics', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.statistics', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_statistics_statistics_dch_unreach_discard_get(self, statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.statistics', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.statistics', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.statistics', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_statistics_statistics_dcl_dropped_get(self, statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.statistics', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.statistics', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.statistics', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_statistics_statistics_dcl_max_get(self, statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.statistics', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.statistics', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.statistics', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_statistics_statistics_dcl_tot_in_get(self, statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.statistics', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.statistics', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.statistics', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_statistics_statistics_dcl_tot_out_get(self, statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.statistics', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.statistics', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.statistics', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_statistics_statistics_dcm_drop_get(self, statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.statistics', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.statistics', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.statistics', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_statistics_statistics_dcm_max_get(self, statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.statistics', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.statistics', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.statistics', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_statistics_statistics_dcm_tot_get(self, statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.statistics', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.statistics', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.statistics', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_statistics_statistics_feid_get(self, statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.statistics', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.statistics', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.statistics', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_statistics_statistics_pipe_get(self, statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type statistics: statistics_sfmid
    :param statistics: Keyword argument tuple.

    :type statistics_sfmid: long
    :param statistics_sfmid: **statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.statistics', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.statistics', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.statistics', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'statistics', 'keyval': 'statistics_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics=statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics=statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_thresholds_get(self, thresholds=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type thresholds: thresholds_sfmid
    :param thresholds: Keyword argument tuple.

    :type thresholds_sfmid: long
    :param thresholds_sfmid: **thresholds** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.thresholds', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.thresholds', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.thresholds', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'thresholds', 'keyval': 'thresholds_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, thresholds=thresholds)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, thresholds=thresholds)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_thresholds_thresholds_feid_get(self, thresholds=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type thresholds: thresholds_sfmid
    :param thresholds: Keyword argument tuple.

    :type thresholds_sfmid: long
    :param thresholds_sfmid: **thresholds** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.thresholds', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.thresholds', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.thresholds', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'thresholds', 'keyval': 'thresholds_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, thresholds=thresholds)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, thresholds=thresholds)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sfm_state_thresholds_thresholds_port_get(self, thresholds=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type thresholds: thresholds_sfmid
    :param thresholds: Keyword argument tuple.

    :type thresholds_sfmid: long
    :param thresholds_sfmid: **thresholds** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sfm_state.thresholds', 'pybind.slxos.v17r_1_01a.brocade_sysmgr_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sfm_state.thresholds', 'pybind.slxos.v17r_2_00.brocade_sysmgr_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sfm_state.thresholds', 'pybind.slxos.v17s_1_02.brocade_sysmgr_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'thresholds', 'keyval': 'thresholds_sfmid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, thresholds=thresholds)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, thresholds=thresholds)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.show', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.show', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.show', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_bpswitch_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.show.bpswitch', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show.bpswitch', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show.bpswitch', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_client_id_df_info_state_get(self, show_client_id_df_info_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_client_id_df_info_state: cluster_id, client_id
    :param show_client_id_df_info_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.show_client_id_df_info_state', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show_client_id_df_info_state', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show_client_id_df_info_state', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.show_client_id_df_info_state', u'df_vlans'), ('pybind.slxos.v17r_1_01a.show_client_id_df_info_state', u'df_vlans'), ('pybind.slxos.v17s_1_02.show_client_id_df_info_state', u'df_vlans')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_client_id_df_info_state', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_client_id_df_info_state=show_client_id_df_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_client_id_df_info_state=show_client_id_df_info_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_client_id_df_info_state_client_state_get(self, show_client_id_df_info_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_client_id_df_info_state: cluster_id, client_id
    :param show_client_id_df_info_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.show_client_id_df_info_state', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show_client_id_df_info_state', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show_client_id_df_info_state', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.show_client_id_df_info_state', u'df_vlans'), ('pybind.slxos.v17r_1_01a.show_client_id_df_info_state', u'df_vlans'), ('pybind.slxos.v17s_1_02.show_client_id_df_info_state', u'df_vlans')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_client_id_df_info_state', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_client_id_df_info_state=show_client_id_df_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_client_id_df_info_state=show_client_id_df_info_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_client_id_df_info_state_df_bds_get(self, show_client_id_df_info_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_client_id_df_info_state: cluster_id, client_id
    :param show_client_id_df_info_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.show_client_id_df_info_state', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show_client_id_df_info_state', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show_client_id_df_info_state', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.show_client_id_df_info_state', u'df_vlans'), ('pybind.slxos.v17r_1_01a.show_client_id_df_info_state', u'df_vlans'), ('pybind.slxos.v17s_1_02.show_client_id_df_info_state', u'df_vlans')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_client_id_df_info_state', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_client_id_df_info_state=show_client_id_df_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_client_id_df_info_state=show_client_id_df_info_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_client_id_df_info_state_df_vlans_get(self, show_client_id_df_info_state=None, df_vlans=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_client_id_df_info_state: cluster_id, client_id
    :param show_client_id_df_info_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type df_vlans: vlan_id
    :param df_vlans: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **df_vlans** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.show_client_id_df_info_state', 'show_client_id_df_info_state'), ('pybind.slxos.v17r_2_00.show_client_id_df_info_state', 'show_client_id_df_info_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.show_client_id_df_info_state.df_vlans', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show_client_id_df_info_state.df_vlans', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id, client_id', 'extra_keyval': ''}, {'keyval': 'cluster_id, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'df_vlans', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_client_id_df_info_state=show_client_id_df_info_state, df_vlans=df_vlans)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_client_id_df_info_state=show_client_id_df_info_state, df_vlans=df_vlans)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_client_id_df_info_state_df_vlans_vlan_id_get(self, show_client_id_df_info_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_client_id_df_info_state: cluster_id, client_id
    :param show_client_id_df_info_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.show_client_id_df_info_state', 'show_client_id_df_info_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.show_client_id_df_info_state.df_vlans', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id, client_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_client_id_df_info_state=show_client_id_df_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_client_id_df_info_state=show_client_id_df_info_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_client_id_df_info_state_is_all_vlan_elected_get(self, show_client_id_df_info_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_client_id_df_info_state: cluster_id, client_id
    :param show_client_id_df_info_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.show_client_id_df_info_state', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show_client_id_df_info_state', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show_client_id_df_info_state', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.show_client_id_df_info_state', u'df_vlans'), ('pybind.slxos.v17r_1_01a.show_client_id_df_info_state', u'df_vlans'), ('pybind.slxos.v17s_1_02.show_client_id_df_info_state', u'df_vlans')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_client_id_df_info_state', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_client_id_df_info_state=show_client_id_df_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_client_id_df_info_state=show_client_id_df_info_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_client_id_df_info_state_is_df_election_pending_get(self, show_client_id_df_info_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_client_id_df_info_state: cluster_id, client_id
    :param show_client_id_df_info_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.show_client_id_df_info_state', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show_client_id_df_info_state', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show_client_id_df_info_state', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.show_client_id_df_info_state', u'df_vlans'), ('pybind.slxos.v17r_1_01a.show_client_id_df_info_state', u'df_vlans'), ('pybind.slxos.v17s_1_02.show_client_id_df_info_state', u'df_vlans')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_client_id_df_info_state', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_client_id_df_info_state=show_client_id_df_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_client_id_df_info_state=show_client_id_df_info_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_client_id_df_info_state_num_df_bds_get(self, show_client_id_df_info_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_client_id_df_info_state: cluster_id, client_id
    :param show_client_id_df_info_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.show_client_id_df_info_state', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show_client_id_df_info_state', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show_client_id_df_info_state', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.show_client_id_df_info_state', u'df_vlans'), ('pybind.slxos.v17r_1_01a.show_client_id_df_info_state', u'df_vlans'), ('pybind.slxos.v17s_1_02.show_client_id_df_info_state', u'df_vlans')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_client_id_df_info_state', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_client_id_df_info_state=show_client_id_df_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_client_id_df_info_state=show_client_id_df_info_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_client_id_df_info_state_num_df_vlans_get(self, show_client_id_df_info_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type show_client_id_df_info_state: cluster_id, client_id
    :param show_client_id_df_info_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type client_id: long
    :param client_id: **show_client_id_df_info_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.show_client_id_df_info_state', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show_client_id_df_info_state', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show_client_id_df_info_state', 'pybind.slxos.v17s_1_02.brocade_mct_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.show_client_id_df_info_state', u'df_vlans'), ('pybind.slxos.v17r_1_01a.show_client_id_df_info_state', u'df_vlans'), ('pybind.slxos.v17s_1_02.show_client_id_df_info_state', u'df_vlans')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_client_id_df_info_state', 'keyval': 'cluster_id, client_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}, {'leafval': 'vlan_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_client_id_df_info_state=show_client_id_df_info_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_client_id_df_info_state=show_client_id_df_info_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_client_state_state_get(self, show_cluster_client_state_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_client_state_state: cluster_id
    :param show_cluster_client_state_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_client_state_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state', u'client_state_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_cluster_client_state_state', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'client_name, client_id, local_state, remote_state, local_esi_label, remote_esi_label'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_client_state_state=show_cluster_client_state_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_client_state_state=show_cluster_client_state_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_client_state_state_client_state_info_get(self, show_cluster_client_state_state=None, client_state_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_client_state_state: cluster_id
    :param show_cluster_client_state_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_client_state_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_state_info: client_id
    :param client_state_info: Keyword argument tuple.

    :type client_id: long
    :param client_id: **client_state_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state', 'show_cluster_client_state_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state.client_state_info', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_state_info', 'keyval': 'client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_client_state_state=show_cluster_client_state_state, client_state_info=client_state_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_client_state_state=show_cluster_client_state_state, client_state_info=client_state_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_client_state_state_client_state_info_client_name_get(self, show_cluster_client_state_state=None, client_state_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_client_state_state: cluster_id
    :param show_cluster_client_state_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_client_state_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_state_info: client_id
    :param client_state_info: Keyword argument tuple.

    :type client_id: long
    :param client_id: **client_state_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state', 'show_cluster_client_state_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state.client_state_info', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_state_info', 'keyval': 'client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_client_state_state=show_cluster_client_state_state, client_state_info=client_state_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_client_state_state=show_cluster_client_state_state, client_state_info=client_state_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_client_state_state_client_state_info_local_esi_label_get(self, show_cluster_client_state_state=None, client_state_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_client_state_state: cluster_id
    :param show_cluster_client_state_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_client_state_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_state_info: client_id
    :param client_state_info: Keyword argument tuple.

    :type client_id: long
    :param client_id: **client_state_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state', 'show_cluster_client_state_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state.client_state_info', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_state_info', 'keyval': 'client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_client_state_state=show_cluster_client_state_state, client_state_info=client_state_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_client_state_state=show_cluster_client_state_state, client_state_info=client_state_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_client_state_state_client_state_info_local_state_get(self, show_cluster_client_state_state=None, client_state_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_client_state_state: cluster_id
    :param show_cluster_client_state_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_client_state_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_state_info: client_id
    :param client_state_info: Keyword argument tuple.

    :type client_id: long
    :param client_id: **client_state_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state', 'show_cluster_client_state_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state.client_state_info', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_state_info', 'keyval': 'client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_client_state_state=show_cluster_client_state_state, client_state_info=client_state_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_client_state_state=show_cluster_client_state_state, client_state_info=client_state_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_client_state_state_client_state_info_remote_esi_label_get(self, show_cluster_client_state_state=None, client_state_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_client_state_state: cluster_id
    :param show_cluster_client_state_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_client_state_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_state_info: client_id
    :param client_state_info: Keyword argument tuple.

    :type client_id: long
    :param client_id: **client_state_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state', 'show_cluster_client_state_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state.client_state_info', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_state_info', 'keyval': 'client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_client_state_state=show_cluster_client_state_state, client_state_info=client_state_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_client_state_state=show_cluster_client_state_state, client_state_info=client_state_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_client_state_state_client_state_info_remote_state_get(self, show_cluster_client_state_state=None, client_state_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_client_state_state: cluster_id
    :param show_cluster_client_state_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_client_state_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type client_state_info: client_id
    :param client_state_info: Keyword argument tuple.

    :type client_id: long
    :param client_id: **client_state_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state', 'show_cluster_client_state_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state.client_state_info', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'client_state_info', 'keyval': 'client_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_client_state_state=show_cluster_client_state_state, client_state_info=client_state_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_client_state_state=show_cluster_client_state_state, client_state_info=client_state_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_client_state_state_num_clients_get(self, show_cluster_client_state_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_client_state_state: cluster_id
    :param show_cluster_client_state_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_client_state_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state', u'client_state_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_cluster_client_state_state', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'client_name, client_id, local_state, remote_state, local_esi_label, remote_esi_label'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_client_state_state=show_cluster_client_state_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_client_state_state=show_cluster_client_state_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_client_state_state_tunnel_status_get(self, show_cluster_client_state_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_client_state_state: cluster_id
    :param show_cluster_client_state_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_client_state_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state', u'client_state_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_cluster_client_state_state', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'client_name, client_id, local_state, remote_state, local_esi_label, remote_esi_label'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_client_state_state=show_cluster_client_state_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_client_state_state=show_cluster_client_state_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_client_state_state_tunnel_type_get(self, show_cluster_client_state_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_client_state_state: cluster_id
    :param show_cluster_client_state_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_client_state_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.show_cluster_client_state_state', u'client_state_info')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_cluster_client_state_state', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'client_name, client_id, local_state, remote_state, local_esi_label, remote_esi_label'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_client_state_state=show_cluster_client_state_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_client_state_state=show_cluster_client_state_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_mem_bd_mct_state_get(self, show_cluster_mem_bd_mct_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_mem_bd_mct_state: cluster_id
    :param show_cluster_mem_bd_mct_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_bd_mct_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.show_cluster_mem_bd_mct_state', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show_cluster_mem_bd_mct_state', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.show_cluster_mem_bd_mct_state', u'bd_label_info'), ('pybind.slxos.v17r_2_00.show_cluster_mem_bd_mct_state', u'bd_label_info_mct')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_cluster_mem_bd_mct_state', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bd_id, mcast_label_local, mcast_label_remote'}, {'leafval': 'bd_id, unicast_label_local, mcast_label_local'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_bd_mct_state=show_cluster_mem_bd_mct_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_bd_mct_state=show_cluster_mem_bd_mct_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_mem_bd_mct_state_bd_label_info_get(self, show_cluster_mem_bd_mct_state=None, bd_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_bd_mct_state: cluster_id
    :param show_cluster_mem_bd_mct_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_bd_mct_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_label_info: bd_id
    :param bd_label_info: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bd_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.show_cluster_mem_bd_mct_state', 'show_cluster_mem_bd_mct_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.show_cluster_mem_bd_mct_state.bd_label_info', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_label_info', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_bd_mct_state=show_cluster_mem_bd_mct_state, bd_label_info=bd_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_bd_mct_state=show_cluster_mem_bd_mct_state, bd_label_info=bd_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_mem_bd_mct_state_bd_label_info_mcast_label_local_get(self, show_cluster_mem_bd_mct_state=None, bd_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_bd_mct_state: cluster_id
    :param show_cluster_mem_bd_mct_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_bd_mct_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_label_info: bd_id
    :param bd_label_info: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bd_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.show_cluster_mem_bd_mct_state', 'show_cluster_mem_bd_mct_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.show_cluster_mem_bd_mct_state.bd_label_info', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_label_info', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_bd_mct_state=show_cluster_mem_bd_mct_state, bd_label_info=bd_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_bd_mct_state=show_cluster_mem_bd_mct_state, bd_label_info=bd_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_mem_bd_mct_state_bd_label_info_mcast_label_remote_get(self, show_cluster_mem_bd_mct_state=None, bd_label_info=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_bd_mct_state: cluster_id
    :param show_cluster_mem_bd_mct_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_bd_mct_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_label_info: bd_id
    :param bd_label_info: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bd_label_info** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.show_cluster_mem_bd_mct_state', 'show_cluster_mem_bd_mct_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.show_cluster_mem_bd_mct_state.bd_label_info', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_label_info', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_bd_mct_state=show_cluster_mem_bd_mct_state, bd_label_info=bd_label_info)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_bd_mct_state=show_cluster_mem_bd_mct_state, bd_label_info=bd_label_info)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_mem_bd_mct_state_bd_label_info_mct_get(self, show_cluster_mem_bd_mct_state=None, bd_label_info_mct=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_bd_mct_state: cluster_id
    :param show_cluster_mem_bd_mct_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_bd_mct_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_label_info_mct: bd_id
    :param bd_label_info_mct: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bd_label_info_mct** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.show_cluster_mem_bd_mct_state', 'show_cluster_mem_bd_mct_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_mem_bd_mct_state.bd_label_info_mct', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_label_info_mct', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_bd_mct_state=show_cluster_mem_bd_mct_state, bd_label_info_mct=bd_label_info_mct)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_bd_mct_state=show_cluster_mem_bd_mct_state, bd_label_info_mct=bd_label_info_mct)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_mem_bd_mct_state_bd_label_info_mct_mcast_label_local_get(self, show_cluster_mem_bd_mct_state=None, bd_label_info_mct=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_bd_mct_state: cluster_id
    :param show_cluster_mem_bd_mct_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_bd_mct_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_label_info_mct: bd_id
    :param bd_label_info_mct: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bd_label_info_mct** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.show_cluster_mem_bd_mct_state', 'show_cluster_mem_bd_mct_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_mem_bd_mct_state.bd_label_info_mct', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_label_info_mct', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_bd_mct_state=show_cluster_mem_bd_mct_state, bd_label_info_mct=bd_label_info_mct)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_bd_mct_state=show_cluster_mem_bd_mct_state, bd_label_info_mct=bd_label_info_mct)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_mem_bd_mct_state_bd_label_info_mct_unicast_label_local_get(self, show_cluster_mem_bd_mct_state=None, bd_label_info_mct=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_bd_mct_state: cluster_id
    :param show_cluster_mem_bd_mct_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_bd_mct_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type bd_label_info_mct: bd_id
    :param bd_label_info_mct: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bd_label_info_mct** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.show_cluster_mem_bd_mct_state', 'show_cluster_mem_bd_mct_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_mem_bd_mct_state.bd_label_info_mct', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bd_label_info_mct', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_bd_mct_state=show_cluster_mem_bd_mct_state, bd_label_info_mct=bd_label_info_mct)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_bd_mct_state=show_cluster_mem_bd_mct_state, bd_label_info_mct=bd_label_info_mct)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_mem_bd_mct_state_num_bds_get(self, show_cluster_mem_bd_mct_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_mem_bd_mct_state: cluster_id
    :param show_cluster_mem_bd_mct_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_bd_mct_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.show_cluster_mem_bd_mct_state', 'pybind.slxos.v17r_1_01a.brocade_mct_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show_cluster_mem_bd_mct_state', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.show_cluster_mem_bd_mct_state', u'bd_label_info'), ('pybind.slxos.v17r_2_00.show_cluster_mem_bd_mct_state', u'bd_label_info_mct')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_cluster_mem_bd_mct_state', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'bd_id, mcast_label_local, mcast_label_remote'}, {'leafval': 'bd_id, unicast_label_local, mcast_label_local'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_bd_mct_state=show_cluster_mem_bd_mct_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_bd_mct_state=show_cluster_mem_bd_mct_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_mem_vlan_mct_state_get(self, show_cluster_mem_vlan_mct_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_mem_vlan_mct_state: cluster_id
    :param show_cluster_mem_vlan_mct_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan_mct_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_mem_vlan_mct_state', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.show_cluster_mem_vlan_mct_state', u'vlan_label_info_mct')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_cluster_mem_vlan_mct_state', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id, unicast_label_local, mcast_label_local'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan_mct_state=show_cluster_mem_vlan_mct_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan_mct_state=show_cluster_mem_vlan_mct_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_mem_vlan_mct_state_num_vlans_get(self, show_cluster_mem_vlan_mct_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type show_cluster_mem_vlan_mct_state: cluster_id
    :param show_cluster_mem_vlan_mct_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan_mct_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_mem_vlan_mct_state', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.show_cluster_mem_vlan_mct_state', u'vlan_label_info_mct')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'show_cluster_mem_vlan_mct_state', 'keyval': 'cluster_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id, unicast_label_local, mcast_label_local'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan_mct_state=show_cluster_mem_vlan_mct_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan_mct_state=show_cluster_mem_vlan_mct_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_mem_vlan_mct_state_vlan_label_info_mct_get(self, show_cluster_mem_vlan_mct_state=None, vlan_label_info_mct=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_vlan_mct_state: cluster_id
    :param show_cluster_mem_vlan_mct_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan_mct_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan_label_info_mct: vlan_id
    :param vlan_label_info_mct: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_label_info_mct** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.show_cluster_mem_vlan_mct_state', 'show_cluster_mem_vlan_mct_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_mem_vlan_mct_state.vlan_label_info_mct', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_label_info_mct', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan_mct_state=show_cluster_mem_vlan_mct_state, vlan_label_info_mct=vlan_label_info_mct)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan_mct_state=show_cluster_mem_vlan_mct_state, vlan_label_info_mct=vlan_label_info_mct)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_mem_vlan_mct_state_vlan_label_info_mct_mcast_label_local_get(self, show_cluster_mem_vlan_mct_state=None, vlan_label_info_mct=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_vlan_mct_state: cluster_id
    :param show_cluster_mem_vlan_mct_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan_mct_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan_label_info_mct: vlan_id
    :param vlan_label_info_mct: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_label_info_mct** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.show_cluster_mem_vlan_mct_state', 'show_cluster_mem_vlan_mct_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_mem_vlan_mct_state.vlan_label_info_mct', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_label_info_mct', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan_mct_state=show_cluster_mem_vlan_mct_state, vlan_label_info_mct=vlan_label_info_mct)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan_mct_state=show_cluster_mem_vlan_mct_state, vlan_label_info_mct=vlan_label_info_mct)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_cluster_mem_vlan_mct_state_vlan_label_info_mct_unicast_label_local_get(self, show_cluster_mem_vlan_mct_state=None, vlan_label_info_mct=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type show_cluster_mem_vlan_mct_state: cluster_id
    :param show_cluster_mem_vlan_mct_state: Keyword argument tuple.

    :type cluster_id: long
    :param cluster_id: **show_cluster_mem_vlan_mct_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vlan_label_info_mct: vlan_id
    :param vlan_label_info_mct: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_label_info_mct** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.show_cluster_mem_vlan_mct_state', 'show_cluster_mem_vlan_mct_state')]
    bindings_list = [('pybind.slxos.v17r_2_00.show_cluster_mem_vlan_mct_state.vlan_label_info_mct', 'pybind.slxos.v17r_2_00.brocade_mct_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cluster_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vlan_label_info_mct', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, show_cluster_mem_vlan_mct_state=show_cluster_mem_vlan_mct_state, vlan_label_info_mct=vlan_label_info_mct)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, show_cluster_mem_vlan_mct_state=show_cluster_mem_vlan_mct_state, vlan_label_info_mct=vlan_label_info_mct)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_crypto_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.show.crypto', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.show.crypto', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.show.crypto', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show.crypto', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show.crypto', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_defaults_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.show.defaults', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.show.defaults', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.show.defaults', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show.defaults', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show.defaults', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_diag_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.show.diag', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.show.diag', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.show.diag', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show.diag', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_fabric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.show.fabric', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.show.fabric', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.show.fabric', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show.fabric', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show.fabric', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_fcsp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.show.fcsp', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.show.fcsp', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.show.fcsp', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show.fcsp', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_firmware_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.show.show_firmware_dummy.show_firmware_option', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show.show_firmware_dummy.show_firmware_option', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_firmware_peripheral_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.show.show_firmware_dummy.show_firmware_option.peripheral_show_option', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show.show_firmware_dummy.show_firmware_option.peripheral_show_option', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_http_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.show.http', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.show.http', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.show.http', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show.http', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show.http', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_infra_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.show.infra', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.show.infra', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.show.infra', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show.infra', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show.infra', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_show_firmware_dummy_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.show.show_firmware_dummy', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show.show_firmware_dummy', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_ssh_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.show.ssh', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.show.ssh', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.show.ssh', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show.ssh', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show.ssh', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_telnet_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.show.telnet', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.show.telnet', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.show.telnet', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show.telnet', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show.telnet', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def show_vnetwork_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.show.vnetwork', 'pybind.nos.v6_0_2f.brocade_common_def', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.show.vnetwork', 'pybind.nos.v7_2_0.brocade_common_def', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.show.vnetwork', 'pybind.slxos.v17r_1_01a.brocade_common_def', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.show.vnetwork', 'pybind.slxos.v17r_2_00.brocade_common_def', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.show.vnetwork', 'pybind.slxos.v17s_1_02.brocade_common_def', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.snmp_server.engineID_drop', u'engineid'), ('pybind.slxos.v17r_1_01a.snmp_server', u'context'), ('pybind.slxos.v17r_1_01a.snmp_server.enable', u'trap'), ('pybind.slxos.v17r_1_01a.snmp_server', u'user'), ('pybind.slxos.v17r_1_01a.snmp_server', u'view'), ('pybind.slxos.v17r_1_01a.snmp_server', u'group'), ('pybind.slxos.v17r_1_01a.snmp_server', u'host'), ('pybind.slxos.v17r_1_01a.snmp_server', u'agtconfig'), ('pybind.slxos.v17r_1_01a.snmp_server', u'v3host'), ('pybind.slxos.v17r_1_01a.snmp_server.mib', u'community_map'), ('pybind.slxos.v17r_1_01a.snmp_server', u'community'), ('pybind.slxos.v17s_1_02.snmp_server', u'v3host'), ('pybind.slxos.v17s_1_02.snmp_server', u'agtconfig'), ('pybind.slxos.v17s_1_02.snmp_server', u'group'), ('pybind.slxos.v17s_1_02.snmp_server', u'user'), ('pybind.slxos.v17s_1_02.snmp_server.mib', u'community_map'), ('pybind.slxos.v17s_1_02.snmp_server', u'community'), ('pybind.slxos.v17s_1_02.snmp_server.engineID_drop', u'engineid'), ('pybind.slxos.v17s_1_02.snmp_server', u'view'), ('pybind.slxos.v17s_1_02.snmp_server', u'context'), ('pybind.slxos.v17s_1_02.snmp_server.enable', u'trap'), ('pybind.slxos.v17s_1_02.snmp_server', u'host'), ('pybind.nos.v7_2_0.snmp_server', u'context'), ('pybind.nos.v7_2_0.snmp_server.enable', u'trap'), ('pybind.nos.v7_2_0.snmp_server', u'community'), ('pybind.nos.v7_2_0.snmp_server.mib', u'community_map'), ('pybind.nos.v7_2_0.snmp_server', u'group'), ('pybind.nos.v7_2_0.snmp_server', u'v3host'), ('pybind.nos.v7_2_0.snmp_server.engineID_drop', u'engineid'), ('pybind.nos.v7_2_0.snmp_server', u'host'), ('pybind.nos.v7_2_0.snmp_server', u'agtconfig'), ('pybind.nos.v7_2_0.snmp_server', u'user'), ('pybind.nos.v7_2_0.snmp_server', u'view'), ('pybind.nos.v6_0_2f.snmp_server', u'user'), ('pybind.nos.v6_0_2f.snmp_server', u'context'), ('pybind.nos.v6_0_2f.snmp_server', u'v3host'), ('pybind.nos.v6_0_2f.snmp_server.engineID_drop', u'engineid'), ('pybind.nos.v6_0_2f.snmp_server', u'group'), ('pybind.nos.v6_0_2f.snmp_server', u'agtconfig'), ('pybind.nos.v6_0_2f.snmp_server.enable', u'trap'), ('pybind.nos.v6_0_2f.snmp_server', u'view'), ('pybind.nos.v6_0_2f.snmp_server', u'host'), ('pybind.nos.v6_0_2f.snmp_server', u'community'), ('pybind.slxos.v17r_2_00.snmp_server.enable', u'trap'), ('pybind.slxos.v17r_2_00.snmp_server', u'community'), ('pybind.slxos.v17r_2_00.snmp_server', u'context'), ('pybind.slxos.v17r_2_00.snmp_server', u'v3host'), ('pybind.slxos.v17r_2_00.snmp_server', u'view'), ('pybind.slxos.v17r_2_00.snmp_server.engineID_drop', u'engineid'), ('pybind.slxos.v17r_2_00.snmp_server', u'host'), ('pybind.slxos.v17r_2_00.snmp_server', u'user'), ('pybind.slxos.v17r_2_00.snmp_server', u'agtconfig'), ('pybind.slxos.v17r_2_00.snmp_server', u'group'), ('pybind.slxos.v17r_2_00.snmp_server.mib', u'community_map')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_'}, {'leafval': 'context_name, vrf_name'}, {'leafval': 'trap_flag'}, {'leafval': 'username, groupname, auth, auth_password, priv, priv_password, encrypted'}, {'leafval': 'viewname, mibtree, mibtree_access'}, {'leafval': 'group_name, group_version, group_auth_mode, read, write, notify'}, {'leafval': 'ip, version, community, udp_port, severity_level, use_vrf'}, {'leafval': 'contact, location, sys_descr'}, {'leafval': 'hostip, username, udp_port, notifytype, engineid, severity_level, use_vrf'}, {'leafval': 'community, context'}, {'leafval': 'community, groupname'}, {'leafval': 'hostip, username, udp_port, notifytype, engineid, severity_level, use_vrf'}, {'leafval': 'contact, location, sys_descr'}, {'leafval': 'group_name, group_version, group_auth_mode, read, write, notify'}, {'leafval': 'username, groupname, auth, auth_password, priv, priv_password, encrypted'}, {'leafval': 'community, context'}, {'leafval': 'community, groupname'}, {'leafval': 'local_'}, {'leafval': 'viewname, mibtree, mibtree_access'}, {'leafval': 'context_name, vrf_name'}, {'leafval': 'trap_flag'}, {'leafval': 'ip, version, community, udp_port, severity_level, use_vrf'}, {'leafval': 'context_name, vrf_name'}, {'leafval': 'trap_flag'}, {'leafval': 'community, groupname, ipv4_acl, ipv6_acl'}, {'leafval': 'community, context'}, {'leafval': 'group_name, group_version, group_auth_mode, read, write, notify'}, {'leafval': 'hostip, username, udp_port, notifytype, engineid, severity_level, use_vrf'}, {'leafval': 'local_'}, {'leafval': 'ip, version, community, udp_port, severity_level, use_vrf'}, {'leafval': 'contact, location, sys_descr'}, {'leafval': 'username, groupname, auth, auth_password, priv, priv_password, encrypted, ipv4_acl, ipv6_acl'}, {'leafval': 'viewname, mibtree, mibtree_access'}, {'leafval': 'username, groupname, auth, auth_password, priv, priv_password, encrypted, ipv4_acl, ipv6_acl'}, {'leafval': 'context_name, vrf_name'}, {'leafval': 'hostip, username, udp_port, notifytype, engineid, severity_level, use_vrf'}, {'leafval': 'local_'}, {'leafval': 'group_name, group_version, group_auth_mode, read, write, notify'}, {'leafval': 'contact, location, sys_descr'}, {'leafval': 'trap_flag'}, {'leafval': 'viewname, mibtree, mibtree_access'}, {'leafval': 'ip, version, community, udp_port, severity_level, use_vrf'}, {'leafval': 'community, groupname, ipv4_acl, ipv6_acl'}, {'leafval': 'trap_flag'}, {'leafval': 'community, groupname'}, {'leafval': 'context_name, vrf_name'}, {'leafval': 'hostip, username, udp_port, notifytype, engineid, severity_level, use_vrf'}, {'leafval': 'viewname, mibtree, mibtree_access'}, {'leafval': 'local_'}, {'leafval': 'ip, version, community, udp_port, severity_level, use_vrf'}, {'leafval': 'username, groupname, auth, auth_password, priv, priv_password, encrypted'}, {'leafval': 'contact, location, sys_descr'}, {'leafval': 'group_name, group_version, group_auth_mode, read, write, notify'}, {'leafval': 'community, context'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_agtconfig_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.agtconfig', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.agtconfig', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.agtconfig', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.agtconfig', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.agtconfig', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_community_get(self, community=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type community: community, groupname, ipv4_acl, ipv6_acl
    :param community: Keyword argument tuple.

    :type community: unicode
    :param community: **community** tuple argument.

    :type groupname: unicode
    :param groupname: **community** tuple argument:  Groupname associated with community string

    :type ipv4_acl: unicode
    :param ipv4_acl: **community** tuple argument:  standard IPv4 Access list name (or) ID associated with community strings.

        * length restriction: ::

            ['0 .. 63']

    :type ipv6_acl: unicode
    :param ipv6_acl: **community** tuple argument:  standard IPv6 Access list name (or) ID associated with community strings.

        * length restriction: ::

            ['0 .. 63']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.community', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.community', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.community', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.community', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.community', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'community', 'keyval': 'community', 'extra_keyval': 'community, groupname'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.snmp_server.community": {}, "pybind.nos.v6_0_2f.snmp_server.community": {"ipv4_acl": "ipv4_acl", "groupname": "groupname", "ipv6_acl": "ipv6_acl", "community": "community"}, "pybind.slxos.v17s_1_02.snmp_server.community": {}, "pybind.nos.v7_2_0.snmp_server.community": {"ipv4_acl": "ipv4_acl", "groupname": "groupname", "ipv6_acl": "ipv6_acl", "community": "community"}, "pybind.slxos.v17r_2_00.snmp_server.community": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, community=community)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, community=community)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_community_groupname_get(self, community=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type community: community
    :param community: Keyword argument tuple.

    :type community: unicode
    :param community: **community** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.community', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.community', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.community', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.community', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.community', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'community', 'keyval': 'community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, community=community)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, community=community)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_community_ipv4_acl_get(self, community=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type community: community
    :param community: Keyword argument tuple.

    :type community: unicode
    :param community: **community** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.community', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.community', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'community', 'keyval': 'community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, community=community)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, community=community)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_community_ipv6_acl_get(self, community=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type community: community
    :param community: Keyword argument tuple.

    :type community: unicode
    :param community: **community** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.community', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.community', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'community', 'keyval': 'community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, community=community)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, community=community)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_contact_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.agtconfig', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.agtconfig', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.agtconfig', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.agtconfig', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.agtconfig', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_context_get(self, context=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type context: context_name
    :param context: Keyword argument tuple.

    :type context_name: unicode
    :param context_name: **context** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.context', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.context', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.context', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.context', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.context', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'context', 'keyval': 'context_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, context=context)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, context=context)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_context_vrf_name_get(self, context=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type context: context_name
    :param context: Keyword argument tuple.

    :type context_name: unicode
    :param context_name: **context** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.context', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.context', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.context', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.context', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.context', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'context', 'keyval': 'context_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, context=context)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, context=context)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.enable', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.enable', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.enable', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.enable', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.enable', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.snmp_server.enable', u'trap'), ('pybind.nos.v7_2_0.snmp_server.enable', u'trap'), ('pybind.slxos.v17r_2_00.snmp_server.enable', u'trap'), ('pybind.nos.v6_0_2f.snmp_server.enable', u'trap'), ('pybind.slxos.v17r_1_01a.snmp_server.enable', u'trap')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'trap_flag'}, {'leafval': 'trap_flag'}, {'leafval': 'trap_flag'}, {'leafval': 'trap_flag'}, {'leafval': 'trap_flag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_enable_trap_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.enable.trap', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.enable.trap', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.enable.trap', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.enable.trap', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.enable.trap', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_enable_trap_trap_flag_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.enable.trap', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.enable.trap', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.enable.trap', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.enable.trap', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.enable.trap', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_engineID_drop_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.engineID_drop', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.engineID_drop', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.engineID_drop', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.engineID_drop', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.engineID_drop', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.snmp_server.engineID_drop', u'engineid'), ('pybind.slxos.v17r_2_00.snmp_server.engineID_drop', u'engineid'), ('pybind.slxos.v17s_1_02.snmp_server.engineID_drop', u'engineid'), ('pybind.slxos.v17r_1_01a.snmp_server.engineID_drop', u'engineid'), ('pybind.nos.v6_0_2f.snmp_server.engineID_drop', u'engineid')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'local_'}, {'leafval': 'local_'}, {'leafval': 'local_'}, {'leafval': 'local_'}, {'leafval': 'local_'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_engineid_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.engineID_drop.engineID', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.engineID_drop.engineID', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.engineID_drop.engineID', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.engineID_drop.engineID', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.engineID_drop.engineID', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_engineid_local_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.engineID_drop.engineID', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.engineID_drop.engineID', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.engineID_drop.engineID', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.engineID_drop.engineID', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.engineID_drop.engineID', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_group_get(self, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group: group_name, group_version, group_auth_mode, read, write, notify
    :param group: Keyword argument tuple.

    :type group_name: unicode
    :param group_name: **group** tuple argument.

        * length restriction: ::

            ['1 .. 32']

    :type group_version: unicode
    :param group_version: **group** tuple argument.

        * enumeration restriction: ::

            ['v2c', 'v1', 'v3']

    :type group_auth_mode: unicode
    :param group_auth_mode: **group** tuple argument.

        * enumeration restriction: ::

            ['noauth', 'auth', 'priv']

    :type read: unicode
    :param read: **group** tuple argument:  read	Specify a read view for the group

        * length restriction: ::

            ['1 .. 32']

    :type write: unicode
    :param write: **group** tuple argument:  write	Specify a write view for the group

        * length restriction: ::

            ['1 .. 32']

    :type notify: unicode
    :param notify: **group** tuple argument:  notify	Specify a notify view for the group

        * length restriction: ::

            ['1 .. 32']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.group', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.group', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.group', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.group', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.group', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'group_name, group_version', 'extra_keyval': 'group_name, group_version, group_auth_mode, read, write, notify'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_group_group_auth_mode_get(self, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group: group_name, group_version
    :param group: Keyword argument tuple.

    :type group_name: unicode
    :param group_name: **group** tuple argument.

        * length restriction: ::

            ['1 .. 32']

    :type group_version: unicode
    :param group_version: **group** tuple argument.

        * enumeration restriction: ::

            ['v2c', 'v1', 'v3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.group', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.group', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.group', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.group', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.group', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'group_name, group_version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_group_notify_get(self, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group: group_name, group_version
    :param group: Keyword argument tuple.

    :type group_name: unicode
    :param group_name: **group** tuple argument.

        * length restriction: ::

            ['1 .. 32']

    :type group_version: unicode
    :param group_version: **group** tuple argument.

        * enumeration restriction: ::

            ['v2c', 'v1', 'v3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.group', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.group', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.group', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.group', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.group', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'group_name, group_version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_group_read_get(self, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group: group_name, group_version
    :param group: Keyword argument tuple.

    :type group_name: unicode
    :param group_name: **group** tuple argument.

        * length restriction: ::

            ['1 .. 32']

    :type group_version: unicode
    :param group_version: **group** tuple argument.

        * enumeration restriction: ::

            ['v2c', 'v1', 'v3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.group', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.group', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.group', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.group', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.group', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'group_name, group_version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_group_write_get(self, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type group: group_name, group_version
    :param group: Keyword argument tuple.

    :type group_name: unicode
    :param group_name: **group** tuple argument.

        * length restriction: ::

            ['1 .. 32']

    :type group_version: unicode
    :param group_version: **group** tuple argument.

        * enumeration restriction: ::

            ['v2c', 'v1', 'v3']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.group', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.group', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.group', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.group', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.group', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'group_name, group_version', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_host_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: ip, community
    :param host: Keyword argument tuple.

    :type ip: unicode
    :param ip: **host** tuple argument:  ipv4/ipv6/dns address of the trap recipient associated with community strings.  Traps will be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type community: unicode
    :param community: **host** tuple argument:  Community string associated with traps.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.host', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.host', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.host', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.host', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.host', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.snmp_server.host', u'source_interface'), ('pybind.nos.v6_0_2f.snmp_server.host', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'ip, community', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'loopback, ve'}, {'leafval': 'loopback, ve'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_host_severity_level_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: ip, community
    :param host: Keyword argument tuple.

    :type ip: unicode
    :param ip: **host** tuple argument:  ipv4/ipv6/dns address of the trap recipient associated with community strings.  Traps will be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type community: unicode
    :param community: **host** tuple argument:  Community string associated with traps.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.host', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.host', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.host', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.host', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.host', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.snmp_server.host', u'source_interface'), ('pybind.nos.v6_0_2f.snmp_server.host', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'ip, community', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'loopback, ve'}, {'leafval': 'loopback, ve'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_host_source_interface_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type host: ip, community
    :param host: Keyword argument tuple.

    :type ip: unicode
    :param ip: **host** tuple argument:  ipv4/ipv6/dns address of the trap recipient associated with community strings.  Traps will be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type community: unicode
    :param community: **host** tuple argument:  Community string associated with traps.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.snmp_server.host', u'host'), ('pybind.nos.v7_2_0.snmp_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.host.source_interface', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.host.source_interface', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip, community', 'extra_keyval': ''}, {'keyval': 'ip, community', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.snmp_server.host.source_interface': [u've', u'loopback'], 'pybind.nos.v7_2_0.snmp_server.host.source_interface': [u've', u'loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_host_source_interface_loopback_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type host: ip, community
    :param host: Keyword argument tuple.

    :type ip: unicode
    :param ip: **host** tuple argument:  ipv4/ipv6/dns address of the trap recipient associated with community strings.  Traps will be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type community: unicode
    :param community: **host** tuple argument:  Community string associated with traps.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.snmp_server.host', u'host'), ('pybind.nos.v7_2_0.snmp_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.host.source_interface', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.host.source_interface', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip, community', 'extra_keyval': ''}, {'keyval': 'ip, community', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_host_source_interface_ve_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type host: ip, community
    :param host: Keyword argument tuple.

    :type ip: unicode
    :param ip: **host** tuple argument:  ipv4/ipv6/dns address of the trap recipient associated with community strings.  Traps will be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type community: unicode
    :param community: **host** tuple argument:  Community string associated with traps.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.snmp_server.host', u'host'), ('pybind.nos.v7_2_0.snmp_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.host.source_interface', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.host.source_interface', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ip, community', 'extra_keyval': ''}, {'keyval': 'ip, community', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_host_udp_port_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: ip, community
    :param host: Keyword argument tuple.

    :type ip: unicode
    :param ip: **host** tuple argument:  ipv4/ipv6/dns address of the trap recipient associated with community strings.  Traps will be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type community: unicode
    :param community: **host** tuple argument:  Community string associated with traps.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.host', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.host', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.host', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.host', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.host', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.snmp_server.host', u'source_interface'), ('pybind.nos.v6_0_2f.snmp_server.host', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'ip, community', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'loopback, ve'}, {'leafval': 'loopback, ve'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_host_use_vrf_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: ip, community
    :param host: Keyword argument tuple.

    :type ip: unicode
    :param ip: **host** tuple argument:  ipv4/ipv6/dns address of the trap recipient associated with community strings.  Traps will be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type community: unicode
    :param community: **host** tuple argument:  Community string associated with traps.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.host', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.host', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.host', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.host', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.host', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.snmp_server.host', u'source_interface'), ('pybind.nos.v6_0_2f.snmp_server.host', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'ip, community', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'loopback, ve'}, {'leafval': 'loopback, ve'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_host_version_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: ip, community
    :param host: Keyword argument tuple.

    :type ip: unicode
    :param ip: **host** tuple argument:  ipv4/ipv6/dns address of the trap recipient associated with community strings.  Traps will be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type community: unicode
    :param community: **host** tuple argument:  Community string associated with traps.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.host', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.host', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.host', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.host', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.host', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.snmp_server.host', u'source_interface'), ('pybind.nos.v6_0_2f.snmp_server.host', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'ip, community', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'loopback, ve'}, {'leafval': 'loopback, ve'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_location_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.agtconfig', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.agtconfig', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.agtconfig', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.agtconfig', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.agtconfig', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_mib_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.snmp_server.mib', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.mib', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.mib', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.mib', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.snmp_server.mib', u'community_map'), ('pybind.slxos.v17r_2_00.snmp_server.mib', u'community_map'), ('pybind.nos.v7_2_0.snmp_server.mib', u'community_map'), ('pybind.slxos.v17r_1_01a.snmp_server.mib', u'community_map')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'community, context'}, {'leafval': 'community, context'}, {'leafval': 'community, context'}, {'leafval': 'community, context'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_mib_community_map_get(self, community_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type community_map: community, context
    :param community_map: Keyword argument tuple.

    :type community: unicode
    :param community: **community_map** tuple argument:  Community string to map with the context name

    :type context: unicode
    :param context: **community_map** tuple argument:  Context Name.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.snmp_server.mib.community_map', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.mib.community_map', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.mib.community_map', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.mib.community_map', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'community_map', 'keyval': 'community', 'extra_keyval': 'community, context'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, community_map=community_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, community_map=community_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_mib_community_map_context_get(self, community_map=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type community_map: community
    :param community_map: Keyword argument tuple.

    :type community: unicode
    :param community: **community_map** tuple argument:  Community string to map with the context name

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.snmp_server.mib.community_map', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.mib.community_map', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.mib.community_map', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.mib.community_map', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'community_map', 'keyval': 'community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, community_map=community_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, community_map=community_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_sys_descr_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.agtconfig', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.agtconfig', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.agtconfig', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.agtconfig', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.agtconfig', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_user_get(self, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type user: username, groupname, auth, auth_password, priv, priv_password, encrypted, ipv4_acl, ipv6_acl
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type groupname: unicode
    :param groupname: **user** tuple argument.

    :type auth: unicode
    :param auth: **user** tuple argument:  Authorization protocol for username(Default=noauth)

        * enumeration restriction: ::

            ['sha', 'noauth', 'md5']

    :type auth_password: unicode
    :param auth_password: **user** tuple argument:  Authorization password associated withusername

    :type priv: unicode
    :param priv: **user** tuple argument:  Privacy protocol for username (Default=nopriv)

        * enumeration restriction: ::

            ['AES128', 'DES', 'nopriv']

    :type priv_password: unicode
    :param priv_password: **user** tuple argument:  Privacy password associated with username

    :type encrypted: YANGBool
    :param encrypted: **user** tuple argument:  This flag is used to enter the auth/privpasswords as encrypted.(Default=disable)

    :type ipv4_acl: unicode
    :param ipv4_acl: **user** tuple argument:  standard IPv4 Access list name (or) ID associated with SNMP v3 user strings.

        * length restriction: ::

            ['0 .. 63']

    :type ipv6_acl: unicode
    :param ipv6_acl: **user** tuple argument:  standard IPv6 Access list name (or) ID associated with SNMP V3 user strings.

        * length restriction: ::

            ['0 .. 63']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.user', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.user', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.user', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.user', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.user', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': 'username, groupname, auth, auth_password, priv, priv_password, encrypted, ipv4_acl, ipv6_acl'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.nos.v6_0_2f.snmp_server.user": {"username": "username", "ipv4_acl": "ipv4_acl", "encrypted": "encrypted", "ipv6_acl": "ipv6_acl", "auth": "auth", "priv_password": "priv_password", "groupname": "groupname", "auth_password": "auth_password", "priv": "priv"}, "pybind.slxos.v17r_2_00.snmp_server.user": {}, "pybind.nos.v7_2_0.snmp_server.user": {"username": "username", "ipv4_acl": "ipv4_acl", "encrypted": "encrypted", "ipv6_acl": "ipv6_acl", "auth": "auth", "priv_password": "priv_password", "groupname": "groupname", "auth_password": "auth_password", "priv": "priv"}, "pybind.slxos.v17s_1_02.snmp_server.user": {}, "pybind.slxos.v17r_1_01a.snmp_server.user": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_user_auth_get(self, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.user', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.user', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.user', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.user', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.user', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_user_auth_password_get(self, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.user', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.user', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.user', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.user', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.user', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_user_encrypted_get(self, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.user', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.user', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.user', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.user', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.user', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_user_groupname_get(self, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.user', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.user', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.user', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.user', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.user', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_user_ipv4_acl_get(self, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.user', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.user', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_user_ipv6_acl_get(self, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.user', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.user', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_user_priv_get(self, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.user', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.user', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.user', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.user', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.user', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_user_priv_password_get(self, user=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type user: username
    :param user: Keyword argument tuple.

    :type username: unicode
    :param username: **user** tuple argument.

        * length restriction: ::

            ['1 .. 25']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.user', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.user', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.user', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.user', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.user', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'user', 'keyval': 'username', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, user=user)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, user=user)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_v3host_get(self, v3host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.v3host', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.v3host', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.v3host', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.v3host', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.v3host', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.snmp_server.v3host', u'source_interface'), ('pybind.nos.v7_2_0.snmp_server.v3host', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'loopback, ve'}, {'leafval': 'loopback, ve'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_v3host_engineid_get(self, v3host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.v3host', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.v3host', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.v3host', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.v3host', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.v3host', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.snmp_server.v3host', u'source_interface'), ('pybind.nos.v7_2_0.snmp_server.v3host', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'loopback, ve'}, {'leafval': 'loopback, ve'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_v3host_notifytype_get(self, v3host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.v3host', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.v3host', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.v3host', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.v3host', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.v3host', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.snmp_server.v3host', u'source_interface'), ('pybind.nos.v7_2_0.snmp_server.v3host', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'loopback, ve'}, {'leafval': 'loopback, ve'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_v3host_severity_level_get(self, v3host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.v3host', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.v3host', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.v3host', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.v3host', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.v3host', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.snmp_server.v3host', u'source_interface'), ('pybind.nos.v7_2_0.snmp_server.v3host', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'loopback, ve'}, {'leafval': 'loopback, ve'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_v3host_source_interface_get(self, v3host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.snmp_server.v3host', u'v3host'), ('pybind.nos.v7_2_0.snmp_server.v3host', u'v3host')]
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.v3host.source_interface', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.v3host.source_interface', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostip, username', 'extra_keyval': ''}, {'keyval': 'hostip, username', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.snmp_server.v3host.source_interface': [u've', u'loopback'], 'pybind.nos.v6_0_2f.snmp_server.v3host.source_interface': [u've', u'loopback']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_v3host_source_interface_loopback_get(self, v3host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.snmp_server.v3host', u'v3host'), ('pybind.nos.v7_2_0.snmp_server.v3host', u'v3host')]
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.v3host.source_interface', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.v3host.source_interface', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostip, username', 'extra_keyval': ''}, {'keyval': 'hostip, username', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_v3host_source_interface_ve_get(self, v3host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.snmp_server.v3host', u'v3host'), ('pybind.nos.v7_2_0.snmp_server.v3host', u'v3host')]
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.v3host.source_interface', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.v3host.source_interface', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostip, username', 'extra_keyval': ''}, {'keyval': 'hostip, username', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_v3host_udp_port_get(self, v3host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.v3host', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.v3host', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.v3host', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.v3host', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.v3host', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.snmp_server.v3host', u'source_interface'), ('pybind.nos.v7_2_0.snmp_server.v3host', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'loopback, ve'}, {'leafval': 'loopback, ve'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_v3host_use_vrf_get(self, v3host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type v3host: hostip, username
    :param v3host: Keyword argument tuple.

    :type hostip: unicode
    :param hostip: **v3host** tuple argument:  ipv4/ipv6/dns address of the notification recipientassociated with username. Notificationswill be sent to this host

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type username: unicode
    :param username: **v3host** tuple argument:  Username associated with notification type.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.v3host', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.v3host', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.v3host', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.v3host', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.v3host', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.snmp_server.v3host', u'source_interface'), ('pybind.nos.v7_2_0.snmp_server.v3host', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'v3host', 'keyval': 'hostip, username', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'loopback, ve'}, {'leafval': 'loopback, ve'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, v3host=v3host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, v3host=v3host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_view_get(self, view=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type view: viewname, mibtree
    :param view: Keyword argument tuple.

    :type viewname: unicode
    :param viewname: **view** tuple argument.

        * length restriction: ::

            ['1 .. 32']

    :type mibtree: unicode
    :param mibtree: **view** tuple argument.

        * length restriction: ::

            ['1 .. 256']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.view', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.view', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.view', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.view', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.view', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'view', 'keyval': 'viewname, mibtree', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, view=view)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, view=view)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def snmp_server_view_mibtree_access_get(self, view=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type view: viewname, mibtree
    :param view: Keyword argument tuple.

    :type viewname: unicode
    :param viewname: **view** tuple argument.

        * length restriction: ::

            ['1 .. 32']

    :type mibtree: unicode
    :param mibtree: **view** tuple argument.

        * length restriction: ::

            ['1 .. 256']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.snmp_server.view', 'pybind.nos.v6_0_2f.brocade_snmp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.snmp_server.view', 'pybind.nos.v7_2_0.brocade_snmp', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.snmp_server.view', 'pybind.slxos.v17r_1_01a.brocade_snmp', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.snmp_server.view', 'pybind.slxos.v17r_2_00.brocade_snmp', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.snmp_server.view', 'pybind.slxos.v17s_1_02.brocade_snmp', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'view', 'keyval': 'viewname, mibtree', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, view=view)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, view=view)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_get(self, spf_log_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.spf_log_state', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', u'spf_log_levels')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'spf_log_state', 'keyval': 'spf_log_version', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'level, log_counts, spf_trigger_count, node_count'}, {'leafval': 'level, log_counts, spf_trigger_count, node_count'}, {'leafval': 'level, log_counts, spf_trigger_count, node_count'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_get(self, spf_log_state=None, spf_log_levels=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    **Instance Keyword Argument Tuple**:

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_events'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_events'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_events')]
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_levels', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'spf_log_index, isis_spf_log_reason, isis_lsp_name, brief_reason, event_count, node_count, time_stamp_ms, duration_ms, ipv4_routes, ipv6_routes, first_trigger_change, first_trigger_time_stamp_ms, first_trigger_detail_reason, last_trigger_change, last_trigger_time_stamp_ms, last_trigger_detail_reason'}, {'leafval': 'spf_log_index, isis_spf_log_reason, isis_lsp_name, brief_reason, event_count, node_count, time_stamp_ms, duration_ms, ipv4_routes, ipv6_routes, first_trigger_change, first_trigger_time_stamp_ms, first_trigger_detail_reason, last_trigger_change, last_trigger_time_stamp_ms, last_trigger_detail_reason'}, {'leafval': 'spf_log_index, isis_spf_log_reason, isis_lsp_name, brief_reason, event_count, node_count, time_stamp_ms, duration_ms, ipv4_routes, ipv6_routes, first_trigger_change, first_trigger_time_stamp_ms, first_trigger_detail_reason, last_trigger_change, last_trigger_time_stamp_ms, last_trigger_detail_reason'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_log_counts_get(self, spf_log_state=None, spf_log_levels=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    **Instance Keyword Argument Tuple**:

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_events'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_events'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_events')]
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_levels', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'spf_log_index, isis_spf_log_reason, isis_lsp_name, brief_reason, event_count, node_count, time_stamp_ms, duration_ms, ipv4_routes, ipv6_routes, first_trigger_change, first_trigger_time_stamp_ms, first_trigger_detail_reason, last_trigger_change, last_trigger_time_stamp_ms, last_trigger_detail_reason'}, {'leafval': 'spf_log_index, isis_spf_log_reason, isis_lsp_name, brief_reason, event_count, node_count, time_stamp_ms, duration_ms, ipv4_routes, ipv6_routes, first_trigger_change, first_trigger_time_stamp_ms, first_trigger_detail_reason, last_trigger_change, last_trigger_time_stamp_ms, last_trigger_detail_reason'}, {'leafval': 'spf_log_index, isis_spf_log_reason, isis_lsp_name, brief_reason, event_count, node_count, time_stamp_ms, duration_ms, ipv4_routes, ipv6_routes, first_trigger_change, first_trigger_time_stamp_ms, first_trigger_detail_reason, last_trigger_change, last_trigger_time_stamp_ms, last_trigger_detail_reason'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_node_count_get(self, spf_log_state=None, spf_log_levels=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    **Instance Keyword Argument Tuple**:

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_events'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_events'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_events')]
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_levels', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'spf_log_index, isis_spf_log_reason, isis_lsp_name, brief_reason, event_count, node_count, time_stamp_ms, duration_ms, ipv4_routes, ipv6_routes, first_trigger_change, first_trigger_time_stamp_ms, first_trigger_detail_reason, last_trigger_change, last_trigger_time_stamp_ms, last_trigger_detail_reason'}, {'leafval': 'spf_log_index, isis_spf_log_reason, isis_lsp_name, brief_reason, event_count, node_count, time_stamp_ms, duration_ms, ipv4_routes, ipv6_routes, first_trigger_change, first_trigger_time_stamp_ms, first_trigger_detail_reason, last_trigger_change, last_trigger_time_stamp_ms, last_trigger_detail_reason'}, {'leafval': 'spf_log_index, isis_spf_log_reason, isis_lsp_name, brief_reason, event_count, node_count, time_stamp_ms, duration_ms, ipv4_routes, ipv6_routes, first_trigger_change, first_trigger_time_stamp_ms, first_trigger_detail_reason, last_trigger_change, last_trigger_time_stamp_ms, last_trigger_detail_reason'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_get(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_brief_reason_get(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_duration_ms_get(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_event_count_get(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_first_trigger_change_get(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_first_trigger_detail_reason_get(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_first_trigger_time_stamp_ms_get(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_ipv4_routes_get(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_ipv6_routes_get(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_isis_lsp_name_get(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_isis_spf_log_reason_get(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_last_trigger_change_get(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_last_trigger_detail_reason_get(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_last_trigger_time_stamp_ms_get(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_node_count_get(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_log_events_time_stamp_ms_get(self, spf_log_state=None, spf_log_levels=None, spf_log_events=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    **Instance Keyword Argument Tuple**:

    :type spf_log_events: spf_log_index
    :param spf_log_events: Keyword argument tuple.

    :type spf_log_index: int
    :param spf_log_index: **spf_log_events** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_levels'), ('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_levels')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels.spf_log_events', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'level', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_events', 'keyval': 'spf_log_index', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels, spf_log_events=spf_log_events)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def spf_log_state_spf_log_levels_spf_trigger_count_get(self, spf_log_state=None, spf_log_levels=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type spf_log_state: spf_log_version
    :param spf_log_state: Keyword argument tuple.

    :type spf_log_version: unicode
    :param spf_log_version: **spf_log_state** tuple argument.

        * enumeration restriction: ::

            ['isis-ipv6-unicast-safi',
            'isis-ipv4-unicast-safi']

    **Instance Keyword Argument Tuple**:

    :type spf_log_levels: level
    :param spf_log_levels: Keyword argument tuple.

    :type level: unicode
    :param level: **spf_log_levels** tuple argument.

        * enumeration restriction: ::

            ['isis-level1-2', 'isis-level1', 'isis-level2']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17r_1_01a.spf_log_state', 'spf_log_state'), ('pybind.slxos.v17s_1_02.spf_log_state', 'spf_log_state')]
    bindings_list = [('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.spf_log_state.spf_log_levels', u'spf_log_events'), ('pybind.slxos.v17r_1_01a.spf_log_state.spf_log_levels', u'spf_log_events'), ('pybind.slxos.v17s_1_02.spf_log_state.spf_log_levels', u'spf_log_events')]
    compositions_keyval_list = [{'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}, {'keyval': 'spf_log_version', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'spf_log_levels', 'keyval': 'level', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'spf_log_index, isis_spf_log_reason, isis_lsp_name, brief_reason, event_count, node_count, time_stamp_ms, duration_ms, ipv4_routes, ipv6_routes, first_trigger_change, first_trigger_time_stamp_ms, first_trigger_detail_reason, last_trigger_change, last_trigger_time_stamp_ms, last_trigger_detail_reason'}, {'leafval': 'spf_log_index, isis_spf_log_reason, isis_lsp_name, brief_reason, event_count, node_count, time_stamp_ms, duration_ms, ipv4_routes, ipv6_routes, first_trigger_change, first_trigger_time_stamp_ms, first_trigger_detail_reason, last_trigger_change, last_trigger_time_stamp_ms, last_trigger_detail_reason'}, {'leafval': 'spf_log_index, isis_spf_log_reason, isis_lsp_name, brief_reason, event_count, node_count, time_stamp_ms, duration_ms, ipv4_routes, ipv6_routes, first_trigger_change, first_trigger_time_stamp_ms, first_trigger_detail_reason, last_trigger_change, last_trigger_time_stamp_ms, last_trigger_detail_reason'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, spf_log_state=spf_log_state, spf_log_levels=spf_log_levels)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.server', u'key'), ('pybind.nos.v6_0_2f.ssh_sa.ssh', u'client'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v6_0_2f.ssh_sa.ssh', u'server'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh', u'server'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.client', u'source_interface'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh', u'client'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'standby'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh', u'client'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'standby'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.client', u'source_interface'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh', u'server'), ('pybind.nos.v7_2_0.ssh_sa.ssh', u'client'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v7_2_0.ssh_sa.ssh', u'server'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'key'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh', u'server'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'standby'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.client', u'source_interface'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh', u'client')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'cipher, mac, key_exchange'}, {'leafval': 'enable'}, {'leafval': 'shutdown, key_exchange, rekey_interval, cipher, mac'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'shutdown, key_exchange, rekey_interval, ssh_server_port, cipher, mac'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'cipher, mac, key_exchange'}, {'leafval': 'enable'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'cipher, mac, key_exchange'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown, key_exchange, rekey_interval, ssh_server_port, cipher, mac'}, {'leafval': 'cipher, mac, key_exchange'}, {'leafval': 'enable'}, {'leafval': 'shutdown, key_exchange, rekey_interval, cipher, mac, max_sessions'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'shutdown, key_exchange, rekey_interval, ssh_server_port, cipher, mac'}, {'leafval': 'enable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'cipher, mac, key_exchange'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_client_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.client', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.client', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.client', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.client', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.client', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.ssh_sa.ssh.client', u'source_interface'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.client', u'source_interface'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.client', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_client_cipher_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.client', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.client', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.client', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.client', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.client', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.ssh_sa.ssh.client', u'source_interface'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.client', u'source_interface'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.client', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_client_key_exchange_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.client', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.client', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.client', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.client', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.client', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.ssh_sa.ssh.client', u'source_interface'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.client', u'source_interface'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.client', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_client_mac_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.client', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.client', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.client', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.client', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.client', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.ssh_sa.ssh.client', u'source_interface'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.client', u'source_interface'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.client', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_client_source_interface_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ssh_sa.ssh.client.source_interface', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.client.source_interface', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.client.source_interface', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_client_source_interface_interface_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ssh_sa.ssh.client.source_interface', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.client.source_interface', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.client.source_interface', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_client_source_interface_interface_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ssh_sa.ssh.client.source_interface', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.client.source_interface', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.client.source_interface', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_sa_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh', u'server'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.client', u'source_interface'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh', u'client'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'standby'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh', u'client'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'standby'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.client', u'source_interface'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh', u'server'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh', u'server'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'standby'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.client', u'source_interface'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh', u'client'), ('pybind.nos.v7_2_0.ssh_sa.ssh', u'client'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v7_2_0.ssh_sa.ssh', u'server'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'key'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server', u'key'), ('pybind.nos.v6_0_2f.ssh_sa.ssh', u'client'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v6_0_2f.ssh_sa.ssh', u'server'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'shutdown, key_exchange, rekey_interval, ssh_server_port, cipher, mac'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'cipher, mac, key_exchange'}, {'leafval': 'enable'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'cipher, mac, key_exchange'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'shutdown, key_exchange, rekey_interval, ssh_server_port, cipher, mac'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'shutdown, key_exchange, rekey_interval, ssh_server_port, cipher, mac'}, {'leafval': 'enable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'cipher, mac, key_exchange'}, {'leafval': 'cipher, mac, key_exchange'}, {'leafval': 'enable'}, {'leafval': 'shutdown, key_exchange, rekey_interval, cipher, mac, max_sessions'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'cipher, mac, key_exchange'}, {'leafval': 'enable'}, {'leafval': 'shutdown, key_exchange, rekey_interval, cipher, mac'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.server', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'key'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'standby'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server', u'key'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}]
    leafval_map = {"pybind.slxos.v17r_2_00.ssh_sa.ssh.server": {}, "pybind.nos.v6_0_2f.ssh_sa.ssh.server": {"mac": "mac", "cipher": "cipher", "key_exchange": "key_exchange", "rekey_interval": "rekey_interval", "shutdown": "shutdown"}, "pybind.slxos.v17r_1_01a.ssh_sa.ssh.server": {}, "pybind.nos.v7_2_0.ssh_sa.ssh.server": {}, "pybind.slxos.v17s_1_02.ssh_sa.ssh.server": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_cipher_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.server', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'key'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'standby'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server', u'key'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_key_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.server.key', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.key', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.key', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.key', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.key', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_key_dsa_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.server.key', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.key', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.key', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.key', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.key', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_key_ecdsa_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.server.key', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.key', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.key', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.key', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.key', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_key_exchange_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.server', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'key'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'standby'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server', u'key'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_key_rsa_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.server.key', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.key', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.key', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.key', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.key', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_mac_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.server', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'key'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'standby'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server', u'key'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_max_sessions_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.ssh_sa.ssh.server', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'key'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_port_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'standby'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'standby'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'standby')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_rekey_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.server', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'key'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'standby'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server', u'key'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_shutdown_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.server', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server', u'key'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server', u'standby'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'key'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server', u'key'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server', u'standby'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'rsa, ecdsa, dsa'}, {'leafval': 'enable'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_ssh_vrf_cont_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.server.ssh_vrf_cont', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.ssh_vrf_cont', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.ssh_vrf_cont', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.ssh_vrf_cont', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.ssh_vrf_cont', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.nos.v6_0_2f.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.ssh_vrf_cont', u'use_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}, {'leafval': 'use_vrf_name, ssh_vrf_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_standby_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.server.standby', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.standby', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.standby', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.standby', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.standby', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_standby_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.server.standby', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.standby', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.standby', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.standby', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.standby', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_use_vrf_get(self, use_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name, ssh_vrf_shutdown
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0 .. max']

    :type ssh_vrf_shutdown: YANGBool
    :param ssh_vrf_shutdown: **use_vrf** tuple argument:  Shutdown SSH server on given vrf

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': 'use_vrf_name, ssh_vrf_shutdown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, use_vrf=use_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def ssh_server_use_vrf_shutdown_get(self, use_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0 .. max']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.ssh_sa.ssh.server.ssh_vrf_cont.use_vrf', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, use_vrf=use_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_barrier_reply_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_barrier_reply_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_barrier_req_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_barrier_req_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_echo_reply_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_echo_reply_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_echo_req_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_echo_req_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_error_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_error_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_experiment_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_experiment_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_feature_reply_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_feature_reply_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_feature_req_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_feature_req_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_flow_mod_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_flow_mod_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_flow_removed_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_flow_removed_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_get_async_reply_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_get_async_reply_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_get_async_req_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_get_async_req_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_get_config_reply_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_get_config_reply_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_get_config_req_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_get_config_req_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_group_mod_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_group_mod_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_hello_rx_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_hello_rx_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_hello_tx_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_hello_tx_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_meter_mod_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_meter_mod_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_multipart_reply_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_multipart_reply_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_multipart_req_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_multipart_req_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_packet_in_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_packet_in_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_packet_out_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_packet_out_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_port_status_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_port_status_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_role_reply_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_role_reply_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_role_req_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_role_req_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_set_async_reply_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_set_async_req_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_set_config_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_set_config_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_total_rx_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_total_rx_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_total_tx_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_total_tx_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_unknown_rx_last_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def statistics_protocol_state_unknown_rx_total_get(self, statistics_protocol_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type statistics_protocol_state: connection_name
    :param statistics_protocol_state: Keyword argument tuple.

    :type connection_name: unicode
    :param connection_name: **statistics_protocol_state** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.statistics_protocol_state', 'pybind.slxos.v17r_2_00.brocade_openflow_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'statistics_protocol_state', 'keyval': 'connection_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, statistics_protocol_state=statistics_protocol_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, statistics_protocol_state=statistics_protocol_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sub_interface_statistics_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state', u'vlan_statistics'), ('pybind.slxos.v17r_1_01a.sub_interface_statistics_state', u'bridge_domain_statistics'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state', u'vlan_statistics'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state', u'bridge_domain_statistics'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state', u'vlan_statistics'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state', u'bridge_domain_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}, {'leafval': 'vlan_id'}, {'leafval': 'bd_id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sub_interface_statistics_state_bridge_domain_statistics_get(self, bridge_domain_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type bridge_domain_statistics: bd_id
    :param bridge_domain_statistics: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.bridge_domain_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.bridge_domain_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.bridge_domain_statistics', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.bridge_domain_statistics', u'lif_statistics'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.bridge_domain_statistics', u'lif_statistics'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.bridge_domain_statistics', u'lif_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'bridge_domain_statistics', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rx_packets, tx_packets, rx_bytes, tx_bytes, lif_id, lif_name'}, {'leafval': 'rx_packets, tx_packets, rx_bytes, tx_bytes, lif_id, lif_name'}, {'leafval': 'rx_packets, tx_packets, rx_bytes, tx_bytes, lif_id, lif_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_statistics=bridge_domain_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_statistics=bridge_domain_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sub_interface_statistics_state_bridge_domain_statistics_lif_statistics_get(self, bridge_domain_statistics=None, lif_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_statistics: bd_id
    :param bridge_domain_statistics: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lif_statistics: lif_id
    :param lif_statistics: Keyword argument tuple.

    :type lif_id: long
    :param lif_id: **lif_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics'), ('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics')]
    bindings_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lif_statistics', 'keyval': 'lif_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sub_interface_statistics_state_bridge_domain_statistics_lif_statistics_lif_name_get(self, bridge_domain_statistics=None, lif_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_statistics: bd_id
    :param bridge_domain_statistics: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lif_statistics: lif_id
    :param lif_statistics: Keyword argument tuple.

    :type lif_id: long
    :param lif_id: **lif_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics'), ('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics')]
    bindings_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lif_statistics', 'keyval': 'lif_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sub_interface_statistics_state_bridge_domain_statistics_lif_statistics_rx_bytes_get(self, bridge_domain_statistics=None, lif_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_statistics: bd_id
    :param bridge_domain_statistics: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lif_statistics: lif_id
    :param lif_statistics: Keyword argument tuple.

    :type lif_id: long
    :param lif_id: **lif_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics'), ('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics')]
    bindings_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lif_statistics', 'keyval': 'lif_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sub_interface_statistics_state_bridge_domain_statistics_lif_statistics_rx_packets_get(self, bridge_domain_statistics=None, lif_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_statistics: bd_id
    :param bridge_domain_statistics: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lif_statistics: lif_id
    :param lif_statistics: Keyword argument tuple.

    :type lif_id: long
    :param lif_id: **lif_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics'), ('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics')]
    bindings_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lif_statistics', 'keyval': 'lif_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sub_interface_statistics_state_bridge_domain_statistics_lif_statistics_tx_bytes_get(self, bridge_domain_statistics=None, lif_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_statistics: bd_id
    :param bridge_domain_statistics: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lif_statistics: lif_id
    :param lif_statistics: Keyword argument tuple.

    :type lif_id: long
    :param lif_id: **lif_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics'), ('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics')]
    bindings_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lif_statistics', 'keyval': 'lif_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sub_interface_statistics_state_bridge_domain_statistics_lif_statistics_tx_packets_get(self, bridge_domain_statistics=None, lif_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type bridge_domain_statistics: bd_id
    :param bridge_domain_statistics: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **bridge_domain_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type lif_statistics: lif_id
    :param lif_statistics: Keyword argument tuple.

    :type lif_id: long
    :param lif_id: **lif_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics'), ('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.bridge_domain_statistics', u'bridge_domain_statistics')]
    bindings_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.bridge_domain_statistics.lif_statistics', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}, {'keyval': 'bd_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'lif_statistics', 'keyval': 'lif_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, bridge_domain_statistics=bridge_domain_statistics, lif_statistics=lif_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sub_interface_statistics_state_vlan_statistics_get(self, vlan_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan_statistics: vlan_id
    :param vlan_statistics: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.vlan_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.vlan_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.vlan_statistics', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.sub_interface_statistics_state.vlan_statistics', u'port_statistics'), ('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.vlan_statistics', u'port_statistics'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.vlan_statistics', u'port_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan_statistics', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rx_packets, tx_packets, rx_bytes, tx_bytes, port_id, port_name'}, {'leafval': 'rx_packets, tx_packets, rx_bytes, tx_bytes, port_id, port_name'}, {'leafval': 'rx_packets, tx_packets, rx_bytes, tx_bytes, port_id, port_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_statistics=vlan_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_statistics=vlan_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sub_interface_statistics_state_vlan_statistics_port_statistics_get(self, vlan_statistics=None, port_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan_statistics: vlan_id
    :param vlan_statistics: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_statistics: port_id
    :param port_statistics: Keyword argument tuple.

    :type port_id: long
    :param port_id: **port_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics'), ('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics')]
    bindings_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_statistics', 'keyval': 'port_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sub_interface_statistics_state_vlan_statistics_port_statistics_port_name_get(self, vlan_statistics=None, port_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan_statistics: vlan_id
    :param vlan_statistics: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_statistics: port_id
    :param port_statistics: Keyword argument tuple.

    :type port_id: long
    :param port_id: **port_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics'), ('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics')]
    bindings_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_statistics', 'keyval': 'port_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sub_interface_statistics_state_vlan_statistics_port_statistics_rx_bytes_get(self, vlan_statistics=None, port_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan_statistics: vlan_id
    :param vlan_statistics: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_statistics: port_id
    :param port_statistics: Keyword argument tuple.

    :type port_id: long
    :param port_id: **port_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics'), ('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics')]
    bindings_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_statistics', 'keyval': 'port_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sub_interface_statistics_state_vlan_statistics_port_statistics_rx_packets_get(self, vlan_statistics=None, port_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan_statistics: vlan_id
    :param vlan_statistics: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_statistics: port_id
    :param port_statistics: Keyword argument tuple.

    :type port_id: long
    :param port_id: **port_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics'), ('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics')]
    bindings_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_statistics', 'keyval': 'port_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sub_interface_statistics_state_vlan_statistics_port_statistics_tx_bytes_get(self, vlan_statistics=None, port_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan_statistics: vlan_id
    :param vlan_statistics: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_statistics: port_id
    :param port_statistics: Keyword argument tuple.

    :type port_id: long
    :param port_id: **port_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics'), ('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics')]
    bindings_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_statistics', 'keyval': 'port_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sub_interface_statistics_state_vlan_statistics_port_statistics_tx_packets_get(self, vlan_statistics=None, port_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan_statistics: vlan_id
    :param vlan_statistics: Keyword argument tuple.

    :type vlan_id: long
    :param vlan_id: **vlan_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type port_statistics: port_id
    :param port_statistics: Keyword argument tuple.

    :type port_id: long
    :param port_id: **port_statistics** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics'), ('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.vlan_statistics', u'vlan_statistics')]
    bindings_list = [('pybind.slxos.v17r_1_01a.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sub_interface_statistics_state.vlan_statistics.port_statistics', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}, {'keyval': 'vlan_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'port_statistics', 'keyval': 'port_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan_statistics=vlan_statistics, port_statistics=port_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def support_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.support', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.support', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.support', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.support', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.support', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.support', u'autoupload'), ('pybind.slxos.v17r_2_00.support', u'autoupload_param'), ('pybind.slxos.v17r_2_00.support', u'support_param'), ('pybind.slxos.v17s_1_02.support', u'autoupload_param'), ('pybind.slxos.v17s_1_02.support', u'support_param'), ('pybind.slxos.v17s_1_02.support', u'autoupload'), ('pybind.nos.v7_2_0.support', u'support_param'), ('pybind.nos.v7_2_0.support', u'autoupload'), ('pybind.nos.v7_2_0.support', u'autoupload_param'), ('pybind.slxos.v17r_1_01a.support', u'autoupload'), ('pybind.slxos.v17r_1_01a.support', u'support_param'), ('pybind.slxos.v17r_1_01a.support', u'autoupload_param'), ('pybind.nos.v6_0_2f.support', u'autoupload'), ('pybind.nos.v6_0_2f.support', u'support_param'), ('pybind.nos.v6_0_2f.support', u'autoupload_param')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'enable'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'enable'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'enable'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'enable'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'hostip, username, directory, protocol, password'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def support_autoupload_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.support.autoupload', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.support.autoupload', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.support.autoupload', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.support.autoupload', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.support.autoupload', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def support_autoupload_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.support.autoupload', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.support.autoupload', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.support.autoupload', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.support.autoupload', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.support.autoupload', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def support_autoupload_param_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.support.autoupload_param', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.support.autoupload_param', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.support.autoupload_param', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.support.autoupload_param', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.support.autoupload_param', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hostip, username, directory, protocol, password'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def support_autoupload_param_directory_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.support.autoupload_param', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.support.autoupload_param', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.support.autoupload_param', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.support.autoupload_param', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.support.autoupload_param', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def support_autoupload_param_hostip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.support.autoupload_param', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.support.autoupload_param', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.support.autoupload_param', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.support.autoupload_param', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.support.autoupload_param', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def support_autoupload_param_password_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.support.autoupload_param', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.support.autoupload_param', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.support.autoupload_param', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.support.autoupload_param', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.support.autoupload_param', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def support_autoupload_param_protocol_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.support.autoupload_param', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.support.autoupload_param', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.support.autoupload_param', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.support.autoupload_param', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.support.autoupload_param', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def support_autoupload_param_username_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.support.autoupload_param', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.support.autoupload_param', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.support.autoupload_param', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.support.autoupload_param', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.support.autoupload_param', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def support_ffdc_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.support', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.support', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.support', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.support', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.support', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.support', u'autoupload'), ('pybind.slxos.v17r_2_00.support', u'autoupload_param'), ('pybind.slxos.v17r_2_00.support', u'support_param'), ('pybind.slxos.v17s_1_02.support', u'autoupload_param'), ('pybind.slxos.v17s_1_02.support', u'support_param'), ('pybind.slxos.v17s_1_02.support', u'autoupload'), ('pybind.nos.v7_2_0.support', u'support_param'), ('pybind.nos.v7_2_0.support', u'autoupload'), ('pybind.nos.v7_2_0.support', u'autoupload_param'), ('pybind.slxos.v17r_1_01a.support', u'autoupload'), ('pybind.slxos.v17r_1_01a.support', u'support_param'), ('pybind.slxos.v17r_1_01a.support', u'autoupload_param'), ('pybind.nos.v6_0_2f.support', u'autoupload'), ('pybind.nos.v6_0_2f.support', u'support_param'), ('pybind.nos.v6_0_2f.support', u'autoupload_param')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'enable'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'enable'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'enable'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'enable'}, {'leafval': 'hostip, username, directory, protocol, password'}, {'leafval': 'hostip, username, directory, protocol, password'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def support_support_param_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.support.support_param', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.support.support_param', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.support.support_param', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.support.support_param', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.support.support_param', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'hostip, username, directory, protocol, password'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def support_support_param_directory_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.support.support_param', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.support.support_param', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.support.support_param', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.support.support_param', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.support.support_param', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def support_support_param_hostip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.support.support_param', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.support.support_param', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.support.support_param', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.support.support_param', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.support.support_param', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def support_support_param_password_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.support.support_param', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.support.support_param', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.support.support_param', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.support.support_param', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.support.support_param', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def support_support_param_protocol_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.support.support_param', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.support.support_param', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.support.support_param', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.support.support_param', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.support.support_param', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def support_support_param_username_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.support.support_param', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.support.support_param', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.support.support_param', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.support.support_param', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.support.support_param', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def switch_attributes_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system.switch_attributes', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system.switch_attributes', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_ras.switch_attributes', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_ras.switch_attributes', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system.switch_attributes', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.system.switch_attributes', u'rbridge_id'), ('pybind.nos.v7_2_0.system.switch_attributes', u'rbridge_id')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'rbridge_id, chassis_name, host_name'}, {'leafval': 'rbridge_id, chassis_name, host_name'}]
    leafval_map = {"pybind.nos.v6_0_2f.system.switch_attributes": {}, "pybind.slxos.v17r_1_01a.system_ras.switch_attributes": {"chassis_name": "chassis_name", "host_name": "host_name"}, "pybind.slxos.v17r_2_00.system_ras.switch_attributes": {"chassis_name": "chassis_name", "host_name": "host_name"}, "pybind.nos.v7_2_0.system.switch_attributes": {}, "pybind.slxos.v17s_1_02.system.switch_attributes": {"chassis_name": "chassis_name", "host_name": "host_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def switch_attributes_chassis_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_ras.switch_attributes', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_ras.switch_attributes', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system.switch_attributes', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def switch_attributes_host_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_ras.switch_attributes', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_ras.switch_attributes', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system.switch_attributes', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def switch_attributes_rbridge_id_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: unicode
    :param rbridge_id: **rbridge_id** tuple argument.

        * length restriction: ::

            ['1..3']

        * pattern restriction: ::

            '[1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9]'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system.switch_attributes.rbridge_id', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system.switch_attributes.rbridge_id', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rbridge_id', 'keyval': 'rbridge_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def switch_attributes_rbridge_id_chassis_name_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: unicode
    :param rbridge_id: **rbridge_id** tuple argument.

        * length restriction: ::

            ['1..3']

        * pattern restriction: ::

            '[1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9]'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system.switch_attributes.rbridge_id', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system.switch_attributes.rbridge_id', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rbridge_id', 'keyval': 'rbridge_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def switch_attributes_rbridge_id_host_name_get(self, rbridge_id=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type rbridge_id: rbridge_id
    :param rbridge_id: Keyword argument tuple.

    :type rbridge_id: unicode
    :param rbridge_id: **rbridge_id** tuple argument.

        * length restriction: ::

            ['1..3']

        * pattern restriction: ::

            '[1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-3][0-9]'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system.switch_attributes.rbridge_id', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system.switch_attributes.rbridge_id', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rbridge_id', 'keyval': 'rbridge_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rbridge_id=rbridge_id)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rbridge_id=rbridge_id)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.sysmon', u'link_crc_monitoring'), ('pybind.slxos.v17r_1_01a.sysmon', u'sfm_walk'), ('pybind.slxos.v17r_1_01a.sysmon', u'fe_access_check'), ('pybind.slxos.v17r_2_00.sysmon', u'link_crc_monitoring'), ('pybind.slxos.v17r_2_00.sysmon', u'sfm_walk'), ('pybind.slxos.v17r_2_00.sysmon', u'fe_access_check'), ('pybind.slxos.v17s_1_02.sysmon', u'link_crc_monitoring'), ('pybind.slxos.v17s_1_02.sysmon', u'fe_access_check'), ('pybind.slxos.v17s_1_02.sysmon', u'sfm_walk')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'link_crc_mon_disable, link_crc_mon_interval, link_crc_mon_threshold, link_crc_mon_action'}, {'leafval': 'sfm_walk_auto, sfm_walk_dis_redundancy_check, sfm_walk_interval, sfm_walk_threshold'}, {'leafval': 'fe_access_check_disable, fe_access_check_interval, fe_access_check_threshold, fe_access_check_recovery_threshold, fe_access_check_action'}, {'leafval': 'link_crc_mon_disable, link_crc_mon_interval, link_crc_mon_threshold, link_crc_mon_action'}, {'leafval': 'sfm_walk_auto, sfm_walk_dis_redundancy_check, sfm_walk_interval, sfm_walk_threshold'}, {'leafval': 'fe_access_check_disable, fe_access_check_interval, fe_access_check_threshold, fe_access_check_recovery_threshold, fe_access_check_action'}, {'leafval': 'link_crc_mon_disable, link_crc_mon_interval, link_crc_mon_threshold, link_crc_mon_action'}, {'leafval': 'fe_access_check_disable, fe_access_check_interval, fe_access_check_threshold, fe_access_check_recovery_threshold, fe_access_check_action'}, {'leafval': 'sfm_walk_auto, sfm_walk_dis_redundancy_check, sfm_walk_interval, sfm_walk_threshold'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_fe_access_check_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon.fe_access_check', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon.fe_access_check', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon.fe_access_check', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_fe_access_check_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon.fe_access_check', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon.fe_access_check', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon.fe_access_check', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_fe_access_check_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon.fe_access_check', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon.fe_access_check', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon.fe_access_check', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_fe_access_check_poll_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon.fe_access_check', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon.fe_access_check', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon.fe_access_check', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_fe_access_check_recovery_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon.fe_access_check', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon.fe_access_check', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon.fe_access_check', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_fe_access_check_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon.fe_access_check', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon.fe_access_check', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon.fe_access_check', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_link_crc_monitoring_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon.link_crc_monitoring', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon.link_crc_monitoring', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon.link_crc_monitoring', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_link_crc_monitoring_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon.link_crc_monitoring', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon.link_crc_monitoring', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon.link_crc_monitoring', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_link_crc_monitoring_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon.link_crc_monitoring', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon.link_crc_monitoring', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon.link_crc_monitoring', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_link_crc_monitoring_poll_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon.link_crc_monitoring', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon.link_crc_monitoring', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon.link_crc_monitoring', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_link_crc_monitoring_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon.link_crc_monitoring', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon.link_crc_monitoring', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon.link_crc_monitoring', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_sfm_walk_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon.sfm_walk', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon.sfm_walk', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon.sfm_walk', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_sfm_walk_auto_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon.sfm_walk', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon.sfm_walk', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon.sfm_walk', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_sfm_walk_disable_redundancy_check_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon.sfm_walk', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon.sfm_walk', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon.sfm_walk', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_sfm_walk_poll_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon.sfm_walk', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon.sfm_walk', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon.sfm_walk', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def sysmon_sfm_walk_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.sysmon.sfm_walk', 'pybind.slxos.v17r_1_01a.brocade_sysmon', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.sysmon.sfm_walk', 'pybind.slxos.v17r_2_00.brocade_sysmon', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.sysmon.sfm_walk', 'pybind.slxos.v17s_1_02.brocade_sysmon', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system', 'pybind.nos.v6_0_2f.brocade_ras', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system', 'pybind.nos.v7_2_0.brocade_ras', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_config', 'pybind.slxos.v17r_1_01a.brocade_system_watermark', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_config', 'pybind.slxos.v17r_2_00.brocade_system_watermark', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system', 'pybind.slxos.v17s_1_02.brocade_ras', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.tunnel_settings.system.tunnel', u'replicator'), ('pybind.slxos.v17s_1_02.system', u'switch_attributes'), ('pybind.slxos.v17s_1_02.tunnel_settings.system', u'tunnel'), ('pybind.slxos.v17r_1_01a.system_config', u'interface'), ('pybind.slxos.v17r_2_00.system_config', u'interface'), ('pybind.nos.v6_0_2f.system.switch_attributes', u'rbridge_id'), ('pybind.nos.v6_0_2f.tunnel_settings.system', u'tunnel'), ('pybind.nos.v7_2_0.tunnel_settings.system', u'tunnel'), ('pybind.nos.v7_2_0.system.switch_attributes', u'rbridge_id'), ('pybind.nos.v7_2_0.tunnel_settings.system.tunnel', u'replicator')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'load_balance'}, {'leafval': 'chassis_name, host_name'}, {'leafval': 'suppress_debounce'}, {'leafval': 'utilization_watermark'}, {'leafval': 'utilization_watermark'}, {'leafval': 'rbridge_id, chassis_name, host_name'}, {'leafval': 'suppress_debounce'}, {'leafval': 'suppress_debounce'}, {'leafval': 'rbridge_id, chassis_name, host_name'}, {'leafval': 'load_balance'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_interface_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_config.interface', 'pybind.slxos.v17r_1_01a.brocade_system_watermark', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_config.interface', 'pybind.slxos.v17r_2_00.brocade_system_watermark', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_interface_utilization_watermark_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_config.interface', 'pybind.slxos.v17r_1_01a.brocade_system_watermark', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_config.interface', 'pybind.slxos.v17r_2_00.brocade_system_watermark', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_max_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_arp_holder.system_max', 'pybind.nos.v6_0_2f.brocade_arp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_arp_holder.system_max', 'pybind.nos.v7_2_0.brocade_arp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_max_arp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.hide_arp_holder.system_max', 'pybind.nos.v6_0_2f.brocade_arp', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.hide_arp_holder.system_max', 'pybind.nos.v7_2_0.brocade_arp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.system_monitor.power', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.LineCard', u'alert'), ('pybind.nos.v6_0_2f.system_monitor.temp', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.sfp', u'alert'), ('pybind.nos.v6_0_2f.system_monitor.LineCard', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.MM', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.cid_card', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.power', u'alert'), ('pybind.nos.v6_0_2f.system_monitor.fan', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.compact_flash', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.cid_card', u'alert'), ('pybind.nos.v6_0_2f.system_monitor.fan', u'alert'), ('pybind.nos.v6_0_2f.system_monitor.SFM', u'threshold'), ('pybind.slxos.v17r_2_00.system_monitor.fan', u'threshold'), ('pybind.slxos.v17r_2_00.system_monitor.compact_flash', u'threshold'), ('pybind.slxos.v17r_2_00.system_monitor.cid_card', u'threshold'), ('pybind.slxos.v17r_2_00.system_monitor.tm', u'delete_packet'), ('pybind.slxos.v17r_2_00.system_monitor.cid_card', u'alert'), ('pybind.slxos.v17r_2_00.system_monitor.MM', u'threshold'), ('pybind.slxos.v17r_2_00.system_monitor.temp', u'threshold'), ('pybind.slxos.v17r_2_00.system_monitor.tm', u'discard_packet'), ('pybind.slxos.v17r_2_00.system_monitor.LineCard', u'alert'), ('pybind.slxos.v17r_2_00.system_monitor.SFM', u'threshold'), ('pybind.slxos.v17r_2_00.system_monitor.fan', u'alert'), ('pybind.slxos.v17r_2_00.system_monitor.LineCard', u'threshold'), ('pybind.slxos.v17r_2_00.system_monitor.power', u'alert'), ('pybind.slxos.v17r_2_00.system_monitor.power', u'threshold'), ('pybind.slxos.v17r_2_00.system_monitor.port', u'crc'), ('pybind.slxos.v17r_2_00.system_monitor.tm', u'discard_voq_packet'), ('pybind.nos.v7_2_0.system_monitor.sfp', u'alert'), ('pybind.nos.v7_2_0.system_monitor.cid_card', u'threshold'), ('pybind.nos.v7_2_0.system_monitor.power', u'threshold'), ('pybind.nos.v7_2_0.system_monitor.MM', u'threshold'), ('pybind.nos.v7_2_0.system_monitor.fan', u'alert'), ('pybind.nos.v7_2_0.system_monitor.temp', u'threshold'), ('pybind.nos.v7_2_0.system_monitor.LineCard', u'alert'), ('pybind.nos.v7_2_0.system_monitor.LineCard', u'threshold'), ('pybind.nos.v7_2_0.system_monitor.power', u'alert'), ('pybind.nos.v7_2_0.system_monitor.compact_flash', u'threshold'), ('pybind.nos.v7_2_0.system_monitor.fan', u'threshold'), ('pybind.nos.v7_2_0.system_monitor.SFM', u'threshold'), ('pybind.nos.v7_2_0.system_monitor.cid_card', u'alert'), ('pybind.slxos.v17s_1_02.system_monitor.cid_card', u'threshold'), ('pybind.slxos.v17s_1_02.system_monitor.temp', u'threshold'), ('pybind.slxos.v17s_1_02.system_monitor.fan', u'threshold'), ('pybind.slxos.v17s_1_02.system_monitor.MM', u'threshold'), ('pybind.slxos.v17s_1_02.system_monitor.power', u'alert'), ('pybind.slxos.v17s_1_02.system_monitor.cid_card', u'alert'), ('pybind.slxos.v17s_1_02.system_monitor.fan', u'alert'), ('pybind.slxos.v17s_1_02.system_monitor.compact_flash', u'threshold'), ('pybind.slxos.v17s_1_02.system_monitor.SFM', u'threshold'), ('pybind.slxos.v17s_1_02.system_monitor.power', u'threshold'), ('pybind.slxos.v17s_1_02.system_monitor.LineCard', u'alert'), ('pybind.slxos.v17s_1_02.system_monitor.LineCard', u'threshold'), ('pybind.slxos.v17r_1_01a.system_monitor.LineCard', u'threshold'), ('pybind.slxos.v17r_1_01a.system_monitor.tm', u'delete_packet'), ('pybind.slxos.v17r_1_01a.system_monitor.compact_flash', u'threshold'), ('pybind.slxos.v17r_1_01a.system_monitor.cid_card', u'alert'), ('pybind.slxos.v17r_1_01a.system_monitor.temp', u'threshold'), ('pybind.slxos.v17r_1_01a.system_monitor.LineCard', u'alert'), ('pybind.slxos.v17r_1_01a.system_monitor.cid_card', u'threshold'), ('pybind.slxos.v17r_1_01a.system_monitor.SFM', u'threshold'), ('pybind.slxos.v17r_1_01a.system_monitor.power', u'threshold'), ('pybind.slxos.v17r_1_01a.system_monitor.port', u'crc'), ('pybind.slxos.v17r_1_01a.system_monitor.tm', u'discard_packet'), ('pybind.slxos.v17r_1_01a.system_monitor.power', u'alert'), ('pybind.slxos.v17r_1_01a.system_monitor.tm', u'discard_voq_packet'), ('pybind.slxos.v17r_1_01a.system_monitor.fan', u'threshold'), ('pybind.slxos.v17r_1_01a.system_monitor.fan', u'alert'), ('pybind.slxos.v17r_1_01a.system_monitor.MM', u'threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'tm_delete_packet_action, tm_delete_packet_threshold, tm_delete_packet_interval'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'tm_discard_packet_action, tm_discard_packet_threshold, tm_discard_packet_interval'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'port_crc_mon_action, port_crc_mon_interval, port_crc_mon_threshold, port_crc_mon_disable'}, {'leafval': 'tm_discard_voq_packet_action, tm_discard_voq_packet_threshold, tm_discard_voq_packet_interval'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'state, action'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'tm_delete_packet_action, tm_delete_packet_threshold, tm_delete_packet_interval'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'port_crc_mon_action, port_crc_mon_interval, port_crc_mon_threshold, port_crc_mon_disable'}, {'leafval': 'tm_discard_packet_action, tm_discard_packet_threshold, tm_discard_packet_interval'}, {'leafval': 'state, action'}, {'leafval': 'tm_discard_voq_packet_action, tm_discard_voq_packet_threshold, tm_discard_voq_packet_interval'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_cid_card_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.cid_card', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.cid_card', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.cid_card', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.cid_card', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.cid_card', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.system_monitor.cid_card', u'threshold'), ('pybind.slxos.v17r_2_00.system_monitor.cid_card', u'alert'), ('pybind.nos.v7_2_0.system_monitor.cid_card', u'threshold'), ('pybind.nos.v7_2_0.system_monitor.cid_card', u'alert'), ('pybind.slxos.v17s_1_02.system_monitor.cid_card', u'threshold'), ('pybind.slxos.v17s_1_02.system_monitor.cid_card', u'alert'), ('pybind.nos.v6_0_2f.system_monitor.cid_card', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.cid_card', u'alert'), ('pybind.slxos.v17r_1_01a.system_monitor.cid_card', u'alert'), ('pybind.slxos.v17r_1_01a.system_monitor.cid_card', u'threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_cid_card_alert_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.cid_card.alert', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.cid_card.alert', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.cid_card.alert', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.cid_card.alert', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.cid_card.alert', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'state, action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_cid_card_alert_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.cid_card.alert', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.cid_card.alert', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.cid_card.alert', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.cid_card.alert', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.cid_card.alert', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_cid_card_alert_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.cid_card.alert', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.cid_card.alert', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.cid_card.alert', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.cid_card.alert', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.cid_card.alert', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_cid_card_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.cid_card.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.cid_card.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.cid_card.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.cid_card.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.cid_card.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'marginal_threshold, down_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_cid_card_threshold_down_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.cid_card.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.cid_card.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.cid_card.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.cid_card.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.cid_card.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_cid_card_threshold_marginal_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.cid_card.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.cid_card.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.cid_card.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.cid_card.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.cid_card.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_compact_flash_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.compact_flash', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.compact_flash', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.compact_flash', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.compact_flash', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.compact_flash', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.system_monitor.compact_flash', u'threshold'), ('pybind.slxos.v17s_1_02.system_monitor.compact_flash', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.compact_flash', u'threshold'), ('pybind.slxos.v17r_1_01a.system_monitor.compact_flash', u'threshold'), ('pybind.nos.v7_2_0.system_monitor.compact_flash', u'threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_compact_flash_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.compact_flash.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.compact_flash.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.compact_flash.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.compact_flash.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.compact_flash.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'marginal_threshold, down_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_compact_flash_threshold_down_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.compact_flash.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.compact_flash.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.compact_flash.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.compact_flash.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.compact_flash.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_compact_flash_threshold_marginal_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.compact_flash.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.compact_flash.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.compact_flash.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.compact_flash.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.compact_flash.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_fan_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.fan', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.fan', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.fan', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.fan', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.fan', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.system_monitor.fan', u'threshold'), ('pybind.slxos.v17r_1_01a.system_monitor.fan', u'alert'), ('pybind.nos.v7_2_0.system_monitor.fan', u'alert'), ('pybind.nos.v7_2_0.system_monitor.fan', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.fan', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.fan', u'alert'), ('pybind.slxos.v17s_1_02.system_monitor.fan', u'threshold'), ('pybind.slxos.v17s_1_02.system_monitor.fan', u'alert'), ('pybind.slxos.v17r_2_00.system_monitor.fan', u'threshold'), ('pybind.slxos.v17r_2_00.system_monitor.fan', u'alert')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_fan_alert_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.fan.alert', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.fan.alert', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.fan.alert', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.fan.alert', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.fan.alert', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'state, action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_fan_alert_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.fan.alert', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.fan.alert', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.fan.alert', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.fan.alert', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.fan.alert', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_fan_alert_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.fan.alert', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.fan.alert', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.fan.alert', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.fan.alert', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.fan.alert', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_fan_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.fan.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.fan.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.fan.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.fan.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.fan.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'marginal_threshold, down_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_fan_threshold_down_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.fan.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.fan.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.fan.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.fan.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.fan.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_fan_threshold_marginal_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.fan.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.fan.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.fan.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.fan.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.fan.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_linecard_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.LineCard', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.LineCard', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.LineCard', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.LineCard', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.LineCard', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.system_monitor.LineCard', u'alert'), ('pybind.slxos.v17r_2_00.system_monitor.LineCard', u'threshold'), ('pybind.slxos.v17s_1_02.system_monitor.LineCard', u'alert'), ('pybind.slxos.v17s_1_02.system_monitor.LineCard', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.LineCard', u'alert'), ('pybind.nos.v6_0_2f.system_monitor.LineCard', u'threshold'), ('pybind.slxos.v17r_1_01a.system_monitor.LineCard', u'threshold'), ('pybind.slxos.v17r_1_01a.system_monitor.LineCard', u'alert'), ('pybind.nos.v7_2_0.system_monitor.LineCard', u'alert'), ('pybind.nos.v7_2_0.system_monitor.LineCard', u'threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_linecard_alert_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.LineCard.alert', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.LineCard.alert', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.LineCard.alert', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.LineCard.alert', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.LineCard.alert', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'state, action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_linecard_alert_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.LineCard.alert', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.LineCard.alert', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.LineCard.alert', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.LineCard.alert', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.LineCard.alert', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_linecard_alert_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.LineCard.alert', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.LineCard.alert', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.LineCard.alert', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.LineCard.alert', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.LineCard.alert', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_linecard_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.LineCard.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.LineCard.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.LineCard.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.LineCard.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.LineCard.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'marginal_threshold, down_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_linecard_threshold_down_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.LineCard.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.LineCard.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.LineCard.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.LineCard.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.LineCard.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_linecard_threshold_marginal_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.LineCard.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.LineCard.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.LineCard.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.LineCard.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.LineCard.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mail_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor_mail', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor_mail', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor_mail', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor_mail', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor_mail', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.system_monitor_mail', u'interface'), ('pybind.nos.v7_2_0.system_monitor_mail', u'security'), ('pybind.nos.v7_2_0.system_monitor_mail', u'relay'), ('pybind.nos.v7_2_0.system_monitor_mail', u'fru'), ('pybind.nos.v7_2_0.system_monitor_mail.interface', u'email_list'), ('pybind.nos.v7_2_0.system_monitor_mail.sfp', u'email_list'), ('pybind.nos.v7_2_0.system_monitor_mail', u'sfp'), ('pybind.nos.v7_2_0.system_monitor_mail.security', u'email_list'), ('pybind.nos.v7_2_0.system_monitor_mail.fru', u'email_list'), ('pybind.slxos.v17r_2_00.system_monitor_mail', u'sfp'), ('pybind.slxos.v17r_2_00.system_monitor_mail', u'interface'), ('pybind.slxos.v17r_2_00.system_monitor_mail.security', u'email_list'), ('pybind.slxos.v17r_2_00.system_monitor_mail.interface', u'email_list'), ('pybind.slxos.v17r_2_00.system_monitor_mail', u'security'), ('pybind.slxos.v17r_2_00.system_monitor_mail', u'fru'), ('pybind.slxos.v17r_2_00.system_monitor_mail.sfp', u'email_list'), ('pybind.slxos.v17r_2_00.system_monitor_mail', u'relay'), ('pybind.slxos.v17r_2_00.system_monitor_mail.fru', u'email_list'), ('pybind.nos.v6_0_2f.system_monitor_mail', u'fru'), ('pybind.nos.v6_0_2f.system_monitor_mail', u'security'), ('pybind.nos.v6_0_2f.system_monitor_mail.security', u'email_list'), ('pybind.nos.v6_0_2f.system_monitor_mail.sfp', u'email_list'), ('pybind.nos.v6_0_2f.system_monitor_mail', u'relay'), ('pybind.nos.v6_0_2f.system_monitor_mail.interface', u'email_list'), ('pybind.nos.v6_0_2f.system_monitor_mail.fru', u'email_list'), ('pybind.nos.v6_0_2f.system_monitor_mail', u'interface'), ('pybind.nos.v6_0_2f.system_monitor_mail', u'sfp'), ('pybind.slxos.v17r_1_01a.system_monitor_mail', u'fru'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.sfp', u'email_list'), ('pybind.slxos.v17r_1_01a.system_monitor_mail', u'security'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.security', u'email_list'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.fru', u'email_list'), ('pybind.slxos.v17r_1_01a.system_monitor_mail', u'relay'), ('pybind.slxos.v17r_1_01a.system_monitor_mail', u'sfp'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.interface', u'email_list'), ('pybind.slxos.v17r_1_01a.system_monitor_mail', u'interface'), ('pybind.slxos.v17s_1_02.system_monitor_mail.sfp', u'email_list'), ('pybind.slxos.v17s_1_02.system_monitor_mail.security', u'email_list'), ('pybind.slxos.v17s_1_02.system_monitor_mail.fru', u'email_list'), ('pybind.slxos.v17s_1_02.system_monitor_mail.interface', u'email_list'), ('pybind.slxos.v17s_1_02.system_monitor_mail', u'fru'), ('pybind.slxos.v17s_1_02.system_monitor_mail', u'sfp'), ('pybind.slxos.v17s_1_02.system_monitor_mail', u'security'), ('pybind.slxos.v17s_1_02.system_monitor_mail', u'interface'), ('pybind.slxos.v17s_1_02.system_monitor_mail', u'relay')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'host_ip, domain_name'}, {'leafval': 'enable'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'enable'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'email'}, {'leafval': 'host_ip, domain_name'}, {'leafval': 'email'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'host_ip, domain_name'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'email'}, {'leafval': 'enable'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'host_ip, domain_name'}, {'leafval': 'enable'}, {'leafval': 'email'}, {'leafval': 'enable'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'host_ip, domain_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mail_fru_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor_mail.fru', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor_mail.fru', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.fru', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor_mail.fru', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor_mail.fru', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.system_monitor_mail.fru', u'email_list'), ('pybind.nos.v6_0_2f.system_monitor_mail.fru', u'email_list'), ('pybind.nos.v7_2_0.system_monitor_mail.fru', u'email_list'), ('pybind.slxos.v17r_2_00.system_monitor_mail.fru', u'email_list'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.fru', u'email_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mail_fru_email_list_get(self, email_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type email_list: email
    :param email_list: Keyword argument tuple.

    :type email: unicode
    :param email: **email_list** tuple argument:  <email:string>  e-mail address for FRU alerts

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor_mail.fru.email_list', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor_mail.fru.email_list', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.fru.email_list', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor_mail.fru.email_list', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor_mail.fru.email_list', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'email_list', 'keyval': 'email', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, email_list=email_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, email_list=email_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mail_fru_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor_mail.fru', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor_mail.fru', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.fru', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor_mail.fru', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor_mail.fru', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.system_monitor_mail.fru', u'email_list'), ('pybind.nos.v6_0_2f.system_monitor_mail.fru', u'email_list'), ('pybind.nos.v7_2_0.system_monitor_mail.fru', u'email_list'), ('pybind.slxos.v17r_2_00.system_monitor_mail.fru', u'email_list'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.fru', u'email_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mail_interface_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor_mail.interface', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor_mail.interface', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.interface', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor_mail.interface', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor_mail.interface', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.system_monitor_mail.interface', u'email_list'), ('pybind.slxos.v17s_1_02.system_monitor_mail.interface', u'email_list'), ('pybind.nos.v7_2_0.system_monitor_mail.interface', u'email_list'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.interface', u'email_list'), ('pybind.slxos.v17r_2_00.system_monitor_mail.interface', u'email_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mail_interface_email_list_get(self, email_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type email_list: email
    :param email_list: Keyword argument tuple.

    :type email: unicode
    :param email: **email_list** tuple argument:  <email:string>  e-mail address for Interface alerts

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor_mail.interface.email_list', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor_mail.interface.email_list', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.interface.email_list', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor_mail.interface.email_list', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor_mail.interface.email_list', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'email_list', 'keyval': 'email', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, email_list=email_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, email_list=email_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mail_interface_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor_mail.interface', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor_mail.interface', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.interface', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor_mail.interface', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor_mail.interface', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.system_monitor_mail.interface', u'email_list'), ('pybind.slxos.v17s_1_02.system_monitor_mail.interface', u'email_list'), ('pybind.nos.v7_2_0.system_monitor_mail.interface', u'email_list'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.interface', u'email_list'), ('pybind.slxos.v17r_2_00.system_monitor_mail.interface', u'email_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mail_relay_get(self, relay=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type relay: host_ip
    :param relay: Keyword argument tuple.

    :type host_ip: unicode
    :param host_ip: **relay** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor_mail.relay', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor_mail.relay', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.relay', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor_mail.relay', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor_mail.relay', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'relay', 'keyval': 'host_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, relay=relay)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, relay=relay)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mail_relay_domain_name_get(self, relay=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type relay: host_ip
    :param relay: Keyword argument tuple.

    :type host_ip: unicode
    :param host_ip: **relay** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor_mail.relay', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor_mail.relay', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.relay', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor_mail.relay', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor_mail.relay', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'relay', 'keyval': 'host_ip', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, relay=relay)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, relay=relay)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mail_security_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor_mail.security', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor_mail.security', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.security', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor_mail.security', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor_mail.security', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.system_monitor_mail.security', u'email_list'), ('pybind.slxos.v17r_2_00.system_monitor_mail.security', u'email_list'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.security', u'email_list'), ('pybind.nos.v6_0_2f.system_monitor_mail.security', u'email_list'), ('pybind.nos.v7_2_0.system_monitor_mail.security', u'email_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mail_security_email_list_get(self, email_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type email_list: email
    :param email_list: Keyword argument tuple.

    :type email: unicode
    :param email: **email_list** tuple argument:  <email:string>  e-mail address for Security alerts

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor_mail.security.email_list', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor_mail.security.email_list', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.security.email_list', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor_mail.security.email_list', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor_mail.security.email_list', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'email_list', 'keyval': 'email', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, email_list=email_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, email_list=email_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mail_security_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor_mail.security', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor_mail.security', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.security', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor_mail.security', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor_mail.security', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.system_monitor_mail.security', u'email_list'), ('pybind.slxos.v17r_2_00.system_monitor_mail.security', u'email_list'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.security', u'email_list'), ('pybind.nos.v6_0_2f.system_monitor_mail.security', u'email_list'), ('pybind.nos.v7_2_0.system_monitor_mail.security', u'email_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mail_sfp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor_mail.sfp', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor_mail.sfp', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.sfp', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor_mail.sfp', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor_mail.sfp', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.system_monitor_mail.sfp', u'email_list'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.sfp', u'email_list'), ('pybind.nos.v6_0_2f.system_monitor_mail.sfp', u'email_list'), ('pybind.nos.v7_2_0.system_monitor_mail.sfp', u'email_list'), ('pybind.slxos.v17r_2_00.system_monitor_mail.sfp', u'email_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mail_sfp_email_list_get(self, email_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type email_list: email
    :param email_list: Keyword argument tuple.

    :type email: unicode
    :param email: **email_list** tuple argument:  <email:string>  e-mail address for SFP alerts

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor_mail.sfp.email_list', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor_mail.sfp.email_list', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.sfp.email_list', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor_mail.sfp.email_list', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor_mail.sfp.email_list', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'email_list', 'keyval': 'email', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, email_list=email_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, email_list=email_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mail_sfp_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor_mail.sfp', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor_mail.sfp', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.sfp', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor_mail.sfp', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor_mail.sfp', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.system_monitor_mail.sfp', u'email_list'), ('pybind.slxos.v17r_1_01a.system_monitor_mail.sfp', u'email_list'), ('pybind.nos.v6_0_2f.system_monitor_mail.sfp', u'email_list'), ('pybind.nos.v7_2_0.system_monitor_mail.sfp', u'email_list'), ('pybind.slxos.v17r_2_00.system_monitor_mail.sfp', u'email_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}, {'leafval': 'email'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mm_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.MM', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.MM', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.MM', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.MM', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.MM', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.system_monitor.MM', u'threshold'), ('pybind.slxos.v17s_1_02.system_monitor.MM', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.MM', u'threshold'), ('pybind.nos.v7_2_0.system_monitor.MM', u'threshold'), ('pybind.slxos.v17r_2_00.system_monitor.MM', u'threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mm_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.MM.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.MM.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.MM.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.MM.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.MM.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'marginal_threshold, down_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mm_threshold_down_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.MM.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.MM.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.MM.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.MM.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.MM.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_mm_threshold_marginal_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.MM.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.MM.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.MM.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.MM.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.MM.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_port_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.port', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.port', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.system_monitor.port', u'crc'), ('pybind.slxos.v17r_2_00.system_monitor.port', u'crc')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'port_crc_mon_action, port_crc_mon_interval, port_crc_mon_threshold, port_crc_mon_disable'}, {'leafval': 'port_crc_mon_action, port_crc_mon_interval, port_crc_mon_threshold, port_crc_mon_disable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_port_crc_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.port.crc', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.port.crc', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_port_crc_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.port.crc', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.port.crc', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_port_crc_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.port.crc', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.port.crc', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_port_crc_poll_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.port.crc', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.port.crc', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_port_crc_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.port.crc', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.port.crc', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_power_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.power', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.power', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.power', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.power', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.power', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.system_monitor.power', u'alert'), ('pybind.slxos.v17r_2_00.system_monitor.power', u'threshold'), ('pybind.slxos.v17r_1_01a.system_monitor.power', u'threshold'), ('pybind.slxos.v17r_1_01a.system_monitor.power', u'alert'), ('pybind.slxos.v17s_1_02.system_monitor.power', u'alert'), ('pybind.slxos.v17s_1_02.system_monitor.power', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.power', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.power', u'alert'), ('pybind.nos.v7_2_0.system_monitor.power', u'threshold'), ('pybind.nos.v7_2_0.system_monitor.power', u'alert')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'state, action'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_power_alert_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.power.alert', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.power.alert', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.power.alert', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.power.alert', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.power.alert', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'state, action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_power_alert_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.power.alert', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.power.alert', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.power.alert', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.power.alert', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.power.alert', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_power_alert_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.power.alert', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.power.alert', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.power.alert', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.power.alert', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.power.alert', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_power_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.power.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.power.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.power.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.power.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.power.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'marginal_threshold, down_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_power_threshold_down_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.power.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.power.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.power.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.power.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.power.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_power_threshold_marginal_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.power.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.power.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.power.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.power.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.power.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_sfm_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.SFM', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.SFM', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.SFM', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.SFM', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.SFM', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.system_monitor.SFM', u'threshold'), ('pybind.nos.v7_2_0.system_monitor.SFM', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.SFM', u'threshold'), ('pybind.slxos.v17r_2_00.system_monitor.SFM', u'threshold'), ('pybind.slxos.v17r_1_01a.system_monitor.SFM', u'threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_sfm_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.SFM.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.SFM.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.SFM.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.SFM.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.SFM.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'marginal_threshold, down_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_sfm_threshold_down_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.SFM.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.SFM.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.SFM.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.SFM.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.SFM.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_sfm_threshold_marginal_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.SFM.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.SFM.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.SFM.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.SFM.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.SFM.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_sfp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.sfp', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.sfp', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.system_monitor.sfp', u'alert'), ('pybind.nos.v6_0_2f.system_monitor.sfp', u'alert')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'state, action'}, {'leafval': 'state, action'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_sfp_alert_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.sfp.alert', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.sfp.alert', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'state, action'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_sfp_alert_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.sfp.alert', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.sfp.alert', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_sfp_alert_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.sfp.alert', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.sfp.alert', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_temp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.temp', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.temp', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.temp', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.temp', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.temp', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.system_monitor.temp', u'threshold'), ('pybind.slxos.v17r_2_00.system_monitor.temp', u'threshold'), ('pybind.nos.v7_2_0.system_monitor.temp', u'threshold'), ('pybind.slxos.v17r_1_01a.system_monitor.temp', u'threshold'), ('pybind.nos.v6_0_2f.system_monitor.temp', u'threshold')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}, {'leafval': 'marginal_threshold, down_threshold'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_temp_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.temp.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.temp.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.temp.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.temp.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.temp.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'marginal_threshold, down_threshold'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_temp_threshold_down_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.temp.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.temp.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.temp.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.temp.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.temp.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_temp_threshold_marginal_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_monitor.temp.threshold', 'pybind.nos.v6_0_2f.brocade_system_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_monitor.temp.threshold', 'pybind.nos.v7_2_0.brocade_system_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_monitor.temp.threshold', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.temp.threshold', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_monitor.temp.threshold', 'pybind.slxos.v17s_1_02.brocade_system_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_tm_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.tm', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.tm', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.system_monitor.tm', u'delete_packet'), ('pybind.slxos.v17r_2_00.system_monitor.tm', u'discard_packet'), ('pybind.slxos.v17r_2_00.system_monitor.tm', u'discard_voq_packet'), ('pybind.slxos.v17r_1_01a.system_monitor.tm', u'delete_packet'), ('pybind.slxos.v17r_1_01a.system_monitor.tm', u'discard_packet'), ('pybind.slxos.v17r_1_01a.system_monitor.tm', u'discard_voq_packet')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'tm_delete_packet_action, tm_delete_packet_threshold, tm_delete_packet_interval'}, {'leafval': 'tm_discard_packet_action, tm_discard_packet_threshold, tm_discard_packet_interval'}, {'leafval': 'tm_discard_voq_packet_action, tm_discard_voq_packet_threshold, tm_discard_voq_packet_interval'}, {'leafval': 'tm_delete_packet_action, tm_delete_packet_threshold, tm_delete_packet_interval'}, {'leafval': 'tm_discard_packet_action, tm_discard_packet_threshold, tm_discard_packet_interval'}, {'leafval': 'tm_discard_voq_packet_action, tm_discard_voq_packet_threshold, tm_discard_voq_packet_interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_tm_delete_packet_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.tm.delete_packet', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.tm.delete_packet', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_tm_delete_packet_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.tm.delete_packet', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.tm.delete_packet', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_tm_delete_packet_logging_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.tm.delete_packet', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.tm.delete_packet', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_tm_delete_packet_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.tm.delete_packet', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.tm.delete_packet', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_tm_discard_packet_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.tm.discard_packet', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.tm.discard_packet', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_tm_discard_packet_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.tm.discard_packet', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.tm.discard_packet', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_tm_discard_packet_logging_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.tm.discard_packet', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.tm.discard_packet', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_tm_discard_packet_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.tm.discard_packet', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.tm.discard_packet', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_tm_discard_voq_packet_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.tm.discard_voq_packet', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.tm.discard_voq_packet', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_tm_discard_voq_packet_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.tm.discard_voq_packet', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.tm.discard_voq_packet', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_tm_discard_voq_packet_logging_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.tm.discard_voq_packet', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.tm.discard_voq_packet', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_monitor_tm_discard_voq_packet_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_monitor.tm.discard_voq_packet', 'pybind.slxos.v17r_1_01a.brocade_system_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_monitor.tm.discard_voq_packet', 'pybind.slxos.v17r_2_00.brocade_system_monitor', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_qos_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.system_qos', 'pybind.nos.v6_0_2f.brocade_policer', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.system_qos', 'pybind.nos.v7_2_0.brocade_policer', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.system_qos', 'pybind.slxos.v17r_1_01a.brocade_qos_mqc', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_qos', 'pybind.slxos.v17r_2_00.brocade_qos_mqc', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.system_qos', 'pybind.slxos.v17s_1_02.brocade_qos_mqc', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.system_qos.qos', u'service_policy'), ('pybind.nos.v6_0_2f.system_qos.qos', u'service_policy'), ('pybind.slxos.v17r_1_01a.system_qos.qos', u'service_policy'), ('pybind.slxos.v17r_2_00.system_qos.qos', u'service_policy'), ('pybind.nos.v7_2_0.system_qos.qos', u'service_policy')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'direction, policy_map_name'}, {'leafval': 'direction, policy_map_name'}, {'leafval': 'direction, policy_map_name'}, {'leafval': 'direction, policy_map_name'}, {'leafval': 'direction, policy_map_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_ras_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_ras', 'pybind.slxos.v17r_1_01a.brocade_ras', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.system_ras', 'pybind.slxos.v17r_2_00.brocade_ras', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.system_ras', u'switch_attributes'), ('pybind.slxos.v17r_2_00.system_ras', u'switch_attributes')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'chassis_name, host_name'}, {'leafval': 'chassis_name, host_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_tunnel_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.tunnel_settings.system.tunnel', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.tunnel_settings.system.tunnel', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.tunnel_settings.system.tunnel', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tunnel_settings.system.tunnel', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tunnel_settings.system.tunnel', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.tunnel_settings.system.tunnel', u'replicator'), ('pybind.nos.v7_2_0.tunnel_settings.system.tunnel', u'replicator'), ('pybind.slxos.v17r_1_01a.tunnel_settings.system.tunnel', u'replicator'), ('pybind.slxos.v17r_2_00.tunnel_settings.system.tunnel', u'replicator')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'load_balance'}, {'leafval': 'load_balance'}, {'leafval': 'load_balance'}, {'leafval': 'load_balance'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_tunnel_replicator_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.tunnel_settings.system.tunnel.replicator', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.tunnel_settings.system.tunnel.replicator', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tunnel_settings.system.tunnel.replicator', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tunnel_settings.system.tunnel.replicator', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_tunnel_replicator_load_balance_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.tunnel_settings.system.tunnel.replicator', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.tunnel_settings.system.tunnel.replicator', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tunnel_settings.system.tunnel.replicator', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tunnel_settings.system.tunnel.replicator', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_tunnel_settings_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.tunnel_settings.system', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.tunnel_settings.system', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17s_1_02.tunnel_settings.system', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.tunnel_settings.system', u'tunnel'), ('pybind.nos.v7_2_0.tunnel_settings.system.tunnel', u'replicator'), ('pybind.slxos.v17s_1_02.tunnel_settings.system.tunnel', u'replicator'), ('pybind.slxos.v17s_1_02.tunnel_settings.system', u'tunnel'), ('pybind.nos.v6_0_2f.tunnel_settings.system', u'tunnel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'suppress_debounce'}, {'leafval': 'load_balance'}, {'leafval': 'load_balance'}, {'leafval': 'suppress_debounce'}, {'leafval': 'suppress_debounce'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_tunnel_settings_system_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tunnel_settings.system', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tunnel_settings.system', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.tunnel_settings.system.tunnel', u'replicator'), ('pybind.slxos.v17r_1_01a.tunnel_settings.system', u'tunnel'), ('pybind.slxos.v17r_2_00.tunnel_settings.system.tunnel', u'replicator'), ('pybind.slxos.v17r_2_00.tunnel_settings.system', u'tunnel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'load_balance'}, {'leafval': 'suppress_debounce'}, {'leafval': 'load_balance'}, {'leafval': 'suppress_debounce'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_tunnel_suppress_debounce_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.tunnel_settings.system.tunnel', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.tunnel_settings.system.tunnel', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.tunnel_settings.system.tunnel', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tunnel_settings.system.tunnel', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tunnel_settings.system.tunnel', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.tunnel_settings.system.tunnel', u'replicator'), ('pybind.nos.v7_2_0.tunnel_settings.system.tunnel', u'replicator'), ('pybind.slxos.v17r_1_01a.tunnel_settings.system.tunnel', u'replicator'), ('pybind.slxos.v17r_2_00.tunnel_settings.system.tunnel', u'replicator')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'load_balance'}, {'leafval': 'load_balance'}, {'leafval': 'load_balance'}, {'leafval': 'load_balance'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_buffers_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_cached_memory_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_hw_interrupt_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_idle_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_iowait_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_kernel_free_memory_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_niced_process_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_profile_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_steal_time_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_sw_interrupt_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_system_process_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_total_free_memory_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_total_free_swap_memory_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_total_swap_memory_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_total_system_memory_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_total_used_memory_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_total_used_swap_memory_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_uptime_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_user_free_memory_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def system_utilization_state_user_process_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.system_utilization_state', 'pybind.slxos.v17r_1_01a.brocade_systemutilization_operational', 'pybind.slxos.v17r_1_01a')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tacacs_server_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.tacacs_server', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.tacacs_server', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.tacacs_server', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tacacs_server', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tacacs_server', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.tacacs_server', u'host'), ('pybind.nos.v7_2_0.tacacs_server', u'host'), ('pybind.slxos.v17r_2_00.tacacs_server', u'host'), ('pybind.nos.v6_0_2f.tacacs_server', u'host'), ('pybind.slxos.v17s_1_02.tacacs_server', u'host')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hostname, use_vrf'}, {'leafval': 'hostname, use_vrf, port, protocol, key, encryption_level, retries, timeout'}, {'leafval': 'hostname, use_vrf'}, {'leafval': 'hostname, port, protocol, key, encryption_level, retries, timeout'}, {'leafval': 'hostname, use_vrf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tacacs_server_host_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this TACACS+ server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.tacacs_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.tacacs_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.tacacs_server.host', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tacacs_server.host', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tacacs_server.host', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.tacacs_server.host', u'tacacs_server_options'), ('pybind.slxos.v17r_2_00.tacacs_server.host', u'tacacs_server_options'), ('pybind.slxos.v17s_1_02.tacacs_server.host', u'tacacs_server_options')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'port, protocol, key, encryption_level, retries, timeout'}, {'leafval': 'port, protocol, key, encryption_level, retries, timeout'}, {'leafval': 'port, protocol, key, encryption_level, retries, timeout'}]
    leafval_map = {"pybind.slxos.v17r_1_01a.tacacs_server.host": {}, "pybind.nos.v6_0_2f.tacacs_server.host": {"encryption_level": "encryption_level", "retries": "retries", "protocol": "protocol", "timeout": "timeout", "hostname": "hostname", "key": "key", "port": "port"}, "pybind.slxos.v17s_1_02.tacacs_server.host": {}, "pybind.nos.v7_2_0.tacacs_server.host": {}, "pybind.slxos.v17r_2_00.tacacs_server.host": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tacacs_server_host_encryption_level_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this TACACS+ server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.tacacs_server.host', u'host'), ('pybind.slxos.v17r_1_01a.tacacs_server.host', u'host'), ('pybind.slxos.v17r_2_00.tacacs_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.tacacs_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.tacacs_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v6_0_2f.tacacs_server.host": {"encryption_level": "encryption_level", "hostname": "hostname"}, "pybind.slxos.v17s_1_02.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v7_2_0.tacacs_server.host": {}, "pybind.slxos.v17r_2_00.tacacs_server.host.tacacs_server_options": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tacacs_server_host_key_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this TACACS+ server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.tacacs_server.host', u'host'), ('pybind.slxos.v17r_1_01a.tacacs_server.host', u'host'), ('pybind.slxos.v17r_2_00.tacacs_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.tacacs_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.tacacs_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v6_0_2f.tacacs_server.host": {"hostname": "hostname", "key": "key"}, "pybind.slxos.v17s_1_02.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v7_2_0.tacacs_server.host": {}, "pybind.slxos.v17r_2_00.tacacs_server.host.tacacs_server_options": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tacacs_server_host_port_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this TACACS+ server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.tacacs_server.host', u'host'), ('pybind.slxos.v17r_1_01a.tacacs_server.host', u'host'), ('pybind.slxos.v17r_2_00.tacacs_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.tacacs_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.tacacs_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v6_0_2f.tacacs_server.host": {"hostname": "hostname", "port": "port"}, "pybind.slxos.v17s_1_02.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v7_2_0.tacacs_server.host": {}, "pybind.slxos.v17r_2_00.tacacs_server.host.tacacs_server_options": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tacacs_server_host_protocol_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this TACACS+ server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.tacacs_server.host', u'host'), ('pybind.slxos.v17r_1_01a.tacacs_server.host', u'host'), ('pybind.slxos.v17r_2_00.tacacs_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.tacacs_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.tacacs_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v6_0_2f.tacacs_server.host": {"hostname": "hostname", "protocol": "protocol"}, "pybind.slxos.v17s_1_02.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v7_2_0.tacacs_server.host": {}, "pybind.slxos.v17r_2_00.tacacs_server.host.tacacs_server_options": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tacacs_server_host_retries_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this TACACS+ server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.tacacs_server.host', u'host'), ('pybind.slxos.v17r_1_01a.tacacs_server.host', u'host'), ('pybind.slxos.v17r_2_00.tacacs_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.tacacs_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.tacacs_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v6_0_2f.tacacs_server.host": {"retries": "retries", "hostname": "hostname"}, "pybind.slxos.v17s_1_02.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v7_2_0.tacacs_server.host": {}, "pybind.slxos.v17r_2_00.tacacs_server.host.tacacs_server_options": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tacacs_server_host_timeout_get(self, host=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type host: hostname
    :param host: Keyword argument tuple.

    :type hostname: unicode
    :param hostname: **host** tuple argument:  INETADDRESS   Domain name or IP Address of this TACACS+ server

        * length restriction: ::

            ['0..max']

        * pattern restriction: ::

            '\p{IsBasicLatin}{0,255}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.tacacs_server.host', u'host'), ('pybind.slxos.v17r_1_01a.tacacs_server.host', u'host'), ('pybind.slxos.v17r_2_00.tacacs_server.host', u'host')]
    bindings_list = [('pybind.nos.v6_0_2f.tacacs_server.host', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.tacacs_server.host', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tacacs_server.host.tacacs_server_options', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}, {'keyval': 'hostname, use_vrf', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'host', 'keyval': 'hostname, use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v6_0_2f.tacacs_server.host": {"hostname": "hostname", "timeout": "timeout"}, "pybind.slxos.v17s_1_02.tacacs_server.host.tacacs_server_options": {}, "pybind.nos.v7_2_0.tacacs_server.host": {}, "pybind.slxos.v17r_2_00.tacacs_server.host.tacacs_server_options": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, host=host)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, host=host)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tacacs_server_source_ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.tacacs_server', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.tacacs_server', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.tacacs_server', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tacacs_server', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tacacs_server', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.tacacs_server', u'host'), ('pybind.nos.v7_2_0.tacacs_server', u'host'), ('pybind.slxos.v17r_2_00.tacacs_server', u'host'), ('pybind.nos.v6_0_2f.tacacs_server', u'host'), ('pybind.slxos.v17s_1_02.tacacs_server', u'host')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'hostname, use_vrf'}, {'leafval': 'hostname, use_vrf, port, protocol, key, encryption_level, retries, timeout'}, {'leafval': 'hostname, use_vrf'}, {'leafval': 'hostname, port, protocol, key, encryption_level, retries, timeout'}, {'leafval': 'hostname, use_vrf'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry', u'server'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'interface'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'tm_voq'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'system_utilization'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'enhanced_voq_max_queue_depth'), ('pybind.slxos.v17r_2_00.telemetry', u'collector'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'mpls_traffic_fec'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'mpls_traffic_lsp'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'mpls_traffic_bypass'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'enhanced_voq_discard_pkts'), ('pybind.slxos.v17r_1_01a.telemetry', u'server'), ('pybind.slxos.v17r_1_01a.telemetry.profile', u'system_utilization'), ('pybind.slxos.v17r_1_01a.telemetry.profile', u'interface'), ('pybind.slxos.v17r_1_01a.telemetry', u'collector'), ('pybind.slxos.v17s_1_02.telemetry', u'collector'), ('pybind.slxos.v17s_1_02.telemetry.profile', u'system_utilization'), ('pybind.slxos.v17s_1_02.telemetry', u'server'), ('pybind.slxos.v17s_1_02.telemetry.profile', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_vrf, transport, port, activate'}, {'leafval': 'name, interval'}, {'leafval': 'name, interval'}, {'leafval': 'name, interval'}, {'leafval': 'name, interval, interface_range'}, {'leafval': 'collector_name, collector_encoding, collector_activate'}, {'leafval': 'name, interval'}, {'leafval': 'name, interval'}, {'leafval': 'name, interval'}, {'leafval': 'name, interval, interface_range'}, {'leafval': 'use_vrf, transport, port, activate'}, {'leafval': 'name, interval'}, {'leafval': 'name, interval'}, {'leafval': 'collector_name, collector_activate'}, {'leafval': 'collector_name, collector_activate, collector_encoding'}, {'leafval': 'name, interval'}, {'leafval': 'use_vrf, transport, port, activate'}, {'leafval': 'name, interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_collector_get(self, collector=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type collector: collector_name
    :param collector: Keyword argument tuple.

    :type collector_name: unicode
    :param collector_name: **collector** tuple argument:  Telemetry Collector Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.collector', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.collector', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.collector', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.telemetry.collector', u'collector_profile'), ('pybind.slxos.v17s_1_02.telemetry.collector', u'collector_ip'), ('pybind.slxos.v17r_2_00.telemetry.collector', u'collector_profile'), ('pybind.slxos.v17r_2_00.telemetry.collector', u'collector_ip'), ('pybind.slxos.v17r_1_01a.telemetry.collector', u'collector_ip'), ('pybind.slxos.v17r_1_01a.telemetry.collector', u'collector_profile')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'collector', 'keyval': 'collector_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'collector_profiletype, collector_profilename'}, {'leafval': 'collector_ip_address, collector_port'}, {'leafval': 'collector_profiletype, collector_profilename'}, {'leafval': 'collector_ip_address, collector_port'}, {'leafval': 'collector_ip_address, collector_port'}, {'leafval': 'collector_profiletype, collector_profilename'}]
    leafval_map = {"pybind.slxos.v17s_1_02.telemetry.collector": {}, "pybind.slxos.v17r_2_00.telemetry.collector": {}, "pybind.slxos.v17r_1_01a.telemetry.collector": {"collector_activate": "collector_activate", "collector_name": "collector_name"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, collector=collector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, collector=collector)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_collector_activate_get(self, collector=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type collector: collector_name
    :param collector: Keyword argument tuple.

    :type collector_name: unicode
    :param collector_name: **collector** tuple argument:  Telemetry Collector Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.collector', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.collector', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.collector', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry.collector', u'collector_profile'), ('pybind.slxos.v17r_2_00.telemetry.collector', u'collector_ip'), ('pybind.slxos.v17s_1_02.telemetry.collector', u'collector_profile'), ('pybind.slxos.v17s_1_02.telemetry.collector', u'collector_ip'), ('pybind.slxos.v17r_1_01a.telemetry.collector', u'collector_ip'), ('pybind.slxos.v17r_1_01a.telemetry.collector', u'collector_profile')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'collector', 'keyval': 'collector_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'collector_profiletype, collector_profilename'}, {'leafval': 'collector_ip_address, collector_port'}, {'leafval': 'collector_profiletype, collector_profilename'}, {'leafval': 'collector_ip_address, collector_port'}, {'leafval': 'collector_ip_address, collector_port'}, {'leafval': 'collector_profiletype, collector_profilename'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, collector=collector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, collector=collector)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_collector_encoding_get(self, collector=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type collector: collector_name
    :param collector: Keyword argument tuple.

    :type collector_name: unicode
    :param collector_name: **collector** tuple argument:  Telemetry Collector Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.collector', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.collector', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry.collector', u'collector_profile'), ('pybind.slxos.v17r_2_00.telemetry.collector', u'collector_ip'), ('pybind.slxos.v17s_1_02.telemetry.collector', u'collector_profile'), ('pybind.slxos.v17s_1_02.telemetry.collector', u'collector_ip')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'collector', 'keyval': 'collector_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'collector_profiletype, collector_profilename'}, {'leafval': 'collector_ip_address, collector_port'}, {'leafval': 'collector_profiletype, collector_profilename'}, {'leafval': 'collector_ip_address, collector_port'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, collector=collector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, collector=collector)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_collector_ip_get(self, collector=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type collector: collector_name
    :param collector: Keyword argument tuple.

    :type collector_name: unicode
    :param collector_name: **collector** tuple argument:  Telemetry Collector Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.telemetry.collector', u'collector'), ('pybind.slxos.v17s_1_02.telemetry.collector', u'collector'), ('pybind.slxos.v17r_2_00.telemetry.collector', u'collector')]
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.collector.collector_ip', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.collector.collector_ip', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.collector.collector_ip', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'collector_name', 'extra_keyval': ''}, {'keyval': 'collector_name', 'extra_keyval': ''}, {'keyval': 'collector_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, collector=collector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, collector=collector)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_collector_ip_collector_ip_address_get(self, collector=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type collector: collector_name
    :param collector: Keyword argument tuple.

    :type collector_name: unicode
    :param collector_name: **collector** tuple argument:  Telemetry Collector Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.telemetry.collector', u'collector'), ('pybind.slxos.v17s_1_02.telemetry.collector', u'collector'), ('pybind.slxos.v17r_2_00.telemetry.collector', u'collector')]
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.collector.collector_ip', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.collector.collector_ip', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.collector.collector_ip', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'collector_name', 'extra_keyval': ''}, {'keyval': 'collector_name', 'extra_keyval': ''}, {'keyval': 'collector_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, collector=collector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, collector=collector)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_collector_ip_port_get(self, collector=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type collector: collector_name
    :param collector: Keyword argument tuple.

    :type collector_name: unicode
    :param collector_name: **collector** tuple argument:  Telemetry Collector Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.telemetry.collector', u'collector'), ('pybind.slxos.v17s_1_02.telemetry.collector', u'collector'), ('pybind.slxos.v17r_2_00.telemetry.collector', u'collector')]
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.collector.collector_ip', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.collector.collector_ip', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.collector.collector_ip', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'collector_name', 'extra_keyval': ''}, {'keyval': 'collector_name', 'extra_keyval': ''}, {'keyval': 'collector_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, collector=collector)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, collector=collector)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_collector_profile_get(self, collector=None, collector_profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type collector: collector_name
    :param collector: Keyword argument tuple.

    :type collector_name: unicode
    :param collector_name: **collector** tuple argument:  Telemetry Collector Name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    **Instance Keyword Argument Tuple**:

    :type collector_profile: collector_profiletype, collector_profilename
    :param collector_profile: Keyword argument tuple.

    :type collector_profiletype: unicode
    :param collector_profiletype: **collector_profile** tuple argument:  Collector profile type

        * enumeration restriction: ::

            ['interface-profile', 'system-profile']

    :type collector_profilename: unicode
    :param collector_profilename: **collector_profile** tuple argument:  Name of Telemetry profile to be added to the collector

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_system_utilization_statistics|default_in'
            'terface_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.telemetry.collector', u'collector'), ('pybind.slxos.v17r_2_00.telemetry.collector', u'collector'), ('pybind.slxos.v17r_1_01a.telemetry.collector', u'collector')]
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.collector.collector_profile', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.collector.collector_profile', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.collector.collector_profile', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'collector_name', 'extra_keyval': ''}, {'keyval': 'collector_name', 'extra_keyval': ''}, {'keyval': 'collector_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'collector_profile', 'keyval': 'collector_profiletype, collector_profilename', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, collector=collector, collector_profile=collector_profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, collector=collector, collector_profile=collector_profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.profile', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.profile', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.profile', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.telemetry.profile', u'system_utilization'), ('pybind.slxos.v17s_1_02.telemetry.profile', u'interface'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'interface'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'tm_voq'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'system_utilization'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'enhanced_voq_max_queue_depth'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'mpls_traffic_fec'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'mpls_traffic_lsp'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'mpls_traffic_bypass'), ('pybind.slxos.v17r_2_00.telemetry.profile', u'enhanced_voq_discard_pkts'), ('pybind.slxos.v17r_1_01a.telemetry.profile', u'system_utilization'), ('pybind.slxos.v17r_1_01a.telemetry.profile', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name, interval'}, {'leafval': 'name, interval'}, {'leafval': 'name, interval'}, {'leafval': 'name, interval'}, {'leafval': 'name, interval'}, {'leafval': 'name, interval, interface_range'}, {'leafval': 'name, interval'}, {'leafval': 'name, interval'}, {'leafval': 'name, interval'}, {'leafval': 'name, interval, interface_range'}, {'leafval': 'name, interval'}, {'leafval': 'name, interval'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_enhanced_voq_discard_pkts_get(self, enhanced_voq_discard_pkts=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type enhanced_voq_discard_pkts: name
    :param enhanced_voq_discard_pkts: Keyword argument tuple.

    :type name: unicode
    :param name: **enhanced_voq_discard_pkts** tuple argument:  Enhanced VOQ discard packets profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_enhanced_voq_discard_pkts_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.enhanced_voq_discard_pkts', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry.profile.enhanced_voq_discard_pkts', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'enhanced_voq_discard_pkts', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'object'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, enhanced_voq_discard_pkts=enhanced_voq_discard_pkts)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, enhanced_voq_discard_pkts=enhanced_voq_discard_pkts)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_enhanced_voq_discard_pkts_add_get(self, enhanced_voq_discard_pkts=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type enhanced_voq_discard_pkts: name
    :param enhanced_voq_discard_pkts: Keyword argument tuple.

    :type name: unicode
    :param name: **enhanced_voq_discard_pkts** tuple argument:  Enhanced VOQ discard packets profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_enhanced_voq_discard_pkts_statistics'

    **Instance Keyword Argument Tuple**:

    :type add: object
    :param add: Keyword argument tuple.

    :type object: unicode
    :param object: **add** tuple argument:  Object name

        * enumeration restriction: ::

            ['discard-pkts']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.telemetry.profile.enhanced_voq_discard_pkts', u'enhanced_voq_discard_pkts')]
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.enhanced_voq_discard_pkts.add_', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'object', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, enhanced_voq_discard_pkts=enhanced_voq_discard_pkts, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, enhanced_voq_discard_pkts=enhanced_voq_discard_pkts, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_enhanced_voq_discard_pkts_interface_range_get(self, enhanced_voq_discard_pkts=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type enhanced_voq_discard_pkts: name
    :param enhanced_voq_discard_pkts: Keyword argument tuple.

    :type name: unicode
    :param name: **enhanced_voq_discard_pkts** tuple argument:  Enhanced VOQ discard packets profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_enhanced_voq_discard_pkts_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.enhanced_voq_discard_pkts', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry.profile.enhanced_voq_discard_pkts', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'enhanced_voq_discard_pkts', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'object'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, enhanced_voq_discard_pkts=enhanced_voq_discard_pkts)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, enhanced_voq_discard_pkts=enhanced_voq_discard_pkts)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_enhanced_voq_discard_pkts_interval_get(self, enhanced_voq_discard_pkts=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type enhanced_voq_discard_pkts: name
    :param enhanced_voq_discard_pkts: Keyword argument tuple.

    :type name: unicode
    :param name: **enhanced_voq_discard_pkts** tuple argument:  Enhanced VOQ discard packets profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_enhanced_voq_discard_pkts_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.enhanced_voq_discard_pkts', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry.profile.enhanced_voq_discard_pkts', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'enhanced_voq_discard_pkts', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'object'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, enhanced_voq_discard_pkts=enhanced_voq_discard_pkts)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, enhanced_voq_discard_pkts=enhanced_voq_discard_pkts)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_enhanced_voq_max_queue_depth_get(self, enhanced_voq_max_queue_depth=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type enhanced_voq_max_queue_depth: name
    :param enhanced_voq_max_queue_depth: Keyword argument tuple.

    :type name: unicode
    :param name: **enhanced_voq_max_queue_depth** tuple argument:  Enhanced VOQ max queue depth

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_enhanced_voq_max_queue_depth_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.enhanced_voq_max_queue_depth', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry.profile.enhanced_voq_max_queue_depth', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'enhanced_voq_max_queue_depth', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'object'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, enhanced_voq_max_queue_depth=enhanced_voq_max_queue_depth)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, enhanced_voq_max_queue_depth=enhanced_voq_max_queue_depth)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_enhanced_voq_max_queue_depth_add_get(self, enhanced_voq_max_queue_depth=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type enhanced_voq_max_queue_depth: name
    :param enhanced_voq_max_queue_depth: Keyword argument tuple.

    :type name: unicode
    :param name: **enhanced_voq_max_queue_depth** tuple argument:  Enhanced VOQ max queue depth

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_enhanced_voq_max_queue_depth_statistics'

    **Instance Keyword Argument Tuple**:

    :type add: object
    :param add: Keyword argument tuple.

    :type object: unicode
    :param object: **add** tuple argument:  Object name

        * enumeration restriction: ::

            ['max-queue-depth']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.telemetry.profile.enhanced_voq_max_queue_depth', u'enhanced_voq_max_queue_depth')]
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.enhanced_voq_max_queue_depth.add_', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'object', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, enhanced_voq_max_queue_depth=enhanced_voq_max_queue_depth, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, enhanced_voq_max_queue_depth=enhanced_voq_max_queue_depth, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_enhanced_voq_max_queue_depth_interface_range_get(self, enhanced_voq_max_queue_depth=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type enhanced_voq_max_queue_depth: name
    :param enhanced_voq_max_queue_depth: Keyword argument tuple.

    :type name: unicode
    :param name: **enhanced_voq_max_queue_depth** tuple argument:  Enhanced VOQ max queue depth

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_enhanced_voq_max_queue_depth_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.enhanced_voq_max_queue_depth', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry.profile.enhanced_voq_max_queue_depth', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'enhanced_voq_max_queue_depth', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'object'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, enhanced_voq_max_queue_depth=enhanced_voq_max_queue_depth)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, enhanced_voq_max_queue_depth=enhanced_voq_max_queue_depth)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_enhanced_voq_max_queue_depth_interval_get(self, enhanced_voq_max_queue_depth=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type enhanced_voq_max_queue_depth: name
    :param enhanced_voq_max_queue_depth: Keyword argument tuple.

    :type name: unicode
    :param name: **enhanced_voq_max_queue_depth** tuple argument:  Enhanced VOQ max queue depth

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_enhanced_voq_max_queue_depth_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.enhanced_voq_max_queue_depth', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry.profile.enhanced_voq_max_queue_depth', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'enhanced_voq_max_queue_depth', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'object'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, enhanced_voq_max_queue_depth=enhanced_voq_max_queue_depth)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, enhanced_voq_max_queue_depth=enhanced_voq_max_queue_depth)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_interface_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: name
    :param interface: Keyword argument tuple.

    :type name: unicode
    :param name: **interface** tuple argument:  Interface profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_interface_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.profile.interface', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.profile.interface', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.profile.interface', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.telemetry.profile.interface', u'interface'), ('pybind.slxos.v17s_1_02.telemetry.profile.interface', u'add'), ('pybind.slxos.v17r_1_01a.telemetry.profile.interface', u'add'), ('pybind.slxos.v17r_1_01a.telemetry.profile.interface', u'interface'), ('pybind.slxos.v17r_2_00.telemetry.profile.interface', u'add'), ('pybind.slxos.v17r_2_00.telemetry.profile.interface', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_range'}, {'leafval': 'object'}, {'leafval': 'object'}, {'leafval': 'interface_range'}, {'leafval': 'object'}, {'leafval': 'interface_range'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_interface_add_get(self, interface=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interface: name
    :param interface: Keyword argument tuple.

    :type name: unicode
    :param name: **interface** tuple argument:  Interface profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_interface_statistics'

    **Instance Keyword Argument Tuple**:

    :type add: object
    :param add: Keyword argument tuple.

    :type object: unicode
    :param object: **add** tuple argument:  Object name

        * enumeration restriction: ::

            ['in-unicast-pkts',
            'out-octets',
            'out-broadcast-pkts',
            'out-pkts-per-second',
            'in-multicast-pkts',
            'out-unicast-pkts',
            'in-errors',
            'out-pkts',
            'in-discards',
            'out-multicast-pkts',
            'in-bandwidth',
            'in-pkts-per-second',
            'out-crc-errors',
            'out-bandwidth',
            'in-pkts',
            'out-discards',
            'in-broadcast-pkts',
            'in-octets',
            'out-errors',
            'in-crc-errors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.telemetry.profile.interface', u'interface'), ('pybind.slxos.v17r_1_01a.telemetry.profile.interface', u'interface'), ('pybind.slxos.v17s_1_02.telemetry.profile.interface', u'interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.profile.interface.add_', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.profile.interface.add_', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.profile.interface.add_', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'object', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_interface_interface_get(self, interface=None, interface_=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type interface: name
    :param interface: Keyword argument tuple.

    :type name: unicode
    :param name: **interface** tuple argument:  Interface profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_interface_statistics'

    **Instance Keyword Argument Tuple**:

    :type interface_: interface_range
    :param interface_: Keyword argument tuple.

    :type interface_range: unicode
    :param interface_range: **interface_** tuple argument:  Interface range

        * length restriction: ::

            ['1..1000']

        * pattern restriction: ::

            '(((([0-9]|1[0-6])/([1-9]|[1-9][0-9]|[1-9][0-9][0'
            '-9])(-([1-9]|[1-9][0-9]|[1-9][0-9][0-9]))?)|(([0'
            '-9]|1[0-6])/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]):['
            '1-4](-[1-4])?))((,([0-9]|1[0-6])/([1-9]|[1-9][0-'
            '9]|[1-9][0-9][0-9])(-([1-9]|[1-9][0-9]|[1-9][0-9'
            '][0-9]))?)(,([0-9]|1[0-6])/([1-9]|[1-9][0-9]|[1-'
            '9][0-9][0-9]):[1-4](-[1-4])?)?)*((,([0-9]|1[0-6]'
            ')/([1-9]|[1-9][0-9]|[1-9][0-9][0-9]):[1-4](-[1-4'
            '])?)(,([0-9]|1[0-6])/([1-9]|[1-9][0-9]|[1-9][0-9'
            '][0-9])(-([1-9]|[1-9][0-9]|[1-9][0-9][0-9]))?)?)'
            '*)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.telemetry.profile.interface', u'interface'), ('pybind.slxos.v17r_1_01a.telemetry.profile.interface', u'interface'), ('pybind.slxos.v17s_1_02.telemetry.profile.interface', u'interface')]
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.profile.interface.interface', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.profile.interface.interface', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.profile.interface.interface', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface_', 'keyval': 'interface_range', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface, interface_=interface_)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface, interface_=interface_)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_interface_interval_get(self, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type interface: name
    :param interface: Keyword argument tuple.

    :type name: unicode
    :param name: **interface** tuple argument:  Interface profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_interface_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.profile.interface', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.profile.interface', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.profile.interface', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.telemetry.profile.interface', u'interface'), ('pybind.slxos.v17s_1_02.telemetry.profile.interface', u'add'), ('pybind.slxos.v17r_1_01a.telemetry.profile.interface', u'add'), ('pybind.slxos.v17r_1_01a.telemetry.profile.interface', u'interface'), ('pybind.slxos.v17r_2_00.telemetry.profile.interface', u'add'), ('pybind.slxos.v17r_2_00.telemetry.profile.interface', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_range'}, {'leafval': 'object'}, {'leafval': 'object'}, {'leafval': 'interface_range'}, {'leafval': 'object'}, {'leafval': 'interface_range'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_mpls_traffic_bypass_get(self, mpls_traffic_bypass=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mpls_traffic_bypass: name
    :param mpls_traffic_bypass: Keyword argument tuple.

    :type name: unicode
    :param name: **mpls_traffic_bypass** tuple argument:  MPLS profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_mpls_traffic_bypass_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_bypass', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_bypass', u'mpls_traffic_bypasses'), ('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_bypass', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mpls_traffic_bypass', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mpls_traffic_bypass_name'}, {'leafval': 'object'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_traffic_bypass=mpls_traffic_bypass)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_traffic_bypass=mpls_traffic_bypass)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_mpls_traffic_bypass_add_get(self, mpls_traffic_bypass=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_traffic_bypass: name
    :param mpls_traffic_bypass: Keyword argument tuple.

    :type name: unicode
    :param name: **mpls_traffic_bypass** tuple argument:  MPLS profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_mpls_traffic_bypass_statistics'

    **Instance Keyword Argument Tuple**:

    :type add: object
    :param add: Keyword argument tuple.

    :type object: unicode
    :param object: **add** tuple argument:  Object name

        * enumeration restriction: ::

            ['out-bytes', 'out-packets']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_bypass', u'mpls_traffic_bypass')]
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_bypass.add_', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'object', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_traffic_bypass=mpls_traffic_bypass, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_traffic_bypass=mpls_traffic_bypass, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_mpls_traffic_bypass_bypass_lsp_get(self, mpls_traffic_bypass=None, mpls_traffic_bypasses=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_traffic_bypass: name
    :param mpls_traffic_bypass: Keyword argument tuple.

    :type name: unicode
    :param name: **mpls_traffic_bypass** tuple argument:  MPLS profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_mpls_traffic_bypass_statistics'

    **Instance Keyword Argument Tuple**:

    :type mpls_traffic_bypasses: mpls_traffic_bypass_name
    :param mpls_traffic_bypasses: Keyword argument tuple.

    :type mpls_traffic_bypass_name: unicode
    :param mpls_traffic_bypass_name: **mpls_traffic_bypasses** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_bypass', u'mpls_traffic_bypass')]
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_bypass.mpls_traffic_bypasses', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_traffic_bypasses', 'keyval': 'mpls_traffic_bypass_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_traffic_bypass=mpls_traffic_bypass, mpls_traffic_bypasses=mpls_traffic_bypasses)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_traffic_bypass=mpls_traffic_bypass, mpls_traffic_bypasses=mpls_traffic_bypasses)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_mpls_traffic_bypass_interval_get(self, mpls_traffic_bypass=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mpls_traffic_bypass: name
    :param mpls_traffic_bypass: Keyword argument tuple.

    :type name: unicode
    :param name: **mpls_traffic_bypass** tuple argument:  MPLS profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_mpls_traffic_bypass_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_bypass', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_bypass', u'mpls_traffic_bypasses'), ('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_bypass', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mpls_traffic_bypass', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mpls_traffic_bypass_name'}, {'leafval': 'object'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_traffic_bypass=mpls_traffic_bypass)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_traffic_bypass=mpls_traffic_bypass)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_mpls_traffic_fec_get(self, mpls_traffic_fec=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mpls_traffic_fec: name
    :param mpls_traffic_fec: Keyword argument tuple.

    :type name: unicode
    :param name: **mpls_traffic_fec** tuple argument:  MPLS profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_mpls_traffic_fec_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_fec', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_fec', u'mpls_traffic_fecs'), ('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_fec', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mpls_traffic_fec', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mpls_traffic_fec_address'}, {'leafval': 'object'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_traffic_fec=mpls_traffic_fec)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_traffic_fec=mpls_traffic_fec)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_mpls_traffic_fec_add_get(self, mpls_traffic_fec=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_traffic_fec: name
    :param mpls_traffic_fec: Keyword argument tuple.

    :type name: unicode
    :param name: **mpls_traffic_fec** tuple argument:  MPLS profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_mpls_traffic_fec_statistics'

    **Instance Keyword Argument Tuple**:

    :type add: object
    :param add: Keyword argument tuple.

    :type object: unicode
    :param object: **add** tuple argument:  Object name

        * enumeration restriction: ::

            ['out-bytes', 'out-packets']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_fec', u'mpls_traffic_fec')]
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_fec.add_', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'object', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_traffic_fec=mpls_traffic_fec, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_traffic_fec=mpls_traffic_fec, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_mpls_traffic_fec_fec_get(self, mpls_traffic_fec=None, mpls_traffic_fecs=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_traffic_fec: name
    :param mpls_traffic_fec: Keyword argument tuple.

    :type name: unicode
    :param name: **mpls_traffic_fec** tuple argument:  MPLS profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_mpls_traffic_fec_statistics'

    **Instance Keyword Argument Tuple**:

    :type mpls_traffic_fecs: mpls_traffic_fec_address
    :param mpls_traffic_fecs: Keyword argument tuple.

    :type mpls_traffic_fec_address: unicode
    :param mpls_traffic_fec_address: **mpls_traffic_fecs** tuple argument.

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_fec', u'mpls_traffic_fec')]
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_fec.mpls_traffic_fecs', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_traffic_fecs', 'keyval': 'mpls_traffic_fec_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_traffic_fec=mpls_traffic_fec, mpls_traffic_fecs=mpls_traffic_fecs)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_traffic_fec=mpls_traffic_fec, mpls_traffic_fecs=mpls_traffic_fecs)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_mpls_traffic_fec_interval_get(self, mpls_traffic_fec=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mpls_traffic_fec: name
    :param mpls_traffic_fec: Keyword argument tuple.

    :type name: unicode
    :param name: **mpls_traffic_fec** tuple argument:  MPLS profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_mpls_traffic_fec_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_fec', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_fec', u'mpls_traffic_fecs'), ('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_fec', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mpls_traffic_fec', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mpls_traffic_fec_address'}, {'leafval': 'object'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_traffic_fec=mpls_traffic_fec)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_traffic_fec=mpls_traffic_fec)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_mpls_traffic_lsp_get(self, mpls_traffic_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mpls_traffic_lsp: name
    :param mpls_traffic_lsp: Keyword argument tuple.

    :type name: unicode
    :param name: **mpls_traffic_lsp** tuple argument:  MPLS profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_mpls_traffic_lsp_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_lsp', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_lsp', u'mpls_traffic_lsps'), ('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_lsp', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mpls_traffic_lsp', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mpls_traffic_lsp_name'}, {'leafval': 'object'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_traffic_lsp=mpls_traffic_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_traffic_lsp=mpls_traffic_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_mpls_traffic_lsp_add_get(self, mpls_traffic_lsp=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_traffic_lsp: name
    :param mpls_traffic_lsp: Keyword argument tuple.

    :type name: unicode
    :param name: **mpls_traffic_lsp** tuple argument:  MPLS profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_mpls_traffic_lsp_statistics'

    **Instance Keyword Argument Tuple**:

    :type add: object
    :param add: Keyword argument tuple.

    :type object: unicode
    :param object: **add** tuple argument:  Object name

        * enumeration restriction: ::

            ['out-bytes', 'out-packets']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_lsp', u'mpls_traffic_lsp')]
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_lsp.add_', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'object', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_traffic_lsp=mpls_traffic_lsp, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_traffic_lsp=mpls_traffic_lsp, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_mpls_traffic_lsp_interval_get(self, mpls_traffic_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type mpls_traffic_lsp: name
    :param mpls_traffic_lsp: Keyword argument tuple.

    :type name: unicode
    :param name: **mpls_traffic_lsp** tuple argument:  MPLS profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_mpls_traffic_lsp_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_lsp', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_lsp', u'mpls_traffic_lsps'), ('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_lsp', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'mpls_traffic_lsp', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'mpls_traffic_lsp_name'}, {'leafval': 'object'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_traffic_lsp=mpls_traffic_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_traffic_lsp=mpls_traffic_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_mpls_traffic_lsp_lsp_get(self, mpls_traffic_lsp=None, mpls_traffic_lsps=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type mpls_traffic_lsp: name
    :param mpls_traffic_lsp: Keyword argument tuple.

    :type name: unicode
    :param name: **mpls_traffic_lsp** tuple argument:  MPLS profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_mpls_traffic_lsp_statistics'

    **Instance Keyword Argument Tuple**:

    :type mpls_traffic_lsps: mpls_traffic_lsp_name
    :param mpls_traffic_lsps: Keyword argument tuple.

    :type mpls_traffic_lsp_name: unicode
    :param mpls_traffic_lsp_name: **mpls_traffic_lsps** tuple argument.

        * length restriction: ::

            ['1..64']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_lsp', u'mpls_traffic_lsp')]
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.mpls_traffic_lsp.mpls_traffic_lsps', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'mpls_traffic_lsps', 'keyval': 'mpls_traffic_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, mpls_traffic_lsp=mpls_traffic_lsp, mpls_traffic_lsps=mpls_traffic_lsps)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, mpls_traffic_lsp=mpls_traffic_lsp, mpls_traffic_lsps=mpls_traffic_lsps)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_system_utilization_get(self, system_utilization=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type system_utilization: name
    :param system_utilization: Keyword argument tuple.

    :type name: unicode
    :param name: **system_utilization** tuple argument:  System profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_system_utilization_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.profile.system_utilization', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.profile.system_utilization', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.profile.system_utilization', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.telemetry.profile.system_utilization', u'add'), ('pybind.slxos.v17r_2_00.telemetry.profile.system_utilization', u'add'), ('pybind.slxos.v17s_1_02.telemetry.profile.system_utilization', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'system_utilization', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'object'}, {'leafval': 'object'}, {'leafval': 'object'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, system_utilization=system_utilization)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, system_utilization=system_utilization)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_system_utilization_add_get(self, system_utilization=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type system_utilization: name
    :param system_utilization: Keyword argument tuple.

    :type name: unicode
    :param name: **system_utilization** tuple argument:  System profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_system_utilization_statistics'

    **Instance Keyword Argument Tuple**:

    :type add: object
    :param add: Keyword argument tuple.

    :type object: unicode
    :param object: **add** tuple argument:  Object name

        * enumeration restriction: ::

            ['user-free-memory',
            'total-used-memory',
            'uptime',
            'niced-process',
            'total-system-memory',
            'iowait',
            'total-swap-memory',
            'system-process',
            'idle-state',
            'user-process',
            'kernel-free-memory',
            'buffers',
            'total-used-swap-memory',
            'cached-memory',
            'steal-time',
            'sw-interrupt',
            'hw-interrupt',
            'total-free-memory',
            'total-free-swap-memory']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.telemetry.profile.system_utilization', u'system_utilization'), ('pybind.slxos.v17r_1_01a.telemetry.profile.system_utilization', u'system_utilization'), ('pybind.slxos.v17r_2_00.telemetry.profile.system_utilization', u'system_utilization')]
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.profile.system_utilization.add_', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.profile.system_utilization.add_', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.profile.system_utilization.add_', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'object', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, system_utilization=system_utilization, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, system_utilization=system_utilization, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_system_utilization_interval_get(self, system_utilization=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type system_utilization: name
    :param system_utilization: Keyword argument tuple.

    :type name: unicode
    :param name: **system_utilization** tuple argument:  System profile name

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_system_utilization_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.profile.system_utilization', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.profile.system_utilization', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.profile.system_utilization', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.telemetry.profile.system_utilization', u'add'), ('pybind.slxos.v17r_2_00.telemetry.profile.system_utilization', u'add'), ('pybind.slxos.v17s_1_02.telemetry.profile.system_utilization', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'system_utilization', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'object'}, {'leafval': 'object'}, {'leafval': 'object'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, system_utilization=system_utilization)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, system_utilization=system_utilization)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_tm_voq_get(self, tm_voq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tm_voq: name
    :param tm_voq: Keyword argument tuple.

    :type name: unicode
    :param name: **tm_voq** tuple argument:  TM VOQ

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_tm_voq_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.tm_voq', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry.profile.tm_voq', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_voq', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'object'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_voq=tm_voq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_voq=tm_voq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_tm_voq_add_get(self, tm_voq=None, add=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tm_voq: name
    :param tm_voq: Keyword argument tuple.

    :type name: unicode
    :param name: **tm_voq** tuple argument:  TM VOQ

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_tm_voq_statistics'

    **Instance Keyword Argument Tuple**:

    :type add: object
    :param add: Keyword argument tuple.

    :type object: unicode
    :param object: **add** tuple argument:  Object name

        * enumeration restriction: ::

            ['discard-pkt-count',
            'discard-byte-count',
            'current-queue-size',
            'max-queue-depth-size',
            'enq-pkt-count',
            'enq-byte-count']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.telemetry.profile.tm_voq', u'tm_voq')]
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.tm_voq.add_', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'add', 'keyval': 'object', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_voq=tm_voq, add=add)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_voq=tm_voq, add=add)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_profile_tm_voq_interval_get(self, tm_voq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tm_voq: name
    :param tm_voq: Keyword argument tuple.

    :type name: unicode
    :param name: **tm_voq** tuple argument:  TM VOQ

        * length restriction: ::

            ['3..64']

        * pattern restriction: ::

            'default_tm_voq_statistics'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.telemetry.profile.tm_voq', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telemetry.profile.tm_voq', u'add')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_voq', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'object'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_voq=tm_voq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_voq=tm_voq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_server_get(self, server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type server: use_vrf
    :param server: Keyword argument tuple.

    :type use_vrf: unicode
    :param use_vrf: **server** tuple argument:  Vrf name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.server', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.server', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.server', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'server', 'keyval': 'use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server=server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server=server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_server_activate_get(self, server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type server: use_vrf
    :param server: Keyword argument tuple.

    :type use_vrf: unicode
    :param use_vrf: **server** tuple argument:  Vrf name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.server', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.server', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.server', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'server', 'keyval': 'use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server=server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server=server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_server_port_get(self, server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type server: use_vrf
    :param server: Keyword argument tuple.

    :type use_vrf: unicode
    :param use_vrf: **server** tuple argument:  Vrf name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.server', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.server', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.server', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'server', 'keyval': 'use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server=server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server=server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telemetry_server_transport_get(self, server=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type server: use_vrf
    :param server: Keyword argument tuple.

    :type use_vrf: unicode
    :param use_vrf: **server** tuple argument:  Vrf name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.telemetry.server', 'pybind.slxos.v17r_1_01a.brocade_telemetry', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telemetry.server', 'pybind.slxos.v17r_2_00.brocade_telemetry', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telemetry.server', 'pybind.slxos.v17s_1_02.brocade_telemetry', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'server', 'keyval': 'use_vrf', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, server=server)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, server=server)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telnet_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.telnet_sa.telnet', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.telnet_sa.telnet', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.telnet_sa.telnet.server', u'standby'), ('pybind.nos.v6_0_2f.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.nos.v6_0_2f.telnet_sa.telnet', u'server'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.client', u'source_interface'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.server', u'standby'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet', u'server'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet', u'server'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.server', u'standby'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.client', u'source_interface'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.client', u'source_interface'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.server', u'standby'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet', u'server'), ('pybind.nos.v7_2_0.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.telnet_sa.telnet.server', u'standby'), ('pybind.nos.v7_2_0.telnet_sa.telnet', u'server')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'enable'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'shutdown'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'enable'}, {'leafval': 'shutdown'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'shutdown'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'shutdown'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telnet_client_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.telnet_sa.telnet.client', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.client', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.client', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.telnet_sa.telnet.client', u'source_interface'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.client', u'source_interface'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.client', u'source_interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telnet_client_source_interface_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.telnet_sa.telnet.client.source_interface', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.client.source_interface', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.client.source_interface', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telnet_client_source_interface_interface_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.telnet_sa.telnet.client.source_interface', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.client.source_interface', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.client.source_interface', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telnet_client_source_interface_interface_type_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.telnet_sa.telnet.client.source_interface', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.client.source_interface', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.client.source_interface', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telnet_sa_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.telnet_sa', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.telnet_sa', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.telnet_sa', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telnet_sa', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telnet_sa', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.telnet_sa.telnet.client', u'source_interface'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.server', u'standby'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet', u'server'), ('pybind.nos.v7_2_0.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.telnet_sa.telnet.server', u'standby'), ('pybind.nos.v7_2_0.telnet_sa.telnet', u'server'), ('pybind.nos.v6_0_2f.telnet_sa.telnet.server', u'standby'), ('pybind.nos.v6_0_2f.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.nos.v6_0_2f.telnet_sa.telnet', u'server'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet', u'server'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.server', u'standby'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.client', u'source_interface'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.client', u'source_interface'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.server', u'standby'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet', u'server'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interface_type, interface_name'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'shutdown'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'shutdown'}, {'leafval': 'enable'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'shutdown'}, {'leafval': 'shutdown'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'interface_type, interface_name'}, {'leafval': 'enable'}, {'leafval': 'shutdown'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telnet_server_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.telnet_sa.telnet.server', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.telnet_sa.telnet.server', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.server', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.server', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.server', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.server', u'standby'), ('pybind.nos.v6_0_2f.telnet_sa.telnet.server', u'standby'), ('pybind.nos.v6_0_2f.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.server', u'standby'), ('pybind.nos.v7_2_0.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.telnet_sa.telnet.server', u'standby'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.server', u'standby'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telnet_server_shutdown_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.telnet_sa.telnet.server', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.telnet_sa.telnet.server', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.server', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.server', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.server', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.server', u'standby'), ('pybind.nos.v6_0_2f.telnet_sa.telnet.server', u'standby'), ('pybind.nos.v6_0_2f.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.server', u'standby'), ('pybind.nos.v7_2_0.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.telnet_sa.telnet.server', u'standby'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.server', u'standby'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'enable'}, {'leafval': 'enable'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telnet_server_standby_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.telnet_sa.telnet.server.standby', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.telnet_sa.telnet.server.standby', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.server.standby', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.server.standby', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.server.standby', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telnet_server_standby_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.telnet_sa.telnet.server.standby', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.telnet_sa.telnet.server.standby', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.server.standby', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.server.standby', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.server.standby', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telnet_server_telnet_vrf_cont_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.telnet_sa.telnet.server.telnet_vrf_cont', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.telnet_sa.telnet.server.telnet_vrf_cont', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.server.telnet_vrf_cont', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.server.telnet_vrf_cont', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.server.telnet_vrf_cont', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.nos.v6_0_2f.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf'), ('pybind.nos.v7_2_0.telnet_sa.telnet.server.telnet_vrf_cont', u'use_vrf')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}, {'leafval': 'use_vrf_name, telnet_vrf_shutdown'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telnet_server_use_vrf_get(self, use_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name, telnet_vrf_shutdown
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0 .. max']

    :type telnet_vrf_shutdown: YANGBool
    :param telnet_vrf_shutdown: **use_vrf** tuple argument:  Shutdown telnet server on given vrf

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': 'use_vrf_name, telnet_vrf_shutdown'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, use_vrf=use_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def telnet_server_use_vrf_shutdown_get(self, use_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type use_vrf: use_vrf_name
    :param use_vrf: Keyword argument tuple.

    :type use_vrf_name: unicode
    :param use_vrf_name: **use_vrf** tuple argument.

        * length restriction: ::

            ['0 .. max']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v6_0_2f.brocade_sec_services', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.nos.v7_2_0.brocade_sec_services', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.slxos.v17r_1_01a.brocade_sec_services', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.slxos.v17r_2_00.brocade_sec_services', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.telnet_sa.telnet.server.telnet_vrf_cont.use_vrf', 'pybind.slxos.v17s_1_02.brocade_sec_services', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'use_vrf', 'keyval': 'use_vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, use_vrf=use_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, use_vrf=use_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def terminal_cfg_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.terminal_cfg', 'pybind.nos.v6_0_2f.brocade_terminal', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.terminal_cfg', 'pybind.nos.v7_2_0.brocade_terminal', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.terminal_cfg', 'pybind.slxos.v17r_1_01a.brocade_terminal', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.terminal_cfg', 'pybind.slxos.v17r_2_00.brocade_terminal', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.terminal_cfg', 'pybind.slxos.v17s_1_02.brocade_terminal', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.terminal_cfg', u'line'), ('pybind.slxos.v17r_2_00.terminal_cfg', u'line'), ('pybind.slxos.v17r_1_01a.terminal_cfg', u'line'), ('pybind.nos.v7_2_0.terminal_cfg', u'line'), ('pybind.nos.v6_0_2f.terminal_cfg', u'line')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sessionid, exec_timeout'}, {'leafval': 'sessionid, exec_timeout'}, {'leafval': 'sessionid, exec_timeout'}, {'leafval': 'sessionid, exec_timeout'}, {'leafval': 'sessionid, exec_timeout'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor', u'sfp'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor', u'memory'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor', u'interface'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor', u'cpu'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor', u'security'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor', u'sfp'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor', u'buffer'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor', u'interface'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor', u'security'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor', u'memory'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor', u'cpu'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor', u'cpu'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor', u'security'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor', u'interface'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor', u'memory'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor', u'sfp'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor', u'sfp'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor', u'security'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor', u'memory'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor', u'buffer'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor', u'cpu'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor', u'interface'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor', u'security'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor', u'sfp'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor', u'cpu'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor', u'memory'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor', u'buffer'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'apply, pause'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'apply, pause'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'apply, pause'}, {'leafval': 'sec_policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'apply, pause'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'apply, pause'}, {'leafval': 'apply, pause'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'policy_name'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'sec_policy_name'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'apply, pause'}, {'leafval': 'sec_policy_name'}, {'leafval': 'apply, pause'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'policy_name'}, {'leafval': 'apply, pause'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'sec_policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'apply, pause'}, {'leafval': 'apply, pause'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'apply, pause'}, {'leafval': 'apply, pause'}, {'leafval': 'apply, pause'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'policy_name'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'sec_policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'apply, pause'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_buffer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'poll, retry, limit, actions'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_buffer_actions_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_buffer_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_buffer_poll_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_buffer_retry_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Buffer', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_cpu_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'poll, retry, limit, actions'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_cpu_actions_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_cpu_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_cpu_poll_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_cpu_retry_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Cpu', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_hidden_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor', u'sfp'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor', u'security'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor', u'memory'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor', u'buffer'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor', u'cpu'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor', u'interface'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor', u'security'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor', u'sfp'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor', u'cpu'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor', u'memory'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor', u'buffer'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor', u'interface'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor', u'sfp'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor', u'memory'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor', u'interface'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor', u'cpu'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor', u'security'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor', u'cpu'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor', u'security'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor', u'interface'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor', u'memory'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor', u'sfp'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor', u'sfp'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor', u'buffer'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor', u'interface'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor', u'security'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor', u'memory'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor', u'cpu'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security', u'policy')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'policy_name'}, {'leafval': 'sec_policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'apply, pause'}, {'leafval': 'apply, pause'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'apply, pause'}, {'leafval': 'apply, pause'}, {'leafval': 'apply, pause'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'policy_name'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'sec_policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'apply, pause'}, {'leafval': 'apply, pause'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'apply, pause'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'apply, pause'}, {'leafval': 'sec_policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'apply, pause'}, {'leafval': 'sec_policy_name'}, {'leafval': 'apply, pause'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'policy_name'}, {'leafval': 'apply, pause'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'apply, pause'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'apply, pause'}, {'leafval': 'apply, pause'}, {'leafval': 'poll, retry, limit, high_limit, low_limit, actions'}, {'leafval': 'policy_name'}, {'leafval': 'poll, retry, limit, actions'}, {'leafval': 'sec_policy_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface', u'policy')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_apply_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface', u'policy')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_pause_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface', u'policy')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_policy_get(self, policy=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy', u'area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'policy', 'keyval': 'policy_name', 'extra_keyval': 'policy_name'}
    composed_child_leafval_list = [{'leafval': 'type, area_value'}, {'leafval': 'type, area_value'}, {'leafval': 'type, area_value'}, {'leafval': 'type, area_value'}, {'leafval': 'type, area_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_policy_area_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert', u'below'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'threshold'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert', u'above'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'threshold'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert', u'below'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert', u'above'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'threshold'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert', u'above'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert', u'below'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'threshold'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert', u'above'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert', u'below'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert', u'below'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'threshold'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert', u'above')]
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'type, area_value', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'timebase_value, high_threshold, low_threshold, buffer'}, {'leafval': 'above_highthresh_action, above_lowthresh_action'}, {'leafval': 'timebase_value, high_threshold, low_threshold, buffer'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'above_highthresh_action, above_lowthresh_action'}, {'leafval': 'timebase_value, high_threshold, low_threshold, buffer'}, {'leafval': 'above_highthresh_action, above_lowthresh_action'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'timebase_value, high_threshold, low_threshold, buffer'}, {'leafval': 'above_highthresh_action, above_lowthresh_action'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'timebase_value, high_threshold, low_threshold, buffer'}, {'leafval': 'above_highthresh_action, above_lowthresh_action'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_policy_area_alert_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_policy_area_alert_above_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_policy_area_alert_above_highthresh_action_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_policy_area_alert_above_lowthresh_action_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.above', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_policy_area_alert_below_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_policy_area_alert_below_highthresh_action_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_policy_area_alert_below_lowthresh_action_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_policy_area_threshold_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'timebase_value, high_threshold, low_threshold, buffer'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_policy_area_threshold_buffer_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_policy_area_threshold_high_threshold_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_policy_area_threshold_low_threshold_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_interface_policy_area_threshold_timebase_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  Interface types that can be configured independent of speed

        * enumeration restriction: ::

            ['Ethernet']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['MissingTerminationCharacter',
            'CRCAlignErrors',
            'IFG',
            'SymbolErrors']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.interface.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_memory_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'poll, retry, limit, high_limit, low_limit, actions'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_memory_actions_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_memory_high_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_memory_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_memory_low_limit_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_memory_poll_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_memory_retry_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.Memory', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_security_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security', u'policy')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sec_policy_name'}, {'leafval': 'sec_policy_name'}, {'leafval': 'sec_policy_name'}, {'leafval': 'sec_policy_name'}, {'leafval': 'sec_policy_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_security_apply_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security', u'policy')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sec_policy_name'}, {'leafval': 'sec_policy_name'}, {'leafval': 'sec_policy_name'}, {'leafval': 'sec_policy_name'}, {'leafval': 'sec_policy_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_security_pause_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security', u'policy')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sec_policy_name'}, {'leafval': 'sec_policy_name'}, {'leafval': 'sec_policy_name'}, {'leafval': 'sec_policy_name'}, {'leafval': 'sec_policy_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_security_policy_get(self, policy=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy', u'area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'policy', 'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}
    composed_child_leafval_list = [{'leafval': 'sec_area_value, timebase'}, {'leafval': 'sec_area_value, timebase'}, {'leafval': 'sec_area_value, timebase'}, {'leafval': 'sec_area_value, timebase'}, {'leafval': 'sec_area_value, timebase'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_security_policy_area_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'threshold'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'threshold'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'threshold'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'threshold'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'threshold')]
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'sec_area_value', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_security_policy_area_alert_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_security_policy_area_alert_above_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.above', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.above', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.above', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.above', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.above', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_security_policy_area_alert_above_highthresh_action_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.above', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.above', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.above', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.above', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.above', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_security_policy_area_alert_below_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_security_policy_area_alert_below_highthresh_action_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_security_policy_area_alert_below_lowthresh_action_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_security_policy_area_threshold_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_security_policy_area_threshold_buffer_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_security_policy_area_threshold_high_threshold_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_security_policy_area_threshold_low_threshold_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_security_policy_area_timebase_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: sec_policy_name
    :param policy: Keyword argument tuple.

    :type sec_policy_name: unicode
    :param sec_policy_name: **policy** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type area: sec_area_value
    :param area: Keyword argument tuple.

    :type sec_area_value: unicode
    :param sec_area_value: **area** tuple argument:  Security Areas

        * enumeration restriction: ::

            ['telnet-violation', 'login-violation']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy', u'policy')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'threshold'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'threshold'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'threshold'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'threshold'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'below'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area.alert', u'above'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.security.policy.area', u'threshold')]
    compositions_keyval_list = [{'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}, {'keyval': 'sec_policy_name', 'extra_keyval': 'sec_policy_name'}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'sec_area_value', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_below_highthresh_action, sec_below_lowthresh_action'}, {'leafval': 'sec_above_highthresh_action'}, {'leafval': 'sec_high_threshold, sec_low_threshold, sec_buffer'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_sfp_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp', u'policy')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_sfp_apply_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp', u'policy')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_sfp_pause_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp', u'policy')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}, {'leafval': 'policy_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_sfp_policy_get(self, policy=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'area')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'policy', 'keyval': 'policy_name', 'extra_keyval': 'policy_name'}
    composed_child_leafval_list = [{'leafval': 'type, area_value'}, {'leafval': 'type, area_value'}, {'leafval': 'type, area_value'}, {'leafval': 'type, area_value'}, {'leafval': 'type, area_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    **Instance Keyword Argument Tuple**:

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert', u'above'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'threshold'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert', u'below'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert', u'below'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert', u'above'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'threshold'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert', u'above'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'threshold'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert', u'below'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert', u'below'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert', u'above'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'threshold'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert', u'below'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'threshold'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert', u'above')]
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}]
    bindings_keyval = {'kwargs_key_name': u'area', 'keyval': 'type, area_value', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'above_highthresh_action'}, {'leafval': 'high_threshold, low_threshold, buffer'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'above_highthresh_action'}, {'leafval': 'high_threshold, low_threshold, buffer'}, {'leafval': 'above_highthresh_action'}, {'leafval': 'high_threshold, low_threshold, buffer'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'above_highthresh_action'}, {'leafval': 'high_threshold, low_threshold, buffer'}, {'leafval': 'below_highthresh_action, below_lowthresh_action'}, {'leafval': 'high_threshold, low_threshold, buffer'}, {'leafval': 'above_highthresh_action'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_alert_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_alert_above_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.above', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.above', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.above', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.above', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.above', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_alert_above_highthresh_action_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.above', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.above', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.above', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.above', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.above', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_alert_below_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_alert_below_highthresh_action_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_alert_below_lowthresh_action_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.alert.below', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_threshold_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'high_threshold, low_threshold, buffer'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_threshold_buffer_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_threshold_high_threshold_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def threshold_monitor_sfp_policy_area_threshold_low_threshold_get(self, policy=None, area=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type policy: policy_name
    :param policy: Keyword argument tuple.

    :type policy_name: unicode
    :param policy_name: **policy** tuple argument.

    :type area: type, area_value
    :param area: Keyword argument tuple.

    :type type: unicode
    :param type: **area** tuple argument:  SFP types that can be configured

        * enumeration restriction: ::

            ['10GLR',
            '1GLR',
            '100GSR',
            '10GUSR',
            '1GSR',
            '10GSR',
            'QSFP']

    :type area_value: unicode
    :param area_value: **area** tuple argument.

        * enumeration restriction: ::

            ['Current',
            'RXP',
            'TXP',
            'Voltage',
            'Temperature']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy', u'policy'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area', u'area')]
    bindings_list = [('pybind.nos.v6_0_2f.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v6_0_2f.brocade_threshold_monitor', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.nos.v7_2_0.brocade_threshold_monitor', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17r_1_01a.brocade_threshold_monitor', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17r_2_00.brocade_threshold_monitor', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.threshold_monitor_hidden.threshold_monitor.sfp.policy.area.threshold', 'pybind.slxos.v17s_1_02.brocade_threshold_monitor', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}, {'keyval': 'policy_name', 'extra_keyval': 'policy_name'}, {'keyval': 'type, area_value', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, policy=policy, area=area)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, policy=policy, area=area)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.tm_state', u'tm_top_max_queue_depth_data'), ('pybind.slxos.v17s_1_02.tm_state', u'non_empty_voq'), ('pybind.slxos.v17s_1_02.tm_state', u'tmcpustatsslot'), ('pybind.slxos.v17s_1_02.tm_state', u'tm_max_buff_util_data'), ('pybind.slxos.v17s_1_02.tm_state', u'tmcpustatsslotallgrp'), ('pybind.slxos.v17s_1_02.tm_state', u'tmvoqstatistics'), ('pybind.slxos.v17s_1_02.tm_state', u'tm_top_discard_pkt_data'), ('pybind.slxos.v17s_1_02.tm_state', u'tmdevicestataggr'), ('pybind.slxos.v17r_1_01a.tm_state', u'cngn_mon_del_pkt'), ('pybind.slxos.v17r_1_01a.tm_state', u'cngn_mon_dev'), ('pybind.slxos.v17r_1_01a.tm_state', u'buf_pool_stats'), ('pybind.slxos.v17r_1_01a.tm_state', u'non_empty_voq'), ('pybind.slxos.v17r_1_01a.tm_state', u'cngn_mon_voq'), ('pybind.slxos.v17r_1_01a.tm_state', u'tmdevicestataggr'), ('pybind.slxos.v17r_1_01a.tm_state', u'tm_max_buff_util_data'), ('pybind.slxos.v17r_1_01a.tm_state', u'tmcpustatsslot'), ('pybind.slxos.v17r_1_01a.tm_state', u'tmcpustatsslotallgrp'), ('pybind.slxos.v17r_1_01a.tm_state', u'tmvoqstatistics'), ('pybind.slxos.v17r_1_01a.tm_state', u'tm_top_discard_pkt_data'), ('pybind.slxos.v17r_1_01a.tm_state', u'tm_top_max_queue_depth_data'), ('pybind.slxos.v17r_2_00.tm_state', u'cngn_mon_dev'), ('pybind.slxos.v17r_2_00.tm_state', u'tm_top_max_queue_depth_data'), ('pybind.slxos.v17r_2_00.tm_state', u'tmvoqstatistics'), ('pybind.slxos.v17r_2_00.tm_state', u'tmcpustatsslotallgrp'), ('pybind.slxos.v17r_2_00.tm_state', u'tmdevicestataggr'), ('pybind.slxos.v17r_2_00.tm_state', u'tm_top_discard_pkt_data'), ('pybind.slxos.v17r_2_00.tm_state', u'tm_max_buff_util_data'), ('pybind.slxos.v17r_2_00.tm_state', u'cngn_mon_del_pkt'), ('pybind.slxos.v17r_2_00.tm_state', u'buf_pool_stats'), ('pybind.slxos.v17r_2_00.tm_state', u'cngn_mon_voq'), ('pybind.slxos.v17r_2_00.tm_state', u'non_empty_voq'), ('pybind.slxos.v17r_2_00.tm_state', u'tmcpustatsslot')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'slot, tower, id, dest_port, priority, queue, max_queue_depth, min_threshold, max_utilization'}, {'leafval': 'slot_port, voq_id, voq_size'}, {'leafval': 'slot_id, cpugroup_id, enquepkt, enqueubytes, discardpkt, discardbytes, currdepth, maxdepth'}, {'leafval': 'slot, tower, max_buff_size, max_buff_util'}, {'leafval': 'slot_id, enquepkt, enqueubytes, discardpkt, discardbytes, currdepth, maxdepth'}, {'leafval': 'ing_slot, ing_tower, egr_voqid, priority, enquepkt, enqueubytes, discardpkt, discardbytes, currdepth, maxdepth'}, {'leafval': 'slot, tower, id, dest_port, priority, queue, discardpkt'}, {'leafval': 'slot, tower, ingress_total_pkt_cnt_aggr, enque_pkt_cnt_aggr, deque_pkt_cnt_aggr, total_discard_pkt_cnt_aggr, deleted_pkt_cnt_aggr, invalid_queue_pkt_aggr, cpu_pkt_cnt_aggr, uni_pkt_cnt_aggr, mcast_pkt_cnt_aggr, uni_discard_pkt_cnt_aggr, mcast_discard_pkt_cnt_aggr, fqp_pkt_cnt_aggr, ehp_discard_cnt_aggr'}, {'leafval': 'delete_pkt_threshold, delete_log_interval'}, {'leafval': 'discard_pkt_threshold, discard_log_interval'}, {'leafval': 'slot, tower, dram_size, bd_occ_core0, buf_occ_bytes_core0, bd_occ_core1, buf_occ_bytes_core1'}, {'leafval': 'slot, tower'}, {'leafval': 'discard_voq_pkt_threshold, discard_voq_log_interval'}, {'leafval': 'slot, tower, ingress_total_pkt_cnt_aggr, cpu_pkt_cnt_aggr, nif_pkt_cnt_aggr, oamp_pkt_cnt_aggr, olp_pkt_cnt_aggr, rcy_pkt_cnt_aggr, mmu_pkt_cnt_aggr, enque_pkt_cnt_aggr, deque_pkt_cnt_aggr, total_discard_pkt_cnt_aggr, deleted_pkt_cnt_aggr, invalid_queue_pkt_aggr, ipt_fdt_pkt_cnt_aggr, ipt_crc_err_pkt_cnt_aggr, uni_pkt_cnt_aggr, fqp_pkt_cnt_aggr, uni_discard_pkt_cnt_aggr, mcast_discard_pkt_cnt_aggr, mcast_pkt_cnt_aggr, ehp_discard_cnt_aggr, prp_uc_discard_cnt_aggr, prp_mc_discard_cnt_aggr, prp_sop_uc_discard_cnt_aggr, prp_sop_mc_discard_cnt_aggr, ehp_mc_high_discard_cnt_aggr, ehp_mc_low_discard_cnt_aggr, erpp_lag_pruning_discard_cnt_aggr, erpp_pmf_discard_cnt_aggr, erpp_vlan_membership_discard_cnt_aggr, epe_discard_cnt_aggr, epe_cnt_aggr, tot_egr_pkt_cnt_aggr'}, {'leafval': 'slot, tower, max_buff_size, max_buff_util'}, {'leafval': 'slot_id, cpugroup_id, priority, enquepkt, enqueubytes, discardpkt, discardbytes, currdepth, maxdepth'}, {'leafval': 'slot_id, priority, enquepkt, enqueubytes, discardpkt, discardbytes, currdepth, maxdepth'}, {'leafval': 'ing_slot, ing_tower, egr_voqid, priority, enquepkt, enqueubytes, discardpkt, discardbytes, currdepth, maxdepth'}, {'leafval': 'slot, tower, id, dest_port, priority, queue, discardpkt'}, {'leafval': 'slot, tower, id, dest_port, priority, queue, max_queue_depth, min_threshold, max_utilization'}, {'leafval': 'discard_pkt_threshold, discard_log_interval'}, {'leafval': 'slot, tower, id, dest_port, priority, queue, max_queue_depth, min_threshold, max_utilization'}, {'leafval': 'ing_slot, ing_tower, egr_voqid, priority, enquepkt, enqueubytes, discardpkt, discardbytes, currdepth, maxdepth'}, {'leafval': 'slot_id, priority, enquepkt, enqueubytes, discardpkt, discardbytes, currdepth, maxdepth'}, {'leafval': 'slot, tower, ingress_total_pkt_cnt_aggr, cpu_pkt_cnt_aggr, nif_pkt_cnt_aggr, oamp_pkt_cnt_aggr, olp_pkt_cnt_aggr, rcy_pkt_cnt_aggr, mmu_pkt_cnt_aggr, enque_pkt_cnt_aggr, deque_pkt_cnt_aggr, total_discard_pkt_cnt_aggr, deleted_pkt_cnt_aggr, invalid_queue_pkt_aggr, ipt_fdt_pkt_cnt_aggr, ipt_crc_err_pkt_cnt_aggr, uni_pkt_cnt_aggr, fqp_pkt_cnt_aggr, uni_discard_pkt_cnt_aggr, mcast_discard_pkt_cnt_aggr, mcast_pkt_cnt_aggr, ehp_discard_cnt_aggr, prp_uc_discard_cnt_aggr, prp_mc_discard_cnt_aggr, prp_sop_uc_discard_cnt_aggr, prp_sop_mc_discard_cnt_aggr, ehp_mc_high_discard_cnt_aggr, ehp_mc_low_discard_cnt_aggr, erpp_lag_pruning_discard_cnt_aggr, erpp_pmf_discard_cnt_aggr, erpp_vlan_membership_discard_cnt_aggr, epe_discard_cnt_aggr, epe_cnt_aggr, tot_egr_pkt_cnt_aggr'}, {'leafval': 'slot, tower, id, dest_port, priority, queue, discardpkt'}, {'leafval': 'slot, tower, max_buff_size, max_buff_util'}, {'leafval': 'delete_pkt_threshold, delete_log_interval'}, {'leafval': 'slot, tower, dram_size, bd_occ_core0, buf_occ_bytes_core0, bd_occ_core1, buf_occ_bytes_core1'}, {'leafval': 'discard_voq_pkt_threshold, discard_voq_log_interval'}, {'leafval': 'slot, tower'}, {'leafval': 'slot_id, cpugroup_id, priority, enquepkt, enqueubytes, discardpkt, discardbytes, currdepth, maxdepth'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_buf_pool_stats_get(self, buf_pool_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type buf_pool_stats: slot, tower
    :param buf_pool_stats: Keyword argument tuple.

    :type slot: int
    :param slot: **buf_pool_stats** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **buf_pool_stats** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.buf_pool_stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.buf_pool_stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'buf_pool_stats', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, buf_pool_stats=buf_pool_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, buf_pool_stats=buf_pool_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_buf_pool_stats_bd_occ_core0_get(self, buf_pool_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type buf_pool_stats: slot, tower
    :param buf_pool_stats: Keyword argument tuple.

    :type slot: int
    :param slot: **buf_pool_stats** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **buf_pool_stats** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.buf_pool_stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.buf_pool_stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'buf_pool_stats', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, buf_pool_stats=buf_pool_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, buf_pool_stats=buf_pool_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_buf_pool_stats_bd_occ_core1_get(self, buf_pool_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type buf_pool_stats: slot, tower
    :param buf_pool_stats: Keyword argument tuple.

    :type slot: int
    :param slot: **buf_pool_stats** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **buf_pool_stats** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.buf_pool_stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.buf_pool_stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'buf_pool_stats', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, buf_pool_stats=buf_pool_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, buf_pool_stats=buf_pool_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_buf_pool_stats_buf_occ_bytes_core0_get(self, buf_pool_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type buf_pool_stats: slot, tower
    :param buf_pool_stats: Keyword argument tuple.

    :type slot: int
    :param slot: **buf_pool_stats** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **buf_pool_stats** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.buf_pool_stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.buf_pool_stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'buf_pool_stats', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, buf_pool_stats=buf_pool_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, buf_pool_stats=buf_pool_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_buf_pool_stats_buf_occ_bytes_core1_get(self, buf_pool_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type buf_pool_stats: slot, tower
    :param buf_pool_stats: Keyword argument tuple.

    :type slot: int
    :param slot: **buf_pool_stats** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **buf_pool_stats** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.buf_pool_stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.buf_pool_stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'buf_pool_stats', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, buf_pool_stats=buf_pool_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, buf_pool_stats=buf_pool_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_buf_pool_stats_dram_size_get(self, buf_pool_stats=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type buf_pool_stats: slot, tower
    :param buf_pool_stats: Keyword argument tuple.

    :type slot: int
    :param slot: **buf_pool_stats** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **buf_pool_stats** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.buf_pool_stats', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.buf_pool_stats', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'buf_pool_stats', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, buf_pool_stats=buf_pool_stats)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, buf_pool_stats=buf_pool_stats)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_cngn_mon_del_pkt_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.cngn_mon_del_pkt', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.cngn_mon_del_pkt', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_cngn_mon_del_pkt_delete_log_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.cngn_mon_del_pkt', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.cngn_mon_del_pkt', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_cngn_mon_del_pkt_delete_pkt_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.cngn_mon_del_pkt', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.cngn_mon_del_pkt', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_cngn_mon_dev_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.cngn_mon_dev', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.cngn_mon_dev', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_cngn_mon_dev_discard_log_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.cngn_mon_dev', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.cngn_mon_dev', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_cngn_mon_dev_discard_pkt_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.cngn_mon_dev', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.cngn_mon_dev', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_cngn_mon_voq_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.cngn_mon_voq', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.cngn_mon_voq', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_cngn_mon_voq_discard_voq_log_interval_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.cngn_mon_voq', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.cngn_mon_voq', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_cngn_mon_voq_discard_voq_pkt_threshold_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.cngn_mon_voq', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.cngn_mon_voq', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_non_empty_voq_get(self, non_empty_voq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type non_empty_voq: slot, tower
    :param non_empty_voq: Keyword argument tuple.

    :type slot: int
    :param slot: **non_empty_voq** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **non_empty_voq** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.non_empty_voq', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.non_empty_voq', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.non_empty_voq', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'non_empty_voq', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.tm_state.non_empty_voq": {"slot": "slot", "tower": "tower"}, "pybind.slxos.v17r_2_00.tm_state.non_empty_voq": {"slot": "slot", "tower": "tower"}, "pybind.slxos.v17s_1_02.tm_state.non_empty_voq": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, non_empty_voq=non_empty_voq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, non_empty_voq=non_empty_voq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_non_empty_voq_voq_id_get(self, non_empty_voq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type non_empty_voq: slot_port
    :param non_empty_voq: Keyword argument tuple.

    :type slot_port: unicode
    :param slot_port: **non_empty_voq** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.tm_state.non_empty_voq', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'non_empty_voq', 'keyval': 'slot_port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, non_empty_voq=non_empty_voq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, non_empty_voq=non_empty_voq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_non_empty_voq_voq_size_get(self, non_empty_voq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type non_empty_voq: slot_port
    :param non_empty_voq: Keyword argument tuple.

    :type slot_port: unicode
    :param slot_port: **non_empty_voq** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.tm_state.non_empty_voq', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'non_empty_voq', 'keyval': 'slot_port', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, non_empty_voq=non_empty_voq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, non_empty_voq=non_empty_voq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tm_max_buff_util_data_get(self, tm_max_buff_util_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tm_max_buff_util_data: slot, tower
    :param tm_max_buff_util_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_max_buff_util_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_max_buff_util_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tm_max_buff_util_data', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tm_max_buff_util_data', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tm_max_buff_util_data', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_max_buff_util_data', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_max_buff_util_data=tm_max_buff_util_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_max_buff_util_data=tm_max_buff_util_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tm_max_buff_util_data_max_buff_size_get(self, tm_max_buff_util_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tm_max_buff_util_data: slot, tower
    :param tm_max_buff_util_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_max_buff_util_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_max_buff_util_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tm_max_buff_util_data', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tm_max_buff_util_data', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tm_max_buff_util_data', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_max_buff_util_data', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_max_buff_util_data=tm_max_buff_util_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_max_buff_util_data=tm_max_buff_util_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tm_max_buff_util_data_max_buff_util_get(self, tm_max_buff_util_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tm_max_buff_util_data: slot, tower
    :param tm_max_buff_util_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_max_buff_util_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_max_buff_util_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tm_max_buff_util_data', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tm_max_buff_util_data', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tm_max_buff_util_data', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_max_buff_util_data', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_max_buff_util_data=tm_max_buff_util_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_max_buff_util_data=tm_max_buff_util_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tm_top_discard_pkt_data_get(self, tm_top_discard_pkt_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tm_top_discard_pkt_data: slot, tower, id
    :param tm_top_discard_pkt_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_discard_pkt_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tm_top_discard_pkt_data_dest_port_get(self, tm_top_discard_pkt_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tm_top_discard_pkt_data: slot, tower, id
    :param tm_top_discard_pkt_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_discard_pkt_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tm_top_discard_pkt_data_discardpkt_get(self, tm_top_discard_pkt_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tm_top_discard_pkt_data: slot, tower, id
    :param tm_top_discard_pkt_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_discard_pkt_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tm_top_discard_pkt_data_priority_get(self, tm_top_discard_pkt_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tm_top_discard_pkt_data: slot, tower, id
    :param tm_top_discard_pkt_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_discard_pkt_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tm_top_discard_pkt_data_queue_get(self, tm_top_discard_pkt_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tm_top_discard_pkt_data: slot, tower, id
    :param tm_top_discard_pkt_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_discard_pkt_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tm_top_discard_pkt_data', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_discard_pkt_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_discard_pkt_data=tm_top_discard_pkt_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tm_top_max_queue_depth_data_get(self, tm_top_max_queue_depth_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tm_top_max_queue_depth_data: slot, tower, id
    :param tm_top_max_queue_depth_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_max_queue_depth_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tm_top_max_queue_depth_data_dest_port_get(self, tm_top_max_queue_depth_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tm_top_max_queue_depth_data: slot, tower, id
    :param tm_top_max_queue_depth_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_max_queue_depth_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tm_top_max_queue_depth_data_max_queue_depth_get(self, tm_top_max_queue_depth_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tm_top_max_queue_depth_data: slot, tower, id
    :param tm_top_max_queue_depth_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_max_queue_depth_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tm_top_max_queue_depth_data_max_utilization_get(self, tm_top_max_queue_depth_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tm_top_max_queue_depth_data: slot, tower, id
    :param tm_top_max_queue_depth_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_max_queue_depth_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tm_top_max_queue_depth_data_min_threshold_get(self, tm_top_max_queue_depth_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tm_top_max_queue_depth_data: slot, tower, id
    :param tm_top_max_queue_depth_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_max_queue_depth_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tm_top_max_queue_depth_data_priority_get(self, tm_top_max_queue_depth_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tm_top_max_queue_depth_data: slot, tower, id
    :param tm_top_max_queue_depth_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_max_queue_depth_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tm_top_max_queue_depth_data_queue_get(self, tm_top_max_queue_depth_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tm_top_max_queue_depth_data: slot, tower, id
    :param tm_top_max_queue_depth_data: Keyword argument tuple.

    :type slot: int
    :param slot: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type id: int
    :param id: **tm_top_max_queue_depth_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tm_top_max_queue_depth_data', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tm_top_max_queue_depth_data', 'keyval': 'slot, tower, id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tm_top_max_queue_depth_data=tm_top_max_queue_depth_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmcpustatsslot_get(self, tmcpustatsslot=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslot: slot_id, cpugroup_id, priority
    :param tmcpustatsslot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type cpugroup_id: int
    :param cpugroup_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type priority: int
    :param priority: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslot', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmcpustatsslot', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmcpustatsslot', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslot', 'keyval': 'slot_id, cpugroup_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslot": {"discardpkt": "discardpkt", "enqueubytes": "enqueubytes", "discardbytes": "discardbytes", "priority": "priority", "cpugroup_id": "cpugroup_id", "slot_id": "slot_id", "maxdepth": "maxdepth", "enquepkt": "enquepkt", "currdepth": "currdepth"}, "pybind.slxos.v17s_1_02.tm_state.tmcpustatsslot": {}, "pybind.slxos.v17r_2_00.tm_state.tmcpustatsslot": {"discardpkt": "discardpkt", "enqueubytes": "enqueubytes", "discardbytes": "discardbytes", "priority": "priority", "cpugroup_id": "cpugroup_id", "slot_id": "slot_id", "maxdepth": "maxdepth", "enquepkt": "enquepkt", "currdepth": "currdepth"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslot=tmcpustatsslot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslot=tmcpustatsslot)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmcpustatsslot_currdepth_get(self, tmcpustatsslot=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslot: slot_id, cpugroup_id, priority
    :param tmcpustatsslot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type cpugroup_id: int
    :param cpugroup_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type priority: int
    :param priority: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslot', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmcpustatsslot', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmcpustatsslot', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslot', 'keyval': 'slot_id, cpugroup_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslot": {"priority": "priority", "cpugroup_id": "cpugroup_id", "slot_id": "slot_id", "currdepth": "currdepth"}, "pybind.slxos.v17s_1_02.tm_state.tmcpustatsslot": {}, "pybind.slxos.v17r_2_00.tm_state.tmcpustatsslot": {"priority": "priority", "cpugroup_id": "cpugroup_id", "slot_id": "slot_id", "currdepth": "currdepth"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslot=tmcpustatsslot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslot=tmcpustatsslot)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmcpustatsslot_discardbytes_get(self, tmcpustatsslot=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslot: slot_id, cpugroup_id, priority
    :param tmcpustatsslot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type cpugroup_id: int
    :param cpugroup_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type priority: int
    :param priority: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslot', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmcpustatsslot', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmcpustatsslot', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslot', 'keyval': 'slot_id, cpugroup_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslot": {"priority": "priority", "cpugroup_id": "cpugroup_id", "slot_id": "slot_id", "discardbytes": "discardbytes"}, "pybind.slxos.v17s_1_02.tm_state.tmcpustatsslot": {}, "pybind.slxos.v17r_2_00.tm_state.tmcpustatsslot": {"priority": "priority", "cpugroup_id": "cpugroup_id", "slot_id": "slot_id", "discardbytes": "discardbytes"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslot=tmcpustatsslot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslot=tmcpustatsslot)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmcpustatsslot_discardpkt_get(self, tmcpustatsslot=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslot: slot_id, cpugroup_id, priority
    :param tmcpustatsslot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type cpugroup_id: int
    :param cpugroup_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type priority: int
    :param priority: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslot', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmcpustatsslot', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmcpustatsslot', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslot', 'keyval': 'slot_id, cpugroup_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslot": {"priority": "priority", "discardpkt": "discardpkt", "cpugroup_id": "cpugroup_id", "slot_id": "slot_id"}, "pybind.slxos.v17s_1_02.tm_state.tmcpustatsslot": {}, "pybind.slxos.v17r_2_00.tm_state.tmcpustatsslot": {"priority": "priority", "discardpkt": "discardpkt", "cpugroup_id": "cpugroup_id", "slot_id": "slot_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslot=tmcpustatsslot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslot=tmcpustatsslot)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmcpustatsslot_enquepkt_get(self, tmcpustatsslot=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslot: slot_id, cpugroup_id, priority
    :param tmcpustatsslot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type cpugroup_id: int
    :param cpugroup_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type priority: int
    :param priority: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslot', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmcpustatsslot', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmcpustatsslot', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslot', 'keyval': 'slot_id, cpugroup_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslot": {"priority": "priority", "enquepkt": "enquepkt", "cpugroup_id": "cpugroup_id", "slot_id": "slot_id"}, "pybind.slxos.v17s_1_02.tm_state.tmcpustatsslot": {}, "pybind.slxos.v17r_2_00.tm_state.tmcpustatsslot": {"priority": "priority", "enquepkt": "enquepkt", "cpugroup_id": "cpugroup_id", "slot_id": "slot_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslot=tmcpustatsslot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslot=tmcpustatsslot)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmcpustatsslot_enqueubytes_get(self, tmcpustatsslot=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslot: slot_id, cpugroup_id, priority
    :param tmcpustatsslot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type cpugroup_id: int
    :param cpugroup_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type priority: int
    :param priority: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslot', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmcpustatsslot', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmcpustatsslot', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslot', 'keyval': 'slot_id, cpugroup_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslot": {"priority": "priority", "enqueubytes": "enqueubytes", "cpugroup_id": "cpugroup_id", "slot_id": "slot_id"}, "pybind.slxos.v17s_1_02.tm_state.tmcpustatsslot": {}, "pybind.slxos.v17r_2_00.tm_state.tmcpustatsslot": {"priority": "priority", "enqueubytes": "enqueubytes", "cpugroup_id": "cpugroup_id", "slot_id": "slot_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslot=tmcpustatsslot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslot=tmcpustatsslot)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmcpustatsslot_maxdepth_get(self, tmcpustatsslot=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslot: slot_id, cpugroup_id, priority
    :param tmcpustatsslot: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type cpugroup_id: int
    :param cpugroup_id: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type priority: int
    :param priority: **tmcpustatsslot** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslot', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmcpustatsslot', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmcpustatsslot', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslot', 'keyval': 'slot_id, cpugroup_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslot": {"priority": "priority", "cpugroup_id": "cpugroup_id", "slot_id": "slot_id", "maxdepth": "maxdepth"}, "pybind.slxos.v17s_1_02.tm_state.tmcpustatsslot": {}, "pybind.slxos.v17r_2_00.tm_state.tmcpustatsslot": {"priority": "priority", "cpugroup_id": "cpugroup_id", "slot_id": "slot_id", "maxdepth": "maxdepth"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslot=tmcpustatsslot)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslot=tmcpustatsslot)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmcpustatsslotallgrp_get(self, tmcpustatsslotallgrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslotallgrp: slot_id, priority
    :param tmcpustatsslotallgrp: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type priority: int
    :param priority: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslotallgrp', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.tm_state.tmcpustatsslotallgrp": {}, "pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslotallgrp": {"discardpkt": "discardpkt", "enqueubytes": "enqueubytes", "discardbytes": "discardbytes", "priority": "priority", "slot_id": "slot_id", "maxdepth": "maxdepth", "enquepkt": "enquepkt", "currdepth": "currdepth"}, "pybind.slxos.v17r_2_00.tm_state.tmcpustatsslotallgrp": {"discardpkt": "discardpkt", "enqueubytes": "enqueubytes", "discardbytes": "discardbytes", "priority": "priority", "slot_id": "slot_id", "maxdepth": "maxdepth", "enquepkt": "enquepkt", "currdepth": "currdepth"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmcpustatsslotallgrp_currdepth_get(self, tmcpustatsslotallgrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslotallgrp: slot_id, priority
    :param tmcpustatsslotallgrp: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type priority: int
    :param priority: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslotallgrp', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.tm_state.tmcpustatsslotallgrp": {}, "pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslotallgrp": {"priority": "priority", "slot_id": "slot_id", "currdepth": "currdepth"}, "pybind.slxos.v17r_2_00.tm_state.tmcpustatsslotallgrp": {"priority": "priority", "slot_id": "slot_id", "currdepth": "currdepth"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmcpustatsslotallgrp_discardbytes_get(self, tmcpustatsslotallgrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslotallgrp: slot_id, priority
    :param tmcpustatsslotallgrp: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type priority: int
    :param priority: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslotallgrp', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.tm_state.tmcpustatsslotallgrp": {}, "pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslotallgrp": {"priority": "priority", "slot_id": "slot_id", "discardbytes": "discardbytes"}, "pybind.slxos.v17r_2_00.tm_state.tmcpustatsslotallgrp": {"priority": "priority", "slot_id": "slot_id", "discardbytes": "discardbytes"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmcpustatsslotallgrp_discardpkt_get(self, tmcpustatsslotallgrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslotallgrp: slot_id, priority
    :param tmcpustatsslotallgrp: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type priority: int
    :param priority: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslotallgrp', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.tm_state.tmcpustatsslotallgrp": {}, "pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslotallgrp": {"priority": "priority", "discardpkt": "discardpkt", "slot_id": "slot_id"}, "pybind.slxos.v17r_2_00.tm_state.tmcpustatsslotallgrp": {"priority": "priority", "discardpkt": "discardpkt", "slot_id": "slot_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmcpustatsslotallgrp_enquepkt_get(self, tmcpustatsslotallgrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslotallgrp: slot_id, priority
    :param tmcpustatsslotallgrp: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type priority: int
    :param priority: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslotallgrp', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.tm_state.tmcpustatsslotallgrp": {}, "pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslotallgrp": {"priority": "priority", "enquepkt": "enquepkt", "slot_id": "slot_id"}, "pybind.slxos.v17r_2_00.tm_state.tmcpustatsslotallgrp": {"priority": "priority", "enquepkt": "enquepkt", "slot_id": "slot_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmcpustatsslotallgrp_enqueubytes_get(self, tmcpustatsslotallgrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslotallgrp: slot_id, priority
    :param tmcpustatsslotallgrp: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type priority: int
    :param priority: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslotallgrp', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.tm_state.tmcpustatsslotallgrp": {}, "pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslotallgrp": {"priority": "priority", "enqueubytes": "enqueubytes", "slot_id": "slot_id"}, "pybind.slxos.v17r_2_00.tm_state.tmcpustatsslotallgrp": {"priority": "priority", "enqueubytes": "enqueubytes", "slot_id": "slot_id"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmcpustatsslotallgrp_maxdepth_get(self, tmcpustatsslotallgrp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmcpustatsslotallgrp: slot_id, priority
    :param tmcpustatsslotallgrp: Keyword argument tuple.

    :type slot_id: int
    :param slot_id: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type priority: int
    :param priority: **tmcpustatsslotallgrp** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmcpustatsslotallgrp', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmcpustatsslotallgrp', 'keyval': 'slot_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.tm_state.tmcpustatsslotallgrp": {}, "pybind.slxos.v17r_1_01a.tm_state.tmcpustatsslotallgrp": {"priority": "priority", "slot_id": "slot_id", "maxdepth": "maxdepth"}, "pybind.slxos.v17r_2_00.tm_state.tmcpustatsslotallgrp": {"priority": "priority", "slot_id": "slot_id", "maxdepth": "maxdepth"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmcpustatsslotallgrp=tmcpustatsslotallgrp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmdevicestataggr', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr": {"olp_pkt_cnt_aggr": "olp_pkt_cnt_aggr", "cpu_pkt_cnt_aggr": "cpu_pkt_cnt_aggr", "deque_pkt_cnt_aggr": "deque_pkt_cnt_aggr", "ipt_crc_err_pkt_cnt_aggr": "ipt_crc_err_pkt_cnt_aggr", "ehp_mc_low_discard_cnt_aggr": "ehp_mc_low_discard_cnt_aggr", "prp_uc_discard_cnt_aggr": "prp_uc_discard_cnt_aggr", "ehp_mc_high_discard_cnt_aggr": "ehp_mc_high_discard_cnt_aggr", "invalid_queue_pkt_aggr": "invalid_queue_pkt_aggr", "ipt_fdt_pkt_cnt_aggr": "ipt_fdt_pkt_cnt_aggr", "fqp_pkt_cnt_aggr": "fqp_pkt_cnt_aggr", "oamp_pkt_cnt_aggr": "oamp_pkt_cnt_aggr", "mmu_pkt_cnt_aggr": "mmu_pkt_cnt_aggr", "slot": "slot", "erpp_pmf_discard_cnt_aggr": "erpp_pmf_discard_cnt_aggr", "erpp_vlan_membership_discard_cnt_aggr": "erpp_vlan_membership_discard_cnt_aggr", "tot_egr_pkt_cnt_aggr": "tot_egr_pkt_cnt_aggr", "uni_discard_pkt_cnt_aggr": "uni_discard_pkt_cnt_aggr", "nif_pkt_cnt_aggr": "nif_pkt_cnt_aggr", "deleted_pkt_cnt_aggr": "deleted_pkt_cnt_aggr", "prp_sop_mc_discard_cnt_aggr": "prp_sop_mc_discard_cnt_aggr", "mcast_discard_pkt_cnt_aggr": "mcast_discard_pkt_cnt_aggr", "ehp_discard_cnt_aggr": "ehp_discard_cnt_aggr", "prp_sop_uc_discard_cnt_aggr": "prp_sop_uc_discard_cnt_aggr", "rcy_pkt_cnt_aggr": "rcy_pkt_cnt_aggr", "epe_cnt_aggr": "epe_cnt_aggr", "tower": "tower", "prp_mc_discard_cnt_aggr": "prp_mc_discard_cnt_aggr", "erpp_lag_pruning_discard_cnt_aggr": "erpp_lag_pruning_discard_cnt_aggr", "uni_pkt_cnt_aggr": "uni_pkt_cnt_aggr", "enque_pkt_cnt_aggr": "enque_pkt_cnt_aggr", "epe_discard_cnt_aggr": "epe_discard_cnt_aggr", "total_discard_pkt_cnt_aggr": "total_discard_pkt_cnt_aggr", "mcast_pkt_cnt_aggr": "mcast_pkt_cnt_aggr", "ingress_total_pkt_cnt_aggr": "ingress_total_pkt_cnt_aggr"}, "pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr": {"olp_pkt_cnt_aggr": "olp_pkt_cnt_aggr", "cpu_pkt_cnt_aggr": "cpu_pkt_cnt_aggr", "deque_pkt_cnt_aggr": "deque_pkt_cnt_aggr", "ipt_crc_err_pkt_cnt_aggr": "ipt_crc_err_pkt_cnt_aggr", "ehp_mc_low_discard_cnt_aggr": "ehp_mc_low_discard_cnt_aggr", "prp_uc_discard_cnt_aggr": "prp_uc_discard_cnt_aggr", "ehp_mc_high_discard_cnt_aggr": "ehp_mc_high_discard_cnt_aggr", "invalid_queue_pkt_aggr": "invalid_queue_pkt_aggr", "ipt_fdt_pkt_cnt_aggr": "ipt_fdt_pkt_cnt_aggr", "fqp_pkt_cnt_aggr": "fqp_pkt_cnt_aggr", "oamp_pkt_cnt_aggr": "oamp_pkt_cnt_aggr", "mmu_pkt_cnt_aggr": "mmu_pkt_cnt_aggr", "slot": "slot", "erpp_pmf_discard_cnt_aggr": "erpp_pmf_discard_cnt_aggr", "erpp_vlan_membership_discard_cnt_aggr": "erpp_vlan_membership_discard_cnt_aggr", "tot_egr_pkt_cnt_aggr": "tot_egr_pkt_cnt_aggr", "uni_discard_pkt_cnt_aggr": "uni_discard_pkt_cnt_aggr", "nif_pkt_cnt_aggr": "nif_pkt_cnt_aggr", "deleted_pkt_cnt_aggr": "deleted_pkt_cnt_aggr", "prp_sop_mc_discard_cnt_aggr": "prp_sop_mc_discard_cnt_aggr", "mcast_discard_pkt_cnt_aggr": "mcast_discard_pkt_cnt_aggr", "ehp_discard_cnt_aggr": "ehp_discard_cnt_aggr", "prp_sop_uc_discard_cnt_aggr": "prp_sop_uc_discard_cnt_aggr", "rcy_pkt_cnt_aggr": "rcy_pkt_cnt_aggr", "epe_cnt_aggr": "epe_cnt_aggr", "tower": "tower", "prp_mc_discard_cnt_aggr": "prp_mc_discard_cnt_aggr", "erpp_lag_pruning_discard_cnt_aggr": "erpp_lag_pruning_discard_cnt_aggr", "uni_pkt_cnt_aggr": "uni_pkt_cnt_aggr", "enque_pkt_cnt_aggr": "enque_pkt_cnt_aggr", "epe_discard_cnt_aggr": "epe_discard_cnt_aggr", "total_discard_pkt_cnt_aggr": "total_discard_pkt_cnt_aggr", "mcast_pkt_cnt_aggr": "mcast_pkt_cnt_aggr", "ingress_total_pkt_cnt_aggr": "ingress_total_pkt_cnt_aggr"}, "pybind.slxos.v17s_1_02.tm_state.tmdevicestataggr": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_cpu_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmdevicestataggr', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_deleted_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmdevicestataggr', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_deque_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmdevicestataggr', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_ehp_discard_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmdevicestataggr', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_ehp_mc_high_discard_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_ehp_mc_low_discard_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_enque_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmdevicestataggr', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_epe_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_epe_discard_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_erpp_lag_pruning_discard_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_erpp_pmf_discard_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_erpp_vlan_membership_discard_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_fqp_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmdevicestataggr', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_ingress_total_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmdevicestataggr', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_invalid_queue_pkt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmdevicestataggr', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_ipt_crc_err_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_ipt_fdt_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_mcast_discard_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmdevicestataggr', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_mcast_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmdevicestataggr', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_mmu_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_nif_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_oamp_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_olp_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_prp_mc_discard_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_prp_sop_mc_discard_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_prp_sop_uc_discard_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_prp_uc_discard_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_rcy_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_tot_egr_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_total_discard_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmdevicestataggr', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_uni_discard_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmdevicestataggr', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmdevicestataggr_uni_pkt_cnt_aggr_get(self, tmdevicestataggr=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmdevicestataggr: slot, tower
    :param tmdevicestataggr: Keyword argument tuple.

    :type slot: int
    :param slot: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type tower: int
    :param tower: **tmdevicestataggr** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmdevicestataggr', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmdevicestataggr', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmdevicestataggr', 'keyval': 'slot, tower', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmdevicestataggr=tmdevicestataggr)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmdevicestataggr=tmdevicestataggr)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmvoqstatistics_get(self, tmvoqstatistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmvoqstatistics: ing_slot, ing_tower, egr_voqid
    :param tmvoqstatistics: Keyword argument tuple.

    :type ing_slot: int
    :param ing_slot: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ing_tower: int
    :param ing_tower: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type egr_voqid: int
    :param egr_voqid: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmvoqstatistics', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmvoqstatistics', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmvoqstatistics', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmvoqstatistics', 'keyval': 'ing_slot, ing_tower, egr_voqid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmvoqstatistics=tmvoqstatistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmvoqstatistics=tmvoqstatistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmvoqstatistics_currdepth_get(self, tmvoqstatistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmvoqstatistics: ing_slot, ing_tower, egr_voqid
    :param tmvoqstatistics: Keyword argument tuple.

    :type ing_slot: int
    :param ing_slot: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ing_tower: int
    :param ing_tower: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type egr_voqid: int
    :param egr_voqid: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmvoqstatistics', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmvoqstatistics', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmvoqstatistics', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmvoqstatistics', 'keyval': 'ing_slot, ing_tower, egr_voqid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmvoqstatistics=tmvoqstatistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmvoqstatistics=tmvoqstatistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmvoqstatistics_discardbytes_get(self, tmvoqstatistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmvoqstatistics: ing_slot, ing_tower, egr_voqid
    :param tmvoqstatistics: Keyword argument tuple.

    :type ing_slot: int
    :param ing_slot: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ing_tower: int
    :param ing_tower: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type egr_voqid: int
    :param egr_voqid: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmvoqstatistics', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmvoqstatistics', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmvoqstatistics', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmvoqstatistics', 'keyval': 'ing_slot, ing_tower, egr_voqid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmvoqstatistics=tmvoqstatistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmvoqstatistics=tmvoqstatistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmvoqstatistics_discardpkt_get(self, tmvoqstatistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmvoqstatistics: ing_slot, ing_tower, egr_voqid
    :param tmvoqstatistics: Keyword argument tuple.

    :type ing_slot: int
    :param ing_slot: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ing_tower: int
    :param ing_tower: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type egr_voqid: int
    :param egr_voqid: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmvoqstatistics', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmvoqstatistics', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmvoqstatistics', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmvoqstatistics', 'keyval': 'ing_slot, ing_tower, egr_voqid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmvoqstatistics=tmvoqstatistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmvoqstatistics=tmvoqstatistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmvoqstatistics_enquepkt_get(self, tmvoqstatistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmvoqstatistics: ing_slot, ing_tower, egr_voqid
    :param tmvoqstatistics: Keyword argument tuple.

    :type ing_slot: int
    :param ing_slot: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ing_tower: int
    :param ing_tower: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type egr_voqid: int
    :param egr_voqid: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmvoqstatistics', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmvoqstatistics', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmvoqstatistics', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmvoqstatistics', 'keyval': 'ing_slot, ing_tower, egr_voqid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmvoqstatistics=tmvoqstatistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmvoqstatistics=tmvoqstatistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmvoqstatistics_enqueubytes_get(self, tmvoqstatistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmvoqstatistics: ing_slot, ing_tower, egr_voqid
    :param tmvoqstatistics: Keyword argument tuple.

    :type ing_slot: int
    :param ing_slot: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ing_tower: int
    :param ing_tower: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type egr_voqid: int
    :param egr_voqid: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmvoqstatistics', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmvoqstatistics', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmvoqstatistics', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmvoqstatistics', 'keyval': 'ing_slot, ing_tower, egr_voqid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmvoqstatistics=tmvoqstatistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmvoqstatistics=tmvoqstatistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmvoqstatistics_maxdepth_get(self, tmvoqstatistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmvoqstatistics: ing_slot, ing_tower, egr_voqid
    :param tmvoqstatistics: Keyword argument tuple.

    :type ing_slot: int
    :param ing_slot: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ing_tower: int
    :param ing_tower: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type egr_voqid: int
    :param egr_voqid: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmvoqstatistics', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmvoqstatistics', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmvoqstatistics', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmvoqstatistics', 'keyval': 'ing_slot, ing_tower, egr_voqid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmvoqstatistics=tmvoqstatistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmvoqstatistics=tmvoqstatistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tm_state_tmvoqstatistics_priority_get(self, tmvoqstatistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tmvoqstatistics: ing_slot, ing_tower, egr_voqid
    :param tmvoqstatistics: Keyword argument tuple.

    :type ing_slot: int
    :param ing_slot: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type ing_tower: int
    :param ing_tower: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type egr_voqid: int
    :param egr_voqid: **tmvoqstatistics** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tm_state.tmvoqstatistics', 'pybind.slxos.v17r_1_01a.brocade_sysdiag_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tm_state.tmvoqstatistics', 'pybind.slxos.v17r_2_00.brocade_sysdiag_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tm_state.tmvoqstatistics', 'pybind.slxos.v17s_1_02.brocade_sysdiag_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'tmvoqstatistics', 'keyval': 'ing_slot, ing_tower, egr_voqid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tmvoqstatistics=tmvoqstatistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tmvoqstatistics=tmvoqstatistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_get(self, topology_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type topology_group: topology_group_id
    :param topology_group: Keyword argument tuple.

    :type topology_group_id: long
    :param topology_group_id: **topology_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group', 'pybind.slxos.v17r_1_01a.brocade_topology_group', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group', 'pybind.slxos.v17r_2_00.brocade_topology_group', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group', 'pybind.slxos.v17s_1_02.brocade_topology_group', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.topology_group', u'member_vlan'), ('pybind.slxos.v17r_1_01a.topology_group', u'member_bridge_domain'), ('pybind.slxos.v17r_2_00.topology_group', u'member_bridge_domain'), ('pybind.slxos.v17r_2_00.topology_group', u'member_vlan'), ('pybind.slxos.v17s_1_02.topology_group', u'member_vlan'), ('pybind.slxos.v17s_1_02.topology_group', u'member_bridge_domain')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'topology_group', 'keyval': 'topology_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'member_vlan_add, member_vlan_remove'}, {'leafval': 'member_bridge_domain_add, member_bridge_domain_remove'}, {'leafval': 'member_bridge_domain_add, member_bridge_domain_remove'}, {'leafval': 'member_vlan_add, member_vlan_remove'}, {'leafval': 'member_vlan_add, member_vlan_remove'}, {'leafval': 'member_bridge_domain_add, member_bridge_domain_remove'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group=topology_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group=topology_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_master_vlan_get(self, topology_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type topology_group: topology_group_id
    :param topology_group: Keyword argument tuple.

    :type topology_group_id: long
    :param topology_group_id: **topology_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group', 'pybind.slxos.v17r_1_01a.brocade_topology_group', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group', 'pybind.slxos.v17r_2_00.brocade_topology_group', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group', 'pybind.slxos.v17s_1_02.brocade_topology_group', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.topology_group', u'member_vlan'), ('pybind.slxos.v17r_1_01a.topology_group', u'member_bridge_domain'), ('pybind.slxos.v17r_2_00.topology_group', u'member_bridge_domain'), ('pybind.slxos.v17r_2_00.topology_group', u'member_vlan'), ('pybind.slxos.v17s_1_02.topology_group', u'member_vlan'), ('pybind.slxos.v17s_1_02.topology_group', u'member_bridge_domain')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'topology_group', 'keyval': 'topology_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'member_vlan_add, member_vlan_remove'}, {'leafval': 'member_bridge_domain_add, member_bridge_domain_remove'}, {'leafval': 'member_bridge_domain_add, member_bridge_domain_remove'}, {'leafval': 'member_vlan_add, member_vlan_remove'}, {'leafval': 'member_vlan_add, member_vlan_remove'}, {'leafval': 'member_bridge_domain_add, member_bridge_domain_remove'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group=topology_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group=topology_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_member_bridge_domain_get(self, topology_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group: topology_group_id
    :param topology_group: Keyword argument tuple.

    :type topology_group_id: long
    :param topology_group_id: **topology_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.topology_group', 'topology_group'), ('pybind.slxos.v17r_2_00.topology_group', 'topology_group'), ('pybind.slxos.v17s_1_02.topology_group', 'topology_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group.member_bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_topology_group', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group.member_bridge_domain', 'pybind.slxos.v17r_2_00.brocade_topology_group', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group.member_bridge_domain', 'pybind.slxos.v17s_1_02.brocade_topology_group', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group=topology_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group=topology_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_member_bridge_domain_add_get(self, topology_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group: topology_group_id
    :param topology_group: Keyword argument tuple.

    :type topology_group_id: long
    :param topology_group_id: **topology_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.topology_group', 'topology_group'), ('pybind.slxos.v17r_2_00.topology_group', 'topology_group'), ('pybind.slxos.v17s_1_02.topology_group', 'topology_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group.member_bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_topology_group', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group.member_bridge_domain', 'pybind.slxos.v17r_2_00.brocade_topology_group', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group.member_bridge_domain', 'pybind.slxos.v17s_1_02.brocade_topology_group', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group=topology_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group=topology_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_member_bridge_domain_remove_get(self, topology_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group: topology_group_id
    :param topology_group: Keyword argument tuple.

    :type topology_group_id: long
    :param topology_group_id: **topology_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.topology_group', 'topology_group'), ('pybind.slxos.v17r_2_00.topology_group', 'topology_group'), ('pybind.slxos.v17s_1_02.topology_group', 'topology_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group.member_bridge_domain', 'pybind.slxos.v17r_1_01a.brocade_topology_group', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group.member_bridge_domain', 'pybind.slxos.v17r_2_00.brocade_topology_group', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group.member_bridge_domain', 'pybind.slxos.v17s_1_02.brocade_topology_group', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group=topology_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group=topology_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_member_vlan_get(self, topology_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group: topology_group_id
    :param topology_group: Keyword argument tuple.

    :type topology_group_id: long
    :param topology_group_id: **topology_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.topology_group', 'topology_group'), ('pybind.slxos.v17r_1_01a.topology_group', 'topology_group'), ('pybind.slxos.v17r_2_00.topology_group', 'topology_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group.member_vlan', 'pybind.slxos.v17r_1_01a.brocade_topology_group', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group.member_vlan', 'pybind.slxos.v17r_2_00.brocade_topology_group', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group.member_vlan', 'pybind.slxos.v17s_1_02.brocade_topology_group', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group=topology_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group=topology_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_member_vlan_add_get(self, topology_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group: topology_group_id
    :param topology_group: Keyword argument tuple.

    :type topology_group_id: long
    :param topology_group_id: **topology_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.topology_group', 'topology_group'), ('pybind.slxos.v17r_1_01a.topology_group', 'topology_group'), ('pybind.slxos.v17r_2_00.topology_group', 'topology_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group.member_vlan', 'pybind.slxos.v17r_1_01a.brocade_topology_group', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group.member_vlan', 'pybind.slxos.v17r_2_00.brocade_topology_group', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group.member_vlan', 'pybind.slxos.v17s_1_02.brocade_topology_group', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group=topology_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group=topology_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_member_vlan_remove_get(self, topology_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group: topology_group_id
    :param topology_group: Keyword argument tuple.

    :type topology_group_id: long
    :param topology_group_id: **topology_group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.topology_group', 'topology_group'), ('pybind.slxos.v17r_1_01a.topology_group', 'topology_group'), ('pybind.slxos.v17r_2_00.topology_group', 'topology_group')]
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group.member_vlan', 'pybind.slxos.v17r_1_01a.brocade_topology_group', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group.member_vlan', 'pybind.slxos.v17r_2_00.brocade_topology_group', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group.member_vlan', 'pybind.slxos.v17s_1_02.brocade_topology_group', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group=topology_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group=topology_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group_state', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group_state', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group_state', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.topology_group_state', u'topology_group_data'), ('pybind.slxos.v17r_1_01a.topology_group_state', u'topology_group_data'), ('pybind.slxos.v17r_2_00.topology_group_state', u'topology_group_data')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'topology_group_id, l2_protocol'}, {'leafval': 'topology_group_id, l2_protocol'}, {'leafval': 'topology_group_id, l2_protocol'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_state_topology_group_data_get(self, topology_group_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data', u'master_vlan'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data', u'member_bd'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data', u'member_vlan'), ('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data', u'member_bd'), ('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data', u'member_vlan'), ('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data', u'master_vlan'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data', u'master_vlan'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data', u'member_bd'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data', u'member_vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'topology_group_data', 'keyval': 'topology_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id, control_ports, free_ports'}, {'leafval': 'bd_id, free_ports'}, {'leafval': 'vlan_id, free_ports'}, {'leafval': 'bd_id, free_ports'}, {'leafval': 'vlan_id, free_ports'}, {'leafval': 'vlan_id, control_ports, free_ports'}, {'leafval': 'vlan_id, control_ports, free_ports'}, {'leafval': 'bd_id, free_ports'}, {'leafval': 'vlan_id, free_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_state_topology_group_data_l2_protocol_get(self, topology_group_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data', u'master_vlan'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data', u'member_bd'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data', u'member_vlan'), ('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data', u'member_bd'), ('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data', u'member_vlan'), ('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data', u'master_vlan'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data', u'master_vlan'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data', u'member_bd'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data', u'member_vlan')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'topology_group_data', 'keyval': 'topology_group_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vlan_id, control_ports, free_ports'}, {'leafval': 'bd_id, free_ports'}, {'leafval': 'vlan_id, free_ports'}, {'leafval': 'bd_id, free_ports'}, {'leafval': 'vlan_id, free_ports'}, {'leafval': 'vlan_id, control_ports, free_ports'}, {'leafval': 'vlan_id, control_ports, free_ports'}, {'leafval': 'bd_id, free_ports'}, {'leafval': 'vlan_id, free_ports'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_state_topology_group_data_master_vlan_get(self, topology_group_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data', u'topology_group_data'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data', u'topology_group_data'), ('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data', u'topology_group_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data.master_vlan', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data.master_vlan', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data.master_vlan', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_state_topology_group_data_master_vlan_control_ports_get(self, topology_group_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data', u'topology_group_data'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data', u'topology_group_data'), ('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data', u'topology_group_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data.master_vlan', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data.master_vlan', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data.master_vlan', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_state_topology_group_data_master_vlan_free_ports_get(self, topology_group_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data', u'topology_group_data'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data', u'topology_group_data'), ('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data', u'topology_group_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data.master_vlan', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data.master_vlan', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data.master_vlan', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_state_topology_group_data_master_vlan_vlan_id_get(self, topology_group_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data', u'topology_group_data'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data', u'topology_group_data'), ('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data', u'topology_group_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data.master_vlan', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data.master_vlan', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data.master_vlan', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_state_topology_group_data_member_bd_get(self, topology_group_data=None, member_bd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type member_bd: bd_id
    :param member_bd: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **member_bd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data', u'topology_group_data'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data', u'topology_group_data'), ('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data', u'topology_group_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data.member_bd', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data.member_bd', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data.member_bd', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_bd', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data, member_bd=member_bd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data, member_bd=member_bd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_state_topology_group_data_member_bd_free_ports_get(self, topology_group_data=None, member_bd=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type member_bd: bd_id
    :param member_bd: Keyword argument tuple.

    :type bd_id: long
    :param bd_id: **member_bd** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data', u'topology_group_data'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data', u'topology_group_data'), ('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data', u'topology_group_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data.member_bd', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data.member_bd', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data.member_bd', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_bd', 'keyval': 'bd_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data, member_bd=member_bd)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data, member_bd=member_bd)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_state_topology_group_data_member_vlan_get(self, topology_group_data=None, member_vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type member_vlan: vlan_id
    :param member_vlan: Keyword argument tuple.

    :type vlan_id: int
    :param vlan_id: **member_vlan** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data', u'topology_group_data'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data', u'topology_group_data'), ('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data', u'topology_group_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data.member_vlan', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data.member_vlan', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data.member_vlan', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_vlan', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data, member_vlan=member_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data, member_vlan=member_vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def topology_group_state_topology_group_data_member_vlan_free_ports_get(self, topology_group_data=None, member_vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type topology_group_data: topology_group_id
    :param topology_group_data: Keyword argument tuple.

    :type topology_group_id: int
    :param topology_group_id: **topology_group_data** tuple argument.

        * range restriction: ::

            ['0..65535']

    **Instance Keyword Argument Tuple**:

    :type member_vlan: vlan_id
    :param member_vlan: Keyword argument tuple.

    :type vlan_id: int
    :param vlan_id: **member_vlan** tuple argument.

        * range restriction: ::

            ['0..65535']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data', u'topology_group_data'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data', u'topology_group_data'), ('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data', u'topology_group_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.topology_group_state.topology_group_data.member_vlan', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.topology_group_state.topology_group_data.member_vlan', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.topology_group_state.topology_group_data.member_vlan', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}, {'keyval': 'topology_group_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_vlan', 'keyval': 'vlan_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, topology_group_data=topology_group_data, member_vlan=member_vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, topology_group_data=topology_group_data, member_vlan=member_vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tpvm_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.tpvm', 'pybind.slxos.v17r_1_01a.brocade_tpvm', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tpvm', 'pybind.slxos.v17r_2_00.brocade_tpvm', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tpvm', 'pybind.slxos.v17s_1_02.brocade_tpvm', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_class_exp_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.traffic_class_exp_state', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.traffic_class_exp_state', u'qos_mpls')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'map_type, map_name, enabled_slots'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_class_exp_state_qos_mpls_get(self, qos_mpls=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.traffic_class_exp_state.qos_mpls', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_class_exp_state_qos_mpls_enabled_slots_get(self, qos_mpls=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.traffic_class_exp_state.qos_mpls', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_class_exp_state_qos_mpls_map_type_get(self, qos_mpls=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type qos_mpls: map_name
    :param qos_mpls: Keyword argument tuple.

    :type map_name: unicode
    :param map_name: **qos_mpls** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.traffic_class_exp_state.qos_mpls', 'pybind.slxos.v17s_1_02.brocade_qos_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'qos_mpls', 'keyval': 'map_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, qos_mpls=qos_mpls)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, qos_mpls=qos_mpls)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_l1_csnp_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_l1_csnp_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_l1_hello_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_l1_hello_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_l1_lsp_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_l1_lsp_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_l1_psnp_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_l1_psnp_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_l2_csnp_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_l2_csnp_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_l2_hello_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_l2_hello_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_l2_lsp_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_l2_lsp_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_l2_psnp_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_l2_psnp_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_pp_hello_rx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def traffic_state_pp_hello_tx_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.traffic_state', 'pybind.slxos.v17r_1_01a.brocade_isis_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.traffic_state', 'pybind.slxos.v17r_2_00.brocade_isis_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.traffic_state', 'pybind.slxos.v17s_1_02.brocade_isis_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tunnel_settings_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.tunnel_settings', 'pybind.nos.v6_0_2f.brocade_tunnels', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.tunnel_settings', 'pybind.nos.v7_2_0.brocade_tunnels', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.tunnel_settings', 'pybind.slxos.v17r_1_01a.brocade_tunnels', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.tunnel_settings', 'pybind.slxos.v17r_2_00.brocade_tunnels', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.tunnel_settings', 'pybind.slxos.v17s_1_02.brocade_tunnels', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.tunnel_settings.system.tunnel', u'replicator'), ('pybind.slxos.v17s_1_02.tunnel_settings.system', u'tunnel'), ('pybind.slxos.v17r_2_00.tunnel_settings.system.tunnel', u'replicator'), ('pybind.slxos.v17r_2_00.tunnel_settings.system', u'tunnel'), ('pybind.nos.v7_2_0.tunnel_settings.system', u'tunnel'), ('pybind.nos.v7_2_0.tunnel_settings.system.tunnel', u'replicator'), ('pybind.slxos.v17r_1_01a.tunnel_settings.system.tunnel', u'replicator'), ('pybind.slxos.v17r_1_01a.tunnel_settings.system', u'tunnel'), ('pybind.nos.v6_0_2f.tunnel_settings.system', u'tunnel')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'load_balance'}, {'leafval': 'suppress_debounce'}, {'leafval': 'load_balance'}, {'leafval': 'suppress_debounce'}, {'leafval': 'suppress_debounce'}, {'leafval': 'load_balance'}, {'leafval': 'load_balance'}, {'leafval': 'suppress_debounce'}, {'leafval': 'suppress_debounce'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tunnel_status_state_get(self, tunnel_status_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tunnel_status_state: tunnel_destination
    :param tunnel_status_state: Keyword argument tuple.

    :type tunnel_destination: long
    :param tunnel_destination: **tunnel_status_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.tunnel_status_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'tunnel_status_state', 'keyval': 'tunnel_destination', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_status_state=tunnel_status_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_status_state=tunnel_status_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tunnel_status_state_oper_status_get(self, tunnel_status_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type tunnel_status_state: tunnel_destination
    :param tunnel_status_state: Keyword argument tuple.

    :type tunnel_destination: long
    :param tunnel_destination: **tunnel_status_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.tunnel_status_state', 'pybind.slxos.v17r_2_00.brocade_mpls_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'tunnel_status_state', 'keyval': 'tunnel_destination', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tunnel_status_state=tunnel_status_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tunnel_status_state=tunnel_status_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tvf_domain_get(self, tvf_domain=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tvf_domain: name
    :param tvf_domain: Keyword argument tuple.

    :type name: long
    :param name: **tvf_domain** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.tvf_domain', 'pybind.slxos.v17s_1_02.brocade_tvf_domain', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'tvf_domain', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tvf_domain=tvf_domain)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tvf_domain=tvf_domain)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tvf_domain_list_state_get(self, tvf_domain_list_state=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type tvf_domain_list_state: domain_count
    :param tvf_domain_list_state: Keyword argument tuple.

    :type domain_count: long
    :param domain_count: **tvf_domain_list_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.tvf_domain_list_state', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.tvf_domain_list_state', u'domain_list')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'tvf_domain_list_state', 'keyval': 'domain_count', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'id'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tvf_domain_list_state=tvf_domain_list_state)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tvf_domain_list_state=tvf_domain_list_state)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tvf_domain_list_state_domain_list_get(self, tvf_domain_list_state=None, domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tvf_domain_list_state: domain_count
    :param tvf_domain_list_state: Keyword argument tuple.

    :type domain_count: long
    :param domain_count: **tvf_domain_list_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type domain_list: id
    :param domain_list: Keyword argument tuple.

    :type id: long
    :param id: **domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.tvf_domain_list_state', 'tvf_domain_list_state')]
    bindings_list = [('pybind.slxos.v17s_1_02.tvf_domain_list_state.domain_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.tvf_domain_list_state.domain_list', u'port_list')]
    compositions_keyval_list = [{'keyval': 'domain_count', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'domain_list', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tvf_domain_list_state=tvf_domain_list_state, domain_list=domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tvf_domain_list_state=tvf_domain_list_state, domain_list=domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tvf_domain_list_state_domain_list_port_list_get(self, tvf_domain_list_state=None, domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tvf_domain_list_state: domain_count
    :param tvf_domain_list_state: Keyword argument tuple.

    :type domain_count: long
    :param domain_count: **tvf_domain_list_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type domain_list: id
    :param domain_list: Keyword argument tuple.

    :type id: long
    :param id: **domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.tvf_domain_list_state', 'tvf_domain_list_state'), ('pybind.slxos.v17s_1_02.tvf_domain_list_state.domain_list', u'domain_list')]
    bindings_list = [('pybind.slxos.v17s_1_02.tvf_domain_list_state.domain_list.port_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_count', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tvf_domain_list_state=tvf_domain_list_state, domain_list=domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tvf_domain_list_state=tvf_domain_list_state, domain_list=domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def tvf_domain_list_state_domain_list_port_list_name_get(self, tvf_domain_list_state=None, domain_list=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type tvf_domain_list_state: domain_count
    :param tvf_domain_list_state: Keyword argument tuple.

    :type domain_count: long
    :param domain_count: **tvf_domain_list_state** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type domain_list: id
    :param domain_list: Keyword argument tuple.

    :type id: long
    :param id: **domain_list** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.tvf_domain_list_state', 'tvf_domain_list_state'), ('pybind.slxos.v17s_1_02.tvf_domain_list_state.domain_list', u'domain_list')]
    bindings_list = [('pybind.slxos.v17s_1_02.tvf_domain_list_state.domain_list.port_list', 'pybind.slxos.v17s_1_02.brocade_nsm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'domain_count', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, tvf_domain_list_state=tvf_domain_list_state, domain_list=domain_list)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, tvf_domain_list_state=tvf_domain_list_state, domain_list=domain_list)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.uda', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.uda.access_list', u'extended')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_access_list_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.uda.access_list', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.uda.access_list', u'extended')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_access_list_extended_get(self, extended=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended.uda_acl_ext', u'seq')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'seq_id, action, uda_value0, uda_value_mask0, uda_value1, uda_value_mask1, uda_value2, uda_value_mask2, uda_value3, uda_value_mask3, count, log, mirror, sflow'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_access_list_extended_seq_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id, action, uda_value0, uda_value_mask0, uda_value1, uda_value_mask1, uda_value2, uda_value_mask2, uda_value3, uda_value_mask3, count, log, mirror, sflow
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type action: unicode
    :param action: **seq** tuple argument.

        * enumeration restriction: ::

            ['deny', 'permit']

    :type uda_value0: unicode
    :param uda_value0: **seq** tuple argument:  uda-value0

        * pattern restriction: ::

            '0x[0-9a-fA-F]{1,8}'

    :type uda_value_mask0: unicode
    :param uda_value_mask0: **seq** tuple argument:  mask0

        * pattern restriction: ::

            '0x[0-9a-fA-F]{1,8}'

    :type uda_value1: unicode
    :param uda_value1: **seq** tuple argument:  uda-value1

        * pattern restriction: ::

            '0x[0-9a-fA-F]{1,8}'

    :type uda_value_mask1: unicode
    :param uda_value_mask1: **seq** tuple argument:  mask1

        * pattern restriction: ::

            '0x[0-9a-fA-F]{1,8}'

    :type uda_value2: unicode
    :param uda_value2: **seq** tuple argument:  uda-value2

        * pattern restriction: ::

            '0x[0-9a-fA-F]{1,8}'

    :type uda_value_mask2: unicode
    :param uda_value_mask2: **seq** tuple argument:  mask2

        * pattern restriction: ::

            '0x[0-9a-fA-F]{1,8}'

    :type uda_value3: unicode
    :param uda_value3: **seq** tuple argument:  uda-value3

        * pattern restriction: ::

            '0x[0-9a-fA-F]{1,8}'

    :type uda_value_mask3: unicode
    :param uda_value_mask3: **seq** tuple argument:  mask3

        * pattern restriction: ::

            '0x[0-9a-fA-F]{1,8}'

    :type count: YANGBool
    :param count: **seq** tuple argument:  Packet count

    :type log: YANGBool
    :param log: **seq** tuple argument:  Log Packet

    :type mirror: YANGBool
    :param mirror: **seq** tuple argument:  Mirror packet

    :type sflow: YANGBool
    :param sflow: **seq** tuple argument:  Copy to sFlow Collector

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended.uda_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': 'seq_id, action, uda_value0, uda_value_mask0, uda_value1, uda_value_mask1, uda_value2, uda_value_mask2, uda_value3, uda_value_mask3, count, log, mirror, sflow'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_access_list_extended_seq_action_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended.uda_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_access_list_extended_seq_count_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended.uda_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_access_list_extended_seq_log_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended.uda_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_access_list_extended_seq_mirror_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended.uda_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_access_list_extended_seq_sflow_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended.uda_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_access_list_extended_seq_uda_value0_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended.uda_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_access_list_extended_seq_uda_value1_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended.uda_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_access_list_extended_seq_uda_value2_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended.uda_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_access_list_extended_seq_uda_value3_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended.uda_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_access_list_extended_seq_uda_value_mask0_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended.uda_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_access_list_extended_seq_uda_value_mask1_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended.uda_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_access_list_extended_seq_uda_value_mask2_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended.uda_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_access_list_extended_seq_uda_value_mask3_get(self, extended=None, seq=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type extended: name
    :param extended: Keyword argument tuple.

    :type name: unicode
    :param name: **extended** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    **Instance Keyword Argument Tuple**:

    :type seq: seq_id
    :param seq: Keyword argument tuple.

    :type seq_id: long
    :param seq_id: **seq** tuple argument.

        * range restriction: ::

            ['0..18446744073709551615']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended', u'extended')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda.access_list.extended.uda_acl_ext.seq', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'seq', 'keyval': 'seq_id', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended=extended, seq=seq)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended=extended, seq=seq)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_key_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.uda_key', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.uda_key', u'profile')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_key_profile_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type profile: name
    :param profile: Keyword argument tuple.

    :type name: unicode
    :param name: **profile** tuple argument:  PROFILE_NAME;; UDA Key Profile Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.uda_key.profile', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.uda_key.profile', u'uda_profile_offsets')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'profile', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'offset_base1, negative1, uda_offset1, offset_base2, negative2, uda_offset2, offset_base3, negative3, uda_offset3, offset_base4, negative4, uda_offset4'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_key_profile_uda_offsets_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: name
    :param profile: Keyword argument tuple.

    :type name: unicode
    :param name: **profile** tuple argument:  PROFILE_NAME;; UDA Key Profile Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda_key.profile', u'profile')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda_key.profile.uda_profile_offsets', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'offset_base1, negative1, uda_offset1, offset_base2, negative2, uda_offset2, offset_base3, negative3, uda_offset3, offset_base4, negative4, uda_offset4'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_key_profile_uda_offsets_negative_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: name
    :param profile: Keyword argument tuple.

    :type name: unicode
    :param name: **profile** tuple argument:  PROFILE_NAME;; UDA Key Profile Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda_key.profile', u'profile')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda_key.profile.uda_profile_offsets', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_key_profile_uda_offsets_offset_base1_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: name
    :param profile: Keyword argument tuple.

    :type name: unicode
    :param name: **profile** tuple argument:  PROFILE_NAME;; UDA Key Profile Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda_key.profile', u'profile')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda_key.profile.uda_profile_offsets', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_key_profile_uda_offsets_offset_base2_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: name
    :param profile: Keyword argument tuple.

    :type name: unicode
    :param name: **profile** tuple argument:  PROFILE_NAME;; UDA Key Profile Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda_key.profile', u'profile')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda_key.profile.uda_profile_offsets', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_key_profile_uda_offsets_offset_base3_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: name
    :param profile: Keyword argument tuple.

    :type name: unicode
    :param name: **profile** tuple argument:  PROFILE_NAME;; UDA Key Profile Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda_key.profile', u'profile')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda_key.profile.uda_profile_offsets', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_key_profile_uda_offsets_offset_base4_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: name
    :param profile: Keyword argument tuple.

    :type name: unicode
    :param name: **profile** tuple argument:  PROFILE_NAME;; UDA Key Profile Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda_key.profile', u'profile')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda_key.profile.uda_profile_offsets', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_key_profile_uda_offsets_uda_offset1_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: name
    :param profile: Keyword argument tuple.

    :type name: unicode
    :param name: **profile** tuple argument:  PROFILE_NAME;; UDA Key Profile Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda_key.profile', u'profile')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda_key.profile.uda_profile_offsets', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_key_profile_uda_offsets_uda_offset2_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: name
    :param profile: Keyword argument tuple.

    :type name: unicode
    :param name: **profile** tuple argument:  PROFILE_NAME;; UDA Key Profile Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda_key.profile', u'profile')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda_key.profile.uda_profile_offsets', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_key_profile_uda_offsets_uda_offset3_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: name
    :param profile: Keyword argument tuple.

    :type name: unicode
    :param name: **profile** tuple argument:  PROFILE_NAME;; UDA Key Profile Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda_key.profile', u'profile')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda_key.profile.uda_profile_offsets', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uda_key_profile_uda_offsets_uda_offset4_get(self, profile=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type profile: name
    :param profile: Keyword argument tuple.

    :type name: unicode
    :param name: **profile** tuple argument:  PROFILE_NAME;; UDA Key Profile Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.uda_key.profile', u'profile')]
    bindings_list = [('pybind.slxos.v17r_2_00.uda_key.profile.uda_profile_offsets', 'pybind.slxos.v17r_2_00.brocade_uda_access_list', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, profile=profile)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, profile=profile)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uplink_switch_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.uplink_switch', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def uplink_switch_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.uplink_switch', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def urpf_exclude_default_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.rpf_config', 'pybind.nos.v7_2_0.brocade_rpf', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.rpf_config', 'pybind.slxos.v17r_1_01a.brocade_rpf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.rpf_config', 'pybind.slxos.v17r_2_00.brocade_rpf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.rpf_config', 'pybind.slxos.v17s_1_02.brocade_rpf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def username_get(self, username=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type username: name, user_password, encryption_level, role, desc, enable, expire
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type user_password: unicode
    :param user_password: **username** tuple argument:  Password of the user

        * length restriction: ::

            ['1..40']

    :type encryption_level: unicode
    :param encryption_level: **username** tuple argument:  Level of encryption of the password(default=0)

        * enumeration restriction: ::

            ['0', '7']

    :type role: unicode
    :param role: **username** tuple argument:  Role of the user

        * length restriction: ::

            ['4 .. 32']

    :type desc: unicode
    :param desc: **username** tuple argument:  Description of the user (default='')

        * length restriction: ::

            ['0 .. 64']

    :type enable: YANGBool
    :param enable: **username** tuple argument:  Represents whether the user account is enabled(default=true)

    :type expire: unicode
    :param expire: **username** tuple argument:  Date until when the password will remain valid after being updated(default=never)

        * length restriction: ::

            ['0 .. 10']

        * pattern restriction: ::

            '((19(0[2-9]|[1-9][0-9])|20([012][0-9]|3[0-7]))-('
            '0[1-9]|1[012])-(0[1-9]|[12][0-9]|3[01]))|never'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.username', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.username', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.username', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.username', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.username', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': 'name, user_password, encryption_level, role, desc, enable, expire, access_time, end_time'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.username": {}, "pybind.nos.v6_0_2f.username": {"encryption_level": "encryption_level", "enable": "enable", "name": "name", "user_password": "user_password", "expire": "expire", "role": "role", "desc": "desc"}, "pybind.slxos.v17s_1_02.username": {}, "pybind.nos.v7_2_0.username": {}, "pybind.slxos.v17r_1_01a.username": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def username_access_time_get(self, username=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type username: name
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.username', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.username', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.username', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.username', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def username_desc_get(self, username=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type username: name
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.username', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.username', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.username', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.username', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.username', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def username_enable_get(self, username=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type username: name
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.username', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.username', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.username', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.username', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.username', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def username_encryption_level_get(self, username=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type username: name
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.username', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.username', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.username', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.username', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.username', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def username_expire_get(self, username=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type username: name
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.username', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.username', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.username', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.username', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.username', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def username_password_get(self, username=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type username: name
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.username', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.username', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.username', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.username', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.username', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def username_role_get(self, username=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type username: name
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.username', 'pybind.nos.v6_0_2f.brocade_aaa', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.username', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.username', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.username', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.username', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def username_to_get(self, username=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type username: name
    :param username: Keyword argument tuple.

    :type name: unicode
    :param name: **username** tuple argument.

        * length restriction: ::

            ['1 .. 40']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.username', 'pybind.nos.v7_2_0.brocade_aaa', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.username', 'pybind.slxos.v17r_1_01a.brocade_aaa', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.username', 'pybind.slxos.v17r_2_00.brocade_aaa', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.username', 'pybind.slxos.v17s_1_02.brocade_aaa', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'username', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, username=username)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, username=username)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.vc_peer_state', u'vc_peer_data'), ('pybind.slxos.v17s_1_02.vc_peer_state', u'vc_peer_data'), ('pybind.slxos.v17r_1_01a.vc_peer_state', u'vc_peer_data')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_id, vc_peer_address, vc_peer_state, vc_peer_uptime, vc_peer_load_balance, vc_peer_cos_enabled, vc_peer_cos_value, vc_ldp_tnnl_in_use, vc_local_label, vc_remote_label, vc_local_mtu, vc_remote_mtu, vc_local_type, vc_remote_type'}, {'leafval': 'vc_id, vc_peer_address, vc_peer_state, vc_peer_uptime, vc_peer_load_balance, vc_peer_cos_enabled, vc_peer_cos_value, vc_ldp_tnnl_in_use, vc_local_label, vc_remote_label, vc_local_mtu, vc_remote_mtu, vc_local_type, vc_remote_type'}, {'leafval': 'vc_id, vc_peer_address, vc_peer_state, vc_peer_uptime, vc_peer_load_balance, vc_peer_cos_enabled, vc_peer_cos_value, vc_ldp_tnnl_in_use, vc_local_label, vc_remote_label, vc_local_mtu, vc_remote_mtu, vc_local_type, vc_remote_type'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_get(self, vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_proto_tnnl')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_assigned_lsp_get(self, vc_peer_data=None, vc_assigned_lsp=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_assigned_lsp: vc_lsp_name
    :param vc_assigned_lsp: Keyword argument tuple.

    :type vc_lsp_name: unicode
    :param vc_lsp_name: **vc_assigned_lsp** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_peer_data'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_peer_data'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_peer_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data.vc_assigned_lsp', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data.vc_assigned_lsp', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data.vc_assigned_lsp', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_assigned_lsp', 'keyval': 'vc_lsp_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data, vc_assigned_lsp=vc_assigned_lsp)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data, vc_assigned_lsp=vc_assigned_lsp)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_ldp_tnnl_in_use_get(self, vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_proto_tnnl')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_local_label_get(self, vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_proto_tnnl')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_local_mtu_get(self, vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_proto_tnnl')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_local_type_get(self, vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_proto_tnnl')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_peer_address_get(self, vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_proto_tnnl')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_peer_cos_enabled_get(self, vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_proto_tnnl')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_peer_cos_value_get(self, vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_proto_tnnl')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_peer_load_balance_get(self, vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_proto_tnnl')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_peer_state_get(self, vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_proto_tnnl')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_peer_uptime_get(self, vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_proto_tnnl')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_proto_tnnl_get(self, vc_peer_data=None, vc_proto_tnnl=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_peer_data'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_peer_data'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_peer_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_proto_tnnl_vc_ldp_name_get(self, vc_peer_data=None, vc_proto_tnnl=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_peer_data'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_peer_data'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_peer_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_proto_tnnl_vc_ldp_tunnel_id_get(self, vc_peer_data=None, vc_proto_tnnl=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_peer_data'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_peer_data'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_peer_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_proto_tnnl_vc_lsp_name_get(self, vc_peer_data=None, vc_proto_tnnl=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_peer_data'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_peer_data'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_peer_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_proto_tnnl_vc_peer_lsp_cos_enabled_get(self, vc_peer_data=None, vc_proto_tnnl=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_peer_data'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_peer_data'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_peer_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_proto_tnnl_vc_peer_lsp_cos_value_get(self, vc_peer_data=None, vc_proto_tnnl=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type vc_proto_tnnl: vc_proto_name
    :param vc_proto_tnnl: Keyword argument tuple.

    :type vc_proto_name: unicode
    :param vc_proto_name: **vc_proto_tnnl** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_peer_data'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_peer_data'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_peer_data')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data.vc_proto_tnnl', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}, {'keyval': 'vc_id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'vc_proto_tnnl', 'keyval': 'vc_proto_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data, vc_proto_tnnl=vc_proto_tnnl)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_remote_label_get(self, vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_proto_tnnl')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_remote_mtu_get(self, vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_proto_tnnl')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vc_peer_state_vc_peer_data_vc_remote_type_get(self, vc_peer_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vc_peer_data: vc_id
    :param vc_peer_data: Keyword argument tuple.

    :type vc_id: long
    :param vc_id: **vc_peer_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_1_01a.brocade_pwm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', 'pybind.slxos.v17r_2_00.brocade_pwm_operational', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', 'pybind.slxos.v17s_1_02.brocade_pwm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17s_1_02.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_proto_tnnl'), ('pybind.slxos.v17r_1_01a.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_assigned_lsp'), ('pybind.slxos.v17r_2_00.vc_peer_state.vc_peer_data', u'vc_proto_tnnl')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vc_peer_data', 'keyval': 'vc_id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_lsp_name'}, {'leafval': 'vc_proto_name, vc_ldp_tunnel_id, vc_ldp_name, vc_lsp_name, vc_peer_lsp_cos_enabled, vc_peer_lsp_cos_value'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vc_peer_data=vc_peer_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vc_peer_data=vc_peer_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcenter_get(self, vcenter=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vcenter', 'pybind.nos.v6_0_2f.brocade_vswitch', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcenter', 'pybind.nos.v7_2_0.brocade_vswitch', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcenter', 'pybind.slxos.v17r_1_01a.brocade_vswitch', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcenter', 'pybind.slxos.v17r_2_00.brocade_vswitch', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcenter', 'pybind.slxos.v17s_1_02.brocade_vswitch', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.vcenter.discovery', u'ignore_delete_all_response'), ('pybind.nos.v6_0_2f.vcenter', u'credentials'), ('pybind.slxos.v17r_2_00.vcenter', u'credentials'), ('pybind.slxos.v17r_2_00.vcenter.discovery', u'ignore_delete_all_response'), ('pybind.slxos.v17r_1_01a.vcenter.discovery', u'ignore_delete_all_response'), ('pybind.slxos.v17r_1_01a.vcenter', u'credentials'), ('pybind.slxos.v17s_1_02.vcenter.discovery', u'ignore_delete_all_response'), ('pybind.slxos.v17s_1_02.vcenter', u'credentials'), ('pybind.nos.v7_2_0.vcenter', u'credentials'), ('pybind.nos.v7_2_0.vcenter.discovery', u'ignore_delete_all_response')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'vcenter', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ignore_value, always'}, {'leafval': 'url, username, password'}, {'leafval': 'url, username, password'}, {'leafval': 'ignore_value, always'}, {'leafval': 'ignore_value, always'}, {'leafval': 'url, username, password'}, {'leafval': 'ignore_value, always'}, {'leafval': 'url, username, password'}, {'leafval': 'url, username, password, vrf_name'}, {'leafval': 'ignore_value, always'}]
    leafval_map = {"pybind.slxos.v17r_2_00.vcenter": {"activate": "activate", "id": "id", "interval": "interval"}, "pybind.slxos.v17r_1_01a.vcenter": {"activate": "activate", "id": "id", "interval": "interval"}, "pybind.nos.v6_0_2f.vcenter": {"activate": "activate", "id": "id", "interval": "interval"}, "pybind.slxos.v17s_1_02.vcenter": {"activate": "activate", "id": "id", "interval": "interval"}, "pybind.nos.v7_2_0.vcenter": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcenter_activate_get(self, vcenter=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vcenter', 'pybind.nos.v6_0_2f.brocade_vswitch', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcenter', 'pybind.nos.v7_2_0.brocade_vswitch', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcenter', 'pybind.slxos.v17r_1_01a.brocade_vswitch', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcenter', 'pybind.slxos.v17r_2_00.brocade_vswitch', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcenter', 'pybind.slxos.v17s_1_02.brocade_vswitch', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.vcenter.discovery', u'ignore_delete_all_response'), ('pybind.nos.v6_0_2f.vcenter', u'credentials'), ('pybind.slxos.v17r_2_00.vcenter', u'credentials'), ('pybind.slxos.v17r_2_00.vcenter.discovery', u'ignore_delete_all_response'), ('pybind.slxos.v17r_1_01a.vcenter.discovery', u'ignore_delete_all_response'), ('pybind.slxos.v17r_1_01a.vcenter', u'credentials'), ('pybind.slxos.v17s_1_02.vcenter.discovery', u'ignore_delete_all_response'), ('pybind.slxos.v17s_1_02.vcenter', u'credentials'), ('pybind.nos.v7_2_0.vcenter', u'credentials'), ('pybind.nos.v7_2_0.vcenter.discovery', u'ignore_delete_all_response')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'vcenter', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ignore_value, always'}, {'leafval': 'url, username, password'}, {'leafval': 'url, username, password'}, {'leafval': 'ignore_value, always'}, {'leafval': 'ignore_value, always'}, {'leafval': 'url, username, password'}, {'leafval': 'ignore_value, always'}, {'leafval': 'url, username, password'}, {'leafval': 'url, username, password, vrf_name'}, {'leafval': 'ignore_value, always'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcenter_discovery_get(self, vcenter=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.vcenter', 'vcenter'), ('pybind.nos.v6_0_2f.vcenter', 'vcenter'), ('pybind.slxos.v17s_1_02.vcenter', 'vcenter'), ('pybind.slxos.v17r_1_01a.vcenter', 'vcenter'), ('pybind.slxos.v17r_2_00.vcenter', 'vcenter')]
    bindings_list = [('pybind.nos.v6_0_2f.vcenter.discovery', 'pybind.nos.v6_0_2f.brocade_vswitch', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcenter.discovery', 'pybind.nos.v7_2_0.brocade_vswitch', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcenter.discovery', 'pybind.slxos.v17r_1_01a.brocade_vswitch', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcenter.discovery', 'pybind.slxos.v17r_2_00.brocade_vswitch', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcenter.discovery', 'pybind.slxos.v17s_1_02.brocade_vswitch', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcenter_discovery_ignore_delete_all_response_get(self, vcenter=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.vcenter', 'vcenter'), ('pybind.nos.v7_2_0.vcenter', 'vcenter'), ('pybind.slxos.v17r_2_00.vcenter', 'vcenter'), ('pybind.slxos.v17r_1_01a.vcenter', 'vcenter'), ('pybind.slxos.v17s_1_02.vcenter', 'vcenter')]
    bindings_list = [('pybind.nos.v6_0_2f.vcenter.discovery.ignore_delete_all_response', 'pybind.nos.v6_0_2f.brocade_vswitch', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcenter.discovery.ignore_delete_all_response', 'pybind.nos.v7_2_0.brocade_vswitch', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcenter.discovery.ignore_delete_all_response', 'pybind.slxos.v17r_1_01a.brocade_vswitch', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcenter.discovery.ignore_delete_all_response', 'pybind.slxos.v17r_2_00.brocade_vswitch', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcenter.discovery.ignore_delete_all_response', 'pybind.slxos.v17s_1_02.brocade_vswitch', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcenter_discovery_ignore_delete_all_response_always_get(self, vcenter=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.vcenter', 'vcenter'), ('pybind.nos.v7_2_0.vcenter', 'vcenter'), ('pybind.slxos.v17r_2_00.vcenter', 'vcenter'), ('pybind.slxos.v17r_1_01a.vcenter', 'vcenter'), ('pybind.slxos.v17s_1_02.vcenter', 'vcenter')]
    bindings_list = [('pybind.nos.v6_0_2f.vcenter.discovery.ignore_delete_all_response', 'pybind.nos.v6_0_2f.brocade_vswitch', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcenter.discovery.ignore_delete_all_response', 'pybind.nos.v7_2_0.brocade_vswitch', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcenter.discovery.ignore_delete_all_response', 'pybind.slxos.v17r_1_01a.brocade_vswitch', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcenter.discovery.ignore_delete_all_response', 'pybind.slxos.v17r_2_00.brocade_vswitch', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcenter.discovery.ignore_delete_all_response', 'pybind.slxos.v17s_1_02.brocade_vswitch', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcenter_discovery_ignore_delete_all_response_ignore_value_get(self, vcenter=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.vcenter', 'vcenter'), ('pybind.nos.v7_2_0.vcenter', 'vcenter'), ('pybind.slxos.v17r_2_00.vcenter', 'vcenter'), ('pybind.slxos.v17r_1_01a.vcenter', 'vcenter'), ('pybind.slxos.v17s_1_02.vcenter', 'vcenter')]
    bindings_list = [('pybind.nos.v6_0_2f.vcenter.discovery.ignore_delete_all_response', 'pybind.nos.v6_0_2f.brocade_vswitch', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcenter.discovery.ignore_delete_all_response', 'pybind.nos.v7_2_0.brocade_vswitch', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcenter.discovery.ignore_delete_all_response', 'pybind.slxos.v17r_1_01a.brocade_vswitch', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcenter.discovery.ignore_delete_all_response', 'pybind.slxos.v17r_2_00.brocade_vswitch', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcenter.discovery.ignore_delete_all_response', 'pybind.slxos.v17s_1_02.brocade_vswitch', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcenter_interval_get(self, vcenter=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vcenter', 'pybind.nos.v6_0_2f.brocade_vswitch', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcenter', 'pybind.nos.v7_2_0.brocade_vswitch', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcenter', 'pybind.slxos.v17r_1_01a.brocade_vswitch', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcenter', 'pybind.slxos.v17r_2_00.brocade_vswitch', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcenter', 'pybind.slxos.v17s_1_02.brocade_vswitch', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.vcenter.discovery', u'ignore_delete_all_response'), ('pybind.nos.v6_0_2f.vcenter', u'credentials'), ('pybind.slxos.v17r_2_00.vcenter', u'credentials'), ('pybind.slxos.v17r_2_00.vcenter.discovery', u'ignore_delete_all_response'), ('pybind.slxos.v17r_1_01a.vcenter.discovery', u'ignore_delete_all_response'), ('pybind.slxos.v17r_1_01a.vcenter', u'credentials'), ('pybind.slxos.v17s_1_02.vcenter.discovery', u'ignore_delete_all_response'), ('pybind.slxos.v17s_1_02.vcenter', u'credentials'), ('pybind.nos.v7_2_0.vcenter', u'credentials'), ('pybind.nos.v7_2_0.vcenter.discovery', u'ignore_delete_all_response')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'vcenter', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ignore_value, always'}, {'leafval': 'url, username, password'}, {'leafval': 'url, username, password'}, {'leafval': 'ignore_value, always'}, {'leafval': 'ignore_value, always'}, {'leafval': 'url, username, password'}, {'leafval': 'ignore_value, always'}, {'leafval': 'url, username, password'}, {'leafval': 'url, username, password, vrf_name'}, {'leafval': 'ignore_value, always'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcenter_password_get(self, vcenter=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vcenter', 'vcenter'), ('pybind.nos.v7_2_0.vcenter', 'vcenter'), ('pybind.slxos.v17r_2_00.vcenter', 'vcenter'), ('pybind.slxos.v17s_1_02.vcenter', 'vcenter'), ('pybind.nos.v6_0_2f.vcenter', 'vcenter')]
    bindings_list = [('pybind.nos.v6_0_2f.vcenter.credentials', 'pybind.nos.v6_0_2f.brocade_vswitch', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcenter.credentials', 'pybind.nos.v7_2_0.brocade_vswitch', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcenter.credentials', 'pybind.slxos.v17r_1_01a.brocade_vswitch', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcenter.credentials', 'pybind.slxos.v17r_2_00.brocade_vswitch', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcenter.credentials', 'pybind.slxos.v17s_1_02.brocade_vswitch', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcenter_url_get(self, vcenter=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vcenter', 'vcenter'), ('pybind.nos.v7_2_0.vcenter', 'vcenter'), ('pybind.slxos.v17r_2_00.vcenter', 'vcenter'), ('pybind.slxos.v17s_1_02.vcenter', 'vcenter'), ('pybind.nos.v6_0_2f.vcenter', 'vcenter')]
    bindings_list = [('pybind.nos.v6_0_2f.vcenter.credentials', 'pybind.nos.v6_0_2f.brocade_vswitch', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcenter.credentials', 'pybind.nos.v7_2_0.brocade_vswitch', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcenter.credentials', 'pybind.slxos.v17r_1_01a.brocade_vswitch', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcenter.credentials', 'pybind.slxos.v17r_2_00.brocade_vswitch', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcenter.credentials', 'pybind.slxos.v17s_1_02.brocade_vswitch', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcenter_use_vrf_get(self, vcenter=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.vcenter', 'vcenter')]
    bindings_list = [('pybind.nos.v7_2_0.vcenter.credentials', 'pybind.nos.v7_2_0.brocade_vswitch', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcenter_username_get(self, vcenter=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vcenter', 'vcenter'), ('pybind.nos.v7_2_0.vcenter', 'vcenter'), ('pybind.slxos.v17r_2_00.vcenter', 'vcenter'), ('pybind.slxos.v17s_1_02.vcenter', 'vcenter'), ('pybind.nos.v6_0_2f.vcenter', 'vcenter')]
    bindings_list = [('pybind.nos.v6_0_2f.vcenter.credentials', 'pybind.nos.v6_0_2f.brocade_vswitch', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcenter.credentials', 'pybind.nos.v7_2_0.brocade_vswitch', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcenter.credentials', 'pybind.slxos.v17r_1_01a.brocade_vswitch', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcenter.credentials', 'pybind.slxos.v17r_2_00.brocade_vswitch', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcenter.credentials', 'pybind.slxos.v17s_1_02.brocade_vswitch', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}, {'keyval': 'id', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcenter_vlan_create_get(self, vcenter=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type vcenter: id
    :param vcenter: Keyword argument tuple.

    :type id: unicode
    :param id: **vcenter** tuple argument:  NAME;;vCenter name (Max Size - 32)

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,31})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.vcenter', 'pybind.nos.v7_2_0.brocade_vswitch', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v7_2_0.vcenter', u'credentials'), ('pybind.nos.v7_2_0.vcenter.discovery', u'ignore_delete_all_response')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'vcenter', 'keyval': 'id', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'url, username, password, vrf_name'}, {'leafval': 'ignore_value, always'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vcenter=vcenter)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vcenter=vcenter)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcs_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vcs', 'pybind.nos.v6_0_2f.brocade_vcs', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcs', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcs', 'pybind.slxos.v17r_1_01a.brocade_vcs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcs', 'pybind.slxos.v17r_2_00.brocade_vcs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcs', 'pybind.slxos.v17s_1_02.brocade_vcs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.vcs.virtual.ip', u'address'), ('pybind.slxos.v17r_2_00.vcs', u'virtual_fabric'), ('pybind.slxos.v17r_2_00.vcs.virtual.ipv6', u'address'), ('pybind.nos.v7_2_0.vcs', u'auto_config_backup'), ('pybind.nos.v7_2_0.vcs.virtual.ipv6', u'address'), ('pybind.nos.v7_2_0.vcs', u'virtual_fabric'), ('pybind.nos.v7_2_0.vcs.virtual.ip', u'address'), ('pybind.slxos.v17s_1_02.vcs', u'virtual_fabric'), ('pybind.slxos.v17s_1_02.vcs.virtual.ipv6', u'address'), ('pybind.slxos.v17s_1_02.vcs.virtual.ip', u'address'), ('pybind.nos.v6_0_2f.vcs.virtual.ipv6', u'address'), ('pybind.nos.v6_0_2f.vcs.virtual.ip', u'address'), ('pybind.nos.v6_0_2f.vcs', u'virtual_fabric'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ipv6', u'address'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ip', u'address'), ('pybind.slxos.v17r_1_01a.vcs', u'virtual_fabric')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'address'}, {'leafval': 'vfab_enable'}, {'leafval': 'ipv6address'}, {'leafval': 'timer'}, {'leafval': 'ipv6address'}, {'leafval': 'vfab_enable'}, {'leafval': 'address'}, {'leafval': 'vfab_enable'}, {'leafval': 'ipv6address'}, {'leafval': 'address'}, {'leafval': 'ipv6address'}, {'leafval': 'address'}, {'leafval': 'vfab_enable'}, {'leafval': 'ipv6address'}, {'leafval': 'address'}, {'leafval': 'vfab_enable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcs_auto_config_backup_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.vcs.auto_config_backup', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcs_auto_config_backup_timer_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.vcs.auto_config_backup', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcs_virtual_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vcs.virtual', 'pybind.nos.v6_0_2f.brocade_vcs', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcs.virtual', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcs.virtual', 'pybind.slxos.v17r_1_01a.brocade_vcs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcs.virtual', 'pybind.slxos.v17r_2_00.brocade_vcs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcs.virtual', 'pybind.slxos.v17s_1_02.brocade_vcs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.vcs.virtual.ip', u'address'), ('pybind.slxos.v17r_2_00.vcs.virtual.ipv6', u'address'), ('pybind.nos.v6_0_2f.vcs.virtual.ipv6', u'address'), ('pybind.nos.v6_0_2f.vcs.virtual.ip', u'address'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ipv6', u'address'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ip', u'address'), ('pybind.slxos.v17s_1_02.vcs.virtual.ipv6', u'address'), ('pybind.slxos.v17s_1_02.vcs.virtual.ip', u'address'), ('pybind.nos.v7_2_0.vcs.virtual.ipv6', u'address'), ('pybind.nos.v7_2_0.vcs.virtual.ip', u'address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'address'}, {'leafval': 'ipv6address'}, {'leafval': 'ipv6address'}, {'leafval': 'address'}, {'leafval': 'ipv6address'}, {'leafval': 'address'}, {'leafval': 'ipv6address'}, {'leafval': 'address'}, {'leafval': 'ipv6address'}, {'leafval': 'address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcs_virtual_fabric_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vcs.virtual_fabric', 'pybind.nos.v6_0_2f.brocade_vcs', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcs.virtual_fabric', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcs.virtual_fabric', 'pybind.slxos.v17r_1_01a.brocade_vcs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcs.virtual_fabric', 'pybind.slxos.v17r_2_00.brocade_vcs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcs.virtual_fabric', 'pybind.slxos.v17s_1_02.brocade_vcs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcs_virtual_fabric_enable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vcs.virtual_fabric', 'pybind.nos.v6_0_2f.brocade_vcs', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcs.virtual_fabric', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcs.virtual_fabric', 'pybind.slxos.v17r_1_01a.brocade_vcs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcs.virtual_fabric', 'pybind.slxos.v17r_2_00.brocade_vcs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcs.virtual_fabric', 'pybind.slxos.v17s_1_02.brocade_vcs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcs_virtual_ip_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vcs.virtual.ip', 'pybind.nos.v6_0_2f.brocade_vcs', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcs.virtual.ip', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ip', 'pybind.slxos.v17r_1_01a.brocade_vcs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcs.virtual.ip', 'pybind.slxos.v17r_2_00.brocade_vcs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcs.virtual.ip', 'pybind.slxos.v17s_1_02.brocade_vcs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.vcs.virtual.ip', u'address'), ('pybind.nos.v6_0_2f.vcs.virtual.ip', u'address'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ip', u'address'), ('pybind.nos.v7_2_0.vcs.virtual.ip', u'address'), ('pybind.slxos.v17s_1_02.vcs.virtual.ip', u'address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'address'}, {'leafval': 'address'}, {'leafval': 'address'}, {'leafval': 'address'}, {'leafval': 'address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcs_virtual_ip_address_get(self, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  Virtual IP address (IPv4 Address/Prefix)

        * pattern restriction: ::

            '((0|(1[0-9]{0,2})|(2(([0-4][0-9]?)|(5[0-5]?)|([6'
            '-9]?)))|([3-9][0-9]?))\.){3}(0|(1[0-9]{0,2})|(2('
            '([0-4][0-9]?)|(5[0-5]?)|([6-9]?)))|([3-9][0-9]?)'
            ')/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vcs.virtual.ip.address', 'pybind.nos.v6_0_2f.brocade_vcs', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcs.virtual.ip.address', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ip.address', 'pybind.slxos.v17r_1_01a.brocade_vcs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcs.virtual.ip.address', 'pybind.slxos.v17r_2_00.brocade_vcs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcs.virtual.ip.address', 'pybind.slxos.v17s_1_02.brocade_vcs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.vcs.virtual.ip.address.inband', u'interface'), ('pybind.slxos.v17s_1_02.vcs.virtual.ip.address.inband', u'interface'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ip.address.inband', u'interface'), ('pybind.nos.v6_0_2f.vcs.virtual.ip.address.inband', u'interface'), ('pybind.nos.v7_2_0.vcs.virtual.ip.address.inband', u'interface')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'address', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 've'}, {'leafval': 've'}, {'leafval': 've'}, {'leafval': 've'}, {'leafval': 've'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcs_virtual_ip_address_inband_get(self, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  Virtual IP address (IPv4 Address/Prefix)

        * pattern restriction: ::

            '((0|(1[0-9]{0,2})|(2(([0-4][0-9]?)|(5[0-5]?)|([6'
            '-9]?)))|([3-9][0-9]?))\.){3}(0|(1[0-9]{0,2})|(2('
            '([0-4][0-9]?)|(5[0-5]?)|([6-9]?)))|([3-9][0-9]?)'
            ')/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.vcs.virtual.ip.address', u'address'), ('pybind.slxos.v17r_2_00.vcs.virtual.ip.address', u'address'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ip.address', u'address'), ('pybind.slxos.v17s_1_02.vcs.virtual.ip.address', u'address'), ('pybind.nos.v6_0_2f.vcs.virtual.ip.address', u'address')]
    bindings_list = [('pybind.nos.v6_0_2f.vcs.virtual.ip.address.inband', 'pybind.nos.v6_0_2f.brocade_vcs', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcs.virtual.ip.address.inband', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ip.address.inband', 'pybind.slxos.v17r_1_01a.brocade_vcs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcs.virtual.ip.address.inband', 'pybind.slxos.v17r_2_00.brocade_vcs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcs.virtual.ip.address.inband', 'pybind.slxos.v17s_1_02.brocade_vcs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcs_virtual_ip_address_inband_interface_get(self, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  Virtual IP address (IPv4 Address/Prefix)

        * pattern restriction: ::

            '((0|(1[0-9]{0,2})|(2(([0-4][0-9]?)|(5[0-5]?)|([6'
            '-9]?)))|([3-9][0-9]?))\.){3}(0|(1[0-9]{0,2})|(2('
            '([0-4][0-9]?)|(5[0-5]?)|([6-9]?)))|([3-9][0-9]?)'
            ')/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.vcs.virtual.ip.address', u'address'), ('pybind.slxos.v17s_1_02.vcs.virtual.ip.address', u'address'), ('pybind.nos.v7_2_0.vcs.virtual.ip.address', u'address'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ip.address', u'address'), ('pybind.slxos.v17r_2_00.vcs.virtual.ip.address', u'address')]
    bindings_list = [('pybind.nos.v6_0_2f.vcs.virtual.ip.address.inband.interface', 'pybind.nos.v6_0_2f.brocade_vcs', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcs.virtual.ip.address.inband.interface', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ip.address.inband.interface', 'pybind.slxos.v17r_1_01a.brocade_vcs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcs.virtual.ip.address.inband.interface', 'pybind.slxos.v17r_2_00.brocade_vcs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcs.virtual.ip.address.inband.interface', 'pybind.slxos.v17s_1_02.brocade_vcs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcs_virtual_ip_address_inband_interface_ve_get(self, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type address: address
    :param address: Keyword argument tuple.

    :type address: unicode
    :param address: **address** tuple argument:  Virtual IP address (IPv4 Address/Prefix)

        * pattern restriction: ::

            '((0|(1[0-9]{0,2})|(2(([0-4][0-9]?)|(5[0-5]?)|([6'
            '-9]?)))|([3-9][0-9]?))\.){3}(0|(1[0-9]{0,2})|(2('
            '([0-4][0-9]?)|(5[0-5]?)|([6-9]?)))|([3-9][0-9]?)'
            ')/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.vcs.virtual.ip.address', u'address'), ('pybind.slxos.v17s_1_02.vcs.virtual.ip.address', u'address'), ('pybind.nos.v7_2_0.vcs.virtual.ip.address', u'address'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ip.address', u'address'), ('pybind.slxos.v17r_2_00.vcs.virtual.ip.address', u'address')]
    bindings_list = [('pybind.nos.v6_0_2f.vcs.virtual.ip.address.inband.interface', 'pybind.nos.v6_0_2f.brocade_vcs', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcs.virtual.ip.address.inband.interface', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ip.address.inband.interface', 'pybind.slxos.v17r_1_01a.brocade_vcs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcs.virtual.ip.address.inband.interface', 'pybind.slxos.v17r_2_00.brocade_vcs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcs.virtual.ip.address.inband.interface', 'pybind.slxos.v17s_1_02.brocade_vcs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}, {'keyval': 'address', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcs_virtual_ipv6_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vcs.virtual.ipv6', 'pybind.nos.v6_0_2f.brocade_vcs', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcs.virtual.ipv6', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ipv6', 'pybind.slxos.v17r_1_01a.brocade_vcs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcs.virtual.ipv6', 'pybind.slxos.v17r_2_00.brocade_vcs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcs.virtual.ipv6', 'pybind.slxos.v17s_1_02.brocade_vcs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.vcs.virtual.ipv6', u'address'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ipv6', u'address'), ('pybind.slxos.v17s_1_02.vcs.virtual.ipv6', u'address'), ('pybind.nos.v7_2_0.vcs.virtual.ipv6', u'address'), ('pybind.slxos.v17r_2_00.vcs.virtual.ipv6', u'address')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ipv6address'}, {'leafval': 'ipv6address'}, {'leafval': 'ipv6address'}, {'leafval': 'ipv6address'}, {'leafval': 'ipv6address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcs_virtual_ipv6_address_get(self, address=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type address: ipv6address
    :param address: Keyword argument tuple.

    :type ipv6address: unicode
    :param ipv6address: **address** tuple argument:  Virtual IPV6 address (IPv6 Address/Prefix)

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vcs.virtual.ipv6.address', 'pybind.nos.v6_0_2f.brocade_vcs', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcs.virtual.ipv6.address', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcs.virtual.ipv6.address', 'pybind.slxos.v17r_1_01a.brocade_vcs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcs.virtual.ipv6.address', 'pybind.slxos.v17r_2_00.brocade_vcs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcs.virtual.ipv6.address', 'pybind.slxos.v17s_1_02.brocade_vcs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'address', 'keyval': 'ipv6address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, address=address)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, address=address)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcsmode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vcsmode', 'pybind.nos.v6_0_2f.brocade_vcs', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcsmode', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcsmode', 'pybind.slxos.v17r_1_01a.brocade_vcs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcsmode', 'pybind.slxos.v17r_2_00.brocade_vcs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcsmode', 'pybind.slxos.v17s_1_02.brocade_vcs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcsmode_vcs_cluster_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vcsmode', 'pybind.nos.v6_0_2f.brocade_vcs', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcsmode', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcsmode', 'pybind.slxos.v17r_1_01a.brocade_vcs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcsmode', 'pybind.slxos.v17r_2_00.brocade_vcs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcsmode', 'pybind.slxos.v17s_1_02.brocade_vcs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vcsmode_vcs_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vcsmode', 'pybind.nos.v6_0_2f.brocade_vcs', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vcsmode', 'pybind.nos.v7_2_0.brocade_vcs', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vcsmode', 'pybind.slxos.v17r_1_01a.brocade_vcs', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vcsmode', 'pybind.slxos.v17r_2_00.brocade_vcs', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vcsmode', 'pybind.slxos.v17s_1_02.brocade_vcs', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlag_commit_mode_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.vlag_commit_mode', 'pybind.nos.v7_2_0.brocade_lacp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlag_commit_mode_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v7_2_0.vlag_commit_mode', 'pybind.nos.v7_2_0.brocade_lacp', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', 'pybind.nos.v6_0_2f.brocade_interface', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', 'pybind.nos.v7_2_0.brocade_interface', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', u'snooping'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter', u'interface'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'private_vlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip', u'igmp'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan', u'static_group'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp', u'inspection'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.private_vlan', u'association'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp', u'snooping'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ipv6', u'mldvlan'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan', u'spanning_tree'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.mac', u'access_group'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection', u'logging'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.arp.inspection', u'filter'), ('pybind.nos.v6_0_2f.interface_vlan.interface.vlan.ip.igmp', u'static_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.dhcp.relay', u'information'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'suppress_nd'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'suppress_arp'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', u'static_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'spanning_tree'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping', u'querier'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.mac', u'access_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip', u'igmp'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'suppress_nd'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldPIM', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan', u'static_group'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmpPIM', u'snooping'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.private_vlan', u'association'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.igmp.snooping.mrouter', u'interface'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp', u'inspection'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'suppress_arp'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6', u'mldvlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan', u'private_vlan'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection', u'filter'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ip.arp.inspection', u'logging'), ('pybind.nos.v7_2_0.interface_vlan.interface.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'suppress_arp'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'suppress_nd'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'qenable'}, {'leafval': 'enable, fast_leave, restrict_unknown_multicast_vlan, robustness_variable'}, {'leafval': 'if_type, value'}, {'leafval': 'qenable'}, {'leafval': 'pvlan_type_leaf'}, {'leafval': 'last_member_query_interval, query_interval, query_max_response_time'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'if_type, value'}, {'leafval': 'trust'}, {'leafval': 'sec_assoc_add, sec_assoc_remove'}, {'leafval': 'enable, fast_leave, mrouter_timeout, restrict_unknown_multicast'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval'}, {'leafval': 'stp_shutdown'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'acl_match'}, {'leafval': 'acl_name'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 've_config'}, {'leafval': 'stp_shutdown'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, enable, fast_leave, robustness_variable'}, {'leafval': 'trust'}, {'leafval': 'igmps_qenable'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'relay_option'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'acl_name'}, {'leafval': 'qenable'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'if_type, value'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_last_member_query_count, igmps_query_interval, igmps_query_max_response_time, igmps_startup_query_interval, igmps_startup_query_count, igmps_enable, igmps_fast_leave, igmps_robustness_variable, restrict_unknown_multicast'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'acl_match'}, {'leafval': 'if_type, value'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'qenable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'stp_shutdown'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, mldVersion, enable, fast_leave'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'igmps_qenable'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'trust'}, {'leafval': 'acl_match'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 've_config'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'mcast_address, interface, if_type, value, source'}, {'leafval': 'stp_shutdown'}, {'leafval': 'qenable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'last_member_query_interval, query_interval, igmp_version, query_max_response_time, last_member_query_count, startup_query_count, startup_query_interval, robustness_variable'}, {'leafval': 'enable, fast_leave, mrouter_timeout, restrict_unknown_multicast'}, {'leafval': 'if_type, value'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'enable, fast_leave, restrict_unknown_multicast_vlan, robustness_variable'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'sec_assoc_add, sec_assoc_remove'}, {'leafval': 'if_type, value'}, {'leafval': 'trust'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval'}, {'leafval': 'pvlan_type_leaf'}, {'leafval': 'acl_name'}, {'leafval': 'acl_match'}, {'leafval': 'qenable'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'acl_name'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, mldVersion, enable, fast_leave, robustness_variable'}, {'leafval': 'qenable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'trust'}, {'leafval': 'acl_match'}, {'leafval': 've_config'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'stp_shutdown'}, {'leafval': 'if_type, value'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'igmps_qenable'}]
    leafval_map = {"pybind.slxos.v17r_2_00.interface_vlan.vlan": {}, "pybind.slxos.v17r_1_01a.interface_vlan.vlan": {}, "pybind.slxos.v17s_1_02.interface_vlan.vlan": {"ifindex": "ifindex", "remote_span": "remote_span", "name": "name", "vlan_name": "vlan_name", "description": "description"}, "pybind.nos.v6_0_2f.interface_vlan.interface.vlan": {"name": "name", "vlan_name": "vlan_name", "transport_service": "transport_service", "ifindex": "ifindex", "remote_span": "remote_span", "description": "description"}, "pybind.nos.v7_2_0.interface_vlan.interface.vlan": {"name": "name", "vlan_name": "vlan_name", "transport_service": "transport_service", "ifindex": "ifindex", "remote_span": "remote_span", "description": "description"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_classifier_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vlan.classifier', 'pybind.nos.v6_0_2f.brocade_vlan', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vlan.classifier', 'pybind.nos.v7_2_0.brocade_vlan', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.vlan.classifier', u'rule'), ('pybind.nos.v6_0_2f.vlan.classifier', u'group'), ('pybind.nos.v7_2_0.vlan.classifier', u'group'), ('pybind.nos.v7_2_0.vlan.classifier', u'rule')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'ruleid'}, {'leafval': 'groupid, oper, rule_name, ruleid'}, {'leafval': 'groupid, oper, rule_name, ruleid'}, {'leafval': 'ruleid'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_classifier_group_get(self, group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type group: groupid, oper, rule_name, ruleid
    :param group: Keyword argument tuple.

    :type groupid: long
    :param groupid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type oper: unicode
    :param oper: **group** tuple argument:  Add/Delete Rule.

        * enumeration restriction: ::

            ['add', 'delete']

    :type rule_name: unicode
    :param rule_name: **group** tuple argument.

        * enumeration restriction: ::

            ['rule']

    :type ruleid: long
    :param ruleid: **group** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vlan.classifier.group', 'pybind.nos.v6_0_2f.brocade_vlan', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vlan.classifier.group', 'pybind.nos.v7_2_0.brocade_vlan', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'group', 'keyval': 'groupid, oper, rule_name, ruleid', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, group=group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, group=group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_classifier_rule_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Instance Keyword Argument Tuple**:

    :type rule: ruleid
    :param rule: Keyword argument tuple.

    :type ruleid: long
    :param ruleid: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vlan.classifier.rule', 'pybind.nos.v6_0_2f.brocade_vlan', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vlan.classifier.rule', 'pybind.nos.v7_2_0.brocade_vlan', 'pybind.nos.v7_2_0')]
    composed_child_list = [('pybind.nos.v6_0_2f.vlan.classifier.rule', u'proto'), ('pybind.nos.v6_0_2f.vlan.classifier.rule', u'mac'), ('pybind.nos.v7_2_0.vlan.classifier.rule', u'proto'), ('pybind.nos.v7_2_0.vlan.classifier.rule', u'mac')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'rule', 'keyval': 'ruleid', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'proto_val, encap'}, {'leafval': 'address'}, {'leafval': 'proto_val, encap'}, {'leafval': 'address'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v6_0_2f.vlan.classifier.rule': [u'mac', u'proto'], 'pybind.nos.v7_2_0.vlan.classifier.rule': [u'mac', u'proto']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_classifier_rule_mac_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: ruleid
    :param rule: Keyword argument tuple.

    :type ruleid: long
    :param ruleid: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.vlan.classifier.rule', u'rule'), ('pybind.nos.v6_0_2f.vlan.classifier.rule', u'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.vlan.classifier.rule.mac', 'pybind.nos.v6_0_2f.brocade_vlan', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vlan.classifier.rule.mac', 'pybind.nos.v7_2_0.brocade_vlan', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ruleid', 'extra_keyval': ''}, {'keyval': 'ruleid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.vlan.classifier.rule.mac': [u'address'], 'pybind.nos.v6_0_2f.vlan.classifier.rule.mac': [u'address']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_classifier_rule_mac_address_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: ruleid
    :param rule: Keyword argument tuple.

    :type ruleid: long
    :param ruleid: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.vlan.classifier.rule', u'rule'), ('pybind.nos.v6_0_2f.vlan.classifier.rule', u'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.vlan.classifier.rule.mac', 'pybind.nos.v6_0_2f.brocade_vlan', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vlan.classifier.rule.mac', 'pybind.nos.v7_2_0.brocade_vlan', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ruleid', 'extra_keyval': ''}, {'keyval': 'ruleid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_classifier_rule_proto_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: ruleid
    :param rule: Keyword argument tuple.

    :type ruleid: long
    :param ruleid: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.vlan.classifier.rule', u'rule'), ('pybind.nos.v7_2_0.vlan.classifier.rule', u'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.vlan.classifier.rule.proto', 'pybind.nos.v6_0_2f.brocade_vlan', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vlan.classifier.rule.proto', 'pybind.nos.v7_2_0.brocade_vlan', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ruleid', 'extra_keyval': ''}, {'keyval': 'ruleid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'proto_val, encap'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.nos.v7_2_0.vlan.classifier.rule.proto': [u'proto_val'], 'pybind.nos.v6_0_2f.vlan.classifier.rule.proto': [u'proto_val']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_classifier_rule_proto_encap_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: ruleid
    :param rule: Keyword argument tuple.

    :type ruleid: long
    :param ruleid: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.vlan.classifier.rule', u'rule'), ('pybind.nos.v7_2_0.vlan.classifier.rule', u'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.vlan.classifier.rule.proto', 'pybind.nos.v6_0_2f.brocade_vlan', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vlan.classifier.rule.proto', 'pybind.nos.v7_2_0.brocade_vlan', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ruleid', 'extra_keyval': ''}, {'keyval': 'ruleid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_classifier_rule_proto_proto_val_get(self, rule=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type rule: ruleid
    :param rule: Keyword argument tuple.

    :type ruleid: long
    :param ruleid: **rule** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v6_0_2f.vlan.classifier.rule', u'rule'), ('pybind.nos.v7_2_0.vlan.classifier.rule', u'rule')]
    bindings_list = [('pybind.nos.v6_0_2f.vlan.classifier.rule.proto', 'pybind.nos.v6_0_2f.brocade_vlan', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vlan.classifier.rule.proto', 'pybind.nos.v7_2_0.brocade_vlan', 'pybind.nos.v7_2_0')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'ruleid', 'extra_keyval': ''}, {'keyval': 'ruleid', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, rule=rule)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, rule=rule)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_description_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.dhcp.relay', u'information'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'suppress_nd'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'suppress_arp'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'suppress_arp'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'suppress_nd'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 've_config'}, {'leafval': 'stp_shutdown'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, enable, fast_leave, robustness_variable'}, {'leafval': 'trust'}, {'leafval': 'igmps_qenable'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'relay_option'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'acl_name'}, {'leafval': 'qenable'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'if_type, value'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_last_member_query_count, igmps_query_interval, igmps_query_max_response_time, igmps_startup_query_interval, igmps_startup_query_count, igmps_enable, igmps_fast_leave, igmps_robustness_variable, restrict_unknown_multicast'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'acl_match'}, {'leafval': 'if_type, value'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'qenable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'stp_shutdown'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, mldVersion, enable, fast_leave'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'igmps_qenable'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'trust'}, {'leafval': 'acl_match'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 've_config'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'acl_name'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, mldVersion, enable, fast_leave, robustness_variable'}, {'leafval': 'qenable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'trust'}, {'leafval': 'acl_match'}, {'leafval': 've_config'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'stp_shutdown'}, {'leafval': 'if_type, value'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'igmps_qenable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_dot1q_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vlan.dot1q', 'pybind.nos.v6_0_2f.brocade_vlan', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vlan.dot1q', 'pybind.nos.v7_2_0.brocade_vlan', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vlan.dot1q', 'pybind.slxos.v17r_1_01a.brocade_vlan', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vlan.dot1q', 'pybind.slxos.v17r_2_00.brocade_vlan', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vlan.dot1q', 'pybind.slxos.v17s_1_02.brocade_vlan', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vlan.dot1q', u'tag'), ('pybind.slxos.v17r_1_01a.vlan.dot1q', u'tag'), ('pybind.nos.v6_0_2f.vlan.dot1q', u'tag'), ('pybind.nos.v7_2_0.vlan.dot1q', u'tag'), ('pybind.slxos.v17r_2_00.vlan.dot1q', u'tag')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'native'}, {'leafval': 'native'}, {'leafval': 'native'}, {'leafval': 'native'}, {'leafval': 'native'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_dot1q_tag_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vlan.dot1q.tag', 'pybind.nos.v6_0_2f.brocade_vlan', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vlan.dot1q.tag', 'pybind.nos.v7_2_0.brocade_vlan', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vlan.dot1q.tag', 'pybind.slxos.v17r_1_01a.brocade_vlan', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vlan.dot1q.tag', 'pybind.slxos.v17r_2_00.brocade_vlan', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vlan.dot1q.tag', 'pybind.slxos.v17s_1_02.brocade_vlan', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_dot1q_tag_native_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.vlan.dot1q.tag', 'pybind.nos.v6_0_2f.brocade_vlan', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.vlan.dot1q.tag', 'pybind.nos.v7_2_0.brocade_vlan', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.vlan.dot1q.tag', 'pybind.slxos.v17r_1_01a.brocade_vlan', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vlan.dot1q.tag', 'pybind.slxos.v17r_2_00.brocade_vlan', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vlan.dot1q.tag', 'pybind.slxos.v17s_1_02.brocade_vlan', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ifindex_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.dhcp.relay', u'information'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'suppress_nd'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'suppress_arp'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'suppress_arp'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'suppress_nd'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 've_config'}, {'leafval': 'stp_shutdown'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, enable, fast_leave, robustness_variable'}, {'leafval': 'trust'}, {'leafval': 'igmps_qenable'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'relay_option'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'acl_name'}, {'leafval': 'qenable'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'if_type, value'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_last_member_query_count, igmps_query_interval, igmps_query_max_response_time, igmps_startup_query_interval, igmps_startup_query_count, igmps_enable, igmps_fast_leave, igmps_robustness_variable, restrict_unknown_multicast'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'acl_match'}, {'leafval': 'if_type, value'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'qenable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'stp_shutdown'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, mldVersion, enable, fast_leave'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'igmps_qenable'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'trust'}, {'leafval': 'acl_match'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 've_config'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'acl_name'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, mldVersion, enable, fast_leave, robustness_variable'}, {'leafval': 'qenable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'trust'}, {'leafval': 'acl_match'}, {'leafval': 've_config'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'stp_shutdown'}, {'leafval': 'if_type, value'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'igmps_qenable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_arp_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_arp_inspection_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_arp_inspection_filter_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection.filter', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection.filter', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection.filter', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_arp_inspection_filter_acl_name_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection.filter', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection.filter', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection.filter', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_arp_inspection_logging_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection.logging', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection.logging', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection.logging', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_arp_inspection_logging_acl_match_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection.logging', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection.logging', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection.logging', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_arp_inspection_trust_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_dhcp_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.dhcp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_dhcp_relay_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.dhcp.relay', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_dhcp_relay_information_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.dhcp.relay.information', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_dhcp_relay_information_option_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.dhcp.relay.information', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping": {"igmps_enable": "igmps_enable", "igmps_last_member_query_interval": "igmps_last_member_query_interval", "igmps_query_max_response_time": "igmps_query_max_response_time", "igmps_query_interval": "igmps_query_interval", "igmps_version": "igmps_version", "igmps_fast_leave": "igmps_fast_leave"}, "pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping": {}, "pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping": {"igmps_enable": "igmps_enable", "igmps_last_member_query_interval": "igmps_last_member_query_interval", "igmps_query_max_response_time": "igmps_query_max_response_time", "igmps_query_interval": "igmps_query_interval", "igmps_version": "igmps_version", "igmps_fast_leave": "igmps_fast_leave"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_enable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_fast_leave_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_last_member_query_count_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_last_member_query_interval_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_mrouter_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_mrouter_interface_get(self, vlan=None, igmps_interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmps_interface: igmps_if_type, igmps_value
    :param igmps_interface: Keyword argument tuple.

    :type igmps_if_type: unicode
    :param igmps_if_type: **igmps_interface** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type igmps_value: unicode
    :param igmps_value: **igmps_interface** tuple argument.

        * length restriction: ::

            ['1..10']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter.igmps_interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter.igmps_interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter.igmps_interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmps_interface', 'keyval': 'igmps_if_type, igmps_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, igmps_interface=igmps_interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, igmps_interface=igmps_interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_querier_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_querier', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_querier', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_querier', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_querier_enable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_querier', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_querier', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_querier', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_query_interval_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_query_max_response_time_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_restrict_unknown_multicast_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_robustness_variable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_startup_query_count_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_startup_query_interval_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_static_group_get(self, vlan=None, igmps_static_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type igmps_static_group: igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value
    :param igmps_static_group: Keyword argument tuple.

    :type igmps_mcast_address: unicode
    :param igmps_mcast_address: **igmps_static_group** tuple argument:  Multicast Address to be Joined in the format A.B.C.D

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type igmps_interface: unicode
    :param igmps_interface: **igmps_static_group** tuple argument.

        * enumeration restriction: ::

            ['interface']

    :type igmps_if_type: unicode
    :param igmps_if_type: **igmps_static_group** tuple argument.

        * enumeration restriction: ::

            ['ethernet', 'port-channel']

    :type igmps_value: unicode
    :param igmps_value: **igmps_static_group** tuple argument.

        * length restriction: ::

            ['1..10']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_static_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_static_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_static_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'igmps_static_group', 'keyval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, igmps_static_group=igmps_static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, igmps_static_group=igmps_static_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_igmp_snooping_version_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_pim_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpPIM', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpPIM', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpPIM', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_pim_snooping_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpPIM.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpPIM.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpPIM.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ip_pim_snooping_enable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpPIM.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpPIM.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpPIM.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_snooping_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping": {"startup_query_interval": "startup_query_interval", "last_member_query_interval": "last_member_query_interval", "enable": "enable", "startup_query_count": "startup_query_count", "query_max_response_time": "query_max_response_time", "fast_leave": "fast_leave", "query_interval": "query_interval", "last_member_query_count": "last_member_query_count"}, "pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping": {"startup_query_interval": "startup_query_interval", "last_member_query_interval": "last_member_query_interval", "enable": "enable", "startup_query_count": "startup_query_count", "query_max_response_time": "query_max_response_time", "mldVersion": "mldVersion", "fast_leave": "fast_leave", "query_interval": "query_interval", "last_member_query_count": "last_member_query_count"}, "pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_snooping_enable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_snooping_fast_leave_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_snooping_last_member_query_count_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_snooping_last_member_query_interval_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_snooping_mrouter_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_snooping_mrouter_interface_get(self, vlan=None, interface=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type interface: if_type, value
    :param interface: Keyword argument tuple.

    :type if_type: unicode
    :param if_type: **interface** tuple argument.

        * enumeration restriction: ::

            ['Ethernet', 'Port-channel']

    :type value: unicode
    :param value: **interface** tuple argument.

        * length restriction: ::

            ['1..10']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter.interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter.interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter.interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'interface', 'keyval': 'if_type, value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, interface=interface)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, interface=interface)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_snooping_querier_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping.querier', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping.querier', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping.querier', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_snooping_querier_enable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping.querier', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping.querier', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping.querier', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_snooping_query_interval_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_snooping_query_max_response_time_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_snooping_robustness_variable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_snooping_startup_query_count_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_snooping_startup_query_interval_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_snooping_static_group_get(self, vlan=None, static_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type static_group: mcast_address, interface, if_type, value
    :param static_group: Keyword argument tuple.

    :type mcast_address: unicode
    :param mcast_address: **static_group** tuple argument:  Multicast Address to be Joined in format xxxx:xxxx/ml, xxxx:xxxx::/ml

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type interface: unicode
    :param interface: **static_group** tuple argument.

        * enumeration restriction: ::

            ['interface']

    :type if_type: unicode
    :param if_type: **static_group** tuple argument.

        * enumeration restriction: ::

            ['Ethernet', 'Port-channel']

    :type value: unicode
    :param value: **static_group** tuple argument.

        * length restriction: ::

            ['1..10']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping.static_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping.static_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping.static_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_group', 'keyval': 'mcast_address, interface, if_type, value', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, static_group=static_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, static_group=static_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_mld_snooping_version_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_pim_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldPIM', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldPIM', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldPIM', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_pim_snooping_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldPIM.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldPIM.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldPIM.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_ipv6_pim_snooping_enable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldPIM.snooping', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldPIM.snooping', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldPIM.snooping', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_loop_detection_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'suppress_arp'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'suppress_nd'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'if_type, value'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'qenable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'stp_shutdown'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, mldVersion, enable, fast_leave'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'igmps_qenable'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'trust'}, {'leafval': 'acl_match'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 've_config'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'acl_name'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, mldVersion, enable, fast_leave, robustness_variable'}, {'leafval': 'qenable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'trust'}, {'leafval': 'acl_match'}, {'leafval': 've_config'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'stp_shutdown'}, {'leafval': 'if_type, value'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'igmps_qenable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_loop_detection_shutdown_disable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'suppress_arp'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'suppress_nd'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'suppress_arp_enable'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'acl_name'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, mldVersion, enable, fast_leave, robustness_variable'}, {'leafval': 'qenable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'trust'}, {'leafval': 'acl_match'}, {'leafval': 've_config'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'stp_shutdown'}, {'leafval': 'if_type, value'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'igmps_qenable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_mac_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.mac', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.mac', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.mac', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_mac_access_group_get(self, vlan=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction, traffic_type
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type traffic_type: unicode
    :param traffic_type: **access_group** tuple argument.

        * enumeration restriction: ::

            ['switched', 'routed']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.mac.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.mac.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.mac.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': 'mac_access_list, mac_direction, traffic_type'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_mac_access_group_traffic_type_get(self, vlan=None, access_group=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    **Instance Keyword Argument Tuple**:

    :type access_group: mac_access_list, mac_direction
    :param access_group: Keyword argument tuple.

    :type mac_access_list: unicode
    :param mac_access_list: **access_group** tuple argument:  ACL_NAME;; Access List Name (Max 63)

        * length restriction: ::

            ['1..63']

        * pattern restriction: ::

            '[a-zA-Z0-9]{1}([-a-zA-Z0-9_]{0,62})'

    :type mac_direction: unicode
    :param mac_direction: **access_group** tuple argument.

        * enumeration restriction: ::

            ['in', 'out']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.mac.access_group', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.mac.access_group', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.mac.access_group', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'access_group', 'keyval': 'mac_access_list, mac_direction', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan, access_group=access_group)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan, access_group=access_group)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_name_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.dhcp.relay', u'information'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'suppress_nd'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'suppress_arp'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'suppress_arp'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'suppress_nd'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 've_config'}, {'leafval': 'stp_shutdown'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, enable, fast_leave, robustness_variable'}, {'leafval': 'trust'}, {'leafval': 'igmps_qenable'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'relay_option'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'acl_name'}, {'leafval': 'qenable'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'if_type, value'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_last_member_query_count, igmps_query_interval, igmps_query_max_response_time, igmps_startup_query_interval, igmps_startup_query_count, igmps_enable, igmps_fast_leave, igmps_robustness_variable, restrict_unknown_multicast'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'acl_match'}, {'leafval': 'if_type, value'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'qenable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'stp_shutdown'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, mldVersion, enable, fast_leave'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'igmps_qenable'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'trust'}, {'leafval': 'acl_match'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 've_config'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'acl_name'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, mldVersion, enable, fast_leave, robustness_variable'}, {'leafval': 'qenable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'trust'}, {'leafval': 'acl_match'}, {'leafval': 've_config'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'stp_shutdown'}, {'leafval': 'if_type, value'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'igmps_qenable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_router_interface_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.router_interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.router_interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.router_interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_router_interface_ve_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.router_interface', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.router_interface', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.router_interface', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_rspan_vlan_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.dhcp.relay', u'information'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'suppress_nd'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'suppress_arp'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'suppress_arp'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'suppress_nd'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 've_config'}, {'leafval': 'stp_shutdown'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, enable, fast_leave, robustness_variable'}, {'leafval': 'trust'}, {'leafval': 'igmps_qenable'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'relay_option'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'acl_name'}, {'leafval': 'qenable'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'if_type, value'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_last_member_query_count, igmps_query_interval, igmps_query_max_response_time, igmps_startup_query_interval, igmps_startup_query_count, igmps_enable, igmps_fast_leave, igmps_robustness_variable, restrict_unknown_multicast'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'acl_match'}, {'leafval': 'if_type, value'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'qenable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'stp_shutdown'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, mldVersion, enable, fast_leave'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'igmps_qenable'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'trust'}, {'leafval': 'acl_match'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 've_config'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'acl_name'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, mldVersion, enable, fast_leave, robustness_variable'}, {'leafval': 'qenable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'trust'}, {'leafval': 'acl_match'}, {'leafval': 've_config'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'stp_shutdown'}, {'leafval': 'if_type, value'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'igmps_qenable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_spanning_tree_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_spanning_tree_shutdown_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan.spanning_tree', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.spanning_tree', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.spanning_tree', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_statistics_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.interface_vlan.vlan', 'pybind.slxos.v17r_1_01a.brocade_interface', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.dhcp.relay', u'information'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'suppress_nd'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'suppress_arp'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17r_1_01a.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'suppress_arp'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping.igmps_mrouter', u'igmps_interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', u'filter'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', u'querier'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldPIM', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.mac', u'access_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp', u'inspection'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.arp.inspection', u'logging'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'router_interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpPIM', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'suppress_nd'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan', u'snooping'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'spanning_tree'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping.mrouter', u'interface'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ipv6.mldVlan.snooping', u'static_group'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan.ip.igmpVlan.snooping', u'igmps_querier')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vlan', 'keyval': 'name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 've_config'}, {'leafval': 'stp_shutdown'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, enable, fast_leave, robustness_variable'}, {'leafval': 'trust'}, {'leafval': 'igmps_qenable'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'relay_option'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'acl_name'}, {'leafval': 'qenable'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'if_type, value'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_last_member_query_count, igmps_query_interval, igmps_query_max_response_time, igmps_startup_query_interval, igmps_startup_query_count, igmps_enable, igmps_fast_leave, igmps_robustness_variable, restrict_unknown_multicast'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'acl_match'}, {'leafval': 'if_type, value'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'qenable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'acl_name'}, {'leafval': 'stp_shutdown'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, mldVersion, enable, fast_leave'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'igmps_qenable'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'trust'}, {'leafval': 'acl_match'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 've_config'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'suppress_arp_enable'}, {'leafval': 'igmps_if_type, igmps_value'}, {'leafval': 'acl_name'}, {'leafval': 'igmps_mcast_address, igmps_interface, igmps_if_type, igmps_value'}, {'leafval': 'last_member_query_interval, last_member_query_count, startup_query_interval, startup_query_count, query_max_response_time, query_interval, mldVersion, enable, fast_leave, robustness_variable'}, {'leafval': 'qenable'}, {'leafval': 'vlan_pimv6_enable'}, {'leafval': 'mac_access_list, mac_direction, traffic_type'}, {'leafval': 'trust'}, {'leafval': 'acl_match'}, {'leafval': 've_config'}, {'leafval': 'vlan_pimv4_enable'}, {'leafval': 'suppress_nd_enable'}, {'leafval': 'igmps_version, igmps_last_member_query_interval, igmps_query_interval, igmps_query_max_response_time, igmps_enable, igmps_fast_leave'}, {'leafval': 'stp_shutdown'}, {'leafval': 'if_type, value'}, {'leafval': 'mcast_address, interface, if_type, value'}, {'leafval': 'igmps_qenable'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_suppress_arp_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan.suppress_arp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.suppress_arp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_suppress_arp_enable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan.suppress_arp', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.suppress_arp', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_suppress_nd_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan.suppress_nd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.suppress_nd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vlan_suppress_nd_enable_get(self, vlan=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vlan: name
    :param vlan: Keyword argument tuple.

    :type name: long
    :param name: **vlan** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.interface_vlan.vlan', u'vlan'), ('pybind.slxos.v17r_2_00.interface_vlan.vlan', u'vlan')]
    bindings_list = [('pybind.slxos.v17r_2_00.interface_vlan.vlan.suppress_nd', 'pybind.slxos.v17r_2_00.brocade_interface', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.interface_vlan.vlan.suppress_nd', 'pybind.slxos.v17s_1_02.brocade_interface', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'name', 'extra_keyval': ''}, {'keyval': 'name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vlan=vlan)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vlan=vlan)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vpn_statistics_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vpn_statistics_state', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vpn_statistics_state', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.vpn_statistics_state', u'vpn_vrf_statistics'), ('pybind.slxos.v17r_2_00.vpn_statistics_state', u'vpn_vrf_statistics')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'vrf_name, tunnel_in_pkt, tunnel_out_pkt'}, {'leafval': 'vrf_name, tunnel_in_pkt, tunnel_out_pkt'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vpn_statistics_state_vpn_vrf_statistics_get(self, vpn_vrf_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type vpn_vrf_statistics: vrf_name
    :param vpn_vrf_statistics: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vpn_vrf_statistics** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vpn_statistics_state.vpn_vrf_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vpn_statistics_state.vpn_vrf_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vpn_vrf_statistics', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vpn_vrf_statistics=vpn_vrf_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vpn_vrf_statistics=vpn_vrf_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vpn_statistics_state_vpn_vrf_statistics_tunnel_in_pkt_get(self, vpn_vrf_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type vpn_vrf_statistics: vrf_name
    :param vpn_vrf_statistics: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vpn_vrf_statistics** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vpn_statistics_state.vpn_vrf_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vpn_statistics_state.vpn_vrf_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vpn_vrf_statistics', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vpn_vrf_statistics=vpn_vrf_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vpn_vrf_statistics=vpn_vrf_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vpn_statistics_state_vpn_vrf_statistics_tunnel_out_pkt_get(self, vpn_vrf_statistics=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type vpn_vrf_statistics: vrf_name
    :param vpn_vrf_statistics: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vpn_vrf_statistics** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vpn_statistics_state.vpn_vrf_statistics', 'pybind.slxos.v17r_1_01a.brocade_nsm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vpn_statistics_state.vpn_vrf_statistics', 'pybind.slxos.v17r_2_00.brocade_nsm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'vpn_vrf_statistics', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vpn_vrf_statistics=vpn_vrf_statistics)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vpn_vrf_statistics=vpn_vrf_statistics)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_oif'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.import_', u'routes'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip', u'unicast'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route', u'static_route_nh'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast', u'import_'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast', u'arp_entry'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.route_taret_container', u'route_target_evpn'), ('pybind.slxos.v17r_2_00.vrf.evpn', u'irb'), ('pybind.slxos.v17r_2_00.vrf', u'ip'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast', u'export'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.import_', u'routes'), ('pybind.slxos.v17r_2_00.vrf', u'route_target'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route', u'static_route_oif'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast', u'import_'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route', u'static_route_oif_vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.route_target_container_ipv6', u'route_target_evpn'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast', u'export'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.route_taret_container_ipv6', u'route_target'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.bgp', u'next_hop'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6', u'unicast'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.route_target_container_ipv4', u'route_target'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.bgp', u'next_hop'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip', u'unicast'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.vrf', u'ip'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast', u'route_target'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.import_', u'routes'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast', u'arp_entry'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static', u'bfd'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.bgp', u'next_hop'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route', u'static_route_oif_vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast', u'export'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6', u'unicast'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast', u'import_'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.import_', u'routes'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast', u'export'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.bgp', u'next_hop'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.vrf', u'route_target'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast', u'route_target'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static', u'bfd'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast', u'import_'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast', u'export'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.import_', u'routes'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh'), ('pybind.slxos.v17s_1_02.vrf', u'route_target'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast', u'route_target'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast', u'route_target'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route', u'static_route_oif_vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static', u'bfd'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17s_1_02.vrf.evpn', u'irb'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast', u'export'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.import_', u'routes'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast', u'arp_entry'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast', u'import_'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh_vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static', u'bfd'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_oif'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route', u'static_route_oif'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route', u'static_route_nh_vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip', u'unicast'), ('pybind.slxos.v17s_1_02.vrf', u'ip'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route', u'static_route_nh'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast', u'import_'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6', u'unicast')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'vrf', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'max_route'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'map_import, evpn_import'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, Ethernet, Ve'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 've, cluster_gateway'}, {'leafval': 'vrf_router_id'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'map_export, evpn_export'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'action, target_community'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'map_import, evpn_import'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'map_export, evpn_export'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'loopback'}, {'leafval': 'max_route'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'holdover_interval'}, {'leafval': 'loopback'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'max_route'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'vrf_router_id'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'action, target_community'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, Ethernet, Ve'}, {'leafval': 'holdover_interval'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'loopback'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'map_export'}, {'leafval': 'max_route'}, {'leafval': 'map_import'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'map_export'}, {'leafval': 'loopback'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'action, target_community'}, {'leafval': 'action, target_community'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'map_import'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'map_export, evpn_export'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'action, target_community'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 've'}, {'leafval': 'map_export, evpn_export'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, Ethernet, Ve'}, {'leafval': 'map_import, evpn_import'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'holdover_interval'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'max_route'}, {'leafval': 'vrf_router_id'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'map_import, evpn_import'}, {'leafval': 'max_route'}]
    leafval_map = {"pybind.slxos.v17r_2_00.vrf": {"vpn_statistics": "vpn_statistics", "vrf_name": "vrf_name", "route_distiniguisher": "route_distiniguisher"}, "pybind.slxos.v17r_1_01a.vrf": {"vpn_statistics": "vpn_statistics", "vrf_name": "vrf_name", "route_distiniguisher": "route_distiniguisher"}, "pybind.slxos.v17s_1_02.vrf": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_arp_get(self, vrf=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address, mac_address_value, interfacename, Ethernet, Ve
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type mac_address_value: unicode
    :param mac_address_value: **arp_entry** tuple argument.

    :type interfacename: unicode
    :param interfacename: **arp_entry** tuple argument.

        * enumeration restriction: ::

            ['interface']

    :type Ethernet: unicode
    :param Ethernet: **arp_entry** tuple argument.

        * length restriction: ::

            ['3..16']

        * pattern restriction: ::

            '((([0-9]|[1][0-6]))/([1-9]|[1-9][0-9]|[1-9][0-9]'
            '[0-9])(:[1-4])?)'

    :type Ve: long
    :param Ve: **arp_entry** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    :raises MultipleChoicesSetError: If more than one choice kwarg is set.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': 'arp_ip_address, mac_address_value, interfacename, Ethernet, Ve'}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {'pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.arp_entry': [u'Ethernet', u'Ve'], 'pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.arp_entry': [u'Ethernet', u'Ve'], 'pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.arp_entry': [u'Ethernet', u'Ve']}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_arp_ethernet_get(self, vrf=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_arp_interfacename_get(self, vrf=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_arp_mac_address_value_get(self, vrf=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_arp_ve_get(self, vrf=None, arp_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type arp_entry: arp_ip_address
    :param arp_entry: Keyword argument tuple.

    :type arp_ip_address: unicode
    :param arp_ip_address: **arp_entry** tuple argument:  A.B.C.D;; IP address of the ARP entry

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.arp_entry', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'arp_entry', 'keyval': 'arp_ip_address', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, arp_entry=arp_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, arp_entry=arp_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_bgp_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.bgp', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.bgp', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_bgp_next_hop_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.bgp.next_hop', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.bgp.next_hop', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_bgp_next_hop_loopback_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.bgp.next_hop', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.bgp.next_hop', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_export_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.export', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.export', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.export', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'map_export, evpn_export'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.export": {}, "pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.export": {"map_export": "map_export"}, "pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.export": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_export_evpn_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.export', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.export', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_export_map_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.export', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.export', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.export', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_import_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.import_', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.import_', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.import_', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 'map_import, evpn_import'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.import_": {}, "pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.import_": {}, "pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.import_": {"map_import": "map_import"}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_import_evpn_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.import_', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.import_', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_import_map_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.import_', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.import_', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.import_', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_import_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.import_', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.import_', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.import_', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_import_routes_get(self, vrf=None, routes=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type routes: src_vrf, route_map
    :param routes: Keyword argument tuple.

    :type src_vrf: unicode
    :param src_vrf: **routes** tuple argument:  ASCII string;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type route_map: unicode
    :param route_map: **routes** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.import_.routes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.import_.routes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.import_.routes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'routes', 'keyval': 'src_vrf, route_map', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, routes=routes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, routes=routes)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_bfd_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static.bfd', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static.bfd', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static.bfd', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_bfd_bfd_static_route_get(self, vrf=None, bfd_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_interval_attributes'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_interval_attributes'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_interval_attributes')]
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_static_route', 'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, bfd_static_route=bfd_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_bfd_bfd_static_route_interval_get(self, vrf=None, bfd_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_static_route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, bfd_static_route=bfd_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_bfd_bfd_static_route_min_rx_get(self, vrf=None, bfd_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_static_route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, bfd_static_route=bfd_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_bfd_bfd_static_route_multiplier_get(self, vrf=None, bfd_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_static_route: bfd_static_route_dest, bfd_static_route_src
    :param bfd_static_route: Keyword argument tuple.

    :type bfd_static_route_dest: unicode
    :param bfd_static_route_dest: **bfd_static_route** tuple argument:  A.B.C.D ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type bfd_static_route_src: unicode
    :param bfd_static_route_src: **bfd_static_route** tuple argument:  A.B.C.D ;; Source IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_static_route'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route', u'bfd_static_route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static.bfd.bfd_static_route.bfd_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_static_route_dest, bfd_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, bfd_static_route=bfd_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, bfd_static_route=bfd_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_bfd_holdover_interval_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static.bfd', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static.bfd', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static.bfd', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_nh_get(self, vrf=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_nh', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_nh', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_nh', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'route_attributes'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'route_attributes'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'route_attributes')]
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh', 'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_nh_distance_get(self, vrf=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_nh_metric_get(self, vrf=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_nh_tag_get(self, vrf=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_nh_vrf_get(self, vrf=None, static_route_nh_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop
    :param static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_nh_vrf** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh_vrf** tuple argument:  A.B.C.D ;; Next hop IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])(%[\p{N}\p{L}]+)?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_nh_vrf', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_nh_vrf', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_nh_vrf', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh_vrf=static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh_vrf=static_route_nh_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_oif_get(self, vrf=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_oif', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_oif', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_oif', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'route_attributes'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'route_attributes'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'route_attributes')]
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif', 'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_oif_distance_get(self, vrf=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_oif_metric_get(self, vrf=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_oif_tag_get(self, vrf=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_oif.route_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_ip_route_static_route_oif_vrf_get(self, vrf=None, static_route_oif_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_oif_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name
    :param static_route_oif_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_oif_vrf** tuple argument:  A.B.C.D/L ;; Destination IP address

        * pattern restriction: ::

            '(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-'
            '5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-'
            '9]|25[0-5])/(([0-9])|([1-2][0-9])|(3[0-2]))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_oif_vrf** tuple argument:  Next Hop Vrf Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static_route_oif_vrf', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static_route_oif_vrf', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static_route_oif_vrf', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif_vrf=static_route_oif_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif_vrf=static_route_oif_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_max_route_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_route_taret_container_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.route_taret_container', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_route_target_get(self, vrf=None, route_target=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target: action, target_community
    :param route_target: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '((\s*(((([1-9][0-9]{0,8})|(4[0-1][0-9]{8})|(42[0'
            '-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{'
            '5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]{3})|('
            '4294967[0-1][0-9]{2})|(42949672[0-8][0-9])|(4294'
            '96729[0-5])):(([1-9][0-9]{0,3})|([1-5][0-9]{4})|'
            '(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9'
            '])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9]{2}|'
            '2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1[0-9]'
            '{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9][0-9]|'
            '1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,3'
            '})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4][0-9'
            ']{2})|(655[0-2][0-9])|(6553[0-5])))))*)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.route_target', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.route_taret_container.route_target_evpn', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.route_target', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.route_target": {"action": "action", "target_community": "target_community"}, "pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.route_target": {}, "pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.route_taret_container.route_target_evpn": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, route_target=route_target)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, route_target=route_target)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_route_target_container_ipv4_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.route_target_container_ipv4', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_route_target_evpn_get(self, vrf=None, route_target_evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target_evpn: action, target_community
    :param route_target_evpn: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target_evpn** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target_evpn** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '((\s*(((([1-9][0-9]{0,8})|(4[0-1][0-9]{8})|(42[0'
            '-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{'
            '5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]{3})|('
            '4294967[0-1][0-9]{2})|(42949672[0-8][0-9])|(4294'
            '96729[0-5])):(([1-9][0-9]{0,3})|([1-5][0-9]{4})|'
            '(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9'
            '])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9]{2}|'
            '2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1[0-9]'
            '{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9][0-9]|'
            '1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,3'
            '})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4][0-9'
            ']{2})|(655[0-2][0-9])|(6553[0-5])))))*)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.route_taret_container.route_target_evpn', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.route_target', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target_evpn', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, route_target_evpn=route_target_evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, route_target_evpn=route_target_evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_route_target_evpn_route_target_container_ipv4_route_target_get(self, vrf=None, route_target=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target: action, target_community
    :param route_target: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '((\s*(((([1-9][0-9]{0,8})|(4[0-1][0-9]{8})|(42[0'
            '-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{'
            '5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]{3})|('
            '4294967[0-1][0-9]{2})|(42949672[0-8][0-9])|(4294'
            '96729[0-5])):(([1-9][0-9]{0,3})|([1-5][0-9]{4})|'
            '(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9'
            '])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9]{2}|'
            '2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1[0-9]'
            '{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9][0-9]|'
            '1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,3'
            '})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4][0-9'
            ']{2})|(655[0-2][0-9])|(6553[0-5])))))*)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.route_target_container_ipv4.route_target', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, route_target=route_target)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, route_target=route_target)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv4_unicast_route_target_route_target_container_ipv4_route_target_get(self, vrf=None, route_target=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target: action, target_community
    :param route_target: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '((\s*(((([1-9][0-9]{0,8})|(4[0-1][0-9]{8})|(42[0'
            '-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{'
            '5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]{3})|('
            '4294967[0-1][0-9]{2})|(42949672[0-8][0-9])|(4294'
            '96729[0-5])):(([1-9][0-9]{0,3})|([1-5][0-9]{4})|'
            '(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9'
            '])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9]{2}|'
            '2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1[0-9]'
            '{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9][0-9]|'
            '1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,3'
            '})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4][0-9'
            ']{2})|(655[0-2][0-9])|(6553[0-5])))))*)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.route_target_container_ipv4.route_target', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, route_target=route_target)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, route_target=route_target)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_bgp_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.bgp', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.bgp', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_bgp_next_hop_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.bgp.next_hop', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.bgp.next_hop', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_bgp_next_hop_loopback_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.bgp.next_hop', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.bgp.next_hop', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_export_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.export', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.export', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.export', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.export": {}, "pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.export": {"map_export": "map_export"}, "pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.export": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_export_evpn_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.export', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.export', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_export_map_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.export', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.export', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.export', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_import_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.import_', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.import_', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.import_', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.import_": {"map_import": "map_import"}, "pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.import_": {}, "pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.import_": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_import_evpn_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.import_', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.import_', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_import_map_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.import_', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.import_', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.import_', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_import_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.import_', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.import_', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.import_', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_import_routes_get(self, vrf=None, routes=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type routes: src_vrf, route_map
    :param routes: Keyword argument tuple.

    :type src_vrf: unicode
    :param src_vrf: **routes** tuple argument:  ASCII string;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type route_map: unicode
    :param route_map: **routes** tuple argument:  Word:1-63;;Route map name

        * pattern restriction: ::

            '[a-zA-Z]{1}([-a-zA-Z0-9\.\\\\@#\+\*\(\)=\{~\}%<>'
            '=$_\[\]\|]{0,62})'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.import_.routes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.import_.routes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.import_.routes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'routes', 'keyval': 'src_vrf, route_map', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, routes=routes)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, routes=routes)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_ipv6_static_route_oif_vrf_get(self, vrf=None, ipv6_static_route_oif_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type ipv6_static_route_oif_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name
    :param ipv6_static_route_oif_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **ipv6_static_route_oif_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **ipv6_static_route_oif_vrf** tuple argument:  Next Hop Vrf Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **ipv6_static_route_oif_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **ipv6_static_route_oif_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.ipv6_static_route_oif_vrf', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'ipv6_static_route_oif_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, ipv6_static_route_oif_vrf=ipv6_static_route_oif_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, ipv6_static_route_oif_vrf=ipv6_static_route_oif_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_get(self, vrf=None, link_local_static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'route_attributes'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'route_attributes'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'route_attributes')]
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_local_static_route_nh', 'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_distance_get(self, vrf=None, link_local_static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_metric_get(self, vrf=None, link_local_static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_tag_get(self, vrf=None, link_local_static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type link_local_static_route_nh: link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh: Keyword argument tuple.

    :type link_local_static_route_dest: unicode
    :param link_local_static_route_dest: **link_local_static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type link_local_nexthop: unicode
    :param link_local_nexthop: **link_local_static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh', u'link_local_static_route_nh')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, link_local_static_route_nh=link_local_static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_link_local_static_route_nh_vrf_get(self, vrf=None, link_local_static_route_nh_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type link_local_static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name
    :param link_local_static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **link_local_static_route_nh_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **link_local_static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type link_local_next_hop: unicode
    :param link_local_next_hop: **link_local_static_route_nh_vrf** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type link_local_route_oif_type: unicode
    :param link_local_route_oif_type: **link_local_static_route_nh_vrf** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'management', 'null', 've']

    :type link_local_route_oif_name: unicode
    :param link_local_route_oif_name: **link_local_static_route_nh_vrf** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh_vrf', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh_vrf', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.link_local_static_route_nh_vrf', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'link_local_static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, link_local_static_route_nh_vrf=link_local_static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, link_local_static_route_nh_vrf=link_local_static_route_nh_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_get(self, vrf=None, bfd_ipv6_link_local_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_interval_attributes'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_interval_attributes'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_interval_attributes')]
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_ipv6_link_local_static_route', 'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_interval_get(self, vrf=None, bfd_ipv6_link_local_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_min_rx_get(self, vrf=None, bfd_ipv6_link_local_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_link_local_static_route_multiplier_get(self, vrf=None, bfd_ipv6_link_local_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_ipv6_link_local_static_route: bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name
    :param bfd_ipv6_link_local_static_route: Keyword argument tuple.

    :type bfd_ipv6_link_local_dest: unicode
    :param bfd_ipv6_link_local_dest: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_link_local_src: unicode
    :param bfd_ipv6_link_local_src: **bfd_ipv6_link_local_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_interface_type: unicode
    :param bfd_interface_type: **bfd_ipv6_link_local_static_route** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type bfd_interface_name: unicode
    :param bfd_interface_name: **bfd_ipv6_link_local_static_route** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route', u'bfd_ipv6_link_local_static_route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_link_local_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, bfd_ipv6_link_local_static_route=bfd_ipv6_link_local_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_static_route_get(self, vrf=None, bfd_ipv6_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_interval_attributes'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_interval_attributes'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_interval_attributes')]
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'bfd_ipv6_static_route', 'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}, {'leafval': 'interval, min_rx, multiplier'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_static_route_interval_get(self, vrf=None, bfd_ipv6_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_static_route_min_rx_get(self, vrf=None, bfd_ipv6_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_bfd_ipv6_static_route_multiplier_get(self, vrf=None, bfd_ipv6_static_route=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type bfd_ipv6_static_route: bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src
    :param bfd_ipv6_static_route: Keyword argument tuple.

    :type bfd_ipv6_static_route_dest: unicode
    :param bfd_ipv6_static_route_dest: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Destination IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type bfd_ipv6_static_route_src: unicode
    :param bfd_ipv6_static_route_src: **bfd_ipv6_static_route** tuple argument:  A:B::C:D ;; Source IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route', u'bfd_ipv6_static_route')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd.bfd_ipv6_static_route.bfd_ipv6_interval_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, bfd_ipv6_static_route=bfd_ipv6_static_route)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_bfd_holdover_interval_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_get(self, vrf=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'route_attributes'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'route_attributes'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'route_attributes')]
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh', 'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_distance_get(self, vrf=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_metric_get(self, vrf=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_tag_get(self, vrf=None, static_route_nh=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_nh: static_route_dest, static_route_next_hop
    :param static_route_nh: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_nh** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh', u'static_route_nh')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh.route_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_next_hop', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh=static_route_nh)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh=static_route_nh)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_nh_vrf_get(self, vrf=None, static_route_nh_vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_nh_vrf: static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop
    :param static_route_nh_vrf: Keyword argument tuple.

    :type static_route_next_vrf_dest: unicode
    :param static_route_next_vrf_dest: **static_route_nh_vrf** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type next_hop_vrf: unicode
    :param next_hop_vrf: **static_route_nh_vrf** tuple argument:  Next Hop Vrf Name

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_next_hop: unicode
    :param static_route_next_hop: **static_route_nh_vrf** tuple argument:  A:B::C:D ;; Next hop IPv6 address

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(%[\p{N}\p{L}]+'
            ')?'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh_vrf', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh_vrf', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_nh_vrf', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_nh_vrf', 'keyval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_nh_vrf=static_route_nh_vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_nh_vrf=static_route_nh_vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_oif_get(self, vrf=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'route_attributes'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'route_attributes'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'route_attributes')]
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'static_route_oif', 'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}, {'leafval': 'metric, distance, tag'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_oif_distance_get(self, vrf=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_oif_metric_get(self, vrf=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_ipv6_route_static_route_oif_tag_get(self, vrf=None, static_route_oif=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type static_route_oif: static_route_dest, static_route_oif_type, static_route_oif_name
    :param static_route_oif: Keyword argument tuple.

    :type static_route_dest: unicode
    :param static_route_dest: **static_route_oif** tuple argument:  A:B::C:D/LEN ;; Destination IPv6 Prefix

        * pattern restriction: ::

            '((:|[0-9a-fA-F]{0,4}):)([0-9a-fA-F]{0,4}:){0,5}('
            '(([0-9a-fA-F]{0,4}:)?(:|[0-9a-fA-F]{0,4}))|(((25'
            '[0-5]|2[0-4][0-9]|[01]?[0-9]?[0-9])\.){3}(25[0-5'
            ']|2[0-4][0-9]|[01]?[0-9]?[0-9])))(/(([0-9])|([0-'
            '9]{2})|(1[0-1][0-9])|(12[0-8])))'

    :type static_route_oif_type: unicode
    :param static_route_oif_type: **static_route_oif** tuple argument:  Outgoing interface type

        * enumeration restriction: ::

            ['ethernet', 'null', 've']

    :type static_route_oif_name: unicode
    :param static_route_oif_name: **static_route_oif** tuple argument.

        * length restriction: ::

            ['1..16']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif'), ('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif', u'static_route_oif')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static_route_oif.route_attributes', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'static_route_dest, static_route_oif_type, static_route_oif_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, static_route_oif=static_route_oif)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, static_route_oif=static_route_oif)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_max_route_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_route_taret_container_ipv6_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.route_taret_container_ipv6', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_route_target_get(self, vrf=None, route_target=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target: action, target_community
    :param route_target: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '((\s*(((([1-9][0-9]{0,8})|(4[0-1][0-9]{8})|(42[0'
            '-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{'
            '5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]{3})|('
            '4294967[0-1][0-9]{2})|(42949672[0-8][0-9])|(4294'
            '96729[0-5])):(([1-9][0-9]{0,3})|([1-5][0-9]{4})|'
            '(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9'
            '])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9]{2}|'
            '2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1[0-9]'
            '{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9][0-9]|'
            '1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,3'
            '})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4][0-9'
            ']{2})|(655[0-2][0-9])|(6553[0-5])))))*)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.route_target', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.route_taret_container_ipv6.route_target', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.route_target', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.route_target": {}, "pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.route_target": {"action": "action", "target_community": "target_community"}, "pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.route_taret_container_ipv6.route_target": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, route_target=route_target)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, route_target=route_target)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_route_target_container_ipv6_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.route_target_container_ipv6', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_route_target_evpn_get(self, vrf=None, route_target=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target: action, target_community
    :param route_target: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '((\s*(((([1-9][0-9]{0,8})|(4[0-1][0-9]{8})|(42[0'
            '-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{'
            '5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]{3})|('
            '4294967[0-1][0-9]{2})|(42949672[0-8][0-9])|(4294'
            '96729[0-5])):(([1-9][0-9]{0,3})|([1-5][0-9]{4})|'
            '(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9'
            '])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9]{2}|'
            '2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1[0-9]'
            '{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9][0-9]|'
            '1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,3'
            '})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4][0-9'
            ']{2})|(655[0-2][0-9])|(6553[0-5])))))*)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.route_taret_container_ipv6.route_target', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.route_target', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, route_target=route_target)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, route_target=route_target)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_route_target_evpn_route_target_container_ipv6_route_target_evpn_get(self, vrf=None, route_target_evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target_evpn: action, target_community
    :param route_target_evpn: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target_evpn** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target_evpn** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '((\s*(((([1-9][0-9]{0,8})|(4[0-1][0-9]{8})|(42[0'
            '-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{'
            '5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]{3})|('
            '4294967[0-1][0-9]{2})|(42949672[0-8][0-9])|(4294'
            '96729[0-5])):(([1-9][0-9]{0,3})|([1-5][0-9]{4})|'
            '(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9'
            '])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9]{2}|'
            '2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1[0-9]'
            '{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9][0-9]|'
            '1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,3'
            '})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4][0-9'
            ']{2})|(655[0-2][0-9])|(6553[0-5])))))*)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.route_target_container_ipv6.route_target_evpn', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target_evpn', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, route_target_evpn=route_target_evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, route_target_evpn=route_target_evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_address_family_ipv6_unicast_route_target_route_target_evpn_get(self, vrf=None, route_target_evpn=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target_evpn: action, target_community
    :param route_target_evpn: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target_evpn** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target_evpn** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '((\s*(((([1-9][0-9]{0,8})|(4[0-1][0-9]{8})|(42[0'
            '-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{'
            '5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]{3})|('
            '4294967[0-1][0-9]{2})|(42949672[0-8][0-9])|(4294'
            '96729[0-5])):(([1-9][0-9]{0,3})|([1-5][0-9]{4})|'
            '(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9'
            '])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9]{2}|'
            '2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1[0-9]'
            '{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9][0-9]|'
            '1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,3'
            '})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4][0-9'
            ']{2})|(655[0-2][0-9])|(6553[0-5])))))*)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.route_target_container_ipv6.route_target_evpn', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target_evpn', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, route_target_evpn=route_target_evpn)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, route_target_evpn=route_target_evpn)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_evpn_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.evpn', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.evpn', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_evpn_irb_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.evpn.irb', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.evpn.irb', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': 've, cluster_gateway'}
    composed_child_leafval_list = []
    leafval_map = {"pybind.slxos.v17r_2_00.vrf.evpn.irb": {"cluster_gateway": "cluster_gateway", "ve": "ve"}, "pybind.slxos.v17s_1_02.vrf.evpn.irb": {}}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_evpn_irb_cluster_gateway_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.evpn.irb', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_evpn_irb_ve_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_2_00.vrf.evpn.irb', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.evpn.irb', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_ip_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.ip', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.ip', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.ip', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_ip_router_id_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17r_2_00.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.ip', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.ip', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.ip', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_rd_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast', u'export'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.import_', u'routes'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh'), ('pybind.slxos.v17s_1_02.vrf', u'route_target'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast', u'route_target'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast', u'route_target'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route', u'static_route_oif_vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static', u'bfd'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17s_1_02.vrf.evpn', u'irb'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast', u'export'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.import_', u'routes'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast', u'arp_entry'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast', u'import_'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh_vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static', u'bfd'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_oif'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route', u'static_route_oif'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route', u'static_route_nh_vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip', u'unicast'), ('pybind.slxos.v17s_1_02.vrf', u'ip'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast.ip.route', u'static_route_nh'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.slxos.v17s_1_02.vrf.address_family.ip.unicast', u'import_'), ('pybind.slxos.v17s_1_02.vrf.address_family.ipv6', u'unicast'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_oif'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.import_', u'routes'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip', u'unicast'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route', u'static_route_nh'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast', u'import_'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast', u'arp_entry'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.route_taret_container', u'route_target_evpn'), ('pybind.slxos.v17r_2_00.vrf.evpn', u'irb'), ('pybind.slxos.v17r_2_00.vrf', u'ip'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast', u'export'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.import_', u'routes'), ('pybind.slxos.v17r_2_00.vrf', u'route_target'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route', u'static_route_oif'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast', u'import_'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route', u'static_route_oif_vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.route_target_container_ipv6', u'route_target_evpn'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast', u'export'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.route_taret_container_ipv6', u'route_target'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.bgp', u'next_hop'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6', u'unicast'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.route_target_container_ipv4', u'route_target'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.bgp', u'next_hop'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip', u'unicast'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.vrf', u'ip'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast', u'route_target'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.import_', u'routes'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast', u'arp_entry'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static', u'bfd'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.bgp', u'next_hop'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route', u'static_route_oif_vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast', u'export'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6', u'unicast'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast', u'import_'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.import_', u'routes'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast', u'export'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.bgp', u'next_hop'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.vrf', u'route_target'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast', u'route_target'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static', u'bfd'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast', u'import_'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'vrf', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'map_export, evpn_export'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'action, target_community'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 've'}, {'leafval': 'map_export, evpn_export'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, Ethernet, Ve'}, {'leafval': 'map_import, evpn_import'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'holdover_interval'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'max_route'}, {'leafval': 'vrf_router_id'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'map_import, evpn_import'}, {'leafval': 'max_route'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'max_route'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'map_import, evpn_import'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, Ethernet, Ve'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 've, cluster_gateway'}, {'leafval': 'vrf_router_id'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'map_export, evpn_export'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'action, target_community'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'map_import, evpn_import'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'map_export, evpn_export'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'loopback'}, {'leafval': 'max_route'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'holdover_interval'}, {'leafval': 'loopback'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'max_route'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'vrf_router_id'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'action, target_community'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, Ethernet, Ve'}, {'leafval': 'holdover_interval'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'loopback'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'map_export'}, {'leafval': 'max_route'}, {'leafval': 'map_import'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'map_export'}, {'leafval': 'loopback'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'action, target_community'}, {'leafval': 'action, target_community'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'map_import'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_route_target_get(self, vrf=None, route_target=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    **Instance Keyword Argument Tuple**:

    :type route_target: action, target_community
    :param route_target: Keyword argument tuple.

    :type action: unicode
    :param action: **route_target** tuple argument.

        * enumeration restriction: ::

            ['import', 'export', 'both']

    :type target_community: unicode
    :param target_community: **route_target** tuple argument:  ASN:nn;; Target VPN Extended Community

        * pattern restriction: ::

            '((\s*(((([1-9][0-9]{0,8})|(4[0-1][0-9]{8})|(42[0'
            '-8][0-9]{7})|(429[0-3][0-9]{6})|(4294[0-8][0-9]{'
            '5})|(42949[0-5][0-9]{4})|(429496[0-6][0-9]{3})|('
            '4294967[0-1][0-9]{2})|(42949672[0-8][0-9])|(4294'
            '96729[0-5])):(([1-9][0-9]{0,3})|([1-5][0-9]{4})|'
            '(6[0-4][0-9]{3})|(65[0-4][0-9]{2})|(655[0-2][0-9'
            '])|(6553[0-5])))|(((([1-9]|[1-9][0-9]|1[0-9]{2}|'
            '2[0-4][0-9]|25[0-5])\.)(([0-9]|[1-9][0-9]|1[0-9]'
            '{2}|2[0-4][0-9]|25[0-5])\.){2}([0-9]|[1-9][0-9]|'
            '1[0-9]{2}|2[0-4][0-9]|25[0-5])):(([1-9][0-9]{0,3'
            '})|([1-5][0-9]{4})|(6[0-4][0-9]{3})|(65[0-4][0-9'
            ']{2})|(655[0-2][0-9])|(6553[0-5])))))*)'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_2_00.vrf', 'vrf'), ('pybind.slxos.v17r_1_01a.vrf', 'vrf'), ('pybind.slxos.v17s_1_02.vrf', 'vrf')]
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf.route_target', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf.route_target', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrf.route_target', 'pybind.slxos.v17s_1_02.brocade_vrf', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}, {'keyval': 'vrf_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'route_target', 'keyval': 'action, target_community', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf, route_target=route_target)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf, route_target=route_target)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrf_vpn_statistics_get(self, vrf=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type vrf: vrf_name
    :param vrf: Keyword argument tuple.

    :type vrf_name: unicode
    :param vrf_name: **vrf** tuple argument:  <WORD:1-32>;;Name of VRF

        * length restriction: ::

            ['1..32']

        * pattern restriction: ::

            '((([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA-Z0-'
            '9]\.)*([a-zA-Z0-9_]([a-zA-Z0-9\-_]){0,61})?[a-zA'
            '-Z0-9]\.?)|\.'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vrf', 'pybind.slxos.v17r_1_01a.brocade_vrf', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrf', 'pybind.slxos.v17r_2_00.brocade_vrf', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_oif'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.import_', u'routes'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip', u'unicast'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route', u'static_route_nh'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast', u'import_'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast', u'arp_entry'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.route_taret_container', u'route_target_evpn'), ('pybind.slxos.v17r_2_00.vrf.evpn', u'irb'), ('pybind.slxos.v17r_2_00.vrf', u'ip'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast', u'export'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.import_', u'routes'), ('pybind.slxos.v17r_2_00.vrf', u'route_target'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route', u'static_route_oif'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast', u'import_'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route', u'static_route_oif_vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.route_target_container_ipv6', u'route_target_evpn'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.ipv6.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast', u'export'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.route_taret_container_ipv6', u'route_target'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6.unicast.bgp', u'next_hop'), ('pybind.slxos.v17r_2_00.vrf.address_family.ipv6', u'unicast'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.route_target_container_ipv4', u'route_target'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.ip.route.static', u'bfd'), ('pybind.slxos.v17r_2_00.vrf.address_family.ip.unicast.bgp', u'next_hop'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_static_route'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh_vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip', u'unicast'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.vrf', u'ip'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_oif'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static.bfd', u'bfd_static_route'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast', u'route_target'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.import_', u'routes'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'link_local_static_route_nh_vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast', u'arp_entry'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route.static', u'bfd'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'ipv6_static_route_oif_vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.bgp', u'next_hop'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route', u'static_route_oif_vrf'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast', u'export'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6', u'unicast'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast', u'import_'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.import_', u'routes'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast', u'export'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.bgp', u'next_hop'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast.ip.route', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.vrf', u'route_target'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast', u'route_target'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static', u'bfd'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ip.unicast', u'import_'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route', u'static_route_nh'), ('pybind.slxos.v17r_1_01a.vrf.address_family.ipv6.unicast.ipv6.route.static.bfd', u'bfd_ipv6_link_local_static_route')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': 'vrf', 'keyval': 'vrf_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'max_route'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'map_import, evpn_import'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, Ethernet, Ve'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 've, cluster_gateway'}, {'leafval': 'vrf_router_id'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'map_export, evpn_export'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'action, target_community'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'map_import, evpn_import'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'map_export, evpn_export'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'loopback'}, {'leafval': 'max_route'}, {'leafval': 'action, target_community, evpn'}, {'leafval': 'holdover_interval'}, {'leafval': 'loopback'}, {'leafval': 'bfd_ipv6_static_route_dest, bfd_ipv6_static_route_src'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_next_hop'}, {'leafval': 'max_route'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'vrf_router_id'}, {'leafval': 'static_route_dest, static_route_oif_type, static_route_oif_name'}, {'leafval': 'bfd_static_route_dest, bfd_static_route_src'}, {'leafval': 'link_local_static_route_dest, link_local_nexthop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'action, target_community'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, link_local_next_hop, link_local_route_oif_type, link_local_route_oif_name'}, {'leafval': 'arp_ip_address, mac_address_value, interfacename, Ethernet, Ve'}, {'leafval': 'holdover_interval'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'loopback'}, {'leafval': 'static_route_next_vrf_dest, next_hop_vrf, static_route_oif_type, static_route_oif_name'}, {'leafval': 'map_export'}, {'leafval': 'max_route'}, {'leafval': 'map_import'}, {'leafval': 'src_vrf, route_map'}, {'leafval': 'map_export'}, {'leafval': 'loopback'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'action, target_community'}, {'leafval': 'action, target_community'}, {'leafval': 'ipv6_holdover_interval'}, {'leafval': 'map_import'}, {'leafval': 'static_route_dest, static_route_next_hop'}, {'leafval': 'bfd_ipv6_link_local_dest, bfd_ipv6_link_local_src, bfd_interface_type, bfd_interface_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, vrf=vrf)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, vrf=vrf)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrrp_acceptmode_disable_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vrrp_global', 'pybind.slxos.v17r_1_01a.brocade_vrrpv3', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrrp_global', 'pybind.slxos.v17r_2_00.brocade_vrrpv3', 'pybind.slxos.v17r_2_00'), ('pybind.slxos.v17s_1_02.vrrp_rbridge_global', 'pybind.slxos.v17s_1_02.brocade_vrrpv3', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrrp_global_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vrrp_global', 'pybind.slxos.v17r_1_01a.brocade_vrrpv3', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vrrp_global', 'pybind.slxos.v17r_2_00.brocade_vrrpv3', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vrrp_rbridge_global_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vrrp_rbridge_global', 'pybind.slxos.v17s_1_02.brocade_vrrpv3', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = [('pybind.slxos.v17r_2_00.vxlan_acl_state', u'extended_data'), ('pybind.slxos.v17r_1_01a.vxlan_acl_state', u'extended_data')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'acl_name, seq_num, permit_deny, dst_vtep_ip, src_vtep_ip, vni, vni_mask, native_tag, dst_ip, dst_ip_mask, src_ip, src_ip_mask, dst_port, src_port, count, byte_count, transit_name, sflow, redir_interface, mirror_interface'}, {'leafval': 'acl_name, seq_num, permit_deny, dst_vtep_ip, src_vtep_ip, vni, vni_mask, native_tag, dst_ip, dst_ip_mask, src_ip, src_ip_mask, dst_port, src_port, count, byte_count, transit_name, sflow, redir_interface, mirror_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_byte_count_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_count_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_dst_ip_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_dst_ip_mask_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_dst_port_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_dst_vtep_ip_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_mirror_interface_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_native_tag_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_permit_deny_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_redir_interface_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_seq_num_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_sflow_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_src_ip_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_src_ip_mask_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_src_port_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_src_vtep_ip_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_transit_name_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_vni_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_acl_state_extended_data_vni_mask_get(self, extended_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17r.1.01a, 17r.2.00    

    **Instance Keyword Argument Tuple**:

    :type extended_data: acl_name
    :param extended_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_data** tuple argument.

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17r_1_01a.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_1_01a.brocade_ssm_operational', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17r_2_00.vxlan_acl_state.extended_data', 'pybind.slxos.v17r_2_00.brocade_ssm_operational', 'pybind.slxos.v17r_2_00')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_data', 'keyval': 'acl_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_data=extended_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_data=extended_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state', u'extended_stats_data')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'acl_name, seq_num, permit_deny, dst_vtep_ip, src_vtep_ip, vni, vni_mask, native_tag, dst_ip, dst_ip_mask, src_ip, src_ip_mask, dst_port, src_port, count, byte_count, sflow, redir_interface, mirror_interface'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_byte_count_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_count_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_dst_ip_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_dst_ip_mask_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_dst_port_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_dst_vtep_ip_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_mirror_interface_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_native_tag_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_permit_deny_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_redir_interface_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_sflow_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_src_ip_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_src_ip_mask_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_src_port_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_src_vtep_ip_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_vni_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def vxlan_stats_acl_state_extended_stats_data_vni_mask_get(self, extended_stats_data=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * SLXOS: 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type extended_stats_data: acl_name, seq_num
    :param extended_stats_data: Keyword argument tuple.

    :type acl_name: unicode
    :param acl_name: **extended_stats_data** tuple argument.

    :type seq_num: long
    :param seq_num: **extended_stats_data** tuple argument.

        * range restriction: ::

            ['0..4294967295']

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.slxos.v17s_1_02.vxlan_stats_acl_state.extended_stats_data', 'pybind.slxos.v17s_1_02.brocade_ssm_operational', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'extended_stats_data', 'keyval': 'acl_name, seq_num', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, extended_stats_data=extended_stats_data)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, extended_stats_data=extended_stats_data)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def zoning_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.zoning', 'pybind.nos.v6_0_2f.brocade_zone', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.zoning', 'pybind.nos.v7_2_0.brocade_zone', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.zoning', 'pybind.slxos.v17r_1_01a.brocade_zone', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.zoning', 'pybind.slxos.v17s_1_02.brocade_zone', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.zoning.defined_configuration', u'zone'), ('pybind.nos.v7_2_0.zoning.defined_configuration', u'cfg'), ('pybind.nos.v7_2_0.zoning', u'enabled_configuration'), ('pybind.nos.v7_2_0.zoning.defined_configuration', u'alias'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration', u'cfg'), ('pybind.slxos.v17r_1_01a.zoning', u'enabled_configuration'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration', u'zone'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration', u'alias'), ('pybind.slxos.v17s_1_02.zoning', u'enabled_configuration'), ('pybind.slxos.v17s_1_02.zoning.defined_configuration', u'cfg'), ('pybind.slxos.v17s_1_02.zoning.defined_configuration', u'alias'), ('pybind.slxos.v17s_1_02.zoning.defined_configuration', u'zone'), ('pybind.nos.v6_0_2f.zoning.defined_configuration', u'alias'), ('pybind.nos.v6_0_2f.zoning.defined_configuration', u'cfg'), ('pybind.nos.v6_0_2f.zoning', u'enabled_configuration'), ('pybind.nos.v6_0_2f.zoning.defined_configuration', u'zone')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'zone_name'}, {'leafval': 'cfg_name'}, {'leafval': 'cfg_name, default_zone_access, cfg_action'}, {'leafval': 'alias_name'}, {'leafval': 'cfg_name'}, {'leafval': 'cfg_name, default_zone_access, cfg_action'}, {'leafval': 'zone_name'}, {'leafval': 'alias_name'}, {'leafval': 'cfg_name, default_zone_access, cfg_action'}, {'leafval': 'cfg_name'}, {'leafval': 'alias_name'}, {'leafval': 'zone_name'}, {'leafval': 'alias_name'}, {'leafval': 'cfg_name'}, {'leafval': 'cfg_name, default_zone_access, cfg_action'}, {'leafval': 'zone_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def zoning_defined_configuration_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.zoning.defined_configuration', 'pybind.nos.v6_0_2f.brocade_zone', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.zoning.defined_configuration', 'pybind.nos.v7_2_0.brocade_zone', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration', 'pybind.slxos.v17r_1_01a.brocade_zone', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.zoning.defined_configuration', 'pybind.slxos.v17s_1_02.brocade_zone', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.zoning.defined_configuration', u'cfg'), ('pybind.slxos.v17s_1_02.zoning.defined_configuration', u'alias'), ('pybind.slxos.v17s_1_02.zoning.defined_configuration', u'zone'), ('pybind.nos.v6_0_2f.zoning.defined_configuration', u'alias'), ('pybind.nos.v6_0_2f.zoning.defined_configuration', u'cfg'), ('pybind.nos.v6_0_2f.zoning.defined_configuration', u'zone'), ('pybind.nos.v7_2_0.zoning.defined_configuration', u'zone'), ('pybind.nos.v7_2_0.zoning.defined_configuration', u'cfg'), ('pybind.nos.v7_2_0.zoning.defined_configuration', u'alias'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration', u'cfg'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration', u'zone'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration', u'alias')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'cfg_name'}, {'leafval': 'alias_name'}, {'leafval': 'zone_name'}, {'leafval': 'alias_name'}, {'leafval': 'cfg_name'}, {'leafval': 'zone_name'}, {'leafval': 'zone_name'}, {'leafval': 'cfg_name'}, {'leafval': 'alias_name'}, {'leafval': 'cfg_name'}, {'leafval': 'zone_name'}, {'leafval': 'alias_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def zoning_defined_configuration_alias_get(self, alias=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type alias: alias_name
    :param alias: Keyword argument tuple.

    :type alias_name: unicode
    :param alias_name: **alias** tuple argument:  <WORD>;;Alias-Name

        * length restriction: ::

            ['1..64']

        * pattern restriction: ::

            '[0-9a-zA-Z_]{1,64}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.zoning.defined_configuration.alias', 'pybind.nos.v6_0_2f.brocade_zone', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.zoning.defined_configuration.alias', 'pybind.nos.v7_2_0.brocade_zone', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration.alias', 'pybind.slxos.v17r_1_01a.brocade_zone', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.zoning.defined_configuration.alias', 'pybind.slxos.v17s_1_02.brocade_zone', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.zoning.defined_configuration.alias', u'member_entry'), ('pybind.nos.v6_0_2f.zoning.defined_configuration.alias', u'member_entry'), ('pybind.slxos.v17s_1_02.zoning.defined_configuration.alias', u'member_entry'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration.alias', u'member_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'alias', 'keyval': 'alias_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'alias_entry_name'}, {'leafval': 'alias_entry_name'}, {'leafval': 'alias_entry_name'}, {'leafval': 'alias_entry_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alias=alias)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alias=alias)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def zoning_defined_configuration_alias_member_entry_get(self, alias=None, member_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type alias: alias_name
    :param alias: Keyword argument tuple.

    :type alias_name: unicode
    :param alias_name: **alias** tuple argument:  <WORD>;;Alias-Name

        * length restriction: ::

            ['1..64']

        * pattern restriction: ::

            '[0-9a-zA-Z_]{1,64}'

    **Instance Keyword Argument Tuple**:

    :type member_entry: alias_entry_name
    :param member_entry: Keyword argument tuple.

    :type alias_entry_name: unicode
    :param alias_entry_name: **member_entry** tuple argument:  <WWN>;;Member-Name - add one or more WWNmembers to an alias, the [no] option removesonly one member at a time.

        * pattern restriction: ::

            '([0-9a-fA-F]{2}(:[0-9a-fA-F]{2}){7})(;[0-9a-fA-F'
            ']{2}(:[0-9a-fA-F]{2}){7})*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17s_1_02.zoning.defined_configuration.alias', u'alias'), ('pybind.nos.v7_2_0.zoning.defined_configuration.alias', u'alias'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration.alias', u'alias'), ('pybind.nos.v6_0_2f.zoning.defined_configuration.alias', u'alias')]
    bindings_list = [('pybind.nos.v6_0_2f.zoning.defined_configuration.alias.member_entry', 'pybind.nos.v6_0_2f.brocade_zone', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.zoning.defined_configuration.alias.member_entry', 'pybind.nos.v7_2_0.brocade_zone', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration.alias.member_entry', 'pybind.slxos.v17r_1_01a.brocade_zone', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.zoning.defined_configuration.alias.member_entry', 'pybind.slxos.v17s_1_02.brocade_zone', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'alias_name', 'extra_keyval': ''}, {'keyval': 'alias_name', 'extra_keyval': ''}, {'keyval': 'alias_name', 'extra_keyval': ''}, {'keyval': 'alias_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_entry', 'keyval': 'alias_entry_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, alias=alias, member_entry=member_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, alias=alias, member_entry=member_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def zoning_defined_configuration_cfg_get(self, cfg=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type cfg: cfg_name
    :param cfg: Keyword argument tuple.

    :type cfg_name: unicode
    :param cfg_name: **cfg** tuple argument:  <WORD>;;CFG-Name

        * length restriction: ::

            ['1..64']

        * pattern restriction: ::

            '[0-9a-zA-Z_]{1,64}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.zoning.defined_configuration.cfg', 'pybind.nos.v6_0_2f.brocade_zone', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.zoning.defined_configuration.cfg', 'pybind.nos.v7_2_0.brocade_zone', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration.cfg', 'pybind.slxos.v17r_1_01a.brocade_zone', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.zoning.defined_configuration.cfg', 'pybind.slxos.v17s_1_02.brocade_zone', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.slxos.v17s_1_02.zoning.defined_configuration.cfg', u'member_zone'), ('pybind.nos.v6_0_2f.zoning.defined_configuration.cfg', u'member_zone'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration.cfg', u'member_zone'), ('pybind.nos.v7_2_0.zoning.defined_configuration.cfg', u'member_zone')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'cfg', 'keyval': 'cfg_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'zone_name'}, {'leafval': 'zone_name'}, {'leafval': 'zone_name'}, {'leafval': 'zone_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cfg=cfg)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cfg=cfg)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def zoning_defined_configuration_cfg_member_zone_get(self, cfg=None, member_zone=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type cfg: cfg_name
    :param cfg: Keyword argument tuple.

    :type cfg_name: unicode
    :param cfg_name: **cfg** tuple argument:  <WORD>;;CFG-Name

        * length restriction: ::

            ['1..64']

        * pattern restriction: ::

            '[0-9a-zA-Z_]{1,64}'

    **Instance Keyword Argument Tuple**:

    :type member_zone: zone_name
    :param member_zone: Keyword argument tuple.

    :type zone_name: unicode
    :param zone_name: **member_zone** tuple argument:  <WORD>;;Zone-Name - add one or more zonemembers to a cfg, the [no] option removesonly one member at a time.

        * pattern restriction: ::

            '([0-9a-zA-Z_]{1,64})(;([0-9a-zA-Z_]{1,64}))*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.nos.v7_2_0.zoning.defined_configuration.cfg', u'cfg'), ('pybind.nos.v6_0_2f.zoning.defined_configuration.cfg', u'cfg'), ('pybind.slxos.v17s_1_02.zoning.defined_configuration.cfg', u'cfg'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration.cfg', u'cfg')]
    bindings_list = [('pybind.nos.v6_0_2f.zoning.defined_configuration.cfg.member_zone', 'pybind.nos.v6_0_2f.brocade_zone', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.zoning.defined_configuration.cfg.member_zone', 'pybind.nos.v7_2_0.brocade_zone', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration.cfg.member_zone', 'pybind.slxos.v17r_1_01a.brocade_zone', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.zoning.defined_configuration.cfg.member_zone', 'pybind.slxos.v17s_1_02.brocade_zone', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'cfg_name', 'extra_keyval': ''}, {'keyval': 'cfg_name', 'extra_keyval': ''}, {'keyval': 'cfg_name', 'extra_keyval': ''}, {'keyval': 'cfg_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_zone', 'keyval': 'zone_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, cfg=cfg, member_zone=member_zone)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, cfg=cfg, member_zone=member_zone)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def zoning_defined_configuration_zone_get(self, zone=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17s.1.02    

    **Instance Keyword Argument Tuple**:

    :type zone: zone_name
    :param zone: Keyword argument tuple.

    :type zone_name: unicode
    :param zone_name: **zone** tuple argument:  <WORD>;;Zone-Name

        * length restriction: ::

            ['1..64']

        * pattern restriction: ::

            '[0-9a-zA-Z_]{1,64}'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.zoning.defined_configuration.zone', 'pybind.nos.v6_0_2f.brocade_zone', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.zoning.defined_configuration.zone', 'pybind.nos.v7_2_0.brocade_zone', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration.zone', 'pybind.slxos.v17r_1_01a.brocade_zone', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.zoning.defined_configuration.zone', 'pybind.slxos.v17s_1_02.brocade_zone', 'pybind.slxos.v17s_1_02')]
    composed_child_list = [('pybind.nos.v7_2_0.zoning.defined_configuration.zone', u'member_entry'), ('pybind.slxos.v17s_1_02.zoning.defined_configuration.zone', u'member_entry'), ('pybind.nos.v6_0_2f.zoning.defined_configuration.zone', u'member_entry'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration.zone', u'member_entry')]
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': u'zone', 'keyval': 'zone_name', 'extra_keyval': ''}
    composed_child_leafval_list = [{'leafval': 'entry_name'}, {'leafval': 'entry_name'}, {'leafval': 'entry_name'}, {'leafval': 'entry_name'}]
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, zone=zone)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, zone=zone)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def zoning_defined_configuration_zone_member_entry_get(self, zone=None, member_entry=None, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17s.1.02    

    **Parent Instance Keyword Argument Tuple(s)**:

    :type zone: zone_name
    :param zone: Keyword argument tuple.

    :type zone_name: unicode
    :param zone_name: **zone** tuple argument:  <WORD>;;Zone-Name

        * length restriction: ::

            ['1..64']

        * pattern restriction: ::

            '[0-9a-zA-Z_]{1,64}'

    **Instance Keyword Argument Tuple**:

    :type member_entry: entry_name
    :param member_entry: Keyword argument tuple.

    :type entry_name: unicode
    :param entry_name: **member_entry** tuple argument:  <WWN> and/or <Alias-Name>;;Member-Name - add one or more WWN and/or Alias-Namemembers to a zone, the [no] option removesonly one member at a time.

        * pattern restriction: ::

            '(([0-9a-zA-Z_]{1,64})|([0-9a-fA-F]{2}(:[0-9a-fA-'
            'F]{2}){7}))(;(([0-9a-zA-Z_]{1,64})|([0-9a-fA-F]{'
            '2}(:[0-9a-fA-F]{2}){7})))*'

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = [('pybind.slxos.v17r_1_01a.zoning.defined_configuration.zone', u'zone'), ('pybind.slxos.v17s_1_02.zoning.defined_configuration.zone', u'zone'), ('pybind.nos.v6_0_2f.zoning.defined_configuration.zone', u'zone'), ('pybind.nos.v7_2_0.zoning.defined_configuration.zone', u'zone')]
    bindings_list = [('pybind.nos.v6_0_2f.zoning.defined_configuration.zone.member_entry', 'pybind.nos.v6_0_2f.brocade_zone', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.zoning.defined_configuration.zone.member_entry', 'pybind.nos.v7_2_0.brocade_zone', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.zoning.defined_configuration.zone.member_entry', 'pybind.slxos.v17r_1_01a.brocade_zone', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.zoning.defined_configuration.zone.member_entry', 'pybind.slxos.v17s_1_02.brocade_zone', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = [{'keyval': 'zone_name', 'extra_keyval': ''}, {'keyval': 'zone_name', 'extra_keyval': ''}, {'keyval': 'zone_name', 'extra_keyval': ''}, {'keyval': 'zone_name', 'extra_keyval': ''}]
    bindings_keyval = {'kwargs_key_name': u'member_entry', 'keyval': 'entry_name', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map, zone=zone, member_entry=member_entry)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map, zone=zone, member_entry=member_entry)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def zoning_enabled_configuration_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.zoning.enabled_configuration', 'pybind.nos.v6_0_2f.brocade_zone', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.zoning.enabled_configuration', 'pybind.nos.v7_2_0.brocade_zone', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.zoning.enabled_configuration', 'pybind.slxos.v17r_1_01a.brocade_zone', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.zoning.enabled_configuration', 'pybind.slxos.v17s_1_02.brocade_zone', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def zoning_enabled_configuration_cfg_action_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.zoning.enabled_configuration', 'pybind.nos.v6_0_2f.brocade_zone', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.zoning.enabled_configuration', 'pybind.nos.v7_2_0.brocade_zone', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.zoning.enabled_configuration', 'pybind.slxos.v17r_1_01a.brocade_zone', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.zoning.enabled_configuration', 'pybind.slxos.v17s_1_02.brocade_zone', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def zoning_enabled_configuration_cfg_name_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.zoning.enabled_configuration', 'pybind.nos.v6_0_2f.brocade_zone', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.zoning.enabled_configuration', 'pybind.nos.v7_2_0.brocade_zone', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.zoning.enabled_configuration', 'pybind.slxos.v17r_1_01a.brocade_zone', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.zoning.enabled_configuration', 'pybind.slxos.v17s_1_02.brocade_zone', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

def zoning_enabled_configuration_default_zone_access_get(self, resource_depth=1, api_timeout=''):
    """
    This is an auto-generated method for the PySwitchLib.

    **Supported Versions**:

        * NOS: 6.0.2f, 7.2.0
        * SLXOS: 17r.1.01a, 17s.1.02    

    :type resource_depth: long
    :param resource_depth: Maximum depth for returned results from the GET response. (Default: 1 level(s) deep.)

    :type api_timeout: long or tuple(long, long)
    :param api_timeout: Timeout for connection and response in seconds.  If a tuple is specified, then the first value is for the connection timeout and the second value is for the response timeout.

    :rtype: (*bool, list*)
    :returns: Returns a tuple.

        #. **api_success** (*bool*) - The success or failure of the API.
        #. **details** (*list*) - List of REST request/response dictionaries, keyed by the asset's ip address.

    :raises ConnectionError: If requests module connection or response timeout occurs.
    :raises UnsupportedOSError: If firmware version installed on asset is not supported.
    :raises RestInterfaceError: If requests module does not get a successful response from the rest URI.
    :raises ValueError: If the argument value does not meet type requirements or value restrictions.
    """

    operation_type = 'get'
    compositions_list = []
    bindings_list = [('pybind.nos.v6_0_2f.zoning.enabled_configuration', 'pybind.nos.v6_0_2f.brocade_zone', 'pybind.nos.v6_0_2f'), ('pybind.nos.v7_2_0.zoning.enabled_configuration', 'pybind.nos.v7_2_0.brocade_zone', 'pybind.nos.v7_2_0'), ('pybind.slxos.v17r_1_01a.zoning.enabled_configuration', 'pybind.slxos.v17r_1_01a.brocade_zone', 'pybind.slxos.v17r_1_01a'), ('pybind.slxos.v17s_1_02.zoning.enabled_configuration', 'pybind.slxos.v17s_1_02.brocade_zone', 'pybind.slxos.v17s_1_02')]
    composed_child_list = []
    compositions_keyval_list = []
    bindings_keyval = {'kwargs_key_name': '', 'keyval': '', 'extra_keyval': ''}
    composed_child_leafval_list = []
    leafval_map = {}
    rest_leaf_name = ''
    choices_kwargs_map = {}
    leaf_os_support_map = {}
    self._api_validation(choices_kwargs_map=choices_kwargs_map, leaf_os_support_map=leaf_os_support_map)
    pybind_object = self._get_pybind_object(operation_type=operation_type, compositions_list=compositions_list, bindings_list=bindings_list, composed_child_list=composed_child_list, compositions_keyval_list=compositions_keyval_list, bindings_keyval=bindings_keyval, composed_child_leafval_list=composed_child_leafval_list, leafval_map=leafval_map)

    return self._config_get_worker(operation_type=operation_type, pybind_object=pybind_object, bindings_list=bindings_list, composed_child_list=composed_child_list, resource_depth=resource_depth, timeout=api_timeout)

